--
-- PostgreSQL database dump
--

-- Dumped from database version 9.1.0
-- Dumped by pg_dump version 9.1.0
-- Started on 2012-02-24 13:24:12

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 8 (class 2615 OID 4499845)
-- Name: census; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA census;


ALTER SCHEMA census OWNER TO postgres;

--
-- TOC entry 7 (class 2615 OID 4499714)
-- Name: staging; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA staging;


ALTER SCHEMA staging OWNER TO postgres;

--
-- TOC entry 169 (class 3079 OID 11638)
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- TOC entry 1881 (class 0 OID 0)
-- Dependencies: 169
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET search_path = census, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 167 (class 1259 OID 4499862)
-- Dependencies: 8
-- Name: facts; Type: TABLE; Schema: census; Owner: postgres; Tablespace: 
--

CREATE TABLE facts (
    fact_type_id integer NOT NULL,
    tract_id character varying(11) NOT NULL,
    yr integer NOT NULL,
    val numeric(12,3),
    perc numeric(6,2)
);


ALTER TABLE census.facts OWNER TO postgres;

--
-- TOC entry 166 (class 1259 OID 4499853)
-- Dependencies: 8
-- Name: lu_fact_types; Type: TABLE; Schema: census; Owner: postgres; Tablespace: 
--

CREATE TABLE lu_fact_types (
    fact_type_id integer NOT NULL,
    category character varying(100),
    fact_subcats character varying(255)[],
    short_name character varying(20)
);


ALTER TABLE census.lu_fact_types OWNER TO postgres;

--
-- TOC entry 165 (class 1259 OID 4499851)
-- Dependencies: 166 8
-- Name: lu_fact_types_fact_type_id_seq; Type: SEQUENCE; Schema: census; Owner: postgres
--

CREATE SEQUENCE lu_fact_types_fact_type_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE census.lu_fact_types_fact_type_id_seq OWNER TO postgres;

--
-- TOC entry 1882 (class 0 OID 0)
-- Dependencies: 165
-- Name: lu_fact_types_fact_type_id_seq; Type: SEQUENCE OWNED BY; Schema: census; Owner: postgres
--

ALTER SEQUENCE lu_fact_types_fact_type_id_seq OWNED BY lu_fact_types.fact_type_id;


--
-- TOC entry 1883 (class 0 OID 0)
-- Dependencies: 165
-- Name: lu_fact_types_fact_type_id_seq; Type: SEQUENCE SET; Schema: census; Owner: postgres
--

SELECT pg_catalog.setval('lu_fact_types_fact_type_id_seq', 102, true);


--
-- TOC entry 164 (class 1259 OID 4499846)
-- Dependencies: 8
-- Name: lu_tracts; Type: TABLE; Schema: census; Owner: postgres; Tablespace: 
--

CREATE TABLE lu_tracts (
    tract_id character varying(11) NOT NULL,
    tract_long_id character varying(25),
    tract_name character varying(150)
);


ALTER TABLE census.lu_tracts OWNER TO postgres;

SET search_path = staging, pg_catalog;

--
-- TOC entry 163 (class 1259 OID 4499715)
-- Dependencies: 7
-- Name: factfinder_import; Type: TABLE; Schema: staging; Owner: postgres; Tablespace: 
--

CREATE TABLE factfinder_import (
    geo_id character varying(255),
    geo_id2 character varying(255),
    geo_display character varying(255),
    s01 character varying(255),
    s01_perc character varying(255),
    s02 character varying(255),
    s02_perc character varying(255),
    s03 character varying(255),
    s03_perc character varying(255),
    s04 character varying(255),
    s04_perc character varying(255),
    s05 character varying(255),
    s05_perc character varying(255),
    s06 character varying(255),
    s06_perc character varying(255),
    s07 character varying(255),
    s07_perc character varying(255),
    s08 character varying(255),
    s08_perc character varying(255),
    s09 character varying(255),
    s09_perc character varying(255),
    s10 character varying(255),
    s10_perc character varying(255),
    s11 character varying(255),
    s11_perc character varying(255),
    s12 character varying(255),
    s12_perc character varying(255),
    s13 character varying(255),
    s13_perc character varying(255),
    s14 character varying(255),
    s14_perc character varying(255),
    s15 character varying(255),
    s15_perc character varying(255),
    s16 character varying(255),
    s16_perc character varying(255),
    s17 character varying(255),
    s17_perc character varying(255),
    s18 character varying(255),
    s18_perc character varying(255),
    s19 character varying(255),
    s19_perc character varying(255),
    s20 character varying(255),
    s20_perc character varying(255),
    s21 character varying(255),
    s21_perc character varying(255),
    s22 character varying(255),
    s22_perc character varying(255),
    s23 character varying(255),
    s23_perc character varying(255),
    s24 character varying(255),
    s24_perc character varying(255),
    s25 character varying(255),
    s25_perc character varying(255),
    s26 character varying(255),
    s26_perc character varying(255),
    s27 character varying(255),
    s27_perc character varying(255),
    s28 character varying(255),
    s28_perc character varying(255),
    s29 character varying(255),
    s29_perc character varying(255),
    s30 character varying(255),
    s30_perc character varying(255),
    s31 character varying(255),
    s31_perc character varying(255),
    s32 character varying(255),
    s32_perc character varying(255),
    s33 character varying(255),
    s33_perc character varying(255),
    s34 character varying(255),
    s34_perc character varying(255),
    s35 character varying(255),
    s35_perc character varying(255),
    s36 character varying(255),
    s36_perc character varying(255),
    s37 character varying(255),
    s37_perc character varying(255),
    s38 character varying(255),
    s38_perc character varying(255),
    s39 character varying(255),
    s39_perc character varying(255),
    s40 character varying(255),
    s40_perc character varying(255),
    s41 character varying(255),
    s41_perc character varying(255),
    s42 character varying(255),
    s42_perc character varying(255),
    s43 character varying(255),
    s43_perc character varying(255),
    s44 character varying(255),
    s44_perc character varying(255),
    s45 character varying(255),
    s45_perc character varying(255),
    s46 character varying(255),
    s46_perc character varying(255),
    s47 character varying(255),
    s47_perc character varying(255),
    s48 character varying(255),
    s48_perc character varying(255),
    s49 character varying(255),
    s49_perc character varying(255),
    s50 character varying(255),
    s50_perc character varying(255),
    s51 character varying(255),
    s51_perc character varying(255)
);


ALTER TABLE staging.factfinder_import OWNER TO postgres;

--
-- TOC entry 168 (class 1259 OID 4499900)
-- Dependencies: 7
-- Name: pop_import; Type: TABLE; Schema: staging; Owner: postgres; Tablespace: 
--

CREATE TABLE pop_import (
    geo_id character varying(255),
    geo_id2 character varying(255),
    geo_display character varying(255),
    d001 character varying(255),
    d002 character varying(255),
    d003 character varying(255),
    d004 character varying(255),
    d005 character varying(255),
    d006 character varying(255),
    d007 character varying(255),
    d008 character varying(255),
    d009 character varying(255),
    d010 character varying(255),
    d011 character varying(255),
    d012 character varying(255),
    d013 character varying(255),
    d014 character varying(255),
    d015 character varying(255),
    d016 character varying(255),
    d017 character varying(255)
);


ALTER TABLE staging.pop_import OWNER TO postgres;

SET search_path = census, pg_catalog;

--
-- TOC entry 1864 (class 2604 OID 4499856)
-- Dependencies: 166 165 166
-- Name: fact_type_id; Type: DEFAULT; Schema: census; Owner: postgres
--

ALTER TABLE lu_fact_types ALTER COLUMN fact_type_id SET DEFAULT nextval('lu_fact_types_fact_type_id_seq'::regclass);


--
-- TOC entry 1874 (class 0 OID 4499862)
-- Dependencies: 167
-- Data for Name: facts; Type: TABLE DATA; Schema: census; Owner: postgres
--

COPY facts (fact_type_id, tract_id, yr, val, perc) FROM stdin;
86	25001010100	2010	2942.000	\N
86	25001010206	2010	2750.000	\N
86	25001010208	2010	2003.000	\N
86	25001010304	2010	2421.000	\N
86	25001010306	2010	2535.000	\N
86	25001010400	2010	2999.000	\N
86	25001010500	2010	2891.000	\N
86	25001010600	2010	2973.000	\N
86	25001010700	2010	3152.000	\N
86	25001010800	2010	4878.000	\N
86	25001010900	2010	4942.000	\N
86	25001011002	2010	4157.000	\N
86	25001011100	2010	4694.000	\N
86	25001011200	2010	3392.000	\N
86	25001011300	2010	2600.000	\N
86	25001011400	2010	2991.000	\N
86	25001011500	2010	4029.000	\N
86	25001011600	2010	2710.000	\N
86	25001011700	2010	1877.000	\N
86	25001011801	2010	2403.000	\N
86	25001011802	2010	4255.000	\N
86	25001012001	2010	5732.000	\N
86	25001012002	2010	3007.000	\N
86	25001012101	2010	5339.000	\N
86	25001012102	2010	3057.000	\N
86	25001012200	2010	5046.000	\N
86	25001012502	2010	3080.000	\N
86	25001012601	2010	2877.000	\N
86	25001012602	2010	4915.000	\N
86	25001012700	2010	4562.000	\N
86	25001012800	2010	3923.000	\N
86	25001012900	2010	4135.000	\N
86	25001013002	2010	2899.000	\N
86	25001013100	2010	5935.000	\N
86	25001013200	2010	4783.000	\N
86	25001013300	2010	3218.000	\N
86	25001013400	2010	4163.000	\N
86	25001013500	2010	6940.000	\N
86	25001013600	2010	6334.000	\N
86	25001013700	2010	4911.000	\N
86	25001013800	2010	4840.000	\N
86	25001013900	2010	4831.000	\N
86	25001014002	2010	4053.000	\N
86	25001014100	2010	1141.000	\N
86	25001014300	2010	4384.000	\N
86	25001014402	2010	6947.000	\N
86	25001014500	2010	5395.000	\N
86	25001014600	2010	4130.000	\N
86	25001014700	2010	3690.000	\N
86	25001014800	2010	3387.000	\N
86	25001014900	2010	3598.000	\N
86	25001015001	2010	4417.000	\N
86	25001015002	2010	3713.000	\N
86	25001015100	2010	3809.000	\N
86	25001015200	2010	2065.000	\N
86	25001015300	2010	3038.000	\N
86	25001990000	2010	0.000	\N
86	25003900100	2010	3389.000	\N
86	25003900200	2010	4449.000	\N
86	25003900300	2010	2903.000	\N
86	25003900400	2010	4862.000	\N
86	25003900500	2010	3288.000	\N
86	25003900600	2010	4117.000	\N
86	25003900700	2010	2910.000	\N
86	25003900800	2010	4835.000	\N
86	25003900900	2010	5134.000	\N
86	25003901100	2010	3729.000	\N
86	25003911100	2010	3091.000	\N
86	25003912100	2010	6756.000	\N
86	25003913100	2010	5025.000	\N
86	25003914100	2010	5943.000	\N
86	25003920101	2010	4638.000	\N
86	25003920102	2010	3116.000	\N
86	25003921300	2010	5118.000	\N
86	25003921400	2010	1699.000	\N
86	25003921500	2010	3100.000	\N
86	25003922100	2010	2680.000	\N
86	25003922200	2010	3689.000	\N
86	25003922300	2010	2116.000	\N
86	25003923100	2010	3235.000	\N
86	25003924100	2010	1947.000	\N
86	25003925100	2010	7104.000	\N
86	25003926100	2010	3257.000	\N
86	25003931100	2010	1702.000	\N
86	25003931300	2010	1444.000	\N
86	25003931400	2010	1746.000	\N
86	25003932200	2010	2317.000	\N
86	25003932300	2010	2032.000	\N
86	25003933200	2010	1288.000	\N
86	25003933300	2010	1509.000	\N
86	25003933400	2010	2527.000	\N
86	25003934200	2010	1306.000	\N
86	25003934300	2010	1886.000	\N
86	25003935100	2010	2420.000	\N
86	25003935200	2010	5121.000	\N
86	25003935300	2010	3791.000	\N
86	25005600100	2010	3920.000	\N
86	25005600202	2010	4481.000	\N
86	25005600203	2010	5611.000	\N
86	25005600204	2010	3895.000	\N
86	25005610100	2010	5103.000	\N
86	25005610202	2010	5586.000	\N
86	25005610203	2010	6883.000	\N
86	25005610204	2010	5612.000	\N
86	25005611101	2010	4585.000	\N
86	25005611102	2010	5047.000	\N
86	25005611201	2010	3003.000	\N
86	25005611202	2010	6396.000	\N
86	25005612100	2010	4538.000	\N
86	25005612200	2010	8845.000	\N
86	25005613100	2010	6327.000	\N
86	25005613300	2010	7201.000	\N
86	25005613400	2010	3812.000	\N
86	25005613600	2010	3771.000	\N
86	25005613700	2010	4369.000	\N
86	25005613800	2010	4519.000	\N
86	25005613901	2010	2801.000	\N
86	25005613902	2010	4751.000	\N
86	25005614000	2010	4472.000	\N
86	25005614101	2010	6833.000	\N
86	25005614102	2010	7018.000	\N
86	25005615100	2010	7086.000	\N
86	25005616100	2010	6411.000	\N
86	25005617101	2010	4681.000	\N
86	25005617102	2010	4189.000	\N
86	25005630101	2010	2855.000	\N
86	25005630102	2010	4201.000	\N
86	25005630200	2010	8204.000	\N
86	25005630300	2010	8597.000	\N
86	25005630400	2010	4855.000	\N
86	25005631100	2010	8093.000	\N
86	25005631200	2010	6841.000	\N
86	25005631300	2010	5183.000	\N
86	25005631400	2010	2674.000	\N
86	25005631500	2010	2797.000	\N
86	25005631600	2010	3955.000	\N
86	25005631700	2010	6471.000	\N
86	25005631800	2010	7579.000	\N
86	25005632100	2010	6543.000	\N
86	25005632200	2010	7179.000	\N
86	25005633100	2010	5490.000	\N
86	25005633200	2010	6118.000	\N
86	25005640100	2010	5358.000	\N
86	25005640200	2010	5954.000	\N
86	25005640300	2010	3693.000	\N
86	25005640400	2010	2682.000	\N
86	25005640500	2010	5165.000	\N
86	25005640600	2010	4450.000	\N
86	25005640700	2010	2900.000	\N
86	25005640800	2010	3813.000	\N
86	25005640901	2010	5071.000	\N
86	25005641000	2010	2419.000	\N
86	25005641101	2010	1712.000	\N
86	25005641200	2010	2803.000	\N
86	25005641300	2010	5326.000	\N
86	25005641400	2010	2586.000	\N
86	25005641500	2010	2401.000	\N
86	25005641600	2010	2323.000	\N
86	25005641700	2010	5096.000	\N
86	25005641800	2010	2059.000	\N
86	25005641900	2010	2275.000	\N
86	25005642000	2010	3274.000	\N
86	25005642100	2010	4144.000	\N
86	25005642200	2010	3881.000	\N
86	25005642300	2010	2195.000	\N
86	25005642400	2010	2760.000	\N
86	25005642500	2010	4517.000	\N
86	25005644101	2010	5828.000	\N
86	25005644102	2010	5057.000	\N
86	25005644200	2010	7280.000	\N
86	25005645101	2010	4863.000	\N
86	25005645102	2010	5385.000	\N
86	25005645103	2010	5617.000	\N
86	25005646101	2010	7356.000	\N
86	25005646103	2010	5604.000	\N
86	25005646104	2010	2572.000	\N
86	25005650101	2010	5753.000	\N
86	25005650102	2010	4879.000	\N
86	25005650201	2010	2916.000	\N
86	25005650202	2010	2142.000	\N
86	25005650300	2010	3304.000	\N
86	25005650400	2010	3773.000	\N
86	25005650500	2010	3141.000	\N
86	25005650600	2010	2759.000	\N
86	25005650700	2010	2583.000	\N
86	25005650800	2010	3651.000	\N
86	25005650900	2010	2867.000	\N
86	25005651001	2010	2865.000	\N
86	25005651002	2010	3833.000	\N
86	25005651100	2010	4117.000	\N
86	25005651200	2010	2068.000	\N
86	25005651300	2010	2227.000	\N
86	25005651400	2010	3215.000	\N
86	25005651500	2010	3115.000	\N
86	25005651600	2010	3862.000	\N
86	25005651700	2010	1983.000	\N
86	25005651800	2010	1745.000	\N
86	25005651900	2010	1942.000	\N
86	25005652000	2010	2676.000	\N
86	25005652100	2010	2815.000	\N
86	25005652200	2010	2836.000	\N
86	25005652300	2010	2870.000	\N
86	25005652400	2010	2664.000	\N
86	25005652500	2010	2589.000	\N
86	25005652600	2010	2843.000	\N
86	25005652700	2010	3762.000	\N
86	25005652800	2010	3277.000	\N
86	25005653101	2010	6664.000	\N
86	25005653102	2010	5381.000	\N
86	25005653203	2010	5005.000	\N
86	25005653204	2010	3214.000	\N
86	25005653301	2010	5057.000	\N
86	25005653304	2010	3205.000	\N
86	25005654100	2010	6916.000	\N
86	25005654200	2010	3387.000	\N
86	25005655100	2010	4225.000	\N
86	25005655200	2010	4415.000	\N
86	25005655300	2010	3317.000	\N
86	25005655400	2010	3916.000	\N
86	25005985500	2010	5506.000	\N
86	25005985600	2010	5205.000	\N
86	25005990000	2010	0.000	\N
86	25007200100	2010	3949.000	\N
86	25007200200	2010	4527.000	\N
86	25007200300	2010	4067.000	\N
86	25007200400	2010	3992.000	\N
86	25007990000	2010	0.000	\N
86	25009201100	2010	3410.000	\N
86	25009202101	2010	2063.000	\N
86	25009202102	2010	5836.000	\N
86	25009202200	2010	5888.000	\N
86	25009203100	2010	7071.000	\N
86	25009203200	2010	4557.000	\N
86	25009203301	2010	4010.000	\N
86	25009203302	2010	4170.000	\N
86	25009204101	2010	4669.000	\N
86	25009204102	2010	4935.000	\N
86	25009204200	2010	4797.000	\N
86	25009204300	2010	3904.000	\N
86	25009204400	2010	3301.000	\N
86	25009204500	2010	3132.000	\N
86	25009204600	2010	5154.000	\N
86	25009204701	2010	5782.000	\N
86	25009204702	2010	5666.000	\N
86	25009205100	2010	5352.000	\N
86	25009205200	2010	5319.000	\N
86	25009205300	2010	4490.000	\N
86	25009205400	2010	5048.000	\N
86	25009205500	2010	4606.000	\N
86	25009205600	2010	3881.000	\N
86	25009205700	2010	4650.000	\N
86	25009205800	2010	3312.000	\N
86	25009205900	2010	4350.000	\N
86	25009206000	2010	3359.000	\N
86	25009206100	2010	3844.000	\N
86	25009206200	2010	5254.000	\N
86	25009206300	2010	3773.000	\N
86	25009206400	2010	5249.000	\N
86	25009206500	2010	3358.000	\N
86	25009206600	2010	4243.000	\N
86	25009206700	2010	4080.000	\N
86	25009206800	2010	3546.000	\N
86	25009206900	2010	3965.000	\N
86	25009207000	2010	2198.000	\N
86	25009207100	2010	3513.000	\N
86	25009207200	2010	2939.000	\N
86	25009208101	2010	5124.000	\N
86	25009208102	2010	3243.000	\N
86	25009208200	2010	5262.000	\N
86	25009208300	2010	7254.000	\N
86	25009208400	2010	5745.000	\N
86	25009209100	2010	6088.000	\N
86	25009209200	2010	5508.000	\N
86	25009210100	2010	6948.000	\N
86	25009210200	2010	5384.000	\N
86	25009210300	2010	9110.000	\N
86	25009210400	2010	6823.000	\N
86	25009210500	2010	6438.000	\N
86	25009210600	2010	4095.000	\N
86	25009210700	2010	4001.000	\N
86	25009210800	2010	4569.000	\N
86	25009210900	2010	3883.000	\N
86	25009211100	2010	3794.000	\N
86	25009211200	2010	6100.000	\N
86	25009211300	2010	6967.000	\N
86	25009211401	2010	3560.000	\N
86	25009211402	2010	6072.000	\N
86	25009212100	2010	8987.000	\N
86	25009213100	2010	7961.000	\N
86	25009214100	2010	6089.000	\N
86	25009215101	2010	4896.000	\N
86	25009215102	2010	2868.000	\N
86	25009216100	2010	4875.000	\N
86	25009217100	2010	7291.000	\N
86	25009217201	2010	4218.000	\N
86	25009217202	2010	3491.000	\N
86	25009217300	2010	4504.000	\N
86	25009217400	2010	5218.000	\N
86	25009217500	2010	6101.000	\N
86	25009217600	2010	8679.000	\N
86	25009218100	2010	5136.000	\N
86	25009220101	2010	4003.000	\N
86	25009220102	2010	2949.000	\N
86	25009221100	2010	4182.000	\N
86	25009221300	2010	4532.000	\N
86	25009221400	2010	3221.000	\N
86	25009221500	2010	2923.000	\N
86	25009221600	2010	2448.000	\N
86	25009221700	2010	2840.000	\N
86	25009221800	2010	1773.000	\N
86	25009221901	2010	3419.000	\N
86	25009221902	2010	3451.000	\N
86	25009222100	2010	3504.000	\N
86	25009223100	2010	3880.000	\N
86	25009223200	2010	3740.000	\N
86	25009223300	2010	5555.000	\N
86	25009250100	2010	2329.000	\N
86	25009250200	2010	5524.000	\N
86	25009250300	2010	2101.000	\N
86	25009250400	2010	3858.000	\N
86	25009250500	2010	3810.000	\N
86	25009250600	2010	5599.000	\N
86	25009250700	2010	4756.000	\N
86	25009250800	2010	6932.000	\N
86	25009250900	2010	2193.000	\N
86	25009251000	2010	1782.000	\N
86	25009251100	2010	2937.000	\N
86	25009251200	2010	1357.000	\N
86	25009251300	2010	3721.000	\N
86	25009251400	2010	5053.000	\N
86	25009251500	2010	6149.000	\N
86	25009251600	2010	5977.000	\N
86	25009251700	2010	5145.000	\N
86	25009251800	2010	7154.000	\N
86	25009252101	2010	3509.000	\N
86	25009252102	2010	3798.000	\N
86	25009252201	2010	3230.000	\N
86	25009252202	2010	3198.000	\N
86	25009252300	2010	6552.000	\N
86	25009252400	2010	4175.000	\N
86	25009252501	2010	3874.000	\N
86	25009252502	2010	4865.000	\N
86	25009252601	2010	6621.000	\N
86	25009252602	2010	4407.000	\N
86	25009252603	2010	3026.000	\N
86	25009253100	2010	5352.000	\N
86	25009253201	2010	2913.000	\N
86	25009253202	2010	6253.000	\N
86	25009253203	2010	4160.000	\N
86	25009253204	2010	5329.000	\N
86	25009253205	2010	4345.000	\N
86	25009254100	2010	6009.000	\N
86	25009254200	2010	5018.000	\N
86	25009254301	2010	3893.000	\N
86	25009254302	2010	4493.000	\N
86	25009254401	2010	3235.000	\N
86	25009254402	2010	6713.000	\N
86	25009254403	2010	3840.000	\N
86	25009260100	2010	4789.000	\N
86	25009260200	2010	3437.000	\N
86	25009260301	2010	4466.000	\N
86	25009260302	2010	3091.000	\N
86	25009260401	2010	3820.000	\N
86	25009260402	2010	6211.000	\N
86	25009260500	2010	3788.000	\N
86	25009260600	2010	3377.000	\N
86	25009260700	2010	4498.000	\N
86	25009260800	2010	4631.000	\N
86	25009260900	2010	5089.000	\N
86	25009261000	2010	3942.000	\N
86	25009261101	2010	4782.000	\N
86	25009261102	2010	4958.000	\N
86	25009262100	2010	6338.000	\N
86	25009263100	2010	4235.000	\N
86	25009264100	2010	6459.000	\N
86	25009265101	2010	3645.000	\N
86	25009265102	2010	4538.000	\N
86	25009266100	2010	4032.000	\N
86	25009266200	2010	5194.000	\N
86	25009266300	2010	3709.000	\N
86	25009266400	2010	3348.000	\N
86	25009267101	2010	3573.000	\N
86	25009267102	2010	4710.000	\N
86	25009268100	2010	2668.000	\N
86	25009268200	2010	6322.000	\N
86	25009268300	2010	4126.000	\N
86	25009268400	2010	4300.000	\N
86	25009269100	2010	6666.000	\N
86	25009270100	2010	5856.000	\N
86	25009990100	2010	0.000	\N
86	25011040100	2010	4494.000	\N
86	25011040200	2010	4340.000	\N
86	25011040300	2010	3032.000	\N
86	25011040400	2010	3428.000	\N
86	25011040501	2010	4264.000	\N
86	25011040502	2010	3575.000	\N
86	25011040600	2010	4612.000	\N
86	25011040701	2010	4213.000	\N
86	25011040702	2010	4224.000	\N
86	25011040800	2010	5180.000	\N
86	25011040900	2010	5125.000	\N
86	25011041000	2010	3271.000	\N
86	25011041100	2010	3603.000	\N
86	25011041200	2010	3156.000	\N
86	25011041300	2010	4642.000	\N
86	25011041400	2010	2784.000	\N
86	25011041501	2010	3634.000	\N
86	25011041502	2010	3795.000	\N
86	25013800101	2010	4052.000	\N
86	25013800102	2010	4119.000	\N
86	25013800201	2010	6334.000	\N
86	25013800202	2010	1333.000	\N
86	25013800300	2010	4395.000	\N
86	25013800400	2010	6726.000	\N
86	25013800500	2010	3366.000	\N
86	25013800600	2010	2620.000	\N
86	25013800700	2010	4000.000	\N
86	25013800800	2010	2098.000	\N
86	25013800900	2010	4136.000	\N
86	25013801101	2010	1862.000	\N
86	25013801102	2010	1537.000	\N
86	25013801200	2010	2638.000	\N
86	25013801300	2010	4636.000	\N
86	25013801401	2010	3992.000	\N
86	25013801402	2010	2016.000	\N
86	25013801501	2010	5361.000	\N
86	25013801502	2010	3412.000	\N
86	25013801503	2010	4036.000	\N
86	25013801601	2010	5067.000	\N
86	25013801602	2010	5108.000	\N
86	25013801603	2010	4185.000	\N
86	25013801604	2010	3767.000	\N
86	25013801605	2010	4608.000	\N
86	25013801700	2010	7577.000	\N
86	25013801800	2010	4279.000	\N
86	25013801901	2010	3938.000	\N
86	25013801902	2010	3614.000	\N
86	25013802000	2010	2849.000	\N
86	25013802100	2010	6075.000	\N
86	25013802200	2010	3308.000	\N
86	25013802300	2010	6838.000	\N
86	25013802400	2010	3544.000	\N
86	25013802500	2010	6694.000	\N
86	25013802601	2010	7038.000	\N
86	25013802602	2010	1902.000	\N
86	25013810100	2010	6290.000	\N
86	25013810200	2010	2710.000	\N
86	25013810300	2010	3140.000	\N
86	25013810403	2010	3931.000	\N
86	25013810404	2010	3761.000	\N
86	25013810412	2010	5933.000	\N
86	25013810414	2010	7478.000	\N
86	25013810601	2010	4267.000	\N
86	25013810602	2010	2657.000	\N
86	25013810700	2010	6151.000	\N
86	25013810800	2010	3823.000	\N
86	25013810901	2010	1948.000	\N
86	25013810902	2010	4578.000	\N
86	25013811000	2010	4622.000	\N
86	25013811101	2010	5058.000	\N
86	25013811102	2010	6100.000	\N
86	25013811200	2010	4859.000	\N
86	25013811301	2010	5494.000	\N
86	25013811302	2010	5741.000	\N
86	25013811400	2010	2447.000	\N
86	25013811500	2010	2277.000	\N
86	25013811600	2010	3749.000	\N
86	25013811700	2010	2029.000	\N
86	25013811800	2010	4139.000	\N
86	25013811900	2010	3555.000	\N
86	25013812001	2010	3451.000	\N
86	25013812002	2010	4646.000	\N
86	25013812101	2010	5106.000	\N
86	25013812103	2010	3836.000	\N
86	25013812104	2010	4645.000	\N
86	25013812201	2010	4600.000	\N
86	25013812202	2010	4043.000	\N
86	25013812300	2010	5861.000	\N
86	25013812401	2010	6210.000	\N
86	25013812403	2010	3796.000	\N
86	25013812404	2010	3881.000	\N
86	25013812500	2010	7665.000	\N
86	25013812600	2010	6799.000	\N
86	25013812701	2010	4078.000	\N
86	25013812702	2010	5489.000	\N
86	25013812800	2010	6666.000	\N
86	25013812901	2010	3002.000	\N
86	25013812902	2010	4802.000	\N
86	25013812903	2010	2593.000	\N
86	25013813000	2010	7234.000	\N
86	25013813101	2010	5888.000	\N
86	25013813102	2010	3614.000	\N
86	25013813204	2010	3240.000	\N
86	25013813205	2010	7481.000	\N
86	25013813206	2010	4042.000	\N
86	25013813207	2010	5111.000	\N
86	25013813208	2010	2918.000	\N
86	25013813209	2010	5646.000	\N
86	25013813301	2010	7343.000	\N
86	25013813303	2010	4387.000	\N
86	25013813304	2010	4054.000	\N
86	25013813401	2010	5243.000	\N
86	25013813403	2010	3847.000	\N
86	25013813404	2010	6630.000	\N
86	25013813500	2010	5139.000	\N
86	25013813601	2010	8146.000	\N
86	25013813602	2010	6073.000	\N
86	25013813701	2010	3462.000	\N
86	25013813702	2010	5098.000	\N
86	25013813801	2010	4319.000	\N
86	25013813802	2010	3609.000	\N
86	25015820101	2010	6189.000	\N
86	25015820102	2010	3683.000	\N
86	25015820202	2010	1321.000	\N
86	25015820203	2010	8507.000	\N
86	25015820204	2010	6142.000	\N
86	25015820300	2010	6818.000	\N
86	25015820400	2010	12079.000	\N
86	25015820500	2010	6342.000	\N
86	25015820600	2010	1681.000	\N
86	25015820700	2010	4509.000	\N
86	25015820801	2010	5232.000	\N
86	25015820802	2010	1158.000	\N
86	25015820900	2010	6240.000	\N
86	25015821000	2010	4251.000	\N
86	25015821100	2010	6939.000	\N
86	25015821200	2010	2127.000	\N
86	25015821300	2010	4197.000	\N
86	25015821400	2010	5250.000	\N
86	25015821500	2010	3279.000	\N
86	25015821601	2010	3424.000	\N
86	25015821602	2010	3844.000	\N
86	25015821700	2010	3725.000	\N
86	25015821901	2010	3291.000	\N
86	25015821903	2010	3425.000	\N
86	25015821904	2010	2764.000	\N
86	25015822000	2010	1962.000	\N
86	25015822200	2010	6114.000	\N
86	25015822300	2010	5372.000	\N
86	25015822401	2010	5842.000	\N
86	25015822402	2010	4839.000	\N
86	25015822500	2010	5792.000	\N
86	25015822601	2010	2180.000	\N
86	25015822603	2010	1607.000	\N
86	25015822605	2010	1222.000	\N
86	25015822606	2010	3536.000	\N
86	25015822700	2010	3197.000	\N
86	25017300100	2010	3074.000	\N
86	25017301101	2010	4024.000	\N
86	25017301102	2010	4902.000	\N
86	25017310100	2010	5267.000	\N
86	25017310200	2010	5976.000	\N
86	25017310300	2010	6016.000	\N
86	25017310400	2010	3245.000	\N
86	25017310500	2010	3449.000	\N
86	25017310601	2010	5746.000	\N
86	25017310602	2010	5825.000	\N
86	25017310700	2010	4441.000	\N
86	25017311100	2010	2410.000	\N
86	25017311200	2010	3267.000	\N
86	25017311300	2010	4057.000	\N
86	25017311400	2010	5986.000	\N
86	25017311500	2010	2974.000	\N
86	25017311600	2010	5295.000	\N
86	25017311700	2010	5098.000	\N
86	25017311800	2010	3513.000	\N
86	25017311900	2010	2429.000	\N
86	25017312000	2010	2938.000	\N
86	25017312100	2010	3149.000	\N
86	25017312200	2010	4309.000	\N
86	25017312300	2010	4931.000	\N
86	25017312400	2010	2354.000	\N
86	25017312501	2010	4464.000	\N
86	25017312502	2010	3960.000	\N
86	25017313101	2010	5488.000	\N
86	25017313102	2010	5804.000	\N
86	25017314101	2010	6055.000	\N
86	25017314102	2010	7223.000	\N
86	25017314200	2010	5233.000	\N
86	25017314301	2010	8011.000	\N
86	25017314302	2010	2935.000	\N
86	25017315100	2010	5456.000	\N
86	25017315200	2010	7585.000	\N
86	25017315401	2010	3532.000	\N
86	25017315402	2010	2921.000	\N
86	25017315403	2010	1745.000	\N
86	25017315500	2010	7722.000	\N
86	25017316101	2010	5108.000	\N
86	25017316102	2010	6060.000	\N
86	25017316201	2010	4104.000	\N
86	25017316202	2010	4290.000	\N
86	25017316300	2010	8172.000	\N
86	25017316400	2010	6570.000	\N
86	25017316500	2010	5939.000	\N
86	25017317101	2010	6139.000	\N
86	25017317102	2010	4353.000	\N
86	25017317103	2010	4895.000	\N
86	25017317201	2010	2849.000	\N
86	25017317202	2010	3388.000	\N
86	25017317203	2010	4003.000	\N
86	25017317301	2010	2627.000	\N
86	25017317302	2010	5548.000	\N
86	25017318100	2010	6674.000	\N
86	25017318200	2010	3853.000	\N
86	25017318300	2010	7516.000	\N
86	25017318400	2010	3908.000	\N
86	25017320102	2010	5040.000	\N
86	25017320103	2010	2795.000	\N
86	25017320104	2010	7090.000	\N
86	25017321100	2010	6992.000	\N
86	25017321200	2010	6267.000	\N
86	25017321300	2010	7497.000	\N
86	25017321400	2010	3297.000	\N
86	25017321500	2010	6898.000	\N
86	25017321600	2010	7548.000	\N
86	25017322100	2010	4671.000	\N
86	25017322200	2010	3687.000	\N
86	25017322300	2010	6090.000	\N
86	25017322400	2010	4615.000	\N
86	25017323100	2010	6590.000	\N
86	25017324101	2010	4761.000	\N
86	25017324102	2010	4163.000	\N
86	25017325100	2010	7427.000	\N
86	25017326101	2010	3896.000	\N
86	25017326102	2010	6750.000	\N
86	25017327101	2010	3586.000	\N
86	25017327102	2010	4333.000	\N
86	25017327103	2010	3578.000	\N
86	25017328100	2010	3179.000	\N
86	25017330100	2010	8231.000	\N
86	25017330200	2010	6661.000	\N
86	25017331101	2010	3011.000	\N
86	25017331102	2010	6971.000	\N
86	25017331200	2010	5346.000	\N
86	25017331300	2010	6997.000	\N
86	25017332100	2010	5972.000	\N
86	25017332200	2010	8376.000	\N
86	25017332300	2010	6677.000	\N
86	25017332400	2010	3473.000	\N
86	25017333100	2010	7399.000	\N
86	25017333200	2010	5364.000	\N
86	25017333300	2010	4063.000	\N
86	25017333400	2010	6229.000	\N
86	25017333501	2010	5001.000	\N
86	25017333502	2010	3273.000	\N
86	25017333600	2010	6791.000	\N
86	25017334100	2010	6718.000	\N
86	25017334200	2010	3968.000	\N
86	25017334300	2010	7605.000	\N
86	25017334400	2010	6456.000	\N
86	25017335100	2010	5728.000	\N
86	25017335200	2010	5637.000	\N
86	25017335301	2010	3852.000	\N
86	25017335302	2010	4621.000	\N
86	25017335400	2010	5094.000	\N
86	25017336100	2010	5360.000	\N
86	25017336200	2010	6142.000	\N
86	25017336300	2010	6664.000	\N
86	25017336401	2010	4260.000	\N
86	25017336402	2010	4557.000	\N
86	25017337101	2010	3095.000	\N
86	25017337102	2010	5042.000	\N
86	25017337201	2010	3192.000	\N
86	25017337202	2010	4849.000	\N
86	25017337300	2010	5259.000	\N
86	25017338100	2010	2964.000	\N
86	25017338200	2010	3869.000	\N
86	25017338300	2010	3180.000	\N
86	25017338400	2010	5745.000	\N
86	25017338500	2010	5616.000	\N
86	25017339100	2010	6442.000	\N
86	25017339200	2010	5830.000	\N
86	25017339300	2010	2890.000	\N
86	25017339400	2010	3326.000	\N
86	25017339500	2010	5399.000	\N
86	25017339600	2010	5024.000	\N
86	25017339700	2010	3878.000	\N
86	25017339801	2010	4410.000	\N
86	25017339802	2010	4557.000	\N
86	25017339900	2010	5171.000	\N
86	25017340000	2010	2594.000	\N
86	25017340100	2010	6652.000	\N
86	25017341101	2010	3675.000	\N
86	25017341102	2010	4564.000	\N
86	25017341200	2010	6857.000	\N
86	25017341300	2010	5439.000	\N
86	25017341400	2010	6212.000	\N
86	25017341500	2010	4780.000	\N
86	25017341600	2010	6564.000	\N
86	25017341700	2010	5298.000	\N
86	25017341800	2010	6554.000	\N
86	25017341901	2010	1387.000	\N
86	25017341902	2010	8120.000	\N
86	25017342101	2010	4457.000	\N
86	25017342102	2010	4066.000	\N
86	25017342201	2010	5268.000	\N
86	25017342202	2010	3833.000	\N
86	25017342300	2010	6826.000	\N
86	25017342400	2010	6055.000	\N
86	25017342500	2010	6797.000	\N
86	25017342600	2010	4365.000	\N
86	25017350103	2010	1210.000	\N
86	25017350104	2010	7275.000	\N
86	25017350200	2010	6567.000	\N
86	25017350300	2010	2441.000	\N
86	25017350400	2010	5568.000	\N
86	25017350500	2010	1629.000	\N
86	25017350600	2010	4572.000	\N
86	25017350700	2010	6048.000	\N
86	25017350800	2010	1828.000	\N
86	25017350900	2010	3314.000	\N
86	25017351000	2010	6450.000	\N
86	25017351100	2010	5622.000	\N
86	25017351203	2010	4241.000	\N
86	25017351204	2010	4129.000	\N
86	25017351300	2010	4233.000	\N
86	25017351403	2010	4028.000	\N
86	25017351404	2010	4289.000	\N
86	25017351500	2010	2310.000	\N
86	25017352101	2010	1654.000	\N
86	25017352102	2010	2277.000	\N
86	25017352200	2010	1849.000	\N
86	25017352300	2010	3450.000	\N
86	25017352400	2010	2126.000	\N
86	25017352500	2010	2894.000	\N
86	25017352600	2010	2378.000	\N
86	25017352700	2010	2057.000	\N
86	25017352800	2010	2115.000	\N
86	25017352900	2010	2646.000	\N
86	25017353000	2010	3584.000	\N
86	25017353101	2010	2460.000	\N
86	25017353102	2010	5040.000	\N
86	25017353200	2010	4897.000	\N
86	25017353300	2010	3471.000	\N
86	25017353400	2010	2848.000	\N
86	25017353500	2010	2602.000	\N
86	25017353600	2010	4551.000	\N
86	25017353700	2010	5365.000	\N
86	25017353800	2010	4702.000	\N
86	25017353900	2010	7090.000	\N
86	25017354000	2010	4366.000	\N
86	25017354100	2010	2907.000	\N
86	25017354200	2010	2907.000	\N
86	25017354300	2010	3346.000	\N
86	25017354400	2010	1647.000	\N
86	25017354500	2010	2236.000	\N
86	25017354600	2010	4538.000	\N
86	25017354700	2010	2509.000	\N
86	25017354800	2010	1903.000	\N
86	25017354900	2010	6058.000	\N
86	25017355000	2010	2689.000	\N
86	25017356100	2010	3110.000	\N
86	25017356300	2010	5040.000	\N
86	25017356400	2010	7247.000	\N
86	25017356500	2010	6580.000	\N
86	25017356601	2010	4216.000	\N
86	25017356602	2010	4169.000	\N
86	25017356701	2010	5844.000	\N
86	25017356702	2010	6638.000	\N
86	25017357100	2010	4185.000	\N
86	25017357200	2010	3202.000	\N
86	25017357300	2010	2973.000	\N
86	25017357400	2010	2339.000	\N
86	25017357500	2010	2130.000	\N
86	25017357600	2010	2432.000	\N
86	25017357700	2010	3727.000	\N
86	25017357800	2010	3741.000	\N
86	25017358100	2010	5105.000	\N
86	25017358300	2010	5526.000	\N
86	25017358400	2010	4895.000	\N
86	25017358500	2010	4861.000	\N
86	25017358600	2010	5947.000	\N
86	25017358700	2010	5060.000	\N
86	25017359100	2010	6198.000	\N
86	25017359300	2010	7122.000	\N
86	25017360100	2010	1286.000	\N
86	25017360200	2010	5076.000	\N
86	25017361100	2010	5657.000	\N
86	25017361200	2010	5765.000	\N
86	25017361300	2010	6246.000	\N
86	25017362100	2010	4852.000	\N
86	25017363102	2010	5909.000	\N
86	25017363103	2010	3229.000	\N
86	25017363104	2010	6105.000	\N
86	25017363201	2010	3219.000	\N
86	25017363202	2010	3462.000	\N
86	25017364101	2010	5266.000	\N
86	25017364102	2010	4840.000	\N
86	25017365100	2010	7732.000	\N
86	25017365201	2010	5607.000	\N
86	25017365202	2010	4320.000	\N
86	25017366100	2010	4697.000	\N
86	25017366201	2010	3598.000	\N
86	25017366202	2010	4699.000	\N
86	25017367100	2010	3959.000	\N
86	25017367200	2010	7302.000	\N
86	25017368101	2010	6101.000	\N
86	25017368102	2010	3627.000	\N
86	25017368200	2010	4294.000	\N
86	25017368300	2010	5345.000	\N
86	25017368400	2010	8117.000	\N
86	25017368500	2010	3297.000	\N
86	25017368600	2010	5196.000	\N
86	25017368700	2010	2462.000	\N
86	25017368800	2010	4741.000	\N
86	25017368901	2010	6801.000	\N
86	25017368902	2010	4320.000	\N
86	25017369000	2010	1528.000	\N
86	25017369100	2010	4803.000	\N
86	25017370101	2010	6488.000	\N
86	25017370102	2010	6751.000	\N
86	25017370201	2010	3757.000	\N
86	25017370202	2010	4149.000	\N
86	25017370300	2010	5644.000	\N
86	25017370400	2010	5126.000	\N
86	25017373100	2010	4755.000	\N
86	25017373200	2010	4391.000	\N
86	25017373300	2010	2799.000	\N
86	25017373400	2010	3204.000	\N
86	25017373500	2010	6187.000	\N
86	25017373600	2010	6026.000	\N
86	25017373700	2010	3790.000	\N
86	25017373800	2010	5923.000	\N
86	25017373900	2010	6373.000	\N
86	25017374000	2010	5237.000	\N
86	25017374100	2010	4647.000	\N
86	25017374200	2010	4194.000	\N
86	25017374300	2010	3494.000	\N
86	25017374400	2010	5743.000	\N
86	25017374500	2010	4339.000	\N
86	25017374600	2010	4829.000	\N
86	25017374700	2010	4477.000	\N
86	25017374800	2010	4738.000	\N
86	25017382100	2010	4911.000	\N
86	25017382200	2010	5158.000	\N
86	25017382300	2010	5568.000	\N
86	25017382400	2010	4523.000	\N
86	25017382500	2010	4418.000	\N
86	25017382601	2010	4269.000	\N
86	25017382602	2010	4159.000	\N
86	25017383101	2010	4217.000	\N
86	25017383102	2010	4923.000	\N
86	25017383200	2010	6046.000	\N
86	25017383300	2010	3042.000	\N
86	25017383400	2010	5540.000	\N
86	25017383501	2010	4259.000	\N
86	25017383502	2010	3773.000	\N
86	25017383600	2010	6138.000	\N
86	25017383700	2010	5213.000	\N
86	25017383800	2010	5360.000	\N
86	25017383901	2010	7628.000	\N
86	25017383902	2010	5227.000	\N
86	25017384001	2010	1437.000	\N
86	25017384002	2010	5515.000	\N
86	25017385100	2010	6717.000	\N
86	25017385201	2010	2568.000	\N
86	25017385202	2010	7308.000	\N
86	25017386100	2010	4119.000	\N
86	25017387100	2010	4257.000	\N
86	25017387201	2010	5464.000	\N
86	25017387202	2010	3826.000	\N
86	25017388100	2010	4996.000	\N
86	25017388200	2010	7211.000	\N
86	25017388300	2010	5420.000	\N
86	25017980000	2010	0.000	\N
86	25019950100	2010	1375.000	\N
86	25019950200	2010	4869.000	\N
86	25019950307	2010	342.000	\N
86	25019950400	2010	2422.000	\N
86	25019950500	2010	1164.000	\N
86	25019990000	2010	0.000	\N
86	25021400100	2010	4977.000	\N
86	25021400200	2010	6132.000	\N
86	25021400300	2010	4110.000	\N
86	25021400400	2010	5449.000	\N
86	25021400500	2010	5173.000	\N
86	25021400600	2010	5177.000	\N
86	25021400700	2010	3598.000	\N
86	25021400800	2010	5630.000	\N
86	25021400900	2010	3865.000	\N
86	25021401000	2010	3149.000	\N
86	25021401100	2010	4441.000	\N
86	25021401200	2010	7031.000	\N
86	25021402101	2010	3634.000	\N
86	25021402102	2010	4063.000	\N
86	25021402200	2010	2169.000	\N
86	25021402300	2010	4549.000	\N
86	25021402400	2010	6050.000	\N
86	25021402500	2010	4264.000	\N
86	25021403100	2010	6841.000	\N
86	25021403300	2010	4222.000	\N
86	25021403400	2010	6488.000	\N
86	25021403500	2010	5684.000	\N
86	25021404100	2010	4025.000	\N
86	25021404201	2010	3658.000	\N
86	25021404202	2010	4986.000	\N
86	25021404301	2010	5508.000	\N
86	25021404302	2010	3529.000	\N
86	25021404400	2010	6276.000	\N
86	25021405100	2010	5589.000	\N
86	25021406101	2010	5537.000	\N
86	25021406102	2010	6487.000	\N
86	25021407100	2010	7891.000	\N
86	25021408101	2010	7962.000	\N
86	25021408102	2010	4790.000	\N
86	25021409101	2010	6217.000	\N
86	25021409102	2010	5010.000	\N
86	25021410100	2010	6142.000	\N
86	25021410300	2010	4423.000	\N
86	25021410400	2010	6300.000	\N
86	25021411100	2010	7972.000	\N
86	25021411200	2010	6562.000	\N
86	25021411301	2010	5527.000	\N
86	25021411302	2010	4009.000	\N
86	25021412100	2010	6334.000	\N
86	25021412200	2010	3572.000	\N
86	25021412300	2010	4712.000	\N
86	25021413100	2010	5854.000	\N
86	25021413200	2010	6079.000	\N
86	25021413300	2010	4954.000	\N
86	25021413401	2010	3167.000	\N
86	25021413402	2010	4244.000	\N
86	25021413500	2010	4304.000	\N
86	25021414100	2010	5693.000	\N
86	25021414200	2010	7183.000	\N
86	25021414300	2010	4736.000	\N
86	25021415101	2010	4532.000	\N
86	25021415102	2010	7465.000	\N
86	25021415200	2010	5850.000	\N
86	25021415300	2010	3714.000	\N
86	25021416101	2010	5724.000	\N
86	25021416102	2010	3810.000	\N
86	25021416200	2010	6651.000	\N
86	25021416300	2010	4749.000	\N
86	25021416400	2010	6069.000	\N
86	25021417100	2010	4264.000	\N
86	25021417200	2010	8182.000	\N
86	25021417300	2010	2681.000	\N
86	25021417400	2010	2566.000	\N
86	25021417501	2010	5004.000	\N
86	25021417502	2010	4639.000	\N
86	25021417601	2010	5196.000	\N
86	25021417602	2010	5155.000	\N
86	25021417701	2010	5417.000	\N
86	25021417702	2010	2765.000	\N
86	25021417801	2010	5443.000	\N
86	25021417802	2010	3150.000	\N
86	25021417901	2010	6048.000	\N
86	25021417902	2010	3542.000	\N
86	25021418002	2010	7020.000	\N
86	25021418003	2010	2481.000	\N
86	25021418004	2010	4280.000	\N
86	25021418101	2010	4837.000	\N
86	25021418102	2010	3377.000	\N
86	25021418200	2010	6224.000	\N
86	25021419100	2010	5691.000	\N
86	25021419200	2010	5002.000	\N
86	25021419300	2010	3863.000	\N
86	25021419400	2010	3166.000	\N
86	25021419500	2010	3077.000	\N
86	25021419600	2010	6766.000	\N
86	25021419700	2010	3821.000	\N
86	25021419800	2010	4358.000	\N
86	25021420100	2010	7804.000	\N
86	25021420201	2010	3505.000	\N
86	25021420202	2010	6303.000	\N
86	25021420301	2010	6797.000	\N
86	25021420302	2010	7703.000	\N
86	25021421100	2010	5120.000	\N
86	25021421200	2010	5671.000	\N
86	25021422100	2010	5293.000	\N
86	25021422200	2010	6815.000	\N
86	25021422301	2010	2975.000	\N
86	25021422302	2010	6590.000	\N
86	25021422400	2010	7785.000	\N
86	25021422501	2010	4758.000	\N
86	25021422502	2010	5165.000	\N
86	25021422600	2010	6668.000	\N
86	25021422700	2010	3842.000	\N
86	25021422800	2010	3852.000	\N
86	25021423100	2010	7542.000	\N
86	25021440100	2010	8264.000	\N
86	25021441202	2010	2726.000	\N
86	25021441203	2010	3730.000	\N
86	25021441204	2010	4499.000	\N
86	25021442101	2010	5572.000	\N
86	25021442102	2010	7071.000	\N
86	25021442103	2010	6946.000	\N
86	25021442201	2010	4166.000	\N
86	25021442202	2010	7880.000	\N
86	25021443101	2010	7638.000	\N
86	25021443102	2010	8694.000	\N
86	25021456101	2010	3776.000	\N
86	25021456102	2010	4945.000	\N
86	25021456200	2010	3146.000	\N
86	25021456301	2010	1753.000	\N
86	25021456302	2010	5000.000	\N
86	25021456401	2010	2765.000	\N
86	25021456402	2010	5577.000	\N
86	25021457100	2010	4356.000	\N
86	25021457200	2010	5651.000	\N
86	25023500101	2010	3702.000	\N
86	25023500103	2010	2209.000	\N
86	25023500104	2010	4382.000	\N
86	25023501101	2010	3302.000	\N
86	25023501102	2010	8057.000	\N
86	25023501201	2010	3667.000	\N
86	25023501202	2010	7131.000	\N
86	25023502101	2010	6051.000	\N
86	25023502102	2010	5600.000	\N
86	25023502200	2010	5838.000	\N
86	25023503101	2010	7176.000	\N
86	25023503102	2010	6703.000	\N
86	25023504101	2010	5370.000	\N
86	25023504102	2010	5136.000	\N
86	25023505101	2010	6468.000	\N
86	25023505102	2010	4991.000	\N
86	25023505200	2010	6674.000	\N
86	25023506101	2010	6531.000	\N
86	25023506102	2010	5899.000	\N
86	25023506202	2010	2512.000	\N
86	25023506203	2010	5220.000	\N
86	25023506204	2010	4970.000	\N
86	25023507101	2010	5323.000	\N
86	25023507103	2010	4351.000	\N
86	25023507104	2010	5385.000	\N
86	25023508101	2010	6708.000	\N
86	25023508102	2010	5098.000	\N
86	25023508200	2010	6031.000	\N
86	25023509101	2010	6947.000	\N
86	25023509102	2010	5682.000	\N
86	25023510100	2010	4776.000	\N
86	25023510200	2010	5964.000	\N
86	25023510300	2010	3798.000	\N
86	25023510400	2010	3706.000	\N
86	25023510501	2010	3358.000	\N
86	25023510502	2010	5796.000	\N
86	25023510503	2010	4296.000	\N
86	25023510600	2010	2857.000	\N
86	25023510700	2010	5656.000	\N
86	25023510800	2010	6339.000	\N
86	25023510900	2010	2531.000	\N
86	25023511000	2010	3040.000	\N
86	25023511100	2010	5291.000	\N
86	25023511200	2010	4849.000	\N
86	25023511301	2010	5334.000	\N
86	25023511302	2010	3531.000	\N
86	25023511400	2010	3716.000	\N
86	25023511500	2010	4308.000	\N
86	25023511600	2010	7211.000	\N
86	25023511701	2010	4655.000	\N
86	25023511702	2010	2798.000	\N
86	25023520100	2010	6458.000	\N
86	25023520201	2010	3952.000	\N
86	25023520202	2010	5575.000	\N
86	25023521101	2010	4303.000	\N
86	25023521102	2010	3316.000	\N
86	25023521201	2010	2904.000	\N
86	25023521202	2010	3966.000	\N
86	25023522101	2010	4745.000	\N
86	25023522102	2010	5464.000	\N
86	25023523100	2010	3044.000	\N
86	25023523201	2010	2897.000	\N
86	25023523202	2010	7853.000	\N
86	25023524101	2010	3035.000	\N
86	25023524102	2010	3881.000	\N
86	25023525101	2010	6305.000	\N
86	25023525104	2010	6289.000	\N
86	25023525203	2010	5595.000	\N
86	25023525204	2010	3382.000	\N
86	25023525300	2010	2063.000	\N
86	25023526100	2010	7518.000	\N
86	25023530100	2010	3808.000	\N
86	25023530200	2010	3600.000	\N
86	25023530300	2010	3782.000	\N
86	25023530400	2010	5823.000	\N
86	25023530500	2010	5680.000	\N
86	25023530600	2010	6364.000	\N
86	25023530700	2010	4242.000	\N
86	25023530801	2010	5587.000	\N
86	25023530802	2010	4785.000	\N
86	25023530901	2010	8328.000	\N
86	25023530902	2010	4469.000	\N
86	25023540101	2010	3783.000	\N
86	25023540102	2010	2570.000	\N
86	25023540103	2010	4249.000	\N
86	25023541100	2010	5232.000	\N
86	25023542101	2010	7131.000	\N
86	25023542102	2010	2552.000	\N
86	25023542200	2010	6114.000	\N
86	25023542300	2010	7319.000	\N
86	25023543100	2010	2820.000	\N
86	25023544100	2010	5629.000	\N
86	25023544200	2010	5880.000	\N
86	25023545100	2010	6446.000	\N
86	25023545200	2010	5669.000	\N
86	25023545300	2010	4413.000	\N
86	25023545400	2010	5294.000	\N
86	25023560100	2010	6045.000	\N
86	25023561100	2010	4907.000	\N
86	25023561200	2010	2929.000	\N
86	25023990003	2010	0.000	\N
86	25025000100	2010	4254.000	\N
86	25025000201	2010	3854.000	\N
86	25025000202	2010	3885.000	\N
86	25025000301	2010	2740.000	\N
86	25025000302	2010	3142.000	\N
86	25025000401	2010	5672.000	\N
86	25025000402	2010	3648.000	\N
86	25025000502	2010	6303.000	\N
86	25025000503	2010	2211.000	\N
86	25025000504	2010	4985.000	\N
86	25025000601	2010	3571.000	\N
86	25025000602	2010	3974.000	\N
86	25025000701	2010	4446.000	\N
86	25025000703	2010	2791.000	\N
86	25025000704	2010	4801.000	\N
86	25025000802	2010	8136.000	\N
86	25025000803	2010	6584.000	\N
86	25025010103	2010	4569.000	\N
86	25025010104	2010	4804.000	\N
86	25025010203	2010	5569.000	\N
86	25025010204	2010	3173.000	\N
86	25025010300	2010	4861.000	\N
86	25025010403	2010	3003.000	\N
86	25025010404	2010	5817.000	\N
86	25025010405	2010	5522.000	\N
86	25025010408	2010	1426.000	\N
86	25025010500	2010	3044.000	\N
86	25025010600	2010	2858.000	\N
86	25025010701	2010	2478.000	\N
86	25025010702	2010	2400.000	\N
86	25025010801	2010	2783.000	\N
86	25025010802	2010	3059.000	\N
86	25025020101	2010	4193.000	\N
86	25025020200	2010	3649.000	\N
86	25025020301	2010	2023.000	\N
86	25025020302	2010	1181.000	\N
86	25025020303	2010	3400.000	\N
86	25025030100	2010	1954.000	\N
86	25025030200	2010	1665.000	\N
86	25025030300	2010	4872.000	\N
86	25025030400	2010	2451.000	\N
86	25025030500	2010	2538.000	\N
86	25025040100	2010	2168.000	\N
86	25025040200	2010	1606.000	\N
86	25025040300	2010	3882.000	\N
86	25025040401	2010	2439.000	\N
86	25025040600	2010	2444.000	\N
86	25025040801	2010	3900.000	\N
86	25025050101	2010	5115.000	\N
86	25025050200	2010	5231.000	\N
86	25025050300	2010	2251.000	\N
86	25025050400	2010	2372.000	\N
86	25025050500	2010	1857.000	\N
86	25025050600	2010	2063.000	\N
86	25025050700	2010	4504.000	\N
86	25025050901	2010	4165.000	\N
86	25025051000	2010	4089.000	\N
86	25025051101	2010	6093.000	\N
86	25025051200	2010	2379.000	\N
86	25025060101	2010	3216.000	\N
86	25025060200	2010	1916.000	\N
86	25025060301	2010	3076.000	\N
86	25025060400	2010	4904.000	\N
86	25025060501	2010	3571.000	\N
86	25025060600	2010	2357.000	\N
86	25025060700	2010	1893.000	\N
86	25025060800	2010	3964.000	\N
86	25025061000	2010	3098.000	\N
86	25025061101	2010	2232.000	\N
86	25025061200	2010	3240.000	\N
86	25025070101	2010	5902.000	\N
86	25025070200	2010	5218.000	\N
86	25025070300	2010	3909.000	\N
86	25025070402	2010	1723.000	\N
86	25025070500	2010	5460.000	\N
86	25025070600	2010	2240.000	\N
86	25025070700	2010	2361.000	\N
86	25025070800	2010	3706.000	\N
86	25025070900	2010	3329.000	\N
86	25025071101	2010	3753.000	\N
86	25025071201	2010	3131.000	\N
86	25025080100	2010	3350.000	\N
86	25025080300	2010	1769.000	\N
86	25025080401	2010	2710.000	\N
86	25025080500	2010	3096.000	\N
86	25025080601	2010	4271.000	\N
86	25025080801	2010	3885.000	\N
86	25025080900	2010	4008.000	\N
86	25025081001	2010	4890.000	\N
86	25025081100	2010	4091.000	\N
86	25025081200	2010	3265.000	\N
86	25025081300	2010	4760.000	\N
86	25025081400	2010	3003.000	\N
86	25025081500	2010	2134.000	\N
86	25025081700	2010	3820.000	\N
86	25025081800	2010	2898.000	\N
86	25025081900	2010	3115.000	\N
86	25025082000	2010	2815.000	\N
86	25025082100	2010	5025.000	\N
86	25025090100	2010	4571.000	\N
86	25025090200	2010	2233.000	\N
86	25025090300	2010	3179.000	\N
86	25025090400	2010	3659.000	\N
86	25025090600	2010	2348.000	\N
86	25025090700	2010	4275.000	\N
86	25025090901	2010	3730.000	\N
86	25025091001	2010	2742.000	\N
86	25025091100	2010	4861.000	\N
86	25025091200	2010	3234.000	\N
86	25025091300	2010	2499.000	\N
86	25025091400	2010	2741.000	\N
86	25025091500	2010	4370.000	\N
86	25025091600	2010	3138.000	\N
86	25025091700	2010	3069.000	\N
86	25025091800	2010	3452.000	\N
86	25025091900	2010	3860.000	\N
86	25025092000	2010	4945.000	\N
86	25025092101	2010	6451.000	\N
86	25025092200	2010	3349.000	\N
86	25025092300	2010	2893.000	\N
86	25025092400	2010	5277.000	\N
86	25025100100	2010	5510.000	\N
86	25025100200	2010	2787.000	\N
86	25025100300	2010	3303.000	\N
86	25025100400	2010	4865.000	\N
86	25025100500	2010	5989.000	\N
86	25025100601	2010	5154.000	\N
86	25025100603	2010	1904.000	\N
86	25025100700	2010	4322.000	\N
86	25025100800	2010	5546.000	\N
86	25025100900	2010	4072.000	\N
86	25025101001	2010	5480.000	\N
86	25025101002	2010	4979.000	\N
86	25025101101	2010	3155.000	\N
86	25025101102	2010	4396.000	\N
86	25025110103	2010	5460.000	\N
86	25025110201	2010	2051.000	\N
86	25025110301	2010	2405.000	\N
86	25025110401	2010	3566.000	\N
86	25025110403	2010	4309.000	\N
86	25025110501	2010	3253.000	\N
86	25025110502	2010	3806.000	\N
86	25025110601	2010	2969.000	\N
86	25025110607	2010	5077.000	\N
86	25025120103	2010	1508.000	\N
86	25025120104	2010	2095.000	\N
86	25025120105	2010	2444.000	\N
86	25025120201	2010	3439.000	\N
86	25025120301	2010	4795.000	\N
86	25025120400	2010	5751.000	\N
86	25025120500	2010	2331.000	\N
86	25025120600	2010	2335.000	\N
86	25025120700	2010	2014.000	\N
86	25025130100	2010	5906.000	\N
86	25025130200	2010	4506.000	\N
86	25025130300	2010	4419.000	\N
86	25025130402	2010	4637.000	\N
86	25025130404	2010	2901.000	\N
86	25025130406	2010	5107.000	\N
86	25025140102	2010	4401.000	\N
86	25025140105	2010	3675.000	\N
86	25025140106	2010	1901.000	\N
86	25025140107	2010	2531.000	\N
86	25025140201	2010	2072.000	\N
86	25025140202	2010	5600.000	\N
86	25025140300	2010	6382.000	\N
86	25025140400	2010	7650.000	\N
86	25025160101	2010	7551.000	\N
86	25025160200	2010	4043.000	\N
86	25025160300	2010	2065.000	\N
86	25025160400	2010	2716.000	\N
86	25025160501	2010	5604.000	\N
86	25025160502	2010	4460.000	\N
86	25025160601	2010	4063.000	\N
86	25025160602	2010	4675.000	\N
86	25025170100	2010	7560.000	\N
86	25025170200	2010	4564.000	\N
86	25025170300	2010	9040.000	\N
86	25025170400	2010	5379.000	\N
86	25025170501	2010	3435.000	\N
86	25025170502	2010	2818.000	\N
86	25025170601	2010	5105.000	\N
86	25025170701	2010	2099.000	\N
86	25025170702	2010	6628.000	\N
86	25025170800	2010	5118.000	\N
86	25025180101	2010	4766.000	\N
86	25025180200	2010	4109.000	\N
86	25025180301	2010	3024.000	\N
86	25025180400	2010	1715.000	\N
86	25025180500	2010	3883.000	\N
86	25025980101	2010	535.000	\N
86	25025980300	2010	338.000	\N
86	25025980700	2010	6.000	\N
86	25025981000	2010	22.000	\N
86	25025981100	2010	418.000	\N
86	25025981201	2010	0.000	\N
86	25025981202	2010	207.000	\N
86	25025981300	2010	389.000	\N
86	25025981501	2010	12.000	\N
86	25025981502	2010	9.000	\N
86	25025981600	2010	0.000	\N
86	25025981700	2010	0.000	\N
86	25025981800	2010	82.000	\N
86	25025990101	2010	0.000	\N
86	25027700100	2010	6081.000	\N
86	25027701100	2010	8340.000	\N
86	25027702200	2010	3218.000	\N
86	25027703100	2010	4323.000	\N
86	25027703200	2010	3558.000	\N
86	25027703300	2010	3703.000	\N
86	25027704200	2010	2916.000	\N
86	25027705100	2010	8013.000	\N
86	25027706100	2010	4382.000	\N
86	25027707100	2010	3909.000	\N
86	25027707200	2010	1839.000	\N
86	25027707300	2010	3931.000	\N
86	25027707400	2010	4591.000	\N
86	25027707500	2010	5958.000	\N
86	25027708100	2010	7277.000	\N
86	25027709100	2010	4066.000	\N
86	25027709201	2010	6921.000	\N
86	25027709202	2010	6829.000	\N
86	25027709400	2010	4750.000	\N
86	25027709501	2010	2149.000	\N
86	25027709502	2010	5670.000	\N
86	25027709600	2010	2423.000	\N
86	25027709701	2010	5609.000	\N
86	25027709702	2010	2342.000	\N
86	25027710100	2010	3435.000	\N
86	25027710200	2010	6759.000	\N
86	25027710300	2010	3224.000	\N
86	25027710400	2010	2149.000	\N
86	25027710500	2010	3246.000	\N
86	25027710600	2010	6594.000	\N
86	25027710700	2010	1580.000	\N
86	25027710800	2010	4539.000	\N
86	25027711000	2010	3080.000	\N
86	25027711100	2010	5712.000	\N
86	25027712101	2010	5955.000	\N
86	25027712102	2010	4131.000	\N
86	25027713100	2010	8055.000	\N
86	25027715100	2010	4897.000	\N
86	25027716100	2010	7558.000	\N
86	25027716200	2010	2820.000	\N
86	25027716300	2010	3228.000	\N
86	25027717100	2010	2866.000	\N
86	25027718100	2010	4355.000	\N
86	25027719100	2010	7808.000	\N
86	25027720100	2010	3413.000	\N
86	25027721101	2010	1902.000	\N
86	25027721102	2010	7973.000	\N
86	25027722100	2010	5398.000	\N
86	25027723100	2010	3989.000	\N
86	25027724100	2010	3701.000	\N
86	25027725100	2010	4680.000	\N
86	25027726100	2010	5988.000	\N
86	25027726200	2010	5700.000	\N
86	25027727100	2010	4806.000	\N
86	25027728100	2010	4126.000	\N
86	25027728200	2010	3713.000	\N
86	25027728300	2010	4544.000	\N
86	25027728400	2010	4963.000	\N
86	25027729100	2010	4997.000	\N
86	25027729200	2010	2672.000	\N
86	25027730100	2010	5923.000	\N
86	25027730200	2010	5583.000	\N
86	25027730300	2010	4559.000	\N
86	25027730401	2010	5444.000	\N
86	25027730402	2010	1660.000	\N
86	25027730500	2010	3535.000	\N
86	25027730600	2010	8799.000	\N
86	25027730700	2010	6803.000	\N
86	25027730801	2010	3665.000	\N
86	25027730802	2010	2046.000	\N
86	25027730901	2010	3404.000	\N
86	25027730902	2010	3716.000	\N
86	25027731001	2010	2229.000	\N
86	25027731002	2010	6402.000	\N
86	25027731101	2010	3949.000	\N
86	25027731102	2010	2511.000	\N
86	25027731202	2010	1111.000	\N
86	25027731203	2010	5198.000	\N
86	25027731204	2010	2498.000	\N
86	25027731300	2010	3841.000	\N
86	25027731400	2010	4673.000	\N
86	25027731500	2010	5174.000	\N
86	25027731600	2010	7357.000	\N
86	25027731700	2010	2761.000	\N
86	25027731800	2010	6172.000	\N
86	25027731900	2010	5227.000	\N
86	25027732001	2010	3327.000	\N
86	25027732002	2010	4036.000	\N
86	25027732201	2010	2820.000	\N
86	25027732202	2010	3240.000	\N
86	25027732203	2010	2853.000	\N
86	25027732301	2010	4155.000	\N
86	25027732302	2010	3902.000	\N
86	25027732400	2010	6459.000	\N
86	25027732500	2010	1776.000	\N
86	25027732600	2010	4253.000	\N
86	25027732700	2010	3938.000	\N
86	25027732801	2010	4829.000	\N
86	25027732802	2010	4122.000	\N
86	25027732901	2010	6592.000	\N
86	25027732902	2010	2459.000	\N
86	25027733000	2010	3762.000	\N
86	25027733101	2010	2058.000	\N
86	25027733102	2010	2224.000	\N
86	25027735100	2010	6713.000	\N
86	25027735200	2010	4257.000	\N
86	25027736100	2010	2600.000	\N
86	25027736200	2010	3722.000	\N
86	25027736300	2010	2426.000	\N
86	25027736400	2010	3071.000	\N
86	25027736500	2010	4369.000	\N
86	25027737100	2010	5116.000	\N
86	25027737200	2010	1747.000	\N
86	25027737300	2010	6398.000	\N
86	25027738100	2010	4636.000	\N
86	25027738201	2010	4075.000	\N
86	25027738202	2010	5995.000	\N
86	25027739100	2010	9557.000	\N
86	25027739200	2010	5958.000	\N
86	25027739300	2010	3688.000	\N
86	25027739400	2010	8851.000	\N
86	25027739500	2010	7554.000	\N
86	25027740101	2010	5191.000	\N
86	25027740102	2010	6053.000	\N
86	25027740200	2010	2911.000	\N
86	25027741101	2010	4478.000	\N
86	25027741102	2010	5289.000	\N
86	25027742300	2010	4045.000	\N
86	25027742401	2010	5421.000	\N
86	25027742402	2010	3026.000	\N
86	25027743100	2010	7542.000	\N
86	25027744101	2010	7445.000	\N
86	25027744102	2010	5258.000	\N
86	25027744200	2010	7484.000	\N
86	25027744300	2010	3838.000	\N
86	25027744400	2010	3974.000	\N
86	25027745100	2010	5911.000	\N
86	25027746100	2010	5839.000	\N
86	25027747101	2010	5110.000	\N
86	25027747102	2010	3916.000	\N
86	25027748100	2010	3190.000	\N
86	25027749100	2010	7988.000	\N
86	25027749200	2010	5469.000	\N
86	25027750100	2010	6048.000	\N
86	25027750200	2010	6749.000	\N
86	25027750300	2010	2910.000	\N
86	25027751101	2010	6219.000	\N
86	25027751102	2010	2744.000	\N
86	25027752100	2010	8471.000	\N
86	25027753100	2010	7458.000	\N
86	25027753200	2010	6251.000	\N
86	25027754100	2010	6502.000	\N
86	25027754200	2010	3462.000	\N
86	25027754300	2010	2960.000	\N
86	25027754400	2010	3843.000	\N
86	25027755100	2010	3300.000	\N
86	25027755200	2010	8090.000	\N
86	25027756101	2010	4512.000	\N
86	25027756102	2010	8469.000	\N
86	25027757100	2010	4514.000	\N
86	25027757200	2010	2293.000	\N
86	25027757300	2010	2871.000	\N
86	25027757400	2010	2707.000	\N
86	25027757500	2010	4334.000	\N
86	25027758101	2010	1650.000	\N
86	25027758102	2010	7618.000	\N
86	25027759100	2010	2183.000	\N
86	25027760100	2010	3390.000	\N
86	25027761100	2010	5135.000	\N
86	25027761200	2010	5780.000	\N
86	25027761300	2010	3059.000	\N
86	25027761400	2010	6520.000	\N
87	25001010100	2010	2800.000	\N
87	25001010206	2010	2709.000	\N
87	25001010208	2010	1962.000	\N
87	25001010304	2010	2381.000	\N
87	25001010306	2010	2500.000	\N
87	25001010400	2010	2938.000	\N
87	25001010500	2010	2871.000	\N
87	25001010600	2010	2923.000	\N
87	25001010700	2010	3094.000	\N
87	25001010800	2010	4809.000	\N
87	25001010900	2010	4845.000	\N
87	25001011002	2010	4088.000	\N
87	25001011100	2010	4620.000	\N
87	25001011200	2010	3357.000	\N
87	25001011300	2010	2561.000	\N
87	25001011400	2010	2914.000	\N
87	25001011500	2010	3943.000	\N
87	25001011600	2010	2642.000	\N
87	25001011700	2010	1841.000	\N
87	25001011801	2010	2384.000	\N
87	25001011802	2010	4198.000	\N
87	25001012001	2010	5609.000	\N
87	25001012002	2010	2886.000	\N
87	25001012101	2010	5152.000	\N
87	25001012102	2010	2943.000	\N
87	25001012200	2010	5003.000	\N
87	25001012502	2010	2946.000	\N
87	25001012601	2010	2729.000	\N
87	25001012602	2010	4505.000	\N
87	25001012700	2010	4449.000	\N
87	25001012800	2010	3851.000	\N
87	25001012900	2010	4063.000	\N
87	25001013002	2010	2863.000	\N
87	25001013100	2010	5819.000	\N
87	25001013200	2010	4695.000	\N
87	25001013300	2010	3190.000	\N
87	25001013400	2010	4119.000	\N
87	25001013500	2010	6859.000	\N
87	25001013600	2010	6214.000	\N
87	25001013700	2010	4831.000	\N
87	25001013800	2010	4745.000	\N
87	25001013900	2010	4791.000	\N
87	25001014002	2010	4005.000	\N
87	25001014100	2010	1047.000	\N
87	25001014300	2010	4334.000	\N
87	25001014402	2010	6824.000	\N
87	25001014500	2010	5256.000	\N
87	25001014600	2010	4041.000	\N
87	25001014700	2010	3628.000	\N
87	25001014800	2010	3342.000	\N
87	25001014900	2010	3541.000	\N
87	25001015001	2010	4290.000	\N
87	25001015002	2010	3632.000	\N
87	25001015100	2010	3725.000	\N
87	25001015200	2010	2042.000	\N
87	25001015300	2010	2852.000	\N
87	25001990000	2010	0.000	\N
87	25003900100	2010	3073.000	\N
87	25003900200	2010	3907.000	\N
87	25003900300	2010	2733.000	\N
87	25003900400	2010	4647.000	\N
87	25003900500	2010	3196.000	\N
87	25003900600	2010	3813.000	\N
87	25003900700	2010	2841.000	\N
87	25003900800	2010	4763.000	\N
87	25003900900	2010	4854.000	\N
87	25003901100	2010	3657.000	\N
87	25003911100	2010	3050.000	\N
87	25003912100	2010	6647.000	\N
87	25003913100	2010	4887.000	\N
87	25003914100	2010	5682.000	\N
87	25003920101	2010	4440.000	\N
87	25003920102	2010	2994.000	\N
87	25003921300	2010	4926.000	\N
87	25003921400	2010	1605.000	\N
87	25003921500	2010	3020.000	\N
87	25003922100	2010	2651.000	\N
87	25003922200	2010	3644.000	\N
87	25003922300	2010	2092.000	\N
87	25003923100	2010	3200.000	\N
87	25003924100	2010	1888.000	\N
87	25003925100	2010	6680.000	\N
87	25003926100	2010	3152.000	\N
87	25003931100	2010	1686.000	\N
87	25003931300	2010	1430.000	\N
87	25003931400	2010	1742.000	\N
87	25003932200	2010	2274.000	\N
87	25003932300	2010	2014.000	\N
87	25003933200	2010	1279.000	\N
87	25003933300	2010	1482.000	\N
87	25003933400	2010	2499.000	\N
87	25003934200	2010	1294.000	\N
87	25003934300	2010	1854.000	\N
87	25003935100	2010	2384.000	\N
87	25003935200	2010	5028.000	\N
87	25003935300	2010	3681.000	\N
87	25005600100	2010	3826.000	\N
87	25005600202	2010	4360.000	\N
87	25005600203	2010	5508.000	\N
87	25005600204	2010	3787.000	\N
87	25005610100	2010	5001.000	\N
87	25005610202	2010	5488.000	\N
87	25005610203	2010	6755.000	\N
87	25005610204	2010	5453.000	\N
87	25005611101	2010	4503.000	\N
87	25005611102	2010	4916.000	\N
87	25005611201	2010	2958.000	\N
87	25005611202	2010	6280.000	\N
87	25005612100	2010	4468.000	\N
87	25005612200	2010	8668.000	\N
87	25005613100	2010	6172.000	\N
87	25005613300	2010	7032.000	\N
87	25005613400	2010	3523.000	\N
87	25005613600	2010	3514.000	\N
87	25005613700	2010	4146.000	\N
87	25005613800	2010	4099.000	\N
87	25005613901	2010	2563.000	\N
87	25005613902	2010	4552.000	\N
87	25005614000	2010	3922.000	\N
87	25005614101	2010	6495.000	\N
87	25005614102	2010	6798.000	\N
87	25005615100	2010	6982.000	\N
87	25005616100	2010	6321.000	\N
87	25005617101	2010	4622.000	\N
87	25005617102	2010	4139.000	\N
87	25005630101	2010	2733.000	\N
87	25005630102	2010	4049.000	\N
87	25005630200	2010	8086.000	\N
87	25005630300	2010	8429.000	\N
87	25005630400	2010	4740.000	\N
87	25005631100	2010	7784.000	\N
87	25005631200	2010	6560.000	\N
87	25005631300	2010	4934.000	\N
87	25005631400	2010	2157.000	\N
87	25005631500	2010	2584.000	\N
87	25005631600	2010	3290.000	\N
87	25005631700	2010	6230.000	\N
87	25005631800	2010	7289.000	\N
87	25005632100	2010	6448.000	\N
87	25005632200	2010	7023.000	\N
87	25005633100	2010	5412.000	\N
87	25005633200	2010	6013.000	\N
87	25005640100	2010	4811.000	\N
87	25005640200	2010	5616.000	\N
87	25005640300	2010	3132.000	\N
87	25005640400	2010	2612.000	\N
87	25005640500	2010	4876.000	\N
87	25005640600	2010	4161.000	\N
87	25005640700	2010	2840.000	\N
87	25005640800	2010	3391.000	\N
87	25005640901	2010	4528.000	\N
87	25005641000	2010	2206.000	\N
87	25005641101	2010	1480.000	\N
87	25005641200	2010	2540.000	\N
87	25005641300	2010	4461.000	\N
87	25005641400	2010	2333.000	\N
87	25005641500	2010	2284.000	\N
87	25005641600	2010	2280.000	\N
87	25005641700	2010	4952.000	\N
87	25005641800	2010	1978.000	\N
87	25005641900	2010	2158.000	\N
87	25005642000	2010	2901.000	\N
87	25005642100	2010	3870.000	\N
87	25005642200	2010	3621.000	\N
87	25005642300	2010	2160.000	\N
87	25005642400	2010	2677.000	\N
87	25005642500	2010	4427.000	\N
87	25005644101	2010	5771.000	\N
87	25005644102	2010	4999.000	\N
87	25005644200	2010	7204.000	\N
87	25005645101	2010	4820.000	\N
87	25005645102	2010	5311.000	\N
87	25005645103	2010	5561.000	\N
87	25005646101	2010	7289.000	\N
87	25005646103	2010	5557.000	\N
87	25005646104	2010	2548.000	\N
87	25005650101	2010	5571.000	\N
87	25005650102	2010	4188.000	\N
87	25005650201	2010	2787.000	\N
87	25005650202	2010	1969.000	\N
87	25005650300	2010	3083.000	\N
87	25005650400	2010	3361.000	\N
87	25005650500	2010	2796.000	\N
87	25005650600	2010	2213.000	\N
87	25005650700	2010	1408.000	\N
87	25005650800	2010	2839.000	\N
87	25005650900	2010	1769.000	\N
87	25005651001	2010	2693.000	\N
87	25005651002	2010	3243.000	\N
87	25005651100	2010	3159.000	\N
87	25005651200	2010	1496.000	\N
87	25005651300	2010	1792.000	\N
87	25005651400	2010	2773.000	\N
87	25005651500	2010	2380.000	\N
87	25005651600	2010	3431.000	\N
87	25005651700	2010	1599.000	\N
87	25005651800	2010	1466.000	\N
87	25005651900	2010	1309.000	\N
87	25005652000	2010	2347.000	\N
87	25005652100	2010	2591.000	\N
87	25005652200	2010	2732.000	\N
87	25005652300	2010	2469.000	\N
87	25005652400	2010	2288.000	\N
87	25005652500	2010	2005.000	\N
87	25005652600	2010	1624.000	\N
87	25005652700	2010	2669.000	\N
87	25005652800	2010	3106.000	\N
87	25005653101	2010	6518.000	\N
87	25005653102	2010	5115.000	\N
87	25005653203	2010	4930.000	\N
87	25005653204	2010	3168.000	\N
87	25005653301	2010	4978.000	\N
87	25005653304	2010	3176.000	\N
87	25005654100	2010	6844.000	\N
87	25005654200	2010	3340.000	\N
87	25005655100	2010	4173.000	\N
87	25005655200	2010	4342.000	\N
87	25005655300	2010	3277.000	\N
87	25005655400	2010	3883.000	\N
87	25005985500	2010	5342.000	\N
87	25005985600	2010	5056.000	\N
87	25005990000	2010	0.000	\N
87	25007200100	2010	3831.000	\N
87	25007200200	2010	4417.000	\N
87	25007200300	2010	3968.000	\N
87	25007200400	2010	3935.000	\N
87	25007990000	2010	0.000	\N
87	25009201100	2010	3358.000	\N
87	25009202101	2010	2017.000	\N
87	25009202102	2010	5649.000	\N
87	25009202200	2010	5766.000	\N
87	25009203100	2010	6918.000	\N
87	25009203200	2010	4473.000	\N
87	25009203301	2010	3952.000	\N
87	25009203302	2010	4048.000	\N
87	25009204101	2010	4055.000	\N
87	25009204102	2010	4504.000	\N
87	25009204200	2010	3906.000	\N
87	25009204300	2010	2093.000	\N
87	25009204400	2010	3130.000	\N
87	25009204500	2010	2792.000	\N
87	25009204600	2010	4623.000	\N
87	25009204701	2010	4692.000	\N
87	25009204702	2010	5080.000	\N
87	25009205100	2010	4712.000	\N
87	25009205200	2010	4004.000	\N
87	25009205300	2010	4071.000	\N
87	25009205400	2010	4871.000	\N
87	25009205500	2010	2681.000	\N
87	25009205600	2010	2966.000	\N
87	25009205700	2010	3732.000	\N
87	25009205800	2010	2014.000	\N
87	25009205900	2010	2894.000	\N
87	25009206000	2010	1551.000	\N
87	25009206100	2010	1950.000	\N
87	25009206200	2010	2422.000	\N
87	25009206300	2010	2234.000	\N
87	25009206400	2010	3718.000	\N
87	25009206500	2010	1782.000	\N
87	25009206600	2010	3215.000	\N
87	25009206700	2010	2866.000	\N
87	25009206800	2010	1840.000	\N
87	25009206900	2010	2925.000	\N
87	25009207000	2010	1320.000	\N
87	25009207100	2010	1843.000	\N
87	25009207200	2010	1705.000	\N
87	25009208101	2010	4878.000	\N
87	25009208102	2010	3032.000	\N
87	25009208200	2010	5103.000	\N
87	25009208300	2010	6994.000	\N
87	25009208400	2010	5555.000	\N
87	25009209100	2010	5965.000	\N
87	25009209200	2010	5429.000	\N
87	25009210100	2010	6796.000	\N
87	25009210200	2010	5281.000	\N
87	25009210300	2010	8772.000	\N
87	25009210400	2010	6487.000	\N
87	25009210500	2010	6233.000	\N
87	25009210600	2010	3714.000	\N
87	25009210700	2010	3254.000	\N
87	25009210800	2010	3830.000	\N
87	25009210900	2010	3672.000	\N
87	25009211100	2010	3708.000	\N
87	25009211200	2010	5956.000	\N
87	25009211300	2010	6854.000	\N
87	25009211401	2010	3424.000	\N
87	25009211402	2010	5933.000	\N
87	25009212100	2010	8347.000	\N
87	25009213100	2010	7816.000	\N
87	25009214100	2010	5977.000	\N
87	25009215101	2010	4832.000	\N
87	25009215102	2010	2811.000	\N
87	25009216100	2010	4780.000	\N
87	25009217100	2010	7054.000	\N
87	25009217201	2010	4062.000	\N
87	25009217202	2010	3446.000	\N
87	25009217300	2010	4102.000	\N
87	25009217400	2010	4964.000	\N
87	25009217500	2010	5945.000	\N
87	25009217600	2010	8532.000	\N
87	25009218100	2010	5060.000	\N
87	25009220101	2010	3942.000	\N
87	25009220102	2010	2899.000	\N
87	25009221100	2010	4124.000	\N
87	25009221300	2010	4470.000	\N
87	25009221400	2010	3055.000	\N
87	25009221500	2010	2777.000	\N
87	25009221600	2010	2291.000	\N
87	25009221700	2010	2749.000	\N
87	25009221800	2010	1766.000	\N
87	25009221901	2010	3380.000	\N
87	25009221902	2010	3390.000	\N
87	25009222100	2010	3458.000	\N
87	25009223100	2010	3823.000	\N
87	25009223200	2010	3661.000	\N
87	25009223300	2010	5459.000	\N
87	25009250100	2010	592.000	\N
87	25009250200	2010	1546.000	\N
87	25009250300	2010	227.000	\N
87	25009250400	2010	368.000	\N
87	25009250500	2010	245.000	\N
87	25009250600	2010	948.000	\N
87	25009250700	2010	666.000	\N
87	25009250800	2010	2544.000	\N
87	25009250900	2010	153.000	\N
87	25009251000	2010	270.000	\N
87	25009251100	2010	785.000	\N
87	25009251200	2010	188.000	\N
87	25009251300	2010	391.000	\N
87	25009251400	2010	1157.000	\N
87	25009251500	2010	1857.000	\N
87	25009251600	2010	1583.000	\N
87	25009251700	2010	2009.000	\N
87	25009251800	2010	4485.000	\N
87	25009252101	2010	2927.000	\N
87	25009252102	2010	3613.000	\N
87	25009252201	2010	2807.000	\N
87	25009252202	2010	3097.000	\N
87	25009252300	2010	4758.000	\N
87	25009252400	2010	1570.000	\N
87	25009252501	2010	2855.000	\N
87	25009252502	2010	4295.000	\N
87	25009252601	2010	6000.000	\N
87	25009252602	2010	4022.000	\N
87	25009252603	2010	2780.000	\N
87	25009253100	2010	5031.000	\N
87	25009253201	2010	2741.000	\N
87	25009253202	2010	5608.000	\N
87	25009253203	2010	4094.000	\N
87	25009253204	2010	5216.000	\N
87	25009253205	2010	4264.000	\N
87	25009254100	2010	5846.000	\N
87	25009254200	2010	4752.000	\N
87	25009254301	2010	3816.000	\N
87	25009254302	2010	4412.000	\N
87	25009254401	2010	3106.000	\N
87	25009254402	2010	6335.000	\N
87	25009254403	2010	3738.000	\N
87	25009260100	2010	3048.000	\N
87	25009260200	2010	2798.000	\N
87	25009260301	2010	4259.000	\N
87	25009260302	2010	3012.000	\N
87	25009260401	2010	3610.000	\N
87	25009260402	2010	5911.000	\N
87	25009260500	2010	3549.000	\N
87	25009260600	2010	2583.000	\N
87	25009260700	2010	3784.000	\N
87	25009260800	2010	2832.000	\N
87	25009260900	2010	3941.000	\N
87	25009261000	2010	3579.000	\N
87	25009261101	2010	4646.000	\N
87	25009261102	2010	4496.000	\N
87	25009262100	2010	6223.000	\N
87	25009263100	2010	4169.000	\N
87	25009264100	2010	6374.000	\N
87	25009265101	2010	3580.000	\N
87	25009265102	2010	4460.000	\N
87	25009266100	2010	3962.000	\N
87	25009266200	2010	5083.000	\N
87	25009266300	2010	3640.000	\N
87	25009266400	2010	3288.000	\N
87	25009267101	2010	3517.000	\N
87	25009267102	2010	4638.000	\N
87	25009268100	2010	2617.000	\N
87	25009268200	2010	6215.000	\N
87	25009268300	2010	4058.000	\N
87	25009268400	2010	4235.000	\N
87	25009269100	2010	6599.000	\N
87	25009270100	2010	5797.000	\N
87	25009990100	2010	0.000	\N
87	25011040100	2010	4447.000	\N
87	25011040200	2010	4303.000	\N
87	25011040300	2010	2976.000	\N
87	25011040400	2010	3368.000	\N
87	25011040501	2010	4118.000	\N
87	25011040502	2010	3499.000	\N
87	25011040600	2010	4508.000	\N
87	25011040701	2010	3867.000	\N
87	25011040702	2010	4132.000	\N
87	25011040800	2010	4973.000	\N
87	25011040900	2010	4993.000	\N
87	25011041000	2010	3104.000	\N
87	25011041100	2010	3521.000	\N
87	25011041200	2010	3041.000	\N
87	25011041300	2010	4400.000	\N
87	25011041400	2010	2537.000	\N
87	25011041501	2010	3575.000	\N
87	25011041502	2010	3760.000	\N
87	25013800101	2010	2763.000	\N
87	25013800102	2010	2560.000	\N
87	25013800201	2010	3992.000	\N
87	25013800202	2010	974.000	\N
87	25013800300	2010	2674.000	\N
87	25013800400	2010	3328.000	\N
87	25013800500	2010	1404.000	\N
87	25013800600	2010	251.000	\N
87	25013800700	2010	499.000	\N
87	25013800800	2010	397.000	\N
87	25013800900	2010	1164.000	\N
87	25013801101	2010	639.000	\N
87	25013801102	2010	934.000	\N
87	25013801200	2010	1056.000	\N
87	25013801300	2010	2864.000	\N
87	25013801401	2010	2255.000	\N
87	25013801402	2010	1375.000	\N
87	25013801501	2010	3776.000	\N
87	25013801502	2010	2127.000	\N
87	25013801503	2010	2741.000	\N
87	25013801601	2010	4461.000	\N
87	25013801602	2010	4135.000	\N
87	25013801603	2010	3506.000	\N
87	25013801604	2010	3418.000	\N
87	25013801605	2010	3643.000	\N
87	25013801700	2010	5737.000	\N
87	25013801800	2010	2250.000	\N
87	25013801901	2010	1582.000	\N
87	25013801902	2010	1447.000	\N
87	25013802000	2010	810.000	\N
87	25013802100	2010	4105.000	\N
87	25013802200	2010	1591.000	\N
87	25013802300	2010	3384.000	\N
87	25013802400	2010	3244.000	\N
87	25013802500	2010	5877.000	\N
87	25013802601	2010	4889.000	\N
87	25013802602	2010	1757.000	\N
87	25013810100	2010	6129.000	\N
87	25013810200	2010	2654.000	\N
87	25013810300	2010	3066.000	\N
87	25013810403	2010	3709.000	\N
87	25013810404	2010	3616.000	\N
87	25013810412	2010	5840.000	\N
87	25013810414	2010	6755.000	\N
87	25013810601	2010	3800.000	\N
87	25013810602	2010	2594.000	\N
87	25013810700	2010	5450.000	\N
87	25013810800	2010	3135.000	\N
87	25013810901	2010	1323.000	\N
87	25013810902	2010	3726.000	\N
87	25013811000	2010	4303.000	\N
87	25013811101	2010	3703.000	\N
87	25013811102	2010	4242.000	\N
87	25013811200	2010	4525.000	\N
87	25013811301	2010	4983.000	\N
87	25013811302	2010	5318.000	\N
87	25013811400	2010	240.000	\N
87	25013811500	2010	217.000	\N
87	25013811600	2010	519.000	\N
87	25013811700	2010	586.000	\N
87	25013811800	2010	1775.000	\N
87	25013811900	2010	3167.000	\N
87	25013812001	2010	1677.000	\N
87	25013812002	2010	2675.000	\N
87	25013812101	2010	4741.000	\N
87	25013812103	2010	2059.000	\N
87	25013812104	2010	2911.000	\N
87	25013812201	2010	4163.000	\N
87	25013812202	2010	3532.000	\N
87	25013812300	2010	4897.000	\N
87	25013812401	2010	6065.000	\N
87	25013812403	2010	3605.000	\N
87	25013812404	2010	3658.000	\N
87	25013812500	2010	6952.000	\N
87	25013812600	2010	6584.000	\N
87	25013812701	2010	3630.000	\N
87	25013812702	2010	4587.000	\N
87	25013812800	2010	6244.000	\N
87	25013812901	2010	2847.000	\N
87	25013812902	2010	4660.000	\N
87	25013812903	2010	2493.000	\N
87	25013813000	2010	7111.000	\N
87	25013813101	2010	5784.000	\N
87	25013813102	2010	3520.000	\N
87	25013813204	2010	3181.000	\N
87	25013813205	2010	7215.000	\N
87	25013813206	2010	3916.000	\N
87	25013813207	2010	4868.000	\N
87	25013813208	2010	2836.000	\N
87	25013813209	2010	5482.000	\N
87	25013813301	2010	7140.000	\N
87	25013813303	2010	4299.000	\N
87	25013813304	2010	3975.000	\N
87	25013813401	2010	5083.000	\N
87	25013813403	2010	3765.000	\N
87	25013813404	2010	6515.000	\N
87	25013813500	2010	5064.000	\N
87	25013813601	2010	7889.000	\N
87	25013813602	2010	5937.000	\N
87	25013813701	2010	3396.000	\N
87	25013813702	2010	5011.000	\N
87	25013813801	2010	4233.000	\N
87	25013813802	2010	3530.000	\N
87	25015820101	2010	6053.000	\N
87	25015820102	2010	3430.000	\N
87	25015820202	2010	1280.000	\N
87	25015820203	2010	8227.000	\N
87	25015820204	2010	6037.000	\N
87	25015820300	2010	6371.000	\N
87	25015820400	2010	11475.000	\N
87	25015820500	2010	5952.000	\N
87	25015820600	2010	1464.000	\N
87	25015820700	2010	4068.000	\N
87	25015820801	2010	4654.000	\N
87	25015820802	2010	1078.000	\N
87	25015820900	2010	6110.000	\N
87	25015821000	2010	4127.000	\N
87	25015821100	2010	6645.000	\N
87	25015821200	2010	1987.000	\N
87	25015821300	2010	4002.000	\N
87	25015821400	2010	5087.000	\N
87	25015821500	2010	3232.000	\N
87	25015821601	2010	3104.000	\N
87	25015821602	2010	3515.000	\N
87	25015821700	2010	3614.000	\N
87	25015821901	2010	3162.000	\N
87	25015821903	2010	3037.000	\N
87	25015821904	2010	2617.000	\N
87	25015822000	2010	1811.000	\N
87	25015822200	2010	5761.000	\N
87	25015822300	2010	5149.000	\N
87	25015822401	2010	5725.000	\N
87	25015822402	2010	4589.000	\N
87	25015822500	2010	5707.000	\N
87	25015822601	2010	2139.000	\N
87	25015822603	2010	1577.000	\N
87	25015822605	2010	1204.000	\N
87	25015822606	2010	3475.000	\N
87	25015822700	2010	3160.000	\N
87	25017300100	2010	3017.000	\N
87	25017301101	2010	3933.000	\N
87	25017301102	2010	4830.000	\N
87	25017310100	2010	3865.000	\N
87	25017310200	2010	4863.000	\N
87	25017310300	2010	4601.000	\N
87	25017310400	2010	2122.000	\N
87	25017310500	2010	3016.000	\N
87	25017310601	2010	5135.000	\N
87	25017310602	2010	5258.000	\N
87	25017310700	2010	3665.000	\N
87	25017311100	2010	1618.000	\N
87	25017311200	2010	2786.000	\N
87	25017311300	2010	3537.000	\N
87	25017311400	2010	5131.000	\N
87	25017311500	2010	2730.000	\N
87	25017311600	2010	4837.000	\N
87	25017311700	2010	4417.000	\N
87	25017311800	2010	2932.000	\N
87	25017311900	2010	1839.000	\N
87	25017312000	2010	2222.000	\N
87	25017312100	2010	2491.000	\N
87	25017312200	2010	3711.000	\N
87	25017312300	2010	4435.000	\N
87	25017312400	2010	1384.000	\N
87	25017312501	2010	4062.000	\N
87	25017312502	2010	3686.000	\N
87	25017313101	2010	5361.000	\N
87	25017313102	2010	5666.000	\N
87	25017314101	2010	5840.000	\N
87	25017314102	2010	6927.000	\N
87	25017314200	2010	4993.000	\N
87	25017314301	2010	7673.000	\N
87	25017314302	2010	2875.000	\N
87	25017315100	2010	5345.000	\N
87	25017315200	2010	7428.000	\N
87	25017315401	2010	3416.000	\N
87	25017315402	2010	2871.000	\N
87	25017315403	2010	1726.000	\N
87	25017315500	2010	7573.000	\N
87	25017316101	2010	5016.000	\N
87	25017316102	2010	5957.000	\N
87	25017316201	2010	4031.000	\N
87	25017316202	2010	4190.000	\N
87	25017316300	2010	7931.000	\N
87	25017316400	2010	6343.000	\N
87	25017316500	2010	5740.000	\N
87	25017317101	2010	6013.000	\N
87	25017317102	2010	4253.000	\N
87	25017317103	2010	4819.000	\N
87	25017317201	2010	2797.000	\N
87	25017317202	2010	3325.000	\N
87	25017317203	2010	3947.000	\N
87	25017317301	2010	2542.000	\N
87	25017317302	2010	5420.000	\N
87	25017318100	2010	6585.000	\N
87	25017318200	2010	3785.000	\N
87	25017318300	2010	7395.000	\N
87	25017318400	2010	3853.000	\N
87	25017320102	2010	4952.000	\N
87	25017320103	2010	2740.000	\N
87	25017320104	2010	6966.000	\N
87	25017321100	2010	6535.000	\N
87	25017321200	2010	5812.000	\N
87	25017321300	2010	6131.000	\N
87	25017321400	2010	3136.000	\N
87	25017321500	2010	5673.000	\N
87	25017321600	2010	7038.000	\N
87	25017322100	2010	4553.000	\N
87	25017322200	2010	3552.000	\N
87	25017322300	2010	5714.000	\N
87	25017322400	2010	4430.000	\N
87	25017323100	2010	6468.000	\N
87	25017324101	2010	4700.000	\N
87	25017324102	2010	4103.000	\N
87	25017325100	2010	7006.000	\N
87	25017326101	2010	3827.000	\N
87	25017326102	2010	6626.000	\N
87	25017327101	2010	3538.000	\N
87	25017327102	2010	4244.000	\N
87	25017327103	2010	3521.000	\N
87	25017328100	2010	3135.000	\N
87	25017330100	2010	8110.000	\N
87	25017330200	2010	6551.000	\N
87	25017331101	2010	2954.000	\N
87	25017331102	2010	6842.000	\N
87	25017331200	2010	5271.000	\N
87	25017331300	2010	6855.000	\N
87	25017332100	2010	5889.000	\N
87	25017332200	2010	8081.000	\N
87	25017332300	2010	6572.000	\N
87	25017332400	2010	3378.000	\N
87	25017333100	2010	7222.000	\N
87	25017333200	2010	5202.000	\N
87	25017333300	2010	3764.000	\N
87	25017333400	2010	5877.000	\N
87	25017333501	2010	4790.000	\N
87	25017333502	2010	3030.000	\N
87	25017333600	2010	6511.000	\N
87	25017334100	2010	6592.000	\N
87	25017334200	2010	3898.000	\N
87	25017334300	2010	7515.000	\N
87	25017334400	2010	6364.000	\N
87	25017335100	2010	5604.000	\N
87	25017335200	2010	5526.000	\N
87	25017335301	2010	3738.000	\N
87	25017335302	2010	4508.000	\N
87	25017335400	2010	4981.000	\N
87	25017336100	2010	5234.000	\N
87	25017336200	2010	6037.000	\N
87	25017336300	2010	6521.000	\N
87	25017336401	2010	4104.000	\N
87	25017336402	2010	4424.000	\N
87	25017337101	2010	3017.000	\N
87	25017337102	2010	4947.000	\N
87	25017337201	2010	3112.000	\N
87	25017337202	2010	4711.000	\N
87	25017337300	2010	5016.000	\N
87	25017338100	2010	2892.000	\N
87	25017338200	2010	3769.000	\N
87	25017338300	2010	3124.000	\N
87	25017338400	2010	5659.000	\N
87	25017338500	2010	5525.000	\N
87	25017339100	2010	6280.000	\N
87	25017339200	2010	5711.000	\N
87	25017339300	2010	2756.000	\N
87	25017339400	2010	3173.000	\N
87	25017339500	2010	5163.000	\N
87	25017339600	2010	4752.000	\N
87	25017339700	2010	3597.000	\N
87	25017339801	2010	4191.000	\N
87	25017339802	2010	4272.000	\N
87	25017339900	2010	4908.000	\N
87	25017340000	2010	2431.000	\N
87	25017340100	2010	6492.000	\N
87	25017341101	2010	3515.000	\N
87	25017341102	2010	4323.000	\N
87	25017341200	2010	6418.000	\N
87	25017341300	2010	5215.000	\N
87	25017341400	2010	5504.000	\N
87	25017341500	2010	4114.000	\N
87	25017341600	2010	6196.000	\N
87	25017341700	2010	4825.000	\N
87	25017341800	2010	5730.000	\N
87	25017341901	2010	1260.000	\N
87	25017341902	2010	7358.000	\N
87	25017342101	2010	3560.000	\N
87	25017342102	2010	3377.000	\N
87	25017342201	2010	4161.000	\N
87	25017342202	2010	3115.000	\N
87	25017342300	2010	5481.000	\N
87	25017342400	2010	4778.000	\N
87	25017342500	2010	5215.000	\N
87	25017342600	2010	3188.000	\N
87	25017350103	2010	1099.000	\N
87	25017350104	2010	5610.000	\N
87	25017350200	2010	5685.000	\N
87	25017350300	2010	2177.000	\N
87	25017350400	2010	5387.000	\N
87	25017350500	2010	1585.000	\N
87	25017350600	2010	4384.000	\N
87	25017350700	2010	5573.000	\N
87	25017350800	2010	1751.000	\N
87	25017350900	2010	3187.000	\N
87	25017351000	2010	6141.000	\N
87	25017351100	2010	5321.000	\N
87	25017351203	2010	4029.000	\N
87	25017351204	2010	3783.000	\N
87	25017351300	2010	3920.000	\N
87	25017351403	2010	2854.000	\N
87	25017351404	2010	3353.000	\N
87	25017351500	2010	1898.000	\N
87	25017352101	2010	1422.000	\N
87	25017352102	2010	2150.000	\N
87	25017352200	2010	1659.000	\N
87	25017352300	2010	3104.000	\N
87	25017352400	2010	1776.000	\N
87	25017352500	2010	2610.000	\N
87	25017352600	2010	2113.000	\N
87	25017352700	2010	1829.000	\N
87	25017352800	2010	1901.000	\N
87	25017352900	2010	2508.000	\N
87	25017353000	2010	3271.000	\N
87	25017353101	2010	2194.000	\N
87	25017353102	2010	4479.000	\N
87	25017353200	2010	4536.000	\N
87	25017353300	2010	3301.000	\N
87	25017353400	2010	2607.000	\N
87	25017353500	2010	2427.000	\N
87	25017353600	2010	4305.000	\N
87	25017353700	2010	5011.000	\N
87	25017353800	2010	4445.000	\N
87	25017353900	2010	6512.000	\N
87	25017354000	2010	4102.000	\N
87	25017354100	2010	2760.000	\N
87	25017354200	2010	2812.000	\N
87	25017354300	2010	3100.000	\N
87	25017354400	2010	1580.000	\N
87	25017354500	2010	2124.000	\N
87	25017354600	2010	4304.000	\N
87	25017354700	2010	2403.000	\N
87	25017354800	2010	1827.000	\N
87	25017354900	2010	5495.000	\N
87	25017355000	2010	2521.000	\N
87	25017356100	2010	2990.000	\N
87	25017356300	2010	4797.000	\N
87	25017356400	2010	7075.000	\N
87	25017356500	2010	6381.000	\N
87	25017356601	2010	4079.000	\N
87	25017356602	2010	4058.000	\N
87	25017356701	2010	5630.000	\N
87	25017356702	2010	6439.000	\N
87	25017357100	2010	4092.000	\N
87	25017357200	2010	3104.000	\N
87	25017357300	2010	2876.000	\N
87	25017357400	2010	2253.000	\N
87	25017357500	2010	2071.000	\N
87	25017357600	2010	2359.000	\N
87	25017357700	2010	3595.000	\N
87	25017357800	2010	3625.000	\N
87	25017358100	2010	5002.000	\N
87	25017358300	2010	5377.000	\N
87	25017358400	2010	4775.000	\N
87	25017358500	2010	4760.000	\N
87	25017358600	2010	5819.000	\N
87	25017358700	2010	4948.000	\N
87	25017359100	2010	6017.000	\N
87	25017359300	2010	6947.000	\N
87	25017360100	2010	1094.000	\N
87	25017360200	2010	4952.000	\N
87	25017361100	2010	5574.000	\N
87	25017361200	2010	5400.000	\N
87	25017361300	2010	6039.000	\N
87	25017362100	2010	4752.000	\N
87	25017363102	2010	5694.000	\N
87	25017363103	2010	3149.000	\N
87	25017363104	2010	5962.000	\N
87	25017363201	2010	3158.000	\N
87	25017363202	2010	3401.000	\N
87	25017364101	2010	5026.000	\N
87	25017364102	2010	4703.000	\N
87	25017365100	2010	7604.000	\N
87	25017365201	2010	5488.000	\N
87	25017365202	2010	4217.000	\N
87	25017366100	2010	4561.000	\N
87	25017366201	2010	3517.000	\N
87	25017366202	2010	4601.000	\N
87	25017367100	2010	3869.000	\N
87	25017367200	2010	7098.000	\N
87	25017368101	2010	5795.000	\N
87	25017368102	2010	3371.000	\N
87	25017368200	2010	3930.000	\N
87	25017368300	2010	4136.000	\N
87	25017368400	2010	7352.000	\N
87	25017368500	2010	2441.000	\N
87	25017368600	2010	3856.000	\N
87	25017368700	2010	1593.000	\N
87	25017368800	2010	3609.000	\N
87	25017368901	2010	6414.000	\N
87	25017368902	2010	3821.000	\N
87	25017369000	2010	1448.000	\N
87	25017369100	2010	4586.000	\N
87	25017370101	2010	6104.000	\N
87	25017370102	2010	6331.000	\N
87	25017370201	2010	3629.000	\N
87	25017370202	2010	3990.000	\N
87	25017370300	2010	5269.000	\N
87	25017370400	2010	4904.000	\N
87	25017373100	2010	4578.000	\N
87	25017373200	2010	4122.000	\N
87	25017373300	2010	2695.000	\N
87	25017373400	2010	3060.000	\N
87	25017373500	2010	5965.000	\N
87	25017373600	2010	5645.000	\N
87	25017373700	2010	3714.000	\N
87	25017373800	2010	5704.000	\N
87	25017373900	2010	6177.000	\N
87	25017374000	2010	5030.000	\N
87	25017374100	2010	4413.000	\N
87	25017374200	2010	4054.000	\N
87	25017374300	2010	3424.000	\N
87	25017374400	2010	5564.000	\N
87	25017374500	2010	4122.000	\N
87	25017374600	2010	4513.000	\N
87	25017374700	2010	4309.000	\N
87	25017374800	2010	4581.000	\N
87	25017382100	2010	4793.000	\N
87	25017382200	2010	5000.000	\N
87	25017382300	2010	5415.000	\N
87	25017382400	2010	4418.000	\N
87	25017382500	2010	4276.000	\N
87	25017382601	2010	4071.000	\N
87	25017382602	2010	4039.000	\N
87	25017383101	2010	3074.000	\N
87	25017383102	2010	2570.000	\N
87	25017383200	2010	4470.000	\N
87	25017383300	2010	2690.000	\N
87	25017383400	2010	4598.000	\N
87	25017383501	2010	3652.000	\N
87	25017383502	2010	3502.000	\N
87	25017383600	2010	5683.000	\N
87	25017383700	2010	4852.000	\N
87	25017383800	2010	5075.000	\N
87	25017383901	2010	7367.000	\N
87	25017383902	2010	5078.000	\N
87	25017384001	2010	1360.000	\N
87	25017384002	2010	5186.000	\N
87	25017385100	2010	6503.000	\N
87	25017385201	2010	2374.000	\N
87	25017385202	2010	6976.000	\N
87	25017386100	2010	4062.000	\N
87	25017387100	2010	4191.000	\N
87	25017387201	2010	5359.000	\N
87	25017387202	2010	3751.000	\N
87	25017388100	2010	4883.000	\N
87	25017388200	2010	6650.000	\N
87	25017388300	2010	3780.000	\N
87	25017980000	2010	0.000	\N
87	25019950100	2010	1345.000	\N
87	25019950200	2010	4267.000	\N
87	25019950307	2010	338.000	\N
87	25019950400	2010	2120.000	\N
87	25019950500	2010	1145.000	\N
87	25019990000	2010	0.000	\N
87	25021400100	2010	4698.000	\N
87	25021400200	2010	5749.000	\N
87	25021400300	2010	3922.000	\N
87	25021400400	2010	5219.000	\N
87	25021400500	2010	4936.000	\N
87	25021400600	2010	4960.000	\N
87	25021400700	2010	3429.000	\N
87	25021400800	2010	5358.000	\N
87	25021400900	2010	3623.000	\N
87	25021401000	2010	2902.000	\N
87	25021401100	2010	4269.000	\N
87	25021401200	2010	6703.000	\N
87	25021402101	2010	3441.000	\N
87	25021402102	2010	3719.000	\N
87	25021402200	2010	2013.000	\N
87	25021402300	2010	4400.000	\N
87	25021402400	2010	5734.000	\N
87	25021402500	2010	4069.000	\N
87	25021403100	2010	6710.000	\N
87	25021403300	2010	4123.000	\N
87	25021403400	2010	6328.000	\N
87	25021403500	2010	5551.000	\N
87	25021404100	2010	3833.000	\N
87	25021404201	2010	3582.000	\N
87	25021404202	2010	4747.000	\N
87	25021404301	2010	5383.000	\N
87	25021404302	2010	3433.000	\N
87	25021404400	2010	5984.000	\N
87	25021405100	2010	5506.000	\N
87	25021406101	2010	5444.000	\N
87	25021406102	2010	6400.000	\N
87	25021407100	2010	7755.000	\N
87	25021408101	2010	7828.000	\N
87	25021408102	2010	4674.000	\N
87	25021409101	2010	5470.000	\N
87	25021409102	2010	4955.000	\N
87	25021410100	2010	6061.000	\N
87	25021410300	2010	4351.000	\N
87	25021410400	2010	6144.000	\N
87	25021411100	2010	7751.000	\N
87	25021411200	2010	6425.000	\N
87	25021411301	2010	5464.000	\N
87	25021411302	2010	3779.000	\N
87	25021412100	2010	6229.000	\N
87	25021412200	2010	3522.000	\N
87	25021412300	2010	4630.000	\N
87	25021413100	2010	5681.000	\N
87	25021413200	2010	5835.000	\N
87	25021413300	2010	4776.000	\N
87	25021413401	2010	3061.000	\N
87	25021413402	2010	4031.000	\N
87	25021413500	2010	3991.000	\N
87	25021414100	2010	5561.000	\N
87	25021414200	2010	7011.000	\N
87	25021414300	2010	4667.000	\N
87	25021415101	2010	4444.000	\N
87	25021415102	2010	7255.000	\N
87	25021415200	2010	5612.000	\N
87	25021415300	2010	3654.000	\N
87	25021416101	2010	5612.000	\N
87	25021416102	2010	3694.000	\N
87	25021416200	2010	6263.000	\N
87	25021416300	2010	4563.000	\N
87	25021416400	2010	5990.000	\N
87	25021417100	2010	4179.000	\N
87	25021417200	2010	8024.000	\N
87	25021417300	2010	2609.000	\N
87	25021417400	2010	2518.000	\N
87	25021417501	2010	4899.000	\N
87	25021417502	2010	4494.000	\N
87	25021417601	2010	5056.000	\N
87	25021417602	2010	5015.000	\N
87	25021417701	2010	5246.000	\N
87	25021417702	2010	2700.000	\N
87	25021417801	2010	5307.000	\N
87	25021417802	2010	3023.000	\N
87	25021417901	2010	5845.000	\N
87	25021417902	2010	3362.000	\N
87	25021418002	2010	6732.000	\N
87	25021418003	2010	2328.000	\N
87	25021418004	2010	4061.000	\N
87	25021418101	2010	4674.000	\N
87	25021418102	2010	3171.000	\N
87	25021418200	2010	5939.000	\N
87	25021419100	2010	5577.000	\N
87	25021419200	2010	4867.000	\N
87	25021419300	2010	3649.000	\N
87	25021419400	2010	3085.000	\N
87	25021419500	2010	3022.000	\N
87	25021419600	2010	6641.000	\N
87	25021419700	2010	3759.000	\N
87	25021419800	2010	4254.000	\N
87	25021420100	2010	7294.000	\N
87	25021420201	2010	3308.000	\N
87	25021420202	2010	5900.000	\N
87	25021420301	2010	6268.000	\N
87	25021420302	2010	7285.000	\N
87	25021421100	2010	4859.000	\N
87	25021421200	2010	5458.000	\N
87	25021422100	2010	5188.000	\N
87	25021422200	2010	6688.000	\N
87	25021422301	2010	2929.000	\N
87	25021422302	2010	6384.000	\N
87	25021422400	2010	7593.000	\N
87	25021422501	2010	4589.000	\N
87	25021422502	2010	4959.000	\N
87	25021422600	2010	6515.000	\N
87	25021422700	2010	3731.000	\N
87	25021422800	2010	3755.000	\N
87	25021423100	2010	7446.000	\N
87	25021440100	2010	8117.000	\N
87	25021441202	2010	2683.000	\N
87	25021441203	2010	3691.000	\N
87	25021441204	2010	4448.000	\N
87	25021442101	2010	5450.000	\N
87	25021442102	2010	6961.000	\N
87	25021442103	2010	6831.000	\N
87	25021442201	2010	4092.000	\N
87	25021442202	2010	7681.000	\N
87	25021443101	2010	7403.000	\N
87	25021443102	2010	8520.000	\N
87	25021456101	2010	3679.000	\N
87	25021456102	2010	4773.000	\N
87	25021456200	2010	3071.000	\N
87	25021456301	2010	1665.000	\N
87	25021456302	2010	4833.000	\N
87	25021456401	2010	2674.000	\N
87	25021456402	2010	5391.000	\N
87	25021457100	2010	4235.000	\N
87	25021457200	2010	5556.000	\N
87	25023500101	2010	3650.000	\N
87	25023500103	2010	2184.000	\N
87	25023500104	2010	4286.000	\N
87	25023501101	2010	3276.000	\N
87	25023501102	2010	7957.000	\N
87	25023501201	2010	3634.000	\N
87	25023501202	2010	7049.000	\N
87	25023502101	2010	5950.000	\N
87	25023502102	2010	5439.000	\N
87	25023502200	2010	5752.000	\N
87	25023503101	2010	7091.000	\N
87	25023503102	2010	6660.000	\N
87	25023504101	2010	5287.000	\N
87	25023504102	2010	5091.000	\N
87	25023505101	2010	6396.000	\N
87	25023505102	2010	4941.000	\N
87	25023505200	2010	6605.000	\N
87	25023506101	2010	6448.000	\N
87	25023506102	2010	5796.000	\N
87	25023506202	2010	2490.000	\N
87	25023506203	2010	5161.000	\N
87	25023506204	2010	4922.000	\N
87	25023507101	2010	5254.000	\N
87	25023507103	2010	4286.000	\N
87	25023507104	2010	5335.000	\N
87	25023508101	2010	6635.000	\N
87	25023508102	2010	5042.000	\N
87	25023508200	2010	5967.000	\N
87	25023509101	2010	6862.000	\N
87	25023509102	2010	5627.000	\N
87	25023510100	2010	4454.000	\N
87	25023510200	2010	5477.000	\N
87	25023510300	2010	3343.000	\N
87	25023510400	2010	3133.000	\N
87	25023510501	2010	3121.000	\N
87	25023510502	2010	5275.000	\N
87	25023510503	2010	4006.000	\N
87	25023510600	2010	2726.000	\N
87	25023510700	2010	5226.000	\N
87	25023510800	2010	5512.000	\N
87	25023510900	2010	2125.000	\N
87	25023511000	2010	2575.000	\N
87	25023511100	2010	4911.000	\N
87	25023511200	2010	4295.000	\N
87	25023511301	2010	4725.000	\N
87	25023511302	2010	3169.000	\N
87	25023511400	2010	3186.000	\N
87	25023511500	2010	3751.000	\N
87	25023511600	2010	6455.000	\N
87	25023511701	2010	4331.000	\N
87	25023511702	2010	2657.000	\N
87	25023520100	2010	6356.000	\N
87	25023520201	2010	3874.000	\N
87	25023520202	2010	5445.000	\N
87	25023521101	2010	4223.000	\N
87	25023521102	2010	3246.000	\N
87	25023521201	2010	2835.000	\N
87	25023521202	2010	3918.000	\N
87	25023522101	2010	4696.000	\N
87	25023522102	2010	5418.000	\N
87	25023523100	2010	2987.000	\N
87	25023523201	2010	2871.000	\N
87	25023523202	2010	7732.000	\N
87	25023524101	2010	2972.000	\N
87	25023524102	2010	3823.000	\N
87	25023525101	2010	6156.000	\N
87	25023525104	2010	6219.000	\N
87	25023525203	2010	5496.000	\N
87	25023525204	2010	3327.000	\N
87	25023525300	2010	1717.000	\N
87	25023526100	2010	7437.000	\N
87	25023530100	2010	3695.000	\N
87	25023530200	2010	3511.000	\N
87	25023530300	2010	3701.000	\N
87	25023530400	2010	5755.000	\N
87	25023530500	2010	5622.000	\N
87	25023530600	2010	6140.000	\N
87	25023530700	2010	4180.000	\N
87	25023530801	2010	5519.000	\N
87	25023530802	2010	4726.000	\N
87	25023530901	2010	8173.000	\N
87	25023530902	2010	4416.000	\N
87	25023540101	2010	3752.000	\N
87	25023540102	2010	2546.000	\N
87	25023540103	2010	4212.000	\N
87	25023541100	2010	5192.000	\N
87	25023542101	2010	7016.000	\N
87	25023542102	2010	2528.000	\N
87	25023542200	2010	6045.000	\N
87	25023542300	2010	7160.000	\N
87	25023543100	2010	2784.000	\N
87	25023544100	2010	5573.000	\N
87	25023544200	2010	5807.000	\N
87	25023545100	2010	6322.000	\N
87	25023545200	2010	5481.000	\N
87	25023545300	2010	4317.000	\N
87	25023545400	2010	5200.000	\N
87	25023560100	2010	5988.000	\N
87	25023561100	2010	4855.000	\N
87	25023561200	2010	2810.000	\N
87	25023990003	2010	0.000	\N
87	25025000100	2010	3633.000	\N
87	25025000201	2010	3447.000	\N
87	25025000202	2010	3289.000	\N
87	25025000301	2010	2550.000	\N
87	25025000302	2010	2913.000	\N
87	25025000401	2010	5385.000	\N
87	25025000402	2010	3459.000	\N
87	25025000502	2010	5857.000	\N
87	25025000503	2010	2115.000	\N
87	25025000504	2010	4667.000	\N
87	25025000601	2010	3283.000	\N
87	25025000602	2010	3333.000	\N
87	25025000701	2010	4113.000	\N
87	25025000703	2010	2609.000	\N
87	25025000704	2010	4226.000	\N
87	25025000802	2010	6670.000	\N
87	25025000803	2010	6008.000	\N
87	25025010103	2010	4222.000	\N
87	25025010104	2010	4395.000	\N
87	25025010203	2010	5000.000	\N
87	25025010204	2010	2995.000	\N
87	25025010300	2010	4404.000	\N
87	25025010403	2010	2710.000	\N
87	25025010404	2010	5431.000	\N
87	25025010405	2010	5087.000	\N
87	25025010408	2010	1293.000	\N
87	25025010500	2010	2753.000	\N
87	25025010600	2010	2702.000	\N
87	25025010701	2010	2342.000	\N
87	25025010702	2010	2298.000	\N
87	25025010801	2010	2644.000	\N
87	25025010802	2010	2940.000	\N
87	25025020101	2010	4054.000	\N
87	25025020200	2010	3475.000	\N
87	25025020301	2010	1915.000	\N
87	25025020302	2010	1120.000	\N
87	25025020303	2010	3027.000	\N
87	25025030100	2010	1886.000	\N
87	25025030200	2010	1596.000	\N
87	25025030300	2010	4633.000	\N
87	25025030400	2010	2373.000	\N
87	25025030500	2010	2445.000	\N
87	25025040100	2010	2127.000	\N
87	25025040200	2010	1255.000	\N
87	25025040300	2010	3498.000	\N
87	25025040401	2010	2295.000	\N
87	25025040600	2010	2386.000	\N
87	25025040801	2010	3287.000	\N
87	25025050101	2010	1975.000	\N
87	25025050200	2010	1804.000	\N
87	25025050300	2010	1223.000	\N
87	25025050400	2010	1168.000	\N
87	25025050500	2010	861.000	\N
87	25025050600	2010	689.000	\N
87	25025050700	2010	1598.000	\N
87	25025050901	2010	1461.000	\N
87	25025051000	2010	2517.000	\N
87	25025051101	2010	3918.000	\N
87	25025051200	2010	1557.000	\N
87	25025060101	2010	3172.000	\N
87	25025060200	2010	1903.000	\N
87	25025060301	2010	3048.000	\N
87	25025060400	2010	4814.000	\N
87	25025060501	2010	3499.000	\N
87	25025060600	2010	2265.000	\N
87	25025060700	2010	1016.000	\N
87	25025060800	2010	3858.000	\N
87	25025061000	2010	2203.000	\N
87	25025061101	2010	1297.000	\N
87	25025061200	2010	3084.000	\N
87	25025070101	2010	5542.000	\N
87	25025070200	2010	5058.000	\N
87	25025070300	2010	3748.000	\N
87	25025070402	2010	1565.000	\N
87	25025070500	2010	4390.000	\N
87	25025070600	2010	2126.000	\N
87	25025070700	2010	2167.000	\N
87	25025070800	2010	3369.000	\N
87	25025070900	2010	2615.000	\N
87	25025071101	2010	3240.000	\N
87	25025071201	2010	2373.000	\N
87	25025080100	2010	2408.000	\N
87	25025080300	2010	1261.000	\N
87	25025080401	2010	1726.000	\N
87	25025080500	2010	1767.000	\N
87	25025080601	2010	3528.000	\N
87	25025080801	2010	2540.000	\N
87	25025080900	2010	3695.000	\N
87	25025081001	2010	3940.000	\N
87	25025081100	2010	3483.000	\N
87	25025081200	2010	1545.000	\N
87	25025081300	2010	2499.000	\N
87	25025081400	2010	2417.000	\N
87	25025081500	2010	1618.000	\N
87	25025081700	2010	3038.000	\N
87	25025081800	2010	2162.000	\N
87	25025081900	2010	2287.000	\N
87	25025082000	2010	2281.000	\N
87	25025082100	2010	3364.000	\N
87	25025090100	2010	3542.000	\N
87	25025090200	2010	1368.000	\N
87	25025090300	2010	2097.000	\N
87	25025090400	2010	2454.000	\N
87	25025090600	2010	1856.000	\N
87	25025090700	2010	3896.000	\N
87	25025090901	2010	2962.000	\N
87	25025091001	2010	2530.000	\N
87	25025091100	2010	4395.000	\N
87	25025091200	2010	2537.000	\N
87	25025091300	2010	1967.000	\N
87	25025091400	2010	1939.000	\N
87	25025091500	2010	3453.000	\N
87	25025091600	2010	2652.000	\N
87	25025091700	2010	2437.000	\N
87	25025091800	2010	2739.000	\N
87	25025091900	2010	3036.000	\N
87	25025092000	2010	3894.000	\N
87	25025092101	2010	5762.000	\N
87	25025092200	2010	2927.000	\N
87	25025092300	2010	2435.000	\N
87	25025092400	2010	3807.000	\N
87	25025100100	2010	3907.000	\N
87	25025100200	2010	2374.000	\N
87	25025100300	2010	2951.000	\N
87	25025100400	2010	4408.000	\N
87	25025100500	2010	5021.000	\N
87	25025100601	2010	4676.000	\N
87	25025100603	2010	1775.000	\N
87	25025100700	2010	4221.000	\N
87	25025100800	2010	5134.000	\N
87	25025100900	2010	3722.000	\N
87	25025101001	2010	4886.000	\N
87	25025101002	2010	4286.000	\N
87	25025101101	2010	2676.000	\N
87	25025101102	2010	3875.000	\N
87	25025110103	2010	3714.000	\N
87	25025110201	2010	1317.000	\N
87	25025110301	2010	1713.000	\N
87	25025110401	2010	2257.000	\N
87	25025110403	2010	3307.000	\N
87	25025110501	2010	2792.000	\N
87	25025110502	2010	2930.000	\N
87	25025110601	2010	2847.000	\N
87	25025110607	2010	4590.000	\N
87	25025120103	2010	1431.000	\N
87	25025120104	2010	1688.000	\N
87	25025120105	2010	2294.000	\N
87	25025120201	2010	2639.000	\N
87	25025120301	2010	2974.000	\N
87	25025120400	2010	5185.000	\N
87	25025120500	2010	1136.000	\N
87	25025120600	2010	2034.000	\N
87	25025120700	2010	1660.000	\N
87	25025130100	2010	5641.000	\N
87	25025130200	2010	4299.000	\N
87	25025130300	2010	4149.000	\N
87	25025130402	2010	4337.000	\N
87	25025130404	2010	2552.000	\N
87	25025130406	2010	4047.000	\N
87	25025140102	2010	3646.000	\N
87	25025140105	2010	2720.000	\N
87	25025140106	2010	1306.000	\N
87	25025140107	2010	1913.000	\N
87	25025140201	2010	1731.000	\N
87	25025140202	2010	4465.000	\N
87	25025140300	2010	4908.000	\N
87	25025140400	2010	6421.000	\N
87	25025160101	2010	1836.000	\N
87	25025160200	2010	696.000	\N
87	25025160300	2010	1604.000	\N
87	25025160400	2010	794.000	\N
87	25025160501	2010	1648.000	\N
87	25025160502	2010	1710.000	\N
87	25025160601	2010	2341.000	\N
87	25025160602	2010	2693.000	\N
87	25025170100	2010	5553.000	\N
87	25025170200	2010	3718.000	\N
87	25025170300	2010	7820.000	\N
87	25025170400	2010	4173.000	\N
87	25025170501	2010	2621.000	\N
87	25025170502	2010	2552.000	\N
87	25025170601	2010	3590.000	\N
87	25025170701	2010	1561.000	\N
87	25025170702	2010	3735.000	\N
87	25025170800	2010	3808.000	\N
87	25025180101	2010	4487.000	\N
87	25025180200	2010	3843.000	\N
87	25025180301	2010	2899.000	\N
87	25025180400	2010	1622.000	\N
87	25025180500	2010	3580.000	\N
87	25025980101	2010	401.000	\N
87	25025980300	2010	270.000	\N
87	25025980700	2010	6.000	\N
87	25025981000	2010	22.000	\N
87	25025981100	2010	333.000	\N
87	25025981201	2010	0.000	\N
87	25025981202	2010	170.000	\N
87	25025981300	2010	318.000	\N
87	25025981501	2010	11.000	\N
87	25025981502	2010	7.000	\N
87	25025981600	2010	0.000	\N
87	25025981700	2010	0.000	\N
87	25025981800	2010	79.000	\N
87	25025990101	2010	0.000	\N
87	25027700100	2010	5926.000	\N
87	25027701100	2010	8040.000	\N
87	25027702200	2010	3134.000	\N
87	25027703100	2010	4135.000	\N
87	25027703200	2010	3473.000	\N
87	25027703300	2010	3563.000	\N
87	25027704200	2010	2865.000	\N
87	25027705100	2010	7860.000	\N
87	25027706100	2010	4319.000	\N
87	25027707100	2010	3609.000	\N
87	25027707200	2010	1702.000	\N
87	25027707300	2010	3703.000	\N
87	25027707400	2010	4378.000	\N
87	25027707500	2010	5406.000	\N
87	25027708100	2010	7084.000	\N
87	25027709100	2010	3672.000	\N
87	25027709201	2010	6105.000	\N
87	25027709202	2010	5600.000	\N
87	25027709400	2010	3408.000	\N
87	25027709501	2010	2057.000	\N
87	25027709502	2010	5311.000	\N
87	25027709600	2010	1918.000	\N
87	25027709701	2010	4671.000	\N
87	25027709702	2010	2117.000	\N
87	25027710100	2010	2473.000	\N
87	25027710200	2010	5635.000	\N
87	25027710300	2010	2828.000	\N
87	25027710400	2010	1878.000	\N
87	25027710500	2010	2106.000	\N
87	25027710600	2010	4593.000	\N
87	25027710700	2010	1001.000	\N
87	25027710800	2010	3343.000	\N
87	25027711000	2010	2279.000	\N
87	25027711100	2010	5455.000	\N
87	25027712101	2010	5804.000	\N
87	25027712102	2010	4042.000	\N
87	25027713100	2010	7400.000	\N
87	25027715100	2010	4810.000	\N
87	25027716100	2010	6700.000	\N
87	25027716200	2010	2398.000	\N
87	25027716300	2010	2664.000	\N
87	25027717100	2010	2822.000	\N
87	25027718100	2010	4291.000	\N
87	25027719100	2010	7650.000	\N
87	25027720100	2010	3364.000	\N
87	25027721101	2010	1856.000	\N
87	25027721102	2010	7827.000	\N
87	25027722100	2010	5295.000	\N
87	25027723100	2010	3928.000	\N
87	25027724100	2010	3638.000	\N
87	25027725100	2010	4591.000	\N
87	25027726100	2010	5896.000	\N
87	25027726200	2010	5457.000	\N
87	25027727100	2010	4655.000	\N
87	25027728100	2010	4028.000	\N
87	25027728200	2010	3642.000	\N
87	25027728300	2010	4428.000	\N
87	25027728400	2010	4875.000	\N
87	25027729100	2010	4654.000	\N
87	25027729200	2010	2611.000	\N
87	25027730100	2010	5524.000	\N
87	25027730200	2010	5148.000	\N
87	25027730300	2010	4181.000	\N
87	25027730401	2010	4280.000	\N
87	25027730402	2010	1243.000	\N
87	25027730500	2010	2975.000	\N
87	25027730600	2010	8441.000	\N
87	25027730700	2010	6432.000	\N
87	25027730801	2010	3528.000	\N
87	25027730802	2010	1901.000	\N
87	25027730901	2010	3194.000	\N
87	25027730902	2010	3491.000	\N
87	25027731001	2010	2013.000	\N
87	25027731002	2010	5321.000	\N
87	25027731101	2010	2925.000	\N
87	25027731102	2010	2220.000	\N
87	25027731202	2010	1052.000	\N
87	25027731203	2010	3232.000	\N
87	25027731204	2010	1378.000	\N
87	25027731300	2010	1834.000	\N
87	25027731400	2010	2245.000	\N
87	25027731500	2010	2755.000	\N
87	25027731600	2010	6306.000	\N
87	25027731700	2010	2002.000	\N
87	25027731800	2010	3877.000	\N
87	25027731900	2010	3267.000	\N
87	25027732001	2010	1084.000	\N
87	25027732002	2010	3565.000	\N
87	25027732201	2010	2600.000	\N
87	25027732202	2010	2846.000	\N
87	25027732203	2010	2262.000	\N
87	25027732301	2010	3830.000	\N
87	25027732302	2010	3233.000	\N
87	25027732400	2010	4032.000	\N
87	25027732500	2010	1082.000	\N
87	25027732600	2010	2977.000	\N
87	25027732700	2010	2892.000	\N
87	25027732801	2010	4509.000	\N
87	25027732802	2010	3714.000	\N
87	25027732901	2010	5476.000	\N
87	25027732902	2010	2249.000	\N
87	25027733000	2010	2376.000	\N
87	25027733101	2010	1803.000	\N
87	25027733102	2010	1932.000	\N
87	25027735100	2010	6490.000	\N
87	25027735200	2010	4066.000	\N
87	25027736100	2010	2533.000	\N
87	25027736200	2010	3637.000	\N
87	25027736300	2010	2319.000	\N
87	25027736400	2010	2968.000	\N
87	25027736500	2010	4305.000	\N
87	25027737100	2010	5004.000	\N
87	25027737200	2010	1709.000	\N
87	25027737300	2010	6242.000	\N
87	25027738100	2010	4480.000	\N
87	25027738201	2010	3997.000	\N
87	25027738202	2010	5902.000	\N
87	25027739100	2010	9277.000	\N
87	25027739200	2010	5749.000	\N
87	25027739300	2010	3582.000	\N
87	25027739400	2010	8658.000	\N
87	25027739500	2010	7381.000	\N
87	25027740101	2010	5072.000	\N
87	25027740102	2010	5875.000	\N
87	25027740200	2010	2827.000	\N
87	25027741101	2010	4347.000	\N
87	25027741102	2010	5148.000	\N
87	25027742300	2010	3794.000	\N
87	25027742401	2010	5333.000	\N
87	25027742402	2010	2928.000	\N
87	25027743100	2010	7423.000	\N
87	25027744101	2010	7136.000	\N
87	25027744102	2010	4968.000	\N
87	25027744200	2010	6860.000	\N
87	25027744300	2010	3149.000	\N
87	25027744400	2010	3571.000	\N
87	25027745100	2010	5784.000	\N
87	25027746100	2010	5766.000	\N
87	25027747101	2010	5012.000	\N
87	25027747102	2010	3829.000	\N
87	25027748100	2010	3149.000	\N
87	25027749100	2010	7844.000	\N
87	25027749200	2010	5356.000	\N
87	25027750100	2010	5804.000	\N
87	25027750200	2010	6631.000	\N
87	25027750300	2010	2781.000	\N
87	25027751101	2010	6142.000	\N
87	25027751102	2010	2706.000	\N
87	25027752100	2010	8332.000	\N
87	25027753100	2010	7137.000	\N
87	25027753200	2010	6108.000	\N
87	25027754100	2010	6280.000	\N
87	25027754200	2010	3116.000	\N
87	25027754300	2010	2582.000	\N
87	25027754400	2010	3641.000	\N
87	25027755100	2010	3168.000	\N
87	25027755200	2010	7892.000	\N
87	25027756101	2010	4397.000	\N
87	25027756102	2010	8210.000	\N
87	25027757100	2010	3324.000	\N
87	25027757200	2010	1311.000	\N
87	25027757300	2010	1707.000	\N
87	25027757400	2010	2253.000	\N
87	25027757500	2010	3672.000	\N
87	25027758101	2010	1629.000	\N
87	25027758102	2010	7408.000	\N
87	25027759100	2010	2132.000	\N
87	25027760100	2010	3346.000	\N
87	25027761100	2010	5015.000	\N
87	25027761200	2010	5500.000	\N
87	25027761300	2010	2980.000	\N
87	25027761400	2010	6256.000	\N
88	25001010100	2010	2603.000	\N
88	25001010206	2010	2635.000	\N
88	25001010208	2010	1883.000	\N
88	25001010304	2010	2316.000	\N
88	25001010306	2010	2434.000	\N
88	25001010400	2010	2821.000	\N
88	25001010500	2010	2809.000	\N
88	25001010600	2010	2812.000	\N
88	25001010700	2010	2999.000	\N
88	25001010800	2010	4680.000	\N
88	25001010900	2010	4690.000	\N
88	25001011002	2010	3778.000	\N
88	25001011100	2010	4368.000	\N
88	25001011200	2010	3201.000	\N
88	25001011300	2010	2493.000	\N
88	25001011400	2010	2825.000	\N
88	25001011500	2010	3701.000	\N
88	25001011600	2010	2355.000	\N
88	25001011700	2010	1743.000	\N
88	25001011801	2010	2339.000	\N
88	25001011802	2010	4034.000	\N
88	25001012001	2010	5305.000	\N
88	25001012002	2010	2611.000	\N
88	25001012101	2010	4713.000	\N
88	25001012102	2010	2696.000	\N
88	25001012200	2010	4829.000	\N
88	25001012502	2010	2547.000	\N
88	25001012601	2010	2340.000	\N
88	25001012602	2010	3409.000	\N
88	25001012700	2010	4111.000	\N
88	25001012800	2010	3638.000	\N
88	25001012900	2010	3804.000	\N
88	25001013002	2010	2738.000	\N
88	25001013100	2010	5529.000	\N
88	25001013200	2010	4513.000	\N
88	25001013300	2010	3107.000	\N
88	25001013400	2010	4051.000	\N
88	25001013500	2010	6645.000	\N
88	25001013600	2010	5997.000	\N
88	25001013700	2010	4569.000	\N
88	25001013800	2010	4475.000	\N
88	25001013900	2010	4533.000	\N
88	25001014002	2010	3795.000	\N
88	25001014100	2010	908.000	\N
88	25001014300	2010	4166.000	\N
88	25001014402	2010	6287.000	\N
88	25001014500	2010	4810.000	\N
88	25001014600	2010	3636.000	\N
88	25001014700	2010	3326.000	\N
88	25001014800	2010	3059.000	\N
88	25001014900	2010	3328.000	\N
88	25001015001	2010	3795.000	\N
88	25001015002	2010	3090.000	\N
88	25001015100	2010	3420.000	\N
88	25001015200	2010	1974.000	\N
88	25001015300	2010	2054.000	\N
88	25001990000	2010	0.000	\N
88	25003900100	2010	2543.000	\N
88	25003900200	2010	3285.000	\N
88	25003900300	2010	2509.000	\N
88	25003900400	2010	4263.000	\N
88	25003900500	2010	3056.000	\N
88	25003900600	2010	2912.000	\N
88	25003900700	2010	2731.000	\N
88	25003900800	2010	4582.000	\N
88	25003900900	2010	4477.000	\N
88	25003901100	2010	3386.000	\N
88	25003911100	2010	2963.000	\N
88	25003912100	2010	6469.000	\N
88	25003913100	2010	4671.000	\N
88	25003914100	2010	5453.000	\N
88	25003920101	2010	3933.000	\N
88	25003920102	2010	2654.000	\N
88	25003921300	2010	4598.000	\N
88	25003921400	2010	1530.000	\N
88	25003921500	2010	2862.000	\N
88	25003922100	2010	2579.000	\N
88	25003922200	2010	3542.000	\N
88	25003922300	2010	2045.000	\N
88	25003923100	2010	3139.000	\N
88	25003924100	2010	1826.000	\N
88	25003925100	2010	6200.000	\N
88	25003926100	2010	3070.000	\N
88	25003931100	2010	1668.000	\N
88	25003931300	2010	1370.000	\N
88	25003931400	2010	1690.000	\N
88	25003932200	2010	2225.000	\N
88	25003932300	2010	1976.000	\N
88	25003933200	2010	1256.000	\N
88	25003933300	2010	1439.000	\N
88	25003933400	2010	2434.000	\N
88	25003934200	2010	1250.000	\N
88	25003934300	2010	1815.000	\N
88	25003935100	2010	2324.000	\N
88	25003935200	2010	4693.000	\N
88	25003935300	2010	3508.000	\N
88	25005600100	2010	3599.000	\N
88	25005600202	2010	3929.000	\N
88	25005600203	2010	5151.000	\N
88	25005600204	2010	3332.000	\N
88	25005610100	2010	4628.000	\N
88	25005610202	2010	5119.000	\N
88	25005610203	2010	6401.000	\N
88	25005610204	2010	4751.000	\N
88	25005611101	2010	4282.000	\N
88	25005611102	2010	4563.000	\N
88	25005611201	2010	2848.000	\N
88	25005611202	2010	5976.000	\N
88	25005612100	2010	4247.000	\N
88	25005612200	2010	8072.000	\N
88	25005613100	2010	5775.000	\N
88	25005613300	2010	6697.000	\N
88	25005613400	2010	3148.000	\N
88	25005613600	2010	3100.000	\N
88	25005613700	2010	3712.000	\N
88	25005613800	2010	3362.000	\N
88	25005613901	2010	2154.000	\N
88	25005613902	2010	4178.000	\N
88	25005614000	2010	3221.000	\N
88	25005614101	2010	5576.000	\N
88	25005614102	2010	6298.000	\N
88	25005615100	2010	6769.000	\N
88	25005616100	2010	6125.000	\N
88	25005617101	2010	4511.000	\N
88	25005617102	2010	3969.000	\N
88	25005630101	2010	2539.000	\N
88	25005630102	2010	3803.000	\N
88	25005630200	2010	7615.000	\N
88	25005630300	2010	7832.000	\N
88	25005630400	2010	4340.000	\N
88	25005631100	2010	7119.000	\N
88	25005631200	2010	5931.000	\N
88	25005631300	2010	4503.000	\N
88	25005631400	2010	1757.000	\N
88	25005631500	2010	2339.000	\N
88	25005631600	2010	2668.000	\N
88	25005631700	2010	5756.000	\N
88	25005631800	2010	6535.000	\N
88	25005632100	2010	6237.000	\N
88	25005632200	2010	6661.000	\N
88	25005633100	2010	5239.000	\N
88	25005633200	2010	5845.000	\N
88	25005640100	2010	4308.000	\N
88	25005640200	2010	5131.000	\N
88	25005640300	2010	2721.000	\N
88	25005640400	2010	2461.000	\N
88	25005640500	2010	4512.000	\N
88	25005640600	2010	3701.000	\N
88	25005640700	2010	2641.000	\N
88	25005640800	2010	2881.000	\N
88	25005640901	2010	3942.000	\N
88	25005641000	2010	1968.000	\N
88	25005641101	2010	1230.000	\N
88	25005641200	2010	2135.000	\N
88	25005641300	2010	3676.000	\N
88	25005641400	2010	1931.000	\N
88	25005641500	2010	2118.000	\N
88	25005641600	2010	2191.000	\N
88	25005641700	2010	4663.000	\N
88	25005641800	2010	1847.000	\N
88	25005641900	2010	1933.000	\N
88	25005642000	2010	2479.000	\N
88	25005642100	2010	3480.000	\N
88	25005642200	2010	3338.000	\N
88	25005642300	2010	2063.000	\N
88	25005642400	2010	2506.000	\N
88	25005642500	2010	4251.000	\N
88	25005644101	2010	5618.000	\N
88	25005644102	2010	4878.000	\N
88	25005644200	2010	7059.000	\N
88	25005645101	2010	4735.000	\N
88	25005645102	2010	5132.000	\N
88	25005645103	2010	5420.000	\N
88	25005646101	2010	7111.000	\N
88	25005646103	2010	5458.000	\N
88	25005646104	2010	2487.000	\N
88	25005650101	2010	5237.000	\N
88	25005650102	2010	3676.000	\N
88	25005650201	2010	2592.000	\N
88	25005650202	2010	1818.000	\N
88	25005650300	2010	2849.000	\N
88	25005650400	2010	3047.000	\N
88	25005650500	2010	2536.000	\N
88	25005650600	2010	1920.000	\N
88	25005650700	2010	993.000	\N
88	25005650800	2010	2272.000	\N
88	25005650900	2010	1267.000	\N
88	25005651001	2010	2297.000	\N
88	25005651002	2010	2596.000	\N
88	25005651100	2010	2380.000	\N
88	25005651200	2010	1126.000	\N
88	25005651300	2010	1318.000	\N
88	25005651400	2010	1906.000	\N
88	25005651500	2010	1461.000	\N
88	25005651600	2010	2347.000	\N
88	25005651700	2010	885.000	\N
88	25005651800	2010	1082.000	\N
88	25005651900	2010	499.000	\N
88	25005652000	2010	1720.000	\N
88	25005652100	2010	2160.000	\N
88	25005652200	2010	2455.000	\N
88	25005652300	2010	2142.000	\N
88	25005652400	2010	2046.000	\N
88	25005652500	2010	1637.000	\N
88	25005652600	2010	1277.000	\N
88	25005652700	2010	2150.000	\N
88	25005652800	2010	2907.000	\N
88	25005653101	2010	6026.000	\N
88	25005653102	2010	4623.000	\N
88	25005653203	2010	4620.000	\N
88	25005653204	2010	2920.000	\N
88	25005653301	2010	4785.000	\N
88	25005653304	2010	3078.000	\N
88	25005654100	2010	6689.000	\N
88	25005654200	2010	3230.000	\N
88	25005655100	2010	3972.000	\N
88	25005655200	2010	4146.000	\N
88	25005655300	2010	3162.000	\N
88	25005655400	2010	3754.000	\N
88	25005985500	2010	4750.000	\N
88	25005985600	2010	4774.000	\N
88	25005990000	2010	0.000	\N
88	25007200100	2010	3334.000	\N
88	25007200200	2010	3737.000	\N
88	25007200300	2010	3550.000	\N
88	25007200400	2010	3654.000	\N
88	25007990000	2010	0.000	\N
88	25009201100	2010	3257.000	\N
88	25009202101	2010	1944.000	\N
88	25009202102	2010	5336.000	\N
88	25009202200	2010	5544.000	\N
88	25009203100	2010	6717.000	\N
88	25009203200	2010	4361.000	\N
88	25009203301	2010	3820.000	\N
88	25009203302	2010	3920.000	\N
88	25009204101	2010	3658.000	\N
88	25009204102	2010	4054.000	\N
88	25009204200	2010	3559.000	\N
88	25009204300	2010	1800.000	\N
88	25009204400	2010	2989.000	\N
88	25009204500	2010	2552.000	\N
88	25009204600	2010	4316.000	\N
88	25009204701	2010	4058.000	\N
88	25009204702	2010	4391.000	\N
88	25009205100	2010	4087.000	\N
88	25009205200	2010	3115.000	\N
88	25009205300	2010	3697.000	\N
88	25009205400	2010	4550.000	\N
88	25009205500	2010	1738.000	\N
88	25009205600	2010	2212.000	\N
88	25009205700	2010	3035.000	\N
88	25009205800	2010	1137.000	\N
88	25009205900	2010	2025.000	\N
88	25009206000	2010	693.000	\N
88	25009206100	2010	786.000	\N
88	25009206200	2010	1050.000	\N
88	25009206300	2010	1174.000	\N
88	25009206400	2010	2764.000	\N
88	25009206500	2010	897.000	\N
88	25009206600	2010	2396.000	\N
88	25009206700	2010	2159.000	\N
88	25009206800	2010	1044.000	\N
88	25009206900	2010	2097.000	\N
88	25009207000	2010	792.000	\N
88	25009207100	2010	648.000	\N
88	25009207200	2010	873.000	\N
88	25009208101	2010	4576.000	\N
88	25009208102	2010	2755.000	\N
88	25009208200	2010	4820.000	\N
88	25009208300	2010	6599.000	\N
88	25009208400	2010	5110.000	\N
88	25009209100	2010	5619.000	\N
88	25009209200	2010	5219.000	\N
88	25009210100	2010	6574.000	\N
88	25009210200	2010	5071.000	\N
88	25009210300	2010	8146.000	\N
88	25009210400	2010	6036.000	\N
88	25009210500	2010	5970.000	\N
88	25009210600	2010	3513.000	\N
88	25009210700	2010	2782.000	\N
88	25009210800	2010	3372.000	\N
88	25009210900	2010	3470.000	\N
88	25009211100	2010	3561.000	\N
88	25009211200	2010	5746.000	\N
88	25009211300	2010	6628.000	\N
88	25009211401	2010	3181.000	\N
88	25009211402	2010	5723.000	\N
88	25009212100	2010	7845.000	\N
88	25009213100	2010	7570.000	\N
88	25009214100	2010	5802.000	\N
88	25009215101	2010	4367.000	\N
88	25009215102	2010	2721.000	\N
88	25009216100	2010	4607.000	\N
88	25009217100	2010	6675.000	\N
88	25009217201	2010	3853.000	\N
88	25009217202	2010	3345.000	\N
88	25009217300	2010	3687.000	\N
88	25009217400	2010	4520.000	\N
88	25009217500	2010	5742.000	\N
88	25009217600	2010	8283.000	\N
88	25009218100	2010	4952.000	\N
88	25009220101	2010	3856.000	\N
88	25009220102	2010	2810.000	\N
88	25009221100	2010	4049.000	\N
88	25009221300	2010	4366.000	\N
88	25009221400	2010	2902.000	\N
88	25009221500	2010	2659.000	\N
88	25009221600	2010	2183.000	\N
88	25009221700	2010	2635.000	\N
88	25009221800	2010	1733.000	\N
88	25009221901	2010	3313.000	\N
88	25009221902	2010	3260.000	\N
88	25009222100	2010	3369.000	\N
88	25009223100	2010	3695.000	\N
88	25009223200	2010	3515.000	\N
88	25009223300	2010	5261.000	\N
88	25009250100	2010	471.000	\N
88	25009250200	2010	1241.000	\N
88	25009250300	2010	137.000	\N
88	25009250400	2010	263.000	\N
88	25009250500	2010	162.000	\N
88	25009250600	2010	739.000	\N
88	25009250700	2010	479.000	\N
88	25009250800	2010	2161.000	\N
88	25009250900	2010	101.000	\N
88	25009251000	2010	208.000	\N
88	25009251100	2010	695.000	\N
88	25009251200	2010	147.000	\N
88	25009251300	2010	253.000	\N
88	25009251400	2010	804.000	\N
88	25009251500	2010	1360.000	\N
88	25009251600	2010	1077.000	\N
88	25009251700	2010	1467.000	\N
88	25009251800	2010	3872.000	\N
88	25009252101	2010	2633.000	\N
88	25009252102	2010	3447.000	\N
88	25009252201	2010	2652.000	\N
88	25009252202	2010	2951.000	\N
88	25009252300	2010	4259.000	\N
88	25009252400	2010	1261.000	\N
88	25009252501	2010	2536.000	\N
88	25009252502	2010	3985.000	\N
88	25009252601	2010	5454.000	\N
88	25009252602	2010	3710.000	\N
88	25009252603	2010	2499.000	\N
88	25009253100	2010	4684.000	\N
88	25009253201	2010	2527.000	\N
88	25009253202	2010	4765.000	\N
88	25009253203	2010	3860.000	\N
88	25009253204	2010	4494.000	\N
88	25009253205	2010	4025.000	\N
88	25009254100	2010	5160.000	\N
88	25009254200	2010	4372.000	\N
88	25009254301	2010	3384.000	\N
88	25009254302	2010	3849.000	\N
88	25009254401	2010	2651.000	\N
88	25009254402	2010	4968.000	\N
88	25009254403	2010	3314.000	\N
88	25009260100	2010	2615.000	\N
88	25009260200	2010	2531.000	\N
88	25009260301	2010	4077.000	\N
88	25009260302	2010	2914.000	\N
88	25009260401	2010	3420.000	\N
88	25009260402	2010	5576.000	\N
88	25009260500	2010	3401.000	\N
88	25009260600	2010	2355.000	\N
88	25009260700	2010	3463.000	\N
88	25009260800	2010	2417.000	\N
88	25009260900	2010	3616.000	\N
88	25009261000	2010	3392.000	\N
88	25009261101	2010	4478.000	\N
88	25009261102	2010	4139.000	\N
88	25009262100	2010	6067.000	\N
88	25009263100	2010	4079.000	\N
88	25009264100	2010	6230.000	\N
88	25009265101	2010	3478.000	\N
88	25009265102	2010	4354.000	\N
88	25009266100	2010	3861.000	\N
88	25009266200	2010	4881.000	\N
88	25009266300	2010	3541.000	\N
88	25009266400	2010	3196.000	\N
88	25009267101	2010	3428.000	\N
88	25009267102	2010	4456.000	\N
88	25009268100	2010	2550.000	\N
88	25009268200	2010	5975.000	\N
88	25009268300	2010	3925.000	\N
88	25009268400	2010	4124.000	\N
88	25009269100	2010	6468.000	\N
88	25009270100	2010	5660.000	\N
88	25009990100	2010	0.000	\N
88	25011040100	2010	4307.000	\N
88	25011040200	2010	4202.000	\N
88	25011040300	2010	2915.000	\N
88	25011040400	2010	3286.000	\N
88	25011040501	2010	3972.000	\N
88	25011040502	2010	3337.000	\N
88	25011040600	2010	4229.000	\N
88	25011040701	2010	3635.000	\N
88	25011040702	2010	3986.000	\N
88	25011040800	2010	4558.000	\N
88	25011040900	2010	4781.000	\N
88	25011041000	2010	2958.000	\N
88	25011041100	2010	3410.000	\N
88	25011041200	2010	2906.000	\N
88	25011041300	2010	4092.000	\N
88	25011041400	2010	2309.000	\N
88	25011041501	2010	3459.000	\N
88	25011041502	2010	3636.000	\N
88	25013800101	2010	1990.000	\N
88	25013800102	2010	1719.000	\N
88	25013800201	2010	3050.000	\N
88	25013800202	2010	776.000	\N
88	25013800300	2010	2043.000	\N
88	25013800400	2010	2397.000	\N
88	25013800500	2010	996.000	\N
88	25013800600	2010	105.000	\N
88	25013800700	2010	164.000	\N
88	25013800800	2010	183.000	\N
88	25013800900	2010	523.000	\N
88	25013801101	2010	301.000	\N
88	25013801102	2010	591.000	\N
88	25013801200	2010	466.000	\N
88	25013801300	2010	645.000	\N
88	25013801401	2010	370.000	\N
88	25013801402	2010	538.000	\N
88	25013801501	2010	1757.000	\N
88	25013801502	2010	934.000	\N
88	25013801503	2010	1672.000	\N
88	25013801601	2010	3217.000	\N
88	25013801602	2010	3022.000	\N
88	25013801603	2010	2604.000	\N
88	25013801604	2010	2879.000	\N
88	25013801605	2010	2452.000	\N
88	25013801700	2010	1963.000	\N
88	25013801800	2010	377.000	\N
88	25013801901	2010	474.000	\N
88	25013801902	2010	615.000	\N
88	25013802000	2010	379.000	\N
88	25013802100	2010	2856.000	\N
88	25013802200	2010	612.000	\N
88	25013802300	2010	1369.000	\N
88	25013802400	2010	2753.000	\N
88	25013802500	2010	4824.000	\N
88	25013802601	2010	3058.000	\N
88	25013802602	2010	1574.000	\N
88	25013810100	2010	5901.000	\N
88	25013810200	2010	2584.000	\N
88	25013810300	2010	2961.000	\N
88	25013810403	2010	3517.000	\N
88	25013810404	2010	3494.000	\N
88	25013810412	2010	5694.000	\N
88	25013810414	2010	6258.000	\N
88	25013810601	2010	3515.000	\N
88	25013810602	2010	2507.000	\N
88	25013810700	2010	5108.000	\N
88	25013810800	2010	2924.000	\N
88	25013810901	2010	1157.000	\N
88	25013810902	2010	3492.000	\N
88	25013811000	2010	4132.000	\N
88	25013811101	2010	3437.000	\N
88	25013811102	2010	3906.000	\N
88	25013811200	2010	4273.000	\N
88	25013811301	2010	4695.000	\N
88	25013811302	2010	4792.000	\N
88	25013811400	2010	188.000	\N
88	25013811500	2010	136.000	\N
88	25013811600	2010	361.000	\N
88	25013811700	2010	503.000	\N
88	25013811800	2010	1565.000	\N
88	25013811900	2010	2999.000	\N
88	25013812001	2010	1474.000	\N
88	25013812002	2010	2445.000	\N
88	25013812101	2010	4548.000	\N
88	25013812103	2010	1782.000	\N
88	25013812104	2010	2650.000	\N
88	25013812201	2010	3654.000	\N
88	25013812202	2010	3000.000	\N
88	25013812300	2010	4070.000	\N
88	25013812401	2010	5850.000	\N
88	25013812403	2010	3353.000	\N
88	25013812404	2010	3379.000	\N
88	25013812500	2010	6591.000	\N
88	25013812600	2010	6309.000	\N
88	25013812701	2010	3439.000	\N
88	25013812702	2010	4250.000	\N
88	25013812800	2010	6088.000	\N
88	25013812901	2010	2784.000	\N
88	25013812902	2010	4535.000	\N
88	25013812903	2010	2334.000	\N
88	25013813000	2010	6985.000	\N
88	25013813101	2010	5623.000	\N
88	25013813102	2010	3405.000	\N
88	25013813204	2010	3095.000	\N
88	25013813205	2010	6956.000	\N
88	25013813206	2010	3768.000	\N
88	25013813207	2010	4583.000	\N
88	25013813208	2010	2675.000	\N
88	25013813209	2010	5210.000	\N
88	25013813301	2010	6725.000	\N
88	25013813303	2010	3965.000	\N
88	25013813304	2010	3632.000	\N
88	25013813401	2010	4773.000	\N
88	25013813403	2010	3642.000	\N
88	25013813404	2010	6197.000	\N
88	25013813500	2010	4908.000	\N
88	25013813601	2010	7402.000	\N
88	25013813602	2010	5706.000	\N
88	25013813701	2010	3313.000	\N
88	25013813702	2010	4859.000	\N
88	25013813801	2010	4119.000	\N
88	25013813802	2010	3423.000	\N
88	25015820101	2010	5861.000	\N
88	25015820102	2010	3240.000	\N
88	25015820202	2010	1209.000	\N
88	25015820203	2010	7756.000	\N
88	25015820204	2010	5748.000	\N
88	25015820300	2010	4936.000	\N
88	25015820400	2010	9078.000	\N
88	25015820500	2010	5215.000	\N
88	25015820600	2010	964.000	\N
88	25015820700	2010	3080.000	\N
88	25015820801	2010	3524.000	\N
88	25015820802	2010	920.000	\N
88	25015820900	2010	5941.000	\N
88	25015821000	2010	3986.000	\N
88	25015821100	2010	6280.000	\N
88	25015821200	2010	1308.000	\N
88	25015821300	2010	3734.000	\N
88	25015821400	2010	4695.000	\N
88	25015821500	2010	3168.000	\N
88	25015821601	2010	2712.000	\N
88	25015821602	2010	3273.000	\N
88	25015821700	2010	3391.000	\N
88	25015821901	2010	2849.000	\N
88	25015821903	2010	2753.000	\N
88	25015821904	2010	2401.000	\N
88	25015822000	2010	1292.000	\N
88	25015822200	2010	5359.000	\N
88	25015822300	2010	4887.000	\N
88	25015822401	2010	5503.000	\N
88	25015822402	2010	4287.000	\N
88	25015822500	2010	5593.000	\N
88	25015822601	2010	2090.000	\N
88	25015822603	2010	1558.000	\N
88	25015822605	2010	1189.000	\N
88	25015822606	2010	3391.000	\N
88	25015822700	2010	3078.000	\N
88	25017300100	2010	2954.000	\N
88	25017301101	2010	3781.000	\N
88	25017301102	2010	4725.000	\N
88	25017310100	2010	2854.000	\N
88	25017310200	2010	3720.000	\N
88	25017310300	2010	3322.000	\N
88	25017310400	2010	1371.000	\N
88	25017310500	2010	2231.000	\N
88	25017310601	2010	3876.000	\N
88	25017310602	2010	4076.000	\N
88	25017310700	2010	2059.000	\N
88	25017311100	2010	582.000	\N
88	25017311200	2010	711.000	\N
88	25017311300	2010	1599.000	\N
88	25017311400	2010	2659.000	\N
88	25017311500	2010	1488.000	\N
88	25017311600	2010	3110.000	\N
88	25017311700	2010	1606.000	\N
88	25017311800	2010	797.000	\N
88	25017311900	2010	1224.000	\N
88	25017312000	2010	1388.000	\N
88	25017312100	2010	1400.000	\N
88	25017312200	2010	2364.000	\N
88	25017312300	2010	3573.000	\N
88	25017312400	2010	959.000	\N
88	25017312501	2010	3457.000	\N
88	25017312502	2010	3323.000	\N
88	25017313101	2010	4933.000	\N
88	25017313102	2010	5304.000	\N
88	25017314101	2010	5269.000	\N
88	25017314102	2010	6213.000	\N
88	25017314200	2010	4679.000	\N
88	25017314301	2010	7049.000	\N
88	25017314302	2010	2755.000	\N
88	25017315100	2010	5036.000	\N
88	25017315200	2010	6954.000	\N
88	25017315401	2010	3171.000	\N
88	25017315402	2010	2749.000	\N
88	25017315403	2010	1672.000	\N
88	25017315500	2010	7304.000	\N
88	25017316101	2010	4836.000	\N
88	25017316102	2010	5658.000	\N
88	25017316201	2010	3769.000	\N
88	25017316202	2010	3647.000	\N
88	25017316300	2010	6734.000	\N
88	25017316400	2010	5663.000	\N
88	25017316500	2010	5261.000	\N
88	25017317101	2010	5238.000	\N
88	25017317102	2010	3666.000	\N
88	25017317103	2010	4467.000	\N
88	25017317201	2010	2646.000	\N
88	25017317202	2010	3070.000	\N
88	25017317203	2010	3513.000	\N
88	25017317301	2010	2091.000	\N
88	25017317302	2010	4764.000	\N
88	25017318100	2010	5340.000	\N
88	25017318200	2010	3317.000	\N
88	25017318300	2010	6411.000	\N
88	25017318400	2010	3357.000	\N
88	25017320102	2010	4592.000	\N
88	25017320103	2010	2463.000	\N
88	25017320104	2010	6632.000	\N
88	25017321100	2010	5543.000	\N
88	25017321200	2010	4781.000	\N
88	25017321300	2010	5202.000	\N
88	25017321400	2010	2828.000	\N
88	25017321500	2010	4799.000	\N
88	25017321600	2010	5800.000	\N
88	25017322100	2010	4335.000	\N
88	25017322200	2010	3270.000	\N
88	25017322300	2010	5235.000	\N
88	25017322400	2010	4105.000	\N
88	25017323100	2010	6079.000	\N
88	25017324101	2010	4410.000	\N
88	25017324102	2010	3829.000	\N
88	25017325100	2010	6045.000	\N
88	25017326101	2010	3636.000	\N
88	25017326102	2010	6328.000	\N
88	25017327101	2010	3440.000	\N
88	25017327102	2010	4073.000	\N
88	25017327103	2010	3433.000	\N
88	25017328100	2010	2993.000	\N
88	25017330100	2010	7841.000	\N
88	25017330200	2010	6150.000	\N
88	25017331101	2010	2704.000	\N
88	25017331102	2010	6516.000	\N
88	25017331200	2010	4939.000	\N
88	25017331300	2010	6441.000	\N
88	25017332100	2010	5066.000	\N
88	25017332200	2010	6194.000	\N
88	25017332300	2010	5250.000	\N
88	25017332400	2010	2882.000	\N
88	25017333100	2010	6306.000	\N
88	25017333200	2010	4685.000	\N
88	25017333300	2010	3260.000	\N
88	25017333400	2010	4977.000	\N
88	25017333501	2010	4341.000	\N
88	25017333502	2010	2607.000	\N
88	25017333600	2010	4954.000	\N
88	25017334100	2010	6104.000	\N
88	25017334200	2010	3726.000	\N
88	25017334300	2010	7220.000	\N
88	25017334400	2010	5827.000	\N
88	25017335100	2010	5397.000	\N
88	25017335200	2010	5272.000	\N
88	25017335301	2010	3483.000	\N
88	25017335302	2010	4258.000	\N
88	25017335400	2010	4771.000	\N
88	25017336100	2010	4878.000	\N
88	25017336200	2010	5743.000	\N
88	25017336300	2010	6158.000	\N
88	25017336401	2010	3373.000	\N
88	25017336402	2010	4009.000	\N
88	25017337101	2010	2827.000	\N
88	25017337102	2010	4612.000	\N
88	25017337201	2010	2898.000	\N
88	25017337202	2010	4459.000	\N
88	25017337300	2010	4608.000	\N
88	25017338100	2010	2385.000	\N
88	25017338200	2010	2837.000	\N
88	25017338300	2010	2927.000	\N
88	25017338400	2010	5075.000	\N
88	25017338500	2010	5085.000	\N
88	25017339100	2010	5641.000	\N
88	25017339200	2010	5324.000	\N
88	25017339300	2010	1580.000	\N
88	25017339400	2010	2703.000	\N
88	25017339500	2010	4185.000	\N
88	25017339600	2010	3737.000	\N
88	25017339700	2010	2539.000	\N
88	25017339801	2010	2781.000	\N
88	25017339802	2010	2904.000	\N
88	25017339900	2010	3936.000	\N
88	25017340000	2010	1793.000	\N
88	25017340100	2010	5666.000	\N
88	25017341101	2010	2214.000	\N
88	25017341102	2010	2596.000	\N
88	25017341200	2010	3569.000	\N
88	25017341300	2010	2174.000	\N
88	25017341400	2010	3127.000	\N
88	25017341500	2010	1857.000	\N
88	25017341600	2010	3770.000	\N
88	25017341700	2010	3439.000	\N
88	25017341800	2010	3047.000	\N
88	25017341901	2010	854.000	\N
88	25017341902	2010	4564.000	\N
88	25017342101	2010	2563.000	\N
88	25017342102	2010	2349.000	\N
88	25017342201	2010	2751.000	\N
88	25017342202	2010	2173.000	\N
88	25017342300	2010	3805.000	\N
88	25017342400	2010	3130.000	\N
88	25017342500	2010	3464.000	\N
88	25017342600	2010	2081.000	\N
88	25017350103	2010	905.000	\N
88	25017350104	2010	3377.000	\N
88	25017350200	2010	4117.000	\N
88	25017350300	2010	1669.000	\N
88	25017350400	2010	4778.000	\N
88	25017350500	2010	1425.000	\N
88	25017350600	2010	3584.000	\N
88	25017350700	2010	4380.000	\N
88	25017350800	2010	1433.000	\N
88	25017350900	2010	2811.000	\N
88	25017351000	2010	5135.000	\N
88	25017351100	2010	4467.000	\N
88	25017351203	2010	3239.000	\N
88	25017351204	2010	2784.000	\N
88	25017351300	2010	3089.000	\N
88	25017351403	2010	1899.000	\N
88	25017351404	2010	2005.000	\N
88	25017351500	2010	1262.000	\N
88	25017352101	2010	895.000	\N
88	25017352102	2010	1668.000	\N
88	25017352200	2010	1160.000	\N
88	25017352300	2010	2102.000	\N
88	25017352400	2010	567.000	\N
88	25017352500	2010	1587.000	\N
88	25017352600	2010	1488.000	\N
88	25017352700	2010	1162.000	\N
88	25017352800	2010	1430.000	\N
88	25017352900	2010	2037.000	\N
88	25017353000	2010	2159.000	\N
88	25017353101	2010	1311.000	\N
88	25017353102	2010	2101.000	\N
88	25017353200	2010	2826.000	\N
88	25017353300	2010	2608.000	\N
88	25017353400	2010	1339.000	\N
88	25017353500	2010	1547.000	\N
88	25017353600	2010	3302.000	\N
88	25017353700	2010	3503.000	\N
88	25017353800	2010	3299.000	\N
88	25017353900	2010	3743.000	\N
88	25017354000	2010	3188.000	\N
88	25017354100	2010	2317.000	\N
88	25017354200	2010	2545.000	\N
88	25017354300	2010	2233.000	\N
88	25017354400	2010	1334.000	\N
88	25017354500	2010	1792.000	\N
88	25017354600	2010	2557.000	\N
88	25017354700	2010	1942.000	\N
88	25017354800	2010	1550.000	\N
88	25017354900	2010	2140.000	\N
88	25017355000	2010	1827.000	\N
88	25017356100	2010	2658.000	\N
88	25017356300	2010	3861.000	\N
88	25017356400	2010	6387.000	\N
88	25017356500	2010	5535.000	\N
88	25017356601	2010	3475.000	\N
88	25017356602	2010	3606.000	\N
88	25017356701	2010	4690.000	\N
88	25017356702	2010	5592.000	\N
88	25017357100	2010	3499.000	\N
88	25017357200	2010	2630.000	\N
88	25017357300	2010	2395.000	\N
88	25017357400	2010	1989.000	\N
88	25017357500	2010	1751.000	\N
88	25017357600	2010	1907.000	\N
88	25017357700	2010	2866.000	\N
88	25017357800	2010	3081.000	\N
88	25017358100	2010	3989.000	\N
88	25017358300	2010	3700.000	\N
88	25017358400	2010	3726.000	\N
88	25017358500	2010	3552.000	\N
88	25017358600	2010	4382.000	\N
88	25017358700	2010	3789.000	\N
88	25017359100	2010	5201.000	\N
88	25017359300	2010	5983.000	\N
88	25017360100	2010	843.000	\N
88	25017360200	2010	4423.000	\N
88	25017361100	2010	5296.000	\N
88	25017361200	2010	4578.000	\N
88	25017361300	2010	5528.000	\N
88	25017362100	2010	4257.000	\N
88	25017363102	2010	3905.000	\N
88	25017363103	2010	2517.000	\N
88	25017363104	2010	4633.000	\N
88	25017363201	2010	2635.000	\N
88	25017363202	2010	2865.000	\N
88	25017364101	2010	4718.000	\N
88	25017364102	2010	4392.000	\N
88	25017365100	2010	6911.000	\N
88	25017365201	2010	5023.000	\N
88	25017365202	2010	3845.000	\N
88	25017366100	2010	3830.000	\N
88	25017366201	2010	3193.000	\N
88	25017366202	2010	4059.000	\N
88	25017367100	2010	3342.000	\N
88	25017367200	2010	6051.000	\N
88	25017368101	2010	4452.000	\N
88	25017368102	2010	2560.000	\N
88	25017368200	2010	3287.000	\N
88	25017368300	2010	3148.000	\N
88	25017368400	2010	5557.000	\N
88	25017368500	2010	1827.000	\N
88	25017368600	2010	3300.000	\N
88	25017368700	2010	1255.000	\N
88	25017368800	2010	2861.000	\N
88	25017368901	2010	5421.000	\N
88	25017368902	2010	2607.000	\N
88	25017369000	2010	1192.000	\N
88	25017369100	2010	4211.000	\N
88	25017370101	2010	5355.000	\N
88	25017370102	2010	5150.000	\N
88	25017370201	2010	3229.000	\N
88	25017370202	2010	3699.000	\N
88	25017370300	2010	4343.000	\N
88	25017370400	2010	4289.000	\N
88	25017373100	2010	3793.000	\N
88	25017373200	2010	3359.000	\N
88	25017373300	2010	2234.000	\N
88	25017373400	2010	2641.000	\N
88	25017373500	2010	5203.000	\N
88	25017373600	2010	4747.000	\N
88	25017373700	2010	3309.000	\N
88	25017373800	2010	4627.000	\N
88	25017373900	2010	4975.000	\N
88	25017374000	2010	3931.000	\N
88	25017374100	2010	3216.000	\N
88	25017374200	2010	3416.000	\N
88	25017374300	2010	3087.000	\N
88	25017374400	2010	4830.000	\N
88	25017374500	2010	3407.000	\N
88	25017374600	2010	3814.000	\N
88	25017374700	2010	3483.000	\N
88	25017374800	2010	3729.000	\N
88	25017382100	2010	4199.000	\N
88	25017382200	2010	4559.000	\N
88	25017382300	2010	4982.000	\N
88	25017382400	2010	4163.000	\N
88	25017382500	2010	3800.000	\N
88	25017382601	2010	2962.000	\N
88	25017382602	2010	3524.000	\N
88	25017383101	2010	1686.000	\N
88	25017383102	2010	1141.000	\N
88	25017383200	2010	2929.000	\N
88	25017383300	2010	1993.000	\N
88	25017383400	2010	2881.000	\N
88	25017383501	2010	2464.000	\N
88	25017383502	2010	2981.000	\N
88	25017383600	2010	4421.000	\N
88	25017383700	2010	4091.000	\N
88	25017383800	2010	4423.000	\N
88	25017383901	2010	6602.000	\N
88	25017383902	2010	4383.000	\N
88	25017384001	2010	1092.000	\N
88	25017384002	2010	3538.000	\N
88	25017385100	2010	5721.000	\N
88	25017385201	2010	2058.000	\N
88	25017385202	2010	5751.000	\N
88	25017386100	2010	3845.000	\N
88	25017387100	2010	4005.000	\N
88	25017387201	2010	5047.000	\N
88	25017387202	2010	3593.000	\N
88	25017388100	2010	3940.000	\N
88	25017388200	2010	5739.000	\N
88	25017388300	2010	2531.000	\N
88	25017980000	2010	0.000	\N
88	25019950100	2010	1273.000	\N
88	25019950200	2010	3583.000	\N
88	25019950307	2010	331.000	\N
88	25019950400	2010	1898.000	\N
88	25019950500	2010	1107.000	\N
88	25019990000	2010	0.000	\N
88	25021400100	2010	3609.000	\N
88	25021400200	2010	4247.000	\N
88	25021400300	2010	3117.000	\N
88	25021400400	2010	4303.000	\N
88	25021400500	2010	4132.000	\N
88	25021400600	2010	4020.000	\N
88	25021400700	2010	2690.000	\N
88	25021400800	2010	3957.000	\N
88	25021400900	2010	2424.000	\N
88	25021401000	2010	2141.000	\N
88	25021401100	2010	3530.000	\N
88	25021401200	2010	4870.000	\N
88	25021402101	2010	3110.000	\N
88	25021402102	2010	3120.000	\N
88	25021402200	2010	1843.000	\N
88	25021402300	2010	4133.000	\N
88	25021402400	2010	5104.000	\N
88	25021402500	2010	3737.000	\N
88	25021403100	2010	6265.000	\N
88	25021403300	2010	3841.000	\N
88	25021403400	2010	5690.000	\N
88	25021403500	2010	4844.000	\N
88	25021404100	2010	3039.000	\N
88	25021404201	2010	3340.000	\N
88	25021404202	2010	4019.000	\N
88	25021404301	2010	4822.000	\N
88	25021404302	2010	2960.000	\N
88	25021404400	2010	4881.000	\N
88	25021405100	2010	5099.000	\N
88	25021406101	2010	5186.000	\N
88	25021406102	2010	6107.000	\N
88	25021407100	2010	7315.000	\N
88	25021408101	2010	7468.000	\N
88	25021408102	2010	4456.000	\N
88	25021409101	2010	4703.000	\N
88	25021409102	2010	4790.000	\N
88	25021410100	2010	5802.000	\N
88	25021410300	2010	4057.000	\N
88	25021410400	2010	5606.000	\N
88	25021411100	2010	7280.000	\N
88	25021411200	2010	5941.000	\N
88	25021411301	2010	5263.000	\N
88	25021411302	2010	3364.000	\N
88	25021412100	2010	5824.000	\N
88	25021412200	2010	3347.000	\N
88	25021412300	2010	4210.000	\N
88	25021413100	2010	5185.000	\N
88	25021413200	2010	5291.000	\N
88	25021413300	2010	4245.000	\N
88	25021413401	2010	2846.000	\N
88	25021413402	2010	2777.000	\N
88	25021413500	2010	3298.000	\N
88	25021414100	2010	4222.000	\N
88	25021414200	2010	5915.000	\N
88	25021414300	2010	4134.000	\N
88	25021415101	2010	3928.000	\N
88	25021415102	2010	6164.000	\N
88	25021415200	2010	4560.000	\N
88	25021415300	2010	3299.000	\N
88	25021416101	2010	5028.000	\N
88	25021416102	2010	3172.000	\N
88	25021416200	2010	3376.000	\N
88	25021416300	2010	3417.000	\N
88	25021416400	2010	5496.000	\N
88	25021417100	2010	2919.000	\N
88	25021417200	2010	4023.000	\N
88	25021417300	2010	2071.000	\N
88	25021417400	2010	2397.000	\N
88	25021417501	2010	2837.000	\N
88	25021417502	2010	2185.000	\N
88	25021417601	2010	3271.000	\N
88	25021417602	2010	3368.000	\N
88	25021417701	2010	3756.000	\N
88	25021417702	2010	2294.000	\N
88	25021417801	2010	4851.000	\N
88	25021417802	2010	1534.000	\N
88	25021417901	2010	4066.000	\N
88	25021417902	2010	2293.000	\N
88	25021418002	2010	4165.000	\N
88	25021418003	2010	1713.000	\N
88	25021418004	2010	2599.000	\N
88	25021418101	2010	3345.000	\N
88	25021418102	2010	2269.000	\N
88	25021418200	2010	4492.000	\N
88	25021419100	2010	4898.000	\N
88	25021419200	2010	4347.000	\N
88	25021419300	2010	2844.000	\N
88	25021419400	2010	2729.000	\N
88	25021419500	2010	2653.000	\N
88	25021419600	2010	5874.000	\N
88	25021419700	2010	3347.000	\N
88	25021419800	2010	3779.000	\N
88	25021420100	2010	3120.000	\N
88	25021420201	2010	1371.000	\N
88	25021420202	2010	2280.000	\N
88	25021420301	2010	2876.000	\N
88	25021420302	2010	2906.000	\N
88	25021421100	2010	3962.000	\N
88	25021421200	2010	4759.000	\N
88	25021422100	2010	4860.000	\N
88	25021422200	2010	6077.000	\N
88	25021422301	2010	2781.000	\N
88	25021422302	2010	5458.000	\N
88	25021422400	2010	6739.000	\N
88	25021422501	2010	3916.000	\N
88	25021422502	2010	4278.000	\N
88	25021422600	2010	6186.000	\N
88	25021422700	2010	3500.000	\N
88	25021422800	2010	3569.000	\N
88	25021423100	2010	7254.000	\N
88	25021440100	2010	7691.000	\N
88	25021441202	2010	2602.000	\N
88	25021441203	2010	3592.000	\N
88	25021441204	2010	4347.000	\N
88	25021442101	2010	5052.000	\N
88	25021442102	2010	6557.000	\N
88	25021442103	2010	6331.000	\N
88	25021442201	2010	3797.000	\N
88	25021442202	2010	7189.000	\N
88	25021443101	2010	6988.000	\N
88	25021443102	2010	7997.000	\N
88	25021456101	2010	2943.000	\N
88	25021456102	2010	3755.000	\N
88	25021456200	2010	2408.000	\N
88	25021456301	2010	1221.000	\N
88	25021456302	2010	4004.000	\N
88	25021456401	2010	2213.000	\N
88	25021456402	2010	4596.000	\N
88	25021457100	2010	3615.000	\N
88	25021457200	2010	5090.000	\N
88	25023500101	2010	3492.000	\N
88	25023500103	2010	2110.000	\N
88	25023500104	2010	4100.000	\N
88	25023501101	2010	3170.000	\N
88	25023501102	2010	7649.000	\N
88	25023501201	2010	3513.000	\N
88	25023501202	2010	6803.000	\N
88	25023502101	2010	5418.000	\N
88	25023502102	2010	4988.000	\N
88	25023502200	2010	5473.000	\N
88	25023503101	2010	6843.000	\N
88	25023503102	2010	6457.000	\N
88	25023504101	2010	5103.000	\N
88	25023504102	2010	4908.000	\N
88	25023505101	2010	6110.000	\N
88	25023505102	2010	4797.000	\N
88	25023505200	2010	6370.000	\N
88	25023506101	2010	6269.000	\N
88	25023506102	2010	5560.000	\N
88	25023506202	2010	2444.000	\N
88	25023506203	2010	5032.000	\N
88	25023506204	2010	4822.000	\N
88	25023507101	2010	5115.000	\N
88	25023507103	2010	4201.000	\N
88	25023507104	2010	5183.000	\N
88	25023508101	2010	6411.000	\N
88	25023508102	2010	4910.000	\N
88	25023508200	2010	5817.000	\N
88	25023509101	2010	6597.000	\N
88	25023509102	2010	5434.000	\N
88	25023510100	2010	3127.000	\N
88	25023510200	2010	3108.000	\N
88	25023510300	2010	872.000	\N
88	25023510400	2010	701.000	\N
88	25023510501	2010	1618.000	\N
88	25023510502	2010	2372.000	\N
88	25023510503	2010	2035.000	\N
88	25023510600	2010	2087.000	\N
88	25023510700	2010	2615.000	\N
88	25023510800	2010	1170.000	\N
88	25023510900	2010	602.000	\N
88	25023511000	2010	862.000	\N
88	25023511100	2010	3133.000	\N
88	25023511200	2010	2303.000	\N
88	25023511301	2010	2066.000	\N
88	25023511302	2010	1789.000	\N
88	25023511400	2010	908.000	\N
88	25023511500	2010	926.000	\N
88	25023511600	2010	2995.000	\N
88	25023511701	2010	3011.000	\N
88	25023511702	2010	1968.000	\N
88	25023520100	2010	5986.000	\N
88	25023520201	2010	3618.000	\N
88	25023520202	2010	5013.000	\N
88	25023521101	2010	4026.000	\N
88	25023521102	2010	3094.000	\N
88	25023521201	2010	2721.000	\N
88	25023521202	2010	3762.000	\N
88	25023522101	2010	4514.000	\N
88	25023522102	2010	5271.000	\N
88	25023523100	2010	2820.000	\N
88	25023523201	2010	2707.000	\N
88	25023523202	2010	7477.000	\N
88	25023524101	2010	2829.000	\N
88	25023524102	2010	3647.000	\N
88	25023525101	2010	5734.000	\N
88	25023525104	2010	5906.000	\N
88	25023525203	2010	5147.000	\N
88	25023525204	2010	3136.000	\N
88	25023525300	2010	1136.000	\N
88	25023526100	2010	7236.000	\N
88	25023530100	2010	3439.000	\N
88	25023530200	2010	3038.000	\N
88	25023530300	2010	3445.000	\N
88	25023530400	2010	5570.000	\N
88	25023530500	2010	5211.000	\N
88	25023530600	2010	5602.000	\N
88	25023530700	2010	4039.000	\N
88	25023530801	2010	5355.000	\N
88	25023530802	2010	4546.000	\N
88	25023530901	2010	7757.000	\N
88	25023530902	2010	4236.000	\N
88	25023540101	2010	3630.000	\N
88	25023540102	2010	2484.000	\N
88	25023540103	2010	4073.000	\N
88	25023541100	2010	4973.000	\N
88	25023542101	2010	6742.000	\N
88	25023542102	2010	2389.000	\N
88	25023542200	2010	5865.000	\N
88	25023542300	2010	6734.000	\N
88	25023543100	2010	2708.000	\N
88	25023544100	2010	5294.000	\N
88	25023544200	2010	5628.000	\N
88	25023545100	2010	5566.000	\N
88	25023545200	2010	4764.000	\N
88	25023545300	2010	3623.000	\N
88	25023545400	2010	4641.000	\N
88	25023560100	2010	5770.000	\N
88	25023561100	2010	4509.000	\N
88	25023561200	2010	2563.000	\N
88	25023990003	2010	0.000	\N
88	25025000100	2010	2508.000	\N
88	25025000201	2010	2728.000	\N
88	25025000202	2010	2370.000	\N
88	25025000301	2010	2050.000	\N
88	25025000302	2010	2295.000	\N
88	25025000401	2010	4089.000	\N
88	25025000402	2010	2734.000	\N
88	25025000502	2010	4719.000	\N
88	25025000503	2010	1739.000	\N
88	25025000504	2010	3862.000	\N
88	25025000601	2010	2480.000	\N
88	25025000602	2010	2137.000	\N
88	25025000701	2010	3050.000	\N
88	25025000703	2010	1708.000	\N
88	25025000704	2010	2873.000	\N
88	25025000802	2010	4292.000	\N
88	25025000803	2010	3935.000	\N
88	25025010103	2010	2574.000	\N
88	25025010104	2010	3140.000	\N
88	25025010203	2010	3605.000	\N
88	25025010204	2010	2134.000	\N
88	25025010300	2010	3381.000	\N
88	25025010403	2010	1686.000	\N
88	25025010404	2010	4068.000	\N
88	25025010405	2010	3767.000	\N
88	25025010408	2010	1014.000	\N
88	25025010500	2010	1970.000	\N
88	25025010600	2010	2159.000	\N
88	25025010701	2010	2009.000	\N
88	25025010702	2010	2080.000	\N
88	25025010801	2010	2336.000	\N
88	25025010802	2010	2542.000	\N
88	25025020101	2010	3782.000	\N
88	25025020200	2010	3039.000	\N
88	25025020301	2010	1403.000	\N
88	25025020302	2010	1011.000	\N
88	25025020303	2010	2047.000	\N
88	25025030100	2010	1818.000	\N
88	25025030200	2010	1523.000	\N
88	25025030300	2010	3988.000	\N
88	25025030400	2010	2253.000	\N
88	25025030500	2010	2294.000	\N
88	25025040100	2010	2052.000	\N
88	25025040200	2010	861.000	\N
88	25025040300	2010	3169.000	\N
88	25025040401	2010	2002.000	\N
88	25025040600	2010	2235.000	\N
88	25025040801	2010	2139.000	\N
88	25025050101	2010	1428.000	\N
88	25025050200	2010	1353.000	\N
88	25025050300	2010	650.000	\N
88	25025050400	2010	935.000	\N
88	25025050500	2010	710.000	\N
88	25025050600	2010	523.000	\N
88	25025050700	2010	1225.000	\N
88	25025050901	2010	1215.000	\N
88	25025051000	2010	2216.000	\N
88	25025051101	2010	3189.000	\N
88	25025051200	2010	1349.000	\N
88	25025060101	2010	3115.000	\N
88	25025060200	2010	1884.000	\N
88	25025060301	2010	2969.000	\N
88	25025060400	2010	4626.000	\N
88	25025060501	2010	3343.000	\N
88	25025060600	2010	2039.000	\N
88	25025060700	2010	354.000	\N
88	25025060800	2010	3577.000	\N
88	25025061000	2010	1284.000	\N
88	25025061101	2010	449.000	\N
88	25025061200	2010	2743.000	\N
88	25025070101	2010	3524.000	\N
88	25025070200	2010	1749.000	\N
88	25025070300	2010	2983.000	\N
88	25025070402	2010	110.000	\N
88	25025070500	2010	2962.000	\N
88	25025070600	2010	1838.000	\N
88	25025070700	2010	1287.000	\N
88	25025070800	2010	2307.000	\N
88	25025070900	2010	1482.000	\N
88	25025071101	2010	1837.000	\N
88	25025071201	2010	1218.000	\N
88	25025080100	2010	516.000	\N
88	25025080300	2010	83.000	\N
88	25025080401	2010	200.000	\N
88	25025080500	2010	233.000	\N
88	25025080601	2010	2146.000	\N
88	25025080801	2010	1258.000	\N
88	25025080900	2010	2601.000	\N
88	25025081001	2010	2180.000	\N
88	25025081100	2010	1953.000	\N
88	25025081200	2010	393.000	\N
88	25025081300	2010	299.000	\N
88	25025081400	2010	685.000	\N
88	25025081500	2010	177.000	\N
88	25025081700	2010	74.000	\N
88	25025081800	2010	78.000	\N
88	25025081900	2010	68.000	\N
88	25025082000	2010	52.000	\N
88	25025082100	2010	62.000	\N
88	25025090100	2010	86.000	\N
88	25025090200	2010	40.000	\N
88	25025090300	2010	47.000	\N
88	25025090400	2010	89.000	\N
88	25025090600	2010	93.000	\N
88	25025090700	2010	2597.000	\N
88	25025090901	2010	1400.000	\N
88	25025091001	2010	1599.000	\N
88	25025091100	2010	2260.000	\N
88	25025091200	2010	981.000	\N
88	25025091300	2010	165.000	\N
88	25025091400	2010	196.000	\N
88	25025091500	2010	407.000	\N
88	25025091600	2010	385.000	\N
88	25025091700	2010	200.000	\N
88	25025091800	2010	132.000	\N
88	25025091900	2010	94.000	\N
88	25025092000	2010	258.000	\N
88	25025092101	2010	1906.000	\N
88	25025092200	2010	740.000	\N
88	25025092300	2010	47.000	\N
88	25025092400	2010	56.000	\N
88	25025100100	2010	57.000	\N
88	25025100200	2010	37.000	\N
88	25025100300	2010	120.000	\N
88	25025100400	2010	557.000	\N
88	25025100500	2010	796.000	\N
88	25025100601	2010	2102.000	\N
88	25025100603	2010	1314.000	\N
88	25025100700	2010	3847.000	\N
88	25025100800	2010	2896.000	\N
88	25025100900	2010	933.000	\N
88	25025101001	2010	133.000	\N
88	25025101002	2010	201.000	\N
88	25025101101	2010	29.000	\N
88	25025101102	2010	54.000	\N
88	25025110103	2010	2138.000	\N
88	25025110201	2010	411.000	\N
88	25025110301	2010	955.000	\N
88	25025110401	2010	1117.000	\N
88	25025110403	2010	2148.000	\N
88	25025110501	2010	2299.000	\N
88	25025110502	2010	2070.000	\N
88	25025110601	2010	2580.000	\N
88	25025110607	2010	4085.000	\N
88	25025120103	2010	1270.000	\N
88	25025120104	2010	1359.000	\N
88	25025120105	2010	1890.000	\N
88	25025120201	2010	1903.000	\N
88	25025120301	2010	1908.000	\N
88	25025120400	2010	4344.000	\N
88	25025120500	2010	764.000	\N
88	25025120600	2010	1751.000	\N
88	25025120700	2010	1267.000	\N
88	25025130100	2010	4789.000	\N
88	25025130200	2010	3913.000	\N
88	25025130300	2010	3677.000	\N
88	25025130402	2010	3695.000	\N
88	25025130404	2010	2054.000	\N
88	25025130406	2010	1594.000	\N
88	25025140102	2010	1699.000	\N
88	25025140105	2010	1305.000	\N
88	25025140106	2010	278.000	\N
88	25025140107	2010	891.000	\N
88	25025140201	2010	978.000	\N
88	25025140202	2010	2400.000	\N
88	25025140300	2010	1184.000	\N
88	25025140400	2010	666.000	\N
88	25025160101	2010	1059.000	\N
88	25025160200	2010	391.000	\N
88	25025160300	2010	1343.000	\N
88	25025160400	2010	400.000	\N
88	25025160501	2010	949.000	\N
88	25025160502	2010	1154.000	\N
88	25025160601	2010	1701.000	\N
88	25025160602	2010	1885.000	\N
88	25025170100	2010	4610.000	\N
88	25025170200	2010	3225.000	\N
88	25025170300	2010	6533.000	\N
88	25025170400	2010	3433.000	\N
88	25025170501	2010	2194.000	\N
88	25025170502	2010	2340.000	\N
88	25025170601	2010	3123.000	\N
88	25025170701	2010	1322.000	\N
88	25025170702	2010	2187.000	\N
88	25025170800	2010	3325.000	\N
88	25025180101	2010	4185.000	\N
88	25025180200	2010	3611.000	\N
88	25025180301	2010	2774.000	\N
88	25025180400	2010	1550.000	\N
88	25025180500	2010	3366.000	\N
88	25025980101	2010	165.000	\N
88	25025980300	2010	147.000	\N
88	25025980700	2010	5.000	\N
88	25025981000	2010	3.000	\N
88	25025981100	2010	84.000	\N
88	25025981201	2010	0.000	\N
88	25025981202	2010	155.000	\N
88	25025981300	2010	258.000	\N
88	25025981501	2010	7.000	\N
88	25025981502	2010	7.000	\N
88	25025981600	2010	0.000	\N
88	25025981700	2010	0.000	\N
88	25025981800	2010	71.000	\N
88	25025990101	2010	0.000	\N
88	25027700100	2010	5713.000	\N
88	25027701100	2010	7628.000	\N
88	25027702200	2010	3051.000	\N
88	25027703100	2010	4020.000	\N
88	25027703200	2010	3345.000	\N
88	25027703300	2010	3439.000	\N
88	25027704200	2010	2797.000	\N
88	25027705100	2010	7656.000	\N
88	25027706100	2010	4225.000	\N
88	25027707100	2010	3453.000	\N
88	25027707200	2010	1607.000	\N
88	25027707300	2010	3467.000	\N
88	25027707400	2010	4177.000	\N
88	25027707500	2010	4891.000	\N
88	25027708100	2010	6868.000	\N
88	25027709100	2010	3437.000	\N
88	25027709201	2010	5657.000	\N
88	25027709202	2010	4687.000	\N
88	25027709400	2010	2825.000	\N
88	25027709501	2010	1912.000	\N
88	25027709502	2010	4676.000	\N
88	25027709600	2010	1547.000	\N
88	25027709701	2010	4068.000	\N
88	25027709702	2010	1936.000	\N
88	25027710100	2010	2041.000	\N
88	25027710200	2010	5064.000	\N
88	25027710300	2010	2530.000	\N
88	25027710400	2010	1689.000	\N
88	25027710500	2010	1720.000	\N
88	25027710600	2010	3904.000	\N
88	25027710700	2010	802.000	\N
88	25027710800	2010	2857.000	\N
88	25027711000	2010	1841.000	\N
88	25027711100	2010	5054.000	\N
88	25027712101	2010	5579.000	\N
88	25027712102	2010	3872.000	\N
88	25027713100	2010	6568.000	\N
88	25027715100	2010	4577.000	\N
88	25027716100	2010	6240.000	\N
88	25027716200	2010	2147.000	\N
88	25027716300	2010	2497.000	\N
88	25027717100	2010	2715.000	\N
88	25027718100	2010	4021.000	\N
88	25027719100	2010	7441.000	\N
88	25027720100	2010	3277.000	\N
88	25027721101	2010	1819.000	\N
88	25027721102	2010	7510.000	\N
88	25027722100	2010	5132.000	\N
88	25027723100	2010	3833.000	\N
88	25027724100	2010	3549.000	\N
88	25027725100	2010	4482.000	\N
88	25027726100	2010	5777.000	\N
88	25027726200	2010	5284.000	\N
88	25027727100	2010	4445.000	\N
88	25027728100	2010	3779.000	\N
88	25027728200	2010	3459.000	\N
88	25027728300	2010	4254.000	\N
88	25027728400	2010	4594.000	\N
88	25027729100	2010	4297.000	\N
88	25027729200	2010	2520.000	\N
88	25027730100	2010	4510.000	\N
88	25027730200	2010	4403.000	\N
88	25027730300	2010	3651.000	\N
88	25027730401	2010	3079.000	\N
88	25027730402	2010	889.000	\N
88	25027730500	2010	2093.000	\N
88	25027730600	2010	7545.000	\N
88	25027730700	2010	5509.000	\N
88	25027730801	2010	3222.000	\N
88	25027730802	2010	1680.000	\N
88	25027730901	2010	2883.000	\N
88	25027730902	2010	3081.000	\N
88	25027731001	2010	1411.000	\N
88	25027731002	2010	3692.000	\N
88	25027731101	2010	1981.000	\N
88	25027731102	2010	1776.000	\N
88	25027731202	2010	853.000	\N
88	25027731203	2010	2003.000	\N
88	25027731204	2010	743.000	\N
88	25027731300	2010	828.000	\N
88	25027731400	2010	997.000	\N
88	25027731500	2010	1601.000	\N
88	25027731600	2010	4773.000	\N
88	25027731700	2010	1317.000	\N
88	25027731800	2010	2635.000	\N
88	25027731900	2010	1774.000	\N
88	25027732001	2010	520.000	\N
88	25027732002	2010	2688.000	\N
88	25027732201	2010	1986.000	\N
88	25027732202	2010	2310.000	\N
88	25027732203	2010	1516.000	\N
88	25027732301	2010	3180.000	\N
88	25027732302	2010	2474.000	\N
88	25027732400	2010	2454.000	\N
88	25027732500	2010	679.000	\N
88	25027732600	2010	2186.000	\N
88	25027732700	2010	1978.000	\N
88	25027732801	2010	3663.000	\N
88	25027732802	2010	2767.000	\N
88	25027732901	2010	4074.000	\N
88	25027732902	2010	1993.000	\N
88	25027733000	2010	1413.000	\N
88	25027733101	2010	1517.000	\N
88	25027733102	2010	1487.000	\N
88	25027735100	2010	6196.000	\N
88	25027735200	2010	3765.000	\N
88	25027736100	2010	2408.000	\N
88	25027736200	2010	3470.000	\N
88	25027736300	2010	2212.000	\N
88	25027736400	2010	2815.000	\N
88	25027736500	2010	4177.000	\N
88	25027737100	2010	4793.000	\N
88	25027737200	2010	1631.000	\N
88	25027737300	2010	5885.000	\N
88	25027738100	2010	3554.000	\N
88	25027738201	2010	3680.000	\N
88	25027738202	2010	5441.000	\N
88	25027739100	2010	6585.000	\N
88	25027739200	2010	4289.000	\N
88	25027739300	2010	3026.000	\N
88	25027739400	2010	7118.000	\N
88	25027739500	2010	6516.000	\N
88	25027740101	2010	4463.000	\N
88	25027740102	2010	5219.000	\N
88	25027740200	2010	2478.000	\N
88	25027741101	2010	3901.000	\N
88	25027741102	2010	4504.000	\N
88	25027742300	2010	3387.000	\N
88	25027742401	2010	4665.000	\N
88	25027742402	2010	1714.000	\N
88	25027743100	2010	7105.000	\N
88	25027744101	2010	6492.000	\N
88	25027744102	2010	4609.000	\N
88	25027744200	2010	6165.000	\N
88	25027744300	2010	2669.000	\N
88	25027744400	2010	3169.000	\N
88	25027745100	2010	5561.000	\N
88	25027746100	2010	5631.000	\N
88	25027747101	2010	4848.000	\N
88	25027747102	2010	3707.000	\N
88	25027748100	2010	3073.000	\N
88	25027749100	2010	7568.000	\N
88	25027749200	2010	5188.000	\N
88	25027750100	2010	5586.000	\N
88	25027750200	2010	6448.000	\N
88	25027750300	2010	2686.000	\N
88	25027751101	2010	5959.000	\N
88	25027751102	2010	2645.000	\N
88	25027752100	2010	8074.000	\N
88	25027753100	2010	6848.000	\N
88	25027753200	2010	5943.000	\N
88	25027754100	2010	6047.000	\N
88	25027754200	2010	2853.000	\N
88	25027754300	2010	2307.000	\N
88	25027754400	2010	3451.000	\N
88	25027755100	2010	3044.000	\N
88	25027755200	2010	7638.000	\N
88	25027756101	2010	4240.000	\N
88	25027756102	2010	7993.000	\N
88	25027757100	2010	3073.000	\N
88	25027757200	2010	1189.000	\N
88	25027757300	2010	1588.000	\N
88	25027757400	2010	2140.000	\N
88	25027757500	2010	3475.000	\N
88	25027758101	2010	1598.000	\N
88	25027758102	2010	7067.000	\N
88	25027759100	2010	2079.000	\N
88	25027760100	2010	3265.000	\N
88	25027761100	2010	4893.000	\N
88	25027761200	2010	3957.000	\N
88	25027761300	2010	2802.000	\N
88	25027761400	2010	5668.000	\N
89	25001010100	2010	114.000	\N
89	25001010206	2010	22.000	\N
89	25001010208	2010	38.000	\N
89	25001010304	2010	17.000	\N
89	25001010306	2010	17.000	\N
89	25001010400	2010	37.000	\N
89	25001010500	2010	13.000	\N
89	25001010600	2010	49.000	\N
89	25001010700	2010	32.000	\N
89	25001010800	2010	20.000	\N
89	25001010900	2010	47.000	\N
89	25001011002	2010	88.000	\N
89	25001011100	2010	62.000	\N
89	25001011200	2010	38.000	\N
89	25001011300	2010	18.000	\N
89	25001011400	2010	32.000	\N
89	25001011500	2010	88.000	\N
89	25001011600	2010	121.000	\N
89	25001011700	2010	20.000	\N
89	25001011801	2010	8.000	\N
89	25001011802	2010	36.000	\N
89	25001012001	2010	119.000	\N
89	25001012002	2010	78.000	\N
89	25001012101	2010	134.000	\N
89	25001012102	2010	73.000	\N
89	25001012200	2010	38.000	\N
89	25001012502	2010	119.000	\N
89	25001012601	2010	116.000	\N
89	25001012602	2010	407.000	\N
89	25001012700	2010	86.000	\N
89	25001012800	2010	59.000	\N
89	25001012900	2010	61.000	\N
89	25001013002	2010	23.000	\N
89	25001013100	2010	65.000	\N
89	25001013200	2010	51.000	\N
89	25001013300	2010	10.000	\N
89	25001013400	2010	9.000	\N
89	25001013500	2010	19.000	\N
89	25001013600	2010	32.000	\N
89	25001013700	2010	46.000	\N
89	25001013800	2010	52.000	\N
89	25001013900	2010	36.000	\N
89	25001014002	2010	60.000	\N
89	25001014100	2010	93.000	\N
89	25001014300	2010	38.000	\N
89	25001014402	2010	139.000	\N
89	25001014500	2010	101.000	\N
89	25001014600	2010	115.000	\N
89	25001014700	2010	66.000	\N
89	25001014800	2010	70.000	\N
89	25001014900	2010	47.000	\N
89	25001015001	2010	80.000	\N
89	25001015002	2010	133.000	\N
89	25001015100	2010	77.000	\N
89	25001015200	2010	22.000	\N
89	25001015300	2010	266.000	\N
89	25001990000	2010	0.000	\N
89	25003900100	2010	306.000	\N
89	25003900200	2010	322.000	\N
89	25003900300	2010	100.000	\N
89	25003900400	2010	216.000	\N
89	25003900500	2010	62.000	\N
89	25003900600	2010	592.000	\N
89	25003900700	2010	58.000	\N
89	25003900800	2010	45.000	\N
89	25003900900	2010	170.000	\N
89	25003901100	2010	141.000	\N
89	25003911100	2010	39.000	\N
89	25003912100	2010	48.000	\N
89	25003913100	2010	55.000	\N
89	25003914100	2010	57.000	\N
89	25003920101	2010	128.000	\N
89	25003920102	2010	84.000	\N
89	25003921300	2010	142.000	\N
89	25003921400	2010	28.000	\N
89	25003921500	2010	45.000	\N
89	25003922100	2010	12.000	\N
89	25003922200	2010	27.000	\N
89	25003922300	2010	12.000	\N
89	25003923100	2010	14.000	\N
89	25003924100	2010	18.000	\N
89	25003925100	2010	177.000	\N
89	25003926100	2010	34.000	\N
89	25003931100	2010	3.000	\N
89	25003931300	2010	18.000	\N
89	25003931400	2010	14.000	\N
89	25003932200	2010	12.000	\N
89	25003932300	2010	8.000	\N
89	25003933200	2010	17.000	\N
89	25003933300	2010	18.000	\N
89	25003933400	2010	10.000	\N
89	25003934200	2010	14.000	\N
89	25003934300	2010	11.000	\N
89	25003935100	2010	11.000	\N
89	25003935200	2010	202.000	\N
89	25003935300	2010	64.000	\N
89	25005600100	2010	94.000	\N
89	25005600202	2010	160.000	\N
89	25005600203	2010	138.000	\N
89	25005600204	2010	205.000	\N
89	25005610100	2010	124.000	\N
89	25005610202	2010	114.000	\N
89	25005610203	2010	101.000	\N
89	25005610204	2010	262.000	\N
89	25005611101	2010	74.000	\N
89	25005611102	2010	129.000	\N
89	25005611201	2010	26.000	\N
89	25005611202	2010	89.000	\N
89	25005612100	2010	84.000	\N
89	25005612200	2010	260.000	\N
89	25005613100	2010	140.000	\N
89	25005613300	2010	136.000	\N
89	25005613400	2010	162.000	\N
89	25005613600	2010	199.000	\N
89	25005613700	2010	202.000	\N
89	25005613800	2010	340.000	\N
89	25005613901	2010	208.000	\N
89	25005613902	2010	152.000	\N
89	25005614000	2010	291.000	\N
89	25005614101	2010	464.000	\N
89	25005614102	2010	235.000	\N
89	25005615100	2010	55.000	\N
89	25005616100	2010	55.000	\N
89	25005617101	2010	29.000	\N
89	25005617102	2010	48.000	\N
89	25005630101	2010	44.000	\N
89	25005630102	2010	69.000	\N
89	25005630200	2010	113.000	\N
89	25005630300	2010	118.000	\N
89	25005630400	2010	73.000	\N
89	25005631100	2010	195.000	\N
89	25005631200	2010	183.000	\N
89	25005631300	2010	131.000	\N
89	25005631400	2010	123.000	\N
89	25005631500	2010	91.000	\N
89	25005631600	2010	143.000	\N
89	25005631700	2010	149.000	\N
89	25005631800	2010	232.000	\N
89	25005632100	2010	43.000	\N
89	25005632200	2010	94.000	\N
89	25005633100	2010	28.000	\N
89	25005633200	2010	28.000	\N
89	25005640100	2010	152.000	\N
89	25005640200	2010	140.000	\N
89	25005640300	2010	157.000	\N
89	25005640400	2010	53.000	\N
89	25005640500	2010	121.000	\N
89	25005640600	2010	166.000	\N
89	25005640700	2010	47.000	\N
89	25005640800	2010	164.000	\N
89	25005640901	2010	273.000	\N
89	25005641000	2010	102.000	\N
89	25005641101	2010	134.000	\N
89	25005641200	2010	127.000	\N
89	25005641300	2010	290.000	\N
89	25005641400	2010	111.000	\N
89	25005641500	2010	66.000	\N
89	25005641600	2010	31.000	\N
89	25005641700	2010	71.000	\N
89	25005641800	2010	54.000	\N
89	25005641900	2010	100.000	\N
89	25005642000	2010	194.000	\N
89	25005642100	2010	179.000	\N
89	25005642200	2010	116.000	\N
89	25005642300	2010	20.000	\N
89	25005642400	2010	71.000	\N
89	25005642500	2010	77.000	\N
89	25005644101	2010	26.000	\N
89	25005644102	2010	11.000	\N
89	25005644200	2010	29.000	\N
89	25005645101	2010	20.000	\N
89	25005645102	2010	42.000	\N
89	25005645103	2010	33.000	\N
89	25005646101	2010	37.000	\N
89	25005646103	2010	18.000	\N
89	25005646104	2010	12.000	\N
89	25005650101	2010	108.000	\N
89	25005650102	2010	125.000	\N
89	25005650201	2010	50.000	\N
89	25005650202	2010	63.000	\N
89	25005650300	2010	77.000	\N
89	25005650400	2010	93.000	\N
89	25005650500	2010	64.000	\N
89	25005650600	2010	115.000	\N
89	25005650700	2010	154.000	\N
89	25005650800	2010	222.000	\N
89	25005650900	2010	162.000	\N
89	25005651001	2010	87.000	\N
89	25005651002	2010	232.000	\N
89	25005651100	2010	282.000	\N
89	25005651200	2010	156.000	\N
89	25005651300	2010	152.000	\N
89	25005651400	2010	353.000	\N
89	25005651500	2010	340.000	\N
89	25005651600	2010	363.000	\N
89	25005651700	2010	323.000	\N
89	25005651800	2010	145.000	\N
89	25005651900	2010	214.000	\N
89	25005652000	2010	184.000	\N
89	25005652100	2010	129.000	\N
89	25005652200	2010	86.000	\N
89	25005652300	2010	100.000	\N
89	25005652400	2010	87.000	\N
89	25005652500	2010	107.000	\N
89	25005652600	2010	134.000	\N
89	25005652700	2010	165.000	\N
89	25005652800	2010	47.000	\N
89	25005653101	2010	93.000	\N
89	25005653102	2010	285.000	\N
89	25005653203	2010	49.000	\N
89	25005653204	2010	36.000	\N
89	25005653301	2010	38.000	\N
89	25005653304	2010	7.000	\N
89	25005654100	2010	34.000	\N
89	25005654200	2010	14.000	\N
89	25005655100	2010	45.000	\N
89	25005655200	2010	48.000	\N
89	25005655300	2010	29.000	\N
89	25005655400	2010	18.000	\N
89	25005985500	2010	316.000	\N
89	25005985600	2010	128.000	\N
89	25005990000	2010	0.000	\N
89	25007200100	2010	141.000	\N
89	25007200200	2010	209.000	\N
89	25007200300	2010	85.000	\N
89	25007200400	2010	42.000	\N
89	25007990000	2010	0.000	\N
89	25009201100	2010	15.000	\N
89	25009202101	2010	14.000	\N
89	25009202102	2010	101.000	\N
89	25009202200	2010	42.000	\N
89	25009203100	2010	31.000	\N
89	25009203200	2010	19.000	\N
89	25009203301	2010	46.000	\N
89	25009203302	2010	35.000	\N
89	25009204101	2010	153.000	\N
89	25009204102	2010	228.000	\N
89	25009204200	2010	152.000	\N
89	25009204300	2010	163.000	\N
89	25009204400	2010	37.000	\N
89	25009204500	2010	68.000	\N
89	25009204600	2010	94.000	\N
89	25009204701	2010	315.000	\N
89	25009204702	2010	240.000	\N
89	25009205100	2010	314.000	\N
89	25009205200	2010	456.000	\N
89	25009205300	2010	181.000	\N
89	25009205400	2010	98.000	\N
89	25009205500	2010	510.000	\N
89	25009205600	2010	463.000	\N
89	25009205700	2010	297.000	\N
89	25009205800	2010	311.000	\N
89	25009205900	2010	428.000	\N
89	25009206000	2010	498.000	\N
89	25009206100	2010	569.000	\N
89	25009206200	2010	712.000	\N
89	25009206300	2010	584.000	\N
89	25009206400	2010	540.000	\N
89	25009206500	2010	518.000	\N
89	25009206600	2010	391.000	\N
89	25009206700	2010	463.000	\N
89	25009206800	2010	465.000	\N
89	25009206900	2010	591.000	\N
89	25009207000	2010	357.000	\N
89	25009207100	2010	389.000	\N
89	25009207200	2010	359.000	\N
89	25009208101	2010	99.000	\N
89	25009208102	2010	81.000	\N
89	25009208200	2010	101.000	\N
89	25009208300	2010	111.000	\N
89	25009208400	2010	133.000	\N
89	25009209100	2010	33.000	\N
89	25009209200	2010	15.000	\N
89	25009210100	2010	37.000	\N
89	25009210200	2010	64.000	\N
89	25009210300	2010	243.000	\N
89	25009210400	2010	146.000	\N
89	25009210500	2010	104.000	\N
89	25009210600	2010	73.000	\N
89	25009210700	2010	123.000	\N
89	25009210800	2010	127.000	\N
89	25009210900	2010	53.000	\N
89	25009211100	2010	52.000	\N
89	25009211200	2010	45.000	\N
89	25009211300	2010	27.000	\N
89	25009211401	2010	66.000	\N
89	25009211402	2010	63.000	\N
89	25009212100	2010	153.000	\N
89	25009213100	2010	32.000	\N
89	25009214100	2010	31.000	\N
89	25009215101	2010	37.000	\N
89	25009215102	2010	5.000	\N
89	25009216100	2010	29.000	\N
89	25009217100	2010	121.000	\N
89	25009217201	2010	79.000	\N
89	25009217202	2010	10.000	\N
89	25009217300	2010	127.000	\N
89	25009217400	2010	143.000	\N
89	25009217500	2010	46.000	\N
89	25009217600	2010	58.000	\N
89	25009218100	2010	6.000	\N
89	25009220101	2010	23.000	\N
89	25009220102	2010	18.000	\N
89	25009221100	2010	12.000	\N
89	25009221300	2010	9.000	\N
89	25009221400	2010	34.000	\N
89	25009221500	2010	28.000	\N
89	25009221600	2010	43.000	\N
89	25009221700	2010	28.000	\N
89	25009221800	2010	3.000	\N
89	25009221901	2010	2.000	\N
89	25009221902	2010	40.000	\N
89	25009222100	2010	11.000	\N
89	25009223100	2010	25.000	\N
89	25009223200	2010	15.000	\N
89	25009223300	2010	21.000	\N
89	25009250100	2010	75.000	\N
89	25009250200	2010	141.000	\N
89	25009250300	2010	43.000	\N
89	25009250400	2010	62.000	\N
89	25009250500	2010	40.000	\N
89	25009250600	2010	111.000	\N
89	25009250700	2010	104.000	\N
89	25009250800	2010	171.000	\N
89	25009250900	2010	26.000	\N
89	25009251000	2010	37.000	\N
89	25009251100	2010	44.000	\N
89	25009251200	2010	27.000	\N
89	25009251300	2010	69.000	\N
89	25009251400	2010	157.000	\N
89	25009251500	2010	139.000	\N
89	25009251600	2010	178.000	\N
89	25009251700	2010	114.000	\N
89	25009251800	2010	184.000	\N
89	25009252101	2010	108.000	\N
89	25009252102	2010	24.000	\N
89	25009252201	2010	49.000	\N
89	25009252202	2010	24.000	\N
89	25009252300	2010	177.000	\N
89	25009252400	2010	135.000	\N
89	25009252501	2010	117.000	\N
89	25009252502	2010	87.000	\N
89	25009252601	2010	107.000	\N
89	25009252602	2010	61.000	\N
89	25009252603	2010	46.000	\N
89	25009253100	2010	100.000	\N
89	25009253201	2010	24.000	\N
89	25009253202	2010	220.000	\N
89	25009253203	2010	27.000	\N
89	25009253204	2010	32.000	\N
89	25009253205	2010	24.000	\N
89	25009254100	2010	49.000	\N
89	25009254200	2010	77.000	\N
89	25009254301	2010	42.000	\N
89	25009254302	2010	28.000	\N
89	25009254401	2010	38.000	\N
89	25009254402	2010	83.000	\N
89	25009254403	2010	26.000	\N
89	25009260100	2010	227.000	\N
89	25009260200	2010	149.000	\N
89	25009260301	2010	60.000	\N
89	25009260302	2010	24.000	\N
89	25009260401	2010	55.000	\N
89	25009260402	2010	97.000	\N
89	25009260500	2010	51.000	\N
89	25009260600	2010	71.000	\N
89	25009260700	2010	130.000	\N
89	25009260800	2010	245.000	\N
89	25009260900	2010	118.000	\N
89	25009261000	2010	96.000	\N
89	25009261101	2010	52.000	\N
89	25009261102	2010	158.000	\N
89	25009262100	2010	36.000	\N
89	25009263100	2010	4.000	\N
89	25009264100	2010	28.000	\N
89	25009265101	2010	17.000	\N
89	25009265102	2010	20.000	\N
89	25009266100	2010	28.000	\N
89	25009266200	2010	44.000	\N
89	25009266300	2010	18.000	\N
89	25009266400	2010	18.000	\N
89	25009267101	2010	19.000	\N
89	25009267102	2010	16.000	\N
89	25009268100	2010	13.000	\N
89	25009268200	2010	34.000	\N
89	25009268300	2010	23.000	\N
89	25009268400	2010	25.000	\N
89	25009269100	2010	15.000	\N
89	25009270100	2010	16.000	\N
89	25009990100	2010	0.000	\N
89	25011040100	2010	17.000	\N
89	25011040200	2010	17.000	\N
89	25011040300	2010	13.000	\N
89	25011040400	2010	15.000	\N
89	25011040501	2010	50.000	\N
89	25011040502	2010	25.000	\N
89	25011040600	2010	60.000	\N
89	25011040701	2010	59.000	\N
89	25011040702	2010	22.000	\N
89	25011040800	2010	105.000	\N
89	25011040900	2010	34.000	\N
89	25011041000	2010	39.000	\N
89	25011041100	2010	25.000	\N
89	25011041200	2010	37.000	\N
89	25011041300	2010	69.000	\N
89	25011041400	2010	92.000	\N
89	25011041501	2010	9.000	\N
89	25011041502	2010	15.000	\N
89	25013800101	2010	614.000	\N
89	25013800102	2010	655.000	\N
89	25013800201	2010	659.000	\N
89	25013800202	2010	144.000	\N
89	25013800300	2010	473.000	\N
89	25013800400	2010	699.000	\N
89	25013800500	2010	311.000	\N
89	25013800600	2010	85.000	\N
89	25013800700	2010	292.000	\N
89	25013800800	2010	195.000	\N
89	25013800900	2010	534.000	\N
89	25013801101	2010	255.000	\N
89	25013801102	2010	271.000	\N
89	25013801200	2010	526.000	\N
89	25013801300	2010	2043.000	\N
89	25013801401	2010	1769.000	\N
89	25013801402	2010	688.000	\N
89	25013801501	2010	1769.000	\N
89	25013801502	2010	1000.000	\N
89	25013801503	2010	867.000	\N
89	25013801601	2010	975.000	\N
89	25013801602	2010	906.000	\N
89	25013801603	2010	656.000	\N
89	25013801604	2010	374.000	\N
89	25013801605	2010	928.000	\N
89	25013801700	2010	3503.000	\N
89	25013801800	2010	1745.000	\N
89	25013801901	2010	955.000	\N
89	25013801902	2010	690.000	\N
89	25013802000	2010	358.000	\N
89	25013802100	2010	907.000	\N
89	25013802200	2010	607.000	\N
89	25013802300	2010	1291.000	\N
89	25013802400	2010	278.000	\N
89	25013802500	2010	638.000	\N
89	25013802601	2010	1187.000	\N
89	25013802602	2010	87.000	\N
89	25013810100	2010	72.000	\N
89	25013810200	2010	17.000	\N
89	25013810300	2010	33.000	\N
89	25013810403	2010	54.000	\N
89	25013810404	2010	32.000	\N
89	25013810412	2010	26.000	\N
89	25013810414	2010	373.000	\N
89	25013810601	2010	123.000	\N
89	25013810602	2010	21.000	\N
89	25013810700	2010	148.000	\N
89	25013810800	2010	123.000	\N
89	25013810901	2010	83.000	\N
89	25013810902	2010	129.000	\N
89	25013811000	2010	65.000	\N
89	25013811101	2010	114.000	\N
89	25013811102	2010	174.000	\N
89	25013811200	2010	79.000	\N
89	25013811301	2010	111.000	\N
89	25013811302	2010	355.000	\N
89	25013811400	2010	26.000	\N
89	25013811500	2010	64.000	\N
89	25013811600	2010	107.000	\N
89	25013811700	2010	33.000	\N
89	25013811800	2010	110.000	\N
89	25013811900	2010	57.000	\N
89	25013812001	2010	111.000	\N
89	25013812002	2010	132.000	\N
89	25013812101	2010	78.000	\N
89	25013812103	2010	134.000	\N
89	25013812104	2010	109.000	\N
89	25013812201	2010	146.000	\N
89	25013812202	2010	274.000	\N
89	25013812300	2010	269.000	\N
89	25013812401	2010	31.000	\N
89	25013812403	2010	76.000	\N
89	25013812404	2010	45.000	\N
89	25013812500	2010	124.000	\N
89	25013812600	2010	77.000	\N
89	25013812701	2010	39.000	\N
89	25013812702	2010	115.000	\N
89	25013812800	2010	53.000	\N
89	25013812901	2010	13.000	\N
89	25013812902	2010	33.000	\N
89	25013812903	2010	89.000	\N
89	25013813000	2010	27.000	\N
89	25013813101	2010	40.000	\N
89	25013813102	2010	39.000	\N
89	25013813204	2010	23.000	\N
89	25013813205	2010	83.000	\N
89	25013813206	2010	40.000	\N
89	25013813207	2010	94.000	\N
89	25013813208	2010	42.000	\N
89	25013813209	2010	101.000	\N
89	25013813301	2010	78.000	\N
89	25013813303	2010	35.000	\N
89	25013813304	2010	42.000	\N
89	25013813401	2010	88.000	\N
89	25013813403	2010	30.000	\N
89	25013813404	2010	94.000	\N
89	25013813500	2010	25.000	\N
89	25013813601	2010	201.000	\N
89	25013813602	2010	76.000	\N
89	25013813701	2010	28.000	\N
89	25013813702	2010	37.000	\N
89	25013813801	2010	31.000	\N
89	25013813802	2010	27.000	\N
89	25015820101	2010	42.000	\N
89	25015820102	2010	53.000	\N
89	25015820202	2010	22.000	\N
89	25015820203	2010	107.000	\N
89	25015820204	2010	83.000	\N
89	25015820300	2010	242.000	\N
89	25015820400	2010	618.000	\N
89	25015820500	2010	169.000	\N
89	25015820600	2010	189.000	\N
89	25015820700	2010	216.000	\N
89	25015820801	2010	335.000	\N
89	25015820802	2010	46.000	\N
89	25015820900	2010	23.000	\N
89	25015821000	2010	45.000	\N
89	25015821100	2010	95.000	\N
89	25015821200	2010	166.000	\N
89	25015821300	2010	62.000	\N
89	25015821400	2010	96.000	\N
89	25015821500	2010	22.000	\N
89	25015821601	2010	109.000	\N
89	25015821602	2010	82.000	\N
89	25015821700	2010	71.000	\N
89	25015821901	2010	75.000	\N
89	25015821903	2010	114.000	\N
89	25015821904	2010	43.000	\N
89	25015822000	2010	129.000	\N
89	25015822200	2010	77.000	\N
89	25015822300	2010	52.000	\N
89	25015822401	2010	37.000	\N
89	25015822402	2010	71.000	\N
89	25015822500	2010	20.000	\N
89	25015822601	2010	4.000	\N
89	25015822603	2010	2.000	\N
89	25015822605	2010	1.000	\N
89	25015822606	2010	11.000	\N
89	25015822700	2010	18.000	\N
89	25017300100	2010	9.000	\N
89	25017301101	2010	35.000	\N
89	25017301102	2010	19.000	\N
89	25017310100	2010	492.000	\N
89	25017310200	2010	485.000	\N
89	25017310300	2010	553.000	\N
89	25017310400	2010	223.000	\N
89	25017310500	2010	205.000	\N
89	25017310601	2010	255.000	\N
89	25017310602	2010	321.000	\N
89	25017310700	2010	231.000	\N
89	25017311100	2010	137.000	\N
89	25017311200	2010	176.000	\N
89	25017311300	2010	245.000	\N
89	25017311400	2010	653.000	\N
89	25017311500	2010	155.000	\N
89	25017311600	2010	189.000	\N
89	25017311700	2010	209.000	\N
89	25017311800	2010	148.000	\N
89	25017311900	2010	144.000	\N
89	25017312000	2010	175.000	\N
89	25017312100	2010	208.000	\N
89	25017312200	2010	274.000	\N
89	25017312300	2010	232.000	\N
89	25017312400	2010	148.000	\N
89	25017312501	2010	180.000	\N
89	25017312502	2010	89.000	\N
89	25017313101	2010	33.000	\N
89	25017313102	2010	85.000	\N
89	25017314101	2010	232.000	\N
89	25017314102	2010	181.000	\N
89	25017314200	2010	84.000	\N
89	25017314301	2010	164.000	\N
89	25017314302	2010	30.000	\N
89	25017315100	2010	53.000	\N
89	25017315200	2010	91.000	\N
89	25017315401	2010	83.000	\N
89	25017315402	2010	27.000	\N
89	25017315403	2010	22.000	\N
89	25017315500	2010	31.000	\N
89	25017316101	2010	36.000	\N
89	25017316102	2010	63.000	\N
89	25017316201	2010	29.000	\N
89	25017316202	2010	75.000	\N
89	25017316300	2010	236.000	\N
89	25017316400	2010	289.000	\N
89	25017316500	2010	98.000	\N
89	25017317101	2010	75.000	\N
89	25017317102	2010	70.000	\N
89	25017317103	2010	21.000	\N
89	25017317201	2010	12.000	\N
89	25017317202	2010	14.000	\N
89	25017317203	2010	37.000	\N
89	25017317301	2010	30.000	\N
89	25017317302	2010	79.000	\N
89	25017318100	2010	13.000	\N
89	25017318200	2010	26.000	\N
89	25017318300	2010	19.000	\N
89	25017318400	2010	16.000	\N
89	25017320102	2010	43.000	\N
89	25017320103	2010	31.000	\N
89	25017320104	2010	48.000	\N
89	25017321100	2010	196.000	\N
89	25017321200	2010	146.000	\N
89	25017321300	2010	230.000	\N
89	25017321400	2010	46.000	\N
89	25017321500	2010	213.000	\N
89	25017321600	2010	150.000	\N
89	25017322100	2010	31.000	\N
89	25017322200	2010	63.000	\N
89	25017322300	2010	122.000	\N
89	25017322400	2010	60.000	\N
89	25017323100	2010	44.000	\N
89	25017324101	2010	31.000	\N
89	25017324102	2010	15.000	\N
89	25017325100	2010	425.000	\N
89	25017326101	2010	21.000	\N
89	25017326102	2010	24.000	\N
89	25017327101	2010	13.000	\N
89	25017327102	2010	36.000	\N
89	25017327103	2010	1.000	\N
89	25017328100	2010	6.000	\N
89	25017330100	2010	26.000	\N
89	25017330200	2010	58.000	\N
89	25017331101	2010	35.000	\N
89	25017331102	2010	40.000	\N
89	25017331200	2010	43.000	\N
89	25017331300	2010	44.000	\N
89	25017332100	2010	79.000	\N
89	25017332200	2010	371.000	\N
89	25017332300	2010	258.000	\N
89	25017332400	2010	79.000	\N
89	25017333100	2010	260.000	\N
89	25017333200	2010	178.000	\N
89	25017333300	2010	216.000	\N
89	25017333400	2010	279.000	\N
89	25017333501	2010	165.000	\N
89	25017333502	2010	120.000	\N
89	25017333600	2010	319.000	\N
89	25017334100	2010	90.000	\N
89	25017334200	2010	19.000	\N
89	25017334300	2010	27.000	\N
89	25017334400	2010	47.000	\N
89	25017335100	2010	49.000	\N
89	25017335200	2010	54.000	\N
89	25017335301	2010	50.000	\N
89	25017335302	2010	18.000	\N
89	25017335400	2010	43.000	\N
89	25017336100	2010	86.000	\N
89	25017336200	2010	54.000	\N
89	25017336300	2010	91.000	\N
89	25017336401	2010	238.000	\N
89	25017336402	2010	156.000	\N
89	25017337101	2010	50.000	\N
89	25017337102	2010	50.000	\N
89	25017337201	2010	53.000	\N
89	25017337202	2010	49.000	\N
89	25017337300	2010	137.000	\N
89	25017338100	2010	33.000	\N
89	25017338200	2010	97.000	\N
89	25017338300	2010	28.000	\N
89	25017338400	2010	20.000	\N
89	25017338500	2010	35.000	\N
89	25017339100	2010	242.000	\N
89	25017339200	2010	115.000	\N
89	25017339300	2010	884.000	\N
89	25017339400	2010	199.000	\N
89	25017339500	2010	312.000	\N
89	25017339600	2010	467.000	\N
89	25017339700	2010	547.000	\N
89	25017339801	2010	285.000	\N
89	25017339802	2010	687.000	\N
89	25017339900	2010	424.000	\N
89	25017340000	2010	335.000	\N
89	25017340100	2010	290.000	\N
89	25017341101	2010	299.000	\N
89	25017341102	2010	455.000	\N
89	25017341200	2010	779.000	\N
89	25017341300	2010	681.000	\N
89	25017341400	2010	1092.000	\N
89	25017341500	2010	1100.000	\N
89	25017341600	2010	897.000	\N
89	25017341700	2010	762.000	\N
89	25017341800	2010	1280.000	\N
89	25017341901	2010	165.000	\N
89	25017341902	2010	973.000	\N
89	25017342101	2010	577.000	\N
89	25017342102	2010	643.000	\N
89	25017342201	2010	924.000	\N
89	25017342202	2010	487.000	\N
89	25017342300	2010	842.000	\N
89	25017342400	2010	713.000	\N
89	25017342500	2010	915.000	\N
89	25017342600	2010	551.000	\N
89	25017350103	2010	85.000	\N
89	25017350104	2010	1048.000	\N
89	25017350200	2010	548.000	\N
89	25017350300	2010	184.000	\N
89	25017350400	2010	125.000	\N
89	25017350500	2010	33.000	\N
89	25017350600	2010	104.000	\N
89	25017350700	2010	647.000	\N
89	25017350800	2010	145.000	\N
89	25017350900	2010	55.000	\N
89	25017351000	2010	169.000	\N
89	25017351100	2010	267.000	\N
89	25017351203	2010	137.000	\N
89	25017351204	2010	252.000	\N
89	25017351300	2010	242.000	\N
89	25017351403	2010	313.000	\N
89	25017351404	2010	317.000	\N
89	25017351500	2010	198.000	\N
89	25017352101	2010	102.000	\N
89	25017352102	2010	88.000	\N
89	25017352200	2010	159.000	\N
89	25017352300	2010	232.000	\N
89	25017352400	2010	839.000	\N
89	25017352500	2010	568.000	\N
89	25017352600	2010	250.000	\N
89	25017352700	2010	422.000	\N
89	25017352800	2010	194.000	\N
89	25017352900	2010	135.000	\N
89	25017353000	2010	406.000	\N
89	25017353101	2010	351.000	\N
89	25017353102	2010	269.000	\N
89	25017353200	2010	458.000	\N
89	25017353300	2010	279.000	\N
89	25017353400	2010	786.000	\N
89	25017353500	2010	503.000	\N
89	25017353600	2010	230.000	\N
89	25017353700	2010	231.000	\N
89	25017353800	2010	240.000	\N
89	25017353900	2010	509.000	\N
89	25017354000	2010	149.000	\N
89	25017354100	2010	101.000	\N
89	25017354200	2010	52.000	\N
89	25017354300	2010	458.000	\N
89	25017354400	2010	81.000	\N
89	25017354500	2010	71.000	\N
89	25017354600	2010	1066.000	\N
89	25017354700	2010	150.000	\N
89	25017354800	2010	83.000	\N
89	25017354900	2010	1821.000	\N
89	25017355000	2010	306.000	\N
89	25017356100	2010	31.000	\N
89	25017356300	2010	261.000	\N
89	25017356400	2010	93.000	\N
89	25017356500	2010	118.000	\N
89	25017356601	2010	112.000	\N
89	25017356602	2010	93.000	\N
89	25017356701	2010	144.000	\N
89	25017356702	2010	129.000	\N
89	25017357100	2010	29.000	\N
89	25017357200	2010	32.000	\N
89	25017357300	2010	54.000	\N
89	25017357400	2010	28.000	\N
89	25017357500	2010	21.000	\N
89	25017357600	2010	60.000	\N
89	25017357700	2010	135.000	\N
89	25017357800	2010	84.000	\N
89	25017358100	2010	76.000	\N
89	25017358300	2010	144.000	\N
89	25017358400	2010	56.000	\N
89	25017358500	2010	46.000	\N
89	25017358600	2010	57.000	\N
89	25017358700	2010	78.000	\N
89	25017359100	2010	146.000	\N
89	25017359300	2010	136.000	\N
89	25017360100	2010	129.000	\N
89	25017360200	2010	95.000	\N
89	25017361100	2010	35.000	\N
89	25017361200	2010	462.000	\N
89	25017361300	2010	151.000	\N
89	25017362100	2010	14.000	\N
89	25017363102	2010	102.000	\N
89	25017363103	2010	44.000	\N
89	25017363104	2010	63.000	\N
89	25017363201	2010	6.000	\N
89	25017363202	2010	17.000	\N
89	25017364101	2010	93.000	\N
89	25017364102	2010	66.000	\N
89	25017365100	2010	60.000	\N
89	25017365201	2010	25.000	\N
89	25017365202	2010	52.000	\N
89	25017366100	2010	61.000	\N
89	25017366201	2010	20.000	\N
89	25017366202	2010	20.000	\N
89	25017367100	2010	20.000	\N
89	25017367200	2010	189.000	\N
89	25017368101	2010	284.000	\N
89	25017368102	2010	300.000	\N
89	25017368200	2010	219.000	\N
89	25017368300	2010	418.000	\N
89	25017368400	2010	410.000	\N
89	25017368500	2010	144.000	\N
89	25017368600	2010	231.000	\N
89	25017368700	2010	191.000	\N
89	25017368800	2010	339.000	\N
89	25017368901	2010	213.000	\N
89	25017368902	2010	542.000	\N
89	25017369000	2010	47.000	\N
89	25017369100	2010	121.000	\N
89	25017370101	2010	195.000	\N
89	25017370102	2010	224.000	\N
89	25017370201	2010	74.000	\N
89	25017370202	2010	67.000	\N
89	25017370300	2010	192.000	\N
89	25017370400	2010	131.000	\N
89	25017373100	2010	139.000	\N
89	25017373200	2010	106.000	\N
89	25017373300	2010	79.000	\N
89	25017373400	2010	60.000	\N
89	25017373500	2010	70.000	\N
89	25017373600	2010	146.000	\N
89	25017373700	2010	47.000	\N
89	25017373800	2010	134.000	\N
89	25017373900	2010	115.000	\N
89	25017374000	2010	200.000	\N
89	25017374100	2010	173.000	\N
89	25017374200	2010	100.000	\N
89	25017374300	2010	35.000	\N
89	25017374400	2010	76.000	\N
89	25017374500	2010	142.000	\N
89	25017374600	2010	114.000	\N
89	25017374700	2010	107.000	\N
89	25017374800	2010	165.000	\N
89	25017382100	2010	93.000	\N
89	25017382200	2010	117.000	\N
89	25017382300	2010	67.000	\N
89	25017382400	2010	36.000	\N
89	25017382500	2010	111.000	\N
89	25017382601	2010	138.000	\N
89	25017382602	2010	85.000	\N
89	25017383101	2010	299.000	\N
89	25017383102	2010	506.000	\N
89	25017383200	2010	339.000	\N
89	25017383300	2010	145.000	\N
89	25017383400	2010	384.000	\N
89	25017383501	2010	246.000	\N
89	25017383502	2010	163.000	\N
89	25017383600	2010	372.000	\N
89	25017383700	2010	201.000	\N
89	25017383800	2010	148.000	\N
89	25017383901	2010	225.000	\N
89	25017383902	2010	124.000	\N
89	25017384001	2010	54.000	\N
89	25017384002	2010	240.000	\N
89	25017385100	2010	110.000	\N
89	25017385201	2010	69.000	\N
89	25017385202	2010	190.000	\N
89	25017386100	2010	16.000	\N
89	25017387100	2010	32.000	\N
89	25017387201	2010	60.000	\N
89	25017387202	2010	25.000	\N
89	25017388100	2010	24.000	\N
89	25017388200	2010	574.000	\N
89	25017388300	2010	240.000	\N
89	25017980000	2010	0.000	\N
89	25019950100	2010	43.000	\N
89	25019950200	2010	455.000	\N
89	25019950307	2010	1.000	\N
89	25019950400	2010	146.000	\N
89	25019950500	2010	19.000	\N
89	25019990000	2010	0.000	\N
89	25021400100	2010	232.000	\N
89	25021400200	2010	156.000	\N
89	25021400300	2010	76.000	\N
89	25021400400	2010	83.000	\N
89	25021400500	2010	99.000	\N
89	25021400600	2010	109.000	\N
89	25021400700	2010	84.000	\N
89	25021400800	2010	162.000	\N
89	25021400900	2010	237.000	\N
89	25021401000	2010	180.000	\N
89	25021401100	2010	113.000	\N
89	25021401200	2010	297.000	\N
89	25021402101	2010	138.000	\N
89	25021402102	2010	378.000	\N
89	25021402200	2010	88.000	\N
89	25021402300	2010	80.000	\N
89	25021402400	2010	358.000	\N
89	25021402500	2010	226.000	\N
89	25021403100	2010	25.000	\N
89	25021403300	2010	41.000	\N
89	25021403400	2010	90.000	\N
89	25021403500	2010	83.000	\N
89	25021404100	2010	137.000	\N
89	25021404201	2010	20.000	\N
89	25021404202	2010	112.000	\N
89	25021404301	2010	32.000	\N
89	25021404302	2010	41.000	\N
89	25021404400	2010	204.000	\N
89	25021405100	2010	34.000	\N
89	25021406101	2010	46.000	\N
89	25021406102	2010	26.000	\N
89	25021407100	2010	57.000	\N
89	25021408101	2010	67.000	\N
89	25021408102	2010	57.000	\N
89	25021409101	2010	633.000	\N
89	25021409102	2010	33.000	\N
89	25021410100	2010	82.000	\N
89	25021410300	2010	71.000	\N
89	25021410400	2010	154.000	\N
89	25021411100	2010	226.000	\N
89	25021411200	2010	101.000	\N
89	25021411301	2010	53.000	\N
89	25021411302	2010	189.000	\N
89	25021412100	2010	53.000	\N
89	25021412200	2010	19.000	\N
89	25021412300	2010	55.000	\N
89	25021413100	2010	193.000	\N
89	25021413200	2010	254.000	\N
89	25021413300	2010	220.000	\N
89	25021413401	2010	110.000	\N
89	25021413402	2010	357.000	\N
89	25021413500	2010	258.000	\N
89	25021414100	2010	310.000	\N
89	25021414200	2010	228.000	\N
89	25021414300	2010	163.000	\N
89	25021415101	2010	134.000	\N
89	25021415102	2010	496.000	\N
89	25021415200	2010	547.000	\N
89	25021415300	2010	124.000	\N
89	25021416101	2010	196.000	\N
89	25021416102	2010	295.000	\N
89	25021416200	2010	2319.000	\N
89	25021416300	2010	801.000	\N
89	25021416400	2010	94.000	\N
89	25021417100	2010	84.000	\N
89	25021417200	2010	214.000	\N
89	25021417300	2010	88.000	\N
89	25021417400	2010	21.000	\N
89	25021417501	2010	106.000	\N
89	25021417502	2010	125.000	\N
89	25021417601	2010	131.000	\N
89	25021417602	2010	95.000	\N
89	25021417701	2010	282.000	\N
89	25021417702	2010	127.000	\N
89	25021417801	2010	99.000	\N
89	25021417802	2010	247.000	\N
89	25021417901	2010	410.000	\N
89	25021417902	2010	188.000	\N
89	25021418002	2010	345.000	\N
89	25021418003	2010	168.000	\N
89	25021418004	2010	312.000	\N
89	25021418101	2010	226.000	\N
89	25021418102	2010	335.000	\N
89	25021418200	2010	395.000	\N
89	25021419100	2010	113.000	\N
89	25021419200	2010	142.000	\N
89	25021419300	2010	298.000	\N
89	25021419400	2010	67.000	\N
89	25021419500	2010	62.000	\N
89	25021419600	2010	134.000	\N
89	25021419700	2010	23.000	\N
89	25021419800	2010	72.000	\N
89	25021420100	2010	2555.000	\N
89	25021420201	2010	1270.000	\N
89	25021420202	2010	2533.000	\N
89	25021420301	2010	2304.000	\N
89	25021420302	2010	3256.000	\N
89	25021421100	2010	549.000	\N
89	25021421200	2010	369.000	\N
89	25021422100	2010	66.000	\N
89	25021422200	2010	127.000	\N
89	25021422301	2010	37.000	\N
89	25021422302	2010	360.000	\N
89	25021422400	2010	283.000	\N
89	25021422501	2010	327.000	\N
89	25021422502	2010	217.000	\N
89	25021422600	2010	38.000	\N
89	25021422700	2010	25.000	\N
89	25021422800	2010	47.000	\N
89	25021423100	2010	20.000	\N
89	25021440100	2010	80.000	\N
89	25021441202	2010	14.000	\N
89	25021441203	2010	16.000	\N
89	25021441204	2010	30.000	\N
89	25021442101	2010	149.000	\N
89	25021442102	2010	58.000	\N
89	25021442103	2010	45.000	\N
89	25021442201	2010	65.000	\N
89	25021442202	2010	99.000	\N
89	25021443101	2010	95.000	\N
89	25021443102	2010	122.000	\N
89	25021456101	2010	441.000	\N
89	25021456102	2010	569.000	\N
89	25021456200	2010	373.000	\N
89	25021456301	2010	238.000	\N
89	25021456302	2010	549.000	\N
89	25021456401	2010	242.000	\N
89	25021456402	2010	466.000	\N
89	25021457100	2010	414.000	\N
89	25021457200	2010	36.000	\N
89	25023500101	2010	50.000	\N
89	25023500103	2010	18.000	\N
89	25023500104	2010	20.000	\N
89	25023501101	2010	6.000	\N
89	25023501102	2010	52.000	\N
89	25023501201	2010	16.000	\N
89	25023501202	2010	35.000	\N
89	25023502101	2010	154.000	\N
89	25023502102	2010	184.000	\N
89	25023502200	2010	93.000	\N
89	25023503101	2010	71.000	\N
89	25023503102	2010	35.000	\N
89	25023504101	2010	42.000	\N
89	25023504102	2010	21.000	\N
89	25023505101	2010	31.000	\N
89	25023505102	2010	23.000	\N
89	25023505200	2010	44.000	\N
89	25023506101	2010	25.000	\N
89	25023506102	2010	48.000	\N
89	25023506202	2010	6.000	\N
89	25023506203	2010	11.000	\N
89	25023506204	2010	20.000	\N
89	25023507101	2010	33.000	\N
89	25023507103	2010	5.000	\N
89	25023507104	2010	21.000	\N
89	25023508101	2010	31.000	\N
89	25023508102	2010	30.000	\N
89	25023508200	2010	44.000	\N
89	25023509101	2010	76.000	\N
89	25023509102	2010	53.000	\N
89	25023510100	2010	947.000	\N
89	25023510200	2010	1516.000	\N
89	25023510300	2010	1451.000	\N
89	25023510400	2010	1417.000	\N
89	25023510501	2010	1034.000	\N
89	25023510502	2010	2075.000	\N
89	25023510503	2010	1380.000	\N
89	25023510600	2010	392.000	\N
89	25023510700	2010	1747.000	\N
89	25023510800	2010	2781.000	\N
89	25023510900	2010	916.000	\N
89	25023511000	2010	997.000	\N
89	25023511100	2010	1295.000	\N
89	25023511200	2010	1280.000	\N
89	25023511301	2010	1643.000	\N
89	25023511302	2010	1005.000	\N
89	25023511400	2010	1335.000	\N
89	25023511500	2010	1388.000	\N
89	25023511600	2010	2122.000	\N
89	25023511701	2010	846.000	\N
89	25023511702	2010	372.000	\N
89	25023520100	2010	110.000	\N
89	25023520201	2010	41.000	\N
89	25023520202	2010	162.000	\N
89	25023521101	2010	53.000	\N
89	25023521102	2010	38.000	\N
89	25023521201	2010	37.000	\N
89	25023521202	2010	48.000	\N
89	25023522101	2010	54.000	\N
89	25023522102	2010	42.000	\N
89	25023523100	2010	39.000	\N
89	25023523201	2010	65.000	\N
89	25023523202	2010	105.000	\N
89	25023524101	2010	46.000	\N
89	25023524102	2010	55.000	\N
89	25023525101	2010	154.000	\N
89	25023525104	2010	157.000	\N
89	25023525203	2010	187.000	\N
89	25023525204	2010	84.000	\N
89	25023525300	2010	533.000	\N
89	25023526100	2010	45.000	\N
89	25023530100	2010	127.000	\N
89	25023530200	2010	136.000	\N
89	25023530300	2010	54.000	\N
89	25023530400	2010	48.000	\N
89	25023530500	2010	98.000	\N
89	25023530600	2010	360.000	\N
89	25023530700	2010	37.000	\N
89	25023530801	2010	40.000	\N
89	25023530802	2010	43.000	\N
89	25023530901	2010	113.000	\N
89	25023530902	2010	50.000	\N
89	25023540101	2010	30.000	\N
89	25023540102	2010	15.000	\N
89	25023540103	2010	33.000	\N
89	25023541100	2010	51.000	\N
89	25023542101	2010	89.000	\N
89	25023542102	2010	65.000	\N
89	25023542200	2010	70.000	\N
89	25023542300	2010	118.000	\N
89	25023543100	2010	23.000	\N
89	25023544100	2010	79.000	\N
89	25023544200	2010	53.000	\N
89	25023545100	2010	192.000	\N
89	25023545200	2010	152.000	\N
89	25023545300	2010	238.000	\N
89	25023545400	2010	146.000	\N
89	25023560100	2010	41.000	\N
89	25023561100	2010	82.000	\N
89	25023561200	2010	116.000	\N
89	25023990003	2010	0.000	\N
89	25025000100	2010	249.000	\N
89	25025000201	2010	244.000	\N
89	25025000202	2010	273.000	\N
89	25025000301	2010	124.000	\N
89	25025000302	2010	89.000	\N
89	25025000401	2010	132.000	\N
89	25025000402	2010	69.000	\N
89	25025000502	2010	268.000	\N
89	25025000503	2010	55.000	\N
89	25025000504	2010	168.000	\N
89	25025000601	2010	82.000	\N
89	25025000602	2010	424.000	\N
89	25025000701	2010	179.000	\N
89	25025000703	2010	85.000	\N
89	25025000704	2010	288.000	\N
89	25025000802	2010	318.000	\N
89	25025000803	2010	384.000	\N
89	25025010103	2010	130.000	\N
89	25025010104	2010	128.000	\N
89	25025010203	2010	278.000	\N
89	25025010204	2010	90.000	\N
89	25025010300	2010	377.000	\N
89	25025010403	2010	295.000	\N
89	25025010404	2010	259.000	\N
89	25025010405	2010	426.000	\N
89	25025010408	2010	50.000	\N
89	25025010500	2010	308.000	\N
89	25025010600	2010	134.000	\N
89	25025010701	2010	57.000	\N
89	25025010702	2010	53.000	\N
89	25025010801	2010	62.000	\N
89	25025010802	2010	47.000	\N
89	25025020101	2010	26.000	\N
89	25025020200	2010	121.000	\N
89	25025020301	2010	51.000	\N
89	25025020302	2010	31.000	\N
89	25025020303	2010	564.000	\N
89	25025030100	2010	19.000	\N
89	25025030200	2010	8.000	\N
89	25025030300	2010	250.000	\N
89	25025030400	2010	13.000	\N
89	25025030500	2010	13.000	\N
89	25025040100	2010	11.000	\N
89	25025040200	2010	224.000	\N
89	25025040300	2010	138.000	\N
89	25025040401	2010	50.000	\N
89	25025040600	2010	36.000	\N
89	25025040801	2010	305.000	\N
89	25025050101	2010	132.000	\N
89	25025050200	2010	135.000	\N
89	25025050300	2010	231.000	\N
89	25025050400	2010	66.000	\N
89	25025050500	2010	29.000	\N
89	25025050600	2010	40.000	\N
89	25025050700	2010	82.000	\N
89	25025050901	2010	70.000	\N
89	25025051000	2010	98.000	\N
89	25025051101	2010	328.000	\N
89	25025051200	2010	59.000	\N
89	25025060101	2010	18.000	\N
89	25025060200	2010	3.000	\N
89	25025060301	2010	20.000	\N
89	25025060400	2010	50.000	\N
89	25025060501	2010	22.000	\N
89	25025060600	2010	29.000	\N
89	25025060700	2010	381.000	\N
89	25025060800	2010	39.000	\N
89	25025061000	2010	464.000	\N
89	25025061101	2010	467.000	\N
89	25025061200	2010	68.000	\N
89	25025070101	2010	274.000	\N
89	25025070200	2010	182.000	\N
89	25025070300	2010	105.000	\N
89	25025070402	2010	221.000	\N
89	25025070500	2010	381.000	\N
89	25025070600	2010	91.000	\N
89	25025070700	2010	553.000	\N
89	25025070800	2010	685.000	\N
89	25025070900	2010	747.000	\N
89	25025071101	2010	593.000	\N
89	25025071201	2010	592.000	\N
89	25025080100	2010	1448.000	\N
89	25025080300	2010	1065.000	\N
89	25025080401	2010	1349.000	\N
89	25025080500	2010	1369.000	\N
89	25025080601	2010	850.000	\N
89	25025080801	2010	791.000	\N
89	25025080900	2010	329.000	\N
89	25025081001	2010	684.000	\N
89	25025081100	2010	876.000	\N
89	25025081200	2010	962.000	\N
89	25025081300	2010	2012.000	\N
89	25025081400	2010	1516.000	\N
89	25025081500	2010	1329.000	\N
89	25025081700	2010	2725.000	\N
89	25025081800	2010	1879.000	\N
89	25025081900	2010	2046.000	\N
89	25025082000	2010	2087.000	\N
89	25025082100	2010	3093.000	\N
89	25025090100	2010	3231.000	\N
89	25025090200	2010	1176.000	\N
89	25025090300	2010	1854.000	\N
89	25025090400	2010	1900.000	\N
89	25025090600	2010	916.000	\N
89	25025090700	2010	370.000	\N
89	25025090901	2010	659.000	\N
89	25025091001	2010	298.000	\N
89	25025091100	2010	597.000	\N
89	25025091200	2010	762.000	\N
89	25025091300	2010	869.000	\N
89	25025091400	2010	1267.000	\N
89	25025091500	2010	1735.000	\N
89	25025091600	2010	1015.000	\N
89	25025091700	2010	1440.000	\N
89	25025091800	2010	1798.000	\N
89	25025091900	2010	2699.000	\N
89	25025092000	2010	2676.000	\N
89	25025092101	2010	1413.000	\N
89	25025092200	2010	1417.000	\N
89	25025092300	2010	2222.000	\N
89	25025092400	2010	3470.000	\N
89	25025100100	2010	3542.000	\N
89	25025100200	2010	2185.000	\N
89	25025100300	2010	2643.000	\N
89	25025100400	2010	3320.000	\N
89	25025100500	2010	3317.000	\N
89	25025100601	2010	1418.000	\N
89	25025100603	2010	235.000	\N
89	25025100700	2010	152.000	\N
89	25025100800	2010	1364.000	\N
89	25025100900	2010	2342.000	\N
89	25025101001	2010	4551.000	\N
89	25025101002	2010	3834.000	\N
89	25025101101	2010	2532.000	\N
89	25025101102	2010	3692.000	\N
89	25025110103	2010	961.000	\N
89	25025110201	2010	795.000	\N
89	25025110301	2010	602.000	\N
89	25025110401	2010	945.000	\N
89	25025110403	2010	895.000	\N
89	25025110501	2010	321.000	\N
89	25025110502	2010	625.000	\N
89	25025110601	2010	76.000	\N
89	25025110607	2010	263.000	\N
89	25025120103	2010	55.000	\N
89	25025120104	2010	150.000	\N
89	25025120105	2010	117.000	\N
89	25025120201	2010	510.000	\N
89	25025120301	2010	789.000	\N
89	25025120400	2010	383.000	\N
89	25025120500	2010	232.000	\N
89	25025120600	2010	115.000	\N
89	25025120700	2010	169.000	\N
89	25025130100	2010	190.000	\N
89	25025130200	2010	110.000	\N
89	25025130300	2010	139.000	\N
89	25025130402	2010	177.000	\N
89	25025130404	2010	204.000	\N
89	25025130406	2010	2063.000	\N
89	25025140102	2010	1717.000	\N
89	25025140105	2010	1232.000	\N
89	25025140106	2010	930.000	\N
89	25025140107	2010	898.000	\N
89	25025140201	2010	607.000	\N
89	25025140202	2010	1784.000	\N
89	25025140300	2010	3448.000	\N
89	25025140400	2010	5425.000	\N
89	25025160101	2010	429.000	\N
89	25025160200	2010	176.000	\N
89	25025160300	2010	161.000	\N
89	25025160400	2010	234.000	\N
89	25025160501	2010	364.000	\N
89	25025160502	2010	230.000	\N
89	25025160601	2010	328.000	\N
89	25025160602	2010	419.000	\N
89	25025170100	2010	331.000	\N
89	25025170200	2010	150.000	\N
89	25025170300	2010	465.000	\N
89	25025170400	2010	299.000	\N
89	25025170501	2010	133.000	\N
89	25025170502	2010	74.000	\N
89	25025170601	2010	117.000	\N
89	25025170701	2010	84.000	\N
89	25025170702	2010	354.000	\N
89	25025170800	2010	230.000	\N
89	25025180101	2010	128.000	\N
89	25025180200	2010	84.000	\N
89	25025180301	2010	21.000	\N
89	25025180400	2010	25.000	\N
89	25025180500	2010	71.000	\N
89	25025980101	2010	204.000	\N
89	25025980300	2010	107.000	\N
89	25025980700	2010	0.000	\N
89	25025981000	2010	14.000	\N
89	25025981100	2010	228.000	\N
89	25025981201	2010	0.000	\N
89	25025981202	2010	11.000	\N
89	25025981300	2010	13.000	\N
89	25025981501	2010	3.000	\N
89	25025981502	2010	0.000	\N
89	25025981600	2010	0.000	\N
89	25025981700	2010	0.000	\N
89	25025981800	2010	5.000	\N
89	25025990101	2010	0.000	\N
89	25027700100	2010	53.000	\N
89	25027701100	2010	118.000	\N
89	25027702200	2010	18.000	\N
89	25027703100	2010	35.000	\N
89	25027703200	2010	29.000	\N
89	25027703300	2010	31.000	\N
89	25027704200	2010	22.000	\N
89	25027705100	2010	52.000	\N
89	25027706100	2010	21.000	\N
89	25027707100	2010	54.000	\N
89	25027707200	2010	33.000	\N
89	25027707300	2010	69.000	\N
89	25027707400	2010	57.000	\N
89	25027707500	2010	287.000	\N
89	25027708100	2010	62.000	\N
89	25027709100	2010	87.000	\N
89	25027709201	2010	181.000	\N
89	25027709202	2010	382.000	\N
89	25027709400	2010	189.000	\N
89	25027709501	2010	60.000	\N
89	25027709502	2010	305.000	\N
89	25027709600	2010	202.000	\N
89	25027709701	2010	344.000	\N
89	25027709702	2010	76.000	\N
89	25027710100	2010	156.000	\N
89	25027710200	2010	212.000	\N
89	25027710300	2010	110.000	\N
89	25027710400	2010	37.000	\N
89	25027710500	2010	129.000	\N
89	25027710600	2010	267.000	\N
89	25027710700	2010	103.000	\N
89	25027710800	2010	286.000	\N
89	25027711000	2010	164.000	\N
89	25027711100	2010	150.000	\N
89	25027712101	2010	45.000	\N
89	25027712102	2010	34.000	\N
89	25027713100	2010	572.000	\N
89	25027715100	2010	22.000	\N
89	25027716100	2010	156.000	\N
89	25027716200	2010	128.000	\N
89	25027716300	2010	57.000	\N
89	25027717100	2010	18.000	\N
89	25027718100	2010	29.000	\N
89	25027719100	2010	52.000	\N
89	25027720100	2010	14.000	\N
89	25027721101	2010	7.000	\N
89	25027721102	2010	91.000	\N
89	25027722100	2010	48.000	\N
89	25027723100	2010	30.000	\N
89	25027724100	2010	27.000	\N
89	25027725100	2010	16.000	\N
89	25027726100	2010	23.000	\N
89	25027726200	2010	38.000	\N
89	25027727100	2010	92.000	\N
89	25027728100	2010	43.000	\N
89	25027728200	2010	40.000	\N
89	25027728300	2010	43.000	\N
89	25027728400	2010	37.000	\N
89	25027729100	2010	280.000	\N
89	25027729200	2010	41.000	\N
89	25027730100	2010	572.000	\N
89	25027730200	2010	459.000	\N
89	25027730300	2010	230.000	\N
89	25027730401	2010	946.000	\N
89	25027730402	2010	209.000	\N
89	25027730500	2010	617.000	\N
89	25027730600	2010	369.000	\N
89	25027730700	2010	424.000	\N
89	25027730801	2010	114.000	\N
89	25027730802	2010	89.000	\N
89	25027730901	2010	142.000	\N
89	25027730902	2010	177.000	\N
89	25027731001	2010	296.000	\N
89	25027731002	2010	893.000	\N
89	25027731101	2010	400.000	\N
89	25027731102	2010	226.000	\N
89	25027731202	2010	37.000	\N
89	25027731203	2010	454.000	\N
89	25027731204	2010	272.000	\N
89	25027731300	2010	398.000	\N
89	25027731400	2010	664.000	\N
89	25027731500	2010	684.000	\N
89	25027731600	2010	531.000	\N
89	25027731700	2010	420.000	\N
89	25027731800	2010	636.000	\N
89	25027731900	2010	1066.000	\N
89	25027732001	2010	372.000	\N
89	25027732002	2010	403.000	\N
89	25027732201	2010	223.000	\N
89	25027732202	2010	202.000	\N
89	25027732203	2010	317.000	\N
89	25027732301	2010	317.000	\N
89	25027732302	2010	449.000	\N
89	25027732400	2010	958.000	\N
89	25027732500	2010	167.000	\N
89	25027732600	2010	475.000	\N
89	25027732700	2010	615.000	\N
89	25027732801	2010	444.000	\N
89	25027732802	2010	573.000	\N
89	25027732901	2010	877.000	\N
89	25027732902	2010	98.000	\N
89	25027733000	2010	367.000	\N
89	25027733101	2010	125.000	\N
89	25027733102	2010	194.000	\N
89	25027735100	2010	76.000	\N
89	25027735200	2010	137.000	\N
89	25027736100	2010	27.000	\N
89	25027736200	2010	38.000	\N
89	25027736300	2010	20.000	\N
89	25027736400	2010	39.000	\N
89	25027736500	2010	30.000	\N
89	25027737100	2010	57.000	\N
89	25027737200	2010	22.000	\N
89	25027737300	2010	86.000	\N
89	25027738100	2010	53.000	\N
89	25027738201	2010	45.000	\N
89	25027738202	2010	54.000	\N
89	25027739100	2010	308.000	\N
89	25027739200	2010	121.000	\N
89	25027739300	2010	71.000	\N
89	25027739400	2010	145.000	\N
89	25027739500	2010	72.000	\N
89	25027740101	2010	43.000	\N
89	25027740102	2010	52.000	\N
89	25027740200	2010	32.000	\N
89	25027741101	2010	40.000	\N
89	25027741102	2010	40.000	\N
89	25027742300	2010	41.000	\N
89	25027742401	2010	39.000	\N
89	25027742402	2010	30.000	\N
89	25027743100	2010	52.000	\N
89	25027744101	2010	129.000	\N
89	25027744102	2010	110.000	\N
89	25027744200	2010	120.000	\N
89	25027744300	2010	100.000	\N
89	25027744400	2010	76.000	\N
89	25027745100	2010	36.000	\N
89	25027746100	2010	17.000	\N
89	25027747101	2010	54.000	\N
89	25027747102	2010	23.000	\N
89	25027748100	2010	13.000	\N
89	25027749100	2010	63.000	\N
89	25027749200	2010	38.000	\N
89	25027750100	2010	44.000	\N
89	25027750200	2010	31.000	\N
89	25027750300	2010	21.000	\N
89	25027751101	2010	33.000	\N
89	25027751102	2010	5.000	\N
89	25027752100	2010	35.000	\N
89	25027753100	2010	95.000	\N
89	25027753200	2010	39.000	\N
89	25027754100	2010	66.000	\N
89	25027754200	2010	130.000	\N
89	25027754300	2010	133.000	\N
89	25027754400	2010	91.000	\N
89	25027755100	2010	44.000	\N
89	25027755200	2010	74.000	\N
89	25027756101	2010	40.000	\N
89	25027756102	2010	35.000	\N
89	25027757100	2010	67.000	\N
89	25027757200	2010	40.000	\N
89	25027757300	2010	31.000	\N
89	25027757400	2010	40.000	\N
89	25027757500	2010	58.000	\N
89	25027758101	2010	7.000	\N
89	25027758102	2010	49.000	\N
89	25027759100	2010	11.000	\N
89	25027760100	2010	10.000	\N
89	25027761100	2010	29.000	\N
89	25027761200	2010	121.000	\N
89	25027761300	2010	32.000	\N
89	25027761400	2010	259.000	\N
90	25001010100	2010	11.000	\N
90	25001010206	2010	7.000	\N
90	25001010208	2010	3.000	\N
90	25001010304	2010	6.000	\N
90	25001010306	2010	6.000	\N
90	25001010400	2010	4.000	\N
90	25001010500	2010	2.000	\N
90	25001010600	2010	8.000	\N
90	25001010700	2010	7.000	\N
90	25001010800	2010	9.000	\N
90	25001010900	2010	4.000	\N
90	25001011002	2010	20.000	\N
90	25001011100	2010	10.000	\N
90	25001011200	2010	7.000	\N
90	25001011300	2010	8.000	\N
90	25001011400	2010	6.000	\N
90	25001011500	2010	13.000	\N
90	25001011600	2010	17.000	\N
90	25001011700	2010	12.000	\N
90	25001011801	2010	7.000	\N
90	25001011802	2010	7.000	\N
90	25001012001	2010	10.000	\N
90	25001012002	2010	7.000	\N
90	25001012101	2010	24.000	\N
90	25001012102	2010	4.000	\N
90	25001012200	2010	9.000	\N
90	25001012502	2010	24.000	\N
90	25001012601	2010	16.000	\N
90	25001012602	2010	72.000	\N
90	25001012700	2010	22.000	\N
90	25001012800	2010	0.000	\N
90	25001012900	2010	11.000	\N
90	25001013002	2010	4.000	\N
90	25001013100	2010	33.000	\N
90	25001013200	2010	20.000	\N
90	25001013300	2010	1.000	\N
90	25001013400	2010	3.000	\N
90	25001013500	2010	13.000	\N
90	25001013600	2010	27.000	\N
90	25001013700	2010	29.000	\N
90	25001013800	2010	22.000	\N
90	25001013900	2010	25.000	\N
90	25001014002	2010	13.000	\N
90	25001014100	2010	9.000	\N
90	25001014300	2010	12.000	\N
90	25001014402	2010	33.000	\N
90	25001014500	2010	34.000	\N
90	25001014600	2010	31.000	\N
90	25001014700	2010	26.000	\N
90	25001014800	2010	21.000	\N
90	25001014900	2010	6.000	\N
90	25001015001	2010	181.000	\N
90	25001015002	2010	157.000	\N
90	25001015100	2010	56.000	\N
90	25001015200	2010	11.000	\N
90	25001015300	2010	44.000	\N
90	25001990000	2010	0.000	\N
90	25003900100	2010	10.000	\N
90	25003900200	2010	17.000	\N
90	25003900300	2010	3.000	\N
90	25003900400	2010	2.000	\N
90	25003900500	2010	0.000	\N
90	25003900600	2010	15.000	\N
90	25003900700	2010	1.000	\N
90	25003900800	2010	2.000	\N
90	25003900900	2010	16.000	\N
90	25003901100	2010	5.000	\N
90	25003911100	2010	1.000	\N
90	25003912100	2010	4.000	\N
90	25003913100	2010	4.000	\N
90	25003914100	2010	10.000	\N
90	25003920101	2010	4.000	\N
90	25003920102	2010	2.000	\N
90	25003921300	2010	15.000	\N
90	25003921400	2010	4.000	\N
90	25003921500	2010	8.000	\N
90	25003922100	2010	0.000	\N
90	25003922200	2010	8.000	\N
90	25003922300	2010	0.000	\N
90	25003923100	2010	5.000	\N
90	25003924100	2010	1.000	\N
90	25003925100	2010	12.000	\N
90	25003926100	2010	5.000	\N
90	25003931100	2010	0.000	\N
90	25003931300	2010	6.000	\N
90	25003931400	2010	4.000	\N
90	25003932200	2010	4.000	\N
90	25003932300	2010	1.000	\N
90	25003933200	2010	0.000	\N
90	25003933300	2010	1.000	\N
90	25003933400	2010	4.000	\N
90	25003934200	2010	0.000	\N
90	25003934300	2010	1.000	\N
90	25003935100	2010	4.000	\N
90	25003935200	2010	6.000	\N
90	25003935300	2010	12.000	\N
90	25005600100	2010	4.000	\N
90	25005600202	2010	1.000	\N
90	25005600203	2010	8.000	\N
90	25005600204	2010	3.000	\N
90	25005610100	2010	6.000	\N
90	25005610202	2010	7.000	\N
90	25005610203	2010	11.000	\N
90	25005610204	2010	35.000	\N
90	25005611101	2010	8.000	\N
90	25005611102	2010	8.000	\N
90	25005611201	2010	0.000	\N
90	25005611202	2010	5.000	\N
90	25005612100	2010	3.000	\N
90	25005612200	2010	20.000	\N
90	25005613100	2010	10.000	\N
90	25005613300	2010	10.000	\N
90	25005613400	2010	7.000	\N
90	25005613600	2010	9.000	\N
90	25005613700	2010	1.000	\N
90	25005613800	2010	30.000	\N
90	25005613901	2010	7.000	\N
90	25005613902	2010	14.000	\N
90	25005614000	2010	9.000	\N
90	25005614101	2010	6.000	\N
90	25005614102	2010	5.000	\N
90	25005615100	2010	12.000	\N
90	25005616100	2010	6.000	\N
90	25005617101	2010	4.000	\N
90	25005617102	2010	5.000	\N
90	25005630101	2010	12.000	\N
90	25005630102	2010	12.000	\N
90	25005630200	2010	1.000	\N
90	25005630300	2010	1.000	\N
90	25005630400	2010	6.000	\N
90	25005631100	2010	7.000	\N
90	25005631200	2010	8.000	\N
90	25005631300	2010	5.000	\N
90	25005631400	2010	6.000	\N
90	25005631500	2010	6.000	\N
90	25005631600	2010	10.000	\N
90	25005631700	2010	8.000	\N
90	25005631800	2010	14.000	\N
90	25005632100	2010	9.000	\N
90	25005632200	2010	14.000	\N
90	25005633100	2010	4.000	\N
90	25005633200	2010	18.000	\N
90	25005640100	2010	9.000	\N
90	25005640200	2010	18.000	\N
90	25005640300	2010	11.000	\N
90	25005640400	2010	5.000	\N
90	25005640500	2010	12.000	\N
90	25005640600	2010	6.000	\N
90	25005640700	2010	2.000	\N
90	25005640800	2010	7.000	\N
90	25005640901	2010	6.000	\N
90	25005641000	2010	2.000	\N
90	25005641101	2010	4.000	\N
90	25005641200	2010	2.000	\N
90	25005641300	2010	26.000	\N
90	25005641400	2010	4.000	\N
90	25005641500	2010	5.000	\N
90	25005641600	2010	4.000	\N
90	25005641700	2010	4.000	\N
90	25005641800	2010	5.000	\N
90	25005641900	2010	9.000	\N
90	25005642000	2010	5.000	\N
90	25005642100	2010	5.000	\N
90	25005642200	2010	4.000	\N
90	25005642300	2010	4.000	\N
90	25005642400	2010	2.000	\N
90	25005642500	2010	2.000	\N
90	25005644101	2010	8.000	\N
90	25005644102	2010	3.000	\N
90	25005644200	2010	9.000	\N
90	25005645101	2010	1.000	\N
90	25005645102	2010	4.000	\N
90	25005645103	2010	4.000	\N
90	25005646101	2010	4.000	\N
90	25005646103	2010	0.000	\N
90	25005646104	2010	1.000	\N
90	25005650101	2010	4.000	\N
90	25005650102	2010	12.000	\N
90	25005650201	2010	8.000	\N
90	25005650202	2010	6.000	\N
90	25005650300	2010	5.000	\N
90	25005650400	2010	6.000	\N
90	25005650500	2010	1.000	\N
90	25005650600	2010	7.000	\N
90	25005650700	2010	32.000	\N
90	25005650800	2010	17.000	\N
90	25005650900	2010	16.000	\N
90	25005651001	2010	14.000	\N
90	25005651002	2010	20.000	\N
90	25005651100	2010	12.000	\N
90	25005651200	2010	33.000	\N
90	25005651300	2010	17.000	\N
90	25005651400	2010	14.000	\N
90	25005651500	2010	13.000	\N
90	25005651600	2010	26.000	\N
90	25005651700	2010	15.000	\N
90	25005651800	2010	18.000	\N
90	25005651900	2010	18.000	\N
90	25005652000	2010	17.000	\N
90	25005652100	2010	12.000	\N
90	25005652200	2010	10.000	\N
90	25005652300	2010	6.000	\N
90	25005652400	2010	5.000	\N
90	25005652500	2010	11.000	\N
90	25005652600	2010	19.000	\N
90	25005652700	2010	12.000	\N
90	25005652800	2010	3.000	\N
90	25005653101	2010	9.000	\N
90	25005653102	2010	11.000	\N
90	25005653203	2010	8.000	\N
90	25005653204	2010	3.000	\N
90	25005653301	2010	4.000	\N
90	25005653304	2010	6.000	\N
90	25005654100	2010	7.000	\N
90	25005654200	2010	9.000	\N
90	25005655100	2010	4.000	\N
90	25005655200	2010	11.000	\N
90	25005655300	2010	3.000	\N
90	25005655400	2010	5.000	\N
90	25005985500	2010	7.000	\N
90	25005985600	2010	1.000	\N
90	25005990000	2010	0.000	\N
90	25007200100	2010	16.000	\N
90	25007200200	2010	41.000	\N
90	25007200300	2010	17.000	\N
90	25007200400	2010	101.000	\N
90	25007990000	2010	0.000	\N
90	25009201100	2010	3.000	\N
90	25009202101	2010	1.000	\N
90	25009202102	2010	4.000	\N
90	25009202200	2010	2.000	\N
90	25009203100	2010	2.000	\N
90	25009203200	2010	4.000	\N
90	25009203301	2010	3.000	\N
90	25009203302	2010	3.000	\N
90	25009204101	2010	2.000	\N
90	25009204102	2010	7.000	\N
90	25009204200	2010	12.000	\N
90	25009204300	2010	10.000	\N
90	25009204400	2010	4.000	\N
90	25009204500	2010	5.000	\N
90	25009204600	2010	2.000	\N
90	25009204701	2010	14.000	\N
90	25009204702	2010	10.000	\N
90	25009205100	2010	0.000	\N
90	25009205200	2010	7.000	\N
90	25009205300	2010	7.000	\N
90	25009205400	2010	8.000	\N
90	25009205500	2010	7.000	\N
90	25009205600	2010	10.000	\N
90	25009205700	2010	14.000	\N
90	25009205800	2010	1.000	\N
90	25009205900	2010	5.000	\N
90	25009206000	2010	3.000	\N
90	25009206100	2010	13.000	\N
90	25009206200	2010	8.000	\N
90	25009206300	2010	6.000	\N
90	25009206400	2010	8.000	\N
90	25009206500	2010	7.000	\N
90	25009206600	2010	15.000	\N
90	25009206700	2010	8.000	\N
90	25009206800	2010	18.000	\N
90	25009206900	2010	15.000	\N
90	25009207000	2010	8.000	\N
90	25009207100	2010	3.000	\N
90	25009207200	2010	7.000	\N
90	25009208101	2010	4.000	\N
90	25009208102	2010	1.000	\N
90	25009208200	2010	3.000	\N
90	25009208300	2010	17.000	\N
90	25009208400	2010	3.000	\N
90	25009209100	2010	2.000	\N
90	25009209200	2010	3.000	\N
90	25009210100	2010	5.000	\N
90	25009210200	2010	8.000	\N
90	25009210300	2010	5.000	\N
90	25009210400	2010	5.000	\N
90	25009210500	2010	4.000	\N
90	25009210600	2010	7.000	\N
90	25009210700	2010	3.000	\N
90	25009210800	2010	2.000	\N
90	25009210900	2010	6.000	\N
90	25009211100	2010	1.000	\N
90	25009211200	2010	9.000	\N
90	25009211300	2010	2.000	\N
90	25009211401	2010	3.000	\N
90	25009211402	2010	9.000	\N
90	25009212100	2010	13.000	\N
90	25009213100	2010	2.000	\N
90	25009214100	2010	4.000	\N
90	25009215101	2010	12.000	\N
90	25009215102	2010	0.000	\N
90	25009216100	2010	4.000	\N
90	25009217100	2010	3.000	\N
90	25009217201	2010	0.000	\N
90	25009217202	2010	1.000	\N
90	25009217300	2010	13.000	\N
90	25009217400	2010	9.000	\N
90	25009217500	2010	9.000	\N
90	25009217600	2010	7.000	\N
90	25009218100	2010	11.000	\N
90	25009220101	2010	2.000	\N
90	25009220102	2010	2.000	\N
90	25009221100	2010	1.000	\N
90	25009221300	2010	2.000	\N
90	25009221400	2010	0.000	\N
90	25009221500	2010	6.000	\N
90	25009221600	2010	1.000	\N
90	25009221700	2010	3.000	\N
90	25009221800	2010	0.000	\N
90	25009221901	2010	7.000	\N
90	25009221902	2010	9.000	\N
90	25009222100	2010	0.000	\N
90	25009223100	2010	3.000	\N
90	25009223200	2010	5.000	\N
90	25009223300	2010	4.000	\N
90	25009250100	2010	6.000	\N
90	25009250200	2010	20.000	\N
90	25009250300	2010	6.000	\N
90	25009250400	2010	9.000	\N
90	25009250500	2010	2.000	\N
90	25009250600	2010	18.000	\N
90	25009250700	2010	10.000	\N
90	25009250800	2010	14.000	\N
90	25009250900	2010	3.000	\N
90	25009251000	2010	1.000	\N
90	25009251100	2010	3.000	\N
90	25009251200	2010	0.000	\N
90	25009251300	2010	5.000	\N
90	25009251400	2010	13.000	\N
90	25009251500	2010	2.000	\N
90	25009251600	2010	3.000	\N
90	25009251700	2010	7.000	\N
90	25009251800	2010	8.000	\N
90	25009252101	2010	6.000	\N
90	25009252102	2010	3.000	\N
90	25009252201	2010	2.000	\N
90	25009252202	2010	5.000	\N
90	25009252300	2010	13.000	\N
90	25009252400	2010	3.000	\N
90	25009252501	2010	11.000	\N
90	25009252502	2010	5.000	\N
90	25009252601	2010	3.000	\N
90	25009252602	2010	9.000	\N
90	25009252603	2010	8.000	\N
90	25009253100	2010	11.000	\N
90	25009253201	2010	1.000	\N
90	25009253202	2010	0.000	\N
90	25009253203	2010	6.000	\N
90	25009253204	2010	4.000	\N
90	25009253205	2010	0.000	\N
90	25009254100	2010	4.000	\N
90	25009254200	2010	3.000	\N
90	25009254301	2010	1.000	\N
90	25009254302	2010	3.000	\N
90	25009254401	2010	0.000	\N
90	25009254402	2010	4.000	\N
90	25009254403	2010	0.000	\N
90	25009260100	2010	8.000	\N
90	25009260200	2010	18.000	\N
90	25009260301	2010	2.000	\N
90	25009260302	2010	0.000	\N
90	25009260401	2010	1.000	\N
90	25009260402	2010	3.000	\N
90	25009260500	2010	5.000	\N
90	25009260600	2010	8.000	\N
90	25009260700	2010	5.000	\N
90	25009260800	2010	12.000	\N
90	25009260900	2010	10.000	\N
90	25009261000	2010	3.000	\N
90	25009261101	2010	4.000	\N
90	25009261102	2010	3.000	\N
90	25009262100	2010	8.000	\N
90	25009263100	2010	3.000	\N
90	25009264100	2010	3.000	\N
90	25009265101	2010	5.000	\N
90	25009265102	2010	2.000	\N
90	25009266100	2010	7.000	\N
90	25009266200	2010	13.000	\N
90	25009266300	2010	4.000	\N
90	25009266400	2010	6.000	\N
90	25009267101	2010	6.000	\N
90	25009267102	2010	12.000	\N
90	25009268100	2010	0.000	\N
90	25009268200	2010	7.000	\N
90	25009268300	2010	8.000	\N
90	25009268400	2010	2.000	\N
90	25009269100	2010	10.000	\N
90	25009270100	2010	1.000	\N
90	25009990100	2010	0.000	\N
90	25011040100	2010	9.000	\N
90	25011040200	2010	6.000	\N
90	25011040300	2010	5.000	\N
90	25011040400	2010	12.000	\N
90	25011040501	2010	11.000	\N
90	25011040502	2010	18.000	\N
90	25011040600	2010	12.000	\N
90	25011040701	2010	9.000	\N
90	25011040702	2010	6.000	\N
90	25011040800	2010	12.000	\N
90	25011040900	2010	1.000	\N
90	25011041000	2010	5.000	\N
90	25011041100	2010	6.000	\N
90	25011041200	2010	10.000	\N
90	25011041300	2010	25.000	\N
90	25011041400	2010	6.000	\N
90	25011041501	2010	15.000	\N
90	25011041502	2010	7.000	\N
90	25013800101	2010	7.000	\N
90	25013800102	2010	8.000	\N
90	25013800201	2010	16.000	\N
90	25013800202	2010	2.000	\N
90	25013800300	2010	6.000	\N
90	25013800400	2010	11.000	\N
90	25013800500	2010	3.000	\N
90	25013800600	2010	2.000	\N
90	25013800700	2010	6.000	\N
90	25013800800	2010	3.000	\N
90	25013800900	2010	4.000	\N
90	25013801101	2010	4.000	\N
90	25013801102	2010	7.000	\N
90	25013801200	2010	4.000	\N
90	25013801300	2010	15.000	\N
90	25013801401	2010	6.000	\N
90	25013801402	2010	5.000	\N
90	25013801501	2010	25.000	\N
90	25013801502	2010	12.000	\N
90	25013801503	2010	12.000	\N
90	25013801601	2010	17.000	\N
90	25013801602	2010	8.000	\N
90	25013801603	2010	5.000	\N
90	25013801604	2010	10.000	\N
90	25013801605	2010	4.000	\N
90	25013801700	2010	13.000	\N
90	25013801800	2010	11.000	\N
90	25013801901	2010	18.000	\N
90	25013801902	2010	13.000	\N
90	25013802000	2010	4.000	\N
90	25013802100	2010	6.000	\N
90	25013802200	2010	10.000	\N
90	25013802300	2010	15.000	\N
90	25013802400	2010	2.000	\N
90	25013802500	2010	4.000	\N
90	25013802601	2010	31.000	\N
90	25013802602	2010	0.000	\N
90	25013810100	2010	12.000	\N
90	25013810200	2010	5.000	\N
90	25013810300	2010	3.000	\N
90	25013810403	2010	2.000	\N
90	25013810404	2010	2.000	\N
90	25013810412	2010	3.000	\N
90	25013810414	2010	7.000	\N
90	25013810601	2010	7.000	\N
90	25013810602	2010	3.000	\N
90	25013810700	2010	12.000	\N
90	25013810800	2010	4.000	\N
90	25013810901	2010	4.000	\N
90	25013810902	2010	10.000	\N
90	25013811000	2010	5.000	\N
90	25013811101	2010	10.000	\N
90	25013811102	2010	6.000	\N
90	25013811200	2010	5.000	\N
90	25013811301	2010	9.000	\N
90	25013811302	2010	12.000	\N
90	25013811400	2010	3.000	\N
90	25013811500	2010	0.000	\N
90	25013811600	2010	5.000	\N
90	25013811700	2010	4.000	\N
90	25013811800	2010	7.000	\N
90	25013811900	2010	7.000	\N
90	25013812001	2010	0.000	\N
90	25013812002	2010	3.000	\N
90	25013812101	2010	3.000	\N
90	25013812103	2010	4.000	\N
90	25013812104	2010	7.000	\N
90	25013812201	2010	8.000	\N
90	25013812202	2010	7.000	\N
90	25013812300	2010	6.000	\N
90	25013812401	2010	7.000	\N
90	25013812403	2010	4.000	\N
90	25013812404	2010	2.000	\N
90	25013812500	2010	5.000	\N
90	25013812600	2010	13.000	\N
90	25013812701	2010	10.000	\N
90	25013812702	2010	18.000	\N
90	25013812800	2010	4.000	\N
90	25013812901	2010	4.000	\N
90	25013812902	2010	1.000	\N
90	25013812903	2010	1.000	\N
90	25013813000	2010	19.000	\N
90	25013813101	2010	14.000	\N
90	25013813102	2010	9.000	\N
90	25013813204	2010	5.000	\N
90	25013813205	2010	8.000	\N
90	25013813206	2010	3.000	\N
90	25013813207	2010	6.000	\N
90	25013813208	2010	1.000	\N
90	25013813209	2010	6.000	\N
90	25013813301	2010	3.000	\N
90	25013813303	2010	0.000	\N
90	25013813304	2010	1.000	\N
90	25013813401	2010	5.000	\N
90	25013813403	2010	4.000	\N
90	25013813404	2010	0.000	\N
90	25013813500	2010	3.000	\N
90	25013813601	2010	1.000	\N
90	25013813602	2010	3.000	\N
90	25013813701	2010	2.000	\N
90	25013813702	2010	16.000	\N
90	25013813801	2010	15.000	\N
90	25013813802	2010	10.000	\N
90	25015820101	2010	10.000	\N
90	25015820102	2010	15.000	\N
90	25015820202	2010	2.000	\N
90	25015820203	2010	13.000	\N
90	25015820204	2010	5.000	\N
90	25015820300	2010	10.000	\N
90	25015820400	2010	12.000	\N
90	25015820500	2010	7.000	\N
90	25015820600	2010	1.000	\N
90	25015820700	2010	2.000	\N
90	25015820801	2010	13.000	\N
90	25015820802	2010	2.000	\N
90	25015820900	2010	13.000	\N
90	25015821000	2010	5.000	\N
90	25015821100	2010	10.000	\N
90	25015821200	2010	1.000	\N
90	25015821300	2010	4.000	\N
90	25015821400	2010	8.000	\N
90	25015821500	2010	3.000	\N
90	25015821601	2010	6.000	\N
90	25015821602	2010	8.000	\N
90	25015821700	2010	10.000	\N
90	25015821901	2010	6.000	\N
90	25015821903	2010	10.000	\N
90	25015821904	2010	7.000	\N
90	25015822000	2010	2.000	\N
90	25015822200	2010	10.000	\N
90	25015822300	2010	8.000	\N
90	25015822401	2010	11.000	\N
90	25015822402	2010	12.000	\N
90	25015822500	2010	5.000	\N
90	25015822601	2010	5.000	\N
90	25015822603	2010	1.000	\N
90	25015822605	2010	1.000	\N
90	25015822606	2010	3.000	\N
90	25015822700	2010	1.000	\N
90	25017300100	2010	2.000	\N
90	25017301101	2010	7.000	\N
90	25017301102	2010	10.000	\N
90	25017310100	2010	9.000	\N
90	25017310200	2010	2.000	\N
90	25017310300	2010	8.000	\N
90	25017310400	2010	2.000	\N
90	25017310500	2010	10.000	\N
90	25017310601	2010	9.000	\N
90	25017310602	2010	4.000	\N
90	25017310700	2010	4.000	\N
90	25017311100	2010	11.000	\N
90	25017311200	2010	1.000	\N
90	25017311300	2010	1.000	\N
90	25017311400	2010	8.000	\N
90	25017311500	2010	1.000	\N
90	25017311600	2010	2.000	\N
90	25017311700	2010	2.000	\N
90	25017311800	2010	2.000	\N
90	25017311900	2010	9.000	\N
90	25017312000	2010	16.000	\N
90	25017312100	2010	4.000	\N
90	25017312200	2010	2.000	\N
90	25017312300	2010	5.000	\N
90	25017312400	2010	5.000	\N
90	25017312501	2010	8.000	\N
90	25017312502	2010	5.000	\N
90	25017313101	2010	6.000	\N
90	25017313102	2010	3.000	\N
90	25017314101	2010	11.000	\N
90	25017314102	2010	3.000	\N
90	25017314200	2010	7.000	\N
90	25017314301	2010	4.000	\N
90	25017314302	2010	7.000	\N
90	25017315100	2010	1.000	\N
90	25017315200	2010	5.000	\N
90	25017315401	2010	4.000	\N
90	25017315402	2010	8.000	\N
90	25017315403	2010	1.000	\N
90	25017315500	2010	8.000	\N
90	25017316101	2010	7.000	\N
90	25017316102	2010	5.000	\N
90	25017316201	2010	4.000	\N
90	25017316202	2010	5.000	\N
90	25017316300	2010	8.000	\N
90	25017316400	2010	13.000	\N
90	25017316500	2010	6.000	\N
90	25017317101	2010	7.000	\N
90	25017317102	2010	2.000	\N
90	25017317103	2010	2.000	\N
90	25017317201	2010	6.000	\N
90	25017317202	2010	0.000	\N
90	25017317203	2010	7.000	\N
90	25017317301	2010	2.000	\N
90	25017317302	2010	4.000	\N
90	25017318100	2010	6.000	\N
90	25017318200	2010	0.000	\N
90	25017318300	2010	5.000	\N
90	25017318400	2010	1.000	\N
90	25017320102	2010	2.000	\N
90	25017320103	2010	3.000	\N
90	25017320104	2010	3.000	\N
90	25017321100	2010	6.000	\N
90	25017321200	2010	10.000	\N
90	25017321300	2010	12.000	\N
90	25017321400	2010	5.000	\N
90	25017321500	2010	12.000	\N
90	25017321600	2010	7.000	\N
90	25017322100	2010	3.000	\N
90	25017322200	2010	1.000	\N
90	25017322300	2010	5.000	\N
90	25017322400	2010	4.000	\N
90	25017323100	2010	9.000	\N
90	25017324101	2010	1.000	\N
90	25017324102	2010	5.000	\N
90	25017325100	2010	15.000	\N
90	25017326101	2010	2.000	\N
90	25017326102	2010	5.000	\N
90	25017327101	2010	5.000	\N
90	25017327102	2010	7.000	\N
90	25017327103	2010	2.000	\N
90	25017328100	2010	3.000	\N
90	25017330100	2010	4.000	\N
90	25017330200	2010	12.000	\N
90	25017331101	2010	2.000	\N
90	25017331102	2010	9.000	\N
90	25017331200	2010	1.000	\N
90	25017331300	2010	3.000	\N
90	25017332100	2010	3.000	\N
90	25017332200	2010	18.000	\N
90	25017332300	2010	7.000	\N
90	25017332400	2010	4.000	\N
90	25017333100	2010	4.000	\N
90	25017333200	2010	7.000	\N
90	25017333300	2010	7.000	\N
90	25017333400	2010	5.000	\N
90	25017333501	2010	7.000	\N
90	25017333502	2010	4.000	\N
90	25017333600	2010	12.000	\N
90	25017334100	2010	4.000	\N
90	25017334200	2010	1.000	\N
90	25017334300	2010	1.000	\N
90	25017334400	2010	4.000	\N
90	25017335100	2010	7.000	\N
90	25017335200	2010	1.000	\N
90	25017335301	2010	6.000	\N
90	25017335302	2010	4.000	\N
90	25017335400	2010	4.000	\N
90	25017336100	2010	3.000	\N
90	25017336200	2010	3.000	\N
90	25017336300	2010	3.000	\N
90	25017336401	2010	1.000	\N
90	25017336402	2010	1.000	\N
90	25017337101	2010	8.000	\N
90	25017337102	2010	4.000	\N
90	25017337201	2010	2.000	\N
90	25017337202	2010	0.000	\N
90	25017337300	2010	4.000	\N
90	25017338100	2010	1.000	\N
90	25017338200	2010	2.000	\N
90	25017338300	2010	3.000	\N
90	25017338400	2010	3.000	\N
90	25017338500	2010	3.000	\N
90	25017339100	2010	13.000	\N
90	25017339200	2010	2.000	\N
90	25017339300	2010	5.000	\N
90	25017339400	2010	7.000	\N
90	25017339500	2010	8.000	\N
90	25017339600	2010	4.000	\N
90	25017339700	2010	3.000	\N
90	25017339801	2010	10.000	\N
90	25017339802	2010	13.000	\N
90	25017339900	2010	8.000	\N
90	25017340000	2010	3.000	\N
90	25017340100	2010	5.000	\N
90	25017341101	2010	0.000	\N
90	25017341102	2010	3.000	\N
90	25017341200	2010	5.000	\N
90	25017341300	2010	9.000	\N
90	25017341400	2010	11.000	\N
90	25017341500	2010	8.000	\N
90	25017341600	2010	12.000	\N
90	25017341700	2010	2.000	\N
90	25017341800	2010	10.000	\N
90	25017341901	2010	0.000	\N
90	25017341902	2010	16.000	\N
90	25017342101	2010	13.000	\N
90	25017342102	2010	16.000	\N
90	25017342201	2010	16.000	\N
90	25017342202	2010	3.000	\N
90	25017342300	2010	15.000	\N
90	25017342400	2010	10.000	\N
90	25017342500	2010	7.000	\N
90	25017342600	2010	4.000	\N
90	25017350103	2010	0.000	\N
90	25017350104	2010	7.000	\N
90	25017350200	2010	3.000	\N
90	25017350300	2010	4.000	\N
90	25017350400	2010	7.000	\N
90	25017350500	2010	1.000	\N
90	25017350600	2010	3.000	\N
90	25017350700	2010	4.000	\N
90	25017350800	2010	0.000	\N
90	25017350900	2010	5.000	\N
90	25017351000	2010	8.000	\N
90	25017351100	2010	4.000	\N
90	25017351203	2010	9.000	\N
90	25017351204	2010	4.000	\N
90	25017351300	2010	7.000	\N
90	25017351403	2010	8.000	\N
90	25017351404	2010	11.000	\N
90	25017351500	2010	5.000	\N
90	25017352101	2010	1.000	\N
90	25017352102	2010	0.000	\N
90	25017352200	2010	6.000	\N
90	25017352300	2010	4.000	\N
90	25017352400	2010	0.000	\N
90	25017352500	2010	7.000	\N
90	25017352600	2010	2.000	\N
90	25017352700	2010	2.000	\N
90	25017352800	2010	5.000	\N
90	25017352900	2010	2.000	\N
90	25017353000	2010	3.000	\N
90	25017353101	2010	6.000	\N
90	25017353102	2010	12.000	\N
90	25017353200	2010	5.000	\N
90	25017353300	2010	5.000	\N
90	25017353400	2010	10.000	\N
90	25017353500	2010	5.000	\N
90	25017353600	2010	6.000	\N
90	25017353700	2010	5.000	\N
90	25017353800	2010	1.000	\N
90	25017353900	2010	10.000	\N
90	25017354000	2010	8.000	\N
90	25017354100	2010	1.000	\N
90	25017354200	2010	4.000	\N
90	25017354300	2010	9.000	\N
90	25017354400	2010	10.000	\N
90	25017354500	2010	1.000	\N
90	25017354600	2010	9.000	\N
90	25017354700	2010	2.000	\N
90	25017354800	2010	0.000	\N
90	25017354900	2010	18.000	\N
90	25017355000	2010	0.000	\N
90	25017356100	2010	2.000	\N
90	25017356300	2010	3.000	\N
90	25017356400	2010	2.000	\N
90	25017356500	2010	3.000	\N
90	25017356601	2010	5.000	\N
90	25017356602	2010	3.000	\N
90	25017356701	2010	3.000	\N
90	25017356702	2010	8.000	\N
90	25017357100	2010	4.000	\N
90	25017357200	2010	2.000	\N
90	25017357300	2010	0.000	\N
90	25017357400	2010	0.000	\N
90	25017357500	2010	0.000	\N
90	25017357600	2010	2.000	\N
90	25017357700	2010	5.000	\N
90	25017357800	2010	5.000	\N
90	25017358100	2010	1.000	\N
90	25017358300	2010	3.000	\N
90	25017358400	2010	0.000	\N
90	25017358500	2010	7.000	\N
90	25017358600	2010	7.000	\N
90	25017358700	2010	3.000	\N
90	25017359100	2010	3.000	\N
90	25017359300	2010	14.000	\N
90	25017360100	2010	6.000	\N
90	25017360200	2010	4.000	\N
90	25017361100	2010	2.000	\N
90	25017361200	2010	1.000	\N
90	25017361300	2010	5.000	\N
90	25017362100	2010	1.000	\N
90	25017363102	2010	5.000	\N
90	25017363103	2010	0.000	\N
90	25017363104	2010	2.000	\N
90	25017363201	2010	2.000	\N
90	25017363202	2010	4.000	\N
90	25017364101	2010	9.000	\N
90	25017364102	2010	3.000	\N
90	25017365100	2010	2.000	\N
90	25017365201	2010	1.000	\N
90	25017365202	2010	3.000	\N
90	25017366100	2010	3.000	\N
90	25017366201	2010	1.000	\N
90	25017366202	2010	0.000	\N
90	25017367100	2010	3.000	\N
90	25017367200	2010	2.000	\N
90	25017368101	2010	10.000	\N
90	25017368102	2010	0.000	\N
90	25017368200	2010	5.000	\N
90	25017368300	2010	7.000	\N
90	25017368400	2010	9.000	\N
90	25017368500	2010	6.000	\N
90	25017368600	2010	5.000	\N
90	25017368700	2010	2.000	\N
90	25017368800	2010	6.000	\N
90	25017368901	2010	2.000	\N
90	25017368902	2010	4.000	\N
90	25017369000	2010	2.000	\N
90	25017369100	2010	8.000	\N
90	25017370101	2010	7.000	\N
90	25017370102	2010	7.000	\N
90	25017370201	2010	1.000	\N
90	25017370202	2010	5.000	\N
90	25017370300	2010	2.000	\N
90	25017370400	2010	3.000	\N
90	25017373100	2010	8.000	\N
90	25017373200	2010	2.000	\N
90	25017373300	2010	0.000	\N
90	25017373400	2010	2.000	\N
90	25017373500	2010	1.000	\N
90	25017373600	2010	1.000	\N
90	25017373700	2010	3.000	\N
90	25017373800	2010	2.000	\N
90	25017373900	2010	2.000	\N
90	25017374000	2010	6.000	\N
90	25017374100	2010	5.000	\N
90	25017374200	2010	1.000	\N
90	25017374300	2010	2.000	\N
90	25017374400	2010	2.000	\N
90	25017374500	2010	6.000	\N
90	25017374600	2010	6.000	\N
90	25017374700	2010	3.000	\N
90	25017374800	2010	4.000	\N
90	25017382100	2010	0.000	\N
90	25017382200	2010	9.000	\N
90	25017382300	2010	9.000	\N
90	25017382400	2010	3.000	\N
90	25017382500	2010	0.000	\N
90	25017382601	2010	5.000	\N
90	25017382602	2010	2.000	\N
90	25017383101	2010	13.000	\N
90	25017383102	2010	2.000	\N
90	25017383200	2010	18.000	\N
90	25017383300	2010	7.000	\N
90	25017383400	2010	14.000	\N
90	25017383501	2010	12.000	\N
90	25017383502	2010	3.000	\N
90	25017383600	2010	8.000	\N
90	25017383700	2010	3.000	\N
90	25017383800	2010	4.000	\N
90	25017383901	2010	8.000	\N
90	25017383902	2010	9.000	\N
90	25017384001	2010	0.000	\N
90	25017384002	2010	3.000	\N
90	25017385100	2010	3.000	\N
90	25017385201	2010	3.000	\N
90	25017385202	2010	10.000	\N
90	25017386100	2010	1.000	\N
90	25017387100	2010	2.000	\N
90	25017387201	2010	7.000	\N
90	25017387202	2010	3.000	\N
90	25017388100	2010	1.000	\N
90	25017388200	2010	12.000	\N
90	25017388300	2010	7.000	\N
90	25017980000	2010	0.000	\N
90	25019950100	2010	3.000	\N
90	25019950200	2010	3.000	\N
90	25019950307	2010	0.000	\N
90	25019950400	2010	0.000	\N
90	25019950500	2010	0.000	\N
90	25019990000	2010	0.000	\N
90	25021400100	2010	3.000	\N
90	25021400200	2010	6.000	\N
90	25021400300	2010	4.000	\N
90	25021400400	2010	4.000	\N
90	25021400500	2010	2.000	\N
90	25021400600	2010	5.000	\N
90	25021400700	2010	2.000	\N
90	25021400800	2010	6.000	\N
90	25021400900	2010	2.000	\N
90	25021401000	2010	2.000	\N
90	25021401100	2010	2.000	\N
90	25021401200	2010	4.000	\N
90	25021402101	2010	13.000	\N
90	25021402102	2010	16.000	\N
90	25021402200	2010	3.000	\N
90	25021402300	2010	1.000	\N
90	25021402400	2010	9.000	\N
90	25021402500	2010	4.000	\N
90	25021403100	2010	1.000	\N
90	25021403300	2010	3.000	\N
90	25021403400	2010	4.000	\N
90	25021403500	2010	1.000	\N
90	25021404100	2010	10.000	\N
90	25021404201	2010	0.000	\N
90	25021404202	2010	4.000	\N
90	25021404301	2010	1.000	\N
90	25021404302	2010	0.000	\N
90	25021404400	2010	7.000	\N
90	25021405100	2010	7.000	\N
90	25021406101	2010	3.000	\N
90	25021406102	2010	5.000	\N
90	25021407100	2010	21.000	\N
90	25021408101	2010	7.000	\N
90	25021408102	2010	13.000	\N
90	25021409101	2010	16.000	\N
90	25021409102	2010	5.000	\N
90	25021410100	2010	19.000	\N
90	25021410300	2010	0.000	\N
90	25021410400	2010	6.000	\N
90	25021411100	2010	15.000	\N
90	25021411200	2010	0.000	\N
90	25021411301	2010	3.000	\N
90	25021411302	2010	8.000	\N
90	25021412100	2010	0.000	\N
90	25021412200	2010	2.000	\N
90	25021412300	2010	1.000	\N
90	25021413100	2010	17.000	\N
90	25021413200	2010	10.000	\N
90	25021413300	2010	2.000	\N
90	25021413401	2010	1.000	\N
90	25021413402	2010	7.000	\N
90	25021413500	2010	4.000	\N
90	25021414100	2010	0.000	\N
90	25021414200	2010	8.000	\N
90	25021414300	2010	1.000	\N
90	25021415101	2010	1.000	\N
90	25021415102	2010	11.000	\N
90	25021415200	2010	5.000	\N
90	25021415300	2010	0.000	\N
90	25021416101	2010	0.000	\N
90	25021416102	2010	0.000	\N
90	25021416200	2010	11.000	\N
90	25021416300	2010	17.000	\N
90	25021416400	2010	2.000	\N
90	25021417100	2010	5.000	\N
90	25021417200	2010	1.000	\N
90	25021417300	2010	5.000	\N
90	25021417400	2010	8.000	\N
90	25021417501	2010	2.000	\N
90	25021417502	2010	6.000	\N
90	25021417601	2010	3.000	\N
90	25021417602	2010	11.000	\N
90	25021417701	2010	5.000	\N
90	25021417702	2010	4.000	\N
90	25021417801	2010	13.000	\N
90	25021417802	2010	10.000	\N
90	25021417901	2010	15.000	\N
90	25021417902	2010	2.000	\N
90	25021418002	2010	12.000	\N
90	25021418003	2010	1.000	\N
90	25021418004	2010	11.000	\N
90	25021418101	2010	12.000	\N
90	25021418102	2010	8.000	\N
90	25021418200	2010	3.000	\N
90	25021419100	2010	2.000	\N
90	25021419200	2010	11.000	\N
90	25021419300	2010	12.000	\N
90	25021419400	2010	1.000	\N
90	25021419500	2010	2.000	\N
90	25021419600	2010	9.000	\N
90	25021419700	2010	4.000	\N
90	25021419800	2010	5.000	\N
90	25021420100	2010	15.000	\N
90	25021420201	2010	2.000	\N
90	25021420202	2010	18.000	\N
90	25021420301	2010	11.000	\N
90	25021420302	2010	23.000	\N
90	25021421100	2010	19.000	\N
90	25021421200	2010	3.000	\N
90	25021422100	2010	0.000	\N
90	25021422200	2010	10.000	\N
90	25021422301	2010	4.000	\N
90	25021422302	2010	14.000	\N
90	25021422400	2010	11.000	\N
90	25021422501	2010	14.000	\N
90	25021422502	2010	21.000	\N
90	25021422600	2010	3.000	\N
90	25021422700	2010	6.000	\N
90	25021422800	2010	4.000	\N
90	25021423100	2010	8.000	\N
90	25021440100	2010	9.000	\N
90	25021441202	2010	6.000	\N
90	25021441203	2010	7.000	\N
90	25021441204	2010	3.000	\N
90	25021442101	2010	6.000	\N
90	25021442102	2010	2.000	\N
90	25021442103	2010	5.000	\N
90	25021442201	2010	0.000	\N
90	25021442202	2010	10.000	\N
90	25021443101	2010	5.000	\N
90	25021443102	2010	5.000	\N
90	25021456101	2010	5.000	\N
90	25021456102	2010	6.000	\N
90	25021456200	2010	5.000	\N
90	25021456301	2010	6.000	\N
90	25021456302	2010	9.000	\N
90	25021456401	2010	2.000	\N
90	25021456402	2010	2.000	\N
90	25021457100	2010	1.000	\N
90	25021457200	2010	1.000	\N
90	25023500101	2010	8.000	\N
90	25023500103	2010	5.000	\N
90	25023500104	2010	21.000	\N
90	25023501101	2010	3.000	\N
90	25023501102	2010	11.000	\N
90	25023501201	2010	10.000	\N
90	25023501202	2010	7.000	\N
90	25023502101	2010	9.000	\N
90	25023502102	2010	3.000	\N
90	25023502200	2010	10.000	\N
90	25023503101	2010	6.000	\N
90	25023503102	2010	7.000	\N
90	25023504101	2010	2.000	\N
90	25023504102	2010	6.000	\N
90	25023505101	2010	7.000	\N
90	25023505102	2010	3.000	\N
90	25023505200	2010	3.000	\N
90	25023506101	2010	9.000	\N
90	25023506102	2010	8.000	\N
90	25023506202	2010	3.000	\N
90	25023506203	2010	12.000	\N
90	25023506204	2010	3.000	\N
90	25023507101	2010	5.000	\N
90	25023507103	2010	4.000	\N
90	25023507104	2010	7.000	\N
90	25023508101	2010	7.000	\N
90	25023508102	2010	13.000	\N
90	25023508200	2010	4.000	\N
90	25023509101	2010	5.000	\N
90	25023509102	2010	7.000	\N
90	25023510100	2010	27.000	\N
90	25023510200	2010	22.000	\N
90	25023510300	2010	6.000	\N
90	25023510400	2010	14.000	\N
90	25023510501	2010	9.000	\N
90	25023510502	2010	14.000	\N
90	25023510503	2010	5.000	\N
90	25023510600	2010	2.000	\N
90	25023510700	2010	11.000	\N
90	25023510800	2010	16.000	\N
90	25023510900	2010	14.000	\N
90	25023511000	2010	16.000	\N
90	25023511100	2010	16.000	\N
90	25023511200	2010	8.000	\N
90	25023511301	2010	16.000	\N
90	25023511302	2010	9.000	\N
90	25023511400	2010	8.000	\N
90	25023511500	2010	10.000	\N
90	25023511600	2010	16.000	\N
90	25023511701	2010	4.000	\N
90	25023511702	2010	10.000	\N
90	25023520100	2010	24.000	\N
90	25023520201	2010	5.000	\N
90	25023520202	2010	12.000	\N
90	25023521101	2010	13.000	\N
90	25023521102	2010	5.000	\N
90	25023521201	2010	4.000	\N
90	25023521202	2010	10.000	\N
90	25023522101	2010	2.000	\N
90	25023522102	2010	0.000	\N
90	25023523100	2010	11.000	\N
90	25023523201	2010	5.000	\N
90	25023523202	2010	9.000	\N
90	25023524101	2010	0.000	\N
90	25023524102	2010	7.000	\N
90	25023525101	2010	11.000	\N
90	25023525104	2010	8.000	\N
90	25023525203	2010	5.000	\N
90	25023525204	2010	5.000	\N
90	25023525300	2010	23.000	\N
90	25023526100	2010	4.000	\N
90	25023530100	2010	18.000	\N
90	25023530200	2010	19.000	\N
90	25023530300	2010	7.000	\N
90	25023530400	2010	6.000	\N
90	25023530500	2010	21.000	\N
90	25023530600	2010	25.000	\N
90	25023530700	2010	9.000	\N
90	25023530801	2010	7.000	\N
90	25023530802	2010	15.000	\N
90	25023530901	2010	33.000	\N
90	25023530902	2010	15.000	\N
90	25023540101	2010	2.000	\N
90	25023540102	2010	3.000	\N
90	25023540103	2010	8.000	\N
90	25023541100	2010	4.000	\N
90	25023542101	2010	11.000	\N
90	25023542102	2010	7.000	\N
90	25023542200	2010	11.000	\N
90	25023542300	2010	19.000	\N
90	25023543100	2010	2.000	\N
90	25023544100	2010	13.000	\N
90	25023544200	2010	5.000	\N
90	25023545100	2010	22.000	\N
90	25023545200	2010	31.000	\N
90	25023545300	2010	38.000	\N
90	25023545400	2010	34.000	\N
90	25023560100	2010	7.000	\N
90	25023561100	2010	5.000	\N
90	25023561200	2010	3.000	\N
90	25023990003	2010	0.000	\N
90	25025000100	2010	3.000	\N
90	25025000201	2010	5.000	\N
90	25025000202	2010	12.000	\N
90	25025000301	2010	0.000	\N
90	25025000302	2010	2.000	\N
90	25025000401	2010	2.000	\N
90	25025000402	2010	0.000	\N
90	25025000502	2010	6.000	\N
90	25025000503	2010	2.000	\N
90	25025000504	2010	4.000	\N
90	25025000601	2010	2.000	\N
90	25025000602	2010	3.000	\N
90	25025000701	2010	4.000	\N
90	25025000703	2010	3.000	\N
90	25025000704	2010	3.000	\N
90	25025000802	2010	6.000	\N
90	25025000803	2010	8.000	\N
90	25025010103	2010	4.000	\N
90	25025010104	2010	8.000	\N
90	25025010203	2010	11.000	\N
90	25025010204	2010	3.000	\N
90	25025010300	2010	3.000	\N
90	25025010403	2010	10.000	\N
90	25025010404	2010	4.000	\N
90	25025010405	2010	10.000	\N
90	25025010408	2010	2.000	\N
90	25025010500	2010	4.000	\N
90	25025010600	2010	2.000	\N
90	25025010701	2010	2.000	\N
90	25025010702	2010	2.000	\N
90	25025010801	2010	3.000	\N
90	25025010802	2010	0.000	\N
90	25025020101	2010	1.000	\N
90	25025020200	2010	3.000	\N
90	25025020301	2010	2.000	\N
90	25025020302	2010	1.000	\N
90	25025020303	2010	6.000	\N
90	25025030100	2010	0.000	\N
90	25025030200	2010	6.000	\N
90	25025030300	2010	12.000	\N
90	25025030400	2010	5.000	\N
90	25025030500	2010	0.000	\N
90	25025040100	2010	2.000	\N
90	25025040200	2010	2.000	\N
90	25025040300	2010	1.000	\N
90	25025040401	2010	4.000	\N
90	25025040600	2010	0.000	\N
90	25025040801	2010	9.000	\N
90	25025050101	2010	11.000	\N
90	25025050200	2010	8.000	\N
90	25025050300	2010	4.000	\N
90	25025050400	2010	5.000	\N
90	25025050500	2010	0.000	\N
90	25025050600	2010	5.000	\N
90	25025050700	2010	5.000	\N
90	25025050901	2010	3.000	\N
90	25025051000	2010	7.000	\N
90	25025051101	2010	13.000	\N
90	25025051200	2010	4.000	\N
90	25025060101	2010	4.000	\N
90	25025060200	2010	0.000	\N
90	25025060301	2010	1.000	\N
90	25025060400	2010	5.000	\N
90	25025060501	2010	2.000	\N
90	25025060600	2010	7.000	\N
90	25025060700	2010	1.000	\N
90	25025060800	2010	6.000	\N
90	25025061000	2010	3.000	\N
90	25025061101	2010	7.000	\N
90	25025061200	2010	2.000	\N
90	25025070101	2010	3.000	\N
90	25025070200	2010	3.000	\N
90	25025070300	2010	4.000	\N
90	25025070402	2010	2.000	\N
90	25025070500	2010	4.000	\N
90	25025070600	2010	3.000	\N
90	25025070700	2010	7.000	\N
90	25025070800	2010	3.000	\N
90	25025070900	2010	9.000	\N
90	25025071101	2010	17.000	\N
90	25025071201	2010	7.000	\N
90	25025080100	2010	6.000	\N
90	25025080300	2010	11.000	\N
90	25025080401	2010	16.000	\N
90	25025080500	2010	2.000	\N
90	25025080601	2010	12.000	\N
90	25025080801	2010	19.000	\N
90	25025080900	2010	5.000	\N
90	25025081001	2010	19.000	\N
90	25025081100	2010	6.000	\N
90	25025081200	2010	3.000	\N
90	25025081300	2010	22.000	\N
90	25025081400	2010	18.000	\N
90	25025081500	2010	9.000	\N
90	25025081700	2010	18.000	\N
90	25025081800	2010	13.000	\N
90	25025081900	2010	16.000	\N
90	25025082000	2010	9.000	\N
90	25025082100	2010	21.000	\N
90	25025090100	2010	28.000	\N
90	25025090200	2010	5.000	\N
90	25025090300	2010	8.000	\N
90	25025090400	2010	18.000	\N
90	25025090600	2010	8.000	\N
90	25025090700	2010	10.000	\N
90	25025090901	2010	10.000	\N
90	25025091001	2010	0.000	\N
90	25025091100	2010	16.000	\N
90	25025091200	2010	5.000	\N
90	25025091300	2010	6.000	\N
90	25025091400	2010	6.000	\N
90	25025091500	2010	8.000	\N
90	25025091600	2010	9.000	\N
90	25025091700	2010	10.000	\N
90	25025091800	2010	14.000	\N
90	25025091900	2010	17.000	\N
90	25025092000	2010	11.000	\N
90	25025092101	2010	10.000	\N
90	25025092200	2010	15.000	\N
90	25025092300	2010	5.000	\N
90	25025092400	2010	32.000	\N
90	25025100100	2010	17.000	\N
90	25025100200	2010	4.000	\N
90	25025100300	2010	7.000	\N
90	25025100400	2010	19.000	\N
90	25025100500	2010	14.000	\N
90	25025100601	2010	8.000	\N
90	25025100603	2010	1.000	\N
90	25025100700	2010	5.000	\N
90	25025100800	2010	15.000	\N
90	25025100900	2010	0.000	\N
90	25025101001	2010	18.000	\N
90	25025101002	2010	19.000	\N
90	25025101101	2010	7.000	\N
90	25025101102	2010	15.000	\N
90	25025110103	2010	22.000	\N
90	25025110201	2010	13.000	\N
90	25025110301	2010	13.000	\N
90	25025110401	2010	5.000	\N
90	25025110403	2010	10.000	\N
90	25025110501	2010	1.000	\N
90	25025110502	2010	5.000	\N
90	25025110601	2010	7.000	\N
90	25025110607	2010	6.000	\N
90	25025120103	2010	1.000	\N
90	25025120104	2010	2.000	\N
90	25025120105	2010	2.000	\N
90	25025120201	2010	7.000	\N
90	25025120301	2010	9.000	\N
90	25025120400	2010	13.000	\N
90	25025120500	2010	6.000	\N
90	25025120600	2010	3.000	\N
90	25025120700	2010	3.000	\N
90	25025130100	2010	1.000	\N
90	25025130200	2010	7.000	\N
90	25025130300	2010	3.000	\N
90	25025130402	2010	2.000	\N
90	25025130404	2010	1.000	\N
90	25025130406	2010	8.000	\N
90	25025140102	2010	4.000	\N
90	25025140105	2010	3.000	\N
90	25025140106	2010	7.000	\N
90	25025140107	2010	12.000	\N
90	25025140201	2010	7.000	\N
90	25025140202	2010	10.000	\N
90	25025140300	2010	19.000	\N
90	25025140400	2010	30.000	\N
90	25025160101	2010	12.000	\N
90	25025160200	2010	3.000	\N
90	25025160300	2010	2.000	\N
90	25025160400	2010	2.000	\N
90	25025160501	2010	14.000	\N
90	25025160502	2010	9.000	\N
90	25025160601	2010	8.000	\N
90	25025160602	2010	5.000	\N
90	25025170100	2010	7.000	\N
90	25025170200	2010	7.000	\N
90	25025170300	2010	11.000	\N
90	25025170400	2010	5.000	\N
90	25025170501	2010	2.000	\N
90	25025170502	2010	9.000	\N
90	25025170601	2010	9.000	\N
90	25025170701	2010	4.000	\N
90	25025170702	2010	9.000	\N
90	25025170800	2010	3.000	\N
90	25025180101	2010	5.000	\N
90	25025180200	2010	6.000	\N
90	25025180301	2010	1.000	\N
90	25025180400	2010	1.000	\N
90	25025180500	2010	6.000	\N
90	25025980101	2010	2.000	\N
90	25025980300	2010	2.000	\N
90	25025980700	2010	0.000	\N
90	25025981000	2010	0.000	\N
90	25025981100	2010	0.000	\N
90	25025981201	2010	0.000	\N
90	25025981202	2010	0.000	\N
90	25025981300	2010	4.000	\N
90	25025981501	2010	0.000	\N
90	25025981502	2010	0.000	\N
90	25025981600	2010	0.000	\N
90	25025981700	2010	0.000	\N
90	25025981800	2010	0.000	\N
90	25025990101	2010	0.000	\N
90	25027700100	2010	6.000	\N
90	25027701100	2010	11.000	\N
90	25027702200	2010	3.000	\N
90	25027703100	2010	8.000	\N
90	25027703200	2010	4.000	\N
90	25027703300	2010	5.000	\N
90	25027704200	2010	1.000	\N
90	25027705100	2010	7.000	\N
90	25027706100	2010	1.000	\N
90	25027707100	2010	2.000	\N
90	25027707200	2010	0.000	\N
90	25027707300	2010	11.000	\N
90	25027707400	2010	8.000	\N
90	25027707500	2010	23.000	\N
90	25027708100	2010	11.000	\N
90	25027709100	2010	3.000	\N
90	25027709201	2010	11.000	\N
90	25027709202	2010	9.000	\N
90	25027709400	2010	10.000	\N
90	25027709501	2010	0.000	\N
90	25027709502	2010	9.000	\N
90	25027709600	2010	4.000	\N
90	25027709701	2010	2.000	\N
90	25027709702	2010	1.000	\N
90	25027710100	2010	22.000	\N
90	25027710200	2010	7.000	\N
90	25027710300	2010	8.000	\N
90	25027710400	2010	1.000	\N
90	25027710500	2010	10.000	\N
90	25027710600	2010	7.000	\N
90	25027710700	2010	0.000	\N
90	25027710800	2010	3.000	\N
90	25027711000	2010	8.000	\N
90	25027711100	2010	3.000	\N
90	25027712101	2010	8.000	\N
90	25027712102	2010	8.000	\N
90	25027713100	2010	5.000	\N
90	25027715100	2010	7.000	\N
90	25027716100	2010	9.000	\N
90	25027716200	2010	13.000	\N
90	25027716300	2010	3.000	\N
90	25027717100	2010	7.000	\N
90	25027718100	2010	9.000	\N
90	25027719100	2010	13.000	\N
90	25027720100	2010	1.000	\N
90	25027721101	2010	0.000	\N
90	25027721102	2010	6.000	\N
90	25027722100	2010	12.000	\N
90	25027723100	2010	12.000	\N
90	25027724100	2010	1.000	\N
90	25027725100	2010	14.000	\N
90	25027726100	2010	8.000	\N
90	25027726200	2010	12.000	\N
90	25027727100	2010	3.000	\N
90	25027728100	2010	4.000	\N
90	25027728200	2010	1.000	\N
90	25027728300	2010	4.000	\N
90	25027728400	2010	0.000	\N
90	25027729100	2010	17.000	\N
90	25027729200	2010	0.000	\N
90	25027730100	2010	13.000	\N
90	25027730200	2010	8.000	\N
90	25027730300	2010	15.000	\N
90	25027730401	2010	11.000	\N
90	25027730402	2010	3.000	\N
90	25027730500	2010	7.000	\N
90	25027730600	2010	5.000	\N
90	25027730700	2010	4.000	\N
90	25027730801	2010	1.000	\N
90	25027730802	2010	0.000	\N
90	25027730901	2010	7.000	\N
90	25027730902	2010	7.000	\N
90	25027731001	2010	6.000	\N
90	25027731002	2010	18.000	\N
90	25027731101	2010	5.000	\N
90	25027731102	2010	3.000	\N
90	25027731202	2010	0.000	\N
90	25027731203	2010	19.000	\N
90	25027731204	2010	7.000	\N
90	25027731300	2010	7.000	\N
90	25027731400	2010	27.000	\N
90	25027731500	2010	42.000	\N
90	25027731600	2010	20.000	\N
90	25027731700	2010	8.000	\N
90	25027731800	2010	10.000	\N
90	25027731900	2010	39.000	\N
90	25027732001	2010	10.000	\N
90	25027732002	2010	4.000	\N
90	25027732201	2010	2.000	\N
90	25027732202	2010	7.000	\N
90	25027732203	2010	5.000	\N
90	25027732301	2010	4.000	\N
90	25027732302	2010	1.000	\N
90	25027732400	2010	17.000	\N
90	25027732500	2010	10.000	\N
90	25027732600	2010	24.000	\N
90	25027732700	2010	5.000	\N
90	25027732801	2010	7.000	\N
90	25027732802	2010	1.000	\N
90	25027732901	2010	19.000	\N
90	25027732902	2010	3.000	\N
90	25027733000	2010	7.000	\N
90	25027733101	2010	5.000	\N
90	25027733102	2010	4.000	\N
90	25027735100	2010	18.000	\N
90	25027735200	2010	13.000	\N
90	25027736100	2010	0.000	\N
90	25027736200	2010	7.000	\N
90	25027736300	2010	8.000	\N
90	25027736400	2010	5.000	\N
90	25027736500	2010	1.000	\N
90	25027737100	2010	4.000	\N
90	25027737200	2010	4.000	\N
90	25027737300	2010	12.000	\N
90	25027738100	2010	6.000	\N
90	25027738201	2010	1.000	\N
90	25027738202	2010	3.000	\N
90	25027739100	2010	14.000	\N
90	25027739200	2010	3.000	\N
90	25027739300	2010	5.000	\N
90	25027739400	2010	2.000	\N
90	25027739500	2010	3.000	\N
90	25027740101	2010	5.000	\N
90	25027740102	2010	3.000	\N
90	25027740200	2010	2.000	\N
90	25027741101	2010	11.000	\N
90	25027741102	2010	2.000	\N
90	25027742300	2010	5.000	\N
90	25027742401	2010	3.000	\N
90	25027742402	2010	7.000	\N
90	25027743100	2010	4.000	\N
90	25027744101	2010	4.000	\N
90	25027744102	2010	6.000	\N
90	25027744200	2010	12.000	\N
90	25027744300	2010	9.000	\N
90	25027744400	2010	2.000	\N
90	25027745100	2010	4.000	\N
90	25027746100	2010	2.000	\N
90	25027747101	2010	13.000	\N
90	25027747102	2010	8.000	\N
90	25027748100	2010	7.000	\N
90	25027749100	2010	1.000	\N
90	25027749200	2010	6.000	\N
90	25027750100	2010	10.000	\N
90	25027750200	2010	7.000	\N
90	25027750300	2010	5.000	\N
90	25027751101	2010	1.000	\N
90	25027751102	2010	2.000	\N
90	25027752100	2010	14.000	\N
90	25027753100	2010	8.000	\N
90	25027753200	2010	8.000	\N
90	25027754100	2010	9.000	\N
90	25027754200	2010	21.000	\N
90	25027754300	2010	6.000	\N
90	25027754400	2010	10.000	\N
90	25027755100	2010	5.000	\N
90	25027755200	2010	8.000	\N
90	25027756101	2010	4.000	\N
90	25027756102	2010	16.000	\N
90	25027757100	2010	27.000	\N
90	25027757200	2010	1.000	\N
90	25027757300	2010	15.000	\N
90	25027757400	2010	7.000	\N
90	25027757500	2010	8.000	\N
90	25027758101	2010	0.000	\N
90	25027758102	2010	23.000	\N
90	25027759100	2010	5.000	\N
90	25027760100	2010	3.000	\N
90	25027761100	2010	10.000	\N
90	25027761200	2010	11.000	\N
90	25027761300	2010	5.000	\N
90	25027761400	2010	1.000	\N
91	25001010100	2010	18.000	\N
91	25001010206	2010	13.000	\N
91	25001010208	2010	10.000	\N
91	25001010304	2010	16.000	\N
91	25001010306	2010	12.000	\N
91	25001010400	2010	26.000	\N
91	25001010500	2010	18.000	\N
91	25001010600	2010	15.000	\N
91	25001010700	2010	21.000	\N
91	25001010800	2010	44.000	\N
91	25001010900	2010	42.000	\N
91	25001011002	2010	14.000	\N
91	25001011100	2010	45.000	\N
91	25001011200	2010	21.000	\N
91	25001011300	2010	8.000	\N
91	25001011400	2010	9.000	\N
91	25001011500	2010	29.000	\N
91	25001011600	2010	11.000	\N
91	25001011700	2010	24.000	\N
91	25001011801	2010	17.000	\N
91	25001011802	2010	39.000	\N
91	25001012001	2010	54.000	\N
91	25001012002	2010	73.000	\N
91	25001012101	2010	42.000	\N
91	25001012102	2010	33.000	\N
91	25001012200	2010	54.000	\N
91	25001012502	2010	48.000	\N
91	25001012601	2010	78.000	\N
91	25001012602	2010	76.000	\N
91	25001012700	2010	53.000	\N
91	25001012800	2010	36.000	\N
91	25001012900	2010	45.000	\N
91	25001013002	2010	19.000	\N
91	25001013100	2010	49.000	\N
91	25001013200	2010	25.000	\N
91	25001013300	2010	42.000	\N
91	25001013400	2010	28.000	\N
91	25001013500	2010	99.000	\N
91	25001013600	2010	75.000	\N
91	25001013700	2010	45.000	\N
91	25001013800	2010	78.000	\N
91	25001013900	2010	64.000	\N
91	25001014002	2010	34.000	\N
91	25001014100	2010	11.000	\N
91	25001014300	2010	41.000	\N
91	25001014402	2010	82.000	\N
91	25001014500	2010	38.000	\N
91	25001014600	2010	57.000	\N
91	25001014700	2010	51.000	\N
91	25001014800	2010	59.000	\N
91	25001014900	2010	77.000	\N
91	25001015001	2010	42.000	\N
91	25001015002	2010	59.000	\N
91	25001015100	2010	52.000	\N
91	25001015200	2010	15.000	\N
91	25001015300	2010	77.000	\N
91	25001990000	2010	0.000	\N
91	25003900100	2010	68.000	\N
91	25003900200	2010	69.000	\N
91	25003900300	2010	40.000	\N
91	25003900400	2010	31.000	\N
91	25003900500	2010	45.000	\N
91	25003900600	2010	52.000	\N
91	25003900700	2010	14.000	\N
91	25003900800	2010	63.000	\N
91	25003900900	2010	42.000	\N
91	25003901100	2010	74.000	\N
91	25003911100	2010	20.000	\N
91	25003912100	2010	53.000	\N
91	25003913100	2010	69.000	\N
91	25003914100	2010	100.000	\N
91	25003920101	2010	241.000	\N
91	25003920102	2010	157.000	\N
91	25003921300	2010	40.000	\N
91	25003921400	2010	3.000	\N
91	25003921500	2010	29.000	\N
91	25003922100	2010	18.000	\N
91	25003922200	2010	14.000	\N
91	25003922300	2010	8.000	\N
91	25003923100	2010	12.000	\N
91	25003924100	2010	19.000	\N
91	25003925100	2010	124.000	\N
91	25003926100	2010	11.000	\N
91	25003931100	2010	2.000	\N
91	25003931300	2010	7.000	\N
91	25003931400	2010	8.000	\N
91	25003932200	2010	8.000	\N
91	25003932300	2010	7.000	\N
91	25003933200	2010	4.000	\N
91	25003933300	2010	12.000	\N
91	25003933400	2010	16.000	\N
91	25003934200	2010	18.000	\N
91	25003934300	2010	10.000	\N
91	25003935100	2010	17.000	\N
91	25003935200	2010	52.000	\N
91	25003935300	2010	25.000	\N
91	25005600100	2010	63.000	\N
91	25005600202	2010	143.000	\N
91	25005600203	2010	138.000	\N
91	25005600204	2010	142.000	\N
91	25005610100	2010	173.000	\N
91	25005610202	2010	158.000	\N
91	25005610203	2010	152.000	\N
91	25005610204	2010	308.000	\N
91	25005611101	2010	60.000	\N
91	25005611102	2010	132.000	\N
91	25005611201	2010	40.000	\N
91	25005611202	2010	106.000	\N
91	25005612100	2010	80.000	\N
91	25005612200	2010	129.000	\N
91	25005613100	2010	74.000	\N
91	25005613300	2010	38.000	\N
91	25005613400	2010	44.000	\N
91	25005613600	2010	9.000	\N
91	25005613700	2010	38.000	\N
91	25005613800	2010	49.000	\N
91	25005613901	2010	9.000	\N
91	25005613902	2010	29.000	\N
91	25005614000	2010	54.000	\N
91	25005614101	2010	119.000	\N
91	25005614102	2010	83.000	\N
91	25005615100	2010	45.000	\N
91	25005616100	2010	27.000	\N
91	25005617101	2010	29.000	\N
91	25005617102	2010	26.000	\N
91	25005630101	2010	85.000	\N
91	25005630102	2010	97.000	\N
91	25005630200	2010	247.000	\N
91	25005630300	2010	335.000	\N
91	25005630400	2010	237.000	\N
91	25005631100	2010	310.000	\N
91	25005631200	2010	317.000	\N
91	25005631300	2010	180.000	\N
91	25005631400	2010	182.000	\N
91	25005631500	2010	58.000	\N
91	25005631600	2010	347.000	\N
91	25005631700	2010	213.000	\N
91	25005631800	2010	366.000	\N
91	25005632100	2010	54.000	\N
91	25005632200	2010	112.000	\N
91	25005633100	2010	64.000	\N
91	25005633200	2010	51.000	\N
91	25005640100	2010	198.000	\N
91	25005640200	2010	108.000	\N
91	25005640300	2010	130.000	\N
91	25005640400	2010	24.000	\N
91	25005640500	2010	67.000	\N
91	25005640600	2010	144.000	\N
91	25005640700	2010	103.000	\N
91	25005640800	2010	198.000	\N
91	25005640901	2010	61.000	\N
91	25005641000	2010	25.000	\N
91	25005641101	2010	36.000	\N
91	25005641200	2010	112.000	\N
91	25005641300	2010	259.000	\N
91	25005641400	2010	151.000	\N
91	25005641500	2010	24.000	\N
91	25005641600	2010	14.000	\N
91	25005641700	2010	128.000	\N
91	25005641800	2010	24.000	\N
91	25005641900	2010	25.000	\N
91	25005642000	2010	128.000	\N
91	25005642100	2010	82.000	\N
91	25005642200	2010	61.000	\N
91	25005642300	2010	45.000	\N
91	25005642400	2010	57.000	\N
91	25005642500	2010	45.000	\N
91	25005644101	2010	55.000	\N
91	25005644102	2010	33.000	\N
91	25005644200	2010	60.000	\N
91	25005645101	2010	20.000	\N
91	25005645102	2010	50.000	\N
91	25005645103	2010	39.000	\N
91	25005646101	2010	52.000	\N
91	25005646103	2010	27.000	\N
91	25005646104	2010	24.000	\N
91	25005650101	2010	26.000	\N
91	25005650102	2010	71.000	\N
91	25005650201	2010	46.000	\N
91	25005650202	2010	10.000	\N
91	25005650300	2010	29.000	\N
91	25005650400	2010	14.000	\N
91	25005650500	2010	40.000	\N
91	25005650600	2010	25.000	\N
91	25005650700	2010	18.000	\N
91	25005650800	2010	30.000	\N
91	25005650900	2010	44.000	\N
91	25005651001	2010	77.000	\N
91	25005651002	2010	63.000	\N
91	25005651100	2010	25.000	\N
91	25005651200	2010	16.000	\N
91	25005651300	2010	36.000	\N
91	25005651400	2010	15.000	\N
91	25005651500	2010	41.000	\N
91	25005651600	2010	50.000	\N
91	25005651700	2010	14.000	\N
91	25005651800	2010	31.000	\N
91	25005651900	2010	16.000	\N
91	25005652000	2010	9.000	\N
91	25005652100	2010	21.000	\N
91	25005652200	2010	19.000	\N
91	25005652300	2010	9.000	\N
91	25005652400	2010	26.000	\N
91	25005652500	2010	27.000	\N
91	25005652600	2010	4.000	\N
91	25005652700	2010	15.000	\N
91	25005652800	2010	12.000	\N
91	25005653101	2010	194.000	\N
91	25005653102	2010	79.000	\N
91	25005653203	2010	73.000	\N
91	25005653204	2010	114.000	\N
91	25005653301	2010	58.000	\N
91	25005653304	2010	23.000	\N
91	25005654100	2010	25.000	\N
91	25005654200	2010	6.000	\N
91	25005655100	2010	42.000	\N
91	25005655200	2010	46.000	\N
91	25005655300	2010	27.000	\N
91	25005655400	2010	37.000	\N
91	25005985500	2010	101.000	\N
91	25005985600	2010	75.000	\N
91	25005990000	2010	0.000	\N
91	25007200100	2010	30.000	\N
91	25007200200	2010	52.000	\N
91	25007200300	2010	19.000	\N
91	25007200400	2010	22.000	\N
91	25007990000	2010	0.000	\N
91	25009201100	2010	58.000	\N
91	25009202101	2010	24.000	\N
91	25009202102	2010	129.000	\N
91	25009202200	2010	111.000	\N
91	25009203100	2010	93.000	\N
91	25009203200	2010	38.000	\N
91	25009203301	2010	33.000	\N
91	25009203302	2010	34.000	\N
91	25009204101	2010	116.000	\N
91	25009204102	2010	129.000	\N
91	25009204200	2010	81.000	\N
91	25009204300	2010	52.000	\N
91	25009204400	2010	29.000	\N
91	25009204500	2010	83.000	\N
91	25009204600	2010	77.000	\N
91	25009204701	2010	189.000	\N
91	25009204702	2010	327.000	\N
91	25009205100	2010	179.000	\N
91	25009205200	2010	302.000	\N
91	25009205300	2010	101.000	\N
91	25009205400	2010	107.000	\N
91	25009205500	2010	313.000	\N
91	25009205600	2010	167.000	\N
91	25009205700	2010	303.000	\N
91	25009205800	2010	449.000	\N
91	25009205900	2010	308.000	\N
91	25009206000	2010	281.000	\N
91	25009206100	2010	490.000	\N
91	25009206200	2010	499.000	\N
91	25009206300	2010	323.000	\N
91	25009206400	2010	276.000	\N
91	25009206500	2010	232.000	\N
91	25009206600	2010	285.000	\N
91	25009206700	2010	108.000	\N
91	25009206800	2010	195.000	\N
91	25009206900	2010	107.000	\N
91	25009207000	2010	116.000	\N
91	25009207100	2010	675.000	\N
91	25009207200	2010	394.000	\N
91	25009208101	2010	119.000	\N
91	25009208102	2010	128.000	\N
91	25009208200	2010	85.000	\N
91	25009208300	2010	165.000	\N
91	25009208400	2010	211.000	\N
91	25009209100	2010	241.000	\N
91	25009209200	2010	138.000	\N
91	25009210100	2010	133.000	\N
91	25009210200	2010	83.000	\N
91	25009210300	2010	260.000	\N
91	25009210400	2010	162.000	\N
91	25009210500	2010	95.000	\N
91	25009210600	2010	34.000	\N
91	25009210700	2010	83.000	\N
91	25009210800	2010	67.000	\N
91	25009210900	2010	23.000	\N
91	25009211100	2010	49.000	\N
91	25009211200	2010	82.000	\N
91	25009211300	2010	168.000	\N
91	25009211401	2010	112.000	\N
91	25009211402	2010	87.000	\N
91	25009212100	2010	202.000	\N
91	25009213100	2010	123.000	\N
91	25009214100	2010	75.000	\N
91	25009215101	2010	375.000	\N
91	25009215102	2010	45.000	\N
91	25009216100	2010	82.000	\N
91	25009217100	2010	161.000	\N
91	25009217201	2010	71.000	\N
91	25009217202	2010	48.000	\N
91	25009217300	2010	101.000	\N
91	25009217400	2010	118.000	\N
91	25009217500	2010	59.000	\N
91	25009217600	2010	119.000	\N
91	25009218100	2010	41.000	\N
91	25009220101	2010	35.000	\N
91	25009220102	2010	21.000	\N
91	25009221100	2010	19.000	\N
91	25009221300	2010	54.000	\N
91	25009221400	2010	26.000	\N
91	25009221500	2010	30.000	\N
91	25009221600	2010	10.000	\N
91	25009221700	2010	33.000	\N
91	25009221800	2010	18.000	\N
91	25009221901	2010	32.000	\N
91	25009221902	2010	34.000	\N
91	25009222100	2010	34.000	\N
91	25009223100	2010	36.000	\N
91	25009223200	2010	52.000	\N
91	25009223300	2010	86.000	\N
91	25009250100	2010	28.000	\N
91	25009250200	2010	80.000	\N
91	25009250300	2010	30.000	\N
91	25009250400	2010	13.000	\N
91	25009250500	2010	9.000	\N
91	25009250600	2010	28.000	\N
91	25009250700	2010	42.000	\N
91	25009250800	2010	110.000	\N
91	25009250900	2010	5.000	\N
91	25009251000	2010	12.000	\N
91	25009251100	2010	14.000	\N
91	25009251200	2010	5.000	\N
91	25009251300	2010	44.000	\N
91	25009251400	2010	112.000	\N
91	25009251500	2010	293.000	\N
91	25009251600	2010	271.000	\N
91	25009251700	2010	349.000	\N
91	25009251800	2010	311.000	\N
91	25009252101	2010	111.000	\N
91	25009252102	2010	110.000	\N
91	25009252201	2010	80.000	\N
91	25009252202	2010	82.000	\N
91	25009252300	2010	212.000	\N
91	25009252400	2010	121.000	\N
91	25009252501	2010	136.000	\N
91	25009252502	2010	157.000	\N
91	25009252601	2010	356.000	\N
91	25009252602	2010	182.000	\N
91	25009252603	2010	194.000	\N
91	25009253100	2010	163.000	\N
91	25009253201	2010	154.000	\N
91	25009253202	2010	525.000	\N
91	25009253203	2010	168.000	\N
91	25009253204	2010	611.000	\N
91	25009253205	2010	162.000	\N
91	25009254100	2010	533.000	\N
91	25009254200	2010	219.000	\N
91	25009254301	2010	332.000	\N
91	25009254302	2010	455.000	\N
91	25009254401	2010	361.000	\N
91	25009254402	2010	1157.000	\N
91	25009254403	2010	358.000	\N
91	25009260100	2010	74.000	\N
91	25009260200	2010	15.000	\N
91	25009260301	2010	64.000	\N
91	25009260302	2010	38.000	\N
91	25009260401	2010	79.000	\N
91	25009260402	2010	138.000	\N
91	25009260500	2010	40.000	\N
91	25009260600	2010	76.000	\N
91	25009260700	2010	91.000	\N
91	25009260800	2010	38.000	\N
91	25009260900	2010	98.000	\N
91	25009261000	2010	39.000	\N
91	25009261101	2010	65.000	\N
91	25009261102	2010	116.000	\N
91	25009262100	2010	41.000	\N
91	25009263100	2010	44.000	\N
91	25009264100	2010	59.000	\N
91	25009265101	2010	35.000	\N
91	25009265102	2010	41.000	\N
91	25009266100	2010	12.000	\N
91	25009266200	2010	49.000	\N
91	25009266300	2010	27.000	\N
91	25009266400	2010	18.000	\N
91	25009267101	2010	28.000	\N
91	25009267102	2010	69.000	\N
91	25009268100	2010	31.000	\N
91	25009268200	2010	82.000	\N
91	25009268300	2010	45.000	\N
91	25009268400	2010	36.000	\N
91	25009269100	2010	43.000	\N
91	25009270100	2010	60.000	\N
91	25009990100	2010	0.000	\N
91	25011040100	2010	31.000	\N
91	25011040200	2010	37.000	\N
91	25011040300	2010	8.000	\N
91	25011040400	2010	17.000	\N
91	25011040501	2010	15.000	\N
91	25011040502	2010	59.000	\N
91	25011040600	2010	69.000	\N
91	25011040701	2010	29.000	\N
91	25011040702	2010	38.000	\N
91	25011040800	2010	196.000	\N
91	25011040900	2010	96.000	\N
91	25011041000	2010	28.000	\N
91	25011041100	2010	36.000	\N
91	25011041200	2010	37.000	\N
91	25011041300	2010	89.000	\N
91	25011041400	2010	46.000	\N
91	25011041501	2010	20.000	\N
91	25011041502	2010	36.000	\N
91	25013800101	2010	65.000	\N
91	25013800102	2010	56.000	\N
91	25013800201	2010	113.000	\N
91	25013800202	2010	23.000	\N
91	25013800300	2010	50.000	\N
91	25013800400	2010	84.000	\N
91	25013800500	2010	56.000	\N
91	25013800600	2010	9.000	\N
91	25013800700	2010	17.000	\N
91	25013800800	2010	4.000	\N
91	25013800900	2010	39.000	\N
91	25013801101	2010	43.000	\N
91	25013801102	2010	31.000	\N
91	25013801200	2010	17.000	\N
91	25013801300	2010	19.000	\N
91	25013801401	2010	16.000	\N
91	25013801402	2010	87.000	\N
91	25013801501	2010	67.000	\N
91	25013801502	2010	33.000	\N
91	25013801503	2010	90.000	\N
91	25013801601	2010	115.000	\N
91	25013801602	2010	72.000	\N
91	25013801603	2010	124.000	\N
91	25013801604	2010	81.000	\N
91	25013801605	2010	126.000	\N
91	25013801700	2010	65.000	\N
91	25013801800	2010	9.000	\N
91	25013801901	2010	52.000	\N
91	25013801902	2010	51.000	\N
91	25013802000	2010	34.000	\N
91	25013802100	2010	169.000	\N
91	25013802200	2010	275.000	\N
91	25013802300	2010	578.000	\N
91	25013802400	2010	147.000	\N
91	25013802500	2010	276.000	\N
91	25013802601	2010	458.000	\N
91	25013802602	2010	64.000	\N
91	25013810100	2010	71.000	\N
91	25013810200	2010	9.000	\N
91	25013810300	2010	27.000	\N
91	25013810403	2010	33.000	\N
91	25013810404	2010	34.000	\N
91	25013810412	2010	52.000	\N
91	25013810414	2010	51.000	\N
91	25013810601	2010	90.000	\N
91	25013810602	2010	36.000	\N
91	25013810700	2010	71.000	\N
91	25013810800	2010	24.000	\N
91	25013810901	2010	18.000	\N
91	25013810902	2010	34.000	\N
91	25013811000	2010	53.000	\N
91	25013811101	2010	67.000	\N
91	25013811102	2010	68.000	\N
91	25013811200	2010	84.000	\N
91	25013811301	2010	96.000	\N
91	25013811302	2010	81.000	\N
91	25013811400	2010	1.000	\N
91	25013811500	2010	1.000	\N
91	25013811600	2010	20.000	\N
91	25013811700	2010	22.000	\N
91	25013811800	2010	28.000	\N
91	25013811900	2010	59.000	\N
91	25013812001	2010	41.000	\N
91	25013812002	2010	43.000	\N
91	25013812101	2010	38.000	\N
91	25013812103	2010	68.000	\N
91	25013812104	2010	81.000	\N
91	25013812201	2010	260.000	\N
91	25013812202	2010	183.000	\N
91	25013812300	2010	398.000	\N
91	25013812401	2010	120.000	\N
91	25013812403	2010	123.000	\N
91	25013812404	2010	161.000	\N
91	25013812500	2010	100.000	\N
91	25013812600	2010	107.000	\N
91	25013812701	2010	63.000	\N
91	25013812702	2010	128.000	\N
91	25013812800	2010	42.000	\N
91	25013812901	2010	21.000	\N
91	25013812902	2010	43.000	\N
91	25013812903	2010	22.000	\N
91	25013813000	2010	20.000	\N
91	25013813101	2010	46.000	\N
91	25013813102	2010	31.000	\N
91	25013813204	2010	34.000	\N
91	25013813205	2010	103.000	\N
91	25013813206	2010	57.000	\N
91	25013813207	2010	129.000	\N
91	25013813208	2010	66.000	\N
91	25013813209	2010	107.000	\N
91	25013813301	2010	230.000	\N
91	25013813303	2010	259.000	\N
91	25013813304	2010	254.000	\N
91	25013813401	2010	150.000	\N
91	25013813403	2010	65.000	\N
91	25013813404	2010	161.000	\N
91	25013813500	2010	70.000	\N
91	25013813601	2010	177.000	\N
91	25013813602	2010	108.000	\N
91	25013813701	2010	23.000	\N
91	25013813702	2010	29.000	\N
91	25013813801	2010	14.000	\N
91	25013813802	2010	17.000	\N
91	25015820101	2010	43.000	\N
91	25015820102	2010	25.000	\N
91	25015820202	2010	23.000	\N
91	25015820203	2010	197.000	\N
91	25015820204	2010	107.000	\N
91	25015820300	2010	935.000	\N
91	25015820400	2010	1350.000	\N
91	25015820500	2010	396.000	\N
91	25015820600	2010	217.000	\N
91	25015820700	2010	585.000	\N
91	25015820801	2010	565.000	\N
91	25015820802	2010	61.000	\N
91	25015820900	2010	68.000	\N
91	25015821000	2010	54.000	\N
91	25015821100	2010	117.000	\N
91	25015821200	2010	403.000	\N
91	25015821300	2010	127.000	\N
91	25015821400	2010	210.000	\N
91	25015821500	2010	16.000	\N
91	25015821601	2010	217.000	\N
91	25015821602	2010	65.000	\N
91	25015821700	2010	66.000	\N
91	25015821901	2010	140.000	\N
91	25015821903	2010	94.000	\N
91	25015821904	2010	79.000	\N
91	25015822000	2010	290.000	\N
91	25015822200	2010	197.000	\N
91	25015822300	2010	125.000	\N
91	25015822401	2010	108.000	\N
91	25015822402	2010	145.000	\N
91	25015822500	2010	32.000	\N
91	25015822601	2010	3.000	\N
91	25015822603	2010	8.000	\N
91	25015822605	2010	5.000	\N
91	25015822606	2010	23.000	\N
91	25015822700	2010	27.000	\N
91	25017300100	2010	10.000	\N
91	25017301101	2010	48.000	\N
91	25017301102	2010	26.000	\N
91	25017310100	2010	290.000	\N
91	25017310200	2010	451.000	\N
91	25017310300	2010	498.000	\N
91	25017310400	2010	414.000	\N
91	25017310500	2010	483.000	\N
91	25017310601	2010	868.000	\N
91	25017310602	2010	687.000	\N
91	25017310700	2010	1166.000	\N
91	25017311100	2010	822.000	\N
91	25017311200	2010	1801.000	\N
91	25017311300	2010	1547.000	\N
91	25017311400	2010	1539.000	\N
91	25017311500	2010	972.000	\N
91	25017311600	2010	1371.000	\N
91	25017311700	2010	2374.000	\N
91	25017311800	2010	1848.000	\N
91	25017311900	2010	309.000	\N
91	25017312000	2010	450.000	\N
91	25017312100	2010	651.000	\N
91	25017312200	2010	911.000	\N
91	25017312300	2010	433.000	\N
91	25017312400	2010	175.000	\N
91	25017312501	2010	292.000	\N
91	25017312502	2010	170.000	\N
91	25017313101	2010	316.000	\N
91	25017313102	2010	215.000	\N
91	25017314101	2010	245.000	\N
91	25017314102	2010	363.000	\N
91	25017314200	2010	158.000	\N
91	25017314301	2010	346.000	\N
91	25017314302	2010	64.000	\N
91	25017315100	2010	178.000	\N
91	25017315200	2010	298.000	\N
91	25017315401	2010	112.000	\N
91	25017315402	2010	62.000	\N
91	25017315403	2010	16.000	\N
91	25017315500	2010	119.000	\N
91	25017316101	2010	94.000	\N
91	25017316102	2010	165.000	\N
91	25017316201	2010	192.000	\N
91	25017316202	2010	384.000	\N
91	25017316300	2010	761.000	\N
91	25017316400	2010	306.000	\N
91	25017316500	2010	284.000	\N
91	25017317101	2010	610.000	\N
91	25017317102	2010	471.000	\N
91	25017317103	2010	283.000	\N
91	25017317201	2010	109.000	\N
91	25017317202	2010	182.000	\N
91	25017317203	2010	332.000	\N
91	25017317301	2010	391.000	\N
91	25017317302	2010	459.000	\N
91	25017318100	2010	1124.000	\N
91	25017318200	2010	382.000	\N
91	25017318300	2010	826.000	\N
91	25017318400	2010	429.000	\N
91	25017320102	2010	224.000	\N
91	25017320103	2010	213.000	\N
91	25017320104	2010	217.000	\N
91	25017321100	2010	436.000	\N
91	25017321200	2010	267.000	\N
91	25017321300	2010	175.000	\N
91	25017321400	2010	186.000	\N
91	25017321500	2010	206.000	\N
91	25017321600	2010	657.000	\N
91	25017322100	2010	115.000	\N
91	25017322200	2010	80.000	\N
91	25017322300	2010	160.000	\N
91	25017322400	2010	71.000	\N
91	25017323100	2010	213.000	\N
91	25017324101	2010	179.000	\N
91	25017324102	2010	171.000	\N
91	25017325100	2010	266.000	\N
91	25017326101	2010	106.000	\N
91	25017326102	2010	187.000	\N
91	25017327101	2010	35.000	\N
91	25017327102	2010	64.000	\N
91	25017327103	2010	34.000	\N
91	25017328100	2010	97.000	\N
91	25017330100	2010	168.000	\N
91	25017330200	2010	229.000	\N
91	25017331101	2010	161.000	\N
91	25017331102	2010	204.000	\N
91	25017331200	2010	204.000	\N
91	25017331300	2010	262.000	\N
91	25017332100	2010	650.000	\N
91	25017332200	2010	1310.000	\N
91	25017332300	2010	956.000	\N
91	25017332400	2010	350.000	\N
91	25017333100	2010	545.000	\N
91	25017333200	2010	254.000	\N
91	25017333300	2010	154.000	\N
91	25017333400	2010	444.000	\N
91	25017333501	2010	191.000	\N
91	25017333502	2010	154.000	\N
91	25017333600	2010	1028.000	\N
91	25017334100	2010	309.000	\N
91	25017334200	2010	108.000	\N
91	25017334300	2010	212.000	\N
91	25017334400	2010	400.000	\N
91	25017335100	2010	99.000	\N
91	25017335200	2010	149.000	\N
91	25017335301	2010	134.000	\N
91	25017335302	2010	156.000	\N
91	25017335400	2010	121.000	\N
91	25017336100	2010	172.000	\N
91	25017336200	2010	169.000	\N
91	25017336300	2010	171.000	\N
91	25017336401	2010	359.000	\N
91	25017336402	2010	149.000	\N
91	25017337101	2010	81.000	\N
91	25017337102	2010	213.000	\N
91	25017337201	2010	103.000	\N
91	25017337202	2010	154.000	\N
91	25017337300	2010	172.000	\N
91	25017338100	2010	376.000	\N
91	25017338200	2010	712.000	\N
91	25017338300	2010	123.000	\N
91	25017338400	2010	470.000	\N
91	25017338500	2010	311.000	\N
91	25017339100	2010	246.000	\N
91	25017339200	2010	168.000	\N
91	25017339300	2010	114.000	\N
91	25017339400	2010	156.000	\N
91	25017339500	2010	408.000	\N
91	25017339600	2010	298.000	\N
91	25017339700	2010	279.000	\N
91	25017339801	2010	945.000	\N
91	25017339802	2010	484.000	\N
91	25017339900	2010	236.000	\N
91	25017340000	2010	127.000	\N
91	25017340100	2010	395.000	\N
91	25017341101	2010	905.000	\N
91	25017341102	2010	1132.000	\N
91	25017341200	2010	1735.000	\N
91	25017341300	2010	2100.000	\N
91	25017341400	2010	896.000	\N
91	25017341500	2010	906.000	\N
91	25017341600	2010	1194.000	\N
91	25017341700	2010	455.000	\N
91	25017341800	2010	1043.000	\N
91	25017341901	2010	169.000	\N
91	25017341902	2010	1363.000	\N
91	25017342101	2010	171.000	\N
91	25017342102	2010	140.000	\N
91	25017342201	2010	181.000	\N
91	25017342202	2010	242.000	\N
91	25017342300	2010	275.000	\N
91	25017342400	2010	388.000	\N
91	25017342500	2010	332.000	\N
91	25017342600	2010	253.000	\N
91	25017350103	2010	63.000	\N
91	25017350104	2010	582.000	\N
91	25017350200	2010	548.000	\N
91	25017350300	2010	182.000	\N
91	25017350400	2010	330.000	\N
91	25017350500	2010	86.000	\N
91	25017350600	2010	544.000	\N
91	25017350700	2010	334.000	\N
91	25017350800	2010	123.000	\N
91	25017350900	2010	234.000	\N
91	25017351000	2010	678.000	\N
91	25017351100	2010	436.000	\N
91	25017351203	2010	495.000	\N
91	25017351204	2010	503.000	\N
91	25017351300	2010	289.000	\N
91	25017351403	2010	345.000	\N
91	25017351404	2010	541.000	\N
91	25017351500	2010	265.000	\N
91	25017352101	2010	372.000	\N
91	25017352102	2010	319.000	\N
91	25017352200	2010	259.000	\N
91	25017352300	2010	641.000	\N
91	25017352400	2010	264.000	\N
91	25017352500	2010	303.000	\N
91	25017352600	2010	247.000	\N
91	25017352700	2010	135.000	\N
91	25017352800	2010	166.000	\N
91	25017352900	2010	251.000	\N
91	25017353000	2010	557.000	\N
91	25017353101	2010	376.000	\N
91	25017353102	2010	1836.000	\N
91	25017353200	2010	1055.000	\N
91	25017353300	2010	256.000	\N
91	25017353400	2010	321.000	\N
91	25017353500	2010	281.000	\N
91	25017353600	2010	590.000	\N
91	25017353700	2010	1003.000	\N
91	25017353800	2010	754.000	\N
91	25017353900	2010	1891.000	\N
91	25017354000	2010	630.000	\N
91	25017354100	2010	256.000	\N
91	25017354200	2010	124.000	\N
91	25017354300	2010	277.000	\N
91	25017354400	2010	84.000	\N
91	25017354500	2010	210.000	\N
91	25017354600	2010	489.000	\N
91	25017354700	2010	219.000	\N
91	25017354800	2010	134.000	\N
91	25017354900	2010	1241.000	\N
91	25017355000	2010	277.000	\N
91	25017356100	2010	202.000	\N
91	25017356300	2010	526.000	\N
91	25017356400	2010	449.000	\N
91	25017356500	2010	534.000	\N
91	25017356601	2010	384.000	\N
91	25017356602	2010	268.000	\N
91	25017356701	2010	650.000	\N
91	25017356702	2010	528.000	\N
91	25017357100	2010	477.000	\N
91	25017357200	2010	357.000	\N
91	25017357300	2010	343.000	\N
91	25017357400	2010	169.000	\N
91	25017357500	2010	241.000	\N
91	25017357600	2010	336.000	\N
91	25017357700	2010	477.000	\N
91	25017357800	2010	324.000	\N
91	25017358100	2010	813.000	\N
91	25017358300	2010	1341.000	\N
91	25017358400	2010	891.000	\N
91	25017358500	2010	1023.000	\N
91	25017358600	2010	1210.000	\N
91	25017358700	2010	961.000	\N
91	25017359100	2010	561.000	\N
91	25017359300	2010	689.000	\N
91	25017360100	2010	41.000	\N
91	25017360200	2010	306.000	\N
91	25017361100	2010	177.000	\N
91	25017361200	2010	276.000	\N
91	25017361300	2010	255.000	\N
91	25017362100	2010	380.000	\N
91	25017363102	2010	1487.000	\N
91	25017363103	2010	518.000	\N
91	25017363104	2010	1167.000	\N
91	25017363201	2010	455.000	\N
91	25017363202	2010	435.000	\N
91	25017364101	2010	123.000	\N
91	25017364102	2010	151.000	\N
91	25017365100	2010	475.000	\N
91	25017365201	2010	323.000	\N
91	25017365202	2010	242.000	\N
91	25017366100	2010	593.000	\N
91	25017366201	2010	243.000	\N
91	25017366202	2010	448.000	\N
91	25017367100	2010	436.000	\N
91	25017367200	2010	678.000	\N
91	25017368101	2010	914.000	\N
91	25017368102	2010	431.000	\N
91	25017368200	2010	325.000	\N
91	25017368300	2010	449.000	\N
91	25017368400	2010	1162.000	\N
91	25017368500	2010	385.000	\N
91	25017368600	2010	224.000	\N
91	25017368700	2010	84.000	\N
91	25017368800	2010	316.000	\N
91	25017368901	2010	658.000	\N
91	25017368902	2010	542.000	\N
91	25017369000	2010	174.000	\N
91	25017369100	2010	170.000	\N
91	25017370101	2010	391.000	\N
91	25017370102	2010	761.000	\N
91	25017370201	2010	214.000	\N
91	25017370202	2010	129.000	\N
91	25017370300	2010	445.000	\N
91	25017370400	2010	346.000	\N
91	25017373100	2010	500.000	\N
91	25017373200	2010	555.000	\N
91	25017373300	2010	304.000	\N
91	25017373400	2010	283.000	\N
91	25017373500	2010	514.000	\N
91	25017373600	2010	599.000	\N
91	25017373700	2010	238.000	\N
91	25017373800	2010	806.000	\N
91	25017373900	2010	965.000	\N
91	25017374000	2010	775.000	\N
91	25017374100	2010	895.000	\N
91	25017374200	2010	438.000	\N
91	25017374300	2010	226.000	\N
91	25017374400	2010	515.000	\N
91	25017374500	2010	457.000	\N
91	25017374600	2010	471.000	\N
91	25017374700	2010	611.000	\N
91	25017374800	2010	607.000	\N
91	25017382100	2010	423.000	\N
91	25017382200	2010	205.000	\N
91	25017382300	2010	231.000	\N
91	25017382400	2010	132.000	\N
91	25017382500	2010	266.000	\N
91	25017382601	2010	804.000	\N
91	25017382602	2010	314.000	\N
91	25017383101	2010	55.000	\N
91	25017383102	2010	59.000	\N
91	25017383200	2010	181.000	\N
91	25017383300	2010	111.000	\N
91	25017383400	2010	309.000	\N
91	25017383501	2010	481.000	\N
91	25017383502	2010	153.000	\N
91	25017383600	2010	482.000	\N
91	25017383700	2010	295.000	\N
91	25017383800	2010	290.000	\N
91	25017383901	2010	353.000	\N
91	25017383902	2010	414.000	\N
91	25017384001	2010	148.000	\N
91	25017384002	2010	971.000	\N
91	25017385100	2010	492.000	\N
91	25017385201	2010	121.000	\N
91	25017385202	2010	837.000	\N
91	25017386100	2010	137.000	\N
91	25017387100	2010	82.000	\N
91	25017387201	2010	154.000	\N
91	25017387202	2010	95.000	\N
91	25017388100	2010	813.000	\N
91	25017388200	2010	200.000	\N
91	25017388300	2010	815.000	\N
91	25017980000	2010	0.000	\N
91	25019950100	2010	14.000	\N
91	25019950200	2010	72.000	\N
91	25019950307	2010	2.000	\N
91	25019950400	2010	27.000	\N
91	25019950500	2010	3.000	\N
91	25019990000	2010	0.000	\N
91	25021400100	2010	698.000	\N
91	25021400200	2010	1172.000	\N
91	25021400300	2010	574.000	\N
91	25021400400	2010	709.000	\N
91	25021400500	2010	572.000	\N
91	25021400600	2010	691.000	\N
91	25021400700	2010	500.000	\N
91	25021400800	2010	1068.000	\N
91	25021400900	2010	850.000	\N
91	25021401000	2010	460.000	\N
91	25021401100	2010	532.000	\N
91	25021401200	2010	1331.000	\N
91	25021402101	2010	122.000	\N
91	25021402102	2010	112.000	\N
91	25021402200	2010	56.000	\N
91	25021402300	2010	120.000	\N
91	25021402400	2010	162.000	\N
91	25021402500	2010	60.000	\N
91	25021403100	2010	332.000	\N
91	25021403300	2010	169.000	\N
91	25021403400	2010	418.000	\N
91	25021403500	2010	499.000	\N
91	25021404100	2010	545.000	\N
91	25021404201	2010	156.000	\N
91	25021404202	2010	483.000	\N
91	25021404301	2010	460.000	\N
91	25021404302	2010	362.000	\N
91	25021404400	2010	736.000	\N
91	25021405100	2010	285.000	\N
91	25021406101	2010	146.000	\N
91	25021406102	2010	179.000	\N
91	25021407100	2010	238.000	\N
91	25021408101	2010	192.000	\N
91	25021408102	2010	85.000	\N
91	25021409101	2010	85.000	\N
91	25021409102	2010	84.000	\N
91	25021410100	2010	85.000	\N
91	25021410300	2010	172.000	\N
91	25021410400	2010	282.000	\N
91	25021411100	2010	145.000	\N
91	25021411200	2010	306.000	\N
91	25021411301	2010	84.000	\N
91	25021411302	2010	188.000	\N
91	25021412100	2010	288.000	\N
91	25021412200	2010	120.000	\N
91	25021412300	2010	317.000	\N
91	25021413100	2010	185.000	\N
91	25021413200	2010	181.000	\N
91	25021413300	2010	214.000	\N
91	25021413401	2010	59.000	\N
91	25021413402	2010	790.000	\N
91	25021413500	2010	266.000	\N
91	25021414100	2010	908.000	\N
91	25021414200	2010	724.000	\N
91	25021414300	2010	288.000	\N
91	25021415101	2010	315.000	\N
91	25021415102	2010	437.000	\N
91	25021415200	2010	369.000	\N
91	25021415300	2010	191.000	\N
91	25021416101	2010	275.000	\N
91	25021416102	2010	129.000	\N
91	25021416200	2010	246.000	\N
91	25021416300	2010	160.000	\N
91	25021416400	2010	301.000	\N
91	25021417100	2010	1101.000	\N
91	25021417200	2010	3640.000	\N
91	25021417300	2010	395.000	\N
91	25021417400	2010	66.000	\N
91	25021417501	2010	1852.000	\N
91	25021417502	2010	2099.000	\N
91	25021417601	2010	1565.000	\N
91	25021417602	2010	1441.000	\N
91	25021417701	2010	1077.000	\N
91	25021417702	2010	237.000	\N
91	25021417801	2010	238.000	\N
91	25021417802	2010	1113.000	\N
91	25021417901	2010	1127.000	\N
91	25021417902	2010	653.000	\N
91	25021418002	2010	1973.000	\N
91	25021418003	2010	351.000	\N
91	25021418004	2010	968.000	\N
91	25021418101	2010	1016.000	\N
91	25021418102	2010	390.000	\N
91	25021418200	2010	822.000	\N
91	25021419100	2010	427.000	\N
91	25021419200	2010	284.000	\N
91	25021419300	2010	350.000	\N
91	25021419400	2010	236.000	\N
91	25021419500	2010	255.000	\N
91	25021419600	2010	512.000	\N
91	25021419700	2010	345.000	\N
91	25021419800	2010	278.000	\N
91	25021420100	2010	1290.000	\N
91	25021420201	2010	481.000	\N
91	25021420202	2010	769.000	\N
91	25021420301	2010	724.000	\N
91	25021420302	2010	725.000	\N
91	25021421100	2010	146.000	\N
91	25021421200	2010	164.000	\N
91	25021422100	2010	138.000	\N
91	25021422200	2010	284.000	\N
91	25021422301	2010	43.000	\N
91	25021422302	2010	312.000	\N
91	25021422400	2010	281.000	\N
91	25021422501	2010	148.000	\N
91	25021422502	2010	137.000	\N
91	25021422600	2010	177.000	\N
91	25021422700	2010	122.000	\N
91	25021422800	2010	74.000	\N
91	25021423100	2010	71.000	\N
91	25021440100	2010	257.000	\N
91	25021441202	2010	43.000	\N
91	25021441203	2010	37.000	\N
91	25021441204	2010	32.000	\N
91	25021442101	2010	172.000	\N
91	25021442102	2010	259.000	\N
91	25021442103	2010	349.000	\N
91	25021442201	2010	162.000	\N
91	25021442202	2010	251.000	\N
91	25021443101	2010	203.000	\N
91	25021443102	2010	270.000	\N
91	25021456101	2010	157.000	\N
91	25021456102	2010	194.000	\N
91	25021456200	2010	164.000	\N
91	25021456301	2010	50.000	\N
91	25021456302	2010	143.000	\N
91	25021456401	2010	85.000	\N
91	25021456402	2010	177.000	\N
91	25021457100	2010	120.000	\N
91	25021457200	2010	335.000	\N
91	25023500101	2010	23.000	\N
91	25023500103	2010	19.000	\N
91	25023500104	2010	58.000	\N
91	25023501101	2010	53.000	\N
91	25023501102	2010	117.000	\N
91	25023501201	2010	44.000	\N
91	25023501202	2010	129.000	\N
91	25023502101	2010	59.000	\N
91	25023502102	2010	70.000	\N
91	25023502200	2010	63.000	\N
91	25023503101	2010	75.000	\N
91	25023503102	2010	85.000	\N
91	25023504101	2010	91.000	\N
91	25023504102	2010	90.000	\N
91	25023505101	2010	47.000	\N
91	25023505102	2010	33.000	\N
91	25023505200	2010	52.000	\N
91	25023506101	2010	64.000	\N
91	25023506102	2010	58.000	\N
91	25023506202	2010	11.000	\N
91	25023506203	2010	23.000	\N
91	25023506204	2010	22.000	\N
91	25023507101	2010	51.000	\N
91	25023507103	2010	30.000	\N
91	25023507104	2010	67.000	\N
91	25023508101	2010	100.000	\N
91	25023508102	2010	25.000	\N
91	25023508200	2010	42.000	\N
91	25023509101	2010	72.000	\N
91	25023509102	2010	44.000	\N
91	25023510100	2010	90.000	\N
91	25023510200	2010	167.000	\N
91	25023510300	2010	111.000	\N
91	25023510400	2010	61.000	\N
91	25023510501	2010	76.000	\N
91	25023510502	2010	172.000	\N
91	25023510503	2010	110.000	\N
91	25023510600	2010	109.000	\N
91	25023510700	2010	206.000	\N
91	25023510800	2010	126.000	\N
91	25023510900	2010	21.000	\N
91	25023511000	2010	27.000	\N
91	25023511100	2010	113.000	\N
91	25023511200	2010	59.000	\N
91	25023511301	2010	92.000	\N
91	25023511302	2010	25.000	\N
91	25023511400	2010	65.000	\N
91	25023511500	2010	71.000	\N
91	25023511600	2010	148.000	\N
91	25023511701	2010	157.000	\N
91	25023511702	2010	125.000	\N
91	25023520100	2010	84.000	\N
91	25023520201	2010	57.000	\N
91	25023520202	2010	141.000	\N
91	25023521101	2010	46.000	\N
91	25023521102	2010	31.000	\N
91	25023521201	2010	11.000	\N
91	25023521202	2010	20.000	\N
91	25023522101	2010	23.000	\N
91	25023522102	2010	25.000	\N
91	25023523100	2010	42.000	\N
91	25023523201	2010	20.000	\N
91	25023523202	2010	55.000	\N
91	25023524101	2010	37.000	\N
91	25023524102	2010	38.000	\N
91	25023525101	2010	123.000	\N
91	25023525104	2010	55.000	\N
91	25023525203	2010	59.000	\N
91	25023525204	2010	29.000	\N
91	25023525300	2010	16.000	\N
91	25023526100	2010	42.000	\N
91	25023530100	2010	42.000	\N
91	25023530200	2010	40.000	\N
91	25023530300	2010	36.000	\N
91	25023530400	2010	66.000	\N
91	25023530500	2010	74.000	\N
91	25023530600	2010	30.000	\N
91	25023530700	2010	41.000	\N
91	25023530801	2010	46.000	\N
91	25023530802	2010	24.000	\N
91	25023530901	2010	81.000	\N
91	25023530902	2010	34.000	\N
91	25023540101	2010	29.000	\N
91	25023540102	2010	12.000	\N
91	25023540103	2010	45.000	\N
91	25023541100	2010	33.000	\N
91	25023542101	2010	34.000	\N
91	25023542102	2010	10.000	\N
91	25023542200	2010	19.000	\N
91	25023542300	2010	105.000	\N
91	25023543100	2010	22.000	\N
91	25023544100	2010	27.000	\N
91	25023544200	2010	19.000	\N
91	25023545100	2010	48.000	\N
91	25023545200	2010	44.000	\N
91	25023545300	2010	28.000	\N
91	25023545400	2010	27.000	\N
91	25023560100	2010	36.000	\N
91	25023561100	2010	31.000	\N
91	25023561200	2010	43.000	\N
91	25023990003	2010	0.000	\N
91	25025000100	2010	468.000	\N
91	25025000201	2010	322.000	\N
91	25025000202	2010	525.000	\N
91	25025000301	2010	295.000	\N
91	25025000302	2010	449.000	\N
91	25025000401	2010	1032.000	\N
91	25025000402	2010	543.000	\N
91	25025000502	2010	704.000	\N
91	25025000503	2010	264.000	\N
91	25025000504	2010	537.000	\N
91	25025000601	2010	540.000	\N
91	25025000602	2010	635.000	\N
91	25025000701	2010	728.000	\N
91	25025000703	2010	662.000	\N
91	25025000704	2010	874.000	\N
91	25025000802	2010	1565.000	\N
91	25025000803	2010	1400.000	\N
91	25025010103	2010	1328.000	\N
91	25025010104	2010	967.000	\N
91	25025010203	2010	916.000	\N
91	25025010204	2010	669.000	\N
91	25025010300	2010	477.000	\N
91	25025010403	2010	628.000	\N
91	25025010404	2010	936.000	\N
91	25025010405	2010	717.000	\N
91	25025010408	2010	206.000	\N
91	25025010500	2010	405.000	\N
91	25025010600	2010	361.000	\N
91	25025010701	2010	211.000	\N
91	25025010702	2010	122.000	\N
91	25025010801	2010	186.000	\N
91	25025010802	2010	277.000	\N
91	25025020101	2010	186.000	\N
91	25025020200	2010	236.000	\N
91	25025020301	2010	416.000	\N
91	25025020302	2010	60.000	\N
91	25025020303	2010	329.000	\N
91	25025030100	2010	30.000	\N
91	25025030200	2010	36.000	\N
91	25025030300	2010	286.000	\N
91	25025030400	2010	74.000	\N
91	25025030500	2010	107.000	\N
91	25025040100	2010	46.000	\N
91	25025040200	2010	130.000	\N
91	25025040300	2010	146.000	\N
91	25025040401	2010	203.000	\N
91	25025040600	2010	89.000	\N
91	25025040801	2010	720.000	\N
91	25025050101	2010	287.000	\N
91	25025050200	2010	129.000	\N
91	25025050300	2010	236.000	\N
91	25025050400	2010	63.000	\N
91	25025050500	2010	48.000	\N
91	25025050600	2010	45.000	\N
91	25025050700	2010	86.000	\N
91	25025050901	2010	86.000	\N
91	25025051000	2010	121.000	\N
91	25025051101	2010	228.000	\N
91	25025051200	2010	52.000	\N
91	25025060101	2010	14.000	\N
91	25025060200	2010	7.000	\N
91	25025060301	2010	28.000	\N
91	25025060400	2010	85.000	\N
91	25025060501	2010	99.000	\N
91	25025060600	2010	150.000	\N
91	25025060700	2010	185.000	\N
91	25025060800	2010	183.000	\N
91	25025061000	2010	342.000	\N
91	25025061101	2010	313.000	\N
91	25025061200	2010	222.000	\N
91	25025070101	2010	1604.000	\N
91	25025070200	2010	3038.000	\N
91	25025070300	2010	567.000	\N
91	25025070402	2010	1206.000	\N
91	25025070500	2010	937.000	\N
91	25025070600	2010	130.000	\N
91	25025070700	2010	234.000	\N
91	25025070800	2010	264.000	\N
91	25025070900	2010	270.000	\N
91	25025071101	2010	670.000	\N
91	25025071201	2010	476.000	\N
91	25025080100	2010	44.000	\N
91	25025080300	2010	16.000	\N
91	25025080401	2010	66.000	\N
91	25025080500	2010	99.000	\N
91	25025080601	2010	385.000	\N
91	25025080801	2010	386.000	\N
91	25025080900	2010	660.000	\N
91	25025081001	2010	920.000	\N
91	25025081100	2010	549.000	\N
91	25025081200	2010	83.000	\N
91	25025081300	2010	39.000	\N
91	25025081400	2010	92.000	\N
91	25025081500	2010	25.000	\N
91	25025081700	2010	58.000	\N
91	25025081800	2010	39.000	\N
91	25025081900	2010	18.000	\N
91	25025082000	2010	19.000	\N
91	25025082100	2010	32.000	\N
91	25025090100	2010	30.000	\N
91	25025090200	2010	45.000	\N
91	25025090300	2010	19.000	\N
91	25025090400	2010	32.000	\N
91	25025090600	2010	36.000	\N
91	25025090700	2010	747.000	\N
91	25025090901	2010	742.000	\N
91	25025091001	2010	517.000	\N
91	25025091100	2010	1215.000	\N
91	25025091200	2010	196.000	\N
91	25025091300	2010	81.000	\N
91	25025091400	2010	26.000	\N
91	25025091500	2010	202.000	\N
91	25025091600	2010	805.000	\N
91	25025091700	2010	127.000	\N
91	25025091800	2010	59.000	\N
91	25025091900	2010	12.000	\N
91	25025092000	2010	467.000	\N
91	25025092101	2010	2026.000	\N
91	25025092200	2010	542.000	\N
91	25025092300	2010	21.000	\N
91	25025092400	2010	43.000	\N
91	25025100100	2010	48.000	\N
91	25025100200	2010	27.000	\N
91	25025100300	2010	23.000	\N
91	25025100400	2010	233.000	\N
91	25025100500	2010	572.000	\N
91	25025100601	2010	839.000	\N
91	25025100603	2010	160.000	\N
91	25025100700	2010	167.000	\N
91	25025100800	2010	614.000	\N
91	25025100900	2010	278.000	\N
91	25025101001	2010	13.000	\N
91	25025101002	2010	53.000	\N
91	25025101101	2010	2.000	\N
91	25025101102	2010	24.000	\N
91	25025110103	2010	390.000	\N
91	25025110201	2010	42.000	\N
91	25025110301	2010	60.000	\N
91	25025110401	2010	92.000	\N
91	25025110403	2010	110.000	\N
91	25025110501	2010	91.000	\N
91	25025110502	2010	113.000	\N
91	25025110601	2010	131.000	\N
91	25025110607	2010	128.000	\N
91	25025120103	2010	54.000	\N
91	25025120104	2010	126.000	\N
91	25025120105	2010	209.000	\N
91	25025120201	2010	115.000	\N
91	25025120301	2010	136.000	\N
91	25025120400	2010	259.000	\N
91	25025120500	2010	63.000	\N
91	25025120600	2010	79.000	\N
91	25025120700	2010	169.000	\N
91	25025130100	2010	523.000	\N
91	25025130200	2010	209.000	\N
91	25025130300	2010	230.000	\N
91	25025130402	2010	389.000	\N
91	25025130404	2010	231.000	\N
91	25025130406	2010	256.000	\N
91	25025140102	2010	88.000	\N
91	25025140105	2010	56.000	\N
91	25025140106	2010	30.000	\N
91	25025140107	2010	56.000	\N
91	25025140201	2010	51.000	\N
91	25025140202	2010	117.000	\N
91	25025140300	2010	85.000	\N
91	25025140400	2010	71.000	\N
91	25025160101	2010	152.000	\N
91	25025160200	2010	50.000	\N
91	25025160300	2010	38.000	\N
91	25025160400	2010	106.000	\N
91	25025160501	2010	155.000	\N
91	25025160502	2010	162.000	\N
91	25025160601	2010	168.000	\N
91	25025160602	2010	221.000	\N
91	25025170100	2010	344.000	\N
91	25025170200	2010	203.000	\N
91	25025170300	2010	503.000	\N
91	25025170400	2010	239.000	\N
91	25025170501	2010	185.000	\N
91	25025170502	2010	76.000	\N
91	25025170601	2010	186.000	\N
91	25025170701	2010	95.000	\N
91	25025170702	2010	921.000	\N
91	25025170800	2010	104.000	\N
91	25025180101	2010	56.000	\N
91	25025180200	2010	58.000	\N
91	25025180301	2010	44.000	\N
91	25025180400	2010	8.000	\N
91	25025180500	2010	43.000	\N
91	25025980101	2010	8.000	\N
91	25025980300	2010	10.000	\N
91	25025980700	2010	0.000	\N
91	25025981000	2010	0.000	\N
91	25025981100	2010	13.000	\N
91	25025981201	2010	0.000	\N
91	25025981202	2010	2.000	\N
91	25025981300	2010	29.000	\N
91	25025981501	2010	1.000	\N
91	25025981502	2010	0.000	\N
91	25025981600	2010	0.000	\N
91	25025981700	2010	0.000	\N
91	25025981800	2010	3.000	\N
91	25025990101	2010	0.000	\N
91	25027700100	2010	71.000	\N
91	25027701100	2010	179.000	\N
91	25027702200	2010	19.000	\N
91	25027703100	2010	19.000	\N
91	25027703200	2010	34.000	\N
91	25027703300	2010	30.000	\N
91	25027704200	2010	14.000	\N
91	25027705100	2010	42.000	\N
91	25027706100	2010	21.000	\N
91	25027707100	2010	32.000	\N
91	25027707200	2010	32.000	\N
91	25027707300	2010	71.000	\N
91	25027707400	2010	50.000	\N
91	25027707500	2010	106.000	\N
91	25027708100	2010	73.000	\N
91	25027709100	2010	53.000	\N
91	25027709201	2010	115.000	\N
91	25027709202	2010	233.000	\N
91	25027709400	2010	243.000	\N
91	25027709501	2010	52.000	\N
91	25027709502	2010	187.000	\N
91	25027709600	2010	47.000	\N
91	25027709701	2010	125.000	\N
91	25027709702	2010	49.000	\N
91	25027710100	2010	197.000	\N
91	25027710200	2010	223.000	\N
91	25027710300	2010	103.000	\N
91	25027710400	2010	126.000	\N
91	25027710500	2010	146.000	\N
91	25027710600	2010	213.000	\N
91	25027710700	2010	45.000	\N
91	25027710800	2010	81.000	\N
91	25027711000	2010	159.000	\N
91	25027711100	2010	158.000	\N
91	25027712101	2010	92.000	\N
91	25027712102	2010	61.000	\N
91	25027713100	2010	140.000	\N
91	25027715100	2010	130.000	\N
91	25027716100	2010	121.000	\N
91	25027716200	2010	45.000	\N
91	25027716300	2010	14.000	\N
91	25027717100	2010	40.000	\N
91	25027718100	2010	159.000	\N
91	25027719100	2010	67.000	\N
91	25027720100	2010	40.000	\N
91	25027721101	2010	8.000	\N
91	25027721102	2010	126.000	\N
91	25027722100	2010	28.000	\N
91	25027723100	2010	12.000	\N
91	25027724100	2010	23.000	\N
91	25027725100	2010	13.000	\N
91	25027726100	2010	41.000	\N
91	25027726200	2010	38.000	\N
91	25027727100	2010	62.000	\N
91	25027728100	2010	144.000	\N
91	25027728200	2010	99.000	\N
91	25027728300	2010	88.000	\N
91	25027728400	2010	182.000	\N
91	25027729100	2010	29.000	\N
91	25027729200	2010	23.000	\N
91	25027730100	2010	293.000	\N
91	25027730200	2010	173.000	\N
91	25027730300	2010	146.000	\N
91	25027730401	2010	96.000	\N
91	25027730402	2010	74.000	\N
91	25027730500	2010	128.000	\N
91	25027730600	2010	391.000	\N
91	25027730700	2010	326.000	\N
91	25027730801	2010	114.000	\N
91	25027730802	2010	79.000	\N
91	25027730901	2010	86.000	\N
91	25027730902	2010	128.000	\N
91	25027731001	2010	270.000	\N
91	25027731002	2010	532.000	\N
91	25027731101	2010	430.000	\N
91	25027731102	2010	143.000	\N
91	25027731202	2010	112.000	\N
91	25027731203	2010	611.000	\N
91	25027731204	2010	295.000	\N
91	25027731300	2010	485.000	\N
91	25027731400	2010	367.000	\N
91	25027731500	2010	260.000	\N
91	25027731600	2010	694.000	\N
91	25027731700	2010	159.000	\N
91	25027731800	2010	268.000	\N
91	25027731900	2010	192.000	\N
91	25027732001	2010	96.000	\N
91	25027732002	2010	348.000	\N
91	25027732201	2010	256.000	\N
91	25027732202	2010	192.000	\N
91	25027732203	2010	306.000	\N
91	25027732301	2010	242.000	\N
91	25027732302	2010	123.000	\N
91	25027732400	2010	305.000	\N
91	25027732500	2010	149.000	\N
91	25027732600	2010	128.000	\N
91	25027732700	2010	191.000	\N
91	25027732801	2010	278.000	\N
91	25027732802	2010	263.000	\N
91	25027732901	2010	337.000	\N
91	25027732902	2010	117.000	\N
91	25027733000	2010	449.000	\N
91	25027733101	2010	96.000	\N
91	25027733102	2010	199.000	\N
91	25027735100	2010	106.000	\N
91	25027735200	2010	75.000	\N
91	25027736100	2010	65.000	\N
91	25027736200	2010	62.000	\N
91	25027736300	2010	35.000	\N
91	25027736400	2010	76.000	\N
91	25027736500	2010	61.000	\N
91	25027737100	2010	73.000	\N
91	25027737200	2010	19.000	\N
91	25027737300	2010	156.000	\N
91	25027738100	2010	755.000	\N
91	25027738201	2010	216.000	\N
91	25027738202	2010	314.000	\N
91	25027739100	2010	2092.000	\N
91	25027739200	2010	1117.000	\N
91	25027739300	2010	386.000	\N
91	25027739400	2010	1189.000	\N
91	25027739500	2010	663.000	\N
91	25027740101	2010	434.000	\N
91	25027740102	2010	490.000	\N
91	25027740200	2010	229.000	\N
91	25027741101	2010	322.000	\N
91	25027741102	2010	491.000	\N
91	25027742300	2010	267.000	\N
91	25027742401	2010	532.000	\N
91	25027742402	2010	1136.000	\N
91	25027743100	2010	162.000	\N
91	25027744101	2010	287.000	\N
91	25027744102	2010	88.000	\N
91	25027744200	2010	198.000	\N
91	25027744300	2010	31.000	\N
91	25027744400	2010	70.000	\N
91	25027745100	2010	101.000	\N
91	25027746100	2010	57.000	\N
91	25027747101	2010	33.000	\N
91	25027747102	2010	38.000	\N
91	25027748100	2010	29.000	\N
91	25027749100	2010	96.000	\N
91	25027749200	2010	44.000	\N
91	25027750100	2010	60.000	\N
91	25027750200	2010	75.000	\N
91	25027750300	2010	24.000	\N
91	25027751101	2010	65.000	\N
91	25027751102	2010	19.000	\N
91	25027752100	2010	75.000	\N
91	25027753100	2010	86.000	\N
91	25027753200	2010	55.000	\N
91	25027754100	2010	77.000	\N
91	25027754200	2010	34.000	\N
91	25027754300	2010	47.000	\N
91	25027754400	2010	20.000	\N
91	25027755100	2010	24.000	\N
91	25027755200	2010	69.000	\N
91	25027756101	2010	49.000	\N
91	25027756102	2010	65.000	\N
91	25027757100	2010	102.000	\N
91	25027757200	2010	46.000	\N
91	25027757300	2010	44.000	\N
91	25027757400	2010	28.000	\N
91	25027757500	2010	76.000	\N
91	25027758101	2010	10.000	\N
91	25027758102	2010	174.000	\N
91	25027759100	2010	6.000	\N
91	25027760100	2010	7.000	\N
91	25027761100	2010	17.000	\N
91	25027761200	2010	1246.000	\N
91	25027761300	2010	85.000	\N
91	25027761400	2010	217.000	\N
92	25001010100	2010	0.000	\N
92	25001010206	2010	0.000	\N
92	25001010208	2010	0.000	\N
92	25001010304	2010	0.000	\N
92	25001010306	2010	0.000	\N
92	25001010400	2010	0.000	\N
92	25001010500	2010	1.000	\N
92	25001010600	2010	0.000	\N
92	25001010700	2010	0.000	\N
92	25001010800	2010	0.000	\N
92	25001010900	2010	0.000	\N
92	25001011002	2010	2.000	\N
92	25001011100	2010	0.000	\N
92	25001011200	2010	0.000	\N
92	25001011300	2010	6.000	\N
92	25001011400	2010	0.000	\N
92	25001011500	2010	2.000	\N
92	25001011600	2010	0.000	\N
92	25001011700	2010	1.000	\N
92	25001011801	2010	1.000	\N
92	25001011802	2010	0.000	\N
92	25001012001	2010	0.000	\N
92	25001012002	2010	0.000	\N
92	25001012101	2010	1.000	\N
92	25001012102	2010	1.000	\N
92	25001012200	2010	1.000	\N
92	25001012502	2010	1.000	\N
92	25001012601	2010	7.000	\N
92	25001012602	2010	0.000	\N
92	25001012700	2010	0.000	\N
92	25001012800	2010	1.000	\N
92	25001012900	2010	5.000	\N
92	25001013002	2010	0.000	\N
92	25001013100	2010	1.000	\N
92	25001013200	2010	0.000	\N
92	25001013300	2010	4.000	\N
92	25001013400	2010	0.000	\N
92	25001013500	2010	0.000	\N
92	25001013600	2010	1.000	\N
92	25001013700	2010	1.000	\N
92	25001013800	2010	0.000	\N
92	25001013900	2010	4.000	\N
92	25001014002	2010	1.000	\N
92	25001014100	2010	0.000	\N
92	25001014300	2010	1.000	\N
92	25001014402	2010	7.000	\N
92	25001014500	2010	0.000	\N
92	25001014600	2010	3.000	\N
92	25001014700	2010	0.000	\N
92	25001014800	2010	0.000	\N
92	25001014900	2010	1.000	\N
92	25001015001	2010	6.000	\N
92	25001015002	2010	3.000	\N
92	25001015100	2010	0.000	\N
92	25001015200	2010	0.000	\N
92	25001015300	2010	2.000	\N
92	25001990000	2010	0.000	\N
92	25003900100	2010	0.000	\N
92	25003900200	2010	0.000	\N
92	25003900300	2010	1.000	\N
92	25003900400	2010	0.000	\N
92	25003900500	2010	1.000	\N
92	25003900600	2010	1.000	\N
92	25003900700	2010	0.000	\N
92	25003900800	2010	0.000	\N
92	25003900900	2010	0.000	\N
92	25003901100	2010	0.000	\N
92	25003911100	2010	1.000	\N
92	25003912100	2010	1.000	\N
92	25003913100	2010	2.000	\N
92	25003914100	2010	0.000	\N
92	25003920101	2010	1.000	\N
92	25003920102	2010	0.000	\N
92	25003921300	2010	6.000	\N
92	25003921400	2010	2.000	\N
92	25003921500	2010	0.000	\N
92	25003922100	2010	1.000	\N
92	25003922200	2010	0.000	\N
92	25003922300	2010	1.000	\N
92	25003923100	2010	0.000	\N
92	25003924100	2010	0.000	\N
92	25003925100	2010	1.000	\N
92	25003926100	2010	0.000	\N
92	25003931100	2010	0.000	\N
92	25003931300	2010	0.000	\N
92	25003931400	2010	0.000	\N
92	25003932200	2010	0.000	\N
92	25003932300	2010	0.000	\N
92	25003933200	2010	0.000	\N
92	25003933300	2010	0.000	\N
92	25003933400	2010	2.000	\N
92	25003934200	2010	0.000	\N
92	25003934300	2010	1.000	\N
92	25003935100	2010	0.000	\N
92	25003935200	2010	1.000	\N
92	25003935300	2010	0.000	\N
92	25005600100	2010	2.000	\N
92	25005600202	2010	1.000	\N
92	25005600203	2010	0.000	\N
92	25005600204	2010	1.000	\N
92	25005610100	2010	0.000	\N
92	25005610202	2010	0.000	\N
92	25005610203	2010	0.000	\N
92	25005610204	2010	4.000	\N
92	25005611101	2010	0.000	\N
92	25005611102	2010	3.000	\N
92	25005611201	2010	0.000	\N
92	25005611202	2010	3.000	\N
92	25005612100	2010	0.000	\N
92	25005612200	2010	0.000	\N
92	25005613100	2010	2.000	\N
92	25005613300	2010	5.000	\N
92	25005613400	2010	0.000	\N
92	25005613600	2010	1.000	\N
92	25005613700	2010	0.000	\N
92	25005613800	2010	2.000	\N
92	25005613901	2010	0.000	\N
92	25005613902	2010	0.000	\N
92	25005614000	2010	1.000	\N
92	25005614101	2010	6.000	\N
92	25005614102	2010	1.000	\N
92	25005615100	2010	0.000	\N
92	25005616100	2010	1.000	\N
92	25005617101	2010	0.000	\N
92	25005617102	2010	0.000	\N
92	25005630101	2010	1.000	\N
92	25005630102	2010	1.000	\N
92	25005630200	2010	0.000	\N
92	25005630300	2010	5.000	\N
92	25005630400	2010	0.000	\N
92	25005631100	2010	2.000	\N
92	25005631200	2010	1.000	\N
92	25005631300	2010	3.000	\N
92	25005631400	2010	1.000	\N
92	25005631500	2010	0.000	\N
92	25005631600	2010	8.000	\N
92	25005631700	2010	9.000	\N
92	25005631800	2010	3.000	\N
92	25005632100	2010	1.000	\N
92	25005632200	2010	1.000	\N
92	25005633100	2010	4.000	\N
92	25005633200	2010	0.000	\N
92	25005640100	2010	0.000	\N
92	25005640200	2010	2.000	\N
92	25005640300	2010	0.000	\N
92	25005640400	2010	0.000	\N
92	25005640500	2010	0.000	\N
92	25005640600	2010	0.000	\N
92	25005640700	2010	0.000	\N
92	25005640800	2010	0.000	\N
92	25005640901	2010	0.000	\N
92	25005641000	2010	0.000	\N
92	25005641101	2010	0.000	\N
92	25005641200	2010	0.000	\N
92	25005641300	2010	3.000	\N
92	25005641400	2010	0.000	\N
92	25005641500	2010	1.000	\N
92	25005641600	2010	0.000	\N
92	25005641700	2010	0.000	\N
92	25005641800	2010	0.000	\N
92	25005641900	2010	0.000	\N
92	25005642000	2010	0.000	\N
92	25005642100	2010	1.000	\N
92	25005642200	2010	0.000	\N
92	25005642300	2010	0.000	\N
92	25005642400	2010	2.000	\N
92	25005642500	2010	1.000	\N
92	25005644101	2010	0.000	\N
92	25005644102	2010	1.000	\N
92	25005644200	2010	0.000	\N
92	25005645101	2010	0.000	\N
92	25005645102	2010	0.000	\N
92	25005645103	2010	1.000	\N
92	25005646101	2010	0.000	\N
92	25005646103	2010	4.000	\N
92	25005646104	2010	0.000	\N
92	25005650101	2010	0.000	\N
92	25005650102	2010	0.000	\N
92	25005650201	2010	0.000	\N
92	25005650202	2010	0.000	\N
92	25005650300	2010	0.000	\N
92	25005650400	2010	0.000	\N
92	25005650500	2010	4.000	\N
92	25005650600	2010	0.000	\N
92	25005650700	2010	0.000	\N
92	25005650800	2010	2.000	\N
92	25005650900	2010	0.000	\N
92	25005651001	2010	3.000	\N
92	25005651002	2010	2.000	\N
92	25005651100	2010	0.000	\N
92	25005651200	2010	0.000	\N
92	25005651300	2010	1.000	\N
92	25005651400	2010	1.000	\N
92	25005651500	2010	0.000	\N
92	25005651600	2010	0.000	\N
92	25005651700	2010	1.000	\N
92	25005651800	2010	0.000	\N
92	25005651900	2010	1.000	\N
92	25005652000	2010	0.000	\N
92	25005652100	2010	0.000	\N
92	25005652200	2010	0.000	\N
92	25005652300	2010	0.000	\N
92	25005652400	2010	0.000	\N
92	25005652500	2010	0.000	\N
92	25005652600	2010	0.000	\N
92	25005652700	2010	0.000	\N
92	25005652800	2010	0.000	\N
92	25005653101	2010	3.000	\N
92	25005653102	2010	1.000	\N
92	25005653203	2010	0.000	\N
92	25005653204	2010	0.000	\N
92	25005653301	2010	0.000	\N
92	25005653304	2010	0.000	\N
92	25005654100	2010	0.000	\N
92	25005654200	2010	0.000	\N
92	25005655100	2010	5.000	\N
92	25005655200	2010	4.000	\N
92	25005655300	2010	0.000	\N
92	25005655400	2010	0.000	\N
92	25005985500	2010	2.000	\N
92	25005985600	2010	0.000	\N
92	25005990000	2010	0.000	\N
92	25007200100	2010	1.000	\N
92	25007200200	2010	1.000	\N
92	25007200300	2010	1.000	\N
92	25007200400	2010	1.000	\N
92	25007990000	2010	0.000	\N
92	25009201100	2010	0.000	\N
92	25009202101	2010	0.000	\N
92	25009202102	2010	4.000	\N
92	25009202200	2010	0.000	\N
92	25009203100	2010	1.000	\N
92	25009203200	2010	0.000	\N
92	25009203301	2010	0.000	\N
92	25009203302	2010	0.000	\N
92	25009204101	2010	2.000	\N
92	25009204102	2010	5.000	\N
92	25009204200	2010	1.000	\N
92	25009204300	2010	1.000	\N
92	25009204400	2010	3.000	\N
92	25009204500	2010	1.000	\N
92	25009204600	2010	1.000	\N
92	25009204701	2010	3.000	\N
92	25009204702	2010	0.000	\N
92	25009205100	2010	2.000	\N
92	25009205200	2010	0.000	\N
92	25009205300	2010	0.000	\N
92	25009205400	2010	2.000	\N
92	25009205500	2010	4.000	\N
92	25009205600	2010	0.000	\N
92	25009205700	2010	0.000	\N
92	25009205800	2010	0.000	\N
92	25009205900	2010	0.000	\N
92	25009206000	2010	0.000	\N
92	25009206100	2010	10.000	\N
92	25009206200	2010	0.000	\N
92	25009206300	2010	2.000	\N
92	25009206400	2010	3.000	\N
92	25009206500	2010	0.000	\N
92	25009206600	2010	2.000	\N
92	25009206700	2010	1.000	\N
92	25009206800	2010	1.000	\N
92	25009206900	2010	0.000	\N
92	25009207000	2010	4.000	\N
92	25009207100	2010	6.000	\N
92	25009207200	2010	0.000	\N
92	25009208101	2010	0.000	\N
92	25009208102	2010	1.000	\N
92	25009208200	2010	0.000	\N
92	25009208300	2010	0.000	\N
92	25009208400	2010	0.000	\N
92	25009209100	2010	0.000	\N
92	25009209200	2010	0.000	\N
92	25009210100	2010	0.000	\N
92	25009210200	2010	0.000	\N
92	25009210300	2010	3.000	\N
92	25009210400	2010	2.000	\N
92	25009210500	2010	0.000	\N
92	25009210600	2010	0.000	\N
92	25009210700	2010	0.000	\N
92	25009210800	2010	0.000	\N
92	25009210900	2010	0.000	\N
92	25009211100	2010	0.000	\N
92	25009211200	2010	1.000	\N
92	25009211300	2010	0.000	\N
92	25009211401	2010	3.000	\N
92	25009211402	2010	0.000	\N
92	25009212100	2010	0.000	\N
92	25009213100	2010	0.000	\N
92	25009214100	2010	0.000	\N
92	25009215101	2010	0.000	\N
92	25009215102	2010	0.000	\N
92	25009216100	2010	4.000	\N
92	25009217100	2010	3.000	\N
92	25009217201	2010	2.000	\N
92	25009217202	2010	0.000	\N
92	25009217300	2010	13.000	\N
92	25009217400	2010	4.000	\N
92	25009217500	2010	0.000	\N
92	25009217600	2010	1.000	\N
92	25009218100	2010	0.000	\N
92	25009220101	2010	0.000	\N
92	25009220102	2010	6.000	\N
92	25009221100	2010	1.000	\N
92	25009221300	2010	0.000	\N
92	25009221400	2010	5.000	\N
92	25009221500	2010	5.000	\N
92	25009221600	2010	1.000	\N
92	25009221700	2010	4.000	\N
92	25009221800	2010	0.000	\N
92	25009221901	2010	0.000	\N
92	25009221902	2010	0.000	\N
92	25009222100	2010	1.000	\N
92	25009223100	2010	0.000	\N
92	25009223200	2010	6.000	\N
92	25009223300	2010	0.000	\N
92	25009250100	2010	0.000	\N
92	25009250200	2010	0.000	\N
92	25009250300	2010	0.000	\N
92	25009250400	2010	0.000	\N
92	25009250500	2010	0.000	\N
92	25009250600	2010	0.000	\N
92	25009250700	2010	0.000	\N
92	25009250800	2010	1.000	\N
92	25009250900	2010	1.000	\N
92	25009251000	2010	0.000	\N
92	25009251100	2010	0.000	\N
92	25009251200	2010	0.000	\N
92	25009251300	2010	0.000	\N
92	25009251400	2010	0.000	\N
92	25009251500	2010	0.000	\N
92	25009251600	2010	0.000	\N
92	25009251700	2010	0.000	\N
92	25009251800	2010	0.000	\N
92	25009252101	2010	0.000	\N
92	25009252102	2010	0.000	\N
92	25009252201	2010	0.000	\N
92	25009252202	2010	0.000	\N
92	25009252300	2010	0.000	\N
92	25009252400	2010	1.000	\N
92	25009252501	2010	0.000	\N
92	25009252502	2010	0.000	\N
92	25009252601	2010	0.000	\N
92	25009252602	2010	0.000	\N
92	25009252603	2010	0.000	\N
92	25009253100	2010	2.000	\N
92	25009253201	2010	0.000	\N
92	25009253202	2010	1.000	\N
92	25009253203	2010	0.000	\N
92	25009253204	2010	0.000	\N
92	25009253205	2010	0.000	\N
92	25009254100	2010	6.000	\N
92	25009254200	2010	2.000	\N
92	25009254301	2010	0.000	\N
92	25009254302	2010	0.000	\N
92	25009254401	2010	0.000	\N
92	25009254402	2010	0.000	\N
92	25009254403	2010	0.000	\N
92	25009260100	2010	0.000	\N
92	25009260200	2010	0.000	\N
92	25009260301	2010	0.000	\N
92	25009260302	2010	1.000	\N
92	25009260401	2010	0.000	\N
92	25009260402	2010	1.000	\N
92	25009260500	2010	2.000	\N
92	25009260600	2010	1.000	\N
92	25009260700	2010	0.000	\N
92	25009260800	2010	1.000	\N
92	25009260900	2010	0.000	\N
92	25009261000	2010	0.000	\N
92	25009261101	2010	1.000	\N
92	25009261102	2010	1.000	\N
92	25009262100	2010	0.000	\N
92	25009263100	2010	0.000	\N
92	25009264100	2010	2.000	\N
92	25009265101	2010	0.000	\N
92	25009265102	2010	0.000	\N
92	25009266100	2010	6.000	\N
92	25009266200	2010	0.000	\N
92	25009266300	2010	0.000	\N
92	25009266400	2010	0.000	\N
92	25009267101	2010	1.000	\N
92	25009267102	2010	0.000	\N
92	25009268100	2010	0.000	\N
92	25009268200	2010	1.000	\N
92	25009268300	2010	0.000	\N
92	25009268400	2010	0.000	\N
92	25009269100	2010	0.000	\N
92	25009270100	2010	4.000	\N
92	25009990100	2010	0.000	\N
92	25011040100	2010	0.000	\N
92	25011040200	2010	0.000	\N
92	25011040300	2010	0.000	\N
92	25011040400	2010	0.000	\N
92	25011040501	2010	1.000	\N
92	25011040502	2010	0.000	\N
92	25011040600	2010	0.000	\N
92	25011040701	2010	0.000	\N
92	25011040702	2010	1.000	\N
92	25011040800	2010	2.000	\N
92	25011040900	2010	1.000	\N
92	25011041000	2010	0.000	\N
92	25011041100	2010	0.000	\N
92	25011041200	2010	0.000	\N
92	25011041300	2010	1.000	\N
92	25011041400	2010	1.000	\N
92	25011041501	2010	2.000	\N
92	25011041502	2010	0.000	\N
92	25013800101	2010	1.000	\N
92	25013800102	2010	3.000	\N
92	25013800201	2010	0.000	\N
92	25013800202	2010	2.000	\N
92	25013800300	2010	0.000	\N
92	25013800400	2010	4.000	\N
92	25013800500	2010	0.000	\N
92	25013800600	2010	0.000	\N
92	25013800700	2010	0.000	\N
92	25013800800	2010	0.000	\N
92	25013800900	2010	0.000	\N
92	25013801101	2010	0.000	\N
92	25013801102	2010	1.000	\N
92	25013801200	2010	0.000	\N
92	25013801300	2010	4.000	\N
92	25013801401	2010	0.000	\N
92	25013801402	2010	0.000	\N
92	25013801501	2010	1.000	\N
92	25013801502	2010	0.000	\N
92	25013801503	2010	1.000	\N
92	25013801601	2010	2.000	\N
92	25013801602	2010	4.000	\N
92	25013801603	2010	2.000	\N
92	25013801604	2010	0.000	\N
92	25013801605	2010	4.000	\N
92	25013801700	2010	5.000	\N
92	25013801800	2010	0.000	\N
92	25013801901	2010	2.000	\N
92	25013801902	2010	4.000	\N
92	25013802000	2010	0.000	\N
92	25013802100	2010	0.000	\N
92	25013802200	2010	0.000	\N
92	25013802300	2010	2.000	\N
92	25013802400	2010	0.000	\N
92	25013802500	2010	0.000	\N
92	25013802601	2010	4.000	\N
92	25013802602	2010	1.000	\N
92	25013810100	2010	0.000	\N
92	25013810200	2010	0.000	\N
92	25013810300	2010	0.000	\N
92	25013810403	2010	4.000	\N
92	25013810404	2010	4.000	\N
92	25013810412	2010	0.000	\N
92	25013810414	2010	0.000	\N
92	25013810601	2010	8.000	\N
92	25013810602	2010	2.000	\N
92	25013810700	2010	1.000	\N
92	25013810800	2010	2.000	\N
92	25013810901	2010	0.000	\N
92	25013810902	2010	0.000	\N
92	25013811000	2010	0.000	\N
92	25013811101	2010	2.000	\N
92	25013811102	2010	1.000	\N
92	25013811200	2010	0.000	\N
92	25013811301	2010	2.000	\N
92	25013811302	2010	4.000	\N
92	25013811400	2010	0.000	\N
92	25013811500	2010	0.000	\N
92	25013811600	2010	0.000	\N
92	25013811700	2010	0.000	\N
92	25013811800	2010	0.000	\N
92	25013811900	2010	0.000	\N
92	25013812001	2010	0.000	\N
92	25013812002	2010	2.000	\N
92	25013812101	2010	0.000	\N
92	25013812103	2010	1.000	\N
92	25013812104	2010	4.000	\N
92	25013812201	2010	3.000	\N
92	25013812202	2010	3.000	\N
92	25013812300	2010	5.000	\N
92	25013812401	2010	1.000	\N
92	25013812403	2010	0.000	\N
92	25013812404	2010	2.000	\N
92	25013812500	2010	3.000	\N
92	25013812600	2010	0.000	\N
92	25013812701	2010	0.000	\N
92	25013812702	2010	0.000	\N
92	25013812800	2010	3.000	\N
92	25013812901	2010	0.000	\N
92	25013812902	2010	2.000	\N
92	25013812903	2010	0.000	\N
92	25013813000	2010	0.000	\N
92	25013813101	2010	2.000	\N
92	25013813102	2010	1.000	\N
92	25013813204	2010	0.000	\N
92	25013813205	2010	0.000	\N
92	25013813206	2010	0.000	\N
92	25013813207	2010	0.000	\N
92	25013813208	2010	0.000	\N
92	25013813209	2010	0.000	\N
92	25013813301	2010	2.000	\N
92	25013813303	2010	0.000	\N
92	25013813304	2010	1.000	\N
92	25013813401	2010	0.000	\N
92	25013813403	2010	0.000	\N
92	25013813404	2010	0.000	\N
92	25013813500	2010	1.000	\N
92	25013813601	2010	1.000	\N
92	25013813602	2010	0.000	\N
92	25013813701	2010	0.000	\N
92	25013813702	2010	0.000	\N
92	25013813801	2010	0.000	\N
92	25013813802	2010	0.000	\N
92	25015820101	2010	0.000	\N
92	25015820102	2010	0.000	\N
92	25015820202	2010	0.000	\N
92	25015820203	2010	5.000	\N
92	25015820204	2010	1.000	\N
92	25015820300	2010	7.000	\N
92	25015820400	2010	1.000	\N
92	25015820500	2010	1.000	\N
92	25015820600	2010	0.000	\N
92	25015820700	2010	0.000	\N
92	25015820801	2010	2.000	\N
92	25015820802	2010	0.000	\N
92	25015820900	2010	1.000	\N
92	25015821000	2010	0.000	\N
92	25015821100	2010	7.000	\N
92	25015821200	2010	2.000	\N
92	25015821300	2010	0.000	\N
92	25015821400	2010	1.000	\N
92	25015821500	2010	0.000	\N
92	25015821601	2010	0.000	\N
92	25015821602	2010	2.000	\N
92	25015821700	2010	1.000	\N
92	25015821901	2010	1.000	\N
92	25015821903	2010	0.000	\N
92	25015821904	2010	0.000	\N
92	25015822000	2010	0.000	\N
92	25015822200	2010	3.000	\N
92	25015822300	2010	3.000	\N
92	25015822401	2010	0.000	\N
92	25015822402	2010	0.000	\N
92	25015822500	2010	0.000	\N
92	25015822601	2010	2.000	\N
92	25015822603	2010	0.000	\N
92	25015822605	2010	1.000	\N
92	25015822606	2010	0.000	\N
92	25015822700	2010	0.000	\N
92	25017300100	2010	1.000	\N
92	25017301101	2010	0.000	\N
92	25017301102	2010	0.000	\N
92	25017310100	2010	1.000	\N
92	25017310200	2010	4.000	\N
92	25017310300	2010	0.000	\N
92	25017310400	2010	0.000	\N
92	25017310500	2010	2.000	\N
92	25017310601	2010	1.000	\N
92	25017310602	2010	0.000	\N
92	25017310700	2010	0.000	\N
92	25017311100	2010	0.000	\N
92	25017311200	2010	0.000	\N
92	25017311300	2010	0.000	\N
92	25017311400	2010	3.000	\N
92	25017311500	2010	3.000	\N
92	25017311600	2010	0.000	\N
92	25017311700	2010	7.000	\N
92	25017311800	2010	0.000	\N
92	25017311900	2010	2.000	\N
92	25017312000	2010	1.000	\N
92	25017312100	2010	0.000	\N
92	25017312200	2010	1.000	\N
92	25017312300	2010	0.000	\N
92	25017312400	2010	0.000	\N
92	25017312501	2010	3.000	\N
92	25017312502	2010	2.000	\N
92	25017313101	2010	0.000	\N
92	25017313102	2010	0.000	\N
92	25017314101	2010	0.000	\N
92	25017314102	2010	0.000	\N
92	25017314200	2010	0.000	\N
92	25017314301	2010	3.000	\N
92	25017314302	2010	0.000	\N
92	25017315100	2010	0.000	\N
92	25017315200	2010	1.000	\N
92	25017315401	2010	0.000	\N
92	25017315402	2010	0.000	\N
92	25017315403	2010	0.000	\N
92	25017315500	2010	0.000	\N
92	25017316101	2010	0.000	\N
92	25017316102	2010	0.000	\N
92	25017316201	2010	0.000	\N
92	25017316202	2010	2.000	\N
92	25017316300	2010	2.000	\N
92	25017316400	2010	1.000	\N
92	25017316500	2010	3.000	\N
92	25017317101	2010	1.000	\N
92	25017317102	2010	0.000	\N
92	25017317103	2010	0.000	\N
92	25017317201	2010	1.000	\N
92	25017317202	2010	0.000	\N
92	25017317203	2010	0.000	\N
92	25017317301	2010	0.000	\N
92	25017317302	2010	0.000	\N
92	25017318100	2010	1.000	\N
92	25017318200	2010	0.000	\N
92	25017318300	2010	0.000	\N
92	25017318400	2010	0.000	\N
92	25017320102	2010	0.000	\N
92	25017320103	2010	0.000	\N
92	25017320104	2010	0.000	\N
92	25017321100	2010	0.000	\N
92	25017321200	2010	0.000	\N
92	25017321300	2010	9.000	\N
92	25017321400	2010	0.000	\N
92	25017321500	2010	7.000	\N
92	25017321600	2010	0.000	\N
92	25017322100	2010	0.000	\N
92	25017322200	2010	0.000	\N
92	25017322300	2010	0.000	\N
92	25017322400	2010	0.000	\N
92	25017323100	2010	0.000	\N
92	25017324101	2010	0.000	\N
92	25017324102	2010	0.000	\N
92	25017325100	2010	11.000	\N
92	25017326101	2010	1.000	\N
92	25017326102	2010	0.000	\N
92	25017327101	2010	0.000	\N
92	25017327102	2010	0.000	\N
92	25017327103	2010	0.000	\N
92	25017328100	2010	4.000	\N
92	25017330100	2010	0.000	\N
92	25017330200	2010	0.000	\N
92	25017331101	2010	8.000	\N
92	25017331102	2010	0.000	\N
92	25017331200	2010	4.000	\N
92	25017331300	2010	0.000	\N
92	25017332100	2010	0.000	\N
92	25017332200	2010	5.000	\N
92	25017332300	2010	0.000	\N
92	25017332400	2010	0.000	\N
92	25017333100	2010	0.000	\N
92	25017333200	2010	1.000	\N
92	25017333300	2010	0.000	\N
92	25017333400	2010	0.000	\N
92	25017333501	2010	0.000	\N
92	25017333502	2010	1.000	\N
92	25017333600	2010	0.000	\N
92	25017334100	2010	3.000	\N
92	25017334200	2010	0.000	\N
92	25017334300	2010	0.000	\N
92	25017334400	2010	3.000	\N
92	25017335100	2010	0.000	\N
92	25017335200	2010	0.000	\N
92	25017335301	2010	0.000	\N
92	25017335302	2010	0.000	\N
92	25017335400	2010	0.000	\N
92	25017336100	2010	1.000	\N
92	25017336200	2010	0.000	\N
92	25017336300	2010	0.000	\N
92	25017336401	2010	0.000	\N
92	25017336402	2010	0.000	\N
92	25017337101	2010	0.000	\N
92	25017337102	2010	0.000	\N
92	25017337201	2010	0.000	\N
92	25017337202	2010	1.000	\N
92	25017337300	2010	4.000	\N
92	25017338100	2010	0.000	\N
92	25017338200	2010	1.000	\N
92	25017338300	2010	0.000	\N
92	25017338400	2010	2.000	\N
92	25017338500	2010	5.000	\N
92	25017339100	2010	0.000	\N
92	25017339200	2010	1.000	\N
92	25017339300	2010	0.000	\N
92	25017339400	2010	0.000	\N
92	25017339500	2010	0.000	\N
92	25017339600	2010	1.000	\N
92	25017339700	2010	0.000	\N
92	25017339801	2010	0.000	\N
92	25017339802	2010	3.000	\N
92	25017339900	2010	2.000	\N
92	25017340000	2010	0.000	\N
92	25017340100	2010	0.000	\N
92	25017341101	2010	0.000	\N
92	25017341102	2010	0.000	\N
92	25017341200	2010	1.000	\N
92	25017341300	2010	1.000	\N
92	25017341400	2010	1.000	\N
92	25017341500	2010	1.000	\N
92	25017341600	2010	3.000	\N
92	25017341700	2010	1.000	\N
92	25017341800	2010	2.000	\N
92	25017341901	2010	0.000	\N
92	25017341902	2010	4.000	\N
92	25017342101	2010	3.000	\N
92	25017342102	2010	0.000	\N
92	25017342201	2010	1.000	\N
92	25017342202	2010	0.000	\N
92	25017342300	2010	0.000	\N
92	25017342400	2010	5.000	\N
92	25017342500	2010	0.000	\N
92	25017342600	2010	4.000	\N
92	25017350103	2010	0.000	\N
92	25017350104	2010	1.000	\N
92	25017350200	2010	1.000	\N
92	25017350300	2010	0.000	\N
92	25017350400	2010	0.000	\N
92	25017350500	2010	1.000	\N
92	25017350600	2010	0.000	\N
92	25017350700	2010	0.000	\N
92	25017350800	2010	0.000	\N
92	25017350900	2010	1.000	\N
92	25017351000	2010	3.000	\N
92	25017351100	2010	3.000	\N
92	25017351203	2010	2.000	\N
92	25017351204	2010	1.000	\N
92	25017351300	2010	1.000	\N
92	25017351403	2010	1.000	\N
92	25017351404	2010	1.000	\N
92	25017351500	2010	0.000	\N
92	25017352101	2010	0.000	\N
92	25017352102	2010	2.000	\N
92	25017352200	2010	0.000	\N
92	25017352300	2010	0.000	\N
92	25017352400	2010	0.000	\N
92	25017352500	2010	4.000	\N
92	25017352600	2010	0.000	\N
92	25017352700	2010	1.000	\N
92	25017352800	2010	0.000	\N
92	25017352900	2010	0.000	\N
92	25017353000	2010	3.000	\N
92	25017353101	2010	1.000	\N
92	25017353102	2010	0.000	\N
92	25017353200	2010	3.000	\N
92	25017353300	2010	3.000	\N
92	25017353400	2010	1.000	\N
92	25017353500	2010	3.000	\N
92	25017353600	2010	1.000	\N
92	25017353700	2010	0.000	\N
92	25017353800	2010	0.000	\N
92	25017353900	2010	2.000	\N
92	25017354000	2010	0.000	\N
92	25017354100	2010	1.000	\N
92	25017354200	2010	0.000	\N
92	25017354300	2010	0.000	\N
92	25017354400	2010	0.000	\N
92	25017354500	2010	0.000	\N
92	25017354600	2010	0.000	\N
92	25017354700	2010	1.000	\N
92	25017354800	2010	0.000	\N
92	25017354900	2010	5.000	\N
92	25017355000	2010	0.000	\N
92	25017356100	2010	1.000	\N
92	25017356300	2010	4.000	\N
92	25017356400	2010	0.000	\N
92	25017356500	2010	1.000	\N
92	25017356601	2010	0.000	\N
92	25017356602	2010	0.000	\N
92	25017356701	2010	0.000	\N
92	25017356702	2010	1.000	\N
92	25017357100	2010	0.000	\N
92	25017357200	2010	0.000	\N
92	25017357300	2010	1.000	\N
92	25017357400	2010	0.000	\N
92	25017357500	2010	0.000	\N
92	25017357600	2010	1.000	\N
92	25017357700	2010	1.000	\N
92	25017357800	2010	0.000	\N
92	25017358100	2010	0.000	\N
92	25017358300	2010	2.000	\N
92	25017358400	2010	0.000	\N
92	25017358500	2010	0.000	\N
92	25017358600	2010	1.000	\N
92	25017358700	2010	0.000	\N
92	25017359100	2010	3.000	\N
92	25017359300	2010	0.000	\N
92	25017360100	2010	3.000	\N
92	25017360200	2010	3.000	\N
92	25017361100	2010	0.000	\N
92	25017361200	2010	0.000	\N
92	25017361300	2010	0.000	\N
92	25017362100	2010	1.000	\N
92	25017363102	2010	0.000	\N
92	25017363103	2010	0.000	\N
92	25017363104	2010	3.000	\N
92	25017363201	2010	0.000	\N
92	25017363202	2010	0.000	\N
92	25017364101	2010	1.000	\N
92	25017364102	2010	0.000	\N
92	25017365100	2010	2.000	\N
92	25017365201	2010	3.000	\N
92	25017365202	2010	1.000	\N
92	25017366100	2010	2.000	\N
92	25017366201	2010	0.000	\N
92	25017366202	2010	0.000	\N
92	25017367100	2010	0.000	\N
92	25017367200	2010	0.000	\N
92	25017368101	2010	0.000	\N
92	25017368102	2010	0.000	\N
92	25017368200	2010	0.000	\N
92	25017368300	2010	1.000	\N
92	25017368400	2010	2.000	\N
92	25017368500	2010	9.000	\N
92	25017368600	2010	6.000	\N
92	25017368700	2010	4.000	\N
92	25017368800	2010	3.000	\N
92	25017368901	2010	3.000	\N
92	25017368902	2010	1.000	\N
92	25017369000	2010	0.000	\N
92	25017369100	2010	2.000	\N
92	25017370101	2010	1.000	\N
92	25017370102	2010	1.000	\N
92	25017370201	2010	0.000	\N
92	25017370202	2010	0.000	\N
92	25017370300	2010	7.000	\N
92	25017370400	2010	1.000	\N
92	25017373100	2010	1.000	\N
92	25017373200	2010	2.000	\N
92	25017373300	2010	0.000	\N
92	25017373400	2010	0.000	\N
92	25017373500	2010	3.000	\N
92	25017373600	2010	1.000	\N
92	25017373700	2010	1.000	\N
92	25017373800	2010	1.000	\N
92	25017373900	2010	2.000	\N
92	25017374000	2010	0.000	\N
92	25017374100	2010	4.000	\N
92	25017374200	2010	2.000	\N
92	25017374300	2010	0.000	\N
92	25017374400	2010	1.000	\N
92	25017374500	2010	0.000	\N
92	25017374600	2010	0.000	\N
92	25017374700	2010	0.000	\N
92	25017374800	2010	0.000	\N
92	25017382100	2010	0.000	\N
92	25017382200	2010	0.000	\N
92	25017382300	2010	1.000	\N
92	25017382400	2010	1.000	\N
92	25017382500	2010	1.000	\N
92	25017382601	2010	1.000	\N
92	25017382602	2010	5.000	\N
92	25017383101	2010	6.000	\N
92	25017383102	2010	0.000	\N
92	25017383200	2010	2.000	\N
92	25017383300	2010	1.000	\N
92	25017383400	2010	3.000	\N
92	25017383501	2010	2.000	\N
92	25017383502	2010	0.000	\N
92	25017383600	2010	1.000	\N
92	25017383700	2010	0.000	\N
92	25017383800	2010	0.000	\N
92	25017383901	2010	2.000	\N
92	25017383902	2010	0.000	\N
92	25017384001	2010	0.000	\N
92	25017384002	2010	1.000	\N
92	25017385100	2010	0.000	\N
92	25017385201	2010	0.000	\N
92	25017385202	2010	0.000	\N
92	25017386100	2010	0.000	\N
92	25017387100	2010	0.000	\N
92	25017387201	2010	2.000	\N
92	25017387202	2010	0.000	\N
92	25017388100	2010	1.000	\N
92	25017388200	2010	5.000	\N
92	25017388300	2010	4.000	\N
92	25017980000	2010	0.000	\N
92	25019950100	2010	0.000	\N
92	25019950200	2010	1.000	\N
92	25019950307	2010	0.000	\N
92	25019950400	2010	0.000	\N
92	25019950500	2010	0.000	\N
92	25019990000	2010	0.000	\N
92	25021400100	2010	1.000	\N
92	25021400200	2010	0.000	\N
92	25021400300	2010	0.000	\N
92	25021400400	2010	0.000	\N
92	25021400500	2010	1.000	\N
92	25021400600	2010	0.000	\N
92	25021400700	2010	0.000	\N
92	25021400800	2010	8.000	\N
92	25021400900	2010	0.000	\N
92	25021401000	2010	0.000	\N
92	25021401100	2010	0.000	\N
92	25021401200	2010	2.000	\N
92	25021402101	2010	0.000	\N
92	25021402102	2010	0.000	\N
92	25021402200	2010	1.000	\N
92	25021402300	2010	1.000	\N
92	25021402400	2010	0.000	\N
92	25021402500	2010	2.000	\N
92	25021403100	2010	0.000	\N
92	25021403300	2010	1.000	\N
92	25021403400	2010	1.000	\N
92	25021403500	2010	6.000	\N
92	25021404100	2010	0.000	\N
92	25021404201	2010	0.000	\N
92	25021404202	2010	1.000	\N
92	25021404301	2010	0.000	\N
92	25021404302	2010	0.000	\N
92	25021404400	2010	0.000	\N
92	25021405100	2010	3.000	\N
92	25021406101	2010	0.000	\N
92	25021406102	2010	0.000	\N
92	25021407100	2010	0.000	\N
92	25021408101	2010	1.000	\N
92	25021408102	2010	0.000	\N
92	25021409101	2010	0.000	\N
92	25021409102	2010	0.000	\N
92	25021410100	2010	2.000	\N
92	25021410300	2010	0.000	\N
92	25021410400	2010	2.000	\N
92	25021411100	2010	0.000	\N
92	25021411200	2010	1.000	\N
92	25021411301	2010	0.000	\N
92	25021411302	2010	0.000	\N
92	25021412100	2010	0.000	\N
92	25021412200	2010	0.000	\N
92	25021412300	2010	0.000	\N
92	25021413100	2010	0.000	\N
92	25021413200	2010	3.000	\N
92	25021413300	2010	0.000	\N
92	25021413401	2010	0.000	\N
92	25021413402	2010	2.000	\N
92	25021413500	2010	0.000	\N
92	25021414100	2010	4.000	\N
92	25021414200	2010	2.000	\N
92	25021414300	2010	0.000	\N
92	25021415101	2010	0.000	\N
92	25021415102	2010	1.000	\N
92	25021415200	2010	0.000	\N
92	25021415300	2010	0.000	\N
92	25021416101	2010	4.000	\N
92	25021416102	2010	1.000	\N
92	25021416200	2010	0.000	\N
92	25021416300	2010	0.000	\N
92	25021416400	2010	0.000	\N
92	25021417100	2010	5.000	\N
92	25021417200	2010	2.000	\N
92	25021417300	2010	1.000	\N
92	25021417400	2010	0.000	\N
92	25021417501	2010	0.000	\N
92	25021417502	2010	0.000	\N
92	25021417601	2010	0.000	\N
92	25021417602	2010	0.000	\N
92	25021417701	2010	0.000	\N
92	25021417702	2010	0.000	\N
92	25021417801	2010	1.000	\N
92	25021417802	2010	0.000	\N
92	25021417901	2010	5.000	\N
92	25021417902	2010	0.000	\N
92	25021418002	2010	0.000	\N
92	25021418003	2010	4.000	\N
92	25021418004	2010	1.000	\N
92	25021418101	2010	1.000	\N
92	25021418102	2010	1.000	\N
92	25021418200	2010	0.000	\N
92	25021419100	2010	0.000	\N
92	25021419200	2010	1.000	\N
92	25021419300	2010	8.000	\N
92	25021419400	2010	1.000	\N
92	25021419500	2010	0.000	\N
92	25021419600	2010	0.000	\N
92	25021419700	2010	0.000	\N
92	25021419800	2010	0.000	\N
92	25021420100	2010	0.000	\N
92	25021420201	2010	1.000	\N
92	25021420202	2010	0.000	\N
92	25021420301	2010	0.000	\N
92	25021420302	2010	2.000	\N
92	25021421100	2010	1.000	\N
92	25021421200	2010	1.000	\N
92	25021422100	2010	0.000	\N
92	25021422200	2010	4.000	\N
92	25021422301	2010	0.000	\N
92	25021422302	2010	4.000	\N
92	25021422400	2010	0.000	\N
92	25021422501	2010	0.000	\N
92	25021422502	2010	2.000	\N
92	25021422600	2010	0.000	\N
92	25021422700	2010	0.000	\N
92	25021422800	2010	0.000	\N
92	25021423100	2010	1.000	\N
92	25021440100	2010	0.000	\N
92	25021441202	2010	0.000	\N
92	25021441203	2010	0.000	\N
92	25021441204	2010	0.000	\N
92	25021442101	2010	0.000	\N
92	25021442102	2010	1.000	\N
92	25021442103	2010	1.000	\N
92	25021442201	2010	1.000	\N
92	25021442202	2010	1.000	\N
92	25021443101	2010	2.000	\N
92	25021443102	2010	1.000	\N
92	25021456101	2010	0.000	\N
92	25021456102	2010	0.000	\N
92	25021456200	2010	0.000	\N
92	25021456301	2010	0.000	\N
92	25021456302	2010	1.000	\N
92	25021456401	2010	0.000	\N
92	25021456402	2010	1.000	\N
92	25021457100	2010	0.000	\N
92	25021457200	2010	0.000	\N
92	25023500101	2010	1.000	\N
92	25023500103	2010	0.000	\N
92	25023500104	2010	4.000	\N
92	25023501101	2010	5.000	\N
92	25023501102	2010	2.000	\N
92	25023501201	2010	1.000	\N
92	25023501202	2010	0.000	\N
92	25023502101	2010	1.000	\N
92	25023502102	2010	4.000	\N
92	25023502200	2010	0.000	\N
92	25023503101	2010	1.000	\N
92	25023503102	2010	3.000	\N
92	25023504101	2010	0.000	\N
92	25023504102	2010	0.000	\N
92	25023505101	2010	3.000	\N
92	25023505102	2010	3.000	\N
92	25023505200	2010	1.000	\N
92	25023506101	2010	2.000	\N
92	25023506102	2010	0.000	\N
92	25023506202	2010	1.000	\N
92	25023506203	2010	0.000	\N
92	25023506204	2010	1.000	\N
92	25023507101	2010	0.000	\N
92	25023507103	2010	0.000	\N
92	25023507104	2010	2.000	\N
92	25023508101	2010	0.000	\N
92	25023508102	2010	1.000	\N
92	25023508200	2010	2.000	\N
92	25023509101	2010	1.000	\N
92	25023509102	2010	0.000	\N
92	25023510100	2010	0.000	\N
92	25023510200	2010	1.000	\N
92	25023510300	2010	4.000	\N
92	25023510400	2010	0.000	\N
92	25023510501	2010	0.000	\N
92	25023510502	2010	2.000	\N
92	25023510503	2010	1.000	\N
92	25023510600	2010	0.000	\N
92	25023510700	2010	2.000	\N
92	25023510800	2010	8.000	\N
92	25023510900	2010	2.000	\N
92	25023511000	2010	5.000	\N
92	25023511100	2010	0.000	\N
92	25023511200	2010	0.000	\N
92	25023511301	2010	0.000	\N
92	25023511302	2010	0.000	\N
92	25023511400	2010	1.000	\N
92	25023511500	2010	6.000	\N
92	25023511600	2010	1.000	\N
92	25023511701	2010	1.000	\N
92	25023511702	2010	3.000	\N
92	25023520100	2010	2.000	\N
92	25023520201	2010	0.000	\N
92	25023520202	2010	0.000	\N
92	25023521101	2010	4.000	\N
92	25023521102	2010	1.000	\N
92	25023521201	2010	0.000	\N
92	25023521202	2010	0.000	\N
92	25023522101	2010	0.000	\N
92	25023522102	2010	1.000	\N
92	25023523100	2010	0.000	\N
92	25023523201	2010	0.000	\N
92	25023523202	2010	0.000	\N
92	25023524101	2010	0.000	\N
92	25023524102	2010	0.000	\N
92	25023525101	2010	0.000	\N
92	25023525104	2010	0.000	\N
92	25023525203	2010	0.000	\N
92	25023525204	2010	0.000	\N
92	25023525300	2010	0.000	\N
92	25023526100	2010	0.000	\N
92	25023530100	2010	1.000	\N
92	25023530200	2010	3.000	\N
92	25023530300	2010	3.000	\N
92	25023530400	2010	0.000	\N
92	25023530500	2010	2.000	\N
92	25023530600	2010	2.000	\N
92	25023530700	2010	3.000	\N
92	25023530801	2010	2.000	\N
92	25023530802	2010	0.000	\N
92	25023530901	2010	4.000	\N
92	25023530902	2010	2.000	\N
92	25023540101	2010	0.000	\N
92	25023540102	2010	0.000	\N
92	25023540103	2010	1.000	\N
92	25023541100	2010	0.000	\N
92	25023542101	2010	0.000	\N
92	25023542102	2010	0.000	\N
92	25023542200	2010	0.000	\N
92	25023542300	2010	2.000	\N
92	25023543100	2010	0.000	\N
92	25023544100	2010	0.000	\N
92	25023544200	2010	1.000	\N
92	25023545100	2010	1.000	\N
92	25023545200	2010	4.000	\N
92	25023545300	2010	0.000	\N
92	25023545400	2010	0.000	\N
92	25023560100	2010	1.000	\N
92	25023561100	2010	2.000	\N
92	25023561200	2010	0.000	\N
92	25023990003	2010	0.000	\N
92	25025000100	2010	0.000	\N
92	25025000201	2010	2.000	\N
92	25025000202	2010	0.000	\N
92	25025000301	2010	0.000	\N
92	25025000302	2010	0.000	\N
92	25025000401	2010	1.000	\N
92	25025000402	2010	2.000	\N
92	25025000502	2010	2.000	\N
92	25025000503	2010	0.000	\N
92	25025000504	2010	3.000	\N
92	25025000601	2010	0.000	\N
92	25025000602	2010	2.000	\N
92	25025000701	2010	4.000	\N
92	25025000703	2010	1.000	\N
92	25025000704	2010	4.000	\N
92	25025000802	2010	3.000	\N
92	25025000803	2010	1.000	\N
92	25025010103	2010	0.000	\N
92	25025010104	2010	0.000	\N
92	25025010203	2010	4.000	\N
92	25025010204	2010	0.000	\N
92	25025010300	2010	4.000	\N
92	25025010403	2010	0.000	\N
92	25025010404	2010	4.000	\N
92	25025010405	2010	2.000	\N
92	25025010408	2010	1.000	\N
92	25025010500	2010	1.000	\N
92	25025010600	2010	0.000	\N
92	25025010701	2010	0.000	\N
92	25025010702	2010	1.000	\N
92	25025010801	2010	0.000	\N
92	25025010802	2010	0.000	\N
92	25025020101	2010	1.000	\N
92	25025020200	2010	0.000	\N
92	25025020301	2010	0.000	\N
92	25025020302	2010	0.000	\N
92	25025020303	2010	1.000	\N
92	25025030100	2010	2.000	\N
92	25025030200	2010	1.000	\N
92	25025030300	2010	1.000	\N
92	25025030400	2010	0.000	\N
92	25025030500	2010	0.000	\N
92	25025040100	2010	0.000	\N
92	25025040200	2010	0.000	\N
92	25025040300	2010	0.000	\N
92	25025040401	2010	1.000	\N
92	25025040600	2010	1.000	\N
92	25025040801	2010	8.000	\N
92	25025050101	2010	0.000	\N
92	25025050200	2010	1.000	\N
92	25025050300	2010	0.000	\N
92	25025050400	2010	0.000	\N
92	25025050500	2010	0.000	\N
92	25025050600	2010	0.000	\N
92	25025050700	2010	0.000	\N
92	25025050901	2010	0.000	\N
92	25025051000	2010	1.000	\N
92	25025051101	2010	1.000	\N
92	25025051200	2010	0.000	\N
92	25025060101	2010	1.000	\N
92	25025060200	2010	0.000	\N
92	25025060301	2010	0.000	\N
92	25025060400	2010	2.000	\N
92	25025060501	2010	1.000	\N
92	25025060600	2010	1.000	\N
92	25025060700	2010	0.000	\N
92	25025060800	2010	1.000	\N
92	25025061000	2010	0.000	\N
92	25025061101	2010	2.000	\N
92	25025061200	2010	3.000	\N
92	25025070101	2010	3.000	\N
92	25025070200	2010	1.000	\N
92	25025070300	2010	1.000	\N
92	25025070402	2010	0.000	\N
92	25025070500	2010	0.000	\N
92	25025070600	2010	1.000	\N
92	25025070700	2010	0.000	\N
92	25025070800	2010	0.000	\N
92	25025070900	2010	1.000	\N
92	25025071101	2010	1.000	\N
92	25025071201	2010	4.000	\N
92	25025080100	2010	0.000	\N
92	25025080300	2010	0.000	\N
92	25025080401	2010	0.000	\N
92	25025080500	2010	1.000	\N
92	25025080601	2010	0.000	\N
92	25025080801	2010	0.000	\N
92	25025080900	2010	4.000	\N
92	25025081001	2010	3.000	\N
92	25025081100	2010	1.000	\N
92	25025081200	2010	0.000	\N
92	25025081300	2010	5.000	\N
92	25025081400	2010	0.000	\N
92	25025081500	2010	2.000	\N
92	25025081700	2010	1.000	\N
92	25025081800	2010	4.000	\N
92	25025081900	2010	0.000	\N
92	25025082000	2010	1.000	\N
92	25025082100	2010	1.000	\N
92	25025090100	2010	1.000	\N
92	25025090200	2010	0.000	\N
92	25025090300	2010	1.000	\N
92	25025090400	2010	2.000	\N
92	25025090600	2010	3.000	\N
92	25025090700	2010	0.000	\N
92	25025090901	2010	5.000	\N
92	25025091001	2010	2.000	\N
92	25025091100	2010	0.000	\N
92	25025091200	2010	5.000	\N
92	25025091300	2010	1.000	\N
92	25025091400	2010	1.000	\N
92	25025091500	2010	0.000	\N
92	25025091600	2010	0.000	\N
92	25025091700	2010	0.000	\N
92	25025091800	2010	0.000	\N
92	25025091900	2010	0.000	\N
92	25025092000	2010	4.000	\N
92	25025092101	2010	3.000	\N
92	25025092200	2010	0.000	\N
92	25025092300	2010	0.000	\N
92	25025092400	2010	0.000	\N
92	25025100100	2010	4.000	\N
92	25025100200	2010	0.000	\N
92	25025100300	2010	0.000	\N
92	25025100400	2010	0.000	\N
92	25025100500	2010	1.000	\N
92	25025100601	2010	2.000	\N
92	25025100603	2010	1.000	\N
92	25025100700	2010	0.000	\N
92	25025100800	2010	1.000	\N
92	25025100900	2010	0.000	\N
92	25025101001	2010	0.000	\N
92	25025101002	2010	0.000	\N
92	25025101101	2010	0.000	\N
92	25025101102	2010	3.000	\N
92	25025110103	2010	2.000	\N
92	25025110201	2010	0.000	\N
92	25025110301	2010	0.000	\N
92	25025110401	2010	5.000	\N
92	25025110403	2010	4.000	\N
92	25025110501	2010	0.000	\N
92	25025110502	2010	0.000	\N
92	25025110601	2010	1.000	\N
92	25025110607	2010	0.000	\N
92	25025120103	2010	0.000	\N
92	25025120104	2010	0.000	\N
92	25025120105	2010	1.000	\N
92	25025120201	2010	0.000	\N
92	25025120301	2010	0.000	\N
92	25025120400	2010	2.000	\N
92	25025120500	2010	0.000	\N
92	25025120600	2010	1.000	\N
92	25025120700	2010	0.000	\N
92	25025130100	2010	0.000	\N
92	25025130200	2010	1.000	\N
92	25025130300	2010	2.000	\N
92	25025130402	2010	2.000	\N
92	25025130404	2010	1.000	\N
92	25025130406	2010	0.000	\N
92	25025140102	2010	1.000	\N
92	25025140105	2010	2.000	\N
92	25025140106	2010	0.000	\N
92	25025140107	2010	0.000	\N
92	25025140201	2010	0.000	\N
92	25025140202	2010	3.000	\N
92	25025140300	2010	0.000	\N
92	25025140400	2010	4.000	\N
92	25025160101	2010	0.000	\N
92	25025160200	2010	0.000	\N
92	25025160300	2010	0.000	\N
92	25025160400	2010	0.000	\N
92	25025160501	2010	0.000	\N
92	25025160502	2010	0.000	\N
92	25025160601	2010	2.000	\N
92	25025160602	2010	0.000	\N
92	25025170100	2010	4.000	\N
92	25025170200	2010	0.000	\N
92	25025170300	2010	1.000	\N
92	25025170400	2010	0.000	\N
92	25025170501	2010	0.000	\N
92	25025170502	2010	0.000	\N
92	25025170601	2010	0.000	\N
92	25025170701	2010	1.000	\N
92	25025170702	2010	0.000	\N
92	25025170800	2010	0.000	\N
92	25025180101	2010	0.000	\N
92	25025180200	2010	0.000	\N
92	25025180301	2010	4.000	\N
92	25025180400	2010	0.000	\N
92	25025180500	2010	2.000	\N
92	25025980101	2010	1.000	\N
92	25025980300	2010	0.000	\N
92	25025980700	2010	1.000	\N
92	25025981000	2010	0.000	\N
92	25025981100	2010	0.000	\N
92	25025981201	2010	0.000	\N
92	25025981202	2010	1.000	\N
92	25025981300	2010	0.000	\N
92	25025981501	2010	0.000	\N
92	25025981502	2010	0.000	\N
92	25025981600	2010	0.000	\N
92	25025981700	2010	0.000	\N
92	25025981800	2010	0.000	\N
92	25025990101	2010	0.000	\N
92	25027700100	2010	2.000	\N
92	25027701100	2010	0.000	\N
92	25027702200	2010	0.000	\N
92	25027703100	2010	0.000	\N
92	25027703200	2010	0.000	\N
92	25027703300	2010	0.000	\N
92	25027704200	2010	0.000	\N
92	25027705100	2010	0.000	\N
92	25027706100	2010	0.000	\N
92	25027707100	2010	1.000	\N
92	25027707200	2010	0.000	\N
92	25027707300	2010	0.000	\N
92	25027707400	2010	0.000	\N
92	25027707500	2010	3.000	\N
92	25027708100	2010	0.000	\N
92	25027709100	2010	0.000	\N
92	25027709201	2010	5.000	\N
92	25027709202	2010	8.000	\N
92	25027709400	2010	0.000	\N
92	25027709501	2010	0.000	\N
92	25027709502	2010	1.000	\N
92	25027709600	2010	0.000	\N
92	25027709701	2010	1.000	\N
92	25027709702	2010	1.000	\N
92	25027710100	2010	0.000	\N
92	25027710200	2010	1.000	\N
92	25027710300	2010	0.000	\N
92	25027710400	2010	0.000	\N
92	25027710500	2010	0.000	\N
92	25027710600	2010	0.000	\N
92	25027710700	2010	0.000	\N
92	25027710800	2010	1.000	\N
92	25027711000	2010	2.000	\N
92	25027711100	2010	3.000	\N
92	25027712101	2010	0.000	\N
92	25027712102	2010	0.000	\N
92	25027713100	2010	0.000	\N
92	25027715100	2010	1.000	\N
92	25027716100	2010	2.000	\N
92	25027716200	2010	0.000	\N
92	25027716300	2010	0.000	\N
92	25027717100	2010	0.000	\N
92	25027718100	2010	0.000	\N
92	25027719100	2010	5.000	\N
92	25027720100	2010	0.000	\N
92	25027721101	2010	1.000	\N
92	25027721102	2010	1.000	\N
92	25027722100	2010	0.000	\N
92	25027723100	2010	2.000	\N
92	25027724100	2010	0.000	\N
92	25027725100	2010	3.000	\N
92	25027726100	2010	2.000	\N
92	25027726200	2010	3.000	\N
92	25027727100	2010	1.000	\N
92	25027728100	2010	0.000	\N
92	25027728200	2010	0.000	\N
92	25027728300	2010	0.000	\N
92	25027728400	2010	2.000	\N
92	25027729100	2010	1.000	\N
92	25027729200	2010	1.000	\N
92	25027730100	2010	3.000	\N
92	25027730200	2010	2.000	\N
92	25027730300	2010	0.000	\N
92	25027730401	2010	1.000	\N
92	25027730402	2010	0.000	\N
92	25027730500	2010	3.000	\N
92	25027730600	2010	1.000	\N
92	25027730700	2010	1.000	\N
92	25027730801	2010	0.000	\N
92	25027730802	2010	0.000	\N
92	25027730901	2010	0.000	\N
92	25027730902	2010	1.000	\N
92	25027731001	2010	3.000	\N
92	25027731002	2010	0.000	\N
92	25027731101	2010	0.000	\N
92	25027731102	2010	0.000	\N
92	25027731202	2010	0.000	\N
92	25027731203	2010	2.000	\N
92	25027731204	2010	0.000	\N
92	25027731300	2010	0.000	\N
92	25027731400	2010	1.000	\N
92	25027731500	2010	0.000	\N
92	25027731600	2010	3.000	\N
92	25027731700	2010	0.000	\N
92	25027731800	2010	0.000	\N
92	25027731900	2010	0.000	\N
92	25027732001	2010	0.000	\N
92	25027732002	2010	2.000	\N
92	25027732201	2010	0.000	\N
92	25027732202	2010	6.000	\N
92	25027732203	2010	2.000	\N
92	25027732301	2010	0.000	\N
92	25027732302	2010	0.000	\N
92	25027732400	2010	15.000	\N
92	25027732500	2010	1.000	\N
92	25027732600	2010	0.000	\N
92	25027732700	2010	2.000	\N
92	25027732801	2010	0.000	\N
92	25027732802	2010	0.000	\N
92	25027732901	2010	1.000	\N
92	25027732902	2010	0.000	\N
92	25027733000	2010	1.000	\N
92	25027733101	2010	1.000	\N
92	25027733102	2010	0.000	\N
92	25027735100	2010	0.000	\N
92	25027735200	2010	6.000	\N
92	25027736100	2010	0.000	\N
92	25027736200	2010	1.000	\N
92	25027736300	2010	2.000	\N
92	25027736400	2010	0.000	\N
92	25027736500	2010	0.000	\N
92	25027737100	2010	1.000	\N
92	25027737200	2010	4.000	\N
92	25027737300	2010	3.000	\N
92	25027738100	2010	2.000	\N
92	25027738201	2010	0.000	\N
92	25027738202	2010	0.000	\N
92	25027739100	2010	5.000	\N
92	25027739200	2010	0.000	\N
92	25027739300	2010	0.000	\N
92	25027739400	2010	0.000	\N
92	25027739500	2010	0.000	\N
92	25027740101	2010	0.000	\N
92	25027740102	2010	2.000	\N
92	25027740200	2010	0.000	\N
92	25027741101	2010	0.000	\N
92	25027741102	2010	0.000	\N
92	25027742300	2010	0.000	\N
92	25027742401	2010	0.000	\N
92	25027742402	2010	0.000	\N
92	25027743100	2010	1.000	\N
92	25027744101	2010	1.000	\N
92	25027744102	2010	0.000	\N
92	25027744200	2010	0.000	\N
92	25027744300	2010	0.000	\N
92	25027744400	2010	1.000	\N
92	25027745100	2010	1.000	\N
92	25027746100	2010	2.000	\N
92	25027747101	2010	1.000	\N
92	25027747102	2010	2.000	\N
92	25027748100	2010	0.000	\N
92	25027749100	2010	1.000	\N
92	25027749200	2010	1.000	\N
92	25027750100	2010	1.000	\N
92	25027750200	2010	0.000	\N
92	25027750300	2010	0.000	\N
92	25027751101	2010	6.000	\N
92	25027751102	2010	2.000	\N
92	25027752100	2010	3.000	\N
92	25027753100	2010	2.000	\N
92	25027753200	2010	0.000	\N
92	25027754100	2010	0.000	\N
92	25027754200	2010	0.000	\N
92	25027754300	2010	0.000	\N
92	25027754400	2010	0.000	\N
92	25027755100	2010	1.000	\N
92	25027755200	2010	0.000	\N
92	25027756101	2010	0.000	\N
92	25027756102	2010	8.000	\N
92	25027757100	2010	1.000	\N
92	25027757200	2010	0.000	\N
92	25027757300	2010	0.000	\N
92	25027757400	2010	1.000	\N
92	25027757500	2010	1.000	\N
92	25027758101	2010	0.000	\N
92	25027758102	2010	0.000	\N
92	25027759100	2010	0.000	\N
92	25027760100	2010	0.000	\N
92	25027761100	2010	2.000	\N
92	25027761200	2010	4.000	\N
92	25027761300	2010	0.000	\N
92	25027761400	2010	3.000	\N
93	25001010100	2010	9.000	\N
93	25001010206	2010	7.000	\N
93	25001010208	2010	4.000	\N
93	25001010304	2010	5.000	\N
93	25001010306	2010	2.000	\N
93	25001010400	2010	12.000	\N
93	25001010500	2010	6.000	\N
93	25001010600	2010	10.000	\N
93	25001010700	2010	6.000	\N
93	25001010800	2010	6.000	\N
93	25001010900	2010	23.000	\N
93	25001011002	2010	110.000	\N
93	25001011100	2010	31.000	\N
93	25001011200	2010	48.000	\N
93	25001011300	2010	12.000	\N
93	25001011400	2010	4.000	\N
93	25001011500	2010	43.000	\N
93	25001011600	2010	52.000	\N
93	25001011700	2010	20.000	\N
93	25001011801	2010	2.000	\N
93	25001011802	2010	26.000	\N
93	25001012001	2010	51.000	\N
93	25001012002	2010	43.000	\N
93	25001012101	2010	102.000	\N
93	25001012102	2010	57.000	\N
93	25001012200	2010	10.000	\N
93	25001012502	2010	117.000	\N
93	25001012601	2010	67.000	\N
93	25001012602	2010	214.000	\N
93	25001012700	2010	88.000	\N
93	25001012800	2010	44.000	\N
93	25001012900	2010	70.000	\N
93	25001013002	2010	26.000	\N
93	25001013100	2010	29.000	\N
93	25001013200	2010	23.000	\N
93	25001013300	2010	10.000	\N
93	25001013400	2010	4.000	\N
93	25001013500	2010	12.000	\N
93	25001013600	2010	8.000	\N
93	25001013700	2010	35.000	\N
93	25001013800	2010	24.000	\N
93	25001013900	2010	31.000	\N
93	25001014002	2010	31.000	\N
93	25001014100	2010	5.000	\N
93	25001014300	2010	24.000	\N
93	25001014402	2010	93.000	\N
93	25001014500	2010	85.000	\N
93	25001014600	2010	61.000	\N
93	25001014700	2010	66.000	\N
93	25001014800	2010	63.000	\N
93	25001014900	2010	16.000	\N
93	25001015001	2010	52.000	\N
93	25001015002	2010	49.000	\N
93	25001015100	2010	27.000	\N
93	25001015200	2010	5.000	\N
93	25001015300	2010	204.000	\N
93	25001990000	2010	0.000	\N
93	25003900100	2010	16.000	\N
93	25003900200	2010	20.000	\N
93	25003900300	2010	6.000	\N
93	25003900400	2010	12.000	\N
93	25003900500	2010	6.000	\N
93	25003900600	2010	29.000	\N
93	25003900700	2010	0.000	\N
93	25003900800	2010	8.000	\N
93	25003900900	2010	12.000	\N
93	25003901100	2010	1.000	\N
93	25003911100	2010	1.000	\N
93	25003912100	2010	4.000	\N
93	25003913100	2010	17.000	\N
93	25003914100	2010	23.000	\N
93	25003920101	2010	7.000	\N
93	25003920102	2010	9.000	\N
93	25003921300	2010	6.000	\N
93	25003921400	2010	0.000	\N
93	25003921500	2010	4.000	\N
93	25003922100	2010	1.000	\N
93	25003922200	2010	4.000	\N
93	25003922300	2010	0.000	\N
93	25003923100	2010	1.000	\N
93	25003924100	2010	8.000	\N
93	25003925100	2010	24.000	\N
93	25003926100	2010	2.000	\N
93	25003931100	2010	0.000	\N
93	25003931300	2010	0.000	\N
93	25003931400	2010	1.000	\N
93	25003932200	2010	4.000	\N
93	25003932300	2010	0.000	\N
93	25003933200	2010	0.000	\N
93	25003933300	2010	0.000	\N
93	25003933400	2010	3.000	\N
93	25003934200	2010	1.000	\N
93	25003934300	2010	0.000	\N
93	25003935100	2010	2.000	\N
93	25003935200	2010	4.000	\N
93	25003935300	2010	3.000	\N
93	25005600100	2010	26.000	\N
93	25005600202	2010	43.000	\N
93	25005600203	2010	11.000	\N
93	25005600204	2010	16.000	\N
93	25005610100	2010	10.000	\N
93	25005610202	2010	18.000	\N
93	25005610203	2010	17.000	\N
93	25005610204	2010	15.000	\N
93	25005611101	2010	16.000	\N
93	25005611102	2010	12.000	\N
93	25005611201	2010	1.000	\N
93	25005611202	2010	13.000	\N
93	25005612100	2010	16.000	\N
93	25005612200	2010	42.000	\N
93	25005613100	2010	64.000	\N
93	25005613300	2010	54.000	\N
93	25005613400	2010	43.000	\N
93	25005613600	2010	68.000	\N
93	25005613700	2010	57.000	\N
93	25005613800	2010	131.000	\N
93	25005613901	2010	92.000	\N
93	25005613902	2010	79.000	\N
93	25005614000	2010	132.000	\N
93	25005614101	2010	89.000	\N
93	25005614102	2010	58.000	\N
93	25005615100	2010	14.000	\N
93	25005616100	2010	37.000	\N
93	25005617101	2010	16.000	\N
93	25005617102	2010	41.000	\N
93	25005630101	2010	5.000	\N
93	25005630102	2010	6.000	\N
1	25025000401	2010	2965.000	100.00
1	25025000402	2010	1543.000	100.00
1	25025000100	2010	1707.000	100.00
1	25025000201	2010	1618.000	100.00
1	25025000202	2010	1522.000	100.00
1	25025000301	2010	1219.000	100.00
1	25025000302	2010	1346.000	100.00
1	25025000502	2010	2041.000	100.00
1	25025000503	2010	1408.000	100.00
1	25025000504	2010	2726.000	100.00
1	25025000601	2010	1525.000	100.00
1	25025000602	2010	2035.000	100.00
1	25025000701	2010	2359.000	100.00
1	25025000703	2010	1418.000	100.00
1	25025000704	2010	2405.000	100.00
1	25025000802	2010	3129.000	100.00
1	25025000803	2010	946.000	100.00
1	25025010103	2010	528.000	100.00
1	25025010104	2010	2136.000	100.00
1	25025010203	2010	3663.000	100.00
1	25025010204	2010	1283.000	100.00
1	25025010300	2010	416.000	100.00
1	25025010403	2010	2076.000	100.00
1	25025010404	2010	1862.000	100.00
1	25025010405	2010	994.000	100.00
1	25025010408	2010	961.000	100.00
1	25025010500	2010	1767.000	100.00
1	25025010600	2010	2325.000	100.00
1	25025010701	2010	1599.000	100.00
1	25025010702	2010	1643.000	100.00
1	25025010801	2010	1899.000	100.00
1	25025010802	2010	2106.000	100.00
1	25025020101	2010	2814.000	100.00
1	25025020200	2010	2478.000	100.00
1	25025020301	2010	1414.000	100.00
1	25025020302	2010	721.000	100.00
1	25025020303	2010	1847.000	100.00
1	25025030100	2010	1377.000	100.00
1	25025030200	2010	1103.000	100.00
1	25025030300	2010	2960.000	100.00
1	25025030400	2010	1659.000	100.00
1	25025030500	2010	1656.000	100.00
1	25025040100	2010	1239.000	100.00
1	25025040200	2010	727.000	100.00
1	25025040300	2010	2037.000	100.00
1	25025040401	2010	1222.000	100.00
1	25025040600	2010	1334.000	100.00
1	25025040801	2010	2089.000	100.00
1	25025050101	2010	1850.000	100.00
1	25025050200	2010	1834.000	100.00
1	25025050300	2010	1041.000	100.00
1	25025050400	2010	1035.000	100.00
1	25025050500	2010	702.000	100.00
1	25025050600	2010	806.000	100.00
1	25025050700	2010	1606.000	100.00
1	25025050901	2010	1446.000	100.00
1	25025051000	2010	1784.000	100.00
1	25025051101	2010	2345.000	100.00
1	25025051200	2010	1160.000	100.00
1	25025060101	2010	1684.000	100.00
1	25025060200	2010	999.000	100.00
1	25025060301	2010	1647.000	100.00
1	25025060400	2010	2543.000	100.00
1	25025060501	2010	1942.000	100.00
1	25025060600	2010	1530.000	100.00
1	25025060700	2010	636.000	100.00
1	25025060800	2010	2142.000	100.00
1	25025061000	2010	1408.000	100.00
1	25025061101	2010	1044.000	100.00
1	25025061200	2010	2041.000	100.00
1	25025070101	2010	3383.000	100.00
1	25025070200	2010	1690.000	100.00
1	25025070300	2010	2706.000	100.00
1	25025070402	2010	680.000	100.00
1	25025070500	2010	3066.000	100.00
1	25025070600	2010	1309.000	100.00
1	25025070700	2010	1366.000	100.00
1	25025070800	2010	2156.000	100.00
1	25025070900	2010	1798.000	100.00
1	25025071101	2010	2185.000	100.00
1	25025071201	2010	1399.000	100.00
1	25025080100	2010	744.000	100.00
1	25025080300	2010	791.000	100.00
1	25025080401	2010	1249.000	100.00
1	25025080500	2010	1323.000	100.00
1	25025080601	2010	920.000	100.00
1	25025080801	2010	946.000	100.00
1	25025080900	2010	1776.000	100.00
1	25025081001	2010	2287.000	100.00
1	25025081100	2010	1781.000	100.00
1	25025081200	2010	1232.000	100.00
1	25025081300	2010	2111.000	100.00
1	25025081400	2010	1462.000	100.00
1	25025081500	2010	905.000	100.00
1	25025081700	2010	1599.000	100.00
1	25025081800	2010	1388.000	100.00
1	25025081900	2010	1397.000	100.00
1	25025082000	2010	1278.000	100.00
1	25025082100	2010	2117.000	100.00
1	25025090100	2010	1863.000	100.00
1	25025090200	2010	830.000	100.00
1	25025090300	2010	1268.000	100.00
1	25025090400	2010	1294.000	100.00
1	25025090600	2010	793.000	100.00
1	25025090700	2010	1990.000	100.00
1	25025090901	2010	1640.000	100.00
1	25025091001	2010	1315.000	100.00
1	25025091100	2010	1966.000	100.00
1	25025091200	2010	1239.000	100.00
1	25025091300	2010	868.000	100.00
1	25025091400	2010	939.000	100.00
1	25025091500	2010	1653.000	100.00
1	25025091600	2010	1165.000	100.00
1	25025091700	2010	1050.000	100.00
1	25025091800	2010	1214.000	100.00
1	25025091900	2010	1380.000	100.00
1	25025092000	2010	1693.000	100.00
1	25025092101	2010	2454.000	100.00
1	25025092200	2010	1227.000	100.00
1	25025092300	2010	1077.000	100.00
1	25025092400	2010	2065.000	100.00
1	25025100100	2010	2047.000	100.00
1	25025100200	2010	1013.000	100.00
1	25025100300	2010	1262.000	100.00
1	25025100400	2010	1830.000	100.00
1	25025100500	2010	2383.000	100.00
1	25025100601	2010	2192.000	100.00
1	25025100603	2010	840.000	100.00
1	25025100700	2010	1975.000	100.00
1	25025100800	2010	2702.000	100.00
1	25025100900	2010	1729.000	100.00
1	25025101001	2010	2266.000	100.00
1	25025101002	2010	2149.000	100.00
1	25025101101	2010	1160.000	100.00
1	25025101102	2010	1672.000	100.00
1	25025110103	2010	2353.000	100.00
1	25025110201	2010	874.000	100.00
1	25025110301	2010	955.000	100.00
1	25025110401	2010	1362.000	100.00
1	25025110403	2010	1767.000	100.00
1	25025110501	2010	1371.000	100.00
1	25025110502	2010	1684.000	100.00
1	25025110601	2010	1295.000	100.00
1	25025110607	2010	2227.000	100.00
1	25025120103	2010	696.000	100.00
1	25025120104	2010	1060.000	100.00
1	25025120105	2010	953.000	100.00
1	25025120201	2010	1726.000	100.00
1	25025120301	2010	1895.000	100.00
1	25025120400	2010	2825.000	100.00
1	25025120500	2010	905.000	100.00
1	25025120600	2010	1103.000	100.00
1	25025120700	2010	1044.000	100.00
1	25025130100	2010	2816.000	100.00
1	25025130200	2010	1914.000	100.00
1	25025130300	2010	1811.000	100.00
1	25025130402	2010	2196.000	100.00
1	25025130404	2010	1322.000	100.00
1	25025130406	2010	2192.000	100.00
1	25025140102	2010	1654.000	100.00
1	25025140105	2010	1324.000	100.00
1	25025140106	2010	898.000	100.00
1	25025140107	2010	1051.000	100.00
1	25025140201	2010	935.000	100.00
1	25025140202	2010	2081.000	100.00
1	25025140300	2010	2525.000	100.00
1	25025140400	2010	2906.000	100.00
1	25025160101	2010	2159.000	100.00
1	25025160200	2010	1225.000	100.00
1	25025160300	2010	1279.000	100.00
1	25025160400	2010	1028.000	100.00
1	25025160501	2010	1971.000	100.00
1	25025160502	2010	1589.000	100.00
1	25025160601	2010	1570.000	100.00
1	25025160602	2010	1800.000	100.00
1	25025170100	2010	3064.000	100.00
1	25025170200	2010	1814.000	100.00
1	25025170300	2010	3816.000	100.00
1	25025170400	2010	2332.000	100.00
1	25025170501	2010	1927.000	100.00
1	25025170502	2010	1548.000	100.00
1	25025170601	2010	2007.000	100.00
1	25025170701	2010	1053.000	100.00
1	25025170702	2010	2319.000	100.00
1	25025170800	2010	2217.000	100.00
1	25025180101	2010	2502.000	100.00
1	25025180200	2010	1794.000	100.00
1	25025180301	2010	1228.000	100.00
1	25025180400	2010	782.000	100.00
1	25025180500	2010	2014.000	100.00
1	25025980101	2010	0.000	\N
1	25025980300	2010	2.000	100.00
1	25025980700	2010	5.000	100.00
1	25025981000	2010	5.000	100.00
1	25025981100	2010	136.000	100.00
1	25025981201	2010	0.000	\N
1	25025981202	2010	0.000	\N
1	25025981300	2010	245.000	100.00
1	25025981501	2010	0.000	\N
1	25025981502	2010	3.000	100.00
1	25025981600	2010	0.000	\N
1	25025981700	2010	0.000	\N
1	25025981800	2010	49.000	100.00
1	25025990101	2010	0.000	\N
2	25025000401	2010	2877.000	97.00
2	25025000402	2010	1461.000	94.70
2	25025000100	2010	1616.000	94.70
2	25025000201	2010	1541.000	95.20
2	25025000202	2010	1480.000	97.20
2	25025000301	2010	1159.000	95.10
2	25025000302	2010	1276.000	94.80
2	25025000502	2010	1872.000	91.70
2	25025000503	2010	1341.000	95.20
2	25025000504	2010	2637.000	96.70
2	25025000601	2010	1450.000	95.10
2	25025000602	2010	1968.000	96.70
2	25025000701	2010	2294.000	97.20
2	25025000703	2010	1395.000	98.40
2	25025000704	2010	2350.000	97.70
2	25025000802	2010	3011.000	96.20
2	25025000803	2010	882.000	93.20
2	25025010103	2010	490.000	92.80
2	25025010104	2010	1916.000	89.70
2	25025010203	2010	3499.000	95.50
2	25025010204	2010	1188.000	92.60
2	25025010300	2010	395.000	95.00
2	25025010403	2010	2025.000	97.50
2	25025010404	2010	1810.000	97.20
2	25025010405	2010	966.000	97.20
2	25025010408	2010	943.000	98.10
2	25025010500	2010	1655.000	93.70
2	25025010600	2010	1854.000	79.70
2	25025010701	2010	1396.000	87.30
2	25025010702	2010	1402.000	85.30
2	25025010801	2010	1651.000	86.90
2	25025010802	2010	1871.000	88.80
2	25025020101	2010	2473.000	87.90
2	25025020200	2010	2302.000	92.90
2	25025020301	2010	1250.000	88.40
2	25025020302	2010	675.000	93.60
2	25025020303	2010	1632.000	88.40
2	25025030100	2010	1276.000	92.70
2	25025030200	2010	1044.000	94.70
2	25025030300	2010	2468.000	83.40
2	25025030400	2010	1513.000	91.20
2	25025030500	2010	1457.000	88.00
2	25025040100	2010	1188.000	95.90
2	25025040200	2010	663.000	91.20
2	25025040300	2010	1894.000	93.00
2	25025040401	2010	1174.000	96.10
2	25025040600	2010	1238.000	92.80
2	25025040801	2010	1876.000	89.80
2	25025050101	2010	1713.000	92.60
2	25025050200	2010	1695.000	92.40
2	25025050300	2010	973.000	93.50
2	25025050400	2010	967.000	93.40
2	25025050500	2010	659.000	93.90
2	25025050600	2010	746.000	92.60
2	25025050700	2010	1455.000	90.60
2	25025050901	2010	1324.000	91.60
2	25025051000	2010	1670.000	93.60
2	25025051101	2010	2190.000	93.40
2	25025051200	2010	1023.000	88.20
2	25025060101	2010	1575.000	93.50
2	25025060200	2010	927.000	92.80
2	25025060301	2010	1540.000	93.50
2	25025060400	2010	2378.000	93.50
2	25025060501	2010	1831.000	94.30
2	25025060600	2010	1370.000	89.50
2	25025060700	2010	617.000	97.00
2	25025060800	2010	2002.000	93.50
2	25025061000	2010	1239.000	88.00
2	25025061101	2010	982.000	94.10
2	25025061200	2010	1753.000	85.90
2	25025070101	2010	2875.000	85.00
2	25025070200	2010	1533.000	90.70
2	25025070300	2010	2448.000	90.50
2	25025070402	2010	666.000	97.90
2	25025070500	2010	2903.000	94.70
2	25025070600	2010	1210.000	92.40
2	25025070700	2010	1238.000	90.60
2	25025070800	2010	2044.000	94.80
2	25025070900	2010	1728.000	96.10
2	25025071101	2010	2088.000	95.60
2	25025071201	2010	1304.000	93.20
2	25025080100	2010	681.000	91.50
2	25025080300	2010	693.000	87.60
2	25025080401	2010	1225.000	98.10
2	25025080500	2010	1269.000	95.90
2	25025080601	2010	882.000	95.90
2	25025080801	2010	927.000	98.00
2	25025080900	2010	1686.000	94.90
2	25025081001	2010	2234.000	97.70
2	25025081100	2010	1682.000	94.40
2	25025081200	2010	1125.000	91.30
2	25025081300	2010	2001.000	94.80
2	25025081400	2010	1300.000	88.90
2	25025081500	2010	839.000	92.70
2	25025081700	2010	1473.000	92.10
2	25025081800	2010	1139.000	82.10
2	25025081900	2010	1256.000	89.90
2	25025082000	2010	1158.000	90.60
2	25025082100	2010	2035.000	96.10
2	25025090100	2010	1681.000	90.20
2	25025090200	2010	772.000	93.00
2	25025090300	2010	1123.000	88.60
2	25025090400	2010	1148.000	88.70
2	25025090600	2010	720.000	90.80
2	25025090700	2010	1832.000	92.10
2	25025090901	2010	1540.000	93.90
2	25025091001	2010	1236.000	94.00
2	25025091100	2010	1792.000	91.10
2	25025091200	2010	1160.000	93.60
2	25025091300	2010	790.000	91.00
2	25025091400	2010	879.000	93.60
2	25025091500	2010	1470.000	88.90
2	25025091600	2010	1043.000	89.50
2	25025091700	2010	917.000	87.30
2	25025091800	2010	1042.000	85.80
2	25025091900	2010	1244.000	90.10
2	25025092000	2010	1532.000	90.50
2	25025092101	2010	2252.000	91.80
2	25025092200	2010	1134.000	92.40
2	25025092300	2010	956.000	88.80
2	25025092400	2010	1873.000	90.70
2	25025100100	2010	1895.000	92.60
2	25025100200	2010	905.000	89.30
2	25025100300	2010	1121.000	88.80
2	25025100400	2010	1695.000	92.60
2	25025100500	2010	2174.000	91.20
2	25025100601	2010	2028.000	92.50
2	25025100603	2010	754.000	89.80
2	25025100700	2010	1873.000	94.80
2	25025100800	2010	2524.000	93.40
2	25025100900	2010	1610.000	93.10
2	25025101001	2010	2127.000	93.90
2	25025101002	2010	1968.000	91.60
2	25025101101	2010	1048.000	90.30
2	25025101102	2010	1511.000	90.40
2	25025110103	2010	2186.000	92.90
2	25025110201	2010	815.000	93.20
2	25025110301	2010	898.000	94.00
2	25025110401	2010	1285.000	94.30
2	25025110403	2010	1675.000	94.80
2	25025110501	2010	1300.000	94.80
2	25025110502	2010	1580.000	93.80
2	25025110601	2010	1235.000	95.40
2	25025110607	2010	2089.000	93.80
2	25025120103	2010	660.000	94.80
2	25025120104	2010	1000.000	94.30
2	25025120105	2010	898.000	94.20
2	25025120201	2010	1659.000	96.10
2	25025120301	2010	1784.000	94.10
2	25025120400	2010	2710.000	95.90
2	25025120500	2010	852.000	94.10
2	25025120600	2010	1054.000	95.60
2	25025120700	2010	983.000	94.20
2	25025130100	2010	2668.000	94.70
2	25025130200	2010	1829.000	95.60
2	25025130300	2010	1756.000	97.00
2	25025130402	2010	2102.000	95.70
2	25025130404	2010	1258.000	95.20
2	25025130406	2010	2112.000	96.40
2	25025140102	2010	1548.000	93.60
2	25025140105	2010	1274.000	96.20
2	25025140106	2010	791.000	88.10
2	25025140107	2010	977.000	93.00
2	25025140201	2010	861.000	92.10
2	25025140202	2010	1952.000	93.80
2	25025140300	2010	2353.000	93.20
2	25025140400	2010	2743.000	94.40
2	25025160101	2010	2014.000	93.30
2	25025160200	2010	1181.000	96.40
2	25025160300	2010	1197.000	93.60
2	25025160400	2010	943.000	91.70
2	25025160501	2010	1867.000	94.70
2	25025160502	2010	1476.000	92.90
2	25025160601	2010	1470.000	93.60
2	25025160602	2010	1683.000	93.50
2	25025170100	2010	2852.000	93.10
2	25025170200	2010	1728.000	95.30
2	25025170300	2010	3586.000	94.00
2	25025170400	2010	2191.000	94.00
2	25025170501	2010	1634.000	84.80
2	25025170502	2010	1406.000	90.80
2	25025170601	2010	1875.000	93.40
2	25025170701	2010	963.000	91.50
2	25025170702	2010	2144.000	92.50
2	25025170800	2010	2072.000	93.50
2	25025180101	2010	2347.000	93.80
2	25025180200	2010	1683.000	93.80
2	25025180301	2010	1180.000	96.10
2	25025180400	2010	742.000	94.90
2	25025180500	2010	1831.000	90.90
2	25025980101	2010	0.000	\N
2	25025980300	2010	2.000	100.00
2	25025980700	2010	4.000	80.00
2	25025981000	2010	5.000	100.00
2	25025981100	2010	85.000	62.50
2	25025981201	2010	0.000	\N
2	25025981202	2010	0.000	\N
2	25025981300	2010	236.000	96.30
2	25025981501	2010	0.000	\N
2	25025981502	2010	3.000	100.00
2	25025981600	2010	0.000	\N
2	25025981700	2010	0.000	\N
2	25025981800	2010	46.000	93.90
2	25025990101	2010	0.000	\N
3	25025000401	2010	88.000	3.00
3	25025000402	2010	82.000	5.30
3	25025000100	2010	91.000	5.30
3	25025000201	2010	77.000	4.80
3	25025000202	2010	42.000	2.80
3	25025000301	2010	60.000	4.90
3	25025000302	2010	70.000	5.20
3	25025000502	2010	169.000	8.30
3	25025000503	2010	67.000	4.80
3	25025000504	2010	89.000	3.30
3	25025000601	2010	75.000	4.90
3	25025000602	2010	67.000	3.30
3	25025000701	2010	65.000	2.80
3	25025000703	2010	23.000	1.60
3	25025000704	2010	55.000	2.30
3	25025000802	2010	118.000	3.80
3	25025000803	2010	64.000	6.80
3	25025010103	2010	38.000	7.20
3	25025010104	2010	220.000	10.30
3	25025010203	2010	164.000	4.50
3	25025010204	2010	95.000	7.40
3	25025010300	2010	21.000	5.00
3	25025010403	2010	51.000	2.50
3	25025010404	2010	52.000	2.80
3	25025010405	2010	28.000	2.80
3	25025010408	2010	18.000	1.90
3	25025010500	2010	112.000	6.30
3	25025010600	2010	471.000	20.30
3	25025010701	2010	203.000	12.70
3	25025010702	2010	241.000	14.70
3	25025010801	2010	248.000	13.10
3	25025010802	2010	235.000	11.20
3	25025020101	2010	341.000	12.10
3	25025020200	2010	176.000	7.10
3	25025020301	2010	164.000	11.60
3	25025020302	2010	46.000	6.40
3	25025020303	2010	215.000	11.60
3	25025030100	2010	101.000	7.30
3	25025030200	2010	59.000	5.30
3	25025030300	2010	492.000	16.60
3	25025030400	2010	146.000	8.80
3	25025030500	2010	199.000	12.00
3	25025040100	2010	51.000	4.10
3	25025040200	2010	64.000	8.80
3	25025040300	2010	143.000	7.00
3	25025040401	2010	48.000	3.90
3	25025040600	2010	96.000	7.20
3	25025040801	2010	213.000	10.20
3	25025050101	2010	137.000	7.40
3	25025050200	2010	139.000	7.60
3	25025050300	2010	68.000	6.50
3	25025050400	2010	68.000	6.60
3	25025050500	2010	43.000	6.10
3	25025050600	2010	60.000	7.40
3	25025050700	2010	151.000	9.40
3	25025050901	2010	122.000	8.40
3	25025051000	2010	114.000	6.40
3	25025051101	2010	155.000	6.60
3	25025051200	2010	137.000	11.80
3	25025060101	2010	109.000	6.50
3	25025060200	2010	72.000	7.20
3	25025060301	2010	107.000	6.50
3	25025060400	2010	165.000	6.50
3	25025060501	2010	111.000	5.70
3	25025060600	2010	160.000	10.50
3	25025060700	2010	19.000	3.00
3	25025060800	2010	140.000	6.50
3	25025061000	2010	169.000	12.00
3	25025061101	2010	62.000	5.90
3	25025061200	2010	288.000	14.10
3	25025070101	2010	508.000	15.00
3	25025070200	2010	157.000	9.30
3	25025070300	2010	258.000	9.50
3	25025070402	2010	14.000	2.10
3	25025070500	2010	163.000	5.30
3	25025070600	2010	99.000	7.60
3	25025070700	2010	128.000	9.40
3	25025070800	2010	112.000	5.20
3	25025070900	2010	70.000	3.90
3	25025071101	2010	97.000	4.40
3	25025071201	2010	95.000	6.80
3	25025080100	2010	63.000	8.50
3	25025080300	2010	98.000	12.40
3	25025080401	2010	24.000	1.90
3	25025080500	2010	54.000	4.10
3	25025080601	2010	38.000	4.10
3	25025080801	2010	19.000	2.00
3	25025080900	2010	90.000	5.10
3	25025081001	2010	53.000	2.30
3	25025081100	2010	99.000	5.60
3	25025081200	2010	107.000	8.70
3	25025081300	2010	110.000	5.20
3	25025081400	2010	162.000	11.10
3	25025081500	2010	66.000	7.30
3	25025081700	2010	126.000	7.90
3	25025081800	2010	249.000	17.90
3	25025081900	2010	141.000	10.10
3	25025082000	2010	120.000	9.40
3	25025082100	2010	82.000	3.90
3	25025090100	2010	182.000	9.80
3	25025090200	2010	58.000	7.00
3	25025090300	2010	145.000	11.40
3	25025090400	2010	146.000	11.30
3	25025090600	2010	73.000	9.20
3	25025090700	2010	158.000	7.90
3	25025090901	2010	100.000	6.10
3	25025091001	2010	79.000	6.00
3	25025091100	2010	174.000	8.90
3	25025091200	2010	79.000	6.40
3	25025091300	2010	78.000	9.00
3	25025091400	2010	60.000	6.40
3	25025091500	2010	183.000	11.10
3	25025091600	2010	122.000	10.50
3	25025091700	2010	133.000	12.70
3	25025091800	2010	172.000	14.20
3	25025091900	2010	136.000	9.90
3	25025092000	2010	161.000	9.50
3	25025092101	2010	202.000	8.20
3	25025092200	2010	93.000	7.60
3	25025092300	2010	121.000	11.20
3	25025092400	2010	192.000	9.30
3	25025100100	2010	152.000	7.40
3	25025100200	2010	108.000	10.70
3	25025100300	2010	141.000	11.20
3	25025100400	2010	135.000	7.40
3	25025100500	2010	209.000	8.80
3	25025100601	2010	164.000	7.50
3	25025100603	2010	86.000	10.20
3	25025100700	2010	102.000	5.20
3	25025100800	2010	178.000	6.60
3	25025100900	2010	119.000	6.90
3	25025101001	2010	139.000	6.10
3	25025101002	2010	181.000	8.40
3	25025101101	2010	112.000	9.70
3	25025101102	2010	161.000	9.60
3	25025110103	2010	167.000	7.10
3	25025110201	2010	59.000	6.80
3	25025110301	2010	57.000	6.00
3	25025110401	2010	77.000	5.70
3	25025110403	2010	92.000	5.20
3	25025110501	2010	71.000	5.20
3	25025110502	2010	104.000	6.20
3	25025110601	2010	60.000	4.60
3	25025110607	2010	138.000	6.20
3	25025120103	2010	36.000	5.20
3	25025120104	2010	60.000	5.70
3	25025120105	2010	55.000	5.80
3	25025120201	2010	67.000	3.90
3	25025120301	2010	111.000	5.90
3	25025120400	2010	115.000	4.10
3	25025120500	2010	53.000	5.90
3	25025120600	2010	49.000	4.40
3	25025120700	2010	61.000	5.80
3	25025130100	2010	148.000	5.30
3	25025130200	2010	85.000	4.40
3	25025130300	2010	55.000	3.00
3	25025130402	2010	94.000	4.30
3	25025130404	2010	64.000	4.80
3	25025130406	2010	80.000	3.60
3	25025140102	2010	106.000	6.40
3	25025140105	2010	50.000	3.80
3	25025140106	2010	107.000	11.90
3	25025140107	2010	74.000	7.00
3	25025140201	2010	74.000	7.90
3	25025140202	2010	129.000	6.20
3	25025140300	2010	172.000	6.80
3	25025140400	2010	163.000	5.60
3	25025160101	2010	145.000	6.70
3	25025160200	2010	44.000	3.60
3	25025160300	2010	82.000	6.40
3	25025160400	2010	85.000	8.30
3	25025160501	2010	104.000	5.30
3	25025160502	2010	113.000	7.10
3	25025160601	2010	100.000	6.40
3	25025160602	2010	117.000	6.50
3	25025170100	2010	212.000	6.90
3	25025170200	2010	86.000	4.70
3	25025170300	2010	230.000	6.00
3	25025170400	2010	141.000	6.00
3	25025170501	2010	293.000	15.20
3	25025170502	2010	142.000	9.20
3	25025170601	2010	132.000	6.60
3	25025170701	2010	90.000	8.50
3	25025170702	2010	175.000	7.50
3	25025170800	2010	145.000	6.50
3	25025180101	2010	155.000	6.20
3	25025180200	2010	111.000	6.20
3	25025180301	2010	48.000	3.90
3	25025180400	2010	40.000	5.10
3	25025180500	2010	183.000	9.10
3	25025980101	2010	0.000	\N
3	25025980300	2010	0.000	0.00
3	25025980700	2010	1.000	20.00
3	25025981000	2010	0.000	0.00
3	25025981100	2010	51.000	37.50
3	25025981201	2010	0.000	\N
3	25025981202	2010	0.000	\N
3	25025981300	2010	9.000	3.70
3	25025981501	2010	0.000	\N
3	25025981502	2010	0.000	0.00
3	25025981600	2010	0.000	\N
3	25025981700	2010	0.000	\N
3	25025981800	2010	3.000	6.10
3	25025990101	2010	0.000	\N
4	25025000401	2010	2877.000	100.00
4	25025000402	2010	1461.000	100.00
4	25025000100	2010	1616.000	100.00
4	25025000201	2010	1541.000	100.00
4	25025000202	2010	1480.000	100.00
4	25025000301	2010	1159.000	100.00
4	25025000302	2010	1276.000	100.00
4	25025000502	2010	1872.000	100.00
4	25025000503	2010	1341.000	100.00
4	25025000504	2010	2637.000	100.00
4	25025000601	2010	1450.000	100.00
4	25025000602	2010	1968.000	100.00
4	25025000701	2010	2294.000	100.00
4	25025000703	2010	1395.000	100.00
4	25025000704	2010	2350.000	100.00
4	25025000802	2010	3011.000	100.00
4	25025000803	2010	882.000	100.00
4	25025010103	2010	490.000	100.00
4	25025010104	2010	1916.000	100.00
4	25025010203	2010	3499.000	100.00
4	25025010204	2010	1188.000	100.00
4	25025010300	2010	395.000	100.00
4	25025010403	2010	2025.000	100.00
4	25025010404	2010	1810.000	100.00
4	25025010405	2010	966.000	100.00
4	25025010408	2010	943.000	100.00
4	25025010500	2010	1655.000	100.00
4	25025010600	2010	1854.000	100.00
4	25025010701	2010	1396.000	100.00
4	25025010702	2010	1402.000	100.00
4	25025010801	2010	1651.000	100.00
4	25025010802	2010	1871.000	100.00
4	25025020101	2010	2473.000	100.00
4	25025020200	2010	2302.000	100.00
4	25025020301	2010	1250.000	100.00
4	25025020302	2010	675.000	100.00
4	25025020303	2010	1632.000	100.00
4	25025030100	2010	1276.000	100.00
4	25025030200	2010	1044.000	100.00
4	25025030300	2010	2468.000	100.00
4	25025030400	2010	1513.000	100.00
4	25025030500	2010	1457.000	100.00
4	25025040100	2010	1188.000	100.00
4	25025040200	2010	663.000	100.00
4	25025040300	2010	1894.000	100.00
4	25025040401	2010	1174.000	100.00
4	25025040600	2010	1238.000	100.00
4	25025040801	2010	1876.000	100.00
4	25025050101	2010	1713.000	100.00
4	25025050200	2010	1695.000	100.00
4	25025050300	2010	973.000	100.00
4	25025050400	2010	967.000	100.00
4	25025050500	2010	659.000	100.00
4	25025050600	2010	746.000	100.00
4	25025050700	2010	1455.000	100.00
4	25025050901	2010	1324.000	100.00
4	25025051000	2010	1670.000	100.00
4	25025051101	2010	2190.000	100.00
4	25025051200	2010	1023.000	100.00
4	25025060101	2010	1575.000	100.00
4	25025060200	2010	927.000	100.00
4	25025060301	2010	1540.000	100.00
4	25025060400	2010	2378.000	100.00
4	25025060501	2010	1831.000	100.00
4	25025060600	2010	1370.000	100.00
4	25025060700	2010	617.000	100.00
4	25025060800	2010	2002.000	100.00
4	25025061000	2010	1239.000	100.00
4	25025061101	2010	982.000	100.00
4	25025061200	2010	1753.000	100.00
4	25025070101	2010	2875.000	100.00
4	25025070200	2010	1533.000	100.00
4	25025070300	2010	2448.000	100.00
4	25025070402	2010	666.000	100.00
4	25025070500	2010	2903.000	100.00
4	25025070600	2010	1210.000	100.00
4	25025070700	2010	1238.000	100.00
4	25025070800	2010	2044.000	100.00
4	25025070900	2010	1728.000	100.00
4	25025071101	2010	2088.000	100.00
4	25025071201	2010	1304.000	100.00
4	25025080100	2010	681.000	100.00
4	25025080300	2010	693.000	100.00
4	25025080401	2010	1225.000	100.00
4	25025080500	2010	1269.000	100.00
4	25025080601	2010	882.000	100.00
4	25025080801	2010	927.000	100.00
4	25025080900	2010	1686.000	100.00
4	25025081001	2010	2234.000	100.00
4	25025081100	2010	1682.000	100.00
4	25025081200	2010	1125.000	100.00
4	25025081300	2010	2001.000	100.00
4	25025081400	2010	1300.000	100.00
4	25025081500	2010	839.000	100.00
4	25025081700	2010	1473.000	100.00
4	25025081800	2010	1139.000	100.00
4	25025081900	2010	1256.000	100.00
4	25025082000	2010	1158.000	100.00
4	25025082100	2010	2035.000	100.00
4	25025090100	2010	1681.000	100.00
4	25025090200	2010	772.000	100.00
4	25025090300	2010	1123.000	100.00
4	25025090400	2010	1148.000	100.00
4	25025090600	2010	720.000	100.00
4	25025090700	2010	1832.000	100.00
4	25025090901	2010	1540.000	100.00
4	25025091001	2010	1236.000	100.00
4	25025091100	2010	1792.000	100.00
4	25025091200	2010	1160.000	100.00
4	25025091300	2010	790.000	100.00
4	25025091400	2010	879.000	100.00
4	25025091500	2010	1470.000	100.00
4	25025091600	2010	1043.000	100.00
4	25025091700	2010	917.000	100.00
4	25025091800	2010	1042.000	100.00
4	25025091900	2010	1244.000	100.00
4	25025092000	2010	1532.000	100.00
4	25025092101	2010	2252.000	100.00
4	25025092200	2010	1134.000	100.00
4	25025092300	2010	956.000	100.00
4	25025092400	2010	1873.000	100.00
4	25025100100	2010	1895.000	100.00
4	25025100200	2010	905.000	100.00
4	25025100300	2010	1121.000	100.00
4	25025100400	2010	1695.000	100.00
4	25025100500	2010	2174.000	100.00
4	25025100601	2010	2028.000	100.00
4	25025100603	2010	754.000	100.00
4	25025100700	2010	1873.000	100.00
4	25025100800	2010	2524.000	100.00
4	25025100900	2010	1610.000	100.00
4	25025101001	2010	2127.000	100.00
4	25025101002	2010	1968.000	100.00
4	25025101101	2010	1048.000	100.00
4	25025101102	2010	1511.000	100.00
4	25025110103	2010	2186.000	100.00
4	25025110201	2010	815.000	100.00
4	25025110301	2010	898.000	100.00
4	25025110401	2010	1285.000	100.00
4	25025110403	2010	1675.000	100.00
4	25025110501	2010	1300.000	100.00
4	25025110502	2010	1580.000	100.00
4	25025110601	2010	1235.000	100.00
4	25025110607	2010	2089.000	100.00
4	25025120103	2010	660.000	100.00
4	25025120104	2010	1000.000	100.00
4	25025120105	2010	898.000	100.00
4	25025120201	2010	1659.000	100.00
4	25025120301	2010	1784.000	100.00
4	25025120400	2010	2710.000	100.00
4	25025120500	2010	852.000	100.00
4	25025120600	2010	1054.000	100.00
4	25025120700	2010	983.000	100.00
4	25025130100	2010	2668.000	100.00
4	25025130200	2010	1829.000	100.00
4	25025130300	2010	1756.000	100.00
4	25025130402	2010	2102.000	100.00
4	25025130404	2010	1258.000	100.00
4	25025130406	2010	2112.000	100.00
4	25025140102	2010	1548.000	100.00
4	25025140105	2010	1274.000	100.00
4	25025140106	2010	791.000	100.00
4	25025140107	2010	977.000	100.00
4	25025140201	2010	861.000	100.00
4	25025140202	2010	1952.000	100.00
4	25025140300	2010	2353.000	100.00
4	25025140400	2010	2743.000	100.00
4	25025160101	2010	2014.000	100.00
4	25025160200	2010	1181.000	100.00
4	25025160300	2010	1197.000	100.00
4	25025160400	2010	943.000	100.00
4	25025160501	2010	1867.000	100.00
4	25025160502	2010	1476.000	100.00
4	25025160601	2010	1470.000	100.00
4	25025160602	2010	1683.000	100.00
4	25025170100	2010	2852.000	100.00
4	25025170200	2010	1728.000	100.00
4	25025170300	2010	3586.000	100.00
4	25025170400	2010	2191.000	100.00
4	25025170501	2010	1634.000	100.00
4	25025170502	2010	1406.000	100.00
4	25025170601	2010	1875.000	100.00
4	25025170701	2010	963.000	100.00
4	25025170702	2010	2144.000	100.00
4	25025170800	2010	2072.000	100.00
4	25025180101	2010	2347.000	100.00
4	25025180200	2010	1683.000	100.00
4	25025180301	2010	1180.000	100.00
4	25025180400	2010	742.000	100.00
4	25025180500	2010	1831.000	100.00
4	25025980101	2010	0.000	\N
4	25025980300	2010	2.000	100.00
4	25025980700	2010	4.000	100.00
4	25025981000	2010	5.000	100.00
4	25025981100	2010	85.000	100.00
4	25025981201	2010	0.000	\N
4	25025981202	2010	0.000	\N
4	25025981300	2010	236.000	100.00
4	25025981501	2010	0.000	\N
4	25025981502	2010	3.000	100.00
4	25025981600	2010	0.000	\N
4	25025981700	2010	0.000	\N
4	25025981800	2010	46.000	100.00
4	25025990101	2010	0.000	\N
5	25025000401	2010	496.000	17.20
5	25025000402	2010	480.000	32.90
5	25025000100	2010	408.000	25.20
5	25025000201	2010	447.000	29.00
5	25025000202	2010	474.000	32.00
5	25025000301	2010	476.000	41.10
5	25025000302	2010	631.000	49.50
5	25025000502	2010	359.000	19.20
5	25025000503	2010	348.000	26.00
5	25025000504	2010	518.000	19.60
5	25025000601	2010	462.000	31.90
5	25025000602	2010	187.000	9.50
5	25025000701	2010	339.000	14.80
5	25025000703	2010	47.000	3.40
5	25025000704	2010	316.000	13.40
5	25025000802	2010	439.000	14.60
5	25025000803	2010	8.000	0.90
5	25025010103	2010	49.000	10.00
5	25025010104	2010	401.000	20.90
5	25025010203	2010	244.000	7.00
5	25025010204	2010	162.000	13.60
5	25025010300	2010	63.000	15.90
5	25025010403	2010	121.000	6.00
5	25025010404	2010	201.000	11.10
5	25025010405	2010	96.000	9.90
5	25025010408	2010	99.000	10.50
5	25025010500	2010	208.000	12.60
5	25025010600	2010	352.000	19.00
5	25025010701	2010	455.000	32.60
5	25025010702	2010	637.000	45.40
5	25025010801	2010	812.000	49.20
5	25025010802	2010	766.000	40.90
5	25025020101	2010	1115.000	45.10
5	25025020200	2010	498.000	21.60
5	25025020301	2010	237.000	19.00
5	25025020302	2010	223.000	33.00
5	25025020303	2010	444.000	27.20
5	25025030100	2010	238.000	18.70
5	25025030200	2010	173.000	16.60
5	25025030300	2010	900.000	36.50
5	25025030400	2010	309.000	20.40
5	25025030500	2010	548.000	37.60
5	25025040100	2010	678.000	57.10
5	25025040200	2010	209.000	31.50
5	25025040300	2010	1057.000	55.80
5	25025040401	2010	471.000	40.10
5	25025040600	2010	694.000	56.10
5	25025040801	2010	610.000	32.50
5	25025050101	2010	394.000	23.00
5	25025050200	2010	376.000	22.20
5	25025050300	2010	78.000	8.00
5	25025050400	2010	239.000	24.70
5	25025050500	2010	142.000	21.50
5	25025050600	2010	155.000	20.80
5	25025050700	2010	350.000	24.10
5	25025050901	2010	398.000	30.10
5	25025051000	2010	516.000	30.90
5	25025051101	2010	873.000	39.90
5	25025051200	2010	353.000	34.50
5	25025060101	2010	732.000	46.50
5	25025060200	2010	471.000	50.80
5	25025060301	2010	759.000	49.30
5	25025060400	2010	1106.000	46.50
5	25025060501	2010	832.000	45.40
5	25025060600	2010	520.000	38.00
5	25025060700	2010	5.000	0.80
5	25025060800	2010	940.000	47.00
5	25025061000	2010	258.000	20.80
5	25025061101	2010	12.000	1.20
5	25025061200	2010	860.000	49.10
5	25025070101	2010	952.000	33.10
5	25025070200	2010	119.000	7.80
5	25025070300	2010	1155.000	47.20
5	25025070402	2010	3.000	0.50
5	25025070500	2010	1179.000	40.60
5	25025070600	2010	686.000	56.70
5	25025070700	2010	480.000	38.80
5	25025070800	2010	636.000	31.10
5	25025070900	2010	506.000	29.30
5	25025071101	2010	570.000	27.30
5	25025071201	2010	487.000	37.30
5	25025080100	2010	149.000	21.90
5	25025080300	2010	133.000	19.20
5	25025080401	2010	128.000	10.40
5	25025080500	2010	59.000	4.60
5	25025080601	2010	105.000	11.90
5	25025080801	2010	2.000	0.20
5	25025080900	2010	143.000	8.50
5	25025081001	2010	174.000	7.80
5	25025081100	2010	440.000	26.20
5	25025081200	2010	156.000	13.90
5	25025081300	2010	201.000	10.00
5	25025081400	2010	419.000	32.20
5	25025081500	2010	265.000	31.60
5	25025081700	2010	337.000	22.90
5	25025081800	2010	343.000	30.10
5	25025081900	2010	257.000	20.50
5	25025082000	2010	330.000	28.50
5	25025082100	2010	198.000	9.70
5	25025090100	2010	400.000	23.80
5	25025090200	2010	123.000	15.90
5	25025090300	2010	223.000	19.90
5	25025090400	2010	369.000	32.10
5	25025090600	2010	258.000	35.80
5	25025090700	2010	603.000	32.90
5	25025090901	2010	3.000	0.20
5	25025091001	2010	527.000	42.60
5	25025091100	2010	709.000	39.60
5	25025091200	2010	399.000	34.40
5	25025091300	2010	216.000	27.30
5	25025091400	2010	301.000	34.20
5	25025091500	2010	457.000	31.10
5	25025091600	2010	285.000	27.30
5	25025091700	2010	319.000	34.80
5	25025091800	2010	388.000	37.20
5	25025091900	2010	401.000	32.20
5	25025092000	2010	535.000	34.90
5	25025092101	2010	872.000	38.70
5	25025092200	2010	536.000	47.30
5	25025092300	2010	362.000	37.90
5	25025092400	2010	386.000	20.60
5	25025100100	2010	418.000	22.10
5	25025100200	2010	336.000	37.10
5	25025100300	2010	477.000	42.60
5	25025100400	2010	715.000	42.20
5	25025100500	2010	680.000	31.30
5	25025100601	2010	927.000	45.70
5	25025100603	2010	413.000	54.80
5	25025100700	2010	1038.000	55.40
5	25025100800	2010	1152.000	45.60
5	25025100900	2010	868.000	53.90
5	25025101001	2010	949.000	44.60
5	25025101002	2010	667.000	33.90
5	25025101101	2010	414.000	39.50
5	25025101102	2010	407.000	26.90
5	25025110103	2010	859.000	39.30
5	25025110201	2010	301.000	36.90
5	25025110301	2010	602.000	67.00
5	25025110401	2010	605.000	47.10
5	25025110403	2010	1076.000	64.20
5	25025110501	2010	818.000	62.90
5	25025110502	2010	821.000	52.00
5	25025110601	2010	948.000	76.80
5	25025110607	2010	1171.000	56.10
5	25025120103	2010	447.000	67.70
5	25025120104	2010	459.000	45.90
5	25025120105	2010	811.000	90.30
5	25025120201	2010	573.000	34.50
5	25025120301	2010	772.000	43.30
5	25025120400	2010	1330.000	49.10
5	25025120500	2010	273.000	32.00
5	25025120600	2010	457.000	43.40
5	25025120700	2010	499.000	50.80
5	25025130100	2010	1941.000	72.80
5	25025130200	2010	1303.000	71.20
5	25025130300	2010	1349.000	76.80
5	25025130402	2010	1400.000	66.60
5	25025130404	2010	740.000	58.80
5	25025130406	2010	556.000	26.30
5	25025140102	2010	1049.000	67.80
5	25025140105	2010	898.000	70.50
5	25025140106	2010	70.000	8.80
5	25025140107	2010	563.000	57.60
5	25025140201	2010	336.000	39.00
5	25025140202	2010	1228.000	62.90
5	25025140300	2010	1016.000	43.20
5	25025140400	2010	1689.000	61.60
5	25025160101	2010	580.000	28.80
5	25025160200	2010	152.000	12.90
5	25025160300	2010	489.000	40.90
5	25025160400	2010	136.000	14.40
5	25025160501	2010	476.000	25.50
5	25025160502	2010	497.000	33.70
5	25025160601	2010	411.000	28.00
5	25025160602	2010	652.000	38.70
5	25025170100	2010	1573.000	55.20
5	25025170200	2010	828.000	47.90
5	25025170300	2010	1912.000	53.30
5	25025170400	2010	970.000	44.30
5	25025170501	2010	772.000	47.20
5	25025170502	2010	790.000	56.20
5	25025170601	2010	1030.000	54.90
5	25025170701	2010	379.000	39.40
5	25025170702	2010	638.000	29.80
5	25025170800	2010	835.000	40.30
5	25025180101	2010	1142.000	48.70
5	25025180200	2010	966.000	57.40
5	25025180301	2010	850.000	72.00
5	25025180400	2010	418.000	56.30
5	25025180500	2010	931.000	50.80
5	25025980101	2010	0.000	\N
5	25025980300	2010	1.000	50.00
5	25025980700	2010	3.000	75.00
5	25025981000	2010	0.000	0.00
5	25025981100	2010	15.000	17.60
5	25025981201	2010	0.000	\N
5	25025981202	2010	0.000	\N
5	25025981300	2010	154.000	65.30
5	25025981501	2010	0.000	\N
5	25025981502	2010	2.000	66.70
5	25025981600	2010	0.000	\N
5	25025981700	2010	0.000	\N
5	25025981800	2010	39.000	84.80
5	25025990101	2010	0.000	\N
6	25025000401	2010	355.000	12.30
6	25025000402	2010	342.000	23.40
6	25025000100	2010	290.000	17.90
6	25025000201	2010	322.000	20.90
6	25025000202	2010	317.000	21.40
6	25025000301	2010	347.000	29.90
6	25025000302	2010	413.000	32.40
6	25025000502	2010	264.000	14.10
6	25025000503	2010	297.000	22.10
6	25025000504	2010	410.000	15.50
6	25025000601	2010	320.000	22.10
6	25025000602	2010	134.000	6.80
6	25025000701	2010	270.000	11.80
6	25025000703	2010	35.000	2.50
6	25025000704	2010	238.000	10.10
6	25025000802	2010	309.000	10.30
6	25025000803	2010	5.000	0.60
6	25025010103	2010	29.000	5.90
6	25025010104	2010	296.000	15.40
6	25025010203	2010	201.000	5.70
6	25025010204	2010	116.000	9.80
6	25025010300	2010	55.000	13.90
6	25025010403	2010	81.000	4.00
6	25025010404	2010	140.000	7.70
6	25025010405	2010	58.000	6.00
6	25025010408	2010	84.000	8.90
6	25025010500	2010	172.000	10.40
6	25025010600	2010	233.000	12.60
6	25025010701	2010	314.000	22.50
6	25025010702	2010	407.000	29.00
6	25025010801	2010	545.000	33.00
6	25025010802	2010	524.000	28.00
6	25025020101	2010	709.000	28.70
6	25025020200	2010	383.000	16.60
6	25025020301	2010	147.000	11.80
6	25025020302	2010	178.000	26.40
6	25025020303	2010	337.000	20.60
6	25025030100	2010	170.000	13.30
6	25025030200	2010	127.000	12.20
6	25025030300	2010	634.000	25.70
6	25025030400	2010	217.000	14.30
6	25025030500	2010	408.000	28.00
6	25025040100	2010	567.000	47.70
6	25025040200	2010	175.000	26.40
6	25025040300	2010	892.000	47.10
6	25025040401	2010	405.000	34.50
6	25025040600	2010	572.000	46.20
6	25025040801	2010	495.000	26.40
6	25025050101	2010	311.000	18.20
6	25025050200	2010	298.000	17.60
6	25025050300	2010	65.000	6.70
6	25025050400	2010	186.000	19.20
6	25025050500	2010	107.000	16.20
6	25025050600	2010	106.000	14.20
6	25025050700	2010	257.000	17.70
6	25025050901	2010	305.000	23.00
6	25025051000	2010	370.000	22.20
6	25025051101	2010	605.000	27.60
6	25025051200	2010	243.000	23.80
6	25025060101	2010	571.000	36.30
6	25025060200	2010	379.000	40.90
6	25025060301	2010	614.000	39.90
6	25025060400	2010	908.000	38.20
6	25025060501	2010	719.000	39.30
6	25025060600	2010	478.000	34.90
6	25025060700	2010	2.000	0.30
6	25025060800	2010	809.000	40.40
6	25025061000	2010	229.000	18.50
6	25025061101	2010	9.000	0.90
6	25025061200	2010	751.000	42.80
6	25025070101	2010	733.000	25.50
6	25025070200	2010	86.000	5.60
6	25025070300	2010	838.000	34.20
6	25025070402	2010	1.000	0.20
6	25025070500	2010	1006.000	34.70
6	25025070600	2010	537.000	44.40
6	25025070700	2010	380.000	30.70
6	25025070800	2010	551.000	27.00
6	25025070900	2010	459.000	26.60
6	25025071101	2010	515.000	24.70
6	25025071201	2010	437.000	33.50
6	25025080100	2010	113.000	16.60
6	25025080300	2010	112.000	16.20
6	25025080401	2010	121.000	9.90
6	25025080500	2010	42.000	3.30
6	25025080601	2010	94.000	10.70
6	25025080801	2010	2.000	0.20
6	25025080900	2010	91.000	5.40
6	25025081001	2010	144.000	6.40
6	25025081100	2010	369.000	21.90
6	25025081200	2010	138.000	12.30
6	25025081300	2010	166.000	8.30
6	25025081400	2010	376.000	28.90
6	25025081500	2010	224.000	26.70
6	25025081700	2010	275.000	18.70
6	25025081800	2010	279.000	24.50
6	25025081900	2010	208.000	16.60
6	25025082000	2010	256.000	22.10
6	25025082100	2010	163.000	8.00
6	25025090100	2010	336.000	20.00
6	25025090200	2010	95.000	12.30
6	25025090300	2010	178.000	15.90
6	25025090400	2010	318.000	27.70
6	25025090600	2010	199.000	27.60
6	25025090700	2010	462.000	25.20
6	25025090901	2010	0.000	0.00
6	25025091001	2010	410.000	33.20
6	25025091100	2010	555.000	31.00
6	25025091200	2010	346.000	29.80
6	25025091300	2010	169.000	21.40
6	25025091400	2010	263.000	29.90
6	25025091500	2010	396.000	26.90
6	25025091600	2010	248.000	23.80
6	25025091700	2010	273.000	29.80
6	25025091800	2010	339.000	32.50
6	25025091900	2010	331.000	26.60
6	25025092000	2010	442.000	28.90
6	25025092101	2010	705.000	31.30
6	25025092200	2010	465.000	41.00
6	25025092300	2010	310.000	32.40
6	25025092400	2010	309.000	16.50
6	25025100100	2010	370.000	19.50
6	25025100200	2010	292.000	32.30
6	25025100300	2010	404.000	36.00
6	25025100400	2010	610.000	36.00
6	25025100500	2010	554.000	25.50
6	25025100601	2010	758.000	37.40
6	25025100603	2010	340.000	45.10
6	25025100700	2010	791.000	42.20
6	25025100800	2010	915.000	36.30
6	25025100900	2010	742.000	46.10
6	25025101001	2010	787.000	37.00
6	25025101002	2010	551.000	28.00
6	25025101101	2010	345.000	32.90
6	25025101102	2010	347.000	23.00
6	25025110103	2010	713.000	32.60
6	25025110201	2010	249.000	30.60
6	25025110301	2010	489.000	54.50
6	25025110401	2010	500.000	38.90
6	25025110403	2010	848.000	50.60
6	25025110501	2010	588.000	45.20
6	25025110502	2010	642.000	40.60
6	25025110601	2010	639.000	51.70
6	25025110607	2010	902.000	43.20
6	25025120103	2010	337.000	51.10
6	25025120104	2010	374.000	37.40
6	25025120105	2010	524.000	58.40
6	25025120201	2010	512.000	30.90
6	25025120301	2010	672.000	37.70
6	25025120400	2010	1093.000	40.30
6	25025120500	2010	242.000	28.40
6	25025120600	2010	379.000	36.00
6	25025120700	2010	401.000	40.80
6	25025130100	2010	1407.000	52.70
6	25025130200	2010	918.000	50.20
6	25025130300	2010	973.000	55.40
6	25025130402	2010	937.000	44.60
6	25025130404	2010	564.000	44.80
6	25025130406	2010	390.000	18.50
6	25025140102	2010	834.000	53.90
6	25025140105	2010	692.000	54.30
6	25025140106	2010	55.000	7.00
6	25025140107	2010	446.000	45.60
6	25025140201	2010	271.000	31.50
6	25025140202	2010	969.000	49.60
6	25025140300	2010	880.000	37.40
6	25025140400	2010	1422.000	51.80
6	25025160101	2010	487.000	24.20
6	25025160200	2010	132.000	11.20
6	25025160300	2010	414.000	34.60
6	25025160400	2010	104.000	11.00
6	25025160501	2010	405.000	21.70
6	25025160502	2010	403.000	27.30
6	25025160601	2010	331.000	22.50
6	25025160602	2010	476.000	28.30
6	25025170100	2010	1197.000	42.00
6	25025170200	2010	600.000	34.70
6	25025170300	2010	1325.000	36.90
6	25025170400	2010	714.000	32.60
6	25025170501	2010	561.000	34.30
6	25025170502	2010	550.000	39.10
6	25025170601	2010	729.000	38.90
6	25025170701	2010	286.000	29.70
6	25025170702	2010	506.000	23.60
6	25025170800	2010	621.000	30.00
6	25025180101	2010	832.000	35.40
6	25025180200	2010	725.000	43.10
6	25025180301	2010	647.000	54.80
6	25025180400	2010	312.000	42.00
6	25025180500	2010	731.000	39.90
6	25025980101	2010	0.000	\N
6	25025980300	2010	0.000	0.00
6	25025980700	2010	1.000	25.00
6	25025981000	2010	0.000	0.00
6	25025981100	2010	14.000	16.50
6	25025981201	2010	0.000	\N
6	25025981202	2010	0.000	\N
6	25025981300	2010	143.000	60.60
6	25025981501	2010	0.000	\N
6	25025981502	2010	1.000	33.30
6	25025981600	2010	0.000	\N
6	25025981700	2010	0.000	\N
6	25025981800	2010	28.000	60.90
6	25025990101	2010	0.000	\N
7	25025000401	2010	141.000	4.90
7	25025000402	2010	138.000	9.40
7	25025000100	2010	118.000	7.30
7	25025000201	2010	125.000	8.10
7	25025000202	2010	157.000	10.60
7	25025000301	2010	129.000	11.10
7	25025000302	2010	218.000	17.10
7	25025000502	2010	95.000	5.10
7	25025000503	2010	51.000	3.80
7	25025000504	2010	108.000	4.10
7	25025000601	2010	142.000	9.80
7	25025000602	2010	53.000	2.70
7	25025000701	2010	69.000	3.00
7	25025000703	2010	12.000	0.90
7	25025000704	2010	78.000	3.30
7	25025000802	2010	130.000	4.30
7	25025000803	2010	3.000	0.30
7	25025010103	2010	20.000	4.10
7	25025010104	2010	105.000	5.50
7	25025010203	2010	43.000	1.20
7	25025010204	2010	46.000	3.90
7	25025010300	2010	8.000	2.00
7	25025010403	2010	40.000	2.00
7	25025010404	2010	61.000	3.40
7	25025010405	2010	38.000	3.90
7	25025010408	2010	15.000	1.60
7	25025010500	2010	36.000	2.20
7	25025010600	2010	119.000	6.40
7	25025010701	2010	141.000	10.10
7	25025010702	2010	230.000	16.40
7	25025010801	2010	267.000	16.20
7	25025010802	2010	242.000	12.90
7	25025020101	2010	406.000	16.40
7	25025020200	2010	115.000	5.00
7	25025020301	2010	90.000	7.20
7	25025020302	2010	45.000	6.70
7	25025020303	2010	107.000	6.60
7	25025030100	2010	68.000	5.30
7	25025030200	2010	46.000	4.40
7	25025030300	2010	266.000	10.80
7	25025030400	2010	92.000	6.10
7	25025030500	2010	140.000	9.60
7	25025040100	2010	111.000	9.30
7	25025040200	2010	34.000	5.10
7	25025040300	2010	165.000	8.70
7	25025040401	2010	66.000	5.60
7	25025040600	2010	122.000	9.90
7	25025040801	2010	115.000	6.10
7	25025050101	2010	83.000	4.80
7	25025050200	2010	78.000	4.60
7	25025050300	2010	13.000	1.30
7	25025050400	2010	53.000	5.50
7	25025050500	2010	35.000	5.30
7	25025050600	2010	49.000	6.60
7	25025050700	2010	93.000	6.40
7	25025050901	2010	93.000	7.00
7	25025051000	2010	146.000	8.70
7	25025051101	2010	268.000	12.20
7	25025051200	2010	110.000	10.80
7	25025060101	2010	161.000	10.20
7	25025060200	2010	92.000	9.90
7	25025060301	2010	145.000	9.40
7	25025060400	2010	198.000	8.30
7	25025060501	2010	113.000	6.20
7	25025060600	2010	42.000	3.10
7	25025060700	2010	3.000	0.50
7	25025060800	2010	131.000	6.50
7	25025061000	2010	29.000	2.30
7	25025061101	2010	3.000	0.30
7	25025061200	2010	109.000	6.20
7	25025070101	2010	219.000	7.60
7	25025070200	2010	33.000	2.20
7	25025070300	2010	317.000	12.90
7	25025070402	2010	2.000	0.30
7	25025070500	2010	173.000	6.00
7	25025070600	2010	149.000	12.30
7	25025070700	2010	100.000	8.10
7	25025070800	2010	85.000	4.20
7	25025070900	2010	47.000	2.70
7	25025071101	2010	55.000	2.60
7	25025071201	2010	50.000	3.80
7	25025080100	2010	36.000	5.30
7	25025080300	2010	21.000	3.00
7	25025080401	2010	7.000	0.60
7	25025080500	2010	17.000	1.30
7	25025080601	2010	11.000	1.20
7	25025080801	2010	0.000	0.00
7	25025080900	2010	52.000	3.10
7	25025081001	2010	30.000	1.30
7	25025081100	2010	71.000	4.20
7	25025081200	2010	18.000	1.60
7	25025081300	2010	35.000	1.70
7	25025081400	2010	43.000	3.30
7	25025081500	2010	41.000	4.90
7	25025081700	2010	62.000	4.20
7	25025081800	2010	64.000	5.60
7	25025081900	2010	49.000	3.90
7	25025082000	2010	74.000	6.40
7	25025082100	2010	35.000	1.70
7	25025090100	2010	64.000	3.80
7	25025090200	2010	28.000	3.60
7	25025090300	2010	45.000	4.00
7	25025090400	2010	51.000	4.40
7	25025090600	2010	59.000	8.20
7	25025090700	2010	141.000	7.70
7	25025090901	2010	3.000	0.20
7	25025091001	2010	117.000	9.50
7	25025091100	2010	154.000	8.60
7	25025091200	2010	53.000	4.60
7	25025091300	2010	47.000	5.90
7	25025091400	2010	38.000	4.30
7	25025091500	2010	61.000	4.10
7	25025091600	2010	37.000	3.50
7	25025091700	2010	46.000	5.00
7	25025091800	2010	49.000	4.70
7	25025091900	2010	70.000	5.60
7	25025092000	2010	93.000	6.10
7	25025092101	2010	167.000	7.40
7	25025092200	2010	71.000	6.30
7	25025092300	2010	52.000	5.40
7	25025092400	2010	77.000	4.10
7	25025100100	2010	48.000	2.50
7	25025100200	2010	44.000	4.90
7	25025100300	2010	73.000	6.50
7	25025100400	2010	105.000	6.20
7	25025100500	2010	126.000	5.80
7	25025100601	2010	169.000	8.30
7	25025100603	2010	73.000	9.70
7	25025100700	2010	247.000	13.20
7	25025100800	2010	237.000	9.40
7	25025100900	2010	126.000	7.80
7	25025101001	2010	162.000	7.60
7	25025101002	2010	116.000	5.90
7	25025101101	2010	69.000	6.60
7	25025101102	2010	60.000	4.00
7	25025110103	2010	146.000	6.70
7	25025110201	2010	52.000	6.40
7	25025110301	2010	113.000	12.60
7	25025110401	2010	105.000	8.20
7	25025110403	2010	228.000	13.60
7	25025110501	2010	230.000	17.70
7	25025110502	2010	179.000	11.30
7	25025110601	2010	309.000	25.00
7	25025110607	2010	269.000	12.90
7	25025120103	2010	110.000	16.70
7	25025120104	2010	85.000	8.50
7	25025120105	2010	287.000	32.00
7	25025120201	2010	61.000	3.70
7	25025120301	2010	100.000	5.60
7	25025120400	2010	237.000	8.70
7	25025120500	2010	31.000	3.60
7	25025120600	2010	78.000	7.40
7	25025120700	2010	98.000	10.00
7	25025130100	2010	534.000	20.00
7	25025130200	2010	385.000	21.00
7	25025130300	2010	376.000	21.40
7	25025130402	2010	463.000	22.00
7	25025130404	2010	176.000	14.00
7	25025130406	2010	166.000	7.90
7	25025140102	2010	215.000	13.90
7	25025140105	2010	206.000	16.20
7	25025140106	2010	15.000	1.90
7	25025140107	2010	117.000	12.00
7	25025140201	2010	65.000	7.50
7	25025140202	2010	259.000	13.30
7	25025140300	2010	136.000	5.80
7	25025140400	2010	267.000	9.70
7	25025160101	2010	93.000	4.60
7	25025160200	2010	20.000	1.70
7	25025160300	2010	75.000	6.30
7	25025160400	2010	32.000	3.40
7	25025160501	2010	71.000	3.80
7	25025160502	2010	94.000	6.40
7	25025160601	2010	80.000	5.40
7	25025160602	2010	176.000	10.50
7	25025170100	2010	376.000	13.20
7	25025170200	2010	228.000	13.20
7	25025170300	2010	587.000	16.40
7	25025170400	2010	256.000	11.70
7	25025170501	2010	211.000	12.90
7	25025170502	2010	240.000	17.10
7	25025170601	2010	301.000	16.10
7	25025170701	2010	93.000	9.70
7	25025170702	2010	132.000	6.20
7	25025170800	2010	214.000	10.30
7	25025180101	2010	310.000	13.20
7	25025180200	2010	241.000	14.30
7	25025180301	2010	203.000	17.20
7	25025180400	2010	106.000	14.30
7	25025180500	2010	200.000	10.90
7	25025980101	2010	0.000	\N
7	25025980300	2010	1.000	50.00
7	25025980700	2010	2.000	50.00
7	25025981000	2010	0.000	0.00
7	25025981100	2010	1.000	1.20
7	25025981201	2010	0.000	\N
7	25025981202	2010	0.000	\N
7	25025981300	2010	11.000	4.70
7	25025981501	2010	0.000	\N
7	25025981502	2010	1.000	33.30
7	25025981600	2010	0.000	\N
7	25025981700	2010	0.000	\N
7	25025981800	2010	11.000	23.90
7	25025990101	2010	0.000	\N
8	25025000401	2010	2381.000	82.80
8	25025000402	2010	981.000	67.10
8	25025000100	2010	1208.000	74.80
8	25025000201	2010	1094.000	71.00
8	25025000202	2010	1006.000	68.00
8	25025000301	2010	683.000	58.90
8	25025000302	2010	645.000	50.50
8	25025000502	2010	1513.000	80.80
8	25025000503	2010	993.000	74.00
8	25025000504	2010	2119.000	80.40
8	25025000601	2010	988.000	68.10
8	25025000602	2010	1781.000	90.50
8	25025000701	2010	1955.000	85.20
8	25025000703	2010	1348.000	96.60
8	25025000704	2010	2034.000	86.60
8	25025000802	2010	2572.000	85.40
8	25025000803	2010	874.000	99.10
8	25025010103	2010	441.000	90.00
8	25025010104	2010	1515.000	79.10
8	25025010203	2010	3255.000	93.00
8	25025010204	2010	1026.000	86.40
8	25025010300	2010	332.000	84.10
8	25025010403	2010	1904.000	94.00
8	25025010404	2010	1609.000	88.90
8	25025010405	2010	870.000	90.10
8	25025010408	2010	844.000	89.50
8	25025010500	2010	1447.000	87.40
8	25025010600	2010	1502.000	81.00
8	25025010701	2010	941.000	67.40
8	25025010702	2010	765.000	54.60
8	25025010801	2010	839.000	50.80
8	25025010802	2010	1105.000	59.10
8	25025020101	2010	1358.000	54.90
8	25025020200	2010	1804.000	78.40
8	25025020301	2010	1013.000	81.00
8	25025020302	2010	452.000	67.00
8	25025020303	2010	1188.000	72.80
8	25025030100	2010	1038.000	81.30
8	25025030200	2010	871.000	83.40
8	25025030300	2010	1568.000	63.50
8	25025030400	2010	1204.000	79.60
8	25025030500	2010	909.000	62.40
8	25025040100	2010	510.000	42.90
8	25025040200	2010	454.000	68.50
8	25025040300	2010	837.000	44.20
8	25025040401	2010	703.000	59.90
8	25025040600	2010	544.000	43.90
8	25025040801	2010	1266.000	67.50
8	25025050101	2010	1319.000	77.00
8	25025050200	2010	1319.000	77.80
8	25025050300	2010	895.000	92.00
8	25025050400	2010	728.000	75.30
8	25025050500	2010	517.000	78.50
8	25025050600	2010	591.000	79.20
8	25025050700	2010	1105.000	75.90
8	25025050901	2010	926.000	69.90
8	25025051000	2010	1154.000	69.10
8	25025051101	2010	1317.000	60.10
8	25025051200	2010	670.000	65.50
8	25025060101	2010	843.000	53.50
8	25025060200	2010	456.000	49.20
8	25025060301	2010	781.000	50.70
8	25025060400	2010	1272.000	53.50
8	25025060501	2010	999.000	54.60
8	25025060600	2010	850.000	62.00
8	25025060700	2010	612.000	99.20
8	25025060800	2010	1062.000	53.00
8	25025061000	2010	981.000	79.20
8	25025061101	2010	970.000	98.80
8	25025061200	2010	893.000	50.90
8	25025070101	2010	1923.000	66.90
8	25025070200	2010	1414.000	92.20
8	25025070300	2010	1293.000	52.80
8	25025070402	2010	663.000	99.50
8	25025070500	2010	1724.000	59.40
8	25025070600	2010	524.000	43.30
8	25025070700	2010	758.000	61.20
8	25025070800	2010	1408.000	68.90
8	25025070900	2010	1222.000	70.70
8	25025071101	2010	1518.000	72.70
8	25025071201	2010	817.000	62.70
8	25025080100	2010	532.000	78.10
8	25025080300	2010	560.000	80.80
8	25025080401	2010	1097.000	89.60
8	25025080500	2010	1210.000	95.40
8	25025080601	2010	777.000	88.10
8	25025080801	2010	925.000	99.80
8	25025080900	2010	1543.000	91.50
8	25025081001	2010	2060.000	92.20
8	25025081100	2010	1242.000	73.80
8	25025081200	2010	969.000	86.10
8	25025081300	2010	1800.000	90.00
8	25025081400	2010	881.000	67.80
8	25025081500	2010	574.000	68.40
8	25025081700	2010	1136.000	77.10
8	25025081800	2010	796.000	69.90
8	25025081900	2010	999.000	79.50
8	25025082000	2010	828.000	71.50
8	25025082100	2010	1837.000	90.30
8	25025090100	2010	1281.000	76.20
8	25025090200	2010	649.000	84.10
8	25025090300	2010	900.000	80.10
8	25025090400	2010	779.000	67.90
8	25025090600	2010	462.000	64.20
8	25025090700	2010	1229.000	67.10
8	25025090901	2010	1537.000	99.80
8	25025091001	2010	709.000	57.40
8	25025091100	2010	1083.000	60.40
8	25025091200	2010	761.000	65.60
8	25025091300	2010	574.000	72.70
8	25025091400	2010	578.000	65.80
8	25025091500	2010	1013.000	68.90
8	25025091600	2010	758.000	72.70
8	25025091700	2010	598.000	65.20
8	25025091800	2010	654.000	62.80
8	25025091900	2010	843.000	67.80
8	25025092000	2010	997.000	65.10
8	25025092101	2010	1380.000	61.30
8	25025092200	2010	598.000	52.70
8	25025092300	2010	594.000	62.10
8	25025092400	2010	1487.000	79.40
8	25025100100	2010	1477.000	77.90
8	25025100200	2010	569.000	62.90
8	25025100300	2010	644.000	57.40
8	25025100400	2010	980.000	57.80
8	25025100500	2010	1494.000	68.70
8	25025100601	2010	1101.000	54.30
8	25025100603	2010	341.000	45.20
8	25025100700	2010	835.000	44.60
8	25025100800	2010	1372.000	54.40
8	25025100900	2010	742.000	46.10
8	25025101001	2010	1178.000	55.40
8	25025101002	2010	1301.000	66.10
8	25025101101	2010	634.000	60.50
8	25025101102	2010	1104.000	73.10
8	25025110103	2010	1327.000	60.70
8	25025110201	2010	514.000	63.10
8	25025110301	2010	296.000	33.00
8	25025110401	2010	680.000	52.90
8	25025110403	2010	599.000	35.80
8	25025110501	2010	482.000	37.10
8	25025110502	2010	759.000	48.00
8	25025110601	2010	287.000	23.20
8	25025110607	2010	918.000	43.90
8	25025120103	2010	213.000	32.30
8	25025120104	2010	541.000	54.10
8	25025120105	2010	87.000	9.70
8	25025120201	2010	1086.000	65.50
8	25025120301	2010	1012.000	56.70
8	25025120400	2010	1380.000	50.90
8	25025120500	2010	579.000	68.00
8	25025120600	2010	597.000	56.60
8	25025120700	2010	484.000	49.20
8	25025130100	2010	727.000	27.20
8	25025130200	2010	526.000	28.80
8	25025130300	2010	407.000	23.20
8	25025130402	2010	702.000	33.40
8	25025130404	2010	518.000	41.20
8	25025130406	2010	1556.000	73.70
8	25025140102	2010	499.000	32.20
8	25025140105	2010	376.000	29.50
8	25025140106	2010	721.000	91.20
8	25025140107	2010	414.000	42.40
8	25025140201	2010	525.000	61.00
8	25025140202	2010	724.000	37.10
8	25025140300	2010	1337.000	56.80
8	25025140400	2010	1054.000	38.40
8	25025160101	2010	1434.000	71.20
8	25025160200	2010	1029.000	87.10
8	25025160300	2010	708.000	59.10
8	25025160400	2010	807.000	85.60
8	25025160501	2010	1391.000	74.50
8	25025160502	2010	979.000	66.30
8	25025160601	2010	1059.000	72.00
8	25025160602	2010	1031.000	61.30
8	25025170100	2010	1279.000	44.80
8	25025170200	2010	900.000	52.10
8	25025170300	2010	1674.000	46.70
8	25025170400	2010	1221.000	55.70
8	25025170501	2010	862.000	52.80
8	25025170502	2010	616.000	43.80
8	25025170601	2010	845.000	45.10
8	25025170701	2010	584.000	60.60
8	25025170702	2010	1506.000	70.20
8	25025170800	2010	1237.000	59.70
8	25025180101	2010	1205.000	51.30
8	25025180200	2010	717.000	42.60
8	25025180301	2010	330.000	28.00
8	25025180400	2010	324.000	43.70
8	25025180500	2010	900.000	49.20
8	25025980101	2010	0.000	\N
8	25025980300	2010	1.000	50.00
8	25025980700	2010	1.000	25.00
8	25025981000	2010	5.000	100.00
8	25025981100	2010	70.000	82.40
8	25025981201	2010	0.000	\N
8	25025981202	2010	0.000	\N
8	25025981300	2010	82.000	34.70
8	25025981501	2010	0.000	\N
8	25025981502	2010	1.000	33.30
8	25025981600	2010	0.000	\N
8	25025981700	2010	0.000	\N
8	25025981800	2010	7.000	15.20
8	25025990101	2010	0.000	\N
9	25025000401	2010	88.000	100.00
9	25025000402	2010	82.000	100.00
9	25025000100	2010	91.000	100.00
9	25025000201	2010	77.000	100.00
9	25025000202	2010	42.000	100.00
9	25025000301	2010	60.000	100.00
9	25025000302	2010	70.000	100.00
9	25025000502	2010	169.000	100.00
9	25025000503	2010	67.000	100.00
9	25025000504	2010	89.000	100.00
9	25025000601	2010	75.000	100.00
9	25025000602	2010	67.000	100.00
9	25025000701	2010	65.000	100.00
9	25025000703	2010	23.000	100.00
9	25025000704	2010	55.000	100.00
9	25025000802	2010	118.000	100.00
9	25025000803	2010	64.000	100.00
9	25025010103	2010	38.000	100.00
9	25025010104	2010	220.000	100.00
9	25025010203	2010	164.000	100.00
9	25025010204	2010	95.000	100.00
9	25025010300	2010	21.000	100.00
9	25025010403	2010	51.000	100.00
9	25025010404	2010	52.000	100.00
9	25025010405	2010	28.000	100.00
9	25025010408	2010	18.000	100.00
9	25025010500	2010	112.000	100.00
9	25025010600	2010	471.000	100.00
9	25025010701	2010	203.000	100.00
9	25025010702	2010	241.000	100.00
9	25025010801	2010	248.000	100.00
9	25025010802	2010	235.000	100.00
9	25025020101	2010	341.000	100.00
9	25025020200	2010	176.000	100.00
9	25025020301	2010	164.000	100.00
9	25025020302	2010	46.000	100.00
9	25025020303	2010	215.000	100.00
9	25025030100	2010	101.000	100.00
9	25025030200	2010	59.000	100.00
9	25025030300	2010	492.000	100.00
9	25025030400	2010	146.000	100.00
9	25025030500	2010	199.000	100.00
9	25025040100	2010	51.000	100.00
9	25025040200	2010	64.000	100.00
9	25025040300	2010	143.000	100.00
9	25025040401	2010	48.000	100.00
9	25025040600	2010	96.000	100.00
9	25025040801	2010	213.000	100.00
9	25025050101	2010	137.000	100.00
9	25025050200	2010	139.000	100.00
9	25025050300	2010	68.000	100.00
9	25025050400	2010	68.000	100.00
9	25025050500	2010	43.000	100.00
9	25025050600	2010	60.000	100.00
9	25025050700	2010	151.000	100.00
9	25025050901	2010	122.000	100.00
9	25025051000	2010	114.000	100.00
9	25025051101	2010	155.000	100.00
9	25025051200	2010	137.000	100.00
9	25025060101	2010	109.000	100.00
9	25025060200	2010	72.000	100.00
9	25025060301	2010	107.000	100.00
9	25025060400	2010	165.000	100.00
9	25025060501	2010	111.000	100.00
9	25025060600	2010	160.000	100.00
9	25025060700	2010	19.000	100.00
9	25025060800	2010	140.000	100.00
9	25025061000	2010	169.000	100.00
9	25025061101	2010	62.000	100.00
9	25025061200	2010	288.000	100.00
9	25025070101	2010	508.000	100.00
9	25025070200	2010	157.000	100.00
9	25025070300	2010	258.000	100.00
9	25025070402	2010	14.000	100.00
9	25025070500	2010	163.000	100.00
9	25025070600	2010	99.000	100.00
9	25025070700	2010	128.000	100.00
9	25025070800	2010	112.000	100.00
9	25025070900	2010	70.000	100.00
9	25025071101	2010	97.000	100.00
9	25025071201	2010	95.000	100.00
9	25025080100	2010	63.000	100.00
9	25025080300	2010	98.000	100.00
9	25025080401	2010	24.000	100.00
9	25025080500	2010	54.000	100.00
9	25025080601	2010	38.000	100.00
9	25025080801	2010	19.000	100.00
9	25025080900	2010	90.000	100.00
9	25025081001	2010	53.000	100.00
9	25025081100	2010	99.000	100.00
9	25025081200	2010	107.000	100.00
9	25025081300	2010	110.000	100.00
9	25025081400	2010	162.000	100.00
9	25025081500	2010	66.000	100.00
9	25025081700	2010	126.000	100.00
9	25025081800	2010	249.000	100.00
9	25025081900	2010	141.000	100.00
9	25025082000	2010	120.000	100.00
9	25025082100	2010	82.000	100.00
9	25025090100	2010	182.000	100.00
9	25025090200	2010	58.000	100.00
9	25025090300	2010	145.000	100.00
9	25025090400	2010	146.000	100.00
9	25025090600	2010	73.000	100.00
9	25025090700	2010	158.000	100.00
9	25025090901	2010	100.000	100.00
9	25025091001	2010	79.000	100.00
9	25025091100	2010	174.000	100.00
9	25025091200	2010	79.000	100.00
9	25025091300	2010	78.000	100.00
9	25025091400	2010	60.000	100.00
9	25025091500	2010	183.000	100.00
9	25025091600	2010	122.000	100.00
9	25025091700	2010	133.000	100.00
9	25025091800	2010	172.000	100.00
9	25025091900	2010	136.000	100.00
9	25025092000	2010	161.000	100.00
9	25025092101	2010	202.000	100.00
9	25025092200	2010	93.000	100.00
9	25025092300	2010	121.000	100.00
9	25025092400	2010	192.000	100.00
9	25025100100	2010	152.000	100.00
9	25025100200	2010	108.000	100.00
9	25025100300	2010	141.000	100.00
9	25025100400	2010	135.000	100.00
9	25025100500	2010	209.000	100.00
9	25025100601	2010	164.000	100.00
9	25025100603	2010	86.000	100.00
9	25025100700	2010	102.000	100.00
9	25025100800	2010	178.000	100.00
9	25025100900	2010	119.000	100.00
9	25025101001	2010	139.000	100.00
9	25025101002	2010	181.000	100.00
9	25025101101	2010	112.000	100.00
9	25025101102	2010	161.000	100.00
9	25025110103	2010	167.000	100.00
9	25025110201	2010	59.000	100.00
9	25025110301	2010	57.000	100.00
9	25025110401	2010	77.000	100.00
9	25025110403	2010	92.000	100.00
9	25025110501	2010	71.000	100.00
9	25025110502	2010	104.000	100.00
9	25025110601	2010	60.000	100.00
9	25025110607	2010	138.000	100.00
9	25025120103	2010	36.000	100.00
9	25025120104	2010	60.000	100.00
9	25025120105	2010	55.000	100.00
9	25025120201	2010	67.000	100.00
9	25025120301	2010	111.000	100.00
9	25025120400	2010	115.000	100.00
9	25025120500	2010	53.000	100.00
9	25025120600	2010	49.000	100.00
9	25025120700	2010	61.000	100.00
9	25025130100	2010	148.000	100.00
9	25025130200	2010	85.000	100.00
9	25025130300	2010	55.000	100.00
9	25025130402	2010	94.000	100.00
9	25025130404	2010	64.000	100.00
9	25025130406	2010	80.000	100.00
9	25025140102	2010	106.000	100.00
9	25025140105	2010	50.000	100.00
9	25025140106	2010	107.000	100.00
9	25025140107	2010	74.000	100.00
9	25025140201	2010	74.000	100.00
9	25025140202	2010	129.000	100.00
9	25025140300	2010	172.000	100.00
9	25025140400	2010	163.000	100.00
9	25025160101	2010	145.000	100.00
9	25025160200	2010	44.000	100.00
9	25025160300	2010	82.000	100.00
9	25025160400	2010	85.000	100.00
9	25025160501	2010	104.000	100.00
9	25025160502	2010	113.000	100.00
9	25025160601	2010	100.000	100.00
9	25025160602	2010	117.000	100.00
9	25025170100	2010	212.000	100.00
9	25025170200	2010	86.000	100.00
9	25025170300	2010	230.000	100.00
9	25025170400	2010	141.000	100.00
9	25025170501	2010	293.000	100.00
9	25025170502	2010	142.000	100.00
9	25025170601	2010	132.000	100.00
9	25025170701	2010	90.000	100.00
9	25025170702	2010	175.000	100.00
9	25025170800	2010	145.000	100.00
9	25025180101	2010	155.000	100.00
9	25025180200	2010	111.000	100.00
9	25025180301	2010	48.000	100.00
9	25025180400	2010	40.000	100.00
9	25025180500	2010	183.000	100.00
9	25025980101	2010	0.000	\N
9	25025980300	2010	0.000	\N
9	25025980700	2010	1.000	100.00
9	25025981000	2010	0.000	\N
9	25025981100	2010	51.000	100.00
9	25025981201	2010	0.000	\N
9	25025981202	2010	0.000	\N
9	25025981300	2010	9.000	100.00
9	25025981501	2010	0.000	\N
9	25025981502	2010	0.000	\N
9	25025981600	2010	0.000	\N
9	25025981700	2010	0.000	\N
9	25025981800	2010	3.000	100.00
9	25025990101	2010	0.000	\N
10	25025000401	2010	40.000	45.50
10	25025000402	2010	47.000	57.30
10	25025000100	2010	34.000	37.40
10	25025000201	2010	42.000	54.50
10	25025000202	2010	23.000	54.80
10	25025000301	2010	34.000	56.70
10	25025000302	2010	33.000	47.10
10	25025000502	2010	95.000	56.20
10	25025000503	2010	50.000	74.60
10	25025000504	2010	58.000	65.20
10	25025000601	2010	44.000	58.70
10	25025000602	2010	45.000	67.20
10	25025000701	2010	43.000	66.20
10	25025000703	2010	18.000	78.30
10	25025000704	2010	35.000	63.60
10	25025000802	2010	78.000	66.10
10	25025000803	2010	3.000	4.70
10	25025010103	2010	28.000	73.70
10	25025010104	2010	100.000	45.50
10	25025010203	2010	102.000	62.20
10	25025010204	2010	86.000	90.50
10	25025010300	2010	14.000	66.70
10	25025010403	2010	21.000	41.20
10	25025010404	2010	34.000	65.40
10	25025010405	2010	20.000	71.40
10	25025010408	2010	12.000	66.70
10	25025010500	2010	71.000	63.40
10	25025010600	2010	137.000	29.10
10	25025010701	2010	76.000	37.40
10	25025010702	2010	27.000	11.20
10	25025010801	2010	68.000	27.40
10	25025010802	2010	50.000	21.30
10	25025020101	2010	73.000	21.40
10	25025020200	2010	78.000	44.30
10	25025020301	2010	52.000	31.70
10	25025020302	2010	22.000	47.80
10	25025020303	2010	90.000	41.90
10	25025030100	2010	65.000	64.40
10	25025030200	2010	23.000	39.00
10	25025030300	2010	115.000	23.40
10	25025030400	2010	68.000	46.60
10	25025030500	2010	39.000	19.60
10	25025040100	2010	14.000	27.50
10	25025040200	2010	56.000	87.50
10	25025040300	2010	51.000	35.70
10	25025040401	2010	15.000	31.30
10	25025040600	2010	48.000	50.00
10	25025040801	2010	156.000	73.20
10	25025050101	2010	64.000	46.70
10	25025050200	2010	53.000	38.10
10	25025050300	2010	56.000	82.40
10	25025050400	2010	41.000	60.30
10	25025050500	2010	25.000	58.10
10	25025050600	2010	23.000	38.30
10	25025050700	2010	73.000	48.30
10	25025050901	2010	49.000	40.20
10	25025051000	2010	49.000	43.00
10	25025051101	2010	83.000	53.50
10	25025051200	2010	60.000	43.80
10	25025060101	2010	27.000	24.80
10	25025060200	2010	18.000	25.00
10	25025060301	2010	33.000	30.80
10	25025060400	2010	54.000	32.70
10	25025060501	2010	35.000	31.50
10	25025060600	2010	48.000	30.00
10	25025060700	2010	18.000	94.70
10	25025060800	2010	61.000	43.60
10	25025061000	2010	103.000	60.90
10	25025061101	2010	28.000	45.20
10	25025061200	2010	134.000	46.50
10	25025070101	2010	209.000	41.10
10	25025070200	2010	32.000	20.40
10	25025070300	2010	44.000	17.10
10	25025070402	2010	7.000	50.00
10	25025070500	2010	65.000	39.90
10	25025070600	2010	34.000	34.30
10	25025070700	2010	24.000	18.80
10	25025070800	2010	63.000	56.30
10	25025070900	2010	24.000	34.30
10	25025071101	2010	69.000	71.10
10	25025071201	2010	28.000	29.50
10	25025080100	2010	39.000	61.90
10	25025080300	2010	51.000	52.00
10	25025080401	2010	16.000	66.70
10	25025080500	2010	44.000	81.50
10	25025080601	2010	28.000	73.70
10	25025080801	2010	17.000	89.50
10	25025080900	2010	52.000	57.80
10	25025081001	2010	26.000	49.10
10	25025081100	2010	39.000	39.40
10	25025081200	2010	63.000	58.90
10	25025081300	2010	79.000	71.80
10	25025081400	2010	49.000	30.20
10	25025081500	2010	34.000	51.50
10	25025081700	2010	63.000	50.00
10	25025081800	2010	102.000	41.00
10	25025081900	2010	105.000	74.50
10	25025082000	2010	57.000	47.50
10	25025082100	2010	55.000	67.10
10	25025090100	2010	113.000	62.10
10	25025090200	2010	29.000	50.00
10	25025090300	2010	76.000	52.40
10	25025090400	2010	76.000	52.10
10	25025090600	2010	35.000	47.90
10	25025090700	2010	70.000	44.30
10	25025090901	2010	86.000	86.00
10	25025091001	2010	39.000	49.40
10	25025091100	2010	65.000	37.40
10	25025091200	2010	40.000	50.60
10	25025091300	2010	31.000	39.70
10	25025091400	2010	27.000	45.00
10	25025091500	2010	95.000	51.90
10	25025091600	2010	69.000	56.60
10	25025091700	2010	79.000	59.40
10	25025091800	2010	109.000	63.40
10	25025091900	2010	78.000	57.40
10	25025092000	2010	61.000	37.90
10	25025092101	2010	140.000	69.30
10	25025092200	2010	66.000	71.00
10	25025092300	2010	65.000	53.70
10	25025092400	2010	122.000	63.50
10	25025100100	2010	79.000	52.00
10	25025100200	2010	53.000	49.10
10	25025100300	2010	69.000	48.90
10	25025100400	2010	86.000	63.70
10	25025100500	2010	130.000	62.20
10	25025100601	2010	95.000	57.90
10	25025100603	2010	37.000	43.00
10	25025100700	2010	33.000	32.40
10	25025100800	2010	93.000	52.20
10	25025100900	2010	63.000	52.90
10	25025101001	2010	73.000	52.50
10	25025101002	2010	129.000	71.30
10	25025101101	2010	60.000	53.60
10	25025101102	2010	114.000	70.80
10	25025110103	2010	98.000	58.70
10	25025110201	2010	25.000	42.40
10	25025110301	2010	33.000	57.90
10	25025110401	2010	44.000	57.10
10	25025110403	2010	34.000	37.00
10	25025110501	2010	34.000	47.90
10	25025110502	2010	43.000	41.30
10	25025110601	2010	30.000	50.00
10	25025110607	2010	49.000	35.50
10	25025120103	2010	20.000	55.60
10	25025120104	2010	21.000	35.00
10	25025120105	2010	4.000	7.30
10	25025120201	2010	32.000	47.80
10	25025120301	2010	46.000	41.40
10	25025120400	2010	33.000	28.70
10	25025120500	2010	30.000	56.60
10	25025120600	2010	20.000	40.80
10	25025120700	2010	31.000	50.80
10	25025130100	2010	62.000	41.90
10	25025130200	2010	29.000	34.10
10	25025130300	2010	16.000	29.10
10	25025130402	2010	36.000	38.30
10	25025130404	2010	36.000	56.30
10	25025130406	2010	58.000	72.50
10	25025140102	2010	31.000	29.20
10	25025140105	2010	16.000	32.00
10	25025140106	2010	50.000	46.70
10	25025140107	2010	37.000	50.00
10	25025140201	2010	53.000	71.60
10	25025140202	2010	67.000	51.90
10	25025140300	2010	87.000	50.60
10	25025140400	2010	76.000	46.60
10	25025160101	2010	77.000	53.10
10	25025160200	2010	39.000	88.60
10	25025160300	2010	36.000	43.90
10	25025160400	2010	56.000	65.90
10	25025160501	2010	54.000	51.90
10	25025160502	2010	43.000	38.10
10	25025160601	2010	57.000	57.00
10	25025160602	2010	64.000	54.70
10	25025170100	2010	55.000	25.90
10	25025170200	2010	27.000	31.40
10	25025170300	2010	138.000	60.00
10	25025170400	2010	51.000	36.20
10	25025170501	2010	195.000	66.60
10	25025170502	2010	51.000	35.90
10	25025170601	2010	56.000	42.40
10	25025170701	2010	47.000	52.20
10	25025170702	2010	107.000	61.10
10	25025170800	2010	54.000	37.20
10	25025180101	2010	65.000	41.90
10	25025180200	2010	37.000	33.30
10	25025180301	2010	16.000	33.30
10	25025180400	2010	19.000	47.50
10	25025180500	2010	67.000	36.60
10	25025980101	2010	0.000	\N
10	25025980300	2010	0.000	\N
10	25025980700	2010	0.000	0.00
10	25025981000	2010	0.000	\N
10	25025981100	2010	13.000	25.50
10	25025981201	2010	0.000	\N
10	25025981202	2010	0.000	\N
10	25025981300	2010	4.000	44.40
10	25025981501	2010	0.000	\N
10	25025981502	2010	0.000	\N
10	25025981600	2010	0.000	\N
10	25025981700	2010	0.000	\N
10	25025981800	2010	0.000	0.00
10	25025990101	2010	0.000	\N
11	25025000401	2010	7.000	8.00
11	25025000402	2010	0.000	0.00
11	25025000100	2010	6.000	6.60
11	25025000201	2010	1.000	1.30
11	25025000202	2010	2.000	4.80
11	25025000301	2010	3.000	5.00
11	25025000302	2010	4.000	5.70
11	25025000502	2010	6.000	3.60
11	25025000503	2010	1.000	1.50
11	25025000504	2010	6.000	6.70
11	25025000601	2010	2.000	2.70
11	25025000602	2010	2.000	3.00
11	25025000701	2010	3.000	4.60
11	25025000703	2010	1.000	4.30
11	25025000704	2010	3.000	5.50
11	25025000802	2010	9.000	7.60
11	25025000803	2010	3.000	4.70
11	25025010103	2010	0.000	0.00
11	25025010104	2010	4.000	1.80
11	25025010203	2010	9.000	5.50
11	25025010204	2010	0.000	0.00
11	25025010300	2010	3.000	14.30
11	25025010403	2010	3.000	5.90
11	25025010404	2010	2.000	3.80
11	25025010405	2010	5.000	17.90
11	25025010408	2010	0.000	0.00
11	25025010500	2010	3.000	2.70
11	25025010600	2010	34.000	7.20
11	25025010701	2010	1.000	0.50
11	25025010702	2010	9.000	3.70
11	25025010801	2010	4.000	1.60
11	25025010802	2010	7.000	3.00
11	25025020101	2010	18.000	5.30
11	25025020200	2010	16.000	9.10
11	25025020301	2010	30.000	18.30
11	25025020302	2010	0.000	0.00
11	25025020303	2010	20.000	9.30
11	25025030100	2010	1.000	1.00
11	25025030200	2010	6.000	10.20
11	25025030300	2010	16.000	3.30
11	25025030400	2010	9.000	6.20
11	25025030500	2010	7.000	3.50
11	25025040100	2010	4.000	7.80
11	25025040200	2010	0.000	0.00
11	25025040300	2010	6.000	4.20
11	25025040401	2010	3.000	6.30
11	25025040600	2010	3.000	3.10
11	25025040801	2010	5.000	2.30
11	25025050101	2010	3.000	2.20
11	25025050200	2010	7.000	5.00
11	25025050300	2010	1.000	1.50
11	25025050400	2010	1.000	1.50
11	25025050500	2010	0.000	0.00
11	25025050600	2010	1.000	1.70
11	25025050700	2010	4.000	2.60
11	25025050901	2010	4.000	3.30
11	25025051000	2010	2.000	1.80
11	25025051101	2010	5.000	3.20
11	25025051200	2010	4.000	2.90
11	25025060101	2010	1.000	0.90
11	25025060200	2010	2.000	2.80
11	25025060301	2010	1.000	0.90
11	25025060400	2010	3.000	1.80
11	25025060501	2010	2.000	1.80
11	25025060600	2010	1.000	0.60
11	25025060700	2010	1.000	5.30
11	25025060800	2010	2.000	1.40
11	25025061000	2010	3.000	1.80
11	25025061101	2010	1.000	1.60
11	25025061200	2010	3.000	1.00
11	25025070101	2010	14.000	2.80
11	25025070200	2010	0.000	0.00
11	25025070300	2010	6.000	2.30
11	25025070402	2010	3.000	21.40
11	25025070500	2010	10.000	6.10
11	25025070600	2010	2.000	2.00
11	25025070700	2010	4.000	3.10
11	25025070800	2010	1.000	0.90
11	25025070900	2010	3.000	4.30
11	25025071101	2010	2.000	2.10
11	25025071201	2010	2.000	2.10
11	25025080100	2010	1.000	1.60
11	25025080300	2010	1.000	1.00
11	25025080401	2010	0.000	0.00
11	25025080500	2010	1.000	1.90
11	25025080601	2010	2.000	5.30
11	25025080801	2010	0.000	0.00
11	25025080900	2010	5.000	5.60
11	25025081001	2010	2.000	3.80
11	25025081100	2010	1.000	1.00
11	25025081200	2010	3.000	2.80
11	25025081300	2010	0.000	0.00
11	25025081400	2010	4.000	2.50
11	25025081500	2010	0.000	0.00
11	25025081700	2010	3.000	2.40
11	25025081800	2010	2.000	0.80
11	25025081900	2010	0.000	0.00
11	25025082000	2010	8.000	6.70
11	25025082100	2010	1.000	1.20
11	25025090100	2010	2.000	1.10
11	25025090200	2010	1.000	1.70
11	25025090300	2010	3.000	2.10
11	25025090400	2010	4.000	2.70
11	25025090600	2010	0.000	0.00
11	25025090700	2010	1.000	0.60
11	25025090901	2010	4.000	4.00
11	25025091001	2010	3.000	3.80
11	25025091100	2010	4.000	2.30
11	25025091200	2010	1.000	1.30
11	25025091300	2010	3.000	3.80
11	25025091400	2010	3.000	5.00
11	25025091500	2010	13.000	7.10
11	25025091600	2010	4.000	3.30
11	25025091700	2010	4.000	3.00
11	25025091800	2010	2.000	1.20
11	25025091900	2010	1.000	0.70
11	25025092000	2010	2.000	1.20
11	25025092101	2010	8.000	4.00
11	25025092200	2010	2.000	2.20
11	25025092300	2010	2.000	1.70
11	25025092400	2010	8.000	4.20
11	25025100100	2010	2.000	1.30
11	25025100200	2010	0.000	0.00
11	25025100300	2010	5.000	3.50
11	25025100400	2010	11.000	8.10
11	25025100500	2010	3.000	1.40
11	25025100601	2010	1.000	0.60
11	25025100603	2010	2.000	2.30
11	25025100700	2010	3.000	2.90
11	25025100800	2010	7.000	3.90
11	25025100900	2010	4.000	3.40
11	25025101001	2010	4.000	2.90
11	25025101002	2010	8.000	4.40
11	25025101101	2010	0.000	0.00
11	25025101102	2010	5.000	3.10
11	25025110103	2010	6.000	3.60
11	25025110201	2010	0.000	0.00
11	25025110301	2010	2.000	3.50
11	25025110401	2010	1.000	1.30
11	25025110403	2010	3.000	3.30
11	25025110501	2010	5.000	7.00
11	25025110502	2010	5.000	4.80
11	25025110601	2010	0.000	0.00
11	25025110607	2010	6.000	4.30
11	25025120103	2010	0.000	0.00
11	25025120104	2010	0.000	0.00
11	25025120105	2010	2.000	3.60
11	25025120201	2010	1.000	1.50
11	25025120301	2010	0.000	0.00
11	25025120400	2010	11.000	9.60
11	25025120500	2010	0.000	0.00
11	25025120600	2010	0.000	0.00
11	25025120700	2010	0.000	0.00
11	25025130100	2010	5.000	3.40
11	25025130200	2010	3.000	3.50
11	25025130300	2010	2.000	3.60
11	25025130402	2010	3.000	3.20
11	25025130404	2010	2.000	3.10
11	25025130406	2010	1.000	1.30
11	25025140102	2010	2.000	1.90
11	25025140105	2010	0.000	0.00
11	25025140106	2010	1.000	0.90
11	25025140107	2010	1.000	1.40
11	25025140201	2010	2.000	2.70
11	25025140202	2010	2.000	1.60
11	25025140300	2010	8.000	4.70
11	25025140400	2010	5.000	3.10
11	25025160101	2010	6.000	4.10
11	25025160200	2010	0.000	0.00
11	25025160300	2010	1.000	1.20
11	25025160400	2010	0.000	0.00
11	25025160501	2010	2.000	1.90
11	25025160502	2010	4.000	3.50
11	25025160601	2010	1.000	1.00
11	25025160602	2010	1.000	0.90
11	25025170100	2010	5.000	2.40
11	25025170200	2010	2.000	2.30
11	25025170300	2010	3.000	1.30
11	25025170400	2010	2.000	1.40
11	25025170501	2010	6.000	2.00
11	25025170502	2010	0.000	0.00
11	25025170601	2010	3.000	2.30
11	25025170701	2010	1.000	1.10
11	25025170702	2010	3.000	1.70
11	25025170800	2010	4.000	2.80
11	25025180101	2010	8.000	5.20
11	25025180200	2010	3.000	2.70
11	25025180301	2010	1.000	2.10
11	25025180400	2010	4.000	10.00
11	25025180500	2010	13.000	7.10
11	25025980101	2010	0.000	\N
11	25025980300	2010	0.000	\N
11	25025980700	2010	0.000	0.00
11	25025981000	2010	0.000	\N
11	25025981100	2010	1.000	2.00
11	25025981201	2010	0.000	\N
11	25025981202	2010	0.000	\N
11	25025981300	2010	0.000	0.00
11	25025981501	2010	0.000	\N
11	25025981502	2010	0.000	\N
11	25025981600	2010	0.000	\N
11	25025981700	2010	0.000	\N
11	25025981800	2010	0.000	0.00
11	25025990101	2010	0.000	\N
12	25025000401	2010	6.000	6.80
12	25025000402	2010	4.000	4.90
12	25025000100	2010	3.000	3.30
12	25025000201	2010	9.000	11.70
12	25025000202	2010	3.000	7.10
12	25025000301	2010	5.000	8.30
12	25025000302	2010	8.000	11.40
12	25025000502	2010	5.000	3.00
12	25025000503	2010	4.000	6.00
12	25025000504	2010	6.000	6.70
12	25025000601	2010	4.000	5.30
12	25025000602	2010	5.000	7.50
12	25025000701	2010	2.000	3.10
12	25025000703	2010	0.000	0.00
12	25025000704	2010	2.000	3.60
12	25025000802	2010	7.000	5.90
12	25025000803	2010	0.000	0.00
12	25025010103	2010	1.000	2.60
12	25025010104	2010	9.000	4.10
12	25025010203	2010	2.000	1.20
12	25025010204	2010	1.000	1.10
12	25025010300	2010	0.000	0.00
12	25025010403	2010	1.000	2.00
12	25025010404	2010	4.000	7.70
12	25025010405	2010	0.000	0.00
12	25025010408	2010	1.000	5.60
12	25025010500	2010	3.000	2.70
12	25025010600	2010	84.000	17.80
12	25025010701	2010	5.000	2.50
12	25025010702	2010	10.000	4.10
12	25025010801	2010	10.000	4.00
12	25025010802	2010	24.000	10.20
12	25025020101	2010	19.000	5.60
12	25025020200	2010	10.000	5.70
12	25025020301	2010	3.000	1.80
12	25025020302	2010	3.000	6.50
12	25025020303	2010	5.000	2.30
12	25025030100	2010	5.000	5.00
12	25025030200	2010	2.000	3.40
12	25025030300	2010	15.000	3.00
12	25025030400	2010	4.000	2.70
12	25025030500	2010	53.000	26.60
12	25025040100	2010	7.000	13.70
12	25025040200	2010	2.000	3.10
12	25025040300	2010	12.000	8.40
12	25025040401	2010	8.000	16.70
12	25025040600	2010	19.000	19.80
12	25025040801	2010	3.000	1.40
12	25025050101	2010	18.000	13.10
12	25025050200	2010	19.000	13.70
12	25025050300	2010	0.000	0.00
12	25025050400	2010	4.000	5.90
12	25025050500	2010	1.000	2.30
12	25025050600	2010	4.000	6.70
12	25025050700	2010	8.000	5.30
12	25025050901	2010	5.000	4.10
12	25025051000	2010	19.000	16.70
12	25025051101	2010	10.000	6.50
12	25025051200	2010	14.000	10.20
12	25025060101	2010	37.000	33.90
12	25025060200	2010	5.000	6.90
12	25025060301	2010	21.000	19.60
12	25025060400	2010	25.000	15.20
12	25025060501	2010	33.000	29.70
12	25025060600	2010	50.000	31.30
12	25025060700	2010	0.000	0.00
12	25025060800	2010	13.000	9.30
12	25025061000	2010	21.000	12.40
12	25025061101	2010	0.000	0.00
12	25025061200	2010	32.000	11.10
12	25025070101	2010	76.000	15.00
12	25025070200	2010	108.000	68.80
12	25025070300	2010	13.000	5.00
12	25025070402	2010	0.000	0.00
12	25025070500	2010	19.000	11.70
12	25025070600	2010	27.000	27.30
12	25025070700	2010	25.000	19.50
12	25025070800	2010	5.000	4.50
12	25025070900	2010	11.000	15.70
12	25025071101	2010	7.000	7.20
12	25025071201	2010	10.000	10.50
12	25025080100	2010	6.000	9.50
12	25025080300	2010	2.000	2.00
12	25025080401	2010	1.000	4.20
12	25025080500	2010	0.000	0.00
12	25025080601	2010	0.000	0.00
12	25025080801	2010	0.000	0.00
12	25025080900	2010	2.000	2.20
12	25025081001	2010	2.000	3.80
12	25025081100	2010	35.000	35.40
12	25025081200	2010	16.000	15.00
12	25025081300	2010	6.000	5.50
12	25025081400	2010	7.000	4.30
12	25025081500	2010	13.000	19.70
12	25025081700	2010	3.000	2.40
12	25025081800	2010	11.000	4.40
12	25025081900	2010	9.000	6.40
12	25025082000	2010	6.000	5.00
12	25025082100	2010	3.000	3.70
12	25025090100	2010	8.000	4.40
12	25025090200	2010	6.000	10.30
12	25025090300	2010	8.000	5.50
12	25025090400	2010	7.000	4.80
12	25025090600	2010	3.000	4.10
12	25025090700	2010	12.000	7.60
12	25025090901	2010	0.000	0.00
12	25025091001	2010	9.000	11.40
12	25025091100	2010	54.000	31.00
12	25025091200	2010	5.000	6.30
12	25025091300	2010	0.000	0.00
12	25025091400	2010	1.000	1.70
12	25025091500	2010	16.000	8.70
12	25025091600	2010	3.000	2.50
12	25025091700	2010	5.000	3.80
12	25025091800	2010	10.000	5.80
12	25025091900	2010	6.000	4.40
12	25025092000	2010	3.000	1.90
12	25025092101	2010	18.000	8.90
12	25025092200	2010	4.000	4.30
12	25025092300	2010	3.000	2.50
12	25025092400	2010	1.000	0.50
12	25025100100	2010	12.000	7.90
12	25025100200	2010	13.000	12.00
12	25025100300	2010	13.000	9.20
12	25025100400	2010	7.000	5.20
12	25025100500	2010	25.000	12.00
12	25025100601	2010	17.000	10.40
12	25025100603	2010	21.000	24.40
12	25025100700	2010	5.000	4.90
12	25025100800	2010	16.000	9.00
12	25025100900	2010	14.000	11.80
12	25025101001	2010	11.000	7.90
12	25025101002	2010	9.000	5.00
12	25025101101	2010	8.000	7.10
12	25025101102	2010	7.000	4.30
12	25025110103	2010	16.000	9.60
12	25025110201	2010	12.000	20.30
12	25025110301	2010	6.000	10.50
12	25025110401	2010	9.000	11.70
12	25025110403	2010	12.000	13.00
12	25025110501	2010	3.000	4.20
12	25025110502	2010	28.000	26.90
12	25025110601	2010	9.000	15.00
12	25025110607	2010	18.000	13.00
12	25025120103	2010	5.000	13.90
12	25025120104	2010	6.000	10.00
12	25025120105	2010	11.000	20.00
12	25025120201	2010	11.000	16.40
12	25025120301	2010	8.000	7.20
12	25025120400	2010	28.000	24.30
12	25025120500	2010	6.000	11.30
12	25025120600	2010	9.000	18.40
12	25025120700	2010	6.000	9.80
12	25025130100	2010	19.000	12.80
12	25025130200	2010	11.000	12.90
12	25025130300	2010	6.000	10.90
12	25025130402	2010	9.000	9.60
12	25025130404	2010	6.000	9.40
12	25025130406	2010	12.000	15.00
12	25025140102	2010	13.000	12.30
12	25025140105	2010	5.000	10.00
12	25025140106	2010	3.000	2.80
12	25025140107	2010	8.000	10.80
12	25025140201	2010	5.000	6.80
12	25025140202	2010	12.000	9.30
12	25025140300	2010	19.000	11.00
12	25025140400	2010	19.000	11.70
12	25025160101	2010	9.000	6.20
12	25025160200	2010	4.000	9.10
12	25025160300	2010	22.000	26.80
12	25025160400	2010	3.000	3.50
12	25025160501	2010	6.000	5.80
12	25025160502	2010	28.000	24.80
12	25025160601	2010	14.000	14.00
12	25025160602	2010	15.000	12.80
12	25025170100	2010	33.000	15.60
12	25025170200	2010	7.000	8.10
12	25025170300	2010	18.000	7.80
12	25025170400	2010	34.000	24.10
12	25025170501	2010	31.000	10.60
12	25025170502	2010	18.000	12.70
12	25025170601	2010	13.000	9.80
12	25025170701	2010	16.000	17.80
12	25025170702	2010	10.000	5.70
12	25025170800	2010	17.000	11.70
12	25025180101	2010	26.000	16.80
12	25025180200	2010	18.000	16.20
12	25025180301	2010	8.000	16.70
12	25025180400	2010	5.000	12.50
12	25025180500	2010	18.000	9.80
12	25025980101	2010	0.000	\N
12	25025980300	2010	0.000	\N
12	25025980700	2010	0.000	0.00
12	25025981000	2010	0.000	\N
12	25025981100	2010	33.000	64.70
12	25025981201	2010	0.000	\N
12	25025981202	2010	0.000	\N
12	25025981300	2010	0.000	0.00
12	25025981501	2010	0.000	\N
12	25025981502	2010	0.000	\N
12	25025981600	2010	0.000	\N
12	25025981700	2010	0.000	\N
12	25025981800	2010	0.000	0.00
12	25025990101	2010	0.000	\N
13	25025000401	2010	1.000	1.10
13	25025000402	2010	1.000	1.20
13	25025000100	2010	1.000	1.10
13	25025000201	2010	4.000	5.20
13	25025000202	2010	0.000	0.00
13	25025000301	2010	7.000	11.70
13	25025000302	2010	0.000	0.00
13	25025000502	2010	9.000	5.30
13	25025000503	2010	3.000	4.50
13	25025000504	2010	1.000	1.10
13	25025000601	2010	5.000	6.70
13	25025000602	2010	0.000	0.00
13	25025000701	2010	1.000	1.50
13	25025000703	2010	0.000	0.00
13	25025000704	2010	1.000	1.80
13	25025000802	2010	1.000	0.80
13	25025000803	2010	0.000	0.00
13	25025010103	2010	0.000	0.00
13	25025010104	2010	5.000	2.30
13	25025010203	2010	1.000	0.60
13	25025010204	2010	0.000	0.00
13	25025010300	2010	4.000	19.00
13	25025010403	2010	0.000	0.00
13	25025010404	2010	0.000	0.00
13	25025010405	2010	1.000	3.60
13	25025010408	2010	0.000	0.00
13	25025010500	2010	1.000	0.90
13	25025010600	2010	11.000	2.30
13	25025010701	2010	16.000	7.90
13	25025010702	2010	24.000	10.00
13	25025010801	2010	7.000	2.80
13	25025010802	2010	13.000	5.50
13	25025020101	2010	30.000	8.80
13	25025020200	2010	2.000	1.10
13	25025020301	2010	2.000	1.20
13	25025020302	2010	1.000	2.20
13	25025020303	2010	0.000	0.00
13	25025030100	2010	0.000	0.00
13	25025030200	2010	12.000	20.30
13	25025030300	2010	9.000	1.80
13	25025030400	2010	6.000	4.10
13	25025030500	2010	2.000	1.00
13	25025040100	2010	0.000	0.00
13	25025040200	2010	0.000	0.00
13	25025040300	2010	11.000	7.70
13	25025040401	2010	0.000	0.00
13	25025040600	2010	3.000	3.10
13	25025040801	2010	2.000	0.90
13	25025050101	2010	1.000	0.70
13	25025050200	2010	0.000	0.00
13	25025050300	2010	0.000	0.00
13	25025050400	2010	2.000	2.90
13	25025050500	2010	0.000	0.00
13	25025050600	2010	0.000	0.00
13	25025050700	2010	1.000	0.70
13	25025050901	2010	0.000	0.00
13	25025051000	2010	1.000	0.90
13	25025051101	2010	0.000	0.00
13	25025051200	2010	5.000	3.60
13	25025060101	2010	1.000	0.90
13	25025060200	2010	5.000	6.90
13	25025060301	2010	5.000	4.70
13	25025060400	2010	13.000	7.90
13	25025060501	2010	5.000	4.50
13	25025060600	2010	6.000	3.80
13	25025060700	2010	0.000	0.00
13	25025060800	2010	3.000	2.10
13	25025061000	2010	4.000	2.40
13	25025061101	2010	0.000	0.00
13	25025061200	2010	3.000	1.00
13	25025070101	2010	13.000	2.60
13	25025070200	2010	0.000	0.00
13	25025070300	2010	6.000	2.30
13	25025070402	2010	0.000	0.00
13	25025070500	2010	11.000	6.70
13	25025070600	2010	2.000	2.00
13	25025070700	2010	7.000	5.50
13	25025070800	2010	6.000	5.40
13	25025070900	2010	2.000	2.90
13	25025071101	2010	0.000	0.00
13	25025071201	2010	2.000	2.10
13	25025080100	2010	0.000	0.00
13	25025080300	2010	4.000	4.10
13	25025080401	2010	4.000	16.70
13	25025080500	2010	0.000	0.00
13	25025080601	2010	0.000	0.00
13	25025080801	2010	0.000	0.00
13	25025080900	2010	3.000	3.30
13	25025081001	2010	3.000	5.70
13	25025081100	2010	0.000	0.00
13	25025081200	2010	1.000	0.90
13	25025081300	2010	1.000	0.90
13	25025081400	2010	7.000	4.30
13	25025081500	2010	5.000	7.60
13	25025081700	2010	3.000	2.40
13	25025081800	2010	11.000	4.40
13	25025081900	2010	1.000	0.70
13	25025082000	2010	1.000	0.80
13	25025082100	2010	0.000	0.00
13	25025090100	2010	2.000	1.10
13	25025090200	2010	6.000	10.30
13	25025090300	2010	3.000	2.10
13	25025090400	2010	7.000	4.80
13	25025090600	2010	3.000	4.10
13	25025090700	2010	8.000	5.10
13	25025090901	2010	0.000	0.00
13	25025091001	2010	7.000	8.90
13	25025091100	2010	4.000	2.30
13	25025091200	2010	4.000	5.10
13	25025091300	2010	0.000	0.00
13	25025091400	2010	4.000	6.70
13	25025091500	2010	3.000	1.60
13	25025091600	2010	0.000	0.00
13	25025091700	2010	0.000	0.00
13	25025091800	2010	0.000	0.00
13	25025091900	2010	7.000	5.10
13	25025092000	2010	3.000	1.90
13	25025092101	2010	4.000	2.00
13	25025092200	2010	3.000	3.20
13	25025092300	2010	7.000	5.80
13	25025092400	2010	4.000	2.10
13	25025100100	2010	6.000	3.90
13	25025100200	2010	0.000	0.00
13	25025100300	2010	1.000	0.70
13	25025100400	2010	5.000	3.70
13	25025100500	2010	1.000	0.50
13	25025100601	2010	6.000	3.70
13	25025100603	2010	3.000	3.50
13	25025100700	2010	10.000	9.80
13	25025100800	2010	3.000	1.70
13	25025100900	2010	4.000	3.40
13	25025101001	2010	6.000	4.30
13	25025101002	2010	5.000	2.80
13	25025101101	2010	2.000	1.80
13	25025101102	2010	2.000	1.20
13	25025110103	2010	5.000	3.00
13	25025110201	2010	7.000	11.90
13	25025110301	2010	2.000	3.50
13	25025110401	2010	2.000	2.60
13	25025110403	2010	2.000	2.20
13	25025110501	2010	2.000	2.80
13	25025110502	2010	2.000	1.90
13	25025110601	2010	4.000	6.70
13	25025110607	2010	10.000	7.20
13	25025120103	2010	2.000	5.60
13	25025120104	2010	3.000	5.00
13	25025120105	2010	7.000	12.70
13	25025120201	2010	4.000	6.00
13	25025120301	2010	2.000	1.80
13	25025120400	2010	1.000	0.90
13	25025120500	2010	1.000	1.90
13	25025120600	2010	2.000	4.10
13	25025120700	2010	0.000	0.00
13	25025130100	2010	9.000	6.10
13	25025130200	2010	4.000	4.70
13	25025130300	2010	2.000	3.60
13	25025130402	2010	3.000	3.20
13	25025130404	2010	1.000	1.60
13	25025130406	2010	1.000	1.30
13	25025140102	2010	5.000	4.70
13	25025140105	2010	2.000	4.00
13	25025140106	2010	0.000	0.00
13	25025140107	2010	1.000	1.40
13	25025140201	2010	0.000	0.00
13	25025140202	2010	3.000	2.30
13	25025140300	2010	9.000	5.20
13	25025140400	2010	13.000	8.00
13	25025160101	2010	1.000	0.70
13	25025160200	2010	0.000	0.00
13	25025160300	2010	0.000	0.00
13	25025160400	2010	3.000	3.50
13	25025160501	2010	3.000	2.90
13	25025160502	2010	4.000	3.50
13	25025160601	2010	0.000	0.00
13	25025160602	2010	1.000	0.90
13	25025170100	2010	10.000	4.70
13	25025170200	2010	2.000	2.30
13	25025170300	2010	3.000	1.30
13	25025170400	2010	4.000	2.80
13	25025170501	2010	12.000	4.10
13	25025170502	2010	2.000	1.40
13	25025170601	2010	2.000	1.50
13	25025170701	2010	1.000	1.10
13	25025170702	2010	0.000	0.00
13	25025170800	2010	3.000	2.10
13	25025180101	2010	7.000	4.50
13	25025180200	2010	8.000	7.20
13	25025180301	2010	2.000	4.20
13	25025180400	2010	2.000	5.00
13	25025180500	2010	12.000	6.60
13	25025980101	2010	0.000	\N
13	25025980300	2010	0.000	\N
13	25025980700	2010	0.000	0.00
13	25025981000	2010	0.000	\N
13	25025981100	2010	2.000	3.90
13	25025981201	2010	0.000	\N
13	25025981202	2010	0.000	\N
13	25025981300	2010	0.000	0.00
13	25025981501	2010	0.000	\N
13	25025981502	2010	0.000	\N
13	25025981600	2010	0.000	\N
13	25025981700	2010	0.000	\N
13	25025981800	2010	0.000	0.00
13	25025990101	2010	0.000	\N
14	25025000401	2010	14.000	15.90
14	25025000402	2010	10.000	12.20
14	25025000100	2010	7.000	7.70
14	25025000201	2010	8.000	10.40
14	25025000202	2010	2.000	4.80
14	25025000301	2010	3.000	5.00
14	25025000302	2010	11.000	15.70
14	25025000502	2010	13.000	7.70
14	25025000503	2010	6.000	9.00
14	25025000504	2010	10.000	11.20
14	25025000601	2010	3.000	4.00
14	25025000602	2010	4.000	6.00
14	25025000701	2010	4.000	6.20
14	25025000703	2010	0.000	0.00
14	25025000704	2010	7.000	12.70
14	25025000802	2010	11.000	9.30
14	25025000803	2010	45.000	70.30
14	25025010103	2010	7.000	18.40
14	25025010104	2010	71.000	32.30
14	25025010203	2010	47.000	28.70
14	25025010204	2010	5.000	5.30
14	25025010300	2010	0.000	0.00
14	25025010403	2010	22.000	43.10
14	25025010404	2010	6.000	11.50
14	25025010405	2010	0.000	0.00
14	25025010408	2010	3.000	16.70
14	25025010500	2010	25.000	22.30
14	25025010600	2010	190.000	40.30
14	25025010701	2010	98.000	48.30
14	25025010702	2010	143.000	59.30
14	25025010801	2010	149.000	60.10
14	25025010802	2010	110.000	46.80
14	25025020101	2010	174.000	51.00
14	25025020200	2010	52.000	29.50
14	25025020301	2010	65.000	39.60
14	25025020302	2010	19.000	41.30
14	25025020303	2010	97.000	45.10
14	25025030100	2010	17.000	16.80
14	25025030200	2010	14.000	23.70
14	25025030300	2010	321.000	65.20
14	25025030400	2010	36.000	24.70
14	25025030500	2010	92.000	46.20
14	25025040100	2010	16.000	31.40
14	25025040200	2010	4.000	6.30
14	25025040300	2010	11.000	7.70
14	25025040401	2010	7.000	14.60
14	25025040600	2010	7.000	7.30
14	25025040801	2010	42.000	19.70
14	25025050101	2010	9.000	6.60
14	25025050200	2010	7.000	5.00
14	25025050300	2010	1.000	1.50
14	25025050400	2010	5.000	7.40
14	25025050500	2010	1.000	2.30
14	25025050600	2010	5.000	8.30
14	25025050700	2010	3.000	2.00
14	25025050901	2010	7.000	5.70
14	25025051000	2010	5.000	4.40
14	25025051101	2010	12.000	7.70
14	25025051200	2010	8.000	5.80
14	25025060101	2010	8.000	7.30
14	25025060200	2010	1.000	1.40
14	25025060301	2010	9.000	8.40
14	25025060400	2010	9.000	5.50
14	25025060501	2010	2.000	1.80
14	25025060600	2010	47.000	29.40
14	25025060700	2010	0.000	0.00
14	25025060800	2010	7.000	5.00
14	25025061000	2010	0.000	0.00
14	25025061101	2010	0.000	0.00
14	25025061200	2010	21.000	7.30
14	25025070101	2010	183.000	36.00
14	25025070200	2010	7.000	4.50
14	25025070300	2010	172.000	66.70
14	25025070402	2010	0.000	0.00
14	25025070500	2010	24.000	14.70
14	25025070600	2010	26.000	26.30
14	25025070700	2010	56.000	43.80
14	25025070800	2010	27.000	24.10
14	25025070900	2010	21.000	30.00
14	25025071101	2010	9.000	9.30
14	25025071201	2010	9.000	9.50
14	25025080100	2010	1.000	1.60
14	25025080300	2010	4.000	4.10
14	25025080401	2010	1.000	4.20
14	25025080500	2010	0.000	0.00
14	25025080601	2010	3.000	7.90
14	25025080801	2010	0.000	0.00
14	25025080900	2010	10.000	11.10
14	25025081001	2010	5.000	9.40
14	25025081100	2010	6.000	6.10
14	25025081200	2010	1.000	0.90
14	25025081300	2010	1.000	0.90
14	25025081400	2010	6.000	3.70
14	25025081500	2010	1.000	1.50
14	25025081700	2010	2.000	1.60
14	25025081800	2010	2.000	0.80
14	25025081900	2010	4.000	2.80
14	25025082000	2010	2.000	1.70
14	25025082100	2010	1.000	1.20
14	25025090100	2010	3.000	1.60
14	25025090200	2010	1.000	1.70
14	25025090300	2010	2.000	1.40
14	25025090400	2010	2.000	1.40
14	25025090600	2010	0.000	0.00
14	25025090700	2010	17.000	10.80
14	25025090901	2010	9.000	9.00
14	25025091001	2010	2.000	2.50
14	25025091100	2010	3.000	1.70
14	25025091200	2010	3.000	3.80
14	25025091300	2010	0.000	0.00
14	25025091400	2010	0.000	0.00
14	25025091500	2010	1.000	0.50
14	25025091600	2010	0.000	0.00
14	25025091700	2010	5.000	3.80
14	25025091800	2010	3.000	1.70
14	25025091900	2010	1.000	0.70
14	25025092000	2010	2.000	1.20
14	25025092101	2010	3.000	1.50
14	25025092200	2010	1.000	1.10
14	25025092300	2010	4.000	3.30
14	25025092400	2010	1.000	0.50
14	25025100100	2010	3.000	2.00
14	25025100200	2010	1.000	0.90
14	25025100300	2010	0.000	0.00
14	25025100400	2010	2.000	1.50
14	25025100500	2010	1.000	0.50
14	25025100601	2010	7.000	4.30
14	25025100603	2010	7.000	8.10
14	25025100700	2010	4.000	3.90
14	25025100800	2010	9.000	5.10
14	25025100900	2010	4.000	3.40
14	25025101001	2010	1.000	0.70
14	25025101002	2010	2.000	1.10
14	25025101101	2010	0.000	0.00
14	25025101102	2010	2.000	1.20
14	25025110103	2010	8.000	4.80
14	25025110201	2010	1.000	1.70
14	25025110301	2010	1.000	1.80
14	25025110401	2010	1.000	1.30
14	25025110403	2010	0.000	0.00
14	25025110501	2010	5.000	7.00
14	25025110502	2010	5.000	4.80
14	25025110601	2010	4.000	6.70
14	25025110607	2010	5.000	3.60
14	25025120103	2010	4.000	11.10
14	25025120104	2010	3.000	5.00
14	25025120105	2010	14.000	25.50
14	25025120201	2010	0.000	0.00
14	25025120301	2010	2.000	1.80
14	25025120400	2010	5.000	4.30
14	25025120500	2010	0.000	0.00
14	25025120600	2010	3.000	6.10
14	25025120700	2010	3.000	4.90
14	25025130100	2010	16.000	10.80
14	25025130200	2010	11.000	12.90
14	25025130300	2010	8.000	14.50
14	25025130402	2010	4.000	4.30
14	25025130404	2010	3.000	4.70
14	25025130406	2010	1.000	1.30
14	25025140102	2010	3.000	2.80
14	25025140105	2010	1.000	2.00
14	25025140106	2010	0.000	0.00
14	25025140107	2010	2.000	2.70
14	25025140201	2010	0.000	0.00
14	25025140202	2010	7.000	5.40
14	25025140300	2010	4.000	2.30
14	25025140400	2010	8.000	4.90
14	25025160101	2010	3.000	2.10
14	25025160200	2010	0.000	0.00
14	25025160300	2010	10.000	12.20
14	25025160400	2010	1.000	1.20
14	25025160501	2010	1.000	1.00
14	25025160502	2010	4.000	3.50
14	25025160601	2010	6.000	6.00
14	25025160602	2010	4.000	3.40
14	25025170100	2010	14.000	6.60
14	25025170200	2010	15.000	17.40
14	25025170300	2010	9.000	3.90
14	25025170400	2010	5.000	3.50
14	25025170501	2010	27.000	9.20
14	25025170502	2010	31.000	21.80
14	25025170601	2010	7.000	5.30
14	25025170701	2010	9.000	10.00
14	25025170702	2010	6.000	3.40
14	25025170800	2010	21.000	14.50
14	25025180101	2010	23.000	14.80
14	25025180200	2010	11.000	9.90
14	25025180301	2010	3.000	6.30
14	25025180400	2010	1.000	2.50
14	25025180500	2010	29.000	15.80
14	25025980101	2010	0.000	\N
14	25025980300	2010	0.000	\N
14	25025980700	2010	0.000	0.00
14	25025981000	2010	0.000	\N
14	25025981100	2010	0.000	0.00
14	25025981201	2010	0.000	\N
14	25025981202	2010	0.000	\N
14	25025981300	2010	1.000	11.10
14	25025981501	2010	0.000	\N
14	25025981502	2010	0.000	\N
14	25025981600	2010	0.000	\N
14	25025981700	2010	0.000	\N
14	25025981800	2010	1.000	33.30
14	25025990101	2010	0.000	\N
15	25025000401	2010	0.000	0.00
15	25025000402	2010	0.000	0.00
15	25025000100	2010	0.000	0.00
15	25025000201	2010	0.000	0.00
15	25025000202	2010	0.000	0.00
15	25025000301	2010	0.000	0.00
15	25025000302	2010	0.000	0.00
15	25025000502	2010	0.000	0.00
15	25025000503	2010	0.000	0.00
15	25025000504	2010	0.000	0.00
15	25025000601	2010	0.000	0.00
15	25025000602	2010	0.000	0.00
15	25025000701	2010	0.000	0.00
15	25025000703	2010	0.000	0.00
15	25025000704	2010	0.000	0.00
15	25025000802	2010	0.000	0.00
15	25025000803	2010	0.000	0.00
15	25025010103	2010	0.000	0.00
15	25025010104	2010	0.000	0.00
15	25025010203	2010	0.000	0.00
15	25025010204	2010	0.000	0.00
15	25025010300	2010	0.000	0.00
15	25025010403	2010	0.000	0.00
15	25025010404	2010	0.000	0.00
15	25025010405	2010	0.000	0.00
15	25025010408	2010	0.000	0.00
15	25025010500	2010	0.000	0.00
15	25025010600	2010	0.000	0.00
15	25025010701	2010	0.000	0.00
15	25025010702	2010	0.000	0.00
15	25025010801	2010	0.000	0.00
15	25025010802	2010	0.000	0.00
15	25025020101	2010	0.000	0.00
15	25025020200	2010	0.000	0.00
15	25025020301	2010	0.000	0.00
15	25025020302	2010	0.000	0.00
15	25025020303	2010	0.000	0.00
15	25025030100	2010	0.000	0.00
15	25025030200	2010	0.000	0.00
15	25025030300	2010	0.000	0.00
15	25025030400	2010	1.000	0.70
15	25025030500	2010	0.000	0.00
15	25025040100	2010	0.000	0.00
15	25025040200	2010	0.000	0.00
15	25025040300	2010	0.000	0.00
15	25025040401	2010	0.000	0.00
15	25025040600	2010	0.000	0.00
15	25025040801	2010	0.000	0.00
15	25025050101	2010	0.000	0.00
15	25025050200	2010	0.000	0.00
15	25025050300	2010	0.000	0.00
15	25025050400	2010	0.000	0.00
15	25025050500	2010	0.000	0.00
15	25025050600	2010	0.000	0.00
15	25025050700	2010	0.000	0.00
15	25025050901	2010	0.000	0.00
15	25025051000	2010	0.000	0.00
15	25025051101	2010	0.000	0.00
15	25025051200	2010	0.000	0.00
15	25025060101	2010	0.000	0.00
15	25025060200	2010	0.000	0.00
15	25025060301	2010	0.000	0.00
15	25025060400	2010	0.000	0.00
15	25025060501	2010	0.000	0.00
15	25025060600	2010	0.000	0.00
15	25025060700	2010	0.000	0.00
15	25025060800	2010	0.000	0.00
15	25025061000	2010	0.000	0.00
15	25025061101	2010	0.000	0.00
15	25025061200	2010	0.000	0.00
15	25025070101	2010	0.000	0.00
15	25025070200	2010	0.000	0.00
15	25025070300	2010	0.000	0.00
15	25025070402	2010	0.000	0.00
15	25025070500	2010	0.000	0.00
15	25025070600	2010	0.000	0.00
15	25025070700	2010	0.000	0.00
15	25025070800	2010	0.000	0.00
15	25025070900	2010	0.000	0.00
15	25025071101	2010	0.000	0.00
15	25025071201	2010	0.000	0.00
15	25025080100	2010	0.000	0.00
15	25025080300	2010	0.000	0.00
15	25025080401	2010	0.000	0.00
15	25025080500	2010	0.000	0.00
15	25025080601	2010	0.000	0.00
15	25025080801	2010	0.000	0.00
15	25025080900	2010	0.000	0.00
15	25025081001	2010	0.000	0.00
15	25025081100	2010	0.000	0.00
15	25025081200	2010	0.000	0.00
15	25025081300	2010	0.000	0.00
15	25025081400	2010	0.000	0.00
15	25025081500	2010	0.000	0.00
15	25025081700	2010	0.000	0.00
15	25025081800	2010	0.000	0.00
15	25025081900	2010	0.000	0.00
15	25025082000	2010	0.000	0.00
15	25025082100	2010	0.000	0.00
15	25025090100	2010	0.000	0.00
15	25025090200	2010	0.000	0.00
15	25025090300	2010	0.000	0.00
15	25025090400	2010	0.000	0.00
15	25025090600	2010	0.000	0.00
15	25025090700	2010	0.000	0.00
15	25025090901	2010	0.000	0.00
15	25025091001	2010	0.000	0.00
15	25025091100	2010	0.000	0.00
15	25025091200	2010	0.000	0.00
15	25025091300	2010	0.000	0.00
15	25025091400	2010	0.000	0.00
15	25025091500	2010	0.000	0.00
15	25025091600	2010	0.000	0.00
15	25025091700	2010	0.000	0.00
15	25025091800	2010	0.000	0.00
15	25025091900	2010	0.000	0.00
15	25025092000	2010	0.000	0.00
15	25025092101	2010	0.000	0.00
15	25025092200	2010	0.000	0.00
15	25025092300	2010	0.000	0.00
15	25025092400	2010	0.000	0.00
15	25025100100	2010	0.000	0.00
15	25025100200	2010	0.000	0.00
15	25025100300	2010	0.000	0.00
15	25025100400	2010	0.000	0.00
15	25025100500	2010	0.000	0.00
15	25025100601	2010	0.000	0.00
15	25025100603	2010	0.000	0.00
15	25025100700	2010	1.000	1.00
15	25025100800	2010	0.000	0.00
15	25025100900	2010	0.000	0.00
15	25025101001	2010	0.000	0.00
15	25025101002	2010	0.000	0.00
15	25025101101	2010	0.000	0.00
15	25025101102	2010	0.000	0.00
15	25025110103	2010	0.000	0.00
15	25025110201	2010	0.000	0.00
15	25025110301	2010	0.000	0.00
15	25025110401	2010	0.000	0.00
15	25025110403	2010	0.000	0.00
15	25025110501	2010	0.000	0.00
15	25025110502	2010	0.000	0.00
15	25025110601	2010	0.000	0.00
15	25025110607	2010	0.000	0.00
15	25025120103	2010	1.000	2.80
15	25025120104	2010	0.000	0.00
15	25025120105	2010	0.000	0.00
15	25025120201	2010	0.000	0.00
15	25025120301	2010	0.000	0.00
15	25025120400	2010	0.000	0.00
15	25025120500	2010	0.000	0.00
15	25025120600	2010	0.000	0.00
15	25025120700	2010	0.000	0.00
15	25025130100	2010	0.000	0.00
15	25025130200	2010	0.000	0.00
15	25025130300	2010	0.000	0.00
15	25025130402	2010	0.000	0.00
15	25025130404	2010	0.000	0.00
15	25025130406	2010	0.000	0.00
15	25025140102	2010	0.000	0.00
15	25025140105	2010	0.000	0.00
15	25025140106	2010	0.000	0.00
15	25025140107	2010	0.000	0.00
15	25025140201	2010	0.000	0.00
15	25025140202	2010	0.000	0.00
15	25025140300	2010	0.000	0.00
15	25025140400	2010	0.000	0.00
15	25025160101	2010	0.000	0.00
15	25025160200	2010	0.000	0.00
15	25025160300	2010	0.000	0.00
15	25025160400	2010	0.000	0.00
15	25025160501	2010	0.000	0.00
15	25025160502	2010	0.000	0.00
15	25025160601	2010	0.000	0.00
15	25025160602	2010	0.000	0.00
15	25025170100	2010	0.000	0.00
15	25025170200	2010	3.000	3.50
15	25025170300	2010	0.000	0.00
15	25025170400	2010	0.000	0.00
15	25025170501	2010	0.000	0.00
15	25025170502	2010	0.000	0.00
15	25025170601	2010	0.000	0.00
15	25025170701	2010	0.000	0.00
15	25025170702	2010	0.000	0.00
15	25025170800	2010	0.000	0.00
15	25025180101	2010	0.000	0.00
15	25025180200	2010	0.000	0.00
15	25025180301	2010	0.000	0.00
15	25025180400	2010	0.000	0.00
15	25025180500	2010	0.000	0.00
15	25025980101	2010	0.000	\N
15	25025980300	2010	0.000	\N
15	25025980700	2010	0.000	0.00
15	25025981000	2010	0.000	\N
15	25025981100	2010	0.000	0.00
15	25025981201	2010	0.000	\N
15	25025981202	2010	0.000	\N
15	25025981300	2010	0.000	0.00
15	25025981501	2010	0.000	\N
15	25025981502	2010	0.000	\N
15	25025981600	2010	0.000	\N
15	25025981700	2010	0.000	\N
15	25025981800	2010	0.000	0.00
15	25025990101	2010	0.000	\N
16	25025000401	2010	20.000	22.70
16	25025000402	2010	20.000	24.40
16	25025000100	2010	40.000	44.00
16	25025000201	2010	13.000	16.90
16	25025000202	2010	12.000	28.60
16	25025000301	2010	8.000	13.30
16	25025000302	2010	14.000	20.00
16	25025000502	2010	41.000	24.30
16	25025000503	2010	3.000	4.50
16	25025000504	2010	8.000	9.00
16	25025000601	2010	17.000	22.70
16	25025000602	2010	11.000	16.40
16	25025000701	2010	12.000	18.50
16	25025000703	2010	4.000	17.40
16	25025000704	2010	7.000	12.70
16	25025000802	2010	12.000	10.20
16	25025000803	2010	13.000	20.30
16	25025010103	2010	2.000	5.30
16	25025010104	2010	31.000	14.10
16	25025010203	2010	3.000	1.80
16	25025010204	2010	3.000	3.20
16	25025010300	2010	0.000	0.00
16	25025010403	2010	4.000	7.80
16	25025010404	2010	6.000	11.50
16	25025010405	2010	2.000	7.10
16	25025010408	2010	2.000	11.10
16	25025010500	2010	9.000	8.00
16	25025010600	2010	15.000	3.20
16	25025010701	2010	7.000	3.40
16	25025010702	2010	28.000	11.60
16	25025010801	2010	10.000	4.00
16	25025010802	2010	31.000	13.20
16	25025020101	2010	27.000	7.90
16	25025020200	2010	18.000	10.20
16	25025020301	2010	12.000	7.30
16	25025020302	2010	1.000	2.20
16	25025020303	2010	3.000	1.40
16	25025030100	2010	13.000	12.90
16	25025030200	2010	2.000	3.40
16	25025030300	2010	16.000	3.30
16	25025030400	2010	22.000	15.10
16	25025030500	2010	6.000	3.00
16	25025040100	2010	10.000	19.60
16	25025040200	2010	2.000	3.10
16	25025040300	2010	52.000	36.40
16	25025040401	2010	15.000	31.30
16	25025040600	2010	16.000	16.70
16	25025040801	2010	5.000	2.30
16	25025050101	2010	42.000	30.70
16	25025050200	2010	53.000	38.10
16	25025050300	2010	10.000	14.70
16	25025050400	2010	15.000	22.10
16	25025050500	2010	16.000	37.20
16	25025050600	2010	27.000	45.00
16	25025050700	2010	62.000	41.10
16	25025050901	2010	57.000	46.70
16	25025051000	2010	38.000	33.30
16	25025051101	2010	45.000	29.00
16	25025051200	2010	46.000	33.60
16	25025060101	2010	35.000	32.10
16	25025060200	2010	41.000	56.90
16	25025060301	2010	38.000	35.50
16	25025060400	2010	61.000	37.00
16	25025060501	2010	34.000	30.60
16	25025060600	2010	8.000	5.00
16	25025060700	2010	0.000	0.00
16	25025060800	2010	54.000	38.60
16	25025061000	2010	38.000	22.50
16	25025061101	2010	33.000	53.20
16	25025061200	2010	95.000	33.00
16	25025070101	2010	13.000	2.60
16	25025070200	2010	10.000	6.40
16	25025070300	2010	17.000	6.60
16	25025070402	2010	4.000	28.60
16	25025070500	2010	34.000	20.90
16	25025070600	2010	8.000	8.10
16	25025070700	2010	12.000	9.40
16	25025070800	2010	10.000	8.90
16	25025070900	2010	9.000	12.90
16	25025071101	2010	10.000	10.30
16	25025071201	2010	44.000	46.30
16	25025080100	2010	16.000	25.40
16	25025080300	2010	36.000	36.70
16	25025080401	2010	2.000	8.30
16	25025080500	2010	9.000	16.70
16	25025080601	2010	5.000	13.20
16	25025080801	2010	2.000	10.50
16	25025080900	2010	18.000	20.00
16	25025081001	2010	15.000	28.30
16	25025081100	2010	18.000	18.20
16	25025081200	2010	23.000	21.50
16	25025081300	2010	23.000	20.90
16	25025081400	2010	89.000	54.90
16	25025081500	2010	13.000	19.70
16	25025081700	2010	52.000	41.30
16	25025081800	2010	121.000	48.60
16	25025081900	2010	22.000	15.60
16	25025082000	2010	46.000	38.30
16	25025082100	2010	22.000	26.80
16	25025090100	2010	54.000	29.70
16	25025090200	2010	15.000	25.90
16	25025090300	2010	53.000	36.60
16	25025090400	2010	50.000	34.20
16	25025090600	2010	32.000	43.80
16	25025090700	2010	50.000	31.60
16	25025090901	2010	1.000	1.00
16	25025091001	2010	19.000	24.10
16	25025091100	2010	44.000	25.30
16	25025091200	2010	26.000	32.90
16	25025091300	2010	44.000	56.40
16	25025091400	2010	25.000	41.70
16	25025091500	2010	55.000	30.10
16	25025091600	2010	46.000	37.70
16	25025091700	2010	40.000	30.10
16	25025091800	2010	48.000	27.90
16	25025091900	2010	43.000	31.60
16	25025092000	2010	90.000	55.90
16	25025092101	2010	29.000	14.40
16	25025092200	2010	17.000	18.30
16	25025092300	2010	40.000	33.10
16	25025092400	2010	56.000	29.20
16	25025100100	2010	50.000	32.90
16	25025100200	2010	41.000	38.00
16	25025100300	2010	53.000	37.60
16	25025100400	2010	24.000	17.80
16	25025100500	2010	49.000	23.40
16	25025100601	2010	38.000	23.20
16	25025100603	2010	16.000	18.60
16	25025100700	2010	46.000	45.10
16	25025100800	2010	50.000	28.10
16	25025100900	2010	30.000	25.20
16	25025101001	2010	44.000	31.70
16	25025101002	2010	28.000	15.50
16	25025101101	2010	42.000	37.50
16	25025101102	2010	31.000	19.30
16	25025110103	2010	34.000	20.40
16	25025110201	2010	14.000	23.70
16	25025110301	2010	13.000	22.80
16	25025110401	2010	20.000	26.00
16	25025110403	2010	41.000	44.60
16	25025110501	2010	22.000	31.00
16	25025110502	2010	21.000	20.20
16	25025110601	2010	13.000	21.70
16	25025110607	2010	50.000	36.20
16	25025120103	2010	4.000	11.10
16	25025120104	2010	27.000	45.00
16	25025120105	2010	17.000	30.90
16	25025120201	2010	19.000	28.40
16	25025120301	2010	53.000	47.70
16	25025120400	2010	37.000	32.20
16	25025120500	2010	16.000	30.20
16	25025120600	2010	15.000	30.60
16	25025120700	2010	21.000	34.40
16	25025130100	2010	37.000	25.00
16	25025130200	2010	27.000	31.80
16	25025130300	2010	21.000	38.20
16	25025130402	2010	39.000	41.50
16	25025130404	2010	16.000	25.00
16	25025130406	2010	7.000	8.80
16	25025140102	2010	52.000	49.10
16	25025140105	2010	26.000	52.00
16	25025140106	2010	53.000	49.50
16	25025140107	2010	25.000	33.80
16	25025140201	2010	14.000	18.90
16	25025140202	2010	38.000	29.50
16	25025140300	2010	45.000	26.20
16	25025140400	2010	42.000	25.80
16	25025160101	2010	49.000	33.80
16	25025160200	2010	1.000	2.30
16	25025160300	2010	13.000	15.90
16	25025160400	2010	22.000	25.90
16	25025160501	2010	38.000	36.50
16	25025160502	2010	30.000	26.50
16	25025160601	2010	22.000	22.00
16	25025160602	2010	32.000	27.40
16	25025170100	2010	95.000	44.80
16	25025170200	2010	30.000	34.90
16	25025170300	2010	59.000	25.70
16	25025170400	2010	45.000	31.90
16	25025170501	2010	22.000	7.50
16	25025170502	2010	40.000	28.20
16	25025170601	2010	51.000	38.60
16	25025170701	2010	16.000	17.80
16	25025170702	2010	49.000	28.00
16	25025170800	2010	46.000	31.70
16	25025180101	2010	26.000	16.80
16	25025180200	2010	34.000	30.60
16	25025180301	2010	18.000	37.50
16	25025180400	2010	9.000	22.50
16	25025180500	2010	44.000	24.00
16	25025980101	2010	0.000	\N
16	25025980300	2010	0.000	\N
16	25025980700	2010	1.000	100.00
16	25025981000	2010	0.000	\N
16	25025981100	2010	2.000	3.90
16	25025981201	2010	0.000	\N
16	25025981202	2010	0.000	\N
16	25025981300	2010	4.000	44.40
16	25025981501	2010	0.000	\N
16	25025981502	2010	0.000	\N
16	25025981600	2010	0.000	\N
16	25025981700	2010	0.000	\N
16	25025981800	2010	2.000	66.70
16	25025990101	2010	0.000	\N
17	25025000401	2010	2877.000	100.00
17	25025000402	2010	1461.000	100.00
17	25025000100	2010	1616.000	100.00
17	25025000201	2010	1541.000	100.00
17	25025000202	2010	1480.000	100.00
17	25025000301	2010	1159.000	100.00
17	25025000302	2010	1276.000	100.00
17	25025000502	2010	1872.000	100.00
17	25025000503	2010	1341.000	100.00
17	25025000504	2010	2637.000	100.00
17	25025000601	2010	1450.000	100.00
17	25025000602	2010	1968.000	100.00
17	25025000701	2010	2294.000	100.00
17	25025000703	2010	1395.000	100.00
17	25025000704	2010	2350.000	100.00
17	25025000802	2010	3011.000	100.00
17	25025000803	2010	882.000	100.00
17	25025010103	2010	490.000	100.00
17	25025010104	2010	1916.000	100.00
17	25025010203	2010	3499.000	100.00
17	25025010204	2010	1188.000	100.00
17	25025010300	2010	395.000	100.00
17	25025010403	2010	2025.000	100.00
17	25025010404	2010	1810.000	100.00
17	25025010405	2010	966.000	100.00
17	25025010408	2010	943.000	100.00
17	25025010500	2010	1655.000	100.00
17	25025010600	2010	1854.000	100.00
17	25025010701	2010	1396.000	100.00
17	25025010702	2010	1402.000	100.00
17	25025010801	2010	1651.000	100.00
17	25025010802	2010	1871.000	100.00
17	25025020101	2010	2473.000	100.00
17	25025020200	2010	2302.000	100.00
17	25025020301	2010	1250.000	100.00
17	25025020302	2010	675.000	100.00
17	25025020303	2010	1632.000	100.00
17	25025030100	2010	1276.000	100.00
17	25025030200	2010	1044.000	100.00
17	25025030300	2010	2468.000	100.00
17	25025030400	2010	1513.000	100.00
17	25025030500	2010	1457.000	100.00
17	25025040100	2010	1188.000	100.00
17	25025040200	2010	663.000	100.00
17	25025040300	2010	1894.000	100.00
17	25025040401	2010	1174.000	100.00
17	25025040600	2010	1238.000	100.00
17	25025040801	2010	1876.000	100.00
17	25025050101	2010	1713.000	100.00
17	25025050200	2010	1695.000	100.00
17	25025050300	2010	973.000	100.00
17	25025050400	2010	967.000	100.00
17	25025050500	2010	659.000	100.00
17	25025050600	2010	746.000	100.00
17	25025050700	2010	1455.000	100.00
17	25025050901	2010	1324.000	100.00
17	25025051000	2010	1670.000	100.00
17	25025051101	2010	2190.000	100.00
17	25025051200	2010	1023.000	100.00
17	25025060101	2010	1575.000	100.00
17	25025060200	2010	927.000	100.00
17	25025060301	2010	1540.000	100.00
17	25025060400	2010	2378.000	100.00
17	25025060501	2010	1831.000	100.00
17	25025060600	2010	1370.000	100.00
17	25025060700	2010	617.000	100.00
17	25025060800	2010	2002.000	100.00
17	25025061000	2010	1239.000	100.00
17	25025061101	2010	982.000	100.00
17	25025061200	2010	1753.000	100.00
17	25025070101	2010	2875.000	100.00
17	25025070200	2010	1533.000	100.00
17	25025070300	2010	2448.000	100.00
17	25025070402	2010	666.000	100.00
17	25025070500	2010	2903.000	100.00
17	25025070600	2010	1210.000	100.00
17	25025070700	2010	1238.000	100.00
17	25025070800	2010	2044.000	100.00
17	25025070900	2010	1728.000	100.00
17	25025071101	2010	2088.000	100.00
17	25025071201	2010	1304.000	100.00
17	25025080100	2010	681.000	100.00
17	25025080300	2010	693.000	100.00
17	25025080401	2010	1225.000	100.00
17	25025080500	2010	1269.000	100.00
17	25025080601	2010	882.000	100.00
17	25025080801	2010	927.000	100.00
17	25025080900	2010	1686.000	100.00
17	25025081001	2010	2234.000	100.00
17	25025081100	2010	1682.000	100.00
17	25025081200	2010	1125.000	100.00
17	25025081300	2010	2001.000	100.00
17	25025081400	2010	1300.000	100.00
17	25025081500	2010	839.000	100.00
17	25025081700	2010	1473.000	100.00
17	25025081800	2010	1139.000	100.00
17	25025081900	2010	1256.000	100.00
17	25025082000	2010	1158.000	100.00
17	25025082100	2010	2035.000	100.00
17	25025090100	2010	1681.000	100.00
17	25025090200	2010	772.000	100.00
17	25025090300	2010	1123.000	100.00
17	25025090400	2010	1148.000	100.00
17	25025090600	2010	720.000	100.00
17	25025090700	2010	1832.000	100.00
17	25025090901	2010	1540.000	100.00
17	25025091001	2010	1236.000	100.00
17	25025091100	2010	1792.000	100.00
17	25025091200	2010	1160.000	100.00
17	25025091300	2010	790.000	100.00
17	25025091400	2010	879.000	100.00
17	25025091500	2010	1470.000	100.00
17	25025091600	2010	1043.000	100.00
17	25025091700	2010	917.000	100.00
17	25025091800	2010	1042.000	100.00
17	25025091900	2010	1244.000	100.00
17	25025092000	2010	1532.000	100.00
17	25025092101	2010	2252.000	100.00
17	25025092200	2010	1134.000	100.00
17	25025092300	2010	956.000	100.00
17	25025092400	2010	1873.000	100.00
17	25025100100	2010	1895.000	100.00
17	25025100200	2010	905.000	100.00
17	25025100300	2010	1121.000	100.00
17	25025100400	2010	1695.000	100.00
17	25025100500	2010	2174.000	100.00
17	25025100601	2010	2028.000	100.00
17	25025100603	2010	754.000	100.00
17	25025100700	2010	1873.000	100.00
17	25025100800	2010	2524.000	100.00
17	25025100900	2010	1610.000	100.00
17	25025101001	2010	2127.000	100.00
17	25025101002	2010	1968.000	100.00
17	25025101101	2010	1048.000	100.00
17	25025101102	2010	1511.000	100.00
17	25025110103	2010	2186.000	100.00
17	25025110201	2010	815.000	100.00
17	25025110301	2010	898.000	100.00
17	25025110401	2010	1285.000	100.00
17	25025110403	2010	1675.000	100.00
17	25025110501	2010	1300.000	100.00
17	25025110502	2010	1580.000	100.00
17	25025110601	2010	1235.000	100.00
17	25025110607	2010	2089.000	100.00
17	25025120103	2010	660.000	100.00
17	25025120104	2010	1000.000	100.00
17	25025120105	2010	898.000	100.00
17	25025120201	2010	1659.000	100.00
17	25025120301	2010	1784.000	100.00
17	25025120400	2010	2710.000	100.00
17	25025120500	2010	852.000	100.00
17	25025120600	2010	1054.000	100.00
17	25025120700	2010	983.000	100.00
17	25025130100	2010	2668.000	100.00
17	25025130200	2010	1829.000	100.00
17	25025130300	2010	1756.000	100.00
17	25025130402	2010	2102.000	100.00
17	25025130404	2010	1258.000	100.00
17	25025130406	2010	2112.000	100.00
17	25025140102	2010	1548.000	100.00
17	25025140105	2010	1274.000	100.00
17	25025140106	2010	791.000	100.00
17	25025140107	2010	977.000	100.00
17	25025140201	2010	861.000	100.00
17	25025140202	2010	1952.000	100.00
17	25025140300	2010	2353.000	100.00
17	25025140400	2010	2743.000	100.00
17	25025160101	2010	2014.000	100.00
17	25025160200	2010	1181.000	100.00
17	25025160300	2010	1197.000	100.00
17	25025160400	2010	943.000	100.00
17	25025160501	2010	1867.000	100.00
17	25025160502	2010	1476.000	100.00
17	25025160601	2010	1470.000	100.00
17	25025160602	2010	1683.000	100.00
17	25025170100	2010	2852.000	100.00
17	25025170200	2010	1728.000	100.00
17	25025170300	2010	3586.000	100.00
17	25025170400	2010	2191.000	100.00
17	25025170501	2010	1634.000	100.00
17	25025170502	2010	1406.000	100.00
17	25025170601	2010	1875.000	100.00
17	25025170701	2010	963.000	100.00
17	25025170702	2010	2144.000	100.00
17	25025170800	2010	2072.000	100.00
17	25025180101	2010	2347.000	100.00
17	25025180200	2010	1683.000	100.00
17	25025180301	2010	1180.000	100.00
17	25025180400	2010	742.000	100.00
17	25025180500	2010	1831.000	100.00
17	25025980101	2010	0.000	\N
17	25025980300	2010	2.000	100.00
17	25025980700	2010	4.000	100.00
17	25025981000	2010	5.000	100.00
17	25025981100	2010	85.000	100.00
17	25025981201	2010	0.000	\N
17	25025981202	2010	0.000	\N
17	25025981300	2010	236.000	100.00
17	25025981501	2010	0.000	\N
17	25025981502	2010	3.000	100.00
17	25025981600	2010	0.000	\N
17	25025981700	2010	0.000	\N
17	25025981800	2010	46.000	100.00
17	25025990101	2010	0.000	\N
18	25025000401	2010	496.000	17.20
18	25025000402	2010	480.000	32.90
18	25025000100	2010	408.000	25.20
18	25025000201	2010	447.000	29.00
18	25025000202	2010	474.000	32.00
18	25025000301	2010	476.000	41.10
18	25025000302	2010	631.000	49.50
18	25025000502	2010	359.000	19.20
18	25025000503	2010	348.000	26.00
18	25025000504	2010	518.000	19.60
18	25025000601	2010	462.000	31.90
18	25025000602	2010	187.000	9.50
18	25025000701	2010	339.000	14.80
18	25025000703	2010	47.000	3.40
18	25025000704	2010	316.000	13.40
18	25025000802	2010	439.000	14.60
18	25025000803	2010	8.000	0.90
18	25025010103	2010	49.000	10.00
18	25025010104	2010	401.000	20.90
18	25025010203	2010	244.000	7.00
18	25025010204	2010	162.000	13.60
18	25025010300	2010	63.000	15.90
18	25025010403	2010	121.000	6.00
18	25025010404	2010	201.000	11.10
18	25025010405	2010	96.000	9.90
18	25025010408	2010	99.000	10.50
18	25025010500	2010	208.000	12.60
18	25025010600	2010	352.000	19.00
18	25025010701	2010	455.000	32.60
18	25025010702	2010	637.000	45.40
18	25025010801	2010	812.000	49.20
18	25025010802	2010	766.000	40.90
18	25025020101	2010	1115.000	45.10
18	25025020200	2010	498.000	21.60
18	25025020301	2010	237.000	19.00
18	25025020302	2010	223.000	33.00
18	25025020303	2010	444.000	27.20
18	25025030100	2010	238.000	18.70
18	25025030200	2010	173.000	16.60
18	25025030300	2010	900.000	36.50
18	25025030400	2010	309.000	20.40
18	25025030500	2010	548.000	37.60
18	25025040100	2010	678.000	57.10
18	25025040200	2010	209.000	31.50
18	25025040300	2010	1057.000	55.80
18	25025040401	2010	471.000	40.10
18	25025040600	2010	694.000	56.10
18	25025040801	2010	610.000	32.50
18	25025050101	2010	394.000	23.00
18	25025050200	2010	376.000	22.20
18	25025050300	2010	78.000	8.00
18	25025050400	2010	239.000	24.70
18	25025050500	2010	142.000	21.50
18	25025050600	2010	155.000	20.80
18	25025050700	2010	350.000	24.10
18	25025050901	2010	398.000	30.10
18	25025051000	2010	516.000	30.90
18	25025051101	2010	873.000	39.90
18	25025051200	2010	353.000	34.50
18	25025060101	2010	732.000	46.50
18	25025060200	2010	471.000	50.80
18	25025060301	2010	759.000	49.30
18	25025060400	2010	1106.000	46.50
18	25025060501	2010	832.000	45.40
18	25025060600	2010	520.000	38.00
18	25025060700	2010	5.000	0.80
18	25025060800	2010	940.000	47.00
18	25025061000	2010	258.000	20.80
18	25025061101	2010	12.000	1.20
18	25025061200	2010	860.000	49.10
18	25025070101	2010	952.000	33.10
18	25025070200	2010	119.000	7.80
18	25025070300	2010	1155.000	47.20
18	25025070402	2010	3.000	0.50
18	25025070500	2010	1179.000	40.60
18	25025070600	2010	686.000	56.70
18	25025070700	2010	480.000	38.80
18	25025070800	2010	636.000	31.10
18	25025070900	2010	506.000	29.30
18	25025071101	2010	570.000	27.30
18	25025071201	2010	487.000	37.30
18	25025080100	2010	149.000	21.90
18	25025080300	2010	133.000	19.20
18	25025080401	2010	128.000	10.40
18	25025080500	2010	59.000	4.60
18	25025080601	2010	105.000	11.90
18	25025080801	2010	2.000	0.20
18	25025080900	2010	143.000	8.50
18	25025081001	2010	174.000	7.80
18	25025081100	2010	440.000	26.20
18	25025081200	2010	156.000	13.90
18	25025081300	2010	201.000	10.00
18	25025081400	2010	419.000	32.20
18	25025081500	2010	265.000	31.60
18	25025081700	2010	337.000	22.90
18	25025081800	2010	343.000	30.10
18	25025081900	2010	257.000	20.50
18	25025082000	2010	330.000	28.50
18	25025082100	2010	198.000	9.70
18	25025090100	2010	400.000	23.80
18	25025090200	2010	123.000	15.90
18	25025090300	2010	223.000	19.90
18	25025090400	2010	369.000	32.10
18	25025090600	2010	258.000	35.80
18	25025090700	2010	603.000	32.90
18	25025090901	2010	3.000	0.20
18	25025091001	2010	527.000	42.60
18	25025091100	2010	709.000	39.60
18	25025091200	2010	399.000	34.40
18	25025091300	2010	216.000	27.30
18	25025091400	2010	301.000	34.20
18	25025091500	2010	457.000	31.10
18	25025091600	2010	285.000	27.30
18	25025091700	2010	319.000	34.80
18	25025091800	2010	388.000	37.20
18	25025091900	2010	401.000	32.20
18	25025092000	2010	535.000	34.90
18	25025092101	2010	872.000	38.70
18	25025092200	2010	536.000	47.30
18	25025092300	2010	362.000	37.90
18	25025092400	2010	386.000	20.60
18	25025100100	2010	418.000	22.10
18	25025100200	2010	336.000	37.10
18	25025100300	2010	477.000	42.60
18	25025100400	2010	715.000	42.20
18	25025100500	2010	680.000	31.30
18	25025100601	2010	927.000	45.70
18	25025100603	2010	413.000	54.80
18	25025100700	2010	1038.000	55.40
18	25025100800	2010	1152.000	45.60
18	25025100900	2010	868.000	53.90
18	25025101001	2010	949.000	44.60
18	25025101002	2010	667.000	33.90
18	25025101101	2010	414.000	39.50
18	25025101102	2010	407.000	26.90
18	25025110103	2010	859.000	39.30
18	25025110201	2010	301.000	36.90
18	25025110301	2010	602.000	67.00
18	25025110401	2010	605.000	47.10
18	25025110403	2010	1076.000	64.20
18	25025110501	2010	818.000	62.90
18	25025110502	2010	821.000	52.00
18	25025110601	2010	948.000	76.80
18	25025110607	2010	1171.000	56.10
18	25025120103	2010	447.000	67.70
18	25025120104	2010	459.000	45.90
18	25025120105	2010	811.000	90.30
18	25025120201	2010	573.000	34.50
18	25025120301	2010	772.000	43.30
18	25025120400	2010	1330.000	49.10
18	25025120500	2010	273.000	32.00
18	25025120600	2010	457.000	43.40
18	25025120700	2010	499.000	50.80
18	25025130100	2010	1941.000	72.80
18	25025130200	2010	1303.000	71.20
18	25025130300	2010	1349.000	76.80
18	25025130402	2010	1400.000	66.60
18	25025130404	2010	740.000	58.80
18	25025130406	2010	556.000	26.30
18	25025140102	2010	1049.000	67.80
18	25025140105	2010	898.000	70.50
18	25025140106	2010	70.000	8.80
18	25025140107	2010	563.000	57.60
18	25025140201	2010	336.000	39.00
18	25025140202	2010	1228.000	62.90
18	25025140300	2010	1016.000	43.20
18	25025140400	2010	1689.000	61.60
18	25025160101	2010	580.000	28.80
18	25025160200	2010	152.000	12.90
18	25025160300	2010	489.000	40.90
18	25025160400	2010	136.000	14.40
18	25025160501	2010	476.000	25.50
18	25025160502	2010	497.000	33.70
18	25025160601	2010	411.000	28.00
18	25025160602	2010	652.000	38.70
18	25025170100	2010	1573.000	55.20
18	25025170200	2010	828.000	47.90
18	25025170300	2010	1912.000	53.30
18	25025170400	2010	970.000	44.30
18	25025170501	2010	772.000	47.20
18	25025170502	2010	790.000	56.20
18	25025170601	2010	1030.000	54.90
18	25025170701	2010	379.000	39.40
18	25025170702	2010	638.000	29.80
18	25025170800	2010	835.000	40.30
18	25025180101	2010	1142.000	48.70
18	25025180200	2010	966.000	57.40
18	25025180301	2010	850.000	72.00
18	25025180400	2010	418.000	56.30
18	25025180500	2010	931.000	50.80
18	25025980101	2010	0.000	\N
18	25025980300	2010	1.000	50.00
18	25025980700	2010	3.000	75.00
18	25025981000	2010	0.000	0.00
18	25025981100	2010	15.000	17.60
18	25025981201	2010	0.000	\N
18	25025981202	2010	0.000	\N
18	25025981300	2010	154.000	65.30
18	25025981501	2010	0.000	\N
18	25025981502	2010	2.000	66.70
18	25025981600	2010	0.000	\N
18	25025981700	2010	0.000	\N
18	25025981800	2010	39.000	84.80
18	25025990101	2010	0.000	\N
19	25025000401	2010	483.000	16.80
19	25025000402	2010	467.000	32.00
19	25025000100	2010	385.000	23.80
19	25025000201	2010	428.000	27.80
19	25025000202	2010	454.000	30.70
19	25025000301	2010	460.000	39.70
19	25025000302	2010	613.000	48.00
19	25025000502	2010	349.000	18.60
19	25025000503	2010	338.000	25.20
19	25025000504	2010	491.000	18.60
19	25025000601	2010	441.000	30.40
19	25025000602	2010	179.000	9.10
19	25025000701	2010	324.000	14.10
19	25025000703	2010	44.000	3.20
19	25025000704	2010	302.000	12.90
19	25025000802	2010	408.000	13.60
19	25025000803	2010	8.000	0.90
19	25025010103	2010	47.000	9.60
19	25025010104	2010	379.000	19.80
19	25025010203	2010	233.000	6.70
19	25025010204	2010	159.000	13.40
19	25025010300	2010	60.000	15.20
19	25025010403	2010	112.000	5.50
19	25025010404	2010	186.000	10.30
19	25025010405	2010	89.000	9.20
19	25025010408	2010	93.000	9.90
19	25025010500	2010	200.000	12.10
19	25025010600	2010	340.000	18.30
19	25025010701	2010	445.000	31.90
19	25025010702	2010	625.000	44.60
19	25025010801	2010	794.000	48.10
19	25025010802	2010	755.000	40.40
19	25025020101	2010	1102.000	44.60
19	25025020200	2010	491.000	21.30
19	25025020301	2010	232.000	18.60
19	25025020302	2010	216.000	32.00
19	25025020303	2010	426.000	26.10
19	25025030100	2010	233.000	18.30
19	25025030200	2010	165.000	15.80
19	25025030300	2010	888.000	36.00
19	25025030400	2010	305.000	20.20
19	25025030500	2010	540.000	37.10
19	25025040100	2010	672.000	56.60
19	25025040200	2010	204.000	30.80
19	25025040300	2010	1042.000	55.00
19	25025040401	2010	467.000	39.80
19	25025040600	2010	685.000	55.30
19	25025040801	2010	598.000	31.90
19	25025050101	2010	268.000	15.60
19	25025050200	2010	240.000	14.20
19	25025050300	2010	59.000	6.10
19	25025050400	2010	190.000	19.60
19	25025050500	2010	123.000	18.70
19	25025050600	2010	108.000	14.50
19	25025050700	2010	231.000	15.90
19	25025050901	2010	246.000	18.60
19	25025051000	2010	433.000	25.90
19	25025051101	2010	774.000	35.30
19	25025051200	2010	314.000	30.70
19	25025060101	2010	730.000	46.30
19	25025060200	2010	468.000	50.50
19	25025060301	2010	754.000	49.00
19	25025060400	2010	1094.000	46.00
19	25025060501	2010	827.000	45.20
19	25025060600	2010	505.000	36.90
19	25025060700	2010	2.000	0.30
19	25025060800	2010	924.000	46.20
19	25025061000	2010	251.000	20.30
19	25025061101	2010	10.000	1.00
19	25025061200	2010	831.000	47.40
19	25025070101	2010	921.000	32.00
19	25025070200	2010	115.000	7.50
19	25025070300	2010	1126.000	46.00
19	25025070402	2010	3.000	0.50
19	25025070500	2010	1148.000	39.50
19	25025070600	2010	668.000	55.20
19	25025070700	2010	468.000	37.80
19	25025070800	2010	621.000	30.40
19	25025070900	2010	495.000	28.60
19	25025071101	2010	549.000	26.30
19	25025071201	2010	469.000	36.00
19	25025080100	2010	132.000	19.40
19	25025080300	2010	114.000	16.50
19	25025080401	2010	123.000	10.00
19	25025080500	2010	55.000	4.30
19	25025080601	2010	95.000	10.80
19	25025080801	2010	1.000	0.10
19	25025080900	2010	136.000	8.10
19	25025081001	2010	162.000	7.30
19	25025081100	2010	393.000	23.40
19	25025081200	2010	105.000	9.30
19	25025081300	2010	158.000	7.90
19	25025081400	2010	380.000	29.20
19	25025081500	2010	233.000	27.80
19	25025081700	2010	315.000	21.40
19	25025081800	2010	309.000	27.10
19	25025081900	2010	221.000	17.60
19	25025082000	2010	310.000	26.80
19	25025082100	2010	179.000	8.80
19	25025090100	2010	372.000	22.10
19	25025090200	2010	100.000	13.00
19	25025090300	2010	183.000	16.30
19	25025090400	2010	307.000	26.70
19	25025090600	2010	230.000	31.90
19	25025090700	2010	580.000	31.70
19	25025090901	2010	2.000	0.10
19	25025091001	2010	519.000	42.00
19	25025091100	2010	685.000	38.20
19	25025091200	2010	368.000	31.70
19	25025091300	2010	185.000	23.40
19	25025091400	2010	245.000	27.90
19	25025091500	2010	407.000	27.70
19	25025091600	2010	263.000	25.20
19	25025091700	2010	272.000	29.70
19	25025091800	2010	327.000	31.40
19	25025091900	2010	367.000	29.50
19	25025092000	2010	462.000	30.20
19	25025092101	2010	823.000	36.50
19	25025092200	2010	505.000	44.50
19	25025092300	2010	332.000	34.70
19	25025092400	2010	355.000	19.00
19	25025100100	2010	365.000	19.30
19	25025100200	2010	311.000	34.40
19	25025100300	2010	443.000	39.50
19	25025100400	2010	672.000	39.60
19	25025100500	2010	633.000	29.10
19	25025100601	2010	887.000	43.70
19	25025100603	2010	398.000	52.80
19	25025100700	2010	1022.000	54.60
19	25025100800	2010	1119.000	44.30
19	25025100900	2010	832.000	51.70
19	25025101001	2010	909.000	42.70
19	25025101002	2010	623.000	31.70
19	25025101101	2010	391.000	37.30
19	25025101102	2010	389.000	25.70
19	25025110103	2010	758.000	34.70
19	25025110201	2010	234.000	28.70
19	25025110301	2010	486.000	54.10
19	25025110401	2010	495.000	38.50
19	25025110403	2010	930.000	55.50
19	25025110501	2010	772.000	59.40
19	25025110502	2010	727.000	46.00
19	25025110601	2010	924.000	74.80
19	25025110607	2010	1134.000	54.30
19	25025120103	2010	432.000	65.50
19	25025120104	2010	429.000	42.90
19	25025120105	2010	784.000	87.30
19	25025120201	2010	524.000	31.60
19	25025120301	2010	626.000	35.10
19	25025120400	2010	1275.000	47.00
19	25025120500	2010	187.000	21.90
19	25025120600	2010	413.000	39.20
19	25025120700	2010	462.000	47.00
19	25025130100	2010	1876.000	70.30
19	25025130200	2010	1285.000	70.30
19	25025130300	2010	1325.000	75.50
19	25025130402	2010	1358.000	64.60
19	25025130404	2010	704.000	56.00
19	25025130406	2010	524.000	24.80
19	25025140102	2010	935.000	60.40
19	25025140105	2010	746.000	58.60
19	25025140106	2010	61.000	7.70
19	25025140107	2010	476.000	48.70
19	25025140201	2010	291.000	33.80
19	25025140202	2010	1094.000	56.00
19	25025140300	2010	854.000	36.30
19	25025140400	2010	1499.000	54.60
19	25025160101	2010	299.000	14.80
19	25025160200	2010	76.000	6.40
19	25025160300	2010	455.000	38.00
19	25025160400	2010	82.000	8.70
19	25025160501	2010	233.000	12.50
19	25025160502	2010	327.000	22.20
19	25025160601	2010	303.000	20.60
19	25025160602	2010	506.000	30.10
19	25025170100	2010	1341.000	47.00
19	25025170200	2010	738.000	42.70
19	25025170300	2010	1764.000	49.20
19	25025170400	2010	830.000	37.90
19	25025170501	2010	697.000	42.70
19	25025170502	2010	753.000	53.60
19	25025170601	2010	881.000	47.00
19	25025170701	2010	310.000	32.20
19	25025170702	2010	470.000	21.90
19	25025170800	2010	735.000	35.50
19	25025180101	2010	1110.000	47.30
19	25025180200	2010	941.000	55.90
19	25025180301	2010	838.000	71.00
19	25025180400	2010	412.000	55.50
19	25025180500	2010	898.000	49.00
19	25025980101	2010	0.000	\N
19	25025980300	2010	1.000	50.00
19	25025980700	2010	3.000	75.00
19	25025981000	2010	0.000	0.00
19	25025981100	2010	15.000	17.60
19	25025981201	2010	0.000	\N
19	25025981202	2010	0.000	\N
19	25025981300	2010	145.000	61.40
19	25025981501	2010	0.000	\N
19	25025981502	2010	2.000	66.70
19	25025981600	2010	0.000	\N
19	25025981700	2010	0.000	\N
19	25025981800	2010	38.000	82.60
19	25025990101	2010	0.000	\N
20	25025000401	2010	349.000	12.10
20	25025000402	2010	338.000	23.10
20	25025000100	2010	288.000	17.80
20	25025000201	2010	356.000	23.10
20	25025000202	2010	364.000	24.60
20	25025000301	2010	392.000	33.80
20	25025000302	2010	495.000	38.80
20	25025000502	2010	299.000	16.00
20	25025000503	2010	276.000	20.60
20	25025000504	2010	393.000	14.90
20	25025000601	2010	335.000	23.10
20	25025000602	2010	137.000	7.00
20	25025000701	2010	221.000	9.60
20	25025000703	2010	24.000	1.70
20	25025000704	2010	186.000	7.90
20	25025000802	2010	252.000	8.40
20	25025000803	2010	5.000	0.60
20	25025010103	2010	39.000	8.00
20	25025010104	2010	297.000	15.50
20	25025010203	2010	196.000	5.60
20	25025010204	2010	125.000	10.50
20	25025010300	2010	43.000	10.90
20	25025010403	2010	87.000	4.30
20	25025010404	2010	148.000	8.20
20	25025010405	2010	77.000	8.00
20	25025010408	2010	81.000	8.60
20	25025010500	2010	167.000	10.10
20	25025010600	2010	300.000	16.20
20	25025010701	2010	404.000	28.90
20	25025010702	2010	592.000	42.20
20	25025010801	2010	743.000	45.00
20	25025010802	2010	696.000	37.20
20	25025020101	2010	1069.000	43.20
20	25025020200	2010	453.000	19.70
20	25025020301	2010	199.000	15.90
20	25025020302	2010	207.000	30.70
20	25025020303	2010	367.000	22.50
20	25025030100	2010	233.000	18.30
20	25025030200	2010	162.000	15.50
20	25025030300	2010	839.000	34.00
20	25025030400	2010	297.000	19.60
20	25025030500	2010	520.000	35.70
20	25025040100	2010	656.000	55.20
20	25025040200	2010	197.000	29.70
20	25025040300	2010	1012.000	53.40
20	25025040401	2010	453.000	38.60
20	25025040600	2010	662.000	53.50
20	25025040801	2010	551.000	29.40
20	25025050101	2010	226.000	13.20
20	25025050200	2010	205.000	12.10
20	25025050300	2010	46.000	4.70
20	25025050400	2010	166.000	17.20
20	25025050500	2010	112.000	17.00
20	25025050600	2010	95.000	12.70
20	25025050700	2010	208.000	14.30
20	25025050901	2010	230.000	17.40
20	25025051000	2010	419.000	25.10
20	25025051101	2010	729.000	33.30
20	25025051200	2010	299.000	29.20
20	25025060101	2010	724.000	46.00
20	25025060200	2010	462.000	49.80
20	25025060301	2010	739.000	48.00
20	25025060400	2010	1068.000	44.90
20	25025060501	2010	800.000	43.70
20	25025060600	2010	475.000	34.70
20	25025060700	2010	2.000	0.30
20	25025060800	2010	864.000	43.20
20	25025061000	2010	238.000	19.20
20	25025061101	2010	10.000	1.00
20	25025061200	2010	747.000	42.60
20	25025070101	2010	742.000	25.80
20	25025070200	2010	41.000	2.70
20	25025070300	2010	1007.000	41.10
20	25025070402	2010	0.000	0.00
20	25025070500	2010	1023.000	35.20
20	25025070600	2010	610.000	50.40
20	25025070700	2010	390.000	31.50
20	25025070800	2010	549.000	26.90
20	25025070900	2010	425.000	24.60
20	25025071101	2010	458.000	21.90
20	25025071201	2010	370.000	28.40
20	25025080100	2010	28.000	4.10
20	25025080300	2010	9.000	1.30
20	25025080401	2010	78.000	6.40
20	25025080500	2010	21.000	1.70
20	25025080601	2010	17.000	1.90
20	25025080801	2010	0.000	0.00
20	25025080900	2010	110.000	6.50
20	25025081001	2010	117.000	5.20
20	25025081100	2010	224.000	13.30
20	25025081200	2010	71.000	6.30
20	25025081300	2010	44.000	2.20
20	25025081400	2010	97.000	7.50
20	25025081500	2010	31.000	3.70
20	25025081700	2010	15.000	1.00
20	25025081800	2010	22.000	1.90
20	25025081900	2010	6.000	0.50
20	25025082000	2010	3.000	0.30
20	25025082100	2010	13.000	0.60
20	25025090100	2010	9.000	0.50
20	25025090200	2010	1.000	0.10
20	25025090300	2010	2.000	0.20
20	25025090400	2010	15.000	1.30
20	25025090600	2010	13.000	1.80
20	25025090700	2010	471.000	25.70
20	25025090901	2010	0.000	0.00
20	25025091001	2010	445.000	36.00
20	25025091100	2010	522.000	29.10
20	25025091200	2010	252.000	21.70
20	25025091300	2010	38.000	4.80
20	25025091400	2010	31.000	3.50
20	25025091500	2010	123.000	8.40
20	25025091600	2010	97.000	9.30
20	25025091700	2010	44.000	4.80
20	25025091800	2010	23.000	2.20
20	25025091900	2010	10.000	0.80
20	25025092000	2010	52.000	3.40
20	25025092101	2010	481.000	21.40
20	25025092200	2010	226.000	19.90
20	25025092300	2010	5.000	0.50
20	25025092400	2010	3.000	0.20
20	25025100100	2010	4.000	0.20
20	25025100200	2010	3.000	0.30
20	25025100300	2010	21.000	1.90
20	25025100400	2010	146.000	8.60
20	25025100500	2010	222.000	10.20
20	25025100601	2010	601.000	29.60
20	25025100603	2010	335.000	44.40
20	25025100700	2010	971.000	51.80
20	25025100800	2010	856.000	33.90
20	25025100900	2010	296.000	18.40
20	25025101001	2010	37.000	1.70
20	25025101002	2010	29.000	1.50
20	25025101101	2010	5.000	0.50
20	25025101102	2010	5.000	0.30
20	25025110103	2010	563.000	25.80
20	25025110201	2010	107.000	13.10
20	25025110301	2010	337.000	37.50
20	25025110401	2010	333.000	25.90
20	25025110403	2010	724.000	43.20
20	25025110501	2010	706.000	54.30
20	25025110502	2010	606.000	38.40
20	25025110601	2010	863.000	69.90
20	25025110607	2010	1075.000	51.50
20	25025120103	2010	387.000	58.60
20	25025120104	2010	382.000	38.20
20	25025120105	2010	716.000	79.70
20	25025120201	2010	436.000	26.30
20	25025120301	2010	461.000	25.80
20	25025120400	2010	1133.000	41.80
20	25025120500	2010	147.000	17.30
20	25025120600	2010	362.000	34.30
20	25025120700	2010	396.000	40.30
20	25025130100	2010	1739.000	65.20
20	25025130200	2010	1224.000	66.90
20	25025130300	2010	1238.000	70.50
20	25025130402	2010	1237.000	58.80
20	25025130404	2010	619.000	49.20
20	25025130406	2010	439.000	20.80
20	25025140102	2010	582.000	37.60
20	25025140105	2010	504.000	39.60
20	25025140106	2010	45.000	5.70
20	25025140107	2010	297.000	30.40
20	25025140201	2010	204.000	23.70
20	25025140202	2010	744.000	38.10
20	25025140300	2010	303.000	12.90
20	25025140400	2010	272.000	9.90
20	25025160101	2010	231.000	11.50
20	25025160200	2010	58.000	4.90
20	25025160300	2010	433.000	36.20
20	25025160400	2010	65.000	6.90
20	25025160501	2010	176.000	9.40
20	25025160502	2010	268.000	18.20
20	25025160601	2010	258.000	17.60
20	25025160602	2010	424.000	25.20
20	25025170100	2010	1211.000	42.50
20	25025170200	2010	681.000	39.40
20	25025170300	2010	1635.000	45.60
20	25025170400	2010	758.000	34.60
20	25025170501	2010	626.000	38.30
20	25025170502	2010	713.000	50.70
20	25025170601	2010	825.000	44.00
20	25025170701	2010	277.000	28.80
20	25025170702	2010	355.000	16.60
20	25025170800	2010	672.000	32.40
20	25025180101	2010	1063.000	45.30
20	25025180200	2010	917.000	54.50
20	25025180301	2010	816.000	69.20
20	25025180400	2010	403.000	54.30
20	25025180500	2010	877.000	47.90
20	25025980101	2010	0.000	\N
20	25025980300	2010	1.000	50.00
20	25025980700	2010	2.000	50.00
20	25025981000	2010	0.000	0.00
20	25025981100	2010	3.000	3.50
20	25025981201	2010	0.000	\N
20	25025981202	2010	0.000	\N
20	25025981300	2010	125.000	53.00
20	25025981501	2010	0.000	\N
20	25025981502	2010	2.000	66.70
20	25025981600	2010	0.000	\N
20	25025981700	2010	0.000	\N
20	25025981800	2010	35.000	76.10
20	25025990101	2010	0.000	\N
21	25025000401	2010	4.000	0.10
21	25025000402	2010	4.000	0.30
21	25025000100	2010	12.000	0.70
21	25025000201	2010	12.000	0.80
21	25025000202	2010	3.000	0.20
21	25025000301	2010	7.000	0.60
21	25025000302	2010	14.000	1.10
21	25025000502	2010	6.000	0.30
21	25025000503	2010	8.000	0.60
21	25025000504	2010	6.000	0.20
21	25025000601	2010	2.000	0.10
21	25025000602	2010	4.000	0.20
21	25025000701	2010	7.000	0.30
21	25025000703	2010	0.000	0.00
21	25025000704	2010	11.000	0.50
21	25025000802	2010	21.000	0.70
21	25025000803	2010	1.000	0.10
21	25025010103	2010	2.000	0.40
21	25025010104	2010	7.000	0.40
21	25025010203	2010	2.000	0.10
21	25025010204	2010	2.000	0.20
21	25025010300	2010	4.000	1.00
21	25025010403	2010	5.000	0.20
21	25025010404	2010	7.000	0.40
21	25025010405	2010	3.000	0.30
21	25025010408	2010	0.000	0.00
21	25025010500	2010	12.000	0.70
21	25025010600	2010	6.000	0.30
21	25025010701	2010	1.000	0.10
21	25025010702	2010	3.000	0.20
21	25025010801	2010	2.000	0.10
21	25025010802	2010	8.000	0.40
21	25025020101	2010	3.000	0.10
21	25025020200	2010	5.000	0.20
21	25025020301	2010	2.000	0.20
21	25025020302	2010	0.000	0.00
21	25025020303	2010	5.000	0.30
21	25025030100	2010	0.000	0.00
21	25025030200	2010	0.000	0.00
21	25025030300	2010	4.000	0.20
21	25025030400	2010	1.000	0.10
21	25025030500	2010	1.000	0.10
21	25025040100	2010	1.000	0.10
21	25025040200	2010	3.000	0.50
21	25025040300	2010	2.000	0.10
21	25025040401	2010	3.000	0.30
21	25025040600	2010	5.000	0.40
21	25025040801	2010	4.000	0.20
21	25025050101	2010	9.000	0.50
21	25025050200	2010	7.000	0.40
21	25025050300	2010	3.000	0.30
21	25025050400	2010	4.000	0.40
21	25025050500	2010	3.000	0.50
21	25025050600	2010	4.000	0.50
21	25025050700	2010	6.000	0.40
21	25025050901	2010	4.000	0.30
21	25025051000	2010	2.000	0.10
21	25025051101	2010	10.000	0.50
21	25025051200	2010	3.000	0.30
21	25025060101	2010	1.000	0.10
21	25025060200	2010	0.000	0.00
21	25025060301	2010	1.000	0.10
21	25025060400	2010	3.000	0.10
21	25025060501	2010	2.000	0.10
21	25025060600	2010	6.000	0.40
21	25025060700	2010	0.000	0.00
21	25025060800	2010	6.000	0.30
21	25025061000	2010	3.000	0.20
21	25025061101	2010	0.000	0.00
21	25025061200	2010	7.000	0.40
21	25025070101	2010	10.000	0.30
21	25025070200	2010	3.000	0.20
21	25025070300	2010	13.000	0.50
21	25025070402	2010	1.000	0.20
21	25025070500	2010	14.000	0.50
21	25025070600	2010	22.000	1.80
21	25025070700	2010	33.000	2.70
21	25025070800	2010	26.000	1.30
21	25025070900	2010	32.000	1.90
21	25025071101	2010	24.000	1.10
21	25025071201	2010	18.000	1.40
21	25025080100	2010	62.000	9.10
21	25025080300	2010	91.000	13.10
21	25025080401	2010	29.000	2.40
21	25025080500	2010	31.000	2.40
21	25025080601	2010	50.000	5.70
21	25025080801	2010	1.000	0.10
21	25025080900	2010	10.000	0.60
21	25025081001	2010	18.000	0.80
21	25025081100	2010	73.000	4.30
21	25025081200	2010	16.000	1.40
21	25025081300	2010	101.000	5.00
21	25025081400	2010	248.000	19.10
21	25025081500	2010	189.000	22.50
21	25025081700	2010	280.000	19.00
21	25025081800	2010	256.000	22.50
21	25025081900	2010	195.000	15.50
21	25025082000	2010	287.000	24.80
21	25025082100	2010	156.000	7.70
21	25025090100	2010	342.000	20.30
21	25025090200	2010	82.000	10.60
21	25025090300	2010	166.000	14.80
21	25025090400	2010	232.000	20.20
21	25025090600	2010	125.000	17.40
21	25025090700	2010	26.000	1.40
21	25025090901	2010	1.000	0.10
21	25025091001	2010	20.000	1.60
21	25025091100	2010	38.000	2.10
21	25025091200	2010	50.000	4.30
21	25025091300	2010	62.000	7.80
21	25025091400	2010	180.000	20.50
21	25025091500	2010	171.000	11.60
21	25025091600	2010	87.000	8.30
21	25025091700	2010	151.000	16.50
21	25025091800	2010	233.000	22.40
21	25025091900	2010	326.000	26.20
21	25025092000	2010	324.000	21.10
21	25025092101	2010	135.000	6.00
21	25025092200	2010	205.000	18.10
21	25025092300	2010	308.000	32.20
21	25025092400	2010	328.000	17.50
21	25025100100	2010	340.000	17.90
21	25025100200	2010	293.000	32.40
21	25025100300	2010	403.000	36.00
21	25025100400	2010	463.000	27.30
21	25025100500	2010	339.000	15.60
21	25025100601	2010	171.000	8.40
21	25025100603	2010	28.000	3.70
21	25025100700	2010	20.000	1.10
21	25025100800	2010	159.000	6.30
21	25025100900	2010	465.000	28.90
21	25025101001	2010	841.000	39.50
21	25025101002	2010	565.000	28.70
21	25025101101	2010	377.000	36.00
21	25025101102	2010	372.000	24.60
21	25025110103	2010	99.000	4.50
21	25025110201	2010	106.000	13.00
21	25025110301	2010	122.000	13.60
21	25025110401	2010	140.000	10.90
21	25025110403	2010	150.000	9.00
21	25025110501	2010	33.000	2.50
21	25025110502	2010	86.000	5.40
21	25025110601	2010	12.000	1.00
21	25025110607	2010	22.000	1.10
21	25025120103	2010	20.000	3.00
21	25025120104	2010	14.000	1.40
21	25025120105	2010	28.000	3.10
21	25025120201	2010	50.000	3.00
21	25025120301	2010	126.000	7.10
21	25025120400	2010	55.000	2.00
21	25025120500	2010	21.000	2.50
21	25025120600	2010	21.000	2.00
21	25025120700	2010	31.000	3.20
21	25025130100	2010	28.000	1.00
21	25025130200	2010	8.000	0.40
21	25025130300	2010	23.000	1.30
21	25025130402	2010	28.000	1.30
21	25025130404	2010	18.000	1.40
21	25025130406	2010	27.000	1.30
21	25025140102	2010	312.000	20.20
21	25025140105	2010	202.000	15.90
21	25025140106	2010	10.000	1.30
21	25025140107	2010	156.000	16.00
21	25025140201	2010	72.000	8.40
21	25025140202	2010	312.000	16.00
21	25025140300	2010	511.000	21.70
21	25025140400	2010	1160.000	42.30
21	25025160101	2010	30.000	1.50
21	25025160200	2010	7.000	0.60
21	25025160300	2010	14.000	1.20
21	25025160400	2010	5.000	0.50
21	25025160501	2010	25.000	1.30
21	25025160502	2010	16.000	1.10
21	25025160601	2010	17.000	1.20
21	25025160602	2010	32.000	1.90
21	25025170100	2010	41.000	1.40
21	25025170200	2010	13.000	0.80
21	25025170300	2010	40.000	1.10
21	25025170400	2010	30.000	1.40
21	25025170501	2010	21.000	1.30
21	25025170502	2010	14.000	1.00
21	25025170601	2010	18.000	1.00
21	25025170701	2010	11.000	1.10
21	25025170702	2010	26.000	1.20
21	25025170800	2010	32.000	1.50
21	25025180101	2010	21.000	0.90
21	25025180200	2010	8.000	0.50
21	25025180301	2010	3.000	0.30
21	25025180400	2010	4.000	0.50
21	25025180500	2010	8.000	0.40
21	25025980101	2010	0.000	\N
21	25025980300	2010	0.000	0.00
21	25025980700	2010	0.000	0.00
21	25025981000	2010	0.000	0.00
21	25025981100	2010	9.000	10.60
21	25025981201	2010	0.000	\N
21	25025981202	2010	0.000	\N
21	25025981300	2010	2.000	0.80
21	25025981501	2010	0.000	\N
21	25025981502	2010	0.000	0.00
21	25025981600	2010	0.000	\N
21	25025981700	2010	0.000	\N
21	25025981800	2010	1.000	2.20
21	25025990101	2010	0.000	\N
22	25025000401	2010	0.000	0.00
22	25025000402	2010	0.000	0.00
22	25025000100	2010	0.000	0.00
22	25025000201	2010	0.000	0.00
22	25025000202	2010	1.000	0.10
22	25025000301	2010	0.000	0.00
22	25025000302	2010	0.000	0.00
22	25025000502	2010	0.000	0.00
22	25025000503	2010	0.000	0.00
22	25025000504	2010	0.000	0.00
22	25025000601	2010	0.000	0.00
22	25025000602	2010	1.000	0.10
22	25025000701	2010	0.000	0.00
22	25025000703	2010	0.000	0.00
22	25025000704	2010	0.000	0.00
22	25025000802	2010	0.000	0.00
22	25025000803	2010	0.000	0.00
22	25025010103	2010	0.000	0.00
22	25025010104	2010	1.000	0.10
22	25025010203	2010	0.000	0.00
22	25025010204	2010	0.000	0.00
22	25025010300	2010	0.000	0.00
22	25025010403	2010	0.000	0.00
22	25025010404	2010	0.000	0.00
22	25025010405	2010	0.000	0.00
22	25025010408	2010	0.000	0.00
22	25025010500	2010	1.000	0.10
22	25025010600	2010	0.000	0.00
22	25025010701	2010	0.000	0.00
22	25025010702	2010	0.000	0.00
22	25025010801	2010	0.000	0.00
22	25025010802	2010	0.000	0.00
22	25025020101	2010	1.000	0.00
22	25025020200	2010	0.000	0.00
22	25025020301	2010	0.000	0.00
22	25025020302	2010	1.000	0.10
22	25025020303	2010	0.000	0.00
22	25025030100	2010	0.000	0.00
22	25025030200	2010	1.000	0.10
22	25025030300	2010	0.000	0.00
22	25025030400	2010	0.000	0.00
22	25025030500	2010	0.000	0.00
22	25025040100	2010	0.000	0.00
22	25025040200	2010	0.000	0.00
22	25025040300	2010	1.000	0.10
22	25025040401	2010	0.000	0.00
22	25025040600	2010	0.000	0.00
22	25025040801	2010	1.000	0.10
22	25025050101	2010	1.000	0.10
22	25025050200	2010	1.000	0.10
22	25025050300	2010	0.000	0.00
22	25025050400	2010	1.000	0.10
22	25025050500	2010	0.000	0.00
22	25025050600	2010	0.000	0.00
22	25025050700	2010	1.000	0.10
22	25025050901	2010	1.000	0.10
22	25025051000	2010	0.000	0.00
22	25025051101	2010	4.000	0.20
22	25025051200	2010	0.000	0.00
22	25025060101	2010	0.000	0.00
22	25025060200	2010	0.000	0.00
22	25025060301	2010	0.000	0.00
22	25025060400	2010	0.000	0.00
22	25025060501	2010	0.000	0.00
22	25025060600	2010	0.000	0.00
22	25025060700	2010	0.000	0.00
22	25025060800	2010	1.000	0.00
22	25025061000	2010	0.000	0.00
22	25025061101	2010	0.000	0.00
22	25025061200	2010	1.000	0.10
22	25025070101	2010	0.000	0.00
22	25025070200	2010	0.000	0.00
22	25025070300	2010	0.000	0.00
22	25025070402	2010	0.000	0.00
22	25025070500	2010	0.000	0.00
22	25025070600	2010	2.000	0.20
22	25025070700	2010	1.000	0.10
22	25025070800	2010	1.000	0.00
22	25025070900	2010	1.000	0.10
22	25025071101	2010	3.000	0.10
22	25025071201	2010	0.000	0.00
22	25025080100	2010	1.000	0.10
22	25025080300	2010	1.000	0.10
22	25025080401	2010	1.000	0.10
22	25025080500	2010	0.000	0.00
22	25025080601	2010	0.000	0.00
22	25025080801	2010	0.000	0.00
22	25025080900	2010	0.000	0.00
22	25025081001	2010	2.000	0.10
22	25025081100	2010	0.000	0.00
22	25025081200	2010	0.000	0.00
22	25025081300	2010	0.000	0.00
22	25025081400	2010	2.000	0.20
22	25025081500	2010	2.000	0.20
22	25025081700	2010	2.000	0.10
22	25025081800	2010	1.000	0.10
22	25025081900	2010	1.000	0.10
22	25025082000	2010	2.000	0.20
22	25025082100	2010	0.000	0.00
22	25025090100	2010	4.000	0.20
22	25025090200	2010	0.000	0.00
22	25025090300	2010	1.000	0.10
22	25025090400	2010	1.000	0.10
22	25025090600	2010	1.000	0.10
22	25025090700	2010	0.000	0.00
22	25025090901	2010	0.000	0.00
22	25025091001	2010	0.000	0.00
22	25025091100	2010	0.000	0.00
22	25025091200	2010	0.000	0.00
22	25025091300	2010	0.000	0.00
22	25025091400	2010	0.000	0.00
22	25025091500	2010	0.000	0.00
22	25025091600	2010	1.000	0.10
22	25025091700	2010	0.000	0.00
22	25025091800	2010	0.000	0.00
22	25025091900	2010	1.000	0.10
22	25025092000	2010	0.000	0.00
22	25025092101	2010	1.000	0.00
22	25025092200	2010	0.000	0.00
22	25025092300	2010	1.000	0.10
22	25025092400	2010	2.000	0.10
22	25025100100	2010	0.000	0.00
22	25025100200	2010	2.000	0.20
22	25025100300	2010	1.000	0.10
22	25025100400	2010	2.000	0.10
22	25025100500	2010	1.000	0.00
22	25025100601	2010	3.000	0.10
22	25025100603	2010	0.000	0.00
22	25025100700	2010	1.000	0.10
22	25025100800	2010	0.000	0.00
22	25025100900	2010	0.000	0.00
22	25025101001	2010	3.000	0.10
22	25025101002	2010	2.000	0.10
22	25025101101	2010	0.000	0.00
22	25025101102	2010	0.000	0.00
22	25025110103	2010	1.000	0.00
22	25025110201	2010	1.000	0.10
22	25025110301	2010	4.000	0.40
22	25025110401	2010	1.000	0.10
22	25025110403	2010	3.000	0.20
22	25025110501	2010	0.000	0.00
22	25025110502	2010	0.000	0.00
22	25025110601	2010	1.000	0.10
22	25025110607	2010	1.000	0.00
22	25025120103	2010	0.000	0.00
22	25025120104	2010	0.000	0.00
22	25025120105	2010	0.000	0.00
22	25025120201	2010	2.000	0.10
22	25025120301	2010	0.000	0.00
22	25025120400	2010	2.000	0.10
22	25025120500	2010	2.000	0.20
22	25025120600	2010	0.000	0.00
22	25025120700	2010	0.000	0.00
22	25025130100	2010	0.000	0.00
22	25025130200	2010	1.000	0.10
22	25025130300	2010	1.000	0.10
22	25025130402	2010	1.000	0.00
22	25025130404	2010	0.000	0.00
22	25025130406	2010	0.000	0.00
22	25025140102	2010	2.000	0.10
22	25025140105	2010	1.000	0.10
22	25025140106	2010	0.000	0.00
22	25025140107	2010	2.000	0.20
22	25025140201	2010	1.000	0.10
22	25025140202	2010	0.000	0.00
22	25025140300	2010	3.000	0.10
22	25025140400	2010	7.000	0.30
22	25025160101	2010	0.000	0.00
22	25025160200	2010	0.000	0.00
22	25025160300	2010	0.000	0.00
22	25025160400	2010	0.000	0.00
22	25025160501	2010	0.000	0.00
22	25025160502	2010	1.000	0.10
22	25025160601	2010	0.000	0.00
22	25025160602	2010	1.000	0.10
22	25025170100	2010	0.000	0.00
22	25025170200	2010	0.000	0.00
22	25025170300	2010	3.000	0.10
22	25025170400	2010	1.000	0.00
22	25025170501	2010	0.000	0.00
22	25025170502	2010	4.000	0.30
22	25025170601	2010	1.000	0.10
22	25025170701	2010	0.000	0.00
22	25025170702	2010	0.000	0.00
22	25025170800	2010	1.000	0.00
22	25025180101	2010	0.000	0.00
22	25025180200	2010	0.000	0.00
22	25025180301	2010	1.000	0.10
22	25025180400	2010	0.000	0.00
22	25025180500	2010	0.000	0.00
22	25025980101	2010	0.000	\N
22	25025980300	2010	0.000	0.00
22	25025980700	2010	0.000	0.00
22	25025981000	2010	0.000	0.00
22	25025981100	2010	0.000	0.00
22	25025981201	2010	0.000	\N
22	25025981202	2010	0.000	\N
22	25025981300	2010	0.000	0.00
22	25025981501	2010	0.000	\N
22	25025981502	2010	0.000	0.00
22	25025981600	2010	0.000	\N
22	25025981700	2010	0.000	\N
22	25025981800	2010	0.000	0.00
22	25025990101	2010	0.000	\N
23	25025000401	2010	123.000	4.30
23	25025000402	2010	115.000	7.90
23	25025000100	2010	69.000	4.30
23	25025000201	2010	53.000	3.40
23	25025000202	2010	81.000	5.50
23	25025000301	2010	54.000	4.70
23	25025000302	2010	99.000	7.80
23	25025000502	2010	41.000	2.20
23	25025000503	2010	46.000	3.40
23	25025000504	2010	82.000	3.10
23	25025000601	2010	93.000	6.40
23	25025000602	2010	34.000	1.70
23	25025000701	2010	92.000	4.00
23	25025000703	2010	20.000	1.40
23	25025000704	2010	102.000	4.30
23	25025000802	2010	125.000	4.20
23	25025000803	2010	2.000	0.20
23	25025010103	2010	6.000	1.20
23	25025010104	2010	64.000	3.30
23	25025010203	2010	25.000	0.70
23	25025010204	2010	27.000	2.30
23	25025010300	2010	9.000	2.30
23	25025010403	2010	19.000	0.90
23	25025010404	2010	27.000	1.50
23	25025010405	2010	7.000	0.70
23	25025010408	2010	11.000	1.20
23	25025010500	2010	19.000	1.10
23	25025010600	2010	28.000	1.50
23	25025010701	2010	33.000	2.40
23	25025010702	2010	27.000	1.90
23	25025010801	2010	35.000	2.10
23	25025010802	2010	44.000	2.40
23	25025020101	2010	25.000	1.00
23	25025020200	2010	27.000	1.20
23	25025020301	2010	28.000	2.20
23	25025020302	2010	6.000	0.90
23	25025020303	2010	48.000	2.90
23	25025030100	2010	0.000	0.00
23	25025030200	2010	1.000	0.10
23	25025030300	2010	36.000	1.50
23	25025030400	2010	4.000	0.30
23	25025030500	2010	16.000	1.10
23	25025040100	2010	15.000	1.30
23	25025040200	2010	3.000	0.50
23	25025040300	2010	19.000	1.00
23	25025040401	2010	10.000	0.90
23	25025040600	2010	16.000	1.30
23	25025040801	2010	36.000	1.90
23	25025050101	2010	27.000	1.60
23	25025050200	2010	18.000	1.10
23	25025050300	2010	6.000	0.60
23	25025050400	2010	12.000	1.20
23	25025050500	2010	6.000	0.90
23	25025050600	2010	5.000	0.70
23	25025050700	2010	10.000	0.70
23	25025050901	2010	5.000	0.40
23	25025051000	2010	9.000	0.50
23	25025051101	2010	18.000	0.80
23	25025051200	2010	5.000	0.50
23	25025060101	2010	3.000	0.20
23	25025060200	2010	4.000	0.40
23	25025060301	2010	9.000	0.60
23	25025060400	2010	12.000	0.50
23	25025060501	2010	22.000	1.20
23	25025060600	2010	20.000	1.50
23	25025060700	2010	0.000	0.00
23	25025060800	2010	41.000	2.00
23	25025061000	2010	4.000	0.30
23	25025061101	2010	0.000	0.00
23	25025061200	2010	63.000	3.60
23	25025070101	2010	151.000	5.30
23	25025070200	2010	66.000	4.30
23	25025070300	2010	93.000	3.80
23	25025070402	2010	2.000	0.30
23	25025070500	2010	101.000	3.50
23	25025070600	2010	28.000	2.30
23	25025070700	2010	35.000	2.80
23	25025070800	2010	35.000	1.70
23	25025070900	2010	23.000	1.30
23	25025071101	2010	58.000	2.80
23	25025071201	2010	80.000	6.10
23	25025080100	2010	1.000	0.10
23	25025080300	2010	3.000	0.40
23	25025080401	2010	8.000	0.70
23	25025080500	2010	1.000	0.10
23	25025080601	2010	24.000	2.70
23	25025080801	2010	0.000	0.00
23	25025080900	2010	11.000	0.70
23	25025081001	2010	20.000	0.90
23	25025081100	2010	84.000	5.00
23	25025081200	2010	7.000	0.60
23	25025081300	2010	6.000	0.30
23	25025081400	2010	18.000	1.40
23	25025081500	2010	4.000	0.50
23	25025081700	2010	3.000	0.20
23	25025081800	2010	6.000	0.50
23	25025081900	2010	2.000	0.20
23	25025082000	2010	3.000	0.30
23	25025082100	2010	4.000	0.20
23	25025090100	2010	0.000	0.00
23	25025090200	2010	8.000	1.00
23	25025090300	2010	1.000	0.10
23	25025090400	2010	4.000	0.30
23	25025090600	2010	5.000	0.70
23	25025090700	2010	67.000	3.70
23	25025090901	2010	1.000	0.10
23	25025091001	2010	45.000	3.60
23	25025091100	2010	89.000	5.00
23	25025091200	2010	20.000	1.70
23	25025091300	2010	14.000	1.80
23	25025091400	2010	4.000	0.50
23	25025091500	2010	20.000	1.40
23	25025091600	2010	48.000	4.60
23	25025091700	2010	12.000	1.30
23	25025091800	2010	8.000	0.80
23	25025091900	2010	1.000	0.10
23	25025092000	2010	45.000	2.90
23	25025092101	2010	181.000	8.00
23	25025092200	2010	57.000	5.00
23	25025092300	2010	1.000	0.10
23	25025092400	2010	3.000	0.20
23	25025100100	2010	4.000	0.20
23	25025100200	2010	3.000	0.30
23	25025100300	2010	3.000	0.30
23	25025100400	2010	28.000	1.70
23	25025100500	2010	46.000	2.10
23	25025100601	2010	82.000	4.00
23	25025100603	2010	27.000	3.60
23	25025100700	2010	25.000	1.30
23	25025100800	2010	78.000	3.10
23	25025100900	2010	43.000	2.70
23	25025101001	2010	1.000	0.00
23	25025101002	2010	1.000	0.10
23	25025101101	2010	1.000	0.10
23	25025101102	2010	1.000	0.10
23	25025110103	2010	75.000	3.40
23	25025110201	2010	12.000	1.50
23	25025110301	2010	13.000	1.40
23	25025110401	2010	15.000	1.20
23	25025110403	2010	36.000	2.10
23	25025110501	2010	25.000	1.90
23	25025110502	2010	22.000	1.40
23	25025110601	2010	40.000	3.20
23	25025110607	2010	27.000	1.30
23	25025120103	2010	17.000	2.60
23	25025120104	2010	28.000	2.80
23	25025120105	2010	30.000	3.30
23	25025120201	2010	25.000	1.50
23	25025120301	2010	29.000	1.60
23	25025120400	2010	60.000	2.20
23	25025120500	2010	11.000	1.30
23	25025120600	2010	19.000	1.80
23	25025120700	2010	27.000	2.70
23	25025130100	2010	91.000	3.40
23	25025130200	2010	48.000	2.60
23	25025130300	2010	53.000	3.00
23	25025130402	2010	80.000	3.80
23	25025130404	2010	56.000	4.50
23	25025130406	2010	52.000	2.50
23	25025140102	2010	21.000	1.40
23	25025140105	2010	16.000	1.30
23	25025140106	2010	3.000	0.40
23	25025140107	2010	10.000	1.00
23	25025140201	2010	9.000	1.00
23	25025140202	2010	19.000	1.00
23	25025140300	2010	16.000	0.70
23	25025140400	2010	19.000	0.70
23	25025160101	2010	22.000	1.10
23	25025160200	2010	6.000	0.50
23	25025160300	2010	5.000	0.40
23	25025160400	2010	11.000	1.20
23	25025160501	2010	23.000	1.20
23	25025160502	2010	28.000	1.90
23	25025160601	2010	20.000	1.40
23	25025160602	2010	38.000	2.30
23	25025170100	2010	53.000	1.90
23	25025170200	2010	29.000	1.70
23	25025170300	2010	55.000	1.50
23	25025170400	2010	26.000	1.20
23	25025170501	2010	33.000	2.00
23	25025170502	2010	12.000	0.90
23	25025170601	2010	25.000	1.30
23	25025170701	2010	16.000	1.70
23	25025170702	2010	74.000	3.50
23	25025170800	2010	18.000	0.90
23	25025180101	2010	8.000	0.30
23	25025180200	2010	10.000	0.60
23	25025180301	2010	9.000	0.80
23	25025180400	2010	1.000	0.10
23	25025180500	2010	5.000	0.30
23	25025980101	2010	0.000	\N
23	25025980300	2010	0.000	0.00
23	25025980700	2010	0.000	0.00
23	25025981000	2010	0.000	0.00
23	25025981100	2010	2.000	2.40
23	25025981201	2010	0.000	\N
23	25025981202	2010	0.000	\N
23	25025981300	2010	13.000	5.50
23	25025981501	2010	0.000	\N
23	25025981502	2010	0.000	0.00
23	25025981600	2010	0.000	\N
23	25025981700	2010	0.000	\N
23	25025981800	2010	2.000	4.30
23	25025990101	2010	0.000	\N
24	25025000401	2010	0.000	0.00
24	25025000402	2010	0.000	0.00
24	25025000100	2010	0.000	0.00
24	25025000201	2010	0.000	0.00
24	25025000202	2010	0.000	0.00
24	25025000301	2010	0.000	0.00
24	25025000302	2010	0.000	0.00
24	25025000502	2010	0.000	0.00
24	25025000503	2010	0.000	0.00
24	25025000504	2010	0.000	0.00
24	25025000601	2010	0.000	0.00
24	25025000602	2010	0.000	0.00
24	25025000701	2010	0.000	0.00
24	25025000703	2010	0.000	0.00
24	25025000704	2010	0.000	0.00
24	25025000802	2010	0.000	0.00
24	25025000803	2010	0.000	0.00
24	25025010103	2010	0.000	0.00
24	25025010104	2010	0.000	0.00
24	25025010203	2010	0.000	0.00
24	25025010204	2010	0.000	0.00
24	25025010300	2010	0.000	0.00
24	25025010403	2010	0.000	0.00
24	25025010404	2010	0.000	0.00
24	25025010405	2010	0.000	0.00
24	25025010408	2010	0.000	0.00
24	25025010500	2010	0.000	0.00
24	25025010600	2010	0.000	0.00
24	25025010701	2010	0.000	0.00
24	25025010702	2010	0.000	0.00
24	25025010801	2010	0.000	0.00
24	25025010802	2010	0.000	0.00
24	25025020101	2010	0.000	0.00
24	25025020200	2010	0.000	0.00
24	25025020301	2010	0.000	0.00
24	25025020302	2010	0.000	0.00
24	25025020303	2010	0.000	0.00
24	25025030100	2010	0.000	0.00
24	25025030200	2010	0.000	0.00
24	25025030300	2010	0.000	0.00
24	25025030400	2010	0.000	0.00
24	25025030500	2010	0.000	0.00
24	25025040100	2010	0.000	0.00
24	25025040200	2010	0.000	0.00
24	25025040300	2010	0.000	0.00
24	25025040401	2010	0.000	0.00
24	25025040600	2010	0.000	0.00
24	25025040801	2010	0.000	0.00
24	25025050101	2010	0.000	0.00
24	25025050200	2010	0.000	0.00
24	25025050300	2010	0.000	0.00
24	25025050400	2010	0.000	0.00
24	25025050500	2010	0.000	0.00
24	25025050600	2010	0.000	0.00
24	25025050700	2010	0.000	0.00
24	25025050901	2010	0.000	0.00
24	25025051000	2010	0.000	0.00
24	25025051101	2010	0.000	0.00
24	25025051200	2010	0.000	0.00
24	25025060101	2010	0.000	0.00
24	25025060200	2010	0.000	0.00
24	25025060301	2010	0.000	0.00
24	25025060400	2010	0.000	0.00
24	25025060501	2010	0.000	0.00
24	25025060600	2010	0.000	0.00
24	25025060700	2010	0.000	0.00
24	25025060800	2010	0.000	0.00
24	25025061000	2010	0.000	0.00
24	25025061101	2010	0.000	0.00
24	25025061200	2010	1.000	0.10
24	25025070101	2010	0.000	0.00
24	25025070200	2010	0.000	0.00
24	25025070300	2010	0.000	0.00
24	25025070402	2010	0.000	0.00
24	25025070500	2010	0.000	0.00
24	25025070600	2010	1.000	0.10
24	25025070700	2010	0.000	0.00
24	25025070800	2010	0.000	0.00
24	25025070900	2010	0.000	0.00
24	25025071101	2010	0.000	0.00
24	25025071201	2010	0.000	0.00
24	25025080100	2010	0.000	0.00
24	25025080300	2010	0.000	0.00
24	25025080401	2010	0.000	0.00
24	25025080500	2010	0.000	0.00
24	25025080601	2010	0.000	0.00
24	25025080801	2010	0.000	0.00
24	25025080900	2010	0.000	0.00
24	25025081001	2010	0.000	0.00
24	25025081100	2010	0.000	0.00
24	25025081200	2010	0.000	0.00
24	25025081300	2010	0.000	0.00
24	25025081400	2010	0.000	0.00
24	25025081500	2010	0.000	0.00
24	25025081700	2010	1.000	0.10
24	25025081800	2010	0.000	0.00
24	25025081900	2010	0.000	0.00
24	25025082000	2010	0.000	0.00
24	25025082100	2010	0.000	0.00
24	25025090100	2010	0.000	0.00
24	25025090200	2010	0.000	0.00
24	25025090300	2010	1.000	0.10
24	25025090400	2010	0.000	0.00
24	25025090600	2010	0.000	0.00
24	25025090700	2010	0.000	0.00
24	25025090901	2010	0.000	0.00
24	25025091001	2010	0.000	0.00
24	25025091100	2010	0.000	0.00
24	25025091200	2010	0.000	0.00
24	25025091300	2010	0.000	0.00
24	25025091400	2010	0.000	0.00
24	25025091500	2010	0.000	0.00
24	25025091600	2010	0.000	0.00
24	25025091700	2010	0.000	0.00
24	25025091800	2010	0.000	0.00
24	25025091900	2010	0.000	0.00
24	25025092000	2010	0.000	0.00
24	25025092101	2010	0.000	0.00
24	25025092200	2010	0.000	0.00
24	25025092300	2010	0.000	0.00
24	25025092400	2010	0.000	0.00
24	25025100100	2010	0.000	0.00
24	25025100200	2010	0.000	0.00
24	25025100300	2010	0.000	0.00
24	25025100400	2010	0.000	0.00
24	25025100500	2010	0.000	0.00
24	25025100601	2010	0.000	0.00
24	25025100603	2010	1.000	0.10
24	25025100700	2010	0.000	0.00
24	25025100800	2010	0.000	0.00
24	25025100900	2010	0.000	0.00
24	25025101001	2010	0.000	0.00
24	25025101002	2010	0.000	0.00
24	25025101101	2010	0.000	0.00
24	25025101102	2010	1.000	0.10
24	25025110103	2010	1.000	0.00
24	25025110201	2010	0.000	0.00
24	25025110301	2010	0.000	0.00
24	25025110401	2010	0.000	0.00
24	25025110403	2010	1.000	0.10
24	25025110501	2010	0.000	0.00
24	25025110502	2010	0.000	0.00
24	25025110601	2010	0.000	0.00
24	25025110607	2010	0.000	0.00
24	25025120103	2010	0.000	0.00
24	25025120104	2010	0.000	0.00
24	25025120105	2010	0.000	0.00
24	25025120201	2010	0.000	0.00
24	25025120301	2010	0.000	0.00
24	25025120400	2010	0.000	0.00
24	25025120500	2010	0.000	0.00
24	25025120600	2010	0.000	0.00
24	25025120700	2010	0.000	0.00
24	25025130100	2010	0.000	0.00
24	25025130200	2010	0.000	0.00
24	25025130300	2010	1.000	0.10
24	25025130402	2010	1.000	0.00
24	25025130404	2010	0.000	0.00
24	25025130406	2010	0.000	0.00
24	25025140102	2010	0.000	0.00
24	25025140105	2010	1.000	0.10
24	25025140106	2010	0.000	0.00
24	25025140107	2010	0.000	0.00
24	25025140201	2010	0.000	0.00
24	25025140202	2010	0.000	0.00
24	25025140300	2010	0.000	0.00
24	25025140400	2010	0.000	0.00
24	25025160101	2010	0.000	0.00
24	25025160200	2010	0.000	0.00
24	25025160300	2010	0.000	0.00
24	25025160400	2010	0.000	0.00
24	25025160501	2010	0.000	0.00
24	25025160502	2010	0.000	0.00
24	25025160601	2010	0.000	0.00
24	25025160602	2010	0.000	0.00
24	25025170100	2010	1.000	0.00
24	25025170200	2010	0.000	0.00
24	25025170300	2010	0.000	0.00
24	25025170400	2010	0.000	0.00
24	25025170501	2010	0.000	0.00
24	25025170502	2010	0.000	0.00
24	25025170601	2010	0.000	0.00
24	25025170701	2010	0.000	0.00
24	25025170702	2010	0.000	0.00
24	25025170800	2010	0.000	0.00
24	25025180101	2010	0.000	0.00
24	25025180200	2010	0.000	0.00
24	25025180301	2010	1.000	0.10
24	25025180400	2010	0.000	0.00
24	25025180500	2010	1.000	0.10
24	25025980101	2010	0.000	\N
24	25025980300	2010	0.000	0.00
24	25025980700	2010	1.000	25.00
24	25025981000	2010	0.000	0.00
24	25025981100	2010	0.000	0.00
24	25025981201	2010	0.000	\N
24	25025981202	2010	0.000	\N
24	25025981300	2010	0.000	0.00
24	25025981501	2010	0.000	\N
24	25025981502	2010	0.000	0.00
24	25025981600	2010	0.000	\N
24	25025981700	2010	0.000	\N
24	25025981800	2010	0.000	0.00
24	25025990101	2010	0.000	\N
25	25025000401	2010	0.000	0.00
25	25025000402	2010	0.000	0.00
25	25025000100	2010	4.000	0.20
25	25025000201	2010	2.000	0.10
25	25025000202	2010	2.000	0.10
25	25025000301	2010	2.000	0.20
25	25025000302	2010	2.000	0.20
25	25025000502	2010	1.000	0.10
25	25025000503	2010	2.000	0.10
25	25025000504	2010	0.000	0.00
25	25025000601	2010	2.000	0.10
25	25025000602	2010	0.000	0.00
25	25025000701	2010	0.000	0.00
25	25025000703	2010	0.000	0.00
25	25025000704	2010	2.000	0.10
25	25025000802	2010	2.000	0.10
25	25025000803	2010	0.000	0.00
25	25025010103	2010	0.000	0.00
25	25025010104	2010	2.000	0.10
25	25025010203	2010	0.000	0.00
25	25025010204	2010	0.000	0.00
25	25025010300	2010	1.000	0.30
25	25025010403	2010	0.000	0.00
25	25025010404	2010	2.000	0.10
25	25025010405	2010	0.000	0.00
25	25025010408	2010	0.000	0.00
25	25025010500	2010	0.000	0.00
25	25025010600	2010	0.000	0.00
25	25025010701	2010	0.000	0.00
25	25025010702	2010	1.000	0.10
25	25025010801	2010	1.000	0.10
25	25025010802	2010	1.000	0.10
25	25025020101	2010	1.000	0.00
25	25025020200	2010	1.000	0.00
25	25025020301	2010	1.000	0.10
25	25025020302	2010	0.000	0.00
25	25025020303	2010	1.000	0.10
25	25025030100	2010	0.000	0.00
25	25025030200	2010	0.000	0.00
25	25025030300	2010	1.000	0.00
25	25025030400	2010	1.000	0.10
25	25025030500	2010	0.000	0.00
25	25025040100	2010	0.000	0.00
25	25025040200	2010	0.000	0.00
25	25025040300	2010	0.000	0.00
25	25025040401	2010	0.000	0.00
25	25025040600	2010	1.000	0.10
25	25025040801	2010	3.000	0.20
25	25025050101	2010	1.000	0.10
25	25025050200	2010	6.000	0.40
25	25025050300	2010	0.000	0.00
25	25025050400	2010	3.000	0.30
25	25025050500	2010	1.000	0.20
25	25025050600	2010	1.000	0.10
25	25025050700	2010	5.000	0.30
25	25025050901	2010	2.000	0.20
25	25025051000	2010	1.000	0.10
25	25025051101	2010	5.000	0.20
25	25025051200	2010	3.000	0.30
25	25025060101	2010	0.000	0.00
25	25025060200	2010	0.000	0.00
25	25025060301	2010	2.000	0.10
25	25025060400	2010	1.000	0.00
25	25025060501	2010	1.000	0.10
25	25025060600	2010	0.000	0.00
25	25025060700	2010	0.000	0.00
25	25025060800	2010	2.000	0.10
25	25025061000	2010	1.000	0.10
25	25025061101	2010	0.000	0.00
25	25025061200	2010	2.000	0.10
25	25025070101	2010	1.000	0.00
25	25025070200	2010	0.000	0.00
25	25025070300	2010	2.000	0.10
25	25025070402	2010	0.000	0.00
25	25025070500	2010	2.000	0.10
25	25025070600	2010	1.000	0.10
25	25025070700	2010	1.000	0.10
25	25025070800	2010	3.000	0.10
25	25025070900	2010	0.000	0.00
25	25025071101	2010	1.000	0.00
25	25025071201	2010	0.000	0.00
25	25025080100	2010	31.000	4.60
25	25025080300	2010	4.000	0.60
25	25025080401	2010	0.000	0.00
25	25025080500	2010	0.000	0.00
25	25025080601	2010	0.000	0.00
25	25025080801	2010	0.000	0.00
25	25025080900	2010	0.000	0.00
25	25025081001	2010	0.000	0.00
25	25025081100	2010	1.000	0.10
25	25025081200	2010	0.000	0.00
25	25025081300	2010	1.000	0.00
25	25025081400	2010	4.000	0.30
25	25025081500	2010	2.000	0.20
25	25025081700	2010	2.000	0.10
25	25025081800	2010	5.000	0.40
25	25025081900	2010	4.000	0.30
25	25025082000	2010	5.000	0.40
25	25025082100	2010	0.000	0.00
25	25025090100	2010	4.000	0.20
25	25025090200	2010	7.000	0.90
25	25025090300	2010	5.000	0.40
25	25025090400	2010	31.000	2.70
25	25025090600	2010	60.000	8.30
25	25025090700	2010	8.000	0.40
25	25025090901	2010	0.000	0.00
25	25025091001	2010	2.000	0.20
25	25025091100	2010	15.000	0.80
25	25025091200	2010	29.000	2.50
25	25025091300	2010	52.000	6.60
25	25025091400	2010	14.000	1.60
25	25025091500	2010	57.000	3.90
25	25025091600	2010	11.000	1.10
25	25025091700	2010	47.000	5.10
25	25025091800	2010	40.000	3.80
25	25025091900	2010	16.000	1.30
25	25025092000	2010	19.000	1.20
25	25025092101	2010	10.000	0.40
25	25025092200	2010	10.000	0.90
25	25025092300	2010	6.000	0.60
25	25025092400	2010	3.000	0.20
25	25025100100	2010	9.000	0.50
25	25025100200	2010	2.000	0.20
25	25025100300	2010	3.000	0.30
25	25025100400	2010	15.000	0.90
25	25025100500	2010	8.000	0.40
25	25025100601	2010	15.000	0.70
25	25025100603	2010	3.000	0.40
25	25025100700	2010	1.000	0.10
25	25025100800	2010	9.000	0.40
25	25025100900	2010	10.000	0.60
25	25025101001	2010	6.000	0.30
25	25025101002	2010	4.000	0.20
25	25025101101	2010	3.000	0.30
25	25025101102	2010	1.000	0.10
25	25025110103	2010	6.000	0.30
25	25025110201	2010	2.000	0.20
25	25025110301	2010	3.000	0.30
25	25025110401	2010	1.000	0.10
25	25025110403	2010	1.000	0.10
25	25025110501	2010	2.000	0.20
25	25025110502	2010	2.000	0.10
25	25025110601	2010	1.000	0.10
25	25025110607	2010	6.000	0.30
25	25025120103	2010	2.000	0.30
25	25025120104	2010	1.000	0.10
25	25025120105	2010	0.000	0.00
25	25025120201	2010	2.000	0.10
25	25025120301	2010	1.000	0.10
25	25025120400	2010	3.000	0.10
25	25025120500	2010	1.000	0.10
25	25025120600	2010	1.000	0.10
25	25025120700	2010	1.000	0.10
25	25025130100	2010	1.000	0.00
25	25025130200	2010	0.000	0.00
25	25025130300	2010	2.000	0.10
25	25025130402	2010	1.000	0.00
25	25025130404	2010	3.000	0.20
25	25025130406	2010	1.000	0.00
25	25025140102	2010	6.000	0.40
25	25025140105	2010	3.000	0.20
25	25025140106	2010	1.000	0.10
25	25025140107	2010	1.000	0.10
25	25025140201	2010	0.000	0.00
25	25025140202	2010	7.000	0.40
25	25025140300	2010	5.000	0.20
25	25025140400	2010	9.000	0.30
25	25025160101	2010	7.000	0.30
25	25025160200	2010	1.000	0.10
25	25025160300	2010	0.000	0.00
25	25025160400	2010	0.000	0.00
25	25025160501	2010	2.000	0.10
25	25025160502	2010	5.000	0.30
25	25025160601	2010	5.000	0.30
25	25025160602	2010	4.000	0.20
25	25025170100	2010	16.000	0.60
25	25025170200	2010	7.000	0.40
25	25025170300	2010	12.000	0.30
25	25025170400	2010	5.000	0.20
25	25025170501	2010	6.000	0.40
25	25025170502	2010	3.000	0.20
25	25025170601	2010	8.000	0.40
25	25025170701	2010	3.000	0.30
25	25025170702	2010	5.000	0.20
25	25025170800	2010	6.000	0.30
25	25025180101	2010	6.000	0.30
25	25025180200	2010	2.000	0.10
25	25025180301	2010	3.000	0.30
25	25025180400	2010	1.000	0.10
25	25025180500	2010	0.000	0.00
25	25025980101	2010	0.000	\N
25	25025980300	2010	0.000	0.00
25	25025980700	2010	0.000	0.00
25	25025981000	2010	0.000	0.00
25	25025981100	2010	0.000	0.00
25	25025981201	2010	0.000	\N
25	25025981202	2010	0.000	\N
25	25025981300	2010	0.000	0.00
25	25025981501	2010	0.000	\N
25	25025981502	2010	0.000	0.00
25	25025981600	2010	0.000	\N
25	25025981700	2010	0.000	\N
25	25025981800	2010	0.000	0.00
25	25025990101	2010	0.000	\N
26	25025000401	2010	7.000	0.20
26	25025000402	2010	10.000	0.70
26	25025000100	2010	12.000	0.70
26	25025000201	2010	5.000	0.30
26	25025000202	2010	3.000	0.20
26	25025000301	2010	5.000	0.40
26	25025000302	2010	3.000	0.20
26	25025000502	2010	2.000	0.10
26	25025000503	2010	6.000	0.40
26	25025000504	2010	10.000	0.40
26	25025000601	2010	9.000	0.60
26	25025000602	2010	3.000	0.20
26	25025000701	2010	4.000	0.20
26	25025000703	2010	0.000	0.00
26	25025000704	2010	1.000	0.00
26	25025000802	2010	8.000	0.30
26	25025000803	2010	0.000	0.00
26	25025010103	2010	0.000	0.00
26	25025010104	2010	8.000	0.40
26	25025010203	2010	10.000	0.30
26	25025010204	2010	5.000	0.40
26	25025010300	2010	3.000	0.80
26	25025010403	2010	1.000	0.00
26	25025010404	2010	2.000	0.10
26	25025010405	2010	2.000	0.20
26	25025010408	2010	1.000	0.10
26	25025010500	2010	1.000	0.10
26	25025010600	2010	6.000	0.30
26	25025010701	2010	7.000	0.50
26	25025010702	2010	2.000	0.10
26	25025010801	2010	13.000	0.80
26	25025010802	2010	6.000	0.30
26	25025020101	2010	3.000	0.10
26	25025020200	2010	5.000	0.20
26	25025020301	2010	2.000	0.20
26	25025020302	2010	2.000	0.30
26	25025020303	2010	5.000	0.30
26	25025030100	2010	0.000	0.00
26	25025030200	2010	1.000	0.10
26	25025030300	2010	8.000	0.30
26	25025030400	2010	2.000	0.10
26	25025030500	2010	3.000	0.20
26	25025040100	2010	0.000	0.00
26	25025040200	2010	1.000	0.20
26	25025040300	2010	8.000	0.40
26	25025040401	2010	1.000	0.10
26	25025040600	2010	1.000	0.10
26	25025040801	2010	3.000	0.20
26	25025050101	2010	4.000	0.20
26	25025050200	2010	3.000	0.20
26	25025050300	2010	4.000	0.40
26	25025050400	2010	4.000	0.40
26	25025050500	2010	1.000	0.20
26	25025050600	2010	3.000	0.40
26	25025050700	2010	1.000	0.10
26	25025050901	2010	4.000	0.30
26	25025051000	2010	2.000	0.10
26	25025051101	2010	8.000	0.40
26	25025051200	2010	4.000	0.40
26	25025060101	2010	2.000	0.10
26	25025060200	2010	2.000	0.20
26	25025060301	2010	3.000	0.20
26	25025060400	2010	10.000	0.40
26	25025060501	2010	2.000	0.10
26	25025060600	2010	4.000	0.30
26	25025060700	2010	0.000	0.00
26	25025060800	2010	10.000	0.50
26	25025061000	2010	5.000	0.40
26	25025061101	2010	0.000	0.00
26	25025061200	2010	10.000	0.60
26	25025070101	2010	17.000	0.60
26	25025070200	2010	5.000	0.30
26	25025070300	2010	11.000	0.40
26	25025070402	2010	0.000	0.00
26	25025070500	2010	8.000	0.30
26	25025070600	2010	4.000	0.30
26	25025070700	2010	8.000	0.60
26	25025070800	2010	7.000	0.30
26	25025070900	2010	14.000	0.80
26	25025071101	2010	5.000	0.20
26	25025071201	2010	1.000	0.10
26	25025080100	2010	9.000	1.30
26	25025080300	2010	6.000	0.90
26	25025080401	2010	7.000	0.60
26	25025080500	2010	2.000	0.20
26	25025080601	2010	4.000	0.50
26	25025080801	2010	0.000	0.00
26	25025080900	2010	5.000	0.30
26	25025081001	2010	5.000	0.20
26	25025081100	2010	11.000	0.70
26	25025081200	2010	11.000	1.00
26	25025081300	2010	6.000	0.30
26	25025081400	2010	11.000	0.80
26	25025081500	2010	5.000	0.60
26	25025081700	2010	12.000	0.80
26	25025081800	2010	19.000	1.70
26	25025081900	2010	13.000	1.00
26	25025082000	2010	10.000	0.90
26	25025082100	2010	6.000	0.30
26	25025090100	2010	13.000	0.80
26	25025090200	2010	2.000	0.30
26	25025090300	2010	7.000	0.60
26	25025090400	2010	24.000	2.10
26	25025090600	2010	26.000	3.60
26	25025090700	2010	8.000	0.40
26	25025090901	2010	0.000	0.00
26	25025091001	2010	7.000	0.60
26	25025091100	2010	21.000	1.20
26	25025091200	2010	17.000	1.50
26	25025091300	2010	19.000	2.40
26	25025091400	2010	16.000	1.80
26	25025091500	2010	36.000	2.40
26	25025091600	2010	19.000	1.80
26	25025091700	2010	18.000	2.00
26	25025091800	2010	23.000	2.20
26	25025091900	2010	13.000	1.00
26	25025092000	2010	22.000	1.40
26	25025092101	2010	15.000	0.70
26	25025092200	2010	7.000	0.60
26	25025092300	2010	11.000	1.20
26	25025092400	2010	16.000	0.90
26	25025100100	2010	8.000	0.40
26	25025100200	2010	8.000	0.90
26	25025100300	2010	12.000	1.10
26	25025100400	2010	18.000	1.10
26	25025100500	2010	17.000	0.80
26	25025100601	2010	15.000	0.70
26	25025100603	2010	4.000	0.50
26	25025100700	2010	4.000	0.20
26	25025100800	2010	17.000	0.70
26	25025100900	2010	18.000	1.10
26	25025101001	2010	21.000	1.00
26	25025101002	2010	22.000	1.10
26	25025101101	2010	5.000	0.50
26	25025101102	2010	9.000	0.60
26	25025110103	2010	13.000	0.60
26	25025110201	2010	6.000	0.70
26	25025110301	2010	7.000	0.80
26	25025110401	2010	5.000	0.40
26	25025110403	2010	15.000	0.90
26	25025110501	2010	6.000	0.50
26	25025110502	2010	11.000	0.70
26	25025110601	2010	7.000	0.60
26	25025110607	2010	3.000	0.10
26	25025120103	2010	6.000	0.90
26	25025120104	2010	4.000	0.40
26	25025120105	2010	10.000	1.10
26	25025120201	2010	9.000	0.50
26	25025120301	2010	9.000	0.50
26	25025120400	2010	22.000	0.80
26	25025120500	2010	5.000	0.60
26	25025120600	2010	10.000	0.90
26	25025120700	2010	7.000	0.70
26	25025130100	2010	17.000	0.60
26	25025130200	2010	4.000	0.20
26	25025130300	2010	7.000	0.40
26	25025130402	2010	10.000	0.50
26	25025130404	2010	8.000	0.60
26	25025130406	2010	5.000	0.20
26	25025140102	2010	12.000	0.80
26	25025140105	2010	19.000	1.50
26	25025140106	2010	2.000	0.30
26	25025140107	2010	10.000	1.00
26	25025140201	2010	5.000	0.60
26	25025140202	2010	12.000	0.60
26	25025140300	2010	16.000	0.70
26	25025140400	2010	32.000	1.20
26	25025160101	2010	9.000	0.40
26	25025160200	2010	4.000	0.30
26	25025160300	2010	3.000	0.30
26	25025160400	2010	1.000	0.10
26	25025160501	2010	7.000	0.40
26	25025160502	2010	9.000	0.60
26	25025160601	2010	3.000	0.20
26	25025160602	2010	7.000	0.40
26	25025170100	2010	19.000	0.70
26	25025170200	2010	8.000	0.50
26	25025170300	2010	19.000	0.50
26	25025170400	2010	10.000	0.50
26	25025170501	2010	11.000	0.70
26	25025170502	2010	7.000	0.50
26	25025170601	2010	4.000	0.20
26	25025170701	2010	3.000	0.30
26	25025170702	2010	10.000	0.50
26	25025170800	2010	6.000	0.30
26	25025180101	2010	12.000	0.50
26	25025180200	2010	4.000	0.20
26	25025180301	2010	5.000	0.40
26	25025180400	2010	3.000	0.40
26	25025180500	2010	7.000	0.40
26	25025980101	2010	0.000	\N
26	25025980300	2010	0.000	0.00
26	25025980700	2010	0.000	0.00
26	25025981000	2010	0.000	0.00
26	25025981100	2010	1.000	1.20
26	25025981201	2010	0.000	\N
26	25025981202	2010	0.000	\N
26	25025981300	2010	5.000	2.10
26	25025981501	2010	0.000	\N
26	25025981502	2010	0.000	0.00
26	25025981600	2010	0.000	\N
26	25025981700	2010	0.000	\N
26	25025981800	2010	0.000	0.00
26	25025990101	2010	0.000	\N
27	25025000401	2010	13.000	0.50
27	25025000402	2010	13.000	0.90
27	25025000100	2010	23.000	1.40
27	25025000201	2010	19.000	1.20
27	25025000202	2010	20.000	1.40
27	25025000301	2010	16.000	1.40
27	25025000302	2010	18.000	1.40
27	25025000502	2010	10.000	0.50
27	25025000503	2010	10.000	0.70
27	25025000504	2010	27.000	1.00
27	25025000601	2010	21.000	1.40
27	25025000602	2010	8.000	0.40
27	25025000701	2010	15.000	0.70
27	25025000703	2010	3.000	0.20
27	25025000704	2010	14.000	0.60
27	25025000802	2010	31.000	1.00
27	25025000803	2010	0.000	0.00
27	25025010103	2010	2.000	0.40
27	25025010104	2010	22.000	1.10
27	25025010203	2010	11.000	0.30
27	25025010204	2010	3.000	0.30
27	25025010300	2010	3.000	0.80
27	25025010403	2010	9.000	0.40
27	25025010404	2010	15.000	0.80
27	25025010405	2010	7.000	0.70
27	25025010408	2010	6.000	0.60
27	25025010500	2010	8.000	0.50
27	25025010600	2010	12.000	0.60
27	25025010701	2010	10.000	0.70
27	25025010702	2010	12.000	0.90
27	25025010801	2010	18.000	1.10
27	25025010802	2010	11.000	0.60
27	25025020101	2010	13.000	0.50
27	25025020200	2010	7.000	0.30
27	25025020301	2010	5.000	0.40
27	25025020302	2010	7.000	1.00
27	25025020303	2010	18.000	1.10
27	25025030100	2010	5.000	0.40
27	25025030200	2010	8.000	0.80
27	25025030300	2010	12.000	0.50
27	25025030400	2010	4.000	0.30
27	25025030500	2010	8.000	0.50
27	25025040100	2010	6.000	0.50
27	25025040200	2010	5.000	0.80
27	25025040300	2010	15.000	0.80
27	25025040401	2010	4.000	0.30
27	25025040600	2010	9.000	0.70
27	25025040801	2010	12.000	0.60
27	25025050101	2010	126.000	7.40
27	25025050200	2010	136.000	8.00
27	25025050300	2010	19.000	2.00
27	25025050400	2010	49.000	5.10
27	25025050500	2010	19.000	2.90
27	25025050600	2010	47.000	6.30
27	25025050700	2010	119.000	8.20
27	25025050901	2010	152.000	11.50
27	25025051000	2010	83.000	5.00
27	25025051101	2010	99.000	4.50
27	25025051200	2010	39.000	3.80
27	25025060101	2010	2.000	0.10
27	25025060200	2010	3.000	0.30
27	25025060301	2010	5.000	0.30
27	25025060400	2010	12.000	0.50
27	25025060501	2010	5.000	0.30
27	25025060600	2010	15.000	1.10
27	25025060700	2010	3.000	0.50
27	25025060800	2010	16.000	0.80
27	25025061000	2010	7.000	0.60
27	25025061101	2010	2.000	0.20
27	25025061200	2010	29.000	1.70
27	25025070101	2010	31.000	1.10
27	25025070200	2010	4.000	0.30
27	25025070300	2010	29.000	1.20
27	25025070402	2010	0.000	0.00
27	25025070500	2010	31.000	1.10
27	25025070600	2010	18.000	1.50
27	25025070700	2010	12.000	1.00
27	25025070800	2010	15.000	0.70
27	25025070900	2010	11.000	0.60
27	25025071101	2010	21.000	1.00
27	25025071201	2010	18.000	1.40
27	25025080100	2010	17.000	2.50
27	25025080300	2010	19.000	2.70
27	25025080401	2010	5.000	0.40
27	25025080500	2010	4.000	0.30
27	25025080601	2010	10.000	1.10
27	25025080801	2010	1.000	0.10
27	25025080900	2010	7.000	0.40
27	25025081001	2010	12.000	0.50
27	25025081100	2010	47.000	2.80
27	25025081200	2010	51.000	4.50
27	25025081300	2010	43.000	2.10
27	25025081400	2010	39.000	3.00
27	25025081500	2010	32.000	3.80
27	25025081700	2010	22.000	1.50
27	25025081800	2010	34.000	3.00
27	25025081900	2010	36.000	2.90
27	25025082000	2010	20.000	1.70
27	25025082100	2010	19.000	0.90
27	25025090100	2010	28.000	1.70
27	25025090200	2010	23.000	3.00
27	25025090300	2010	40.000	3.60
27	25025090400	2010	62.000	5.40
27	25025090600	2010	28.000	3.90
27	25025090700	2010	23.000	1.30
27	25025090901	2010	1.000	0.10
27	25025091001	2010	8.000	0.60
27	25025091100	2010	24.000	1.30
27	25025091200	2010	31.000	2.70
27	25025091300	2010	31.000	3.90
27	25025091400	2010	56.000	6.40
27	25025091500	2010	50.000	3.40
27	25025091600	2010	22.000	2.10
27	25025091700	2010	47.000	5.10
27	25025091800	2010	61.000	5.90
27	25025091900	2010	34.000	2.70
27	25025092000	2010	73.000	4.80
27	25025092101	2010	49.000	2.20
27	25025092200	2010	31.000	2.70
27	25025092300	2010	30.000	3.10
27	25025092400	2010	31.000	1.70
27	25025100100	2010	53.000	2.80
27	25025100200	2010	25.000	2.80
27	25025100300	2010	34.000	3.00
27	25025100400	2010	43.000	2.50
27	25025100500	2010	47.000	2.20
27	25025100601	2010	40.000	2.00
27	25025100603	2010	15.000	2.00
27	25025100700	2010	16.000	0.90
27	25025100800	2010	33.000	1.30
27	25025100900	2010	36.000	2.20
27	25025101001	2010	40.000	1.90
27	25025101002	2010	44.000	2.20
27	25025101101	2010	23.000	2.20
27	25025101102	2010	18.000	1.20
27	25025110103	2010	101.000	4.60
27	25025110201	2010	67.000	8.20
27	25025110301	2010	116.000	12.90
27	25025110401	2010	110.000	8.60
27	25025110403	2010	146.000	8.70
27	25025110501	2010	46.000	3.50
27	25025110502	2010	94.000	5.90
27	25025110601	2010	24.000	1.90
27	25025110607	2010	37.000	1.80
27	25025120103	2010	15.000	2.30
27	25025120104	2010	30.000	3.00
27	25025120105	2010	27.000	3.00
27	25025120201	2010	49.000	3.00
27	25025120301	2010	146.000	8.20
27	25025120400	2010	55.000	2.00
27	25025120500	2010	86.000	10.10
27	25025120600	2010	44.000	4.20
27	25025120700	2010	37.000	3.80
27	25025130100	2010	65.000	2.40
27	25025130200	2010	18.000	1.00
27	25025130300	2010	24.000	1.40
27	25025130402	2010	42.000	2.00
27	25025130404	2010	36.000	2.90
27	25025130406	2010	32.000	1.50
27	25025140102	2010	114.000	7.40
27	25025140105	2010	152.000	11.90
27	25025140106	2010	9.000	1.10
27	25025140107	2010	87.000	8.90
27	25025140201	2010	45.000	5.20
27	25025140202	2010	134.000	6.90
27	25025140300	2010	162.000	6.90
27	25025140400	2010	190.000	6.90
27	25025160101	2010	281.000	14.00
27	25025160200	2010	76.000	6.40
27	25025160300	2010	34.000	2.80
27	25025160400	2010	54.000	5.70
27	25025160501	2010	243.000	13.00
27	25025160502	2010	170.000	11.50
27	25025160601	2010	108.000	7.30
27	25025160602	2010	146.000	8.70
27	25025170100	2010	232.000	8.10
27	25025170200	2010	90.000	5.20
27	25025170300	2010	148.000	4.10
27	25025170400	2010	140.000	6.40
27	25025170501	2010	75.000	4.60
27	25025170502	2010	37.000	2.60
27	25025170601	2010	149.000	7.90
27	25025170701	2010	69.000	7.20
27	25025170702	2010	168.000	7.80
27	25025170800	2010	100.000	4.80
27	25025180101	2010	32.000	1.40
27	25025180200	2010	25.000	1.50
27	25025180301	2010	12.000	1.00
27	25025180400	2010	6.000	0.80
27	25025180500	2010	33.000	1.80
27	25025980101	2010	0.000	\N
27	25025980300	2010	0.000	0.00
27	25025980700	2010	0.000	0.00
27	25025981000	2010	0.000	0.00
27	25025981100	2010	0.000	0.00
27	25025981201	2010	0.000	\N
27	25025981202	2010	0.000	\N
27	25025981300	2010	9.000	3.80
27	25025981501	2010	0.000	\N
27	25025981502	2010	0.000	0.00
27	25025981600	2010	0.000	\N
27	25025981700	2010	0.000	\N
27	25025981800	2010	1.000	2.20
27	25025990101	2010	0.000	\N
28	25025000401	2010	8.000	0.30
28	25025000402	2010	10.000	0.70
28	25025000100	2010	12.000	0.70
28	25025000201	2010	14.000	0.90
28	25025000202	2010	15.000	1.00
28	25025000301	2010	14.000	1.20
28	25025000302	2010	15.000	1.20
28	25025000502	2010	9.000	0.50
28	25025000503	2010	5.000	0.40
28	25025000504	2010	18.000	0.70
28	25025000601	2010	14.000	1.00
28	25025000602	2010	5.000	0.30
28	25025000701	2010	9.000	0.40
28	25025000703	2010	3.000	0.20
28	25025000704	2010	10.000	0.40
28	25025000802	2010	15.000	0.50
28	25025000803	2010	0.000	0.00
28	25025010103	2010	1.000	0.20
28	25025010104	2010	19.000	1.00
28	25025010203	2010	10.000	0.30
28	25025010204	2010	2.000	0.20
28	25025010300	2010	2.000	0.50
28	25025010403	2010	5.000	0.20
28	25025010404	2010	10.000	0.60
28	25025010405	2010	4.000	0.40
28	25025010408	2010	5.000	0.50
28	25025010500	2010	6.000	0.40
28	25025010600	2010	5.000	0.30
28	25025010701	2010	8.000	0.60
28	25025010702	2010	10.000	0.70
28	25025010801	2010	17.000	1.00
28	25025010802	2010	9.000	0.50
28	25025020101	2010	12.000	0.50
28	25025020200	2010	5.000	0.20
28	25025020301	2010	5.000	0.40
28	25025020302	2010	5.000	0.70
28	25025020303	2010	15.000	0.90
28	25025030100	2010	4.000	0.30
28	25025030200	2010	8.000	0.80
28	25025030300	2010	9.000	0.40
28	25025030400	2010	3.000	0.20
28	25025030500	2010	7.000	0.50
28	25025040100	2010	4.000	0.30
28	25025040200	2010	3.000	0.50
28	25025040300	2010	10.000	0.50
28	25025040401	2010	3.000	0.30
28	25025040600	2010	9.000	0.70
28	25025040801	2010	10.000	0.50
28	25025050101	2010	61.000	3.60
28	25025050200	2010	71.000	4.20
28	25025050300	2010	10.000	1.00
28	25025050400	2010	30.000	3.10
28	25025050500	2010	14.000	2.10
28	25025050600	2010	26.000	3.50
28	25025050700	2010	56.000	3.80
28	25025050901	2010	80.000	6.00
28	25025051000	2010	49.000	2.90
28	25025051101	2010	57.000	2.60
28	25025051200	2010	23.000	2.20
28	25025060101	2010	1.000	0.10
28	25025060200	2010	2.000	0.20
28	25025060301	2010	2.000	0.10
28	25025060400	2010	10.000	0.40
28	25025060501	2010	4.000	0.20
28	25025060600	2010	12.000	0.90
28	25025060700	2010	0.000	0.00
28	25025060800	2010	11.000	0.50
28	25025061000	2010	5.000	0.40
28	25025061101	2010	1.000	0.10
28	25025061200	2010	22.000	1.30
28	25025070101	2010	23.000	0.80
28	25025070200	2010	2.000	0.10
28	25025070300	2010	27.000	1.10
28	25025070402	2010	0.000	0.00
28	25025070500	2010	22.000	0.80
28	25025070600	2010	13.000	1.10
28	25025070700	2010	12.000	1.00
28	25025070800	2010	13.000	0.60
28	25025070900	2010	9.000	0.50
28	25025071101	2010	13.000	0.60
28	25025071201	2010	8.000	0.60
28	25025080100	2010	7.000	1.00
28	25025080300	2010	3.000	0.40
28	25025080401	2010	2.000	0.20
28	25025080500	2010	2.000	0.20
28	25025080601	2010	2.000	0.20
28	25025080801	2010	0.000	0.00
28	25025080900	2010	3.000	0.20
28	25025081001	2010	7.000	0.30
28	25025081100	2010	23.000	1.40
28	25025081200	2010	18.000	1.60
28	25025081300	2010	13.000	0.60
28	25025081400	2010	14.000	1.10
28	25025081500	2010	9.000	1.10
28	25025081700	2010	1.000	0.10
28	25025081800	2010	4.000	0.40
28	25025081900	2010	5.000	0.40
28	25025082000	2010	2.000	0.20
28	25025082100	2010	3.000	0.10
28	25025090100	2010	2.000	0.10
28	25025090200	2010	3.000	0.40
28	25025090300	2010	8.000	0.70
28	25025090400	2010	20.000	1.70
28	25025090600	2010	11.000	1.50
28	25025090700	2010	17.000	0.90
28	25025090901	2010	0.000	0.00
28	25025091001	2010	4.000	0.30
28	25025091100	2010	12.000	0.70
28	25025091200	2010	5.000	0.40
28	25025091300	2010	13.000	1.60
28	25025091400	2010	19.000	2.20
28	25025091500	2010	16.000	1.10
28	25025091600	2010	3.000	0.30
28	25025091700	2010	9.000	1.00
28	25025091800	2010	18.000	1.70
28	25025091900	2010	5.000	0.40
28	25025092000	2010	13.000	0.80
28	25025092101	2010	23.000	1.00
28	25025092200	2010	9.000	0.80
28	25025092300	2010	3.000	0.30
28	25025092400	2010	6.000	0.30
28	25025100100	2010	7.000	0.40
28	25025100200	2010	7.000	0.80
28	25025100300	2010	9.000	0.80
28	25025100400	2010	9.000	0.50
28	25025100500	2010	15.000	0.70
28	25025100601	2010	9.000	0.40
28	25025100603	2010	9.000	1.20
28	25025100700	2010	9.000	0.50
28	25025100800	2010	13.000	0.50
28	25025100900	2010	9.000	0.60
28	25025101001	2010	3.000	0.10
28	25025101002	2010	5.000	0.30
28	25025101101	2010	0.000	0.00
28	25025101102	2010	4.000	0.30
28	25025110103	2010	41.000	1.90
28	25025110201	2010	22.000	2.70
28	25025110301	2010	50.000	5.60
28	25025110401	2010	49.000	3.80
28	25025110403	2010	67.000	4.00
28	25025110501	2010	23.000	1.80
28	25025110502	2010	53.000	3.40
28	25025110601	2010	21.000	1.70
28	25025110607	2010	25.000	1.20
28	25025120103	2010	12.000	1.80
28	25025120104	2010	21.000	2.10
28	25025120105	2010	15.000	1.70
28	25025120201	2010	30.000	1.80
28	25025120301	2010	58.000	3.30
28	25025120400	2010	40.000	1.50
28	25025120500	2010	40.000	4.70
28	25025120600	2010	22.000	2.10
28	25025120700	2010	18.000	1.80
28	25025130100	2010	43.000	1.60
28	25025130200	2010	18.000	1.00
28	25025130300	2010	19.000	1.10
28	25025130402	2010	26.000	1.20
28	25025130404	2010	22.000	1.70
28	25025130406	2010	16.000	0.80
28	25025140102	2010	44.000	2.80
28	25025140105	2010	70.000	5.50
28	25025140106	2010	4.000	0.50
28	25025140107	2010	48.000	4.90
28	25025140201	2010	22.000	2.60
28	25025140202	2010	55.000	2.80
28	25025140300	2010	61.000	2.60
28	25025140400	2010	66.000	2.40
28	25025160101	2010	111.000	5.50
28	25025160200	2010	24.000	2.00
28	25025160300	2010	21.000	1.80
28	25025160400	2010	22.000	2.30
28	25025160501	2010	111.000	5.90
28	25025160502	2010	74.000	5.00
28	25025160601	2010	53.000	3.60
28	25025160602	2010	59.000	3.50
28	25025170100	2010	111.000	3.90
28	25025170200	2010	46.000	2.70
28	25025170300	2010	73.000	2.00
28	25025170400	2010	70.000	3.20
28	25025170501	2010	43.000	2.60
28	25025170502	2010	25.000	1.80
28	25025170601	2010	58.000	3.10
28	25025170701	2010	44.000	4.60
28	25025170702	2010	87.000	4.10
28	25025170800	2010	51.000	2.50
28	25025180101	2010	18.000	0.80
28	25025180200	2010	17.000	1.00
28	25025180301	2010	10.000	0.80
28	25025180400	2010	5.000	0.70
28	25025180500	2010	19.000	1.00
28	25025980101	2010	0.000	\N
28	25025980300	2010	0.000	0.00
28	25025980700	2010	0.000	0.00
28	25025981000	2010	0.000	0.00
28	25025981100	2010	0.000	0.00
28	25025981201	2010	0.000	\N
28	25025981202	2010	0.000	\N
28	25025981300	2010	5.000	2.10
28	25025981501	2010	0.000	\N
28	25025981502	2010	0.000	0.00
28	25025981600	2010	0.000	\N
28	25025981700	2010	0.000	\N
28	25025981800	2010	1.000	2.20
28	25025990101	2010	0.000	\N
29	25025000401	2010	0.000	0.00
29	25025000402	2010	0.000	0.00
29	25025000100	2010	4.000	0.20
29	25025000201	2010	0.000	0.00
29	25025000202	2010	0.000	0.00
29	25025000301	2010	0.000	0.00
29	25025000302	2010	0.000	0.00
29	25025000502	2010	0.000	0.00
29	25025000503	2010	1.000	0.10
29	25025000504	2010	2.000	0.10
29	25025000601	2010	1.000	0.10
29	25025000602	2010	0.000	0.00
29	25025000701	2010	2.000	0.10
29	25025000703	2010	0.000	0.00
29	25025000704	2010	0.000	0.00
29	25025000802	2010	1.000	0.00
29	25025000803	2010	0.000	0.00
29	25025010103	2010	0.000	0.00
29	25025010104	2010	0.000	0.00
29	25025010203	2010	1.000	0.00
29	25025010204	2010	0.000	0.00
29	25025010300	2010	0.000	0.00
29	25025010403	2010	1.000	0.00
29	25025010404	2010	0.000	0.00
29	25025010405	2010	1.000	0.10
29	25025010408	2010	0.000	0.00
29	25025010500	2010	1.000	0.10
29	25025010600	2010	1.000	0.10
29	25025010701	2010	0.000	0.00
29	25025010702	2010	1.000	0.10
29	25025010801	2010	0.000	0.00
29	25025010802	2010	0.000	0.00
29	25025020101	2010	0.000	0.00
29	25025020200	2010	0.000	0.00
29	25025020301	2010	0.000	0.00
29	25025020302	2010	0.000	0.00
29	25025020303	2010	0.000	0.00
29	25025030100	2010	0.000	0.00
29	25025030200	2010	0.000	0.00
29	25025030300	2010	0.000	0.00
29	25025030400	2010	0.000	0.00
29	25025030500	2010	0.000	0.00
29	25025040100	2010	0.000	0.00
29	25025040200	2010	1.000	0.20
29	25025040300	2010	1.000	0.10
29	25025040401	2010	0.000	0.00
29	25025040600	2010	0.000	0.00
29	25025040801	2010	0.000	0.00
29	25025050101	2010	1.000	0.10
29	25025050200	2010	1.000	0.10
29	25025050300	2010	0.000	0.00
29	25025050400	2010	0.000	0.00
29	25025050500	2010	0.000	0.00
29	25025050600	2010	0.000	0.00
29	25025050700	2010	0.000	0.00
29	25025050901	2010	2.000	0.20
29	25025051000	2010	0.000	0.00
29	25025051101	2010	2.000	0.10
29	25025051200	2010	0.000	0.00
29	25025060101	2010	0.000	0.00
29	25025060200	2010	0.000	0.00
29	25025060301	2010	0.000	0.00
29	25025060400	2010	0.000	0.00
29	25025060501	2010	0.000	0.00
29	25025060600	2010	1.000	0.10
29	25025060700	2010	0.000	0.00
29	25025060800	2010	0.000	0.00
29	25025061000	2010	1.000	0.10
29	25025061101	2010	0.000	0.00
29	25025061200	2010	2.000	0.10
29	25025070101	2010	1.000	0.00
29	25025070200	2010	0.000	0.00
29	25025070300	2010	0.000	0.00
29	25025070402	2010	0.000	0.00
29	25025070500	2010	1.000	0.00
29	25025070600	2010	0.000	0.00
29	25025070700	2010	0.000	0.00
29	25025070800	2010	0.000	0.00
29	25025070900	2010	0.000	0.00
29	25025071101	2010	2.000	0.10
29	25025071201	2010	4.000	0.30
29	25025080100	2010	3.000	0.40
29	25025080300	2010	3.000	0.40
29	25025080401	2010	1.000	0.10
29	25025080500	2010	0.000	0.00
29	25025080601	2010	3.000	0.30
29	25025080801	2010	0.000	0.00
29	25025080900	2010	0.000	0.00
29	25025081001	2010	1.000	0.00
29	25025081100	2010	5.000	0.30
29	25025081200	2010	9.000	0.80
29	25025081300	2010	7.000	0.30
29	25025081400	2010	13.000	1.00
29	25025081500	2010	6.000	0.70
29	25025081700	2010	8.000	0.50
29	25025081800	2010	15.000	1.30
29	25025081900	2010	15.000	1.20
29	25025082000	2010	6.000	0.50
29	25025082100	2010	8.000	0.40
29	25025090100	2010	10.000	0.60
29	25025090200	2010	6.000	0.80
29	25025090300	2010	9.000	0.80
29	25025090400	2010	13.000	1.10
29	25025090600	2010	5.000	0.70
29	25025090700	2010	1.000	0.10
29	25025090901	2010	0.000	0.00
29	25025091001	2010	0.000	0.00
29	25025091100	2010	3.000	0.20
29	25025091200	2010	5.000	0.40
29	25025091300	2010	5.000	0.60
29	25025091400	2010	11.000	1.30
29	25025091500	2010	11.000	0.70
29	25025091600	2010	3.000	0.30
29	25025091700	2010	19.000	2.10
29	25025091800	2010	14.000	1.30
29	25025091900	2010	14.000	1.10
29	25025092000	2010	19.000	1.20
29	25025092101	2010	4.000	0.20
29	25025092200	2010	11.000	1.00
29	25025092300	2010	11.000	1.20
29	25025092400	2010	12.000	0.60
29	25025100100	2010	23.000	1.20
29	25025100200	2010	7.000	0.80
29	25025100300	2010	12.000	1.10
29	25025100400	2010	13.000	0.80
29	25025100500	2010	13.000	0.60
29	25025100601	2010	11.000	0.50
29	25025100603	2010	2.000	0.30
29	25025100700	2010	1.000	0.10
29	25025100800	2010	5.000	0.20
29	25025100900	2010	15.000	0.90
29	25025101001	2010	24.000	1.10
29	25025101002	2010	22.000	1.10
29	25025101101	2010	13.000	1.20
29	25025101102	2010	10.000	0.70
29	25025110103	2010	6.000	0.30
29	25025110201	2010	7.000	0.90
29	25025110301	2010	13.000	1.40
29	25025110401	2010	3.000	0.20
29	25025110403	2010	14.000	0.80
29	25025110501	2010	2.000	0.20
29	25025110502	2010	3.000	0.20
29	25025110601	2010	0.000	0.00
29	25025110607	2010	1.000	0.00
29	25025120103	2010	0.000	0.00
29	25025120104	2010	3.000	0.30
29	25025120105	2010	1.000	0.10
29	25025120201	2010	3.000	0.20
29	25025120301	2010	15.000	0.80
29	25025120400	2010	2.000	0.10
29	25025120500	2010	6.000	0.70
29	25025120600	2010	0.000	0.00
29	25025120700	2010	3.000	0.30
29	25025130100	2010	2.000	0.10
29	25025130200	2010	0.000	0.00
29	25025130300	2010	1.000	0.10
29	25025130402	2010	5.000	0.20
29	25025130404	2010	2.000	0.20
29	25025130406	2010	2.000	0.10
29	25025140102	2010	19.000	1.20
29	25025140105	2010	12.000	0.90
29	25025140106	2010	2.000	0.30
29	25025140107	2010	5.000	0.50
29	25025140201	2010	3.000	0.30
29	25025140202	2010	17.000	0.90
29	25025140300	2010	28.000	1.20
29	25025140400	2010	37.000	1.30
29	25025160101	2010	6.000	0.30
29	25025160200	2010	3.000	0.30
29	25025160300	2010	0.000	0.00
29	25025160400	2010	2.000	0.20
29	25025160501	2010	6.000	0.30
29	25025160502	2010	2.000	0.10
29	25025160601	2010	7.000	0.50
29	25025160602	2010	3.000	0.20
29	25025170100	2010	9.000	0.30
29	25025170200	2010	1.000	0.10
29	25025170300	2010	0.000	0.00
29	25025170400	2010	2.000	0.10
29	25025170501	2010	2.000	0.10
29	25025170502	2010	2.000	0.10
29	25025170601	2010	1.000	0.10
29	25025170701	2010	4.000	0.40
29	25025170702	2010	3.000	0.10
29	25025170800	2010	1.000	0.00
29	25025180101	2010	0.000	0.00
29	25025180200	2010	0.000	0.00
29	25025180301	2010	0.000	0.00
29	25025180400	2010	0.000	0.00
29	25025180500	2010	0.000	0.00
29	25025980101	2010	0.000	\N
29	25025980300	2010	0.000	0.00
29	25025980700	2010	0.000	0.00
29	25025981000	2010	0.000	0.00
29	25025981100	2010	0.000	0.00
29	25025981201	2010	0.000	\N
29	25025981202	2010	0.000	\N
29	25025981300	2010	0.000	0.00
29	25025981501	2010	0.000	\N
29	25025981502	2010	0.000	0.00
29	25025981600	2010	0.000	\N
29	25025981700	2010	0.000	\N
29	25025981800	2010	0.000	0.00
29	25025990101	2010	0.000	\N
30	25025000401	2010	0.000	0.00
30	25025000402	2010	0.000	0.00
30	25025000100	2010	0.000	0.00
30	25025000201	2010	0.000	0.00
30	25025000202	2010	0.000	0.00
30	25025000301	2010	0.000	0.00
30	25025000302	2010	0.000	0.00
30	25025000502	2010	0.000	0.00
30	25025000503	2010	0.000	0.00
30	25025000504	2010	0.000	0.00
30	25025000601	2010	0.000	0.00
30	25025000602	2010	0.000	0.00
30	25025000701	2010	0.000	0.00
30	25025000703	2010	0.000	0.00
30	25025000704	2010	0.000	0.00
30	25025000802	2010	0.000	0.00
30	25025000803	2010	0.000	0.00
30	25025010103	2010	0.000	0.00
30	25025010104	2010	0.000	0.00
30	25025010203	2010	0.000	0.00
30	25025010204	2010	0.000	0.00
30	25025010300	2010	0.000	0.00
30	25025010403	2010	0.000	0.00
30	25025010404	2010	0.000	0.00
30	25025010405	2010	0.000	0.00
30	25025010408	2010	0.000	0.00
30	25025010500	2010	0.000	0.00
30	25025010600	2010	0.000	0.00
30	25025010701	2010	0.000	0.00
30	25025010702	2010	0.000	0.00
30	25025010801	2010	0.000	0.00
30	25025010802	2010	0.000	0.00
30	25025020101	2010	0.000	0.00
30	25025020200	2010	0.000	0.00
30	25025020301	2010	0.000	0.00
30	25025020302	2010	0.000	0.00
30	25025020303	2010	0.000	0.00
30	25025030100	2010	0.000	0.00
30	25025030200	2010	0.000	0.00
30	25025030300	2010	0.000	0.00
30	25025030400	2010	0.000	0.00
30	25025030500	2010	0.000	0.00
30	25025040100	2010	0.000	0.00
30	25025040200	2010	0.000	0.00
30	25025040300	2010	0.000	0.00
30	25025040401	2010	0.000	0.00
30	25025040600	2010	0.000	0.00
30	25025040801	2010	0.000	0.00
30	25025050101	2010	0.000	0.00
30	25025050200	2010	1.000	0.10
30	25025050300	2010	0.000	0.00
30	25025050400	2010	0.000	0.00
30	25025050500	2010	0.000	0.00
30	25025050600	2010	0.000	0.00
30	25025050700	2010	1.000	0.10
30	25025050901	2010	1.000	0.10
30	25025051000	2010	1.000	0.10
30	25025051101	2010	0.000	0.00
30	25025051200	2010	0.000	0.00
30	25025060101	2010	0.000	0.00
30	25025060200	2010	0.000	0.00
30	25025060301	2010	0.000	0.00
30	25025060400	2010	0.000	0.00
30	25025060501	2010	0.000	0.00
30	25025060600	2010	0.000	0.00
30	25025060700	2010	0.000	0.00
30	25025060800	2010	0.000	0.00
30	25025061000	2010	0.000	0.00
30	25025061101	2010	0.000	0.00
30	25025061200	2010	0.000	0.00
30	25025070101	2010	0.000	0.00
30	25025070200	2010	0.000	0.00
30	25025070300	2010	0.000	0.00
30	25025070402	2010	0.000	0.00
30	25025070500	2010	0.000	0.00
30	25025070600	2010	0.000	0.00
30	25025070700	2010	0.000	0.00
30	25025070800	2010	0.000	0.00
30	25025070900	2010	0.000	0.00
30	25025071101	2010	0.000	0.00
30	25025071201	2010	0.000	0.00
30	25025080100	2010	0.000	0.00
30	25025080300	2010	0.000	0.00
30	25025080401	2010	0.000	0.00
30	25025080500	2010	0.000	0.00
30	25025080601	2010	0.000	0.00
30	25025080801	2010	0.000	0.00
30	25025080900	2010	0.000	0.00
30	25025081001	2010	0.000	0.00
30	25025081100	2010	0.000	0.00
30	25025081200	2010	0.000	0.00
30	25025081300	2010	0.000	0.00
30	25025081400	2010	0.000	0.00
30	25025081500	2010	0.000	0.00
30	25025081700	2010	0.000	0.00
30	25025081800	2010	0.000	0.00
30	25025081900	2010	0.000	0.00
30	25025082000	2010	0.000	0.00
30	25025082100	2010	0.000	0.00
30	25025090100	2010	0.000	0.00
30	25025090200	2010	0.000	0.00
30	25025090300	2010	1.000	0.10
30	25025090400	2010	1.000	0.10
30	25025090600	2010	0.000	0.00
30	25025090700	2010	0.000	0.00
30	25025090901	2010	0.000	0.00
30	25025091001	2010	0.000	0.00
30	25025091100	2010	0.000	0.00
30	25025091200	2010	0.000	0.00
30	25025091300	2010	0.000	0.00
30	25025091400	2010	1.000	0.10
30	25025091500	2010	1.000	0.10
30	25025091600	2010	0.000	0.00
30	25025091700	2010	0.000	0.00
30	25025091800	2010	0.000	0.00
30	25025091900	2010	1.000	0.10
30	25025092000	2010	0.000	0.00
30	25025092101	2010	1.000	0.00
30	25025092200	2010	0.000	0.00
30	25025092300	2010	0.000	0.00
30	25025092400	2010	1.000	0.10
30	25025100100	2010	0.000	0.00
30	25025100200	2010	1.000	0.10
30	25025100300	2010	0.000	0.00
30	25025100400	2010	0.000	0.00
30	25025100500	2010	0.000	0.00
30	25025100601	2010	0.000	0.00
30	25025100603	2010	0.000	0.00
30	25025100700	2010	1.000	0.10
30	25025100800	2010	0.000	0.00
30	25025100900	2010	0.000	0.00
30	25025101001	2010	1.000	0.00
30	25025101002	2010	1.000	0.10
30	25025101101	2010	0.000	0.00
30	25025101102	2010	0.000	0.00
30	25025110103	2010	2.000	0.10
30	25025110201	2010	3.000	0.40
30	25025110301	2010	0.000	0.00
30	25025110401	2010	0.000	0.00
30	25025110403	2010	0.000	0.00
30	25025110501	2010	0.000	0.00
30	25025110502	2010	2.000	0.10
30	25025110601	2010	0.000	0.00
30	25025110607	2010	0.000	0.00
30	25025120103	2010	0.000	0.00
30	25025120104	2010	0.000	0.00
30	25025120105	2010	1.000	0.10
30	25025120201	2010	1.000	0.10
30	25025120301	2010	3.000	0.20
30	25025120400	2010	0.000	0.00
30	25025120500	2010	2.000	0.20
30	25025120600	2010	2.000	0.20
30	25025120700	2010	0.000	0.00
30	25025130100	2010	1.000	0.00
30	25025130200	2010	0.000	0.00
30	25025130300	2010	0.000	0.00
30	25025130402	2010	0.000	0.00
30	25025130404	2010	0.000	0.00
30	25025130406	2010	1.000	0.00
30	25025140102	2010	1.000	0.10
30	25025140105	2010	0.000	0.00
30	25025140106	2010	0.000	0.00
30	25025140107	2010	1.000	0.10
30	25025140201	2010	1.000	0.10
30	25025140202	2010	2.000	0.10
30	25025140300	2010	2.000	0.10
30	25025140400	2010	3.000	0.10
30	25025160101	2010	0.000	0.00
30	25025160200	2010	1.000	0.10
30	25025160300	2010	1.000	0.10
30	25025160400	2010	0.000	0.00
30	25025160501	2010	4.000	0.20
30	25025160502	2010	0.000	0.00
30	25025160601	2010	1.000	0.10
30	25025160602	2010	1.000	0.10
30	25025170100	2010	3.000	0.10
30	25025170200	2010	1.000	0.10
30	25025170300	2010	0.000	0.00
30	25025170400	2010	1.000	0.00
30	25025170501	2010	1.000	0.10
30	25025170502	2010	0.000	0.00
30	25025170601	2010	1.000	0.10
30	25025170701	2010	0.000	0.00
30	25025170702	2010	0.000	0.00
30	25025170800	2010	4.000	0.20
30	25025180101	2010	0.000	0.00
30	25025180200	2010	0.000	0.00
30	25025180301	2010	1.000	0.10
30	25025180400	2010	0.000	0.00
30	25025180500	2010	3.000	0.20
30	25025980101	2010	0.000	\N
30	25025980300	2010	0.000	0.00
30	25025980700	2010	0.000	0.00
30	25025981000	2010	0.000	0.00
30	25025981100	2010	0.000	0.00
30	25025981201	2010	0.000	\N
30	25025981202	2010	0.000	\N
30	25025981300	2010	0.000	0.00
30	25025981501	2010	0.000	\N
30	25025981502	2010	0.000	0.00
30	25025981600	2010	0.000	\N
30	25025981700	2010	0.000	\N
30	25025981800	2010	0.000	0.00
30	25025990101	2010	0.000	\N
31	25025000401	2010	0.000	0.00
31	25025000402	2010	0.000	0.00
31	25025000100	2010	0.000	0.00
31	25025000201	2010	1.000	0.10
31	25025000202	2010	0.000	0.00
31	25025000301	2010	0.000	0.00
31	25025000302	2010	1.000	0.10
31	25025000502	2010	0.000	0.00
31	25025000503	2010	0.000	0.00
31	25025000504	2010	1.000	0.00
31	25025000601	2010	0.000	0.00
31	25025000602	2010	0.000	0.00
31	25025000701	2010	0.000	0.00
31	25025000703	2010	0.000	0.00
31	25025000704	2010	0.000	0.00
31	25025000802	2010	0.000	0.00
31	25025000803	2010	0.000	0.00
31	25025010103	2010	1.000	0.20
31	25025010104	2010	1.000	0.10
31	25025010203	2010	0.000	0.00
31	25025010204	2010	0.000	0.00
31	25025010300	2010	0.000	0.00
31	25025010403	2010	1.000	0.00
31	25025010404	2010	0.000	0.00
31	25025010405	2010	0.000	0.00
31	25025010408	2010	0.000	0.00
31	25025010500	2010	0.000	0.00
31	25025010600	2010	0.000	0.00
31	25025010701	2010	0.000	0.00
31	25025010702	2010	0.000	0.00
31	25025010801	2010	0.000	0.00
31	25025010802	2010	0.000	0.00
31	25025020101	2010	0.000	0.00
31	25025020200	2010	0.000	0.00
31	25025020301	2010	0.000	0.00
31	25025020302	2010	0.000	0.00
31	25025020303	2010	0.000	0.00
31	25025030100	2010	0.000	0.00
31	25025030200	2010	0.000	0.00
31	25025030300	2010	0.000	0.00
31	25025030400	2010	0.000	0.00
31	25025030500	2010	0.000	0.00
31	25025040100	2010	0.000	0.00
31	25025040200	2010	0.000	0.00
31	25025040300	2010	1.000	0.10
31	25025040401	2010	0.000	0.00
31	25025040600	2010	0.000	0.00
31	25025040801	2010	0.000	0.00
31	25025050101	2010	0.000	0.00
31	25025050200	2010	0.000	0.00
31	25025050300	2010	0.000	0.00
31	25025050400	2010	0.000	0.00
31	25025050500	2010	0.000	0.00
31	25025050600	2010	0.000	0.00
31	25025050700	2010	0.000	0.00
31	25025050901	2010	0.000	0.00
31	25025051000	2010	0.000	0.00
31	25025051101	2010	0.000	0.00
31	25025051200	2010	0.000	0.00
31	25025060101	2010	0.000	0.00
31	25025060200	2010	1.000	0.10
31	25025060301	2010	0.000	0.00
31	25025060400	2010	0.000	0.00
31	25025060501	2010	0.000	0.00
31	25025060600	2010	0.000	0.00
31	25025060700	2010	0.000	0.00
31	25025060800	2010	0.000	0.00
31	25025061000	2010	0.000	0.00
31	25025061101	2010	0.000	0.00
31	25025061200	2010	0.000	0.00
31	25025070101	2010	0.000	0.00
31	25025070200	2010	2.000	0.10
31	25025070300	2010	0.000	0.00
31	25025070402	2010	0.000	0.00
31	25025070500	2010	0.000	0.00
31	25025070600	2010	0.000	0.00
31	25025070700	2010	0.000	0.00
31	25025070800	2010	0.000	0.00
31	25025070900	2010	0.000	0.00
31	25025071101	2010	0.000	0.00
31	25025071201	2010	1.000	0.10
31	25025080100	2010	0.000	0.00
31	25025080300	2010	0.000	0.00
31	25025080401	2010	0.000	0.00
31	25025080500	2010	0.000	0.00
31	25025080601	2010	0.000	0.00
31	25025080801	2010	0.000	0.00
31	25025080900	2010	0.000	0.00
31	25025081001	2010	0.000	0.00
31	25025081100	2010	0.000	0.00
31	25025081200	2010	0.000	0.00
31	25025081300	2010	0.000	0.00
31	25025081400	2010	0.000	0.00
31	25025081500	2010	0.000	0.00
31	25025081700	2010	0.000	0.00
31	25025081800	2010	0.000	0.00
31	25025081900	2010	0.000	0.00
31	25025082000	2010	0.000	0.00
31	25025082100	2010	0.000	0.00
31	25025090100	2010	0.000	0.00
31	25025090200	2010	0.000	0.00
31	25025090300	2010	0.000	0.00
31	25025090400	2010	1.000	0.10
31	25025090600	2010	0.000	0.00
31	25025090700	2010	0.000	0.00
31	25025090901	2010	0.000	0.00
31	25025091001	2010	0.000	0.00
31	25025091100	2010	0.000	0.00
31	25025091200	2010	0.000	0.00
31	25025091300	2010	0.000	0.00
31	25025091400	2010	0.000	0.00
31	25025091500	2010	0.000	0.00
31	25025091600	2010	1.000	0.10
31	25025091700	2010	0.000	0.00
31	25025091800	2010	0.000	0.00
31	25025091900	2010	0.000	0.00
31	25025092000	2010	0.000	0.00
31	25025092101	2010	2.000	0.10
31	25025092200	2010	0.000	0.00
31	25025092300	2010	0.000	0.00
31	25025092400	2010	0.000	0.00
31	25025100100	2010	0.000	0.00
31	25025100200	2010	0.000	0.00
31	25025100300	2010	0.000	0.00
31	25025100400	2010	1.000	0.10
31	25025100500	2010	0.000	0.00
31	25025100601	2010	1.000	0.00
31	25025100603	2010	0.000	0.00
31	25025100700	2010	0.000	0.00
31	25025100800	2010	1.000	0.00
31	25025100900	2010	0.000	0.00
31	25025101001	2010	0.000	0.00
31	25025101002	2010	1.000	0.10
31	25025101101	2010	0.000	0.00
31	25025101102	2010	0.000	0.00
31	25025110103	2010	0.000	0.00
31	25025110201	2010	1.000	0.10
31	25025110301	2010	0.000	0.00
31	25025110401	2010	1.000	0.10
31	25025110403	2010	1.000	0.10
31	25025110501	2010	0.000	0.00
31	25025110502	2010	0.000	0.00
31	25025110601	2010	0.000	0.00
31	25025110607	2010	1.000	0.00
31	25025120103	2010	0.000	0.00
31	25025120104	2010	0.000	0.00
31	25025120105	2010	1.000	0.10
31	25025120201	2010	0.000	0.00
31	25025120301	2010	1.000	0.10
31	25025120400	2010	1.000	0.00
31	25025120500	2010	0.000	0.00
31	25025120600	2010	1.000	0.10
31	25025120700	2010	0.000	0.00
31	25025130100	2010	0.000	0.00
31	25025130200	2010	0.000	0.00
31	25025130300	2010	0.000	0.00
31	25025130402	2010	0.000	0.00
31	25025130404	2010	1.000	0.10
31	25025130406	2010	0.000	0.00
31	25025140102	2010	1.000	0.10
31	25025140105	2010	1.000	0.10
31	25025140106	2010	0.000	0.00
31	25025140107	2010	0.000	0.00
31	25025140201	2010	0.000	0.00
31	25025140202	2010	1.000	0.10
31	25025140300	2010	0.000	0.00
31	25025140400	2010	0.000	0.00
31	25025160101	2010	1.000	0.00
31	25025160200	2010	0.000	0.00
31	25025160300	2010	0.000	0.00
31	25025160400	2010	0.000	0.00
31	25025160501	2010	0.000	0.00
31	25025160502	2010	0.000	0.00
31	25025160601	2010	0.000	0.00
31	25025160602	2010	1.000	0.10
31	25025170100	2010	0.000	0.00
31	25025170200	2010	0.000	0.00
31	25025170300	2010	1.000	0.00
31	25025170400	2010	0.000	0.00
31	25025170501	2010	0.000	0.00
31	25025170502	2010	0.000	0.00
31	25025170601	2010	0.000	0.00
31	25025170701	2010	0.000	0.00
31	25025170702	2010	0.000	0.00
31	25025170800	2010	0.000	0.00
31	25025180101	2010	1.000	0.00
31	25025180200	2010	0.000	0.00
31	25025180301	2010	0.000	0.00
31	25025180400	2010	0.000	0.00
31	25025180500	2010	0.000	0.00
31	25025980101	2010	0.000	\N
31	25025980300	2010	0.000	0.00
31	25025980700	2010	0.000	0.00
31	25025981000	2010	0.000	0.00
31	25025981100	2010	0.000	0.00
31	25025981201	2010	0.000	\N
31	25025981202	2010	0.000	\N
31	25025981300	2010	1.000	0.40
31	25025981501	2010	0.000	\N
31	25025981502	2010	0.000	0.00
31	25025981600	2010	0.000	\N
31	25025981700	2010	0.000	\N
31	25025981800	2010	0.000	0.00
31	25025990101	2010	0.000	\N
32	25025000401	2010	0.000	0.00
32	25025000402	2010	0.000	0.00
32	25025000100	2010	0.000	0.00
32	25025000201	2010	0.000	0.00
32	25025000202	2010	0.000	0.00
32	25025000301	2010	0.000	0.00
32	25025000302	2010	0.000	0.00
32	25025000502	2010	0.000	0.00
32	25025000503	2010	0.000	0.00
32	25025000504	2010	0.000	0.00
32	25025000601	2010	0.000	0.00
32	25025000602	2010	0.000	0.00
32	25025000701	2010	0.000	0.00
32	25025000703	2010	0.000	0.00
32	25025000704	2010	0.000	0.00
32	25025000802	2010	0.000	0.00
32	25025000803	2010	0.000	0.00
32	25025010103	2010	0.000	0.00
32	25025010104	2010	0.000	0.00
32	25025010203	2010	0.000	0.00
32	25025010204	2010	0.000	0.00
32	25025010300	2010	0.000	0.00
32	25025010403	2010	0.000	0.00
32	25025010404	2010	0.000	0.00
32	25025010405	2010	0.000	0.00
32	25025010408	2010	0.000	0.00
32	25025010500	2010	0.000	0.00
32	25025010600	2010	0.000	0.00
32	25025010701	2010	0.000	0.00
32	25025010702	2010	0.000	0.00
32	25025010801	2010	0.000	0.00
32	25025010802	2010	0.000	0.00
32	25025020101	2010	0.000	0.00
32	25025020200	2010	0.000	0.00
32	25025020301	2010	0.000	0.00
32	25025020302	2010	0.000	0.00
32	25025020303	2010	0.000	0.00
32	25025030100	2010	0.000	0.00
32	25025030200	2010	0.000	0.00
32	25025030300	2010	0.000	0.00
32	25025030400	2010	0.000	0.00
32	25025030500	2010	0.000	0.00
32	25025040100	2010	0.000	0.00
32	25025040200	2010	0.000	0.00
32	25025040300	2010	0.000	0.00
32	25025040401	2010	0.000	0.00
32	25025040600	2010	0.000	0.00
32	25025040801	2010	0.000	0.00
32	25025050101	2010	0.000	0.00
32	25025050200	2010	0.000	0.00
32	25025050300	2010	0.000	0.00
32	25025050400	2010	0.000	0.00
32	25025050500	2010	0.000	0.00
32	25025050600	2010	0.000	0.00
32	25025050700	2010	0.000	0.00
32	25025050901	2010	0.000	0.00
32	25025051000	2010	0.000	0.00
32	25025051101	2010	0.000	0.00
32	25025051200	2010	0.000	0.00
32	25025060101	2010	0.000	0.00
32	25025060200	2010	0.000	0.00
32	25025060301	2010	0.000	0.00
32	25025060400	2010	0.000	0.00
32	25025060501	2010	0.000	0.00
32	25025060600	2010	0.000	0.00
32	25025060700	2010	0.000	0.00
32	25025060800	2010	0.000	0.00
32	25025061000	2010	0.000	0.00
32	25025061101	2010	0.000	0.00
32	25025061200	2010	0.000	0.00
32	25025070101	2010	0.000	0.00
32	25025070200	2010	0.000	0.00
32	25025070300	2010	0.000	0.00
32	25025070402	2010	0.000	0.00
32	25025070500	2010	0.000	0.00
32	25025070600	2010	0.000	0.00
32	25025070700	2010	0.000	0.00
32	25025070800	2010	0.000	0.00
32	25025070900	2010	0.000	0.00
32	25025071101	2010	0.000	0.00
32	25025071201	2010	0.000	0.00
32	25025080100	2010	0.000	0.00
32	25025080300	2010	0.000	0.00
32	25025080401	2010	0.000	0.00
32	25025080500	2010	0.000	0.00
32	25025080601	2010	0.000	0.00
32	25025080801	2010	0.000	0.00
32	25025080900	2010	0.000	0.00
32	25025081001	2010	0.000	0.00
32	25025081100	2010	0.000	0.00
32	25025081200	2010	0.000	0.00
32	25025081300	2010	0.000	0.00
32	25025081400	2010	0.000	0.00
32	25025081500	2010	0.000	0.00
32	25025081700	2010	0.000	0.00
32	25025081800	2010	0.000	0.00
32	25025081900	2010	0.000	0.00
32	25025082000	2010	0.000	0.00
32	25025082100	2010	0.000	0.00
32	25025090100	2010	0.000	0.00
32	25025090200	2010	0.000	0.00
32	25025090300	2010	0.000	0.00
32	25025090400	2010	0.000	0.00
32	25025090600	2010	0.000	0.00
32	25025090700	2010	0.000	0.00
32	25025090901	2010	0.000	0.00
32	25025091001	2010	0.000	0.00
32	25025091100	2010	0.000	0.00
32	25025091200	2010	1.000	0.10
32	25025091300	2010	1.000	0.10
32	25025091400	2010	0.000	0.00
32	25025091500	2010	0.000	0.00
32	25025091600	2010	0.000	0.00
32	25025091700	2010	0.000	0.00
32	25025091800	2010	0.000	0.00
32	25025091900	2010	0.000	0.00
32	25025092000	2010	0.000	0.00
32	25025092101	2010	0.000	0.00
32	25025092200	2010	0.000	0.00
32	25025092300	2010	0.000	0.00
32	25025092400	2010	0.000	0.00
32	25025100100	2010	0.000	0.00
32	25025100200	2010	0.000	0.00
32	25025100300	2010	0.000	0.00
32	25025100400	2010	0.000	0.00
32	25025100500	2010	0.000	0.00
32	25025100601	2010	0.000	0.00
32	25025100603	2010	0.000	0.00
32	25025100700	2010	0.000	0.00
32	25025100800	2010	0.000	0.00
32	25025100900	2010	1.000	0.10
32	25025101001	2010	0.000	0.00
32	25025101002	2010	0.000	0.00
32	25025101101	2010	0.000	0.00
32	25025101102	2010	0.000	0.00
32	25025110103	2010	0.000	0.00
32	25025110201	2010	0.000	0.00
32	25025110301	2010	0.000	0.00
32	25025110401	2010	0.000	0.00
32	25025110403	2010	0.000	0.00
32	25025110501	2010	0.000	0.00
32	25025110502	2010	0.000	0.00
32	25025110601	2010	0.000	0.00
32	25025110607	2010	0.000	0.00
32	25025120103	2010	0.000	0.00
32	25025120104	2010	0.000	0.00
32	25025120105	2010	0.000	0.00
32	25025120201	2010	0.000	0.00
32	25025120301	2010	0.000	0.00
32	25025120400	2010	0.000	0.00
32	25025120500	2010	0.000	0.00
32	25025120600	2010	0.000	0.00
32	25025120700	2010	0.000	0.00
32	25025130100	2010	0.000	0.00
32	25025130200	2010	0.000	0.00
32	25025130300	2010	0.000	0.00
32	25025130402	2010	0.000	0.00
32	25025130404	2010	0.000	0.00
32	25025130406	2010	0.000	0.00
32	25025140102	2010	0.000	0.00
32	25025140105	2010	0.000	0.00
32	25025140106	2010	0.000	0.00
32	25025140107	2010	0.000	0.00
32	25025140201	2010	0.000	0.00
32	25025140202	2010	2.000	0.10
32	25025140300	2010	0.000	0.00
32	25025140400	2010	0.000	0.00
32	25025160101	2010	0.000	0.00
32	25025160200	2010	0.000	0.00
32	25025160300	2010	0.000	0.00
32	25025160400	2010	0.000	0.00
32	25025160501	2010	0.000	0.00
32	25025160502	2010	0.000	0.00
32	25025160601	2010	0.000	0.00
32	25025160602	2010	0.000	0.00
32	25025170100	2010	0.000	0.00
32	25025170200	2010	0.000	0.00
32	25025170300	2010	0.000	0.00
32	25025170400	2010	0.000	0.00
32	25025170501	2010	0.000	0.00
32	25025170502	2010	0.000	0.00
32	25025170601	2010	0.000	0.00
32	25025170701	2010	0.000	0.00
32	25025170702	2010	0.000	0.00
32	25025170800	2010	0.000	0.00
32	25025180101	2010	0.000	0.00
32	25025180200	2010	0.000	0.00
32	25025180301	2010	0.000	0.00
32	25025180400	2010	0.000	0.00
32	25025180500	2010	0.000	0.00
32	25025980101	2010	0.000	\N
32	25025980300	2010	0.000	0.00
32	25025980700	2010	0.000	0.00
32	25025981000	2010	0.000	0.00
32	25025981100	2010	0.000	0.00
32	25025981201	2010	0.000	\N
32	25025981202	2010	0.000	\N
32	25025981300	2010	0.000	0.00
32	25025981501	2010	0.000	\N
32	25025981502	2010	0.000	0.00
32	25025981600	2010	0.000	\N
32	25025981700	2010	0.000	\N
32	25025981800	2010	0.000	0.00
32	25025990101	2010	0.000	\N
33	25025000401	2010	5.000	0.20
33	25025000402	2010	1.000	0.10
33	25025000100	2010	5.000	0.30
33	25025000201	2010	1.000	0.10
33	25025000202	2010	5.000	0.30
33	25025000301	2010	2.000	0.20
33	25025000302	2010	2.000	0.20
33	25025000502	2010	0.000	0.00
33	25025000503	2010	1.000	0.10
33	25025000504	2010	5.000	0.20
33	25025000601	2010	6.000	0.40
33	25025000602	2010	3.000	0.20
33	25025000701	2010	4.000	0.20
33	25025000703	2010	0.000	0.00
33	25025000704	2010	1.000	0.00
33	25025000802	2010	11.000	0.40
33	25025000803	2010	0.000	0.00
33	25025010103	2010	0.000	0.00
33	25025010104	2010	2.000	0.10
33	25025010203	2010	0.000	0.00
33	25025010204	2010	0.000	0.00
33	25025010300	2010	1.000	0.30
33	25025010403	2010	1.000	0.00
33	25025010404	2010	3.000	0.20
33	25025010405	2010	2.000	0.20
33	25025010408	2010	1.000	0.10
33	25025010500	2010	1.000	0.10
33	25025010600	2010	6.000	0.30
33	25025010701	2010	1.000	0.10
33	25025010702	2010	0.000	0.00
33	25025010801	2010	1.000	0.10
33	25025010802	2010	2.000	0.10
33	25025020101	2010	0.000	0.00
33	25025020200	2010	2.000	0.10
33	25025020301	2010	0.000	0.00
33	25025020302	2010	2.000	0.30
33	25025020303	2010	2.000	0.10
33	25025030100	2010	1.000	0.10
33	25025030200	2010	0.000	0.00
33	25025030300	2010	3.000	0.10
33	25025030400	2010	1.000	0.10
33	25025030500	2010	1.000	0.10
33	25025040100	2010	1.000	0.10
33	25025040200	2010	1.000	0.20
33	25025040300	2010	2.000	0.10
33	25025040401	2010	0.000	0.00
33	25025040600	2010	0.000	0.00
33	25025040801	2010	1.000	0.10
33	25025050101	2010	56.000	3.30
33	25025050200	2010	54.000	3.20
33	25025050300	2010	9.000	0.90
33	25025050400	2010	16.000	1.70
33	25025050500	2010	3.000	0.50
33	25025050600	2010	12.000	1.60
33	25025050700	2010	56.000	3.80
33	25025050901	2010	53.000	4.00
33	25025051000	2010	26.000	1.60
33	25025051101	2010	32.000	1.50
33	25025051200	2010	14.000	1.40
33	25025060101	2010	1.000	0.10
33	25025060200	2010	0.000	0.00
33	25025060301	2010	2.000	0.10
33	25025060400	2010	2.000	0.10
33	25025060501	2010	0.000	0.00
33	25025060600	2010	1.000	0.10
33	25025060700	2010	2.000	0.30
33	25025060800	2010	4.000	0.20
33	25025061000	2010	1.000	0.10
33	25025061101	2010	0.000	0.00
33	25025061200	2010	3.000	0.20
33	25025070101	2010	5.000	0.20
33	25025070200	2010	0.000	0.00
33	25025070300	2010	1.000	0.00
33	25025070402	2010	0.000	0.00
33	25025070500	2010	6.000	0.20
33	25025070600	2010	4.000	0.30
33	25025070700	2010	0.000	0.00
33	25025070800	2010	2.000	0.10
33	25025070900	2010	2.000	0.10
33	25025071101	2010	4.000	0.20
33	25025071201	2010	3.000	0.20
33	25025080100	2010	7.000	1.00
33	25025080300	2010	9.000	1.30
33	25025080401	2010	2.000	0.20
33	25025080500	2010	2.000	0.20
33	25025080601	2010	5.000	0.60
33	25025080801	2010	0.000	0.00
33	25025080900	2010	4.000	0.20
33	25025081001	2010	4.000	0.20
33	25025081100	2010	15.000	0.90
33	25025081200	2010	19.000	1.70
33	25025081300	2010	19.000	0.90
33	25025081400	2010	10.000	0.80
33	25025081500	2010	11.000	1.30
33	25025081700	2010	10.000	0.70
33	25025081800	2010	12.000	1.10
33	25025081900	2010	13.000	1.00
33	25025082000	2010	8.000	0.70
33	25025082100	2010	7.000	0.30
33	25025090100	2010	11.000	0.70
33	25025090200	2010	10.000	1.30
33	25025090300	2010	15.000	1.30
33	25025090400	2010	21.000	1.80
33	25025090600	2010	9.000	1.30
33	25025090700	2010	5.000	0.30
33	25025090901	2010	1.000	0.10
33	25025091001	2010	4.000	0.30
33	25025091100	2010	8.000	0.40
33	25025091200	2010	16.000	1.40
33	25025091300	2010	9.000	1.10
33	25025091400	2010	22.000	2.50
33	25025091500	2010	19.000	1.30
33	25025091600	2010	12.000	1.20
33	25025091700	2010	13.000	1.40
33	25025091800	2010	26.000	2.50
33	25025091900	2010	9.000	0.70
33	25025092000	2010	31.000	2.00
33	25025092101	2010	15.000	0.70
33	25025092200	2010	9.000	0.80
33	25025092300	2010	12.000	1.30
33	25025092400	2010	12.000	0.60
33	25025100100	2010	18.000	0.90
33	25025100200	2010	8.000	0.90
33	25025100300	2010	12.000	1.10
33	25025100400	2010	15.000	0.90
33	25025100500	2010	15.000	0.70
33	25025100601	2010	11.000	0.50
33	25025100603	2010	3.000	0.40
33	25025100700	2010	5.000	0.30
33	25025100800	2010	12.000	0.50
33	25025100900	2010	9.000	0.60
33	25025101001	2010	8.000	0.40
33	25025101002	2010	8.000	0.40
33	25025101101	2010	8.000	0.80
33	25025101102	2010	3.000	0.20
33	25025110103	2010	47.000	2.20
33	25025110201	2010	27.000	3.30
33	25025110301	2010	46.000	5.10
33	25025110401	2010	45.000	3.50
33	25025110403	2010	57.000	3.40
33	25025110501	2010	16.000	1.20
33	25025110502	2010	30.000	1.90
33	25025110601	2010	2.000	0.20
33	25025110607	2010	9.000	0.40
33	25025120103	2010	1.000	0.20
33	25025120104	2010	4.000	0.40
33	25025120105	2010	4.000	0.40
33	25025120201	2010	13.000	0.80
33	25025120301	2010	52.000	2.90
33	25025120400	2010	8.000	0.30
33	25025120500	2010	29.000	3.40
33	25025120600	2010	14.000	1.30
33	25025120700	2010	13.000	1.30
33	25025130100	2010	16.000	0.60
33	25025130200	2010	0.000	0.00
33	25025130300	2010	4.000	0.20
33	25025130402	2010	8.000	0.40
33	25025130404	2010	10.000	0.80
33	25025130406	2010	11.000	0.50
33	25025140102	2010	42.000	2.70
33	25025140105	2010	57.000	4.50
33	25025140106	2010	3.000	0.40
33	25025140107	2010	24.000	2.50
33	25025140201	2010	12.000	1.40
33	25025140202	2010	48.000	2.50
33	25025140300	2010	61.000	2.60
33	25025140400	2010	61.000	2.20
33	25025160101	2010	146.000	7.20
33	25025160200	2010	39.000	3.30
33	25025160300	2010	11.000	0.90
33	25025160400	2010	24.000	2.50
33	25025160501	2010	103.000	5.50
33	25025160502	2010	80.000	5.40
33	25025160601	2010	42.000	2.90
33	25025160602	2010	65.000	3.90
33	25025170100	2010	98.000	3.40
33	25025170200	2010	38.000	2.20
33	25025170300	2010	62.000	1.70
33	25025170400	2010	58.000	2.60
33	25025170501	2010	23.000	1.40
33	25025170502	2010	8.000	0.60
33	25025170601	2010	76.000	4.10
33	25025170701	2010	20.000	2.10
33	25025170702	2010	70.000	3.30
33	25025170800	2010	34.000	1.60
33	25025180101	2010	10.000	0.40
33	25025180200	2010	6.000	0.40
33	25025180301	2010	0.000	0.00
33	25025180400	2010	1.000	0.10
33	25025180500	2010	8.000	0.40
33	25025980101	2010	0.000	\N
33	25025980300	2010	0.000	0.00
33	25025980700	2010	0.000	0.00
33	25025981000	2010	0.000	0.00
33	25025981100	2010	0.000	0.00
33	25025981201	2010	0.000	\N
33	25025981202	2010	0.000	\N
33	25025981300	2010	3.000	1.30
33	25025981501	2010	0.000	\N
33	25025981502	2010	0.000	0.00
33	25025981600	2010	0.000	\N
33	25025981700	2010	0.000	\N
33	25025981800	2010	0.000	0.00
33	25025990101	2010	0.000	\N
34	25025000401	2010	0.000	0.00
34	25025000402	2010	2.000	0.10
34	25025000100	2010	2.000	0.10
34	25025000201	2010	3.000	0.20
34	25025000202	2010	0.000	0.00
34	25025000301	2010	0.000	0.00
34	25025000302	2010	0.000	0.00
34	25025000502	2010	1.000	0.10
34	25025000503	2010	3.000	0.20
34	25025000504	2010	1.000	0.00
34	25025000601	2010	0.000	0.00
34	25025000602	2010	0.000	0.00
34	25025000701	2010	0.000	0.00
34	25025000703	2010	0.000	0.00
34	25025000704	2010	3.000	0.10
34	25025000802	2010	4.000	0.10
34	25025000803	2010	0.000	0.00
34	25025010103	2010	0.000	0.00
34	25025010104	2010	0.000	0.00
34	25025010203	2010	0.000	0.00
34	25025010204	2010	1.000	0.10
34	25025010300	2010	0.000	0.00
34	25025010403	2010	1.000	0.00
34	25025010404	2010	2.000	0.10
34	25025010405	2010	0.000	0.00
34	25025010408	2010	0.000	0.00
34	25025010500	2010	0.000	0.00
34	25025010600	2010	0.000	0.00
34	25025010701	2010	1.000	0.10
34	25025010702	2010	1.000	0.10
34	25025010801	2010	0.000	0.00
34	25025010802	2010	0.000	0.00
34	25025020101	2010	1.000	0.00
34	25025020200	2010	0.000	0.00
34	25025020301	2010	0.000	0.00
34	25025020302	2010	0.000	0.00
34	25025020303	2010	1.000	0.10
34	25025030100	2010	0.000	0.00
34	25025030200	2010	0.000	0.00
34	25025030300	2010	0.000	0.00
34	25025030400	2010	0.000	0.00
34	25025030500	2010	0.000	0.00
34	25025040100	2010	1.000	0.10
34	25025040200	2010	0.000	0.00
34	25025040300	2010	1.000	0.10
34	25025040401	2010	1.000	0.10
34	25025040600	2010	0.000	0.00
34	25025040801	2010	1.000	0.10
34	25025050101	2010	8.000	0.50
34	25025050200	2010	9.000	0.50
34	25025050300	2010	0.000	0.00
34	25025050400	2010	3.000	0.30
34	25025050500	2010	2.000	0.30
34	25025050600	2010	9.000	1.20
34	25025050700	2010	6.000	0.40
34	25025050901	2010	16.000	1.20
34	25025051000	2010	7.000	0.40
34	25025051101	2010	8.000	0.40
34	25025051200	2010	2.000	0.20
34	25025060101	2010	0.000	0.00
34	25025060200	2010	0.000	0.00
34	25025060301	2010	1.000	0.10
34	25025060400	2010	0.000	0.00
34	25025060501	2010	1.000	0.10
34	25025060600	2010	1.000	0.10
34	25025060700	2010	1.000	0.20
34	25025060800	2010	1.000	0.00
34	25025061000	2010	0.000	0.00
34	25025061101	2010	1.000	0.10
34	25025061200	2010	2.000	0.10
34	25025070101	2010	2.000	0.10
34	25025070200	2010	0.000	0.00
34	25025070300	2010	1.000	0.00
34	25025070402	2010	0.000	0.00
34	25025070500	2010	2.000	0.10
34	25025070600	2010	1.000	0.10
34	25025070700	2010	0.000	0.00
34	25025070800	2010	0.000	0.00
34	25025070900	2010	0.000	0.00
34	25025071101	2010	2.000	0.10
34	25025071201	2010	2.000	0.20
34	25025080100	2010	0.000	0.00
34	25025080300	2010	4.000	0.60
34	25025080401	2010	0.000	0.00
34	25025080500	2010	0.000	0.00
34	25025080601	2010	0.000	0.00
34	25025080801	2010	1.000	0.10
34	25025080900	2010	0.000	0.00
34	25025081001	2010	0.000	0.00
34	25025081100	2010	4.000	0.20
34	25025081200	2010	5.000	0.40
34	25025081300	2010	4.000	0.20
34	25025081400	2010	2.000	0.20
34	25025081500	2010	6.000	0.70
34	25025081700	2010	3.000	0.20
34	25025081800	2010	3.000	0.30
34	25025081900	2010	3.000	0.20
34	25025082000	2010	4.000	0.30
34	25025082100	2010	1.000	0.00
34	25025090100	2010	5.000	0.30
34	25025090200	2010	4.000	0.50
34	25025090300	2010	7.000	0.60
34	25025090400	2010	6.000	0.50
34	25025090600	2010	3.000	0.40
34	25025090700	2010	0.000	0.00
34	25025090901	2010	0.000	0.00
34	25025091001	2010	0.000	0.00
34	25025091100	2010	1.000	0.10
34	25025091200	2010	4.000	0.30
34	25025091300	2010	3.000	0.40
34	25025091400	2010	3.000	0.30
34	25025091500	2010	3.000	0.20
34	25025091600	2010	3.000	0.30
34	25025091700	2010	6.000	0.70
34	25025091800	2010	3.000	0.30
34	25025091900	2010	5.000	0.40
34	25025092000	2010	10.000	0.70
34	25025092101	2010	4.000	0.20
34	25025092200	2010	2.000	0.20
34	25025092300	2010	4.000	0.40
34	25025092400	2010	0.000	0.00
34	25025100100	2010	5.000	0.30
34	25025100200	2010	2.000	0.20
34	25025100300	2010	1.000	0.10
34	25025100400	2010	5.000	0.30
34	25025100500	2010	4.000	0.20
34	25025100601	2010	8.000	0.40
34	25025100603	2010	1.000	0.10
34	25025100700	2010	0.000	0.00
34	25025100800	2010	2.000	0.10
34	25025100900	2010	2.000	0.10
34	25025101001	2010	4.000	0.20
34	25025101002	2010	7.000	0.40
34	25025101101	2010	2.000	0.20
34	25025101102	2010	1.000	0.10
34	25025110103	2010	5.000	0.20
34	25025110201	2010	7.000	0.90
34	25025110301	2010	7.000	0.80
34	25025110401	2010	12.000	0.90
34	25025110403	2010	7.000	0.40
34	25025110501	2010	5.000	0.40
34	25025110502	2010	6.000	0.40
34	25025110601	2010	1.000	0.10
34	25025110607	2010	1.000	0.00
34	25025120103	2010	2.000	0.30
34	25025120104	2010	2.000	0.20
34	25025120105	2010	5.000	0.60
34	25025120201	2010	2.000	0.10
34	25025120301	2010	17.000	1.00
34	25025120400	2010	4.000	0.10
34	25025120500	2010	9.000	1.10
34	25025120600	2010	5.000	0.50
34	25025120700	2010	3.000	0.30
34	25025130100	2010	3.000	0.10
34	25025130200	2010	0.000	0.00
34	25025130300	2010	0.000	0.00
34	25025130402	2010	3.000	0.10
34	25025130404	2010	1.000	0.10
34	25025130406	2010	2.000	0.10
34	25025140102	2010	7.000	0.50
34	25025140105	2010	12.000	0.90
34	25025140106	2010	0.000	0.00
34	25025140107	2010	9.000	0.90
34	25025140201	2010	7.000	0.80
34	25025140202	2010	9.000	0.50
34	25025140300	2010	10.000	0.40
34	25025140400	2010	23.000	0.80
34	25025160101	2010	17.000	0.80
34	25025160200	2010	9.000	0.80
34	25025160300	2010	1.000	0.10
34	25025160400	2010	6.000	0.60
34	25025160501	2010	19.000	1.00
34	25025160502	2010	14.000	0.90
34	25025160601	2010	5.000	0.30
34	25025160602	2010	17.000	1.00
34	25025170100	2010	11.000	0.40
34	25025170200	2010	4.000	0.20
34	25025170300	2010	12.000	0.30
34	25025170400	2010	9.000	0.40
34	25025170501	2010	6.000	0.40
34	25025170502	2010	2.000	0.10
34	25025170601	2010	13.000	0.70
34	25025170701	2010	1.000	0.10
34	25025170702	2010	8.000	0.40
34	25025170800	2010	10.000	0.50
34	25025180101	2010	3.000	0.10
34	25025180200	2010	2.000	0.10
34	25025180301	2010	1.000	0.10
34	25025180400	2010	0.000	0.00
34	25025180500	2010	3.000	0.20
34	25025980101	2010	0.000	\N
34	25025980300	2010	0.000	0.00
34	25025980700	2010	0.000	0.00
34	25025981000	2010	0.000	0.00
34	25025981100	2010	0.000	0.00
34	25025981201	2010	0.000	\N
34	25025981202	2010	0.000	\N
34	25025981300	2010	0.000	0.00
34	25025981501	2010	0.000	\N
34	25025981502	2010	0.000	0.00
34	25025981600	2010	0.000	\N
34	25025981700	2010	0.000	\N
34	25025981800	2010	0.000	0.00
34	25025990101	2010	0.000	\N
35	25025000401	2010	2381.000	82.80
35	25025000402	2010	981.000	67.10
35	25025000100	2010	1208.000	74.80
35	25025000201	2010	1094.000	71.00
35	25025000202	2010	1006.000	68.00
35	25025000301	2010	683.000	58.90
35	25025000302	2010	645.000	50.50
35	25025000502	2010	1513.000	80.80
35	25025000503	2010	993.000	74.00
35	25025000504	2010	2119.000	80.40
35	25025000601	2010	988.000	68.10
35	25025000602	2010	1781.000	90.50
35	25025000701	2010	1955.000	85.20
35	25025000703	2010	1348.000	96.60
35	25025000704	2010	2034.000	86.60
35	25025000802	2010	2572.000	85.40
35	25025000803	2010	874.000	99.10
35	25025010103	2010	441.000	90.00
35	25025010104	2010	1515.000	79.10
35	25025010203	2010	3255.000	93.00
35	25025010204	2010	1026.000	86.40
35	25025010300	2010	332.000	84.10
35	25025010403	2010	1904.000	94.00
35	25025010404	2010	1609.000	88.90
35	25025010405	2010	870.000	90.10
35	25025010408	2010	844.000	89.50
35	25025010500	2010	1447.000	87.40
35	25025010600	2010	1502.000	81.00
35	25025010701	2010	941.000	67.40
35	25025010702	2010	765.000	54.60
35	25025010801	2010	839.000	50.80
35	25025010802	2010	1105.000	59.10
35	25025020101	2010	1358.000	54.90
35	25025020200	2010	1804.000	78.40
35	25025020301	2010	1013.000	81.00
35	25025020302	2010	452.000	67.00
35	25025020303	2010	1188.000	72.80
35	25025030100	2010	1038.000	81.30
35	25025030200	2010	871.000	83.40
35	25025030300	2010	1568.000	63.50
35	25025030400	2010	1204.000	79.60
35	25025030500	2010	909.000	62.40
35	25025040100	2010	510.000	42.90
35	25025040200	2010	454.000	68.50
35	25025040300	2010	837.000	44.20
35	25025040401	2010	703.000	59.90
35	25025040600	2010	544.000	43.90
35	25025040801	2010	1266.000	67.50
35	25025050101	2010	1319.000	77.00
35	25025050200	2010	1319.000	77.80
35	25025050300	2010	895.000	92.00
35	25025050400	2010	728.000	75.30
35	25025050500	2010	517.000	78.50
35	25025050600	2010	591.000	79.20
35	25025050700	2010	1105.000	75.90
35	25025050901	2010	926.000	69.90
35	25025051000	2010	1154.000	69.10
35	25025051101	2010	1317.000	60.10
35	25025051200	2010	670.000	65.50
35	25025060101	2010	843.000	53.50
35	25025060200	2010	456.000	49.20
35	25025060301	2010	781.000	50.70
35	25025060400	2010	1272.000	53.50
35	25025060501	2010	999.000	54.60
35	25025060600	2010	850.000	62.00
35	25025060700	2010	612.000	99.20
35	25025060800	2010	1062.000	53.00
35	25025061000	2010	981.000	79.20
35	25025061101	2010	970.000	98.80
35	25025061200	2010	893.000	50.90
35	25025070101	2010	1923.000	66.90
35	25025070200	2010	1414.000	92.20
35	25025070300	2010	1293.000	52.80
35	25025070402	2010	663.000	99.50
35	25025070500	2010	1724.000	59.40
35	25025070600	2010	524.000	43.30
35	25025070700	2010	758.000	61.20
35	25025070800	2010	1408.000	68.90
35	25025070900	2010	1222.000	70.70
35	25025071101	2010	1518.000	72.70
35	25025071201	2010	817.000	62.70
35	25025080100	2010	532.000	78.10
35	25025080300	2010	560.000	80.80
35	25025080401	2010	1097.000	89.60
35	25025080500	2010	1210.000	95.40
35	25025080601	2010	777.000	88.10
35	25025080801	2010	925.000	99.80
35	25025080900	2010	1543.000	91.50
35	25025081001	2010	2060.000	92.20
35	25025081100	2010	1242.000	73.80
35	25025081200	2010	969.000	86.10
35	25025081300	2010	1800.000	90.00
35	25025081400	2010	881.000	67.80
35	25025081500	2010	574.000	68.40
35	25025081700	2010	1136.000	77.10
35	25025081800	2010	796.000	69.90
35	25025081900	2010	999.000	79.50
35	25025082000	2010	828.000	71.50
35	25025082100	2010	1837.000	90.30
35	25025090100	2010	1281.000	76.20
35	25025090200	2010	649.000	84.10
35	25025090300	2010	900.000	80.10
35	25025090400	2010	779.000	67.90
35	25025090600	2010	462.000	64.20
35	25025090700	2010	1229.000	67.10
35	25025090901	2010	1537.000	99.80
35	25025091001	2010	709.000	57.40
35	25025091100	2010	1083.000	60.40
35	25025091200	2010	761.000	65.60
35	25025091300	2010	574.000	72.70
35	25025091400	2010	578.000	65.80
35	25025091500	2010	1013.000	68.90
35	25025091600	2010	758.000	72.70
35	25025091700	2010	598.000	65.20
35	25025091800	2010	654.000	62.80
35	25025091900	2010	843.000	67.80
35	25025092000	2010	997.000	65.10
35	25025092101	2010	1380.000	61.30
35	25025092200	2010	598.000	52.70
35	25025092300	2010	594.000	62.10
35	25025092400	2010	1487.000	79.40
35	25025100100	2010	1477.000	77.90
35	25025100200	2010	569.000	62.90
35	25025100300	2010	644.000	57.40
35	25025100400	2010	980.000	57.80
35	25025100500	2010	1494.000	68.70
35	25025100601	2010	1101.000	54.30
35	25025100603	2010	341.000	45.20
35	25025100700	2010	835.000	44.60
35	25025100800	2010	1372.000	54.40
35	25025100900	2010	742.000	46.10
35	25025101001	2010	1178.000	55.40
35	25025101002	2010	1301.000	66.10
35	25025101101	2010	634.000	60.50
35	25025101102	2010	1104.000	73.10
35	25025110103	2010	1327.000	60.70
35	25025110201	2010	514.000	63.10
35	25025110301	2010	296.000	33.00
35	25025110401	2010	680.000	52.90
35	25025110403	2010	599.000	35.80
35	25025110501	2010	482.000	37.10
35	25025110502	2010	759.000	48.00
35	25025110601	2010	287.000	23.20
35	25025110607	2010	918.000	43.90
35	25025120103	2010	213.000	32.30
35	25025120104	2010	541.000	54.10
35	25025120105	2010	87.000	9.70
35	25025120201	2010	1086.000	65.50
35	25025120301	2010	1012.000	56.70
35	25025120400	2010	1380.000	50.90
35	25025120500	2010	579.000	68.00
35	25025120600	2010	597.000	56.60
35	25025120700	2010	484.000	49.20
35	25025130100	2010	727.000	27.20
35	25025130200	2010	526.000	28.80
35	25025130300	2010	407.000	23.20
35	25025130402	2010	702.000	33.40
35	25025130404	2010	518.000	41.20
35	25025130406	2010	1556.000	73.70
35	25025140102	2010	499.000	32.20
35	25025140105	2010	376.000	29.50
35	25025140106	2010	721.000	91.20
35	25025140107	2010	414.000	42.40
35	25025140201	2010	525.000	61.00
35	25025140202	2010	724.000	37.10
35	25025140300	2010	1337.000	56.80
35	25025140400	2010	1054.000	38.40
35	25025160101	2010	1434.000	71.20
35	25025160200	2010	1029.000	87.10
35	25025160300	2010	708.000	59.10
35	25025160400	2010	807.000	85.60
35	25025160501	2010	1391.000	74.50
35	25025160502	2010	979.000	66.30
35	25025160601	2010	1059.000	72.00
35	25025160602	2010	1031.000	61.30
35	25025170100	2010	1279.000	44.80
35	25025170200	2010	900.000	52.10
35	25025170300	2010	1674.000	46.70
35	25025170400	2010	1221.000	55.70
35	25025170501	2010	862.000	52.80
35	25025170502	2010	616.000	43.80
35	25025170601	2010	845.000	45.10
35	25025170701	2010	584.000	60.60
35	25025170702	2010	1506.000	70.20
35	25025170800	2010	1237.000	59.70
35	25025180101	2010	1205.000	51.30
35	25025180200	2010	717.000	42.60
35	25025180301	2010	330.000	28.00
35	25025180400	2010	324.000	43.70
35	25025180500	2010	900.000	49.20
35	25025980101	2010	0.000	\N
35	25025980300	2010	1.000	50.00
35	25025980700	2010	1.000	25.00
35	25025981000	2010	5.000	100.00
35	25025981100	2010	70.000	82.40
35	25025981201	2010	0.000	\N
35	25025981202	2010	0.000	\N
35	25025981300	2010	82.000	34.70
35	25025981501	2010	0.000	\N
35	25025981502	2010	1.000	33.30
35	25025981600	2010	0.000	\N
35	25025981700	2010	0.000	\N
35	25025981800	2010	7.000	15.20
35	25025990101	2010	0.000	\N
36	25025000401	2010	2289.000	79.60
36	25025000402	2010	939.000	64.30
36	25025000100	2010	1066.000	66.00
36	25025000201	2010	991.000	64.30
36	25025000202	2010	850.000	57.40
36	25025000301	2010	627.000	54.10
36	25025000302	2010	617.000	48.40
36	25025000502	2010	1423.000	76.00
36	25025000503	2010	954.000	71.10
36	25025000504	2010	1994.000	75.60
36	25025000601	2010	913.000	63.00
36	25025000602	2010	1546.000	78.60
36	25025000701	2010	1813.000	79.00
36	25025000703	2010	1271.000	91.10
36	25025000704	2010	1808.000	76.90
36	25025000802	2010	2216.000	73.60
36	25025000803	2010	783.000	88.80
36	25025010103	2010	414.000	84.50
36	25025010104	2010	1397.000	72.90
36	25025010203	2010	2943.000	84.10
36	25025010204	2010	978.000	82.30
36	25025010300	2010	229.000	58.00
36	25025010403	2010	1735.000	85.70
36	25025010404	2010	1482.000	81.90
36	25025010405	2010	770.000	79.70
36	25025010408	2010	772.000	81.90
36	25025010500	2010	1318.000	79.60
36	25025010600	2010	1416.000	76.40
36	25025010701	2010	881.000	63.10
36	25025010702	2010	727.000	51.90
36	25025010801	2010	789.000	47.80
36	25025010802	2010	1065.000	56.90
36	25025020101	2010	1298.000	52.50
36	25025020200	2010	1713.000	74.40
36	25025020301	2010	970.000	77.60
36	25025020302	2010	429.000	63.60
36	25025020303	2010	1112.000	68.10
36	25025030100	2010	1000.000	78.40
36	25025030200	2010	844.000	80.80
36	25025030300	2010	1494.000	60.50
36	25025030400	2010	1162.000	76.80
36	25025030500	2010	866.000	59.40
36	25025040100	2010	496.000	41.80
36	25025040200	2010	346.000	52.20
36	25025040300	2010	717.000	37.90
36	25025040401	2010	670.000	57.10
36	25025040600	2010	518.000	41.80
36	25025040801	2010	1063.000	56.70
36	25025050101	2010	615.000	35.90
36	25025050200	2010	568.000	33.50
36	25025050300	2010	570.000	58.60
36	25025050400	2010	420.000	43.40
36	25025050500	2010	272.000	41.30
36	25025050600	2010	232.000	31.10
36	25025050700	2010	471.000	32.40
36	25025050901	2010	417.000	31.50
36	25025051000	2010	790.000	47.30
36	25025051101	2010	806.000	36.80
36	25025051200	2010	470.000	45.90
36	25025060101	2010	833.000	52.90
36	25025060200	2010	454.000	49.00
36	25025060301	2010	774.000	50.30
36	25025060400	2010	1249.000	52.50
36	25025060501	2010	981.000	53.60
36	25025060600	2010	816.000	59.60
36	25025060700	2010	336.000	54.50
36	25025060800	2010	1037.000	51.80
36	25025061000	2010	682.000	55.00
36	25025061101	2010	629.000	64.10
36	25025061200	2010	850.000	48.50
36	25025070101	2010	1816.000	63.20
36	25025070200	2010	1383.000	90.20
36	25025070300	2010	1228.000	50.20
36	25025070402	2010	606.000	91.00
36	25025070500	2010	1269.000	43.70
36	25025070600	2010	486.000	40.20
36	25025070700	2010	688.000	55.60
36	25025070800	2010	1251.000	61.20
36	25025070900	2010	957.000	55.40
36	25025071101	2010	1318.000	63.10
36	25025071201	2010	566.000	43.40
36	25025080100	2010	404.000	59.30
36	25025080300	2010	416.000	60.00
36	25025080401	2010	704.000	57.50
36	25025080500	2010	701.000	55.20
36	25025080601	2010	550.000	62.40
36	25025080801	2010	491.000	53.00
36	25025080900	2010	1428.000	84.70
36	25025081001	2010	1684.000	75.40
36	25025081100	2010	1053.000	62.60
36	25025081200	2010	468.000	41.60
36	25025081300	2010	1041.000	52.00
36	25025081400	2010	699.000	53.80
36	25025081500	2010	440.000	52.40
36	25025081700	2010	920.000	62.50
36	25025081800	2010	564.000	49.50
36	25025081900	2010	756.000	60.20
36	25025082000	2010	664.000	57.30
36	25025082100	2010	1229.000	60.40
36	25025090100	2010	975.000	58.00
36	25025090200	2010	404.000	52.30
36	25025090300	2010	609.000	54.20
36	25025090400	2010	508.000	44.30
36	25025090600	2010	355.000	49.30
36	25025090700	2010	1128.000	61.60
36	25025090901	2010	1266.000	82.20
36	25025091001	2010	631.000	51.10
36	25025091100	2010	975.000	54.40
36	25025091200	2010	592.000	51.00
36	25025091300	2010	431.000	54.60
36	25025091400	2010	357.000	40.60
36	25025091500	2010	784.000	53.30
36	25025091600	2010	642.000	61.60
36	25025091700	2010	473.000	51.60
36	25025091800	2010	523.000	50.20
36	25025091900	2010	652.000	52.40
36	25025092000	2010	780.000	50.90
36	25025092101	2010	1207.000	53.60
36	25025092200	2010	512.000	45.10
36	25025092300	2010	490.000	51.30
36	25025092400	2010	1038.000	55.40
36	25025100100	2010	1039.000	54.80
36	25025100200	2010	470.000	51.90
36	25025100300	2010	569.000	50.80
36	25025100400	2010	888.000	52.40
36	25025100500	2010	1239.000	57.00
36	25025100601	2010	981.000	48.40
36	25025100603	2010	316.000	41.90
36	25025100700	2010	811.000	43.30
36	25025100800	2010	1260.000	49.90
36	25025100900	2010	664.000	41.20
36	25025101001	2010	996.000	46.80
36	25025101002	2010	1120.000	56.90
36	25025101101	2010	524.000	50.00
36	25025101102	2010	979.000	64.80
36	25025110103	2010	893.000	40.90
36	25025110201	2010	336.000	41.20
36	25025110301	2010	206.000	22.90
36	25025110401	2010	398.000	31.00
36	25025110403	2010	442.000	26.40
36	25025110501	2010	392.000	30.20
36	25025110502	2010	556.000	35.20
36	25025110601	2010	274.000	22.20
36	25025110607	2010	805.000	38.50
36	25025120103	2010	202.000	30.60
36	25025120104	2010	433.000	43.30
36	25025120105	2010	82.000	9.10
36	25025120201	2010	814.000	49.10
36	25025120301	2010	604.000	33.90
36	25025120400	2010	1201.000	44.30
36	25025120500	2010	278.000	32.60
36	25025120600	2010	531.000	50.40
36	25025120700	2010	391.000	39.80
36	25025130100	2010	692.000	25.90
36	25025130200	2010	490.000	26.80
36	25025130300	2010	364.000	20.70
36	25025130402	2010	636.000	30.30
36	25025130404	2010	435.000	34.60
36	25025130406	2010	1208.000	57.20
36	25025140102	2010	401.000	25.90
36	25025140105	2010	262.000	20.60
36	25025140106	2010	529.000	66.90
36	25025140107	2010	293.000	30.00
36	25025140201	2010	454.000	52.70
36	25025140202	2010	547.000	28.00
36	25025140300	2010	1036.000	44.00
36	25025140400	2010	861.000	31.40
36	25025160101	2010	377.000	18.70
36	25025160200	2010	225.000	19.10
36	25025160300	2010	568.000	47.50
36	25025160400	2010	306.000	32.40
36	25025160501	2010	523.000	28.00
36	25025160502	2010	417.000	28.30
36	25025160601	2010	630.000	42.90
36	25025160602	2010	636.000	37.80
36	25025170100	2010	987.000	34.60
36	25025170200	2010	759.000	43.90
36	25025170300	2010	1466.000	40.90
36	25025170400	2010	994.000	45.40
36	25025170501	2010	681.000	41.70
36	25025170502	2010	577.000	41.00
36	25025170601	2010	621.000	33.10
36	25025170701	2010	491.000	51.00
36	25025170702	2010	938.000	43.80
36	25025170800	2010	963.000	46.50
36	25025180101	2010	1145.000	48.80
36	25025180200	2010	670.000	39.80
36	25025180301	2010	308.000	26.10
36	25025180400	2010	303.000	40.80
36	25025180500	2010	838.000	45.80
36	25025980101	2010	0.000	\N
36	25025980300	2010	1.000	50.00
36	25025980700	2010	1.000	25.00
36	25025981000	2010	5.000	100.00
36	25025981100	2010	60.000	70.60
36	25025981201	2010	0.000	\N
36	25025981202	2010	0.000	\N
36	25025981300	2010	67.000	28.40
36	25025981501	2010	0.000	\N
36	25025981502	2010	0.000	0.00
36	25025981600	2010	0.000	\N
36	25025981700	2010	0.000	\N
36	25025981800	2010	7.000	15.20
36	25025990101	2010	0.000	\N
37	25025000401	2010	1781.000	61.90
37	25025000402	2010	787.000	53.90
37	25025000100	2010	821.000	50.80
37	25025000201	2010	843.000	54.70
37	25025000202	2010	661.000	44.70
37	25025000301	2010	529.000	45.60
37	25025000302	2010	522.000	40.90
37	25025000502	2010	1184.000	63.20
37	25025000503	2010	805.000	60.00
37	25025000504	2010	1677.000	63.60
37	25025000601	2010	719.000	49.60
37	25025000602	2010	1046.000	53.20
37	25025000701	2010	1405.000	61.20
37	25025000703	2010	820.000	58.80
37	25025000704	2010	1306.000	55.60
37	25025000802	2010	1478.000	49.10
37	25025000803	2010	414.000	46.90
37	25025010103	2010	264.000	53.90
37	25025010104	2010	1035.000	54.00
37	25025010203	2010	2171.000	62.00
37	25025010204	2010	709.000	59.70
37	25025010300	2010	121.000	30.60
37	25025010403	2010	1087.000	53.70
37	25025010404	2010	1050.000	58.00
37	25025010405	2010	461.000	47.70
37	25025010408	2010	607.000	64.40
37	25025010500	2010	906.000	54.70
37	25025010600	2010	1102.000	59.40
37	25025010701	2010	752.000	53.90
37	25025010702	2010	648.000	46.20
37	25025010801	2010	682.000	41.30
37	25025010802	2010	890.000	47.60
37	25025020101	2010	1189.000	48.10
37	25025020200	2010	1472.000	63.90
37	25025020301	2010	705.000	56.40
37	25025020302	2010	376.000	55.70
37	25025020303	2010	879.000	53.90
37	25025030100	2010	966.000	75.70
37	25025030200	2010	809.000	77.50
37	25025030300	2010	1275.000	51.70
37	25025030400	2010	1105.000	73.00
37	25025030500	2010	817.000	56.10
37	25025040100	2010	476.000	40.10
37	25025040200	2010	215.000	32.40
37	25025040300	2010	622.000	32.80
37	25025040401	2010	592.000	50.40
37	25025040600	2010	481.000	38.90
37	25025040801	2010	673.000	35.90
37	25025050101	2010	469.000	27.40
37	25025050200	2010	429.000	25.30
37	25025050300	2010	358.000	36.80
37	25025050400	2010	348.000	36.00
37	25025050500	2010	222.000	33.70
37	25025050600	2010	182.000	24.40
37	25025050700	2010	370.000	25.40
37	25025050901	2010	352.000	26.60
37	25025051000	2010	701.000	42.00
37	25025051101	2010	642.000	29.30
37	25025051200	2010	408.000	39.90
37	25025060101	2010	824.000	52.30
37	25025060200	2010	447.000	48.20
37	25025060301	2010	757.000	49.20
37	25025060400	2010	1199.000	50.40
37	25025060501	2010	947.000	51.70
37	25025060600	2010	731.000	53.40
37	25025060700	2010	146.000	23.70
37	25025060800	2010	985.000	49.20
37	25025061000	2010	392.000	31.60
37	25025061101	2010	255.000	26.00
37	25025061200	2010	783.000	44.70
37	25025070101	2010	993.000	34.50
37	25025070200	2010	163.000	10.60
37	25025070300	2010	882.000	36.00
37	25025070402	2010	60.000	9.00
37	25025070500	2010	739.000	25.50
37	25025070600	2010	419.000	34.60
37	25025070700	2010	358.000	28.90
37	25025070800	2010	744.000	36.40
37	25025070900	2010	440.000	25.50
37	25025071101	2010	627.000	30.00
37	25025071201	2010	246.000	18.90
37	25025080100	2010	79.000	11.60
37	25025080300	2010	19.000	2.70
37	25025080401	2010	44.000	3.60
37	25025080500	2010	85.000	6.70
37	25025080601	2010	198.000	22.40
37	25025080801	2010	62.000	6.70
37	25025080900	2010	985.000	58.40
37	25025081001	2010	939.000	42.00
37	25025081100	2010	663.000	39.40
37	25025081200	2010	83.000	7.40
37	25025081300	2010	108.000	5.40
37	25025081400	2010	206.000	15.80
37	25025081500	2010	35.000	4.20
37	25025081700	2010	27.000	1.80
37	25025081800	2010	14.000	1.20
37	25025081900	2010	21.000	1.70
37	25025082000	2010	19.000	1.60
37	25025082100	2010	22.000	1.10
37	25025090100	2010	23.000	1.40
37	25025090200	2010	19.000	2.50
37	25025090300	2010	21.000	1.90
37	25025090400	2010	26.000	2.30
37	25025090600	2010	21.000	2.90
37	25025090700	2010	783.000	42.70
37	25025090901	2010	615.000	39.90
37	25025091001	2010	393.000	31.80
37	25025091100	2010	526.000	29.40
37	25025091200	2010	218.000	18.80
37	25025091300	2010	47.000	5.90
37	25025091400	2010	23.000	2.60
37	25025091500	2010	104.000	7.10
37	25025091600	2010	113.000	10.80
37	25025091700	2010	42.000	4.60
37	25025091800	2010	25.000	2.40
37	25025091900	2010	22.000	1.80
37	25025092000	2010	63.000	4.10
37	25025092101	2010	413.000	18.30
37	25025092200	2010	105.000	9.30
37	25025092300	2010	12.000	1.30
37	25025092400	2010	20.000	1.10
37	25025100100	2010	27.000	1.40
37	25025100200	2010	11.000	1.20
37	25025100300	2010	22.000	2.00
37	25025100400	2010	83.000	4.90
37	25025100500	2010	158.000	7.30
37	25025100601	2010	396.000	19.50
37	25025100603	2010	234.000	31.00
37	25025100700	2010	728.000	38.90
37	25025100800	2010	622.000	24.60
37	25025100900	2010	201.000	12.50
37	25025101001	2010	28.000	1.30
37	25025101002	2010	57.000	2.90
37	25025101101	2010	5.000	0.50
37	25025101102	2010	16.000	1.10
37	25025110103	2010	507.000	23.20
37	25025110201	2010	104.000	12.80
37	25025110301	2010	112.000	12.50
37	25025110401	2010	188.000	14.60
37	25025110403	2010	269.000	16.10
37	25025110501	2010	302.000	23.20
37	25025110502	2010	380.000	24.10
37	25025110601	2010	255.000	20.60
37	25025110607	2010	684.000	32.70
37	25025120103	2010	177.000	26.80
37	25025120104	2010	344.000	34.40
37	25025120105	2010	71.000	7.90
37	25025120201	2010	540.000	32.50
37	25025120301	2010	398.000	22.30
37	25025120400	2010	961.000	35.50
37	25025120500	2010	190.000	22.30
37	25025120600	2010	472.000	44.80
37	25025120700	2010	301.000	30.60
37	25025130100	2010	517.000	19.40
37	25025130200	2010	435.000	23.80
37	25025130300	2010	310.000	17.70
37	25025130402	2010	542.000	25.80
37	25025130404	2010	339.000	26.90
37	25025130406	2010	417.000	19.70
37	25025140102	2010	192.000	12.40
37	25025140105	2010	97.000	7.60
37	25025140106	2010	126.000	15.90
37	25025140107	2010	152.000	15.60
37	25025140201	2010	270.000	31.40
37	25025140202	2010	282.000	14.40
37	25025140300	2010	317.000	13.50
37	25025140400	2010	77.000	2.80
37	25025160101	2010	230.000	11.40
37	25025160200	2010	126.000	10.70
37	25025160300	2010	472.000	39.40
37	25025160400	2010	175.000	18.60
37	25025160501	2010	338.000	18.10
37	25025160502	2010	288.000	19.50
37	25025160601	2010	430.000	29.30
37	25025160602	2010	473.000	28.10
37	25025170100	2010	837.000	29.30
37	25025170200	2010	671.000	38.80
37	25025170300	2010	1126.000	31.40
37	25025170400	2010	800.000	36.50
37	25025170501	2010	572.000	35.00
37	25025170502	2010	546.000	38.80
37	25025170601	2010	553.000	29.50
37	25025170701	2010	438.000	45.50
37	25025170702	2010	599.000	27.90
37	25025170800	2010	851.000	41.10
37	25025180101	2010	1087.000	46.30
37	25025180200	2010	635.000	37.70
37	25025180301	2010	296.000	25.10
37	25025180400	2010	280.000	37.70
37	25025180500	2010	779.000	42.50
37	25025980101	2010	0.000	\N
37	25025980300	2010	1.000	50.00
37	25025980700	2010	1.000	25.00
37	25025981000	2010	2.000	40.00
37	25025981100	2010	5.000	5.90
37	25025981201	2010	0.000	\N
37	25025981202	2010	0.000	\N
37	25025981300	2010	54.000	22.90
37	25025981501	2010	0.000	\N
37	25025981502	2010	0.000	0.00
37	25025981600	2010	0.000	\N
37	25025981700	2010	0.000	\N
37	25025981800	2010	6.000	13.00
37	25025990101	2010	0.000	\N
38	25025000401	2010	68.000	2.40
38	25025000402	2010	24.000	1.60
38	25025000100	2010	70.000	4.30
38	25025000201	2010	54.000	3.50
38	25025000202	2010	83.000	5.60
38	25025000301	2010	38.000	3.30
38	25025000302	2010	16.000	1.30
38	25025000502	2010	45.000	2.40
38	25025000503	2010	30.000	2.20
38	25025000504	2010	94.000	3.60
38	25025000601	2010	33.000	2.30
38	25025000602	2010	180.000	9.10
38	25025000701	2010	91.000	4.00
38	25025000703	2010	49.000	3.50
38	25025000704	2010	134.000	5.70
38	25025000802	2010	112.000	3.70
38	25025000803	2010	52.000	5.90
38	25025010103	2010	16.000	3.30
38	25025010104	2010	42.000	2.20
38	25025010203	2010	130.000	3.70
38	25025010204	2010	30.000	2.50
38	25025010300	2010	61.000	15.40
38	25025010403	2010	208.000	10.30
38	25025010404	2010	70.000	3.90
38	25025010405	2010	121.000	12.50
38	25025010408	2010	24.000	2.50
38	25025010500	2010	171.000	10.30
38	25025010600	2010	94.000	5.10
38	25025010701	2010	16.000	1.10
38	25025010702	2010	13.000	0.90
38	25025010801	2010	14.000	0.80
38	25025010802	2010	20.000	1.10
38	25025020101	2010	12.000	0.50
38	25025020200	2010	70.000	3.00
38	25025020301	2010	25.000	2.00
38	25025020302	2010	9.000	1.30
38	25025020303	2010	61.000	3.70
38	25025030100	2010	12.000	0.90
38	25025030200	2010	4.000	0.40
38	25025030300	2010	62.000	2.50
38	25025030400	2010	6.000	0.40
38	25025030500	2010	6.000	0.40
38	25025040100	2010	4.000	0.30
38	25025040200	2010	69.000	10.40
38	25025040300	2010	52.000	2.70
38	25025040401	2010	16.000	1.40
38	25025040600	2010	13.000	1.10
38	25025040801	2010	137.000	7.30
38	25025050101	2010	45.000	2.60
38	25025050200	2010	58.000	3.40
38	25025050300	2010	95.000	9.80
38	25025050400	2010	33.000	3.40
38	25025050500	2010	15.000	2.30
38	25025050600	2010	12.000	1.60
38	25025050700	2010	23.000	1.60
38	25025050901	2010	25.000	1.90
38	25025051000	2010	36.000	2.20
38	25025051101	2010	86.000	3.90
38	25025051200	2010	22.000	2.20
38	25025060101	2010	1.000	0.10
38	25025060200	2010	2.000	0.20
38	25025060301	2010	5.000	0.30
38	25025060400	2010	11.000	0.50
38	25025060501	2010	5.000	0.30
38	25025060600	2010	11.000	0.80
38	25025060700	2010	107.000	17.30
38	25025060800	2010	14.000	0.70
38	25025061000	2010	162.000	13.10
38	25025061101	2010	225.000	22.90
38	25025061200	2010	28.000	1.60
38	25025070101	2010	43.000	1.50
38	25025070200	2010	51.000	3.30
38	25025070300	2010	64.000	2.60
38	25025070402	2010	89.000	13.40
38	25025070500	2010	198.000	6.80
38	25025070600	2010	20.000	1.70
38	25025070700	2010	221.000	17.90
38	25025070800	2010	353.000	17.30
38	25025070900	2010	369.000	21.40
38	25025071101	2010	277.000	13.30
38	25025071201	2010	198.000	15.20
38	25025080100	2010	223.000	32.70
38	25025080300	2010	370.000	53.40
38	25025080401	2010	603.000	49.20
38	25025080500	2010	558.000	44.00
38	25025080601	2010	285.000	32.30
38	25025080801	2010	305.000	32.90
38	25025080900	2010	143.000	8.50
38	25025081001	2010	301.000	13.50
38	25025081100	2010	232.000	13.80
38	25025081200	2010	344.000	30.60
38	25025081300	2010	867.000	43.30
38	25025081400	2010	447.000	34.40
38	25025081500	2010	371.000	44.20
38	25025081700	2010	824.000	55.90
38	25025081800	2010	515.000	45.20
38	25025081900	2010	686.000	54.60
38	25025082000	2010	601.000	51.90
38	25025082100	2010	1133.000	55.70
38	25025090100	2010	896.000	53.30
38	25025090200	2010	358.000	46.40
38	25025090300	2010	533.000	47.50
38	25025090400	2010	412.000	35.90
38	25025090600	2010	165.000	22.90
38	25025090700	2010	129.000	7.00
38	25025090901	2010	303.000	19.70
38	25025091001	2010	110.000	8.90
38	25025091100	2010	171.000	9.50
38	25025091200	2010	219.000	18.90
38	25025091300	2010	219.000	27.70
38	25025091400	2010	251.000	28.60
38	25025091500	2010	416.000	28.30
38	25025091600	2010	262.000	25.10
38	25025091700	2010	304.000	33.20
38	25025091800	2010	350.000	33.60
38	25025091900	2010	576.000	46.30
38	25025092000	2010	561.000	36.60
38	25025092101	2010	377.000	16.70
38	25025092200	2010	292.000	25.70
38	25025092300	2010	446.000	46.70
38	25025092400	2010	953.000	50.90
38	25025100100	2010	932.000	49.20
38	25025100200	2010	428.000	47.30
38	25025100300	2010	509.000	45.40
38	25025100400	2010	717.000	42.30
38	25025100500	2010	881.000	40.50
38	25025100601	2010	386.000	19.00
38	25025100603	2010	56.000	7.40
38	25025100700	2010	55.000	2.90
38	25025100800	2010	476.000	18.90
38	25025100900	2010	398.000	24.70
38	25025101001	2010	915.000	43.00
38	25025101002	2010	999.000	50.80
38	25025101101	2010	492.000	46.90
38	25025101102	2010	924.000	61.20
38	25025110103	2010	282.000	12.90
38	25025110201	2010	214.000	26.30
38	25025110301	2010	75.000	8.40
38	25025110401	2010	181.000	14.10
38	25025110403	2010	152.000	9.10
38	25025110501	2010	70.000	5.40
38	25025110502	2010	152.000	9.60
38	25025110601	2010	14.000	1.10
38	25025110607	2010	83.000	4.00
38	25025120103	2010	11.000	1.70
38	25025120104	2010	50.000	5.00
38	25025120105	2010	3.000	0.30
38	25025120201	2010	205.000	12.40
38	25025120301	2010	159.000	8.90
38	25025120400	2010	146.000	5.40
38	25025120500	2010	59.000	6.90
38	25025120600	2010	20.000	1.90
38	25025120700	2010	38.000	3.90
38	25025130100	2010	46.000	1.70
38	25025130200	2010	30.000	1.60
38	25025130300	2010	27.000	1.50
38	25025130402	2010	47.000	2.20
38	25025130404	2010	72.000	5.70
38	25025130406	2010	723.000	34.20
38	25025140102	2010	186.000	12.00
38	25025140105	2010	151.000	11.90
38	25025140106	2010	373.000	47.20
38	25025140107	2010	131.000	13.40
38	25025140201	2010	150.000	17.40
38	25025140202	2010	230.000	11.80
38	25025140300	2010	681.000	28.90
38	25025140400	2010	739.000	26.90
38	25025160101	2010	94.000	4.70
38	25025160200	2010	68.000	5.80
38	25025160300	2010	61.000	5.10
38	25025160400	2010	96.000	10.20
38	25025160501	2010	117.000	6.30
38	25025160502	2010	68.000	4.60
38	25025160601	2010	107.000	7.30
38	25025160602	2010	92.000	5.50
38	25025170100	2010	70.000	2.50
38	25025170200	2010	37.000	2.10
38	25025170300	2010	150.000	4.20
38	25025170400	2010	95.000	4.30
38	25025170501	2010	41.000	2.50
38	25025170502	2010	14.000	1.00
38	25025170601	2010	21.000	1.10
38	25025170701	2010	24.000	2.50
38	25025170702	2010	100.000	4.70
38	25025170800	2010	56.000	2.70
38	25025180101	2010	27.000	1.20
38	25025180200	2010	12.000	0.70
38	25025180301	2010	5.000	0.40
38	25025180400	2010	8.000	1.10
38	25025180500	2010	28.000	1.50
38	25025980101	2010	0.000	\N
38	25025980300	2010	0.000	0.00
38	25025980700	2010	0.000	0.00
38	25025981000	2010	2.000	40.00
38	25025981100	2010	50.000	58.80
38	25025981201	2010	0.000	\N
38	25025981202	2010	0.000	\N
38	25025981300	2010	5.000	2.10
38	25025981501	2010	0.000	\N
38	25025981502	2010	0.000	0.00
38	25025981600	2010	0.000	\N
38	25025981700	2010	0.000	\N
38	25025981800	2010	1.000	2.20
38	25025990101	2010	0.000	\N
39	25025000401	2010	0.000	0.00
39	25025000402	2010	0.000	0.00
39	25025000100	2010	0.000	0.00
39	25025000201	2010	1.000	0.10
39	25025000202	2010	4.000	0.30
39	25025000301	2010	0.000	0.00
39	25025000302	2010	1.000	0.10
39	25025000502	2010	2.000	0.10
39	25025000503	2010	1.000	0.10
39	25025000504	2010	4.000	0.20
39	25025000601	2010	2.000	0.10
39	25025000602	2010	0.000	0.00
39	25025000701	2010	2.000	0.10
39	25025000703	2010	1.000	0.10
39	25025000704	2010	2.000	0.10
39	25025000802	2010	5.000	0.20
39	25025000803	2010	2.000	0.20
39	25025010103	2010	0.000	0.00
39	25025010104	2010	3.000	0.20
39	25025010203	2010	8.000	0.20
39	25025010204	2010	1.000	0.10
39	25025010300	2010	0.000	0.00
39	25025010403	2010	8.000	0.40
39	25025010404	2010	3.000	0.20
39	25025010405	2010	6.000	0.60
39	25025010408	2010	1.000	0.10
39	25025010500	2010	3.000	0.20
39	25025010600	2010	1.000	0.10
39	25025010701	2010	1.000	0.10
39	25025010702	2010	0.000	0.00
39	25025010801	2010	1.000	0.10
39	25025010802	2010	0.000	0.00
39	25025020101	2010	0.000	0.00
39	25025020200	2010	1.000	0.00
39	25025020301	2010	2.000	0.20
39	25025020302	2010	0.000	0.00
39	25025020303	2010	2.000	0.10
39	25025030100	2010	0.000	0.00
39	25025030200	2010	4.000	0.40
39	25025030300	2010	3.000	0.10
39	25025030400	2010	2.000	0.10
39	25025030500	2010	0.000	0.00
39	25025040100	2010	0.000	0.00
39	25025040200	2010	1.000	0.20
39	25025040300	2010	0.000	0.00
39	25025040401	2010	1.000	0.10
39	25025040600	2010	0.000	0.00
39	25025040801	2010	1.000	0.10
39	25025050101	2010	5.000	0.30
39	25025050200	2010	1.000	0.10
39	25025050300	2010	1.000	0.10
39	25025050400	2010	0.000	0.00
39	25025050500	2010	0.000	0.00
39	25025050600	2010	1.000	0.10
39	25025050700	2010	2.000	0.10
39	25025050901	2010	0.000	0.00
39	25025051000	2010	1.000	0.10
39	25025051101	2010	1.000	0.00
39	25025051200	2010	2.000	0.20
39	25025060101	2010	1.000	0.10
39	25025060200	2010	0.000	0.00
39	25025060301	2010	1.000	0.10
39	25025060400	2010	3.000	0.10
39	25025060501	2010	1.000	0.10
39	25025060600	2010	2.000	0.10
39	25025060700	2010	1.000	0.20
39	25025060800	2010	0.000	0.00
39	25025061000	2010	3.000	0.20
39	25025061101	2010	4.000	0.40
39	25025061200	2010	0.000	0.00
39	25025070101	2010	0.000	0.00
39	25025070200	2010	2.000	0.10
39	25025070300	2010	2.000	0.10
39	25025070402	2010	2.000	0.30
39	25025070500	2010	4.000	0.10
39	25025070600	2010	0.000	0.00
39	25025070700	2010	5.000	0.40
39	25025070800	2010	1.000	0.00
39	25025070900	2010	5.000	0.30
39	25025071101	2010	6.000	0.30
39	25025071201	2010	1.000	0.10
39	25025080100	2010	0.000	0.00
39	25025080300	2010	7.000	1.00
39	25025080401	2010	8.000	0.70
39	25025080500	2010	1.000	0.10
39	25025080601	2010	4.000	0.50
39	25025080801	2010	6.000	0.60
39	25025080900	2010	3.000	0.20
39	25025081001	2010	9.000	0.40
39	25025081100	2010	2.000	0.10
39	25025081200	2010	2.000	0.20
39	25025081300	2010	14.000	0.70
39	25025081400	2010	4.000	0.30
39	25025081500	2010	4.000	0.50
39	25025081700	2010	10.000	0.70
39	25025081800	2010	5.000	0.40
39	25025081900	2010	9.000	0.70
39	25025082000	2010	3.000	0.30
39	25025082100	2010	7.000	0.30
39	25025090100	2010	6.000	0.40
39	25025090200	2010	3.000	0.40
39	25025090300	2010	3.000	0.30
39	25025090400	2010	4.000	0.30
39	25025090600	2010	1.000	0.10
39	25025090700	2010	4.000	0.20
39	25025090901	2010	4.000	0.30
39	25025091001	2010	0.000	0.00
39	25025091100	2010	5.000	0.30
39	25025091200	2010	2.000	0.20
39	25025091300	2010	3.000	0.40
39	25025091400	2010	2.000	0.20
39	25025091500	2010	2.000	0.10
39	25025091600	2010	1.000	0.10
39	25025091700	2010	2.000	0.20
39	25025091800	2010	3.000	0.30
39	25025091900	2010	8.000	0.60
39	25025092000	2010	2.000	0.10
39	25025092101	2010	9.000	0.40
39	25025092200	2010	5.000	0.40
39	25025092300	2010	2.000	0.20
39	25025092400	2010	9.000	0.50
39	25025100100	2010	6.000	0.30
39	25025100200	2010	0.000	0.00
39	25025100300	2010	2.000	0.20
39	25025100400	2010	2.000	0.10
39	25025100500	2010	4.000	0.20
39	25025100601	2010	2.000	0.10
39	25025100603	2010	0.000	0.00
39	25025100700	2010	0.000	0.00
39	25025100800	2010	4.000	0.20
39	25025100900	2010	0.000	0.00
39	25025101001	2010	5.000	0.20
39	25025101002	2010	5.000	0.30
39	25025101101	2010	1.000	0.10
39	25025101102	2010	5.000	0.30
39	25025110103	2010	4.000	0.20
39	25025110201	2010	3.000	0.40
39	25025110301	2010	2.000	0.20
39	25025110401	2010	2.000	0.20
39	25025110403	2010	2.000	0.10
39	25025110501	2010	1.000	0.10
39	25025110502	2010	0.000	0.00
39	25025110601	2010	0.000	0.00
39	25025110607	2010	2.000	0.10
39	25025120103	2010	1.000	0.20
39	25025120104	2010	0.000	0.00
39	25025120105	2010	0.000	0.00
39	25025120201	2010	2.000	0.10
39	25025120301	2010	2.000	0.10
39	25025120400	2010	4.000	0.10
39	25025120500	2010	1.000	0.10
39	25025120600	2010	0.000	0.00
39	25025120700	2010	0.000	0.00
39	25025130100	2010	1.000	0.00
39	25025130200	2010	2.000	0.10
39	25025130300	2010	1.000	0.10
39	25025130402	2010	1.000	0.00
39	25025130404	2010	0.000	0.00
39	25025130406	2010	3.000	0.10
39	25025140102	2010	1.000	0.10
39	25025140105	2010	0.000	0.00
39	25025140106	2010	3.000	0.40
39	25025140107	2010	2.000	0.20
39	25025140201	2010	2.000	0.20
39	25025140202	2010	4.000	0.20
39	25025140300	2010	4.000	0.20
39	25025140400	2010	6.000	0.20
39	25025160101	2010	3.000	0.10
39	25025160200	2010	0.000	0.00
39	25025160300	2010	2.000	0.20
39	25025160400	2010	0.000	0.00
39	25025160501	2010	4.000	0.20
39	25025160502	2010	2.000	0.10
39	25025160601	2010	3.000	0.20
39	25025160602	2010	2.000	0.10
39	25025170100	2010	1.000	0.00
39	25025170200	2010	2.000	0.10
39	25025170300	2010	3.000	0.10
39	25025170400	2010	4.000	0.20
39	25025170501	2010	1.000	0.10
39	25025170502	2010	0.000	0.00
39	25025170601	2010	2.000	0.10
39	25025170701	2010	1.000	0.10
39	25025170702	2010	4.000	0.20
39	25025170800	2010	2.000	0.10
39	25025180101	2010	2.000	0.10
39	25025180200	2010	1.000	0.10
39	25025180301	2010	0.000	0.00
39	25025180400	2010	1.000	0.10
39	25025180500	2010	3.000	0.20
39	25025980101	2010	0.000	\N
39	25025980300	2010	0.000	0.00
39	25025980700	2010	0.000	0.00
39	25025981000	2010	0.000	0.00
39	25025981100	2010	0.000	0.00
39	25025981201	2010	0.000	\N
39	25025981202	2010	0.000	\N
39	25025981300	2010	0.000	0.00
39	25025981501	2010	0.000	\N
39	25025981502	2010	0.000	0.00
39	25025981600	2010	0.000	\N
39	25025981700	2010	0.000	\N
39	25025981800	2010	0.000	0.00
39	25025990101	2010	0.000	\N
40	25025000401	2010	393.000	13.70
40	25025000402	2010	96.000	6.60
40	25025000100	2010	85.000	5.30
40	25025000201	2010	53.000	3.40
40	25025000202	2010	77.000	5.20
40	25025000301	2010	47.000	4.10
40	25025000302	2010	59.000	4.60
40	25025000502	2010	162.000	8.70
40	25025000503	2010	97.000	7.20
40	25025000504	2010	185.000	7.00
40	25025000601	2010	99.000	6.80
40	25025000602	2010	262.000	13.30
40	25025000701	2010	247.000	10.80
40	25025000703	2010	339.000	24.30
40	25025000704	2010	290.000	12.30
40	25025000802	2010	476.000	15.80
40	25025000803	2010	271.000	30.70
40	25025010103	2010	119.000	24.30
40	25025010104	2010	282.000	14.70
40	25025010203	2010	530.000	15.10
40	25025010204	2010	217.000	18.30
40	25025010300	2010	38.000	9.60
40	25025010403	2010	378.000	18.70
40	25025010404	2010	316.000	17.50
40	25025010405	2010	146.000	15.10
40	25025010408	2010	127.000	13.50
40	25025010500	2010	209.000	12.60
40	25025010600	2010	196.000	10.60
40	25025010701	2010	89.000	6.40
40	25025010702	2010	52.000	3.70
40	25025010801	2010	78.000	4.70
40	25025010802	2010	127.000	6.80
40	25025020101	2010	78.000	3.20
40	25025020200	2010	129.000	5.60
40	25025020301	2010	221.000	17.70
40	25025020302	2010	33.000	4.90
40	25025020303	2010	143.000	8.80
40	25025030100	2010	15.000	1.20
40	25025030200	2010	16.000	1.50
40	25025030300	2010	122.000	4.90
40	25025030400	2010	32.000	2.10
40	25025030500	2010	27.000	1.90
40	25025040100	2010	13.000	1.10
40	25025040200	2010	49.000	7.40
40	25025040300	2010	38.000	2.00
40	25025040401	2010	55.000	4.70
40	25025040600	2010	21.000	1.70
40	25025040801	2010	216.000	11.50
40	25025050101	2010	60.000	3.50
40	25025050200	2010	21.000	1.20
40	25025050300	2010	89.000	9.10
40	25025050400	2010	12.000	1.20
40	25025050500	2010	11.000	1.70
40	25025050600	2010	12.000	1.60
40	25025050700	2010	17.000	1.20
40	25025050901	2010	20.000	1.50
40	25025051000	2010	29.000	1.70
40	25025051101	2010	45.000	2.10
40	25025051200	2010	13.000	1.30
40	25025060101	2010	4.000	0.30
40	25025060200	2010	1.000	0.10
40	25025060301	2010	5.000	0.30
40	25025060400	2010	24.000	1.00
40	25025060501	2010	16.000	0.90
40	25025060600	2010	54.000	3.90
40	25025060700	2010	56.000	9.10
40	25025060800	2010	29.000	1.40
40	25025061000	2010	97.000	7.80
40	25025061101	2010	123.000	12.50
40	25025061200	2010	33.000	1.90
40	25025070101	2010	743.000	25.80
40	25025070200	2010	1153.000	75.20
40	25025070300	2010	244.000	10.00
40	25025070402	2010	441.000	66.20
40	25025070500	2010	292.000	10.10
40	25025070600	2010	37.000	3.10
40	25025070700	2010	69.000	5.60
40	25025070800	2010	111.000	5.40
40	25025070900	2010	114.000	6.60
40	25025071101	2010	352.000	16.90
40	25025071201	2010	100.000	7.70
40	25025080100	2010	4.000	0.60
40	25025080300	2010	4.000	0.60
40	25025080401	2010	21.000	1.70
40	25025080500	2010	33.000	2.60
40	25025080601	2010	38.000	4.30
40	25025080801	2010	100.000	10.80
40	25025080900	2010	263.000	15.60
40	25025081001	2010	375.000	16.80
40	25025081100	2010	135.000	8.00
40	25025081200	2010	20.000	1.80
40	25025081300	2010	13.000	0.60
40	25025081400	2010	14.000	1.10
40	25025081500	2010	5.000	0.60
40	25025081700	2010	10.000	0.70
40	25025081800	2010	1.000	0.10
40	25025081900	2010	3.000	0.20
40	25025082000	2010	3.000	0.30
40	25025082100	2010	9.000	0.40
40	25025090100	2010	10.000	0.60
40	25025090200	2010	2.000	0.30
40	25025090300	2010	4.000	0.40
40	25025090400	2010	5.000	0.40
40	25025090600	2010	8.000	1.10
40	25025090700	2010	169.000	9.20
40	25025090901	2010	302.000	19.60
40	25025091001	2010	98.000	7.90
40	25025091100	2010	218.000	12.20
40	25025091200	2010	48.000	4.10
40	25025091300	2010	11.000	1.40
40	25025091400	2010	1.000	0.10
40	25025091500	2010	38.000	2.60
40	25025091600	2010	183.000	17.50
40	25025091700	2010	19.000	2.10
40	25025091800	2010	9.000	0.90
40	25025091900	2010	4.000	0.30
40	25025092000	2010	69.000	4.50
40	25025092101	2010	319.000	14.20
40	25025092200	2010	65.000	5.70
40	25025092300	2010	4.000	0.40
40	25025092400	2010	6.000	0.30
40	25025100100	2010	11.000	0.60
40	25025100200	2010	3.000	0.30
40	25025100300	2010	3.000	0.30
40	25025100400	2010	32.000	1.90
40	25025100500	2010	109.000	5.00
40	25025100601	2010	135.000	6.70
40	25025100603	2010	17.000	2.30
40	25025100700	2010	16.000	0.90
40	25025100800	2010	94.000	3.70
40	25025100900	2010	36.000	2.20
40	25025101001	2010	2.000	0.10
40	25025101002	2010	16.000	0.80
40	25025101101	2010	1.000	0.10
40	25025101102	2010	3.000	0.20
40	25025110103	2010	57.000	2.60
40	25025110201	2010	6.000	0.70
40	25025110301	2010	8.000	0.90
40	25025110401	2010	10.000	0.80
40	25025110403	2010	3.000	0.20
40	25025110501	2010	5.000	0.40
40	25025110502	2010	10.000	0.60
40	25025110601	2010	4.000	0.30
40	25025110607	2010	12.000	0.60
40	25025120103	2010	4.000	0.60
40	25025120104	2010	22.000	2.20
40	25025120105	2010	5.000	0.60
40	25025120201	2010	33.000	2.00
40	25025120301	2010	24.000	1.30
40	25025120400	2010	46.000	1.70
40	25025120500	2010	14.000	1.60
40	25025120600	2010	19.000	1.80
40	25025120700	2010	45.000	4.60
40	25025130100	2010	108.000	4.00
40	25025130200	2010	16.000	0.90
40	25025130300	2010	15.000	0.90
40	25025130402	2010	34.000	1.60
40	25025130404	2010	13.000	1.00
40	25025130406	2010	34.000	1.60
40	25025140102	2010	5.000	0.30
40	25025140105	2010	1.000	0.10
40	25025140106	2010	14.000	1.80
40	25025140107	2010	2.000	0.20
40	25025140201	2010	8.000	0.90
40	25025140202	2010	10.000	0.50
40	25025140300	2010	9.000	0.40
40	25025140400	2010	10.000	0.40
40	25025160101	2010	22.000	1.10
40	25025160200	2010	15.000	1.30
40	25025160300	2010	13.000	1.10
40	25025160400	2010	19.000	2.00
40	25025160501	2010	27.000	1.40
40	25025160502	2010	24.000	1.60
40	25025160601	2010	46.000	3.10
40	25025160602	2010	30.000	1.80
40	25025170100	2010	33.000	1.20
40	25025170200	2010	28.000	1.60
40	25025170300	2010	116.000	3.20
40	25025170400	2010	44.000	2.00
40	25025170501	2010	40.000	2.40
40	25025170502	2010	7.000	0.50
40	25025170601	2010	18.000	1.00
40	25025170701	2010	12.000	1.20
40	25025170702	2010	172.000	8.00
40	25025170800	2010	16.000	0.80
40	25025180101	2010	10.000	0.40
40	25025180200	2010	5.000	0.30
40	25025180301	2010	1.000	0.10
40	25025180400	2010	3.000	0.40
40	25025180500	2010	12.000	0.70
40	25025980101	2010	0.000	\N
40	25025980300	2010	0.000	0.00
40	25025980700	2010	0.000	0.00
40	25025981000	2010	0.000	0.00
40	25025981100	2010	2.000	2.40
40	25025981201	2010	0.000	\N
40	25025981202	2010	0.000	\N
40	25025981300	2010	3.000	1.30
40	25025981501	2010	0.000	\N
40	25025981502	2010	0.000	0.00
40	25025981600	2010	0.000	\N
40	25025981700	2010	0.000	\N
40	25025981800	2010	0.000	0.00
40	25025990101	2010	0.000	\N
41	25025000401	2010	1.000	0.00
41	25025000402	2010	0.000	0.00
41	25025000100	2010	0.000	0.00
41	25025000201	2010	0.000	0.00
41	25025000202	2010	0.000	0.00
41	25025000301	2010	0.000	0.00
41	25025000302	2010	0.000	0.00
41	25025000502	2010	2.000	0.10
41	25025000503	2010	0.000	0.00
41	25025000504	2010	0.000	0.00
41	25025000601	2010	0.000	0.00
41	25025000602	2010	1.000	0.10
41	25025000701	2010	0.000	0.00
41	25025000703	2010	0.000	0.00
41	25025000704	2010	2.000	0.10
41	25025000802	2010	1.000	0.00
41	25025000803	2010	0.000	0.00
41	25025010103	2010	0.000	0.00
41	25025010104	2010	0.000	0.00
41	25025010203	2010	3.000	0.10
41	25025010204	2010	0.000	0.00
41	25025010300	2010	0.000	0.00
41	25025010403	2010	0.000	0.00
41	25025010404	2010	0.000	0.00
41	25025010405	2010	0.000	0.00
41	25025010408	2010	0.000	0.00
41	25025010500	2010	0.000	0.00
41	25025010600	2010	0.000	0.00
41	25025010701	2010	0.000	0.00
41	25025010702	2010	1.000	0.10
41	25025010801	2010	0.000	0.00
41	25025010802	2010	0.000	0.00
41	25025020101	2010	0.000	0.00
41	25025020200	2010	0.000	0.00
41	25025020301	2010	0.000	0.00
41	25025020302	2010	0.000	0.00
41	25025020303	2010	0.000	0.00
41	25025030100	2010	1.000	0.10
41	25025030200	2010	0.000	0.00
41	25025030300	2010	0.000	0.00
41	25025030400	2010	0.000	0.00
41	25025030500	2010	0.000	0.00
41	25025040100	2010	0.000	0.00
41	25025040200	2010	0.000	0.00
41	25025040300	2010	0.000	0.00
41	25025040401	2010	0.000	0.00
41	25025040600	2010	0.000	0.00
41	25025040801	2010	4.000	0.20
41	25025050101	2010	0.000	0.00
41	25025050200	2010	1.000	0.10
41	25025050300	2010	0.000	0.00
41	25025050400	2010	0.000	0.00
41	25025050500	2010	0.000	0.00
41	25025050600	2010	0.000	0.00
41	25025050700	2010	0.000	0.00
41	25025050901	2010	0.000	0.00
41	25025051000	2010	0.000	0.00
41	25025051101	2010	0.000	0.00
41	25025051200	2010	0.000	0.00
41	25025060101	2010	1.000	0.10
41	25025060200	2010	0.000	0.00
41	25025060301	2010	0.000	0.00
41	25025060400	2010	0.000	0.00
41	25025060501	2010	1.000	0.10
41	25025060600	2010	0.000	0.00
41	25025060700	2010	0.000	0.00
41	25025060800	2010	0.000	0.00
41	25025061000	2010	0.000	0.00
41	25025061101	2010	1.000	0.10
41	25025061200	2010	1.000	0.10
41	25025070101	2010	0.000	0.00
41	25025070200	2010	0.000	0.00
41	25025070300	2010	0.000	0.00
41	25025070402	2010	0.000	0.00
41	25025070500	2010	0.000	0.00
41	25025070600	2010	0.000	0.00
41	25025070700	2010	0.000	0.00
41	25025070800	2010	0.000	0.00
41	25025070900	2010	0.000	0.00
41	25025071101	2010	0.000	0.00
41	25025071201	2010	2.000	0.20
41	25025080100	2010	0.000	0.00
41	25025080300	2010	0.000	0.00
41	25025080401	2010	0.000	0.00
41	25025080500	2010	0.000	0.00
41	25025080601	2010	0.000	0.00
41	25025080801	2010	0.000	0.00
41	25025080900	2010	0.000	0.00
41	25025081001	2010	1.000	0.00
41	25025081100	2010	0.000	0.00
41	25025081200	2010	0.000	0.00
41	25025081300	2010	2.000	0.10
41	25025081400	2010	0.000	0.00
41	25025081500	2010	1.000	0.10
41	25025081700	2010	0.000	0.00
41	25025081800	2010	1.000	0.10
41	25025081900	2010	0.000	0.00
41	25025082000	2010	1.000	0.10
41	25025082100	2010	1.000	0.00
41	25025090100	2010	1.000	0.10
41	25025090200	2010	0.000	0.00
41	25025090300	2010	0.000	0.00
41	25025090400	2010	0.000	0.00
41	25025090600	2010	1.000	0.10
41	25025090700	2010	0.000	0.00
41	25025090901	2010	1.000	0.10
41	25025091001	2010	0.000	0.00
41	25025091100	2010	0.000	0.00
41	25025091200	2010	3.000	0.30
41	25025091300	2010	0.000	0.00
41	25025091400	2010	0.000	0.00
41	25025091500	2010	0.000	0.00
41	25025091600	2010	0.000	0.00
41	25025091700	2010	0.000	0.00
41	25025091800	2010	0.000	0.00
41	25025091900	2010	0.000	0.00
41	25025092000	2010	1.000	0.10
41	25025092101	2010	0.000	0.00
41	25025092200	2010	0.000	0.00
41	25025092300	2010	0.000	0.00
41	25025092400	2010	0.000	0.00
41	25025100100	2010	2.000	0.10
41	25025100200	2010	0.000	0.00
41	25025100300	2010	0.000	0.00
41	25025100400	2010	0.000	0.00
41	25025100500	2010	0.000	0.00
41	25025100601	2010	1.000	0.00
41	25025100603	2010	0.000	0.00
41	25025100700	2010	0.000	0.00
41	25025100800	2010	0.000	0.00
41	25025100900	2010	0.000	0.00
41	25025101001	2010	0.000	0.00
41	25025101002	2010	0.000	0.00
41	25025101101	2010	0.000	0.00
41	25025101102	2010	1.000	0.10
41	25025110103	2010	1.000	0.00
41	25025110201	2010	0.000	0.00
41	25025110301	2010	0.000	0.00
41	25025110401	2010	2.000	0.20
41	25025110403	2010	0.000	0.00
41	25025110501	2010	0.000	0.00
41	25025110502	2010	0.000	0.00
41	25025110601	2010	1.000	0.10
41	25025110607	2010	0.000	0.00
41	25025120103	2010	0.000	0.00
41	25025120104	2010	0.000	0.00
41	25025120105	2010	0.000	0.00
41	25025120201	2010	0.000	0.00
41	25025120301	2010	0.000	0.00
41	25025120400	2010	0.000	0.00
41	25025120500	2010	0.000	0.00
41	25025120600	2010	1.000	0.10
41	25025120700	2010	0.000	0.00
41	25025130100	2010	0.000	0.00
41	25025130200	2010	0.000	0.00
41	25025130300	2010	0.000	0.00
41	25025130402	2010	0.000	0.00
41	25025130404	2010	0.000	0.00
41	25025130406	2010	0.000	0.00
41	25025140102	2010	0.000	0.00
41	25025140105	2010	0.000	0.00
41	25025140106	2010	0.000	0.00
41	25025140107	2010	0.000	0.00
41	25025140201	2010	0.000	0.00
41	25025140202	2010	1.000	0.10
41	25025140300	2010	0.000	0.00
41	25025140400	2010	2.000	0.10
41	25025160101	2010	0.000	0.00
41	25025160200	2010	0.000	0.00
41	25025160300	2010	0.000	0.00
41	25025160400	2010	0.000	0.00
41	25025160501	2010	0.000	0.00
41	25025160502	2010	0.000	0.00
41	25025160601	2010	0.000	0.00
41	25025160602	2010	0.000	0.00
41	25025170100	2010	0.000	0.00
41	25025170200	2010	0.000	0.00
41	25025170300	2010	1.000	0.00
41	25025170400	2010	0.000	0.00
41	25025170501	2010	0.000	0.00
41	25025170502	2010	0.000	0.00
41	25025170601	2010	0.000	0.00
41	25025170701	2010	0.000	0.00
41	25025170702	2010	0.000	0.00
41	25025170800	2010	0.000	0.00
41	25025180101	2010	0.000	0.00
41	25025180200	2010	0.000	0.00
41	25025180301	2010	0.000	0.00
41	25025180400	2010	0.000	0.00
41	25025180500	2010	0.000	0.00
41	25025980101	2010	0.000	\N
41	25025980300	2010	0.000	0.00
41	25025980700	2010	0.000	0.00
41	25025981000	2010	0.000	0.00
41	25025981100	2010	0.000	0.00
41	25025981201	2010	0.000	\N
41	25025981202	2010	0.000	\N
41	25025981300	2010	0.000	0.00
41	25025981501	2010	0.000	\N
41	25025981502	2010	0.000	0.00
41	25025981600	2010	0.000	\N
41	25025981700	2010	0.000	\N
41	25025981800	2010	0.000	0.00
41	25025990101	2010	0.000	\N
42	25025000401	2010	10.000	0.30
42	25025000402	2010	10.000	0.70
42	25025000100	2010	59.000	3.70
42	25025000201	2010	17.000	1.10
42	25025000202	2010	14.000	0.90
42	25025000301	2010	5.000	0.40
42	25025000302	2010	6.000	0.50
42	25025000502	2010	4.000	0.20
42	25025000503	2010	5.000	0.40
42	25025000504	2010	2.000	0.10
42	25025000601	2010	35.000	2.40
42	25025000602	2010	11.000	0.60
42	25025000701	2010	16.000	0.70
42	25025000703	2010	19.000	1.40
42	25025000704	2010	24.000	1.00
42	25025000802	2010	66.000	2.20
42	25025000803	2010	8.000	0.90
42	25025010103	2010	0.000	0.00
42	25025010104	2010	5.000	0.30
42	25025010203	2010	10.000	0.30
42	25025010204	2010	1.000	0.10
42	25025010300	2010	0.000	0.00
42	25025010403	2010	3.000	0.10
42	25025010404	2010	2.000	0.10
42	25025010405	2010	3.000	0.30
42	25025010408	2010	1.000	0.10
42	25025010500	2010	6.000	0.40
42	25025010600	2010	4.000	0.20
42	25025010701	2010	7.000	0.50
42	25025010702	2010	0.000	0.00
42	25025010801	2010	2.000	0.10
42	25025010802	2010	8.000	0.40
42	25025020101	2010	3.000	0.10
42	25025020200	2010	4.000	0.20
42	25025020301	2010	2.000	0.20
42	25025020302	2010	3.000	0.40
42	25025020303	2010	2.000	0.10
42	25025030100	2010	2.000	0.20
42	25025030200	2010	1.000	0.10
42	25025030300	2010	6.000	0.20
42	25025030400	2010	3.000	0.20
42	25025030500	2010	4.000	0.30
42	25025040100	2010	0.000	0.00
42	25025040200	2010	4.000	0.60
42	25025040300	2010	0.000	0.00
42	25025040401	2010	0.000	0.00
42	25025040600	2010	1.000	0.10
42	25025040801	2010	10.000	0.50
42	25025050101	2010	9.000	0.50
42	25025050200	2010	31.000	1.80
42	25025050300	2010	10.000	1.00
42	25025050400	2010	14.000	1.40
42	25025050500	2010	15.000	2.30
42	25025050600	2010	12.000	1.60
42	25025050700	2010	45.000	3.10
42	25025050901	2010	12.000	0.90
42	25025051000	2010	7.000	0.40
42	25025051101	2010	16.000	0.70
42	25025051200	2010	15.000	1.50
42	25025060101	2010	0.000	0.00
42	25025060200	2010	0.000	0.00
42	25025060301	2010	1.000	0.10
42	25025060400	2010	0.000	0.00
42	25025060501	2010	2.000	0.10
42	25025060600	2010	3.000	0.20
42	25025060700	2010	8.000	1.30
42	25025060800	2010	1.000	0.00
42	25025061000	2010	10.000	0.80
42	25025061101	2010	5.000	0.50
42	25025061200	2010	1.000	0.10
42	25025070101	2010	2.000	0.10
42	25025070200	2010	3.000	0.20
42	25025070300	2010	7.000	0.30
42	25025070402	2010	4.000	0.60
42	25025070500	2010	7.000	0.20
42	25025070600	2010	1.000	0.10
42	25025070700	2010	6.000	0.50
42	25025070800	2010	7.000	0.30
42	25025070900	2010	5.000	0.30
42	25025071101	2010	18.000	0.90
42	25025071201	2010	6.000	0.50
42	25025080100	2010	56.000	8.20
42	25025080300	2010	4.000	0.60
42	25025080401	2010	5.000	0.40
42	25025080500	2010	2.000	0.20
42	25025080601	2010	10.000	1.10
42	25025080801	2010	1.000	0.10
42	25025080900	2010	5.000	0.30
42	25025081001	2010	7.000	0.30
42	25025081100	2010	3.000	0.20
42	25025081200	2010	5.000	0.40
42	25025081300	2010	5.000	0.20
42	25025081400	2010	4.000	0.30
42	25025081500	2010	9.000	1.10
42	25025081700	2010	11.000	0.70
42	25025081800	2010	8.000	0.70
42	25025081900	2010	13.000	1.00
42	25025082000	2010	17.000	1.50
42	25025082100	2010	16.000	0.80
42	25025090100	2010	14.000	0.80
42	25025090200	2010	11.000	1.40
42	25025090300	2010	16.000	1.40
42	25025090400	2010	30.000	2.60
42	25025090600	2010	125.000	17.40
42	25025090700	2010	15.000	0.80
42	25025090901	2010	15.000	1.00
42	25025091001	2010	8.000	0.60
42	25025091100	2010	24.000	1.30
42	25025091200	2010	65.000	5.60
42	25025091300	2010	122.000	15.40
42	25025091400	2010	47.000	5.30
42	25025091500	2010	141.000	9.60
42	25025091600	2010	54.000	5.20
42	25025091700	2010	73.000	8.00
42	25025091800	2010	88.000	8.40
42	25025091900	2010	16.000	1.30
42	25025092000	2010	44.000	2.90
42	25025092101	2010	47.000	2.10
42	25025092200	2010	16.000	1.40
42	25025092300	2010	7.000	0.70
42	25025092400	2010	9.000	0.50
42	25025100100	2010	26.000	1.40
42	25025100200	2010	10.000	1.10
42	25025100300	2010	18.000	1.60
42	25025100400	2010	16.000	0.90
42	25025100500	2010	33.000	1.50
42	25025100601	2010	35.000	1.70
42	25025100603	2010	1.000	0.10
42	25025100700	2010	4.000	0.20
42	25025100800	2010	15.000	0.60
42	25025100900	2010	12.000	0.70
42	25025101001	2010	9.000	0.40
42	25025101002	2010	14.000	0.70
42	25025101101	2010	1.000	0.10
42	25025101102	2010	0.000	0.00
42	25025110103	2010	6.000	0.30
42	25025110201	2010	5.000	0.60
42	25025110301	2010	2.000	0.20
42	25025110401	2010	4.000	0.30
42	25025110403	2010	6.000	0.40
42	25025110501	2010	1.000	0.10
42	25025110502	2010	2.000	0.10
42	25025110601	2010	0.000	0.00
42	25025110607	2010	4.000	0.20
42	25025120103	2010	1.000	0.20
42	25025120104	2010	4.000	0.40
42	25025120105	2010	1.000	0.10
42	25025120201	2010	9.000	0.50
42	25025120301	2010	3.000	0.20
42	25025120400	2010	6.000	0.20
42	25025120500	2010	3.000	0.40
42	25025120600	2010	4.000	0.40
42	25025120700	2010	0.000	0.00
42	25025130100	2010	8.000	0.30
42	25025130200	2010	3.000	0.20
42	25025130300	2010	1.000	0.10
42	25025130402	2010	6.000	0.30
42	25025130404	2010	2.000	0.20
42	25025130406	2010	8.000	0.40
42	25025140102	2010	5.000	0.30
42	25025140105	2010	7.000	0.50
42	25025140106	2010	3.000	0.40
42	25025140107	2010	0.000	0.00
42	25025140201	2010	14.000	1.60
42	25025140202	2010	4.000	0.20
42	25025140300	2010	6.000	0.30
42	25025140400	2010	4.000	0.10
42	25025160101	2010	18.000	0.90
42	25025160200	2010	6.000	0.50
42	25025160300	2010	2.000	0.20
42	25025160400	2010	6.000	0.60
42	25025160501	2010	9.000	0.50
42	25025160502	2010	10.000	0.70
42	25025160601	2010	25.000	1.70
42	25025160602	2010	30.000	1.80
42	25025170100	2010	27.000	0.90
42	25025170200	2010	11.000	0.60
42	25025170300	2010	37.000	1.00
42	25025170400	2010	29.000	1.30
42	25025170501	2010	11.000	0.70
42	25025170502	2010	0.000	0.00
42	25025170601	2010	14.000	0.70
42	25025170701	2010	4.000	0.40
42	25025170702	2010	40.000	1.90
42	25025170800	2010	11.000	0.50
42	25025180101	2010	6.000	0.30
42	25025180200	2010	6.000	0.40
42	25025180301	2010	3.000	0.30
42	25025180400	2010	5.000	0.70
42	25025180500	2010	5.000	0.30
42	25025980101	2010	0.000	\N
42	25025980300	2010	0.000	0.00
42	25025980700	2010	0.000	0.00
42	25025981000	2010	0.000	0.00
42	25025981100	2010	1.000	1.20
42	25025981201	2010	0.000	\N
42	25025981202	2010	0.000	\N
42	25025981300	2010	0.000	0.00
42	25025981501	2010	0.000	\N
42	25025981502	2010	0.000	0.00
42	25025981600	2010	0.000	\N
42	25025981700	2010	0.000	\N
42	25025981800	2010	0.000	0.00
42	25025990101	2010	0.000	\N
43	25025000401	2010	36.000	1.30
43	25025000402	2010	22.000	1.50
43	25025000100	2010	31.000	1.90
43	25025000201	2010	23.000	1.50
43	25025000202	2010	11.000	0.70
43	25025000301	2010	8.000	0.70
43	25025000302	2010	13.000	1.00
43	25025000502	2010	24.000	1.30
43	25025000503	2010	16.000	1.20
43	25025000504	2010	32.000	1.20
43	25025000601	2010	25.000	1.70
43	25025000602	2010	46.000	2.30
43	25025000701	2010	52.000	2.30
43	25025000703	2010	43.000	3.10
43	25025000704	2010	50.000	2.10
43	25025000802	2010	78.000	2.60
43	25025000803	2010	36.000	4.10
43	25025010103	2010	15.000	3.10
43	25025010104	2010	30.000	1.60
43	25025010203	2010	91.000	2.60
43	25025010204	2010	20.000	1.70
43	25025010300	2010	9.000	2.30
43	25025010403	2010	51.000	2.50
43	25025010404	2010	41.000	2.30
43	25025010405	2010	33.000	3.40
43	25025010408	2010	12.000	1.30
43	25025010500	2010	23.000	1.40
43	25025010600	2010	19.000	1.00
43	25025010701	2010	16.000	1.10
43	25025010702	2010	13.000	0.90
43	25025010801	2010	12.000	0.70
43	25025010802	2010	20.000	1.10
43	25025020101	2010	16.000	0.60
43	25025020200	2010	37.000	1.60
43	25025020301	2010	15.000	1.20
43	25025020302	2010	8.000	1.20
43	25025020303	2010	25.000	1.50
43	25025030100	2010	4.000	0.30
43	25025030200	2010	10.000	1.00
43	25025030300	2010	26.000	1.10
43	25025030400	2010	14.000	0.90
43	25025030500	2010	12.000	0.80
43	25025040100	2010	3.000	0.30
43	25025040200	2010	8.000	1.20
43	25025040300	2010	5.000	0.30
43	25025040401	2010	6.000	0.50
43	25025040600	2010	2.000	0.20
43	25025040801	2010	22.000	1.20
43	25025050101	2010	27.000	1.60
43	25025050200	2010	27.000	1.60
43	25025050300	2010	17.000	1.70
43	25025050400	2010	13.000	1.30
43	25025050500	2010	9.000	1.40
43	25025050600	2010	13.000	1.70
43	25025050700	2010	14.000	1.00
43	25025050901	2010	8.000	0.60
43	25025051000	2010	16.000	1.00
43	25025051101	2010	16.000	0.70
43	25025051200	2010	10.000	1.00
43	25025060101	2010	2.000	0.10
43	25025060200	2010	4.000	0.40
43	25025060301	2010	5.000	0.30
43	25025060400	2010	12.000	0.50
43	25025060501	2010	9.000	0.50
43	25025060600	2010	15.000	1.10
43	25025060700	2010	18.000	2.90
43	25025060800	2010	8.000	0.40
43	25025061000	2010	18.000	1.50
43	25025061101	2010	16.000	1.60
43	25025061200	2010	4.000	0.20
43	25025070101	2010	35.000	1.20
43	25025070200	2010	11.000	0.70
43	25025070300	2010	29.000	1.20
43	25025070402	2010	10.000	1.50
43	25025070500	2010	29.000	1.00
43	25025070600	2010	9.000	0.70
43	25025070700	2010	29.000	2.30
43	25025070800	2010	35.000	1.70
43	25025070900	2010	24.000	1.40
43	25025071101	2010	38.000	1.80
43	25025071201	2010	13.000	1.00
43	25025080100	2010	42.000	6.20
43	25025080300	2010	12.000	1.70
43	25025080401	2010	23.000	1.90
43	25025080500	2010	22.000	1.70
43	25025080601	2010	15.000	1.70
43	25025080801	2010	17.000	1.80
43	25025080900	2010	29.000	1.70
43	25025081001	2010	52.000	2.30
43	25025081100	2010	18.000	1.10
43	25025081200	2010	14.000	1.20
43	25025081300	2010	32.000	1.60
43	25025081400	2010	24.000	1.80
43	25025081500	2010	15.000	1.80
43	25025081700	2010	38.000	2.60
43	25025081800	2010	20.000	1.80
43	25025081900	2010	24.000	1.90
43	25025082000	2010	20.000	1.70
43	25025082100	2010	41.000	2.00
43	25025090100	2010	25.000	1.50
43	25025090200	2010	11.000	1.40
43	25025090300	2010	32.000	2.80
43	25025090400	2010	31.000	2.70
43	25025090600	2010	34.000	4.70
43	25025090700	2010	28.000	1.50
43	25025090901	2010	26.000	1.70
43	25025091001	2010	22.000	1.80
43	25025091100	2010	31.000	1.70
43	25025091200	2010	37.000	3.20
43	25025091300	2010	29.000	3.70
43	25025091400	2010	33.000	3.80
43	25025091500	2010	83.000	5.60
43	25025091600	2010	29.000	2.80
43	25025091700	2010	33.000	3.60
43	25025091800	2010	48.000	4.60
43	25025091900	2010	26.000	2.10
43	25025092000	2010	40.000	2.60
43	25025092101	2010	42.000	1.90
43	25025092200	2010	29.000	2.60
43	25025092300	2010	19.000	2.00
43	25025092400	2010	41.000	2.20
43	25025100100	2010	35.000	1.80
43	25025100200	2010	18.000	2.00
43	25025100300	2010	15.000	1.30
43	25025100400	2010	38.000	2.20
43	25025100500	2010	54.000	2.50
43	25025100601	2010	26.000	1.30
43	25025100603	2010	8.000	1.10
43	25025100700	2010	8.000	0.40
43	25025100800	2010	49.000	1.90
43	25025100900	2010	17.000	1.10
43	25025101001	2010	37.000	1.70
43	25025101002	2010	29.000	1.50
43	25025101101	2010	24.000	2.30
43	25025101102	2010	30.000	2.00
43	25025110103	2010	36.000	1.60
43	25025110201	2010	4.000	0.50
43	25025110301	2010	7.000	0.80
43	25025110401	2010	11.000	0.90
43	25025110403	2010	10.000	0.60
43	25025110501	2010	13.000	1.00
43	25025110502	2010	12.000	0.80
43	25025110601	2010	0.000	0.00
43	25025110607	2010	20.000	1.00
43	25025120103	2010	8.000	1.20
43	25025120104	2010	13.000	1.30
43	25025120105	2010	2.000	0.20
43	25025120201	2010	25.000	1.50
43	25025120301	2010	18.000	1.00
43	25025120400	2010	38.000	1.40
43	25025120500	2010	11.000	1.30
43	25025120600	2010	15.000	1.40
43	25025120700	2010	7.000	0.70
43	25025130100	2010	12.000	0.40
43	25025130200	2010	4.000	0.20
43	25025130300	2010	10.000	0.60
43	25025130402	2010	6.000	0.30
43	25025130404	2010	9.000	0.70
43	25025130406	2010	23.000	1.10
43	25025140102	2010	12.000	0.80
43	25025140105	2010	6.000	0.50
43	25025140106	2010	10.000	1.30
43	25025140107	2010	6.000	0.60
43	25025140201	2010	10.000	1.20
43	25025140202	2010	16.000	0.80
43	25025140300	2010	19.000	0.80
43	25025140400	2010	23.000	0.80
43	25025160101	2010	10.000	0.50
43	25025160200	2010	10.000	0.80
43	25025160300	2010	18.000	1.50
43	25025160400	2010	10.000	1.10
43	25025160501	2010	28.000	1.50
43	25025160502	2010	25.000	1.70
43	25025160601	2010	19.000	1.30
43	25025160602	2010	9.000	0.50
43	25025170100	2010	19.000	0.70
43	25025170200	2010	10.000	0.60
43	25025170300	2010	33.000	0.90
43	25025170400	2010	22.000	1.00
43	25025170501	2010	16.000	1.00
43	25025170502	2010	10.000	0.70
43	25025170601	2010	13.000	0.70
43	25025170701	2010	12.000	1.20
43	25025170702	2010	23.000	1.10
43	25025170800	2010	27.000	1.30
43	25025180101	2010	13.000	0.60
43	25025180200	2010	11.000	0.70
43	25025180301	2010	3.000	0.30
43	25025180400	2010	6.000	0.80
43	25025180500	2010	11.000	0.60
43	25025980101	2010	0.000	\N
43	25025980300	2010	0.000	0.00
43	25025980700	2010	0.000	0.00
43	25025981000	2010	1.000	20.00
43	25025981100	2010	2.000	2.40
43	25025981201	2010	0.000	\N
43	25025981202	2010	0.000	\N
43	25025981300	2010	5.000	2.10
43	25025981501	2010	0.000	\N
43	25025981502	2010	0.000	0.00
43	25025981600	2010	0.000	\N
43	25025981700	2010	0.000	\N
43	25025981800	2010	0.000	0.00
43	25025990101	2010	0.000	\N
44	25025000401	2010	92.000	3.20
44	25025000402	2010	42.000	2.90
44	25025000100	2010	142.000	8.80
44	25025000201	2010	103.000	6.70
44	25025000202	2010	156.000	10.50
44	25025000301	2010	56.000	4.80
44	25025000302	2010	28.000	2.20
44	25025000502	2010	90.000	4.80
44	25025000503	2010	39.000	2.90
44	25025000504	2010	125.000	4.70
44	25025000601	2010	75.000	5.20
44	25025000602	2010	235.000	11.90
44	25025000701	2010	142.000	6.20
44	25025000703	2010	77.000	5.50
44	25025000704	2010	226.000	9.60
44	25025000802	2010	356.000	11.80
44	25025000803	2010	91.000	10.30
44	25025010103	2010	27.000	5.50
44	25025010104	2010	118.000	6.20
44	25025010203	2010	312.000	8.90
44	25025010204	2010	48.000	4.00
44	25025010300	2010	103.000	26.10
44	25025010403	2010	169.000	8.30
44	25025010404	2010	127.000	7.00
44	25025010405	2010	100.000	10.40
44	25025010408	2010	72.000	7.60
44	25025010500	2010	129.000	7.80
44	25025010600	2010	86.000	4.60
44	25025010701	2010	60.000	4.30
44	25025010702	2010	38.000	2.70
44	25025010801	2010	50.000	3.00
44	25025010802	2010	40.000	2.10
44	25025020101	2010	60.000	2.40
44	25025020200	2010	91.000	4.00
44	25025020301	2010	43.000	3.40
44	25025020302	2010	23.000	3.40
44	25025020303	2010	76.000	4.70
44	25025030100	2010	38.000	3.00
44	25025030200	2010	27.000	2.60
44	25025030300	2010	74.000	3.00
44	25025030400	2010	42.000	2.80
44	25025030500	2010	43.000	3.00
44	25025040100	2010	14.000	1.20
44	25025040200	2010	108.000	16.30
44	25025040300	2010	120.000	6.30
44	25025040401	2010	33.000	2.80
44	25025040600	2010	26.000	2.10
44	25025040801	2010	203.000	10.80
44	25025050101	2010	704.000	41.10
44	25025050200	2010	751.000	44.30
44	25025050300	2010	325.000	33.40
44	25025050400	2010	308.000	31.90
44	25025050500	2010	245.000	37.20
44	25025050600	2010	359.000	48.10
44	25025050700	2010	634.000	43.60
44	25025050901	2010	509.000	38.40
44	25025051000	2010	364.000	21.80
44	25025051101	2010	511.000	23.30
44	25025051200	2010	200.000	19.60
44	25025060101	2010	10.000	0.60
44	25025060200	2010	2.000	0.20
44	25025060301	2010	7.000	0.50
44	25025060400	2010	23.000	1.00
44	25025060501	2010	18.000	1.00
44	25025060600	2010	34.000	2.50
44	25025060700	2010	276.000	44.70
44	25025060800	2010	25.000	1.20
44	25025061000	2010	299.000	24.10
44	25025061101	2010	341.000	34.70
44	25025061200	2010	43.000	2.50
44	25025070101	2010	107.000	3.70
44	25025070200	2010	31.000	2.00
44	25025070300	2010	65.000	2.70
44	25025070402	2010	57.000	8.60
44	25025070500	2010	455.000	15.70
44	25025070600	2010	38.000	3.10
44	25025070700	2010	70.000	5.70
44	25025070800	2010	157.000	7.70
44	25025070900	2010	265.000	15.30
44	25025071101	2010	200.000	9.60
44	25025071201	2010	251.000	19.20
44	25025080100	2010	128.000	18.80
44	25025080300	2010	144.000	20.80
44	25025080401	2010	393.000	32.10
44	25025080500	2010	509.000	40.10
44	25025080601	2010	227.000	25.70
44	25025080801	2010	434.000	46.80
44	25025080900	2010	115.000	6.80
44	25025081001	2010	376.000	16.80
44	25025081100	2010	189.000	11.20
44	25025081200	2010	501.000	44.50
44	25025081300	2010	759.000	37.90
44	25025081400	2010	182.000	14.00
44	25025081500	2010	134.000	16.00
44	25025081700	2010	216.000	14.70
44	25025081800	2010	232.000	20.40
44	25025081900	2010	243.000	19.30
44	25025082000	2010	164.000	14.20
44	25025082100	2010	608.000	29.90
44	25025090100	2010	306.000	18.20
44	25025090200	2010	245.000	31.70
44	25025090300	2010	291.000	25.90
44	25025090400	2010	271.000	23.60
44	25025090600	2010	107.000	14.90
44	25025090700	2010	101.000	5.50
44	25025090901	2010	271.000	17.60
44	25025091001	2010	78.000	6.30
44	25025091100	2010	108.000	6.00
44	25025091200	2010	169.000	14.60
44	25025091300	2010	143.000	18.10
44	25025091400	2010	221.000	25.10
44	25025091500	2010	229.000	15.60
44	25025091600	2010	116.000	11.10
44	25025091700	2010	125.000	13.60
44	25025091800	2010	131.000	12.60
44	25025091900	2010	191.000	15.40
44	25025092000	2010	217.000	14.20
44	25025092101	2010	173.000	7.70
44	25025092200	2010	86.000	7.60
44	25025092300	2010	104.000	10.90
44	25025092400	2010	449.000	24.00
44	25025100100	2010	438.000	23.10
44	25025100200	2010	99.000	10.90
44	25025100300	2010	75.000	6.70
44	25025100400	2010	92.000	5.40
44	25025100500	2010	255.000	11.70
44	25025100601	2010	120.000	5.90
44	25025100603	2010	25.000	3.30
44	25025100700	2010	24.000	1.30
44	25025100800	2010	112.000	4.40
44	25025100900	2010	78.000	4.80
44	25025101001	2010	182.000	8.60
44	25025101002	2010	181.000	9.20
44	25025101101	2010	110.000	10.50
44	25025101102	2010	125.000	8.30
44	25025110103	2010	434.000	19.90
44	25025110201	2010	178.000	21.80
44	25025110301	2010	90.000	10.00
44	25025110401	2010	282.000	21.90
44	25025110403	2010	157.000	9.40
44	25025110501	2010	90.000	6.90
44	25025110502	2010	203.000	12.80
44	25025110601	2010	13.000	1.10
44	25025110607	2010	113.000	5.40
44	25025120103	2010	11.000	1.70
44	25025120104	2010	108.000	10.80
44	25025120105	2010	5.000	0.60
44	25025120201	2010	272.000	16.40
44	25025120301	2010	408.000	22.90
44	25025120400	2010	179.000	6.60
44	25025120500	2010	301.000	35.30
44	25025120600	2010	66.000	6.30
44	25025120700	2010	93.000	9.50
44	25025130100	2010	35.000	1.30
44	25025130200	2010	36.000	2.00
44	25025130300	2010	43.000	2.40
44	25025130402	2010	66.000	3.10
44	25025130404	2010	83.000	6.60
44	25025130406	2010	348.000	16.50
44	25025140102	2010	98.000	6.30
44	25025140105	2010	114.000	8.90
44	25025140106	2010	192.000	24.30
44	25025140107	2010	121.000	12.40
44	25025140201	2010	71.000	8.20
44	25025140202	2010	177.000	9.10
44	25025140300	2010	301.000	12.80
44	25025140400	2010	193.000	7.00
44	25025160101	2010	1057.000	52.50
44	25025160200	2010	804.000	68.10
44	25025160300	2010	140.000	11.70
44	25025160400	2010	501.000	53.10
44	25025160501	2010	868.000	46.50
44	25025160502	2010	562.000	38.10
44	25025160601	2010	429.000	29.20
44	25025160602	2010	395.000	23.50
44	25025170100	2010	292.000	10.20
44	25025170200	2010	141.000	8.20
44	25025170300	2010	208.000	5.80
44	25025170400	2010	227.000	10.40
44	25025170501	2010	181.000	11.10
44	25025170502	2010	39.000	2.80
44	25025170601	2010	224.000	11.90
44	25025170701	2010	93.000	9.70
44	25025170702	2010	568.000	26.50
44	25025170800	2010	274.000	13.20
44	25025180101	2010	60.000	2.60
44	25025180200	2010	47.000	2.80
44	25025180301	2010	22.000	1.90
44	25025180400	2010	21.000	2.80
44	25025180500	2010	62.000	3.40
44	25025980101	2010	0.000	\N
44	25025980300	2010	0.000	0.00
44	25025980700	2010	0.000	0.00
44	25025981000	2010	0.000	0.00
44	25025981100	2010	10.000	11.80
44	25025981201	2010	0.000	\N
44	25025981202	2010	0.000	\N
44	25025981300	2010	15.000	6.40
44	25025981501	2010	0.000	\N
44	25025981502	2010	1.000	33.30
44	25025981600	2010	0.000	\N
44	25025981700	2010	0.000	\N
44	25025981800	2010	0.000	0.00
44	25025990101	2010	0.000	\N
45	25025000401	2010	52.000	1.80
45	25025000402	2010	27.000	1.80
45	25025000100	2010	60.000	3.70
45	25025000201	2010	50.000	3.20
45	25025000202	2010	63.000	4.30
45	25025000301	2010	28.000	2.40
45	25025000302	2010	18.000	1.40
45	25025000502	2010	61.000	3.30
45	25025000503	2010	25.000	1.90
45	25025000504	2010	73.000	2.80
45	25025000601	2010	48.000	3.30
45	25025000602	2010	103.000	5.20
45	25025000701	2010	83.000	3.60
45	25025000703	2010	47.000	3.40
45	25025000704	2010	126.000	5.40
45	25025000802	2010	170.000	5.60
45	25025000803	2010	61.000	6.90
45	25025010103	2010	21.000	4.30
45	25025010104	2010	88.000	4.60
45	25025010203	2010	193.000	5.50
45	25025010204	2010	31.000	2.60
45	25025010300	2010	23.000	5.80
45	25025010403	2010	84.000	4.10
45	25025010404	2010	77.000	4.30
45	25025010405	2010	39.000	4.00
45	25025010408	2010	44.000	4.70
45	25025010500	2010	88.000	5.30
45	25025010600	2010	65.000	3.50
45	25025010701	2010	44.000	3.20
45	25025010702	2010	29.000	2.10
45	25025010801	2010	39.000	2.40
45	25025010802	2010	33.000	1.80
45	25025020101	2010	48.000	1.90
45	25025020200	2010	64.000	2.80
45	25025020301	2010	30.000	2.40
45	25025020302	2010	17.000	2.50
45	25025020303	2010	55.000	3.40
45	25025030100	2010	30.000	2.40
45	25025030200	2010	19.000	1.80
45	25025030300	2010	54.000	2.20
45	25025030400	2010	32.000	2.10
45	25025030500	2010	32.000	2.20
45	25025040100	2010	7.000	0.60
45	25025040200	2010	41.000	6.20
45	25025040300	2010	37.000	2.00
45	25025040401	2010	12.000	1.00
45	25025040600	2010	20.000	1.60
45	25025040801	2010	88.000	4.70
45	25025050101	2010	346.000	20.20
45	25025050200	2010	348.000	20.50
45	25025050300	2010	141.000	14.50
45	25025050400	2010	191.000	19.80
45	25025050500	2010	144.000	21.90
45	25025050600	2010	196.000	26.30
45	25025050700	2010	257.000	17.70
45	25025050901	2010	291.000	22.00
45	25025051000	2010	206.000	12.30
45	25025051101	2010	285.000	13.00
45	25025051200	2010	116.000	11.30
45	25025060101	2010	8.000	0.50
45	25025060200	2010	2.000	0.20
45	25025060301	2010	4.000	0.30
45	25025060400	2010	13.000	0.50
45	25025060501	2010	10.000	0.50
45	25025060600	2010	26.000	1.90
45	25025060700	2010	64.000	10.40
45	25025060800	2010	8.000	0.40
45	25025061000	2010	81.000	6.50
45	25025061101	2010	126.000	12.80
45	25025061200	2010	24.000	1.40
45	25025070101	2010	83.000	2.90
45	25025070200	2010	17.000	1.10
45	25025070300	2010	37.000	1.50
45	25025070402	2010	20.000	3.00
45	25025070500	2010	204.000	7.00
45	25025070600	2010	21.000	1.70
45	25025070700	2010	38.000	3.10
45	25025070800	2010	73.000	3.60
45	25025070900	2010	93.000	5.40
45	25025071101	2010	77.000	3.70
45	25025071201	2010	77.000	5.90
45	25025080100	2010	35.000	5.10
45	25025080300	2010	35.000	5.10
45	25025080401	2010	117.000	9.60
45	25025080500	2010	140.000	11.00
45	25025080601	2010	69.000	7.80
45	25025080801	2010	156.000	16.80
45	25025080900	2010	61.000	3.60
45	25025081001	2010	143.000	6.40
45	25025081100	2010	83.000	4.90
45	25025081200	2010	166.000	14.80
45	25025081300	2010	223.000	11.10
45	25025081400	2010	42.000	3.20
45	25025081500	2010	42.000	5.00
45	25025081700	2010	51.000	3.50
45	25025081800	2010	50.000	4.40
45	25025081900	2010	58.000	4.60
45	25025082000	2010	38.000	3.30
45	25025082100	2010	122.000	6.00
45	25025090100	2010	46.000	2.70
45	25025090200	2010	46.000	6.00
45	25025090300	2010	73.000	6.50
45	25025090400	2010	65.000	5.70
45	25025090600	2010	25.000	3.50
45	25025090700	2010	31.000	1.70
45	25025090901	2010	104.000	6.80
45	25025091001	2010	23.000	1.90
45	25025091100	2010	40.000	2.20
45	25025091200	2010	44.000	3.80
45	25025091300	2010	37.000	4.70
45	25025091400	2010	55.000	6.30
45	25025091500	2010	58.000	3.90
45	25025091600	2010	26.000	2.50
45	25025091700	2010	28.000	3.10
45	25025091800	2010	28.000	2.70
45	25025091900	2010	41.000	3.30
45	25025092000	2010	50.000	3.30
45	25025092101	2010	45.000	2.00
45	25025092200	2010	26.000	2.30
45	25025092300	2010	27.000	2.80
45	25025092400	2010	106.000	5.70
45	25025100100	2010	106.000	5.60
45	25025100200	2010	11.000	1.20
45	25025100300	2010	9.000	0.80
45	25025100400	2010	16.000	0.90
45	25025100500	2010	58.000	2.70
45	25025100601	2010	30.000	1.50
45	25025100603	2010	12.000	1.60
45	25025100700	2010	12.000	0.60
45	25025100800	2010	37.000	1.50
45	25025100900	2010	18.000	1.10
45	25025101001	2010	40.000	1.90
45	25025101002	2010	31.000	1.60
45	25025101101	2010	11.000	1.00
45	25025101102	2010	22.000	1.50
45	25025110103	2010	162.000	7.40
45	25025110201	2010	65.000	8.00
45	25025110301	2010	30.000	3.30
45	25025110401	2010	104.000	8.10
45	25025110403	2010	48.000	2.90
45	25025110501	2010	29.000	2.20
45	25025110502	2010	88.000	5.60
45	25025110601	2010	8.000	0.60
45	25025110607	2010	53.000	2.50
45	25025120103	2010	9.000	1.40
45	25025120104	2010	49.000	4.90
45	25025120105	2010	2.000	0.20
45	25025120201	2010	85.000	5.10
45	25025120301	2010	137.000	7.70
45	25025120400	2010	85.000	3.10
45	25025120500	2010	98.000	11.50
45	25025120600	2010	36.000	3.40
45	25025120700	2010	35.000	3.60
45	25025130100	2010	18.000	0.70
45	25025130200	2010	23.000	1.30
45	25025130300	2010	16.000	0.90
45	25025130402	2010	33.000	1.60
45	25025130404	2010	34.000	2.70
45	25025130406	2010	98.000	4.60
45	25025140102	2010	20.000	1.30
45	25025140105	2010	36.000	2.80
45	25025140106	2010	62.000	7.80
45	25025140107	2010	37.000	3.80
45	25025140201	2010	13.000	1.50
45	25025140202	2010	41.000	2.10
45	25025140300	2010	96.000	4.10
45	25025140400	2010	45.000	1.60
45	25025160101	2010	354.000	17.60
45	25025160200	2010	202.000	17.10
45	25025160300	2010	55.000	4.60
45	25025160400	2010	161.000	17.10
45	25025160501	2010	343.000	18.40
45	25025160502	2010	201.000	13.60
45	25025160601	2010	189.000	12.90
45	25025160602	2010	162.000	9.60
45	25025170100	2010	107.000	3.80
45	25025170200	2010	59.000	3.40
45	25025170300	2010	111.000	3.10
45	25025170400	2010	96.000	4.40
45	25025170501	2010	105.000	6.40
45	25025170502	2010	26.000	1.80
45	25025170601	2010	97.000	5.20
45	25025170701	2010	54.000	5.60
45	25025170702	2010	266.000	12.40
45	25025170800	2010	130.000	6.30
45	25025180101	2010	30.000	1.30
45	25025180200	2010	25.000	1.50
45	25025180301	2010	16.000	1.40
45	25025180400	2010	11.000	1.50
45	25025180500	2010	22.000	1.20
45	25025980101	2010	0.000	\N
45	25025980300	2010	0.000	0.00
45	25025980700	2010	0.000	0.00
45	25025981000	2010	0.000	0.00
45	25025981100	2010	3.000	3.50
45	25025981201	2010	0.000	\N
45	25025981202	2010	0.000	\N
45	25025981300	2010	11.000	4.70
45	25025981501	2010	0.000	\N
45	25025981502	2010	1.000	33.30
45	25025981600	2010	0.000	\N
45	25025981700	2010	0.000	\N
45	25025981800	2010	0.000	0.00
45	25025990101	2010	0.000	\N
46	25025000401	2010	5.000	0.20
46	25025000402	2010	1.000	0.10
46	25025000100	2010	9.000	0.60
46	25025000201	2010	8.000	0.50
46	25025000202	2010	15.000	1.00
46	25025000301	2010	1.000	0.10
46	25025000302	2010	1.000	0.10
46	25025000502	2010	4.000	0.20
46	25025000503	2010	1.000	0.10
46	25025000504	2010	10.000	0.40
46	25025000601	2010	4.000	0.30
46	25025000602	2010	14.000	0.70
46	25025000701	2010	8.000	0.30
46	25025000703	2010	3.000	0.20
46	25025000704	2010	12.000	0.50
46	25025000802	2010	11.000	0.40
46	25025000803	2010	4.000	0.50
46	25025010103	2010	4.000	0.80
46	25025010104	2010	1.000	0.10
46	25025010203	2010	13.000	0.40
46	25025010204	2010	2.000	0.20
46	25025010300	2010	12.000	3.00
46	25025010403	2010	13.000	0.60
46	25025010404	2010	5.000	0.30
46	25025010405	2010	15.000	1.60
46	25025010408	2010	3.000	0.30
46	25025010500	2010	6.000	0.40
46	25025010600	2010	4.000	0.20
46	25025010701	2010	2.000	0.10
46	25025010702	2010	0.000	0.00
46	25025010801	2010	3.000	0.20
46	25025010802	2010	0.000	0.00
46	25025020101	2010	2.000	0.10
46	25025020200	2010	3.000	0.10
46	25025020301	2010	2.000	0.20
46	25025020302	2010	0.000	0.00
46	25025020303	2010	3.000	0.20
46	25025030100	2010	1.000	0.10
46	25025030200	2010	0.000	0.00
46	25025030300	2010	2.000	0.10
46	25025030400	2010	0.000	0.00
46	25025030500	2010	0.000	0.00
46	25025040100	2010	1.000	0.10
46	25025040200	2010	16.000	2.40
46	25025040300	2010	16.000	0.80
46	25025040401	2010	4.000	0.30
46	25025040600	2010	1.000	0.10
46	25025040801	2010	25.000	1.30
46	25025050101	2010	26.000	1.50
46	25025050200	2010	17.000	1.00
46	25025050300	2010	27.000	2.80
46	25025050400	2010	6.000	0.60
46	25025050500	2010	6.000	0.90
46	25025050600	2010	6.000	0.80
46	25025050700	2010	10.000	0.70
46	25025050901	2010	6.000	0.50
46	25025051000	2010	12.000	0.70
46	25025051101	2010	30.000	1.40
46	25025051200	2010	10.000	1.00
46	25025060101	2010	0.000	0.00
46	25025060200	2010	0.000	0.00
46	25025060301	2010	1.000	0.10
46	25025060400	2010	0.000	0.00
46	25025060501	2010	1.000	0.10
46	25025060600	2010	1.000	0.10
46	25025060700	2010	36.000	5.80
46	25025060800	2010	2.000	0.10
46	25025061000	2010	44.000	3.60
46	25025061101	2010	56.000	5.70
46	25025061200	2010	5.000	0.30
46	25025070101	2010	4.000	0.10
46	25025070200	2010	2.000	0.10
46	25025070300	2010	3.000	0.10
46	25025070402	2010	6.000	0.90
46	25025070500	2010	44.000	1.50
46	25025070600	2010	1.000	0.10
46	25025070700	2010	9.000	0.70
46	25025070800	2010	16.000	0.80
46	25025070900	2010	30.000	1.70
46	25025071101	2010	21.000	1.00
46	25025071201	2010	22.000	1.70
46	25025080100	2010	24.000	3.50
46	25025080300	2010	25.000	3.60
46	25025080401	2010	74.000	6.00
46	25025080500	2010	116.000	9.10
46	25025080601	2010	34.000	3.90
46	25025080801	2010	40.000	4.30
46	25025080900	2010	12.000	0.70
46	25025081001	2010	41.000	1.80
46	25025081100	2010	23.000	1.40
46	25025081200	2010	55.000	4.90
46	25025081300	2010	115.000	5.70
46	25025081400	2010	41.000	3.20
46	25025081500	2010	31.000	3.70
46	25025081700	2010	43.000	2.90
46	25025081800	2010	45.000	4.00
46	25025081900	2010	36.000	2.90
46	25025082000	2010	30.000	2.60
46	25025082100	2010	82.000	4.00
46	25025090100	2010	72.000	4.30
46	25025090200	2010	35.000	4.50
46	25025090300	2010	53.000	4.70
46	25025090400	2010	57.000	5.00
46	25025090600	2010	22.000	3.10
46	25025090700	2010	11.000	0.60
46	25025090901	2010	23.000	1.50
46	25025091001	2010	9.000	0.70
46	25025091100	2010	10.000	0.60
46	25025091200	2010	17.000	1.50
46	25025091300	2010	16.000	2.00
46	25025091400	2010	26.000	3.00
46	25025091500	2010	36.000	2.40
46	25025091600	2010	20.000	1.90
46	25025091700	2010	29.000	3.20
46	25025091800	2010	31.000	3.00
46	25025091900	2010	44.000	3.50
46	25025092000	2010	46.000	3.00
46	25025092101	2010	22.000	1.00
46	25025092200	2010	10.000	0.90
46	25025092300	2010	20.000	2.10
46	25025092400	2010	84.000	4.50
46	25025100100	2010	97.000	5.10
46	25025100200	2010	33.000	3.60
46	25025100300	2010	25.000	2.20
46	25025100400	2010	29.000	1.70
46	25025100500	2010	55.000	2.50
46	25025100601	2010	32.000	1.60
46	25025100603	2010	4.000	0.50
46	25025100700	2010	1.000	0.10
46	25025100800	2010	25.000	1.00
46	25025100900	2010	24.000	1.50
46	25025101001	2010	36.000	1.70
46	25025101002	2010	44.000	2.20
46	25025101101	2010	25.000	2.40
46	25025101102	2010	37.000	2.40
46	25025110103	2010	28.000	1.30
46	25025110201	2010	17.000	2.10
46	25025110301	2010	12.000	1.30
46	25025110401	2010	29.000	2.30
46	25025110403	2010	27.000	1.60
46	25025110501	2010	6.000	0.50
46	25025110502	2010	13.000	0.80
46	25025110601	2010	0.000	0.00
46	25025110607	2010	11.000	0.50
46	25025120103	2010	0.000	0.00
46	25025120104	2010	10.000	1.00
46	25025120105	2010	0.000	0.00
46	25025120201	2010	30.000	1.80
46	25025120301	2010	37.000	2.10
46	25025120400	2010	19.000	0.70
46	25025120500	2010	27.000	3.20
46	25025120600	2010	1.000	0.10
46	25025120700	2010	8.000	0.80
46	25025130100	2010	1.000	0.00
46	25025130200	2010	3.000	0.20
46	25025130300	2010	8.000	0.50
46	25025130402	2010	3.000	0.10
46	25025130404	2010	6.000	0.50
46	25025130406	2010	58.000	2.70
46	25025140102	2010	10.000	0.60
46	25025140105	2010	14.000	1.10
46	25025140106	2010	19.000	2.40
46	25025140107	2010	16.000	1.60
46	25025140201	2010	9.000	1.00
46	25025140202	2010	25.000	1.30
46	25025140300	2010	37.000	1.60
46	25025140400	2010	43.000	1.60
46	25025160101	2010	35.000	1.70
46	25025160200	2010	15.000	1.30
46	25025160300	2010	8.000	0.70
46	25025160400	2010	20.000	2.10
46	25025160501	2010	29.000	1.60
46	25025160502	2010	28.000	1.90
46	25025160601	2010	25.000	1.70
46	25025160602	2010	13.000	0.80
46	25025170100	2010	12.000	0.40
46	25025170200	2010	2.000	0.10
46	25025170300	2010	7.000	0.20
46	25025170400	2010	12.000	0.50
46	25025170501	2010	4.000	0.20
46	25025170502	2010	0.000	0.00
46	25025170601	2010	7.000	0.40
46	25025170701	2010	2.000	0.20
46	25025170702	2010	6.000	0.30
46	25025170800	2010	6.000	0.30
46	25025180101	2010	3.000	0.10
46	25025180200	2010	1.000	0.10
46	25025180301	2010	1.000	0.10
46	25025180400	2010	0.000	0.00
46	25025180500	2010	2.000	0.10
46	25025980101	2010	0.000	\N
46	25025980300	2010	0.000	0.00
46	25025980700	2010	0.000	0.00
46	25025981000	2010	0.000	0.00
46	25025981100	2010	6.000	7.10
46	25025981201	2010	0.000	\N
46	25025981202	2010	0.000	\N
46	25025981300	2010	0.000	0.00
46	25025981501	2010	0.000	\N
46	25025981502	2010	0.000	0.00
46	25025981600	2010	0.000	\N
46	25025981700	2010	0.000	\N
46	25025981800	2010	0.000	0.00
46	25025990101	2010	0.000	\N
47	25025000401	2010	1.000	0.00
47	25025000402	2010	0.000	0.00
47	25025000100	2010	0.000	0.00
47	25025000201	2010	2.000	0.10
47	25025000202	2010	1.000	0.10
47	25025000301	2010	1.000	0.10
47	25025000302	2010	0.000	0.00
47	25025000502	2010	0.000	0.00
47	25025000503	2010	0.000	0.00
47	25025000504	2010	1.000	0.00
47	25025000601	2010	0.000	0.00
47	25025000602	2010	5.000	0.30
47	25025000701	2010	1.000	0.00
47	25025000703	2010	0.000	0.00
47	25025000704	2010	4.000	0.20
47	25025000802	2010	6.000	0.20
47	25025000803	2010	1.000	0.10
47	25025010103	2010	0.000	0.00
47	25025010104	2010	0.000	0.00
47	25025010203	2010	1.000	0.00
47	25025010204	2010	0.000	0.00
47	25025010300	2010	0.000	0.00
47	25025010403	2010	0.000	0.00
47	25025010404	2010	1.000	0.10
47	25025010405	2010	0.000	0.00
47	25025010408	2010	0.000	0.00
47	25025010500	2010	1.000	0.10
47	25025010600	2010	1.000	0.10
47	25025010701	2010	0.000	0.00
47	25025010702	2010	0.000	0.00
47	25025010801	2010	0.000	0.00
47	25025010802	2010	0.000	0.00
47	25025020101	2010	0.000	0.00
47	25025020200	2010	0.000	0.00
47	25025020301	2010	0.000	0.00
47	25025020302	2010	1.000	0.10
47	25025020303	2010	0.000	0.00
47	25025030100	2010	0.000	0.00
47	25025030200	2010	1.000	0.10
47	25025030300	2010	0.000	0.00
47	25025030400	2010	1.000	0.10
47	25025030500	2010	0.000	0.00
47	25025040100	2010	0.000	0.00
47	25025040200	2010	2.000	0.30
47	25025040300	2010	2.000	0.10
47	25025040401	2010	1.000	0.10
47	25025040600	2010	0.000	0.00
47	25025040801	2010	2.000	0.10
47	25025050101	2010	6.000	0.40
47	25025050200	2010	4.000	0.20
47	25025050300	2010	3.000	0.30
47	25025050400	2010	1.000	0.10
47	25025050500	2010	0.000	0.00
47	25025050600	2010	1.000	0.10
47	25025050700	2010	5.000	0.30
47	25025050901	2010	3.000	0.20
47	25025051000	2010	3.000	0.20
47	25025051101	2010	3.000	0.10
47	25025051200	2010	1.000	0.10
47	25025060101	2010	0.000	0.00
47	25025060200	2010	0.000	0.00
47	25025060301	2010	0.000	0.00
47	25025060400	2010	1.000	0.00
47	25025060501	2010	0.000	0.00
47	25025060600	2010	0.000	0.00
47	25025060700	2010	2.000	0.30
47	25025060800	2010	1.000	0.00
47	25025061000	2010	3.000	0.20
47	25025061101	2010	5.000	0.50
47	25025061200	2010	0.000	0.00
47	25025070101	2010	0.000	0.00
47	25025070200	2010	1.000	0.10
47	25025070300	2010	0.000	0.00
47	25025070402	2010	0.000	0.00
47	25025070500	2010	8.000	0.30
47	25025070600	2010	0.000	0.00
47	25025070700	2010	0.000	0.00
47	25025070800	2010	1.000	0.00
47	25025070900	2010	2.000	0.10
47	25025071101	2010	2.000	0.10
47	25025071201	2010	0.000	0.00
47	25025080100	2010	4.000	0.60
47	25025080300	2010	2.000	0.30
47	25025080401	2010	7.000	0.60
47	25025080500	2010	4.000	0.30
47	25025080601	2010	3.000	0.30
47	25025080801	2010	7.000	0.80
47	25025080900	2010	2.000	0.10
47	25025081001	2010	8.000	0.40
47	25025081100	2010	2.000	0.10
47	25025081200	2010	13.000	1.20
47	25025081300	2010	12.000	0.60
47	25025081400	2010	7.000	0.50
47	25025081500	2010	0.000	0.00
47	25025081700	2010	4.000	0.30
47	25025081800	2010	1.000	0.10
47	25025081900	2010	1.000	0.10
47	25025082000	2010	1.000	0.10
47	25025082100	2010	10.000	0.50
47	25025090100	2010	4.000	0.20
47	25025090200	2010	4.000	0.50
47	25025090300	2010	2.000	0.20
47	25025090400	2010	5.000	0.40
47	25025090600	2010	2.000	0.30
47	25025090700	2010	1.000	0.10
47	25025090901	2010	3.000	0.20
47	25025091001	2010	0.000	0.00
47	25025091100	2010	0.000	0.00
47	25025091200	2010	2.000	0.20
47	25025091300	2010	0.000	0.00
47	25025091400	2010	2.000	0.20
47	25025091500	2010	2.000	0.10
47	25025091600	2010	0.000	0.00
47	25025091700	2010	3.000	0.30
47	25025091800	2010	0.000	0.00
47	25025091900	2010	4.000	0.30
47	25025092000	2010	1.000	0.10
47	25025092101	2010	4.000	0.20
47	25025092200	2010	0.000	0.00
47	25025092300	2010	2.000	0.20
47	25025092400	2010	5.000	0.30
47	25025100100	2010	1.000	0.10
47	25025100200	2010	1.000	0.10
47	25025100300	2010	0.000	0.00
47	25025100400	2010	1.000	0.10
47	25025100500	2010	7.000	0.30
47	25025100601	2010	0.000	0.00
47	25025100603	2010	0.000	0.00
47	25025100700	2010	0.000	0.00
47	25025100800	2010	0.000	0.00
47	25025100900	2010	1.000	0.10
47	25025101001	2010	3.000	0.10
47	25025101002	2010	3.000	0.20
47	25025101101	2010	1.000	0.10
47	25025101102	2010	3.000	0.20
47	25025110103	2010	4.000	0.20
47	25025110201	2010	4.000	0.50
47	25025110301	2010	0.000	0.00
47	25025110401	2010	3.000	0.20
47	25025110403	2010	0.000	0.00
47	25025110501	2010	2.000	0.20
47	25025110502	2010	4.000	0.30
47	25025110601	2010	0.000	0.00
47	25025110607	2010	2.000	0.10
47	25025120103	2010	0.000	0.00
47	25025120104	2010	1.000	0.10
47	25025120105	2010	0.000	0.00
47	25025120201	2010	4.000	0.20
47	25025120301	2010	12.000	0.70
47	25025120400	2010	3.000	0.10
47	25025120500	2010	12.000	1.40
47	25025120600	2010	1.000	0.10
47	25025120700	2010	1.000	0.10
47	25025130100	2010	0.000	0.00
47	25025130200	2010	1.000	0.10
47	25025130300	2010	0.000	0.00
47	25025130402	2010	0.000	0.00
47	25025130404	2010	1.000	0.10
47	25025130406	2010	1.000	0.00
47	25025140102	2010	0.000	0.00
47	25025140105	2010	1.000	0.10
47	25025140106	2010	3.000	0.40
47	25025140107	2010	1.000	0.10
47	25025140201	2010	1.000	0.10
47	25025140202	2010	5.000	0.30
47	25025140300	2010	1.000	0.00
47	25025140400	2010	8.000	0.30
47	25025160101	2010	20.000	1.00
47	25025160200	2010	7.000	0.60
47	25025160300	2010	4.000	0.30
47	25025160400	2010	10.000	1.10
47	25025160501	2010	16.000	0.90
47	25025160502	2010	5.000	0.30
47	25025160601	2010	6.000	0.40
47	25025160602	2010	5.000	0.30
47	25025170100	2010	3.000	0.10
47	25025170200	2010	1.000	0.10
47	25025170300	2010	2.000	0.10
47	25025170400	2010	3.000	0.10
47	25025170501	2010	2.000	0.10
47	25025170502	2010	1.000	0.10
47	25025170601	2010	0.000	0.00
47	25025170701	2010	1.000	0.10
47	25025170702	2010	3.000	0.10
47	25025170800	2010	4.000	0.20
47	25025180101	2010	0.000	0.00
47	25025180200	2010	1.000	0.10
47	25025180301	2010	0.000	0.00
47	25025180400	2010	0.000	0.00
47	25025180500	2010	0.000	0.00
47	25025980101	2010	0.000	\N
47	25025980300	2010	0.000	0.00
47	25025980700	2010	0.000	0.00
47	25025981000	2010	0.000	0.00
47	25025981100	2010	0.000	0.00
47	25025981201	2010	0.000	\N
47	25025981202	2010	0.000	\N
47	25025981300	2010	0.000	0.00
47	25025981501	2010	0.000	\N
47	25025981502	2010	0.000	0.00
47	25025981600	2010	0.000	\N
47	25025981700	2010	0.000	\N
47	25025981800	2010	0.000	0.00
47	25025990101	2010	0.000	\N
48	25025000401	2010	0.000	0.00
48	25025000402	2010	0.000	0.00
48	25025000100	2010	0.000	0.00
48	25025000201	2010	1.000	0.10
48	25025000202	2010	0.000	0.00
48	25025000301	2010	0.000	0.00
48	25025000302	2010	1.000	0.10
48	25025000502	2010	1.000	0.10
48	25025000503	2010	1.000	0.10
48	25025000504	2010	2.000	0.10
48	25025000601	2010	0.000	0.00
48	25025000602	2010	1.000	0.10
48	25025000701	2010	0.000	0.00
48	25025000703	2010	4.000	0.30
48	25025000704	2010	2.000	0.10
48	25025000802	2010	3.000	0.10
48	25025000803	2010	1.000	0.10
48	25025010103	2010	0.000	0.00
48	25025010104	2010	0.000	0.00
48	25025010203	2010	1.000	0.00
48	25025010204	2010	1.000	0.10
48	25025010300	2010	0.000	0.00
48	25025010403	2010	1.000	0.00
48	25025010404	2010	2.000	0.10
48	25025010405	2010	0.000	0.00
48	25025010408	2010	1.000	0.10
48	25025010500	2010	0.000	0.00
48	25025010600	2010	0.000	0.00
48	25025010701	2010	2.000	0.10
48	25025010702	2010	0.000	0.00
48	25025010801	2010	0.000	0.00
48	25025010802	2010	0.000	0.00
48	25025020101	2010	1.000	0.00
48	25025020200	2010	1.000	0.00
48	25025020301	2010	1.000	0.10
48	25025020302	2010	0.000	0.00
48	25025020303	2010	2.000	0.10
48	25025030100	2010	1.000	0.10
48	25025030200	2010	1.000	0.10
48	25025030300	2010	0.000	0.00
48	25025030400	2010	0.000	0.00
48	25025030500	2010	0.000	0.00
48	25025040100	2010	0.000	0.00
48	25025040200	2010	0.000	0.00
48	25025040300	2010	1.000	0.10
48	25025040401	2010	0.000	0.00
48	25025040600	2010	0.000	0.00
48	25025040801	2010	0.000	0.00
48	25025050101	2010	1.000	0.10
48	25025050200	2010	0.000	0.00
48	25025050300	2010	1.000	0.10
48	25025050400	2010	1.000	0.10
48	25025050500	2010	0.000	0.00
48	25025050600	2010	0.000	0.00
48	25025050700	2010	0.000	0.00
48	25025050901	2010	2.000	0.20
48	25025051000	2010	1.000	0.10
48	25025051101	2010	1.000	0.00
48	25025051200	2010	1.000	0.10
48	25025060101	2010	0.000	0.00
48	25025060200	2010	0.000	0.00
48	25025060301	2010	0.000	0.00
48	25025060400	2010	0.000	0.00
48	25025060501	2010	0.000	0.00
48	25025060600	2010	0.000	0.00
48	25025060700	2010	3.000	0.50
48	25025060800	2010	0.000	0.00
48	25025061000	2010	1.000	0.10
48	25025061101	2010	0.000	0.00
48	25025061200	2010	2.000	0.10
48	25025070101	2010	1.000	0.00
48	25025070200	2010	0.000	0.00
48	25025070300	2010	1.000	0.00
48	25025070402	2010	0.000	0.00
48	25025070500	2010	1.000	0.00
48	25025070600	2010	0.000	0.00
48	25025070700	2010	0.000	0.00
48	25025070800	2010	0.000	0.00
48	25025070900	2010	0.000	0.00
48	25025071101	2010	0.000	0.00
48	25025071201	2010	0.000	0.00
48	25025080100	2010	0.000	0.00
48	25025080300	2010	0.000	0.00
48	25025080401	2010	1.000	0.10
48	25025080500	2010	0.000	0.00
48	25025080601	2010	1.000	0.10
48	25025080801	2010	1.000	0.10
48	25025080900	2010	0.000	0.00
48	25025081001	2010	2.000	0.10
48	25025081100	2010	3.000	0.20
48	25025081200	2010	0.000	0.00
48	25025081300	2010	1.000	0.00
48	25025081400	2010	0.000	0.00
48	25025081500	2010	0.000	0.00
48	25025081700	2010	1.000	0.10
48	25025081800	2010	1.000	0.10
48	25025081900	2010	0.000	0.00
48	25025082000	2010	0.000	0.00
48	25025082100	2010	0.000	0.00
48	25025090100	2010	0.000	0.00
48	25025090200	2010	0.000	0.00
48	25025090300	2010	1.000	0.10
48	25025090400	2010	1.000	0.10
48	25025090600	2010	0.000	0.00
48	25025090700	2010	0.000	0.00
48	25025090901	2010	0.000	0.00
48	25025091001	2010	0.000	0.00
48	25025091100	2010	1.000	0.10
48	25025091200	2010	0.000	0.00
48	25025091300	2010	1.000	0.10
48	25025091400	2010	0.000	0.00
48	25025091500	2010	0.000	0.00
48	25025091600	2010	3.000	0.30
48	25025091700	2010	0.000	0.00
48	25025091800	2010	0.000	0.00
48	25025091900	2010	0.000	0.00
48	25025092000	2010	0.000	0.00
48	25025092101	2010	2.000	0.10
48	25025092200	2010	0.000	0.00
48	25025092300	2010	0.000	0.00
48	25025092400	2010	1.000	0.10
48	25025100100	2010	0.000	0.00
48	25025100200	2010	0.000	0.00
48	25025100300	2010	0.000	0.00
48	25025100400	2010	0.000	0.00
48	25025100500	2010	0.000	0.00
48	25025100601	2010	0.000	0.00
48	25025100603	2010	0.000	0.00
48	25025100700	2010	0.000	0.00
48	25025100800	2010	0.000	0.00
48	25025100900	2010	0.000	0.00
48	25025101001	2010	1.000	0.00
48	25025101002	2010	0.000	0.00
48	25025101101	2010	0.000	0.00
48	25025101102	2010	0.000	0.00
48	25025110103	2010	0.000	0.00
48	25025110201	2010	1.000	0.10
48	25025110301	2010	0.000	0.00
48	25025110401	2010	0.000	0.00
48	25025110403	2010	0.000	0.00
48	25025110501	2010	0.000	0.00
48	25025110502	2010	0.000	0.00
48	25025110601	2010	0.000	0.00
48	25025110607	2010	1.000	0.00
48	25025120103	2010	0.000	0.00
48	25025120104	2010	0.000	0.00
48	25025120105	2010	0.000	0.00
48	25025120201	2010	0.000	0.00
48	25025120301	2010	1.000	0.10
48	25025120400	2010	0.000	0.00
48	25025120500	2010	0.000	0.00
48	25025120600	2010	0.000	0.00
48	25025120700	2010	0.000	0.00
48	25025130100	2010	0.000	0.00
48	25025130200	2010	0.000	0.00
48	25025130300	2010	1.000	0.10
48	25025130402	2010	0.000	0.00
48	25025130404	2010	0.000	0.00
48	25025130406	2010	0.000	0.00
48	25025140102	2010	0.000	0.00
48	25025140105	2010	1.000	0.10
48	25025140106	2010	0.000	0.00
48	25025140107	2010	1.000	0.10
48	25025140201	2010	0.000	0.00
48	25025140202	2010	0.000	0.00
48	25025140300	2010	0.000	0.00
48	25025140400	2010	1.000	0.00
48	25025160101	2010	0.000	0.00
48	25025160200	2010	0.000	0.00
48	25025160300	2010	0.000	0.00
48	25025160400	2010	3.000	0.30
48	25025160501	2010	0.000	0.00
48	25025160502	2010	1.000	0.10
48	25025160601	2010	1.000	0.10
48	25025160602	2010	1.000	0.10
48	25025170100	2010	0.000	0.00
48	25025170200	2010	0.000	0.00
48	25025170300	2010	2.000	0.10
48	25025170400	2010	0.000	0.00
48	25025170501	2010	3.000	0.20
48	25025170502	2010	0.000	0.00
48	25025170601	2010	0.000	0.00
48	25025170701	2010	0.000	0.00
48	25025170702	2010	1.000	0.00
48	25025170800	2010	0.000	0.00
48	25025180101	2010	0.000	0.00
48	25025180200	2010	0.000	0.00
48	25025180301	2010	0.000	0.00
48	25025180400	2010	0.000	0.00
48	25025180500	2010	1.000	0.10
48	25025980101	2010	0.000	\N
48	25025980300	2010	0.000	0.00
48	25025980700	2010	0.000	0.00
48	25025981000	2010	0.000	0.00
48	25025981100	2010	0.000	0.00
48	25025981201	2010	0.000	\N
48	25025981202	2010	0.000	\N
48	25025981300	2010	0.000	0.00
48	25025981501	2010	0.000	\N
48	25025981502	2010	0.000	0.00
48	25025981600	2010	0.000	\N
48	25025981700	2010	0.000	\N
48	25025981800	2010	0.000	0.00
48	25025990101	2010	0.000	\N
49	25025000401	2010	0.000	0.00
49	25025000402	2010	0.000	0.00
49	25025000100	2010	0.000	0.00
49	25025000201	2010	0.000	0.00
49	25025000202	2010	1.000	0.10
49	25025000301	2010	0.000	0.00
49	25025000302	2010	0.000	0.00
49	25025000502	2010	0.000	0.00
49	25025000503	2010	0.000	0.00
49	25025000504	2010	0.000	0.00
49	25025000601	2010	0.000	0.00
49	25025000602	2010	0.000	0.00
49	25025000701	2010	0.000	0.00
49	25025000703	2010	0.000	0.00
49	25025000704	2010	1.000	0.00
49	25025000802	2010	0.000	0.00
49	25025000803	2010	0.000	0.00
49	25025010103	2010	0.000	0.00
49	25025010104	2010	0.000	0.00
49	25025010203	2010	0.000	0.00
49	25025010204	2010	0.000	0.00
49	25025010300	2010	0.000	0.00
49	25025010403	2010	0.000	0.00
49	25025010404	2010	1.000	0.10
49	25025010405	2010	0.000	0.00
49	25025010408	2010	0.000	0.00
49	25025010500	2010	0.000	0.00
49	25025010600	2010	0.000	0.00
49	25025010701	2010	0.000	0.00
49	25025010702	2010	0.000	0.00
49	25025010801	2010	0.000	0.00
49	25025010802	2010	0.000	0.00
49	25025020101	2010	0.000	0.00
49	25025020200	2010	0.000	0.00
49	25025020301	2010	0.000	0.00
49	25025020302	2010	0.000	0.00
49	25025020303	2010	0.000	0.00
49	25025030100	2010	0.000	0.00
49	25025030200	2010	0.000	0.00
49	25025030300	2010	0.000	0.00
49	25025030400	2010	0.000	0.00
49	25025030500	2010	0.000	0.00
49	25025040100	2010	0.000	0.00
49	25025040200	2010	0.000	0.00
49	25025040300	2010	0.000	0.00
49	25025040401	2010	0.000	0.00
49	25025040600	2010	0.000	0.00
49	25025040801	2010	0.000	0.00
49	25025050101	2010	0.000	0.00
49	25025050200	2010	0.000	0.00
49	25025050300	2010	0.000	0.00
49	25025050400	2010	0.000	0.00
49	25025050500	2010	0.000	0.00
49	25025050600	2010	0.000	0.00
49	25025050700	2010	1.000	0.10
49	25025050901	2010	0.000	0.00
49	25025051000	2010	1.000	0.10
49	25025051101	2010	0.000	0.00
49	25025051200	2010	1.000	0.10
49	25025060101	2010	0.000	0.00
49	25025060200	2010	0.000	0.00
49	25025060301	2010	0.000	0.00
49	25025060400	2010	0.000	0.00
49	25025060501	2010	0.000	0.00
49	25025060600	2010	0.000	0.00
49	25025060700	2010	0.000	0.00
49	25025060800	2010	0.000	0.00
49	25025061000	2010	0.000	0.00
49	25025061101	2010	1.000	0.10
49	25025061200	2010	0.000	0.00
49	25025070101	2010	0.000	0.00
49	25025070200	2010	0.000	0.00
49	25025070300	2010	0.000	0.00
49	25025070402	2010	0.000	0.00
49	25025070500	2010	1.000	0.00
49	25025070600	2010	0.000	0.00
49	25025070700	2010	0.000	0.00
49	25025070800	2010	0.000	0.00
49	25025070900	2010	0.000	0.00
49	25025071101	2010	0.000	0.00
49	25025071201	2010	0.000	0.00
49	25025080100	2010	0.000	0.00
49	25025080300	2010	0.000	0.00
49	25025080401	2010	0.000	0.00
49	25025080500	2010	2.000	0.20
49	25025080601	2010	0.000	0.00
49	25025080801	2010	0.000	0.00
49	25025080900	2010	0.000	0.00
49	25025081001	2010	0.000	0.00
49	25025081100	2010	0.000	0.00
49	25025081200	2010	0.000	0.00
49	25025081300	2010	0.000	0.00
49	25025081400	2010	0.000	0.00
49	25025081500	2010	0.000	0.00
49	25025081700	2010	0.000	0.00
49	25025081800	2010	0.000	0.00
49	25025081900	2010	0.000	0.00
49	25025082000	2010	0.000	0.00
49	25025082100	2010	0.000	0.00
49	25025090100	2010	1.000	0.10
49	25025090200	2010	1.000	0.10
49	25025090300	2010	1.000	0.10
49	25025090400	2010	0.000	0.00
49	25025090600	2010	0.000	0.00
49	25025090700	2010	0.000	0.00
49	25025090901	2010	0.000	0.00
49	25025091001	2010	0.000	0.00
49	25025091100	2010	2.000	0.10
49	25025091200	2010	0.000	0.00
49	25025091300	2010	0.000	0.00
49	25025091400	2010	0.000	0.00
49	25025091500	2010	0.000	0.00
49	25025091600	2010	0.000	0.00
49	25025091700	2010	0.000	0.00
49	25025091800	2010	0.000	0.00
49	25025091900	2010	0.000	0.00
49	25025092000	2010	1.000	0.10
49	25025092101	2010	0.000	0.00
49	25025092200	2010	0.000	0.00
49	25025092300	2010	0.000	0.00
49	25025092400	2010	0.000	0.00
49	25025100100	2010	0.000	0.00
49	25025100200	2010	0.000	0.00
49	25025100300	2010	0.000	0.00
49	25025100400	2010	0.000	0.00
49	25025100500	2010	1.000	0.00
49	25025100601	2010	0.000	0.00
49	25025100603	2010	0.000	0.00
49	25025100700	2010	0.000	0.00
49	25025100800	2010	0.000	0.00
49	25025100900	2010	0.000	0.00
49	25025101001	2010	0.000	0.00
49	25025101002	2010	1.000	0.10
49	25025101101	2010	1.000	0.10
49	25025101102	2010	0.000	0.00
49	25025110103	2010	0.000	0.00
49	25025110201	2010	0.000	0.00
49	25025110301	2010	0.000	0.00
49	25025110401	2010	1.000	0.10
49	25025110403	2010	0.000	0.00
49	25025110501	2010	0.000	0.00
49	25025110502	2010	0.000	0.00
49	25025110601	2010	0.000	0.00
49	25025110607	2010	0.000	0.00
49	25025120103	2010	0.000	0.00
49	25025120104	2010	0.000	0.00
49	25025120105	2010	0.000	0.00
49	25025120201	2010	0.000	0.00
49	25025120301	2010	0.000	0.00
49	25025120400	2010	0.000	0.00
49	25025120500	2010	0.000	0.00
49	25025120600	2010	0.000	0.00
49	25025120700	2010	0.000	0.00
49	25025130100	2010	0.000	0.00
49	25025130200	2010	0.000	0.00
49	25025130300	2010	0.000	0.00
49	25025130402	2010	1.000	0.00
49	25025130404	2010	0.000	0.00
49	25025130406	2010	0.000	0.00
49	25025140102	2010	1.000	0.10
49	25025140105	2010	0.000	0.00
49	25025140106	2010	0.000	0.00
49	25025140107	2010	0.000	0.00
49	25025140201	2010	0.000	0.00
49	25025140202	2010	0.000	0.00
49	25025140300	2010	1.000	0.00
49	25025140400	2010	0.000	0.00
49	25025160101	2010	0.000	0.00
49	25025160200	2010	1.000	0.10
49	25025160300	2010	0.000	0.00
49	25025160400	2010	0.000	0.00
49	25025160501	2010	0.000	0.00
49	25025160502	2010	0.000	0.00
49	25025160601	2010	1.000	0.10
49	25025160602	2010	0.000	0.00
49	25025170100	2010	1.000	0.00
49	25025170200	2010	0.000	0.00
49	25025170300	2010	0.000	0.00
49	25025170400	2010	0.000	0.00
49	25025170501	2010	0.000	0.00
49	25025170502	2010	0.000	0.00
49	25025170601	2010	0.000	0.00
49	25025170701	2010	0.000	0.00
49	25025170702	2010	0.000	0.00
49	25025170800	2010	0.000	0.00
49	25025180101	2010	0.000	0.00
49	25025180200	2010	0.000	0.00
49	25025180301	2010	0.000	0.00
49	25025180400	2010	0.000	0.00
49	25025180500	2010	0.000	0.00
49	25025980101	2010	0.000	\N
49	25025980300	2010	0.000	0.00
49	25025980700	2010	0.000	0.00
49	25025981000	2010	0.000	0.00
49	25025981100	2010	0.000	0.00
49	25025981201	2010	0.000	\N
49	25025981202	2010	0.000	\N
49	25025981300	2010	0.000	0.00
49	25025981501	2010	0.000	\N
49	25025981502	2010	0.000	0.00
49	25025981600	2010	0.000	\N
49	25025981700	2010	0.000	\N
49	25025981800	2010	0.000	0.00
49	25025990101	2010	0.000	\N
50	25025000401	2010	26.000	0.90
50	25025000402	2010	10.000	0.70
50	25025000100	2010	60.000	3.70
50	25025000201	2010	36.000	2.30
50	25025000202	2010	60.000	4.10
50	25025000301	2010	22.000	1.90
50	25025000302	2010	3.000	0.20
50	25025000502	2010	19.000	1.00
50	25025000503	2010	11.000	0.80
50	25025000504	2010	26.000	1.00
50	25025000601	2010	19.000	1.30
50	25025000602	2010	93.000	4.70
50	25025000701	2010	41.000	1.80
50	25025000703	2010	19.000	1.40
50	25025000704	2010	70.000	3.00
50	25025000802	2010	137.000	4.50
50	25025000803	2010	20.000	2.30
50	25025010103	2010	2.000	0.40
50	25025010104	2010	23.000	1.20
50	25025010203	2010	75.000	2.10
50	25025010204	2010	13.000	1.10
50	25025010300	2010	67.000	17.00
50	25025010403	2010	53.000	2.60
50	25025010404	2010	30.000	1.70
50	25025010405	2010	37.000	3.80
50	25025010408	2010	17.000	1.80
50	25025010500	2010	26.000	1.60
50	25025010600	2010	14.000	0.80
50	25025010701	2010	9.000	0.60
50	25025010702	2010	7.000	0.50
50	25025010801	2010	7.000	0.40
50	25025010802	2010	5.000	0.30
50	25025020101	2010	3.000	0.10
50	25025020200	2010	18.000	0.80
50	25025020301	2010	9.000	0.70
50	25025020302	2010	3.000	0.40
50	25025020303	2010	13.000	0.80
50	25025030100	2010	6.000	0.50
50	25025030200	2010	3.000	0.30
50	25025030300	2010	14.000	0.60
50	25025030400	2010	7.000	0.50
50	25025030500	2010	9.000	0.60
50	25025040100	2010	6.000	0.50
50	25025040200	2010	46.000	6.90
50	25025040300	2010	46.000	2.40
50	25025040401	2010	13.000	1.10
50	25025040600	2010	3.000	0.20
50	25025040801	2010	68.000	3.60
50	25025050101	2010	276.000	16.10
50	25025050200	2010	322.000	19.00
50	25025050300	2010	122.000	12.50
50	25025050400	2010	89.000	9.20
50	25025050500	2010	78.000	11.80
50	25025050600	2010	129.000	17.30
50	25025050700	2010	316.000	21.70
50	25025050901	2010	181.000	13.70
50	25025051000	2010	126.000	7.50
50	25025051101	2010	157.000	7.20
50	25025051200	2010	55.000	5.40
50	25025060101	2010	1.000	0.10
50	25025060200	2010	0.000	0.00
50	25025060301	2010	1.000	0.10
50	25025060400	2010	8.000	0.30
50	25025060501	2010	3.000	0.20
50	25025060600	2010	6.000	0.40
50	25025060700	2010	148.000	24.00
50	25025060800	2010	11.000	0.50
50	25025061000	2010	135.000	10.90
50	25025061101	2010	112.000	11.40
50	25025061200	2010	11.000	0.60
50	25025070101	2010	13.000	0.50
50	25025070200	2010	9.000	0.60
50	25025070300	2010	16.000	0.70
50	25025070402	2010	27.000	4.10
50	25025070500	2010	166.000	5.70
50	25025070600	2010	14.000	1.20
50	25025070700	2010	17.000	1.40
50	25025070800	2010	44.000	2.20
50	25025070900	2010	115.000	6.70
50	25025071101	2010	87.000	4.20
50	25025071201	2010	138.000	10.60
50	25025080100	2010	51.000	7.50
50	25025080300	2010	71.000	10.20
50	25025080401	2010	142.000	11.60
50	25025080500	2010	189.000	14.90
50	25025080601	2010	98.000	11.10
50	25025080801	2010	198.000	21.40
50	25025080900	2010	29.000	1.70
50	25025081001	2010	159.000	7.10
50	25025081100	2010	62.000	3.70
50	25025081200	2010	218.000	19.40
50	25025081300	2010	327.000	16.30
50	25025081400	2010	81.000	6.20
50	25025081500	2010	44.000	5.20
50	25025081700	2010	99.000	6.70
50	25025081800	2010	112.000	9.80
50	25025081900	2010	119.000	9.50
50	25025082000	2010	80.000	6.90
50	25025082100	2010	336.000	16.50
50	25025090100	2010	158.000	9.40
50	25025090200	2010	143.000	18.50
50	25025090300	2010	140.000	12.50
50	25025090400	2010	117.000	10.20
50	25025090600	2010	46.000	6.40
50	25025090700	2010	53.000	2.90
50	25025090901	2010	128.000	8.30
50	25025091001	2010	35.000	2.80
50	25025091100	2010	49.000	2.70
50	25025091200	2010	86.000	7.40
50	25025091300	2010	70.000	8.90
50	25025091400	2010	125.000	14.20
50	25025091500	2010	113.000	7.70
50	25025091600	2010	55.000	5.30
50	25025091700	2010	53.000	5.80
50	25025091800	2010	69.000	6.60
50	25025091900	2010	88.000	7.10
50	25025092000	2010	102.000	6.70
50	25025092101	2010	91.000	4.00
50	25025092200	2010	41.000	3.60
50	25025092300	2010	41.000	4.30
50	25025092400	2010	204.000	10.90
50	25025100100	2010	201.000	10.60
50	25025100200	2010	43.000	4.80
50	25025100300	2010	35.000	3.10
50	25025100400	2010	37.000	2.20
50	25025100500	2010	108.000	5.00
50	25025100601	2010	49.000	2.40
50	25025100603	2010	9.000	1.20
50	25025100700	2010	10.000	0.50
50	25025100800	2010	33.000	1.30
50	25025100900	2010	26.000	1.60
50	25025101001	2010	89.000	4.20
50	25025101002	2010	83.000	4.20
50	25025101101	2010	61.000	5.80
50	25025101102	2010	55.000	3.60
50	25025110103	2010	206.000	9.40
50	25025110201	2010	79.000	9.70
50	25025110301	2010	44.000	4.90
50	25025110401	2010	117.000	9.10
50	25025110403	2010	61.000	3.60
50	25025110501	2010	42.000	3.20
50	25025110502	2010	86.000	5.40
50	25025110601	2010	4.000	0.30
50	25025110607	2010	35.000	1.70
50	25025120103	2010	1.000	0.20
50	25025120104	2010	39.000	3.90
50	25025120105	2010	1.000	0.10
50	25025120201	2010	130.000	7.80
50	25025120301	2010	186.000	10.40
50	25025120400	2010	62.000	2.30
50	25025120500	2010	130.000	15.30
50	25025120600	2010	20.000	1.90
50	25025120700	2010	35.000	3.60
50	25025130100	2010	14.000	0.50
50	25025130200	2010	4.000	0.20
50	25025130300	2010	15.000	0.90
50	25025130402	2010	23.000	1.10
50	25025130404	2010	38.000	3.00
50	25025130406	2010	163.000	7.70
50	25025140102	2010	53.000	3.40
50	25025140105	2010	56.000	4.40
50	25025140106	2010	85.000	10.70
50	25025140107	2010	51.000	5.20
50	25025140201	2010	41.000	4.80
50	25025140202	2010	85.000	4.40
50	25025140300	2010	137.000	5.80
50	25025140400	2010	83.000	3.00
50	25025160101	2010	575.000	28.60
50	25025160200	2010	531.000	45.00
50	25025160300	2010	64.000	5.30
50	25025160400	2010	270.000	28.60
50	25025160501	2010	421.000	22.50
50	25025160502	2010	285.000	19.30
50	25025160601	2010	180.000	12.20
50	25025160602	2010	184.000	10.90
50	25025170100	2010	144.000	5.00
50	25025170200	2010	70.000	4.10
50	25025170300	2010	73.000	2.00
50	25025170400	2010	93.000	4.20
50	25025170501	2010	51.000	3.10
50	25025170502	2010	10.000	0.70
50	25025170601	2010	105.000	5.60
50	25025170701	2010	32.000	3.30
50	25025170702	2010	250.000	11.70
50	25025170800	2010	117.000	5.60
50	25025180101	2010	22.000	0.90
50	25025180200	2010	17.000	1.00
50	25025180301	2010	5.000	0.40
50	25025180400	2010	6.000	0.80
50	25025180500	2010	32.000	1.70
50	25025980101	2010	0.000	\N
50	25025980300	2010	0.000	0.00
50	25025980700	2010	0.000	0.00
50	25025981000	2010	0.000	0.00
50	25025981100	2010	1.000	1.20
50	25025981201	2010	0.000	\N
50	25025981202	2010	0.000	\N
50	25025981300	2010	3.000	1.30
50	25025981501	2010	0.000	\N
50	25025981502	2010	0.000	0.00
50	25025981600	2010	0.000	\N
50	25025981700	2010	0.000	\N
50	25025981800	2010	0.000	0.00
50	25025990101	2010	0.000	\N
51	25025000401	2010	8.000	0.30
51	25025000402	2010	4.000	0.30
51	25025000100	2010	13.000	0.80
51	25025000201	2010	6.000	0.40
51	25025000202	2010	16.000	1.10
51	25025000301	2010	4.000	0.30
51	25025000302	2010	5.000	0.40
51	25025000502	2010	5.000	0.30
51	25025000503	2010	1.000	0.10
51	25025000504	2010	13.000	0.50
51	25025000601	2010	4.000	0.30
51	25025000602	2010	19.000	1.00
51	25025000701	2010	9.000	0.40
51	25025000703	2010	4.000	0.30
51	25025000704	2010	11.000	0.50
51	25025000802	2010	29.000	1.00
51	25025000803	2010	4.000	0.50
51	25025010103	2010	0.000	0.00
51	25025010104	2010	6.000	0.30
51	25025010203	2010	29.000	0.80
51	25025010204	2010	1.000	0.10
51	25025010300	2010	1.000	0.30
51	25025010403	2010	18.000	0.90
51	25025010404	2010	11.000	0.60
51	25025010405	2010	9.000	0.90
51	25025010408	2010	7.000	0.70
51	25025010500	2010	8.000	0.50
51	25025010600	2010	2.000	0.10
51	25025010701	2010	3.000	0.20
51	25025010702	2010	2.000	0.10
51	25025010801	2010	1.000	0.10
51	25025010802	2010	2.000	0.10
51	25025020101	2010	6.000	0.20
51	25025020200	2010	5.000	0.20
51	25025020301	2010	1.000	0.10
51	25025020302	2010	2.000	0.30
51	25025020303	2010	3.000	0.20
51	25025030100	2010	0.000	0.00
51	25025030200	2010	3.000	0.30
51	25025030300	2010	4.000	0.20
51	25025030400	2010	2.000	0.10
51	25025030500	2010	2.000	0.10
51	25025040100	2010	0.000	0.00
51	25025040200	2010	3.000	0.50
51	25025040300	2010	18.000	1.00
51	25025040401	2010	3.000	0.30
51	25025040600	2010	2.000	0.20
51	25025040801	2010	20.000	1.10
51	25025050101	2010	49.000	2.90
51	25025050200	2010	60.000	3.50
51	25025050300	2010	31.000	3.20
51	25025050400	2010	20.000	2.10
51	25025050500	2010	17.000	2.60
51	25025050600	2010	27.000	3.60
51	25025050700	2010	45.000	3.10
51	25025050901	2010	26.000	2.00
51	25025051000	2010	15.000	0.90
51	25025051101	2010	35.000	1.60
51	25025051200	2010	16.000	1.60
51	25025060101	2010	1.000	0.10
51	25025060200	2010	0.000	0.00
51	25025060301	2010	1.000	0.10
51	25025060400	2010	1.000	0.00
51	25025060501	2010	4.000	0.20
51	25025060600	2010	1.000	0.10
51	25025060700	2010	23.000	3.70
51	25025060800	2010	3.000	0.10
51	25025061000	2010	35.000	2.80
51	25025061101	2010	41.000	4.20
51	25025061200	2010	1.000	0.10
51	25025070101	2010	6.000	0.20
51	25025070200	2010	2.000	0.10
51	25025070300	2010	8.000	0.30
51	25025070402	2010	4.000	0.60
51	25025070500	2010	31.000	1.10
51	25025070600	2010	2.000	0.20
51	25025070700	2010	6.000	0.50
51	25025070800	2010	23.000	1.10
51	25025070900	2010	25.000	1.40
51	25025071101	2010	13.000	0.60
51	25025071201	2010	14.000	1.10
51	25025080100	2010	14.000	2.10
51	25025080300	2010	11.000	1.60
51	25025080401	2010	52.000	4.20
51	25025080500	2010	58.000	4.60
51	25025080601	2010	22.000	2.50
51	25025080801	2010	32.000	3.50
51	25025080900	2010	11.000	0.70
51	25025081001	2010	23.000	1.00
51	25025081100	2010	16.000	1.00
51	25025081200	2010	49.000	4.40
51	25025081300	2010	81.000	4.00
51	25025081400	2010	11.000	0.80
51	25025081500	2010	17.000	2.00
51	25025081700	2010	18.000	1.20
51	25025081800	2010	23.000	2.00
51	25025081900	2010	29.000	2.30
51	25025082000	2010	15.000	1.30
51	25025082100	2010	58.000	2.90
51	25025090100	2010	25.000	1.50
51	25025090200	2010	16.000	2.10
51	25025090300	2010	21.000	1.90
51	25025090400	2010	26.000	2.30
51	25025090600	2010	12.000	1.70
51	25025090700	2010	5.000	0.30
51	25025090901	2010	13.000	0.80
51	25025091001	2010	11.000	0.90
51	25025091100	2010	6.000	0.30
51	25025091200	2010	20.000	1.70
51	25025091300	2010	19.000	2.40
51	25025091400	2010	13.000	1.50
51	25025091500	2010	20.000	1.40
51	25025091600	2010	12.000	1.20
51	25025091700	2010	12.000	1.30
51	25025091800	2010	3.000	0.30
51	25025091900	2010	14.000	1.10
51	25025092000	2010	17.000	1.10
51	25025092101	2010	9.000	0.40
51	25025092200	2010	9.000	0.80
51	25025092300	2010	14.000	1.50
51	25025092400	2010	49.000	2.60
51	25025100100	2010	33.000	1.70
51	25025100200	2010	11.000	1.20
51	25025100300	2010	6.000	0.50
51	25025100400	2010	9.000	0.50
51	25025100500	2010	26.000	1.20
51	25025100601	2010	9.000	0.40
51	25025100603	2010	0.000	0.00
51	25025100700	2010	1.000	0.10
51	25025100800	2010	17.000	0.70
51	25025100900	2010	9.000	0.60
51	25025101001	2010	13.000	0.60
51	25025101002	2010	19.000	1.00
51	25025101101	2010	11.000	1.00
51	25025101102	2010	8.000	0.50
51	25025110103	2010	34.000	1.60
51	25025110201	2010	12.000	1.50
51	25025110301	2010	4.000	0.40
51	25025110401	2010	28.000	2.20
51	25025110403	2010	21.000	1.30
51	25025110501	2010	11.000	0.80
51	25025110502	2010	12.000	0.80
51	25025110601	2010	1.000	0.10
51	25025110607	2010	11.000	0.50
51	25025120103	2010	1.000	0.20
51	25025120104	2010	9.000	0.90
51	25025120105	2010	2.000	0.20
51	25025120201	2010	23.000	1.40
51	25025120301	2010	35.000	2.00
51	25025120400	2010	10.000	0.40
51	25025120500	2010	34.000	4.00
51	25025120600	2010	8.000	0.80
51	25025120700	2010	14.000	1.40
51	25025130100	2010	2.000	0.10
51	25025130200	2010	5.000	0.30
51	25025130300	2010	3.000	0.20
51	25025130402	2010	6.000	0.30
51	25025130404	2010	4.000	0.30
51	25025130406	2010	28.000	1.30
51	25025140102	2010	14.000	0.90
51	25025140105	2010	6.000	0.50
51	25025140106	2010	23.000	2.90
51	25025140107	2010	15.000	1.50
51	25025140201	2010	7.000	0.80
51	25025140202	2010	21.000	1.10
51	25025140300	2010	29.000	1.20
51	25025140400	2010	13.000	0.50
51	25025160101	2010	73.000	3.60
51	25025160200	2010	48.000	4.10
51	25025160300	2010	9.000	0.80
51	25025160400	2010	37.000	3.90
51	25025160501	2010	59.000	3.20
51	25025160502	2010	42.000	2.80
51	25025160601	2010	27.000	1.80
51	25025160602	2010	30.000	1.80
51	25025170100	2010	25.000	0.90
51	25025170200	2010	9.000	0.50
51	25025170300	2010	13.000	0.40
51	25025170400	2010	23.000	1.00
51	25025170501	2010	16.000	1.00
51	25025170502	2010	2.000	0.10
51	25025170601	2010	15.000	0.80
51	25025170701	2010	4.000	0.40
51	25025170702	2010	42.000	2.00
51	25025170800	2010	17.000	0.80
51	25025180101	2010	5.000	0.20
51	25025180200	2010	3.000	0.20
51	25025180301	2010	0.000	0.00
51	25025180400	2010	4.000	0.50
51	25025180500	2010	5.000	0.30
51	25025980101	2010	0.000	\N
51	25025980300	2010	0.000	0.00
51	25025980700	2010	0.000	0.00
51	25025981000	2010	0.000	0.00
51	25025981100	2010	0.000	0.00
51	25025981201	2010	0.000	\N
51	25025981202	2010	0.000	\N
51	25025981300	2010	1.000	0.40
51	25025981501	2010	0.000	\N
51	25025981502	2010	0.000	0.00
51	25025981600	2010	0.000	\N
51	25025981700	2010	0.000	\N
51	25025981800	2010	0.000	0.00
51	25025990101	2010	0.000	\N
93	25005630200	2010	14.000	\N
93	25005630300	2010	23.000	\N
93	25005630400	2010	17.000	\N
93	25005631100	2010	46.000	\N
93	25005631200	2010	25.000	\N
93	25005631300	2010	24.000	\N
93	25005631400	2010	19.000	\N
93	25005631500	2010	7.000	\N
93	25005631600	2010	19.000	\N
93	25005631700	2010	10.000	\N
93	25005631800	2010	19.000	\N
93	25005632100	2010	33.000	\N
93	25005632200	2010	40.000	\N
93	25005633100	2010	18.000	\N
93	25005633200	2010	8.000	\N
93	25005640100	2010	27.000	\N
93	25005640200	2010	52.000	\N
93	25005640300	2010	20.000	\N
93	25005640400	2010	17.000	\N
93	25005640500	2010	41.000	\N
93	25005640600	2010	42.000	\N
93	25005640700	2010	19.000	\N
93	25005640800	2010	42.000	\N
93	25005640901	2010	81.000	\N
93	25005641000	2010	33.000	\N
93	25005641101	2010	21.000	\N
93	25005641200	2010	83.000	\N
93	25005641300	2010	67.000	\N
93	25005641400	2010	72.000	\N
93	25005641500	2010	12.000	\N
93	25005641600	2010	8.000	\N
93	25005641700	2010	21.000	\N
93	25005641800	2010	4.000	\N
93	25005641900	2010	33.000	\N
93	25005642000	2010	16.000	\N
93	25005642100	2010	43.000	\N
93	25005642200	2010	17.000	\N
93	25005642300	2010	10.000	\N
93	25005642400	2010	0.000	\N
93	25005642500	2010	6.000	\N
93	25005644101	2010	9.000	\N
93	25005644102	2010	10.000	\N
93	25005644200	2010	7.000	\N
93	25005645101	2010	1.000	\N
93	25005645102	2010	10.000	\N
93	25005645103	2010	21.000	\N
93	25005646101	2010	22.000	\N
93	25005646103	2010	9.000	\N
93	25005646104	2010	5.000	\N
93	25005650101	2010	89.000	\N
93	25005650102	2010	139.000	\N
93	25005650201	2010	47.000	\N
93	25005650202	2010	26.000	\N
93	25005650300	2010	37.000	\N
93	25005650400	2010	73.000	\N
93	25005650500	2010	47.000	\N
93	25005650600	2010	59.000	\N
93	25005650700	2010	129.000	\N
93	25005650800	2010	167.000	\N
93	25005650900	2010	159.000	\N
93	25005651001	2010	123.000	\N
93	25005651002	2010	141.000	\N
93	25005651100	2010	220.000	\N
93	25005651200	2010	75.000	\N
93	25005651300	2010	139.000	\N
93	25005651400	2010	235.000	\N
93	25005651500	2010	288.000	\N
93	25005651600	2010	369.000	\N
93	25005651700	2010	214.000	\N
93	25005651800	2010	91.000	\N
93	25005651900	2010	362.000	\N
93	25005652000	2010	231.000	\N
93	25005652100	2010	105.000	\N
93	25005652200	2010	71.000	\N
93	25005652300	2010	94.000	\N
93	25005652400	2010	45.000	\N
93	25005652500	2010	155.000	\N
93	25005652600	2010	90.000	\N
93	25005652700	2010	150.000	\N
93	25005652800	2010	54.000	\N
93	25005653101	2010	64.000	\N
93	25005653102	2010	34.000	\N
93	25005653203	2010	98.000	\N
93	25005653204	2010	35.000	\N
93	25005653301	2010	28.000	\N
93	25005653304	2010	18.000	\N
93	25005654100	2010	40.000	\N
93	25005654200	2010	23.000	\N
93	25005655100	2010	48.000	\N
93	25005655200	2010	24.000	\N
93	25005655300	2010	30.000	\N
93	25005655400	2010	23.000	\N
93	25005985500	2010	49.000	\N
93	25005985600	2010	23.000	\N
93	25005990000	2010	0.000	\N
93	25007200100	2010	189.000	\N
93	25007200200	2010	167.000	\N
93	25007200300	2010	193.000	\N
93	25007200400	2010	22.000	\N
93	25007990000	2010	0.000	\N
93	25009201100	2010	5.000	\N
93	25009202101	2010	5.000	\N
93	25009202102	2010	8.000	\N
93	25009202200	2010	8.000	\N
93	25009203100	2010	9.000	\N
93	25009203200	2010	8.000	\N
93	25009203301	2010	10.000	\N
93	25009203302	2010	4.000	\N
93	25009204101	2010	19.000	\N
93	25009204102	2010	10.000	\N
93	25009204200	2010	19.000	\N
93	25009204300	2010	12.000	\N
93	25009204400	2010	12.000	\N
93	25009204500	2010	19.000	\N
93	25009204600	2010	39.000	\N
93	25009204701	2010	8.000	\N
93	25009204702	2010	28.000	\N
93	25009205100	2010	23.000	\N
93	25009205200	2010	15.000	\N
93	25009205300	2010	13.000	\N
93	25009205400	2010	19.000	\N
93	25009205500	2010	14.000	\N
93	25009205600	2010	11.000	\N
93	25009205700	2010	12.000	\N
93	25009205800	2010	21.000	\N
93	25009205900	2010	30.000	\N
93	25009206000	2010	17.000	\N
93	25009206100	2010	10.000	\N
93	25009206200	2010	23.000	\N
93	25009206300	2010	20.000	\N
93	25009206400	2010	22.000	\N
93	25009206500	2010	21.000	\N
93	25009206600	2010	13.000	\N
93	25009206700	2010	20.000	\N
93	25009206800	2010	23.000	\N
93	25009206900	2010	28.000	\N
93	25009207000	2010	1.000	\N
93	25009207100	2010	40.000	\N
93	25009207200	2010	11.000	\N
93	25009208101	2010	11.000	\N
93	25009208102	2010	10.000	\N
93	25009208200	2010	42.000	\N
93	25009208300	2010	41.000	\N
93	25009208400	2010	28.000	\N
93	25009209100	2010	17.000	\N
93	25009209200	2010	13.000	\N
93	25009210100	2010	8.000	\N
93	25009210200	2010	8.000	\N
93	25009210300	2010	35.000	\N
93	25009210400	2010	65.000	\N
93	25009210500	2010	11.000	\N
93	25009210600	2010	25.000	\N
93	25009210700	2010	184.000	\N
93	25009210800	2010	183.000	\N
93	25009210900	2010	54.000	\N
93	25009211100	2010	7.000	\N
93	25009211200	2010	6.000	\N
93	25009211300	2010	1.000	\N
93	25009211401	2010	10.000	\N
93	25009211402	2010	10.000	\N
93	25009212100	2010	15.000	\N
93	25009213100	2010	7.000	\N
93	25009214100	2010	8.000	\N
93	25009215101	2010	3.000	\N
93	25009215102	2010	2.000	\N
93	25009216100	2010	16.000	\N
93	25009217100	2010	11.000	\N
93	25009217201	2010	11.000	\N
93	25009217202	2010	7.000	\N
93	25009217300	2010	64.000	\N
93	25009217400	2010	55.000	\N
93	25009217500	2010	18.000	\N
93	25009217600	2010	9.000	\N
93	25009218100	2010	1.000	\N
93	25009220101	2010	2.000	\N
93	25009220102	2010	7.000	\N
93	25009221100	2010	5.000	\N
93	25009221300	2010	4.000	\N
93	25009221400	2010	52.000	\N
93	25009221500	2010	18.000	\N
93	25009221600	2010	5.000	\N
93	25009221700	2010	8.000	\N
93	25009221800	2010	0.000	\N
93	25009221901	2010	4.000	\N
93	25009221902	2010	3.000	\N
93	25009222100	2010	4.000	\N
93	25009223100	2010	7.000	\N
93	25009223200	2010	25.000	\N
93	25009223300	2010	23.000	\N
93	25009250100	2010	3.000	\N
93	25009250200	2010	12.000	\N
93	25009250300	2010	5.000	\N
93	25009250400	2010	10.000	\N
93	25009250500	2010	13.000	\N
93	25009250600	2010	14.000	\N
93	25009250700	2010	21.000	\N
93	25009250800	2010	19.000	\N
93	25009250900	2010	13.000	\N
93	25009251000	2010	5.000	\N
93	25009251100	2010	10.000	\N
93	25009251200	2010	6.000	\N
93	25009251300	2010	7.000	\N
93	25009251400	2010	32.000	\N
93	25009251500	2010	18.000	\N
93	25009251600	2010	27.000	\N
93	25009251700	2010	16.000	\N
93	25009251800	2010	22.000	\N
93	25009252101	2010	15.000	\N
93	25009252102	2010	7.000	\N
93	25009252201	2010	5.000	\N
93	25009252202	2010	9.000	\N
93	25009252300	2010	22.000	\N
93	25009252400	2010	7.000	\N
93	25009252501	2010	6.000	\N
93	25009252502	2010	10.000	\N
93	25009252601	2010	24.000	\N
93	25009252602	2010	5.000	\N
93	25009252603	2010	1.000	\N
93	25009253100	2010	4.000	\N
93	25009253201	2010	6.000	\N
93	25009253202	2010	11.000	\N
93	25009253203	2010	4.000	\N
93	25009253204	2010	2.000	\N
93	25009253205	2010	5.000	\N
93	25009254100	2010	16.000	\N
93	25009254200	2010	3.000	\N
93	25009254301	2010	5.000	\N
93	25009254302	2010	10.000	\N
93	25009254401	2010	12.000	\N
93	25009254402	2010	19.000	\N
93	25009254403	2010	8.000	\N
93	25009260100	2010	34.000	\N
93	25009260200	2010	10.000	\N
93	25009260301	2010	10.000	\N
93	25009260302	2010	7.000	\N
93	25009260401	2010	9.000	\N
93	25009260402	2010	12.000	\N
93	25009260500	2010	4.000	\N
93	25009260600	2010	13.000	\N
93	25009260700	2010	12.000	\N
93	25009260800	2010	8.000	\N
93	25009260900	2010	19.000	\N
93	25009261000	2010	7.000	\N
93	25009261101	2010	3.000	\N
93	25009261102	2010	9.000	\N
93	25009262100	2010	3.000	\N
93	25009263100	2010	3.000	\N
93	25009264100	2010	4.000	\N
93	25009265101	2010	3.000	\N
93	25009265102	2010	1.000	\N
93	25009266100	2010	4.000	\N
93	25009266200	2010	22.000	\N
93	25009266300	2010	3.000	\N
93	25009266400	2010	9.000	\N
93	25009267101	2010	5.000	\N
93	25009267102	2010	9.000	\N
93	25009268100	2010	2.000	\N
93	25009268200	2010	26.000	\N
93	25009268300	2010	16.000	\N
93	25009268400	2010	4.000	\N
93	25009269100	2010	6.000	\N
93	25009270100	2010	13.000	\N
93	25009990100	2010	0.000	\N
93	25011040100	2010	6.000	\N
93	25011040200	2010	0.000	\N
93	25011040300	2010	1.000	\N
93	25011040400	2010	2.000	\N
93	25011040501	2010	8.000	\N
93	25011040502	2010	6.000	\N
93	25011040600	2010	10.000	\N
93	25011040701	2010	7.000	\N
93	25011040702	2010	10.000	\N
93	25011040800	2010	11.000	\N
93	25011040900	2010	3.000	\N
93	25011041000	2010	6.000	\N
93	25011041100	2010	7.000	\N
93	25011041200	2010	3.000	\N
93	25011041300	2010	13.000	\N
93	25011041400	2010	3.000	\N
93	25011041501	2010	2.000	\N
93	25011041502	2010	1.000	\N
93	25013800101	2010	1.000	\N
93	25013800102	2010	8.000	\N
93	25013800201	2010	15.000	\N
93	25013800202	2010	0.000	\N
93	25013800300	2010	5.000	\N
93	25013800400	2010	9.000	\N
93	25013800500	2010	11.000	\N
93	25013800600	2010	9.000	\N
93	25013800700	2010	0.000	\N
93	25013800800	2010	1.000	\N
93	25013800900	2010	15.000	\N
93	25013801101	2010	2.000	\N
93	25013801102	2010	1.000	\N
93	25013801200	2010	1.000	\N
93	25013801300	2010	3.000	\N
93	25013801401	2010	2.000	\N
93	25013801402	2010	0.000	\N
93	25013801501	2010	6.000	\N
93	25013801502	2010	0.000	\N
93	25013801503	2010	10.000	\N
93	25013801601	2010	16.000	\N
93	25013801602	2010	7.000	\N
93	25013801603	2010	7.000	\N
93	25013801604	2010	6.000	\N
93	25013801605	2010	10.000	\N
93	25013801700	2010	9.000	\N
93	25013801800	2010	13.000	\N
93	25013801901	2010	6.000	\N
93	25013801902	2010	9.000	\N
93	25013802000	2010	6.000	\N
93	25013802100	2010	38.000	\N
93	25013802200	2010	6.000	\N
93	25013802300	2010	3.000	\N
93	25013802400	2010	3.000	\N
93	25013802500	2010	6.000	\N
93	25013802601	2010	4.000	\N
93	25013802602	2010	0.000	\N
93	25013810100	2010	0.000	\N
93	25013810200	2010	4.000	\N
93	25013810300	2010	2.000	\N
93	25013810403	2010	14.000	\N
93	25013810404	2010	9.000	\N
93	25013810412	2010	16.000	\N
93	25013810414	2010	6.000	\N
93	25013810601	2010	13.000	\N
93	25013810602	2010	0.000	\N
93	25013810700	2010	8.000	\N
93	25013810800	2010	5.000	\N
93	25013810901	2010	31.000	\N
93	25013810902	2010	5.000	\N
93	25013811000	2010	0.000	\N
93	25013811101	2010	12.000	\N
93	25013811102	2010	6.000	\N
93	25013811200	2010	2.000	\N
93	25013811301	2010	10.000	\N
93	25013811302	2010	3.000	\N
93	25013811400	2010	2.000	\N
93	25013811500	2010	7.000	\N
93	25013811600	2010	0.000	\N
93	25013811700	2010	3.000	\N
93	25013811800	2010	5.000	\N
93	25013811900	2010	1.000	\N
93	25013812001	2010	5.000	\N
93	25013812002	2010	7.000	\N
93	25013812101	2010	16.000	\N
93	25013812103	2010	2.000	\N
93	25013812104	2010	13.000	\N
93	25013812201	2010	10.000	\N
93	25013812202	2010	11.000	\N
93	25013812300	2010	2.000	\N
93	25013812401	2010	9.000	\N
93	25013812403	2010	0.000	\N
93	25013812404	2010	2.000	\N
93	25013812500	2010	3.000	\N
93	25013812600	2010	0.000	\N
93	25013812701	2010	4.000	\N
93	25013812702	2010	4.000	\N
93	25013812800	2010	0.000	\N
93	25013812901	2010	0.000	\N
93	25013812902	2010	0.000	\N
93	25013812903	2010	0.000	\N
93	25013813000	2010	1.000	\N
93	25013813101	2010	0.000	\N
93	25013813102	2010	1.000	\N
93	25013813204	2010	0.000	\N
93	25013813205	2010	2.000	\N
93	25013813206	2010	0.000	\N
93	25013813207	2010	12.000	\N
93	25013813208	2010	8.000	\N
93	25013813209	2010	3.000	\N
93	25013813301	2010	3.000	\N
93	25013813303	2010	1.000	\N
93	25013813304	2010	8.000	\N
93	25013813401	2010	6.000	\N
93	25013813403	2010	0.000	\N
93	25013813404	2010	10.000	\N
93	25013813500	2010	7.000	\N
93	25013813601	2010	10.000	\N
93	25013813602	2010	6.000	\N
93	25013813701	2010	1.000	\N
93	25013813702	2010	6.000	\N
93	25013813801	2010	2.000	\N
93	25013813802	2010	1.000	\N
93	25015820101	2010	7.000	\N
93	25015820102	2010	0.000	\N
93	25015820202	2010	2.000	\N
93	25015820203	2010	19.000	\N
93	25015820204	2010	10.000	\N
93	25015820300	2010	20.000	\N
93	25015820400	2010	57.000	\N
93	25015820500	2010	20.000	\N
93	25015820600	2010	9.000	\N
93	25015820700	2010	17.000	\N
93	25015820801	2010	21.000	\N
93	25015820802	2010	2.000	\N
93	25015820900	2010	4.000	\N
93	25015821000	2010	4.000	\N
93	25015821100	2010	18.000	\N
93	25015821200	2010	6.000	\N
93	25015821300	2010	5.000	\N
93	25015821400	2010	5.000	\N
93	25015821500	2010	4.000	\N
93	25015821601	2010	8.000	\N
93	25015821602	2010	10.000	\N
93	25015821700	2010	7.000	\N
93	25015821901	2010	12.000	\N
93	25015821903	2010	7.000	\N
93	25015821904	2010	19.000	\N
93	25015822000	2010	10.000	\N
93	25015822200	2010	11.000	\N
93	25015822300	2010	6.000	\N
93	25015822401	2010	3.000	\N
93	25015822402	2010	4.000	\N
93	25015822500	2010	3.000	\N
93	25015822601	2010	0.000	\N
93	25015822603	2010	2.000	\N
93	25015822605	2010	0.000	\N
93	25015822606	2010	8.000	\N
93	25015822700	2010	3.000	\N
93	25017300100	2010	2.000	\N
93	25017301101	2010	4.000	\N
93	25017301102	2010	4.000	\N
93	25017310100	2010	86.000	\N
93	25017310200	2010	58.000	\N
93	25017310300	2010	68.000	\N
93	25017310400	2010	32.000	\N
93	25017310500	2010	29.000	\N
93	25017310601	2010	27.000	\N
93	25017310602	2010	51.000	\N
93	25017310700	2010	96.000	\N
93	25017311100	2010	22.000	\N
93	25017311200	2010	24.000	\N
93	25017311300	2010	74.000	\N
93	25017311400	2010	113.000	\N
93	25017311500	2010	44.000	\N
93	25017311600	2010	74.000	\N
93	25017311700	2010	54.000	\N
93	25017311800	2010	27.000	\N
93	25017311900	2010	85.000	\N
93	25017312000	2010	92.000	\N
93	25017312100	2010	137.000	\N
93	25017312200	2010	64.000	\N
93	25017312300	2010	90.000	\N
93	25017312400	2010	52.000	\N
93	25017312501	2010	49.000	\N
93	25017312502	2010	51.000	\N
93	25017313101	2010	3.000	\N
93	25017313102	2010	6.000	\N
93	25017314101	2010	16.000	\N
93	25017314102	2010	40.000	\N
93	25017314200	2010	14.000	\N
93	25017314301	2010	25.000	\N
93	25017314302	2010	1.000	\N
93	25017315100	2010	4.000	\N
93	25017315200	2010	10.000	\N
93	25017315401	2010	7.000	\N
93	25017315402	2010	0.000	\N
93	25017315403	2010	0.000	\N
93	25017315500	2010	28.000	\N
93	25017316101	2010	2.000	\N
93	25017316102	2010	7.000	\N
93	25017316201	2010	4.000	\N
93	25017316202	2010	13.000	\N
93	25017316300	2010	33.000	\N
93	25017316400	2010	6.000	\N
93	25017316500	2010	9.000	\N
93	25017317101	2010	6.000	\N
93	25017317102	2010	1.000	\N
93	25017317103	2010	5.000	\N
93	25017317201	2010	5.000	\N
93	25017317202	2010	4.000	\N
93	25017317203	2010	6.000	\N
93	25017317301	2010	4.000	\N
93	25017317302	2010	9.000	\N
93	25017318100	2010	13.000	\N
93	25017318200	2010	6.000	\N
93	25017318300	2010	11.000	\N
93	25017318400	2010	1.000	\N
93	25017320102	2010	14.000	\N
93	25017320103	2010	0.000	\N
93	25017320104	2010	14.000	\N
93	25017321100	2010	178.000	\N
93	25017321200	2010	366.000	\N
93	25017321300	2010	299.000	\N
93	25017321400	2010	22.000	\N
93	25017321500	2010	269.000	\N
93	25017321600	2010	249.000	\N
93	25017322100	2010	20.000	\N
93	25017322200	2010	55.000	\N
93	25017322300	2010	84.000	\N
93	25017322400	2010	91.000	\N
93	25017323100	2010	10.000	\N
93	25017324101	2010	3.000	\N
93	25017324102	2010	9.000	\N
93	25017325100	2010	41.000	\N
93	25017326101	2010	4.000	\N
93	25017326102	2010	4.000	\N
93	25017327101	2010	2.000	\N
93	25017327102	2010	13.000	\N
93	25017327103	2010	5.000	\N
93	25017328100	2010	0.000	\N
93	25017330100	2010	7.000	\N
93	25017330200	2010	17.000	\N
93	25017331101	2010	1.000	\N
93	25017331102	2010	4.000	\N
93	25017331200	2010	17.000	\N
93	25017331300	2010	17.000	\N
93	25017332100	2010	3.000	\N
93	25017332200	2010	46.000	\N
93	25017332300	2010	23.000	\N
93	25017332400	2010	11.000	\N
93	25017333100	2010	38.000	\N
93	25017333200	2010	21.000	\N
93	25017333300	2010	56.000	\N
93	25017333400	2010	65.000	\N
93	25017333501	2010	31.000	\N
93	25017333502	2010	48.000	\N
93	25017333600	2010	66.000	\N
93	25017334100	2010	13.000	\N
93	25017334200	2010	5.000	\N
93	25017334300	2010	3.000	\N
93	25017334400	2010	5.000	\N
93	25017335100	2010	5.000	\N
93	25017335200	2010	6.000	\N
93	25017335301	2010	5.000	\N
93	25017335302	2010	8.000	\N
93	25017335400	2010	2.000	\N
93	25017336100	2010	12.000	\N
93	25017336200	2010	6.000	\N
93	25017336300	2010	5.000	\N
93	25017336401	2010	45.000	\N
93	25017336402	2010	32.000	\N
93	25017337101	2010	6.000	\N
93	25017337102	2010	9.000	\N
93	25017337201	2010	31.000	\N
93	25017337202	2010	11.000	\N
93	25017337300	2010	26.000	\N
93	25017338100	2010	4.000	\N
93	25017338200	2010	13.000	\N
93	25017338300	2010	3.000	\N
93	25017338400	2010	11.000	\N
93	25017338500	2010	9.000	\N
93	25017339100	2010	45.000	\N
93	25017339200	2010	15.000	\N
93	25017339300	2010	35.000	\N
93	25017339400	2010	35.000	\N
93	25017339500	2010	84.000	\N
93	25017339600	2010	125.000	\N
93	25017339700	2010	118.000	\N
93	25017339801	2010	112.000	\N
93	25017339802	2010	55.000	\N
93	25017339900	2010	197.000	\N
93	25017340000	2010	87.000	\N
93	25017340100	2010	35.000	\N
93	25017341101	2010	24.000	\N
93	25017341102	2010	46.000	\N
93	25017341200	2010	197.000	\N
93	25017341300	2010	76.000	\N
93	25017341400	2010	211.000	\N
93	25017341500	2010	132.000	\N
93	25017341600	2010	115.000	\N
93	25017341700	2010	55.000	\N
93	25017341800	2010	129.000	\N
93	25017341901	2010	29.000	\N
93	25017341902	2010	236.000	\N
93	25017342101	2010	135.000	\N
93	25017342102	2010	125.000	\N
93	25017342201	2010	173.000	\N
93	25017342202	2010	127.000	\N
93	25017342300	2010	361.000	\N
93	25017342400	2010	351.000	\N
93	25017342500	2010	341.000	\N
93	25017342600	2010	220.000	\N
93	25017350103	2010	27.000	\N
93	25017350104	2010	355.000	\N
93	25017350200	2010	223.000	\N
93	25017350300	2010	80.000	\N
93	25017350400	2010	26.000	\N
93	25017350500	2010	1.000	\N
93	25017350600	2010	12.000	\N
93	25017350700	2010	41.000	\N
93	25017350800	2010	4.000	\N
93	25017350900	2010	3.000	\N
93	25017351000	2010	28.000	\N
93	25017351100	2010	41.000	\N
93	25017351203	2010	30.000	\N
93	25017351204	2010	121.000	\N
93	25017351300	2010	131.000	\N
93	25017351403	2010	194.000	\N
93	25017351404	2010	300.000	\N
93	25017351500	2010	72.000	\N
93	25017352101	2010	5.000	\N
93	25017352102	2010	17.000	\N
93	25017352200	2010	30.000	\N
93	25017352300	2010	16.000	\N
93	25017352400	2010	18.000	\N
93	25017352500	2010	11.000	\N
93	25017352600	2010	46.000	\N
93	25017352700	2010	37.000	\N
93	25017352800	2010	38.000	\N
93	25017352900	2010	25.000	\N
93	25017353000	2010	15.000	\N
93	25017353101	2010	12.000	\N
93	25017353102	2010	14.000	\N
93	25017353200	2010	36.000	\N
93	25017353300	2010	20.000	\N
93	25017353400	2010	10.000	\N
93	25017353500	2010	9.000	\N
93	25017353600	2010	11.000	\N
93	25017353700	2010	22.000	\N
93	25017353800	2010	24.000	\N
93	25017353900	2010	16.000	\N
93	25017354000	2010	6.000	\N
93	25017354100	2010	10.000	\N
93	25017354200	2010	15.000	\N
93	25017354300	2010	20.000	\N
93	25017354400	2010	9.000	\N
93	25017354500	2010	4.000	\N
93	25017354600	2010	23.000	\N
93	25017354700	2010	7.000	\N
93	25017354800	2010	7.000	\N
93	25017354900	2010	34.000	\N
93	25017355000	2010	8.000	\N
93	25017356100	2010	5.000	\N
93	25017356300	2010	30.000	\N
93	25017356400	2010	20.000	\N
93	25017356500	2010	46.000	\N
93	25017356601	2010	12.000	\N
93	25017356602	2010	19.000	\N
93	25017356701	2010	19.000	\N
93	25017356702	2010	27.000	\N
93	25017357100	2010	5.000	\N
93	25017357200	2010	6.000	\N
93	25017357300	2010	15.000	\N
93	25017357400	2010	10.000	\N
93	25017357500	2010	4.000	\N
93	25017357600	2010	6.000	\N
93	25017357700	2010	21.000	\N
93	25017357800	2010	13.000	\N
93	25017358100	2010	12.000	\N
93	25017358300	2010	17.000	\N
93	25017358400	2010	8.000	\N
93	25017358500	2010	17.000	\N
93	25017358600	2010	17.000	\N
93	25017358700	2010	6.000	\N
93	25017359100	2010	4.000	\N
93	25017359300	2010	6.000	\N
93	25017360100	2010	2.000	\N
93	25017360200	2010	19.000	\N
93	25017361100	2010	8.000	\N
93	25017361200	2010	16.000	\N
93	25017361300	2010	8.000	\N
93	25017362100	2010	10.000	\N
93	25017363102	2010	95.000	\N
93	25017363103	2010	21.000	\N
93	25017363104	2010	19.000	\N
93	25017363201	2010	6.000	\N
93	25017363202	2010	18.000	\N
93	25017364101	2010	21.000	\N
93	25017364102	2010	31.000	\N
93	25017365100	2010	24.000	\N
93	25017365201	2010	17.000	\N
93	25017365202	2010	11.000	\N
93	25017366100	2010	13.000	\N
93	25017366201	2010	5.000	\N
93	25017366202	2010	3.000	\N
93	25017367100	2010	4.000	\N
93	25017367200	2010	30.000	\N
93	25017368101	2010	35.000	\N
93	25017368102	2010	10.000	\N
93	25017368200	2010	9.000	\N
93	25017368300	2010	44.000	\N
93	25017368400	2010	30.000	\N
93	25017368500	2010	21.000	\N
93	25017368600	2010	19.000	\N
93	25017368700	2010	9.000	\N
93	25017368800	2010	17.000	\N
93	25017368901	2010	18.000	\N
93	25017368902	2010	38.000	\N
93	25017369000	2010	4.000	\N
93	25017369100	2010	18.000	\N
93	25017370101	2010	47.000	\N
93	25017370102	2010	37.000	\N
93	25017370201	2010	13.000	\N
93	25017370202	2010	29.000	\N
93	25017370300	2010	84.000	\N
93	25017370400	2010	34.000	\N
93	25017373100	2010	29.000	\N
93	25017373200	2010	28.000	\N
93	25017373300	2010	16.000	\N
93	25017373400	2010	7.000	\N
93	25017373500	2010	31.000	\N
93	25017373600	2010	9.000	\N
93	25017373700	2010	11.000	\N
93	25017373800	2010	13.000	\N
93	25017373900	2010	17.000	\N
93	25017374000	2010	19.000	\N
93	25017374100	2010	13.000	\N
93	25017374200	2010	22.000	\N
93	25017374300	2010	9.000	\N
93	25017374400	2010	14.000	\N
93	25017374500	2010	5.000	\N
93	25017374600	2010	27.000	\N
93	25017374700	2010	13.000	\N
93	25017374800	2010	11.000	\N
93	25017382100	2010	10.000	\N
93	25017382200	2010	22.000	\N
93	25017382300	2010	23.000	\N
93	25017382400	2010	22.000	\N
93	25017382500	2010	18.000	\N
93	25017382601	2010	56.000	\N
93	25017382602	2010	25.000	\N
93	25017383101	2010	548.000	\N
93	25017383102	2010	528.000	\N
93	25017383200	2010	676.000	\N
93	25017383300	2010	335.000	\N
93	25017383400	2010	702.000	\N
93	25017383501	2010	291.000	\N
93	25017383502	2010	89.000	\N
93	25017383600	2010	268.000	\N
93	25017383700	2010	136.000	\N
93	25017383800	2010	75.000	\N
93	25017383901	2010	62.000	\N
93	25017383902	2010	55.000	\N
93	25017384001	2010	41.000	\N
93	25017384002	2010	261.000	\N
93	25017385100	2010	80.000	\N
93	25017385201	2010	83.000	\N
93	25017385202	2010	73.000	\N
93	25017386100	2010	10.000	\N
93	25017387100	2010	18.000	\N
93	25017387201	2010	39.000	\N
93	25017387202	2010	4.000	\N
93	25017388100	2010	14.000	\N
93	25017388200	2010	11.000	\N
93	25017388300	2010	55.000	\N
93	25017980000	2010	0.000	\N
93	25019950100	2010	5.000	\N
93	25019950200	2010	55.000	\N
93	25019950307	2010	0.000	\N
93	25019950400	2010	13.000	\N
93	25019950500	2010	6.000	\N
93	25019990000	2010	0.000	\N
93	25021400100	2010	18.000	\N
93	25021400200	2010	24.000	\N
93	25021400300	2010	15.000	\N
93	25021400400	2010	9.000	\N
93	25021400500	2010	14.000	\N
93	25021400600	2010	16.000	\N
93	25021400700	2010	15.000	\N
93	25021400800	2010	14.000	\N
93	25021400900	2010	7.000	\N
93	25021401000	2010	12.000	\N
93	25021401100	2010	12.000	\N
93	25021401200	2010	31.000	\N
93	25021402101	2010	12.000	\N
93	25021402102	2010	23.000	\N
93	25021402200	2010	3.000	\N
93	25021402300	2010	11.000	\N
93	25021402400	2010	23.000	\N
93	25021402500	2010	2.000	\N
93	25021403100	2010	10.000	\N
93	25021403300	2010	9.000	\N
93	25021403400	2010	5.000	\N
93	25021403500	2010	12.000	\N
93	25021404100	2010	7.000	\N
93	25021404201	2010	4.000	\N
93	25021404202	2010	15.000	\N
93	25021404301	2010	5.000	\N
93	25021404302	2010	1.000	\N
93	25021404400	2010	18.000	\N
93	25021405100	2010	6.000	\N
93	25021406101	2010	5.000	\N
93	25021406102	2010	10.000	\N
93	25021407100	2010	21.000	\N
93	25021408101	2010	9.000	\N
93	25021408102	2010	1.000	\N
93	25021409101	2010	4.000	\N
93	25021409102	2010	1.000	\N
93	25021410100	2010	13.000	\N
93	25021410300	2010	12.000	\N
93	25021410400	2010	18.000	\N
93	25021411100	2010	22.000	\N
93	25021411200	2010	16.000	\N
93	25021411301	2010	16.000	\N
93	25021411302	2010	1.000	\N
93	25021412100	2010	11.000	\N
93	25021412200	2010	7.000	\N
93	25021412300	2010	4.000	\N
93	25021413100	2010	25.000	\N
93	25021413200	2010	41.000	\N
93	25021413300	2010	31.000	\N
93	25021413401	2010	4.000	\N
93	25021413402	2010	22.000	\N
93	25021413500	2010	61.000	\N
93	25021414100	2010	13.000	\N
93	25021414200	2010	15.000	\N
93	25021414300	2010	21.000	\N
93	25021415101	2010	12.000	\N
93	25021415102	2010	37.000	\N
93	25021415200	2010	25.000	\N
93	25021415300	2010	7.000	\N
93	25021416101	2010	27.000	\N
93	25021416102	2010	16.000	\N
93	25021416200	2010	86.000	\N
93	25021416300	2010	36.000	\N
93	25021416400	2010	13.000	\N
93	25021417100	2010	8.000	\N
93	25021417200	2010	21.000	\N
93	25021417300	2010	11.000	\N
93	25021417400	2010	1.000	\N
93	25021417501	2010	17.000	\N
93	25021417502	2010	9.000	\N
93	25021417601	2010	11.000	\N
93	25021417602	2010	11.000	\N
93	25021417701	2010	39.000	\N
93	25021417702	2010	10.000	\N
93	25021417801	2010	22.000	\N
93	25021417802	2010	20.000	\N
93	25021417901	2010	86.000	\N
93	25021417902	2010	138.000	\N
93	25021418002	2010	106.000	\N
93	25021418003	2010	23.000	\N
93	25021418004	2010	60.000	\N
93	25021418101	2010	19.000	\N
93	25021418102	2010	77.000	\N
93	25021418200	2010	79.000	\N
93	25021419100	2010	48.000	\N
93	25021419200	2010	18.000	\N
93	25021419300	2010	43.000	\N
93	25021419400	2010	18.000	\N
93	25021419500	2010	11.000	\N
93	25021419600	2010	42.000	\N
93	25021419700	2010	17.000	\N
93	25021419800	2010	48.000	\N
93	25021420100	2010	105.000	\N
93	25021420201	2010	82.000	\N
93	25021420202	2010	118.000	\N
93	25021420301	2010	163.000	\N
93	25021420302	2010	143.000	\N
93	25021421100	2010	45.000	\N
93	25021421200	2010	63.000	\N
93	25021422100	2010	61.000	\N
93	25021422200	2010	91.000	\N
93	25021422301	2010	23.000	\N
93	25021422302	2010	117.000	\N
93	25021422400	2010	121.000	\N
93	25021422501	2010	85.000	\N
93	25021422502	2010	183.000	\N
93	25021422600	2010	31.000	\N
93	25021422700	2010	22.000	\N
93	25021422800	2010	30.000	\N
93	25021423100	2010	11.000	\N
93	25021440100	2010	6.000	\N
93	25021441202	2010	0.000	\N
93	25021441203	2010	3.000	\N
93	25021441204	2010	3.000	\N
93	25021442101	2010	13.000	\N
93	25021442102	2010	15.000	\N
93	25021442103	2010	4.000	\N
93	25021442201	2010	6.000	\N
93	25021442202	2010	8.000	\N
93	25021443101	2010	28.000	\N
93	25021443102	2010	10.000	\N
93	25021456101	2010	58.000	\N
93	25021456102	2010	96.000	\N
93	25021456200	2010	37.000	\N
93	25021456301	2010	80.000	\N
93	25021456302	2010	65.000	\N
93	25021456401	2010	46.000	\N
93	25021456402	2010	66.000	\N
93	25021457100	2010	30.000	\N
93	25021457200	2010	20.000	\N
93	25023500101	2010	19.000	\N
93	25023500103	2010	3.000	\N
93	25023500104	2010	21.000	\N
93	25023501101	2010	9.000	\N
93	25023501102	2010	13.000	\N
93	25023501201	2010	4.000	\N
93	25023501202	2010	10.000	\N
93	25023502101	2010	193.000	\N
93	25023502102	2010	69.000	\N
93	25023502200	2010	46.000	\N
93	25023503101	2010	25.000	\N
93	25023503102	2010	22.000	\N
93	25023504101	2010	4.000	\N
93	25023504102	2010	15.000	\N
93	25023505101	2010	116.000	\N
93	25023505102	2010	10.000	\N
93	25023505200	2010	72.000	\N
93	25023506101	2010	9.000	\N
93	25023506102	2010	62.000	\N
93	25023506202	2010	8.000	\N
93	25023506203	2010	37.000	\N
93	25023506204	2010	15.000	\N
93	25023507101	2010	10.000	\N
93	25023507103	2010	6.000	\N
93	25023507104	2010	21.000	\N
93	25023508101	2010	17.000	\N
93	25023508102	2010	16.000	\N
93	25023508200	2010	10.000	\N
93	25023509101	2010	25.000	\N
93	25023509102	2010	28.000	\N
93	25023510100	2010	90.000	\N
93	25023510200	2010	398.000	\N
93	25023510300	2010	489.000	\N
93	25023510400	2010	682.000	\N
93	25023510501	2010	156.000	\N
93	25023510502	2010	328.000	\N
93	25023510503	2010	233.000	\N
93	25023510600	2010	61.000	\N
93	25023510700	2010	360.000	\N
93	25023510800	2010	954.000	\N
93	25023510900	2010	367.000	\N
93	25023511000	2010	439.000	\N
93	25023511100	2010	169.000	\N
93	25023511200	2010	407.000	\N
93	25023511301	2010	494.000	\N
93	25023511302	2010	192.000	\N
93	25023511400	2010	571.000	\N
93	25023511500	2010	938.000	\N
93	25023511600	2010	750.000	\N
93	25023511701	2010	161.000	\N
93	25023511702	2010	90.000	\N
93	25023520100	2010	71.000	\N
93	25023520201	2010	114.000	\N
93	25023520202	2010	41.000	\N
93	25023521101	2010	28.000	\N
93	25023521102	2010	17.000	\N
93	25023521201	2010	19.000	\N
93	25023521202	2010	29.000	\N
93	25023522101	2010	37.000	\N
93	25023522102	2010	12.000	\N
93	25023523100	2010	20.000	\N
93	25023523201	2010	25.000	\N
93	25023523202	2010	17.000	\N
93	25023524101	2010	19.000	\N
93	25023524102	2010	24.000	\N
93	25023525101	2010	39.000	\N
93	25023525104	2010	22.000	\N
93	25023525203	2010	24.000	\N
93	25023525204	2010	14.000	\N
93	25023525300	2010	4.000	\N
93	25023526100	2010	17.000	\N
93	25023530100	2010	17.000	\N
93	25023530200	2010	143.000	\N
93	25023530300	2010	67.000	\N
93	25023530400	2010	21.000	\N
93	25023530500	2010	72.000	\N
93	25023530600	2010	70.000	\N
93	25023530700	2010	7.000	\N
93	25023530801	2010	4.000	\N
93	25023530802	2010	15.000	\N
93	25023530901	2010	35.000	\N
93	25023530902	2010	20.000	\N
93	25023540101	2010	20.000	\N
93	25023540102	2010	4.000	\N
93	25023540103	2010	14.000	\N
93	25023541100	2010	44.000	\N
93	25023542101	2010	41.000	\N
93	25023542102	2010	21.000	\N
93	25023542200	2010	26.000	\N
93	25023542300	2010	31.000	\N
93	25023543100	2010	5.000	\N
93	25023544100	2010	55.000	\N
93	25023544200	2010	29.000	\N
93	25023545100	2010	264.000	\N
93	25023545200	2010	256.000	\N
93	25023545300	2010	189.000	\N
93	25023545400	2010	141.000	\N
93	25023560100	2010	61.000	\N
93	25023561100	2010	122.000	\N
93	25023561200	2010	16.000	\N
93	25023990003	2010	0.000	\N
93	25025000100	2010	250.000	\N
93	25025000201	2010	70.000	\N
93	25025000202	2010	50.000	\N
93	25025000301	2010	24.000	\N
93	25025000302	2010	30.000	\N
93	25025000401	2010	30.000	\N
93	25025000402	2010	28.000	\N
93	25025000502	2010	16.000	\N
93	25025000503	2010	11.000	\N
93	25025000504	2010	11.000	\N
93	25025000601	2010	94.000	\N
93	25025000602	2010	28.000	\N
93	25025000701	2010	42.000	\N
93	25025000703	2010	57.000	\N
93	25025000704	2010	73.000	\N
93	25025000802	2010	250.000	\N
93	25025000803	2010	25.000	\N
93	25025010103	2010	21.000	\N
93	25025010104	2010	14.000	\N
93	25025010203	2010	21.000	\N
93	25025010204	2010	7.000	\N
93	25025010300	2010	19.000	\N
93	25025010403	2010	10.000	\N
93	25025010404	2010	23.000	\N
93	25025010405	2010	15.000	\N
93	25025010408	2010	1.000	\N
93	25025010500	2010	12.000	\N
93	25025010600	2010	6.000	\N
93	25025010701	2010	14.000	\N
93	25025010702	2010	3.000	\N
93	25025010801	2010	5.000	\N
93	25025010802	2010	15.000	\N
93	25025020101	2010	19.000	\N
93	25025020200	2010	10.000	\N
93	25025020301	2010	4.000	\N
93	25025020302	2010	3.000	\N
93	25025020303	2010	8.000	\N
93	25025030100	2010	5.000	\N
93	25025030200	2010	6.000	\N
93	25025030300	2010	18.000	\N
93	25025030400	2010	6.000	\N
93	25025030500	2010	7.000	\N
93	25025040100	2010	1.000	\N
93	25025040200	2010	15.000	\N
93	25025040300	2010	1.000	\N
93	25025040401	2010	5.000	\N
93	25025040600	2010	5.000	\N
93	25025040801	2010	35.000	\N
93	25025050101	2010	29.000	\N
93	25025050200	2010	96.000	\N
93	25025050300	2010	40.000	\N
93	25025050400	2010	52.000	\N
93	25025050500	2010	43.000	\N
93	25025050600	2010	44.000	\N
93	25025050700	2010	154.000	\N
93	25025050901	2010	50.000	\N
93	25025051000	2010	27.000	\N
93	25025051101	2010	70.000	\N
93	25025051200	2010	50.000	\N
93	25025060101	2010	1.000	\N
93	25025060200	2010	0.000	\N
93	25025060301	2010	8.000	\N
93	25025060400	2010	2.000	\N
93	25025060501	2010	5.000	\N
93	25025060600	2010	6.000	\N
93	25025060700	2010	37.000	\N
93	25025060800	2010	11.000	\N
93	25025061000	2010	49.000	\N
93	25025061101	2010	9.000	\N
93	25025061200	2010	10.000	\N
93	25025070101	2010	11.000	\N
93	25025070200	2010	9.000	\N
93	25025070300	2010	17.000	\N
93	25025070402	2010	6.000	\N
93	25025070500	2010	17.000	\N
93	25025070600	2010	15.000	\N
93	25025070700	2010	14.000	\N
93	25025070800	2010	20.000	\N
93	25025070900	2010	11.000	\N
93	25025071101	2010	38.000	\N
93	25025071201	2010	18.000	\N
93	25025080100	2010	283.000	\N
93	25025080300	2010	45.000	\N
93	25025080401	2010	15.000	\N
93	25025080500	2010	13.000	\N
93	25025080601	2010	45.000	\N
93	25025080801	2010	12.000	\N
93	25025080900	2010	8.000	\N
93	25025081001	2010	14.000	\N
93	25025081100	2010	15.000	\N
93	25025081200	2010	17.000	\N
93	25025081300	2010	27.000	\N
93	25025081400	2010	18.000	\N
93	25025081500	2010	25.000	\N
93	25025081700	2010	37.000	\N
93	25025081800	2010	51.000	\N
93	25025081900	2010	45.000	\N
93	25025082000	2010	47.000	\N
93	25025082100	2010	44.000	\N
93	25025090100	2010	51.000	\N
93	25025090200	2010	53.000	\N
93	25025090300	2010	73.000	\N
93	25025090400	2010	236.000	\N
93	25025090600	2010	605.000	\N
93	25025090700	2010	72.000	\N
93	25025090901	2010	62.000	\N
93	25025091001	2010	32.000	\N
93	25025091100	2010	130.000	\N
93	25025091200	2010	390.000	\N
93	25025091300	2010	644.000	\N
93	25025091400	2010	262.000	\N
93	25025091500	2010	749.000	\N
93	25025091600	2010	263.000	\N
93	25025091700	2010	456.000	\N
93	25025091800	2010	524.000	\N
93	25025091900	2010	97.000	\N
93	25025092000	2010	220.000	\N
93	25025092101	2010	181.000	\N
93	25025092200	2010	90.000	\N
93	25025092300	2010	41.000	\N
93	25025092400	2010	60.000	\N
93	25025100100	2010	112.000	\N
93	25025100200	2010	49.000	\N
93	25025100300	2010	65.000	\N
93	25025100400	2010	110.000	\N
93	25025100500	2010	115.000	\N
93	25025100601	2010	174.000	\N
93	25025100603	2010	20.000	\N
93	25025100700	2010	16.000	\N
93	25025100800	2010	62.000	\N
93	25025100900	2010	56.000	\N
93	25025101001	2010	44.000	\N
93	25025101002	2010	47.000	\N
93	25025101101	2010	10.000	\N
93	25025101102	2010	3.000	\N
93	25025110103	2010	35.000	\N
93	25025110201	2010	15.000	\N
93	25025110301	2010	19.000	\N
93	25025110401	2010	14.000	\N
93	25025110403	2010	46.000	\N
93	25025110501	2010	10.000	\N
93	25025110502	2010	29.000	\N
93	25025110601	2010	13.000	\N
93	25025110607	2010	29.000	\N
93	25025120103	2010	8.000	\N
93	25025120104	2010	8.000	\N
93	25025120105	2010	5.000	\N
93	25025120201	2010	28.000	\N
93	25025120301	2010	28.000	\N
93	25025120400	2010	24.000	\N
93	25025120500	2010	22.000	\N
93	25025120600	2010	15.000	\N
93	25025120700	2010	8.000	\N
93	25025130100	2010	26.000	\N
93	25025130200	2010	7.000	\N
93	25025130300	2010	13.000	\N
93	25025130402	2010	18.000	\N
93	25025130404	2010	18.000	\N
93	25025130406	2010	23.000	\N
93	25025140102	2010	38.000	\N
93	25025140105	2010	32.000	\N
93	25025140106	2010	13.000	\N
93	25025140107	2010	16.000	\N
93	25025140201	2010	39.000	\N
93	25025140202	2010	38.000	\N
93	25025140300	2010	54.000	\N
93	25025140400	2010	45.000	\N
93	25025160101	2010	99.000	\N
93	25025160200	2010	32.000	\N
93	25025160300	2010	4.000	\N
93	25025160400	2010	15.000	\N
93	25025160501	2010	36.000	\N
93	25025160502	2010	42.000	\N
93	25025160601	2010	79.000	\N
93	25025160602	2010	116.000	\N
93	25025170100	2010	130.000	\N
93	25025170200	2010	56.000	\N
93	25025170300	2010	150.000	\N
93	25025170400	2010	95.000	\N
93	25025170501	2010	48.000	\N
93	25025170502	2010	18.000	\N
93	25025170601	2010	78.000	\N
93	25025170701	2010	17.000	\N
93	25025170702	2010	138.000	\N
93	25025170800	2010	57.000	\N
93	25025180101	2010	46.000	\N
93	25025180200	2010	36.000	\N
93	25025180301	2010	20.000	\N
93	25025180400	2010	17.000	\N
93	25025180500	2010	19.000	\N
93	25025980101	2010	13.000	\N
93	25025980300	2010	0.000	\N
93	25025980700	2010	0.000	\N
93	25025981000	2010	0.000	\N
93	25025981100	2010	2.000	\N
93	25025981201	2010	0.000	\N
93	25025981202	2010	0.000	\N
93	25025981300	2010	0.000	\N
93	25025981501	2010	0.000	\N
93	25025981502	2010	0.000	\N
93	25025981600	2010	0.000	\N
93	25025981700	2010	0.000	\N
93	25025981800	2010	0.000	\N
93	25025990101	2010	0.000	\N
93	25027700100	2010	2.000	\N
93	25027701100	2010	7.000	\N
93	25027702200	2010	0.000	\N
93	25027703100	2010	1.000	\N
93	25027703200	2010	8.000	\N
93	25027703300	2010	6.000	\N
93	25027704200	2010	0.000	\N
93	25027705100	2010	4.000	\N
93	25027706100	2010	7.000	\N
93	25027707100	2010	4.000	\N
93	25027707200	2010	1.000	\N
93	25027707300	2010	0.000	\N
93	25027707400	2010	7.000	\N
93	25027707500	2010	11.000	\N
93	25027708100	2010	7.000	\N
93	25027709100	2010	8.000	\N
93	25027709201	2010	34.000	\N
93	25027709202	2010	123.000	\N
93	25027709400	2010	43.000	\N
93	25027709501	2010	9.000	\N
93	25027709502	2010	36.000	\N
93	25027709600	2010	70.000	\N
93	25027709701	2010	28.000	\N
93	25027709702	2010	12.000	\N
93	25027710100	2010	3.000	\N
93	25027710200	2010	17.000	\N
93	25027710300	2010	11.000	\N
93	25027710400	2010	3.000	\N
93	25027710500	2010	4.000	\N
93	25027710600	2010	24.000	\N
93	25027710700	2010	3.000	\N
93	25027710800	2010	12.000	\N
93	25027711000	2010	3.000	\N
93	25027711100	2010	9.000	\N
93	25027712101	2010	13.000	\N
93	25027712102	2010	2.000	\N
93	25027713100	2010	30.000	\N
93	25027715100	2010	3.000	\N
93	25027716100	2010	50.000	\N
93	25027716200	2010	27.000	\N
93	25027716300	2010	52.000	\N
93	25027717100	2010	6.000	\N
93	25027718100	2010	10.000	\N
93	25027719100	2010	5.000	\N
93	25027720100	2010	0.000	\N
93	25027721101	2010	4.000	\N
93	25027721102	2010	14.000	\N
93	25027722100	2010	7.000	\N
93	25027723100	2010	0.000	\N
93	25027724100	2010	1.000	\N
93	25027725100	2010	1.000	\N
93	25027726100	2010	2.000	\N
93	25027726200	2010	8.000	\N
93	25027727100	2010	3.000	\N
93	25027728100	2010	4.000	\N
93	25027728200	2010	1.000	\N
93	25027728300	2010	9.000	\N
93	25027728400	2010	10.000	\N
93	25027729100	2010	1.000	\N
93	25027729200	2010	12.000	\N
93	25027730100	2010	12.000	\N
93	25027730200	2010	21.000	\N
93	25027730300	2010	12.000	\N
93	25027730401	2010	35.000	\N
93	25027730402	2010	21.000	\N
93	25027730500	2010	28.000	\N
93	25027730600	2010	10.000	\N
93	25027730700	2010	35.000	\N
93	25027730801	2010	12.000	\N
93	25027730802	2010	3.000	\N
93	25027730901	2010	13.000	\N
93	25027730902	2010	19.000	\N
93	25027731001	2010	4.000	\N
93	25027731002	2010	28.000	\N
93	25027731101	2010	20.000	\N
93	25027731102	2010	9.000	\N
93	25027731202	2010	5.000	\N
93	25027731203	2010	45.000	\N
93	25027731204	2010	3.000	\N
93	25027731300	2010	17.000	\N
93	25027731400	2010	42.000	\N
93	25027731500	2010	37.000	\N
93	25027731600	2010	95.000	\N
93	25027731700	2010	21.000	\N
93	25027731800	2010	108.000	\N
93	25027731900	2010	53.000	\N
93	25027732001	2010	7.000	\N
93	25027732002	2010	33.000	\N
93	25027732201	2010	74.000	\N
93	25027732202	2010	56.000	\N
93	25027732203	2010	26.000	\N
93	25027732301	2010	16.000	\N
93	25027732302	2010	45.000	\N
93	25027732400	2010	89.000	\N
93	25027732500	2010	12.000	\N
93	25027732600	2010	15.000	\N
93	25027732700	2010	9.000	\N
93	25027732801	2010	44.000	\N
93	25027732802	2010	39.000	\N
93	25027732901	2010	41.000	\N
93	25027732902	2010	3.000	\N
93	25027733000	2010	35.000	\N
93	25027733101	2010	23.000	\N
93	25027733102	2010	14.000	\N
93	25027735100	2010	15.000	\N
93	25027735200	2010	8.000	\N
93	25027736100	2010	1.000	\N
93	25027736200	2010	5.000	\N
93	25027736300	2010	7.000	\N
93	25027736400	2010	3.000	\N
93	25027736500	2010	4.000	\N
93	25027737100	2010	4.000	\N
93	25027737200	2010	3.000	\N
93	25027737300	2010	20.000	\N
93	25027738100	2010	12.000	\N
93	25027738201	2010	1.000	\N
93	25027738202	2010	18.000	\N
93	25027739100	2010	100.000	\N
93	25027739200	2010	123.000	\N
93	25027739300	2010	28.000	\N
93	25027739400	2010	53.000	\N
93	25027739500	2010	34.000	\N
93	25027740101	2010	21.000	\N
93	25027740102	2010	18.000	\N
93	25027740200	2010	8.000	\N
93	25027741101	2010	18.000	\N
93	25027741102	2010	18.000	\N
93	25027742300	2010	41.000	\N
93	25027742401	2010	5.000	\N
93	25027742402	2010	11.000	\N
93	25027743100	2010	6.000	\N
93	25027744101	2010	54.000	\N
93	25027744102	2010	59.000	\N
93	25027744200	2010	235.000	\N
93	25027744300	2010	221.000	\N
93	25027744400	2010	147.000	\N
93	25027745100	2010	18.000	\N
93	25027746100	2010	5.000	\N
93	25027747101	2010	2.000	\N
93	25027747102	2010	3.000	\N
93	25027748100	2010	0.000	\N
93	25027749100	2010	14.000	\N
93	25027749200	2010	10.000	\N
93	25027750100	2010	5.000	\N
93	25027750200	2010	11.000	\N
93	25027750300	2010	1.000	\N
93	25027751101	2010	5.000	\N
93	25027751102	2010	3.000	\N
93	25027752100	2010	9.000	\N
93	25027753100	2010	9.000	\N
93	25027753200	2010	1.000	\N
93	25027754100	2010	12.000	\N
93	25027754200	2010	13.000	\N
93	25027754300	2010	17.000	\N
93	25027754400	2010	9.000	\N
93	25027755100	2010	3.000	\N
93	25027755200	2010	16.000	\N
93	25027756101	2010	9.000	\N
93	25027756102	2010	2.000	\N
93	25027757100	2010	7.000	\N
93	25027757200	2010	0.000	\N
93	25027757300	2010	1.000	\N
93	25027757400	2010	4.000	\N
93	25027757500	2010	6.000	\N
93	25027758101	2010	0.000	\N
93	25027758102	2010	12.000	\N
93	25027759100	2010	1.000	\N
93	25027760100	2010	0.000	\N
93	25027761100	2010	3.000	\N
93	25027761200	2010	31.000	\N
93	25027761300	2010	8.000	\N
93	25027761400	2010	2.000	\N
94	25001010100	2010	45.000	\N
94	25001010206	2010	25.000	\N
94	25001010208	2010	24.000	\N
94	25001010304	2010	21.000	\N
94	25001010306	2010	29.000	\N
94	25001010400	2010	38.000	\N
94	25001010500	2010	22.000	\N
94	25001010600	2010	29.000	\N
94	25001010700	2010	29.000	\N
94	25001010800	2010	50.000	\N
94	25001010900	2010	39.000	\N
94	25001011002	2010	76.000	\N
94	25001011100	2010	104.000	\N
94	25001011200	2010	42.000	\N
94	25001011300	2010	16.000	\N
94	25001011400	2010	38.000	\N
94	25001011500	2010	67.000	\N
94	25001011600	2010	86.000	\N
94	25001011700	2010	21.000	\N
94	25001011801	2010	10.000	\N
94	25001011802	2010	56.000	\N
94	25001012001	2010	70.000	\N
94	25001012002	2010	74.000	\N
94	25001012101	2010	136.000	\N
94	25001012102	2010	79.000	\N
94	25001012200	2010	62.000	\N
94	25001012502	2010	90.000	\N
94	25001012601	2010	105.000	\N
94	25001012602	2010	327.000	\N
94	25001012700	2010	89.000	\N
94	25001012800	2010	73.000	\N
94	25001012900	2010	67.000	\N
94	25001013002	2010	53.000	\N
94	25001013100	2010	113.000	\N
94	25001013200	2010	63.000	\N
94	25001013300	2010	16.000	\N
94	25001013400	2010	24.000	\N
94	25001013500	2010	71.000	\N
94	25001013600	2010	74.000	\N
94	25001013700	2010	106.000	\N
94	25001013800	2010	94.000	\N
94	25001013900	2010	98.000	\N
94	25001014002	2010	71.000	\N
94	25001014100	2010	21.000	\N
94	25001014300	2010	52.000	\N
94	25001014402	2010	183.000	\N
94	25001014500	2010	188.000	\N
94	25001014600	2010	138.000	\N
94	25001014700	2010	93.000	\N
94	25001014800	2010	70.000	\N
94	25001014900	2010	66.000	\N
94	25001015001	2010	134.000	\N
94	25001015002	2010	141.000	\N
94	25001015100	2010	93.000	\N
94	25001015200	2010	15.000	\N
94	25001015300	2010	205.000	\N
94	25001990000	2010	0.000	\N
94	25003900100	2010	130.000	\N
94	25003900200	2010	194.000	\N
94	25003900300	2010	74.000	\N
94	25003900400	2010	123.000	\N
94	25003900500	2010	26.000	\N
94	25003900600	2010	212.000	\N
94	25003900700	2010	37.000	\N
94	25003900800	2010	63.000	\N
94	25003900900	2010	137.000	\N
94	25003901100	2010	50.000	\N
94	25003911100	2010	25.000	\N
94	25003912100	2010	68.000	\N
94	25003913100	2010	69.000	\N
94	25003914100	2010	39.000	\N
94	25003920101	2010	126.000	\N
94	25003920102	2010	88.000	\N
94	25003921300	2010	119.000	\N
94	25003921400	2010	38.000	\N
94	25003921500	2010	72.000	\N
94	25003922100	2010	40.000	\N
94	25003922200	2010	49.000	\N
94	25003922300	2010	26.000	\N
94	25003923100	2010	29.000	\N
94	25003924100	2010	16.000	\N
94	25003925100	2010	142.000	\N
94	25003926100	2010	30.000	\N
94	25003931100	2010	13.000	\N
94	25003931300	2010	29.000	\N
94	25003931400	2010	25.000	\N
94	25003932200	2010	21.000	\N
94	25003932300	2010	22.000	\N
94	25003933200	2010	2.000	\N
94	25003933300	2010	12.000	\N
94	25003933400	2010	30.000	\N
94	25003934200	2010	11.000	\N
94	25003934300	2010	16.000	\N
94	25003935100	2010	26.000	\N
94	25003935200	2010	70.000	\N
94	25003935300	2010	69.000	\N
94	25005600100	2010	38.000	\N
94	25005600202	2010	83.000	\N
94	25005600203	2010	62.000	\N
94	25005600204	2010	88.000	\N
94	25005610100	2010	60.000	\N
94	25005610202	2010	72.000	\N
94	25005610203	2010	73.000	\N
94	25005610204	2010	78.000	\N
94	25005611101	2010	63.000	\N
94	25005611102	2010	69.000	\N
94	25005611201	2010	43.000	\N
94	25005611202	2010	88.000	\N
94	25005612100	2010	38.000	\N
94	25005612200	2010	145.000	\N
94	25005613100	2010	107.000	\N
94	25005613300	2010	92.000	\N
94	25005613400	2010	119.000	\N
94	25005613600	2010	128.000	\N
94	25005613700	2010	136.000	\N
94	25005613800	2010	185.000	\N
94	25005613901	2010	93.000	\N
94	25005613902	2010	100.000	\N
94	25005614000	2010	214.000	\N
94	25005614101	2010	235.000	\N
94	25005614102	2010	118.000	\N
94	25005615100	2010	87.000	\N
94	25005616100	2010	70.000	\N
94	25005617101	2010	33.000	\N
94	25005617102	2010	50.000	\N
94	25005630101	2010	47.000	\N
94	25005630102	2010	61.000	\N
94	25005630200	2010	96.000	\N
94	25005630300	2010	115.000	\N
94	25005630400	2010	67.000	\N
94	25005631100	2010	105.000	\N
94	25005631200	2010	95.000	\N
94	25005631300	2010	88.000	\N
94	25005631400	2010	69.000	\N
94	25005631500	2010	83.000	\N
94	25005631600	2010	95.000	\N
94	25005631700	2010	85.000	\N
94	25005631800	2010	120.000	\N
94	25005632100	2010	71.000	\N
94	25005632200	2010	101.000	\N
94	25005633100	2010	55.000	\N
94	25005633200	2010	63.000	\N
94	25005640100	2010	117.000	\N
94	25005640200	2010	165.000	\N
94	25005640300	2010	93.000	\N
94	25005640400	2010	52.000	\N
94	25005640500	2010	123.000	\N
94	25005640600	2010	102.000	\N
94	25005640700	2010	28.000	\N
94	25005640800	2010	99.000	\N
94	25005640901	2010	165.000	\N
94	25005641000	2010	76.000	\N
94	25005641101	2010	55.000	\N
94	25005641200	2010	81.000	\N
94	25005641300	2010	140.000	\N
94	25005641400	2010	64.000	\N
94	25005641500	2010	58.000	\N
94	25005641600	2010	32.000	\N
94	25005641700	2010	65.000	\N
94	25005641800	2010	44.000	\N
94	25005641900	2010	58.000	\N
94	25005642000	2010	79.000	\N
94	25005642100	2010	80.000	\N
94	25005642200	2010	85.000	\N
94	25005642300	2010	18.000	\N
94	25005642400	2010	39.000	\N
94	25005642500	2010	45.000	\N
94	25005644101	2010	55.000	\N
94	25005644102	2010	63.000	\N
94	25005644200	2010	40.000	\N
94	25005645101	2010	43.000	\N
94	25005645102	2010	73.000	\N
94	25005645103	2010	43.000	\N
94	25005646101	2010	63.000	\N
94	25005646103	2010	41.000	\N
94	25005646104	2010	19.000	\N
94	25005650101	2010	107.000	\N
94	25005650102	2010	165.000	\N
94	25005650201	2010	44.000	\N
94	25005650202	2010	46.000	\N
94	25005650300	2010	86.000	\N
94	25005650400	2010	128.000	\N
94	25005650500	2010	104.000	\N
94	25005650600	2010	87.000	\N
94	25005650700	2010	82.000	\N
94	25005650800	2010	129.000	\N
94	25005650900	2010	121.000	\N
94	25005651001	2010	92.000	\N
94	25005651002	2010	189.000	\N
94	25005651100	2010	240.000	\N
94	25005651200	2010	90.000	\N
94	25005651300	2010	129.000	\N
94	25005651400	2010	249.000	\N
94	25005651500	2010	237.000	\N
94	25005651600	2010	276.000	\N
94	25005651700	2010	147.000	\N
94	25005651800	2010	99.000	\N
94	25005651900	2010	199.000	\N
94	25005652000	2010	186.000	\N
94	25005652100	2010	164.000	\N
94	25005652200	2010	91.000	\N
94	25005652300	2010	118.000	\N
94	25005652400	2010	79.000	\N
94	25005652500	2010	68.000	\N
94	25005652600	2010	100.000	\N
94	25005652700	2010	177.000	\N
94	25005652800	2010	83.000	\N
94	25005653101	2010	129.000	\N
94	25005653102	2010	82.000	\N
94	25005653203	2010	82.000	\N
94	25005653204	2010	60.000	\N
94	25005653301	2010	65.000	\N
94	25005653304	2010	44.000	\N
94	25005654100	2010	49.000	\N
94	25005654200	2010	58.000	\N
94	25005655100	2010	57.000	\N
94	25005655200	2010	63.000	\N
94	25005655300	2010	26.000	\N
94	25005655400	2010	46.000	\N
94	25005985500	2010	117.000	\N
94	25005985600	2010	55.000	\N
94	25005990000	2010	0.000	\N
94	25007200100	2010	120.000	\N
94	25007200200	2010	210.000	\N
94	25007200300	2010	103.000	\N
94	25007200400	2010	93.000	\N
94	25007990000	2010	0.000	\N
94	25009201100	2010	20.000	\N
94	25009202101	2010	29.000	\N
94	25009202102	2010	67.000	\N
94	25009202200	2010	59.000	\N
94	25009203100	2010	65.000	\N
94	25009203200	2010	43.000	\N
94	25009203301	2010	40.000	\N
94	25009203302	2010	52.000	\N
94	25009204101	2010	105.000	\N
94	25009204102	2010	71.000	\N
94	25009204200	2010	82.000	\N
94	25009204300	2010	55.000	\N
94	25009204400	2010	56.000	\N
94	25009204500	2010	64.000	\N
94	25009204600	2010	94.000	\N
94	25009204701	2010	105.000	\N
94	25009204702	2010	84.000	\N
94	25009205100	2010	107.000	\N
94	25009205200	2010	109.000	\N
94	25009205300	2010	72.000	\N
94	25009205400	2010	87.000	\N
94	25009205500	2010	95.000	\N
94	25009205600	2010	103.000	\N
94	25009205700	2010	71.000	\N
94	25009205800	2010	95.000	\N
94	25009205900	2010	98.000	\N
94	25009206000	2010	59.000	\N
94	25009206100	2010	72.000	\N
94	25009206200	2010	130.000	\N
94	25009206300	2010	125.000	\N
94	25009206400	2010	105.000	\N
94	25009206500	2010	107.000	\N
94	25009206600	2010	113.000	\N
94	25009206700	2010	107.000	\N
94	25009206800	2010	94.000	\N
94	25009206900	2010	87.000	\N
94	25009207000	2010	42.000	\N
94	25009207100	2010	82.000	\N
94	25009207200	2010	61.000	\N
94	25009208101	2010	69.000	\N
94	25009208102	2010	56.000	\N
94	25009208200	2010	52.000	\N
94	25009208300	2010	61.000	\N
94	25009208400	2010	70.000	\N
94	25009209100	2010	53.000	\N
94	25009209200	2010	41.000	\N
94	25009210100	2010	39.000	\N
94	25009210200	2010	47.000	\N
94	25009210300	2010	80.000	\N
94	25009210400	2010	71.000	\N
94	25009210500	2010	49.000	\N
94	25009210600	2010	62.000	\N
94	25009210700	2010	79.000	\N
94	25009210800	2010	79.000	\N
94	25009210900	2010	66.000	\N
94	25009211100	2010	38.000	\N
94	25009211200	2010	67.000	\N
94	25009211300	2010	28.000	\N
94	25009211401	2010	49.000	\N
94	25009211402	2010	41.000	\N
94	25009212100	2010	119.000	\N
94	25009213100	2010	82.000	\N
94	25009214100	2010	57.000	\N
94	25009215101	2010	38.000	\N
94	25009215102	2010	38.000	\N
94	25009216100	2010	38.000	\N
94	25009217100	2010	80.000	\N
94	25009217201	2010	46.000	\N
94	25009217202	2010	35.000	\N
94	25009217300	2010	97.000	\N
94	25009217400	2010	115.000	\N
94	25009217500	2010	71.000	\N
94	25009217600	2010	55.000	\N
94	25009218100	2010	49.000	\N
94	25009220101	2010	24.000	\N
94	25009220102	2010	35.000	\N
94	25009221100	2010	37.000	\N
94	25009221300	2010	35.000	\N
94	25009221400	2010	36.000	\N
94	25009221500	2010	31.000	\N
94	25009221600	2010	48.000	\N
94	25009221700	2010	38.000	\N
94	25009221800	2010	12.000	\N
94	25009221901	2010	22.000	\N
94	25009221902	2010	44.000	\N
94	25009222100	2010	39.000	\N
94	25009223100	2010	57.000	\N
94	25009223200	2010	43.000	\N
94	25009223300	2010	64.000	\N
94	25009250100	2010	9.000	\N
94	25009250200	2010	52.000	\N
94	25009250300	2010	6.000	\N
94	25009250400	2010	11.000	\N
94	25009250500	2010	19.000	\N
94	25009250600	2010	38.000	\N
94	25009250700	2010	10.000	\N
94	25009250800	2010	68.000	\N
94	25009250900	2010	4.000	\N
94	25009251000	2010	7.000	\N
94	25009251100	2010	19.000	\N
94	25009251200	2010	3.000	\N
94	25009251300	2010	13.000	\N
94	25009251400	2010	39.000	\N
94	25009251500	2010	45.000	\N
94	25009251600	2010	27.000	\N
94	25009251700	2010	56.000	\N
94	25009251800	2010	88.000	\N
94	25009252101	2010	54.000	\N
94	25009252102	2010	22.000	\N
94	25009252201	2010	19.000	\N
94	25009252202	2010	26.000	\N
94	25009252300	2010	75.000	\N
94	25009252400	2010	42.000	\N
94	25009252501	2010	49.000	\N
94	25009252502	2010	51.000	\N
94	25009252601	2010	56.000	\N
94	25009252602	2010	55.000	\N
94	25009252603	2010	32.000	\N
94	25009253100	2010	67.000	\N
94	25009253201	2010	29.000	\N
94	25009253202	2010	86.000	\N
94	25009253203	2010	29.000	\N
94	25009253204	2010	73.000	\N
94	25009253205	2010	48.000	\N
94	25009254100	2010	78.000	\N
94	25009254200	2010	76.000	\N
94	25009254301	2010	52.000	\N
94	25009254302	2010	67.000	\N
94	25009254401	2010	44.000	\N
94	25009254402	2010	104.000	\N
94	25009254403	2010	32.000	\N
94	25009260100	2010	90.000	\N
94	25009260200	2010	75.000	\N
94	25009260301	2010	46.000	\N
94	25009260302	2010	28.000	\N
94	25009260401	2010	46.000	\N
94	25009260402	2010	84.000	\N
94	25009260500	2010	46.000	\N
94	25009260600	2010	59.000	\N
94	25009260700	2010	83.000	\N
94	25009260800	2010	111.000	\N
94	25009260900	2010	80.000	\N
94	25009261000	2010	42.000	\N
94	25009261101	2010	43.000	\N
94	25009261102	2010	70.000	\N
94	25009262100	2010	68.000	\N
94	25009263100	2010	36.000	\N
94	25009264100	2010	48.000	\N
94	25009265101	2010	42.000	\N
94	25009265102	2010	42.000	\N
94	25009266100	2010	44.000	\N
94	25009266200	2010	74.000	\N
94	25009266300	2010	47.000	\N
94	25009266400	2010	41.000	\N
94	25009267101	2010	30.000	\N
94	25009267102	2010	76.000	\N
94	25009268100	2010	21.000	\N
94	25009268200	2010	90.000	\N
94	25009268300	2010	41.000	\N
94	25009268400	2010	44.000	\N
94	25009269100	2010	57.000	\N
94	25009270100	2010	43.000	\N
94	25009990100	2010	0.000	\N
94	25011040100	2010	77.000	\N
94	25011040200	2010	41.000	\N
94	25011040300	2010	34.000	\N
94	25011040400	2010	36.000	\N
94	25011040501	2010	61.000	\N
94	25011040502	2010	54.000	\N
94	25011040600	2010	128.000	\N
94	25011040701	2010	128.000	\N
94	25011040702	2010	69.000	\N
94	25011040800	2010	89.000	\N
94	25011040900	2010	77.000	\N
94	25011041000	2010	68.000	\N
94	25011041100	2010	37.000	\N
94	25011041200	2010	48.000	\N
94	25011041300	2010	111.000	\N
94	25011041400	2010	80.000	\N
94	25011041501	2010	68.000	\N
94	25011041502	2010	65.000	\N
94	25013800101	2010	85.000	\N
94	25013800102	2010	111.000	\N
94	25013800201	2010	139.000	\N
94	25013800202	2010	27.000	\N
94	25013800300	2010	97.000	\N
94	25013800400	2010	124.000	\N
94	25013800500	2010	27.000	\N
94	25013800600	2010	41.000	\N
94	25013800700	2010	20.000	\N
94	25013800800	2010	11.000	\N
94	25013800900	2010	49.000	\N
94	25013801101	2010	34.000	\N
94	25013801102	2010	32.000	\N
94	25013801200	2010	42.000	\N
94	25013801300	2010	135.000	\N
94	25013801401	2010	92.000	\N
94	25013801402	2010	57.000	\N
94	25013801501	2010	151.000	\N
94	25013801502	2010	148.000	\N
94	25013801503	2010	89.000	\N
94	25013801601	2010	119.000	\N
94	25013801602	2010	116.000	\N
94	25013801603	2010	108.000	\N
94	25013801604	2010	68.000	\N
94	25013801605	2010	119.000	\N
94	25013801700	2010	179.000	\N
94	25013801800	2010	95.000	\N
94	25013801901	2010	75.000	\N
94	25013801902	2010	65.000	\N
94	25013802000	2010	29.000	\N
94	25013802100	2010	129.000	\N
94	25013802200	2010	81.000	\N
94	25013802300	2010	126.000	\N
94	25013802400	2010	61.000	\N
94	25013802500	2010	129.000	\N
94	25013802601	2010	147.000	\N
94	25013802602	2010	31.000	\N
94	25013810100	2010	73.000	\N
94	25013810200	2010	35.000	\N
94	25013810300	2010	40.000	\N
94	25013810403	2010	85.000	\N
94	25013810404	2010	41.000	\N
94	25013810412	2010	49.000	\N
94	25013810414	2010	60.000	\N
94	25013810601	2010	44.000	\N
94	25013810602	2010	25.000	\N
94	25013810700	2010	102.000	\N
94	25013810800	2010	53.000	\N
94	25013810901	2010	30.000	\N
94	25013810902	2010	56.000	\N
94	25013811000	2010	48.000	\N
94	25013811101	2010	61.000	\N
94	25013811102	2010	81.000	\N
94	25013811200	2010	82.000	\N
94	25013811301	2010	60.000	\N
94	25013811302	2010	71.000	\N
94	25013811400	2010	20.000	\N
94	25013811500	2010	9.000	\N
94	25013811600	2010	26.000	\N
94	25013811700	2010	21.000	\N
94	25013811800	2010	60.000	\N
94	25013811900	2010	44.000	\N
94	25013812001	2010	46.000	\N
94	25013812002	2010	43.000	\N
94	25013812101	2010	58.000	\N
94	25013812103	2010	68.000	\N
94	25013812104	2010	47.000	\N
94	25013812201	2010	82.000	\N
94	25013812202	2010	54.000	\N
94	25013812300	2010	147.000	\N
94	25013812401	2010	47.000	\N
94	25013812403	2010	49.000	\N
94	25013812404	2010	67.000	\N
94	25013812500	2010	126.000	\N
94	25013812600	2010	78.000	\N
94	25013812701	2010	75.000	\N
94	25013812702	2010	72.000	\N
94	25013812800	2010	54.000	\N
94	25013812901	2010	25.000	\N
94	25013812902	2010	46.000	\N
94	25013812903	2010	47.000	\N
94	25013813000	2010	59.000	\N
94	25013813101	2010	59.000	\N
94	25013813102	2010	34.000	\N
94	25013813204	2010	24.000	\N
94	25013813205	2010	63.000	\N
94	25013813206	2010	48.000	\N
94	25013813207	2010	44.000	\N
94	25013813208	2010	44.000	\N
94	25013813209	2010	55.000	\N
94	25013813301	2010	99.000	\N
94	25013813303	2010	39.000	\N
94	25013813304	2010	37.000	\N
94	25013813401	2010	61.000	\N
94	25013813403	2010	24.000	\N
94	25013813404	2010	53.000	\N
94	25013813500	2010	50.000	\N
94	25013813601	2010	97.000	\N
94	25013813602	2010	38.000	\N
94	25013813701	2010	29.000	\N
94	25013813702	2010	64.000	\N
94	25013813801	2010	52.000	\N
94	25013813802	2010	52.000	\N
94	25015820101	2010	90.000	\N
94	25015820102	2010	97.000	\N
94	25015820202	2010	22.000	\N
94	25015820203	2010	130.000	\N
94	25015820204	2010	83.000	\N
94	25015820300	2010	221.000	\N
94	25015820400	2010	359.000	\N
94	25015820500	2010	144.000	\N
94	25015820600	2010	84.000	\N
94	25015820700	2010	168.000	\N
94	25015820801	2010	194.000	\N
94	25015820802	2010	47.000	\N
94	25015820900	2010	60.000	\N
94	25015821000	2010	33.000	\N
94	25015821100	2010	118.000	\N
94	25015821200	2010	101.000	\N
94	25015821300	2010	70.000	\N
94	25015821400	2010	72.000	\N
94	25015821500	2010	19.000	\N
94	25015821601	2010	52.000	\N
94	25015821602	2010	75.000	\N
94	25015821700	2010	68.000	\N
94	25015821901	2010	79.000	\N
94	25015821903	2010	59.000	\N
94	25015821904	2010	68.000	\N
94	25015822000	2010	88.000	\N
94	25015822200	2010	104.000	\N
94	25015822300	2010	68.000	\N
94	25015822401	2010	63.000	\N
94	25015822402	2010	70.000	\N
94	25015822500	2010	54.000	\N
94	25015822601	2010	35.000	\N
94	25015822603	2010	6.000	\N
94	25015822605	2010	7.000	\N
94	25015822606	2010	39.000	\N
94	25015822700	2010	33.000	\N
94	25017300100	2010	39.000	\N
94	25017301101	2010	58.000	\N
94	25017301102	2010	46.000	\N
94	25017310100	2010	133.000	\N
94	25017310200	2010	143.000	\N
94	25017310300	2010	152.000	\N
94	25017310400	2010	80.000	\N
94	25017310500	2010	56.000	\N
94	25017310601	2010	99.000	\N
94	25017310602	2010	119.000	\N
94	25017310700	2010	109.000	\N
94	25017311100	2010	44.000	\N
94	25017311200	2010	73.000	\N
94	25017311300	2010	71.000	\N
94	25017311400	2010	156.000	\N
94	25017311500	2010	67.000	\N
94	25017311600	2010	91.000	\N
94	25017311700	2010	165.000	\N
94	25017311800	2010	110.000	\N
94	25017311900	2010	66.000	\N
94	25017312000	2010	100.000	\N
94	25017312100	2010	91.000	\N
94	25017312200	2010	95.000	\N
94	25017312300	2010	102.000	\N
94	25017312400	2010	45.000	\N
94	25017312501	2010	73.000	\N
94	25017312502	2010	46.000	\N
94	25017313101	2010	70.000	\N
94	25017313102	2010	53.000	\N
94	25017314101	2010	67.000	\N
94	25017314102	2010	127.000	\N
94	25017314200	2010	51.000	\N
94	25017314301	2010	82.000	\N
94	25017314302	2010	18.000	\N
94	25017315100	2010	73.000	\N
94	25017315200	2010	69.000	\N
94	25017315401	2010	39.000	\N
94	25017315402	2010	25.000	\N
94	25017315403	2010	15.000	\N
94	25017315500	2010	83.000	\N
94	25017316101	2010	41.000	\N
94	25017316102	2010	59.000	\N
94	25017316201	2010	33.000	\N
94	25017316202	2010	64.000	\N
94	25017316300	2010	157.000	\N
94	25017316400	2010	65.000	\N
94	25017316500	2010	79.000	\N
94	25017317101	2010	76.000	\N
94	25017317102	2010	43.000	\N
94	25017317103	2010	41.000	\N
94	25017317201	2010	18.000	\N
94	25017317202	2010	55.000	\N
94	25017317203	2010	52.000	\N
94	25017317301	2010	24.000	\N
94	25017317302	2010	105.000	\N
94	25017318100	2010	88.000	\N
94	25017318200	2010	54.000	\N
94	25017318300	2010	123.000	\N
94	25017318400	2010	49.000	\N
94	25017320102	2010	77.000	\N
94	25017320103	2010	30.000	\N
94	25017320104	2010	52.000	\N
94	25017321100	2010	176.000	\N
94	25017321200	2010	242.000	\N
94	25017321300	2010	204.000	\N
94	25017321400	2010	49.000	\N
94	25017321500	2010	167.000	\N
94	25017321600	2010	175.000	\N
94	25017322100	2010	49.000	\N
94	25017322200	2010	83.000	\N
94	25017322300	2010	108.000	\N
94	25017322400	2010	99.000	\N
94	25017323100	2010	113.000	\N
94	25017324101	2010	76.000	\N
94	25017324102	2010	74.000	\N
94	25017325100	2010	203.000	\N
94	25017326101	2010	57.000	\N
94	25017326102	2010	78.000	\N
94	25017327101	2010	43.000	\N
94	25017327102	2010	51.000	\N
94	25017327103	2010	46.000	\N
94	25017328100	2010	32.000	\N
94	25017330100	2010	64.000	\N
94	25017330200	2010	85.000	\N
94	25017331101	2010	43.000	\N
94	25017331102	2010	69.000	\N
94	25017331200	2010	63.000	\N
94	25017331300	2010	88.000	\N
94	25017332100	2010	88.000	\N
94	25017332200	2010	137.000	\N
94	25017332300	2010	78.000	\N
94	25017332400	2010	52.000	\N
94	25017333100	2010	69.000	\N
94	25017333200	2010	56.000	\N
94	25017333300	2010	71.000	\N
94	25017333400	2010	107.000	\N
94	25017333501	2010	55.000	\N
94	25017333502	2010	96.000	\N
94	25017333600	2010	132.000	\N
94	25017334100	2010	69.000	\N
94	25017334200	2010	39.000	\N
94	25017334300	2010	52.000	\N
94	25017334400	2010	78.000	\N
94	25017335100	2010	47.000	\N
94	25017335200	2010	44.000	\N
94	25017335301	2010	60.000	\N
94	25017335302	2010	64.000	\N
94	25017335400	2010	40.000	\N
94	25017336100	2010	82.000	\N
94	25017336200	2010	62.000	\N
94	25017336300	2010	93.000	\N
94	25017336401	2010	88.000	\N
94	25017336402	2010	77.000	\N
94	25017337101	2010	45.000	\N
94	25017337102	2010	59.000	\N
94	25017337201	2010	25.000	\N
94	25017337202	2010	37.000	\N
94	25017337300	2010	65.000	\N
94	25017338100	2010	93.000	\N
94	25017338200	2010	107.000	\N
94	25017338300	2010	40.000	\N
94	25017338400	2010	78.000	\N
94	25017338500	2010	77.000	\N
94	25017339100	2010	93.000	\N
94	25017339200	2010	86.000	\N
94	25017339300	2010	138.000	\N
94	25017339400	2010	73.000	\N
94	25017339500	2010	166.000	\N
94	25017339600	2010	120.000	\N
94	25017339700	2010	111.000	\N
94	25017339801	2010	58.000	\N
94	25017339802	2010	126.000	\N
94	25017339900	2010	105.000	\N
94	25017340000	2010	86.000	\N
94	25017340100	2010	101.000	\N
94	25017341101	2010	73.000	\N
94	25017341102	2010	91.000	\N
94	25017341200	2010	132.000	\N
94	25017341300	2010	174.000	\N
94	25017341400	2010	166.000	\N
94	25017341500	2010	110.000	\N
94	25017341600	2010	205.000	\N
94	25017341700	2010	111.000	\N
94	25017341800	2010	219.000	\N
94	25017341901	2010	43.000	\N
94	25017341902	2010	202.000	\N
94	25017342101	2010	98.000	\N
94	25017342102	2010	104.000	\N
94	25017342201	2010	115.000	\N
94	25017342202	2010	83.000	\N
94	25017342300	2010	183.000	\N
94	25017342400	2010	181.000	\N
94	25017342500	2010	156.000	\N
94	25017342600	2010	75.000	\N
94	25017350103	2010	19.000	\N
94	25017350104	2010	240.000	\N
94	25017350200	2010	245.000	\N
94	25017350300	2010	58.000	\N
94	25017350400	2010	121.000	\N
94	25017350500	2010	38.000	\N
94	25017350600	2010	137.000	\N
94	25017350700	2010	167.000	\N
94	25017350800	2010	46.000	\N
94	25017350900	2010	78.000	\N
94	25017351000	2010	120.000	\N
94	25017351100	2010	103.000	\N
94	25017351203	2010	117.000	\N
94	25017351204	2010	118.000	\N
94	25017351300	2010	161.000	\N
94	25017351403	2010	94.000	\N
94	25017351404	2010	178.000	\N
94	25017351500	2010	96.000	\N
94	25017352101	2010	47.000	\N
94	25017352102	2010	56.000	\N
94	25017352200	2010	45.000	\N
94	25017352300	2010	109.000	\N
94	25017352400	2010	88.000	\N
94	25017352500	2010	130.000	\N
94	25017352600	2010	80.000	\N
94	25017352700	2010	70.000	\N
94	25017352800	2010	68.000	\N
94	25017352900	2010	58.000	\N
94	25017353000	2010	128.000	\N
94	25017353101	2010	137.000	\N
94	25017353102	2010	247.000	\N
94	25017353200	2010	153.000	\N
94	25017353300	2010	130.000	\N
94	25017353400	2010	140.000	\N
94	25017353500	2010	79.000	\N
94	25017353600	2010	165.000	\N
94	25017353700	2010	247.000	\N
94	25017353800	2010	127.000	\N
94	25017353900	2010	341.000	\N
94	25017354000	2010	121.000	\N
94	25017354100	2010	74.000	\N
94	25017354200	2010	72.000	\N
94	25017354300	2010	103.000	\N
94	25017354400	2010	62.000	\N
94	25017354500	2010	46.000	\N
94	25017354600	2010	160.000	\N
94	25017354700	2010	82.000	\N
94	25017354800	2010	53.000	\N
94	25017354900	2010	236.000	\N
94	25017355000	2010	103.000	\N
94	25017356100	2010	91.000	\N
94	25017356300	2010	112.000	\N
94	25017356400	2010	124.000	\N
94	25017356500	2010	144.000	\N
94	25017356601	2010	91.000	\N
94	25017356602	2010	69.000	\N
94	25017356701	2010	124.000	\N
94	25017356702	2010	154.000	\N
94	25017357100	2010	78.000	\N
94	25017357200	2010	77.000	\N
94	25017357300	2010	68.000	\N
94	25017357400	2010	57.000	\N
94	25017357500	2010	54.000	\N
94	25017357600	2010	47.000	\N
94	25017357700	2010	90.000	\N
94	25017357800	2010	118.000	\N
94	25017358100	2010	111.000	\N
94	25017358300	2010	170.000	\N
94	25017358400	2010	94.000	\N
94	25017358500	2010	115.000	\N
94	25017358600	2010	145.000	\N
94	25017358700	2010	111.000	\N
94	25017359100	2010	99.000	\N
94	25017359300	2010	119.000	\N
94	25017360100	2010	70.000	\N
94	25017360200	2010	102.000	\N
94	25017361100	2010	56.000	\N
94	25017361200	2010	67.000	\N
94	25017361300	2010	92.000	\N
94	25017362100	2010	89.000	\N
94	25017363102	2010	100.000	\N
94	25017363103	2010	49.000	\N
94	25017363104	2010	75.000	\N
94	25017363201	2010	54.000	\N
94	25017363202	2010	62.000	\N
94	25017364101	2010	61.000	\N
94	25017364102	2010	60.000	\N
94	25017365100	2010	130.000	\N
94	25017365201	2010	96.000	\N
94	25017365202	2010	63.000	\N
94	25017366100	2010	59.000	\N
94	25017366201	2010	55.000	\N
94	25017366202	2010	71.000	\N
94	25017367100	2010	64.000	\N
94	25017367200	2010	148.000	\N
94	25017368101	2010	100.000	\N
94	25017368102	2010	70.000	\N
94	25017368200	2010	85.000	\N
94	25017368300	2010	69.000	\N
94	25017368400	2010	182.000	\N
94	25017368500	2010	49.000	\N
94	25017368600	2010	71.000	\N
94	25017368700	2010	48.000	\N
94	25017368800	2010	67.000	\N
94	25017368901	2010	99.000	\N
94	25017368902	2010	87.000	\N
94	25017369000	2010	29.000	\N
94	25017369100	2010	56.000	\N
94	25017370101	2010	108.000	\N
94	25017370102	2010	151.000	\N
94	25017370201	2010	98.000	\N
94	25017370202	2010	61.000	\N
94	25017370300	2010	196.000	\N
94	25017370400	2010	100.000	\N
94	25017373100	2010	108.000	\N
94	25017373200	2010	70.000	\N
94	25017373300	2010	62.000	\N
94	25017373400	2010	67.000	\N
94	25017373500	2010	143.000	\N
94	25017373600	2010	142.000	\N
94	25017373700	2010	105.000	\N
94	25017373800	2010	121.000	\N
94	25017373900	2010	101.000	\N
94	25017374000	2010	99.000	\N
94	25017374100	2010	107.000	\N
94	25017374200	2010	75.000	\N
94	25017374300	2010	65.000	\N
94	25017374400	2010	126.000	\N
94	25017374500	2010	105.000	\N
94	25017374600	2010	81.000	\N
94	25017374700	2010	92.000	\N
94	25017374800	2010	65.000	\N
94	25017382100	2010	68.000	\N
94	25017382200	2010	88.000	\N
94	25017382300	2010	102.000	\N
94	25017382400	2010	61.000	\N
94	25017382500	2010	80.000	\N
94	25017382601	2010	105.000	\N
94	25017382602	2010	84.000	\N
94	25017383101	2010	467.000	\N
94	25017383102	2010	334.000	\N
94	25017383200	2010	325.000	\N
94	25017383300	2010	98.000	\N
94	25017383400	2010	305.000	\N
94	25017383501	2010	156.000	\N
94	25017383502	2010	113.000	\N
94	25017383600	2010	131.000	\N
94	25017383700	2010	126.000	\N
94	25017383800	2010	135.000	\N
94	25017383901	2010	115.000	\N
94	25017383902	2010	93.000	\N
94	25017384001	2010	25.000	\N
94	25017384002	2010	172.000	\N
94	25017385100	2010	97.000	\N
94	25017385201	2010	40.000	\N
94	25017385202	2010	115.000	\N
94	25017386100	2010	53.000	\N
94	25017387100	2010	52.000	\N
94	25017387201	2010	50.000	\N
94	25017387202	2010	31.000	\N
94	25017388100	2010	90.000	\N
94	25017388200	2010	109.000	\N
94	25017388300	2010	128.000	\N
94	25017980000	2010	0.000	\N
94	25019950100	2010	7.000	\N
94	25019950200	2010	98.000	\N
94	25019950307	2010	4.000	\N
94	25019950400	2010	36.000	\N
94	25019950500	2010	10.000	\N
94	25019990000	2010	0.000	\N
94	25021400100	2010	137.000	\N
94	25021400200	2010	144.000	\N
94	25021400300	2010	136.000	\N
94	25021400400	2010	111.000	\N
94	25021400500	2010	116.000	\N
94	25021400600	2010	119.000	\N
94	25021400700	2010	138.000	\N
94	25021400800	2010	143.000	\N
94	25021400900	2010	103.000	\N
94	25021401000	2010	107.000	\N
94	25021401100	2010	80.000	\N
94	25021401200	2010	168.000	\N
94	25021402101	2010	46.000	\N
94	25021402102	2010	70.000	\N
94	25021402200	2010	19.000	\N
94	25021402300	2010	54.000	\N
94	25021402400	2010	78.000	\N
94	25021402500	2010	38.000	\N
94	25021403100	2010	77.000	\N
94	25021403300	2010	59.000	\N
94	25021403400	2010	120.000	\N
94	25021403500	2010	106.000	\N
94	25021404100	2010	95.000	\N
94	25021404201	2010	62.000	\N
94	25021404202	2010	113.000	\N
94	25021404301	2010	63.000	\N
94	25021404302	2010	69.000	\N
94	25021404400	2010	138.000	\N
94	25021405100	2010	72.000	\N
94	25021406101	2010	58.000	\N
94	25021406102	2010	73.000	\N
94	25021407100	2010	103.000	\N
94	25021408101	2010	84.000	\N
94	25021408102	2010	62.000	\N
94	25021409101	2010	29.000	\N
94	25021409102	2010	42.000	\N
94	25021410100	2010	58.000	\N
94	25021410300	2010	39.000	\N
94	25021410400	2010	76.000	\N
94	25021411100	2010	63.000	\N
94	25021411200	2010	60.000	\N
94	25021411301	2010	45.000	\N
94	25021411302	2010	29.000	\N
94	25021412100	2010	53.000	\N
94	25021412200	2010	27.000	\N
94	25021412300	2010	43.000	\N
94	25021413100	2010	76.000	\N
94	25021413200	2010	55.000	\N
94	25021413300	2010	64.000	\N
94	25021413401	2010	41.000	\N
94	25021413402	2010	76.000	\N
94	25021413500	2010	104.000	\N
94	25021414100	2010	104.000	\N
94	25021414200	2010	119.000	\N
94	25021414300	2010	60.000	\N
94	25021415101	2010	54.000	\N
94	25021415102	2010	109.000	\N
94	25021415200	2010	106.000	\N
94	25021415300	2010	33.000	\N
94	25021416101	2010	82.000	\N
94	25021416102	2010	81.000	\N
94	25021416200	2010	225.000	\N
94	25021416300	2010	132.000	\N
94	25021416400	2010	84.000	\N
94	25021417100	2010	57.000	\N
94	25021417200	2010	123.000	\N
94	25021417300	2010	38.000	\N
94	25021417400	2010	25.000	\N
94	25021417501	2010	85.000	\N
94	25021417502	2010	70.000	\N
94	25021417601	2010	75.000	\N
94	25021417602	2010	89.000	\N
94	25021417701	2010	87.000	\N
94	25021417702	2010	28.000	\N
94	25021417801	2010	83.000	\N
94	25021417802	2010	99.000	\N
94	25021417901	2010	136.000	\N
94	25021417902	2010	88.000	\N
94	25021418002	2010	131.000	\N
94	25021418003	2010	68.000	\N
94	25021418004	2010	110.000	\N
94	25021418101	2010	55.000	\N
94	25021418102	2010	91.000	\N
94	25021418200	2010	148.000	\N
94	25021419100	2010	89.000	\N
94	25021419200	2010	64.000	\N
94	25021419300	2010	94.000	\N
94	25021419400	2010	33.000	\N
94	25021419500	2010	39.000	\N
94	25021419600	2010	70.000	\N
94	25021419700	2010	23.000	\N
94	25021419800	2010	72.000	\N
94	25021420100	2010	209.000	\N
94	25021420201	2010	101.000	\N
94	25021420202	2010	182.000	\N
94	25021420301	2010	190.000	\N
94	25021420302	2010	230.000	\N
94	25021421100	2010	137.000	\N
94	25021421200	2010	99.000	\N
94	25021422100	2010	63.000	\N
94	25021422200	2010	95.000	\N
94	25021422301	2010	41.000	\N
94	25021422302	2010	119.000	\N
94	25021422400	2010	158.000	\N
94	25021422501	2010	99.000	\N
94	25021422502	2010	121.000	\N
94	25021422600	2010	80.000	\N
94	25021422700	2010	56.000	\N
94	25021422800	2010	31.000	\N
94	25021423100	2010	81.000	\N
94	25021440100	2010	74.000	\N
94	25021441202	2010	18.000	\N
94	25021441203	2010	36.000	\N
94	25021441204	2010	33.000	\N
94	25021442101	2010	58.000	\N
94	25021442102	2010	69.000	\N
94	25021442103	2010	96.000	\N
94	25021442201	2010	61.000	\N
94	25021442202	2010	123.000	\N
94	25021443101	2010	82.000	\N
94	25021443102	2010	115.000	\N
94	25021456101	2010	75.000	\N
94	25021456102	2010	153.000	\N
94	25021456200	2010	84.000	\N
94	25021456301	2010	70.000	\N
94	25021456302	2010	62.000	\N
94	25021456401	2010	86.000	\N
94	25021456402	2010	83.000	\N
94	25021457100	2010	55.000	\N
94	25021457200	2010	74.000	\N
94	25023500101	2010	57.000	\N
94	25023500103	2010	29.000	\N
94	25023500104	2010	62.000	\N
94	25023501101	2010	30.000	\N
94	25023501102	2010	113.000	\N
94	25023501201	2010	46.000	\N
94	25023501202	2010	65.000	\N
94	25023502101	2010	116.000	\N
94	25023502102	2010	121.000	\N
94	25023502200	2010	67.000	\N
94	25023503101	2010	70.000	\N
94	25023503102	2010	51.000	\N
94	25023504101	2010	45.000	\N
94	25023504102	2010	51.000	\N
94	25023505101	2010	82.000	\N
94	25023505102	2010	72.000	\N
94	25023505200	2010	63.000	\N
94	25023506101	2010	70.000	\N
94	25023506102	2010	60.000	\N
94	25023506202	2010	17.000	\N
94	25023506203	2010	46.000	\N
94	25023506204	2010	39.000	\N
94	25023507101	2010	40.000	\N
94	25023507103	2010	40.000	\N
94	25023507104	2010	34.000	\N
94	25023508101	2010	69.000	\N
94	25023508102	2010	47.000	\N
94	25023508200	2010	48.000	\N
94	25023509101	2010	86.000	\N
94	25023509102	2010	61.000	\N
94	25023510100	2010	173.000	\N
94	25023510200	2010	265.000	\N
94	25023510300	2010	410.000	\N
94	25023510400	2010	258.000	\N
94	25023510501	2010	228.000	\N
94	25023510502	2010	312.000	\N
94	25023510503	2010	242.000	\N
94	25023510600	2010	75.000	\N
94	25023510700	2010	285.000	\N
94	25023510800	2010	457.000	\N
94	25023510900	2010	203.000	\N
94	25023511000	2010	229.000	\N
94	25023511100	2010	185.000	\N
94	25023511200	2010	238.000	\N
94	25023511301	2010	414.000	\N
94	25023511302	2010	149.000	\N
94	25023511400	2010	298.000	\N
94	25023511500	2010	412.000	\N
94	25023511600	2010	423.000	\N
94	25023511701	2010	151.000	\N
94	25023511702	2010	89.000	\N
94	25023520100	2010	79.000	\N
94	25023520201	2010	39.000	\N
94	25023520202	2010	76.000	\N
94	25023521101	2010	53.000	\N
94	25023521102	2010	60.000	\N
94	25023521201	2010	43.000	\N
94	25023521202	2010	49.000	\N
94	25023522101	2010	66.000	\N
94	25023522102	2010	67.000	\N
94	25023523100	2010	55.000	\N
94	25023523201	2010	49.000	\N
94	25023523202	2010	69.000	\N
94	25023524101	2010	41.000	\N
94	25023524102	2010	52.000	\N
94	25023525101	2010	95.000	\N
94	25023525104	2010	71.000	\N
94	25023525203	2010	74.000	\N
94	25023525204	2010	59.000	\N
94	25023525300	2010	5.000	\N
94	25023526100	2010	93.000	\N
94	25023530100	2010	51.000	\N
94	25023530200	2010	132.000	\N
94	25023530300	2010	89.000	\N
94	25023530400	2010	44.000	\N
94	25023530500	2010	144.000	\N
94	25023530600	2010	51.000	\N
94	25023530700	2010	44.000	\N
94	25023530801	2010	65.000	\N
94	25023530802	2010	83.000	\N
94	25023530901	2010	150.000	\N
94	25023530902	2010	59.000	\N
94	25023540101	2010	41.000	\N
94	25023540102	2010	28.000	\N
94	25023540103	2010	38.000	\N
94	25023541100	2010	87.000	\N
94	25023542101	2010	99.000	\N
94	25023542102	2010	36.000	\N
94	25023542200	2010	54.000	\N
94	25023542300	2010	151.000	\N
94	25023543100	2010	24.000	\N
94	25023544100	2010	105.000	\N
94	25023544200	2010	72.000	\N
94	25023545100	2010	229.000	\N
94	25023545200	2010	230.000	\N
94	25023545300	2010	201.000	\N
94	25023545400	2010	211.000	\N
94	25023560100	2010	72.000	\N
94	25023561100	2010	104.000	\N
94	25023561200	2010	69.000	\N
94	25023990003	2010	0.000	\N
94	25025000100	2010	155.000	\N
94	25025000201	2010	76.000	\N
94	25025000202	2010	59.000	\N
94	25025000301	2010	57.000	\N
94	25025000302	2010	48.000	\N
94	25025000401	2010	99.000	\N
94	25025000402	2010	83.000	\N
94	25025000502	2010	142.000	\N
94	25025000503	2010	44.000	\N
94	25025000504	2010	82.000	\N
94	25025000601	2010	85.000	\N
94	25025000602	2010	104.000	\N
94	25025000701	2010	106.000	\N
94	25025000703	2010	93.000	\N
94	25025000704	2010	111.000	\N
94	25025000802	2010	236.000	\N
94	25025000803	2010	255.000	\N
94	25025010103	2010	165.000	\N
94	25025010104	2010	138.000	\N
94	25025010203	2010	165.000	\N
94	25025010204	2010	92.000	\N
94	25025010300	2010	143.000	\N
94	25025010403	2010	81.000	\N
94	25025010404	2010	137.000	\N
94	25025010405	2010	150.000	\N
94	25025010408	2010	19.000	\N
94	25025010500	2010	53.000	\N
94	25025010600	2010	40.000	\N
94	25025010701	2010	49.000	\N
94	25025010702	2010	37.000	\N
94	25025010801	2010	52.000	\N
94	25025010802	2010	59.000	\N
94	25025020101	2010	39.000	\N
94	25025020200	2010	66.000	\N
94	25025020301	2010	39.000	\N
94	25025020302	2010	14.000	\N
94	25025020303	2010	72.000	\N
94	25025030100	2010	12.000	\N
94	25025030200	2010	16.000	\N
94	25025030300	2010	78.000	\N
94	25025030400	2010	22.000	\N
94	25025030500	2010	24.000	\N
94	25025040100	2010	15.000	\N
94	25025040200	2010	23.000	\N
94	25025040300	2010	43.000	\N
94	25025040401	2010	30.000	\N
94	25025040600	2010	20.000	\N
94	25025040801	2010	71.000	\N
94	25025050101	2010	88.000	\N
94	25025050200	2010	82.000	\N
94	25025050300	2010	62.000	\N
94	25025050400	2010	47.000	\N
94	25025050500	2010	31.000	\N
94	25025050600	2010	32.000	\N
94	25025050700	2010	46.000	\N
94	25025050901	2010	37.000	\N
94	25025051000	2010	47.000	\N
94	25025051101	2010	89.000	\N
94	25025051200	2010	43.000	\N
94	25025060101	2010	19.000	\N
94	25025060200	2010	9.000	\N
94	25025060301	2010	22.000	\N
94	25025060400	2010	44.000	\N
94	25025060501	2010	27.000	\N
94	25025060600	2010	33.000	\N
94	25025060700	2010	58.000	\N
94	25025060800	2010	41.000	\N
94	25025061000	2010	61.000	\N
94	25025061101	2010	50.000	\N
94	25025061200	2010	36.000	\N
94	25025070101	2010	123.000	\N
94	25025070200	2010	76.000	\N
94	25025070300	2010	71.000	\N
94	25025070402	2010	20.000	\N
94	25025070500	2010	89.000	\N
94	25025070600	2010	48.000	\N
94	25025070700	2010	72.000	\N
94	25025070800	2010	90.000	\N
94	25025070900	2010	95.000	\N
94	25025071101	2010	84.000	\N
94	25025071201	2010	58.000	\N
94	25025080100	2010	111.000	\N
94	25025080300	2010	41.000	\N
94	25025080401	2010	80.000	\N
94	25025080500	2010	50.000	\N
94	25025080601	2010	90.000	\N
94	25025080801	2010	74.000	\N
94	25025080900	2010	88.000	\N
94	25025081001	2010	120.000	\N
94	25025081100	2010	83.000	\N
94	25025081200	2010	87.000	\N
94	25025081300	2010	95.000	\N
94	25025081400	2010	88.000	\N
94	25025081500	2010	51.000	\N
94	25025081700	2010	125.000	\N
94	25025081800	2010	98.000	\N
94	25025081900	2010	94.000	\N
94	25025082000	2010	66.000	\N
94	25025082100	2010	111.000	\N
94	25025090100	2010	115.000	\N
94	25025090200	2010	49.000	\N
94	25025090300	2010	95.000	\N
94	25025090400	2010	177.000	\N
94	25025090600	2010	195.000	\N
94	25025090700	2010	100.000	\N
94	25025090901	2010	84.000	\N
94	25025091001	2010	82.000	\N
94	25025091100	2010	177.000	\N
94	25025091200	2010	198.000	\N
94	25025091300	2010	201.000	\N
94	25025091400	2010	181.000	\N
94	25025091500	2010	352.000	\N
94	25025091600	2010	175.000	\N
94	25025091700	2010	204.000	\N
94	25025091800	2010	212.000	\N
94	25025091900	2010	117.000	\N
94	25025092000	2010	258.000	\N
94	25025092101	2010	223.000	\N
94	25025092200	2010	123.000	\N
94	25025092300	2010	99.000	\N
94	25025092400	2010	146.000	\N
94	25025100100	2010	127.000	\N
94	25025100200	2010	72.000	\N
94	25025100300	2010	93.000	\N
94	25025100400	2010	169.000	\N
94	25025100500	2010	206.000	\N
94	25025100601	2010	133.000	\N
94	25025100603	2010	44.000	\N
94	25025100700	2010	34.000	\N
94	25025100800	2010	182.000	\N
94	25025100900	2010	113.000	\N
94	25025101001	2010	127.000	\N
94	25025101002	2010	132.000	\N
94	25025101101	2010	96.000	\N
94	25025101102	2010	84.000	\N
94	25025110103	2010	166.000	\N
94	25025110201	2010	41.000	\N
94	25025110301	2010	64.000	\N
94	25025110401	2010	79.000	\N
94	25025110403	2010	94.000	\N
94	25025110501	2010	70.000	\N
94	25025110502	2010	88.000	\N
94	25025110601	2010	39.000	\N
94	25025110607	2010	79.000	\N
94	25025120103	2010	43.000	\N
94	25025120104	2010	43.000	\N
94	25025120105	2010	70.000	\N
94	25025120201	2010	76.000	\N
94	25025120301	2010	104.000	\N
94	25025120400	2010	160.000	\N
94	25025120500	2010	49.000	\N
94	25025120600	2010	70.000	\N
94	25025120700	2010	44.000	\N
94	25025130100	2010	112.000	\N
94	25025130200	2010	52.000	\N
94	25025130300	2010	85.000	\N
94	25025130402	2010	54.000	\N
94	25025130404	2010	43.000	\N
94	25025130406	2010	103.000	\N
94	25025140102	2010	99.000	\N
94	25025140105	2010	90.000	\N
94	25025140106	2010	48.000	\N
94	25025140107	2010	40.000	\N
94	25025140201	2010	49.000	\N
94	25025140202	2010	113.000	\N
94	25025140300	2010	118.000	\N
94	25025140400	2010	180.000	\N
94	25025160101	2010	85.000	\N
94	25025160200	2010	44.000	\N
94	25025160300	2010	56.000	\N
94	25025160400	2010	37.000	\N
94	25025160501	2010	130.000	\N
94	25025160502	2010	113.000	\N
94	25025160601	2010	55.000	\N
94	25025160602	2010	47.000	\N
94	25025170100	2010	127.000	\N
94	25025170200	2010	77.000	\N
94	25025170300	2010	157.000	\N
94	25025170400	2010	102.000	\N
94	25025170501	2010	59.000	\N
94	25025170502	2010	35.000	\N
94	25025170601	2010	77.000	\N
94	25025170701	2010	38.000	\N
94	25025170702	2010	126.000	\N
94	25025170800	2010	89.000	\N
94	25025180101	2010	67.000	\N
94	25025180200	2010	48.000	\N
94	25025180301	2010	35.000	\N
94	25025180400	2010	21.000	\N
94	25025180500	2010	73.000	\N
94	25025980101	2010	8.000	\N
94	25025980300	2010	4.000	\N
94	25025980700	2010	0.000	\N
94	25025981000	2010	5.000	\N
94	25025981100	2010	6.000	\N
94	25025981201	2010	0.000	\N
94	25025981202	2010	1.000	\N
94	25025981300	2010	14.000	\N
94	25025981501	2010	0.000	\N
94	25025981502	2010	0.000	\N
94	25025981600	2010	0.000	\N
94	25025981700	2010	0.000	\N
94	25025981800	2010	0.000	\N
94	25025990101	2010	0.000	\N
94	25027700100	2010	79.000	\N
94	25027701100	2010	97.000	\N
94	25027702200	2010	43.000	\N
94	25027703100	2010	52.000	\N
94	25027703200	2010	53.000	\N
94	25027703300	2010	52.000	\N
94	25027704200	2010	31.000	\N
94	25027705100	2010	99.000	\N
94	25027706100	2010	44.000	\N
94	25027707100	2010	63.000	\N
94	25027707200	2010	29.000	\N
94	25027707300	2010	85.000	\N
94	25027707400	2010	79.000	\N
94	25027707500	2010	85.000	\N
94	25027708100	2010	63.000	\N
94	25027709100	2010	84.000	\N
94	25027709201	2010	102.000	\N
94	25027709202	2010	158.000	\N
94	25027709400	2010	98.000	\N
94	25027709501	2010	24.000	\N
94	25027709502	2010	97.000	\N
94	25027709600	2010	48.000	\N
94	25027709701	2010	103.000	\N
94	25027709702	2010	42.000	\N
94	25027710100	2010	54.000	\N
94	25027710200	2010	111.000	\N
94	25027710300	2010	66.000	\N
94	25027710400	2010	22.000	\N
94	25027710500	2010	97.000	\N
94	25027710600	2010	178.000	\N
94	25027710700	2010	48.000	\N
94	25027710800	2010	103.000	\N
94	25027711000	2010	102.000	\N
94	25027711100	2010	78.000	\N
94	25027712101	2010	67.000	\N
94	25027712102	2010	65.000	\N
94	25027713100	2010	85.000	\N
94	25027715100	2010	70.000	\N
94	25027716100	2010	122.000	\N
94	25027716200	2010	38.000	\N
94	25027716300	2010	41.000	\N
94	25027717100	2010	36.000	\N
94	25027718100	2010	63.000	\N
94	25027719100	2010	67.000	\N
94	25027720100	2010	32.000	\N
94	25027721101	2010	17.000	\N
94	25027721102	2010	79.000	\N
94	25027722100	2010	68.000	\N
94	25027723100	2010	39.000	\N
94	25027724100	2010	37.000	\N
94	25027725100	2010	62.000	\N
94	25027726100	2010	43.000	\N
94	25027726200	2010	74.000	\N
94	25027727100	2010	49.000	\N
94	25027728100	2010	54.000	\N
94	25027728200	2010	42.000	\N
94	25027728300	2010	30.000	\N
94	25027728400	2010	50.000	\N
94	25027729100	2010	29.000	\N
94	25027729200	2010	14.000	\N
94	25027730100	2010	121.000	\N
94	25027730200	2010	82.000	\N
94	25027730300	2010	127.000	\N
94	25027730401	2010	112.000	\N
94	25027730402	2010	47.000	\N
94	25027730500	2010	99.000	\N
94	25027730600	2010	120.000	\N
94	25027730700	2010	133.000	\N
94	25027730801	2010	65.000	\N
94	25027730802	2010	50.000	\N
94	25027730901	2010	63.000	\N
94	25027730902	2010	78.000	\N
94	25027731001	2010	23.000	\N
94	25027731002	2010	158.000	\N
94	25027731101	2010	89.000	\N
94	25027731102	2010	63.000	\N
94	25027731202	2010	45.000	\N
94	25027731203	2010	98.000	\N
94	25027731204	2010	58.000	\N
94	25027731300	2010	99.000	\N
94	25027731400	2010	147.000	\N
94	25027731500	2010	131.000	\N
94	25027731600	2010	190.000	\N
94	25027731700	2010	77.000	\N
94	25027731800	2010	220.000	\N
94	25027731900	2010	143.000	\N
94	25027732001	2010	79.000	\N
94	25027732002	2010	87.000	\N
94	25027732201	2010	59.000	\N
94	25027732202	2010	73.000	\N
94	25027732203	2010	90.000	\N
94	25027732301	2010	71.000	\N
94	25027732302	2010	141.000	\N
94	25027732400	2010	194.000	\N
94	25027732500	2010	64.000	\N
94	25027732600	2010	149.000	\N
94	25027732700	2010	92.000	\N
94	25027732801	2010	73.000	\N
94	25027732802	2010	71.000	\N
94	25027732901	2010	127.000	\N
94	25027732902	2010	35.000	\N
94	25027733000	2010	104.000	\N
94	25027733101	2010	36.000	\N
94	25027733102	2010	34.000	\N
94	25027735100	2010	79.000	\N
94	25027735200	2010	62.000	\N
94	25027736100	2010	32.000	\N
94	25027736200	2010	54.000	\N
94	25027736300	2010	35.000	\N
94	25027736400	2010	30.000	\N
94	25027736500	2010	32.000	\N
94	25027737100	2010	72.000	\N
94	25027737200	2010	26.000	\N
94	25027737300	2010	80.000	\N
94	25027738100	2010	98.000	\N
94	25027738201	2010	54.000	\N
94	25027738202	2010	72.000	\N
94	25027739100	2010	173.000	\N
94	25027739200	2010	96.000	\N
94	25027739300	2010	66.000	\N
94	25027739400	2010	151.000	\N
94	25027739500	2010	93.000	\N
94	25027740101	2010	106.000	\N
94	25027740102	2010	91.000	\N
94	25027740200	2010	78.000	\N
94	25027741101	2010	55.000	\N
94	25027741102	2010	93.000	\N
94	25027742300	2010	53.000	\N
94	25027742401	2010	89.000	\N
94	25027742402	2010	30.000	\N
94	25027743100	2010	93.000	\N
94	25027744101	2010	169.000	\N
94	25027744102	2010	96.000	\N
94	25027744200	2010	130.000	\N
94	25027744300	2010	119.000	\N
94	25027744400	2010	106.000	\N
94	25027745100	2010	63.000	\N
94	25027746100	2010	52.000	\N
94	25027747101	2010	61.000	\N
94	25027747102	2010	48.000	\N
94	25027748100	2010	27.000	\N
94	25027749100	2010	101.000	\N
94	25027749200	2010	69.000	\N
94	25027750100	2010	98.000	\N
94	25027750200	2010	59.000	\N
94	25027750300	2010	44.000	\N
94	25027751101	2010	73.000	\N
94	25027751102	2010	30.000	\N
94	25027752100	2010	122.000	\N
94	25027753100	2010	89.000	\N
94	25027753200	2010	62.000	\N
94	25027754100	2010	69.000	\N
94	25027754200	2010	65.000	\N
94	25027754300	2010	72.000	\N
94	25027754400	2010	60.000	\N
94	25027755100	2010	47.000	\N
94	25027755200	2010	87.000	\N
94	25027756101	2010	55.000	\N
94	25027756102	2010	91.000	\N
94	25027757100	2010	47.000	\N
94	25027757200	2010	35.000	\N
94	25027757300	2010	28.000	\N
94	25027757400	2010	33.000	\N
94	25027757500	2010	48.000	\N
94	25027758101	2010	14.000	\N
94	25027758102	2010	83.000	\N
94	25027759100	2010	30.000	\N
94	25027760100	2010	61.000	\N
94	25027761100	2010	61.000	\N
94	25027761200	2010	130.000	\N
94	25027761300	2010	48.000	\N
94	25027761400	2010	106.000	\N
95	25001010100	2010	142.000	\N
95	25001010206	2010	41.000	\N
95	25001010208	2010	41.000	\N
95	25001010304	2010	40.000	\N
95	25001010306	2010	35.000	\N
95	25001010400	2010	61.000	\N
95	25001010500	2010	20.000	\N
95	25001010600	2010	50.000	\N
95	25001010700	2010	58.000	\N
95	25001010800	2010	69.000	\N
95	25001010900	2010	97.000	\N
95	25001011002	2010	69.000	\N
95	25001011100	2010	74.000	\N
95	25001011200	2010	35.000	\N
95	25001011300	2010	39.000	\N
95	25001011400	2010	77.000	\N
95	25001011500	2010	86.000	\N
95	25001011600	2010	68.000	\N
95	25001011700	2010	36.000	\N
95	25001011801	2010	19.000	\N
95	25001011802	2010	57.000	\N
95	25001012001	2010	123.000	\N
95	25001012002	2010	121.000	\N
95	25001012101	2010	187.000	\N
95	25001012102	2010	114.000	\N
95	25001012200	2010	43.000	\N
95	25001012502	2010	134.000	\N
95	25001012601	2010	148.000	\N
95	25001012602	2010	410.000	\N
95	25001012700	2010	113.000	\N
95	25001012800	2010	72.000	\N
95	25001012900	2010	72.000	\N
95	25001013002	2010	36.000	\N
95	25001013100	2010	116.000	\N
95	25001013200	2010	88.000	\N
95	25001013300	2010	28.000	\N
95	25001013400	2010	44.000	\N
95	25001013500	2010	81.000	\N
95	25001013600	2010	120.000	\N
95	25001013700	2010	80.000	\N
95	25001013800	2010	95.000	\N
95	25001013900	2010	40.000	\N
95	25001014002	2010	48.000	\N
95	25001014100	2010	94.000	\N
95	25001014300	2010	50.000	\N
95	25001014402	2010	123.000	\N
95	25001014500	2010	139.000	\N
95	25001014600	2010	89.000	\N
95	25001014700	2010	62.000	\N
95	25001014800	2010	45.000	\N
95	25001014900	2010	57.000	\N
95	25001015001	2010	127.000	\N
95	25001015002	2010	81.000	\N
95	25001015100	2010	84.000	\N
95	25001015200	2010	23.000	\N
95	25001015300	2010	186.000	\N
95	25001990000	2010	0.000	\N
95	25003900100	2010	316.000	\N
95	25003900200	2010	542.000	\N
95	25003900300	2010	170.000	\N
95	25003900400	2010	215.000	\N
95	25003900500	2010	92.000	\N
95	25003900600	2010	304.000	\N
95	25003900700	2010	69.000	\N
95	25003900800	2010	72.000	\N
95	25003900900	2010	280.000	\N
95	25003901100	2010	72.000	\N
95	25003911100	2010	41.000	\N
95	25003912100	2010	109.000	\N
95	25003913100	2010	138.000	\N
95	25003914100	2010	261.000	\N
95	25003920101	2010	198.000	\N
95	25003920102	2010	122.000	\N
95	25003921300	2010	192.000	\N
95	25003921400	2010	94.000	\N
95	25003921500	2010	80.000	\N
95	25003922100	2010	29.000	\N
95	25003922200	2010	45.000	\N
95	25003922300	2010	24.000	\N
95	25003923100	2010	35.000	\N
95	25003924100	2010	59.000	\N
95	25003925100	2010	424.000	\N
95	25003926100	2010	105.000	\N
95	25003931100	2010	16.000	\N
95	25003931300	2010	14.000	\N
95	25003931400	2010	4.000	\N
95	25003932200	2010	43.000	\N
95	25003932300	2010	18.000	\N
95	25003933200	2010	9.000	\N
95	25003933300	2010	27.000	\N
95	25003933400	2010	28.000	\N
95	25003934200	2010	12.000	\N
95	25003934300	2010	32.000	\N
95	25003935100	2010	36.000	\N
95	25003935200	2010	93.000	\N
95	25003935300	2010	110.000	\N
95	25005600100	2010	94.000	\N
95	25005600202	2010	121.000	\N
95	25005600203	2010	103.000	\N
95	25005600204	2010	108.000	\N
95	25005610100	2010	102.000	\N
95	25005610202	2010	98.000	\N
95	25005610203	2010	128.000	\N
95	25005610204	2010	159.000	\N
95	25005611101	2010	82.000	\N
95	25005611102	2010	131.000	\N
95	25005611201	2010	45.000	\N
95	25005611202	2010	116.000	\N
95	25005612100	2010	70.000	\N
95	25005612200	2010	177.000	\N
95	25005613100	2010	155.000	\N
95	25005613300	2010	169.000	\N
95	25005613400	2010	289.000	\N
95	25005613600	2010	257.000	\N
95	25005613700	2010	223.000	\N
95	25005613800	2010	420.000	\N
95	25005613901	2010	238.000	\N
95	25005613902	2010	199.000	\N
95	25005614000	2010	550.000	\N
95	25005614101	2010	338.000	\N
95	25005614102	2010	220.000	\N
95	25005615100	2010	104.000	\N
95	25005616100	2010	90.000	\N
95	25005617101	2010	59.000	\N
95	25005617102	2010	50.000	\N
95	25005630101	2010	122.000	\N
95	25005630102	2010	152.000	\N
95	25005630200	2010	118.000	\N
95	25005630300	2010	168.000	\N
95	25005630400	2010	115.000	\N
95	25005631100	2010	309.000	\N
95	25005631200	2010	281.000	\N
95	25005631300	2010	249.000	\N
95	25005631400	2010	517.000	\N
95	25005631500	2010	213.000	\N
95	25005631600	2010	665.000	\N
95	25005631700	2010	241.000	\N
95	25005631800	2010	290.000	\N
95	25005632100	2010	95.000	\N
95	25005632200	2010	156.000	\N
95	25005633100	2010	78.000	\N
95	25005633200	2010	105.000	\N
95	25005640100	2010	547.000	\N
95	25005640200	2010	338.000	\N
95	25005640300	2010	561.000	\N
95	25005640400	2010	70.000	\N
95	25005640500	2010	289.000	\N
95	25005640600	2010	289.000	\N
95	25005640700	2010	60.000	\N
95	25005640800	2010	422.000	\N
95	25005640901	2010	543.000	\N
95	25005641000	2010	213.000	\N
95	25005641101	2010	232.000	\N
95	25005641200	2010	263.000	\N
95	25005641300	2010	865.000	\N
95	25005641400	2010	253.000	\N
95	25005641500	2010	117.000	\N
95	25005641600	2010	43.000	\N
95	25005641700	2010	144.000	\N
95	25005641800	2010	81.000	\N
95	25005641900	2010	117.000	\N
95	25005642000	2010	373.000	\N
95	25005642100	2010	274.000	\N
95	25005642200	2010	260.000	\N
95	25005642300	2010	35.000	\N
95	25005642400	2010	83.000	\N
95	25005642500	2010	90.000	\N
95	25005644101	2010	57.000	\N
95	25005644102	2010	58.000	\N
95	25005644200	2010	76.000	\N
95	25005645101	2010	43.000	\N
95	25005645102	2010	74.000	\N
95	25005645103	2010	56.000	\N
95	25005646101	2010	67.000	\N
95	25005646103	2010	47.000	\N
95	25005646104	2010	24.000	\N
95	25005650101	2010	182.000	\N
95	25005650102	2010	691.000	\N
95	25005650201	2010	129.000	\N
95	25005650202	2010	173.000	\N
95	25005650300	2010	221.000	\N
95	25005650400	2010	412.000	\N
95	25005650500	2010	345.000	\N
95	25005650600	2010	546.000	\N
95	25005650700	2010	1175.000	\N
95	25005650800	2010	812.000	\N
95	25005650900	2010	1098.000	\N
95	25005651001	2010	172.000	\N
95	25005651002	2010	590.000	\N
95	25005651100	2010	958.000	\N
95	25005651200	2010	572.000	\N
95	25005651300	2010	435.000	\N
95	25005651400	2010	442.000	\N
95	25005651500	2010	735.000	\N
95	25005651600	2010	431.000	\N
95	25005651700	2010	384.000	\N
95	25005651800	2010	279.000	\N
95	25005651900	2010	633.000	\N
95	25005652000	2010	329.000	\N
95	25005652100	2010	224.000	\N
95	25005652200	2010	104.000	\N
95	25005652300	2010	401.000	\N
95	25005652400	2010	376.000	\N
95	25005652500	2010	584.000	\N
95	25005652600	2010	1219.000	\N
95	25005652700	2010	1093.000	\N
95	25005652800	2010	171.000	\N
95	25005653101	2010	146.000	\N
95	25005653102	2010	266.000	\N
95	25005653203	2010	75.000	\N
95	25005653204	2010	46.000	\N
95	25005653301	2010	79.000	\N
95	25005653304	2010	29.000	\N
95	25005654100	2010	72.000	\N
95	25005654200	2010	47.000	\N
95	25005655100	2010	52.000	\N
95	25005655200	2010	73.000	\N
95	25005655300	2010	40.000	\N
95	25005655400	2010	33.000	\N
95	25005985500	2010	164.000	\N
95	25005985600	2010	149.000	\N
95	25005990000	2010	0.000	\N
95	25007200100	2010	118.000	\N
95	25007200200	2010	110.000	\N
95	25007200300	2010	99.000	\N
95	25007200400	2010	57.000	\N
95	25007990000	2010	0.000	\N
95	25009201100	2010	52.000	\N
95	25009202101	2010	46.000	\N
95	25009202102	2010	187.000	\N
95	25009202200	2010	122.000	\N
95	25009203100	2010	153.000	\N
95	25009203200	2010	84.000	\N
95	25009203301	2010	58.000	\N
95	25009203302	2010	122.000	\N
95	25009204101	2010	614.000	\N
95	25009204102	2010	431.000	\N
95	25009204200	2010	891.000	\N
95	25009204300	2010	1811.000	\N
95	25009204400	2010	171.000	\N
95	25009204500	2010	340.000	\N
95	25009204600	2010	531.000	\N
95	25009204701	2010	1090.000	\N
95	25009204702	2010	586.000	\N
95	25009205100	2010	640.000	\N
95	25009205200	2010	1315.000	\N
95	25009205300	2010	419.000	\N
95	25009205400	2010	177.000	\N
95	25009205500	2010	1925.000	\N
95	25009205600	2010	915.000	\N
95	25009205700	2010	918.000	\N
95	25009205800	2010	1298.000	\N
95	25009205900	2010	1456.000	\N
95	25009206000	2010	1808.000	\N
95	25009206100	2010	1894.000	\N
95	25009206200	2010	2832.000	\N
95	25009206300	2010	1539.000	\N
95	25009206400	2010	1531.000	\N
95	25009206500	2010	1576.000	\N
95	25009206600	2010	1028.000	\N
95	25009206700	2010	1214.000	\N
95	25009206800	2010	1706.000	\N
95	25009206900	2010	1040.000	\N
95	25009207000	2010	878.000	\N
95	25009207100	2010	1670.000	\N
95	25009207200	2010	1234.000	\N
95	25009208101	2010	246.000	\N
95	25009208102	2010	211.000	\N
95	25009208200	2010	159.000	\N
95	25009208300	2010	260.000	\N
95	25009208400	2010	190.000	\N
95	25009209100	2010	123.000	\N
95	25009209200	2010	79.000	\N
95	25009210100	2010	152.000	\N
95	25009210200	2010	103.000	\N
95	25009210300	2010	338.000	\N
95	25009210400	2010	336.000	\N
95	25009210500	2010	205.000	\N
95	25009210600	2010	381.000	\N
95	25009210700	2010	747.000	\N
95	25009210800	2010	739.000	\N
95	25009210900	2010	211.000	\N
95	25009211100	2010	86.000	\N
95	25009211200	2010	144.000	\N
95	25009211300	2010	113.000	\N
95	25009211401	2010	136.000	\N
95	25009211402	2010	139.000	\N
95	25009212100	2010	640.000	\N
95	25009213100	2010	145.000	\N
95	25009214100	2010	112.000	\N
95	25009215101	2010	64.000	\N
95	25009215102	2010	57.000	\N
95	25009216100	2010	95.000	\N
95	25009217100	2010	237.000	\N
95	25009217201	2010	156.000	\N
95	25009217202	2010	45.000	\N
95	25009217300	2010	402.000	\N
95	25009217400	2010	254.000	\N
95	25009217500	2010	156.000	\N
95	25009217600	2010	147.000	\N
95	25009218100	2010	76.000	\N
95	25009220101	2010	61.000	\N
95	25009220102	2010	50.000	\N
95	25009221100	2010	58.000	\N
95	25009221300	2010	62.000	\N
95	25009221400	2010	166.000	\N
95	25009221500	2010	146.000	\N
95	25009221600	2010	157.000	\N
95	25009221700	2010	91.000	\N
95	25009221800	2010	7.000	\N
95	25009221901	2010	39.000	\N
95	25009221902	2010	61.000	\N
95	25009222100	2010	46.000	\N
95	25009223100	2010	57.000	\N
95	25009223200	2010	79.000	\N
95	25009223300	2010	96.000	\N
95	25009250100	2010	1737.000	\N
95	25009250200	2010	3978.000	\N
95	25009250300	2010	1874.000	\N
95	25009250400	2010	3490.000	\N
95	25009250500	2010	3565.000	\N
95	25009250600	2010	4651.000	\N
95	25009250700	2010	4090.000	\N
95	25009250800	2010	4388.000	\N
95	25009250900	2010	2040.000	\N
95	25009251000	2010	1512.000	\N
95	25009251100	2010	2152.000	\N
95	25009251200	2010	1169.000	\N
95	25009251300	2010	3330.000	\N
95	25009251400	2010	3896.000	\N
95	25009251500	2010	4292.000	\N
95	25009251600	2010	4394.000	\N
95	25009251700	2010	3136.000	\N
95	25009251800	2010	2669.000	\N
95	25009252101	2010	582.000	\N
95	25009252102	2010	185.000	\N
95	25009252201	2010	423.000	\N
95	25009252202	2010	101.000	\N
95	25009252300	2010	1794.000	\N
95	25009252400	2010	2605.000	\N
95	25009252501	2010	1019.000	\N
95	25009252502	2010	570.000	\N
95	25009252601	2010	621.000	\N
95	25009252602	2010	385.000	\N
95	25009252603	2010	246.000	\N
95	25009253100	2010	321.000	\N
95	25009253201	2010	172.000	\N
95	25009253202	2010	645.000	\N
95	25009253203	2010	66.000	\N
95	25009253204	2010	113.000	\N
95	25009253205	2010	81.000	\N
95	25009254100	2010	163.000	\N
95	25009254200	2010	266.000	\N
95	25009254301	2010	77.000	\N
95	25009254302	2010	81.000	\N
95	25009254401	2010	129.000	\N
95	25009254402	2010	378.000	\N
95	25009254403	2010	102.000	\N
95	25009260100	2010	1741.000	\N
95	25009260200	2010	639.000	\N
95	25009260301	2010	207.000	\N
95	25009260302	2010	79.000	\N
95	25009260401	2010	210.000	\N
95	25009260402	2010	300.000	\N
95	25009260500	2010	239.000	\N
95	25009260600	2010	794.000	\N
95	25009260700	2010	714.000	\N
95	25009260800	2010	1799.000	\N
95	25009260900	2010	1148.000	\N
95	25009261000	2010	363.000	\N
95	25009261101	2010	136.000	\N
95	25009261102	2010	462.000	\N
95	25009262100	2010	115.000	\N
95	25009263100	2010	66.000	\N
95	25009264100	2010	85.000	\N
95	25009265101	2010	65.000	\N
95	25009265102	2010	78.000	\N
95	25009266100	2010	70.000	\N
95	25009266200	2010	111.000	\N
95	25009266300	2010	69.000	\N
95	25009266400	2010	60.000	\N
95	25009267101	2010	56.000	\N
95	25009267102	2010	72.000	\N
95	25009268100	2010	51.000	\N
95	25009268200	2010	107.000	\N
95	25009268300	2010	68.000	\N
95	25009268400	2010	65.000	\N
95	25009269100	2010	67.000	\N
95	25009270100	2010	59.000	\N
95	25009990100	2010	0.000	\N
95	25011040100	2010	47.000	\N
95	25011040200	2010	37.000	\N
95	25011040300	2010	56.000	\N
95	25011040400	2010	60.000	\N
95	25011040501	2010	146.000	\N
95	25011040502	2010	76.000	\N
95	25011040600	2010	104.000	\N
95	25011040701	2010	346.000	\N
95	25011040702	2010	92.000	\N
95	25011040800	2010	207.000	\N
95	25011040900	2010	132.000	\N
95	25011041000	2010	167.000	\N
95	25011041100	2010	82.000	\N
95	25011041200	2010	115.000	\N
95	25011041300	2010	242.000	\N
95	25011041400	2010	247.000	\N
95	25011041501	2010	59.000	\N
95	25011041502	2010	35.000	\N
95	25013800101	2010	1289.000	\N
95	25013800102	2010	1559.000	\N
95	25013800201	2010	2342.000	\N
95	25013800202	2010	359.000	\N
95	25013800300	2010	1721.000	\N
95	25013800400	2010	3398.000	\N
95	25013800500	2010	1962.000	\N
95	25013800600	2010	2369.000	\N
95	25013800700	2010	3501.000	\N
95	25013800800	2010	1701.000	\N
95	25013800900	2010	2972.000	\N
95	25013801101	2010	1223.000	\N
95	25013801102	2010	603.000	\N
95	25013801200	2010	1582.000	\N
95	25013801300	2010	1772.000	\N
95	25013801401	2010	1737.000	\N
95	25013801402	2010	641.000	\N
95	25013801501	2010	1585.000	\N
95	25013801502	2010	1285.000	\N
95	25013801503	2010	1295.000	\N
95	25013801601	2010	606.000	\N
95	25013801602	2010	973.000	\N
95	25013801603	2010	679.000	\N
95	25013801604	2010	349.000	\N
95	25013801605	2010	965.000	\N
95	25013801700	2010	1840.000	\N
95	25013801800	2010	2029.000	\N
95	25013801901	2010	2356.000	\N
95	25013801902	2010	2167.000	\N
95	25013802000	2010	2039.000	\N
95	25013802100	2010	1970.000	\N
95	25013802200	2010	1717.000	\N
95	25013802300	2010	3454.000	\N
95	25013802400	2010	300.000	\N
95	25013802500	2010	817.000	\N
95	25013802601	2010	2149.000	\N
95	25013802602	2010	145.000	\N
95	25013810100	2010	161.000	\N
95	25013810200	2010	56.000	\N
95	25013810300	2010	74.000	\N
95	25013810403	2010	222.000	\N
95	25013810404	2010	145.000	\N
95	25013810412	2010	93.000	\N
95	25013810414	2010	723.000	\N
95	25013810601	2010	467.000	\N
95	25013810602	2010	63.000	\N
95	25013810700	2010	701.000	\N
95	25013810800	2010	688.000	\N
95	25013810901	2010	625.000	\N
95	25013810902	2010	852.000	\N
95	25013811000	2010	319.000	\N
95	25013811101	2010	1355.000	\N
95	25013811102	2010	1858.000	\N
95	25013811200	2010	334.000	\N
95	25013811301	2010	511.000	\N
95	25013811302	2010	423.000	\N
95	25013811400	2010	2207.000	\N
95	25013811500	2010	2060.000	\N
95	25013811600	2010	3230.000	\N
95	25013811700	2010	1443.000	\N
95	25013811800	2010	2364.000	\N
95	25013811900	2010	388.000	\N
95	25013812001	2010	1774.000	\N
95	25013812002	2010	1971.000	\N
95	25013812101	2010	365.000	\N
95	25013812103	2010	1777.000	\N
95	25013812104	2010	1734.000	\N
95	25013812201	2010	437.000	\N
95	25013812202	2010	511.000	\N
95	25013812300	2010	964.000	\N
95	25013812401	2010	145.000	\N
95	25013812403	2010	191.000	\N
95	25013812404	2010	223.000	\N
95	25013812500	2010	713.000	\N
95	25013812600	2010	215.000	\N
95	25013812701	2010	448.000	\N
95	25013812702	2010	902.000	\N
95	25013812800	2010	422.000	\N
95	25013812901	2010	155.000	\N
95	25013812902	2010	142.000	\N
95	25013812903	2010	100.000	\N
95	25013813000	2010	123.000	\N
95	25013813101	2010	104.000	\N
95	25013813102	2010	94.000	\N
95	25013813204	2010	59.000	\N
95	25013813205	2010	266.000	\N
95	25013813206	2010	126.000	\N
95	25013813207	2010	243.000	\N
95	25013813208	2010	82.000	\N
95	25013813209	2010	164.000	\N
95	25013813301	2010	203.000	\N
95	25013813303	2010	88.000	\N
95	25013813304	2010	79.000	\N
95	25013813401	2010	160.000	\N
95	25013813403	2010	82.000	\N
95	25013813404	2010	115.000	\N
95	25013813500	2010	75.000	\N
95	25013813601	2010	257.000	\N
95	25013813602	2010	136.000	\N
95	25013813701	2010	66.000	\N
95	25013813702	2010	87.000	\N
95	25013813801	2010	86.000	\N
95	25013813802	2010	79.000	\N
95	25015820101	2010	136.000	\N
95	25015820102	2010	253.000	\N
95	25015820202	2010	41.000	\N
95	25015820203	2010	280.000	\N
95	25015820204	2010	105.000	\N
95	25015820300	2010	447.000	\N
95	25015820400	2010	604.000	\N
95	25015820500	2010	390.000	\N
95	25015820600	2010	217.000	\N
95	25015820700	2010	441.000	\N
95	25015820801	2010	578.000	\N
95	25015820802	2010	80.000	\N
95	25015820900	2010	130.000	\N
95	25015821000	2010	124.000	\N
95	25015821100	2010	294.000	\N
95	25015821200	2010	140.000	\N
95	25015821300	2010	195.000	\N
95	25015821400	2010	163.000	\N
95	25015821500	2010	47.000	\N
95	25015821601	2010	320.000	\N
95	25015821602	2010	329.000	\N
95	25015821700	2010	111.000	\N
95	25015821901	2010	129.000	\N
95	25015821903	2010	388.000	\N
95	25015821904	2010	147.000	\N
95	25015822000	2010	151.000	\N
95	25015822200	2010	353.000	\N
95	25015822300	2010	223.000	\N
95	25015822401	2010	117.000	\N
95	25015822402	2010	250.000	\N
95	25015822500	2010	85.000	\N
95	25015822601	2010	41.000	\N
95	25015822603	2010	30.000	\N
95	25015822605	2010	18.000	\N
95	25015822606	2010	61.000	\N
95	25015822700	2010	37.000	\N
95	25017300100	2010	57.000	\N
95	25017301101	2010	91.000	\N
95	25017301102	2010	72.000	\N
95	25017310100	2010	1402.000	\N
95	25017310200	2010	1113.000	\N
95	25017310300	2010	1415.000	\N
95	25017310400	2010	1123.000	\N
95	25017310500	2010	433.000	\N
95	25017310601	2010	611.000	\N
95	25017310602	2010	567.000	\N
95	25017310700	2010	776.000	\N
95	25017311100	2010	792.000	\N
95	25017311200	2010	481.000	\N
95	25017311300	2010	520.000	\N
95	25017311400	2010	855.000	\N
95	25017311500	2010	244.000	\N
95	25017311600	2010	458.000	\N
95	25017311700	2010	681.000	\N
95	25017311800	2010	581.000	\N
95	25017311900	2010	590.000	\N
95	25017312000	2010	716.000	\N
95	25017312100	2010	658.000	\N
95	25017312200	2010	598.000	\N
95	25017312300	2010	496.000	\N
95	25017312400	2010	970.000	\N
95	25017312501	2010	402.000	\N
95	25017312502	2010	274.000	\N
95	25017313101	2010	127.000	\N
95	25017313102	2010	138.000	\N
95	25017314101	2010	215.000	\N
95	25017314102	2010	296.000	\N
95	25017314200	2010	240.000	\N
95	25017314301	2010	338.000	\N
95	25017314302	2010	60.000	\N
95	25017315100	2010	111.000	\N
95	25017315200	2010	157.000	\N
95	25017315401	2010	116.000	\N
95	25017315402	2010	50.000	\N
95	25017315403	2010	19.000	\N
95	25017315500	2010	149.000	\N
95	25017316101	2010	92.000	\N
95	25017316102	2010	103.000	\N
95	25017316201	2010	73.000	\N
95	25017316202	2010	100.000	\N
95	25017316300	2010	241.000	\N
95	25017316400	2010	227.000	\N
95	25017316500	2010	199.000	\N
95	25017317101	2010	126.000	\N
95	25017317102	2010	100.000	\N
95	25017317103	2010	76.000	\N
95	25017317201	2010	52.000	\N
95	25017317202	2010	63.000	\N
95	25017317203	2010	56.000	\N
95	25017317301	2010	85.000	\N
95	25017317302	2010	128.000	\N
95	25017318100	2010	89.000	\N
95	25017318200	2010	68.000	\N
95	25017318300	2010	121.000	\N
95	25017318400	2010	55.000	\N
95	25017320102	2010	88.000	\N
95	25017320103	2010	55.000	\N
95	25017320104	2010	124.000	\N
95	25017321100	2010	457.000	\N
95	25017321200	2010	455.000	\N
95	25017321300	2010	1366.000	\N
95	25017321400	2010	161.000	\N
95	25017321500	2010	1225.000	\N
95	25017321600	2010	510.000	\N
95	25017322100	2010	118.000	\N
95	25017322200	2010	135.000	\N
95	25017322300	2010	376.000	\N
95	25017322400	2010	185.000	\N
95	25017323100	2010	122.000	\N
95	25017324101	2010	61.000	\N
95	25017324102	2010	60.000	\N
95	25017325100	2010	421.000	\N
95	25017326101	2010	69.000	\N
95	25017326102	2010	124.000	\N
95	25017327101	2010	48.000	\N
95	25017327102	2010	89.000	\N
95	25017327103	2010	57.000	\N
95	25017328100	2010	44.000	\N
95	25017330100	2010	121.000	\N
95	25017330200	2010	110.000	\N
95	25017331101	2010	57.000	\N
95	25017331102	2010	129.000	\N
95	25017331200	2010	75.000	\N
95	25017331300	2010	142.000	\N
95	25017332100	2010	83.000	\N
95	25017332200	2010	295.000	\N
95	25017332300	2010	105.000	\N
95	25017332400	2010	95.000	\N
95	25017333100	2010	177.000	\N
95	25017333200	2010	162.000	\N
95	25017333300	2010	299.000	\N
95	25017333400	2010	352.000	\N
95	25017333501	2010	211.000	\N
95	25017333502	2010	243.000	\N
95	25017333600	2010	280.000	\N
95	25017334100	2010	126.000	\N
95	25017334200	2010	70.000	\N
95	25017334300	2010	90.000	\N
95	25017334400	2010	92.000	\N
95	25017335100	2010	124.000	\N
95	25017335200	2010	111.000	\N
95	25017335301	2010	114.000	\N
95	25017335302	2010	113.000	\N
95	25017335400	2010	113.000	\N
95	25017336100	2010	126.000	\N
95	25017336200	2010	105.000	\N
95	25017336300	2010	143.000	\N
95	25017336401	2010	156.000	\N
95	25017336402	2010	133.000	\N
95	25017337101	2010	78.000	\N
95	25017337102	2010	95.000	\N
95	25017337201	2010	80.000	\N
95	25017337202	2010	138.000	\N
95	25017337300	2010	243.000	\N
95	25017338100	2010	72.000	\N
95	25017338200	2010	100.000	\N
95	25017338300	2010	56.000	\N
95	25017338400	2010	86.000	\N
95	25017338500	2010	91.000	\N
95	25017339100	2010	162.000	\N
95	25017339200	2010	119.000	\N
95	25017339300	2010	134.000	\N
95	25017339400	2010	153.000	\N
95	25017339500	2010	236.000	\N
95	25017339600	2010	272.000	\N
95	25017339700	2010	281.000	\N
95	25017339801	2010	219.000	\N
95	25017339802	2010	285.000	\N
95	25017339900	2010	263.000	\N
95	25017340000	2010	163.000	\N
95	25017340100	2010	160.000	\N
95	25017341101	2010	160.000	\N
95	25017341102	2010	241.000	\N
95	25017341200	2010	439.000	\N
95	25017341300	2010	224.000	\N
95	25017341400	2010	708.000	\N
95	25017341500	2010	666.000	\N
95	25017341600	2010	368.000	\N
95	25017341700	2010	473.000	\N
95	25017341800	2010	824.000	\N
95	25017341901	2010	127.000	\N
95	25017341902	2010	762.000	\N
95	25017342101	2010	897.000	\N
95	25017342102	2010	689.000	\N
95	25017342201	2010	1107.000	\N
95	25017342202	2010	718.000	\N
95	25017342300	2010	1345.000	\N
95	25017342400	2010	1277.000	\N
95	25017342500	2010	1582.000	\N
95	25017342600	2010	1177.000	\N
95	25017350103	2010	111.000	\N
95	25017350104	2010	1665.000	\N
95	25017350200	2010	882.000	\N
95	25017350300	2010	264.000	\N
95	25017350400	2010	181.000	\N
95	25017350500	2010	44.000	\N
95	25017350600	2010	188.000	\N
95	25017350700	2010	475.000	\N
95	25017350800	2010	77.000	\N
95	25017350900	2010	127.000	\N
95	25017351000	2010	309.000	\N
95	25017351100	2010	301.000	\N
95	25017351203	2010	212.000	\N
95	25017351204	2010	346.000	\N
95	25017351300	2010	313.000	\N
95	25017351403	2010	1174.000	\N
95	25017351404	2010	936.000	\N
95	25017351500	2010	412.000	\N
95	25017352101	2010	232.000	\N
95	25017352102	2010	127.000	\N
95	25017352200	2010	190.000	\N
95	25017352300	2010	346.000	\N
95	25017352400	2010	350.000	\N
95	25017352500	2010	284.000	\N
95	25017352600	2010	265.000	\N
95	25017352700	2010	228.000	\N
95	25017352800	2010	214.000	\N
95	25017352900	2010	138.000	\N
95	25017353000	2010	313.000	\N
95	25017353101	2010	266.000	\N
95	25017353102	2010	561.000	\N
95	25017353200	2010	361.000	\N
95	25017353300	2010	170.000	\N
95	25017353400	2010	241.000	\N
95	25017353500	2010	175.000	\N
95	25017353600	2010	246.000	\N
95	25017353700	2010	354.000	\N
95	25017353800	2010	257.000	\N
95	25017353900	2010	578.000	\N
95	25017354000	2010	264.000	\N
95	25017354100	2010	147.000	\N
95	25017354200	2010	95.000	\N
95	25017354300	2010	246.000	\N
95	25017354400	2010	67.000	\N
95	25017354500	2010	112.000	\N
95	25017354600	2010	234.000	\N
95	25017354700	2010	106.000	\N
95	25017354800	2010	76.000	\N
95	25017354900	2010	563.000	\N
95	25017355000	2010	168.000	\N
95	25017356100	2010	120.000	\N
95	25017356300	2010	243.000	\N
95	25017356400	2010	172.000	\N
95	25017356500	2010	199.000	\N
95	25017356601	2010	137.000	\N
95	25017356602	2010	111.000	\N
95	25017356701	2010	214.000	\N
95	25017356702	2010	199.000	\N
95	25017357100	2010	93.000	\N
95	25017357200	2010	98.000	\N
95	25017357300	2010	97.000	\N
95	25017357400	2010	86.000	\N
95	25017357500	2010	59.000	\N
95	25017357600	2010	73.000	\N
95	25017357700	2010	132.000	\N
95	25017357800	2010	116.000	\N
95	25017358100	2010	103.000	\N
95	25017358300	2010	149.000	\N
95	25017358400	2010	120.000	\N
95	25017358500	2010	101.000	\N
95	25017358600	2010	128.000	\N
95	25017358700	2010	112.000	\N
95	25017359100	2010	181.000	\N
95	25017359300	2010	175.000	\N
95	25017360100	2010	192.000	\N
95	25017360200	2010	124.000	\N
95	25017361100	2010	83.000	\N
95	25017361200	2010	365.000	\N
95	25017361300	2010	207.000	\N
95	25017362100	2010	100.000	\N
95	25017363102	2010	215.000	\N
95	25017363103	2010	80.000	\N
95	25017363104	2010	143.000	\N
95	25017363201	2010	61.000	\N
95	25017363202	2010	61.000	\N
95	25017364101	2010	240.000	\N
95	25017364102	2010	137.000	\N
95	25017365100	2010	128.000	\N
95	25017365201	2010	119.000	\N
95	25017365202	2010	103.000	\N
95	25017366100	2010	136.000	\N
95	25017366201	2010	81.000	\N
95	25017366202	2010	98.000	\N
95	25017367100	2010	90.000	\N
95	25017367200	2010	204.000	\N
95	25017368101	2010	306.000	\N
95	25017368102	2010	256.000	\N
95	25017368200	2010	364.000	\N
95	25017368300	2010	1209.000	\N
95	25017368400	2010	765.000	\N
95	25017368500	2010	856.000	\N
95	25017368600	2010	1340.000	\N
95	25017368700	2010	869.000	\N
95	25017368800	2010	1132.000	\N
95	25017368901	2010	387.000	\N
95	25017368902	2010	499.000	\N
95	25017369000	2010	80.000	\N
95	25017369100	2010	217.000	\N
95	25017370101	2010	384.000	\N
95	25017370102	2010	420.000	\N
95	25017370201	2010	128.000	\N
95	25017370202	2010	159.000	\N
95	25017370300	2010	375.000	\N
95	25017370400	2010	222.000	\N
95	25017373100	2010	177.000	\N
95	25017373200	2010	269.000	\N
95	25017373300	2010	104.000	\N
95	25017373400	2010	144.000	\N
95	25017373500	2010	222.000	\N
95	25017373600	2010	381.000	\N
95	25017373700	2010	76.000	\N
95	25017373800	2010	219.000	\N
95	25017373900	2010	196.000	\N
95	25017374000	2010	207.000	\N
95	25017374100	2010	234.000	\N
95	25017374200	2010	140.000	\N
95	25017374300	2010	70.000	\N
95	25017374400	2010	179.000	\N
95	25017374500	2010	217.000	\N
95	25017374600	2010	316.000	\N
95	25017374700	2010	168.000	\N
95	25017374800	2010	157.000	\N
95	25017382100	2010	118.000	\N
95	25017382200	2010	158.000	\N
95	25017382300	2010	153.000	\N
95	25017382400	2010	105.000	\N
95	25017382500	2010	142.000	\N
95	25017382601	2010	198.000	\N
95	25017382602	2010	120.000	\N
95	25017383101	2010	1143.000	\N
95	25017383102	2010	2353.000	\N
95	25017383200	2010	1576.000	\N
95	25017383300	2010	352.000	\N
95	25017383400	2010	942.000	\N
95	25017383501	2010	607.000	\N
95	25017383502	2010	271.000	\N
95	25017383600	2010	455.000	\N
95	25017383700	2010	361.000	\N
95	25017383800	2010	285.000	\N
95	25017383901	2010	261.000	\N
95	25017383902	2010	149.000	\N
95	25017384001	2010	77.000	\N
95	25017384002	2010	329.000	\N
95	25017385100	2010	214.000	\N
95	25017385201	2010	194.000	\N
95	25017385202	2010	332.000	\N
95	25017386100	2010	57.000	\N
95	25017387100	2010	66.000	\N
95	25017387201	2010	105.000	\N
95	25017387202	2010	75.000	\N
95	25017388100	2010	113.000	\N
95	25017388200	2010	561.000	\N
95	25017388300	2010	1640.000	\N
95	25017980000	2010	0.000	\N
95	25019950100	2010	30.000	\N
95	25019950200	2010	602.000	\N
95	25019950307	2010	4.000	\N
95	25019950400	2010	302.000	\N
95	25019950500	2010	19.000	\N
95	25019990000	2010	0.000	\N
95	25021400100	2010	279.000	\N
95	25021400200	2010	383.000	\N
95	25021400300	2010	188.000	\N
95	25021400400	2010	230.000	\N
95	25021400500	2010	237.000	\N
95	25021400600	2010	217.000	\N
95	25021400700	2010	169.000	\N
95	25021400800	2010	272.000	\N
95	25021400900	2010	242.000	\N
95	25021401000	2010	247.000	\N
95	25021401100	2010	172.000	\N
95	25021401200	2010	328.000	\N
95	25021402101	2010	193.000	\N
95	25021402102	2010	344.000	\N
95	25021402200	2010	156.000	\N
95	25021402300	2010	149.000	\N
95	25021402400	2010	316.000	\N
95	25021402500	2010	195.000	\N
95	25021403100	2010	131.000	\N
95	25021403300	2010	99.000	\N
95	25021403400	2010	160.000	\N
95	25021403500	2010	133.000	\N
95	25021404100	2010	192.000	\N
95	25021404201	2010	76.000	\N
95	25021404202	2010	239.000	\N
95	25021404301	2010	125.000	\N
95	25021404302	2010	96.000	\N
95	25021404400	2010	292.000	\N
95	25021405100	2010	83.000	\N
95	25021406101	2010	93.000	\N
95	25021406102	2010	87.000	\N
95	25021407100	2010	136.000	\N
95	25021408101	2010	134.000	\N
95	25021408102	2010	116.000	\N
95	25021409101	2010	747.000	\N
95	25021409102	2010	55.000	\N
95	25021410100	2010	81.000	\N
95	25021410300	2010	72.000	\N
95	25021410400	2010	156.000	\N
95	25021411100	2010	221.000	\N
95	25021411200	2010	137.000	\N
95	25021411301	2010	63.000	\N
95	25021411302	2010	230.000	\N
95	25021412100	2010	105.000	\N
95	25021412200	2010	50.000	\N
95	25021412300	2010	82.000	\N
95	25021413100	2010	173.000	\N
95	25021413200	2010	244.000	\N
95	25021413300	2010	178.000	\N
95	25021413401	2010	106.000	\N
95	25021413402	2010	213.000	\N
95	25021413500	2010	313.000	\N
95	25021414100	2010	132.000	\N
95	25021414200	2010	172.000	\N
95	25021414300	2010	69.000	\N
95	25021415101	2010	88.000	\N
95	25021415102	2010	210.000	\N
95	25021415200	2010	238.000	\N
95	25021415300	2010	60.000	\N
95	25021416101	2010	112.000	\N
95	25021416102	2010	116.000	\N
95	25021416200	2010	388.000	\N
95	25021416300	2010	186.000	\N
95	25021416400	2010	79.000	\N
95	25021417100	2010	85.000	\N
95	25021417200	2010	158.000	\N
95	25021417300	2010	72.000	\N
95	25021417400	2010	48.000	\N
95	25021417501	2010	105.000	\N
95	25021417502	2010	145.000	\N
95	25021417601	2010	140.000	\N
95	25021417602	2010	140.000	\N
95	25021417701	2010	171.000	\N
95	25021417702	2010	65.000	\N
95	25021417801	2010	136.000	\N
95	25021417802	2010	127.000	\N
95	25021417901	2010	203.000	\N
95	25021417902	2010	180.000	\N
95	25021418002	2010	288.000	\N
95	25021418003	2010	153.000	\N
95	25021418004	2010	219.000	\N
95	25021418101	2010	163.000	\N
95	25021418102	2010	206.000	\N
95	25021418200	2010	285.000	\N
95	25021419100	2010	114.000	\N
95	25021419200	2010	135.000	\N
95	25021419300	2010	214.000	\N
95	25021419400	2010	81.000	\N
95	25021419500	2010	55.000	\N
95	25021419600	2010	125.000	\N
95	25021419700	2010	62.000	\N
95	25021419800	2010	104.000	\N
95	25021420100	2010	510.000	\N
95	25021420201	2010	197.000	\N
95	25021420202	2010	403.000	\N
95	25021420301	2010	529.000	\N
95	25021420302	2010	418.000	\N
95	25021421100	2010	261.000	\N
95	25021421200	2010	213.000	\N
95	25021422100	2010	105.000	\N
95	25021422200	2010	127.000	\N
95	25021422301	2010	46.000	\N
95	25021422302	2010	206.000	\N
95	25021422400	2010	192.000	\N
95	25021422501	2010	169.000	\N
95	25021422502	2010	206.000	\N
95	25021422600	2010	153.000	\N
95	25021422700	2010	111.000	\N
95	25021422800	2010	97.000	\N
95	25021423100	2010	96.000	\N
95	25021440100	2010	147.000	\N
95	25021441202	2010	43.000	\N
95	25021441203	2010	39.000	\N
95	25021441204	2010	51.000	\N
95	25021442101	2010	122.000	\N
95	25021442102	2010	110.000	\N
95	25021442103	2010	115.000	\N
95	25021442201	2010	74.000	\N
95	25021442202	2010	199.000	\N
95	25021443101	2010	235.000	\N
95	25021443102	2010	174.000	\N
95	25021456101	2010	97.000	\N
95	25021456102	2010	172.000	\N
95	25021456200	2010	75.000	\N
95	25021456301	2010	88.000	\N
95	25021456302	2010	167.000	\N
95	25021456401	2010	91.000	\N
95	25021456402	2010	186.000	\N
95	25021457100	2010	121.000	\N
95	25021457200	2010	95.000	\N
95	25023500101	2010	52.000	\N
95	25023500103	2010	25.000	\N
95	25023500104	2010	96.000	\N
95	25023501101	2010	26.000	\N
95	25023501102	2010	100.000	\N
95	25023501201	2010	33.000	\N
95	25023501202	2010	82.000	\N
95	25023502101	2010	101.000	\N
95	25023502102	2010	161.000	\N
95	25023502200	2010	86.000	\N
95	25023503101	2010	85.000	\N
95	25023503102	2010	43.000	\N
95	25023504101	2010	83.000	\N
95	25023504102	2010	45.000	\N
95	25023505101	2010	72.000	\N
95	25023505102	2010	50.000	\N
95	25023505200	2010	69.000	\N
95	25023506101	2010	83.000	\N
95	25023506102	2010	103.000	\N
95	25023506202	2010	22.000	\N
95	25023506203	2010	59.000	\N
95	25023506204	2010	48.000	\N
95	25023507101	2010	69.000	\N
95	25023507103	2010	65.000	\N
95	25023507104	2010	50.000	\N
95	25023508101	2010	73.000	\N
95	25023508102	2010	56.000	\N
95	25023508200	2010	64.000	\N
95	25023509101	2010	85.000	\N
95	25023509102	2010	55.000	\N
95	25023510100	2010	322.000	\N
95	25023510200	2010	487.000	\N
95	25023510300	2010	455.000	\N
95	25023510400	2010	573.000	\N
95	25023510501	2010	237.000	\N
95	25023510502	2010	521.000	\N
95	25023510503	2010	290.000	\N
95	25023510600	2010	131.000	\N
95	25023510700	2010	430.000	\N
95	25023510800	2010	827.000	\N
95	25023510900	2010	406.000	\N
95	25023511000	2010	465.000	\N
95	25023511100	2010	380.000	\N
95	25023511200	2010	554.000	\N
95	25023511301	2010	609.000	\N
95	25023511302	2010	362.000	\N
95	25023511400	2010	530.000	\N
95	25023511500	2010	557.000	\N
95	25023511600	2010	756.000	\N
95	25023511701	2010	324.000	\N
95	25023511702	2010	141.000	\N
95	25023520100	2010	102.000	\N
95	25023520201	2010	78.000	\N
95	25023520202	2010	130.000	\N
95	25023521101	2010	80.000	\N
95	25023521102	2010	70.000	\N
95	25023521201	2010	69.000	\N
95	25023521202	2010	48.000	\N
95	25023522101	2010	49.000	\N
95	25023522102	2010	46.000	\N
95	25023523100	2010	57.000	\N
95	25023523201	2010	26.000	\N
95	25023523202	2010	121.000	\N
95	25023524101	2010	63.000	\N
95	25023524102	2010	58.000	\N
95	25023525101	2010	149.000	\N
95	25023525104	2010	70.000	\N
95	25023525203	2010	99.000	\N
95	25023525204	2010	55.000	\N
95	25023525300	2010	346.000	\N
95	25023526100	2010	81.000	\N
95	25023530100	2010	113.000	\N
95	25023530200	2010	89.000	\N
95	25023530300	2010	81.000	\N
95	25023530400	2010	68.000	\N
95	25023530500	2010	58.000	\N
95	25023530600	2010	224.000	\N
95	25023530700	2010	62.000	\N
95	25023530801	2010	68.000	\N
95	25023530802	2010	59.000	\N
95	25023530901	2010	155.000	\N
95	25023530902	2010	53.000	\N
95	25023540101	2010	31.000	\N
95	25023540102	2010	24.000	\N
95	25023540103	2010	37.000	\N
95	25023541100	2010	40.000	\N
95	25023542101	2010	115.000	\N
95	25023542102	2010	24.000	\N
95	25023542200	2010	69.000	\N
95	25023542300	2010	159.000	\N
95	25023543100	2010	36.000	\N
95	25023544100	2010	56.000	\N
95	25023544200	2010	73.000	\N
95	25023545100	2010	124.000	\N
95	25023545200	2010	188.000	\N
95	25023545300	2010	96.000	\N
95	25023545400	2010	94.000	\N
95	25023560100	2010	57.000	\N
95	25023561100	2010	52.000	\N
95	25023561200	2010	119.000	\N
95	25023990003	2010	0.000	\N
95	25025000100	2010	621.000	\N
95	25025000201	2010	407.000	\N
95	25025000202	2010	596.000	\N
95	25025000301	2010	190.000	\N
95	25025000302	2010	229.000	\N
95	25025000401	2010	287.000	\N
95	25025000402	2010	189.000	\N
95	25025000502	2010	446.000	\N
95	25025000503	2010	96.000	\N
95	25025000504	2010	318.000	\N
95	25025000601	2010	288.000	\N
95	25025000602	2010	641.000	\N
95	25025000701	2010	333.000	\N
95	25025000703	2010	182.000	\N
95	25025000704	2010	575.000	\N
95	25025000802	2010	1466.000	\N
95	25025000803	2010	576.000	\N
95	25025010103	2010	347.000	\N
95	25025010104	2010	409.000	\N
95	25025010203	2010	569.000	\N
95	25025010204	2010	178.000	\N
95	25025010300	2010	457.000	\N
95	25025010403	2010	293.000	\N
95	25025010404	2010	386.000	\N
95	25025010405	2010	435.000	\N
95	25025010408	2010	133.000	\N
95	25025010500	2010	291.000	\N
95	25025010600	2010	156.000	\N
95	25025010701	2010	136.000	\N
95	25025010702	2010	102.000	\N
95	25025010801	2010	139.000	\N
95	25025010802	2010	119.000	\N
95	25025020101	2010	139.000	\N
95	25025020200	2010	174.000	\N
95	25025020301	2010	108.000	\N
95	25025020302	2010	61.000	\N
95	25025020303	2010	373.000	\N
95	25025030100	2010	68.000	\N
95	25025030200	2010	69.000	\N
95	25025030300	2010	239.000	\N
95	25025030400	2010	78.000	\N
95	25025030500	2010	93.000	\N
95	25025040100	2010	41.000	\N
95	25025040200	2010	351.000	\N
95	25025040300	2010	384.000	\N
95	25025040401	2010	144.000	\N
95	25025040600	2010	58.000	\N
95	25025040801	2010	613.000	\N
95	25025050101	2010	3140.000	\N
95	25025050200	2010	3427.000	\N
95	25025050300	2010	1028.000	\N
95	25025050400	2010	1204.000	\N
95	25025050500	2010	996.000	\N
95	25025050600	2010	1374.000	\N
95	25025050700	2010	2906.000	\N
95	25025050901	2010	2704.000	\N
95	25025051000	2010	1572.000	\N
95	25025051101	2010	2175.000	\N
95	25025051200	2010	822.000	\N
95	25025060101	2010	44.000	\N
95	25025060200	2010	13.000	\N
95	25025060301	2010	28.000	\N
95	25025060400	2010	90.000	\N
95	25025060501	2010	72.000	\N
95	25025060600	2010	92.000	\N
95	25025060700	2010	877.000	\N
95	25025060800	2010	106.000	\N
95	25025061000	2010	895.000	\N
95	25025061101	2010	935.000	\N
95	25025061200	2010	156.000	\N
95	25025070101	2010	360.000	\N
95	25025070200	2010	160.000	\N
95	25025070300	2010	161.000	\N
95	25025070402	2010	158.000	\N
95	25025070500	2010	1070.000	\N
95	25025070600	2010	114.000	\N
95	25025070700	2010	194.000	\N
95	25025070800	2010	337.000	\N
95	25025070900	2010	714.000	\N
95	25025071101	2010	513.000	\N
95	25025071201	2010	758.000	\N
95	25025080100	2010	942.000	\N
95	25025080300	2010	508.000	\N
95	25025080401	2010	984.000	\N
95	25025080500	2010	1329.000	\N
95	25025080601	2010	743.000	\N
95	25025080801	2010	1345.000	\N
95	25025080900	2010	313.000	\N
95	25025081001	2010	950.000	\N
95	25025081100	2010	608.000	\N
95	25025081200	2010	1720.000	\N
95	25025081300	2010	2261.000	\N
95	25025081400	2010	586.000	\N
95	25025081500	2010	516.000	\N
95	25025081700	2010	782.000	\N
95	25025081800	2010	736.000	\N
95	25025081900	2010	828.000	\N
95	25025082000	2010	534.000	\N
95	25025082100	2010	1661.000	\N
95	25025090100	2010	1029.000	\N
95	25025090200	2010	865.000	\N
95	25025090300	2010	1082.000	\N
95	25025090400	2010	1205.000	\N
95	25025090600	2010	492.000	\N
95	25025090700	2010	379.000	\N
95	25025090901	2010	768.000	\N
95	25025091001	2010	212.000	\N
95	25025091100	2010	466.000	\N
95	25025091200	2010	697.000	\N
95	25025091300	2010	532.000	\N
95	25025091400	2010	802.000	\N
95	25025091500	2010	917.000	\N
95	25025091600	2010	486.000	\N
95	25025091700	2010	632.000	\N
95	25025091800	2010	713.000	\N
95	25025091900	2010	824.000	\N
95	25025092000	2010	1051.000	\N
95	25025092101	2010	689.000	\N
95	25025092200	2010	422.000	\N
95	25025092300	2010	458.000	\N
95	25025092400	2010	1470.000	\N
95	25025100100	2010	1603.000	\N
95	25025100200	2010	413.000	\N
95	25025100300	2010	352.000	\N
95	25025100400	2010	457.000	\N
95	25025100500	2010	968.000	\N
95	25025100601	2010	478.000	\N
95	25025100603	2010	129.000	\N
95	25025100700	2010	101.000	\N
95	25025100800	2010	412.000	\N
95	25025100900	2010	350.000	\N
95	25025101001	2010	594.000	\N
95	25025101002	2010	693.000	\N
95	25025101101	2010	479.000	\N
95	25025101102	2010	521.000	\N
95	25025110103	2010	1746.000	\N
95	25025110201	2010	734.000	\N
95	25025110301	2010	692.000	\N
95	25025110401	2010	1309.000	\N
95	25025110403	2010	1002.000	\N
95	25025110501	2010	461.000	\N
95	25025110502	2010	876.000	\N
95	25025110601	2010	122.000	\N
95	25025110607	2010	487.000	\N
95	25025120103	2010	77.000	\N
95	25025120104	2010	407.000	\N
95	25025120105	2010	150.000	\N
95	25025120201	2010	800.000	\N
95	25025120301	2010	1821.000	\N
95	25025120400	2010	566.000	\N
95	25025120500	2010	1195.000	\N
95	25025120600	2010	301.000	\N
95	25025120700	2010	354.000	\N
95	25025130100	2010	265.000	\N
95	25025130200	2010	207.000	\N
95	25025130300	2010	270.000	\N
95	25025130402	2010	300.000	\N
95	25025130404	2010	349.000	\N
95	25025130406	2010	1060.000	\N
95	25025140102	2010	755.000	\N
95	25025140105	2010	955.000	\N
95	25025140106	2010	595.000	\N
95	25025140107	2010	618.000	\N
95	25025140201	2010	341.000	\N
95	25025140202	2010	1135.000	\N
95	25025140300	2010	1474.000	\N
95	25025140400	2010	1229.000	\N
95	25025160101	2010	5715.000	\N
95	25025160200	2010	3347.000	\N
95	25025160300	2010	461.000	\N
95	25025160400	2010	1922.000	\N
95	25025160501	2010	3956.000	\N
95	25025160502	2010	2750.000	\N
95	25025160601	2010	1722.000	\N
95	25025160602	2010	1982.000	\N
95	25025170100	2010	2007.000	\N
95	25025170200	2010	846.000	\N
95	25025170300	2010	1220.000	\N
95	25025170400	2010	1206.000	\N
95	25025170501	2010	814.000	\N
95	25025170502	2010	266.000	\N
95	25025170601	2010	1515.000	\N
95	25025170701	2010	538.000	\N
95	25025170702	2010	2893.000	\N
95	25025170800	2010	1310.000	\N
95	25025180101	2010	279.000	\N
95	25025180200	2010	266.000	\N
95	25025180301	2010	125.000	\N
95	25025180400	2010	93.000	\N
95	25025180500	2010	303.000	\N
95	25025980101	2010	134.000	\N
95	25025980300	2010	68.000	\N
95	25025980700	2010	0.000	\N
95	25025981000	2010	0.000	\N
95	25025981100	2010	85.000	\N
95	25025981201	2010	0.000	\N
95	25025981202	2010	37.000	\N
95	25025981300	2010	71.000	\N
95	25025981501	2010	1.000	\N
95	25025981502	2010	2.000	\N
95	25025981600	2010	0.000	\N
95	25025981700	2010	0.000	\N
95	25025981800	2010	3.000	\N
95	25025990101	2010	0.000	\N
95	25027700100	2010	155.000	\N
95	25027701100	2010	300.000	\N
95	25027702200	2010	84.000	\N
95	25027703100	2010	188.000	\N
95	25027703200	2010	85.000	\N
95	25027703300	2010	140.000	\N
95	25027704200	2010	51.000	\N
95	25027705100	2010	153.000	\N
95	25027706100	2010	63.000	\N
95	25027707100	2010	300.000	\N
95	25027707200	2010	137.000	\N
95	25027707300	2010	228.000	\N
95	25027707400	2010	213.000	\N
95	25027707500	2010	552.000	\N
95	25027708100	2010	193.000	\N
95	25027709100	2010	394.000	\N
95	25027709201	2010	816.000	\N
95	25027709202	2010	1229.000	\N
95	25027709400	2010	1342.000	\N
95	25027709501	2010	92.000	\N
95	25027709502	2010	359.000	\N
95	25027709600	2010	505.000	\N
95	25027709701	2010	938.000	\N
95	25027709702	2010	225.000	\N
95	25027710100	2010	962.000	\N
95	25027710200	2010	1124.000	\N
95	25027710300	2010	396.000	\N
95	25027710400	2010	271.000	\N
95	25027710500	2010	1140.000	\N
95	25027710600	2010	2001.000	\N
95	25027710700	2010	579.000	\N
95	25027710800	2010	1196.000	\N
95	25027711000	2010	801.000	\N
95	25027711100	2010	257.000	\N
95	25027712101	2010	151.000	\N
95	25027712102	2010	89.000	\N
95	25027713100	2010	655.000	\N
95	25027715100	2010	87.000	\N
95	25027716100	2010	858.000	\N
95	25027716200	2010	422.000	\N
95	25027716300	2010	564.000	\N
95	25027717100	2010	44.000	\N
95	25027718100	2010	64.000	\N
95	25027719100	2010	158.000	\N
95	25027720100	2010	49.000	\N
95	25027721101	2010	46.000	\N
95	25027721102	2010	146.000	\N
95	25027722100	2010	103.000	\N
95	25027723100	2010	61.000	\N
95	25027724100	2010	63.000	\N
95	25027725100	2010	89.000	\N
95	25027726100	2010	92.000	\N
95	25027726200	2010	243.000	\N
95	25027727100	2010	151.000	\N
95	25027728100	2010	98.000	\N
95	25027728200	2010	71.000	\N
95	25027728300	2010	116.000	\N
95	25027728400	2010	88.000	\N
95	25027729100	2010	343.000	\N
95	25027729200	2010	61.000	\N
95	25027730100	2010	399.000	\N
95	25027730200	2010	435.000	\N
95	25027730300	2010	378.000	\N
95	25027730401	2010	1164.000	\N
95	25027730402	2010	417.000	\N
95	25027730500	2010	560.000	\N
95	25027730600	2010	358.000	\N
95	25027730700	2010	371.000	\N
95	25027730801	2010	137.000	\N
95	25027730802	2010	145.000	\N
95	25027730901	2010	210.000	\N
95	25027730902	2010	225.000	\N
95	25027731001	2010	216.000	\N
95	25027731002	2010	1081.000	\N
95	25027731101	2010	1024.000	\N
95	25027731102	2010	291.000	\N
95	25027731202	2010	59.000	\N
95	25027731203	2010	1966.000	\N
95	25027731204	2010	1120.000	\N
95	25027731300	2010	2007.000	\N
95	25027731400	2010	2428.000	\N
95	25027731500	2010	2419.000	\N
95	25027731600	2010	1051.000	\N
95	25027731700	2010	759.000	\N
95	25027731800	2010	2295.000	\N
95	25027731900	2010	1960.000	\N
95	25027732001	2010	2243.000	\N
95	25027732002	2010	471.000	\N
95	25027732201	2010	220.000	\N
95	25027732202	2010	394.000	\N
95	25027732203	2010	591.000	\N
95	25027732301	2010	325.000	\N
95	25027732302	2010	669.000	\N
95	25027732400	2010	2427.000	\N
95	25027732500	2010	694.000	\N
95	25027732600	2010	1276.000	\N
95	25027732700	2010	1046.000	\N
95	25027732801	2010	320.000	\N
95	25027732802	2010	408.000	\N
95	25027732901	2010	1116.000	\N
95	25027732902	2010	210.000	\N
95	25027733000	2010	1386.000	\N
95	25027733101	2010	255.000	\N
95	25027733102	2010	292.000	\N
95	25027735100	2010	223.000	\N
95	25027735200	2010	191.000	\N
95	25027736100	2010	67.000	\N
95	25027736200	2010	85.000	\N
95	25027736300	2010	107.000	\N
95	25027736400	2010	103.000	\N
95	25027736500	2010	64.000	\N
95	25027737100	2010	112.000	\N
95	25027737200	2010	38.000	\N
95	25027737300	2010	156.000	\N
95	25027738100	2010	156.000	\N
95	25027738201	2010	78.000	\N
95	25027738202	2010	93.000	\N
95	25027739100	2010	280.000	\N
95	25027739200	2010	209.000	\N
95	25027739300	2010	106.000	\N
95	25027739400	2010	193.000	\N
95	25027739500	2010	173.000	\N
95	25027740101	2010	119.000	\N
95	25027740102	2010	178.000	\N
95	25027740200	2010	84.000	\N
95	25027741101	2010	131.000	\N
95	25027741102	2010	141.000	\N
95	25027742300	2010	251.000	\N
95	25027742401	2010	88.000	\N
95	25027742402	2010	98.000	\N
95	25027743100	2010	119.000	\N
95	25027744101	2010	309.000	\N
95	25027744102	2010	290.000	\N
95	25027744200	2010	624.000	\N
95	25027744300	2010	689.000	\N
95	25027744400	2010	403.000	\N
95	25027745100	2010	127.000	\N
95	25027746100	2010	73.000	\N
95	25027747101	2010	98.000	\N
95	25027747102	2010	87.000	\N
95	25027748100	2010	41.000	\N
95	25027749100	2010	144.000	\N
95	25027749200	2010	113.000	\N
95	25027750100	2010	244.000	\N
95	25027750200	2010	118.000	\N
95	25027750300	2010	129.000	\N
95	25027751101	2010	77.000	\N
95	25027751102	2010	38.000	\N
95	25027752100	2010	139.000	\N
95	25027753100	2010	321.000	\N
95	25027753200	2010	143.000	\N
95	25027754100	2010	222.000	\N
95	25027754200	2010	346.000	\N
95	25027754300	2010	378.000	\N
95	25027754400	2010	202.000	\N
95	25027755100	2010	132.000	\N
95	25027755200	2010	198.000	\N
95	25027756101	2010	115.000	\N
95	25027756102	2010	259.000	\N
95	25027757100	2010	1190.000	\N
95	25027757200	2010	982.000	\N
95	25027757300	2010	1164.000	\N
95	25027757400	2010	454.000	\N
95	25027757500	2010	662.000	\N
95	25027758101	2010	21.000	\N
95	25027758102	2010	210.000	\N
95	25027759100	2010	51.000	\N
95	25027760100	2010	44.000	\N
95	25027761100	2010	120.000	\N
95	25027761200	2010	280.000	\N
95	25027761300	2010	79.000	\N
95	25027761400	2010	264.000	\N
96	25001010100	2010	88.000	\N
96	25001010206	2010	31.000	\N
96	25001010208	2010	28.000	\N
96	25001010304	2010	35.000	\N
96	25001010306	2010	25.000	\N
96	25001010400	2010	41.000	\N
96	25001010500	2010	17.000	\N
96	25001010600	2010	29.000	\N
96	25001010700	2010	45.000	\N
96	25001010800	2010	46.000	\N
96	25001010900	2010	80.000	\N
96	25001011002	2010	31.000	\N
96	25001011100	2010	43.000	\N
96	25001011200	2010	23.000	\N
96	25001011300	2010	25.000	\N
96	25001011400	2010	42.000	\N
96	25001011500	2010	43.000	\N
96	25001011600	2010	36.000	\N
96	25001011700	2010	26.000	\N
96	25001011801	2010	19.000	\N
96	25001011802	2010	32.000	\N
96	25001012001	2010	66.000	\N
96	25001012002	2010	65.000	\N
96	25001012101	2010	77.000	\N
96	25001012102	2010	74.000	\N
96	25001012200	2010	23.000	\N
96	25001012502	2010	82.000	\N
96	25001012601	2010	104.000	\N
96	25001012602	2010	236.000	\N
96	25001012700	2010	77.000	\N
96	25001012800	2010	45.000	\N
96	25001012900	2010	38.000	\N
96	25001013002	2010	22.000	\N
96	25001013100	2010	82.000	\N
96	25001013200	2010	56.000	\N
96	25001013300	2010	20.000	\N
96	25001013400	2010	27.000	\N
96	25001013500	2010	51.000	\N
96	25001013600	2010	81.000	\N
96	25001013700	2010	49.000	\N
96	25001013800	2010	53.000	\N
96	25001013900	2010	22.000	\N
96	25001014002	2010	33.000	\N
96	25001014100	2010	50.000	\N
96	25001014300	2010	38.000	\N
96	25001014402	2010	85.000	\N
96	25001014500	2010	68.000	\N
96	25001014600	2010	53.000	\N
96	25001014700	2010	52.000	\N
96	25001014800	2010	29.000	\N
96	25001014900	2010	42.000	\N
96	25001015001	2010	84.000	\N
96	25001015002	2010	54.000	\N
96	25001015100	2010	46.000	\N
96	25001015200	2010	19.000	\N
96	25001015300	2010	79.000	\N
96	25001990000	2010	0.000	\N
96	25003900100	2010	125.000	\N
96	25003900200	2010	276.000	\N
96	25003900300	2010	79.000	\N
96	25003900400	2010	102.000	\N
96	25003900500	2010	70.000	\N
96	25003900600	2010	125.000	\N
96	25003900700	2010	43.000	\N
96	25003900800	2010	35.000	\N
96	25003900900	2010	129.000	\N
96	25003901100	2010	42.000	\N
96	25003911100	2010	32.000	\N
96	25003912100	2010	69.000	\N
96	25003913100	2010	95.000	\N
96	25003914100	2010	156.000	\N
96	25003920101	2010	124.000	\N
96	25003920102	2010	71.000	\N
96	25003921300	2010	102.000	\N
96	25003921400	2010	45.000	\N
96	25003921500	2010	38.000	\N
96	25003922100	2010	20.000	\N
96	25003922200	2010	26.000	\N
96	25003922300	2010	14.000	\N
96	25003923100	2010	28.000	\N
96	25003924100	2010	50.000	\N
96	25003925100	2010	249.000	\N
96	25003926100	2010	51.000	\N
96	25003931100	2010	14.000	\N
96	25003931300	2010	9.000	\N
96	25003931400	2010	3.000	\N
96	25003932200	2010	27.000	\N
96	25003932300	2010	11.000	\N
96	25003933200	2010	4.000	\N
96	25003933300	2010	18.000	\N
96	25003933400	2010	21.000	\N
96	25003934200	2010	4.000	\N
96	25003934300	2010	18.000	\N
96	25003935100	2010	19.000	\N
96	25003935200	2010	53.000	\N
96	25003935300	2010	61.000	\N
96	25005600100	2010	75.000	\N
96	25005600202	2010	71.000	\N
96	25005600203	2010	71.000	\N
96	25005600204	2010	52.000	\N
96	25005610100	2010	63.000	\N
96	25005610202	2010	68.000	\N
96	25005610203	2010	94.000	\N
96	25005610204	2010	103.000	\N
96	25005611101	2010	55.000	\N
96	25005611102	2010	58.000	\N
96	25005611201	2010	30.000	\N
96	25005611202	2010	73.000	\N
96	25005612100	2010	38.000	\N
96	25005612200	2010	116.000	\N
96	25005613100	2010	74.000	\N
96	25005613300	2010	97.000	\N
96	25005613400	2010	144.000	\N
96	25005613600	2010	133.000	\N
96	25005613700	2010	104.000	\N
96	25005613800	2010	200.000	\N
96	25005613901	2010	112.000	\N
96	25005613902	2010	108.000	\N
96	25005614000	2010	214.000	\N
96	25005614101	2010	187.000	\N
96	25005614102	2010	148.000	\N
96	25005615100	2010	79.000	\N
96	25005616100	2010	69.000	\N
96	25005617101	2010	34.000	\N
96	25005617102	2010	36.000	\N
96	25005630101	2010	65.000	\N
96	25005630102	2010	84.000	\N
96	25005630200	2010	77.000	\N
96	25005630300	2010	116.000	\N
96	25005630400	2010	76.000	\N
96	25005631100	2010	197.000	\N
96	25005631200	2010	178.000	\N
96	25005631300	2010	118.000	\N
96	25005631400	2010	246.000	\N
96	25005631500	2010	81.000	\N
96	25005631600	2010	272.000	\N
96	25005631700	2010	114.000	\N
96	25005631800	2010	161.000	\N
96	25005632100	2010	57.000	\N
96	25005632200	2010	103.000	\N
96	25005633100	2010	50.000	\N
96	25005633200	2010	70.000	\N
96	25005640100	2010	309.000	\N
96	25005640200	2010	145.000	\N
96	25005640300	2010	305.000	\N
96	25005640400	2010	38.000	\N
96	25005640500	2010	131.000	\N
96	25005640600	2010	109.000	\N
96	25005640700	2010	25.000	\N
96	25005640800	2010	188.000	\N
96	25005640901	2010	190.000	\N
96	25005641000	2010	101.000	\N
96	25005641101	2010	66.000	\N
96	25005641200	2010	152.000	\N
96	25005641300	2010	401.000	\N
96	25005641400	2010	128.000	\N
96	25005641500	2010	75.000	\N
96	25005641600	2010	28.000	\N
96	25005641700	2010	75.000	\N
96	25005641800	2010	58.000	\N
96	25005641900	2010	76.000	\N
96	25005642000	2010	213.000	\N
96	25005642100	2010	147.000	\N
96	25005642200	2010	143.000	\N
96	25005642300	2010	21.000	\N
96	25005642400	2010	47.000	\N
96	25005642500	2010	71.000	\N
96	25005644101	2010	47.000	\N
96	25005644102	2010	38.000	\N
96	25005644200	2010	60.000	\N
96	25005645101	2010	33.000	\N
96	25005645102	2010	56.000	\N
96	25005645103	2010	53.000	\N
96	25005646101	2010	56.000	\N
96	25005646103	2010	38.000	\N
96	25005646104	2010	20.000	\N
96	25005650101	2010	111.000	\N
96	25005650102	2010	294.000	\N
96	25005650201	2010	85.000	\N
96	25005650202	2010	94.000	\N
96	25005650300	2010	105.000	\N
96	25005650400	2010	236.000	\N
96	25005650500	2010	95.000	\N
96	25005650600	2010	170.000	\N
96	25005650700	2010	271.000	\N
96	25005650800	2010	217.000	\N
96	25005650900	2010	383.000	\N
96	25005651001	2010	86.000	\N
96	25005651002	2010	258.000	\N
96	25005651100	2010	417.000	\N
96	25005651200	2010	141.000	\N
96	25005651300	2010	138.000	\N
96	25005651400	2010	159.000	\N
96	25005651500	2010	299.000	\N
96	25005651600	2010	146.000	\N
96	25005651700	2010	161.000	\N
96	25005651800	2010	97.000	\N
96	25005651900	2010	247.000	\N
96	25005652000	2010	121.000	\N
96	25005652100	2010	101.000	\N
96	25005652200	2010	58.000	\N
96	25005652300	2010	172.000	\N
96	25005652400	2010	164.000	\N
96	25005652500	2010	252.000	\N
96	25005652600	2010	488.000	\N
96	25005652700	2010	539.000	\N
96	25005652800	2010	96.000	\N
96	25005653101	2010	105.000	\N
96	25005653102	2010	182.000	\N
96	25005653203	2010	38.000	\N
96	25005653204	2010	33.000	\N
96	25005653301	2010	59.000	\N
96	25005653304	2010	20.000	\N
96	25005654100	2010	62.000	\N
96	25005654200	2010	30.000	\N
96	25005655100	2010	35.000	\N
96	25005655200	2010	39.000	\N
96	25005655300	2010	32.000	\N
96	25005655400	2010	26.000	\N
96	25005985500	2010	84.000	\N
96	25005985600	2010	90.000	\N
96	25005990000	2010	0.000	\N
96	25007200100	2010	74.000	\N
96	25007200200	2010	71.000	\N
96	25007200300	2010	41.000	\N
96	25007200400	2010	31.000	\N
96	25007990000	2010	0.000	\N
96	25009201100	2010	33.000	\N
96	25009202101	2010	24.000	\N
96	25009202102	2010	108.000	\N
96	25009202200	2010	92.000	\N
96	25009203100	2010	106.000	\N
96	25009203200	2010	55.000	\N
96	25009203301	2010	37.000	\N
96	25009203302	2010	71.000	\N
96	25009204101	2010	188.000	\N
96	25009204102	2010	145.000	\N
96	25009204200	2010	311.000	\N
96	25009204300	2010	669.000	\N
96	25009204400	2010	84.000	\N
96	25009204500	2010	143.000	\N
96	25009204600	2010	207.000	\N
96	25009204701	2010	341.000	\N
96	25009204702	2010	229.000	\N
96	25009205100	2010	193.000	\N
96	25009205200	2010	413.000	\N
96	25009205300	2010	166.000	\N
96	25009205400	2010	88.000	\N
96	25009205500	2010	659.000	\N
96	25009205600	2010	236.000	\N
96	25009205700	2010	383.000	\N
96	25009205800	2010	430.000	\N
96	25009205900	2010	491.000	\N
96	25009206000	2010	487.000	\N
96	25009206100	2010	687.000	\N
96	25009206200	2010	1016.000	\N
96	25009206300	2010	389.000	\N
96	25009206400	2010	477.000	\N
96	25009206500	2010	432.000	\N
96	25009206600	2010	310.000	\N
96	25009206700	2010	366.000	\N
96	25009206800	2010	466.000	\N
96	25009206900	2010	271.000	\N
96	25009207000	2010	296.000	\N
96	25009207100	2010	472.000	\N
96	25009207200	2010	322.000	\N
96	25009208101	2010	147.000	\N
96	25009208102	2010	112.000	\N
96	25009208200	2010	75.000	\N
96	25009208300	2010	176.000	\N
96	25009208400	2010	109.000	\N
96	25009209100	2010	89.000	\N
96	25009209200	2010	59.000	\N
96	25009210100	2010	97.000	\N
96	25009210200	2010	67.000	\N
96	25009210300	2010	187.000	\N
96	25009210400	2010	154.000	\N
96	25009210500	2010	114.000	\N
96	25009210600	2010	115.000	\N
96	25009210700	2010	300.000	\N
96	25009210800	2010	263.000	\N
96	25009210900	2010	87.000	\N
96	25009211100	2010	61.000	\N
96	25009211200	2010	83.000	\N
96	25009211300	2010	73.000	\N
96	25009211401	2010	92.000	\N
96	25009211402	2010	79.000	\N
96	25009212100	2010	218.000	\N
96	25009213100	2010	111.000	\N
96	25009214100	2010	87.000	\N
96	25009215101	2010	45.000	\N
96	25009215102	2010	42.000	\N
96	25009216100	2010	64.000	\N
96	25009217100	2010	147.000	\N
96	25009217201	2010	84.000	\N
96	25009217202	2010	34.000	\N
96	25009217300	2010	174.000	\N
96	25009217400	2010	131.000	\N
96	25009217500	2010	101.000	\N
96	25009217600	2010	92.000	\N
96	25009218100	2010	61.000	\N
96	25009220101	2010	43.000	\N
96	25009220102	2010	36.000	\N
96	25009221100	2010	39.000	\N
96	25009221300	2010	50.000	\N
96	25009221400	2010	55.000	\N
96	25009221500	2010	112.000	\N
96	25009221600	2010	75.000	\N
96	25009221700	2010	39.000	\N
96	25009221800	2010	6.000	\N
96	25009221901	2010	29.000	\N
96	25009221902	2010	43.000	\N
96	25009222100	2010	37.000	\N
96	25009223100	2010	43.000	\N
96	25009223200	2010	48.000	\N
96	25009223300	2010	74.000	\N
96	25009250100	2010	521.000	\N
96	25009250200	2010	1093.000	\N
96	25009250300	2010	455.000	\N
96	25009250400	2010	1105.000	\N
96	25009250500	2010	1102.000	\N
96	25009250600	2010	1182.000	\N
96	25009250700	2010	1209.000	\N
96	25009250800	2010	1770.000	\N
96	25009250900	2010	603.000	\N
96	25009251000	2010	447.000	\N
96	25009251100	2010	713.000	\N
96	25009251200	2010	365.000	\N
96	25009251300	2010	889.000	\N
96	25009251400	2010	1183.000	\N
96	25009251500	2010	1347.000	\N
96	25009251600	2010	1338.000	\N
96	25009251700	2010	931.000	\N
96	25009251800	2010	814.000	\N
96	25009252101	2010	239.000	\N
96	25009252102	2010	67.000	\N
96	25009252201	2010	178.000	\N
96	25009252202	2010	45.000	\N
96	25009252300	2010	681.000	\N
96	25009252400	2010	918.000	\N
96	25009252501	2010	379.000	\N
96	25009252502	2010	328.000	\N
96	25009252601	2010	237.000	\N
96	25009252602	2010	200.000	\N
96	25009252603	2010	103.000	\N
96	25009253100	2010	210.000	\N
96	25009253201	2010	121.000	\N
96	25009253202	2010	268.000	\N
96	25009253203	2010	51.000	\N
96	25009253204	2010	76.000	\N
96	25009253205	2010	63.000	\N
96	25009254100	2010	89.000	\N
96	25009254200	2010	137.000	\N
96	25009254301	2010	48.000	\N
96	25009254302	2010	59.000	\N
96	25009254401	2010	89.000	\N
96	25009254402	2010	171.000	\N
96	25009254403	2010	69.000	\N
96	25009260100	2010	899.000	\N
96	25009260200	2010	262.000	\N
96	25009260301	2010	94.000	\N
96	25009260302	2010	52.000	\N
96	25009260401	2010	110.000	\N
96	25009260402	2010	134.000	\N
96	25009260500	2010	92.000	\N
96	25009260600	2010	410.000	\N
96	25009260700	2010	377.000	\N
96	25009260800	2010	653.000	\N
96	25009260900	2010	421.000	\N
96	25009261000	2010	170.000	\N
96	25009261101	2010	95.000	\N
96	25009261102	2010	218.000	\N
96	25009262100	2010	82.000	\N
96	25009263100	2010	48.000	\N
96	25009264100	2010	60.000	\N
96	25009265101	2010	39.000	\N
96	25009265102	2010	56.000	\N
96	25009266100	2010	45.000	\N
96	25009266200	2010	82.000	\N
96	25009266300	2010	45.000	\N
96	25009266400	2010	37.000	\N
96	25009267101	2010	44.000	\N
96	25009267102	2010	50.000	\N
96	25009268100	2010	41.000	\N
96	25009268200	2010	72.000	\N
96	25009268300	2010	47.000	\N
96	25009268400	2010	54.000	\N
96	25009269100	2010	55.000	\N
96	25009270100	2010	45.000	\N
96	25009990100	2010	0.000	\N
96	25011040100	2010	33.000	\N
96	25011040200	2010	23.000	\N
96	25011040300	2010	29.000	\N
96	25011040400	2010	33.000	\N
96	25011040501	2010	94.000	\N
96	25011040502	2010	58.000	\N
96	25011040600	2010	77.000	\N
96	25011040701	2010	163.000	\N
96	25011040702	2010	39.000	\N
96	25011040800	2010	107.000	\N
96	25011040900	2010	86.000	\N
96	25011041000	2010	84.000	\N
96	25011041100	2010	48.000	\N
96	25011041200	2010	54.000	\N
96	25011041300	2010	146.000	\N
96	25011041400	2010	116.000	\N
96	25011041501	2010	48.000	\N
96	25011041502	2010	23.000	\N
96	25013800101	2010	462.000	\N
96	25013800102	2010	819.000	\N
96	25013800201	2010	945.000	\N
96	25013800202	2010	184.000	\N
96	25013800300	2010	697.000	\N
96	25013800400	2010	1363.000	\N
96	25013800500	2010	682.000	\N
96	25013800600	2010	839.000	\N
96	25013800700	2010	1312.000	\N
96	25013800800	2010	803.000	\N
96	25013800900	2010	1326.000	\N
96	25013801101	2010	478.000	\N
96	25013801102	2010	209.000	\N
96	25013801200	2010	603.000	\N
96	25013801300	2010	729.000	\N
96	25013801401	2010	547.000	\N
96	25013801402	2010	268.000	\N
96	25013801501	2010	577.000	\N
96	25013801502	2010	447.000	\N
96	25013801503	2010	492.000	\N
96	25013801601	2010	300.000	\N
96	25013801602	2010	432.000	\N
96	25013801603	2010	310.000	\N
96	25013801604	2010	230.000	\N
96	25013801605	2010	460.000	\N
96	25013801700	2010	646.000	\N
96	25013801800	2010	643.000	\N
96	25013801901	2010	845.000	\N
96	25013801902	2010	814.000	\N
96	25013802000	2010	718.000	\N
96	25013802100	2010	678.000	\N
96	25013802200	2010	624.000	\N
96	25013802300	2010	1188.000	\N
96	25013802400	2010	177.000	\N
96	25013802500	2010	412.000	\N
96	25013802601	2010	760.000	\N
96	25013802602	2010	68.000	\N
96	25013810100	2010	91.000	\N
96	25013810200	2010	26.000	\N
96	25013810300	2010	36.000	\N
96	25013810403	2010	115.000	\N
96	25013810404	2010	79.000	\N
96	25013810412	2010	78.000	\N
96	25013810414	2010	593.000	\N
96	25013810601	2010	227.000	\N
96	25013810602	2010	36.000	\N
96	25013810700	2010	298.000	\N
96	25013810800	2010	290.000	\N
96	25013810901	2010	260.000	\N
96	25013810902	2010	330.000	\N
96	25013811000	2010	215.000	\N
96	25013811101	2010	781.000	\N
96	25013811102	2010	930.000	\N
96	25013811200	2010	181.000	\N
96	25013811301	2010	276.000	\N
96	25013811302	2010	237.000	\N
96	25013811400	2010	887.000	\N
96	25013811500	2010	789.000	\N
96	25013811600	2010	1092.000	\N
96	25013811700	2010	594.000	\N
96	25013811800	2010	927.000	\N
96	25013811900	2010	219.000	\N
96	25013812001	2010	689.000	\N
96	25013812002	2010	850.000	\N
96	25013812101	2010	209.000	\N
96	25013812103	2010	695.000	\N
96	25013812104	2010	727.000	\N
96	25013812201	2010	235.000	\N
96	25013812202	2010	208.000	\N
96	25013812300	2010	430.000	\N
96	25013812401	2010	96.000	\N
96	25013812403	2010	116.000	\N
96	25013812404	2010	117.000	\N
96	25013812500	2010	437.000	\N
96	25013812600	2010	128.000	\N
96	25013812701	2010	245.000	\N
96	25013812702	2010	489.000	\N
96	25013812800	2010	241.000	\N
96	25013812901	2010	116.000	\N
96	25013812902	2010	92.000	\N
96	25013812903	2010	44.000	\N
96	25013813000	2010	78.000	\N
96	25013813101	2010	62.000	\N
96	25013813102	2010	67.000	\N
96	25013813204	2010	35.000	\N
96	25013813205	2010	203.000	\N
96	25013813206	2010	91.000	\N
96	25013813207	2010	148.000	\N
96	25013813208	2010	37.000	\N
96	25013813209	2010	98.000	\N
96	25013813301	2010	128.000	\N
96	25013813303	2010	69.000	\N
96	25013813304	2010	68.000	\N
96	25013813401	2010	93.000	\N
96	25013813403	2010	63.000	\N
96	25013813404	2010	90.000	\N
96	25013813500	2010	60.000	\N
96	25013813601	2010	163.000	\N
96	25013813602	2010	96.000	\N
96	25013813701	2010	45.000	\N
96	25013813702	2010	70.000	\N
96	25013813801	2010	63.000	\N
96	25013813802	2010	69.000	\N
96	25015820101	2010	70.000	\N
96	25015820102	2010	121.000	\N
96	25015820202	2010	26.000	\N
96	25015820203	2010	169.000	\N
96	25015820204	2010	68.000	\N
96	25015820300	2010	244.000	\N
96	25015820400	2010	281.000	\N
96	25015820500	2010	219.000	\N
96	25015820600	2010	132.000	\N
96	25015820700	2010	200.000	\N
96	25015820801	2010	244.000	\N
96	25015820802	2010	39.000	\N
96	25015820900	2010	80.000	\N
96	25015821000	2010	85.000	\N
96	25015821100	2010	174.000	\N
96	25015821200	2010	77.000	\N
96	25015821300	2010	126.000	\N
96	25015821400	2010	104.000	\N
96	25015821500	2010	28.000	\N
96	25015821601	2010	149.000	\N
96	25015821602	2010	148.000	\N
96	25015821700	2010	63.000	\N
96	25015821901	2010	75.000	\N
96	25015821903	2010	169.000	\N
96	25015821904	2010	76.000	\N
96	25015822000	2010	76.000	\N
96	25015822200	2010	239.000	\N
96	25015822300	2010	139.000	\N
96	25015822401	2010	83.000	\N
96	25015822402	2010	127.000	\N
96	25015822500	2010	45.000	\N
96	25015822601	2010	24.000	\N
96	25015822603	2010	18.000	\N
96	25015822605	2010	10.000	\N
96	25015822606	2010	43.000	\N
96	25015822700	2010	30.000	\N
96	25017300100	2010	32.000	\N
96	25017301101	2010	64.000	\N
96	25017301102	2010	54.000	\N
96	25017310100	2010	672.000	\N
96	25017310200	2010	518.000	\N
96	25017310300	2010	661.000	\N
96	25017310400	2010	506.000	\N
96	25017310500	2010	192.000	\N
96	25017310601	2010	350.000	\N
96	25017310602	2010	280.000	\N
96	25017310700	2010	208.000	\N
96	25017311100	2010	283.000	\N
96	25017311200	2010	124.000	\N
96	25017311300	2010	196.000	\N
96	25017311400	2010	364.000	\N
96	25017311500	2010	79.000	\N
96	25017311600	2010	162.000	\N
96	25017311700	2010	275.000	\N
96	25017311800	2010	223.000	\N
96	25017311900	2010	242.000	\N
96	25017312000	2010	351.000	\N
96	25017312100	2010	277.000	\N
96	25017312200	2010	269.000	\N
96	25017312300	2010	261.000	\N
96	25017312400	2010	437.000	\N
96	25017312501	2010	209.000	\N
96	25017312502	2010	173.000	\N
96	25017313101	2010	71.000	\N
96	25017313102	2010	82.000	\N
96	25017314101	2010	122.000	\N
96	25017314102	2010	171.000	\N
96	25017314200	2010	146.000	\N
96	25017314301	2010	162.000	\N
96	25017314302	2010	44.000	\N
96	25017315100	2010	73.000	\N
96	25017315200	2010	106.000	\N
96	25017315401	2010	104.000	\N
96	25017315402	2010	35.000	\N
96	25017315403	2010	12.000	\N
96	25017315500	2010	111.000	\N
96	25017316101	2010	65.000	\N
96	25017316102	2010	72.000	\N
96	25017316201	2010	45.000	\N
96	25017316202	2010	62.000	\N
96	25017316300	2010	163.000	\N
96	25017316400	2010	167.000	\N
96	25017316500	2010	143.000	\N
96	25017317101	2010	88.000	\N
96	25017317102	2010	70.000	\N
96	25017317103	2010	56.000	\N
96	25017317201	2010	43.000	\N
96	25017317202	2010	52.000	\N
96	25017317203	2010	44.000	\N
96	25017317301	2010	57.000	\N
96	25017317302	2010	79.000	\N
96	25017318100	2010	61.000	\N
96	25017318200	2010	55.000	\N
96	25017318300	2010	101.000	\N
96	25017318400	2010	36.000	\N
96	25017320102	2010	75.000	\N
96	25017320103	2010	38.000	\N
96	25017320104	2010	102.000	\N
96	25017321100	2010	271.000	\N
96	25017321200	2010	271.000	\N
96	25017321300	2010	698.000	\N
96	25017321400	2010	90.000	\N
96	25017321500	2010	598.000	\N
96	25017321600	2010	266.000	\N
96	25017322100	2010	66.000	\N
96	25017322200	2010	83.000	\N
96	25017322300	2010	254.000	\N
96	25017322400	2010	126.000	\N
96	25017323100	2010	90.000	\N
96	25017324101	2010	49.000	\N
96	25017324102	2010	40.000	\N
96	25017325100	2010	215.000	\N
96	25017326101	2010	47.000	\N
96	25017326102	2010	100.000	\N
96	25017327101	2010	35.000	\N
96	25017327102	2010	59.000	\N
96	25017327103	2010	42.000	\N
96	25017328100	2010	38.000	\N
96	25017330100	2010	99.000	\N
96	25017330200	2010	84.000	\N
96	25017331101	2010	38.000	\N
96	25017331102	2010	84.000	\N
96	25017331200	2010	50.000	\N
96	25017331300	2010	97.000	\N
96	25017332100	2010	67.000	\N
96	25017332200	2010	189.000	\N
96	25017332300	2010	73.000	\N
96	25017332400	2010	64.000	\N
96	25017333100	2010	117.000	\N
96	25017333200	2010	93.000	\N
96	25017333300	2010	150.000	\N
96	25017333400	2010	191.000	\N
96	25017333501	2010	132.000	\N
96	25017333502	2010	119.000	\N
96	25017333600	2010	175.000	\N
96	25017334100	2010	83.000	\N
96	25017334200	2010	44.000	\N
96	25017334300	2010	70.000	\N
96	25017334400	2010	67.000	\N
96	25017335100	2010	80.000	\N
96	25017335200	2010	88.000	\N
96	25017335301	2010	65.000	\N
96	25017335302	2010	79.000	\N
96	25017335400	2010	80.000	\N
96	25017336100	2010	104.000	\N
96	25017336200	2010	77.000	\N
96	25017336300	2010	98.000	\N
96	25017336401	2010	80.000	\N
96	25017336402	2010	74.000	\N
96	25017337101	2010	41.000	\N
96	25017337102	2010	60.000	\N
96	25017337201	2010	55.000	\N
96	25017337202	2010	75.000	\N
96	25017337300	2010	132.000	\N
96	25017338100	2010	54.000	\N
96	25017338200	2010	64.000	\N
96	25017338300	2010	50.000	\N
96	25017338400	2010	70.000	\N
96	25017338500	2010	78.000	\N
96	25017339100	2010	110.000	\N
96	25017339200	2010	82.000	\N
96	25017339300	2010	57.000	\N
96	25017339400	2010	91.000	\N
96	25017339500	2010	170.000	\N
96	25017339600	2010	128.000	\N
96	25017339700	2010	142.000	\N
96	25017339801	2010	104.000	\N
96	25017339802	2010	140.000	\N
96	25017339900	2010	157.000	\N
96	25017340000	2010	86.000	\N
96	25017340100	2010	77.000	\N
96	25017341101	2010	77.000	\N
96	25017341102	2010	125.000	\N
96	25017341200	2010	198.000	\N
96	25017341300	2010	123.000	\N
96	25017341400	2010	332.000	\N
96	25017341500	2010	305.000	\N
96	25017341600	2010	212.000	\N
96	25017341700	2010	303.000	\N
96	25017341800	2010	381.000	\N
96	25017341901	2010	78.000	\N
96	25017341902	2010	346.000	\N
96	25017342101	2010	420.000	\N
96	25017342102	2010	340.000	\N
96	25017342201	2010	531.000	\N
96	25017342202	2010	349.000	\N
96	25017342300	2010	507.000	\N
96	25017342400	2010	559.000	\N
96	25017342500	2010	701.000	\N
96	25017342600	2010	454.000	\N
96	25017350103	2010	43.000	\N
96	25017350104	2010	605.000	\N
96	25017350200	2010	325.000	\N
96	25017350300	2010	152.000	\N
96	25017350400	2010	130.000	\N
96	25017350500	2010	32.000	\N
96	25017350600	2010	119.000	\N
96	25017350700	2010	199.000	\N
96	25017350800	2010	49.000	\N
96	25017350900	2010	87.000	\N
96	25017351000	2010	196.000	\N
96	25017351100	2010	169.000	\N
96	25017351203	2010	138.000	\N
96	25017351204	2010	173.000	\N
96	25017351300	2010	159.000	\N
96	25017351403	2010	401.000	\N
96	25017351404	2010	429.000	\N
96	25017351500	2010	229.000	\N
96	25017352101	2010	178.000	\N
96	25017352102	2010	77.000	\N
96	25017352200	2010	91.000	\N
96	25017352300	2010	223.000	\N
96	25017352400	2010	134.000	\N
96	25017352500	2010	123.000	\N
96	25017352600	2010	136.000	\N
96	25017352700	2010	96.000	\N
96	25017352800	2010	78.000	\N
96	25017352900	2010	104.000	\N
96	25017353000	2010	177.000	\N
96	25017353101	2010	141.000	\N
96	25017353102	2010	400.000	\N
96	25017353200	2010	239.000	\N
96	25017353300	2010	103.000	\N
96	25017353400	2010	97.000	\N
96	25017353500	2010	88.000	\N
96	25017353600	2010	171.000	\N
96	25017353700	2010	242.000	\N
96	25017353800	2010	210.000	\N
96	25017353900	2010	446.000	\N
96	25017354000	2010	194.000	\N
96	25017354100	2010	120.000	\N
96	25017354200	2010	75.000	\N
96	25017354300	2010	115.000	\N
96	25017354400	2010	48.000	\N
96	25017354500	2010	89.000	\N
96	25017354600	2010	145.000	\N
96	25017354700	2010	71.000	\N
96	25017354800	2010	48.000	\N
96	25017354900	2010	187.000	\N
96	25017355000	2010	101.000	\N
96	25017356100	2010	88.000	\N
96	25017356300	2010	144.000	\N
96	25017356400	2010	124.000	\N
96	25017356500	2010	117.000	\N
96	25017356601	2010	91.000	\N
96	25017356602	2010	68.000	\N
96	25017356701	2010	141.000	\N
96	25017356702	2010	140.000	\N
96	25017357100	2010	77.000	\N
96	25017357200	2010	76.000	\N
96	25017357300	2010	65.000	\N
96	25017357400	2010	57.000	\N
96	25017357500	2010	33.000	\N
96	25017357600	2010	41.000	\N
96	25017357700	2010	91.000	\N
96	25017357800	2010	81.000	\N
96	25017358100	2010	86.000	\N
96	25017358300	2010	126.000	\N
96	25017358400	2010	97.000	\N
96	25017358500	2010	74.000	\N
96	25017358600	2010	92.000	\N
96	25017358700	2010	92.000	\N
96	25017359100	2010	116.000	\N
96	25017359300	2010	143.000	\N
96	25017360100	2010	119.000	\N
96	25017360200	2010	91.000	\N
96	25017361100	2010	69.000	\N
96	25017361200	2010	251.000	\N
96	25017361300	2010	128.000	\N
96	25017362100	2010	73.000	\N
96	25017363102	2010	144.000	\N
96	25017363103	2010	56.000	\N
96	25017363104	2010	98.000	\N
96	25017363201	2010	54.000	\N
96	25017363202	2010	46.000	\N
96	25017364101	2010	162.000	\N
96	25017364102	2010	93.000	\N
96	25017365100	2010	102.000	\N
96	25017365201	2010	87.000	\N
96	25017365202	2010	68.000	\N
96	25017366100	2010	109.000	\N
96	25017366201	2010	65.000	\N
96	25017366202	2010	74.000	\N
96	25017367100	2010	80.000	\N
96	25017367200	2010	138.000	\N
96	25017368101	2010	199.000	\N
96	25017368102	2010	130.000	\N
96	25017368200	2010	160.000	\N
96	25017368300	2010	604.000	\N
96	25017368400	2010	451.000	\N
96	25017368500	2010	321.000	\N
96	25017368600	2010	550.000	\N
96	25017368700	2010	344.000	\N
96	25017368800	2010	491.000	\N
96	25017368901	2010	250.000	\N
96	25017368902	2010	321.000	\N
96	25017369000	2010	62.000	\N
96	25017369100	2010	136.000	\N
96	25017370101	2010	198.000	\N
96	25017370102	2010	272.000	\N
96	25017370201	2010	91.000	\N
96	25017370202	2010	108.000	\N
96	25017370300	2010	219.000	\N
96	25017370400	2010	138.000	\N
96	25017373100	2010	100.000	\N
96	25017373200	2010	148.000	\N
96	25017373300	2010	50.000	\N
96	25017373400	2010	81.000	\N
96	25017373500	2010	179.000	\N
96	25017373600	2010	268.000	\N
96	25017373700	2010	58.000	\N
96	25017373800	2010	158.000	\N
96	25017373900	2010	146.000	\N
96	25017374000	2010	128.000	\N
96	25017374100	2010	138.000	\N
96	25017374200	2010	109.000	\N
96	25017374300	2010	53.000	\N
96	25017374400	2010	129.000	\N
96	25017374500	2010	147.000	\N
96	25017374600	2010	159.000	\N
96	25017374700	2010	118.000	\N
96	25017374800	2010	104.000	\N
96	25017382100	2010	91.000	\N
96	25017382200	2010	113.000	\N
96	25017382300	2010	99.000	\N
96	25017382400	2010	62.000	\N
96	25017382500	2010	88.000	\N
96	25017382601	2010	102.000	\N
96	25017382602	2010	78.000	\N
96	25017383101	2010	607.000	\N
96	25017383102	2010	1169.000	\N
96	25017383200	2010	680.000	\N
96	25017383300	2010	112.000	\N
96	25017383400	2010	497.000	\N
96	25017383501	2010	257.000	\N
96	25017383502	2010	136.000	\N
96	25017383600	2010	225.000	\N
96	25017383700	2010	205.000	\N
96	25017383800	2010	138.000	\N
96	25017383901	2010	189.000	\N
96	25017383902	2010	77.000	\N
96	25017384001	2010	39.000	\N
96	25017384002	2010	166.000	\N
96	25017385100	2010	139.000	\N
96	25017385201	2010	94.000	\N
96	25017385202	2010	215.000	\N
96	25017386100	2010	42.000	\N
96	25017387100	2010	54.000	\N
96	25017387201	2010	73.000	\N
96	25017387202	2010	53.000	\N
96	25017388100	2010	83.000	\N
96	25017388200	2010	474.000	\N
96	25017388300	2010	648.000	\N
96	25017980000	2010	0.000	\N
96	25019950100	2010	23.000	\N
96	25019950200	2010	432.000	\N
96	25019950307	2010	0.000	\N
96	25019950400	2010	253.000	\N
96	25019950500	2010	13.000	\N
96	25019990000	2010	0.000	\N
96	25021400100	2010	193.000	\N
96	25021400200	2010	260.000	\N
96	25021400300	2010	128.000	\N
96	25021400400	2010	161.000	\N
96	25021400500	2010	183.000	\N
96	25021400600	2010	153.000	\N
96	25021400700	2010	108.000	\N
96	25021400800	2010	195.000	\N
96	25021400900	2010	138.000	\N
96	25021401000	2010	145.000	\N
96	25021401100	2010	120.000	\N
96	25021401200	2010	197.000	\N
96	25021402101	2010	121.000	\N
96	25021402102	2010	178.000	\N
96	25021402200	2010	106.000	\N
96	25021402300	2010	96.000	\N
96	25021402400	2010	160.000	\N
96	25021402500	2010	150.000	\N
96	25021403100	2010	118.000	\N
96	25021403300	2010	88.000	\N
96	25021403400	2010	120.000	\N
96	25021403500	2010	98.000	\N
96	25021404100	2010	136.000	\N
96	25021404201	2010	65.000	\N
96	25021404202	2010	177.000	\N
96	25021404301	2010	116.000	\N
96	25021404302	2010	90.000	\N
96	25021404400	2010	172.000	\N
96	25021405100	2010	59.000	\N
96	25021406101	2010	72.000	\N
96	25021406102	2010	70.000	\N
96	25021407100	2010	115.000	\N
96	25021408101	2010	115.000	\N
96	25021408102	2010	70.000	\N
96	25021409101	2010	482.000	\N
96	25021409102	2010	48.000	\N
96	25021410100	2010	56.000	\N
96	25021410300	2010	54.000	\N
96	25021410400	2010	90.000	\N
96	25021411100	2010	139.000	\N
96	25021411200	2010	95.000	\N
96	25021411301	2010	48.000	\N
96	25021411302	2010	163.000	\N
96	25021412100	2010	79.000	\N
96	25021412200	2010	39.000	\N
96	25021412300	2010	56.000	\N
96	25021413100	2010	110.000	\N
96	25021413200	2010	122.000	\N
96	25021413300	2010	108.000	\N
96	25021413401	2010	64.000	\N
96	25021413402	2010	129.000	\N
96	25021413500	2010	170.000	\N
96	25021414100	2010	71.000	\N
96	25021414200	2010	105.000	\N
96	25021414300	2010	50.000	\N
96	25021415101	2010	52.000	\N
96	25021415102	2010	116.000	\N
96	25021415200	2010	115.000	\N
96	25021415300	2010	39.000	\N
96	25021416101	2010	79.000	\N
96	25021416102	2010	66.000	\N
96	25021416200	2010	118.000	\N
96	25021416300	2010	98.000	\N
96	25021416400	2010	51.000	\N
96	25021417100	2010	45.000	\N
96	25021417200	2010	72.000	\N
96	25021417300	2010	44.000	\N
96	25021417400	2010	29.000	\N
96	25021417501	2010	64.000	\N
96	25021417502	2010	85.000	\N
96	25021417601	2010	84.000	\N
96	25021417602	2010	77.000	\N
96	25021417701	2010	99.000	\N
96	25021417702	2010	52.000	\N
96	25021417801	2010	79.000	\N
96	25021417802	2010	44.000	\N
96	25021417901	2010	102.000	\N
96	25021417902	2010	100.000	\N
96	25021418002	2010	133.000	\N
96	25021418003	2010	89.000	\N
96	25021418004	2010	105.000	\N
96	25021418101	2010	97.000	\N
96	25021418102	2010	99.000	\N
96	25021418200	2010	151.000	\N
96	25021419100	2010	49.000	\N
96	25021419200	2010	83.000	\N
96	25021419300	2010	109.000	\N
96	25021419400	2010	46.000	\N
96	25021419500	2010	37.000	\N
96	25021419600	2010	73.000	\N
96	25021419700	2010	48.000	\N
96	25021419800	2010	60.000	\N
96	25021420100	2010	220.000	\N
96	25021420201	2010	82.000	\N
96	25021420202	2010	120.000	\N
96	25021420301	2010	205.000	\N
96	25021420302	2010	182.000	\N
96	25021421100	2010	110.000	\N
96	25021421200	2010	104.000	\N
96	25021422100	2010	69.000	\N
96	25021422200	2010	71.000	\N
96	25021422301	2010	25.000	\N
96	25021422302	2010	115.000	\N
96	25021422400	2010	124.000	\N
96	25021422501	2010	70.000	\N
96	25021422502	2010	120.000	\N
96	25021422600	2010	112.000	\N
96	25021422700	2010	87.000	\N
96	25021422800	2010	73.000	\N
96	25021423100	2010	83.000	\N
96	25021440100	2010	94.000	\N
96	25021441202	2010	38.000	\N
96	25021441203	2010	27.000	\N
96	25021441204	2010	28.000	\N
96	25021442101	2010	83.000	\N
96	25021442102	2010	94.000	\N
96	25021442103	2010	92.000	\N
96	25021442201	2010	58.000	\N
96	25021442202	2010	97.000	\N
96	25021443101	2010	155.000	\N
96	25021443102	2010	99.000	\N
96	25021456101	2010	59.000	\N
96	25021456102	2010	109.000	\N
96	25021456200	2010	33.000	\N
96	25021456301	2010	23.000	\N
96	25021456302	2010	99.000	\N
96	25021456401	2010	42.000	\N
96	25021456402	2010	129.000	\N
96	25021457100	2010	45.000	\N
96	25021457200	2010	73.000	\N
96	25023500101	2010	30.000	\N
96	25023500103	2010	21.000	\N
96	25023500104	2010	49.000	\N
96	25023501101	2010	20.000	\N
96	25023501102	2010	79.000	\N
96	25023501201	2010	29.000	\N
96	25023501202	2010	62.000	\N
96	25023502101	2010	65.000	\N
96	25023502102	2010	93.000	\N
96	25023502200	2010	58.000	\N
96	25023503101	2010	60.000	\N
96	25023503102	2010	32.000	\N
96	25023504101	2010	75.000	\N
96	25023504102	2010	28.000	\N
96	25023505101	2010	51.000	\N
96	25023505102	2010	43.000	\N
96	25023505200	2010	54.000	\N
96	25023506101	2010	56.000	\N
96	25023506102	2010	57.000	\N
96	25023506202	2010	14.000	\N
96	25023506203	2010	52.000	\N
96	25023506204	2010	30.000	\N
96	25023507101	2010	58.000	\N
96	25023507103	2010	54.000	\N
96	25023507104	2010	38.000	\N
96	25023508101	2010	55.000	\N
96	25023508102	2010	33.000	\N
96	25023508200	2010	48.000	\N
96	25023509101	2010	64.000	\N
96	25023509102	2010	42.000	\N
96	25023510100	2010	156.000	\N
96	25023510200	2010	192.000	\N
96	25023510300	2010	133.000	\N
96	25023510400	2010	228.000	\N
96	25023510501	2010	96.000	\N
96	25023510502	2010	210.000	\N
96	25023510503	2010	137.000	\N
96	25023510600	2010	63.000	\N
96	25023510700	2010	172.000	\N
96	25023510800	2010	238.000	\N
96	25023510900	2010	143.000	\N
96	25023511000	2010	166.000	\N
96	25023511100	2010	172.000	\N
96	25023511200	2010	205.000	\N
96	25023511301	2010	233.000	\N
96	25023511302	2010	151.000	\N
96	25023511400	2010	180.000	\N
96	25023511500	2010	168.000	\N
96	25023511600	2010	286.000	\N
96	25023511701	2010	144.000	\N
96	25023511702	2010	80.000	\N
96	25023520100	2010	69.000	\N
96	25023520201	2010	25.000	\N
96	25023520202	2010	77.000	\N
96	25023521101	2010	51.000	\N
96	25023521102	2010	44.000	\N
96	25023521201	2010	44.000	\N
96	25023521202	2010	26.000	\N
96	25023522101	2010	35.000	\N
96	25023522102	2010	30.000	\N
96	25023523100	2010	29.000	\N
96	25023523201	2010	16.000	\N
96	25023523202	2010	90.000	\N
96	25023524101	2010	49.000	\N
96	25023524102	2010	39.000	\N
96	25023525101	2010	79.000	\N
96	25023525104	2010	49.000	\N
96	25023525203	2010	72.000	\N
96	25023525204	2010	34.000	\N
96	25023525300	2010	251.000	\N
96	25023526100	2010	55.000	\N
96	25023530100	2010	55.000	\N
96	25023530200	2010	53.000	\N
96	25023530300	2010	57.000	\N
96	25023530400	2010	45.000	\N
96	25023530500	2010	43.000	\N
96	25023530600	2010	184.000	\N
96	25023530700	2010	40.000	\N
96	25023530801	2010	43.000	\N
96	25023530802	2010	44.000	\N
96	25023530901	2010	115.000	\N
96	25023530902	2010	38.000	\N
96	25023540101	2010	26.000	\N
96	25023540102	2010	20.000	\N
96	25023540103	2010	29.000	\N
96	25023541100	2010	31.000	\N
96	25023542101	2010	91.000	\N
96	25023542102	2010	20.000	\N
96	25023542200	2010	64.000	\N
96	25023542300	2010	105.000	\N
96	25023543100	2010	23.000	\N
96	25023544100	2010	37.000	\N
96	25023544200	2010	43.000	\N
96	25023545100	2010	78.000	\N
96	25023545200	2010	105.000	\N
96	25023545300	2010	50.000	\N
96	25023545400	2010	47.000	\N
96	25023560100	2010	42.000	\N
96	25023561100	2010	41.000	\N
96	25023561200	2010	56.000	\N
96	25023990003	2010	0.000	\N
96	25025000100	2010	240.000	\N
96	25025000201	2010	190.000	\N
96	25025000202	2010	250.000	\N
96	25025000301	2010	100.000	\N
96	25025000302	2010	177.000	\N
96	25025000401	2010	155.000	\N
96	25025000402	2010	129.000	\N
96	25025000502	2010	307.000	\N
96	25025000503	2010	59.000	\N
96	25025000504	2010	195.000	\N
96	25025000601	2010	165.000	\N
96	25025000602	2010	264.000	\N
96	25025000701	2010	176.000	\N
96	25025000703	2010	113.000	\N
96	25025000704	2010	336.000	\N
96	25025000802	2010	673.000	\N
96	25025000803	2010	398.000	\N
96	25025010103	2010	226.000	\N
96	25025010104	2010	299.000	\N
96	25025010203	2010	347.000	\N
96	25025010204	2010	114.000	\N
96	25025010300	2010	177.000	\N
96	25025010403	2010	144.000	\N
96	25025010404	2010	240.000	\N
96	25025010405	2010	233.000	\N
96	25025010408	2010	84.000	\N
96	25025010500	2010	193.000	\N
96	25025010600	2010	116.000	\N
96	25025010701	2010	96.000	\N
96	25025010702	2010	64.000	\N
96	25025010801	2010	104.000	\N
96	25025010802	2010	88.000	\N
96	25025020101	2010	114.000	\N
96	25025020200	2010	121.000	\N
96	25025020301	2010	82.000	\N
96	25025020302	2010	49.000	\N
96	25025020303	2010	317.000	\N
96	25025030100	2010	50.000	\N
96	25025030200	2010	57.000	\N
96	25025030300	2010	153.000	\N
96	25025030400	2010	58.000	\N
96	25025030500	2010	68.000	\N
96	25025040100	2010	25.000	\N
96	25025040200	2010	147.000	\N
96	25025040300	2010	132.000	\N
96	25025040401	2010	68.000	\N
96	25025040600	2010	49.000	\N
96	25025040801	2010	285.000	\N
96	25025050101	2010	1556.000	\N
96	25025050200	2010	1660.000	\N
96	25025050300	2010	416.000	\N
96	25025050400	2010	704.000	\N
96	25025050500	2010	599.000	\N
96	25025050600	2010	755.000	\N
96	25025050700	2010	1226.000	\N
96	25025050901	2010	1557.000	\N
96	25025051000	2010	919.000	\N
96	25025051101	2010	1236.000	\N
96	25025051200	2010	507.000	\N
96	25025060101	2010	31.000	\N
96	25025060200	2010	10.000	\N
96	25025060301	2010	17.000	\N
96	25025060400	2010	60.000	\N
96	25025060501	2010	36.000	\N
96	25025060600	2010	71.000	\N
96	25025060700	2010	218.000	\N
96	25025060800	2010	53.000	\N
96	25025061000	2010	242.000	\N
96	25025061101	2010	361.000	\N
96	25025061200	2010	99.000	\N
96	25025070101	2010	229.000	\N
96	25025070200	2010	80.000	\N
96	25025070300	2010	108.000	\N
96	25025070402	2010	44.000	\N
96	25025070500	2010	460.000	\N
96	25025070600	2010	64.000	\N
96	25025070700	2010	110.000	\N
96	25025070800	2010	172.000	\N
96	25025070900	2010	243.000	\N
96	25025071101	2010	180.000	\N
96	25025071201	2010	250.000	\N
96	25025080100	2010	606.000	\N
96	25025080300	2010	115.000	\N
96	25025080401	2010	288.000	\N
96	25025080500	2010	413.000	\N
96	25025080601	2010	223.000	\N
96	25025080801	2010	450.000	\N
96	25025080900	2010	147.000	\N
96	25025081001	2010	332.000	\N
96	25025081100	2010	278.000	\N
96	25025081200	2010	564.000	\N
96	25025081300	2010	638.000	\N
96	25025081400	2010	145.000	\N
96	25025081500	2010	159.000	\N
96	25025081700	2010	188.000	\N
96	25025081800	2010	138.000	\N
96	25025081900	2010	195.000	\N
96	25025082000	2010	120.000	\N
96	25025082100	2010	338.000	\N
96	25025090100	2010	166.000	\N
96	25025090200	2010	184.000	\N
96	25025090300	2010	270.000	\N
96	25025090400	2010	299.000	\N
96	25025090600	2010	140.000	\N
96	25025090700	2010	150.000	\N
96	25025090901	2010	274.000	\N
96	25025091001	2010	64.000	\N
96	25025091100	2010	183.000	\N
96	25025091200	2010	180.000	\N
96	25025091300	2010	151.000	\N
96	25025091400	2010	217.000	\N
96	25025091500	2010	219.000	\N
96	25025091600	2010	104.000	\N
96	25025091700	2010	154.000	\N
96	25025091800	2010	162.000	\N
96	25025091900	2010	187.000	\N
96	25025092000	2010	256.000	\N
96	25025092101	2010	214.000	\N
96	25025092200	2010	119.000	\N
96	25025092300	2010	113.000	\N
96	25025092400	2010	354.000	\N
96	25025100100	2010	398.000	\N
96	25025100200	2010	67.000	\N
96	25025100300	2010	60.000	\N
96	25025100400	2010	91.000	\N
96	25025100500	2010	244.000	\N
96	25025100601	2010	115.000	\N
96	25025100603	2010	67.000	\N
96	25025100700	2010	54.000	\N
96	25025100800	2010	142.000	\N
96	25025100900	2010	72.000	\N
96	25025101001	2010	118.000	\N
96	25025101002	2010	117.000	\N
96	25025101101	2010	39.000	\N
96	25025101102	2010	119.000	\N
96	25025110103	2010	668.000	\N
96	25025110201	2010	271.000	\N
96	25025110301	2010	272.000	\N
96	25025110401	2010	538.000	\N
96	25025110403	2010	391.000	\N
96	25025110501	2010	178.000	\N
96	25025110502	2010	426.000	\N
96	25025110601	2010	86.000	\N
96	25025110607	2010	250.000	\N
96	25025120103	2010	51.000	\N
96	25025120104	2010	194.000	\N
96	25025120105	2010	87.000	\N
96	25025120201	2010	283.000	\N
96	25025120301	2010	616.000	\N
96	25025120400	2010	300.000	\N
96	25025120500	2010	420.000	\N
96	25025120600	2010	137.000	\N
96	25025120700	2010	148.000	\N
96	25025130100	2010	160.000	\N
96	25025130200	2010	141.000	\N
96	25025130300	2010	140.000	\N
96	25025130402	2010	163.000	\N
96	25025130404	2010	172.000	\N
96	25025130406	2010	337.000	\N
96	25025140102	2010	249.000	\N
96	25025140105	2010	354.000	\N
96	25025140106	2010	179.000	\N
96	25025140107	2010	271.000	\N
96	25025140201	2010	104.000	\N
96	25025140202	2010	368.000	\N
96	25025140300	2010	483.000	\N
96	25025140400	2010	362.000	\N
96	25025160101	2010	2037.000	\N
96	25025160200	2010	841.000	\N
96	25025160300	2010	208.000	\N
96	25025160400	2010	656.000	\N
96	25025160501	2010	1606.000	\N
96	25025160502	2010	1029.000	\N
96	25025160601	2010	780.000	\N
96	25025160602	2010	793.000	\N
96	25025170100	2010	835.000	\N
96	25025170200	2010	370.000	\N
96	25025170300	2010	650.000	\N
96	25025170400	2010	574.000	\N
96	25025170501	2010	470.000	\N
96	25025170502	2010	167.000	\N
96	25025170601	2010	610.000	\N
96	25025170701	2010	316.000	\N
96	25025170702	2010	1394.000	\N
96	25025170800	2010	662.000	\N
96	25025180101	2010	141.000	\N
96	25025180200	2010	156.000	\N
96	25025180301	2010	93.000	\N
96	25025180400	2010	52.000	\N
96	25025180500	2010	127.000	\N
96	25025980101	2010	45.000	\N
96	25025980300	2010	43.000	\N
96	25025980700	2010	0.000	\N
96	25025981000	2010	0.000	\N
96	25025981100	2010	45.000	\N
96	25025981201	2010	0.000	\N
96	25025981202	2010	29.000	\N
96	25025981300	2010	57.000	\N
96	25025981501	2010	1.000	\N
96	25025981502	2010	2.000	\N
96	25025981600	2010	0.000	\N
96	25025981700	2010	0.000	\N
96	25025981800	2010	2.000	\N
96	25025990101	2010	0.000	\N
96	25027700100	2010	96.000	\N
96	25027701100	2010	170.000	\N
96	25027702200	2010	42.000	\N
96	25027703100	2010	98.000	\N
96	25027703200	2010	54.000	\N
96	25027703300	2010	84.000	\N
96	25027704200	2010	40.000	\N
96	25027705100	2010	96.000	\N
96	25027706100	2010	45.000	\N
96	25027707100	2010	192.000	\N
96	25027707200	2010	90.000	\N
96	25027707300	2010	108.000	\N
96	25027707400	2010	130.000	\N
96	25027707500	2010	381.000	\N
96	25027708100	2010	139.000	\N
96	25027709100	2010	250.000	\N
96	25027709201	2010	407.000	\N
96	25027709202	2010	787.000	\N
96	25027709400	2010	721.000	\N
96	25027709501	2010	61.000	\N
96	25027709502	2010	243.000	\N
96	25027709600	2010	303.000	\N
96	25027709701	2010	532.000	\N
96	25027709702	2010	126.000	\N
96	25027710100	2010	484.000	\N
96	25027710200	2010	499.000	\N
96	25027710300	2010	240.000	\N
96	25027710400	2010	155.000	\N
96	25027710500	2010	507.000	\N
96	25027710600	2010	877.000	\N
96	25027710700	2010	259.000	\N
96	25027710800	2010	479.000	\N
96	25027711000	2010	355.000	\N
96	25027711100	2010	172.000	\N
96	25027712101	2010	86.000	\N
96	25027712102	2010	63.000	\N
96	25027713100	2010	391.000	\N
96	25027715100	2010	72.000	\N
96	25027716100	2010	428.000	\N
96	25027716200	2010	238.000	\N
96	25027716300	2010	295.000	\N
96	25027717100	2010	37.000	\N
96	25027718100	2010	40.000	\N
96	25027719100	2010	130.000	\N
96	25027720100	2010	41.000	\N
96	25027721101	2010	37.000	\N
96	25027721102	2010	115.000	\N
96	25027722100	2010	72.000	\N
96	25027723100	2010	36.000	\N
96	25027724100	2010	35.000	\N
96	25027725100	2010	62.000	\N
96	25027726100	2010	51.000	\N
96	25027726200	2010	137.000	\N
96	25027727100	2010	106.000	\N
96	25027728100	2010	66.000	\N
96	25027728200	2010	43.000	\N
96	25027728300	2010	80.000	\N
96	25027728400	2010	45.000	\N
96	25027729100	2010	292.000	\N
96	25027729200	2010	49.000	\N
96	25027730100	2010	251.000	\N
96	25027730200	2010	240.000	\N
96	25027730300	2010	209.000	\N
96	25027730401	2010	610.000	\N
96	25027730402	2010	227.000	\N
96	25027730500	2010	298.000	\N
96	25027730600	2010	235.000	\N
96	25027730700	2010	195.000	\N
96	25027730801	2010	86.000	\N
96	25027730802	2010	83.000	\N
96	25027730901	2010	96.000	\N
96	25027730902	2010	111.000	\N
96	25027731001	2010	151.000	\N
96	25027731002	2010	503.000	\N
96	25027731101	2010	448.000	\N
96	25027731102	2010	120.000	\N
96	25027731202	2010	27.000	\N
96	25027731203	2010	943.000	\N
96	25027731204	2010	482.000	\N
96	25027731300	2010	698.000	\N
96	25027731400	2010	1045.000	\N
96	25027731500	2010	1029.000	\N
96	25027731600	2010	515.000	\N
96	25027731700	2010	404.000	\N
96	25027731800	2010	1142.000	\N
96	25027731900	2010	980.000	\N
96	25027732001	2010	967.000	\N
96	25027732002	2010	297.000	\N
96	25027732201	2010	115.000	\N
96	25027732202	2010	147.000	\N
96	25027732203	2010	334.000	\N
96	25027732301	2010	192.000	\N
96	25027732302	2010	307.000	\N
96	25027732400	2010	1159.000	\N
96	25027732500	2010	255.000	\N
96	25027732600	2010	649.000	\N
96	25027732700	2010	545.000	\N
96	25027732801	2010	199.000	\N
96	25027732802	2010	170.000	\N
96	25027732901	2010	548.000	\N
96	25027732902	2010	123.000	\N
96	25027733000	2010	498.000	\N
96	25027733101	2010	126.000	\N
96	25027733102	2010	133.000	\N
96	25027735100	2010	135.000	\N
96	25027735200	2010	109.000	\N
96	25027736100	2010	45.000	\N
96	25027736200	2010	42.000	\N
96	25027736300	2010	83.000	\N
96	25027736400	2010	69.000	\N
96	25027736500	2010	45.000	\N
96	25027737100	2010	59.000	\N
96	25027737200	2010	23.000	\N
96	25027737300	2010	106.000	\N
96	25027738100	2010	98.000	\N
96	25027738201	2010	58.000	\N
96	25027738202	2010	54.000	\N
96	25027739100	2010	190.000	\N
96	25027739200	2010	126.000	\N
96	25027739300	2010	75.000	\N
96	25027739400	2010	131.000	\N
96	25027739500	2010	131.000	\N
96	25027740101	2010	69.000	\N
96	25027740102	2010	122.000	\N
96	25027740200	2010	54.000	\N
96	25027741101	2010	100.000	\N
96	25027741102	2010	100.000	\N
96	25027742300	2010	105.000	\N
96	25027742401	2010	72.000	\N
96	25027742402	2010	48.000	\N
96	25027743100	2010	83.000	\N
96	25027744101	2010	216.000	\N
96	25027744102	2010	171.000	\N
96	25027744200	2010	311.000	\N
96	25027744300	2010	380.000	\N
96	25027744400	2010	211.000	\N
96	25027745100	2010	79.000	\N
96	25027746100	2010	43.000	\N
96	25027747101	2010	83.000	\N
96	25027747102	2010	66.000	\N
96	25027748100	2010	32.000	\N
96	25027749100	2010	92.000	\N
96	25027749200	2010	86.000	\N
96	25027750100	2010	159.000	\N
96	25027750200	2010	89.000	\N
96	25027750300	2010	103.000	\N
96	25027751101	2010	65.000	\N
96	25027751102	2010	22.000	\N
96	25027752100	2010	107.000	\N
96	25027753100	2010	187.000	\N
96	25027753200	2010	88.000	\N
96	25027754100	2010	129.000	\N
96	25027754200	2010	174.000	\N
96	25027754300	2010	233.000	\N
96	25027754400	2010	99.000	\N
96	25027755100	2010	77.000	\N
96	25027755200	2010	117.000	\N
96	25027756101	2010	79.000	\N
96	25027756102	2010	176.000	\N
96	25027757100	2010	602.000	\N
96	25027757200	2010	509.000	\N
96	25027757300	2010	431.000	\N
96	25027757400	2010	230.000	\N
96	25027757500	2010	343.000	\N
96	25027758101	2010	15.000	\N
96	25027758102	2010	136.000	\N
96	25027759100	2010	42.000	\N
96	25027760100	2010	34.000	\N
96	25027761100	2010	78.000	\N
96	25027761200	2010	195.000	\N
96	25027761300	2010	61.000	\N
96	25027761400	2010	219.000	\N
97	25001010100	2010	4.000	\N
97	25001010206	2010	0.000	\N
97	25001010208	2010	1.000	\N
97	25001010304	2010	0.000	\N
97	25001010306	2010	0.000	\N
97	25001010400	2010	2.000	\N
97	25001010500	2010	1.000	\N
97	25001010600	2010	5.000	\N
97	25001010700	2010	0.000	\N
97	25001010800	2010	3.000	\N
97	25001010900	2010	1.000	\N
97	25001011002	2010	0.000	\N
97	25001011100	2010	1.000	\N
97	25001011200	2010	4.000	\N
97	25001011300	2010	1.000	\N
97	25001011400	2010	6.000	\N
97	25001011500	2010	10.000	\N
97	25001011600	2010	5.000	\N
97	25001011700	2010	1.000	\N
97	25001011801	2010	0.000	\N
97	25001011802	2010	2.000	\N
97	25001012001	2010	12.000	\N
97	25001012002	2010	7.000	\N
97	25001012101	2010	10.000	\N
97	25001012102	2010	7.000	\N
97	25001012200	2010	0.000	\N
97	25001012502	2010	8.000	\N
97	25001012601	2010	8.000	\N
97	25001012602	2010	14.000	\N
97	25001012700	2010	5.000	\N
97	25001012800	2010	3.000	\N
97	25001012900	2010	2.000	\N
97	25001013002	2010	2.000	\N
97	25001013100	2010	6.000	\N
97	25001013200	2010	6.000	\N
97	25001013300	2010	2.000	\N
97	25001013400	2010	0.000	\N
97	25001013500	2010	2.000	\N
97	25001013600	2010	4.000	\N
97	25001013700	2010	0.000	\N
97	25001013800	2010	3.000	\N
97	25001013900	2010	3.000	\N
97	25001014002	2010	4.000	\N
97	25001014100	2010	3.000	\N
97	25001014300	2010	1.000	\N
97	25001014402	2010	2.000	\N
97	25001014500	2010	4.000	\N
97	25001014600	2010	6.000	\N
97	25001014700	2010	1.000	\N
97	25001014800	2010	2.000	\N
97	25001014900	2010	2.000	\N
97	25001015001	2010	2.000	\N
97	25001015002	2010	4.000	\N
97	25001015100	2010	2.000	\N
97	25001015200	2010	0.000	\N
97	25001015300	2010	21.000	\N
97	25001990000	2010	0.000	\N
97	25003900100	2010	19.000	\N
97	25003900200	2010	33.000	\N
97	25003900300	2010	9.000	\N
97	25003900400	2010	17.000	\N
97	25003900500	2010	7.000	\N
97	25003900600	2010	43.000	\N
97	25003900700	2010	0.000	\N
97	25003900800	2010	0.000	\N
97	25003900900	2010	15.000	\N
97	25003901100	2010	5.000	\N
97	25003911100	2010	4.000	\N
97	25003912100	2010	1.000	\N
97	25003913100	2010	3.000	\N
97	25003914100	2010	4.000	\N
97	25003920101	2010	8.000	\N
97	25003920102	2010	4.000	\N
97	25003921300	2010	18.000	\N
97	25003921400	2010	5.000	\N
97	25003921500	2010	0.000	\N
97	25003922100	2010	2.000	\N
97	25003922200	2010	1.000	\N
97	25003922300	2010	2.000	\N
97	25003923100	2010	1.000	\N
97	25003924100	2010	0.000	\N
97	25003925100	2010	12.000	\N
97	25003926100	2010	2.000	\N
97	25003931100	2010	0.000	\N
97	25003931300	2010	1.000	\N
97	25003931400	2010	0.000	\N
97	25003932200	2010	0.000	\N
97	25003932300	2010	0.000	\N
97	25003933200	2010	0.000	\N
97	25003933300	2010	4.000	\N
97	25003933400	2010	0.000	\N
97	25003934200	2010	1.000	\N
97	25003934300	2010	0.000	\N
97	25003935100	2010	2.000	\N
97	25003935200	2010	7.000	\N
97	25003935300	2010	8.000	\N
97	25005600100	2010	0.000	\N
97	25005600202	2010	0.000	\N
97	25005600203	2010	9.000	\N
97	25005600204	2010	5.000	\N
97	25005610100	2010	8.000	\N
97	25005610202	2010	4.000	\N
97	25005610203	2010	3.000	\N
97	25005610204	2010	18.000	\N
97	25005611101	2010	3.000	\N
97	25005611102	2010	18.000	\N
97	25005611201	2010	3.000	\N
97	25005611202	2010	7.000	\N
97	25005612100	2010	1.000	\N
97	25005612200	2010	5.000	\N
97	25005613100	2010	7.000	\N
97	25005613300	2010	8.000	\N
97	25005613400	2010	36.000	\N
97	25005613600	2010	18.000	\N
97	25005613700	2010	13.000	\N
97	25005613800	2010	20.000	\N
97	25005613901	2010	30.000	\N
97	25005613902	2010	12.000	\N
97	25005614000	2010	53.000	\N
97	25005614101	2010	35.000	\N
97	25005614102	2010	12.000	\N
97	25005615100	2010	1.000	\N
97	25005616100	2010	3.000	\N
97	25005617101	2010	1.000	\N
97	25005617102	2010	3.000	\N
97	25005630101	2010	2.000	\N
97	25005630102	2010	2.000	\N
97	25005630200	2010	3.000	\N
97	25005630300	2010	0.000	\N
97	25005630400	2010	3.000	\N
97	25005631100	2010	10.000	\N
97	25005631200	2010	4.000	\N
97	25005631300	2010	7.000	\N
97	25005631400	2010	4.000	\N
97	25005631500	2010	2.000	\N
97	25005631600	2010	15.000	\N
97	25005631700	2010	3.000	\N
97	25005631800	2010	7.000	\N
97	25005632100	2010	4.000	\N
97	25005632200	2010	6.000	\N
97	25005633100	2010	2.000	\N
97	25005633200	2010	2.000	\N
97	25005640100	2010	41.000	\N
97	25005640200	2010	20.000	\N
97	25005640300	2010	56.000	\N
97	25005640400	2010	0.000	\N
97	25005640500	2010	23.000	\N
97	25005640600	2010	35.000	\N
97	25005640700	2010	3.000	\N
97	25005640800	2010	30.000	\N
97	25005640901	2010	34.000	\N
97	25005641000	2010	15.000	\N
97	25005641101	2010	23.000	\N
97	25005641200	2010	27.000	\N
97	25005641300	2010	35.000	\N
97	25005641400	2010	10.000	\N
97	25005641500	2010	9.000	\N
97	25005641600	2010	0.000	\N
97	25005641700	2010	14.000	\N
97	25005641800	2010	7.000	\N
97	25005641900	2010	4.000	\N
97	25005642000	2010	14.000	\N
97	25005642100	2010	22.000	\N
97	25005642200	2010	17.000	\N
97	25005642300	2010	0.000	\N
97	25005642400	2010	10.000	\N
97	25005642500	2010	1.000	\N
97	25005644101	2010	2.000	\N
97	25005644102	2010	0.000	\N
97	25005644200	2010	0.000	\N
97	25005645101	2010	1.000	\N
97	25005645102	2010	4.000	\N
97	25005645103	2010	1.000	\N
97	25005646101	2010	4.000	\N
97	25005646103	2010	1.000	\N
97	25005646104	2010	0.000	\N
97	25005650101	2010	7.000	\N
97	25005650102	2010	55.000	\N
97	25005650201	2010	12.000	\N
97	25005650202	2010	12.000	\N
97	25005650300	2010	24.000	\N
97	25005650400	2010	30.000	\N
97	25005650500	2010	26.000	\N
97	25005650600	2010	37.000	\N
97	25005650700	2010	60.000	\N
97	25005650800	2010	24.000	\N
97	25005650900	2010	92.000	\N
97	25005651001	2010	4.000	\N
97	25005651002	2010	30.000	\N
97	25005651100	2010	96.000	\N
97	25005651200	2010	41.000	\N
97	25005651300	2010	62.000	\N
97	25005651400	2010	45.000	\N
97	25005651500	2010	66.000	\N
97	25005651600	2010	41.000	\N
97	25005651700	2010	44.000	\N
97	25005651800	2010	27.000	\N
97	25005651900	2010	48.000	\N
97	25005652000	2010	23.000	\N
97	25005652100	2010	20.000	\N
97	25005652200	2010	6.000	\N
97	25005652300	2010	28.000	\N
97	25005652400	2010	25.000	\N
97	25005652500	2010	28.000	\N
97	25005652600	2010	105.000	\N
97	25005652700	2010	43.000	\N
97	25005652800	2010	3.000	\N
97	25005653101	2010	3.000	\N
97	25005653102	2010	12.000	\N
97	25005653203	2010	2.000	\N
97	25005653204	2010	5.000	\N
97	25005653301	2010	0.000	\N
97	25005653304	2010	3.000	\N
97	25005654100	2010	1.000	\N
97	25005654200	2010	0.000	\N
97	25005655100	2010	0.000	\N
97	25005655200	2010	4.000	\N
97	25005655300	2010	1.000	\N
97	25005655400	2010	0.000	\N
97	25005985500	2010	20.000	\N
97	25005985600	2010	6.000	\N
97	25005990000	2010	0.000	\N
97	25007200100	2010	3.000	\N
97	25007200200	2010	11.000	\N
97	25007200300	2010	17.000	\N
97	25007200400	2010	3.000	\N
97	25007990000	2010	0.000	\N
97	25009201100	2010	1.000	\N
97	25009202101	2010	1.000	\N
97	25009202102	2010	7.000	\N
97	25009202200	2010	0.000	\N
97	25009203100	2010	5.000	\N
97	25009203200	2010	0.000	\N
97	25009203301	2010	4.000	\N
97	25009203302	2010	11.000	\N
97	25009204101	2010	53.000	\N
97	25009204102	2010	56.000	\N
97	25009204200	2010	64.000	\N
97	25009204300	2010	190.000	\N
97	25009204400	2010	11.000	\N
97	25009204500	2010	47.000	\N
97	25009204600	2010	39.000	\N
97	25009204701	2010	97.000	\N
97	25009204702	2010	33.000	\N
97	25009205100	2010	40.000	\N
97	25009205200	2010	90.000	\N
97	25009205300	2010	12.000	\N
97	25009205400	2010	16.000	\N
97	25009205500	2010	66.000	\N
97	25009205600	2010	96.000	\N
97	25009205700	2010	71.000	\N
97	25009205800	2010	107.000	\N
97	25009205900	2010	101.000	\N
97	25009206000	2010	123.000	\N
97	25009206100	2010	147.000	\N
97	25009206200	2010	147.000	\N
97	25009206300	2010	121.000	\N
97	25009206400	2010	140.000	\N
97	25009206500	2010	130.000	\N
97	25009206600	2010	61.000	\N
97	25009206700	2010	91.000	\N
97	25009206800	2010	162.000	\N
97	25009206900	2010	108.000	\N
97	25009207000	2010	69.000	\N
97	25009207100	2010	73.000	\N
97	25009207200	2010	75.000	\N
97	25009208101	2010	3.000	\N
97	25009208102	2010	9.000	\N
97	25009208200	2010	4.000	\N
97	25009208300	2010	2.000	\N
97	25009208400	2010	9.000	\N
97	25009209100	2010	5.000	\N
97	25009209200	2010	5.000	\N
97	25009210100	2010	8.000	\N
97	25009210200	2010	1.000	\N
97	25009210300	2010	20.000	\N
97	25009210400	2010	36.000	\N
97	25009210500	2010	16.000	\N
97	25009210600	2010	36.000	\N
97	25009210700	2010	60.000	\N
97	25009210800	2010	53.000	\N
97	25009210900	2010	6.000	\N
97	25009211100	2010	1.000	\N
97	25009211200	2010	9.000	\N
97	25009211300	2010	6.000	\N
97	25009211401	2010	9.000	\N
97	25009211402	2010	4.000	\N
97	25009212100	2010	51.000	\N
97	25009213100	2010	5.000	\N
97	25009214100	2010	4.000	\N
97	25009215101	2010	4.000	\N
97	25009215102	2010	0.000	\N
97	25009216100	2010	1.000	\N
97	25009217100	2010	13.000	\N
97	25009217201	2010	1.000	\N
97	25009217202	2010	6.000	\N
97	25009217300	2010	21.000	\N
97	25009217400	2010	18.000	\N
97	25009217500	2010	3.000	\N
97	25009217600	2010	1.000	\N
97	25009218100	2010	1.000	\N
97	25009220101	2010	1.000	\N
97	25009220102	2010	3.000	\N
97	25009221100	2010	3.000	\N
97	25009221300	2010	1.000	\N
97	25009221400	2010	12.000	\N
97	25009221500	2010	4.000	\N
97	25009221600	2010	9.000	\N
97	25009221700	2010	2.000	\N
97	25009221800	2010	0.000	\N
97	25009221901	2010	2.000	\N
97	25009221902	2010	7.000	\N
97	25009222100	2010	1.000	\N
97	25009223100	2010	1.000	\N
97	25009223200	2010	2.000	\N
97	25009223300	2010	1.000	\N
97	25009250100	2010	123.000	\N
97	25009250200	2010	226.000	\N
97	25009250300	2010	115.000	\N
97	25009250400	2010	322.000	\N
97	25009250500	2010	298.000	\N
97	25009250600	2010	362.000	\N
97	25009250700	2010	283.000	\N
97	25009250800	2010	373.000	\N
97	25009250900	2010	192.000	\N
97	25009251000	2010	118.000	\N
97	25009251100	2010	140.000	\N
97	25009251200	2010	98.000	\N
97	25009251300	2010	178.000	\N
97	25009251400	2010	222.000	\N
97	25009251500	2010	345.000	\N
97	25009251600	2010	305.000	\N
97	25009251700	2010	212.000	\N
97	25009251800	2010	154.000	\N
97	25009252101	2010	52.000	\N
97	25009252102	2010	6.000	\N
97	25009252201	2010	23.000	\N
97	25009252202	2010	0.000	\N
97	25009252300	2010	120.000	\N
97	25009252400	2010	193.000	\N
97	25009252501	2010	70.000	\N
97	25009252502	2010	23.000	\N
97	25009252601	2010	23.000	\N
97	25009252602	2010	22.000	\N
97	25009252603	2010	9.000	\N
97	25009253100	2010	19.000	\N
97	25009253201	2010	5.000	\N
97	25009253202	2010	46.000	\N
97	25009253203	2010	0.000	\N
97	25009253204	2010	5.000	\N
97	25009253205	2010	4.000	\N
97	25009254100	2010	3.000	\N
97	25009254200	2010	6.000	\N
97	25009254301	2010	10.000	\N
97	25009254302	2010	2.000	\N
97	25009254401	2010	6.000	\N
97	25009254402	2010	19.000	\N
97	25009254403	2010	2.000	\N
97	25009260100	2010	118.000	\N
97	25009260200	2010	38.000	\N
97	25009260301	2010	6.000	\N
97	25009260302	2010	2.000	\N
97	25009260401	2010	7.000	\N
97	25009260402	2010	7.000	\N
97	25009260500	2010	16.000	\N
97	25009260600	2010	53.000	\N
97	25009260700	2010	28.000	\N
97	25009260800	2010	90.000	\N
97	25009260900	2010	74.000	\N
97	25009261000	2010	23.000	\N
97	25009261101	2010	3.000	\N
97	25009261102	2010	44.000	\N
97	25009262100	2010	4.000	\N
97	25009263100	2010	2.000	\N
97	25009264100	2010	3.000	\N
97	25009265101	2010	0.000	\N
97	25009265102	2010	1.000	\N
97	25009266100	2010	1.000	\N
97	25009266200	2010	3.000	\N
97	25009266300	2010	3.000	\N
97	25009266400	2010	5.000	\N
97	25009267101	2010	2.000	\N
97	25009267102	2010	1.000	\N
97	25009268100	2010	0.000	\N
97	25009268200	2010	3.000	\N
97	25009268300	2010	0.000	\N
97	25009268400	2010	0.000	\N
97	25009269100	2010	2.000	\N
97	25009270100	2010	1.000	\N
97	25009990100	2010	0.000	\N
97	25011040100	2010	4.000	\N
97	25011040200	2010	0.000	\N
97	25011040300	2010	0.000	\N
97	25011040400	2010	6.000	\N
97	25011040501	2010	5.000	\N
97	25011040502	2010	1.000	\N
97	25011040600	2010	1.000	\N
97	25011040701	2010	15.000	\N
97	25011040702	2010	5.000	\N
97	25011040800	2010	13.000	\N
97	25011040900	2010	7.000	\N
97	25011041000	2010	14.000	\N
97	25011041100	2010	1.000	\N
97	25011041200	2010	3.000	\N
97	25011041300	2010	9.000	\N
97	25011041400	2010	8.000	\N
97	25011041501	2010	1.000	\N
97	25011041502	2010	0.000	\N
97	25013800101	2010	74.000	\N
97	25013800102	2010	75.000	\N
97	25013800201	2010	130.000	\N
97	25013800202	2010	26.000	\N
97	25013800300	2010	64.000	\N
97	25013800400	2010	164.000	\N
97	25013800500	2010	101.000	\N
97	25013800600	2010	123.000	\N
97	25013800700	2010	232.000	\N
97	25013800800	2010	102.000	\N
97	25013800900	2010	166.000	\N
97	25013801101	2010	79.000	\N
97	25013801102	2010	30.000	\N
97	25013801200	2010	106.000	\N
97	25013801300	2010	190.000	\N
97	25013801401	2010	143.000	\N
97	25013801402	2010	61.000	\N
97	25013801501	2010	129.000	\N
97	25013801502	2010	60.000	\N
97	25013801503	2010	115.000	\N
97	25013801601	2010	59.000	\N
97	25013801602	2010	94.000	\N
97	25013801603	2010	66.000	\N
97	25013801604	2010	38.000	\N
97	25013801605	2010	144.000	\N
97	25013801700	2010	224.000	\N
97	25013801800	2010	179.000	\N
97	25013801901	2010	195.000	\N
97	25013801902	2010	138.000	\N
97	25013802000	2010	115.000	\N
97	25013802100	2010	126.000	\N
97	25013802200	2010	108.000	\N
97	25013802300	2010	258.000	\N
97	25013802400	2010	32.000	\N
97	25013802500	2010	53.000	\N
97	25013802601	2010	135.000	\N
97	25013802602	2010	5.000	\N
97	25013810100	2010	8.000	\N
97	25013810200	2010	5.000	\N
97	25013810300	2010	2.000	\N
97	25013810403	2010	6.000	\N
97	25013810404	2010	8.000	\N
97	25013810412	2010	2.000	\N
97	25013810414	2010	13.000	\N
97	25013810601	2010	29.000	\N
97	25013810602	2010	4.000	\N
97	25013810700	2010	37.000	\N
97	25013810800	2010	38.000	\N
97	25013810901	2010	33.000	\N
97	25013810902	2010	51.000	\N
97	25013811000	2010	9.000	\N
97	25013811101	2010	89.000	\N
97	25013811102	2010	168.000	\N
97	25013811200	2010	17.000	\N
97	25013811301	2010	25.000	\N
97	25013811302	2010	28.000	\N
97	25013811400	2010	74.000	\N
97	25013811500	2010	136.000	\N
97	25013811600	2010	167.000	\N
97	25013811700	2010	71.000	\N
97	25013811800	2010	107.000	\N
97	25013811900	2010	17.000	\N
97	25013812001	2010	125.000	\N
97	25013812002	2010	86.000	\N
97	25013812101	2010	4.000	\N
97	25013812103	2010	66.000	\N
97	25013812104	2010	53.000	\N
97	25013812201	2010	18.000	\N
97	25013812202	2010	11.000	\N
97	25013812300	2010	52.000	\N
97	25013812401	2010	0.000	\N
97	25013812403	2010	4.000	\N
97	25013812404	2010	13.000	\N
97	25013812500	2010	26.000	\N
97	25013812600	2010	3.000	\N
97	25013812701	2010	30.000	\N
97	25013812702	2010	36.000	\N
97	25013812800	2010	9.000	\N
97	25013812901	2010	1.000	\N
97	25013812902	2010	8.000	\N
97	25013812903	2010	7.000	\N
97	25013813000	2010	6.000	\N
97	25013813101	2010	3.000	\N
97	25013813102	2010	3.000	\N
97	25013813204	2010	0.000	\N
97	25013813205	2010	3.000	\N
97	25013813206	2010	4.000	\N
97	25013813207	2010	10.000	\N
97	25013813208	2010	13.000	\N
97	25013813209	2010	13.000	\N
97	25013813301	2010	8.000	\N
97	25013813303	2010	3.000	\N
97	25013813304	2010	1.000	\N
97	25013813401	2010	7.000	\N
97	25013813403	2010	1.000	\N
97	25013813404	2010	2.000	\N
97	25013813500	2010	0.000	\N
97	25013813601	2010	14.000	\N
97	25013813602	2010	16.000	\N
97	25013813701	2010	0.000	\N
97	25013813702	2010	8.000	\N
97	25013813801	2010	1.000	\N
97	25013813802	2010	1.000	\N
97	25015820101	2010	3.000	\N
97	25015820102	2010	4.000	\N
97	25015820202	2010	1.000	\N
97	25015820203	2010	9.000	\N
97	25015820204	2010	0.000	\N
97	25015820300	2010	32.000	\N
97	25015820400	2010	87.000	\N
97	25015820500	2010	31.000	\N
97	25015820600	2010	14.000	\N
97	25015820700	2010	24.000	\N
97	25015820801	2010	37.000	\N
97	25015820802	2010	4.000	\N
97	25015820900	2010	2.000	\N
97	25015821000	2010	0.000	\N
97	25015821100	2010	9.000	\N
97	25015821200	2010	12.000	\N
97	25015821300	2010	4.000	\N
97	25015821400	2010	6.000	\N
97	25015821500	2010	0.000	\N
97	25015821601	2010	14.000	\N
97	25015821602	2010	24.000	\N
97	25015821700	2010	2.000	\N
97	25015821901	2010	0.000	\N
97	25015821903	2010	17.000	\N
97	25015821904	2010	2.000	\N
97	25015822000	2010	12.000	\N
97	25015822200	2010	5.000	\N
97	25015822300	2010	2.000	\N
97	25015822401	2010	2.000	\N
97	25015822402	2010	10.000	\N
97	25015822500	2010	2.000	\N
97	25015822601	2010	5.000	\N
97	25015822603	2010	1.000	\N
97	25015822605	2010	1.000	\N
97	25015822606	2010	0.000	\N
97	25015822700	2010	0.000	\N
97	25017300100	2010	3.000	\N
97	25017301101	2010	1.000	\N
97	25017301102	2010	1.000	\N
97	25017310100	2010	74.000	\N
97	25017310200	2010	39.000	\N
97	25017310300	2010	61.000	\N
97	25017310400	2010	63.000	\N
97	25017310500	2010	28.000	\N
97	25017310601	2010	15.000	\N
97	25017310602	2010	40.000	\N
97	25017310700	2010	27.000	\N
97	25017311100	2010	53.000	\N
97	25017311200	2010	31.000	\N
97	25017311300	2010	21.000	\N
97	25017311400	2010	34.000	\N
97	25017311500	2010	12.000	\N
97	25017311600	2010	16.000	\N
97	25017311700	2010	40.000	\N
97	25017311800	2010	9.000	\N
97	25017311900	2010	34.000	\N
97	25017312000	2010	52.000	\N
97	25017312100	2010	33.000	\N
97	25017312200	2010	25.000	\N
97	25017312300	2010	18.000	\N
97	25017312400	2010	52.000	\N
97	25017312501	2010	10.000	\N
97	25017312502	2010	11.000	\N
97	25017313101	2010	2.000	\N
97	25017313102	2010	0.000	\N
97	25017314101	2010	11.000	\N
97	25017314102	2010	17.000	\N
97	25017314200	2010	2.000	\N
97	25017314301	2010	15.000	\N
97	25017314302	2010	1.000	\N
97	25017315100	2010	1.000	\N
97	25017315200	2010	8.000	\N
97	25017315401	2010	4.000	\N
97	25017315402	2010	1.000	\N
97	25017315403	2010	0.000	\N
97	25017315500	2010	0.000	\N
97	25017316101	2010	0.000	\N
97	25017316102	2010	6.000	\N
97	25017316201	2010	0.000	\N
97	25017316202	2010	0.000	\N
97	25017316300	2010	3.000	\N
97	25017316400	2010	12.000	\N
97	25017316500	2010	2.000	\N
97	25017317101	2010	8.000	\N
97	25017317102	2010	4.000	\N
97	25017317103	2010	0.000	\N
97	25017317201	2010	2.000	\N
97	25017317202	2010	0.000	\N
97	25017317203	2010	3.000	\N
97	25017317301	2010	2.000	\N
97	25017317302	2010	1.000	\N
97	25017318100	2010	6.000	\N
97	25017318200	2010	0.000	\N
97	25017318300	2010	3.000	\N
97	25017318400	2010	0.000	\N
97	25017320102	2010	1.000	\N
97	25017320103	2010	0.000	\N
97	25017320104	2010	0.000	\N
97	25017321100	2010	13.000	\N
97	25017321200	2010	20.000	\N
97	25017321300	2010	33.000	\N
97	25017321400	2010	4.000	\N
97	25017321500	2010	3.000	\N
97	25017321600	2010	7.000	\N
97	25017322100	2010	0.000	\N
97	25017322200	2010	2.000	\N
97	25017322300	2010	2.000	\N
97	25017322400	2010	9.000	\N
97	25017323100	2010	0.000	\N
97	25017324101	2010	0.000	\N
97	25017324102	2010	8.000	\N
97	25017325100	2010	14.000	\N
97	25017326101	2010	0.000	\N
97	25017326102	2010	1.000	\N
97	25017327101	2010	0.000	\N
97	25017327102	2010	10.000	\N
97	25017327103	2010	0.000	\N
97	25017328100	2010	1.000	\N
97	25017330100	2010	0.000	\N
97	25017330200	2010	0.000	\N
97	25017331101	2010	1.000	\N
97	25017331102	2010	9.000	\N
97	25017331200	2010	2.000	\N
97	25017331300	2010	0.000	\N
97	25017332100	2010	0.000	\N
97	25017332200	2010	5.000	\N
97	25017332300	2010	1.000	\N
97	25017332400	2010	8.000	\N
97	25017333100	2010	4.000	\N
97	25017333200	2010	6.000	\N
97	25017333300	2010	5.000	\N
97	25017333400	2010	13.000	\N
97	25017333501	2010	5.000	\N
97	25017333502	2010	9.000	\N
97	25017333600	2010	13.000	\N
97	25017334100	2010	5.000	\N
97	25017334200	2010	0.000	\N
97	25017334300	2010	0.000	\N
97	25017334400	2010	0.000	\N
97	25017335100	2010	6.000	\N
97	25017335200	2010	2.000	\N
97	25017335301	2010	3.000	\N
97	25017335302	2010	1.000	\N
97	25017335400	2010	3.000	\N
97	25017336100	2010	1.000	\N
97	25017336200	2010	2.000	\N
97	25017336300	2010	2.000	\N
97	25017336401	2010	18.000	\N
97	25017336402	2010	8.000	\N
97	25017337101	2010	8.000	\N
97	25017337102	2010	3.000	\N
97	25017337201	2010	4.000	\N
97	25017337202	2010	3.000	\N
97	25017337300	2010	22.000	\N
97	25017338100	2010	3.000	\N
97	25017338200	2010	4.000	\N
97	25017338300	2010	1.000	\N
97	25017338400	2010	0.000	\N
97	25017338500	2010	0.000	\N
97	25017339100	2010	2.000	\N
97	25017339200	2010	5.000	\N
97	25017339300	2010	15.000	\N
97	25017339400	2010	6.000	\N
97	25017339500	2010	11.000	\N
97	25017339600	2010	18.000	\N
97	25017339700	2010	20.000	\N
97	25017339801	2010	14.000	\N
97	25017339802	2010	30.000	\N
97	25017339900	2010	13.000	\N
97	25017340000	2010	8.000	\N
97	25017340100	2010	10.000	\N
97	25017341101	2010	17.000	\N
97	25017341102	2010	3.000	\N
97	25017341200	2010	21.000	\N
97	25017341300	2010	19.000	\N
97	25017341400	2010	50.000	\N
97	25017341500	2010	24.000	\N
97	25017341600	2010	27.000	\N
97	25017341700	2010	42.000	\N
97	25017341800	2010	33.000	\N
97	25017341901	2010	7.000	\N
97	25017341902	2010	70.000	\N
97	25017342101	2010	32.000	\N
97	25017342102	2010	32.000	\N
97	25017342201	2010	61.000	\N
97	25017342202	2010	35.000	\N
97	25017342300	2010	34.000	\N
97	25017342400	2010	47.000	\N
97	25017342500	2010	51.000	\N
97	25017342600	2010	18.000	\N
97	25017350103	2010	3.000	\N
97	25017350104	2010	65.000	\N
97	25017350200	2010	34.000	\N
97	25017350300	2010	7.000	\N
97	25017350400	2010	6.000	\N
97	25017350500	2010	2.000	\N
97	25017350600	2010	9.000	\N
97	25017350700	2010	35.000	\N
97	25017350800	2010	6.000	\N
97	25017350900	2010	11.000	\N
97	25017351000	2010	11.000	\N
97	25017351100	2010	18.000	\N
97	25017351203	2010	5.000	\N
97	25017351204	2010	4.000	\N
97	25017351300	2010	12.000	\N
97	25017351403	2010	24.000	\N
97	25017351404	2010	26.000	\N
97	25017351500	2010	14.000	\N
97	25017352101	2010	5.000	\N
97	25017352102	2010	5.000	\N
97	25017352200	2010	31.000	\N
97	25017352300	2010	24.000	\N
97	25017352400	2010	37.000	\N
97	25017352500	2010	38.000	\N
97	25017352600	2010	27.000	\N
97	25017352700	2010	31.000	\N
97	25017352800	2010	36.000	\N
97	25017352900	2010	10.000	\N
97	25017353000	2010	22.000	\N
97	25017353101	2010	28.000	\N
97	25017353102	2010	20.000	\N
97	25017353200	2010	31.000	\N
97	25017353300	2010	15.000	\N
97	25017353400	2010	39.000	\N
97	25017353500	2010	22.000	\N
97	25017353600	2010	12.000	\N
97	25017353700	2010	11.000	\N
97	25017353800	2010	7.000	\N
97	25017353900	2010	14.000	\N
97	25017354000	2010	5.000	\N
97	25017354100	2010	3.000	\N
97	25017354200	2010	2.000	\N
97	25017354300	2010	29.000	\N
97	25017354400	2010	11.000	\N
97	25017354500	2010	6.000	\N
97	25017354600	2010	32.000	\N
97	25017354700	2010	2.000	\N
97	25017354800	2010	1.000	\N
97	25017354900	2010	95.000	\N
97	25017355000	2010	13.000	\N
97	25017356100	2010	1.000	\N
97	25017356300	2010	27.000	\N
97	25017356400	2010	3.000	\N
97	25017356500	2010	4.000	\N
97	25017356601	2010	6.000	\N
97	25017356602	2010	4.000	\N
97	25017356701	2010	10.000	\N
97	25017356702	2010	4.000	\N
97	25017357100	2010	0.000	\N
97	25017357200	2010	1.000	\N
97	25017357300	2010	3.000	\N
97	25017357400	2010	1.000	\N
97	25017357500	2010	0.000	\N
97	25017357600	2010	1.000	\N
97	25017357700	2010	0.000	\N
97	25017357800	2010	6.000	\N
97	25017358100	2010	1.000	\N
97	25017358300	2010	3.000	\N
97	25017358400	2010	2.000	\N
97	25017358500	2010	2.000	\N
97	25017358600	2010	6.000	\N
97	25017358700	2010	2.000	\N
97	25017359100	2010	10.000	\N
97	25017359300	2010	9.000	\N
97	25017360100	2010	18.000	\N
97	25017360200	2010	11.000	\N
97	25017361100	2010	0.000	\N
97	25017361200	2010	17.000	\N
97	25017361300	2010	8.000	\N
97	25017362100	2010	6.000	\N
97	25017363102	2010	1.000	\N
97	25017363103	2010	2.000	\N
97	25017363104	2010	3.000	\N
97	25017363201	2010	0.000	\N
97	25017363202	2010	0.000	\N
97	25017364101	2010	8.000	\N
97	25017364102	2010	3.000	\N
97	25017365100	2010	2.000	\N
97	25017365201	2010	4.000	\N
97	25017365202	2010	6.000	\N
97	25017366100	2010	5.000	\N
97	25017366201	2010	6.000	\N
97	25017366202	2010	1.000	\N
97	25017367100	2010	1.000	\N
97	25017367200	2010	20.000	\N
97	25017368101	2010	9.000	\N
97	25017368102	2010	4.000	\N
97	25017368200	2010	20.000	\N
97	25017368300	2010	15.000	\N
97	25017368400	2010	25.000	\N
97	25017368500	2010	12.000	\N
97	25017368600	2010	32.000	\N
97	25017368700	2010	17.000	\N
97	25017368800	2010	20.000	\N
97	25017368901	2010	16.000	\N
97	25017368902	2010	17.000	\N
97	25017369000	2010	4.000	\N
97	25017369100	2010	1.000	\N
97	25017370101	2010	25.000	\N
97	25017370102	2010	9.000	\N
97	25017370201	2010	3.000	\N
97	25017370202	2010	2.000	\N
97	25017370300	2010	23.000	\N
97	25017370400	2010	5.000	\N
97	25017373100	2010	6.000	\N
97	25017373200	2010	13.000	\N
97	25017373300	2010	6.000	\N
97	25017373400	2010	7.000	\N
97	25017373500	2010	2.000	\N
97	25017373600	2010	15.000	\N
97	25017373700	2010	2.000	\N
97	25017373800	2010	6.000	\N
97	25017373900	2010	8.000	\N
97	25017374000	2010	9.000	\N
97	25017374100	2010	10.000	\N
97	25017374200	2010	2.000	\N
97	25017374300	2010	6.000	\N
97	25017374400	2010	11.000	\N
97	25017374500	2010	6.000	\N
97	25017374600	2010	12.000	\N
97	25017374700	2010	6.000	\N
97	25017374800	2010	25.000	\N
97	25017382100	2010	5.000	\N
97	25017382200	2010	8.000	\N
97	25017382300	2010	7.000	\N
97	25017382400	2010	6.000	\N
97	25017382500	2010	3.000	\N
97	25017382601	2010	8.000	\N
97	25017382602	2010	8.000	\N
97	25017383101	2010	84.000	\N
97	25017383102	2010	198.000	\N
97	25017383200	2010	48.000	\N
97	25017383300	2010	20.000	\N
97	25017383400	2010	53.000	\N
97	25017383501	2010	38.000	\N
97	25017383502	2010	15.000	\N
97	25017383600	2010	30.000	\N
97	25017383700	2010	6.000	\N
97	25017383800	2010	10.000	\N
97	25017383901	2010	11.000	\N
97	25017383902	2010	3.000	\N
97	25017384001	2010	3.000	\N
97	25017384002	2010	28.000	\N
97	25017385100	2010	6.000	\N
97	25017385201	2010	10.000	\N
97	25017385202	2010	6.000	\N
97	25017386100	2010	0.000	\N
97	25017387100	2010	0.000	\N
97	25017387201	2010	0.000	\N
97	25017387202	2010	1.000	\N
97	25017388100	2010	0.000	\N
97	25017388200	2010	5.000	\N
97	25017388300	2010	73.000	\N
97	25017980000	2010	0.000	\N
97	25019950100	2010	0.000	\N
97	25019950200	2010	17.000	\N
97	25019950307	2010	0.000	\N
97	25019950400	2010	6.000	\N
97	25019950500	2010	1.000	\N
97	25019990000	2010	0.000	\N
97	25021400100	2010	3.000	\N
97	25021400200	2010	11.000	\N
97	25021400300	2010	11.000	\N
97	25021400400	2010	0.000	\N
97	25021400500	2010	4.000	\N
97	25021400600	2010	13.000	\N
97	25021400700	2010	8.000	\N
97	25021400800	2010	9.000	\N
97	25021400900	2010	29.000	\N
97	25021401000	2010	13.000	\N
97	25021401100	2010	11.000	\N
97	25021401200	2010	37.000	\N
97	25021402101	2010	8.000	\N
97	25021402102	2010	27.000	\N
97	25021402200	2010	1.000	\N
97	25021402300	2010	8.000	\N
97	25021402400	2010	18.000	\N
97	25021402500	2010	14.000	\N
97	25021403100	2010	0.000	\N
97	25021403300	2010	0.000	\N
97	25021403400	2010	13.000	\N
97	25021403500	2010	0.000	\N
97	25021404100	2010	1.000	\N
97	25021404201	2010	0.000	\N
97	25021404202	2010	10.000	\N
97	25021404301	2010	1.000	\N
97	25021404302	2010	0.000	\N
97	25021404400	2010	13.000	\N
97	25021405100	2010	3.000	\N
97	25021406101	2010	1.000	\N
97	25021406102	2010	1.000	\N
97	25021407100	2010	3.000	\N
97	25021408101	2010	2.000	\N
97	25021408102	2010	5.000	\N
97	25021409101	2010	54.000	\N
97	25021409102	2010	0.000	\N
97	25021410100	2010	1.000	\N
97	25021410300	2010	6.000	\N
97	25021410400	2010	10.000	\N
97	25021411100	2010	11.000	\N
97	25021411200	2010	15.000	\N
97	25021411301	2010	1.000	\N
97	25021411302	2010	8.000	\N
97	25021412100	2010	2.000	\N
97	25021412200	2010	3.000	\N
97	25021412300	2010	4.000	\N
97	25021413100	2010	9.000	\N
97	25021413200	2010	14.000	\N
97	25021413300	2010	22.000	\N
97	25021413401	2010	9.000	\N
97	25021413402	2010	28.000	\N
97	25021413500	2010	9.000	\N
97	25021414100	2010	25.000	\N
97	25021414200	2010	15.000	\N
97	25021414300	2010	5.000	\N
97	25021415101	2010	11.000	\N
97	25021415102	2010	22.000	\N
97	25021415200	2010	29.000	\N
97	25021415300	2010	0.000	\N
97	25021416101	2010	9.000	\N
97	25021416102	2010	11.000	\N
97	25021416200	2010	108.000	\N
97	25021416300	2010	33.000	\N
97	25021416400	2010	6.000	\N
97	25021417100	2010	7.000	\N
97	25021417200	2010	8.000	\N
97	25021417300	2010	8.000	\N
97	25021417400	2010	3.000	\N
97	25021417501	2010	4.000	\N
97	25021417502	2010	13.000	\N
97	25021417601	2010	9.000	\N
97	25021417602	2010	16.000	\N
97	25021417701	2010	8.000	\N
97	25021417702	2010	5.000	\N
97	25021417801	2010	10.000	\N
97	25021417802	2010	23.000	\N
97	25021417901	2010	19.000	\N
97	25021417902	2010	11.000	\N
97	25021418002	2010	11.000	\N
97	25021418003	2010	12.000	\N
97	25021418004	2010	27.000	\N
97	25021418101	2010	3.000	\N
97	25021418102	2010	13.000	\N
97	25021418200	2010	40.000	\N
97	25021419100	2010	6.000	\N
97	25021419200	2010	10.000	\N
97	25021419300	2010	23.000	\N
97	25021419400	2010	1.000	\N
97	25021419500	2010	1.000	\N
97	25021419600	2010	12.000	\N
97	25021419700	2010	2.000	\N
97	25021419800	2010	6.000	\N
97	25021420100	2010	77.000	\N
97	25021420201	2010	35.000	\N
97	25021420202	2010	82.000	\N
97	25021420301	2010	111.000	\N
97	25021420302	2010	85.000	\N
97	25021421100	2010	20.000	\N
97	25021421200	2010	29.000	\N
97	25021422100	2010	11.000	\N
97	25021422200	2010	5.000	\N
97	25021422301	2010	1.000	\N
97	25021422302	2010	23.000	\N
97	25021422400	2010	16.000	\N
97	25021422501	2010	31.000	\N
97	25021422502	2010	20.000	\N
97	25021422600	2010	4.000	\N
97	25021422700	2010	8.000	\N
97	25021422800	2010	5.000	\N
97	25021423100	2010	1.000	\N
97	25021440100	2010	8.000	\N
97	25021441202	2010	0.000	\N
97	25021441203	2010	0.000	\N
97	25021441204	2010	1.000	\N
97	25021442101	2010	13.000	\N
97	25021442102	2010	1.000	\N
97	25021442103	2010	4.000	\N
97	25021442201	2010	4.000	\N
97	25021442202	2010	11.000	\N
97	25021443101	2010	3.000	\N
97	25021443102	2010	15.000	\N
97	25021456101	2010	10.000	\N
97	25021456102	2010	18.000	\N
97	25021456200	2010	19.000	\N
97	25021456301	2010	14.000	\N
97	25021456302	2010	19.000	\N
97	25021456401	2010	16.000	\N
97	25021456402	2010	10.000	\N
97	25021457100	2010	20.000	\N
97	25021457200	2010	0.000	\N
97	25023500101	2010	1.000	\N
97	25023500103	2010	0.000	\N
97	25023500104	2010	5.000	\N
97	25023501101	2010	0.000	\N
97	25023501102	2010	4.000	\N
97	25023501201	2010	2.000	\N
97	25023501202	2010	3.000	\N
97	25023502101	2010	10.000	\N
97	25023502102	2010	7.000	\N
97	25023502200	2010	4.000	\N
97	25023503101	2010	4.000	\N
97	25023503102	2010	0.000	\N
97	25023504101	2010	0.000	\N
97	25023504102	2010	1.000	\N
97	25023505101	2010	4.000	\N
97	25023505102	2010	1.000	\N
97	25023505200	2010	1.000	\N
97	25023506101	2010	2.000	\N
97	25023506102	2010	0.000	\N
97	25023506202	2010	0.000	\N
97	25023506203	2010	0.000	\N
97	25023506204	2010	0.000	\N
97	25023507101	2010	1.000	\N
97	25023507103	2010	1.000	\N
97	25023507104	2010	1.000	\N
97	25023508101	2010	3.000	\N
97	25023508102	2010	1.000	\N
97	25023508200	2010	0.000	\N
97	25023509101	2010	2.000	\N
97	25023509102	2010	2.000	\N
97	25023510100	2010	27.000	\N
97	25023510200	2010	59.000	\N
97	25023510300	2010	82.000	\N
97	25023510400	2010	71.000	\N
97	25023510501	2010	53.000	\N
97	25023510502	2010	78.000	\N
97	25023510503	2010	44.000	\N
97	25023510600	2010	25.000	\N
97	25023510700	2010	83.000	\N
97	25023510800	2010	142.000	\N
97	25023510900	2010	65.000	\N
97	25023511000	2010	64.000	\N
97	25023511100	2010	38.000	\N
97	25023511200	2010	73.000	\N
97	25023511301	2010	71.000	\N
97	25023511302	2010	52.000	\N
97	25023511400	2010	61.000	\N
97	25023511500	2010	79.000	\N
97	25023511600	2010	108.000	\N
97	25023511701	2010	38.000	\N
97	25023511702	2010	24.000	\N
97	25023520100	2010	5.000	\N
97	25023520201	2010	7.000	\N
97	25023520202	2010	17.000	\N
97	25023521101	2010	3.000	\N
97	25023521102	2010	0.000	\N
97	25023521201	2010	1.000	\N
97	25023521202	2010	0.000	\N
97	25023522101	2010	6.000	\N
97	25023522102	2010	2.000	\N
97	25023523100	2010	3.000	\N
97	25023523201	2010	0.000	\N
97	25023523202	2010	4.000	\N
97	25023524101	2010	0.000	\N
97	25023524102	2010	3.000	\N
97	25023525101	2010	15.000	\N
97	25023525104	2010	3.000	\N
97	25023525203	2010	4.000	\N
97	25023525204	2010	7.000	\N
97	25023525300	2010	20.000	\N
97	25023526100	2010	0.000	\N
97	25023530100	2010	11.000	\N
97	25023530200	2010	2.000	\N
97	25023530300	2010	2.000	\N
97	25023530400	2010	4.000	\N
97	25023530500	2010	0.000	\N
97	25023530600	2010	9.000	\N
97	25023530700	2010	0.000	\N
97	25023530801	2010	0.000	\N
97	25023530802	2010	1.000	\N
97	25023530901	2010	9.000	\N
97	25023530902	2010	3.000	\N
97	25023540101	2010	2.000	\N
97	25023540102	2010	0.000	\N
97	25023540103	2010	0.000	\N
97	25023541100	2010	0.000	\N
97	25023542101	2010	6.000	\N
97	25023542102	2010	0.000	\N
97	25023542200	2010	1.000	\N
97	25023542300	2010	12.000	\N
97	25023543100	2010	1.000	\N
97	25023544100	2010	3.000	\N
97	25023544200	2010	1.000	\N
97	25023545100	2010	9.000	\N
97	25023545200	2010	16.000	\N
97	25023545300	2010	9.000	\N
97	25023545400	2010	7.000	\N
97	25023560100	2010	0.000	\N
97	25023561100	2010	0.000	\N
97	25023561200	2010	12.000	\N
97	25023990003	2010	0.000	\N
97	25025000100	2010	51.000	\N
97	25025000201	2010	32.000	\N
97	25025000202	2010	57.000	\N
97	25025000301	2010	7.000	\N
97	25025000302	2010	7.000	\N
97	25025000401	2010	12.000	\N
97	25025000402	2010	3.000	\N
97	25025000502	2010	18.000	\N
97	25025000503	2010	2.000	\N
97	25025000504	2010	23.000	\N
97	25025000601	2010	12.000	\N
97	25025000602	2010	52.000	\N
97	25025000701	2010	19.000	\N
97	25025000703	2010	8.000	\N
97	25025000704	2010	29.000	\N
97	25025000802	2010	41.000	\N
97	25025000803	2010	21.000	\N
97	25025010103	2010	18.000	\N
97	25025010104	2010	1.000	\N
97	25025010203	2010	20.000	\N
97	25025010204	2010	3.000	\N
97	25025010300	2010	36.000	\N
97	25025010403	2010	22.000	\N
97	25025010404	2010	10.000	\N
97	25025010405	2010	45.000	\N
97	25025010408	2010	5.000	\N
97	25025010500	2010	14.000	\N
97	25025010600	2010	7.000	\N
97	25025010701	2010	4.000	\N
97	25025010702	2010	6.000	\N
97	25025010801	2010	10.000	\N
97	25025010802	2010	3.000	\N
97	25025020101	2010	3.000	\N
97	25025020200	2010	6.000	\N
97	25025020301	2010	3.000	\N
97	25025020302	2010	0.000	\N
97	25025020303	2010	11.000	\N
97	25025030100	2010	1.000	\N
97	25025030200	2010	0.000	\N
97	25025030300	2010	15.000	\N
97	25025030400	2010	1.000	\N
97	25025030500	2010	3.000	\N
97	25025040100	2010	1.000	\N
97	25025040200	2010	54.000	\N
97	25025040300	2010	45.000	\N
97	25025040401	2010	17.000	\N
97	25025040600	2010	2.000	\N
97	25025040801	2010	66.000	\N
97	25025050101	2010	76.000	\N
97	25025050200	2010	65.000	\N
97	25025050300	2010	81.000	\N
97	25025050400	2010	24.000	\N
97	25025050500	2010	31.000	\N
97	25025050600	2010	17.000	\N
97	25025050700	2010	42.000	\N
97	25025050901	2010	29.000	\N
97	25025051000	2010	43.000	\N
97	25025051101	2010	92.000	\N
97	25025051200	2010	29.000	\N
97	25025060101	2010	2.000	\N
97	25025060200	2010	0.000	\N
97	25025060301	2010	2.000	\N
97	25025060400	2010	1.000	\N
97	25025060501	2010	1.000	\N
97	25025060600	2010	4.000	\N
97	25025060700	2010	108.000	\N
97	25025060800	2010	4.000	\N
97	25025061000	2010	133.000	\N
97	25025061101	2010	140.000	\N
97	25025061200	2010	20.000	\N
97	25025070101	2010	25.000	\N
97	25025070200	2010	16.000	\N
97	25025070300	2010	5.000	\N
97	25025070402	2010	18.000	\N
97	25025070500	2010	84.000	\N
97	25025070600	2010	5.000	\N
97	25025070700	2010	33.000	\N
97	25025070800	2010	45.000	\N
97	25025070900	2010	86.000	\N
97	25025071101	2010	50.000	\N
97	25025071201	2010	74.000	\N
97	25025080100	2010	89.000	\N
97	25025080300	2010	90.000	\N
97	25025080401	2010	187.000	\N
97	25025080500	2010	304.000	\N
97	25025080601	2010	103.000	\N
97	25025080801	2010	155.000	\N
97	25025080900	2010	31.000	\N
97	25025081001	2010	115.000	\N
97	25025081100	2010	75.000	\N
97	25025081200	2010	210.000	\N
97	25025081300	2010	338.000	\N
97	25025081400	2010	132.000	\N
97	25025081500	2010	117.000	\N
97	25025081700	2010	165.000	\N
97	25025081800	2010	152.000	\N
97	25025081900	2010	169.000	\N
97	25025082000	2010	106.000	\N
97	25025082100	2010	262.000	\N
97	25025090100	2010	256.000	\N
97	25025090200	2010	108.000	\N
97	25025090300	2010	193.000	\N
97	25025090400	2010	255.000	\N
97	25025090600	2010	101.000	\N
97	25025090700	2010	24.000	\N
97	25025090901	2010	101.000	\N
97	25025091001	2010	18.000	\N
97	25025091100	2010	50.000	\N
97	25025091200	2010	96.000	\N
97	25025091300	2010	57.000	\N
97	25025091400	2010	106.000	\N
97	25025091500	2010	153.000	\N
97	25025091600	2010	64.000	\N
97	25025091700	2010	155.000	\N
97	25025091800	2010	149.000	\N
97	25025091900	2010	218.000	\N
97	25025092000	2010	209.000	\N
97	25025092101	2010	80.000	\N
97	25025092200	2010	84.000	\N
97	25025092300	2010	92.000	\N
97	25025092400	2010	320.000	\N
97	25025100100	2010	368.000	\N
97	25025100200	2010	134.000	\N
97	25025100300	2010	107.000	\N
97	25025100400	2010	141.000	\N
97	25025100500	2010	228.000	\N
97	25025100601	2010	124.000	\N
97	25025100603	2010	23.000	\N
97	25025100700	2010	5.000	\N
97	25025100800	2010	97.000	\N
97	25025100900	2010	120.000	\N
97	25025101001	2010	142.000	\N
97	25025101002	2010	206.000	\N
97	25025101101	2010	143.000	\N
97	25025101102	2010	157.000	\N
97	25025110103	2010	128.000	\N
97	25025110201	2010	78.000	\N
97	25025110301	2010	79.000	\N
97	25025110401	2010	102.000	\N
97	25025110403	2010	127.000	\N
97	25025110501	2010	27.000	\N
97	25025110502	2010	56.000	\N
97	25025110601	2010	1.000	\N
97	25025110607	2010	33.000	\N
97	25025120103	2010	0.000	\N
97	25025120104	2010	39.000	\N
97	25025120105	2010	8.000	\N
97	25025120201	2010	86.000	\N
97	25025120301	2010	161.000	\N
97	25025120400	2010	45.000	\N
97	25025120500	2010	115.000	\N
97	25025120600	2010	17.000	\N
97	25025120700	2010	36.000	\N
97	25025130100	2010	12.000	\N
97	25025130200	2010	11.000	\N
97	25025130300	2010	31.000	\N
97	25025130402	2010	30.000	\N
97	25025130404	2010	28.000	\N
97	25025130406	2010	167.000	\N
97	25025140102	2010	91.000	\N
97	25025140105	2010	104.000	\N
97	25025140106	2010	74.000	\N
97	25025140107	2010	64.000	\N
97	25025140201	2010	44.000	\N
97	25025140202	2010	154.000	\N
97	25025140300	2010	219.000	\N
97	25025140400	2010	258.000	\N
97	25025160101	2010	171.000	\N
97	25025160200	2010	55.000	\N
97	25025160300	2010	19.000	\N
97	25025160400	2010	59.000	\N
97	25025160501	2010	111.000	\N
97	25025160502	2010	97.000	\N
97	25025160601	2010	80.000	\N
97	25025160602	2010	53.000	\N
97	25025170100	2010	76.000	\N
97	25025170200	2010	10.000	\N
97	25025170300	2010	22.000	\N
97	25025170400	2010	37.000	\N
97	25025170501	2010	22.000	\N
97	25025170502	2010	6.000	\N
97	25025170601	2010	26.000	\N
97	25025170701	2010	16.000	\N
97	25025170702	2010	40.000	\N
97	25025170800	2010	26.000	\N
97	25025180101	2010	5.000	\N
97	25025180200	2010	4.000	\N
97	25025180301	2010	4.000	\N
97	25025180400	2010	0.000	\N
97	25025180500	2010	9.000	\N
97	25025980101	2010	13.000	\N
97	25025980300	2010	8.000	\N
97	25025980700	2010	0.000	\N
97	25025981000	2010	0.000	\N
97	25025981100	2010	18.000	\N
97	25025981201	2010	0.000	\N
97	25025981202	2010	5.000	\N
97	25025981300	2010	0.000	\N
97	25025981501	2010	0.000	\N
97	25025981502	2010	0.000	\N
97	25025981600	2010	0.000	\N
97	25025981700	2010	0.000	\N
97	25025981800	2010	0.000	\N
97	25025990101	2010	0.000	\N
97	25027700100	2010	6.000	\N
97	25027701100	2010	20.000	\N
97	25027702200	2010	5.000	\N
97	25027703100	2010	16.000	\N
97	25027703200	2010	2.000	\N
97	25027703300	2010	0.000	\N
97	25027704200	2010	0.000	\N
97	25027705100	2010	6.000	\N
97	25027706100	2010	5.000	\N
97	25027707100	2010	18.000	\N
97	25027707200	2010	8.000	\N
97	25027707300	2010	16.000	\N
97	25027707400	2010	9.000	\N
97	25027707500	2010	17.000	\N
97	25027708100	2010	3.000	\N
97	25027709100	2010	20.000	\N
97	25027709201	2010	25.000	\N
97	25027709202	2010	43.000	\N
97	25027709400	2010	62.000	\N
97	25027709501	2010	2.000	\N
97	25027709502	2010	20.000	\N
97	25027709600	2010	17.000	\N
97	25027709701	2010	42.000	\N
97	25027709702	2010	3.000	\N
97	25027710100	2010	54.000	\N
97	25027710200	2010	55.000	\N
97	25027710300	2010	39.000	\N
97	25027710400	2010	4.000	\N
97	25027710500	2010	60.000	\N
97	25027710600	2010	94.000	\N
97	25027710700	2010	22.000	\N
97	25027710800	2010	68.000	\N
97	25027711000	2010	32.000	\N
97	25027711100	2010	7.000	\N
97	25027712101	2010	10.000	\N
97	25027712102	2010	1.000	\N
97	25027713100	2010	52.000	\N
97	25027715100	2010	1.000	\N
97	25027716100	2010	60.000	\N
97	25027716200	2010	34.000	\N
97	25027716300	2010	35.000	\N
97	25027717100	2010	1.000	\N
97	25027718100	2010	1.000	\N
97	25027719100	2010	3.000	\N
97	25027720100	2010	2.000	\N
97	25027721101	2010	5.000	\N
97	25027721102	2010	1.000	\N
97	25027722100	2010	12.000	\N
97	25027723100	2010	2.000	\N
97	25027724100	2010	1.000	\N
97	25027725100	2010	0.000	\N
97	25027726100	2010	3.000	\N
97	25027726200	2010	10.000	\N
97	25027727100	2010	18.000	\N
97	25027728100	2010	5.000	\N
97	25027728200	2010	1.000	\N
97	25027728300	2010	4.000	\N
97	25027728400	2010	11.000	\N
97	25027729100	2010	2.000	\N
97	25027729200	2010	0.000	\N
97	25027730100	2010	18.000	\N
97	25027730200	2010	30.000	\N
97	25027730300	2010	30.000	\N
97	25027730401	2010	97.000	\N
97	25027730402	2010	25.000	\N
97	25027730500	2010	39.000	\N
97	25027730600	2010	23.000	\N
97	25027730700	2010	41.000	\N
97	25027730801	2010	8.000	\N
97	25027730802	2010	13.000	\N
97	25027730901	2010	5.000	\N
97	25027730902	2010	8.000	\N
97	25027731001	2010	12.000	\N
97	25027731002	2010	98.000	\N
97	25027731101	2010	68.000	\N
97	25027731102	2010	29.000	\N
97	25027731202	2010	6.000	\N
97	25027731203	2010	132.000	\N
97	25027731204	2010	69.000	\N
97	25027731300	2010	108.000	\N
97	25027731400	2010	135.000	\N
97	25027731500	2010	207.000	\N
97	25027731600	2010	65.000	\N
97	25027731700	2010	52.000	\N
97	25027731800	2010	161.000	\N
97	25027731900	2010	134.000	\N
97	25027732001	2010	168.000	\N
97	25027732002	2010	28.000	\N
97	25027732201	2010	19.000	\N
97	25027732202	2010	27.000	\N
97	25027732203	2010	28.000	\N
97	25027732301	2010	9.000	\N
97	25027732302	2010	44.000	\N
97	25027732400	2010	219.000	\N
97	25027732500	2010	38.000	\N
97	25027732600	2010	53.000	\N
97	25027732700	2010	88.000	\N
97	25027732801	2010	20.000	\N
97	25027732802	2010	33.000	\N
97	25027732901	2010	60.000	\N
97	25027732902	2010	16.000	\N
97	25027733000	2010	73.000	\N
97	25027733101	2010	11.000	\N
97	25027733102	2010	8.000	\N
97	25027735100	2010	9.000	\N
97	25027735200	2010	6.000	\N
97	25027736100	2010	11.000	\N
97	25027736200	2010	2.000	\N
97	25027736300	2010	4.000	\N
97	25027736400	2010	6.000	\N
97	25027736500	2010	1.000	\N
97	25027737100	2010	8.000	\N
97	25027737200	2010	4.000	\N
97	25027737300	2010	0.000	\N
97	25027738100	2010	4.000	\N
97	25027738201	2010	6.000	\N
97	25027738202	2010	0.000	\N
97	25027739100	2010	6.000	\N
97	25027739200	2010	14.000	\N
97	25027739300	2010	0.000	\N
97	25027739400	2010	8.000	\N
97	25027739500	2010	7.000	\N
97	25027740101	2010	1.000	\N
97	25027740102	2010	8.000	\N
97	25027740200	2010	6.000	\N
97	25027741101	2010	7.000	\N
97	25027741102	2010	2.000	\N
97	25027742300	2010	13.000	\N
97	25027742401	2010	2.000	\N
97	25027742402	2010	0.000	\N
97	25027743100	2010	5.000	\N
97	25027744101	2010	6.000	\N
97	25027744102	2010	29.000	\N
97	25027744200	2010	15.000	\N
97	25027744300	2010	14.000	\N
97	25027744400	2010	12.000	\N
97	25027745100	2010	1.000	\N
97	25027746100	2010	5.000	\N
97	25027747101	2010	3.000	\N
97	25027747102	2010	2.000	\N
97	25027748100	2010	2.000	\N
97	25027749100	2010	8.000	\N
97	25027749200	2010	2.000	\N
97	25027750100	2010	10.000	\N
97	25027750200	2010	4.000	\N
97	25027750300	2010	2.000	\N
97	25027751101	2010	0.000	\N
97	25027751102	2010	1.000	\N
97	25027752100	2010	10.000	\N
97	25027753100	2010	8.000	\N
97	25027753200	2010	1.000	\N
97	25027754100	2010	3.000	\N
97	25027754200	2010	31.000	\N
97	25027754300	2010	9.000	\N
97	25027754400	2010	19.000	\N
97	25027755100	2010	3.000	\N
97	25027755200	2010	15.000	\N
97	25027756101	2010	1.000	\N
97	25027756102	2010	14.000	\N
97	25027757100	2010	58.000	\N
97	25027757200	2010	35.000	\N
97	25027757300	2010	60.000	\N
97	25027757400	2010	9.000	\N
97	25027757500	2010	33.000	\N
97	25027758101	2010	0.000	\N
97	25027758102	2010	0.000	\N
97	25027759100	2010	0.000	\N
97	25027760100	2010	0.000	\N
97	25027761100	2010	1.000	\N
97	25027761200	2010	27.000	\N
97	25027761300	2010	2.000	\N
97	25027761400	2010	5.000	\N
98	25001010100	2010	7.000	\N
98	25001010206	2010	0.000	\N
98	25001010208	2010	1.000	\N
98	25001010304	2010	0.000	\N
98	25001010306	2010	0.000	\N
98	25001010400	2010	1.000	\N
98	25001010500	2010	0.000	\N
98	25001010600	2010	0.000	\N
98	25001010700	2010	1.000	\N
98	25001010800	2010	0.000	\N
98	25001010900	2010	2.000	\N
98	25001011002	2010	5.000	\N
98	25001011100	2010	6.000	\N
98	25001011200	2010	4.000	\N
98	25001011300	2010	0.000	\N
98	25001011400	2010	1.000	\N
98	25001011500	2010	9.000	\N
98	25001011600	2010	3.000	\N
98	25001011700	2010	0.000	\N
98	25001011801	2010	0.000	\N
98	25001011802	2010	2.000	\N
98	25001012001	2010	0.000	\N
98	25001012002	2010	7.000	\N
98	25001012101	2010	1.000	\N
98	25001012102	2010	3.000	\N
98	25001012200	2010	1.000	\N
98	25001012502	2010	0.000	\N
98	25001012601	2010	4.000	\N
98	25001012602	2010	10.000	\N
98	25001012700	2010	3.000	\N
98	25001012800	2010	1.000	\N
98	25001012900	2010	2.000	\N
98	25001013002	2010	0.000	\N
98	25001013100	2010	3.000	\N
98	25001013200	2010	1.000	\N
98	25001013300	2010	0.000	\N
98	25001013400	2010	1.000	\N
98	25001013500	2010	5.000	\N
98	25001013600	2010	1.000	\N
98	25001013700	2010	1.000	\N
98	25001013800	2010	1.000	\N
98	25001013900	2010	4.000	\N
98	25001014002	2010	1.000	\N
98	25001014100	2010	1.000	\N
98	25001014300	2010	1.000	\N
98	25001014402	2010	2.000	\N
98	25001014500	2010	7.000	\N
98	25001014600	2010	5.000	\N
98	25001014700	2010	4.000	\N
98	25001014800	2010	1.000	\N
98	25001014900	2010	0.000	\N
98	25001015001	2010	10.000	\N
98	25001015002	2010	10.000	\N
98	25001015100	2010	7.000	\N
98	25001015200	2010	0.000	\N
98	25001015300	2010	0.000	\N
98	25001990000	2010	0.000	\N
98	25003900100	2010	7.000	\N
98	25003900200	2010	2.000	\N
98	25003900300	2010	0.000	\N
98	25003900400	2010	1.000	\N
98	25003900500	2010	0.000	\N
98	25003900600	2010	2.000	\N
98	25003900700	2010	0.000	\N
98	25003900800	2010	0.000	\N
98	25003900900	2010	1.000	\N
98	25003901100	2010	0.000	\N
98	25003911100	2010	0.000	\N
98	25003912100	2010	0.000	\N
98	25003913100	2010	3.000	\N
98	25003914100	2010	1.000	\N
98	25003920101	2010	2.000	\N
98	25003920102	2010	0.000	\N
98	25003921300	2010	2.000	\N
98	25003921400	2010	0.000	\N
98	25003921500	2010	0.000	\N
98	25003922100	2010	0.000	\N
98	25003922200	2010	7.000	\N
98	25003922300	2010	0.000	\N
98	25003923100	2010	0.000	\N
98	25003924100	2010	0.000	\N
98	25003925100	2010	13.000	\N
98	25003926100	2010	2.000	\N
98	25003931100	2010	0.000	\N
98	25003931300	2010	0.000	\N
98	25003931400	2010	1.000	\N
98	25003932200	2010	1.000	\N
98	25003932300	2010	3.000	\N
98	25003933200	2010	1.000	\N
98	25003933300	2010	0.000	\N
98	25003933400	2010	1.000	\N
98	25003934200	2010	0.000	\N
98	25003934300	2010	0.000	\N
98	25003935100	2010	2.000	\N
98	25003935200	2010	0.000	\N
98	25003935300	2010	2.000	\N
98	25005600100	2010	0.000	\N
98	25005600202	2010	0.000	\N
98	25005600203	2010	1.000	\N
98	25005600204	2010	1.000	\N
98	25005610100	2010	0.000	\N
98	25005610202	2010	0.000	\N
98	25005610203	2010	0.000	\N
98	25005610204	2010	0.000	\N
98	25005611101	2010	0.000	\N
98	25005611102	2010	2.000	\N
98	25005611201	2010	0.000	\N
98	25005611202	2010	4.000	\N
98	25005612100	2010	0.000	\N
98	25005612200	2010	4.000	\N
98	25005613100	2010	1.000	\N
98	25005613300	2010	4.000	\N
98	25005613400	2010	8.000	\N
98	25005613600	2010	1.000	\N
98	25005613700	2010	3.000	\N
98	25005613800	2010	9.000	\N
98	25005613901	2010	1.000	\N
98	25005613902	2010	0.000	\N
98	25005614000	2010	2.000	\N
98	25005614101	2010	4.000	\N
98	25005614102	2010	1.000	\N
98	25005615100	2010	0.000	\N
98	25005616100	2010	1.000	\N
98	25005617101	2010	3.000	\N
98	25005617102	2010	1.000	\N
98	25005630101	2010	1.000	\N
98	25005630102	2010	12.000	\N
98	25005630200	2010	1.000	\N
98	25005630300	2010	5.000	\N
98	25005630400	2010	0.000	\N
98	25005631100	2010	0.000	\N
98	25005631200	2010	1.000	\N
98	25005631300	2010	3.000	\N
98	25005631400	2010	7.000	\N
98	25005631500	2010	1.000	\N
98	25005631600	2010	21.000	\N
98	25005631700	2010	0.000	\N
98	25005631800	2010	1.000	\N
98	25005632100	2010	6.000	\N
98	25005632200	2010	1.000	\N
98	25005633100	2010	0.000	\N
98	25005633200	2010	0.000	\N
98	25005640100	2010	8.000	\N
98	25005640200	2010	6.000	\N
98	25005640300	2010	5.000	\N
98	25005640400	2010	0.000	\N
98	25005640500	2010	1.000	\N
98	25005640600	2010	5.000	\N
98	25005640700	2010	0.000	\N
98	25005640800	2010	4.000	\N
98	25005640901	2010	8.000	\N
98	25005641000	2010	0.000	\N
98	25005641101	2010	10.000	\N
98	25005641200	2010	0.000	\N
98	25005641300	2010	17.000	\N
98	25005641400	2010	0.000	\N
98	25005641500	2010	0.000	\N
98	25005641600	2010	2.000	\N
98	25005641700	2010	1.000	\N
98	25005641800	2010	2.000	\N
98	25005641900	2010	4.000	\N
98	25005642000	2010	2.000	\N
98	25005642100	2010	4.000	\N
98	25005642200	2010	1.000	\N
98	25005642300	2010	2.000	\N
98	25005642400	2010	1.000	\N
98	25005642500	2010	4.000	\N
98	25005644101	2010	0.000	\N
98	25005644102	2010	0.000	\N
98	25005644200	2010	0.000	\N
98	25005645101	2010	1.000	\N
98	25005645102	2010	2.000	\N
98	25005645103	2010	1.000	\N
98	25005646101	2010	0.000	\N
98	25005646103	2010	1.000	\N
98	25005646104	2010	1.000	\N
98	25005650101	2010	2.000	\N
98	25005650102	2010	15.000	\N
98	25005650201	2010	0.000	\N
98	25005650202	2010	1.000	\N
98	25005650300	2010	22.000	\N
98	25005650400	2010	2.000	\N
98	25005650500	2010	21.000	\N
98	25005650600	2010	48.000	\N
98	25005650700	2010	308.000	\N
98	25005650800	2010	44.000	\N
98	25005650900	2010	26.000	\N
98	25005651001	2010	5.000	\N
98	25005651002	2010	11.000	\N
98	25005651100	2010	19.000	\N
98	25005651200	2010	65.000	\N
98	25005651300	2010	9.000	\N
98	25005651400	2010	9.000	\N
98	25005651500	2010	13.000	\N
98	25005651600	2010	5.000	\N
98	25005651700	2010	4.000	\N
98	25005651800	2010	17.000	\N
98	25005651900	2010	6.000	\N
98	25005652000	2010	12.000	\N
98	25005652100	2010	1.000	\N
98	25005652200	2010	3.000	\N
98	25005652300	2010	12.000	\N
98	25005652400	2010	6.000	\N
98	25005652500	2010	21.000	\N
98	25005652600	2010	85.000	\N
98	25005652700	2010	18.000	\N
98	25005652800	2010	1.000	\N
98	25005653101	2010	0.000	\N
98	25005653102	2010	2.000	\N
98	25005653203	2010	8.000	\N
98	25005653204	2010	0.000	\N
98	25005653301	2010	1.000	\N
98	25005653304	2010	2.000	\N
98	25005654100	2010	0.000	\N
98	25005654200	2010	0.000	\N
98	25005655100	2010	2.000	\N
98	25005655200	2010	0.000	\N
98	25005655300	2010	0.000	\N
98	25005655400	2010	0.000	\N
98	25005985500	2010	0.000	\N
98	25005985600	2010	1.000	\N
98	25005990000	2010	0.000	\N
98	25007200100	2010	1.000	\N
98	25007200200	2010	3.000	\N
98	25007200300	2010	3.000	\N
98	25007200400	2010	1.000	\N
98	25007990000	2010	0.000	\N
98	25009201100	2010	0.000	\N
98	25009202101	2010	0.000	\N
98	25009202102	2010	0.000	\N
98	25009202200	2010	6.000	\N
98	25009203100	2010	4.000	\N
98	25009203200	2010	0.000	\N
98	25009203301	2010	1.000	\N
98	25009203302	2010	5.000	\N
98	25009204101	2010	22.000	\N
98	25009204102	2010	11.000	\N
98	25009204200	2010	8.000	\N
98	25009204300	2010	15.000	\N
98	25009204400	2010	3.000	\N
98	25009204500	2010	9.000	\N
98	25009204600	2010	9.000	\N
98	25009204701	2010	23.000	\N
98	25009204702	2010	7.000	\N
98	25009205100	2010	1.000	\N
98	25009205200	2010	4.000	\N
98	25009205300	2010	0.000	\N
98	25009205400	2010	3.000	\N
98	25009205500	2010	45.000	\N
98	25009205600	2010	4.000	\N
98	25009205700	2010	6.000	\N
98	25009205800	2010	27.000	\N
98	25009205900	2010	46.000	\N
98	25009206000	2010	47.000	\N
98	25009206100	2010	29.000	\N
98	25009206200	2010	45.000	\N
98	25009206300	2010	26.000	\N
98	25009206400	2010	10.000	\N
98	25009206500	2010	11.000	\N
98	25009206600	2010	38.000	\N
98	25009206700	2010	15.000	\N
98	25009206800	2010	46.000	\N
98	25009206900	2010	17.000	\N
98	25009207000	2010	18.000	\N
98	25009207100	2010	27.000	\N
98	25009207200	2010	16.000	\N
98	25009208101	2010	6.000	\N
98	25009208102	2010	1.000	\N
98	25009208200	2010	4.000	\N
98	25009208300	2010	0.000	\N
98	25009208400	2010	0.000	\N
98	25009209100	2010	0.000	\N
98	25009209200	2010	0.000	\N
98	25009210100	2010	0.000	\N
98	25009210200	2010	2.000	\N
98	25009210300	2010	14.000	\N
98	25009210400	2010	3.000	\N
98	25009210500	2010	3.000	\N
98	25009210600	2010	3.000	\N
98	25009210700	2010	8.000	\N
98	25009210800	2010	13.000	\N
98	25009210900	2010	0.000	\N
98	25009211100	2010	0.000	\N
98	25009211200	2010	4.000	\N
98	25009211300	2010	0.000	\N
98	25009211401	2010	0.000	\N
98	25009211402	2010	2.000	\N
98	25009212100	2010	30.000	\N
98	25009213100	2010	3.000	\N
98	25009214100	2010	1.000	\N
98	25009215101	2010	2.000	\N
98	25009215102	2010	0.000	\N
98	25009216100	2010	2.000	\N
98	25009217100	2010	0.000	\N
98	25009217201	2010	2.000	\N
98	25009217202	2010	0.000	\N
98	25009217300	2010	7.000	\N
98	25009217400	2010	2.000	\N
98	25009217500	2010	3.000	\N
98	25009217600	2010	6.000	\N
98	25009218100	2010	0.000	\N
98	25009220101	2010	0.000	\N
98	25009220102	2010	1.000	\N
98	25009221100	2010	1.000	\N
98	25009221300	2010	1.000	\N
98	25009221400	2010	3.000	\N
98	25009221500	2010	0.000	\N
98	25009221600	2010	2.000	\N
98	25009221700	2010	3.000	\N
98	25009221800	2010	0.000	\N
98	25009221901	2010	1.000	\N
98	25009221902	2010	0.000	\N
98	25009222100	2010	3.000	\N
98	25009223100	2010	1.000	\N
98	25009223200	2010	1.000	\N
98	25009223300	2010	6.000	\N
98	25009250100	2010	25.000	\N
98	25009250200	2010	53.000	\N
98	25009250300	2010	18.000	\N
98	25009250400	2010	67.000	\N
98	25009250500	2010	48.000	\N
98	25009250600	2010	24.000	\N
98	25009250700	2010	45.000	\N
98	25009250800	2010	69.000	\N
98	25009250900	2010	35.000	\N
98	25009251000	2010	29.000	\N
98	25009251100	2010	32.000	\N
98	25009251200	2010	49.000	\N
98	25009251300	2010	39.000	\N
98	25009251400	2010	42.000	\N
98	25009251500	2010	72.000	\N
98	25009251600	2010	81.000	\N
98	25009251700	2010	54.000	\N
98	25009251800	2010	45.000	\N
98	25009252101	2010	8.000	\N
98	25009252102	2010	2.000	\N
98	25009252201	2010	4.000	\N
98	25009252202	2010	0.000	\N
98	25009252300	2010	21.000	\N
98	25009252400	2010	34.000	\N
98	25009252501	2010	9.000	\N
98	25009252502	2010	2.000	\N
98	25009252601	2010	3.000	\N
98	25009252602	2010	5.000	\N
98	25009252603	2010	4.000	\N
98	25009253100	2010	0.000	\N
98	25009253201	2010	0.000	\N
98	25009253202	2010	1.000	\N
98	25009253203	2010	0.000	\N
98	25009253204	2010	4.000	\N
98	25009253205	2010	1.000	\N
98	25009254100	2010	0.000	\N
98	25009254200	2010	0.000	\N
98	25009254301	2010	0.000	\N
98	25009254302	2010	2.000	\N
98	25009254401	2010	0.000	\N
98	25009254402	2010	7.000	\N
98	25009254403	2010	0.000	\N
98	25009260100	2010	18.000	\N
98	25009260200	2010	6.000	\N
98	25009260301	2010	2.000	\N
98	25009260302	2010	1.000	\N
98	25009260401	2010	0.000	\N
98	25009260402	2010	6.000	\N
98	25009260500	2010	3.000	\N
98	25009260600	2010	0.000	\N
98	25009260700	2010	5.000	\N
98	25009260800	2010	24.000	\N
98	25009260900	2010	19.000	\N
98	25009261000	2010	5.000	\N
98	25009261101	2010	3.000	\N
98	25009261102	2010	2.000	\N
98	25009262100	2010	2.000	\N
98	25009263100	2010	1.000	\N
98	25009264100	2010	2.000	\N
98	25009265101	2010	5.000	\N
98	25009265102	2010	2.000	\N
98	25009266100	2010	3.000	\N
98	25009266200	2010	3.000	\N
98	25009266300	2010	1.000	\N
98	25009266400	2010	0.000	\N
98	25009267101	2010	1.000	\N
98	25009267102	2010	0.000	\N
98	25009268100	2010	4.000	\N
98	25009268200	2010	2.000	\N
98	25009268300	2010	1.000	\N
98	25009268400	2010	0.000	\N
98	25009269100	2010	0.000	\N
98	25009270100	2010	0.000	\N
98	25009990100	2010	0.000	\N
98	25011040100	2010	3.000	\N
98	25011040200	2010	1.000	\N
98	25011040300	2010	1.000	\N
98	25011040400	2010	4.000	\N
98	25011040501	2010	1.000	\N
98	25011040502	2010	1.000	\N
98	25011040600	2010	3.000	\N
98	25011040701	2010	9.000	\N
98	25011040702	2010	1.000	\N
98	25011040800	2010	3.000	\N
98	25011040900	2010	2.000	\N
98	25011041000	2010	1.000	\N
98	25011041100	2010	1.000	\N
98	25011041200	2010	1.000	\N
98	25011041300	2010	2.000	\N
98	25011041400	2010	4.000	\N
98	25011041501	2010	1.000	\N
98	25011041502	2010	0.000	\N
98	25013800101	2010	12.000	\N
98	25013800102	2010	12.000	\N
98	25013800201	2010	31.000	\N
98	25013800202	2010	1.000	\N
98	25013800300	2010	19.000	\N
98	25013800400	2010	48.000	\N
98	25013800500	2010	20.000	\N
98	25013800600	2010	29.000	\N
98	25013800700	2010	20.000	\N
98	25013800800	2010	18.000	\N
98	25013800900	2010	41.000	\N
98	25013801101	2010	10.000	\N
98	25013801102	2010	5.000	\N
98	25013801200	2010	27.000	\N
98	25013801300	2010	25.000	\N
98	25013801401	2010	35.000	\N
98	25013801402	2010	3.000	\N
98	25013801501	2010	27.000	\N
98	25013801502	2010	6.000	\N
98	25013801503	2010	10.000	\N
98	25013801601	2010	4.000	\N
98	25013801602	2010	13.000	\N
98	25013801603	2010	16.000	\N
98	25013801604	2010	0.000	\N
98	25013801605	2010	10.000	\N
98	25013801700	2010	23.000	\N
98	25013801800	2010	15.000	\N
98	25013801901	2010	26.000	\N
98	25013801902	2010	39.000	\N
98	25013802000	2010	28.000	\N
98	25013802100	2010	20.000	\N
98	25013802200	2010	21.000	\N
98	25013802300	2010	27.000	\N
98	25013802400	2010	3.000	\N
98	25013802500	2010	2.000	\N
98	25013802601	2010	10.000	\N
98	25013802602	2010	2.000	\N
98	25013810100	2010	1.000	\N
98	25013810200	2010	0.000	\N
98	25013810300	2010	3.000	\N
98	25013810403	2010	4.000	\N
98	25013810404	2010	0.000	\N
98	25013810412	2010	0.000	\N
98	25013810414	2010	7.000	\N
98	25013810601	2010	4.000	\N
98	25013810602	2010	3.000	\N
98	25013810700	2010	4.000	\N
98	25013810800	2010	5.000	\N
98	25013810901	2010	2.000	\N
98	25013810902	2010	2.000	\N
98	25013811000	2010	2.000	\N
98	25013811101	2010	44.000	\N
98	25013811102	2010	36.000	\N
98	25013811200	2010	5.000	\N
98	25013811301	2010	2.000	\N
98	25013811302	2010	8.000	\N
98	25013811400	2010	58.000	\N
98	25013811500	2010	25.000	\N
98	25013811600	2010	42.000	\N
98	25013811700	2010	20.000	\N
98	25013811800	2010	25.000	\N
98	25013811900	2010	0.000	\N
98	25013812001	2010	24.000	\N
98	25013812002	2010	28.000	\N
98	25013812101	2010	5.000	\N
98	25013812103	2010	15.000	\N
98	25013812104	2010	16.000	\N
98	25013812201	2010	0.000	\N
98	25013812202	2010	4.000	\N
98	25013812300	2010	24.000	\N
98	25013812401	2010	1.000	\N
98	25013812403	2010	2.000	\N
98	25013812404	2010	0.000	\N
98	25013812500	2010	9.000	\N
98	25013812600	2010	9.000	\N
98	25013812701	2010	3.000	\N
98	25013812702	2010	7.000	\N
98	25013812800	2010	3.000	\N
98	25013812901	2010	14.000	\N
98	25013812902	2010	0.000	\N
98	25013812903	2010	2.000	\N
98	25013813000	2010	2.000	\N
98	25013813101	2010	1.000	\N
98	25013813102	2010	0.000	\N
98	25013813204	2010	1.000	\N
98	25013813205	2010	2.000	\N
98	25013813206	2010	0.000	\N
98	25013813207	2010	6.000	\N
98	25013813208	2010	3.000	\N
98	25013813209	2010	4.000	\N
98	25013813301	2010	1.000	\N
98	25013813303	2010	0.000	\N
98	25013813304	2010	0.000	\N
98	25013813401	2010	0.000	\N
98	25013813403	2010	2.000	\N
98	25013813404	2010	0.000	\N
98	25013813500	2010	0.000	\N
98	25013813601	2010	3.000	\N
98	25013813602	2010	3.000	\N
98	25013813701	2010	0.000	\N
98	25013813702	2010	0.000	\N
98	25013813801	2010	0.000	\N
98	25013813802	2010	0.000	\N
98	25015820101	2010	1.000	\N
98	25015820102	2010	4.000	\N
98	25015820202	2010	0.000	\N
98	25015820203	2010	2.000	\N
98	25015820204	2010	1.000	\N
98	25015820300	2010	9.000	\N
98	25015820400	2010	5.000	\N
98	25015820500	2010	4.000	\N
98	25015820600	2010	1.000	\N
98	25015820700	2010	9.000	\N
98	25015820801	2010	16.000	\N
98	25015820802	2010	1.000	\N
98	25015820900	2010	2.000	\N
98	25015821000	2010	1.000	\N
98	25015821100	2010	0.000	\N
98	25015821200	2010	2.000	\N
98	25015821300	2010	0.000	\N
98	25015821400	2010	1.000	\N
98	25015821500	2010	0.000	\N
98	25015821601	2010	2.000	\N
98	25015821602	2010	8.000	\N
98	25015821700	2010	2.000	\N
98	25015821901	2010	2.000	\N
98	25015821903	2010	4.000	\N
98	25015821904	2010	2.000	\N
98	25015822000	2010	2.000	\N
98	25015822200	2010	2.000	\N
98	25015822300	2010	0.000	\N
98	25015822401	2010	0.000	\N
98	25015822402	2010	0.000	\N
98	25015822500	2010	0.000	\N
98	25015822601	2010	0.000	\N
98	25015822603	2010	1.000	\N
98	25015822605	2010	0.000	\N
98	25015822606	2010	2.000	\N
98	25015822700	2010	0.000	\N
98	25017300100	2010	3.000	\N
98	25017301101	2010	1.000	\N
98	25017301102	2010	0.000	\N
98	25017310100	2010	12.000	\N
98	25017310200	2010	4.000	\N
98	25017310300	2010	13.000	\N
98	25017310400	2010	6.000	\N
98	25017310500	2010	0.000	\N
98	25017310601	2010	1.000	\N
98	25017310602	2010	3.000	\N
98	25017310700	2010	12.000	\N
98	25017311100	2010	25.000	\N
98	25017311200	2010	4.000	\N
98	25017311300	2010	3.000	\N
98	25017311400	2010	15.000	\N
98	25017311500	2010	2.000	\N
98	25017311600	2010	6.000	\N
98	25017311700	2010	2.000	\N
98	25017311800	2010	17.000	\N
98	25017311900	2010	3.000	\N
98	25017312000	2010	5.000	\N
98	25017312100	2010	1.000	\N
98	25017312200	2010	0.000	\N
98	25017312300	2010	3.000	\N
98	25017312400	2010	6.000	\N
98	25017312501	2010	2.000	\N
98	25017312502	2010	1.000	\N
98	25017313101	2010	3.000	\N
98	25017313102	2010	2.000	\N
98	25017314101	2010	1.000	\N
98	25017314102	2010	5.000	\N
98	25017314200	2010	0.000	\N
98	25017314301	2010	2.000	\N
98	25017314302	2010	0.000	\N
98	25017315100	2010	0.000	\N
98	25017315200	2010	0.000	\N
98	25017315401	2010	2.000	\N
98	25017315402	2010	0.000	\N
98	25017315403	2010	0.000	\N
98	25017315500	2010	3.000	\N
98	25017316101	2010	0.000	\N
98	25017316102	2010	0.000	\N
98	25017316201	2010	4.000	\N
98	25017316202	2010	3.000	\N
98	25017316300	2010	0.000	\N
98	25017316400	2010	1.000	\N
98	25017316500	2010	3.000	\N
98	25017317101	2010	2.000	\N
98	25017317102	2010	0.000	\N
98	25017317103	2010	0.000	\N
98	25017317201	2010	0.000	\N
98	25017317202	2010	1.000	\N
98	25017317203	2010	0.000	\N
98	25017317301	2010	0.000	\N
98	25017317302	2010	2.000	\N
98	25017318100	2010	2.000	\N
98	25017318200	2010	1.000	\N
98	25017318300	2010	1.000	\N
98	25017318400	2010	2.000	\N
98	25017320102	2010	1.000	\N
98	25017320103	2010	0.000	\N
98	25017320104	2010	2.000	\N
98	25017321100	2010	3.000	\N
98	25017321200	2010	1.000	\N
98	25017321300	2010	6.000	\N
98	25017321400	2010	1.000	\N
98	25017321500	2010	26.000	\N
98	25017321600	2010	2.000	\N
98	25017322100	2010	2.000	\N
98	25017322200	2010	0.000	\N
98	25017322300	2010	12.000	\N
98	25017322400	2010	0.000	\N
98	25017323100	2010	2.000	\N
98	25017324101	2010	1.000	\N
98	25017324102	2010	3.000	\N
98	25017325100	2010	4.000	\N
98	25017326101	2010	0.000	\N
98	25017326102	2010	0.000	\N
98	25017327101	2010	3.000	\N
98	25017327102	2010	1.000	\N
98	25017327103	2010	2.000	\N
98	25017328100	2010	0.000	\N
98	25017330100	2010	6.000	\N
98	25017330200	2010	1.000	\N
98	25017331101	2010	0.000	\N
98	25017331102	2010	0.000	\N
98	25017331200	2010	1.000	\N
98	25017331300	2010	2.000	\N
98	25017332100	2010	1.000	\N
98	25017332200	2010	4.000	\N
98	25017332300	2010	0.000	\N
98	25017332400	2010	2.000	\N
98	25017333100	2010	1.000	\N
98	25017333200	2010	1.000	\N
98	25017333300	2010	1.000	\N
98	25017333400	2010	3.000	\N
98	25017333501	2010	5.000	\N
98	25017333502	2010	0.000	\N
98	25017333600	2010	4.000	\N
98	25017334100	2010	5.000	\N
98	25017334200	2010	3.000	\N
98	25017334300	2010	0.000	\N
98	25017334400	2010	0.000	\N
98	25017335100	2010	2.000	\N
98	25017335200	2010	1.000	\N
98	25017335301	2010	3.000	\N
98	25017335302	2010	1.000	\N
98	25017335400	2010	1.000	\N
98	25017336100	2010	1.000	\N
98	25017336200	2010	1.000	\N
98	25017336300	2010	6.000	\N
98	25017336401	2010	0.000	\N
98	25017336402	2010	3.000	\N
98	25017337101	2010	2.000	\N
98	25017337102	2010	2.000	\N
98	25017337201	2010	0.000	\N
98	25017337202	2010	2.000	\N
98	25017337300	2010	2.000	\N
98	25017338100	2010	4.000	\N
98	25017338200	2010	0.000	\N
98	25017338300	2010	0.000	\N
98	25017338400	2010	0.000	\N
98	25017338500	2010	1.000	\N
98	25017339100	2010	12.000	\N
98	25017339200	2010	1.000	\N
98	25017339300	2010	6.000	\N
98	25017339400	2010	0.000	\N
98	25017339500	2010	0.000	\N
98	25017339600	2010	8.000	\N
98	25017339700	2010	4.000	\N
98	25017339801	2010	1.000	\N
98	25017339802	2010	6.000	\N
98	25017339900	2010	1.000	\N
98	25017340000	2010	1.000	\N
98	25017340100	2010	3.000	\N
98	25017341101	2010	2.000	\N
98	25017341102	2010	0.000	\N
98	25017341200	2010	0.000	\N
98	25017341300	2010	1.000	\N
98	25017341400	2010	3.000	\N
98	25017341500	2010	5.000	\N
98	25017341600	2010	2.000	\N
98	25017341700	2010	5.000	\N
98	25017341800	2010	1.000	\N
98	25017341901	2010	0.000	\N
98	25017341902	2010	9.000	\N
98	25017342101	2010	9.000	\N
98	25017342102	2010	11.000	\N
98	25017342201	2010	12.000	\N
98	25017342202	2010	10.000	\N
98	25017342300	2010	2.000	\N
98	25017342400	2010	9.000	\N
98	25017342500	2010	13.000	\N
98	25017342600	2010	12.000	\N
98	25017350103	2010	0.000	\N
98	25017350104	2010	23.000	\N
98	25017350200	2010	10.000	\N
98	25017350300	2010	3.000	\N
98	25017350400	2010	0.000	\N
98	25017350500	2010	1.000	\N
98	25017350600	2010	3.000	\N
98	25017350700	2010	1.000	\N
98	25017350800	2010	1.000	\N
98	25017350900	2010	1.000	\N
98	25017351000	2010	7.000	\N
98	25017351100	2010	1.000	\N
98	25017351203	2010	2.000	\N
98	25017351204	2010	6.000	\N
98	25017351300	2010	16.000	\N
98	25017351403	2010	19.000	\N
98	25017351404	2010	12.000	\N
98	25017351500	2010	2.000	\N
98	25017352101	2010	0.000	\N
98	25017352102	2010	3.000	\N
98	25017352200	2010	1.000	\N
98	25017352300	2010	4.000	\N
98	25017352400	2010	5.000	\N
98	25017352500	2010	1.000	\N
98	25017352600	2010	2.000	\N
98	25017352700	2010	3.000	\N
98	25017352800	2010	0.000	\N
98	25017352900	2010	1.000	\N
98	25017353000	2010	2.000	\N
98	25017353101	2010	3.000	\N
98	25017353102	2010	1.000	\N
98	25017353200	2010	2.000	\N
98	25017353300	2010	1.000	\N
98	25017353400	2010	8.000	\N
98	25017353500	2010	2.000	\N
98	25017353600	2010	2.000	\N
98	25017353700	2010	3.000	\N
98	25017353800	2010	0.000	\N
98	25017353900	2010	1.000	\N
98	25017354000	2010	5.000	\N
98	25017354100	2010	1.000	\N
98	25017354200	2010	3.000	\N
98	25017354300	2010	3.000	\N
98	25017354400	2010	1.000	\N
98	25017354500	2010	2.000	\N
98	25017354600	2010	1.000	\N
98	25017354700	2010	5.000	\N
98	25017354800	2010	2.000	\N
98	25017354900	2010	15.000	\N
98	25017355000	2010	2.000	\N
98	25017356100	2010	2.000	\N
98	25017356300	2010	0.000	\N
98	25017356400	2010	9.000	\N
98	25017356500	2010	1.000	\N
98	25017356601	2010	1.000	\N
98	25017356602	2010	0.000	\N
98	25017356701	2010	2.000	\N
98	25017356702	2010	5.000	\N
98	25017357100	2010	0.000	\N
98	25017357200	2010	0.000	\N
98	25017357300	2010	5.000	\N
98	25017357400	2010	0.000	\N
98	25017357500	2010	2.000	\N
98	25017357600	2010	0.000	\N
98	25017357700	2010	3.000	\N
98	25017357800	2010	0.000	\N
98	25017358100	2010	1.000	\N
98	25017358300	2010	0.000	\N
98	25017358400	2010	0.000	\N
98	25017358500	2010	2.000	\N
98	25017358600	2010	1.000	\N
98	25017358700	2010	0.000	\N
98	25017359100	2010	1.000	\N
98	25017359300	2010	1.000	\N
98	25017360100	2010	3.000	\N
98	25017360200	2010	0.000	\N
98	25017361100	2010	2.000	\N
98	25017361200	2010	0.000	\N
98	25017361300	2010	4.000	\N
98	25017362100	2010	0.000	\N
98	25017363102	2010	2.000	\N
98	25017363103	2010	2.000	\N
98	25017363104	2010	0.000	\N
98	25017363201	2010	1.000	\N
98	25017363202	2010	0.000	\N
98	25017364101	2010	1.000	\N
98	25017364102	2010	0.000	\N
98	25017365100	2010	0.000	\N
98	25017365201	2010	2.000	\N
98	25017365202	2010	1.000	\N
98	25017366100	2010	0.000	\N
98	25017366201	2010	0.000	\N
98	25017366202	2010	0.000	\N
98	25017367100	2010	0.000	\N
98	25017367200	2010	3.000	\N
98	25017368101	2010	1.000	\N
98	25017368102	2010	6.000	\N
98	25017368200	2010	3.000	\N
98	25017368300	2010	8.000	\N
98	25017368400	2010	0.000	\N
98	25017368500	2010	8.000	\N
98	25017368600	2010	7.000	\N
98	25017368700	2010	13.000	\N
98	25017368800	2010	11.000	\N
98	25017368901	2010	14.000	\N
98	25017368902	2010	2.000	\N
98	25017369000	2010	0.000	\N
98	25017369100	2010	0.000	\N
98	25017370101	2010	4.000	\N
98	25017370102	2010	0.000	\N
98	25017370201	2010	2.000	\N
98	25017370202	2010	5.000	\N
98	25017370300	2010	3.000	\N
98	25017370400	2010	1.000	\N
98	25017373100	2010	0.000	\N
98	25017373200	2010	0.000	\N
98	25017373300	2010	0.000	\N
98	25017373400	2010	4.000	\N
98	25017373500	2010	4.000	\N
98	25017373600	2010	5.000	\N
98	25017373700	2010	2.000	\N
98	25017373800	2010	0.000	\N
98	25017373900	2010	0.000	\N
98	25017374000	2010	4.000	\N
98	25017374100	2010	1.000	\N
98	25017374200	2010	2.000	\N
98	25017374300	2010	0.000	\N
98	25017374400	2010	1.000	\N
98	25017374500	2010	4.000	\N
98	25017374600	2010	5.000	\N
98	25017374700	2010	1.000	\N
98	25017374800	2010	2.000	\N
98	25017382100	2010	1.000	\N
98	25017382200	2010	0.000	\N
98	25017382300	2010	2.000	\N
98	25017382400	2010	2.000	\N
98	25017382500	2010	3.000	\N
98	25017382601	2010	0.000	\N
98	25017382602	2010	6.000	\N
98	25017383101	2010	13.000	\N
98	25017383102	2010	19.000	\N
98	25017383200	2010	22.000	\N
98	25017383300	2010	5.000	\N
98	25017383400	2010	16.000	\N
98	25017383501	2010	4.000	\N
98	25017383502	2010	3.000	\N
98	25017383600	2010	3.000	\N
98	25017383700	2010	0.000	\N
98	25017383800	2010	7.000	\N
98	25017383901	2010	2.000	\N
98	25017383902	2010	0.000	\N
98	25017384001	2010	4.000	\N
98	25017384002	2010	3.000	\N
98	25017385100	2010	2.000	\N
98	25017385201	2010	2.000	\N
98	25017385202	2010	3.000	\N
98	25017386100	2010	0.000	\N
98	25017387100	2010	0.000	\N
98	25017387201	2010	1.000	\N
98	25017387202	2010	0.000	\N
98	25017388100	2010	1.000	\N
98	25017388200	2010	4.000	\N
98	25017388300	2010	9.000	\N
98	25017980000	2010	0.000	\N
98	25019950100	2010	0.000	\N
98	25019950200	2010	0.000	\N
98	25019950307	2010	0.000	\N
98	25019950400	2010	0.000	\N
98	25019950500	2010	0.000	\N
98	25019990000	2010	0.000	\N
98	25021400100	2010	3.000	\N
98	25021400200	2010	0.000	\N
98	25021400300	2010	1.000	\N
98	25021400400	2010	0.000	\N
98	25021400500	2010	8.000	\N
98	25021400600	2010	2.000	\N
98	25021400700	2010	0.000	\N
98	25021400800	2010	3.000	\N
98	25021400900	2010	2.000	\N
98	25021401000	2010	4.000	\N
98	25021401100	2010	0.000	\N
98	25021401200	2010	2.000	\N
98	25021402101	2010	6.000	\N
98	25021402102	2010	4.000	\N
98	25021402200	2010	2.000	\N
98	25021402300	2010	2.000	\N
98	25021402400	2010	3.000	\N
98	25021402500	2010	2.000	\N
98	25021403100	2010	0.000	\N
98	25021403300	2010	0.000	\N
98	25021403400	2010	0.000	\N
98	25021403500	2010	0.000	\N
98	25021404100	2010	6.000	\N
98	25021404201	2010	1.000	\N
98	25021404202	2010	0.000	\N
98	25021404301	2010	0.000	\N
98	25021404302	2010	1.000	\N
98	25021404400	2010	6.000	\N
98	25021405100	2010	0.000	\N
98	25021406101	2010	0.000	\N
98	25021406102	2010	1.000	\N
98	25021407100	2010	1.000	\N
98	25021408101	2010	5.000	\N
98	25021408102	2010	5.000	\N
98	25021409101	2010	9.000	\N
98	25021409102	2010	2.000	\N
98	25021410100	2010	0.000	\N
98	25021410300	2010	1.000	\N
98	25021410400	2010	1.000	\N
98	25021411100	2010	0.000	\N
98	25021411200	2010	3.000	\N
98	25021411301	2010	0.000	\N
98	25021411302	2010	1.000	\N
98	25021412100	2010	2.000	\N
98	25021412200	2010	0.000	\N
98	25021412300	2010	0.000	\N
98	25021413100	2010	0.000	\N
98	25021413200	2010	2.000	\N
98	25021413300	2010	3.000	\N
98	25021413401	2010	0.000	\N
98	25021413402	2010	0.000	\N
98	25021413500	2010	5.000	\N
98	25021414100	2010	0.000	\N
98	25021414200	2010	5.000	\N
98	25021414300	2010	1.000	\N
98	25021415101	2010	4.000	\N
98	25021415102	2010	1.000	\N
98	25021415200	2010	1.000	\N
98	25021415300	2010	0.000	\N
98	25021416101	2010	0.000	\N
98	25021416102	2010	0.000	\N
98	25021416200	2010	8.000	\N
98	25021416300	2010	1.000	\N
98	25021416400	2010	0.000	\N
98	25021417100	2010	1.000	\N
98	25021417200	2010	1.000	\N
98	25021417300	2010	0.000	\N
98	25021417400	2010	0.000	\N
98	25021417501	2010	1.000	\N
98	25021417502	2010	1.000	\N
98	25021417601	2010	0.000	\N
98	25021417602	2010	1.000	\N
98	25021417701	2010	1.000	\N
98	25021417702	2010	1.000	\N
98	25021417801	2010	1.000	\N
98	25021417802	2010	4.000	\N
98	25021417901	2010	3.000	\N
98	25021417902	2010	1.000	\N
98	25021418002	2010	10.000	\N
98	25021418003	2010	2.000	\N
98	25021418004	2010	7.000	\N
98	25021418101	2010	1.000	\N
98	25021418102	2010	1.000	\N
98	25021418200	2010	3.000	\N
98	25021419100	2010	6.000	\N
98	25021419200	2010	0.000	\N
98	25021419300	2010	4.000	\N
98	25021419400	2010	0.000	\N
98	25021419500	2010	0.000	\N
98	25021419600	2010	3.000	\N
98	25021419700	2010	0.000	\N
98	25021419800	2010	3.000	\N
98	25021420100	2010	3.000	\N
98	25021420201	2010	5.000	\N
98	25021420202	2010	17.000	\N
98	25021420301	2010	12.000	\N
98	25021420302	2010	2.000	\N
98	25021421100	2010	6.000	\N
98	25021421200	2010	0.000	\N
98	25021422100	2010	1.000	\N
98	25021422200	2010	0.000	\N
98	25021422301	2010	0.000	\N
98	25021422302	2010	4.000	\N
98	25021422400	2010	0.000	\N
98	25021422501	2010	0.000	\N
98	25021422502	2010	1.000	\N
98	25021422600	2010	0.000	\N
98	25021422700	2010	1.000	\N
98	25021422800	2010	2.000	\N
98	25021423100	2010	3.000	\N
98	25021440100	2010	3.000	\N
98	25021441202	2010	2.000	\N
98	25021441203	2010	1.000	\N
98	25021441204	2010	0.000	\N
98	25021442101	2010	2.000	\N
98	25021442102	2010	0.000	\N
98	25021442103	2010	2.000	\N
98	25021442201	2010	0.000	\N
98	25021442202	2010	18.000	\N
98	25021443101	2010	3.000	\N
98	25021443102	2010	0.000	\N
98	25021456101	2010	1.000	\N
98	25021456102	2010	2.000	\N
98	25021456200	2010	1.000	\N
98	25021456301	2010	5.000	\N
98	25021456302	2010	1.000	\N
98	25021456401	2010	0.000	\N
98	25021456402	2010	1.000	\N
98	25021457100	2010	4.000	\N
98	25021457200	2010	1.000	\N
98	25023500101	2010	1.000	\N
98	25023500103	2010	1.000	\N
98	25023500104	2010	16.000	\N
98	25023501101	2010	0.000	\N
98	25023501102	2010	1.000	\N
98	25023501201	2010	0.000	\N
98	25023501202	2010	2.000	\N
98	25023502101	2010	0.000	\N
98	25023502102	2010	5.000	\N
98	25023502200	2010	0.000	\N
98	25023503101	2010	1.000	\N
98	25023503102	2010	1.000	\N
98	25023504101	2010	0.000	\N
98	25023504102	2010	0.000	\N
98	25023505101	2010	1.000	\N
98	25023505102	2010	0.000	\N
98	25023505200	2010	0.000	\N
98	25023506101	2010	1.000	\N
98	25023506102	2010	0.000	\N
98	25023506202	2010	0.000	\N
98	25023506203	2010	1.000	\N
98	25023506204	2010	1.000	\N
98	25023507101	2010	0.000	\N
98	25023507103	2010	0.000	\N
98	25023507104	2010	0.000	\N
98	25023508101	2010	1.000	\N
98	25023508102	2010	3.000	\N
98	25023508200	2010	1.000	\N
98	25023509101	2010	2.000	\N
98	25023509102	2010	0.000	\N
98	25023510100	2010	3.000	\N
98	25023510200	2010	1.000	\N
98	25023510300	2010	4.000	\N
98	25023510400	2010	6.000	\N
98	25023510501	2010	2.000	\N
98	25023510502	2010	8.000	\N
98	25023510503	2010	2.000	\N
98	25023510600	2010	1.000	\N
98	25023510700	2010	2.000	\N
98	25023510800	2010	8.000	\N
98	25023510900	2010	5.000	\N
98	25023511000	2010	7.000	\N
98	25023511100	2010	0.000	\N
98	25023511200	2010	1.000	\N
98	25023511301	2010	5.000	\N
98	25023511302	2010	8.000	\N
98	25023511400	2010	2.000	\N
98	25023511500	2010	5.000	\N
98	25023511600	2010	8.000	\N
98	25023511701	2010	0.000	\N
98	25023511702	2010	1.000	\N
98	25023520100	2010	1.000	\N
98	25023520201	2010	5.000	\N
98	25023520202	2010	0.000	\N
98	25023521101	2010	0.000	\N
98	25023521102	2010	0.000	\N
98	25023521201	2010	0.000	\N
98	25023521202	2010	3.000	\N
98	25023522101	2010	0.000	\N
98	25023522102	2010	1.000	\N
98	25023523100	2010	0.000	\N
98	25023523201	2010	1.000	\N
98	25023523202	2010	2.000	\N
98	25023524101	2010	0.000	\N
98	25023524102	2010	0.000	\N
98	25023525101	2010	5.000	\N
98	25023525104	2010	0.000	\N
98	25023525203	2010	0.000	\N
98	25023525204	2010	0.000	\N
98	25023525300	2010	2.000	\N
98	25023526100	2010	2.000	\N
98	25023530100	2010	3.000	\N
98	25023530200	2010	1.000	\N
98	25023530300	2010	0.000	\N
98	25023530400	2010	8.000	\N
98	25023530500	2010	1.000	\N
98	25023530600	2010	1.000	\N
98	25023530700	2010	0.000	\N
98	25023530801	2010	0.000	\N
98	25023530802	2010	2.000	\N
98	25023530901	2010	2.000	\N
98	25023530902	2010	0.000	\N
98	25023540101	2010	0.000	\N
98	25023540102	2010	0.000	\N
98	25023540103	2010	0.000	\N
98	25023541100	2010	0.000	\N
98	25023542101	2010	0.000	\N
98	25023542102	2010	0.000	\N
98	25023542200	2010	0.000	\N
98	25023542300	2010	8.000	\N
98	25023543100	2010	6.000	\N
98	25023544100	2010	0.000	\N
98	25023544200	2010	0.000	\N
98	25023545100	2010	5.000	\N
98	25023545200	2010	3.000	\N
98	25023545300	2010	6.000	\N
98	25023545400	2010	2.000	\N
98	25023560100	2010	1.000	\N
98	25023561100	2010	0.000	\N
98	25023561200	2010	0.000	\N
98	25023990003	2010	0.000	\N
98	25025000100	2010	3.000	\N
98	25025000201	2010	3.000	\N
98	25025000202	2010	5.000	\N
98	25025000301	2010	6.000	\N
98	25025000302	2010	0.000	\N
98	25025000401	2010	4.000	\N
98	25025000402	2010	0.000	\N
98	25025000502	2010	2.000	\N
98	25025000503	2010	1.000	\N
98	25025000504	2010	1.000	\N
98	25025000601	2010	0.000	\N
98	25025000602	2010	11.000	\N
98	25025000701	2010	4.000	\N
98	25025000703	2010	0.000	\N
98	25025000704	2010	10.000	\N
98	25025000802	2010	16.000	\N
98	25025000803	2010	2.000	\N
98	25025010103	2010	1.000	\N
98	25025010104	2010	2.000	\N
98	25025010203	2010	4.000	\N
98	25025010204	2010	1.000	\N
98	25025010300	2010	3.000	\N
98	25025010403	2010	0.000	\N
98	25025010404	2010	6.000	\N
98	25025010405	2010	8.000	\N
98	25025010408	2010	0.000	\N
98	25025010500	2010	1.000	\N
98	25025010600	2010	1.000	\N
98	25025010701	2010	0.000	\N
98	25025010702	2010	0.000	\N
98	25025010801	2010	0.000	\N
98	25025010802	2010	0.000	\N
98	25025020101	2010	0.000	\N
98	25025020200	2010	0.000	\N
98	25025020301	2010	0.000	\N
98	25025020302	2010	1.000	\N
98	25025020303	2010	0.000	\N
98	25025030100	2010	0.000	\N
98	25025030200	2010	1.000	\N
98	25025030300	2010	2.000	\N
98	25025030400	2010	1.000	\N
98	25025030500	2010	0.000	\N
98	25025040100	2010	1.000	\N
98	25025040200	2010	3.000	\N
98	25025040300	2010	7.000	\N
98	25025040401	2010	1.000	\N
98	25025040600	2010	0.000	\N
98	25025040801	2010	5.000	\N
98	25025050101	2010	20.000	\N
98	25025050200	2010	14.000	\N
98	25025050300	2010	11.000	\N
98	25025050400	2010	4.000	\N
98	25025050500	2010	0.000	\N
98	25025050600	2010	3.000	\N
98	25025050700	2010	29.000	\N
98	25025050901	2010	16.000	\N
98	25025051000	2010	19.000	\N
98	25025051101	2010	22.000	\N
98	25025051200	2010	4.000	\N
98	25025060101	2010	0.000	\N
98	25025060200	2010	0.000	\N
98	25025060301	2010	0.000	\N
98	25025060400	2010	2.000	\N
98	25025060501	2010	1.000	\N
98	25025060600	2010	0.000	\N
98	25025060700	2010	4.000	\N
98	25025060800	2010	5.000	\N
98	25025061000	2010	13.000	\N
98	25025061101	2010	13.000	\N
98	25025061200	2010	0.000	\N
98	25025070101	2010	0.000	\N
98	25025070200	2010	1.000	\N
98	25025070300	2010	0.000	\N
98	25025070402	2010	0.000	\N
98	25025070500	2010	15.000	\N
98	25025070600	2010	0.000	\N
98	25025070700	2010	0.000	\N
98	25025070800	2010	2.000	\N
98	25025070900	2010	7.000	\N
98	25025071101	2010	7.000	\N
98	25025071201	2010	4.000	\N
98	25025080100	2010	12.000	\N
98	25025080300	2010	8.000	\N
98	25025080401	2010	12.000	\N
98	25025080500	2010	9.000	\N
98	25025080601	2010	6.000	\N
98	25025080801	2010	25.000	\N
98	25025080900	2010	5.000	\N
98	25025081001	2010	16.000	\N
98	25025081100	2010	5.000	\N
98	25025081200	2010	36.000	\N
98	25025081300	2010	38.000	\N
98	25025081400	2010	19.000	\N
98	25025081500	2010	3.000	\N
98	25025081700	2010	16.000	\N
98	25025081800	2010	3.000	\N
98	25025081900	2010	5.000	\N
98	25025082000	2010	11.000	\N
98	25025082100	2010	22.000	\N
98	25025090100	2010	11.000	\N
98	25025090200	2010	14.000	\N
98	25025090300	2010	12.000	\N
98	25025090400	2010	25.000	\N
98	25025090600	2010	8.000	\N
98	25025090700	2010	4.000	\N
98	25025090901	2010	10.000	\N
98	25025091001	2010	1.000	\N
98	25025091100	2010	0.000	\N
98	25025091200	2010	6.000	\N
98	25025091300	2010	6.000	\N
98	25025091400	2010	5.000	\N
98	25025091500	2010	3.000	\N
98	25025091600	2010	0.000	\N
98	25025091700	2010	16.000	\N
98	25025091800	2010	3.000	\N
98	25025091900	2010	18.000	\N
98	25025092000	2010	6.000	\N
98	25025092101	2010	15.000	\N
98	25025092200	2010	1.000	\N
98	25025092300	2010	4.000	\N
98	25025092400	2010	20.000	\N
98	25025100100	2010	8.000	\N
98	25025100200	2010	10.000	\N
98	25025100300	2010	1.000	\N
98	25025100400	2010	2.000	\N
98	25025100500	2010	26.000	\N
98	25025100601	2010	1.000	\N
98	25025100603	2010	0.000	\N
98	25025100700	2010	3.000	\N
98	25025100800	2010	1.000	\N
98	25025100900	2010	5.000	\N
98	25025101001	2010	12.000	\N
98	25025101002	2010	16.000	\N
98	25025101101	2010	1.000	\N
98	25025101102	2010	10.000	\N
98	25025110103	2010	20.000	\N
98	25025110201	2010	22.000	\N
98	25025110301	2010	5.000	\N
98	25025110401	2010	11.000	\N
98	25025110403	2010	4.000	\N
98	25025110501	2010	9.000	\N
98	25025110502	2010	11.000	\N
98	25025110601	2010	3.000	\N
98	25025110607	2010	6.000	\N
98	25025120103	2010	1.000	\N
98	25025120104	2010	3.000	\N
98	25025120105	2010	6.000	\N
98	25025120201	2010	11.000	\N
98	25025120301	2010	36.000	\N
98	25025120400	2010	12.000	\N
98	25025120500	2010	32.000	\N
98	25025120600	2010	5.000	\N
98	25025120700	2010	1.000	\N
98	25025130100	2010	3.000	\N
98	25025130200	2010	7.000	\N
98	25025130300	2010	0.000	\N
98	25025130402	2010	2.000	\N
98	25025130404	2010	2.000	\N
98	25025130406	2010	10.000	\N
98	25025140102	2010	4.000	\N
98	25025140105	2010	10.000	\N
98	25025140106	2010	7.000	\N
98	25025140107	2010	4.000	\N
98	25025140201	2010	3.000	\N
98	25025140202	2010	18.000	\N
98	25025140300	2010	8.000	\N
98	25025140400	2010	28.000	\N
98	25025160101	2010	113.000	\N
98	25025160200	2010	31.000	\N
98	25025160300	2010	7.000	\N
98	25025160400	2010	24.000	\N
98	25025160501	2010	72.000	\N
98	25025160502	2010	20.000	\N
98	25025160601	2010	17.000	\N
98	25025160602	2010	31.000	\N
98	25025170100	2010	29.000	\N
98	25025170200	2010	6.000	\N
98	25025170300	2010	3.000	\N
98	25025170400	2010	14.000	\N
98	25025170501	2010	9.000	\N
98	25025170502	2010	6.000	\N
98	25025170601	2010	6.000	\N
98	25025170701	2010	4.000	\N
98	25025170702	2010	15.000	\N
98	25025170800	2010	28.000	\N
98	25025180101	2010	1.000	\N
98	25025180200	2010	3.000	\N
98	25025180301	2010	1.000	\N
98	25025180400	2010	0.000	\N
98	25025180500	2010	5.000	\N
98	25025980101	2010	0.000	\N
98	25025980300	2010	0.000	\N
98	25025980700	2010	0.000	\N
98	25025981000	2010	0.000	\N
98	25025981100	2010	0.000	\N
98	25025981201	2010	0.000	\N
98	25025981202	2010	0.000	\N
98	25025981300	2010	0.000	\N
98	25025981501	2010	0.000	\N
98	25025981502	2010	0.000	\N
98	25025981600	2010	0.000	\N
98	25025981700	2010	0.000	\N
98	25025981800	2010	0.000	\N
98	25025990101	2010	0.000	\N
98	25027700100	2010	2.000	\N
98	25027701100	2010	4.000	\N
98	25027702200	2010	8.000	\N
98	25027703100	2010	6.000	\N
98	25027703200	2010	0.000	\N
98	25027703300	2010	6.000	\N
98	25027704200	2010	0.000	\N
98	25027705100	2010	3.000	\N
98	25027706100	2010	1.000	\N
98	25027707100	2010	4.000	\N
98	25027707200	2010	8.000	\N
98	25027707300	2010	4.000	\N
98	25027707400	2010	1.000	\N
98	25027707500	2010	3.000	\N
98	25027708100	2010	3.000	\N
98	25027709100	2010	1.000	\N
98	25027709201	2010	1.000	\N
98	25027709202	2010	2.000	\N
98	25027709400	2010	7.000	\N
98	25027709501	2010	0.000	\N
98	25027709502	2010	0.000	\N
98	25027709600	2010	3.000	\N
98	25027709701	2010	10.000	\N
98	25027709702	2010	0.000	\N
98	25027710100	2010	2.000	\N
98	25027710200	2010	6.000	\N
98	25027710300	2010	6.000	\N
98	25027710400	2010	5.000	\N
98	25027710500	2010	14.000	\N
98	25027710600	2010	17.000	\N
98	25027710700	2010	0.000	\N
98	25027710800	2010	4.000	\N
98	25027711000	2010	10.000	\N
98	25027711100	2010	0.000	\N
98	25027712101	2010	1.000	\N
98	25027712102	2010	0.000	\N
98	25027713100	2010	2.000	\N
98	25027715100	2010	0.000	\N
98	25027716100	2010	6.000	\N
98	25027716200	2010	3.000	\N
98	25027716300	2010	13.000	\N
98	25027717100	2010	2.000	\N
98	25027718100	2010	0.000	\N
98	25027719100	2010	1.000	\N
98	25027720100	2010	1.000	\N
98	25027721101	2010	0.000	\N
98	25027721102	2010	0.000	\N
98	25027722100	2010	0.000	\N
98	25027723100	2010	1.000	\N
98	25027724100	2010	6.000	\N
98	25027725100	2010	5.000	\N
98	25027726100	2010	3.000	\N
98	25027726200	2010	3.000	\N
98	25027727100	2010	1.000	\N
98	25027728100	2010	0.000	\N
98	25027728200	2010	1.000	\N
98	25027728300	2010	0.000	\N
98	25027728400	2010	1.000	\N
98	25027729100	2010	0.000	\N
98	25027729200	2010	0.000	\N
98	25027730100	2010	4.000	\N
98	25027730200	2010	1.000	\N
98	25027730300	2010	3.000	\N
98	25027730401	2010	14.000	\N
98	25027730402	2010	0.000	\N
98	25027730500	2010	9.000	\N
98	25027730600	2010	4.000	\N
98	25027730700	2010	5.000	\N
98	25027730801	2010	0.000	\N
98	25027730802	2010	1.000	\N
98	25027730901	2010	4.000	\N
98	25027730902	2010	5.000	\N
98	25027731001	2010	1.000	\N
98	25027731002	2010	18.000	\N
98	25027731101	2010	11.000	\N
98	25027731102	2010	1.000	\N
98	25027731202	2010	0.000	\N
98	25027731203	2010	23.000	\N
98	25027731204	2010	17.000	\N
98	25027731300	2010	9.000	\N
98	25027731400	2010	11.000	\N
98	25027731500	2010	12.000	\N
98	25027731600	2010	3.000	\N
98	25027731700	2010	7.000	\N
98	25027731800	2010	24.000	\N
98	25027731900	2010	17.000	\N
98	25027732001	2010	7.000	\N
98	25027732002	2010	3.000	\N
98	25027732201	2010	2.000	\N
98	25027732202	2010	17.000	\N
98	25027732203	2010	6.000	\N
98	25027732301	2010	0.000	\N
98	25027732302	2010	1.000	\N
98	25027732400	2010	9.000	\N
98	25027732500	2010	13.000	\N
98	25027732600	2010	10.000	\N
98	25027732700	2010	18.000	\N
98	25027732801	2010	0.000	\N
98	25027732802	2010	2.000	\N
98	25027732901	2010	10.000	\N
98	25027732902	2010	0.000	\N
98	25027733000	2010	19.000	\N
98	25027733101	2010	7.000	\N
98	25027733102	2010	0.000	\N
98	25027735100	2010	0.000	\N
98	25027735200	2010	0.000	\N
98	25027736100	2010	0.000	\N
98	25027736200	2010	0.000	\N
98	25027736300	2010	0.000	\N
98	25027736400	2010	1.000	\N
98	25027736500	2010	1.000	\N
98	25027737100	2010	0.000	\N
98	25027737200	2010	1.000	\N
98	25027737300	2010	5.000	\N
98	25027738100	2010	10.000	\N
98	25027738201	2010	0.000	\N
98	25027738202	2010	0.000	\N
98	25027739100	2010	0.000	\N
98	25027739200	2010	3.000	\N
98	25027739300	2010	0.000	\N
98	25027739400	2010	3.000	\N
98	25027739500	2010	0.000	\N
98	25027740101	2010	4.000	\N
98	25027740102	2010	2.000	\N
98	25027740200	2010	0.000	\N
98	25027741101	2010	0.000	\N
98	25027741102	2010	3.000	\N
98	25027742300	2010	1.000	\N
98	25027742401	2010	1.000	\N
98	25027742402	2010	1.000	\N
98	25027743100	2010	8.000	\N
98	25027744101	2010	2.000	\N
98	25027744102	2010	1.000	\N
98	25027744200	2010	8.000	\N
98	25027744300	2010	25.000	\N
98	25027744400	2010	0.000	\N
98	25027745100	2010	1.000	\N
98	25027746100	2010	0.000	\N
98	25027747101	2010	0.000	\N
98	25027747102	2010	1.000	\N
98	25027748100	2010	0.000	\N
98	25027749100	2010	9.000	\N
98	25027749200	2010	3.000	\N
98	25027750100	2010	0.000	\N
98	25027750200	2010	0.000	\N
98	25027750300	2010	1.000	\N
98	25027751101	2010	5.000	\N
98	25027751102	2010	4.000	\N
98	25027752100	2010	1.000	\N
98	25027753100	2010	2.000	\N
98	25027753200	2010	3.000	\N
98	25027754100	2010	1.000	\N
98	25027754200	2010	1.000	\N
98	25027754300	2010	1.000	\N
98	25027754400	2010	1.000	\N
98	25027755100	2010	1.000	\N
98	25027755200	2010	2.000	\N
98	25027756101	2010	0.000	\N
98	25027756102	2010	3.000	\N
98	25027757100	2010	5.000	\N
98	25027757200	2010	1.000	\N
98	25027757300	2010	19.000	\N
98	25027757400	2010	0.000	\N
98	25027757500	2010	5.000	\N
98	25027758101	2010	0.000	\N
98	25027758102	2010	2.000	\N
98	25027759100	2010	0.000	\N
98	25027760100	2010	2.000	\N
98	25027761100	2010	1.000	\N
98	25027761200	2010	1.000	\N
98	25027761300	2010	0.000	\N
98	25027761400	2010	3.000	\N
99	25001010100	2010	0.000	\N
99	25001010206	2010	0.000	\N
99	25001010208	2010	0.000	\N
99	25001010304	2010	1.000	\N
99	25001010306	2010	0.000	\N
99	25001010400	2010	1.000	\N
99	25001010500	2010	0.000	\N
99	25001010600	2010	0.000	\N
99	25001010700	2010	0.000	\N
99	25001010800	2010	2.000	\N
99	25001010900	2010	0.000	\N
99	25001011002	2010	3.000	\N
99	25001011100	2010	0.000	\N
99	25001011200	2010	0.000	\N
99	25001011300	2010	0.000	\N
99	25001011400	2010	0.000	\N
99	25001011500	2010	0.000	\N
99	25001011600	2010	0.000	\N
99	25001011700	2010	0.000	\N
99	25001011801	2010	0.000	\N
99	25001011802	2010	0.000	\N
99	25001012001	2010	0.000	\N
99	25001012002	2010	2.000	\N
99	25001012101	2010	1.000	\N
99	25001012102	2010	1.000	\N
99	25001012200	2010	0.000	\N
99	25001012502	2010	1.000	\N
99	25001012601	2010	1.000	\N
99	25001012602	2010	0.000	\N
99	25001012700	2010	0.000	\N
99	25001012800	2010	0.000	\N
99	25001012900	2010	0.000	\N
99	25001013002	2010	0.000	\N
99	25001013100	2010	0.000	\N
99	25001013200	2010	0.000	\N
99	25001013300	2010	0.000	\N
99	25001013400	2010	0.000	\N
99	25001013500	2010	1.000	\N
99	25001013600	2010	1.000	\N
99	25001013700	2010	0.000	\N
99	25001013800	2010	1.000	\N
99	25001013900	2010	0.000	\N
99	25001014002	2010	0.000	\N
99	25001014100	2010	1.000	\N
99	25001014300	2010	0.000	\N
99	25001014402	2010	0.000	\N
99	25001014500	2010	0.000	\N
99	25001014600	2010	0.000	\N
99	25001014700	2010	0.000	\N
99	25001014800	2010	2.000	\N
99	25001014900	2010	2.000	\N
99	25001015001	2010	2.000	\N
99	25001015002	2010	0.000	\N
99	25001015100	2010	0.000	\N
99	25001015200	2010	1.000	\N
99	25001015300	2010	0.000	\N
99	25001990000	2010	0.000	\N
99	25003900100	2010	0.000	\N
99	25003900200	2010	0.000	\N
99	25003900300	2010	0.000	\N
99	25003900400	2010	0.000	\N
99	25003900500	2010	0.000	\N
99	25003900600	2010	0.000	\N
99	25003900700	2010	0.000	\N
99	25003900800	2010	0.000	\N
99	25003900900	2010	0.000	\N
99	25003901100	2010	0.000	\N
99	25003911100	2010	0.000	\N
99	25003912100	2010	0.000	\N
99	25003913100	2010	0.000	\N
99	25003914100	2010	0.000	\N
99	25003920101	2010	0.000	\N
99	25003920102	2010	2.000	\N
99	25003921300	2010	1.000	\N
99	25003921400	2010	0.000	\N
99	25003921500	2010	2.000	\N
99	25003922100	2010	1.000	\N
99	25003922200	2010	0.000	\N
99	25003922300	2010	1.000	\N
99	25003923100	2010	0.000	\N
99	25003924100	2010	0.000	\N
99	25003925100	2010	0.000	\N
99	25003926100	2010	0.000	\N
99	25003931100	2010	0.000	\N
99	25003931300	2010	1.000	\N
99	25003931400	2010	0.000	\N
99	25003932200	2010	0.000	\N
99	25003932300	2010	0.000	\N
99	25003933200	2010	0.000	\N
99	25003933300	2010	0.000	\N
99	25003933400	2010	0.000	\N
99	25003934200	2010	0.000	\N
99	25003934300	2010	0.000	\N
99	25003935100	2010	1.000	\N
99	25003935200	2010	0.000	\N
99	25003935300	2010	0.000	\N
99	25005600100	2010	0.000	\N
99	25005600202	2010	0.000	\N
99	25005600203	2010	1.000	\N
99	25005600204	2010	0.000	\N
99	25005610100	2010	0.000	\N
99	25005610202	2010	0.000	\N
99	25005610203	2010	2.000	\N
99	25005610204	2010	0.000	\N
99	25005611101	2010	5.000	\N
99	25005611102	2010	1.000	\N
99	25005611201	2010	0.000	\N
99	25005611202	2010	0.000	\N
99	25005612100	2010	6.000	\N
99	25005612200	2010	2.000	\N
99	25005613100	2010	0.000	\N
99	25005613300	2010	3.000	\N
99	25005613400	2010	0.000	\N
99	25005613600	2010	0.000	\N
99	25005613700	2010	1.000	\N
99	25005613800	2010	5.000	\N
99	25005613901	2010	0.000	\N
99	25005613902	2010	1.000	\N
99	25005614000	2010	2.000	\N
99	25005614101	2010	2.000	\N
99	25005614102	2010	0.000	\N
99	25005615100	2010	2.000	\N
99	25005616100	2010	2.000	\N
99	25005617101	2010	0.000	\N
99	25005617102	2010	0.000	\N
99	25005630101	2010	1.000	\N
99	25005630102	2010	0.000	\N
99	25005630200	2010	2.000	\N
99	25005630300	2010	2.000	\N
99	25005630400	2010	2.000	\N
99	25005631100	2010	0.000	\N
99	25005631200	2010	0.000	\N
99	25005631300	2010	2.000	\N
99	25005631400	2010	0.000	\N
99	25005631500	2010	2.000	\N
99	25005631600	2010	1.000	\N
99	25005631700	2010	0.000	\N
99	25005631800	2010	0.000	\N
99	25005632100	2010	0.000	\N
99	25005632200	2010	0.000	\N
99	25005633100	2010	2.000	\N
99	25005633200	2010	0.000	\N
99	25005640100	2010	3.000	\N
99	25005640200	2010	0.000	\N
99	25005640300	2010	0.000	\N
99	25005640400	2010	0.000	\N
99	25005640500	2010	3.000	\N
99	25005640600	2010	4.000	\N
99	25005640700	2010	0.000	\N
99	25005640800	2010	5.000	\N
99	25005640901	2010	1.000	\N
99	25005641000	2010	0.000	\N
99	25005641101	2010	0.000	\N
99	25005641200	2010	0.000	\N
99	25005641300	2010	2.000	\N
99	25005641400	2010	3.000	\N
99	25005641500	2010	1.000	\N
99	25005641600	2010	0.000	\N
99	25005641700	2010	2.000	\N
99	25005641800	2010	0.000	\N
99	25005641900	2010	1.000	\N
99	25005642000	2010	0.000	\N
99	25005642100	2010	0.000	\N
99	25005642200	2010	0.000	\N
99	25005642300	2010	0.000	\N
99	25005642400	2010	1.000	\N
99	25005642500	2010	0.000	\N
99	25005644101	2010	0.000	\N
99	25005644102	2010	0.000	\N
99	25005644200	2010	0.000	\N
99	25005645101	2010	0.000	\N
99	25005645102	2010	1.000	\N
99	25005645103	2010	0.000	\N
99	25005646101	2010	0.000	\N
99	25005646103	2010	0.000	\N
99	25005646104	2010	0.000	\N
99	25005650101	2010	0.000	\N
99	25005650102	2010	1.000	\N
99	25005650201	2010	0.000	\N
99	25005650202	2010	0.000	\N
99	25005650300	2010	0.000	\N
99	25005650400	2010	0.000	\N
99	25005650500	2010	1.000	\N
99	25005650600	2010	0.000	\N
99	25005650700	2010	2.000	\N
99	25005650800	2010	0.000	\N
99	25005650900	2010	2.000	\N
99	25005651001	2010	0.000	\N
99	25005651002	2010	1.000	\N
99	25005651100	2010	0.000	\N
99	25005651200	2010	0.000	\N
99	25005651300	2010	0.000	\N
99	25005651400	2010	1.000	\N
99	25005651500	2010	2.000	\N
99	25005651600	2010	0.000	\N
99	25005651700	2010	0.000	\N
99	25005651800	2010	0.000	\N
99	25005651900	2010	0.000	\N
99	25005652000	2010	1.000	\N
99	25005652100	2010	0.000	\N
99	25005652200	2010	0.000	\N
99	25005652300	2010	0.000	\N
99	25005652400	2010	0.000	\N
99	25005652500	2010	1.000	\N
99	25005652600	2010	2.000	\N
99	25005652700	2010	0.000	\N
99	25005652800	2010	0.000	\N
99	25005653101	2010	2.000	\N
99	25005653102	2010	3.000	\N
99	25005653203	2010	0.000	\N
99	25005653204	2010	0.000	\N
99	25005653301	2010	2.000	\N
99	25005653304	2010	0.000	\N
99	25005654100	2010	0.000	\N
99	25005654200	2010	0.000	\N
99	25005655100	2010	0.000	\N
99	25005655200	2010	1.000	\N
99	25005655300	2010	0.000	\N
99	25005655400	2010	1.000	\N
99	25005985500	2010	2.000	\N
99	25005985600	2010	1.000	\N
99	25005990000	2010	0.000	\N
99	25007200100	2010	1.000	\N
99	25007200200	2010	0.000	\N
99	25007200300	2010	4.000	\N
99	25007200400	2010	0.000	\N
99	25007990000	2010	0.000	\N
99	25009201100	2010	0.000	\N
99	25009202101	2010	0.000	\N
99	25009202102	2010	0.000	\N
99	25009202200	2010	1.000	\N
99	25009203100	2010	1.000	\N
99	25009203200	2010	3.000	\N
99	25009203301	2010	0.000	\N
99	25009203302	2010	0.000	\N
99	25009204101	2010	2.000	\N
99	25009204102	2010	1.000	\N
99	25009204200	2010	2.000	\N
99	25009204300	2010	1.000	\N
99	25009204400	2010	0.000	\N
99	25009204500	2010	3.000	\N
99	25009204600	2010	3.000	\N
99	25009204701	2010	0.000	\N
99	25009204702	2010	0.000	\N
99	25009205100	2010	4.000	\N
99	25009205200	2010	9.000	\N
99	25009205300	2010	0.000	\N
99	25009205400	2010	1.000	\N
99	25009205500	2010	4.000	\N
99	25009205600	2010	4.000	\N
99	25009205700	2010	2.000	\N
99	25009205800	2010	5.000	\N
99	25009205900	2010	3.000	\N
99	25009206000	2010	2.000	\N
99	25009206100	2010	0.000	\N
99	25009206200	2010	5.000	\N
99	25009206300	2010	3.000	\N
99	25009206400	2010	6.000	\N
99	25009206500	2010	6.000	\N
99	25009206600	2010	5.000	\N
99	25009206700	2010	2.000	\N
99	25009206800	2010	4.000	\N
99	25009206900	2010	5.000	\N
99	25009207000	2010	0.000	\N
99	25009207100	2010	8.000	\N
99	25009207200	2010	4.000	\N
99	25009208101	2010	2.000	\N
99	25009208102	2010	0.000	\N
99	25009208200	2010	0.000	\N
99	25009208300	2010	0.000	\N
99	25009208400	2010	2.000	\N
99	25009209100	2010	0.000	\N
99	25009209200	2010	0.000	\N
99	25009210100	2010	0.000	\N
99	25009210200	2010	2.000	\N
99	25009210300	2010	10.000	\N
99	25009210400	2010	2.000	\N
99	25009210500	2010	1.000	\N
99	25009210600	2010	1.000	\N
99	25009210700	2010	0.000	\N
99	25009210800	2010	0.000	\N
99	25009210900	2010	0.000	\N
99	25009211100	2010	1.000	\N
99	25009211200	2010	1.000	\N
99	25009211300	2010	0.000	\N
99	25009211401	2010	0.000	\N
99	25009211402	2010	0.000	\N
99	25009212100	2010	2.000	\N
99	25009213100	2010	0.000	\N
99	25009214100	2010	2.000	\N
99	25009215101	2010	0.000	\N
99	25009215102	2010	3.000	\N
99	25009216100	2010	0.000	\N
99	25009217100	2010	2.000	\N
99	25009217201	2010	1.000	\N
99	25009217202	2010	1.000	\N
99	25009217300	2010	1.000	\N
99	25009217400	2010	1.000	\N
99	25009217500	2010	3.000	\N
99	25009217600	2010	0.000	\N
99	25009218100	2010	3.000	\N
99	25009220101	2010	0.000	\N
99	25009220102	2010	0.000	\N
99	25009221100	2010	0.000	\N
99	25009221300	2010	1.000	\N
99	25009221400	2010	0.000	\N
99	25009221500	2010	0.000	\N
99	25009221600	2010	0.000	\N
99	25009221700	2010	1.000	\N
99	25009221800	2010	0.000	\N
99	25009221901	2010	0.000	\N
99	25009221902	2010	0.000	\N
99	25009222100	2010	1.000	\N
99	25009223100	2010	0.000	\N
99	25009223200	2010	0.000	\N
99	25009223300	2010	0.000	\N
99	25009250100	2010	3.000	\N
99	25009250200	2010	5.000	\N
99	25009250300	2010	1.000	\N
99	25009250400	2010	13.000	\N
99	25009250500	2010	12.000	\N
99	25009250600	2010	9.000	\N
99	25009250700	2010	5.000	\N
99	25009250800	2010	12.000	\N
99	25009250900	2010	1.000	\N
99	25009251000	2010	4.000	\N
99	25009251100	2010	8.000	\N
99	25009251200	2010	1.000	\N
99	25009251300	2010	15.000	\N
99	25009251400	2010	16.000	\N
99	25009251500	2010	5.000	\N
99	25009251600	2010	13.000	\N
99	25009251700	2010	8.000	\N
99	25009251800	2010	8.000	\N
99	25009252101	2010	0.000	\N
99	25009252102	2010	1.000	\N
99	25009252201	2010	4.000	\N
99	25009252202	2010	2.000	\N
99	25009252300	2010	2.000	\N
99	25009252400	2010	6.000	\N
99	25009252501	2010	5.000	\N
99	25009252502	2010	0.000	\N
99	25009252601	2010	6.000	\N
99	25009252602	2010	0.000	\N
99	25009252603	2010	0.000	\N
99	25009253100	2010	0.000	\N
99	25009253201	2010	0.000	\N
99	25009253202	2010	2.000	\N
99	25009253203	2010	0.000	\N
99	25009253204	2010	1.000	\N
99	25009253205	2010	1.000	\N
99	25009254100	2010	2.000	\N
99	25009254200	2010	6.000	\N
99	25009254301	2010	0.000	\N
99	25009254302	2010	4.000	\N
99	25009254401	2010	3.000	\N
99	25009254402	2010	5.000	\N
99	25009254403	2010	3.000	\N
99	25009260100	2010	6.000	\N
99	25009260200	2010	0.000	\N
99	25009260301	2010	1.000	\N
99	25009260302	2010	0.000	\N
99	25009260401	2010	0.000	\N
99	25009260402	2010	0.000	\N
99	25009260500	2010	1.000	\N
99	25009260600	2010	0.000	\N
99	25009260700	2010	0.000	\N
99	25009260800	2010	0.000	\N
99	25009260900	2010	5.000	\N
99	25009261000	2010	1.000	\N
99	25009261101	2010	2.000	\N
99	25009261102	2010	1.000	\N
99	25009262100	2010	0.000	\N
99	25009263100	2010	0.000	\N
99	25009264100	2010	0.000	\N
99	25009265101	2010	0.000	\N
99	25009265102	2010	1.000	\N
99	25009266100	2010	0.000	\N
99	25009266200	2010	0.000	\N
99	25009266300	2010	0.000	\N
99	25009266400	2010	0.000	\N
99	25009267101	2010	0.000	\N
99	25009267102	2010	1.000	\N
99	25009268100	2010	0.000	\N
99	25009268200	2010	1.000	\N
99	25009268300	2010	0.000	\N
99	25009268400	2010	0.000	\N
99	25009269100	2010	1.000	\N
99	25009270100	2010	0.000	\N
99	25009990100	2010	0.000	\N
99	25011040100	2010	0.000	\N
99	25011040200	2010	0.000	\N
99	25011040300	2010	1.000	\N
99	25011040400	2010	0.000	\N
99	25011040501	2010	0.000	\N
99	25011040502	2010	0.000	\N
99	25011040600	2010	1.000	\N
99	25011040701	2010	0.000	\N
99	25011040702	2010	0.000	\N
99	25011040800	2010	0.000	\N
99	25011040900	2010	2.000	\N
99	25011041000	2010	2.000	\N
99	25011041100	2010	0.000	\N
99	25011041200	2010	0.000	\N
99	25011041300	2010	1.000	\N
99	25011041400	2010	0.000	\N
99	25011041501	2010	0.000	\N
99	25011041502	2010	1.000	\N
99	25013800101	2010	2.000	\N
99	25013800102	2010	2.000	\N
99	25013800201	2010	2.000	\N
99	25013800202	2010	1.000	\N
99	25013800300	2010	4.000	\N
99	25013800400	2010	4.000	\N
99	25013800500	2010	5.000	\N
99	25013800600	2010	4.000	\N
99	25013800700	2010	0.000	\N
99	25013800800	2010	2.000	\N
99	25013800900	2010	2.000	\N
99	25013801101	2010	1.000	\N
99	25013801102	2010	1.000	\N
99	25013801200	2010	0.000	\N
99	25013801300	2010	6.000	\N
99	25013801401	2010	5.000	\N
99	25013801402	2010	1.000	\N
99	25013801501	2010	11.000	\N
99	25013801502	2010	3.000	\N
99	25013801503	2010	0.000	\N
99	25013801601	2010	0.000	\N
99	25013801602	2010	11.000	\N
99	25013801603	2010	3.000	\N
99	25013801604	2010	1.000	\N
99	25013801605	2010	0.000	\N
99	25013801700	2010	1.000	\N
99	25013801800	2010	10.000	\N
99	25013801901	2010	4.000	\N
99	25013801902	2010	4.000	\N
99	25013802000	2010	2.000	\N
99	25013802100	2010	1.000	\N
99	25013802200	2010	1.000	\N
99	25013802300	2010	1.000	\N
99	25013802400	2010	4.000	\N
99	25013802500	2010	3.000	\N
99	25013802601	2010	11.000	\N
99	25013802602	2010	0.000	\N
99	25013810100	2010	0.000	\N
99	25013810200	2010	0.000	\N
99	25013810300	2010	0.000	\N
99	25013810403	2010	0.000	\N
99	25013810404	2010	0.000	\N
99	25013810412	2010	0.000	\N
99	25013810414	2010	1.000	\N
99	25013810601	2010	0.000	\N
99	25013810602	2010	0.000	\N
99	25013810700	2010	0.000	\N
99	25013810800	2010	0.000	\N
99	25013810901	2010	0.000	\N
99	25013810902	2010	0.000	\N
99	25013811000	2010	0.000	\N
99	25013811101	2010	4.000	\N
99	25013811102	2010	4.000	\N
99	25013811200	2010	0.000	\N
99	25013811301	2010	1.000	\N
99	25013811302	2010	6.000	\N
99	25013811400	2010	1.000	\N
99	25013811500	2010	0.000	\N
99	25013811600	2010	5.000	\N
99	25013811700	2010	3.000	\N
99	25013811800	2010	1.000	\N
99	25013811900	2010	0.000	\N
99	25013812001	2010	5.000	\N
99	25013812002	2010	6.000	\N
99	25013812101	2010	3.000	\N
99	25013812103	2010	2.000	\N
99	25013812104	2010	0.000	\N
99	25013812201	2010	2.000	\N
99	25013812202	2010	0.000	\N
99	25013812300	2010	4.000	\N
99	25013812401	2010	2.000	\N
99	25013812403	2010	0.000	\N
99	25013812404	2010	0.000	\N
99	25013812500	2010	2.000	\N
99	25013812600	2010	1.000	\N
99	25013812701	2010	1.000	\N
99	25013812702	2010	0.000	\N
99	25013812800	2010	0.000	\N
99	25013812901	2010	0.000	\N
99	25013812902	2010	2.000	\N
99	25013812903	2010	2.000	\N
99	25013813000	2010	0.000	\N
99	25013813101	2010	0.000	\N
99	25013813102	2010	0.000	\N
99	25013813204	2010	0.000	\N
99	25013813205	2010	0.000	\N
99	25013813206	2010	1.000	\N
99	25013813207	2010	3.000	\N
99	25013813208	2010	1.000	\N
99	25013813209	2010	1.000	\N
99	25013813301	2010	2.000	\N
99	25013813303	2010	0.000	\N
99	25013813304	2010	0.000	\N
99	25013813401	2010	0.000	\N
99	25013813403	2010	0.000	\N
99	25013813404	2010	1.000	\N
99	25013813500	2010	0.000	\N
99	25013813601	2010	0.000	\N
99	25013813602	2010	1.000	\N
99	25013813701	2010	0.000	\N
99	25013813702	2010	0.000	\N
99	25013813801	2010	0.000	\N
99	25013813802	2010	0.000	\N
99	25015820101	2010	3.000	\N
99	25015820102	2010	0.000	\N
99	25015820202	2010	0.000	\N
99	25015820203	2010	1.000	\N
99	25015820204	2010	0.000	\N
99	25015820300	2010	1.000	\N
99	25015820400	2010	8.000	\N
99	25015820500	2010	2.000	\N
99	25015820600	2010	2.000	\N
99	25015820700	2010	9.000	\N
99	25015820801	2010	8.000	\N
99	25015820802	2010	1.000	\N
99	25015820900	2010	1.000	\N
99	25015821000	2010	0.000	\N
99	25015821100	2010	2.000	\N
99	25015821200	2010	2.000	\N
99	25015821300	2010	1.000	\N
99	25015821400	2010	3.000	\N
99	25015821500	2010	1.000	\N
99	25015821601	2010	6.000	\N
99	25015821602	2010	1.000	\N
99	25015821700	2010	0.000	\N
99	25015821901	2010	0.000	\N
99	25015821903	2010	2.000	\N
99	25015821904	2010	0.000	\N
99	25015822000	2010	2.000	\N
99	25015822200	2010	3.000	\N
99	25015822300	2010	0.000	\N
99	25015822401	2010	1.000	\N
99	25015822402	2010	1.000	\N
99	25015822500	2010	1.000	\N
99	25015822601	2010	0.000	\N
99	25015822603	2010	0.000	\N
99	25015822605	2010	0.000	\N
99	25015822606	2010	0.000	\N
99	25015822700	2010	0.000	\N
99	25017300100	2010	0.000	\N
99	25017301101	2010	1.000	\N
99	25017301102	2010	0.000	\N
99	25017310100	2010	9.000	\N
99	25017310200	2010	4.000	\N
99	25017310300	2010	6.000	\N
99	25017310400	2010	15.000	\N
99	25017310500	2010	2.000	\N
99	25017310601	2010	1.000	\N
99	25017310602	2010	7.000	\N
99	25017310700	2010	5.000	\N
99	25017311100	2010	3.000	\N
99	25017311200	2010	21.000	\N
99	25017311300	2010	4.000	\N
99	25017311400	2010	5.000	\N
99	25017311500	2010	7.000	\N
99	25017311600	2010	4.000	\N
99	25017311700	2010	15.000	\N
99	25017311800	2010	6.000	\N
99	25017311900	2010	6.000	\N
99	25017312000	2010	8.000	\N
99	25017312100	2010	7.000	\N
99	25017312200	2010	13.000	\N
99	25017312300	2010	4.000	\N
99	25017312400	2010	8.000	\N
99	25017312501	2010	6.000	\N
99	25017312502	2010	1.000	\N
99	25017313101	2010	2.000	\N
99	25017313102	2010	2.000	\N
99	25017314101	2010	3.000	\N
99	25017314102	2010	4.000	\N
99	25017314200	2010	1.000	\N
99	25017314301	2010	0.000	\N
99	25017314302	2010	2.000	\N
99	25017315100	2010	0.000	\N
99	25017315200	2010	0.000	\N
99	25017315401	2010	1.000	\N
99	25017315402	2010	0.000	\N
99	25017315403	2010	0.000	\N
99	25017315500	2010	0.000	\N
99	25017316101	2010	0.000	\N
99	25017316102	2010	0.000	\N
99	25017316201	2010	0.000	\N
99	25017316202	2010	0.000	\N
99	25017316300	2010	1.000	\N
99	25017316400	2010	3.000	\N
99	25017316500	2010	4.000	\N
99	25017317101	2010	1.000	\N
99	25017317102	2010	0.000	\N
99	25017317103	2010	0.000	\N
99	25017317201	2010	0.000	\N
99	25017317202	2010	0.000	\N
99	25017317203	2010	0.000	\N
99	25017317301	2010	1.000	\N
99	25017317302	2010	7.000	\N
99	25017318100	2010	0.000	\N
99	25017318200	2010	0.000	\N
99	25017318300	2010	0.000	\N
99	25017318400	2010	1.000	\N
99	25017320102	2010	0.000	\N
99	25017320103	2010	0.000	\N
99	25017320104	2010	1.000	\N
99	25017321100	2010	1.000	\N
99	25017321200	2010	0.000	\N
99	25017321300	2010	2.000	\N
99	25017321400	2010	0.000	\N
99	25017321500	2010	1.000	\N
99	25017321600	2010	2.000	\N
99	25017322100	2010	1.000	\N
99	25017322200	2010	2.000	\N
99	25017322300	2010	2.000	\N
99	25017322400	2010	0.000	\N
99	25017323100	2010	5.000	\N
99	25017324101	2010	2.000	\N
99	25017324102	2010	0.000	\N
99	25017325100	2010	4.000	\N
99	25017326101	2010	0.000	\N
99	25017326102	2010	1.000	\N
99	25017327101	2010	1.000	\N
99	25017327102	2010	0.000	\N
99	25017327103	2010	0.000	\N
99	25017328100	2010	1.000	\N
99	25017330100	2010	0.000	\N
99	25017330200	2010	0.000	\N
99	25017331101	2010	0.000	\N
99	25017331102	2010	0.000	\N
99	25017331200	2010	0.000	\N
99	25017331300	2010	0.000	\N
99	25017332100	2010	0.000	\N
99	25017332200	2010	5.000	\N
99	25017332300	2010	0.000	\N
99	25017332400	2010	0.000	\N
99	25017333100	2010	1.000	\N
99	25017333200	2010	0.000	\N
99	25017333300	2010	1.000	\N
99	25017333400	2010	1.000	\N
99	25017333501	2010	0.000	\N
99	25017333502	2010	1.000	\N
99	25017333600	2010	1.000	\N
99	25017334100	2010	1.000	\N
99	25017334200	2010	0.000	\N
99	25017334300	2010	1.000	\N
99	25017334400	2010	0.000	\N
99	25017335100	2010	0.000	\N
99	25017335200	2010	0.000	\N
99	25017335301	2010	1.000	\N
99	25017335302	2010	0.000	\N
99	25017335400	2010	0.000	\N
99	25017336100	2010	1.000	\N
99	25017336200	2010	0.000	\N
99	25017336300	2010	0.000	\N
99	25017336401	2010	1.000	\N
99	25017336402	2010	0.000	\N
99	25017337101	2010	0.000	\N
99	25017337102	2010	0.000	\N
99	25017337201	2010	0.000	\N
99	25017337202	2010	2.000	\N
99	25017337300	2010	2.000	\N
99	25017338100	2010	1.000	\N
99	25017338200	2010	2.000	\N
99	25017338300	2010	0.000	\N
99	25017338400	2010	1.000	\N
99	25017338500	2010	2.000	\N
99	25017339100	2010	1.000	\N
99	25017339200	2010	0.000	\N
99	25017339300	2010	0.000	\N
99	25017339400	2010	0.000	\N
99	25017339500	2010	1.000	\N
99	25017339600	2010	3.000	\N
99	25017339700	2010	1.000	\N
99	25017339801	2010	1.000	\N
99	25017339802	2010	0.000	\N
99	25017339900	2010	0.000	\N
99	25017340000	2010	0.000	\N
99	25017340100	2010	2.000	\N
99	25017341101	2010	3.000	\N
99	25017341102	2010	11.000	\N
99	25017341200	2010	19.000	\N
99	25017341300	2010	0.000	\N
99	25017341400	2010	10.000	\N
99	25017341500	2010	7.000	\N
99	25017341600	2010	0.000	\N
99	25017341700	2010	1.000	\N
99	25017341800	2010	13.000	\N
99	25017341901	2010	1.000	\N
99	25017341902	2010	8.000	\N
99	25017342101	2010	7.000	\N
99	25017342102	2010	0.000	\N
99	25017342201	2010	3.000	\N
99	25017342202	2010	1.000	\N
99	25017342300	2010	1.000	\N
99	25017342400	2010	3.000	\N
99	25017342500	2010	5.000	\N
99	25017342600	2010	3.000	\N
99	25017350103	2010	0.000	\N
99	25017350104	2010	4.000	\N
99	25017350200	2010	1.000	\N
99	25017350300	2010	1.000	\N
99	25017350400	2010	2.000	\N
99	25017350500	2010	0.000	\N
99	25017350600	2010	4.000	\N
99	25017350700	2010	0.000	\N
99	25017350800	2010	0.000	\N
99	25017350900	2010	1.000	\N
99	25017351000	2010	3.000	\N
99	25017351100	2010	4.000	\N
99	25017351203	2010	1.000	\N
99	25017351204	2010	0.000	\N
99	25017351300	2010	1.000	\N
99	25017351403	2010	3.000	\N
99	25017351404	2010	1.000	\N
99	25017351500	2010	2.000	\N
99	25017352101	2010	1.000	\N
99	25017352102	2010	3.000	\N
99	25017352200	2010	0.000	\N
99	25017352300	2010	1.000	\N
99	25017352400	2010	1.000	\N
99	25017352500	2010	2.000	\N
99	25017352600	2010	0.000	\N
99	25017352700	2010	3.000	\N
99	25017352800	2010	0.000	\N
99	25017352900	2010	0.000	\N
99	25017353000	2010	1.000	\N
99	25017353101	2010	3.000	\N
99	25017353102	2010	8.000	\N
99	25017353200	2010	1.000	\N
99	25017353300	2010	2.000	\N
99	25017353400	2010	1.000	\N
99	25017353500	2010	1.000	\N
99	25017353600	2010	1.000	\N
99	25017353700	2010	4.000	\N
99	25017353800	2010	3.000	\N
99	25017353900	2010	3.000	\N
99	25017354000	2010	5.000	\N
99	25017354100	2010	2.000	\N
99	25017354200	2010	0.000	\N
99	25017354300	2010	0.000	\N
99	25017354400	2010	0.000	\N
99	25017354500	2010	2.000	\N
99	25017354600	2010	1.000	\N
99	25017354700	2010	1.000	\N
99	25017354800	2010	2.000	\N
99	25017354900	2010	5.000	\N
99	25017355000	2010	4.000	\N
99	25017356100	2010	1.000	\N
99	25017356300	2010	1.000	\N
99	25017356400	2010	0.000	\N
99	25017356500	2010	3.000	\N
99	25017356601	2010	0.000	\N
99	25017356602	2010	1.000	\N
99	25017356701	2010	1.000	\N
99	25017356702	2010	2.000	\N
99	25017357100	2010	2.000	\N
99	25017357200	2010	0.000	\N
99	25017357300	2010	3.000	\N
99	25017357400	2010	0.000	\N
99	25017357500	2010	1.000	\N
99	25017357600	2010	3.000	\N
99	25017357700	2010	0.000	\N
99	25017357800	2010	2.000	\N
99	25017358100	2010	0.000	\N
99	25017358300	2010	0.000	\N
99	25017358400	2010	0.000	\N
99	25017358500	2010	0.000	\N
99	25017358600	2010	1.000	\N
99	25017358700	2010	0.000	\N
99	25017359100	2010	0.000	\N
99	25017359300	2010	0.000	\N
99	25017360100	2010	3.000	\N
99	25017360200	2010	1.000	\N
99	25017361100	2010	0.000	\N
99	25017361200	2010	0.000	\N
99	25017361300	2010	1.000	\N
99	25017362100	2010	1.000	\N
99	25017363102	2010	1.000	\N
99	25017363103	2010	0.000	\N
99	25017363104	2010	2.000	\N
99	25017363201	2010	0.000	\N
99	25017363202	2010	2.000	\N
99	25017364101	2010	0.000	\N
99	25017364102	2010	1.000	\N
99	25017365100	2010	1.000	\N
99	25017365201	2010	0.000	\N
99	25017365202	2010	0.000	\N
99	25017366100	2010	0.000	\N
99	25017366201	2010	1.000	\N
99	25017366202	2010	1.000	\N
99	25017367100	2010	0.000	\N
99	25017367200	2010	0.000	\N
99	25017368101	2010	3.000	\N
99	25017368102	2010	0.000	\N
99	25017368200	2010	1.000	\N
99	25017368300	2010	5.000	\N
99	25017368400	2010	6.000	\N
99	25017368500	2010	0.000	\N
99	25017368600	2010	3.000	\N
99	25017368700	2010	1.000	\N
99	25017368800	2010	3.000	\N
99	25017368901	2010	3.000	\N
99	25017368902	2010	1.000	\N
99	25017369000	2010	0.000	\N
99	25017369100	2010	0.000	\N
99	25017370101	2010	8.000	\N
99	25017370102	2010	3.000	\N
99	25017370201	2010	0.000	\N
99	25017370202	2010	0.000	\N
99	25017370300	2010	1.000	\N
99	25017370400	2010	6.000	\N
99	25017373100	2010	0.000	\N
99	25017373200	2010	2.000	\N
99	25017373300	2010	5.000	\N
99	25017373400	2010	2.000	\N
99	25017373500	2010	1.000	\N
99	25017373600	2010	7.000	\N
99	25017373700	2010	0.000	\N
99	25017373800	2010	0.000	\N
99	25017373900	2010	4.000	\N
99	25017374000	2010	2.000	\N
99	25017374100	2010	3.000	\N
99	25017374200	2010	1.000	\N
99	25017374300	2010	0.000	\N
99	25017374400	2010	3.000	\N
99	25017374500	2010	0.000	\N
99	25017374600	2010	1.000	\N
99	25017374700	2010	0.000	\N
99	25017374800	2010	0.000	\N
99	25017382100	2010	0.000	\N
99	25017382200	2010	0.000	\N
99	25017382300	2010	6.000	\N
99	25017382400	2010	0.000	\N
99	25017382500	2010	4.000	\N
99	25017382601	2010	1.000	\N
99	25017382602	2010	0.000	\N
99	25017383101	2010	7.000	\N
99	25017383102	2010	4.000	\N
99	25017383200	2010	2.000	\N
99	25017383300	2010	4.000	\N
99	25017383400	2010	2.000	\N
99	25017383501	2010	1.000	\N
99	25017383502	2010	2.000	\N
99	25017383600	2010	3.000	\N
99	25017383700	2010	0.000	\N
99	25017383800	2010	2.000	\N
99	25017383901	2010	1.000	\N
99	25017383902	2010	3.000	\N
99	25017384001	2010	0.000	\N
99	25017384002	2010	0.000	\N
99	25017385100	2010	1.000	\N
99	25017385201	2010	0.000	\N
99	25017385202	2010	1.000	\N
99	25017386100	2010	0.000	\N
99	25017387100	2010	0.000	\N
99	25017387201	2010	1.000	\N
99	25017387202	2010	5.000	\N
99	25017388100	2010	1.000	\N
99	25017388200	2010	1.000	\N
99	25017388300	2010	9.000	\N
99	25017980000	2010	0.000	\N
99	25019950100	2010	0.000	\N
99	25019950200	2010	0.000	\N
99	25019950307	2010	0.000	\N
99	25019950400	2010	0.000	\N
99	25019950500	2010	0.000	\N
99	25019990000	2010	0.000	\N
99	25021400100	2010	2.000	\N
99	25021400200	2010	4.000	\N
99	25021400300	2010	2.000	\N
99	25021400400	2010	3.000	\N
99	25021400500	2010	0.000	\N
99	25021400600	2010	5.000	\N
99	25021400700	2010	0.000	\N
99	25021400800	2010	2.000	\N
99	25021400900	2010	4.000	\N
99	25021401000	2010	1.000	\N
99	25021401100	2010	1.000	\N
99	25021401200	2010	2.000	\N
99	25021402101	2010	6.000	\N
99	25021402102	2010	0.000	\N
99	25021402200	2010	0.000	\N
99	25021402300	2010	2.000	\N
99	25021402400	2010	0.000	\N
99	25021402500	2010	0.000	\N
99	25021403100	2010	1.000	\N
99	25021403300	2010	1.000	\N
99	25021403400	2010	2.000	\N
99	25021403500	2010	2.000	\N
99	25021404100	2010	2.000	\N
99	25021404201	2010	0.000	\N
99	25021404202	2010	3.000	\N
99	25021404301	2010	0.000	\N
99	25021404302	2010	0.000	\N
99	25021404400	2010	9.000	\N
99	25021405100	2010	3.000	\N
99	25021406101	2010	0.000	\N
99	25021406102	2010	0.000	\N
99	25021407100	2010	0.000	\N
99	25021408101	2010	0.000	\N
99	25021408102	2010	3.000	\N
99	25021409101	2010	5.000	\N
99	25021409102	2010	0.000	\N
99	25021410100	2010	0.000	\N
99	25021410300	2010	0.000	\N
99	25021410400	2010	0.000	\N
99	25021411100	2010	1.000	\N
99	25021411200	2010	1.000	\N
99	25021411301	2010	0.000	\N
99	25021411302	2010	0.000	\N
99	25021412100	2010	0.000	\N
99	25021412200	2010	0.000	\N
99	25021412300	2010	1.000	\N
99	25021413100	2010	2.000	\N
99	25021413200	2010	0.000	\N
99	25021413300	2010	0.000	\N
99	25021413401	2010	0.000	\N
99	25021413402	2010	1.000	\N
99	25021413500	2010	0.000	\N
99	25021414100	2010	0.000	\N
99	25021414200	2010	1.000	\N
99	25021414300	2010	1.000	\N
99	25021415101	2010	4.000	\N
99	25021415102	2010	2.000	\N
99	25021415200	2010	1.000	\N
99	25021415300	2010	0.000	\N
99	25021416101	2010	2.000	\N
99	25021416102	2010	2.000	\N
99	25021416200	2010	0.000	\N
99	25021416300	2010	3.000	\N
99	25021416400	2010	0.000	\N
99	25021417100	2010	2.000	\N
99	25021417200	2010	5.000	\N
99	25021417300	2010	0.000	\N
99	25021417400	2010	0.000	\N
99	25021417501	2010	2.000	\N
99	25021417502	2010	1.000	\N
99	25021417601	2010	1.000	\N
99	25021417602	2010	3.000	\N
99	25021417701	2010	2.000	\N
99	25021417702	2010	0.000	\N
99	25021417801	2010	4.000	\N
99	25021417802	2010	3.000	\N
99	25021417901	2010	2.000	\N
99	25021417902	2010	2.000	\N
99	25021418002	2010	4.000	\N
99	25021418003	2010	0.000	\N
99	25021418004	2010	5.000	\N
99	25021418101	2010	3.000	\N
99	25021418102	2010	2.000	\N
99	25021418200	2010	9.000	\N
99	25021419100	2010	3.000	\N
99	25021419200	2010	0.000	\N
99	25021419300	2010	7.000	\N
99	25021419400	2010	0.000	\N
99	25021419500	2010	1.000	\N
99	25021419600	2010	3.000	\N
99	25021419700	2010	0.000	\N
99	25021419800	2010	0.000	\N
99	25021420100	2010	1.000	\N
99	25021420201	2010	1.000	\N
99	25021420202	2010	2.000	\N
99	25021420301	2010	2.000	\N
99	25021420302	2010	3.000	\N
99	25021421100	2010	2.000	\N
99	25021421200	2010	2.000	\N
99	25021422100	2010	2.000	\N
99	25021422200	2010	0.000	\N
99	25021422301	2010	0.000	\N
99	25021422302	2010	2.000	\N
99	25021422400	2010	0.000	\N
99	25021422501	2010	0.000	\N
99	25021422502	2010	0.000	\N
99	25021422600	2010	0.000	\N
99	25021422700	2010	0.000	\N
99	25021422800	2010	0.000	\N
99	25021423100	2010	4.000	\N
99	25021440100	2010	1.000	\N
99	25021441202	2010	0.000	\N
99	25021441203	2010	0.000	\N
99	25021441204	2010	0.000	\N
99	25021442101	2010	0.000	\N
99	25021442102	2010	0.000	\N
99	25021442103	2010	0.000	\N
99	25021442201	2010	1.000	\N
99	25021442202	2010	0.000	\N
99	25021443101	2010	1.000	\N
99	25021443102	2010	2.000	\N
99	25021456101	2010	0.000	\N
99	25021456102	2010	0.000	\N
99	25021456200	2010	0.000	\N
99	25021456301	2010	0.000	\N
99	25021456302	2010	1.000	\N
99	25021456401	2010	0.000	\N
99	25021456402	2010	0.000	\N
99	25021457100	2010	0.000	\N
99	25021457200	2010	0.000	\N
99	25023500101	2010	1.000	\N
99	25023500103	2010	0.000	\N
99	25023500104	2010	1.000	\N
99	25023501101	2010	0.000	\N
99	25023501102	2010	0.000	\N
99	25023501201	2010	0.000	\N
99	25023501202	2010	0.000	\N
99	25023502101	2010	0.000	\N
99	25023502102	2010	0.000	\N
99	25023502200	2010	0.000	\N
99	25023503101	2010	0.000	\N
99	25023503102	2010	1.000	\N
99	25023504101	2010	0.000	\N
99	25023504102	2010	0.000	\N
99	25023505101	2010	2.000	\N
99	25023505102	2010	0.000	\N
99	25023505200	2010	2.000	\N
99	25023506101	2010	0.000	\N
99	25023506102	2010	0.000	\N
99	25023506202	2010	0.000	\N
99	25023506203	2010	0.000	\N
99	25023506204	2010	0.000	\N
99	25023507101	2010	0.000	\N
99	25023507103	2010	0.000	\N
99	25023507104	2010	1.000	\N
99	25023508101	2010	0.000	\N
99	25023508102	2010	1.000	\N
99	25023508200	2010	2.000	\N
99	25023509101	2010	0.000	\N
99	25023509102	2010	0.000	\N
99	25023510100	2010	0.000	\N
99	25023510200	2010	1.000	\N
99	25023510300	2010	0.000	\N
99	25023510400	2010	0.000	\N
99	25023510501	2010	0.000	\N
99	25023510502	2010	0.000	\N
99	25023510503	2010	0.000	\N
99	25023510600	2010	0.000	\N
99	25023510700	2010	0.000	\N
99	25023510800	2010	2.000	\N
99	25023510900	2010	2.000	\N
99	25023511000	2010	2.000	\N
99	25023511100	2010	2.000	\N
99	25023511200	2010	0.000	\N
99	25023511301	2010	0.000	\N
99	25023511302	2010	0.000	\N
99	25023511400	2010	2.000	\N
99	25023511500	2010	0.000	\N
99	25023511600	2010	6.000	\N
99	25023511701	2010	2.000	\N
99	25023511702	2010	1.000	\N
99	25023520100	2010	1.000	\N
99	25023520201	2010	0.000	\N
99	25023520202	2010	1.000	\N
99	25023521101	2010	0.000	\N
99	25023521102	2010	0.000	\N
99	25023521201	2010	0.000	\N
99	25023521202	2010	3.000	\N
99	25023522101	2010	0.000	\N
99	25023522102	2010	0.000	\N
99	25023523100	2010	0.000	\N
99	25023523201	2010	0.000	\N
99	25023523202	2010	0.000	\N
99	25023524101	2010	0.000	\N
99	25023524102	2010	0.000	\N
99	25023525101	2010	0.000	\N
99	25023525104	2010	0.000	\N
99	25023525203	2010	1.000	\N
99	25023525204	2010	0.000	\N
99	25023525300	2010	0.000	\N
99	25023526100	2010	0.000	\N
99	25023530100	2010	0.000	\N
99	25023530200	2010	0.000	\N
99	25023530300	2010	2.000	\N
99	25023530400	2010	0.000	\N
99	25023530500	2010	0.000	\N
99	25023530600	2010	0.000	\N
99	25023530700	2010	0.000	\N
99	25023530801	2010	0.000	\N
99	25023530802	2010	0.000	\N
99	25023530901	2010	0.000	\N
99	25023530902	2010	0.000	\N
99	25023540101	2010	0.000	\N
99	25023540102	2010	0.000	\N
99	25023540103	2010	0.000	\N
99	25023541100	2010	0.000	\N
99	25023542101	2010	0.000	\N
99	25023542102	2010	0.000	\N
99	25023542200	2010	0.000	\N
99	25023542300	2010	2.000	\N
99	25023543100	2010	0.000	\N
99	25023544100	2010	0.000	\N
99	25023544200	2010	0.000	\N
99	25023545100	2010	0.000	\N
99	25023545200	2010	3.000	\N
99	25023545300	2010	0.000	\N
99	25023545400	2010	0.000	\N
99	25023560100	2010	0.000	\N
99	25023561100	2010	0.000	\N
99	25023561200	2010	2.000	\N
99	25023990003	2010	0.000	\N
99	25025000100	2010	1.000	\N
99	25025000201	2010	5.000	\N
99	25025000202	2010	2.000	\N
99	25025000301	2010	3.000	\N
99	25025000302	2010	4.000	\N
99	25025000401	2010	0.000	\N
99	25025000402	2010	1.000	\N
99	25025000502	2010	3.000	\N
99	25025000503	2010	1.000	\N
99	25025000504	2010	4.000	\N
99	25025000601	2010	1.000	\N
99	25025000602	2010	2.000	\N
99	25025000701	2010	2.000	\N
99	25025000703	2010	10.000	\N
99	25025000704	2010	5.000	\N
99	25025000802	2010	7.000	\N
99	25025000803	2010	15.000	\N
99	25025010103	2010	10.000	\N
99	25025010104	2010	7.000	\N
99	25025010203	2010	7.000	\N
99	25025010204	2010	3.000	\N
99	25025010300	2010	7.000	\N
99	25025010403	2010	4.000	\N
99	25025010404	2010	7.000	\N
99	25025010405	2010	2.000	\N
99	25025010408	2010	1.000	\N
99	25025010500	2010	0.000	\N
99	25025010600	2010	1.000	\N
99	25025010701	2010	4.000	\N
99	25025010702	2010	2.000	\N
99	25025010801	2010	0.000	\N
99	25025010802	2010	2.000	\N
99	25025020101	2010	1.000	\N
99	25025020200	2010	3.000	\N
99	25025020301	2010	1.000	\N
99	25025020302	2010	0.000	\N
99	25025020303	2010	2.000	\N
99	25025030100	2010	1.000	\N
99	25025030200	2010	1.000	\N
99	25025030300	2010	0.000	\N
99	25025030400	2010	0.000	\N
99	25025030500	2010	1.000	\N
99	25025040100	2010	0.000	\N
99	25025040200	2010	0.000	\N
99	25025040300	2010	3.000	\N
99	25025040401	2010	1.000	\N
99	25025040600	2010	0.000	\N
99	25025040801	2010	1.000	\N
99	25025050101	2010	6.000	\N
99	25025050200	2010	0.000	\N
99	25025050300	2010	1.000	\N
99	25025050400	2010	4.000	\N
99	25025050500	2010	2.000	\N
99	25025050600	2010	1.000	\N
99	25025050700	2010	2.000	\N
99	25025050901	2010	7.000	\N
99	25025051000	2010	4.000	\N
99	25025051101	2010	5.000	\N
99	25025051200	2010	5.000	\N
99	25025060101	2010	0.000	\N
99	25025060200	2010	1.000	\N
99	25025060301	2010	0.000	\N
99	25025060400	2010	1.000	\N
99	25025060501	2010	0.000	\N
99	25025060600	2010	0.000	\N
99	25025060700	2010	9.000	\N
99	25025060800	2010	0.000	\N
99	25025061000	2010	4.000	\N
99	25025061101	2010	0.000	\N
99	25025061200	2010	2.000	\N
99	25025070101	2010	2.000	\N
99	25025070200	2010	3.000	\N
99	25025070300	2010	1.000	\N
99	25025070402	2010	0.000	\N
99	25025070500	2010	1.000	\N
99	25025070600	2010	0.000	\N
99	25025070700	2010	1.000	\N
99	25025070800	2010	1.000	\N
99	25025070900	2010	0.000	\N
99	25025071101	2010	1.000	\N
99	25025071201	2010	2.000	\N
99	25025080100	2010	0.000	\N
99	25025080300	2010	0.000	\N
99	25025080401	2010	1.000	\N
99	25025080500	2010	2.000	\N
99	25025080601	2010	1.000	\N
99	25025080801	2010	4.000	\N
99	25025080900	2010	0.000	\N
99	25025081001	2010	9.000	\N
99	25025081100	2010	6.000	\N
99	25025081200	2010	2.000	\N
99	25025081300	2010	6.000	\N
99	25025081400	2010	1.000	\N
99	25025081500	2010	0.000	\N
99	25025081700	2010	5.000	\N
99	25025081800	2010	1.000	\N
99	25025081900	2010	0.000	\N
99	25025082000	2010	0.000	\N
99	25025082100	2010	2.000	\N
99	25025090100	2010	2.000	\N
99	25025090200	2010	0.000	\N
99	25025090300	2010	9.000	\N
99	25025090400	2010	4.000	\N
99	25025090600	2010	0.000	\N
99	25025090700	2010	0.000	\N
99	25025090901	2010	0.000	\N
99	25025091001	2010	0.000	\N
99	25025091100	2010	2.000	\N
99	25025091200	2010	2.000	\N
99	25025091300	2010	2.000	\N
99	25025091400	2010	1.000	\N
99	25025091500	2010	1.000	\N
99	25025091600	2010	8.000	\N
99	25025091700	2010	0.000	\N
99	25025091800	2010	1.000	\N
99	25025091900	2010	0.000	\N
99	25025092000	2010	3.000	\N
99	25025092101	2010	19.000	\N
99	25025092200	2010	0.000	\N
99	25025092300	2010	0.000	\N
99	25025092400	2010	4.000	\N
99	25025100100	2010	5.000	\N
99	25025100200	2010	0.000	\N
99	25025100300	2010	0.000	\N
99	25025100400	2010	2.000	\N
99	25025100500	2010	0.000	\N
99	25025100601	2010	5.000	\N
99	25025100603	2010	0.000	\N
99	25025100700	2010	0.000	\N
99	25025100800	2010	8.000	\N
99	25025100900	2010	3.000	\N
99	25025101001	2010	1.000	\N
99	25025101002	2010	1.000	\N
99	25025101101	2010	0.000	\N
99	25025101102	2010	2.000	\N
99	25025110103	2010	5.000	\N
99	25025110201	2010	3.000	\N
99	25025110301	2010	1.000	\N
99	25025110401	2010	1.000	\N
99	25025110403	2010	5.000	\N
99	25025110501	2010	0.000	\N
99	25025110502	2010	2.000	\N
99	25025110601	2010	1.000	\N
99	25025110607	2010	4.000	\N
99	25025120103	2010	0.000	\N
99	25025120104	2010	0.000	\N
99	25025120105	2010	1.000	\N
99	25025120201	2010	3.000	\N
99	25025120301	2010	2.000	\N
99	25025120400	2010	3.000	\N
99	25025120500	2010	0.000	\N
99	25025120600	2010	2.000	\N
99	25025120700	2010	0.000	\N
99	25025130100	2010	0.000	\N
99	25025130200	2010	1.000	\N
99	25025130300	2010	2.000	\N
99	25025130402	2010	0.000	\N
99	25025130404	2010	1.000	\N
99	25025130406	2010	0.000	\N
99	25025140102	2010	3.000	\N
99	25025140105	2010	11.000	\N
99	25025140106	2010	1.000	\N
99	25025140107	2010	2.000	\N
99	25025140201	2010	0.000	\N
99	25025140202	2010	1.000	\N
99	25025140300	2010	0.000	\N
99	25025140400	2010	2.000	\N
99	25025160101	2010	5.000	\N
99	25025160200	2010	1.000	\N
99	25025160300	2010	1.000	\N
99	25025160400	2010	7.000	\N
99	25025160501	2010	9.000	\N
99	25025160502	2010	6.000	\N
99	25025160601	2010	10.000	\N
99	25025160602	2010	3.000	\N
99	25025170100	2010	3.000	\N
99	25025170200	2010	0.000	\N
99	25025170300	2010	11.000	\N
99	25025170400	2010	2.000	\N
99	25025170501	2010	6.000	\N
99	25025170502	2010	0.000	\N
99	25025170601	2010	5.000	\N
99	25025170701	2010	1.000	\N
99	25025170702	2010	3.000	\N
99	25025170800	2010	1.000	\N
99	25025180101	2010	1.000	\N
99	25025180200	2010	0.000	\N
99	25025180301	2010	1.000	\N
99	25025180400	2010	0.000	\N
99	25025180500	2010	1.000	\N
99	25025980101	2010	0.000	\N
99	25025980300	2010	0.000	\N
99	25025980700	2010	0.000	\N
99	25025981000	2010	0.000	\N
99	25025981100	2010	1.000	\N
99	25025981201	2010	0.000	\N
99	25025981202	2010	0.000	\N
99	25025981300	2010	2.000	\N
99	25025981501	2010	0.000	\N
99	25025981502	2010	0.000	\N
99	25025981600	2010	0.000	\N
99	25025981700	2010	0.000	\N
99	25025981800	2010	0.000	\N
99	25025990101	2010	0.000	\N
99	25027700100	2010	0.000	\N
99	25027701100	2010	1.000	\N
99	25027702200	2010	0.000	\N
99	25027703100	2010	0.000	\N
99	25027703200	2010	1.000	\N
99	25027703300	2010	0.000	\N
99	25027704200	2010	0.000	\N
99	25027705100	2010	0.000	\N
99	25027706100	2010	0.000	\N
99	25027707100	2010	0.000	\N
99	25027707200	2010	0.000	\N
99	25027707300	2010	0.000	\N
99	25027707400	2010	2.000	\N
99	25027707500	2010	0.000	\N
99	25027708100	2010	0.000	\N
99	25027709100	2010	3.000	\N
99	25027709201	2010	5.000	\N
99	25027709202	2010	1.000	\N
99	25027709400	2010	11.000	\N
99	25027709501	2010	0.000	\N
99	25027709502	2010	0.000	\N
99	25027709600	2010	0.000	\N
99	25027709701	2010	0.000	\N
99	25027709702	2010	0.000	\N
99	25027710100	2010	1.000	\N
99	25027710200	2010	2.000	\N
99	25027710300	2010	1.000	\N
99	25027710400	2010	0.000	\N
99	25027710500	2010	6.000	\N
99	25027710600	2010	2.000	\N
99	25027710700	2010	0.000	\N
99	25027710800	2010	1.000	\N
99	25027711000	2010	1.000	\N
99	25027711100	2010	0.000	\N
99	25027712101	2010	4.000	\N
99	25027712102	2010	0.000	\N
99	25027713100	2010	0.000	\N
99	25027715100	2010	0.000	\N
99	25027716100	2010	1.000	\N
99	25027716200	2010	1.000	\N
99	25027716300	2010	0.000	\N
99	25027717100	2010	0.000	\N
99	25027718100	2010	0.000	\N
99	25027719100	2010	1.000	\N
99	25027720100	2010	0.000	\N
99	25027721101	2010	0.000	\N
99	25027721102	2010	0.000	\N
99	25027722100	2010	1.000	\N
99	25027723100	2010	0.000	\N
99	25027724100	2010	0.000	\N
99	25027725100	2010	0.000	\N
99	25027726100	2010	0.000	\N
99	25027726200	2010	5.000	\N
99	25027727100	2010	0.000	\N
99	25027728100	2010	0.000	\N
99	25027728200	2010	4.000	\N
99	25027728300	2010	0.000	\N
99	25027728400	2010	0.000	\N
99	25027729100	2010	0.000	\N
99	25027729200	2010	0.000	\N
99	25027730100	2010	1.000	\N
99	25027730200	2010	0.000	\N
99	25027730300	2010	4.000	\N
99	25027730401	2010	0.000	\N
99	25027730402	2010	0.000	\N
99	25027730500	2010	4.000	\N
99	25027730600	2010	6.000	\N
99	25027730700	2010	8.000	\N
99	25027730801	2010	0.000	\N
99	25027730802	2010	0.000	\N
99	25027730901	2010	3.000	\N
99	25027730902	2010	1.000	\N
99	25027731001	2010	3.000	\N
99	25027731002	2010	1.000	\N
99	25027731101	2010	1.000	\N
99	25027731102	2010	0.000	\N
99	25027731202	2010	0.000	\N
99	25027731203	2010	0.000	\N
99	25027731204	2010	1.000	\N
99	25027731300	2010	3.000	\N
99	25027731400	2010	7.000	\N
99	25027731500	2010	6.000	\N
99	25027731600	2010	6.000	\N
99	25027731700	2010	2.000	\N
99	25027731800	2010	4.000	\N
99	25027731900	2010	13.000	\N
99	25027732001	2010	11.000	\N
99	25027732002	2010	0.000	\N
99	25027732201	2010	0.000	\N
99	25027732202	2010	0.000	\N
99	25027732203	2010	0.000	\N
99	25027732301	2010	0.000	\N
99	25027732302	2010	2.000	\N
99	25027732400	2010	3.000	\N
99	25027732500	2010	0.000	\N
99	25027732600	2010	0.000	\N
99	25027732700	2010	8.000	\N
99	25027732801	2010	0.000	\N
99	25027732802	2010	0.000	\N
99	25027732901	2010	2.000	\N
99	25027732902	2010	3.000	\N
99	25027733000	2010	3.000	\N
99	25027733101	2010	0.000	\N
99	25027733102	2010	1.000	\N
99	25027735100	2010	0.000	\N
99	25027735200	2010	0.000	\N
99	25027736100	2010	0.000	\N
99	25027736200	2010	0.000	\N
99	25027736300	2010	0.000	\N
99	25027736400	2010	0.000	\N
99	25027736500	2010	0.000	\N
99	25027737100	2010	0.000	\N
99	25027737200	2010	0.000	\N
99	25027737300	2010	0.000	\N
99	25027738100	2010	0.000	\N
99	25027738201	2010	0.000	\N
99	25027738202	2010	0.000	\N
99	25027739100	2010	0.000	\N
99	25027739200	2010	0.000	\N
99	25027739300	2010	4.000	\N
99	25027739400	2010	0.000	\N
99	25027739500	2010	0.000	\N
99	25027740101	2010	2.000	\N
99	25027740102	2010	3.000	\N
99	25027740200	2010	0.000	\N
99	25027741101	2010	0.000	\N
99	25027741102	2010	2.000	\N
99	25027742300	2010	4.000	\N
99	25027742401	2010	0.000	\N
99	25027742402	2010	3.000	\N
99	25027743100	2010	0.000	\N
99	25027744101	2010	0.000	\N
99	25027744102	2010	1.000	\N
99	25027744200	2010	3.000	\N
99	25027744300	2010	3.000	\N
99	25027744400	2010	0.000	\N
99	25027745100	2010	0.000	\N
99	25027746100	2010	0.000	\N
99	25027747101	2010	0.000	\N
99	25027747102	2010	0.000	\N
99	25027748100	2010	0.000	\N
99	25027749100	2010	0.000	\N
99	25027749200	2010	0.000	\N
99	25027750100	2010	0.000	\N
99	25027750200	2010	0.000	\N
99	25027750300	2010	0.000	\N
99	25027751101	2010	0.000	\N
99	25027751102	2010	0.000	\N
99	25027752100	2010	1.000	\N
99	25027753100	2010	1.000	\N
99	25027753200	2010	0.000	\N
99	25027754100	2010	6.000	\N
99	25027754200	2010	0.000	\N
99	25027754300	2010	0.000	\N
99	25027754400	2010	0.000	\N
99	25027755100	2010	0.000	\N
99	25027755200	2010	2.000	\N
99	25027756101	2010	1.000	\N
99	25027756102	2010	5.000	\N
99	25027757100	2010	5.000	\N
99	25027757200	2010	4.000	\N
99	25027757300	2010	4.000	\N
99	25027757400	2010	1.000	\N
99	25027757500	2010	0.000	\N
99	25027758101	2010	0.000	\N
99	25027758102	2010	0.000	\N
99	25027759100	2010	0.000	\N
99	25027760100	2010	0.000	\N
99	25027761100	2010	1.000	\N
99	25027761200	2010	0.000	\N
99	25027761300	2010	0.000	\N
99	25027761400	2010	0.000	\N
100	25001010100	2010	1.000	\N
100	25001010206	2010	0.000	\N
100	25001010208	2010	0.000	\N
100	25001010304	2010	0.000	\N
100	25001010306	2010	3.000	\N
100	25001010400	2010	0.000	\N
100	25001010500	2010	0.000	\N
100	25001010600	2010	0.000	\N
100	25001010700	2010	0.000	\N
100	25001010800	2010	0.000	\N
100	25001010900	2010	2.000	\N
100	25001011002	2010	0.000	\N
100	25001011100	2010	0.000	\N
100	25001011200	2010	0.000	\N
100	25001011300	2010	2.000	\N
100	25001011400	2010	1.000	\N
100	25001011500	2010	0.000	\N
100	25001011600	2010	0.000	\N
100	25001011700	2010	0.000	\N
100	25001011801	2010	0.000	\N
100	25001011802	2010	0.000	\N
100	25001012001	2010	0.000	\N
100	25001012002	2010	0.000	\N
100	25001012101	2010	0.000	\N
100	25001012102	2010	0.000	\N
100	25001012200	2010	2.000	\N
100	25001012502	2010	0.000	\N
100	25001012601	2010	1.000	\N
100	25001012602	2010	1.000	\N
100	25001012700	2010	1.000	\N
100	25001012800	2010	0.000	\N
100	25001012900	2010	0.000	\N
100	25001013002	2010	0.000	\N
100	25001013100	2010	0.000	\N
100	25001013200	2010	0.000	\N
100	25001013300	2010	0.000	\N
100	25001013400	2010	0.000	\N
100	25001013500	2010	0.000	\N
100	25001013600	2010	0.000	\N
100	25001013700	2010	0.000	\N
100	25001013800	2010	2.000	\N
100	25001013900	2010	0.000	\N
100	25001014002	2010	0.000	\N
100	25001014100	2010	0.000	\N
100	25001014300	2010	0.000	\N
100	25001014402	2010	0.000	\N
100	25001014500	2010	0.000	\N
100	25001014600	2010	0.000	\N
100	25001014700	2010	0.000	\N
100	25001014800	2010	0.000	\N
100	25001014900	2010	0.000	\N
100	25001015001	2010	0.000	\N
100	25001015002	2010	0.000	\N
100	25001015100	2010	0.000	\N
100	25001015200	2010	0.000	\N
100	25001015300	2010	4.000	\N
100	25001990000	2010	0.000	\N
100	25003900100	2010	0.000	\N
100	25003900200	2010	1.000	\N
100	25003900300	2010	2.000	\N
100	25003900400	2010	0.000	\N
100	25003900500	2010	0.000	\N
100	25003900600	2010	0.000	\N
100	25003900700	2010	0.000	\N
100	25003900800	2010	0.000	\N
100	25003900900	2010	0.000	\N
100	25003901100	2010	0.000	\N
100	25003911100	2010	0.000	\N
100	25003912100	2010	0.000	\N
100	25003913100	2010	0.000	\N
100	25003914100	2010	1.000	\N
100	25003920101	2010	3.000	\N
100	25003920102	2010	0.000	\N
100	25003921300	2010	0.000	\N
100	25003921400	2010	0.000	\N
100	25003921500	2010	0.000	\N
100	25003922100	2010	0.000	\N
100	25003922200	2010	0.000	\N
100	25003922300	2010	0.000	\N
100	25003923100	2010	0.000	\N
100	25003924100	2010	0.000	\N
100	25003925100	2010	0.000	\N
100	25003926100	2010	0.000	\N
100	25003931100	2010	0.000	\N
100	25003931300	2010	0.000	\N
100	25003931400	2010	0.000	\N
100	25003932200	2010	0.000	\N
100	25003932300	2010	0.000	\N
100	25003933200	2010	0.000	\N
100	25003933300	2010	0.000	\N
100	25003933400	2010	0.000	\N
100	25003934200	2010	0.000	\N
100	25003934300	2010	0.000	\N
100	25003935100	2010	0.000	\N
100	25003935200	2010	0.000	\N
100	25003935300	2010	0.000	\N
100	25005600100	2010	0.000	\N
100	25005600202	2010	0.000	\N
100	25005600203	2010	0.000	\N
100	25005600204	2010	0.000	\N
100	25005610100	2010	0.000	\N
100	25005610202	2010	4.000	\N
100	25005610203	2010	0.000	\N
100	25005610204	2010	0.000	\N
100	25005611101	2010	0.000	\N
100	25005611102	2010	0.000	\N
100	25005611201	2010	0.000	\N
100	25005611202	2010	6.000	\N
100	25005612100	2010	0.000	\N
100	25005612200	2010	0.000	\N
100	25005613100	2010	0.000	\N
100	25005613300	2010	0.000	\N
100	25005613400	2010	0.000	\N
100	25005613600	2010	0.000	\N
100	25005613700	2010	0.000	\N
100	25005613800	2010	1.000	\N
100	25005613901	2010	0.000	\N
100	25005613902	2010	4.000	\N
100	25005614000	2010	0.000	\N
100	25005614101	2010	1.000	\N
100	25005614102	2010	1.000	\N
100	25005615100	2010	0.000	\N
100	25005616100	2010	0.000	\N
100	25005617101	2010	0.000	\N
100	25005617102	2010	0.000	\N
100	25005630101	2010	0.000	\N
100	25005630102	2010	0.000	\N
100	25005630200	2010	0.000	\N
100	25005630300	2010	0.000	\N
100	25005630400	2010	0.000	\N
100	25005631100	2010	2.000	\N
100	25005631200	2010	0.000	\N
100	25005631300	2010	3.000	\N
100	25005631400	2010	0.000	\N
100	25005631500	2010	2.000	\N
100	25005631600	2010	3.000	\N
100	25005631700	2010	0.000	\N
100	25005631800	2010	2.000	\N
100	25005632100	2010	0.000	\N
100	25005632200	2010	0.000	\N
100	25005633100	2010	0.000	\N
100	25005633200	2010	1.000	\N
100	25005640100	2010	0.000	\N
100	25005640200	2010	0.000	\N
100	25005640300	2010	0.000	\N
100	25005640400	2010	0.000	\N
100	25005640500	2010	0.000	\N
100	25005640600	2010	0.000	\N
100	25005640700	2010	3.000	\N
100	25005640800	2010	2.000	\N
100	25005640901	2010	0.000	\N
100	25005641000	2010	0.000	\N
100	25005641101	2010	0.000	\N
100	25005641200	2010	0.000	\N
100	25005641300	2010	7.000	\N
100	25005641400	2010	0.000	\N
100	25005641500	2010	0.000	\N
100	25005641600	2010	0.000	\N
100	25005641700	2010	4.000	\N
100	25005641800	2010	0.000	\N
100	25005641900	2010	0.000	\N
100	25005642000	2010	4.000	\N
100	25005642100	2010	0.000	\N
100	25005642200	2010	0.000	\N
100	25005642300	2010	0.000	\N
100	25005642400	2010	0.000	\N
100	25005642500	2010	0.000	\N
100	25005644101	2010	0.000	\N
100	25005644102	2010	0.000	\N
100	25005644200	2010	0.000	\N
100	25005645101	2010	0.000	\N
100	25005645102	2010	0.000	\N
100	25005645103	2010	0.000	\N
100	25005646101	2010	0.000	\N
100	25005646103	2010	0.000	\N
100	25005646104	2010	0.000	\N
100	25005650101	2010	0.000	\N
100	25005650102	2010	0.000	\N
100	25005650201	2010	0.000	\N
100	25005650202	2010	0.000	\N
100	25005650300	2010	0.000	\N
100	25005650400	2010	1.000	\N
100	25005650500	2010	0.000	\N
100	25005650600	2010	0.000	\N
100	25005650700	2010	3.000	\N
100	25005650800	2010	5.000	\N
100	25005650900	2010	0.000	\N
100	25005651001	2010	0.000	\N
100	25005651002	2010	0.000	\N
100	25005651100	2010	0.000	\N
100	25005651200	2010	8.000	\N
100	25005651300	2010	0.000	\N
100	25005651400	2010	1.000	\N
100	25005651500	2010	0.000	\N
100	25005651600	2010	0.000	\N
100	25005651700	2010	0.000	\N
100	25005651800	2010	1.000	\N
100	25005651900	2010	0.000	\N
100	25005652000	2010	4.000	\N
100	25005652100	2010	0.000	\N
100	25005652200	2010	0.000	\N
100	25005652300	2010	0.000	\N
100	25005652400	2010	0.000	\N
100	25005652500	2010	2.000	\N
100	25005652600	2010	10.000	\N
100	25005652700	2010	0.000	\N
100	25005652800	2010	0.000	\N
100	25005653101	2010	0.000	\N
100	25005653102	2010	0.000	\N
100	25005653203	2010	0.000	\N
100	25005653204	2010	0.000	\N
100	25005653301	2010	0.000	\N
100	25005653304	2010	0.000	\N
100	25005654100	2010	0.000	\N
100	25005654200	2010	0.000	\N
100	25005655100	2010	0.000	\N
100	25005655200	2010	0.000	\N
100	25005655300	2010	0.000	\N
100	25005655400	2010	0.000	\N
100	25005985500	2010	0.000	\N
100	25005985600	2010	1.000	\N
100	25005990000	2010	0.000	\N
100	25007200100	2010	0.000	\N
100	25007200200	2010	4.000	\N
100	25007200300	2010	2.000	\N
100	25007200400	2010	0.000	\N
100	25007990000	2010	0.000	\N
100	25009201100	2010	0.000	\N
100	25009202101	2010	0.000	\N
100	25009202102	2010	0.000	\N
100	25009202200	2010	0.000	\N
100	25009203100	2010	0.000	\N
100	25009203200	2010	0.000	\N
100	25009203301	2010	0.000	\N
100	25009203302	2010	0.000	\N
100	25009204101	2010	0.000	\N
100	25009204102	2010	0.000	\N
100	25009204200	2010	0.000	\N
100	25009204300	2010	0.000	\N
100	25009204400	2010	0.000	\N
100	25009204500	2010	0.000	\N
100	25009204600	2010	4.000	\N
100	25009204701	2010	0.000	\N
100	25009204702	2010	0.000	\N
100	25009205100	2010	0.000	\N
100	25009205200	2010	1.000	\N
100	25009205300	2010	0.000	\N
100	25009205400	2010	0.000	\N
100	25009205500	2010	6.000	\N
100	25009205600	2010	0.000	\N
100	25009205700	2010	0.000	\N
100	25009205800	2010	6.000	\N
100	25009205900	2010	5.000	\N
100	25009206000	2010	0.000	\N
100	25009206100	2010	0.000	\N
100	25009206200	2010	0.000	\N
100	25009206300	2010	1.000	\N
100	25009206400	2010	1.000	\N
100	25009206500	2010	2.000	\N
100	25009206600	2010	0.000	\N
100	25009206700	2010	2.000	\N
100	25009206800	2010	0.000	\N
100	25009206900	2010	3.000	\N
100	25009207000	2010	0.000	\N
100	25009207100	2010	18.000	\N
100	25009207200	2010	0.000	\N
100	25009208101	2010	0.000	\N
100	25009208102	2010	2.000	\N
100	25009208200	2010	0.000	\N
100	25009208300	2010	0.000	\N
100	25009208400	2010	0.000	\N
100	25009209100	2010	0.000	\N
100	25009209200	2010	0.000	\N
100	25009210100	2010	0.000	\N
100	25009210200	2010	0.000	\N
100	25009210300	2010	0.000	\N
100	25009210400	2010	0.000	\N
100	25009210500	2010	0.000	\N
100	25009210600	2010	0.000	\N
100	25009210700	2010	0.000	\N
100	25009210800	2010	0.000	\N
100	25009210900	2010	0.000	\N
100	25009211100	2010	0.000	\N
100	25009211200	2010	0.000	\N
100	25009211300	2010	0.000	\N
100	25009211401	2010	0.000	\N
100	25009211402	2010	0.000	\N
100	25009212100	2010	3.000	\N
100	25009213100	2010	0.000	\N
100	25009214100	2010	0.000	\N
100	25009215101	2010	0.000	\N
100	25009215102	2010	0.000	\N
100	25009216100	2010	0.000	\N
100	25009217100	2010	0.000	\N
100	25009217201	2010	0.000	\N
100	25009217202	2010	0.000	\N
100	25009217300	2010	0.000	\N
100	25009217400	2010	0.000	\N
100	25009217500	2010	0.000	\N
100	25009217600	2010	0.000	\N
100	25009218100	2010	0.000	\N
100	25009220101	2010	0.000	\N
100	25009220102	2010	0.000	\N
100	25009221100	2010	1.000	\N
100	25009221300	2010	0.000	\N
100	25009221400	2010	5.000	\N
100	25009221500	2010	4.000	\N
100	25009221600	2010	0.000	\N
100	25009221700	2010	0.000	\N
100	25009221800	2010	0.000	\N
100	25009221901	2010	0.000	\N
100	25009221902	2010	0.000	\N
100	25009222100	2010	0.000	\N
100	25009223100	2010	0.000	\N
100	25009223200	2010	0.000	\N
100	25009223300	2010	0.000	\N
100	25009250100	2010	0.000	\N
100	25009250200	2010	0.000	\N
100	25009250300	2010	0.000	\N
100	25009250400	2010	7.000	\N
100	25009250500	2010	4.000	\N
100	25009250600	2010	13.000	\N
100	25009250700	2010	4.000	\N
100	25009250800	2010	3.000	\N
100	25009250900	2010	2.000	\N
100	25009251000	2010	0.000	\N
100	25009251100	2010	0.000	\N
100	25009251200	2010	2.000	\N
100	25009251300	2010	3.000	\N
100	25009251400	2010	0.000	\N
100	25009251500	2010	10.000	\N
100	25009251600	2010	2.000	\N
100	25009251700	2010	4.000	\N
100	25009251800	2010	1.000	\N
100	25009252101	2010	0.000	\N
100	25009252102	2010	0.000	\N
100	25009252201	2010	0.000	\N
100	25009252202	2010	0.000	\N
100	25009252300	2010	2.000	\N
100	25009252400	2010	3.000	\N
100	25009252501	2010	4.000	\N
100	25009252502	2010	0.000	\N
100	25009252601	2010	0.000	\N
100	25009252602	2010	0.000	\N
100	25009252603	2010	0.000	\N
100	25009253100	2010	0.000	\N
100	25009253201	2010	0.000	\N
100	25009253202	2010	1.000	\N
100	25009253203	2010	0.000	\N
100	25009253204	2010	0.000	\N
100	25009253205	2010	0.000	\N
100	25009254100	2010	1.000	\N
100	25009254200	2010	1.000	\N
100	25009254301	2010	0.000	\N
100	25009254302	2010	0.000	\N
100	25009254401	2010	0.000	\N
100	25009254402	2010	1.000	\N
100	25009254403	2010	0.000	\N
100	25009260100	2010	6.000	\N
100	25009260200	2010	0.000	\N
100	25009260301	2010	0.000	\N
100	25009260302	2010	0.000	\N
100	25009260401	2010	0.000	\N
100	25009260402	2010	0.000	\N
100	25009260500	2010	0.000	\N
100	25009260600	2010	0.000	\N
100	25009260700	2010	0.000	\N
100	25009260800	2010	3.000	\N
100	25009260900	2010	0.000	\N
100	25009261000	2010	0.000	\N
100	25009261101	2010	0.000	\N
100	25009261102	2010	0.000	\N
100	25009262100	2010	0.000	\N
100	25009263100	2010	0.000	\N
100	25009264100	2010	0.000	\N
100	25009265101	2010	0.000	\N
100	25009265102	2010	0.000	\N
100	25009266100	2010	0.000	\N
100	25009266200	2010	0.000	\N
100	25009266300	2010	1.000	\N
100	25009266400	2010	0.000	\N
100	25009267101	2010	0.000	\N
100	25009267102	2010	0.000	\N
100	25009268100	2010	0.000	\N
100	25009268200	2010	0.000	\N
100	25009268300	2010	0.000	\N
100	25009268400	2010	0.000	\N
100	25009269100	2010	0.000	\N
100	25009270100	2010	0.000	\N
100	25009990100	2010	0.000	\N
100	25011040100	2010	0.000	\N
100	25011040200	2010	0.000	\N
100	25011040300	2010	0.000	\N
100	25011040400	2010	0.000	\N
100	25011040501	2010	0.000	\N
100	25011040502	2010	0.000	\N
100	25011040600	2010	0.000	\N
100	25011040701	2010	1.000	\N
100	25011040702	2010	0.000	\N
100	25011040800	2010	0.000	\N
100	25011040900	2010	0.000	\N
100	25011041000	2010	0.000	\N
100	25011041100	2010	0.000	\N
100	25011041200	2010	0.000	\N
100	25011041300	2010	0.000	\N
100	25011041400	2010	3.000	\N
100	25011041501	2010	0.000	\N
100	25011041502	2010	0.000	\N
100	25013800101	2010	0.000	\N
100	25013800102	2010	0.000	\N
100	25013800201	2010	1.000	\N
100	25013800202	2010	0.000	\N
100	25013800300	2010	0.000	\N
100	25013800400	2010	3.000	\N
100	25013800500	2010	0.000	\N
100	25013800600	2010	9.000	\N
100	25013800700	2010	0.000	\N
100	25013800800	2010	5.000	\N
100	25013800900	2010	7.000	\N
100	25013801101	2010	1.000	\N
100	25013801102	2010	2.000	\N
100	25013801200	2010	0.000	\N
100	25013801300	2010	1.000	\N
100	25013801401	2010	6.000	\N
100	25013801402	2010	1.000	\N
100	25013801501	2010	2.000	\N
100	25013801502	2010	0.000	\N
100	25013801503	2010	0.000	\N
100	25013801601	2010	0.000	\N
100	25013801602	2010	3.000	\N
100	25013801603	2010	0.000	\N
100	25013801604	2010	0.000	\N
100	25013801605	2010	10.000	\N
100	25013801700	2010	13.000	\N
100	25013801800	2010	0.000	\N
100	25013801901	2010	0.000	\N
100	25013801902	2010	0.000	\N
100	25013802000	2010	2.000	\N
100	25013802100	2010	2.000	\N
100	25013802200	2010	0.000	\N
100	25013802300	2010	13.000	\N
100	25013802400	2010	0.000	\N
100	25013802500	2010	0.000	\N
100	25013802601	2010	0.000	\N
100	25013802602	2010	0.000	\N
100	25013810100	2010	0.000	\N
100	25013810200	2010	0.000	\N
100	25013810300	2010	0.000	\N
100	25013810403	2010	0.000	\N
100	25013810404	2010	0.000	\N
100	25013810412	2010	0.000	\N
100	25013810414	2010	0.000	\N
100	25013810601	2010	0.000	\N
100	25013810602	2010	0.000	\N
100	25013810700	2010	1.000	\N
100	25013810800	2010	0.000	\N
100	25013810901	2010	0.000	\N
100	25013810902	2010	0.000	\N
100	25013811000	2010	0.000	\N
100	25013811101	2010	3.000	\N
100	25013811102	2010	9.000	\N
100	25013811200	2010	1.000	\N
100	25013811301	2010	0.000	\N
100	25013811302	2010	0.000	\N
100	25013811400	2010	0.000	\N
100	25013811500	2010	12.000	\N
100	25013811600	2010	2.000	\N
100	25013811700	2010	2.000	\N
100	25013811800	2010	1.000	\N
100	25013811900	2010	1.000	\N
100	25013812001	2010	1.000	\N
100	25013812002	2010	0.000	\N
100	25013812101	2010	0.000	\N
100	25013812103	2010	0.000	\N
100	25013812104	2010	1.000	\N
100	25013812201	2010	0.000	\N
100	25013812202	2010	0.000	\N
100	25013812300	2010	0.000	\N
100	25013812401	2010	0.000	\N
100	25013812403	2010	0.000	\N
100	25013812404	2010	0.000	\N
100	25013812500	2010	0.000	\N
100	25013812600	2010	1.000	\N
100	25013812701	2010	1.000	\N
100	25013812702	2010	0.000	\N
100	25013812800	2010	0.000	\N
100	25013812901	2010	0.000	\N
100	25013812902	2010	0.000	\N
100	25013812903	2010	0.000	\N
100	25013813000	2010	0.000	\N
100	25013813101	2010	0.000	\N
100	25013813102	2010	0.000	\N
100	25013813204	2010	0.000	\N
100	25013813205	2010	0.000	\N
100	25013813206	2010	0.000	\N
100	25013813207	2010	0.000	\N
100	25013813208	2010	0.000	\N
100	25013813209	2010	0.000	\N
100	25013813301	2010	0.000	\N
100	25013813303	2010	0.000	\N
100	25013813304	2010	0.000	\N
100	25013813401	2010	0.000	\N
100	25013813403	2010	0.000	\N
100	25013813404	2010	0.000	\N
100	25013813500	2010	0.000	\N
100	25013813601	2010	0.000	\N
100	25013813602	2010	0.000	\N
100	25013813701	2010	0.000	\N
100	25013813702	2010	0.000	\N
100	25013813801	2010	0.000	\N
100	25013813802	2010	2.000	\N
100	25015820101	2010	0.000	\N
100	25015820102	2010	0.000	\N
100	25015820202	2010	0.000	\N
100	25015820203	2010	2.000	\N
100	25015820204	2010	0.000	\N
100	25015820300	2010	2.000	\N
100	25015820400	2010	0.000	\N
100	25015820500	2010	0.000	\N
100	25015820600	2010	0.000	\N
100	25015820700	2010	0.000	\N
100	25015820801	2010	0.000	\N
100	25015820802	2010	0.000	\N
100	25015820900	2010	0.000	\N
100	25015821000	2010	0.000	\N
100	25015821100	2010	0.000	\N
100	25015821200	2010	0.000	\N
100	25015821300	2010	0.000	\N
100	25015821400	2010	0.000	\N
100	25015821500	2010	0.000	\N
100	25015821601	2010	0.000	\N
100	25015821602	2010	4.000	\N
100	25015821700	2010	0.000	\N
100	25015821901	2010	2.000	\N
100	25015821903	2010	0.000	\N
100	25015821904	2010	0.000	\N
100	25015822000	2010	0.000	\N
100	25015822200	2010	1.000	\N
100	25015822300	2010	0.000	\N
100	25015822401	2010	0.000	\N
100	25015822402	2010	1.000	\N
100	25015822500	2010	0.000	\N
100	25015822601	2010	0.000	\N
100	25015822603	2010	0.000	\N
100	25015822605	2010	0.000	\N
100	25015822606	2010	0.000	\N
100	25015822700	2010	0.000	\N
100	25017300100	2010	0.000	\N
100	25017301101	2010	0.000	\N
100	25017301102	2010	0.000	\N
100	25017310100	2010	0.000	\N
100	25017310200	2010	0.000	\N
100	25017310300	2010	0.000	\N
100	25017310400	2010	4.000	\N
100	25017310500	2010	1.000	\N
100	25017310601	2010	2.000	\N
100	25017310602	2010	0.000	\N
100	25017310700	2010	0.000	\N
100	25017311100	2010	2.000	\N
100	25017311200	2010	0.000	\N
100	25017311300	2010	0.000	\N
100	25017311400	2010	0.000	\N
100	25017311500	2010	0.000	\N
100	25017311600	2010	0.000	\N
100	25017311700	2010	0.000	\N
100	25017311800	2010	0.000	\N
100	25017311900	2010	0.000	\N
100	25017312000	2010	0.000	\N
100	25017312100	2010	0.000	\N
100	25017312200	2010	0.000	\N
100	25017312300	2010	1.000	\N
100	25017312400	2010	0.000	\N
100	25017312501	2010	0.000	\N
100	25017312502	2010	0.000	\N
100	25017313101	2010	0.000	\N
100	25017313102	2010	0.000	\N
100	25017314101	2010	0.000	\N
100	25017314102	2010	0.000	\N
100	25017314200	2010	3.000	\N
100	25017314301	2010	1.000	\N
100	25017314302	2010	0.000	\N
100	25017315100	2010	0.000	\N
100	25017315200	2010	0.000	\N
100	25017315401	2010	0.000	\N
100	25017315402	2010	0.000	\N
100	25017315403	2010	0.000	\N
100	25017315500	2010	0.000	\N
100	25017316101	2010	0.000	\N
100	25017316102	2010	0.000	\N
100	25017316201	2010	0.000	\N
100	25017316202	2010	0.000	\N
100	25017316300	2010	0.000	\N
100	25017316400	2010	0.000	\N
100	25017316500	2010	0.000	\N
100	25017317101	2010	0.000	\N
100	25017317102	2010	0.000	\N
100	25017317103	2010	0.000	\N
100	25017317201	2010	0.000	\N
100	25017317202	2010	0.000	\N
100	25017317203	2010	0.000	\N
100	25017317301	2010	0.000	\N
100	25017317302	2010	0.000	\N
100	25017318100	2010	0.000	\N
100	25017318200	2010	0.000	\N
100	25017318300	2010	0.000	\N
100	25017318400	2010	0.000	\N
100	25017320102	2010	0.000	\N
100	25017320103	2010	0.000	\N
100	25017320104	2010	0.000	\N
100	25017321100	2010	0.000	\N
100	25017321200	2010	0.000	\N
100	25017321300	2010	3.000	\N
100	25017321400	2010	0.000	\N
100	25017321500	2010	6.000	\N
100	25017321600	2010	0.000	\N
100	25017322100	2010	0.000	\N
100	25017322200	2010	0.000	\N
100	25017322300	2010	0.000	\N
100	25017322400	2010	0.000	\N
100	25017323100	2010	0.000	\N
100	25017324101	2010	0.000	\N
100	25017324102	2010	0.000	\N
100	25017325100	2010	5.000	\N
100	25017326101	2010	0.000	\N
100	25017326102	2010	0.000	\N
100	25017327101	2010	0.000	\N
100	25017327102	2010	1.000	\N
100	25017327103	2010	1.000	\N
100	25017328100	2010	0.000	\N
100	25017330100	2010	0.000	\N
100	25017330200	2010	0.000	\N
100	25017331101	2010	0.000	\N
100	25017331102	2010	0.000	\N
100	25017331200	2010	1.000	\N
100	25017331300	2010	0.000	\N
100	25017332100	2010	0.000	\N
100	25017332200	2010	1.000	\N
100	25017332300	2010	0.000	\N
100	25017332400	2010	0.000	\N
100	25017333100	2010	0.000	\N
100	25017333200	2010	0.000	\N
100	25017333300	2010	0.000	\N
100	25017333400	2010	0.000	\N
100	25017333501	2010	0.000	\N
100	25017333502	2010	0.000	\N
100	25017333600	2010	0.000	\N
100	25017334100	2010	0.000	\N
100	25017334200	2010	0.000	\N
100	25017334300	2010	0.000	\N
100	25017334400	2010	0.000	\N
100	25017335100	2010	0.000	\N
100	25017335200	2010	0.000	\N
100	25017335301	2010	0.000	\N
100	25017335302	2010	0.000	\N
100	25017335400	2010	0.000	\N
100	25017336100	2010	0.000	\N
100	25017336200	2010	1.000	\N
100	25017336300	2010	1.000	\N
100	25017336401	2010	0.000	\N
100	25017336402	2010	2.000	\N
100	25017337101	2010	0.000	\N
100	25017337102	2010	0.000	\N
100	25017337201	2010	0.000	\N
100	25017337202	2010	0.000	\N
100	25017337300	2010	0.000	\N
100	25017338100	2010	0.000	\N
100	25017338200	2010	0.000	\N
100	25017338300	2010	1.000	\N
100	25017338400	2010	0.000	\N
100	25017338500	2010	0.000	\N
100	25017339100	2010	0.000	\N
100	25017339200	2010	0.000	\N
100	25017339300	2010	1.000	\N
100	25017339400	2010	0.000	\N
100	25017339500	2010	0.000	\N
100	25017339600	2010	0.000	\N
100	25017339700	2010	0.000	\N
100	25017339801	2010	0.000	\N
100	25017339802	2010	0.000	\N
100	25017339900	2010	0.000	\N
100	25017340000	2010	0.000	\N
100	25017340100	2010	0.000	\N
100	25017341101	2010	0.000	\N
100	25017341102	2010	0.000	\N
100	25017341200	2010	0.000	\N
100	25017341300	2010	2.000	\N
100	25017341400	2010	0.000	\N
100	25017341500	2010	0.000	\N
100	25017341600	2010	0.000	\N
100	25017341700	2010	0.000	\N
100	25017341800	2010	0.000	\N
100	25017341901	2010	0.000	\N
100	25017341902	2010	0.000	\N
100	25017342101	2010	0.000	\N
100	25017342102	2010	3.000	\N
100	25017342201	2010	0.000	\N
100	25017342202	2010	0.000	\N
100	25017342300	2010	0.000	\N
100	25017342400	2010	2.000	\N
100	25017342500	2010	0.000	\N
100	25017342600	2010	0.000	\N
100	25017350103	2010	0.000	\N
100	25017350104	2010	5.000	\N
100	25017350200	2010	3.000	\N
100	25017350300	2010	0.000	\N
100	25017350400	2010	1.000	\N
100	25017350500	2010	1.000	\N
100	25017350600	2010	0.000	\N
100	25017350700	2010	1.000	\N
100	25017350800	2010	0.000	\N
100	25017350900	2010	0.000	\N
100	25017351000	2010	0.000	\N
100	25017351100	2010	0.000	\N
100	25017351203	2010	0.000	\N
100	25017351204	2010	2.000	\N
100	25017351300	2010	1.000	\N
100	25017351403	2010	0.000	\N
100	25017351404	2010	1.000	\N
100	25017351500	2010	0.000	\N
100	25017352101	2010	0.000	\N
100	25017352102	2010	0.000	\N
100	25017352200	2010	0.000	\N
100	25017352300	2010	0.000	\N
100	25017352400	2010	0.000	\N
100	25017352500	2010	2.000	\N
100	25017352600	2010	0.000	\N
100	25017352700	2010	0.000	\N
100	25017352800	2010	0.000	\N
100	25017352900	2010	0.000	\N
100	25017353000	2010	0.000	\N
100	25017353101	2010	0.000	\N
100	25017353102	2010	2.000	\N
100	25017353200	2010	0.000	\N
100	25017353300	2010	0.000	\N
100	25017353400	2010	0.000	\N
100	25017353500	2010	0.000	\N
100	25017353600	2010	0.000	\N
100	25017353700	2010	0.000	\N
100	25017353800	2010	0.000	\N
100	25017353900	2010	0.000	\N
100	25017354000	2010	0.000	\N
100	25017354100	2010	0.000	\N
100	25017354200	2010	0.000	\N
100	25017354300	2010	3.000	\N
100	25017354400	2010	0.000	\N
100	25017354500	2010	0.000	\N
100	25017354600	2010	0.000	\N
100	25017354700	2010	0.000	\N
100	25017354800	2010	0.000	\N
100	25017354900	2010	0.000	\N
100	25017355000	2010	0.000	\N
100	25017356100	2010	0.000	\N
100	25017356300	2010	0.000	\N
100	25017356400	2010	1.000	\N
100	25017356500	2010	0.000	\N
100	25017356601	2010	0.000	\N
100	25017356602	2010	0.000	\N
100	25017356701	2010	0.000	\N
100	25017356702	2010	0.000	\N
100	25017357100	2010	0.000	\N
100	25017357200	2010	0.000	\N
100	25017357300	2010	0.000	\N
100	25017357400	2010	0.000	\N
100	25017357500	2010	0.000	\N
100	25017357600	2010	0.000	\N
100	25017357700	2010	0.000	\N
100	25017357800	2010	0.000	\N
100	25017358100	2010	0.000	\N
100	25017358300	2010	0.000	\N
100	25017358400	2010	0.000	\N
100	25017358500	2010	0.000	\N
100	25017358600	2010	0.000	\N
100	25017358700	2010	0.000	\N
100	25017359100	2010	0.000	\N
100	25017359300	2010	4.000	\N
100	25017360100	2010	0.000	\N
100	25017360200	2010	0.000	\N
100	25017361100	2010	0.000	\N
100	25017361200	2010	0.000	\N
100	25017361300	2010	0.000	\N
100	25017362100	2010	0.000	\N
100	25017363102	2010	0.000	\N
100	25017363103	2010	0.000	\N
100	25017363104	2010	0.000	\N
100	25017363201	2010	0.000	\N
100	25017363202	2010	0.000	\N
100	25017364101	2010	0.000	\N
100	25017364102	2010	0.000	\N
100	25017365100	2010	0.000	\N
100	25017365201	2010	3.000	\N
100	25017365202	2010	0.000	\N
100	25017366100	2010	0.000	\N
100	25017366201	2010	0.000	\N
100	25017366202	2010	0.000	\N
100	25017367100	2010	0.000	\N
100	25017367200	2010	0.000	\N
100	25017368101	2010	0.000	\N
100	25017368102	2010	0.000	\N
100	25017368200	2010	0.000	\N
100	25017368300	2010	8.000	\N
100	25017368400	2010	1.000	\N
100	25017368500	2010	12.000	\N
100	25017368600	2010	8.000	\N
100	25017368700	2010	5.000	\N
100	25017368800	2010	6.000	\N
100	25017368901	2010	2.000	\N
100	25017368902	2010	0.000	\N
100	25017369000	2010	0.000	\N
100	25017369100	2010	0.000	\N
100	25017370101	2010	0.000	\N
100	25017370102	2010	2.000	\N
100	25017370201	2010	0.000	\N
100	25017370202	2010	0.000	\N
100	25017370300	2010	2.000	\N
100	25017370400	2010	0.000	\N
100	25017373100	2010	0.000	\N
100	25017373200	2010	0.000	\N
100	25017373300	2010	0.000	\N
100	25017373400	2010	0.000	\N
100	25017373500	2010	0.000	\N
100	25017373600	2010	1.000	\N
100	25017373700	2010	0.000	\N
100	25017373800	2010	0.000	\N
100	25017373900	2010	0.000	\N
100	25017374000	2010	0.000	\N
100	25017374100	2010	0.000	\N
100	25017374200	2010	0.000	\N
100	25017374300	2010	0.000	\N
100	25017374400	2010	0.000	\N
100	25017374500	2010	0.000	\N
100	25017374600	2010	0.000	\N
100	25017374700	2010	0.000	\N
100	25017374800	2010	0.000	\N
100	25017382100	2010	0.000	\N
100	25017382200	2010	0.000	\N
100	25017382300	2010	1.000	\N
100	25017382400	2010	0.000	\N
100	25017382500	2010	0.000	\N
100	25017382601	2010	0.000	\N
100	25017382602	2010	0.000	\N
100	25017383101	2010	21.000	\N
100	25017383102	2010	3.000	\N
100	25017383200	2010	0.000	\N
100	25017383300	2010	0.000	\N
100	25017383400	2010	0.000	\N
100	25017383501	2010	0.000	\N
100	25017383502	2010	0.000	\N
100	25017383600	2010	0.000	\N
100	25017383700	2010	3.000	\N
100	25017383800	2010	1.000	\N
100	25017383901	2010	1.000	\N
100	25017383902	2010	0.000	\N
100	25017384001	2010	0.000	\N
100	25017384002	2010	0.000	\N
100	25017385100	2010	0.000	\N
100	25017385201	2010	3.000	\N
100	25017385202	2010	0.000	\N
100	25017386100	2010	0.000	\N
100	25017387100	2010	0.000	\N
100	25017387201	2010	0.000	\N
100	25017387202	2010	0.000	\N
100	25017388100	2010	0.000	\N
100	25017388200	2010	1.000	\N
100	25017388300	2010	0.000	\N
100	25017980000	2010	0.000	\N
100	25019950100	2010	0.000	\N
100	25019950200	2010	0.000	\N
100	25019950307	2010	0.000	\N
100	25019950400	2010	0.000	\N
100	25019950500	2010	0.000	\N
100	25019990000	2010	0.000	\N
100	25021400100	2010	1.000	\N
100	25021400200	2010	0.000	\N
100	25021400300	2010	0.000	\N
100	25021400400	2010	0.000	\N
100	25021400500	2010	0.000	\N
100	25021400600	2010	0.000	\N
100	25021400700	2010	0.000	\N
100	25021400800	2010	1.000	\N
100	25021400900	2010	0.000	\N
100	25021401000	2010	0.000	\N
100	25021401100	2010	0.000	\N
100	25021401200	2010	0.000	\N
100	25021402101	2010	0.000	\N
100	25021402102	2010	0.000	\N
100	25021402200	2010	0.000	\N
100	25021402300	2010	0.000	\N
100	25021402400	2010	0.000	\N
100	25021402500	2010	0.000	\N
100	25021403100	2010	0.000	\N
100	25021403300	2010	0.000	\N
100	25021403400	2010	0.000	\N
100	25021403500	2010	0.000	\N
100	25021404100	2010	0.000	\N
100	25021404201	2010	0.000	\N
100	25021404202	2010	0.000	\N
100	25021404301	2010	0.000	\N
100	25021404302	2010	0.000	\N
100	25021404400	2010	6.000	\N
100	25021405100	2010	1.000	\N
100	25021406101	2010	0.000	\N
100	25021406102	2010	0.000	\N
100	25021407100	2010	1.000	\N
100	25021408101	2010	0.000	\N
100	25021408102	2010	0.000	\N
100	25021409101	2010	0.000	\N
100	25021409102	2010	0.000	\N
100	25021410100	2010	0.000	\N
100	25021410300	2010	0.000	\N
100	25021410400	2010	0.000	\N
100	25021411100	2010	0.000	\N
100	25021411200	2010	0.000	\N
100	25021411301	2010	0.000	\N
100	25021411302	2010	0.000	\N
100	25021412100	2010	0.000	\N
100	25021412200	2010	0.000	\N
100	25021412300	2010	0.000	\N
100	25021413100	2010	0.000	\N
100	25021413200	2010	1.000	\N
100	25021413300	2010	0.000	\N
100	25021413401	2010	0.000	\N
100	25021413402	2010	2.000	\N
100	25021413500	2010	0.000	\N
100	25021414100	2010	0.000	\N
100	25021414200	2010	0.000	\N
100	25021414300	2010	0.000	\N
100	25021415101	2010	1.000	\N
100	25021415102	2010	0.000	\N
100	25021415200	2010	0.000	\N
100	25021415300	2010	0.000	\N
100	25021416101	2010	0.000	\N
100	25021416102	2010	0.000	\N
100	25021416200	2010	0.000	\N
100	25021416300	2010	0.000	\N
100	25021416400	2010	0.000	\N
100	25021417100	2010	0.000	\N
100	25021417200	2010	0.000	\N
100	25021417300	2010	0.000	\N
100	25021417400	2010	0.000	\N
100	25021417501	2010	0.000	\N
100	25021417502	2010	0.000	\N
100	25021417601	2010	0.000	\N
100	25021417602	2010	0.000	\N
100	25021417701	2010	0.000	\N
100	25021417702	2010	0.000	\N
100	25021417801	2010	0.000	\N
100	25021417802	2010	0.000	\N
100	25021417901	2010	0.000	\N
100	25021417902	2010	0.000	\N
100	25021418002	2010	0.000	\N
100	25021418003	2010	0.000	\N
100	25021418004	2010	0.000	\N
100	25021418101	2010	0.000	\N
100	25021418102	2010	0.000	\N
100	25021418200	2010	0.000	\N
100	25021419100	2010	2.000	\N
100	25021419200	2010	0.000	\N
100	25021419300	2010	0.000	\N
100	25021419400	2010	0.000	\N
100	25021419500	2010	0.000	\N
100	25021419600	2010	0.000	\N
100	25021419700	2010	0.000	\N
100	25021419800	2010	0.000	\N
100	25021420100	2010	0.000	\N
100	25021420201	2010	0.000	\N
100	25021420202	2010	0.000	\N
100	25021420301	2010	1.000	\N
100	25021420302	2010	0.000	\N
100	25021421100	2010	0.000	\N
100	25021421200	2010	1.000	\N
100	25021422100	2010	0.000	\N
100	25021422200	2010	0.000	\N
100	25021422301	2010	0.000	\N
100	25021422302	2010	0.000	\N
100	25021422400	2010	0.000	\N
100	25021422501	2010	1.000	\N
100	25021422502	2010	1.000	\N
100	25021422600	2010	0.000	\N
100	25021422700	2010	0.000	\N
100	25021422800	2010	0.000	\N
100	25021423100	2010	0.000	\N
100	25021440100	2010	0.000	\N
100	25021441202	2010	0.000	\N
100	25021441203	2010	0.000	\N
100	25021441204	2010	0.000	\N
100	25021442101	2010	0.000	\N
100	25021442102	2010	1.000	\N
100	25021442103	2010	0.000	\N
100	25021442201	2010	0.000	\N
100	25021442202	2010	0.000	\N
100	25021443101	2010	0.000	\N
100	25021443102	2010	1.000	\N
100	25021456101	2010	0.000	\N
100	25021456102	2010	0.000	\N
100	25021456200	2010	0.000	\N
100	25021456301	2010	0.000	\N
100	25021456302	2010	0.000	\N
100	25021456401	2010	0.000	\N
100	25021456402	2010	0.000	\N
100	25021457100	2010	0.000	\N
100	25021457200	2010	0.000	\N
100	25023500101	2010	0.000	\N
100	25023500103	2010	0.000	\N
100	25023500104	2010	0.000	\N
100	25023501101	2010	0.000	\N
100	25023501102	2010	0.000	\N
100	25023501201	2010	0.000	\N
100	25023501202	2010	0.000	\N
100	25023502101	2010	0.000	\N
100	25023502102	2010	0.000	\N
100	25023502200	2010	0.000	\N
100	25023503101	2010	0.000	\N
100	25023503102	2010	1.000	\N
100	25023504101	2010	0.000	\N
100	25023504102	2010	0.000	\N
100	25023505101	2010	0.000	\N
100	25023505102	2010	0.000	\N
100	25023505200	2010	0.000	\N
100	25023506101	2010	0.000	\N
100	25023506102	2010	0.000	\N
100	25023506202	2010	0.000	\N
100	25023506203	2010	0.000	\N
100	25023506204	2010	0.000	\N
100	25023507101	2010	0.000	\N
100	25023507103	2010	0.000	\N
100	25023507104	2010	0.000	\N
100	25023508101	2010	0.000	\N
100	25023508102	2010	0.000	\N
100	25023508200	2010	0.000	\N
100	25023509101	2010	0.000	\N
100	25023509102	2010	0.000	\N
100	25023510100	2010	0.000	\N
100	25023510200	2010	0.000	\N
100	25023510300	2010	1.000	\N
100	25023510400	2010	4.000	\N
100	25023510501	2010	0.000	\N
100	25023510502	2010	2.000	\N
100	25023510503	2010	0.000	\N
100	25023510600	2010	0.000	\N
100	25023510700	2010	0.000	\N
100	25023510800	2010	1.000	\N
100	25023510900	2010	1.000	\N
100	25023511000	2010	0.000	\N
100	25023511100	2010	0.000	\N
100	25023511200	2010	0.000	\N
100	25023511301	2010	6.000	\N
100	25023511302	2010	0.000	\N
100	25023511400	2010	0.000	\N
100	25023511500	2010	0.000	\N
100	25023511600	2010	0.000	\N
100	25023511701	2010	0.000	\N
100	25023511702	2010	0.000	\N
100	25023520100	2010	0.000	\N
100	25023520201	2010	0.000	\N
100	25023520202	2010	0.000	\N
100	25023521101	2010	0.000	\N
100	25023521102	2010	0.000	\N
100	25023521201	2010	0.000	\N
100	25023521202	2010	0.000	\N
100	25023522101	2010	0.000	\N
100	25023522102	2010	0.000	\N
100	25023523100	2010	0.000	\N
100	25023523201	2010	0.000	\N
100	25023523202	2010	0.000	\N
100	25023524101	2010	0.000	\N
100	25023524102	2010	0.000	\N
100	25023525101	2010	0.000	\N
100	25023525104	2010	0.000	\N
100	25023525203	2010	0.000	\N
100	25023525204	2010	0.000	\N
100	25023525300	2010	0.000	\N
100	25023526100	2010	0.000	\N
100	25023530100	2010	0.000	\N
100	25023530200	2010	0.000	\N
100	25023530300	2010	0.000	\N
100	25023530400	2010	0.000	\N
100	25023530500	2010	0.000	\N
100	25023530600	2010	0.000	\N
100	25023530700	2010	0.000	\N
100	25023530801	2010	0.000	\N
100	25023530802	2010	0.000	\N
100	25023530901	2010	0.000	\N
100	25023530902	2010	0.000	\N
100	25023540101	2010	0.000	\N
100	25023540102	2010	0.000	\N
100	25023540103	2010	0.000	\N
100	25023541100	2010	0.000	\N
100	25023542101	2010	1.000	\N
100	25023542102	2010	0.000	\N
100	25023542200	2010	0.000	\N
100	25023542300	2010	1.000	\N
100	25023543100	2010	0.000	\N
100	25023544100	2010	0.000	\N
100	25023544200	2010	0.000	\N
100	25023545100	2010	0.000	\N
100	25023545200	2010	0.000	\N
100	25023545300	2010	0.000	\N
100	25023545400	2010	0.000	\N
100	25023560100	2010	0.000	\N
100	25023561100	2010	0.000	\N
100	25023561200	2010	0.000	\N
100	25023990003	2010	0.000	\N
100	25025000100	2010	0.000	\N
100	25025000201	2010	0.000	\N
100	25025000202	2010	1.000	\N
100	25025000301	2010	0.000	\N
100	25025000302	2010	0.000	\N
100	25025000401	2010	0.000	\N
100	25025000402	2010	0.000	\N
100	25025000502	2010	0.000	\N
100	25025000503	2010	0.000	\N
100	25025000504	2010	0.000	\N
100	25025000601	2010	0.000	\N
100	25025000602	2010	1.000	\N
100	25025000701	2010	0.000	\N
100	25025000703	2010	0.000	\N
100	25025000704	2010	1.000	\N
100	25025000802	2010	0.000	\N
100	25025000803	2010	0.000	\N
100	25025010103	2010	0.000	\N
100	25025010104	2010	0.000	\N
100	25025010203	2010	1.000	\N
100	25025010204	2010	1.000	\N
100	25025010300	2010	1.000	\N
100	25025010403	2010	0.000	\N
100	25025010404	2010	1.000	\N
100	25025010405	2010	0.000	\N
100	25025010408	2010	0.000	\N
100	25025010500	2010	0.000	\N
100	25025010600	2010	0.000	\N
100	25025010701	2010	0.000	\N
100	25025010702	2010	0.000	\N
100	25025010801	2010	0.000	\N
100	25025010802	2010	0.000	\N
100	25025020101	2010	0.000	\N
100	25025020200	2010	0.000	\N
100	25025020301	2010	0.000	\N
100	25025020302	2010	0.000	\N
100	25025020303	2010	0.000	\N
100	25025030100	2010	0.000	\N
100	25025030200	2010	0.000	\N
100	25025030300	2010	0.000	\N
100	25025030400	2010	0.000	\N
100	25025030500	2010	0.000	\N
100	25025040100	2010	0.000	\N
100	25025040200	2010	0.000	\N
100	25025040300	2010	1.000	\N
100	25025040401	2010	0.000	\N
100	25025040600	2010	0.000	\N
100	25025040801	2010	0.000	\N
100	25025050101	2010	0.000	\N
100	25025050200	2010	1.000	\N
100	25025050300	2010	0.000	\N
100	25025050400	2010	0.000	\N
100	25025050500	2010	0.000	\N
100	25025050600	2010	1.000	\N
100	25025050700	2010	7.000	\N
100	25025050901	2010	0.000	\N
100	25025051000	2010	1.000	\N
100	25025051101	2010	0.000	\N
100	25025051200	2010	5.000	\N
100	25025060101	2010	1.000	\N
100	25025060200	2010	0.000	\N
100	25025060301	2010	0.000	\N
100	25025060400	2010	0.000	\N
100	25025060501	2010	0.000	\N
100	25025060600	2010	0.000	\N
100	25025060700	2010	0.000	\N
100	25025060800	2010	0.000	\N
100	25025061000	2010	0.000	\N
100	25025061101	2010	4.000	\N
100	25025061200	2010	0.000	\N
100	25025070101	2010	1.000	\N
100	25025070200	2010	0.000	\N
100	25025070300	2010	0.000	\N
100	25025070402	2010	0.000	\N
100	25025070500	2010	1.000	\N
100	25025070600	2010	0.000	\N
100	25025070700	2010	0.000	\N
100	25025070800	2010	0.000	\N
100	25025070900	2010	0.000	\N
100	25025071101	2010	0.000	\N
100	25025071201	2010	0.000	\N
100	25025080100	2010	0.000	\N
100	25025080300	2010	0.000	\N
100	25025080401	2010	0.000	\N
100	25025080500	2010	2.000	\N
100	25025080601	2010	0.000	\N
100	25025080801	2010	0.000	\N
100	25025080900	2010	0.000	\N
100	25025081001	2010	0.000	\N
100	25025081100	2010	1.000	\N
100	25025081200	2010	0.000	\N
100	25025081300	2010	0.000	\N
100	25025081400	2010	0.000	\N
100	25025081500	2010	0.000	\N
100	25025081700	2010	0.000	\N
100	25025081800	2010	0.000	\N
100	25025081900	2010	0.000	\N
100	25025082000	2010	0.000	\N
100	25025082100	2010	0.000	\N
100	25025090100	2010	1.000	\N
100	25025090200	2010	4.000	\N
100	25025090300	2010	1.000	\N
100	25025090400	2010	1.000	\N
100	25025090600	2010	0.000	\N
100	25025090700	2010	0.000	\N
100	25025090901	2010	0.000	\N
100	25025091001	2010	0.000	\N
100	25025091100	2010	9.000	\N
100	25025091200	2010	1.000	\N
100	25025091300	2010	1.000	\N
100	25025091400	2010	0.000	\N
100	25025091500	2010	1.000	\N
100	25025091600	2010	0.000	\N
100	25025091700	2010	0.000	\N
100	25025091800	2010	0.000	\N
100	25025091900	2010	0.000	\N
100	25025092000	2010	6.000	\N
100	25025092101	2010	0.000	\N
100	25025092200	2010	0.000	\N
100	25025092300	2010	0.000	\N
100	25025092400	2010	0.000	\N
100	25025100100	2010	0.000	\N
100	25025100200	2010	0.000	\N
100	25025100300	2010	0.000	\N
100	25025100400	2010	0.000	\N
100	25025100500	2010	1.000	\N
100	25025100601	2010	0.000	\N
100	25025100603	2010	1.000	\N
100	25025100700	2010	0.000	\N
100	25025100800	2010	0.000	\N
100	25025100900	2010	3.000	\N
100	25025101001	2010	0.000	\N
100	25025101002	2010	3.000	\N
100	25025101101	2010	1.000	\N
100	25025101102	2010	0.000	\N
100	25025110103	2010	0.000	\N
100	25025110201	2010	0.000	\N
100	25025110301	2010	0.000	\N
100	25025110401	2010	1.000	\N
100	25025110403	2010	0.000	\N
100	25025110501	2010	0.000	\N
100	25025110502	2010	0.000	\N
100	25025110601	2010	0.000	\N
100	25025110607	2010	0.000	\N
100	25025120103	2010	0.000	\N
100	25025120104	2010	0.000	\N
100	25025120105	2010	0.000	\N
100	25025120201	2010	0.000	\N
100	25025120301	2010	0.000	\N
100	25025120400	2010	0.000	\N
100	25025120500	2010	0.000	\N
100	25025120600	2010	0.000	\N
100	25025120700	2010	1.000	\N
100	25025130100	2010	0.000	\N
100	25025130200	2010	0.000	\N
100	25025130300	2010	0.000	\N
100	25025130402	2010	1.000	\N
100	25025130404	2010	0.000	\N
100	25025130406	2010	0.000	\N
100	25025140102	2010	3.000	\N
100	25025140105	2010	0.000	\N
100	25025140106	2010	0.000	\N
100	25025140107	2010	0.000	\N
100	25025140201	2010	0.000	\N
100	25025140202	2010	5.000	\N
100	25025140300	2010	4.000	\N
100	25025140400	2010	0.000	\N
100	25025160101	2010	0.000	\N
100	25025160200	2010	1.000	\N
100	25025160300	2010	0.000	\N
100	25025160400	2010	0.000	\N
100	25025160501	2010	0.000	\N
100	25025160502	2010	0.000	\N
100	25025160601	2010	4.000	\N
100	25025160602	2010	0.000	\N
100	25025170100	2010	3.000	\N
100	25025170200	2010	0.000	\N
100	25025170300	2010	0.000	\N
100	25025170400	2010	2.000	\N
100	25025170501	2010	0.000	\N
100	25025170502	2010	0.000	\N
100	25025170601	2010	0.000	\N
100	25025170701	2010	0.000	\N
100	25025170702	2010	0.000	\N
100	25025170800	2010	2.000	\N
100	25025180101	2010	0.000	\N
100	25025180200	2010	0.000	\N
100	25025180301	2010	1.000	\N
100	25025180400	2010	0.000	\N
100	25025180500	2010	0.000	\N
100	25025980101	2010	0.000	\N
100	25025980300	2010	0.000	\N
100	25025980700	2010	0.000	\N
100	25025981000	2010	0.000	\N
100	25025981100	2010	0.000	\N
100	25025981201	2010	0.000	\N
100	25025981202	2010	0.000	\N
100	25025981300	2010	1.000	\N
100	25025981501	2010	0.000	\N
100	25025981502	2010	0.000	\N
100	25025981600	2010	0.000	\N
100	25025981700	2010	0.000	\N
100	25025981800	2010	0.000	\N
100	25025990101	2010	0.000	\N
100	25027700100	2010	0.000	\N
100	25027701100	2010	0.000	\N
100	25027702200	2010	0.000	\N
100	25027703100	2010	0.000	\N
100	25027703200	2010	0.000	\N
100	25027703300	2010	0.000	\N
100	25027704200	2010	0.000	\N
100	25027705100	2010	0.000	\N
100	25027706100	2010	0.000	\N
100	25027707100	2010	0.000	\N
100	25027707200	2010	0.000	\N
100	25027707300	2010	5.000	\N
100	25027707400	2010	0.000	\N
100	25027707500	2010	1.000	\N
100	25027708100	2010	0.000	\N
100	25027709100	2010	0.000	\N
100	25027709201	2010	0.000	\N
100	25027709202	2010	3.000	\N
100	25027709400	2010	4.000	\N
100	25027709501	2010	0.000	\N
100	25027709502	2010	0.000	\N
100	25027709600	2010	0.000	\N
100	25027709701	2010	0.000	\N
100	25027709702	2010	0.000	\N
100	25027710100	2010	1.000	\N
100	25027710200	2010	0.000	\N
100	25027710300	2010	0.000	\N
100	25027710400	2010	0.000	\N
100	25027710500	2010	5.000	\N
100	25027710600	2010	0.000	\N
100	25027710700	2010	0.000	\N
100	25027710800	2010	0.000	\N
100	25027711000	2010	0.000	\N
100	25027711100	2010	0.000	\N
100	25027712101	2010	0.000	\N
100	25027712102	2010	0.000	\N
100	25027713100	2010	0.000	\N
100	25027715100	2010	0.000	\N
100	25027716100	2010	2.000	\N
100	25027716200	2010	1.000	\N
100	25027716300	2010	0.000	\N
100	25027717100	2010	0.000	\N
100	25027718100	2010	0.000	\N
100	25027719100	2010	0.000	\N
100	25027720100	2010	0.000	\N
100	25027721101	2010	0.000	\N
100	25027721102	2010	0.000	\N
100	25027722100	2010	0.000	\N
100	25027723100	2010	0.000	\N
100	25027724100	2010	0.000	\N
100	25027725100	2010	0.000	\N
100	25027726100	2010	0.000	\N
100	25027726200	2010	3.000	\N
100	25027727100	2010	0.000	\N
100	25027728100	2010	0.000	\N
100	25027728200	2010	0.000	\N
100	25027728300	2010	0.000	\N
100	25027728400	2010	0.000	\N
100	25027729100	2010	0.000	\N
100	25027729200	2010	0.000	\N
100	25027730100	2010	0.000	\N
100	25027730200	2010	0.000	\N
100	25027730300	2010	0.000	\N
100	25027730401	2010	0.000	\N
100	25027730402	2010	0.000	\N
100	25027730500	2010	0.000	\N
100	25027730600	2010	1.000	\N
100	25027730700	2010	1.000	\N
100	25027730801	2010	0.000	\N
100	25027730802	2010	0.000	\N
100	25027730901	2010	0.000	\N
100	25027730902	2010	0.000	\N
100	25027731001	2010	0.000	\N
100	25027731002	2010	0.000	\N
100	25027731101	2010	3.000	\N
100	25027731102	2010	0.000	\N
100	25027731202	2010	0.000	\N
100	25027731203	2010	6.000	\N
100	25027731204	2010	0.000	\N
100	25027731300	2010	1.000	\N
100	25027731400	2010	3.000	\N
100	25027731500	2010	5.000	\N
100	25027731600	2010	3.000	\N
100	25027731700	2010	0.000	\N
100	25027731800	2010	1.000	\N
100	25027731900	2010	0.000	\N
100	25027732001	2010	0.000	\N
100	25027732002	2010	0.000	\N
100	25027732201	2010	0.000	\N
100	25027732202	2010	0.000	\N
100	25027732203	2010	1.000	\N
100	25027732301	2010	0.000	\N
100	25027732302	2010	0.000	\N
100	25027732400	2010	5.000	\N
100	25027732500	2010	0.000	\N
100	25027732600	2010	0.000	\N
100	25027732700	2010	2.000	\N
100	25027732801	2010	0.000	\N
100	25027732802	2010	0.000	\N
100	25027732901	2010	0.000	\N
100	25027732902	2010	1.000	\N
100	25027733000	2010	0.000	\N
100	25027733101	2010	0.000	\N
100	25027733102	2010	0.000	\N
100	25027735100	2010	1.000	\N
100	25027735200	2010	0.000	\N
100	25027736100	2010	0.000	\N
100	25027736200	2010	0.000	\N
100	25027736300	2010	0.000	\N
100	25027736400	2010	0.000	\N
100	25027736500	2010	0.000	\N
100	25027737100	2010	1.000	\N
100	25027737200	2010	0.000	\N
100	25027737300	2010	0.000	\N
100	25027738100	2010	0.000	\N
100	25027738201	2010	0.000	\N
100	25027738202	2010	0.000	\N
100	25027739100	2010	0.000	\N
100	25027739200	2010	0.000	\N
100	25027739300	2010	0.000	\N
100	25027739400	2010	0.000	\N
100	25027739500	2010	0.000	\N
100	25027740101	2010	0.000	\N
100	25027740102	2010	0.000	\N
100	25027740200	2010	1.000	\N
100	25027741101	2010	1.000	\N
100	25027741102	2010	0.000	\N
100	25027742300	2010	0.000	\N
100	25027742401	2010	0.000	\N
100	25027742402	2010	0.000	\N
100	25027743100	2010	0.000	\N
100	25027744101	2010	0.000	\N
100	25027744102	2010	0.000	\N
100	25027744200	2010	3.000	\N
100	25027744300	2010	0.000	\N
100	25027744400	2010	1.000	\N
100	25027745100	2010	0.000	\N
100	25027746100	2010	0.000	\N
100	25027747101	2010	0.000	\N
100	25027747102	2010	0.000	\N
100	25027748100	2010	0.000	\N
100	25027749100	2010	0.000	\N
100	25027749200	2010	0.000	\N
100	25027750100	2010	0.000	\N
100	25027750200	2010	0.000	\N
100	25027750300	2010	0.000	\N
100	25027751101	2010	0.000	\N
100	25027751102	2010	0.000	\N
100	25027752100	2010	0.000	\N
100	25027753100	2010	0.000	\N
100	25027753200	2010	1.000	\N
100	25027754100	2010	0.000	\N
100	25027754200	2010	0.000	\N
100	25027754300	2010	0.000	\N
100	25027754400	2010	0.000	\N
100	25027755100	2010	0.000	\N
100	25027755200	2010	0.000	\N
100	25027756101	2010	1.000	\N
100	25027756102	2010	0.000	\N
100	25027757100	2010	0.000	\N
100	25027757200	2010	0.000	\N
100	25027757300	2010	0.000	\N
100	25027757400	2010	0.000	\N
100	25027757500	2010	0.000	\N
100	25027758101	2010	0.000	\N
100	25027758102	2010	0.000	\N
100	25027759100	2010	0.000	\N
100	25027760100	2010	0.000	\N
100	25027761100	2010	0.000	\N
100	25027761200	2010	0.000	\N
100	25027761300	2010	0.000	\N
100	25027761400	2010	0.000	\N
101	25001010100	2010	37.000	\N
101	25001010206	2010	8.000	\N
101	25001010208	2010	5.000	\N
101	25001010304	2010	1.000	\N
101	25001010306	2010	4.000	\N
101	25001010400	2010	10.000	\N
101	25001010500	2010	2.000	\N
101	25001010600	2010	10.000	\N
101	25001010700	2010	12.000	\N
101	25001010800	2010	14.000	\N
101	25001010900	2010	7.000	\N
101	25001011002	2010	27.000	\N
101	25001011100	2010	18.000	\N
101	25001011200	2010	3.000	\N
101	25001011300	2010	4.000	\N
101	25001011400	2010	17.000	\N
101	25001011500	2010	12.000	\N
101	25001011600	2010	16.000	\N
101	25001011700	2010	4.000	\N
101	25001011801	2010	0.000	\N
101	25001011802	2010	15.000	\N
101	25001012001	2010	32.000	\N
101	25001012002	2010	22.000	\N
101	25001012101	2010	69.000	\N
101	25001012102	2010	19.000	\N
101	25001012200	2010	10.000	\N
101	25001012502	2010	35.000	\N
101	25001012601	2010	27.000	\N
101	25001012602	2010	120.000	\N
101	25001012700	2010	23.000	\N
101	25001012800	2010	9.000	\N
101	25001012900	2010	19.000	\N
101	25001013002	2010	5.000	\N
101	25001013100	2010	15.000	\N
101	25001013200	2010	10.000	\N
101	25001013300	2010	6.000	\N
101	25001013400	2010	1.000	\N
101	25001013500	2010	13.000	\N
101	25001013600	2010	23.000	\N
101	25001013700	2010	20.000	\N
101	25001013800	2010	24.000	\N
101	25001013900	2010	3.000	\N
101	25001014002	2010	4.000	\N
101	25001014100	2010	31.000	\N
101	25001014300	2010	6.000	\N
101	25001014402	2010	22.000	\N
101	25001014500	2010	38.000	\N
101	25001014600	2010	7.000	\N
101	25001014700	2010	2.000	\N
101	25001014800	2010	6.000	\N
101	25001014900	2010	7.000	\N
101	25001015001	2010	14.000	\N
101	25001015002	2010	6.000	\N
101	25001015100	2010	22.000	\N
101	25001015200	2010	3.000	\N
101	25001015300	2010	52.000	\N
101	25001990000	2010	0.000	\N
101	25003900100	2010	130.000	\N
101	25003900200	2010	169.000	\N
101	25003900300	2010	66.000	\N
101	25003900400	2010	76.000	\N
101	25003900500	2010	8.000	\N
101	25003900600	2010	92.000	\N
101	25003900700	2010	19.000	\N
101	25003900800	2010	26.000	\N
101	25003900900	2010	124.000	\N
101	25003901100	2010	22.000	\N
101	25003911100	2010	4.000	\N
101	25003912100	2010	33.000	\N
101	25003913100	2010	29.000	\N
101	25003914100	2010	75.000	\N
101	25003920101	2010	38.000	\N
101	25003920102	2010	23.000	\N
101	25003921300	2010	53.000	\N
101	25003921400	2010	28.000	\N
101	25003921500	2010	33.000	\N
101	25003922100	2010	1.000	\N
101	25003922200	2010	10.000	\N
101	25003922300	2010	3.000	\N
101	25003923100	2010	6.000	\N
101	25003924100	2010	8.000	\N
101	25003925100	2010	104.000	\N
101	25003926100	2010	39.000	\N
101	25003931100	2010	0.000	\N
101	25003931300	2010	0.000	\N
101	25003931400	2010	0.000	\N
101	25003932200	2010	15.000	\N
101	25003932300	2010	4.000	\N
101	25003933200	2010	4.000	\N
101	25003933300	2010	5.000	\N
101	25003933400	2010	4.000	\N
101	25003934200	2010	4.000	\N
101	25003934300	2010	7.000	\N
101	25003935100	2010	6.000	\N
101	25003935200	2010	25.000	\N
101	25003935300	2010	25.000	\N
101	25005600100	2010	10.000	\N
101	25005600202	2010	34.000	\N
101	25005600203	2010	17.000	\N
101	25005600204	2010	35.000	\N
101	25005610100	2010	24.000	\N
101	25005610202	2010	16.000	\N
101	25005610203	2010	14.000	\N
101	25005610204	2010	27.000	\N
101	25005611101	2010	14.000	\N
101	25005611102	2010	40.000	\N
101	25005611201	2010	4.000	\N
101	25005611202	2010	16.000	\N
101	25005612100	2010	13.000	\N
101	25005612200	2010	32.000	\N
101	25005613100	2010	51.000	\N
101	25005613300	2010	34.000	\N
101	25005613400	2010	64.000	\N
101	25005613600	2010	62.000	\N
101	25005613700	2010	81.000	\N
101	25005613800	2010	138.000	\N
101	25005613901	2010	73.000	\N
101	25005613902	2010	59.000	\N
101	25005614000	2010	209.000	\N
101	25005614101	2010	75.000	\N
101	25005614102	2010	37.000	\N
101	25005615100	2010	9.000	\N
101	25005616100	2010	9.000	\N
101	25005617101	2010	21.000	\N
101	25005617102	2010	5.000	\N
101	25005630101	2010	47.000	\N
101	25005630102	2010	44.000	\N
101	25005630200	2010	18.000	\N
101	25005630300	2010	31.000	\N
101	25005630400	2010	23.000	\N
101	25005631100	2010	81.000	\N
101	25005631200	2010	75.000	\N
101	25005631300	2010	99.000	\N
101	25005631400	2010	217.000	\N
101	25005631500	2010	111.000	\N
101	25005631600	2010	293.000	\N
101	25005631700	2010	91.000	\N
101	25005631800	2010	98.000	\N
101	25005632100	2010	21.000	\N
101	25005632200	2010	37.000	\N
101	25005633100	2010	18.000	\N
101	25005633200	2010	17.000	\N
101	25005640100	2010	165.000	\N
101	25005640200	2010	132.000	\N
101	25005640300	2010	166.000	\N
101	25005640400	2010	23.000	\N
101	25005640500	2010	97.000	\N
101	25005640600	2010	103.000	\N
101	25005640700	2010	27.000	\N
101	25005640800	2010	153.000	\N
101	25005640901	2010	275.000	\N
101	25005641000	2010	87.000	\N
101	25005641101	2010	123.000	\N
101	25005641200	2010	63.000	\N
101	25005641300	2010	328.000	\N
101	25005641400	2010	78.000	\N
101	25005641500	2010	29.000	\N
101	25005641600	2010	9.000	\N
101	25005641700	2010	37.000	\N
101	25005641800	2010	12.000	\N
101	25005641900	2010	25.000	\N
101	25005642000	2010	107.000	\N
101	25005642100	2010	70.000	\N
101	25005642200	2010	70.000	\N
101	25005642300	2010	6.000	\N
101	25005642400	2010	18.000	\N
101	25005642500	2010	10.000	\N
101	25005644101	2010	4.000	\N
101	25005644102	2010	10.000	\N
101	25005644200	2010	14.000	\N
101	25005645101	2010	2.000	\N
101	25005645102	2010	4.000	\N
101	25005645103	2010	1.000	\N
101	25005646101	2010	4.000	\N
101	25005646103	2010	4.000	\N
101	25005646104	2010	1.000	\N
101	25005650101	2010	34.000	\N
101	25005650102	2010	297.000	\N
101	25005650201	2010	21.000	\N
101	25005650202	2010	53.000	\N
101	25005650300	2010	58.000	\N
101	25005650400	2010	107.000	\N
101	25005650500	2010	162.000	\N
101	25005650600	2010	236.000	\N
101	25005650700	2010	456.000	\N
101	25005650800	2010	458.000	\N
101	25005650900	2010	505.000	\N
101	25005651001	2010	55.000	\N
101	25005651002	2010	256.000	\N
101	25005651100	2010	334.000	\N
101	25005651200	2010	299.000	\N
101	25005651300	2010	186.000	\N
101	25005651400	2010	180.000	\N
101	25005651500	2010	309.000	\N
101	25005651600	2010	194.000	\N
101	25005651700	2010	133.000	\N
101	25005651800	2010	103.000	\N
101	25005651900	2010	269.000	\N
101	25005652000	2010	144.000	\N
101	25005652100	2010	85.000	\N
101	25005652200	2010	29.000	\N
101	25005652300	2010	156.000	\N
101	25005652400	2010	154.000	\N
101	25005652500	2010	236.000	\N
101	25005652600	2010	417.000	\N
101	25005652700	2010	421.000	\N
101	25005652800	2010	60.000	\N
101	25005653101	2010	27.000	\N
101	25005653102	2010	54.000	\N
101	25005653203	2010	19.000	\N
101	25005653204	2010	5.000	\N
101	25005653301	2010	15.000	\N
101	25005653304	2010	2.000	\N
101	25005654100	2010	6.000	\N
101	25005654200	2010	9.000	\N
101	25005655100	2010	12.000	\N
101	25005655200	2010	24.000	\N
101	25005655300	2010	5.000	\N
101	25005655400	2010	4.000	\N
101	25005985500	2010	45.000	\N
101	25005985600	2010	41.000	\N
101	25005990000	2010	0.000	\N
101	25007200100	2010	17.000	\N
101	25007200200	2010	11.000	\N
101	25007200300	2010	31.000	\N
101	25007200400	2010	12.000	\N
101	25007990000	2010	0.000	\N
101	25009201100	2010	14.000	\N
101	25009202101	2010	14.000	\N
101	25009202102	2010	43.000	\N
101	25009202200	2010	17.000	\N
101	25009203100	2010	27.000	\N
101	25009203200	2010	21.000	\N
101	25009203301	2010	9.000	\N
101	25009203302	2010	27.000	\N
101	25009204101	2010	292.000	\N
101	25009204102	2010	192.000	\N
101	25009204200	2010	416.000	\N
101	25009204300	2010	747.000	\N
101	25009204400	2010	46.000	\N
101	25009204500	2010	99.000	\N
101	25009204600	2010	203.000	\N
101	25009204701	2010	497.000	\N
101	25009204702	2010	251.000	\N
101	25009205100	2010	341.000	\N
101	25009205200	2010	691.000	\N
101	25009205300	2010	185.000	\N
101	25009205400	2010	59.000	\N
101	25009205500	2010	970.000	\N
101	25009205600	2010	452.000	\N
101	25009205700	2010	374.000	\N
101	25009205800	2010	634.000	\N
101	25009205900	2010	715.000	\N
101	25009206000	2010	993.000	\N
101	25009206100	2010	848.000	\N
101	25009206200	2010	1359.000	\N
101	25009206300	2010	859.000	\N
101	25009206400	2010	771.000	\N
101	25009206500	2010	880.000	\N
101	25009206600	2010	507.000	\N
101	25009206700	2010	611.000	\N
101	25009206800	2010	891.000	\N
101	25009206900	2010	534.000	\N
101	25009207000	2010	437.000	\N
101	25009207100	2010	965.000	\N
101	25009207200	2010	721.000	\N
101	25009208101	2010	65.000	\N
101	25009208102	2010	56.000	\N
101	25009208200	2010	54.000	\N
101	25009208300	2010	71.000	\N
101	25009208400	2010	52.000	\N
101	25009209100	2010	12.000	\N
101	25009209200	2010	10.000	\N
101	25009210100	2010	40.000	\N
101	25009210200	2010	28.000	\N
101	25009210300	2010	85.000	\N
101	25009210400	2010	97.000	\N
101	25009210500	2010	53.000	\N
101	25009210600	2010	193.000	\N
101	25009210700	2010	334.000	\N
101	25009210800	2010	356.000	\N
101	25009210900	2010	94.000	\N
101	25009211100	2010	21.000	\N
101	25009211200	2010	34.000	\N
101	25009211300	2010	24.000	\N
101	25009211401	2010	24.000	\N
101	25009211402	2010	42.000	\N
101	25009212100	2010	291.000	\N
101	25009213100	2010	14.000	\N
101	25009214100	2010	9.000	\N
101	25009215101	2010	6.000	\N
101	25009215102	2010	11.000	\N
101	25009216100	2010	23.000	\N
101	25009217100	2010	49.000	\N
101	25009217201	2010	57.000	\N
101	25009217202	2010	3.000	\N
101	25009217300	2010	153.000	\N
101	25009217400	2010	82.000	\N
101	25009217500	2010	36.000	\N
101	25009217600	2010	29.000	\N
101	25009218100	2010	4.000	\N
101	25009220101	2010	7.000	\N
101	25009220102	2010	6.000	\N
101	25009221100	2010	12.000	\N
101	25009221300	2010	4.000	\N
101	25009221400	2010	75.000	\N
101	25009221500	2010	15.000	\N
101	25009221600	2010	47.000	\N
101	25009221700	2010	39.000	\N
101	25009221800	2010	0.000	\N
101	25009221901	2010	1.000	\N
101	25009221902	2010	10.000	\N
101	25009222100	2010	3.000	\N
101	25009223100	2010	10.000	\N
101	25009223200	2010	20.000	\N
101	25009223300	2010	11.000	\N
101	25009250100	2010	919.000	\N
101	25009250200	2010	2393.000	\N
101	25009250300	2010	1119.000	\N
101	25009250400	2010	1649.000	\N
101	25009250500	2010	1705.000	\N
101	25009250600	2010	2608.000	\N
101	25009250700	2010	2146.000	\N
101	25009250800	2010	1820.000	\N
101	25009250900	2010	1023.000	\N
101	25009251000	2010	819.000	\N
101	25009251100	2010	1115.000	\N
101	25009251200	2010	585.000	\N
101	25009251300	2010	1933.000	\N
101	25009251400	2010	2148.000	\N
101	25009251500	2010	2157.000	\N
101	25009251600	2010	2413.000	\N
101	25009251700	2010	1745.000	\N
101	25009251800	2010	1468.000	\N
101	25009252101	2010	203.000	\N
101	25009252102	2010	93.000	\N
101	25009252201	2010	176.000	\N
101	25009252202	2010	46.000	\N
101	25009252300	2010	811.000	\N
101	25009252400	2010	1244.000	\N
101	25009252501	2010	492.000	\N
101	25009252502	2010	192.000	\N
101	25009252601	2010	304.000	\N
101	25009252602	2010	124.000	\N
101	25009252603	2010	112.000	\N
101	25009253100	2010	70.000	\N
101	25009253201	2010	35.000	\N
101	25009253202	2010	280.000	\N
101	25009253203	2010	11.000	\N
101	25009253204	2010	21.000	\N
101	25009253205	2010	9.000	\N
101	25009254100	2010	50.000	\N
101	25009254200	2010	89.000	\N
101	25009254301	2010	7.000	\N
101	25009254302	2010	9.000	\N
101	25009254401	2010	24.000	\N
101	25009254402	2010	146.000	\N
101	25009254403	2010	19.000	\N
101	25009260100	2010	579.000	\N
101	25009260200	2010	293.000	\N
101	25009260301	2010	94.000	\N
101	25009260302	2010	13.000	\N
101	25009260401	2010	86.000	\N
101	25009260402	2010	104.000	\N
101	25009260500	2010	95.000	\N
101	25009260600	2010	275.000	\N
101	25009260700	2010	241.000	\N
101	25009260800	2010	891.000	\N
101	25009260900	2010	541.000	\N
101	25009261000	2010	140.000	\N
101	25009261101	2010	20.000	\N
101	25009261102	2010	158.000	\N
101	25009262100	2010	18.000	\N
101	25009263100	2010	3.000	\N
101	25009264100	2010	13.000	\N
101	25009265101	2010	12.000	\N
101	25009265102	2010	12.000	\N
101	25009266100	2010	16.000	\N
101	25009266200	2010	15.000	\N
101	25009266300	2010	10.000	\N
101	25009266400	2010	13.000	\N
101	25009267101	2010	4.000	\N
101	25009267102	2010	12.000	\N
101	25009268100	2010	4.000	\N
101	25009268200	2010	17.000	\N
101	25009268300	2010	14.000	\N
101	25009268400	2010	10.000	\N
101	25009269100	2010	8.000	\N
101	25009270100	2010	9.000	\N
101	25009990100	2010	0.000	\N
101	25011040100	2010	5.000	\N
101	25011040200	2010	9.000	\N
101	25011040300	2010	17.000	\N
101	25011040400	2010	9.000	\N
101	25011040501	2010	36.000	\N
101	25011040502	2010	6.000	\N
101	25011040600	2010	12.000	\N
101	25011040701	2010	128.000	\N
101	25011040702	2010	32.000	\N
101	25011040800	2010	59.000	\N
101	25011040900	2010	22.000	\N
101	25011041000	2010	46.000	\N
101	25011041100	2010	15.000	\N
101	25011041200	2010	44.000	\N
101	25011041300	2010	63.000	\N
101	25011041400	2010	84.000	\N
101	25011041501	2010	2.000	\N
101	25011041502	2010	5.000	\N
101	25013800101	2010	639.000	\N
101	25013800102	2010	520.000	\N
101	25013800201	2010	1048.000	\N
101	25013800202	2010	123.000	\N
101	25013800300	2010	834.000	\N
101	25013800400	2010	1565.000	\N
101	25013800500	2010	1010.000	\N
101	25013800600	2010	1189.000	\N
101	25013800700	2010	1720.000	\N
101	25013800800	2010	678.000	\N
101	25013800900	2010	1287.000	\N
101	25013801101	2010	585.000	\N
101	25013801102	2010	331.000	\N
101	25013801200	2010	754.000	\N
101	25013801300	2010	663.000	\N
101	25013801401	2010	914.000	\N
101	25013801402	2010	261.000	\N
101	25013801501	2010	723.000	\N
101	25013801502	2010	662.000	\N
101	25013801503	2010	567.000	\N
101	25013801601	2010	186.000	\N
101	25013801602	2010	371.000	\N
101	25013801603	2010	235.000	\N
101	25013801604	2010	55.000	\N
101	25013801605	2010	269.000	\N
101	25013801700	2010	793.000	\N
101	25013801800	2010	1083.000	\N
101	25013801901	2010	1146.000	\N
101	25013801902	2010	1047.000	\N
101	25013802000	2010	1058.000	\N
101	25013802100	2010	1012.000	\N
101	25013802200	2010	883.000	\N
101	25013802300	2010	1716.000	\N
101	25013802400	2010	51.000	\N
101	25013802500	2010	260.000	\N
101	25013802601	2010	1066.000	\N
101	25013802602	2010	58.000	\N
101	25013810100	2010	35.000	\N
101	25013810200	2010	11.000	\N
101	25013810300	2010	19.000	\N
101	25013810403	2010	73.000	\N
101	25013810404	2010	51.000	\N
101	25013810412	2010	9.000	\N
101	25013810414	2010	93.000	\N
101	25013810601	2010	174.000	\N
101	25013810602	2010	18.000	\N
101	25013810700	2010	309.000	\N
101	25013810800	2010	299.000	\N
101	25013810901	2010	282.000	\N
101	25013810902	2010	406.000	\N
101	25013811000	2010	78.000	\N
101	25013811101	2010	383.000	\N
101	25013811102	2010	583.000	\N
101	25013811200	2010	93.000	\N
101	25013811301	2010	180.000	\N
101	25013811302	2010	116.000	\N
101	25013811400	2010	1087.000	\N
101	25013811500	2010	943.000	\N
101	25013811600	2010	1712.000	\N
101	25013811700	2010	662.000	\N
101	25013811800	2010	1201.000	\N
101	25013811900	2010	130.000	\N
101	25013812001	2010	845.000	\N
101	25013812002	2010	906.000	\N
101	25013812101	2010	126.000	\N
101	25013812103	2010	895.000	\N
101	25013812104	2010	806.000	\N
101	25013812201	2010	152.000	\N
101	25013812202	2010	239.000	\N
101	25013812300	2010	381.000	\N
101	25013812401	2010	25.000	\N
101	25013812403	2010	58.000	\N
101	25013812404	2010	71.000	\N
101	25013812500	2010	192.000	\N
101	25013812600	2010	57.000	\N
101	25013812701	2010	144.000	\N
101	25013812702	2010	283.000	\N
101	25013812800	2010	141.000	\N
101	25013812901	2010	16.000	\N
101	25013812902	2010	34.000	\N
101	25013812903	2010	30.000	\N
101	25013813000	2010	15.000	\N
101	25013813101	2010	23.000	\N
101	25013813102	2010	13.000	\N
101	25013813204	2010	20.000	\N
101	25013813205	2010	34.000	\N
101	25013813206	2010	21.000	\N
101	25013813207	2010	60.000	\N
101	25013813208	2010	17.000	\N
101	25013813209	2010	35.000	\N
101	25013813301	2010	51.000	\N
101	25013813303	2010	9.000	\N
101	25013813304	2010	4.000	\N
101	25013813401	2010	40.000	\N
101	25013813403	2010	7.000	\N
101	25013813404	2010	12.000	\N
101	25013813500	2010	14.000	\N
101	25013813601	2010	49.000	\N
101	25013813602	2010	12.000	\N
101	25013813701	2010	8.000	\N
101	25013813702	2010	2.000	\N
101	25013813801	2010	16.000	\N
101	25013813802	2010	3.000	\N
101	25015820101	2010	38.000	\N
101	25015820102	2010	92.000	\N
101	25015820202	2010	9.000	\N
101	25015820203	2010	69.000	\N
101	25015820204	2010	17.000	\N
101	25015820300	2010	96.000	\N
101	25015820400	2010	153.000	\N
101	25015820500	2010	91.000	\N
101	25015820600	2010	40.000	\N
101	25015820700	2010	135.000	\N
101	25015820801	2010	215.000	\N
101	25015820802	2010	22.000	\N
101	25015820900	2010	36.000	\N
101	25015821000	2010	28.000	\N
101	25015821100	2010	84.000	\N
101	25015821200	2010	33.000	\N
101	25015821300	2010	45.000	\N
101	25015821400	2010	36.000	\N
101	25015821500	2010	13.000	\N
101	25015821601	2010	108.000	\N
101	25015821602	2010	110.000	\N
101	25015821700	2010	39.000	\N
101	25015821901	2010	44.000	\N
101	25015821903	2010	173.000	\N
101	25015821904	2010	57.000	\N
101	25015822000	2010	34.000	\N
101	25015822200	2010	59.000	\N
101	25015822300	2010	67.000	\N
101	25015822401	2010	23.000	\N
101	25015822402	2010	80.000	\N
101	25015822500	2010	22.000	\N
101	25015822601	2010	7.000	\N
101	25015822603	2010	3.000	\N
101	25015822605	2010	3.000	\N
101	25015822606	2010	8.000	\N
101	25015822700	2010	6.000	\N
101	25017300100	2010	9.000	\N
101	25017301101	2010	16.000	\N
101	25017301102	2010	11.000	\N
101	25017310100	2010	522.000	\N
101	25017310200	2010	455.000	\N
101	25017310300	2010	551.000	\N
101	25017310400	2010	435.000	\N
101	25017310500	2010	172.000	\N
101	25017310601	2010	168.000	\N
101	25017310602	2010	200.000	\N
101	25017310700	2010	465.000	\N
101	25017311100	2010	363.000	\N
101	25017311200	2010	250.000	\N
101	25017311300	2010	247.000	\N
101	25017311400	2010	361.000	\N
101	25017311500	2010	111.000	\N
101	25017311600	2010	248.000	\N
101	25017311700	2010	289.000	\N
101	25017311800	2010	284.000	\N
101	25017311900	2010	270.000	\N
101	25017312000	2010	241.000	\N
101	25017312100	2010	291.000	\N
101	25017312200	2010	255.000	\N
101	25017312300	2010	177.000	\N
101	25017312400	2010	404.000	\N
101	25017312501	2010	147.000	\N
101	25017312502	2010	86.000	\N
101	25017313101	2010	34.000	\N
101	25017313102	2010	31.000	\N
101	25017314101	2010	59.000	\N
101	25017314102	2010	63.000	\N
101	25017314200	2010	57.000	\N
101	25017314301	2010	116.000	\N
101	25017314302	2010	9.000	\N
101	25017315100	2010	28.000	\N
101	25017315200	2010	33.000	\N
101	25017315401	2010	4.000	\N
101	25017315402	2010	9.000	\N
101	25017315403	2010	2.000	\N
101	25017315500	2010	26.000	\N
101	25017316101	2010	17.000	\N
101	25017316102	2010	22.000	\N
101	25017316201	2010	21.000	\N
101	25017316202	2010	20.000	\N
101	25017316300	2010	53.000	\N
101	25017316400	2010	34.000	\N
101	25017316500	2010	40.000	\N
101	25017317101	2010	13.000	\N
101	25017317102	2010	20.000	\N
101	25017317103	2010	10.000	\N
101	25017317201	2010	3.000	\N
101	25017317202	2010	5.000	\N
101	25017317203	2010	7.000	\N
101	25017317301	2010	16.000	\N
101	25017317302	2010	31.000	\N
101	25017318100	2010	16.000	\N
101	25017318200	2010	6.000	\N
101	25017318300	2010	13.000	\N
101	25017318400	2010	4.000	\N
101	25017320102	2010	9.000	\N
101	25017320103	2010	11.000	\N
101	25017320104	2010	7.000	\N
101	25017321100	2010	129.000	\N
101	25017321200	2010	137.000	\N
101	25017321300	2010	546.000	\N
101	25017321400	2010	53.000	\N
101	25017321500	2010	521.000	\N
101	25017321600	2010	191.000	\N
101	25017322100	2010	45.000	\N
101	25017322200	2010	34.000	\N
101	25017322300	2010	79.000	\N
101	25017322400	2010	34.000	\N
101	25017323100	2010	15.000	\N
101	25017324101	2010	1.000	\N
101	25017324102	2010	5.000	\N
101	25017325100	2010	133.000	\N
101	25017326101	2010	14.000	\N
101	25017326102	2010	14.000	\N
101	25017327101	2010	5.000	\N
101	25017327102	2010	9.000	\N
101	25017327103	2010	7.000	\N
101	25017328100	2010	0.000	\N
101	25017330100	2010	10.000	\N
101	25017330200	2010	19.000	\N
101	25017331101	2010	15.000	\N
101	25017331102	2010	16.000	\N
101	25017331200	2010	17.000	\N
101	25017331300	2010	30.000	\N
101	25017332100	2010	11.000	\N
101	25017332200	2010	72.000	\N
101	25017332300	2010	27.000	\N
101	25017332400	2010	11.000	\N
101	25017333100	2010	44.000	\N
101	25017333200	2010	44.000	\N
101	25017333300	2010	112.000	\N
101	25017333400	2010	99.000	\N
101	25017333501	2010	61.000	\N
101	25017333502	2010	91.000	\N
101	25017333600	2010	60.000	\N
101	25017334100	2010	24.000	\N
101	25017334200	2010	13.000	\N
101	25017334300	2010	13.000	\N
101	25017334400	2010	15.000	\N
101	25017335100	2010	32.000	\N
101	25017335200	2010	17.000	\N
101	25017335301	2010	31.000	\N
101	25017335302	2010	22.000	\N
101	25017335400	2010	22.000	\N
101	25017336100	2010	13.000	\N
101	25017336200	2010	12.000	\N
101	25017336300	2010	30.000	\N
101	25017336401	2010	43.000	\N
101	25017336402	2010	37.000	\N
101	25017337101	2010	24.000	\N
101	25017337102	2010	17.000	\N
101	25017337201	2010	19.000	\N
101	25017337202	2010	42.000	\N
101	25017337300	2010	60.000	\N
101	25017338100	2010	6.000	\N
101	25017338200	2010	17.000	\N
101	25017338300	2010	2.000	\N
101	25017338400	2010	12.000	\N
101	25017338500	2010	3.000	\N
101	25017339100	2010	24.000	\N
101	25017339200	2010	17.000	\N
101	25017339300	2010	29.000	\N
101	25017339400	2010	45.000	\N
101	25017339500	2010	35.000	\N
101	25017339600	2010	90.000	\N
101	25017339700	2010	79.000	\N
101	25017339801	2010	76.000	\N
101	25017339802	2010	98.000	\N
101	25017339900	2010	66.000	\N
101	25017340000	2010	51.000	\N
101	25017340100	2010	44.000	\N
101	25017341101	2010	43.000	\N
101	25017341102	2010	80.000	\N
101	25017341200	2010	160.000	\N
101	25017341300	2010	69.000	\N
101	25017341400	2010	230.000	\N
101	25017341500	2010	291.000	\N
101	25017341600	2010	97.000	\N
101	25017341700	2010	74.000	\N
101	25017341800	2010	334.000	\N
101	25017341901	2010	30.000	\N
101	25017341902	2010	286.000	\N
101	25017342101	2010	377.000	\N
101	25017342102	2010	247.000	\N
101	25017342201	2010	419.000	\N
101	25017342202	2010	281.000	\N
101	25017342300	2010	703.000	\N
101	25017342400	2010	572.000	\N
101	25017342500	2010	702.000	\N
101	25017342600	2010	623.000	\N
101	25017350103	2010	50.000	\N
101	25017350104	2010	879.000	\N
101	25017350200	2010	433.000	\N
101	25017350300	2010	80.000	\N
101	25017350400	2010	22.000	\N
101	25017350500	2010	6.000	\N
101	25017350600	2010	37.000	\N
101	25017350700	2010	200.000	\N
101	25017350800	2010	15.000	\N
101	25017350900	2010	16.000	\N
101	25017351000	2010	70.000	\N
101	25017351100	2010	87.000	\N
101	25017351203	2010	42.000	\N
101	25017351204	2010	125.000	\N
101	25017351300	2010	97.000	\N
101	25017351403	2010	647.000	\N
101	25017351404	2010	415.000	\N
101	25017351500	2010	140.000	\N
101	25017352101	2010	40.000	\N
101	25017352102	2010	31.000	\N
101	25017352200	2010	53.000	\N
101	25017352300	2010	56.000	\N
101	25017352400	2010	129.000	\N
101	25017352500	2010	93.000	\N
101	25017352600	2010	76.000	\N
101	25017352700	2010	62.000	\N
101	25017352800	2010	74.000	\N
101	25017352900	2010	21.000	\N
101	25017353000	2010	82.000	\N
101	25017353101	2010	77.000	\N
101	25017353102	2010	78.000	\N
101	25017353200	2010	49.000	\N
101	25017353300	2010	37.000	\N
101	25017353400	2010	71.000	\N
101	25017353500	2010	32.000	\N
101	25017353600	2010	37.000	\N
101	25017353700	2010	61.000	\N
101	25017353800	2010	24.000	\N
101	25017353900	2010	72.000	\N
101	25017354000	2010	30.000	\N
101	25017354100	2010	13.000	\N
101	25017354200	2010	6.000	\N
101	25017354300	2010	70.000	\N
101	25017354400	2010	4.000	\N
101	25017354500	2010	11.000	\N
101	25017354600	2010	38.000	\N
101	25017354700	2010	19.000	\N
101	25017354800	2010	15.000	\N
101	25017354900	2010	180.000	\N
101	25017355000	2010	25.000	\N
101	25017356100	2010	18.000	\N
101	25017356300	2010	53.000	\N
101	25017356400	2010	19.000	\N
101	25017356500	2010	50.000	\N
101	25017356601	2010	22.000	\N
101	25017356602	2010	23.000	\N
101	25017356701	2010	28.000	\N
101	25017356702	2010	26.000	\N
101	25017357100	2010	8.000	\N
101	25017357200	2010	7.000	\N
101	25017357300	2010	12.000	\N
101	25017357400	2010	18.000	\N
101	25017357500	2010	10.000	\N
101	25017357600	2010	26.000	\N
101	25017357700	2010	26.000	\N
101	25017357800	2010	15.000	\N
101	25017358100	2010	3.000	\N
101	25017358300	2010	12.000	\N
101	25017358400	2010	13.000	\N
101	25017358500	2010	13.000	\N
101	25017358600	2010	18.000	\N
101	25017358700	2010	10.000	\N
101	25017359100	2010	33.000	\N
101	25017359300	2010	11.000	\N
101	25017360100	2010	33.000	\N
101	25017360200	2010	13.000	\N
101	25017361100	2010	8.000	\N
101	25017361200	2010	86.000	\N
101	25017361300	2010	44.000	\N
101	25017362100	2010	12.000	\N
101	25017363102	2010	49.000	\N
101	25017363103	2010	11.000	\N
101	25017363104	2010	30.000	\N
101	25017363201	2010	4.000	\N
101	25017363202	2010	10.000	\N
101	25017364101	2010	53.000	\N
101	25017364102	2010	27.000	\N
101	25017365100	2010	10.000	\N
101	25017365201	2010	14.000	\N
101	25017365202	2010	23.000	\N
101	25017366100	2010	10.000	\N
101	25017366201	2010	4.000	\N
101	25017366202	2010	16.000	\N
101	25017367100	2010	6.000	\N
101	25017367200	2010	30.000	\N
101	25017368101	2010	66.000	\N
101	25017368102	2010	108.000	\N
101	25017368200	2010	151.000	\N
101	25017368300	2010	482.000	\N
101	25017368400	2010	235.000	\N
101	25017368500	2010	453.000	\N
101	25017368600	2010	659.000	\N
101	25017368700	2010	447.000	\N
101	25017368800	2010	540.000	\N
101	25017368901	2010	76.000	\N
101	25017368902	2010	130.000	\N
101	25017369000	2010	13.000	\N
101	25017369100	2010	73.000	\N
101	25017370101	2010	117.000	\N
101	25017370102	2010	113.000	\N
101	25017370201	2010	24.000	\N
101	25017370202	2010	32.000	\N
101	25017370300	2010	83.000	\N
101	25017370400	2010	50.000	\N
101	25017373100	2010	59.000	\N
101	25017373200	2010	87.000	\N
101	25017373300	2010	20.000	\N
101	25017373400	2010	35.000	\N
101	25017373500	2010	22.000	\N
101	25017373600	2010	51.000	\N
101	25017373700	2010	8.000	\N
101	25017373800	2010	28.000	\N
101	25017373900	2010	26.000	\N
101	25017374000	2010	46.000	\N
101	25017374100	2010	65.000	\N
101	25017374200	2010	15.000	\N
101	25017374300	2010	6.000	\N
101	25017374400	2010	16.000	\N
101	25017374500	2010	47.000	\N
101	25017374600	2010	118.000	\N
101	25017374700	2010	40.000	\N
101	25017374800	2010	21.000	\N
101	25017382100	2010	19.000	\N
101	25017382200	2010	25.000	\N
101	25017382300	2010	25.000	\N
101	25017382400	2010	27.000	\N
101	25017382500	2010	32.000	\N
101	25017382601	2010	68.000	\N
101	25017382602	2010	19.000	\N
101	25017383101	2010	339.000	\N
101	25017383102	2010	856.000	\N
101	25017383200	2010	714.000	\N
101	25017383300	2010	179.000	\N
101	25017383400	2010	304.000	\N
101	25017383501	2010	273.000	\N
101	25017383502	2010	99.000	\N
101	25017383600	2010	172.000	\N
101	25017383700	2010	112.000	\N
101	25017383800	2010	104.000	\N
101	25017383901	2010	39.000	\N
101	25017383902	2010	56.000	\N
101	25017384001	2010	24.000	\N
101	25017384002	2010	110.000	\N
101	25017385100	2010	45.000	\N
101	25017385201	2010	69.000	\N
101	25017385202	2010	87.000	\N
101	25017386100	2010	9.000	\N
101	25017387100	2010	10.000	\N
101	25017387201	2010	21.000	\N
101	25017387202	2010	13.000	\N
101	25017388100	2010	18.000	\N
101	25017388200	2010	59.000	\N
101	25017388300	2010	779.000	\N
101	25017980000	2010	0.000	\N
101	25019950100	2010	3.000	\N
101	25019950200	2010	136.000	\N
101	25019950307	2010	4.000	\N
101	25019950400	2010	35.000	\N
101	25019950500	2010	3.000	\N
101	25019990000	2010	0.000	\N
101	25021400100	2010	57.000	\N
101	25021400200	2010	70.000	\N
101	25021400300	2010	37.000	\N
101	25021400400	2010	51.000	\N
101	25021400500	2010	32.000	\N
101	25021400600	2010	33.000	\N
101	25021400700	2010	36.000	\N
101	25021400800	2010	29.000	\N
101	25021400900	2010	50.000	\N
101	25021401000	2010	59.000	\N
101	25021401100	2010	22.000	\N
101	25021401200	2010	63.000	\N
101	25021402101	2010	33.000	\N
101	25021402102	2010	110.000	\N
101	25021402200	2010	41.000	\N
101	25021402300	2010	23.000	\N
101	25021402400	2010	101.000	\N
101	25021402500	2010	20.000	\N
101	25021403100	2010	8.000	\N
101	25021403300	2010	7.000	\N
101	25021403400	2010	19.000	\N
101	25021403500	2010	23.000	\N
101	25021404100	2010	32.000	\N
101	25021404201	2010	6.000	\N
101	25021404202	2010	42.000	\N
101	25021404301	2010	7.000	\N
101	25021404302	2010	5.000	\N
101	25021404400	2010	55.000	\N
101	25021405100	2010	12.000	\N
101	25021406101	2010	13.000	\N
101	25021406102	2010	12.000	\N
101	25021407100	2010	14.000	\N
101	25021408101	2010	9.000	\N
101	25021408102	2010	21.000	\N
101	25021409101	2010	176.000	\N
101	25021409102	2010	4.000	\N
101	25021410100	2010	16.000	\N
101	25021410300	2010	11.000	\N
101	25021410400	2010	34.000	\N
101	25021411100	2010	56.000	\N
101	25021411200	2010	13.000	\N
101	25021411301	2010	12.000	\N
101	25021411302	2010	46.000	\N
101	25021412100	2010	10.000	\N
101	25021412200	2010	3.000	\N
101	25021412300	2010	14.000	\N
101	25021413100	2010	35.000	\N
101	25021413200	2010	70.000	\N
101	25021413300	2010	27.000	\N
101	25021413401	2010	27.000	\N
101	25021413402	2010	44.000	\N
101	25021413500	2010	100.000	\N
101	25021414100	2010	26.000	\N
101	25021414200	2010	29.000	\N
101	25021414300	2010	6.000	\N
101	25021415101	2010	10.000	\N
101	25021415102	2010	49.000	\N
101	25021415200	2010	61.000	\N
101	25021415300	2010	13.000	\N
101	25021416101	2010	16.000	\N
101	25021416102	2010	29.000	\N
101	25021416200	2010	111.000	\N
101	25021416300	2010	35.000	\N
101	25021416400	2010	12.000	\N
101	25021417100	2010	21.000	\N
101	25021417200	2010	63.000	\N
101	25021417300	2010	19.000	\N
101	25021417400	2010	13.000	\N
101	25021417501	2010	27.000	\N
101	25021417502	2010	37.000	\N
101	25021417601	2010	42.000	\N
101	25021417602	2010	34.000	\N
101	25021417701	2010	38.000	\N
101	25021417702	2010	4.000	\N
101	25021417801	2010	26.000	\N
101	25021417802	2010	36.000	\N
101	25021417901	2010	53.000	\N
101	25021417902	2010	62.000	\N
101	25021418002	2010	96.000	\N
101	25021418003	2010	40.000	\N
101	25021418004	2010	59.000	\N
101	25021418101	2010	33.000	\N
101	25021418102	2010	78.000	\N
101	25021418200	2010	60.000	\N
101	25021419100	2010	37.000	\N
101	25021419200	2010	37.000	\N
101	25021419300	2010	41.000	\N
101	25021419400	2010	22.000	\N
101	25021419500	2010	11.000	\N
101	25021419600	2010	27.000	\N
101	25021419700	2010	11.000	\N
101	25021419800	2010	19.000	\N
101	25021420100	2010	171.000	\N
101	25021420201	2010	56.000	\N
101	25021420202	2010	131.000	\N
101	25021420301	2010	135.000	\N
101	25021420302	2010	99.000	\N
101	25021421100	2010	90.000	\N
101	25021421200	2010	57.000	\N
101	25021422100	2010	17.000	\N
101	25021422200	2010	30.000	\N
101	25021422301	2010	12.000	\N
101	25021422302	2010	49.000	\N
101	25021422400	2010	32.000	\N
101	25021422501	2010	52.000	\N
101	25021422502	2010	49.000	\N
101	25021422600	2010	36.000	\N
101	25021422700	2010	5.000	\N
101	25021422800	2010	12.000	\N
101	25021423100	2010	2.000	\N
101	25021440100	2010	28.000	\N
101	25021441202	2010	0.000	\N
101	25021441203	2010	4.000	\N
101	25021441204	2010	13.000	\N
101	25021442101	2010	21.000	\N
101	25021442102	2010	11.000	\N
101	25021442103	2010	11.000	\N
101	25021442201	2010	6.000	\N
101	25021442202	2010	52.000	\N
101	25021443101	2010	56.000	\N
101	25021443102	2010	49.000	\N
101	25021456101	2010	19.000	\N
101	25021456102	2010	31.000	\N
101	25021456200	2010	3.000	\N
101	25021456301	2010	32.000	\N
101	25021456302	2010	30.000	\N
101	25021456401	2010	29.000	\N
101	25021456402	2010	38.000	\N
101	25021457100	2010	35.000	\N
101	25021457200	2010	13.000	\N
101	25023500101	2010	9.000	\N
101	25023500103	2010	1.000	\N
101	25023500104	2010	15.000	\N
101	25023501101	2010	1.000	\N
101	25023501102	2010	9.000	\N
101	25023501201	2010	0.000	\N
101	25023501202	2010	12.000	\N
101	25023502101	2010	17.000	\N
101	25023502102	2010	36.000	\N
101	25023502200	2010	17.000	\N
101	25023503101	2010	13.000	\N
101	25023503102	2010	7.000	\N
101	25023504101	2010	3.000	\N
101	25023504102	2010	10.000	\N
101	25023505101	2010	2.000	\N
101	25023505102	2010	2.000	\N
101	25023505200	2010	11.000	\N
101	25023506101	2010	14.000	\N
101	25023506102	2010	31.000	\N
101	25023506202	2010	5.000	\N
101	25023506203	2010	4.000	\N
101	25023506204	2010	14.000	\N
101	25023507101	2010	7.000	\N
101	25023507103	2010	6.000	\N
101	25023507104	2010	8.000	\N
101	25023508101	2010	12.000	\N
101	25023508102	2010	13.000	\N
101	25023508200	2010	11.000	\N
101	25023509101	2010	5.000	\N
101	25023509102	2010	8.000	\N
101	25023510100	2010	99.000	\N
101	25023510200	2010	179.000	\N
101	25023510300	2010	175.000	\N
101	25023510400	2010	217.000	\N
101	25023510501	2010	64.000	\N
101	25023510502	2010	182.000	\N
101	25023510503	2010	81.000	\N
101	25023510600	2010	31.000	\N
101	25023510700	2010	130.000	\N
101	25023510800	2010	337.000	\N
101	25023510900	2010	133.000	\N
101	25023511000	2010	161.000	\N
101	25023511100	2010	122.000	\N
101	25023511200	2010	220.000	\N
101	25023511301	2010	234.000	\N
101	25023511302	2010	110.000	\N
101	25023511400	2010	252.000	\N
101	25023511500	2010	248.000	\N
101	25023511600	2010	262.000	\N
101	25023511701	2010	104.000	\N
101	25023511702	2010	25.000	\N
101	25023520100	2010	14.000	\N
101	25023520201	2010	38.000	\N
101	25023520202	2010	25.000	\N
101	25023521101	2010	18.000	\N
101	25023521102	2010	16.000	\N
101	25023521201	2010	18.000	\N
101	25023521202	2010	5.000	\N
101	25023522101	2010	4.000	\N
101	25023522102	2010	10.000	\N
101	25023523100	2010	9.000	\N
101	25023523201	2010	7.000	\N
101	25023523202	2010	15.000	\N
101	25023524101	2010	9.000	\N
101	25023524102	2010	15.000	\N
101	25023525101	2010	37.000	\N
101	25023525104	2010	10.000	\N
101	25023525203	2010	14.000	\N
101	25023525204	2010	11.000	\N
101	25023525300	2010	65.000	\N
101	25023526100	2010	8.000	\N
101	25023530100	2010	33.000	\N
101	25023530200	2010	27.000	\N
101	25023530300	2010	15.000	\N
101	25023530400	2010	5.000	\N
101	25023530500	2010	10.000	\N
101	25023530600	2010	22.000	\N
101	25023530700	2010	13.000	\N
101	25023530801	2010	11.000	\N
101	25023530802	2010	6.000	\N
101	25023530901	2010	24.000	\N
101	25023530902	2010	12.000	\N
101	25023540101	2010	0.000	\N
101	25023540102	2010	4.000	\N
101	25023540103	2010	2.000	\N
101	25023541100	2010	2.000	\N
101	25023542101	2010	7.000	\N
101	25023542102	2010	2.000	\N
101	25023542200	2010	2.000	\N
101	25023542300	2010	17.000	\N
101	25023543100	2010	3.000	\N
101	25023544100	2010	12.000	\N
101	25023544200	2010	16.000	\N
101	25023545100	2010	24.000	\N
101	25023545200	2010	36.000	\N
101	25023545300	2010	17.000	\N
101	25023545400	2010	23.000	\N
101	25023560100	2010	12.000	\N
101	25023561100	2010	5.000	\N
101	25023561200	2010	38.000	\N
101	25023990003	2010	0.000	\N
101	25025000100	2010	263.000	\N
101	25025000201	2010	139.000	\N
101	25025000202	2010	220.000	\N
101	25025000301	2010	60.000	\N
101	25025000302	2010	26.000	\N
101	25025000401	2010	87.000	\N
101	25025000402	2010	45.000	\N
101	25025000502	2010	91.000	\N
101	25025000503	2010	26.000	\N
101	25025000504	2010	72.000	\N
101	25025000601	2010	95.000	\N
101	25025000602	2010	259.000	\N
101	25025000701	2010	109.000	\N
101	25025000703	2010	42.000	\N
101	25025000704	2010	156.000	\N
101	25025000802	2010	596.000	\N
101	25025000803	2010	108.000	\N
101	25025010103	2010	64.000	\N
101	25025010104	2010	72.000	\N
101	25025010203	2010	145.000	\N
101	25025010204	2010	44.000	\N
101	25025010300	2010	215.000	\N
101	25025010403	2010	95.000	\N
101	25025010404	2010	93.000	\N
101	25025010405	2010	116.000	\N
101	25025010408	2010	32.000	\N
101	25025010500	2010	61.000	\N
101	25025010600	2010	27.000	\N
101	25025010701	2010	22.000	\N
101	25025010702	2010	23.000	\N
101	25025010801	2010	17.000	\N
101	25025010802	2010	19.000	\N
101	25025020101	2010	12.000	\N
101	25025020200	2010	36.000	\N
101	25025020301	2010	19.000	\N
101	25025020302	2010	9.000	\N
101	25025020303	2010	35.000	\N
101	25025030100	2010	15.000	\N
101	25025030200	2010	4.000	\N
101	25025030300	2010	56.000	\N
101	25025030400	2010	16.000	\N
101	25025030500	2010	19.000	\N
101	25025040100	2010	12.000	\N
101	25025040200	2010	131.000	\N
101	25025040300	2010	141.000	\N
101	25025040401	2010	42.000	\N
101	25025040600	2010	4.000	\N
101	25025040801	2010	204.000	\N
101	25025050101	2010	1266.000	\N
101	25025050200	2010	1422.000	\N
101	25025050300	2010	424.000	\N
101	25025050400	2010	406.000	\N
101	25025050500	2010	298.000	\N
101	25025050600	2010	478.000	\N
101	25025050700	2010	1417.000	\N
101	25025050901	2010	931.000	\N
101	25025051000	2010	508.000	\N
101	25025051101	2010	669.000	\N
101	25025051200	2010	227.000	\N
101	25025060101	2010	9.000	\N
101	25025060200	2010	2.000	\N
101	25025060301	2010	5.000	\N
101	25025060400	2010	24.000	\N
101	25025060501	2010	17.000	\N
101	25025060600	2010	11.000	\N
101	25025060700	2010	456.000	\N
101	25025060800	2010	35.000	\N
101	25025061000	2010	386.000	\N
101	25025061101	2010	331.000	\N
101	25025061200	2010	29.000	\N
101	25025070101	2010	79.000	\N
101	25025070200	2010	46.000	\N
101	25025070300	2010	27.000	\N
101	25025070402	2010	75.000	\N
101	25025070500	2010	419.000	\N
101	25025070600	2010	34.000	\N
101	25025070700	2010	31.000	\N
101	25025070800	2010	84.000	\N
101	25025070900	2010	319.000	\N
101	25025071101	2010	234.000	\N
101	25025071201	2010	371.000	\N
101	25025080100	2010	187.000	\N
101	25025080300	2010	245.000	\N
101	25025080401	2010	368.000	\N
101	25025080500	2010	481.000	\N
101	25025080601	2010	344.000	\N
101	25025080801	2010	602.000	\N
101	25025080900	2010	89.000	\N
101	25025081001	2010	388.000	\N
101	25025081100	2010	185.000	\N
101	25025081200	2010	726.000	\N
101	25025081300	2010	998.000	\N
101	25025081400	2010	238.000	\N
101	25025081500	2010	182.000	\N
101	25025081700	2010	330.000	\N
101	25025081800	2010	350.000	\N
101	25025081900	2010	376.000	\N
101	25025082000	2010	243.000	\N
101	25025082100	2010	883.000	\N
101	25025090100	2010	485.000	\N
101	25025090200	2010	481.000	\N
101	25025090300	2010	515.000	\N
101	25025090400	2010	477.000	\N
101	25025090600	2010	194.000	\N
101	25025090700	2010	177.000	\N
101	25025090901	2010	332.000	\N
101	25025091001	2010	111.000	\N
101	25025091100	2010	190.000	\N
101	25025091200	2010	335.000	\N
101	25025091300	2010	256.000	\N
101	25025091400	2010	414.000	\N
101	25025091500	2010	460.000	\N
101	25025091600	2010	263.000	\N
101	25025091700	2010	234.000	\N
101	25025091800	2010	366.000	\N
101	25025091900	2010	320.000	\N
101	25025092000	2010	467.000	\N
101	25025092101	2010	299.000	\N
101	25025092200	2010	172.000	\N
101	25025092300	2010	201.000	\N
101	25025092400	2010	625.000	\N
101	25025100100	2010	697.000	\N
101	25025100200	2010	159.000	\N
101	25025100300	2010	138.000	\N
101	25025100400	2010	159.000	\N
101	25025100500	2010	374.000	\N
101	25025100601	2010	172.000	\N
101	25025100603	2010	34.000	\N
101	25025100700	2010	30.000	\N
101	25025100800	2010	103.000	\N
101	25025100900	2010	105.000	\N
101	25025101001	2010	260.000	\N
101	25025101002	2010	265.000	\N
101	25025101101	2010	241.000	\N
101	25025101102	2010	189.000	\N
101	25025110103	2010	785.000	\N
101	25025110201	2010	297.000	\N
101	25025110301	2010	286.000	\N
101	25025110401	2010	529.000	\N
101	25025110403	2010	366.000	\N
101	25025110501	2010	187.000	\N
101	25025110502	2010	310.000	\N
101	25025110601	2010	19.000	\N
101	25025110607	2010	148.000	\N
101	25025120103	2010	12.000	\N
101	25025120104	2010	141.000	\N
101	25025120105	2010	22.000	\N
101	25025120201	2010	346.000	\N
101	25025120301	2010	815.000	\N
101	25025120400	2010	162.000	\N
101	25025120500	2010	507.000	\N
101	25025120600	2010	93.000	\N
101	25025120700	2010	130.000	\N
101	25025130100	2010	66.000	\N
101	25025130200	2010	21.000	\N
101	25025130300	2010	77.000	\N
101	25025130402	2010	84.000	\N
101	25025130404	2010	136.000	\N
101	25025130406	2010	450.000	\N
101	25025140102	2010	339.000	\N
101	25025140105	2010	399.000	\N
101	25025140106	2010	271.000	\N
101	25025140107	2010	199.000	\N
101	25025140201	2010	157.000	\N
101	25025140202	2010	467.000	\N
101	25025140300	2010	627.000	\N
101	25025140400	2010	475.000	\N
101	25025160101	2010	3057.000	\N
101	25025160200	2010	2224.000	\N
101	25025160300	2010	191.000	\N
101	25025160400	2010	1025.000	\N
101	25025160501	2010	1884.000	\N
101	25025160502	2010	1390.000	\N
101	25025160601	2010	713.000	\N
101	25025160602	2010	919.000	\N
101	25025170100	2010	927.000	\N
101	25025170200	2010	403.000	\N
101	25025170300	2010	455.000	\N
101	25025170400	2010	482.000	\N
101	25025170501	2010	251.000	\N
101	25025170502	2010	61.000	\N
101	25025170601	2010	771.000	\N
101	25025170701	2010	173.000	\N
101	25025170702	2010	1270.000	\N
101	25025170800	2010	506.000	\N
101	25025180101	2010	103.000	\N
101	25025180200	2010	80.000	\N
101	25025180301	2010	20.000	\N
101	25025180400	2010	31.000	\N
101	25025180500	2010	138.000	\N
101	25025980101	2010	66.000	\N
101	25025980300	2010	14.000	\N
101	25025980700	2010	0.000	\N
101	25025981000	2010	0.000	\N
101	25025981100	2010	20.000	\N
101	25025981201	2010	0.000	\N
101	25025981202	2010	3.000	\N
101	25025981300	2010	10.000	\N
101	25025981501	2010	0.000	\N
101	25025981502	2010	0.000	\N
101	25025981600	2010	0.000	\N
101	25025981700	2010	0.000	\N
101	25025981800	2010	0.000	\N
101	25025990101	2010	0.000	\N
101	25027700100	2010	36.000	\N
101	25027701100	2010	75.000	\N
101	25027702200	2010	17.000	\N
101	25027703100	2010	40.000	\N
101	25027703200	2010	21.000	\N
101	25027703300	2010	38.000	\N
101	25027704200	2010	8.000	\N
101	25027705100	2010	26.000	\N
101	25027706100	2010	10.000	\N
101	25027707100	2010	52.000	\N
101	25027707200	2010	22.000	\N
101	25027707300	2010	69.000	\N
101	25027707400	2010	52.000	\N
101	25027707500	2010	131.000	\N
101	25027708100	2010	29.000	\N
101	25027709100	2010	104.000	\N
101	25027709201	2010	310.000	\N
101	25027709202	2010	313.000	\N
101	25027709400	2010	460.000	\N
101	25027709501	2010	16.000	\N
101	25027709502	2010	86.000	\N
101	25027709600	2010	155.000	\N
101	25027709701	2010	275.000	\N
101	25027709702	2010	71.000	\N
101	25027710100	2010	349.000	\N
101	25027710200	2010	479.000	\N
101	25027710300	2010	78.000	\N
101	25027710400	2010	85.000	\N
101	25027710500	2010	451.000	\N
101	25027710600	2010	879.000	\N
101	25027710700	2010	256.000	\N
101	25027710800	2010	566.000	\N
101	25027711000	2010	363.000	\N
101	25027711100	2010	62.000	\N
101	25027712101	2010	40.000	\N
101	25027712102	2010	12.000	\N
101	25027713100	2010	169.000	\N
101	25027715100	2010	5.000	\N
101	25027716100	2010	313.000	\N
101	25027716200	2010	115.000	\N
101	25027716300	2010	189.000	\N
101	25027717100	2010	4.000	\N
101	25027718100	2010	19.000	\N
101	25027719100	2010	18.000	\N
101	25027720100	2010	1.000	\N
101	25027721101	2010	1.000	\N
101	25027721102	2010	21.000	\N
101	25027722100	2010	14.000	\N
101	25027723100	2010	12.000	\N
101	25027724100	2010	12.000	\N
101	25027725100	2010	8.000	\N
101	25027726100	2010	22.000	\N
101	25027726200	2010	70.000	\N
101	25027727100	2010	13.000	\N
101	25027728100	2010	13.000	\N
101	25027728200	2010	15.000	\N
101	25027728300	2010	21.000	\N
101	25027728400	2010	23.000	\N
101	25027729100	2010	43.000	\N
101	25027729200	2010	10.000	\N
101	25027730100	2010	88.000	\N
101	25027730200	2010	133.000	\N
101	25027730300	2010	99.000	\N
101	25027730401	2010	355.000	\N
101	25027730402	2010	146.000	\N
101	25027730500	2010	146.000	\N
101	25027730600	2010	60.000	\N
101	25027730700	2010	83.000	\N
101	25027730801	2010	35.000	\N
101	25027730802	2010	24.000	\N
101	25027730901	2010	69.000	\N
101	25027730902	2010	84.000	\N
101	25027731001	2010	42.000	\N
101	25027731002	2010	360.000	\N
101	25027731101	2010	410.000	\N
101	25027731102	2010	113.000	\N
101	25027731202	2010	15.000	\N
101	25027731203	2010	715.000	\N
101	25027731204	2010	473.000	\N
101	25027731300	2010	991.000	\N
101	25027731400	2010	1078.000	\N
101	25027731500	2010	1054.000	\N
101	25027731600	2010	399.000	\N
101	25027731700	2010	260.000	\N
101	25027731800	2010	784.000	\N
101	25027731900	2010	699.000	\N
101	25027732001	2010	851.000	\N
101	25027732002	2010	111.000	\N
101	25027732201	2010	63.000	\N
101	25027732202	2010	164.000	\N
101	25027732203	2010	181.000	\N
101	25027732301	2010	87.000	\N
101	25027732302	2010	255.000	\N
101	25027732400	2010	846.000	\N
101	25027732500	2010	318.000	\N
101	25027732600	2010	447.000	\N
101	25027732700	2010	326.000	\N
101	25027732801	2010	76.000	\N
101	25027732802	2010	171.000	\N
101	25027732901	2010	386.000	\N
101	25027732902	2010	52.000	\N
101	25027733000	2010	646.000	\N
101	25027733101	2010	79.000	\N
101	25027733102	2010	132.000	\N
101	25027735100	2010	57.000	\N
101	25027735200	2010	60.000	\N
101	25027736100	2010	9.000	\N
101	25027736200	2010	20.000	\N
101	25027736300	2010	14.000	\N
101	25027736400	2010	20.000	\N
101	25027736500	2010	13.000	\N
101	25027737100	2010	28.000	\N
101	25027737200	2010	4.000	\N
101	25027737300	2010	31.000	\N
101	25027738100	2010	32.000	\N
101	25027738201	2010	8.000	\N
101	25027738202	2010	28.000	\N
101	25027739100	2010	63.000	\N
101	25027739200	2010	48.000	\N
101	25027739300	2010	20.000	\N
101	25027739400	2010	43.000	\N
101	25027739500	2010	27.000	\N
101	25027740101	2010	39.000	\N
101	25027740102	2010	32.000	\N
101	25027740200	2010	14.000	\N
101	25027741101	2010	16.000	\N
101	25027741102	2010	12.000	\N
101	25027742300	2010	105.000	\N
101	25027742401	2010	10.000	\N
101	25027742402	2010	38.000	\N
101	25027743100	2010	13.000	\N
101	25027744101	2010	65.000	\N
101	25027744102	2010	68.000	\N
101	25027744200	2010	249.000	\N
101	25027744300	2010	228.000	\N
101	25027744400	2010	144.000	\N
101	25027745100	2010	30.000	\N
101	25027746100	2010	23.000	\N
101	25027747101	2010	8.000	\N
101	25027747102	2010	15.000	\N
101	25027748100	2010	4.000	\N
101	25027749100	2010	29.000	\N
101	25027749200	2010	9.000	\N
101	25027750100	2010	63.000	\N
101	25027750200	2010	10.000	\N
101	25027750300	2010	16.000	\N
101	25027751101	2010	6.000	\N
101	25027751102	2010	6.000	\N
101	25027752100	2010	10.000	\N
101	25027753100	2010	103.000	\N
101	25027753200	2010	35.000	\N
101	25027754100	2010	55.000	\N
101	25027754200	2010	117.000	\N
101	25027754300	2010	113.000	\N
101	25027754400	2010	56.000	\N
101	25027755100	2010	41.000	\N
101	25027755200	2010	43.000	\N
101	25027756101	2010	20.000	\N
101	25027756102	2010	37.000	\N
101	25027757100	2010	441.000	\N
101	25027757200	2010	361.000	\N
101	25027757300	2010	591.000	\N
101	25027757400	2010	185.000	\N
101	25027757500	2010	227.000	\N
101	25027758101	2010	6.000	\N
101	25027758102	2010	52.000	\N
101	25027759100	2010	6.000	\N
101	25027760100	2010	4.000	\N
101	25027761100	2010	15.000	\N
101	25027761200	2010	45.000	\N
101	25027761300	2010	12.000	\N
101	25027761400	2010	19.000	\N
102	25001010100	2010	5.000	\N
102	25001010206	2010	2.000	\N
102	25001010208	2010	6.000	\N
102	25001010304	2010	3.000	\N
102	25001010306	2010	3.000	\N
102	25001010400	2010	6.000	\N
102	25001010500	2010	0.000	\N
102	25001010600	2010	6.000	\N
102	25001010700	2010	0.000	\N
102	25001010800	2010	4.000	\N
102	25001010900	2010	5.000	\N
102	25001011002	2010	3.000	\N
102	25001011100	2010	6.000	\N
102	25001011200	2010	1.000	\N
102	25001011300	2010	7.000	\N
102	25001011400	2010	10.000	\N
102	25001011500	2010	12.000	\N
102	25001011600	2010	8.000	\N
102	25001011700	2010	5.000	\N
102	25001011801	2010	0.000	\N
102	25001011802	2010	6.000	\N
102	25001012001	2010	13.000	\N
102	25001012002	2010	18.000	\N
102	25001012101	2010	29.000	\N
102	25001012102	2010	10.000	\N
102	25001012200	2010	7.000	\N
102	25001012502	2010	8.000	\N
102	25001012601	2010	3.000	\N
102	25001012602	2010	29.000	\N
102	25001012700	2010	4.000	\N
102	25001012800	2010	14.000	\N
102	25001012900	2010	11.000	\N
102	25001013002	2010	7.000	\N
102	25001013100	2010	10.000	\N
102	25001013200	2010	15.000	\N
102	25001013300	2010	0.000	\N
102	25001013400	2010	15.000	\N
102	25001013500	2010	9.000	\N
102	25001013600	2010	10.000	\N
102	25001013700	2010	10.000	\N
102	25001013800	2010	11.000	\N
102	25001013900	2010	8.000	\N
102	25001014002	2010	6.000	\N
102	25001014100	2010	8.000	\N
102	25001014300	2010	4.000	\N
102	25001014402	2010	12.000	\N
102	25001014500	2010	22.000	\N
102	25001014600	2010	18.000	\N
102	25001014700	2010	3.000	\N
102	25001014800	2010	5.000	\N
102	25001014900	2010	4.000	\N
102	25001015001	2010	15.000	\N
102	25001015002	2010	7.000	\N
102	25001015100	2010	7.000	\N
102	25001015200	2010	0.000	\N
102	25001015300	2010	30.000	\N
102	25001990000	2010	0.000	\N
102	25003900100	2010	35.000	\N
102	25003900200	2010	61.000	\N
102	25003900300	2010	14.000	\N
102	25003900400	2010	19.000	\N
102	25003900500	2010	7.000	\N
102	25003900600	2010	42.000	\N
102	25003900700	2010	7.000	\N
102	25003900800	2010	11.000	\N
102	25003900900	2010	11.000	\N
102	25003901100	2010	3.000	\N
102	25003911100	2010	1.000	\N
102	25003912100	2010	6.000	\N
102	25003913100	2010	8.000	\N
102	25003914100	2010	24.000	\N
102	25003920101	2010	23.000	\N
102	25003920102	2010	22.000	\N
102	25003921300	2010	16.000	\N
102	25003921400	2010	16.000	\N
102	25003921500	2010	7.000	\N
102	25003922100	2010	5.000	\N
102	25003922200	2010	1.000	\N
102	25003922300	2010	4.000	\N
102	25003923100	2010	0.000	\N
102	25003924100	2010	1.000	\N
102	25003925100	2010	46.000	\N
102	25003926100	2010	11.000	\N
102	25003931100	2010	2.000	\N
102	25003931300	2010	3.000	\N
102	25003931400	2010	0.000	\N
102	25003932200	2010	0.000	\N
102	25003932300	2010	0.000	\N
102	25003933200	2010	0.000	\N
102	25003933300	2010	0.000	\N
102	25003933400	2010	2.000	\N
102	25003934200	2010	3.000	\N
102	25003934300	2010	7.000	\N
102	25003935100	2010	6.000	\N
102	25003935200	2010	8.000	\N
102	25003935300	2010	14.000	\N
102	25005600100	2010	9.000	\N
102	25005600202	2010	16.000	\N
102	25005600203	2010	4.000	\N
102	25005600204	2010	15.000	\N
102	25005610100	2010	7.000	\N
102	25005610202	2010	6.000	\N
102	25005610203	2010	15.000	\N
102	25005610204	2010	11.000	\N
102	25005611101	2010	5.000	\N
102	25005611102	2010	12.000	\N
102	25005611201	2010	8.000	\N
102	25005611202	2010	10.000	\N
102	25005612100	2010	12.000	\N
102	25005612200	2010	18.000	\N
102	25005613100	2010	22.000	\N
102	25005613300	2010	23.000	\N
102	25005613400	2010	37.000	\N
102	25005613600	2010	43.000	\N
102	25005613700	2010	21.000	\N
102	25005613800	2010	47.000	\N
102	25005613901	2010	22.000	\N
102	25005613902	2010	15.000	\N
102	25005614000	2010	70.000	\N
102	25005614101	2010	34.000	\N
102	25005614102	2010	21.000	\N
102	25005615100	2010	13.000	\N
102	25005616100	2010	6.000	\N
102	25005617101	2010	0.000	\N
102	25005617102	2010	5.000	\N
102	25005630101	2010	6.000	\N
102	25005630102	2010	10.000	\N
102	25005630200	2010	17.000	\N
102	25005630300	2010	14.000	\N
102	25005630400	2010	11.000	\N
102	25005631100	2010	19.000	\N
102	25005631200	2010	23.000	\N
102	25005631300	2010	17.000	\N
102	25005631400	2010	43.000	\N
102	25005631500	2010	14.000	\N
102	25005631600	2010	60.000	\N
102	25005631700	2010	33.000	\N
102	25005631800	2010	21.000	\N
102	25005632100	2010	7.000	\N
102	25005632200	2010	9.000	\N
102	25005633100	2010	6.000	\N
102	25005633200	2010	15.000	\N
102	25005640100	2010	21.000	\N
102	25005640200	2010	35.000	\N
102	25005640300	2010	29.000	\N
102	25005640400	2010	9.000	\N
102	25005640500	2010	34.000	\N
102	25005640600	2010	33.000	\N
102	25005640700	2010	2.000	\N
102	25005640800	2010	40.000	\N
102	25005640901	2010	35.000	\N
102	25005641000	2010	10.000	\N
102	25005641101	2010	10.000	\N
102	25005641200	2010	21.000	\N
102	25005641300	2010	75.000	\N
102	25005641400	2010	34.000	\N
102	25005641500	2010	3.000	\N
102	25005641600	2010	4.000	\N
102	25005641700	2010	11.000	\N
102	25005641800	2010	2.000	\N
102	25005641900	2010	7.000	\N
102	25005642000	2010	33.000	\N
102	25005642100	2010	31.000	\N
102	25005642200	2010	29.000	\N
102	25005642300	2010	6.000	\N
102	25005642400	2010	6.000	\N
102	25005642500	2010	4.000	\N
102	25005644101	2010	4.000	\N
102	25005644102	2010	10.000	\N
102	25005644200	2010	2.000	\N
102	25005645101	2010	6.000	\N
102	25005645102	2010	7.000	\N
102	25005645103	2010	0.000	\N
102	25005646101	2010	3.000	\N
102	25005646103	2010	3.000	\N
102	25005646104	2010	2.000	\N
102	25005650101	2010	28.000	\N
102	25005650102	2010	29.000	\N
102	25005650201	2010	11.000	\N
102	25005650202	2010	13.000	\N
102	25005650300	2010	12.000	\N
102	25005650400	2010	36.000	\N
102	25005650500	2010	40.000	\N
102	25005650600	2010	55.000	\N
102	25005650700	2010	75.000	\N
102	25005650800	2010	64.000	\N
102	25005650900	2010	90.000	\N
102	25005651001	2010	22.000	\N
102	25005651002	2010	34.000	\N
102	25005651100	2010	92.000	\N
102	25005651200	2010	18.000	\N
102	25005651300	2010	40.000	\N
102	25005651400	2010	47.000	\N
102	25005651500	2010	46.000	\N
102	25005651600	2010	45.000	\N
102	25005651700	2010	42.000	\N
102	25005651800	2010	34.000	\N
102	25005651900	2010	63.000	\N
102	25005652000	2010	24.000	\N
102	25005652100	2010	17.000	\N
102	25005652200	2010	8.000	\N
102	25005652300	2010	33.000	\N
102	25005652400	2010	27.000	\N
102	25005652500	2010	44.000	\N
102	25005652600	2010	112.000	\N
102	25005652700	2010	72.000	\N
102	25005652800	2010	11.000	\N
102	25005653101	2010	9.000	\N
102	25005653102	2010	13.000	\N
102	25005653203	2010	8.000	\N
102	25005653204	2010	3.000	\N
102	25005653301	2010	2.000	\N
102	25005653304	2010	2.000	\N
102	25005654100	2010	3.000	\N
102	25005654200	2010	8.000	\N
102	25005655100	2010	3.000	\N
102	25005655200	2010	5.000	\N
102	25005655300	2010	2.000	\N
102	25005655400	2010	2.000	\N
102	25005985500	2010	13.000	\N
102	25005985600	2010	9.000	\N
102	25005990000	2010	0.000	\N
102	25007200100	2010	22.000	\N
102	25007200200	2010	10.000	\N
102	25007200300	2010	1.000	\N
102	25007200400	2010	10.000	\N
102	25007990000	2010	0.000	\N
102	25009201100	2010	4.000	\N
102	25009202101	2010	7.000	\N
102	25009202102	2010	29.000	\N
102	25009202200	2010	6.000	\N
102	25009203100	2010	10.000	\N
102	25009203200	2010	5.000	\N
102	25009203301	2010	7.000	\N
102	25009203302	2010	8.000	\N
102	25009204101	2010	57.000	\N
102	25009204102	2010	26.000	\N
102	25009204200	2010	90.000	\N
102	25009204300	2010	189.000	\N
102	25009204400	2010	27.000	\N
102	25009204500	2010	39.000	\N
102	25009204600	2010	66.000	\N
102	25009204701	2010	132.000	\N
102	25009204702	2010	66.000	\N
102	25009205100	2010	61.000	\N
102	25009205200	2010	107.000	\N
102	25009205300	2010	56.000	\N
102	25009205400	2010	10.000	\N
102	25009205500	2010	175.000	\N
102	25009205600	2010	123.000	\N
102	25009205700	2010	82.000	\N
102	25009205800	2010	89.000	\N
102	25009205900	2010	95.000	\N
102	25009206000	2010	156.000	\N
102	25009206100	2010	183.000	\N
102	25009206200	2010	260.000	\N
102	25009206300	2010	140.000	\N
102	25009206400	2010	126.000	\N
102	25009206500	2010	115.000	\N
102	25009206600	2010	107.000	\N
102	25009206700	2010	127.000	\N
102	25009206800	2010	137.000	\N
102	25009206900	2010	102.000	\N
102	25009207000	2010	58.000	\N
102	25009207100	2010	107.000	\N
102	25009207200	2010	96.000	\N
102	25009208101	2010	23.000	\N
102	25009208102	2010	31.000	\N
102	25009208200	2010	22.000	\N
102	25009208300	2010	11.000	\N
102	25009208400	2010	18.000	\N
102	25009209100	2010	17.000	\N
102	25009209200	2010	5.000	\N
102	25009210100	2010	7.000	\N
102	25009210200	2010	3.000	\N
102	25009210300	2010	22.000	\N
102	25009210400	2010	44.000	\N
102	25009210500	2010	18.000	\N
102	25009210600	2010	33.000	\N
102	25009210700	2010	45.000	\N
102	25009210800	2010	54.000	\N
102	25009210900	2010	24.000	\N
102	25009211100	2010	2.000	\N
102	25009211200	2010	13.000	\N
102	25009211300	2010	10.000	\N
102	25009211401	2010	11.000	\N
102	25009211402	2010	12.000	\N
102	25009212100	2010	45.000	\N
102	25009213100	2010	12.000	\N
102	25009214100	2010	9.000	\N
102	25009215101	2010	7.000	\N
102	25009215102	2010	1.000	\N
102	25009216100	2010	5.000	\N
102	25009217100	2010	26.000	\N
102	25009217201	2010	11.000	\N
102	25009217202	2010	1.000	\N
102	25009217300	2010	46.000	\N
102	25009217400	2010	20.000	\N
102	25009217500	2010	10.000	\N
102	25009217600	2010	19.000	\N
102	25009218100	2010	7.000	\N
102	25009220101	2010	10.000	\N
102	25009220102	2010	4.000	\N
102	25009221100	2010	2.000	\N
102	25009221300	2010	5.000	\N
102	25009221400	2010	16.000	\N
102	25009221500	2010	11.000	\N
102	25009221600	2010	24.000	\N
102	25009221700	2010	7.000	\N
102	25009221800	2010	1.000	\N
102	25009221901	2010	6.000	\N
102	25009221902	2010	1.000	\N
102	25009222100	2010	1.000	\N
102	25009223100	2010	2.000	\N
102	25009223200	2010	8.000	\N
102	25009223300	2010	4.000	\N
102	25009250100	2010	146.000	\N
102	25009250200	2010	208.000	\N
102	25009250300	2010	166.000	\N
102	25009250400	2010	327.000	\N
102	25009250500	2010	396.000	\N
102	25009250600	2010	453.000	\N
102	25009250700	2010	398.000	\N
102	25009250800	2010	341.000	\N
102	25009250900	2010	184.000	\N
102	25009251000	2010	95.000	\N
102	25009251100	2010	144.000	\N
102	25009251200	2010	69.000	\N
102	25009251300	2010	273.000	\N
102	25009251400	2010	285.000	\N
102	25009251500	2010	356.000	\N
102	25009251600	2010	242.000	\N
102	25009251700	2010	182.000	\N
102	25009251800	2010	179.000	\N
102	25009252101	2010	80.000	\N
102	25009252102	2010	16.000	\N
102	25009252201	2010	38.000	\N
102	25009252202	2010	8.000	\N
102	25009252300	2010	157.000	\N
102	25009252400	2010	207.000	\N
102	25009252501	2010	60.000	\N
102	25009252502	2010	25.000	\N
102	25009252601	2010	48.000	\N
102	25009252602	2010	34.000	\N
102	25009252603	2010	18.000	\N
102	25009253100	2010	22.000	\N
102	25009253201	2010	11.000	\N
102	25009253202	2010	47.000	\N
102	25009253203	2010	4.000	\N
102	25009253204	2010	6.000	\N
102	25009253205	2010	3.000	\N
102	25009254100	2010	18.000	\N
102	25009254200	2010	27.000	\N
102	25009254301	2010	12.000	\N
102	25009254302	2010	5.000	\N
102	25009254401	2010	7.000	\N
102	25009254402	2010	29.000	\N
102	25009254403	2010	9.000	\N
102	25009260100	2010	115.000	\N
102	25009260200	2010	40.000	\N
102	25009260301	2010	10.000	\N
102	25009260302	2010	11.000	\N
102	25009260401	2010	7.000	\N
102	25009260402	2010	49.000	\N
102	25009260500	2010	32.000	\N
102	25009260600	2010	56.000	\N
102	25009260700	2010	63.000	\N
102	25009260800	2010	138.000	\N
102	25009260900	2010	88.000	\N
102	25009261000	2010	24.000	\N
102	25009261101	2010	13.000	\N
102	25009261102	2010	39.000	\N
102	25009262100	2010	9.000	\N
102	25009263100	2010	12.000	\N
102	25009264100	2010	7.000	\N
102	25009265101	2010	9.000	\N
102	25009265102	2010	6.000	\N
102	25009266100	2010	5.000	\N
102	25009266200	2010	8.000	\N
102	25009266300	2010	9.000	\N
102	25009266400	2010	5.000	\N
102	25009267101	2010	5.000	\N
102	25009267102	2010	8.000	\N
102	25009268100	2010	2.000	\N
102	25009268200	2010	12.000	\N
102	25009268300	2010	6.000	\N
102	25009268400	2010	1.000	\N
102	25009269100	2010	1.000	\N
102	25009270100	2010	4.000	\N
102	25009990100	2010	0.000	\N
102	25011040100	2010	2.000	\N
102	25011040200	2010	4.000	\N
102	25011040300	2010	8.000	\N
102	25011040400	2010	8.000	\N
102	25011040501	2010	10.000	\N
102	25011040502	2010	10.000	\N
102	25011040600	2010	10.000	\N
102	25011040701	2010	30.000	\N
102	25011040702	2010	15.000	\N
102	25011040800	2010	25.000	\N
102	25011040900	2010	13.000	\N
102	25011041000	2010	20.000	\N
102	25011041100	2010	17.000	\N
102	25011041200	2010	13.000	\N
102	25011041300	2010	21.000	\N
102	25011041400	2010	32.000	\N
102	25011041501	2010	7.000	\N
102	25011041502	2010	6.000	\N
102	25013800101	2010	100.000	\N
102	25013800102	2010	131.000	\N
102	25013800201	2010	185.000	\N
102	25013800202	2010	24.000	\N
102	25013800300	2010	103.000	\N
102	25013800400	2010	251.000	\N
102	25013800500	2010	144.000	\N
102	25013800600	2010	176.000	\N
102	25013800700	2010	217.000	\N
102	25013800800	2010	93.000	\N
102	25013800900	2010	143.000	\N
102	25013801101	2010	69.000	\N
102	25013801102	2010	25.000	\N
102	25013801200	2010	92.000	\N
102	25013801300	2010	158.000	\N
102	25013801401	2010	87.000	\N
102	25013801402	2010	46.000	\N
102	25013801501	2010	116.000	\N
102	25013801502	2010	107.000	\N
102	25013801503	2010	111.000	\N
102	25013801601	2010	57.000	\N
102	25013801602	2010	49.000	\N
102	25013801603	2010	49.000	\N
102	25013801604	2010	25.000	\N
102	25013801605	2010	72.000	\N
102	25013801700	2010	140.000	\N
102	25013801800	2010	99.000	\N
102	25013801901	2010	140.000	\N
102	25013801902	2010	125.000	\N
102	25013802000	2010	116.000	\N
102	25013802100	2010	131.000	\N
102	25013802200	2010	80.000	\N
102	25013802300	2010	251.000	\N
102	25013802400	2010	33.000	\N
102	25013802500	2010	87.000	\N
102	25013802601	2010	167.000	\N
102	25013802602	2010	12.000	\N
102	25013810100	2010	26.000	\N
102	25013810200	2010	14.000	\N
102	25013810300	2010	14.000	\N
102	25013810403	2010	24.000	\N
102	25013810404	2010	7.000	\N
102	25013810412	2010	4.000	\N
102	25013810414	2010	16.000	\N
102	25013810601	2010	33.000	\N
102	25013810602	2010	2.000	\N
102	25013810700	2010	52.000	\N
102	25013810800	2010	56.000	\N
102	25013810901	2010	48.000	\N
102	25013810902	2010	63.000	\N
102	25013811000	2010	15.000	\N
102	25013811101	2010	51.000	\N
102	25013811102	2010	128.000	\N
102	25013811200	2010	37.000	\N
102	25013811301	2010	27.000	\N
102	25013811302	2010	28.000	\N
102	25013811400	2010	100.000	\N
102	25013811500	2010	155.000	\N
102	25013811600	2010	210.000	\N
102	25013811700	2010	91.000	\N
102	25013811800	2010	102.000	\N
102	25013811900	2010	21.000	\N
102	25013812001	2010	85.000	\N
102	25013812002	2010	95.000	\N
102	25013812101	2010	18.000	\N
102	25013812103	2010	104.000	\N
102	25013812104	2010	131.000	\N
102	25013812201	2010	30.000	\N
102	25013812202	2010	49.000	\N
102	25013812300	2010	73.000	\N
102	25013812401	2010	21.000	\N
102	25013812403	2010	11.000	\N
102	25013812404	2010	22.000	\N
102	25013812500	2010	47.000	\N
102	25013812600	2010	16.000	\N
102	25013812701	2010	24.000	\N
102	25013812702	2010	87.000	\N
102	25013812800	2010	28.000	\N
102	25013812901	2010	8.000	\N
102	25013812902	2010	6.000	\N
102	25013812903	2010	15.000	\N
102	25013813000	2010	22.000	\N
102	25013813101	2010	15.000	\N
102	25013813102	2010	11.000	\N
102	25013813204	2010	3.000	\N
102	25013813205	2010	24.000	\N
102	25013813206	2010	9.000	\N
102	25013813207	2010	16.000	\N
102	25013813208	2010	11.000	\N
102	25013813209	2010	13.000	\N
102	25013813301	2010	13.000	\N
102	25013813303	2010	7.000	\N
102	25013813304	2010	6.000	\N
102	25013813401	2010	20.000	\N
102	25013813403	2010	9.000	\N
102	25013813404	2010	10.000	\N
102	25013813500	2010	1.000	\N
102	25013813601	2010	28.000	\N
102	25013813602	2010	8.000	\N
102	25013813701	2010	13.000	\N
102	25013813702	2010	7.000	\N
102	25013813801	2010	6.000	\N
102	25013813802	2010	4.000	\N
102	25015820101	2010	21.000	\N
102	25015820102	2010	32.000	\N
102	25015820202	2010	5.000	\N
102	25015820203	2010	28.000	\N
102	25015820204	2010	19.000	\N
102	25015820300	2010	63.000	\N
102	25015820400	2010	70.000	\N
102	25015820500	2010	43.000	\N
102	25015820600	2010	28.000	\N
102	25015820700	2010	64.000	\N
102	25015820801	2010	58.000	\N
102	25015820802	2010	13.000	\N
102	25015820900	2010	9.000	\N
102	25015821000	2010	10.000	\N
102	25015821100	2010	25.000	\N
102	25015821200	2010	14.000	\N
102	25015821300	2010	19.000	\N
102	25015821400	2010	13.000	\N
102	25015821500	2010	5.000	\N
102	25015821601	2010	41.000	\N
102	25015821602	2010	34.000	\N
102	25015821700	2010	5.000	\N
102	25015821901	2010	6.000	\N
102	25015821903	2010	23.000	\N
102	25015821904	2010	10.000	\N
102	25015822000	2010	25.000	\N
102	25015822200	2010	44.000	\N
102	25015822300	2010	15.000	\N
102	25015822401	2010	8.000	\N
102	25015822402	2010	31.000	\N
102	25015822500	2010	15.000	\N
102	25015822601	2010	5.000	\N
102	25015822603	2010	7.000	\N
102	25015822605	2010	4.000	\N
102	25015822606	2010	8.000	\N
102	25015822700	2010	1.000	\N
102	25017300100	2010	10.000	\N
102	25017301101	2010	8.000	\N
102	25017301102	2010	6.000	\N
102	25017310100	2010	113.000	\N
102	25017310200	2010	93.000	\N
102	25017310300	2010	123.000	\N
102	25017310400	2010	94.000	\N
102	25017310500	2010	38.000	\N
102	25017310601	2010	74.000	\N
102	25017310602	2010	37.000	\N
102	25017310700	2010	59.000	\N
102	25017311100	2010	63.000	\N
102	25017311200	2010	51.000	\N
102	25017311300	2010	49.000	\N
102	25017311400	2010	76.000	\N
102	25017311500	2010	33.000	\N
102	25017311600	2010	22.000	\N
102	25017311700	2010	60.000	\N
102	25017311800	2010	42.000	\N
102	25017311900	2010	35.000	\N
102	25017312000	2010	59.000	\N
102	25017312100	2010	49.000	\N
102	25017312200	2010	36.000	\N
102	25017312300	2010	32.000	\N
102	25017312400	2010	63.000	\N
102	25017312501	2010	28.000	\N
102	25017312502	2010	2.000	\N
102	25017313101	2010	15.000	\N
102	25017313102	2010	21.000	\N
102	25017314101	2010	19.000	\N
102	25017314102	2010	36.000	\N
102	25017314200	2010	31.000	\N
102	25017314301	2010	42.000	\N
102	25017314302	2010	4.000	\N
102	25017315100	2010	9.000	\N
102	25017315200	2010	10.000	\N
102	25017315401	2010	1.000	\N
102	25017315402	2010	5.000	\N
102	25017315403	2010	5.000	\N
102	25017315500	2010	9.000	\N
102	25017316101	2010	10.000	\N
102	25017316102	2010	3.000	\N
102	25017316201	2010	3.000	\N
102	25017316202	2010	15.000	\N
102	25017316300	2010	21.000	\N
102	25017316400	2010	10.000	\N
102	25017316500	2010	7.000	\N
102	25017317101	2010	14.000	\N
102	25017317102	2010	6.000	\N
102	25017317103	2010	10.000	\N
102	25017317201	2010	4.000	\N
102	25017317202	2010	5.000	\N
102	25017317203	2010	2.000	\N
102	25017317301	2010	9.000	\N
102	25017317302	2010	8.000	\N
102	25017318100	2010	4.000	\N
102	25017318200	2010	6.000	\N
102	25017318300	2010	3.000	\N
102	25017318400	2010	12.000	\N
102	25017320102	2010	2.000	\N
102	25017320103	2010	6.000	\N
102	25017320104	2010	12.000	\N
102	25017321100	2010	40.000	\N
102	25017321200	2010	26.000	\N
102	25017321300	2010	78.000	\N
102	25017321400	2010	13.000	\N
102	25017321500	2010	70.000	\N
102	25017321600	2010	42.000	\N
102	25017322100	2010	4.000	\N
102	25017322200	2010	14.000	\N
102	25017322300	2010	27.000	\N
102	25017322400	2010	16.000	\N
102	25017323100	2010	10.000	\N
102	25017324101	2010	8.000	\N
102	25017324102	2010	4.000	\N
102	25017325100	2010	46.000	\N
102	25017326101	2010	8.000	\N
102	25017326102	2010	8.000	\N
102	25017327101	2010	4.000	\N
102	25017327102	2010	9.000	\N
102	25017327103	2010	5.000	\N
102	25017328100	2010	4.000	\N
102	25017330100	2010	6.000	\N
102	25017330200	2010	6.000	\N
102	25017331101	2010	3.000	\N
102	25017331102	2010	20.000	\N
102	25017331200	2010	4.000	\N
102	25017331300	2010	13.000	\N
102	25017332100	2010	4.000	\N
102	25017332200	2010	19.000	\N
102	25017332300	2010	4.000	\N
102	25017332400	2010	10.000	\N
102	25017333100	2010	10.000	\N
102	25017333200	2010	18.000	\N
102	25017333300	2010	30.000	\N
102	25017333400	2010	45.000	\N
102	25017333501	2010	8.000	\N
102	25017333502	2010	23.000	\N
102	25017333600	2010	27.000	\N
102	25017334100	2010	8.000	\N
102	25017334200	2010	10.000	\N
102	25017334300	2010	6.000	\N
102	25017334400	2010	10.000	\N
102	25017335100	2010	4.000	\N
102	25017335200	2010	3.000	\N
102	25017335301	2010	11.000	\N
102	25017335302	2010	10.000	\N
102	25017335400	2010	7.000	\N
102	25017336100	2010	6.000	\N
102	25017336200	2010	12.000	\N
102	25017336300	2010	6.000	\N
102	25017336401	2010	14.000	\N
102	25017336402	2010	9.000	\N
102	25017337101	2010	3.000	\N
102	25017337102	2010	13.000	\N
102	25017337201	2010	2.000	\N
102	25017337202	2010	14.000	\N
102	25017337300	2010	25.000	\N
102	25017338100	2010	4.000	\N
102	25017338200	2010	13.000	\N
102	25017338300	2010	2.000	\N
102	25017338400	2010	3.000	\N
102	25017338500	2010	7.000	\N
102	25017339100	2010	13.000	\N
102	25017339200	2010	14.000	\N
102	25017339300	2010	26.000	\N
102	25017339400	2010	11.000	\N
102	25017339500	2010	19.000	\N
102	25017339600	2010	25.000	\N
102	25017339700	2010	35.000	\N
102	25017339801	2010	23.000	\N
102	25017339802	2010	11.000	\N
102	25017339900	2010	26.000	\N
102	25017340000	2010	17.000	\N
102	25017340100	2010	24.000	\N
102	25017341101	2010	18.000	\N
102	25017341102	2010	22.000	\N
102	25017341200	2010	41.000	\N
102	25017341300	2010	10.000	\N
102	25017341400	2010	83.000	\N
102	25017341500	2010	34.000	\N
102	25017341600	2010	30.000	\N
102	25017341700	2010	48.000	\N
102	25017341800	2010	62.000	\N
102	25017341901	2010	11.000	\N
102	25017341902	2010	43.000	\N
102	25017342101	2010	52.000	\N
102	25017342102	2010	56.000	\N
102	25017342201	2010	81.000	\N
102	25017342202	2010	42.000	\N
102	25017342300	2010	98.000	\N
102	25017342400	2010	85.000	\N
102	25017342500	2010	110.000	\N
102	25017342600	2010	67.000	\N
102	25017350103	2010	15.000	\N
102	25017350104	2010	84.000	\N
102	25017350200	2010	76.000	\N
102	25017350300	2010	21.000	\N
102	25017350400	2010	20.000	\N
102	25017350500	2010	2.000	\N
102	25017350600	2010	16.000	\N
102	25017350700	2010	39.000	\N
102	25017350800	2010	6.000	\N
102	25017350900	2010	11.000	\N
102	25017351000	2010	22.000	\N
102	25017351100	2010	22.000	\N
102	25017351203	2010	24.000	\N
102	25017351204	2010	36.000	\N
102	25017351300	2010	27.000	\N
102	25017351403	2010	80.000	\N
102	25017351404	2010	52.000	\N
102	25017351500	2010	25.000	\N
102	25017352101	2010	8.000	\N
102	25017352102	2010	8.000	\N
102	25017352200	2010	14.000	\N
102	25017352300	2010	38.000	\N
102	25017352400	2010	44.000	\N
102	25017352500	2010	25.000	\N
102	25017352600	2010	24.000	\N
102	25017352700	2010	33.000	\N
102	25017352800	2010	26.000	\N
102	25017352900	2010	2.000	\N
102	25017353000	2010	29.000	\N
102	25017353101	2010	14.000	\N
102	25017353102	2010	52.000	\N
102	25017353200	2010	39.000	\N
102	25017353300	2010	12.000	\N
102	25017353400	2010	25.000	\N
102	25017353500	2010	30.000	\N
102	25017353600	2010	23.000	\N
102	25017353700	2010	33.000	\N
102	25017353800	2010	13.000	\N
102	25017353900	2010	42.000	\N
102	25017354000	2010	25.000	\N
102	25017354100	2010	8.000	\N
102	25017354200	2010	9.000	\N
102	25017354300	2010	26.000	\N
102	25017354400	2010	3.000	\N
102	25017354500	2010	2.000	\N
102	25017354600	2010	17.000	\N
102	25017354700	2010	8.000	\N
102	25017354800	2010	8.000	\N
102	25017354900	2010	81.000	\N
102	25017355000	2010	23.000	\N
102	25017356100	2010	10.000	\N
102	25017356300	2010	18.000	\N
102	25017356400	2010	16.000	\N
102	25017356500	2010	24.000	\N
102	25017356601	2010	17.000	\N
102	25017356602	2010	15.000	\N
102	25017356701	2010	32.000	\N
102	25017356702	2010	22.000	\N
102	25017357100	2010	6.000	\N
102	25017357200	2010	14.000	\N
102	25017357300	2010	9.000	\N
102	25017357400	2010	10.000	\N
102	25017357500	2010	13.000	\N
102	25017357600	2010	2.000	\N
102	25017357700	2010	12.000	\N
102	25017357800	2010	12.000	\N
102	25017358100	2010	12.000	\N
102	25017358300	2010	8.000	\N
102	25017358400	2010	8.000	\N
102	25017358500	2010	10.000	\N
102	25017358600	2010	10.000	\N
102	25017358700	2010	8.000	\N
102	25017359100	2010	21.000	\N
102	25017359300	2010	7.000	\N
102	25017360100	2010	16.000	\N
102	25017360200	2010	8.000	\N
102	25017361100	2010	4.000	\N
102	25017361200	2010	11.000	\N
102	25017361300	2010	22.000	\N
102	25017362100	2010	8.000	\N
102	25017363102	2010	18.000	\N
102	25017363103	2010	9.000	\N
102	25017363104	2010	10.000	\N
102	25017363201	2010	2.000	\N
102	25017363202	2010	3.000	\N
102	25017364101	2010	16.000	\N
102	25017364102	2010	13.000	\N
102	25017365100	2010	13.000	\N
102	25017365201	2010	9.000	\N
102	25017365202	2010	5.000	\N
102	25017366100	2010	12.000	\N
102	25017366201	2010	5.000	\N
102	25017366202	2010	6.000	\N
102	25017367100	2010	3.000	\N
102	25017367200	2010	13.000	\N
102	25017368101	2010	28.000	\N
102	25017368102	2010	8.000	\N
102	25017368200	2010	29.000	\N
102	25017368300	2010	87.000	\N
102	25017368400	2010	47.000	\N
102	25017368500	2010	50.000	\N
102	25017368600	2010	81.000	\N
102	25017368700	2010	42.000	\N
102	25017368800	2010	61.000	\N
102	25017368901	2010	26.000	\N
102	25017368902	2010	28.000	\N
102	25017369000	2010	1.000	\N
102	25017369100	2010	7.000	\N
102	25017370101	2010	32.000	\N
102	25017370102	2010	21.000	\N
102	25017370201	2010	8.000	\N
102	25017370202	2010	12.000	\N
102	25017370300	2010	44.000	\N
102	25017370400	2010	22.000	\N
102	25017373100	2010	12.000	\N
102	25017373200	2010	19.000	\N
102	25017373300	2010	23.000	\N
102	25017373400	2010	15.000	\N
102	25017373500	2010	14.000	\N
102	25017373600	2010	34.000	\N
102	25017373700	2010	6.000	\N
102	25017373800	2010	27.000	\N
102	25017373900	2010	12.000	\N
102	25017374000	2010	18.000	\N
102	25017374100	2010	17.000	\N
102	25017374200	2010	11.000	\N
102	25017374300	2010	5.000	\N
102	25017374400	2010	19.000	\N
102	25017374500	2010	13.000	\N
102	25017374600	2010	21.000	\N
102	25017374700	2010	3.000	\N
102	25017374800	2010	5.000	\N
102	25017382100	2010	2.000	\N
102	25017382200	2010	12.000	\N
102	25017382300	2010	13.000	\N
102	25017382400	2010	8.000	\N
102	25017382500	2010	12.000	\N
102	25017382601	2010	19.000	\N
102	25017382602	2010	9.000	\N
102	25017383101	2010	72.000	\N
102	25017383102	2010	104.000	\N
102	25017383200	2010	110.000	\N
102	25017383300	2010	32.000	\N
102	25017383400	2010	70.000	\N
102	25017383501	2010	34.000	\N
102	25017383502	2010	16.000	\N
102	25017383600	2010	22.000	\N
102	25017383700	2010	35.000	\N
102	25017383800	2010	23.000	\N
102	25017383901	2010	18.000	\N
102	25017383902	2010	10.000	\N
102	25017384001	2010	7.000	\N
102	25017384002	2010	22.000	\N
102	25017385100	2010	21.000	\N
102	25017385201	2010	16.000	\N
102	25017385202	2010	20.000	\N
102	25017386100	2010	6.000	\N
102	25017387100	2010	2.000	\N
102	25017387201	2010	9.000	\N
102	25017387202	2010	3.000	\N
102	25017388100	2010	10.000	\N
102	25017388200	2010	17.000	\N
102	25017388300	2010	122.000	\N
102	25017980000	2010	0.000	\N
102	25019950100	2010	4.000	\N
102	25019950200	2010	17.000	\N
102	25019950307	2010	0.000	\N
102	25019950400	2010	8.000	\N
102	25019950500	2010	2.000	\N
102	25019990000	2010	0.000	\N
102	25021400100	2010	20.000	\N
102	25021400200	2010	38.000	\N
102	25021400300	2010	9.000	\N
102	25021400400	2010	15.000	\N
102	25021400500	2010	10.000	\N
102	25021400600	2010	11.000	\N
102	25021400700	2010	17.000	\N
102	25021400800	2010	33.000	\N
102	25021400900	2010	19.000	\N
102	25021401000	2010	25.000	\N
102	25021401100	2010	18.000	\N
102	25021401200	2010	27.000	\N
102	25021402101	2010	19.000	\N
102	25021402102	2010	25.000	\N
102	25021402200	2010	6.000	\N
102	25021402300	2010	18.000	\N
102	25021402400	2010	34.000	\N
102	25021402500	2010	9.000	\N
102	25021403100	2010	4.000	\N
102	25021403300	2010	3.000	\N
102	25021403400	2010	6.000	\N
102	25021403500	2010	10.000	\N
102	25021404100	2010	15.000	\N
102	25021404201	2010	4.000	\N
102	25021404202	2010	7.000	\N
102	25021404301	2010	1.000	\N
102	25021404302	2010	0.000	\N
102	25021404400	2010	31.000	\N
102	25021405100	2010	5.000	\N
102	25021406101	2010	7.000	\N
102	25021406102	2010	3.000	\N
102	25021407100	2010	2.000	\N
102	25021408101	2010	3.000	\N
102	25021408102	2010	12.000	\N
102	25021409101	2010	21.000	\N
102	25021409102	2010	1.000	\N
102	25021410100	2010	8.000	\N
102	25021410300	2010	0.000	\N
102	25021410400	2010	21.000	\N
102	25021411100	2010	14.000	\N
102	25021411200	2010	10.000	\N
102	25021411301	2010	2.000	\N
102	25021411302	2010	12.000	\N
102	25021412100	2010	12.000	\N
102	25021412200	2010	5.000	\N
102	25021412300	2010	7.000	\N
102	25021413100	2010	17.000	\N
102	25021413200	2010	35.000	\N
102	25021413300	2010	18.000	\N
102	25021413401	2010	6.000	\N
102	25021413402	2010	9.000	\N
102	25021413500	2010	29.000	\N
102	25021414100	2010	10.000	\N
102	25021414200	2010	17.000	\N
102	25021414300	2010	6.000	\N
102	25021415101	2010	6.000	\N
102	25021415102	2010	20.000	\N
102	25021415200	2010	31.000	\N
102	25021415300	2010	8.000	\N
102	25021416101	2010	6.000	\N
102	25021416102	2010	8.000	\N
102	25021416200	2010	43.000	\N
102	25021416300	2010	16.000	\N
102	25021416400	2010	10.000	\N
102	25021417100	2010	9.000	\N
102	25021417200	2010	9.000	\N
102	25021417300	2010	1.000	\N
102	25021417400	2010	3.000	\N
102	25021417501	2010	7.000	\N
102	25021417502	2010	8.000	\N
102	25021417601	2010	4.000	\N
102	25021417602	2010	9.000	\N
102	25021417701	2010	23.000	\N
102	25021417702	2010	3.000	\N
102	25021417801	2010	16.000	\N
102	25021417802	2010	17.000	\N
102	25021417901	2010	24.000	\N
102	25021417902	2010	4.000	\N
102	25021418002	2010	34.000	\N
102	25021418003	2010	10.000	\N
102	25021418004	2010	16.000	\N
102	25021418101	2010	26.000	\N
102	25021418102	2010	13.000	\N
102	25021418200	2010	22.000	\N
102	25021419100	2010	11.000	\N
102	25021419200	2010	5.000	\N
102	25021419300	2010	30.000	\N
102	25021419400	2010	12.000	\N
102	25021419500	2010	5.000	\N
102	25021419600	2010	7.000	\N
102	25021419700	2010	1.000	\N
102	25021419800	2010	16.000	\N
102	25021420100	2010	38.000	\N
102	25021420201	2010	18.000	\N
102	25021420202	2010	51.000	\N
102	25021420301	2010	63.000	\N
102	25021420302	2010	47.000	\N
102	25021421100	2010	33.000	\N
102	25021421200	2010	20.000	\N
102	25021422100	2010	5.000	\N
102	25021422200	2010	21.000	\N
102	25021422301	2010	8.000	\N
102	25021422302	2010	13.000	\N
102	25021422400	2010	20.000	\N
102	25021422501	2010	15.000	\N
102	25021422502	2010	15.000	\N
102	25021422600	2010	1.000	\N
102	25021422700	2010	10.000	\N
102	25021422800	2010	5.000	\N
102	25021423100	2010	3.000	\N
102	25021440100	2010	13.000	\N
102	25021441202	2010	3.000	\N
102	25021441203	2010	7.000	\N
102	25021441204	2010	9.000	\N
102	25021442101	2010	3.000	\N
102	25021442102	2010	3.000	\N
102	25021442103	2010	6.000	\N
102	25021442201	2010	5.000	\N
102	25021442202	2010	21.000	\N
102	25021443101	2010	17.000	\N
102	25021443102	2010	8.000	\N
102	25021456101	2010	8.000	\N
102	25021456102	2010	12.000	\N
102	25021456200	2010	19.000	\N
102	25021456301	2010	14.000	\N
102	25021456302	2010	17.000	\N
102	25021456401	2010	4.000	\N
102	25021456402	2010	8.000	\N
102	25021457100	2010	17.000	\N
102	25021457200	2010	8.000	\N
102	25023500101	2010	10.000	\N
102	25023500103	2010	2.000	\N
102	25023500104	2010	10.000	\N
102	25023501101	2010	5.000	\N
102	25023501102	2010	7.000	\N
102	25023501201	2010	2.000	\N
102	25023501202	2010	3.000	\N
102	25023502101	2010	9.000	\N
102	25023502102	2010	20.000	\N
102	25023502200	2010	7.000	\N
102	25023503101	2010	7.000	\N
102	25023503102	2010	1.000	\N
102	25023504101	2010	5.000	\N
102	25023504102	2010	6.000	\N
102	25023505101	2010	12.000	\N
102	25023505102	2010	4.000	\N
102	25023505200	2010	1.000	\N
102	25023506101	2010	10.000	\N
102	25023506102	2010	15.000	\N
102	25023506202	2010	3.000	\N
102	25023506203	2010	2.000	\N
102	25023506204	2010	3.000	\N
102	25023507101	2010	3.000	\N
102	25023507103	2010	4.000	\N
102	25023507104	2010	2.000	\N
102	25023508101	2010	2.000	\N
102	25023508102	2010	5.000	\N
102	25023508200	2010	2.000	\N
102	25023509101	2010	12.000	\N
102	25023509102	2010	3.000	\N
102	25023510100	2010	37.000	\N
102	25023510200	2010	55.000	\N
102	25023510300	2010	60.000	\N
102	25023510400	2010	47.000	\N
102	25023510501	2010	22.000	\N
102	25023510502	2010	41.000	\N
102	25023510503	2010	26.000	\N
102	25023510600	2010	11.000	\N
102	25023510700	2010	43.000	\N
102	25023510800	2010	99.000	\N
102	25023510900	2010	57.000	\N
102	25023511000	2010	65.000	\N
102	25023511100	2010	46.000	\N
102	25023511200	2010	55.000	\N
102	25023511301	2010	60.000	\N
102	25023511302	2010	41.000	\N
102	25023511400	2010	33.000	\N
102	25023511500	2010	57.000	\N
102	25023511600	2010	86.000	\N
102	25023511701	2010	36.000	\N
102	25023511702	2010	10.000	\N
102	25023520100	2010	12.000	\N
102	25023520201	2010	3.000	\N
102	25023520202	2010	10.000	\N
102	25023521101	2010	8.000	\N
102	25023521102	2010	10.000	\N
102	25023521201	2010	6.000	\N
102	25023521202	2010	11.000	\N
102	25023522101	2010	4.000	\N
102	25023522102	2010	3.000	\N
102	25023523100	2010	16.000	\N
102	25023523201	2010	2.000	\N
102	25023523202	2010	10.000	\N
102	25023524101	2010	5.000	\N
102	25023524102	2010	1.000	\N
102	25023525101	2010	13.000	\N
102	25023525104	2010	8.000	\N
102	25023525203	2010	8.000	\N
102	25023525204	2010	3.000	\N
102	25023525300	2010	8.000	\N
102	25023526100	2010	16.000	\N
102	25023530100	2010	11.000	\N
102	25023530200	2010	6.000	\N
102	25023530300	2010	5.000	\N
102	25023530400	2010	6.000	\N
102	25023530500	2010	4.000	\N
102	25023530600	2010	8.000	\N
102	25023530700	2010	9.000	\N
102	25023530801	2010	14.000	\N
102	25023530802	2010	6.000	\N
102	25023530901	2010	5.000	\N
102	25023530902	2010	0.000	\N
102	25023540101	2010	3.000	\N
102	25023540102	2010	0.000	\N
102	25023540103	2010	6.000	\N
102	25023541100	2010	7.000	\N
102	25023542101	2010	10.000	\N
102	25023542102	2010	2.000	\N
102	25023542200	2010	2.000	\N
102	25023542300	2010	14.000	\N
102	25023543100	2010	3.000	\N
102	25023544100	2010	4.000	\N
102	25023544200	2010	13.000	\N
102	25023545100	2010	8.000	\N
102	25023545200	2010	25.000	\N
102	25023545300	2010	14.000	\N
102	25023545400	2010	15.000	\N
102	25023560100	2010	2.000	\N
102	25023561100	2010	6.000	\N
102	25023561200	2010	11.000	\N
102	25023990003	2010	0.000	\N
102	25025000100	2010	63.000	\N
102	25025000201	2010	38.000	\N
102	25025000202	2010	61.000	\N
102	25025000301	2010	14.000	\N
102	25025000302	2010	15.000	\N
102	25025000401	2010	29.000	\N
102	25025000402	2010	11.000	\N
102	25025000502	2010	25.000	\N
102	25025000503	2010	7.000	\N
102	25025000504	2010	23.000	\N
102	25025000601	2010	15.000	\N
102	25025000602	2010	52.000	\N
102	25025000701	2010	23.000	\N
102	25025000703	2010	9.000	\N
102	25025000704	2010	38.000	\N
102	25025000802	2010	133.000	\N
102	25025000803	2010	32.000	\N
102	25025010103	2010	28.000	\N
102	25025010104	2010	28.000	\N
102	25025010203	2010	45.000	\N
102	25025010204	2010	12.000	\N
102	25025010300	2010	18.000	\N
102	25025010403	2010	28.000	\N
102	25025010404	2010	29.000	\N
102	25025010405	2010	31.000	\N
102	25025010408	2010	11.000	\N
102	25025010500	2010	22.000	\N
102	25025010600	2010	4.000	\N
102	25025010701	2010	10.000	\N
102	25025010702	2010	7.000	\N
102	25025010801	2010	8.000	\N
102	25025010802	2010	7.000	\N
102	25025020101	2010	9.000	\N
102	25025020200	2010	8.000	\N
102	25025020301	2010	3.000	\N
102	25025020302	2010	2.000	\N
102	25025020303	2010	8.000	\N
102	25025030100	2010	1.000	\N
102	25025030200	2010	6.000	\N
102	25025030300	2010	13.000	\N
102	25025030400	2010	2.000	\N
102	25025030500	2010	2.000	\N
102	25025040100	2010	2.000	\N
102	25025040200	2010	16.000	\N
102	25025040300	2010	55.000	\N
102	25025040401	2010	15.000	\N
102	25025040600	2010	3.000	\N
102	25025040801	2010	52.000	\N
102	25025050101	2010	216.000	\N
102	25025050200	2010	265.000	\N
102	25025050300	2010	95.000	\N
102	25025050400	2010	62.000	\N
102	25025050500	2010	66.000	\N
102	25025050600	2010	119.000	\N
102	25025050700	2010	183.000	\N
102	25025050901	2010	164.000	\N
102	25025051000	2010	78.000	\N
102	25025051101	2010	151.000	\N
102	25025051200	2010	45.000	\N
102	25025060101	2010	1.000	\N
102	25025060200	2010	0.000	\N
102	25025060301	2010	4.000	\N
102	25025060400	2010	2.000	\N
102	25025060501	2010	17.000	\N
102	25025060600	2010	6.000	\N
102	25025060700	2010	82.000	\N
102	25025060800	2010	9.000	\N
102	25025061000	2010	117.000	\N
102	25025061101	2010	86.000	\N
102	25025061200	2010	6.000	\N
102	25025070101	2010	24.000	\N
102	25025070200	2010	14.000	\N
102	25025070300	2010	20.000	\N
102	25025070402	2010	21.000	\N
102	25025070500	2010	90.000	\N
102	25025070600	2010	11.000	\N
102	25025070700	2010	19.000	\N
102	25025070800	2010	33.000	\N
102	25025070900	2010	59.000	\N
102	25025071101	2010	41.000	\N
102	25025071201	2010	57.000	\N
102	25025080100	2010	48.000	\N
102	25025080300	2010	50.000	\N
102	25025080401	2010	128.000	\N
102	25025080500	2010	118.000	\N
102	25025080601	2010	66.000	\N
102	25025080801	2010	109.000	\N
102	25025080900	2010	41.000	\N
102	25025081001	2010	90.000	\N
102	25025081100	2010	58.000	\N
102	25025081200	2010	182.000	\N
102	25025081300	2010	243.000	\N
102	25025081400	2010	51.000	\N
102	25025081500	2010	55.000	\N
102	25025081700	2010	78.000	\N
102	25025081800	2010	92.000	\N
102	25025081900	2010	83.000	\N
102	25025082000	2010	54.000	\N
102	25025082100	2010	154.000	\N
102	25025090100	2010	108.000	\N
102	25025090200	2010	74.000	\N
102	25025090300	2010	82.000	\N
102	25025090400	2010	144.000	\N
102	25025090600	2010	49.000	\N
102	25025090700	2010	24.000	\N
102	25025090901	2010	51.000	\N
102	25025091001	2010	18.000	\N
102	25025091100	2010	32.000	\N
102	25025091200	2010	77.000	\N
102	25025091300	2010	59.000	\N
102	25025091400	2010	59.000	\N
102	25025091500	2010	80.000	\N
102	25025091600	2010	47.000	\N
102	25025091700	2010	73.000	\N
102	25025091800	2010	32.000	\N
102	25025091900	2010	81.000	\N
102	25025092000	2010	104.000	\N
102	25025092101	2010	62.000	\N
102	25025092200	2010	46.000	\N
102	25025092300	2010	48.000	\N
102	25025092400	2010	147.000	\N
102	25025100100	2010	127.000	\N
102	25025100200	2010	43.000	\N
102	25025100300	2010	46.000	\N
102	25025100400	2010	62.000	\N
102	25025100500	2010	95.000	\N
102	25025100601	2010	61.000	\N
102	25025100603	2010	4.000	\N
102	25025100700	2010	9.000	\N
102	25025100800	2010	61.000	\N
102	25025100900	2010	42.000	\N
102	25025101001	2010	61.000	\N
102	25025101002	2010	85.000	\N
102	25025101101	2010	54.000	\N
102	25025101102	2010	44.000	\N
102	25025110103	2010	140.000	\N
102	25025110201	2010	63.000	\N
102	25025110301	2010	49.000	\N
102	25025110401	2010	127.000	\N
102	25025110403	2010	109.000	\N
102	25025110501	2010	60.000	\N
102	25025110502	2010	71.000	\N
102	25025110601	2010	12.000	\N
102	25025110607	2010	46.000	\N
102	25025120103	2010	13.000	\N
102	25025120104	2010	30.000	\N
102	25025120105	2010	26.000	\N
102	25025120201	2010	71.000	\N
102	25025120301	2010	191.000	\N
102	25025120400	2010	44.000	\N
102	25025120500	2010	121.000	\N
102	25025120600	2010	47.000	\N
102	25025120700	2010	38.000	\N
102	25025130100	2010	24.000	\N
102	25025130200	2010	26.000	\N
102	25025130300	2010	20.000	\N
102	25025130402	2010	20.000	\N
102	25025130404	2010	10.000	\N
102	25025130406	2010	96.000	\N
102	25025140102	2010	66.000	\N
102	25025140105	2010	77.000	\N
102	25025140106	2010	63.000	\N
102	25025140107	2010	78.000	\N
102	25025140201	2010	33.000	\N
102	25025140202	2010	122.000	\N
102	25025140300	2010	133.000	\N
102	25025140400	2010	104.000	\N
102	25025160101	2010	332.000	\N
102	25025160200	2010	194.000	\N
102	25025160300	2010	35.000	\N
102	25025160400	2010	151.000	\N
102	25025160501	2010	274.000	\N
102	25025160502	2010	208.000	\N
102	25025160601	2010	118.000	\N
102	25025160602	2010	183.000	\N
102	25025170100	2010	134.000	\N
102	25025170200	2010	57.000	\N
102	25025170300	2010	79.000	\N
102	25025170400	2010	95.000	\N
102	25025170501	2010	56.000	\N
102	25025170502	2010	26.000	\N
102	25025170601	2010	97.000	\N
102	25025170701	2010	28.000	\N
102	25025170702	2010	171.000	\N
102	25025170800	2010	85.000	\N
102	25025180101	2010	28.000	\N
102	25025180200	2010	23.000	\N
102	25025180301	2010	5.000	\N
102	25025180400	2010	10.000	\N
102	25025180500	2010	23.000	\N
102	25025980101	2010	10.000	\N
102	25025980300	2010	3.000	\N
102	25025980700	2010	0.000	\N
102	25025981000	2010	0.000	\N
102	25025981100	2010	1.000	\N
102	25025981201	2010	0.000	\N
102	25025981202	2010	0.000	\N
102	25025981300	2010	1.000	\N
102	25025981501	2010	0.000	\N
102	25025981502	2010	0.000	\N
102	25025981600	2010	0.000	\N
102	25025981700	2010	0.000	\N
102	25025981800	2010	1.000	\N
102	25025990101	2010	0.000	\N
102	25027700100	2010	15.000	\N
102	25027701100	2010	30.000	\N
102	25027702200	2010	12.000	\N
102	25027703100	2010	28.000	\N
102	25027703200	2010	7.000	\N
102	25027703300	2010	12.000	\N
102	25027704200	2010	3.000	\N
102	25027705100	2010	22.000	\N
102	25027706100	2010	2.000	\N
102	25027707100	2010	34.000	\N
102	25027707200	2010	9.000	\N
102	25027707300	2010	26.000	\N
102	25027707400	2010	19.000	\N
102	25027707500	2010	19.000	\N
102	25027708100	2010	19.000	\N
102	25027709100	2010	16.000	\N
102	25027709201	2010	68.000	\N
102	25027709202	2010	80.000	\N
102	25027709400	2010	77.000	\N
102	25027709501	2010	13.000	\N
102	25027709502	2010	10.000	\N
102	25027709600	2010	27.000	\N
102	25027709701	2010	79.000	\N
102	25027709702	2010	25.000	\N
102	25027710100	2010	71.000	\N
102	25027710200	2010	83.000	\N
102	25027710300	2010	32.000	\N
102	25027710400	2010	22.000	\N
102	25027710500	2010	97.000	\N
102	25027710600	2010	132.000	\N
102	25027710700	2010	42.000	\N
102	25027710800	2010	78.000	\N
102	25027711000	2010	40.000	\N
102	25027711100	2010	16.000	\N
102	25027712101	2010	10.000	\N
102	25027712102	2010	13.000	\N
102	25027713100	2010	41.000	\N
102	25027715100	2010	9.000	\N
102	25027716100	2010	48.000	\N
102	25027716200	2010	30.000	\N
102	25027716300	2010	32.000	\N
102	25027717100	2010	0.000	\N
102	25027718100	2010	4.000	\N
102	25027719100	2010	5.000	\N
102	25027720100	2010	4.000	\N
102	25027721101	2010	3.000	\N
102	25027721102	2010	9.000	\N
102	25027722100	2010	4.000	\N
102	25027723100	2010	10.000	\N
102	25027724100	2010	9.000	\N
102	25027725100	2010	14.000	\N
102	25027726100	2010	13.000	\N
102	25027726200	2010	15.000	\N
102	25027727100	2010	13.000	\N
102	25027728100	2010	14.000	\N
102	25027728200	2010	7.000	\N
102	25027728300	2010	11.000	\N
102	25027728400	2010	8.000	\N
102	25027729100	2010	6.000	\N
102	25027729200	2010	2.000	\N
102	25027730100	2010	37.000	\N
102	25027730200	2010	31.000	\N
102	25027730300	2010	33.000	\N
102	25027730401	2010	88.000	\N
102	25027730402	2010	19.000	\N
102	25027730500	2010	64.000	\N
102	25027730600	2010	29.000	\N
102	25027730700	2010	38.000	\N
102	25027730801	2010	8.000	\N
102	25027730802	2010	24.000	\N
102	25027730901	2010	33.000	\N
102	25027730902	2010	16.000	\N
102	25027731001	2010	7.000	\N
102	25027731002	2010	101.000	\N
102	25027731101	2010	83.000	\N
102	25027731102	2010	28.000	\N
102	25027731202	2010	11.000	\N
102	25027731203	2010	147.000	\N
102	25027731204	2010	78.000	\N
102	25027731300	2010	197.000	\N
102	25027731400	2010	149.000	\N
102	25027731500	2010	106.000	\N
102	25027731600	2010	60.000	\N
102	25027731700	2010	34.000	\N
102	25027731800	2010	179.000	\N
102	25027731900	2010	117.000	\N
102	25027732001	2010	239.000	\N
102	25027732002	2010	32.000	\N
102	25027732201	2010	21.000	\N
102	25027732202	2010	39.000	\N
102	25027732203	2010	41.000	\N
102	25027732301	2010	37.000	\N
102	25027732302	2010	60.000	\N
102	25027732400	2010	186.000	\N
102	25027732500	2010	70.000	\N
102	25027732600	2010	117.000	\N
102	25027732700	2010	59.000	\N
102	25027732801	2010	25.000	\N
102	25027732802	2010	32.000	\N
102	25027732901	2010	110.000	\N
102	25027732902	2010	15.000	\N
102	25027733000	2010	147.000	\N
102	25027733101	2010	32.000	\N
102	25027733102	2010	18.000	\N
102	25027735100	2010	21.000	\N
102	25027735200	2010	16.000	\N
102	25027736100	2010	2.000	\N
102	25027736200	2010	21.000	\N
102	25027736300	2010	6.000	\N
102	25027736400	2010	7.000	\N
102	25027736500	2010	4.000	\N
102	25027737100	2010	16.000	\N
102	25027737200	2010	6.000	\N
102	25027737300	2010	14.000	\N
102	25027738100	2010	12.000	\N
102	25027738201	2010	6.000	\N
102	25027738202	2010	11.000	\N
102	25027739100	2010	21.000	\N
102	25027739200	2010	18.000	\N
102	25027739300	2010	7.000	\N
102	25027739400	2010	8.000	\N
102	25027739500	2010	8.000	\N
102	25027740101	2010	4.000	\N
102	25027740102	2010	11.000	\N
102	25027740200	2010	9.000	\N
102	25027741101	2010	7.000	\N
102	25027741102	2010	22.000	\N
102	25027742300	2010	23.000	\N
102	25027742401	2010	3.000	\N
102	25027742402	2010	8.000	\N
102	25027743100	2010	10.000	\N
102	25027744101	2010	20.000	\N
102	25027744102	2010	20.000	\N
102	25027744200	2010	35.000	\N
102	25027744300	2010	39.000	\N
102	25027744400	2010	35.000	\N
102	25027745100	2010	16.000	\N
102	25027746100	2010	2.000	\N
102	25027747101	2010	4.000	\N
102	25027747102	2010	3.000	\N
102	25027748100	2010	3.000	\N
102	25027749100	2010	6.000	\N
102	25027749200	2010	13.000	\N
102	25027750100	2010	12.000	\N
102	25027750200	2010	15.000	\N
102	25027750300	2010	7.000	\N
102	25027751101	2010	1.000	\N
102	25027751102	2010	5.000	\N
102	25027752100	2010	10.000	\N
102	25027753100	2010	20.000	\N
102	25027753200	2010	15.000	\N
102	25027754100	2010	28.000	\N
102	25027754200	2010	23.000	\N
102	25027754300	2010	22.000	\N
102	25027754400	2010	27.000	\N
102	25027755100	2010	10.000	\N
102	25027755200	2010	19.000	\N
102	25027756101	2010	13.000	\N
102	25027756102	2010	24.000	\N
102	25027757100	2010	79.000	\N
102	25027757200	2010	72.000	\N
102	25027757300	2010	59.000	\N
102	25027757400	2010	29.000	\N
102	25027757500	2010	54.000	\N
102	25027758101	2010	0.000	\N
102	25027758102	2010	20.000	\N
102	25027759100	2010	3.000	\N
102	25027760100	2010	4.000	\N
102	25027761100	2010	24.000	\N
102	25027761200	2010	12.000	\N
102	25027761300	2010	4.000	\N
102	25027761400	2010	18.000	\N
\.


--
-- TOC entry 1873 (class 0 OID 4499853)
-- Dependencies: 166
-- Data for Name: lu_fact_types; Type: TABLE DATA; Schema: census; Owner: postgres
--

COPY lu_fact_types (fact_type_id, category, fact_subcats, short_name) FROM stdin;
1	Housing	{S01,"OCCUPANCY STATUS","Total housing units",HD01,Number}	s01
2	Housing	{S02,"OCCUPANCY STATUS","Total housing units","Occupied housing units",HD01,Number}	s02
3	Housing	{S03,"OCCUPANCY STATUS","Total housing units","Vacant housing units",HD01,Number}	s03
4	Housing	{S04,TENURE,"Occupied housing units",HD01,Number}	s04
5	Housing	{S05,TENURE,"Occupied housing units","Owner occupied",HD01,Number}	s05
6	Housing	{S06,TENURE,"Occupied housing units","Owner occupied","Owned with a mortgage or loan",HD01,Number}	s06
7	Housing	{S07,TENURE,"Occupied housing units","Owner occupied","Owned free and clear",HD01,Number}	s07
8	Housing	{S08,TENURE,"Occupied housing units","Renter occupied",HD01,Number}	s08
9	Housing	{S09,"VACANCY STATUS","Vacant housing units",HD01,Number}	s09
10	Housing	{S10,"VACANCY STATUS","Vacant housing units","For rent",HD01,Number}	s10
11	Housing	{S11,"VACANCY STATUS","Vacant housing units","Rented, not occupied",HD01,Number}	s11
12	Housing	{S12,"VACANCY STATUS","Vacant housing units","For sale only",HD01,Number}	s12
13	Housing	{S13,"VACANCY STATUS","Vacant housing units","Sold, not occupied",HD01,Number}	s13
14	Housing	{S14,"VACANCY STATUS","Vacant housing units","For seasonal, recreational, or occasional use",HD01,Number}	s14
15	Housing	{S15,"VACANCY STATUS","Vacant housing units","For migratory workers",HD01,Number}	s15
16	Housing	{S16,"VACANCY STATUS","Vacant housing units","Other vacant",HD01,Number}	s16
17	Housing	{S17,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units",HD01,Number}	s17
18	Housing	{S18,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units",HD01,Number}	s18
19	Housing	{S19,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder",HD01,Number}	s19
20	Housing	{S20,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","White alone householder",HD01,Number}	s20
21	Housing	{S21,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","Black or African American alone householder",HD01,Number}	s21
22	Housing	{S22,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","American Indian and Alaska Native alone householder",HD01,Number}	s22
23	Housing	{S23,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","Asian alone householder",HD01,Number}	s23
24	Housing	{S24,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","Native Hawaiian and Other Pacific Islander alone householder",HD01,Number}	s24
25	Housing	{S25,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","Some Other Race alone householder",HD01,Number}	s25
26	Housing	{S26,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Not Hispanic or Latino householder","Two or More Races householder",HD01,Number}	s26
27	Housing	{S27,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder",HD01,Number}	s27
28	Housing	{S28,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","White alone householder",HD01,Number}	s28
29	Housing	{S29,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","Black or African American alone householder",HD01,Number}	s29
30	Housing	{S30,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","American Indian and Alaska Native alone householder",HD01,Number}	s30
31	Housing	{S31,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","Asian alone householder",HD01,Number}	s31
32	Housing	{S32,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","Native Hawaiian and Other Pacific Islander alone householder",HD01,Number}	s32
33	Housing	{S33,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","Some Other Race alone householder",HD01,Number}	s33
34	Housing	{S34,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Owner-occupied housing units","Hispanic or Latino householder","Two or More Races householder",HD01,Number}	s34
35	Housing	{S35,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units",HD01,Number}	s35
36	Housing	{S36,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder",HD01,Number}	s36
37	Housing	{S37,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","White alone householder",HD01,Number}	s37
38	Housing	{S38,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","Black or African American alone householder",HD01,Number}	s38
39	Housing	{S39,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","American Indian and Alaska Native alone householder",HD01,Number}	s39
40	Housing	{S40,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","Asian alone householder",HD01,Number}	s40
41	Housing	{S41,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","Native Hawaiian and Other Pacific Islander alone householder",HD01,Number}	s41
42	Housing	{S42,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","Some Other Race alone householder",HD01,Number}	s42
43	Housing	{S43,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Not Hispanic or Latino householder","Two or More Races householder",HD01,Number}	s43
44	Housing	{S44,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder",HD01,Number}	s44
45	Housing	{S45,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","White alone householder",HD01,Number}	s45
46	Housing	{S46,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","Black or African American alone householder",HD01,Number}	s46
47	Housing	{S47,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","American Indian and Alaska Native alone householder",HD01,Number}	s47
48	Housing	{S48,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","Asian alone householder",HD01,Number}	s48
49	Housing	{S49,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","Native Hawaiian and Other Pacific Islander alone householder",HD01,Number}	s49
50	Housing	{S50,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","Some Other Race alone householder",HD01,Number}	s50
51	Housing	{S51,"TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER","Occupied housing units","Renter-occupied housing units","Hispanic or Latino householder","Two or More Races householder",HD01,Number}	s51
86	Population	{D001,Total:}	d001
87	Population	{D002,Total:,"Not Hispanic or Latino:"}	d002
88	Population	{D003,Total:,"Not Hispanic or Latino:","White alone"}	d003
89	Population	{D004,Total:,"Not Hispanic or Latino:","Black or African American alone"}	d004
90	Population	{D005,Total:,"Not Hispanic or Latino:","American Indian and Alaska Native alone"}	d005
91	Population	{D006,Total:,"Not Hispanic or Latino:","Asian alone"}	d006
92	Population	{D007,Total:,"Not Hispanic or Latino:","Native Hawaiian and Other Pacific Islander alone"}	d007
93	Population	{D008,Total:,"Not Hispanic or Latino:","Some Other Race alone"}	d008
94	Population	{D009,Total:,"Not Hispanic or Latino:","Two or More Races"}	d009
95	Population	{D010,Total:,"Hispanic or Latino:"}	d010
96	Population	{D011,Total:,"Hispanic or Latino:","White alone"}	d011
97	Population	{D012,Total:,"Hispanic or Latino:","Black or African American alone"}	d012
98	Population	{D013,Total:,"Hispanic or Latino:","American Indian and Alaska Native alone"}	d013
99	Population	{D014,Total:,"Hispanic or Latino:","Asian alone"}	d014
100	Population	{D015,Total:,"Hispanic or Latino:","Native Hawaiian and Other Pacific Islander alone"}	d015
101	Population	{D016,Total:,"Hispanic or Latino:","Some Other Race alone"}	d016
102	Population	{D017,Total:,"Hispanic or Latino:","Two or More Races"}	d017
\.


--
-- TOC entry 1872 (class 0 OID 4499846)
-- Dependencies: 164
-- Data for Name: lu_tracts; Type: TABLE DATA; Schema: census; Owner: postgres
--

COPY lu_tracts (tract_id, tract_long_id, tract_name) FROM stdin;
25025000401	1400000US25025000401	Census Tract 4.01, Suffolk County, Massachusetts
25025000402	1400000US25025000402	Census Tract 4.02, Suffolk County, Massachusetts
25025000100	1400000US25025000100	Census Tract 1, Suffolk County, Massachusetts
25025000201	1400000US25025000201	Census Tract 2.01, Suffolk County, Massachusetts
25025000202	1400000US25025000202	Census Tract 2.02, Suffolk County, Massachusetts
25025000301	1400000US25025000301	Census Tract 3.01, Suffolk County, Massachusetts
25025000302	1400000US25025000302	Census Tract 3.02, Suffolk County, Massachusetts
25025000502	1400000US25025000502	Census Tract 5.02, Suffolk County, Massachusetts
25025000503	1400000US25025000503	Census Tract 5.03, Suffolk County, Massachusetts
25025000504	1400000US25025000504	Census Tract 5.04, Suffolk County, Massachusetts
25025000601	1400000US25025000601	Census Tract 6.01, Suffolk County, Massachusetts
25025000602	1400000US25025000602	Census Tract 6.02, Suffolk County, Massachusetts
25025000701	1400000US25025000701	Census Tract 7.01, Suffolk County, Massachusetts
25025000703	1400000US25025000703	Census Tract 7.03, Suffolk County, Massachusetts
25025000704	1400000US25025000704	Census Tract 7.04, Suffolk County, Massachusetts
25025000802	1400000US25025000802	Census Tract 8.02, Suffolk County, Massachusetts
25025000803	1400000US25025000803	Census Tract 8.03, Suffolk County, Massachusetts
25025010103	1400000US25025010103	Census Tract 101.03, Suffolk County, Massachusetts
25025010104	1400000US25025010104	Census Tract 101.04, Suffolk County, Massachusetts
25025010203	1400000US25025010203	Census Tract 102.03, Suffolk County, Massachusetts
25025010204	1400000US25025010204	Census Tract 102.04, Suffolk County, Massachusetts
25025010300	1400000US25025010300	Census Tract 103, Suffolk County, Massachusetts
25025010403	1400000US25025010403	Census Tract 104.03, Suffolk County, Massachusetts
25025010404	1400000US25025010404	Census Tract 104.04, Suffolk County, Massachusetts
25025010405	1400000US25025010405	Census Tract 104.05, Suffolk County, Massachusetts
25025010408	1400000US25025010408	Census Tract 104.08, Suffolk County, Massachusetts
25025010500	1400000US25025010500	Census Tract 105, Suffolk County, Massachusetts
25025010600	1400000US25025010600	Census Tract 106, Suffolk County, Massachusetts
25025010701	1400000US25025010701	Census Tract 107.01, Suffolk County, Massachusetts
25025010702	1400000US25025010702	Census Tract 107.02, Suffolk County, Massachusetts
25025010801	1400000US25025010801	Census Tract 108.01, Suffolk County, Massachusetts
25025010802	1400000US25025010802	Census Tract 108.02, Suffolk County, Massachusetts
25025020101	1400000US25025020101	Census Tract 201.01, Suffolk County, Massachusetts
25025020200	1400000US25025020200	Census Tract 202, Suffolk County, Massachusetts
25025020301	1400000US25025020301	Census Tract 203.01, Suffolk County, Massachusetts
25025020302	1400000US25025020302	Census Tract 203.02, Suffolk County, Massachusetts
25025020303	1400000US25025020303	Census Tract 203.03, Suffolk County, Massachusetts
25025030100	1400000US25025030100	Census Tract 301, Suffolk County, Massachusetts
25025030200	1400000US25025030200	Census Tract 302, Suffolk County, Massachusetts
25025030300	1400000US25025030300	Census Tract 303, Suffolk County, Massachusetts
25025030400	1400000US25025030400	Census Tract 304, Suffolk County, Massachusetts
25025030500	1400000US25025030500	Census Tract 305, Suffolk County, Massachusetts
25025040100	1400000US25025040100	Census Tract 401, Suffolk County, Massachusetts
25025040200	1400000US25025040200	Census Tract 402, Suffolk County, Massachusetts
25025040300	1400000US25025040300	Census Tract 403, Suffolk County, Massachusetts
25025040401	1400000US25025040401	Census Tract 404.01, Suffolk County, Massachusetts
25025040600	1400000US25025040600	Census Tract 406, Suffolk County, Massachusetts
25025040801	1400000US25025040801	Census Tract 408.01, Suffolk County, Massachusetts
25025050101	1400000US25025050101	Census Tract 501.01, Suffolk County, Massachusetts
25025050200	1400000US25025050200	Census Tract 502, Suffolk County, Massachusetts
25025050300	1400000US25025050300	Census Tract 503, Suffolk County, Massachusetts
25025050400	1400000US25025050400	Census Tract 504, Suffolk County, Massachusetts
25025050500	1400000US25025050500	Census Tract 505, Suffolk County, Massachusetts
25025050600	1400000US25025050600	Census Tract 506, Suffolk County, Massachusetts
25025050700	1400000US25025050700	Census Tract 507, Suffolk County, Massachusetts
25025050901	1400000US25025050901	Census Tract 509.01, Suffolk County, Massachusetts
25025051000	1400000US25025051000	Census Tract 510, Suffolk County, Massachusetts
25025051101	1400000US25025051101	Census Tract 511.01, Suffolk County, Massachusetts
25025051200	1400000US25025051200	Census Tract 512, Suffolk County, Massachusetts
25025060101	1400000US25025060101	Census Tract 601.01, Suffolk County, Massachusetts
25025060200	1400000US25025060200	Census Tract 602, Suffolk County, Massachusetts
25025060301	1400000US25025060301	Census Tract 603.01, Suffolk County, Massachusetts
25025060400	1400000US25025060400	Census Tract 604, Suffolk County, Massachusetts
25025060501	1400000US25025060501	Census Tract 605.01, Suffolk County, Massachusetts
25025060600	1400000US25025060600	Census Tract 606, Suffolk County, Massachusetts
25025060700	1400000US25025060700	Census Tract 607, Suffolk County, Massachusetts
25025060800	1400000US25025060800	Census Tract 608, Suffolk County, Massachusetts
25025061000	1400000US25025061000	Census Tract 610, Suffolk County, Massachusetts
25025061101	1400000US25025061101	Census Tract 611.01, Suffolk County, Massachusetts
25025061200	1400000US25025061200	Census Tract 612, Suffolk County, Massachusetts
25025070101	1400000US25025070101	Census Tract 701.01, Suffolk County, Massachusetts
25025070200	1400000US25025070200	Census Tract 702, Suffolk County, Massachusetts
25025070300	1400000US25025070300	Census Tract 703, Suffolk County, Massachusetts
25025070402	1400000US25025070402	Census Tract 704.02, Suffolk County, Massachusetts
25025070500	1400000US25025070500	Census Tract 705, Suffolk County, Massachusetts
25025070600	1400000US25025070600	Census Tract 706, Suffolk County, Massachusetts
25025070700	1400000US25025070700	Census Tract 707, Suffolk County, Massachusetts
25025070800	1400000US25025070800	Census Tract 708, Suffolk County, Massachusetts
25025070900	1400000US25025070900	Census Tract 709, Suffolk County, Massachusetts
25025071101	1400000US25025071101	Census Tract 711.01, Suffolk County, Massachusetts
25025071201	1400000US25025071201	Census Tract 712.01, Suffolk County, Massachusetts
25025080100	1400000US25025080100	Census Tract 801, Suffolk County, Massachusetts
25025080300	1400000US25025080300	Census Tract 803, Suffolk County, Massachusetts
25025080401	1400000US25025080401	Census Tract 804.01, Suffolk County, Massachusetts
25025080500	1400000US25025080500	Census Tract 805, Suffolk County, Massachusetts
25025080601	1400000US25025080601	Census Tract 806.01, Suffolk County, Massachusetts
25025080801	1400000US25025080801	Census Tract 808.01, Suffolk County, Massachusetts
25025080900	1400000US25025080900	Census Tract 809, Suffolk County, Massachusetts
25025081001	1400000US25025081001	Census Tract 810.01, Suffolk County, Massachusetts
25025081100	1400000US25025081100	Census Tract 811, Suffolk County, Massachusetts
25025081200	1400000US25025081200	Census Tract 812, Suffolk County, Massachusetts
25025081300	1400000US25025081300	Census Tract 813, Suffolk County, Massachusetts
25025081400	1400000US25025081400	Census Tract 814, Suffolk County, Massachusetts
25025081500	1400000US25025081500	Census Tract 815, Suffolk County, Massachusetts
25025081700	1400000US25025081700	Census Tract 817, Suffolk County, Massachusetts
25025081800	1400000US25025081800	Census Tract 818, Suffolk County, Massachusetts
25025081900	1400000US25025081900	Census Tract 819, Suffolk County, Massachusetts
25025082000	1400000US25025082000	Census Tract 820, Suffolk County, Massachusetts
25025082100	1400000US25025082100	Census Tract 821, Suffolk County, Massachusetts
25025090100	1400000US25025090100	Census Tract 901, Suffolk County, Massachusetts
25025090200	1400000US25025090200	Census Tract 902, Suffolk County, Massachusetts
25025090300	1400000US25025090300	Census Tract 903, Suffolk County, Massachusetts
25025090400	1400000US25025090400	Census Tract 904, Suffolk County, Massachusetts
25025090600	1400000US25025090600	Census Tract 906, Suffolk County, Massachusetts
25025090700	1400000US25025090700	Census Tract 907, Suffolk County, Massachusetts
25025090901	1400000US25025090901	Census Tract 909.01, Suffolk County, Massachusetts
25025091001	1400000US25025091001	Census Tract 910.01, Suffolk County, Massachusetts
25025091100	1400000US25025091100	Census Tract 911, Suffolk County, Massachusetts
25025091200	1400000US25025091200	Census Tract 912, Suffolk County, Massachusetts
25025091300	1400000US25025091300	Census Tract 913, Suffolk County, Massachusetts
25025091400	1400000US25025091400	Census Tract 914, Suffolk County, Massachusetts
25025091500	1400000US25025091500	Census Tract 915, Suffolk County, Massachusetts
25025091600	1400000US25025091600	Census Tract 916, Suffolk County, Massachusetts
25025091700	1400000US25025091700	Census Tract 917, Suffolk County, Massachusetts
25025091800	1400000US25025091800	Census Tract 918, Suffolk County, Massachusetts
25025091900	1400000US25025091900	Census Tract 919, Suffolk County, Massachusetts
25025092000	1400000US25025092000	Census Tract 920, Suffolk County, Massachusetts
25025092101	1400000US25025092101	Census Tract 921.01, Suffolk County, Massachusetts
25025092200	1400000US25025092200	Census Tract 922, Suffolk County, Massachusetts
25025092300	1400000US25025092300	Census Tract 923, Suffolk County, Massachusetts
25025092400	1400000US25025092400	Census Tract 924, Suffolk County, Massachusetts
25025100100	1400000US25025100100	Census Tract 1001, Suffolk County, Massachusetts
25025100200	1400000US25025100200	Census Tract 1002, Suffolk County, Massachusetts
25025100300	1400000US25025100300	Census Tract 1003, Suffolk County, Massachusetts
25025100400	1400000US25025100400	Census Tract 1004, Suffolk County, Massachusetts
25025100500	1400000US25025100500	Census Tract 1005, Suffolk County, Massachusetts
25025100601	1400000US25025100601	Census Tract 1006.01, Suffolk County, Massachusetts
25025100603	1400000US25025100603	Census Tract 1006.03, Suffolk County, Massachusetts
25025100700	1400000US25025100700	Census Tract 1007, Suffolk County, Massachusetts
25025100800	1400000US25025100800	Census Tract 1008, Suffolk County, Massachusetts
25025100900	1400000US25025100900	Census Tract 1009, Suffolk County, Massachusetts
25025101001	1400000US25025101001	Census Tract 1010.01, Suffolk County, Massachusetts
25025101002	1400000US25025101002	Census Tract 1010.02, Suffolk County, Massachusetts
25025101101	1400000US25025101101	Census Tract 1011.01, Suffolk County, Massachusetts
25025101102	1400000US25025101102	Census Tract 1011.02, Suffolk County, Massachusetts
25025110103	1400000US25025110103	Census Tract 1101.03, Suffolk County, Massachusetts
25025110201	1400000US25025110201	Census Tract 1102.01, Suffolk County, Massachusetts
25025110301	1400000US25025110301	Census Tract 1103.01, Suffolk County, Massachusetts
25025110401	1400000US25025110401	Census Tract 1104.01, Suffolk County, Massachusetts
25025110403	1400000US25025110403	Census Tract 1104.03, Suffolk County, Massachusetts
25025110501	1400000US25025110501	Census Tract 1105.01, Suffolk County, Massachusetts
25025110502	1400000US25025110502	Census Tract 1105.02, Suffolk County, Massachusetts
25025110601	1400000US25025110601	Census Tract 1106.01, Suffolk County, Massachusetts
25025110607	1400000US25025110607	Census Tract 1106.07, Suffolk County, Massachusetts
25025120103	1400000US25025120103	Census Tract 1201.03, Suffolk County, Massachusetts
25025120104	1400000US25025120104	Census Tract 1201.04, Suffolk County, Massachusetts
25025120105	1400000US25025120105	Census Tract 1201.05, Suffolk County, Massachusetts
25025120201	1400000US25025120201	Census Tract 1202.01, Suffolk County, Massachusetts
25025120301	1400000US25025120301	Census Tract 1203.01, Suffolk County, Massachusetts
25025120400	1400000US25025120400	Census Tract 1204, Suffolk County, Massachusetts
25025120500	1400000US25025120500	Census Tract 1205, Suffolk County, Massachusetts
25025120600	1400000US25025120600	Census Tract 1206, Suffolk County, Massachusetts
25025120700	1400000US25025120700	Census Tract 1207, Suffolk County, Massachusetts
25025130100	1400000US25025130100	Census Tract 1301, Suffolk County, Massachusetts
25025130200	1400000US25025130200	Census Tract 1302, Suffolk County, Massachusetts
25025130300	1400000US25025130300	Census Tract 1303, Suffolk County, Massachusetts
25025130402	1400000US25025130402	Census Tract 1304.02, Suffolk County, Massachusetts
25025130404	1400000US25025130404	Census Tract 1304.04, Suffolk County, Massachusetts
25025130406	1400000US25025130406	Census Tract 1304.06, Suffolk County, Massachusetts
25025140102	1400000US25025140102	Census Tract 1401.02, Suffolk County, Massachusetts
25025140105	1400000US25025140105	Census Tract 1401.05, Suffolk County, Massachusetts
25025140106	1400000US25025140106	Census Tract 1401.06, Suffolk County, Massachusetts
25025140107	1400000US25025140107	Census Tract 1401.07, Suffolk County, Massachusetts
25025140201	1400000US25025140201	Census Tract 1402.01, Suffolk County, Massachusetts
25025140202	1400000US25025140202	Census Tract 1402.02, Suffolk County, Massachusetts
25025140300	1400000US25025140300	Census Tract 1403, Suffolk County, Massachusetts
25025140400	1400000US25025140400	Census Tract 1404, Suffolk County, Massachusetts
25025160101	1400000US25025160101	Census Tract 1601.01, Suffolk County, Massachusetts
25025160200	1400000US25025160200	Census Tract 1602, Suffolk County, Massachusetts
25025160300	1400000US25025160300	Census Tract 1603, Suffolk County, Massachusetts
25025160400	1400000US25025160400	Census Tract 1604, Suffolk County, Massachusetts
25025160501	1400000US25025160501	Census Tract 1605.01, Suffolk County, Massachusetts
25025160502	1400000US25025160502	Census Tract 1605.02, Suffolk County, Massachusetts
25025160601	1400000US25025160601	Census Tract 1606.01, Suffolk County, Massachusetts
25025160602	1400000US25025160602	Census Tract 1606.02, Suffolk County, Massachusetts
25025170100	1400000US25025170100	Census Tract 1701, Suffolk County, Massachusetts
25025170200	1400000US25025170200	Census Tract 1702, Suffolk County, Massachusetts
25025170300	1400000US25025170300	Census Tract 1703, Suffolk County, Massachusetts
25025170400	1400000US25025170400	Census Tract 1704, Suffolk County, Massachusetts
25025170501	1400000US25025170501	Census Tract 1705.01, Suffolk County, Massachusetts
25025170502	1400000US25025170502	Census Tract 1705.02, Suffolk County, Massachusetts
25025170601	1400000US25025170601	Census Tract 1706.01, Suffolk County, Massachusetts
25025170701	1400000US25025170701	Census Tract 1707.01, Suffolk County, Massachusetts
25025170702	1400000US25025170702	Census Tract 1707.02, Suffolk County, Massachusetts
25025170800	1400000US25025170800	Census Tract 1708, Suffolk County, Massachusetts
25025180101	1400000US25025180101	Census Tract 1801.01, Suffolk County, Massachusetts
25025180200	1400000US25025180200	Census Tract 1802, Suffolk County, Massachusetts
25025180301	1400000US25025180301	Census Tract 1803.01, Suffolk County, Massachusetts
25025180400	1400000US25025180400	Census Tract 1804, Suffolk County, Massachusetts
25025180500	1400000US25025180500	Census Tract 1805, Suffolk County, Massachusetts
25025980101	1400000US25025980101	Census Tract 9801.01, Suffolk County, Massachusetts
25025980300	1400000US25025980300	Census Tract 9803, Suffolk County, Massachusetts
25025980700	1400000US25025980700	Census Tract 9807, Suffolk County, Massachusetts
25025981000	1400000US25025981000	Census Tract 9810, Suffolk County, Massachusetts
25025981100	1400000US25025981100	Census Tract 9811, Suffolk County, Massachusetts
25025981201	1400000US25025981201	Census Tract 9812.01, Suffolk County, Massachusetts
25025981202	1400000US25025981202	Census Tract 9812.02, Suffolk County, Massachusetts
25025981300	1400000US25025981300	Census Tract 9813, Suffolk County, Massachusetts
25025981501	1400000US25025981501	Census Tract 9815.01, Suffolk County, Massachusetts
25025981502	1400000US25025981502	Census Tract 9815.02, Suffolk County, Massachusetts
25025981600	1400000US25025981600	Census Tract 9816, Suffolk County, Massachusetts
25025981700	1400000US25025981700	Census Tract 9817, Suffolk County, Massachusetts
25025981800	1400000US25025981800	Census Tract 9818, Suffolk County, Massachusetts
25025990101	1400000US25025990101	Census Tract 9901.01, Suffolk County, Massachusetts
\.


SET search_path = staging, pg_catalog;

--
-- TOC entry 1871 (class 0 OID 4499715)
-- Dependencies: 163
-- Data for Name: factfinder_import; Type: TABLE DATA; Schema: staging; Owner: postgres
--

COPY factfinder_import (geo_id, geo_id2, geo_display, s01, s01_perc, s02, s02_perc, s03, s03_perc, s04, s04_perc, s05, s05_perc, s06, s06_perc, s07, s07_perc, s08, s08_perc, s09, s09_perc, s10, s10_perc, s11, s11_perc, s12, s12_perc, s13, s13_perc, s14, s14_perc, s15, s15_perc, s16, s16_perc, s17, s17_perc, s18, s18_perc, s19, s19_perc, s20, s20_perc, s21, s21_perc, s22, s22_perc, s23, s23_perc, s24, s24_perc, s25, s25_perc, s26, s26_perc, s27, s27_perc, s28, s28_perc, s29, s29_perc, s30, s30_perc, s31, s31_perc, s32, s32_perc, s33, s33_perc, s34, s34_perc, s35, s35_perc, s36, s36_perc, s37, s37_perc, s38, s38_perc, s39, s39_perc, s40, s40_perc, s41, s41_perc, s42, s42_perc, s43, s43_perc, s44, s44_perc, s45, s45_perc, s46, s46_perc, s47, s47_perc, s48, s48_perc, s49, s49_perc, s50, s50_perc, s51, s51_perc) FROM stdin;
\N	\N	\N	S01	S01	S02	S02	S03	S03	S04	S04	S05	S05	S06	S06	S07	S07	S08	S08	S09	S09	S10	S10	S11	S11	S12	S12	S13	S13	S14	S14	S15	S15	S16	S16	S17	S17	S18	S18	S19	S19	S20	S20	S21	S21	S22	S22	S23	S23	S24	S24	S25	S25	S26	S26	S27	S27	S28	S28	S29	S29	S30	S30	S31	S31	S32	S32	S33	S33	S34	S34	S35	S35	S36	S36	S37	S37	S38	S38	S39	S39	S40	S40	S41	S41	S42	S42	S43	S43	S44	S44	S45	S45	S46	S46	S47	S47	S48	S48	S49	S49	S50	S50	S51	S51
\N	\N	\N	OCCUPANCY STATUS	OCCUPANCY STATUS	OCCUPANCY STATUS	OCCUPANCY STATUS	OCCUPANCY STATUS	OCCUPANCY STATUS	TENURE	TENURE	TENURE	TENURE	TENURE	TENURE	TENURE	TENURE	TENURE	TENURE	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	VACANCY STATUS	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER	TENURE BY HISPANIC OR LATINO ORIGIN OF HOUSEHOLDER BY RACE OF HOUSEHOLDER
\N	\N	\N	Total housing units	Total housing units	Total housing units	Total housing units	Total housing units	Total housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Vacant housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units	Occupied housing units
\N	\N	\N	\N	\N	Occupied housing units	Occupied housing units	Vacant housing units	Vacant housing units	\N	\N	Owner occupied	Owner occupied	Owner occupied	Owner occupied	Owner occupied	Owner occupied	Renter occupied	Renter occupied	\N	\N	For rent	For rent	Rented, not occupied	Rented, not occupied	For sale only	For sale only	Sold, not occupied	Sold, not occupied	For seasonal, recreational, or occasional use	For seasonal, recreational, or occasional use	For migratory workers	For migratory workers	Other vacant	Other vacant	\N	\N	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Owner-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units	Renter-occupied housing units
1400000US25025000401	25025000401	Census Tract 4.01, Suffolk County, Massachusetts	2965	100.0	2877	97.0	88	3.0	2877	100.0	496	17.2	355	12.3	141	4.9	2381	82.8	88	100.0	40	45.5	7	8.0	6	6.8	1	1.1	14	15.9	0	0.0	20	22.7	2877	100.0	496	17.2	483	16.8	349	12.1	4	0.1	0	0.0	123	4.3	0	0.0	0	0.0	7	0.2	13	0.5	8	0.3	0	0.0	0	0.0	0	0.0	0	0.0	5	0.2	0	0.0	2381	82.8	2289	79.6	1781	61.9	68	2.4	0	0.0	393	13.7	1	0.0	10	0.3	36	1.3	92	3.2	52	1.8	5	0.2	1	0.0	0	0.0	0	0.0	26	0.9	8	0.3
1400000US25025000402	25025000402	Census Tract 4.02, Suffolk County, Massachusetts	1543	100.0	1461	94.7	82	5.3	1461	100.0	480	32.9	342	23.4	138	9.4	981	67.1	82	100.0	47	57.3	0	0.0	4	4.9	1	1.2	10	12.2	0	0.0	20	24.4	1461	100.0	480	32.9	467	32.0	338	23.1	4	0.3	0	0.0	115	7.9	0	0.0	0	0.0	10	0.7	13	0.9	10	0.7	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	2	0.1	981	67.1	939	64.3	787	53.9	24	1.6	0	0.0	96	6.6	0	0.0	10	0.7	22	1.5	42	2.9	27	1.8	1	0.1	0	0.0	0	0.0	0	0.0	10	0.7	4	0.3
\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	Owned with a mortgage or loan	Owned with a mortgage or loan	Owned free and clear	Owned free and clear	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	\N	\N	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Not Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder	Hispanic or Latino householder
\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	\N	White alone householder	White alone householder	Black or African American alone householder	Black or African American alone householder	American Indian and Alaska Native alone householder	American Indian and Alaska Native alone householder	Asian alone householder	Asian alone householder	Native Hawaiian and Other Pacific Islander alone householder	Native Hawaiian and Other Pacific Islander alone householder	Some Other Race alone householder	Some Other Race alone householder	Two or More Races householder	Two or More Races householder	\N	\N	White alone householder	White alone householder	Black or African American alone householder	Black or African American alone householder	American Indian and Alaska Native alone householder	American Indian and Alaska Native alone householder	Asian alone householder	Asian alone householder	Native Hawaiian and Other Pacific Islander alone householder	Native Hawaiian and Other Pacific Islander alone householder	Some Other Race alone householder	Some Other Race alone householder	Two or More Races householder	Two or More Races householder	\N	\N	\N	\N	White alone householder	White alone householder	Black or African American alone householder	Black or African American alone householder	American Indian and Alaska Native alone householder	American Indian and Alaska Native alone householder	Asian alone householder	Asian alone householder	Native Hawaiian and Other Pacific Islander alone householder	Native Hawaiian and Other Pacific Islander alone householder	Some Other Race alone householder	Some Other Race alone householder	Two or More Races householder	Two or More Races householder	\N	\N	White alone householder	White alone householder	Black or African American alone householder	Black or African American alone householder	American Indian and Alaska Native alone householder	American Indian and Alaska Native alone householder	Asian alone householder	Asian alone householder	Native Hawaiian and Other Pacific Islander alone householder	Native Hawaiian and Other Pacific Islander alone householder	Some Other Race alone householder	Some Other Race alone householder	Two or More Races householder	Two or More Races householder
GEO.id	GEO.id2	GEO.display-label	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02	HD01	HD02
Id	Id2	Geography	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent	Number	Percent
1400000US25025000100	25025000100	Census Tract 1, Suffolk County, Massachusetts	1707	100.0	1616	94.7	91	5.3	1616	100.0	408	25.2	290	17.9	118	7.3	1208	74.8	91	100.0	34	37.4	6	6.6	3	3.3	1	1.1	7	7.7	0	0.0	40	44.0	1616	100.0	408	25.2	385	23.8	288	17.8	12	0.7	0	0.0	69	4.3	0	0.0	4	0.2	12	0.7	23	1.4	12	0.7	4	0.2	0	0.0	0	0.0	0	0.0	5	0.3	2	0.1	1208	74.8	1066	66.0	821	50.8	70	4.3	0	0.0	85	5.3	0	0.0	59	3.7	31	1.9	142	8.8	60	3.7	9	0.6	0	0.0	0	0.0	0	0.0	60	3.7	13	0.8
1400000US25025000201	25025000201	Census Tract 2.01, Suffolk County, Massachusetts	1618	100.0	1541	95.2	77	4.8	1541	100.0	447	29.0	322	20.9	125	8.1	1094	71.0	77	100.0	42	54.5	1	1.3	9	11.7	4	5.2	8	10.4	0	0.0	13	16.9	1541	100.0	447	29.0	428	27.8	356	23.1	12	0.8	0	0.0	53	3.4	0	0.0	2	0.1	5	0.3	19	1.2	14	0.9	0	0.0	0	0.0	1	0.1	0	0.0	1	0.1	3	0.2	1094	71.0	991	64.3	843	54.7	54	3.5	1	0.1	53	3.4	0	0.0	17	1.1	23	1.5	103	6.7	50	3.2	8	0.5	2	0.1	1	0.1	0	0.0	36	2.3	6	0.4
1400000US25025000202	25025000202	Census Tract 2.02, Suffolk County, Massachusetts	1522	100.0	1480	97.2	42	2.8	1480	100.0	474	32.0	317	21.4	157	10.6	1006	68.0	42	100.0	23	54.8	2	4.8	3	7.1	0	0.0	2	4.8	0	0.0	12	28.6	1480	100.0	474	32.0	454	30.7	364	24.6	3	0.2	1	0.1	81	5.5	0	0.0	2	0.1	3	0.2	20	1.4	15	1.0	0	0.0	0	0.0	0	0.0	0	0.0	5	0.3	0	0.0	1006	68.0	850	57.4	661	44.7	83	5.6	4	0.3	77	5.2	0	0.0	14	0.9	11	0.7	156	10.5	63	4.3	15	1.0	1	0.1	0	0.0	1	0.1	60	4.1	16	1.1
1400000US25025000301	25025000301	Census Tract 3.01, Suffolk County, Massachusetts	1219	100.0	1159	95.1	60	4.9	1159	100.0	476	41.1	347	29.9	129	11.1	683	58.9	60	100.0	34	56.7	3	5.0	5	8.3	7	11.7	3	5.0	0	0.0	8	13.3	1159	100.0	476	41.1	460	39.7	392	33.8	7	0.6	0	0.0	54	4.7	0	0.0	2	0.2	5	0.4	16	1.4	14	1.2	0	0.0	0	0.0	0	0.0	0	0.0	2	0.2	0	0.0	683	58.9	627	54.1	529	45.6	38	3.3	0	0.0	47	4.1	0	0.0	5	0.4	8	0.7	56	4.8	28	2.4	1	0.1	1	0.1	0	0.0	0	0.0	22	1.9	4	0.3
1400000US25025000302	25025000302	Census Tract 3.02, Suffolk County, Massachusetts	1346	100.0	1276	94.8	70	5.2	1276	100.0	631	49.5	413	32.4	218	17.1	645	50.5	70	100.0	33	47.1	4	5.7	8	11.4	0	0.0	11	15.7	0	0.0	14	20.0	1276	100.0	631	49.5	613	48.0	495	38.8	14	1.1	0	0.0	99	7.8	0	0.0	2	0.2	3	0.2	18	1.4	15	1.2	0	0.0	0	0.0	1	0.1	0	0.0	2	0.2	0	0.0	645	50.5	617	48.4	522	40.9	16	1.3	1	0.1	59	4.6	0	0.0	6	0.5	13	1.0	28	2.2	18	1.4	1	0.1	0	0.0	1	0.1	0	0.0	3	0.2	5	0.4
1400000US25025000502	25025000502	Census Tract 5.02, Suffolk County, Massachusetts	2041	100.0	1872	91.7	169	8.3	1872	100.0	359	19.2	264	14.1	95	5.1	1513	80.8	169	100.0	95	56.2	6	3.6	5	3.0	9	5.3	13	7.7	0	0.0	41	24.3	1872	100.0	359	19.2	349	18.6	299	16.0	6	0.3	0	0.0	41	2.2	0	0.0	1	0.1	2	0.1	10	0.5	9	0.5	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1513	80.8	1423	76.0	1184	63.2	45	2.4	2	0.1	162	8.7	2	0.1	4	0.2	24	1.3	90	4.8	61	3.3	4	0.2	0	0.0	1	0.1	0	0.0	19	1.0	5	0.3
1400000US25025000503	25025000503	Census Tract 5.03, Suffolk County, Massachusetts	1408	100.0	1341	95.2	67	4.8	1341	100.0	348	26.0	297	22.1	51	3.8	993	74.0	67	100.0	50	74.6	1	1.5	4	6.0	3	4.5	6	9.0	0	0.0	3	4.5	1341	100.0	348	26.0	338	25.2	276	20.6	8	0.6	0	0.0	46	3.4	0	0.0	2	0.1	6	0.4	10	0.7	5	0.4	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	3	0.2	993	74.0	954	71.1	805	60.0	30	2.2	1	0.1	97	7.2	0	0.0	5	0.4	16	1.2	39	2.9	25	1.9	1	0.1	0	0.0	1	0.1	0	0.0	11	0.8	1	0.1
1400000US25025000504	25025000504	Census Tract 5.04, Suffolk County, Massachusetts	2726	100.0	2637	96.7	89	3.3	2637	100.0	518	19.6	410	15.5	108	4.1	2119	80.4	89	100.0	58	65.2	6	6.7	6	6.7	1	1.1	10	11.2	0	0.0	8	9.0	2637	100.0	518	19.6	491	18.6	393	14.9	6	0.2	0	0.0	82	3.1	0	0.0	0	0.0	10	0.4	27	1.0	18	0.7	2	0.1	0	0.0	1	0.0	0	0.0	5	0.2	1	0.0	2119	80.4	1994	75.6	1677	63.6	94	3.6	4	0.2	185	7.0	0	0.0	2	0.1	32	1.2	125	4.7	73	2.8	10	0.4	1	0.0	2	0.1	0	0.0	26	1.0	13	0.5
1400000US25025000601	25025000601	Census Tract 6.01, Suffolk County, Massachusetts	1525	100.0	1450	95.1	75	4.9	1450	100.0	462	31.9	320	22.1	142	9.8	988	68.1	75	100.0	44	58.7	2	2.7	4	5.3	5	6.7	3	4.0	0	0.0	17	22.7	1450	100.0	462	31.9	441	30.4	335	23.1	2	0.1	0	0.0	93	6.4	0	0.0	2	0.1	9	0.6	21	1.4	14	1.0	1	0.1	0	0.0	0	0.0	0	0.0	6	0.4	0	0.0	988	68.1	913	63.0	719	49.6	33	2.3	2	0.1	99	6.8	0	0.0	35	2.4	25	1.7	75	5.2	48	3.3	4	0.3	0	0.0	0	0.0	0	0.0	19	1.3	4	0.3
1400000US25025000602	25025000602	Census Tract 6.02, Suffolk County, Massachusetts	2035	100.0	1968	96.7	67	3.3	1968	100.0	187	9.5	134	6.8	53	2.7	1781	90.5	67	100.0	45	67.2	2	3.0	5	7.5	0	0.0	4	6.0	0	0.0	11	16.4	1968	100.0	187	9.5	179	9.1	137	7.0	4	0.2	1	0.1	34	1.7	0	0.0	0	0.0	3	0.2	8	0.4	5	0.3	0	0.0	0	0.0	0	0.0	0	0.0	3	0.2	0	0.0	1781	90.5	1546	78.6	1046	53.2	180	9.1	0	0.0	262	13.3	1	0.1	11	0.6	46	2.3	235	11.9	103	5.2	14	0.7	5	0.3	1	0.1	0	0.0	93	4.7	19	1.0
1400000US25025000701	25025000701	Census Tract 7.01, Suffolk County, Massachusetts	2359	100.0	2294	97.2	65	2.8	2294	100.0	339	14.8	270	11.8	69	3.0	1955	85.2	65	100.0	43	66.2	3	4.6	2	3.1	1	1.5	4	6.2	0	0.0	12	18.5	2294	100.0	339	14.8	324	14.1	221	9.6	7	0.3	0	0.0	92	4.0	0	0.0	0	0.0	4	0.2	15	0.7	9	0.4	2	0.1	0	0.0	0	0.0	0	0.0	4	0.2	0	0.0	1955	85.2	1813	79.0	1405	61.2	91	4.0	2	0.1	247	10.8	0	0.0	16	0.7	52	2.3	142	6.2	83	3.6	8	0.3	1	0.0	0	0.0	0	0.0	41	1.8	9	0.4
1400000US25025000703	25025000703	Census Tract 7.03, Suffolk County, Massachusetts	1418	100.0	1395	98.4	23	1.6	1395	100.0	47	3.4	35	2.5	12	0.9	1348	96.6	23	100.0	18	78.3	1	4.3	0	0.0	0	0.0	0	0.0	0	0.0	4	17.4	1395	100.0	47	3.4	44	3.2	24	1.7	0	0.0	0	0.0	20	1.4	0	0.0	0	0.0	0	0.0	3	0.2	3	0.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1348	96.6	1271	91.1	820	58.8	49	3.5	1	0.1	339	24.3	0	0.0	19	1.4	43	3.1	77	5.5	47	3.4	3	0.2	0	0.0	4	0.3	0	0.0	19	1.4	4	0.3
1400000US25025000704	25025000704	Census Tract 7.04, Suffolk County, Massachusetts	2405	100.0	2350	97.7	55	2.3	2350	100.0	316	13.4	238	10.1	78	3.3	2034	86.6	55	100.0	35	63.6	3	5.5	2	3.6	1	1.8	7	12.7	0	0.0	7	12.7	2350	100.0	316	13.4	302	12.9	186	7.9	11	0.5	0	0.0	102	4.3	0	0.0	2	0.1	1	0.0	14	0.6	10	0.4	0	0.0	0	0.0	0	0.0	0	0.0	1	0.0	3	0.1	2034	86.6	1808	76.9	1306	55.6	134	5.7	2	0.1	290	12.3	2	0.1	24	1.0	50	2.1	226	9.6	126	5.4	12	0.5	4	0.2	2	0.1	1	0.0	70	3.0	11	0.5
1400000US25025000802	25025000802	Census Tract 8.02, Suffolk County, Massachusetts	3129	100.0	3011	96.2	118	3.8	3011	100.0	439	14.6	309	10.3	130	4.3	2572	85.4	118	100.0	78	66.1	9	7.6	7	5.9	1	0.8	11	9.3	0	0.0	12	10.2	3011	100.0	439	14.6	408	13.6	252	8.4	21	0.7	0	0.0	125	4.2	0	0.0	2	0.1	8	0.3	31	1.0	15	0.5	1	0.0	0	0.0	0	0.0	0	0.0	11	0.4	4	0.1	2572	85.4	2216	73.6	1478	49.1	112	3.7	5	0.2	476	15.8	1	0.0	66	2.2	78	2.6	356	11.8	170	5.6	11	0.4	6	0.2	3	0.1	0	0.0	137	4.5	29	1.0
1400000US25025000803	25025000803	Census Tract 8.03, Suffolk County, Massachusetts	946	100.0	882	93.2	64	6.8	882	100.0	8	0.9	5	0.6	3	0.3	874	99.1	64	100.0	3	4.7	3	4.7	0	0.0	0	0.0	45	70.3	0	0.0	13	20.3	882	100.0	8	0.9	8	0.9	5	0.6	1	0.1	0	0.0	2	0.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	874	99.1	783	88.8	414	46.9	52	5.9	2	0.2	271	30.7	0	0.0	8	0.9	36	4.1	91	10.3	61	6.9	4	0.5	1	0.1	1	0.1	0	0.0	20	2.3	4	0.5
1400000US25025010103	25025010103	Census Tract 101.03, Suffolk County, Massachusetts	528	100.0	490	92.8	38	7.2	490	100.0	49	10.0	29	5.9	20	4.1	441	90.0	38	100.0	28	73.7	0	0.0	1	2.6	0	0.0	7	18.4	0	0.0	2	5.3	490	100.0	49	10.0	47	9.6	39	8.0	2	0.4	0	0.0	6	1.2	0	0.0	0	0.0	0	0.0	2	0.4	1	0.2	0	0.0	0	0.0	1	0.2	0	0.0	0	0.0	0	0.0	441	90.0	414	84.5	264	53.9	16	3.3	0	0.0	119	24.3	0	0.0	0	0.0	15	3.1	27	5.5	21	4.3	4	0.8	0	0.0	0	0.0	0	0.0	2	0.4	0	0.0
1400000US25025010104	25025010104	Census Tract 101.04, Suffolk County, Massachusetts	2136	100.0	1916	89.7	220	10.3	1916	100.0	401	20.9	296	15.4	105	5.5	1515	79.1	220	100.0	100	45.5	4	1.8	9	4.1	5	2.3	71	32.3	0	0.0	31	14.1	1916	100.0	401	20.9	379	19.8	297	15.5	7	0.4	1	0.1	64	3.3	0	0.0	2	0.1	8	0.4	22	1.1	19	1.0	0	0.0	0	0.0	1	0.1	0	0.0	2	0.1	0	0.0	1515	79.1	1397	72.9	1035	54.0	42	2.2	3	0.2	282	14.7	0	0.0	5	0.3	30	1.6	118	6.2	88	4.6	1	0.1	0	0.0	0	0.0	0	0.0	23	1.2	6	0.3
1400000US25025010203	25025010203	Census Tract 102.03, Suffolk County, Massachusetts	3663	100.0	3499	95.5	164	4.5	3499	100.0	244	7.0	201	5.7	43	1.2	3255	93.0	164	100.0	102	62.2	9	5.5	2	1.2	1	0.6	47	28.7	0	0.0	3	1.8	3499	100.0	244	7.0	233	6.7	196	5.6	2	0.1	0	0.0	25	0.7	0	0.0	0	0.0	10	0.3	11	0.3	10	0.3	1	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	3255	93.0	2943	84.1	2171	62.0	130	3.7	8	0.2	530	15.1	3	0.1	10	0.3	91	2.6	312	8.9	193	5.5	13	0.4	1	0.0	1	0.0	0	0.0	75	2.1	29	0.8
1400000US25025010204	25025010204	Census Tract 102.04, Suffolk County, Massachusetts	1283	100.0	1188	92.6	95	7.4	1188	100.0	162	13.6	116	9.8	46	3.9	1026	86.4	95	100.0	86	90.5	0	0.0	1	1.1	0	0.0	5	5.3	0	0.0	3	3.2	1188	100.0	162	13.6	159	13.4	125	10.5	2	0.2	0	0.0	27	2.3	0	0.0	0	0.0	5	0.4	3	0.3	2	0.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1026	86.4	978	82.3	709	59.7	30	2.5	1	0.1	217	18.3	0	0.0	1	0.1	20	1.7	48	4.0	31	2.6	2	0.2	0	0.0	1	0.1	0	0.0	13	1.1	1	0.1
1400000US25025010300	25025010300	Census Tract 103, Suffolk County, Massachusetts	416	100.0	395	95.0	21	5.0	395	100.0	63	15.9	55	13.9	8	2.0	332	84.1	21	100.0	14	66.7	3	14.3	0	0.0	4	19.0	0	0.0	0	0.0	0	0.0	395	100.0	63	15.9	60	15.2	43	10.9	4	1.0	0	0.0	9	2.3	0	0.0	1	0.3	3	0.8	3	0.8	2	0.5	0	0.0	0	0.0	0	0.0	0	0.0	1	0.3	0	0.0	332	84.1	229	58.0	121	30.6	61	15.4	0	0.0	38	9.6	0	0.0	0	0.0	9	2.3	103	26.1	23	5.8	12	3.0	0	0.0	0	0.0	0	0.0	67	17.0	1	0.3
1400000US25025010403	25025010403	Census Tract 104.03, Suffolk County, Massachusetts	2076	100.0	2025	97.5	51	2.5	2025	100.0	121	6.0	81	4.0	40	2.0	1904	94.0	51	100.0	21	41.2	3	5.9	1	2.0	0	0.0	22	43.1	0	0.0	4	7.8	2025	100.0	121	6.0	112	5.5	87	4.3	5	0.2	0	0.0	19	0.9	0	0.0	0	0.0	1	0.0	9	0.4	5	0.2	1	0.0	0	0.0	1	0.0	0	0.0	1	0.0	1	0.0	1904	94.0	1735	85.7	1087	53.7	208	10.3	8	0.4	378	18.7	0	0.0	3	0.1	51	2.5	169	8.3	84	4.1	13	0.6	0	0.0	1	0.0	0	0.0	53	2.6	18	0.9
1400000US25025010404	25025010404	Census Tract 104.04, Suffolk County, Massachusetts	1862	100.0	1810	97.2	52	2.8	1810	100.0	201	11.1	140	7.7	61	3.4	1609	88.9	52	100.0	34	65.4	2	3.8	4	7.7	0	0.0	6	11.5	0	0.0	6	11.5	1810	100.0	201	11.1	186	10.3	148	8.2	7	0.4	0	0.0	27	1.5	0	0.0	2	0.1	2	0.1	15	0.8	10	0.6	0	0.0	0	0.0	0	0.0	0	0.0	3	0.2	2	0.1	1609	88.9	1482	81.9	1050	58.0	70	3.9	3	0.2	316	17.5	0	0.0	2	0.1	41	2.3	127	7.0	77	4.3	5	0.3	1	0.1	2	0.1	1	0.1	30	1.7	11	0.6
1400000US25025010405	25025010405	Census Tract 104.05, Suffolk County, Massachusetts	994	100.0	966	97.2	28	2.8	966	100.0	96	9.9	58	6.0	38	3.9	870	90.1	28	100.0	20	71.4	5	17.9	0	0.0	1	3.6	0	0.0	0	0.0	2	7.1	966	100.0	96	9.9	89	9.2	77	8.0	3	0.3	0	0.0	7	0.7	0	0.0	0	0.0	2	0.2	7	0.7	4	0.4	1	0.1	0	0.0	0	0.0	0	0.0	2	0.2	0	0.0	870	90.1	770	79.7	461	47.7	121	12.5	6	0.6	146	15.1	0	0.0	3	0.3	33	3.4	100	10.4	39	4.0	15	1.6	0	0.0	0	0.0	0	0.0	37	3.8	9	0.9
1400000US25025010408	25025010408	Census Tract 104.08, Suffolk County, Massachusetts	961	100.0	943	98.1	18	1.9	943	100.0	99	10.5	84	8.9	15	1.6	844	89.5	18	100.0	12	66.7	0	0.0	1	5.6	0	0.0	3	16.7	0	0.0	2	11.1	943	100.0	99	10.5	93	9.9	81	8.6	0	0.0	0	0.0	11	1.2	0	0.0	0	0.0	1	0.1	6	0.6	5	0.5	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	844	89.5	772	81.9	607	64.4	24	2.5	1	0.1	127	13.5	0	0.0	1	0.1	12	1.3	72	7.6	44	4.7	3	0.3	0	0.0	1	0.1	0	0.0	17	1.8	7	0.7
1400000US25025010500	25025010500	Census Tract 105, Suffolk County, Massachusetts	1767	100.0	1655	93.7	112	6.3	1655	100.0	208	12.6	172	10.4	36	2.2	1447	87.4	112	100.0	71	63.4	3	2.7	3	2.7	1	0.9	25	22.3	0	0.0	9	8.0	1655	100.0	208	12.6	200	12.1	167	10.1	12	0.7	1	0.1	19	1.1	0	0.0	0	0.0	1	0.1	8	0.5	6	0.4	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	1447	87.4	1318	79.6	906	54.7	171	10.3	3	0.2	209	12.6	0	0.0	6	0.4	23	1.4	129	7.8	88	5.3	6	0.4	1	0.1	0	0.0	0	0.0	26	1.6	8	0.5
1400000US25025010600	25025010600	Census Tract 106, Suffolk County, Massachusetts	2325	100.0	1854	79.7	471	20.3	1854	100.0	352	19.0	233	12.6	119	6.4	1502	81.0	471	100.0	137	29.1	34	7.2	84	17.8	11	2.3	190	40.3	0	0.0	15	3.2	1854	100.0	352	19.0	340	18.3	300	16.2	6	0.3	0	0.0	28	1.5	0	0.0	0	0.0	6	0.3	12	0.6	5	0.3	1	0.1	0	0.0	0	0.0	0	0.0	6	0.3	0	0.0	1502	81.0	1416	76.4	1102	59.4	94	5.1	1	0.1	196	10.6	0	0.0	4	0.2	19	1.0	86	4.6	65	3.5	4	0.2	1	0.1	0	0.0	0	0.0	14	0.8	2	0.1
1400000US25025010701	25025010701	Census Tract 107.01, Suffolk County, Massachusetts	1599	100.0	1396	87.3	203	12.7	1396	100.0	455	32.6	314	22.5	141	10.1	941	67.4	203	100.0	76	37.4	1	0.5	5	2.5	16	7.9	98	48.3	0	0.0	7	3.4	1396	100.0	455	32.6	445	31.9	404	28.9	1	0.1	0	0.0	33	2.4	0	0.0	0	0.0	7	0.5	10	0.7	8	0.6	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1	941	67.4	881	63.1	752	53.9	16	1.1	1	0.1	89	6.4	0	0.0	7	0.5	16	1.1	60	4.3	44	3.2	2	0.1	0	0.0	2	0.1	0	0.0	9	0.6	3	0.2
1400000US25025010702	25025010702	Census Tract 107.02, Suffolk County, Massachusetts	1643	100.0	1402	85.3	241	14.7	1402	100.0	637	45.4	407	29.0	230	16.4	765	54.6	241	100.0	27	11.2	9	3.7	10	4.1	24	10.0	143	59.3	0	0.0	28	11.6	1402	100.0	637	45.4	625	44.6	592	42.2	3	0.2	0	0.0	27	1.9	0	0.0	1	0.1	2	0.1	12	0.9	10	0.7	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	765	54.6	727	51.9	648	46.2	13	0.9	0	0.0	52	3.7	1	0.1	0	0.0	13	0.9	38	2.7	29	2.1	0	0.0	0	0.0	0	0.0	0	0.0	7	0.5	2	0.1
1400000US25025010801	25025010801	Census Tract 108.01, Suffolk County, Massachusetts	1899	100.0	1651	86.9	248	13.1	1651	100.0	812	49.2	545	33.0	267	16.2	839	50.8	248	100.0	68	27.4	4	1.6	10	4.0	7	2.8	149	60.1	0	0.0	10	4.0	1651	100.0	812	49.2	794	48.1	743	45.0	2	0.1	0	0.0	35	2.1	0	0.0	1	0.1	13	0.8	18	1.1	17	1.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	839	50.8	789	47.8	682	41.3	14	0.8	1	0.1	78	4.7	0	0.0	2	0.1	12	0.7	50	3.0	39	2.4	3	0.2	0	0.0	0	0.0	0	0.0	7	0.4	1	0.1
1400000US25025010802	25025010802	Census Tract 108.02, Suffolk County, Massachusetts	2106	100.0	1871	88.8	235	11.2	1871	100.0	766	40.9	524	28.0	242	12.9	1105	59.1	235	100.0	50	21.3	7	3.0	24	10.2	13	5.5	110	46.8	0	0.0	31	13.2	1871	100.0	766	40.9	755	40.4	696	37.2	8	0.4	0	0.0	44	2.4	0	0.0	1	0.1	6	0.3	11	0.6	9	0.5	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	0	0.0	1105	59.1	1065	56.9	890	47.6	20	1.1	0	0.0	127	6.8	0	0.0	8	0.4	20	1.1	40	2.1	33	1.8	0	0.0	0	0.0	0	0.0	0	0.0	5	0.3	2	0.1
1400000US25025020101	25025020101	Census Tract 201.01, Suffolk County, Massachusetts	2814	100.0	2473	87.9	341	12.1	2473	100.0	1115	45.1	709	28.7	406	16.4	1358	54.9	341	100.0	73	21.4	18	5.3	19	5.6	30	8.8	174	51.0	0	0.0	27	7.9	2473	100.0	1115	45.1	1102	44.6	1069	43.2	3	0.1	1	0.0	25	1.0	0	0.0	1	0.0	3	0.1	13	0.5	12	0.5	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.0	1358	54.9	1298	52.5	1189	48.1	12	0.5	0	0.0	78	3.2	0	0.0	3	0.1	16	0.6	60	2.4	48	1.9	2	0.1	0	0.0	1	0.0	0	0.0	3	0.1	6	0.2
1400000US25025020200	25025020200	Census Tract 202, Suffolk County, Massachusetts	2478	100.0	2302	92.9	176	7.1	2302	100.0	498	21.6	383	16.6	115	5.0	1804	78.4	176	100.0	78	44.3	16	9.1	10	5.7	2	1.1	52	29.5	0	0.0	18	10.2	2302	100.0	498	21.6	491	21.3	453	19.7	5	0.2	0	0.0	27	1.2	0	0.0	1	0.0	5	0.2	7	0.3	5	0.2	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	0	0.0	1804	78.4	1713	74.4	1472	63.9	70	3.0	1	0.0	129	5.6	0	0.0	4	0.2	37	1.6	91	4.0	64	2.8	3	0.1	0	0.0	1	0.0	0	0.0	18	0.8	5	0.2
1400000US25025020301	25025020301	Census Tract 203.01, Suffolk County, Massachusetts	1414	100.0	1250	88.4	164	11.6	1250	100.0	237	19.0	147	11.8	90	7.2	1013	81.0	164	100.0	52	31.7	30	18.3	3	1.8	2	1.2	65	39.6	0	0.0	12	7.3	1250	100.0	237	19.0	232	18.6	199	15.9	2	0.2	0	0.0	28	2.2	0	0.0	1	0.1	2	0.2	5	0.4	5	0.4	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1013	81.0	970	77.6	705	56.4	25	2.0	2	0.2	221	17.7	0	0.0	2	0.2	15	1.2	43	3.4	30	2.4	2	0.2	0	0.0	1	0.1	0	0.0	9	0.7	1	0.1
1400000US25025020302	25025020302	Census Tract 203.02, Suffolk County, Massachusetts	721	100.0	675	93.6	46	6.4	675	100.0	223	33.0	178	26.4	45	6.7	452	67.0	46	100.0	22	47.8	0	0.0	3	6.5	1	2.2	19	41.3	0	0.0	1	2.2	675	100.0	223	33.0	216	32.0	207	30.7	0	0.0	1	0.1	6	0.9	0	0.0	0	0.0	2	0.3	7	1.0	5	0.7	0	0.0	0	0.0	0	0.0	0	0.0	2	0.3	0	0.0	452	67.0	429	63.6	376	55.7	9	1.3	0	0.0	33	4.9	0	0.0	3	0.4	8	1.2	23	3.4	17	2.5	0	0.0	1	0.1	0	0.0	0	0.0	3	0.4	2	0.3
1400000US25025020303	25025020303	Census Tract 203.03, Suffolk County, Massachusetts	1847	100.0	1632	88.4	215	11.6	1632	100.0	444	27.2	337	20.6	107	6.6	1188	72.8	215	100.0	90	41.9	20	9.3	5	2.3	0	0.0	97	45.1	0	0.0	3	1.4	1632	100.0	444	27.2	426	26.1	367	22.5	5	0.3	0	0.0	48	2.9	0	0.0	1	0.1	5	0.3	18	1.1	15	0.9	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	1	0.1	1188	72.8	1112	68.1	879	53.9	61	3.7	2	0.1	143	8.8	0	0.0	2	0.1	25	1.5	76	4.7	55	3.4	3	0.2	0	0.0	2	0.1	0	0.0	13	0.8	3	0.2
1400000US25025030100	25025030100	Census Tract 301, Suffolk County, Massachusetts	1377	100.0	1276	92.7	101	7.3	1276	100.0	238	18.7	170	13.3	68	5.3	1038	81.3	101	100.0	65	64.4	1	1.0	5	5.0	0	0.0	17	16.8	0	0.0	13	12.9	1276	100.0	238	18.7	233	18.3	233	18.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	5	0.4	4	0.3	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	1038	81.3	1000	78.4	966	75.7	12	0.9	0	0.0	15	1.2	1	0.1	2	0.2	4	0.3	38	3.0	30	2.4	1	0.1	0	0.0	1	0.1	0	0.0	6	0.5	0	0.0
1400000US25025030200	25025030200	Census Tract 302, Suffolk County, Massachusetts	1103	100.0	1044	94.7	59	5.3	1044	100.0	173	16.6	127	12.2	46	4.4	871	83.4	59	100.0	23	39.0	6	10.2	2	3.4	12	20.3	14	23.7	0	0.0	2	3.4	1044	100.0	173	16.6	165	15.8	162	15.5	0	0.0	1	0.1	1	0.1	0	0.0	0	0.0	1	0.1	8	0.8	8	0.8	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	871	83.4	844	80.8	809	77.5	4	0.4	4	0.4	16	1.5	0	0.0	1	0.1	10	1.0	27	2.6	19	1.8	0	0.0	1	0.1	1	0.1	0	0.0	3	0.3	3	0.3
1400000US25025030300	25025030300	Census Tract 303, Suffolk County, Massachusetts	2960	100.0	2468	83.4	492	16.6	2468	100.0	900	36.5	634	25.7	266	10.8	1568	63.5	492	100.0	115	23.4	16	3.3	15	3.0	9	1.8	321	65.2	0	0.0	16	3.3	2468	100.0	900	36.5	888	36.0	839	34.0	4	0.2	0	0.0	36	1.5	0	0.0	1	0.0	8	0.3	12	0.5	9	0.4	0	0.0	0	0.0	0	0.0	0	0.0	3	0.1	0	0.0	1568	63.5	1494	60.5	1275	51.7	62	2.5	3	0.1	122	4.9	0	0.0	6	0.2	26	1.1	74	3.0	54	2.2	2	0.1	0	0.0	0	0.0	0	0.0	14	0.6	4	0.2
1400000US25025030400	25025030400	Census Tract 304, Suffolk County, Massachusetts	1659	100.0	1513	91.2	146	8.8	1513	100.0	309	20.4	217	14.3	92	6.1	1204	79.6	146	100.0	68	46.6	9	6.2	4	2.7	6	4.1	36	24.7	1	0.7	22	15.1	1513	100.0	309	20.4	305	20.2	297	19.6	1	0.1	0	0.0	4	0.3	0	0.0	1	0.1	2	0.1	4	0.3	3	0.2	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	1204	79.6	1162	76.8	1105	73.0	6	0.4	2	0.1	32	2.1	0	0.0	3	0.2	14	0.9	42	2.8	32	2.1	0	0.0	1	0.1	0	0.0	0	0.0	7	0.5	2	0.1
1400000US25025030500	25025030500	Census Tract 305, Suffolk County, Massachusetts	1656	100.0	1457	88.0	199	12.0	1457	100.0	548	37.6	408	28.0	140	9.6	909	62.4	199	100.0	39	19.6	7	3.5	53	26.6	2	1.0	92	46.2	0	0.0	6	3.0	1457	100.0	548	37.6	540	37.1	520	35.7	1	0.1	0	0.0	16	1.1	0	0.0	0	0.0	3	0.2	8	0.5	7	0.5	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	909	62.4	866	59.4	817	56.1	6	0.4	0	0.0	27	1.9	0	0.0	4	0.3	12	0.8	43	3.0	32	2.2	0	0.0	0	0.0	0	0.0	0	0.0	9	0.6	2	0.1
1400000US25025040100	25025040100	Census Tract 401, Suffolk County, Massachusetts	1239	100.0	1188	95.9	51	4.1	1188	100.0	678	57.1	567	47.7	111	9.3	510	42.9	51	100.0	14	27.5	4	7.8	7	13.7	0	0.0	16	31.4	0	0.0	10	19.6	1188	100.0	678	57.1	672	56.6	656	55.2	1	0.1	0	0.0	15	1.3	0	0.0	0	0.0	0	0.0	6	0.5	4	0.3	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1	510	42.9	496	41.8	476	40.1	4	0.3	0	0.0	13	1.1	0	0.0	0	0.0	3	0.3	14	1.2	7	0.6	1	0.1	0	0.0	0	0.0	0	0.0	6	0.5	0	0.0
1400000US25025040200	25025040200	Census Tract 402, Suffolk County, Massachusetts	727	100.0	663	91.2	64	8.8	663	100.0	209	31.5	175	26.4	34	5.1	454	68.5	64	100.0	56	87.5	0	0.0	2	3.1	0	0.0	4	6.3	0	0.0	2	3.1	663	100.0	209	31.5	204	30.8	197	29.7	3	0.5	0	0.0	3	0.5	0	0.0	0	0.0	1	0.2	5	0.8	3	0.5	1	0.2	0	0.0	0	0.0	0	0.0	1	0.2	0	0.0	454	68.5	346	52.2	215	32.4	69	10.4	1	0.2	49	7.4	0	0.0	4	0.6	8	1.2	108	16.3	41	6.2	16	2.4	2	0.3	0	0.0	0	0.0	46	6.9	3	0.5
1400000US25025040300	25025040300	Census Tract 403, Suffolk County, Massachusetts	2037	100.0	1894	93.0	143	7.0	1894	100.0	1057	55.8	892	47.1	165	8.7	837	44.2	143	100.0	51	35.7	6	4.2	12	8.4	11	7.7	11	7.7	0	0.0	52	36.4	1894	100.0	1057	55.8	1042	55.0	1012	53.4	2	0.1	1	0.1	19	1.0	0	0.0	0	0.0	8	0.4	15	0.8	10	0.5	1	0.1	0	0.0	1	0.1	0	0.0	2	0.1	1	0.1	837	44.2	717	37.9	622	32.8	52	2.7	0	0.0	38	2.0	0	0.0	0	0.0	5	0.3	120	6.3	37	2.0	16	0.8	2	0.1	1	0.1	0	0.0	46	2.4	18	1.0
1400000US25025040401	25025040401	Census Tract 404.01, Suffolk County, Massachusetts	1222	100.0	1174	96.1	48	3.9	1174	100.0	471	40.1	405	34.5	66	5.6	703	59.9	48	100.0	15	31.3	3	6.3	8	16.7	0	0.0	7	14.6	0	0.0	15	31.3	1174	100.0	471	40.1	467	39.8	453	38.6	3	0.3	0	0.0	10	0.9	0	0.0	0	0.0	1	0.1	4	0.3	3	0.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	703	59.9	670	57.1	592	50.4	16	1.4	1	0.1	55	4.7	0	0.0	0	0.0	6	0.5	33	2.8	12	1.0	4	0.3	1	0.1	0	0.0	0	0.0	13	1.1	3	0.3
1400000US25025040600	25025040600	Census Tract 406, Suffolk County, Massachusetts	1334	100.0	1238	92.8	96	7.2	1238	100.0	694	56.1	572	46.2	122	9.9	544	43.9	96	100.0	48	50.0	3	3.1	19	19.8	3	3.1	7	7.3	0	0.0	16	16.7	1238	100.0	694	56.1	685	55.3	662	53.5	5	0.4	0	0.0	16	1.3	0	0.0	1	0.1	1	0.1	9	0.7	9	0.7	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	544	43.9	518	41.8	481	38.9	13	1.1	0	0.0	21	1.7	0	0.0	1	0.1	2	0.2	26	2.1	20	1.6	1	0.1	0	0.0	0	0.0	0	0.0	3	0.2	2	0.2
1400000US25025040801	25025040801	Census Tract 408.01, Suffolk County, Massachusetts	2089	100.0	1876	89.8	213	10.2	1876	100.0	610	32.5	495	26.4	115	6.1	1266	67.5	213	100.0	156	73.2	5	2.3	3	1.4	2	0.9	42	19.7	0	0.0	5	2.3	1876	100.0	610	32.5	598	31.9	551	29.4	4	0.2	1	0.1	36	1.9	0	0.0	3	0.2	3	0.2	12	0.6	10	0.5	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1	1266	67.5	1063	56.7	673	35.9	137	7.3	1	0.1	216	11.5	4	0.2	10	0.5	22	1.2	203	10.8	88	4.7	25	1.3	2	0.1	0	0.0	0	0.0	68	3.6	20	1.1
1400000US25025050101	25025050101	Census Tract 501.01, Suffolk County, Massachusetts	1850	100.0	1713	92.6	137	7.4	1713	100.0	394	23.0	311	18.2	83	4.8	1319	77.0	137	100.0	64	46.7	3	2.2	18	13.1	1	0.7	9	6.6	0	0.0	42	30.7	1713	100.0	394	23.0	268	15.6	226	13.2	9	0.5	1	0.1	27	1.6	0	0.0	1	0.1	4	0.2	126	7.4	61	3.6	1	0.1	0	0.0	0	0.0	0	0.0	56	3.3	8	0.5	1319	77.0	615	35.9	469	27.4	45	2.6	5	0.3	60	3.5	0	0.0	9	0.5	27	1.6	704	41.1	346	20.2	26	1.5	6	0.4	1	0.1	0	0.0	276	16.1	49	2.9
1400000US25025050200	25025050200	Census Tract 502, Suffolk County, Massachusetts	1834	100.0	1695	92.4	139	7.6	1695	100.0	376	22.2	298	17.6	78	4.6	1319	77.8	139	100.0	53	38.1	7	5.0	19	13.7	0	0.0	7	5.0	0	0.0	53	38.1	1695	100.0	376	22.2	240	14.2	205	12.1	7	0.4	1	0.1	18	1.1	0	0.0	6	0.4	3	0.2	136	8.0	71	4.2	1	0.1	1	0.1	0	0.0	0	0.0	54	3.2	9	0.5	1319	77.8	568	33.5	429	25.3	58	3.4	1	0.1	21	1.2	1	0.1	31	1.8	27	1.6	751	44.3	348	20.5	17	1.0	4	0.2	0	0.0	0	0.0	322	19.0	60	3.5
1400000US25025050300	25025050300	Census Tract 503, Suffolk County, Massachusetts	1041	100.0	973	93.5	68	6.5	973	100.0	78	8.0	65	6.7	13	1.3	895	92.0	68	100.0	56	82.4	1	1.5	0	0.0	0	0.0	1	1.5	0	0.0	10	14.7	973	100.0	78	8.0	59	6.1	46	4.7	3	0.3	0	0.0	6	0.6	0	0.0	0	0.0	4	0.4	19	2.0	10	1.0	0	0.0	0	0.0	0	0.0	0	0.0	9	0.9	0	0.0	895	92.0	570	58.6	358	36.8	95	9.8	1	0.1	89	9.1	0	0.0	10	1.0	17	1.7	325	33.4	141	14.5	27	2.8	3	0.3	1	0.1	0	0.0	122	12.5	31	3.2
1400000US25025050400	25025050400	Census Tract 504, Suffolk County, Massachusetts	1035	100.0	967	93.4	68	6.6	967	100.0	239	24.7	186	19.2	53	5.5	728	75.3	68	100.0	41	60.3	1	1.5	4	5.9	2	2.9	5	7.4	0	0.0	15	22.1	967	100.0	239	24.7	190	19.6	166	17.2	4	0.4	1	0.1	12	1.2	0	0.0	3	0.3	4	0.4	49	5.1	30	3.1	0	0.0	0	0.0	0	0.0	0	0.0	16	1.7	3	0.3	728	75.3	420	43.4	348	36.0	33	3.4	0	0.0	12	1.2	0	0.0	14	1.4	13	1.3	308	31.9	191	19.8	6	0.6	1	0.1	1	0.1	0	0.0	89	9.2	20	2.1
1400000US25025050500	25025050500	Census Tract 505, Suffolk County, Massachusetts	702	100.0	659	93.9	43	6.1	659	100.0	142	21.5	107	16.2	35	5.3	517	78.5	43	100.0	25	58.1	0	0.0	1	2.3	0	0.0	1	2.3	0	0.0	16	37.2	659	100.0	142	21.5	123	18.7	112	17.0	3	0.5	0	0.0	6	0.9	0	0.0	1	0.2	1	0.2	19	2.9	14	2.1	0	0.0	0	0.0	0	0.0	0	0.0	3	0.5	2	0.3	517	78.5	272	41.3	222	33.7	15	2.3	0	0.0	11	1.7	0	0.0	15	2.3	9	1.4	245	37.2	144	21.9	6	0.9	0	0.0	0	0.0	0	0.0	78	11.8	17	2.6
1400000US25025050600	25025050600	Census Tract 506, Suffolk County, Massachusetts	806	100.0	746	92.6	60	7.4	746	100.0	155	20.8	106	14.2	49	6.6	591	79.2	60	100.0	23	38.3	1	1.7	4	6.7	0	0.0	5	8.3	0	0.0	27	45.0	746	100.0	155	20.8	108	14.5	95	12.7	4	0.5	0	0.0	5	0.7	0	0.0	1	0.1	3	0.4	47	6.3	26	3.5	0	0.0	0	0.0	0	0.0	0	0.0	12	1.6	9	1.2	591	79.2	232	31.1	182	24.4	12	1.6	1	0.1	12	1.6	0	0.0	12	1.6	13	1.7	359	48.1	196	26.3	6	0.8	1	0.1	0	0.0	0	0.0	129	17.3	27	3.6
1400000US25025050700	25025050700	Census Tract 507, Suffolk County, Massachusetts	1606	100.0	1455	90.6	151	9.4	1455	100.0	350	24.1	257	17.7	93	6.4	1105	75.9	151	100.0	73	48.3	4	2.6	8	5.3	1	0.7	3	2.0	0	0.0	62	41.1	1455	100.0	350	24.1	231	15.9	208	14.3	6	0.4	1	0.1	10	0.7	0	0.0	5	0.3	1	0.1	119	8.2	56	3.8	0	0.0	1	0.1	0	0.0	0	0.0	56	3.8	6	0.4	1105	75.9	471	32.4	370	25.4	23	1.6	2	0.1	17	1.2	0	0.0	45	3.1	14	1.0	634	43.6	257	17.7	10	0.7	5	0.3	0	0.0	1	0.1	316	21.7	45	3.1
1400000US25025050901	25025050901	Census Tract 509.01, Suffolk County, Massachusetts	1446	100.0	1324	91.6	122	8.4	1324	100.0	398	30.1	305	23.0	93	7.0	926	69.9	122	100.0	49	40.2	4	3.3	5	4.1	0	0.0	7	5.7	0	0.0	57	46.7	1324	100.0	398	30.1	246	18.6	230	17.4	4	0.3	1	0.1	5	0.4	0	0.0	2	0.2	4	0.3	152	11.5	80	6.0	2	0.2	1	0.1	0	0.0	0	0.0	53	4.0	16	1.2	926	69.9	417	31.5	352	26.6	25	1.9	0	0.0	20	1.5	0	0.0	12	0.9	8	0.6	509	38.4	291	22.0	6	0.5	3	0.2	2	0.2	0	0.0	181	13.7	26	2.0
1400000US25025051000	25025051000	Census Tract 510, Suffolk County, Massachusetts	1784	100.0	1670	93.6	114	6.4	1670	100.0	516	30.9	370	22.2	146	8.7	1154	69.1	114	100.0	49	43.0	2	1.8	19	16.7	1	0.9	5	4.4	0	0.0	38	33.3	1670	100.0	516	30.9	433	25.9	419	25.1	2	0.1	0	0.0	9	0.5	0	0.0	1	0.1	2	0.1	83	5.0	49	2.9	0	0.0	1	0.1	0	0.0	0	0.0	26	1.6	7	0.4	1154	69.1	790	47.3	701	42.0	36	2.2	1	0.1	29	1.7	0	0.0	7	0.4	16	1.0	364	21.8	206	12.3	12	0.7	3	0.2	1	0.1	1	0.1	126	7.5	15	0.9
1400000US25025051101	25025051101	Census Tract 511.01, Suffolk County, Massachusetts	2345	100.0	2190	93.4	155	6.6	2190	100.0	873	39.9	605	27.6	268	12.2	1317	60.1	155	100.0	83	53.5	5	3.2	10	6.5	0	0.0	12	7.7	0	0.0	45	29.0	2190	100.0	873	39.9	774	35.3	729	33.3	10	0.5	4	0.2	18	0.8	0	0.0	5	0.2	8	0.4	99	4.5	57	2.6	2	0.1	0	0.0	0	0.0	0	0.0	32	1.5	8	0.4	1317	60.1	806	36.8	642	29.3	86	3.9	1	0.0	45	2.1	0	0.0	16	0.7	16	0.7	511	23.3	285	13.0	30	1.4	3	0.1	1	0.0	0	0.0	157	7.2	35	1.6
1400000US25025051200	25025051200	Census Tract 512, Suffolk County, Massachusetts	1160	100.0	1023	88.2	137	11.8	1023	100.0	353	34.5	243	23.8	110	10.8	670	65.5	137	100.0	60	43.8	4	2.9	14	10.2	5	3.6	8	5.8	0	0.0	46	33.6	1023	100.0	353	34.5	314	30.7	299	29.2	3	0.3	0	0.0	5	0.5	0	0.0	3	0.3	4	0.4	39	3.8	23	2.2	0	0.0	0	0.0	0	0.0	0	0.0	14	1.4	2	0.2	670	65.5	470	45.9	408	39.9	22	2.2	2	0.2	13	1.3	0	0.0	15	1.5	10	1.0	200	19.6	116	11.3	10	1.0	1	0.1	1	0.1	1	0.1	55	5.4	16	1.6
1400000US25025060101	25025060101	Census Tract 601.01, Suffolk County, Massachusetts	1684	100.0	1575	93.5	109	6.5	1575	100.0	732	46.5	571	36.3	161	10.2	843	53.5	109	100.0	27	24.8	1	0.9	37	33.9	1	0.9	8	7.3	0	0.0	35	32.1	1575	100.0	732	46.5	730	46.3	724	46.0	1	0.1	0	0.0	3	0.2	0	0.0	0	0.0	2	0.1	2	0.1	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	843	53.5	833	52.9	824	52.3	1	0.1	1	0.1	4	0.3	1	0.1	0	0.0	2	0.1	10	0.6	8	0.5	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1
1400000US25025060200	25025060200	Census Tract 602, Suffolk County, Massachusetts	999	100.0	927	92.8	72	7.2	927	100.0	471	50.8	379	40.9	92	9.9	456	49.2	72	100.0	18	25.0	2	2.8	5	6.9	5	6.9	1	1.4	0	0.0	41	56.9	927	100.0	471	50.8	468	50.5	462	49.8	0	0.0	0	0.0	4	0.4	0	0.0	0	0.0	2	0.2	3	0.3	2	0.2	0	0.0	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	456	49.2	454	49.0	447	48.2	2	0.2	0	0.0	1	0.1	0	0.0	0	0.0	4	0.4	2	0.2	2	0.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025060301	25025060301	Census Tract 603.01, Suffolk County, Massachusetts	1647	100.0	1540	93.5	107	6.5	1540	100.0	759	49.3	614	39.9	145	9.4	781	50.7	107	100.0	33	30.8	1	0.9	21	19.6	5	4.7	9	8.4	0	0.0	38	35.5	1540	100.0	759	49.3	754	49.0	739	48.0	1	0.1	0	0.0	9	0.6	0	0.0	2	0.1	3	0.2	5	0.3	2	0.1	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	1	0.1	781	50.7	774	50.3	757	49.2	5	0.3	1	0.1	5	0.3	0	0.0	1	0.1	5	0.3	7	0.5	4	0.3	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1
1400000US25025060400	25025060400	Census Tract 604, Suffolk County, Massachusetts	2543	100.0	2378	93.5	165	6.5	2378	100.0	1106	46.5	908	38.2	198	8.3	1272	53.5	165	100.0	54	32.7	3	1.8	25	15.2	13	7.9	9	5.5	0	0.0	61	37.0	2378	100.0	1106	46.5	1094	46.0	1068	44.9	3	0.1	0	0.0	12	0.5	0	0.0	1	0.0	10	0.4	12	0.5	10	0.4	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	0	0.0	1272	53.5	1249	52.5	1199	50.4	11	0.5	3	0.1	24	1.0	0	0.0	0	0.0	12	0.5	23	1.0	13	0.5	0	0.0	1	0.0	0	0.0	0	0.0	8	0.3	1	0.0
1400000US25025060501	25025060501	Census Tract 605.01, Suffolk County, Massachusetts	1942	100.0	1831	94.3	111	5.7	1831	100.0	832	45.4	719	39.3	113	6.2	999	54.6	111	100.0	35	31.5	2	1.8	33	29.7	5	4.5	2	1.8	0	0.0	34	30.6	1831	100.0	832	45.4	827	45.2	800	43.7	2	0.1	0	0.0	22	1.2	0	0.0	1	0.1	2	0.1	5	0.3	4	0.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	999	54.6	981	53.6	947	51.7	5	0.3	1	0.1	16	0.9	1	0.1	2	0.1	9	0.5	18	1.0	10	0.5	1	0.1	0	0.0	0	0.0	0	0.0	3	0.2	4	0.2
1400000US25025060600	25025060600	Census Tract 606, Suffolk County, Massachusetts	1530	100.0	1370	89.5	160	10.5	1370	100.0	520	38.0	478	34.9	42	3.1	850	62.0	160	100.0	48	30.0	1	0.6	50	31.3	6	3.8	47	29.4	0	0.0	8	5.0	1370	100.0	520	38.0	505	36.9	475	34.7	6	0.4	0	0.0	20	1.5	0	0.0	0	0.0	4	0.3	15	1.1	12	0.9	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	1	0.1	850	62.0	816	59.6	731	53.4	11	0.8	2	0.1	54	3.9	0	0.0	3	0.2	15	1.1	34	2.5	26	1.9	1	0.1	0	0.0	0	0.0	0	0.0	6	0.4	1	0.1
1400000US25025060700	25025060700	Census Tract 607, Suffolk County, Massachusetts	636	100.0	617	97.0	19	3.0	617	100.0	5	0.8	2	0.3	3	0.5	612	99.2	19	100.0	18	94.7	1	5.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	617	100.0	5	0.8	2	0.3	2	0.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	3	0.5	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	2	0.3	1	0.2	612	99.2	336	54.5	146	23.7	107	17.3	1	0.2	56	9.1	0	0.0	8	1.3	18	2.9	276	44.7	64	10.4	36	5.8	2	0.3	3	0.5	0	0.0	148	24.0	23	3.7
1400000US25025060800	25025060800	Census Tract 608, Suffolk County, Massachusetts	2142	100.0	2002	93.5	140	6.5	2002	100.0	940	47.0	809	40.4	131	6.5	1062	53.0	140	100.0	61	43.6	2	1.4	13	9.3	3	2.1	7	5.0	0	0.0	54	38.6	2002	100.0	940	47.0	924	46.2	864	43.2	6	0.3	1	0.0	41	2.0	0	0.0	2	0.1	10	0.5	16	0.8	11	0.5	0	0.0	0	0.0	0	0.0	0	0.0	4	0.2	1	0.0	1062	53.0	1037	51.8	985	49.2	14	0.7	0	0.0	29	1.4	0	0.0	1	0.0	8	0.4	25	1.2	8	0.4	2	0.1	1	0.0	0	0.0	0	0.0	11	0.5	3	0.1
1400000US25025061000	25025061000	Census Tract 610, Suffolk County, Massachusetts	1408	100.0	1239	88.0	169	12.0	1239	100.0	258	20.8	229	18.5	29	2.3	981	79.2	169	100.0	103	60.9	3	1.8	21	12.4	4	2.4	0	0.0	0	0.0	38	22.5	1239	100.0	258	20.8	251	20.3	238	19.2	3	0.2	0	0.0	4	0.3	0	0.0	1	0.1	5	0.4	7	0.6	5	0.4	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	981	79.2	682	55.0	392	31.6	162	13.1	3	0.2	97	7.8	0	0.0	10	0.8	18	1.5	299	24.1	81	6.5	44	3.6	3	0.2	1	0.1	0	0.0	135	10.9	35	2.8
1400000US25025061101	25025061101	Census Tract 611.01, Suffolk County, Massachusetts	1044	100.0	982	94.1	62	5.9	982	100.0	12	1.2	9	0.9	3	0.3	970	98.8	62	100.0	28	45.2	1	1.6	0	0.0	0	0.0	0	0.0	0	0.0	33	53.2	982	100.0	12	1.2	10	1.0	10	1.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	2	0.2	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	970	98.8	629	64.1	255	26.0	225	22.9	4	0.4	123	12.5	1	0.1	5	0.5	16	1.6	341	34.7	126	12.8	56	5.7	5	0.5	0	0.0	1	0.1	112	11.4	41	4.2
1400000US25025061200	25025061200	Census Tract 612, Suffolk County, Massachusetts	2041	100.0	1753	85.9	288	14.1	1753	100.0	860	49.1	751	42.8	109	6.2	893	50.9	288	100.0	134	46.5	3	1.0	32	11.1	3	1.0	21	7.3	0	0.0	95	33.0	1753	100.0	860	49.1	831	47.4	747	42.6	7	0.4	1	0.1	63	3.6	1	0.1	2	0.1	10	0.6	29	1.7	22	1.3	2	0.1	0	0.0	0	0.0	0	0.0	3	0.2	2	0.1	893	50.9	850	48.5	783	44.7	28	1.6	0	0.0	33	1.9	1	0.1	1	0.1	4	0.2	43	2.5	24	1.4	5	0.3	0	0.0	2	0.1	0	0.0	11	0.6	1	0.1
1400000US25025070101	25025070101	Census Tract 701.01, Suffolk County, Massachusetts	3383	100.0	2875	85.0	508	15.0	2875	100.0	952	33.1	733	25.5	219	7.6	1923	66.9	508	100.0	209	41.1	14	2.8	76	15.0	13	2.6	183	36.0	0	0.0	13	2.6	2875	100.0	952	33.1	921	32.0	742	25.8	10	0.3	0	0.0	151	5.3	0	0.0	1	0.0	17	0.6	31	1.1	23	0.8	1	0.0	0	0.0	0	0.0	0	0.0	5	0.2	2	0.1	1923	66.9	1816	63.2	993	34.5	43	1.5	0	0.0	743	25.8	0	0.0	2	0.1	35	1.2	107	3.7	83	2.9	4	0.1	0	0.0	1	0.0	0	0.0	13	0.5	6	0.2
1400000US25025070200	25025070200	Census Tract 702, Suffolk County, Massachusetts	1690	100.0	1533	90.7	157	9.3	1533	100.0	119	7.8	86	5.6	33	2.2	1414	92.2	157	100.0	32	20.4	0	0.0	108	68.8	0	0.0	7	4.5	0	0.0	10	6.4	1533	100.0	119	7.8	115	7.5	41	2.7	3	0.2	0	0.0	66	4.3	0	0.0	0	0.0	5	0.3	4	0.3	2	0.1	0	0.0	0	0.0	2	0.1	0	0.0	0	0.0	0	0.0	1414	92.2	1383	90.2	163	10.6	51	3.3	2	0.1	1153	75.2	0	0.0	3	0.2	11	0.7	31	2.0	17	1.1	2	0.1	1	0.1	0	0.0	0	0.0	9	0.6	2	0.1
1400000US25025070300	25025070300	Census Tract 703, Suffolk County, Massachusetts	2706	100.0	2448	90.5	258	9.5	2448	100.0	1155	47.2	838	34.2	317	12.9	1293	52.8	258	100.0	44	17.1	6	2.3	13	5.0	6	2.3	172	66.7	0	0.0	17	6.6	2448	100.0	1155	47.2	1126	46.0	1007	41.1	13	0.5	0	0.0	93	3.8	0	0.0	2	0.1	11	0.4	29	1.2	27	1.1	0	0.0	0	0.0	0	0.0	0	0.0	1	0.0	1	0.0	1293	52.8	1228	50.2	882	36.0	64	2.6	2	0.1	244	10.0	0	0.0	7	0.3	29	1.2	65	2.7	37	1.5	3	0.1	0	0.0	1	0.0	0	0.0	16	0.7	8	0.3
1400000US25025070402	25025070402	Census Tract 704.02, Suffolk County, Massachusetts	680	100.0	666	97.9	14	2.1	666	100.0	3	0.5	1	0.2	2	0.3	663	99.5	14	100.0	7	50.0	3	21.4	0	0.0	0	0.0	0	0.0	0	0.0	4	28.6	666	100.0	3	0.5	3	0.5	0	0.0	1	0.2	0	0.0	2	0.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	663	99.5	606	91.0	60	9.0	89	13.4	2	0.3	441	66.2	0	0.0	4	0.6	10	1.5	57	8.6	20	3.0	6	0.9	0	0.0	0	0.0	0	0.0	27	4.1	4	0.6
1400000US25025070500	25025070500	Census Tract 705, Suffolk County, Massachusetts	3066	100.0	2903	94.7	163	5.3	2903	100.0	1179	40.6	1006	34.7	173	6.0	1724	59.4	163	100.0	65	39.9	10	6.1	19	11.7	11	6.7	24	14.7	0	0.0	34	20.9	2903	100.0	1179	40.6	1148	39.5	1023	35.2	14	0.5	0	0.0	101	3.5	0	0.0	2	0.1	8	0.3	31	1.1	22	0.8	1	0.0	0	0.0	0	0.0	0	0.0	6	0.2	2	0.1	1724	59.4	1269	43.7	739	25.5	198	6.8	4	0.1	292	10.1	0	0.0	7	0.2	29	1.0	455	15.7	204	7.0	44	1.5	8	0.3	1	0.0	1	0.0	166	5.7	31	1.1
1400000US25025070600	25025070600	Census Tract 706, Suffolk County, Massachusetts	1309	100.0	1210	92.4	99	7.6	1210	100.0	686	56.7	537	44.4	149	12.3	524	43.3	99	100.0	34	34.3	2	2.0	27	27.3	2	2.0	26	26.3	0	0.0	8	8.1	1210	100.0	686	56.7	668	55.2	610	50.4	22	1.8	2	0.2	28	2.3	1	0.1	1	0.1	4	0.3	18	1.5	13	1.1	0	0.0	0	0.0	0	0.0	0	0.0	4	0.3	1	0.1	524	43.3	486	40.2	419	34.6	20	1.7	0	0.0	37	3.1	0	0.0	1	0.1	9	0.7	38	3.1	21	1.7	1	0.1	0	0.0	0	0.0	0	0.0	14	1.2	2	0.2
1400000US25025070700	25025070700	Census Tract 707, Suffolk County, Massachusetts	1366	100.0	1238	90.6	128	9.4	1238	100.0	480	38.8	380	30.7	100	8.1	758	61.2	128	100.0	24	18.8	4	3.1	25	19.5	7	5.5	56	43.8	0	0.0	12	9.4	1238	100.0	480	38.8	468	37.8	390	31.5	33	2.7	1	0.1	35	2.8	0	0.0	1	0.1	8	0.6	12	1.0	12	1.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	758	61.2	688	55.6	358	28.9	221	17.9	5	0.4	69	5.6	0	0.0	6	0.5	29	2.3	70	5.7	38	3.1	9	0.7	0	0.0	0	0.0	0	0.0	17	1.4	6	0.5
1400000US25025070800	25025070800	Census Tract 708, Suffolk County, Massachusetts	2156	100.0	2044	94.8	112	5.2	2044	100.0	636	31.1	551	27.0	85	4.2	1408	68.9	112	100.0	63	56.3	1	0.9	5	4.5	6	5.4	27	24.1	0	0.0	10	8.9	2044	100.0	636	31.1	621	30.4	549	26.9	26	1.3	1	0.0	35	1.7	0	0.0	3	0.1	7	0.3	15	0.7	13	0.6	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	0	0.0	1408	68.9	1251	61.2	744	36.4	353	17.3	1	0.0	111	5.4	0	0.0	7	0.3	35	1.7	157	7.7	73	3.6	16	0.8	1	0.0	0	0.0	0	0.0	44	2.2	23	1.1
1400000US25025070900	25025070900	Census Tract 709, Suffolk County, Massachusetts	1798	100.0	1728	96.1	70	3.9	1728	100.0	506	29.3	459	26.6	47	2.7	1222	70.7	70	100.0	24	34.3	3	4.3	11	15.7	2	2.9	21	30.0	0	0.0	9	12.9	1728	100.0	506	29.3	495	28.6	425	24.6	32	1.9	1	0.1	23	1.3	0	0.0	0	0.0	14	0.8	11	0.6	9	0.5	0	0.0	0	0.0	0	0.0	0	0.0	2	0.1	0	0.0	1222	70.7	957	55.4	440	25.5	369	21.4	5	0.3	114	6.6	0	0.0	5	0.3	24	1.4	265	15.3	93	5.4	30	1.7	2	0.1	0	0.0	0	0.0	115	6.7	25	1.4
1400000US25025071101	25025071101	Census Tract 711.01, Suffolk County, Massachusetts	2185	100.0	2088	95.6	97	4.4	2088	100.0	570	27.3	515	24.7	55	2.6	1518	72.7	97	100.0	69	71.1	2	2.1	7	7.2	0	0.0	9	9.3	0	0.0	10	10.3	2088	100.0	570	27.3	549	26.3	458	21.9	24	1.1	3	0.1	58	2.8	0	0.0	1	0.0	5	0.2	21	1.0	13	0.6	2	0.1	0	0.0	0	0.0	0	0.0	4	0.2	2	0.1	1518	72.7	1318	63.1	627	30.0	277	13.3	6	0.3	352	16.9	0	0.0	18	0.9	38	1.8	200	9.6	77	3.7	21	1.0	2	0.1	0	0.0	0	0.0	87	4.2	13	0.6
1400000US25025071201	25025071201	Census Tract 712.01, Suffolk County, Massachusetts	1399	100.0	1304	93.2	95	6.8	1304	100.0	487	37.3	437	33.5	50	3.8	817	62.7	95	100.0	28	29.5	2	2.1	10	10.5	2	2.1	9	9.5	0	0.0	44	46.3	1304	100.0	487	37.3	469	36.0	370	28.4	18	1.4	0	0.0	80	6.1	0	0.0	0	0.0	1	0.1	18	1.4	8	0.6	4	0.3	0	0.0	1	0.1	0	0.0	3	0.2	2	0.2	817	62.7	566	43.4	246	18.9	198	15.2	1	0.1	100	7.7	2	0.2	6	0.5	13	1.0	251	19.2	77	5.9	22	1.7	0	0.0	0	0.0	0	0.0	138	10.6	14	1.1
1400000US25025080100	25025080100	Census Tract 801, Suffolk County, Massachusetts	744	100.0	681	91.5	63	8.5	681	100.0	149	21.9	113	16.6	36	5.3	532	78.1	63	100.0	39	61.9	1	1.6	6	9.5	0	0.0	1	1.6	0	0.0	16	25.4	681	100.0	149	21.9	132	19.4	28	4.1	62	9.1	1	0.1	1	0.1	0	0.0	31	4.6	9	1.3	17	2.5	7	1.0	3	0.4	0	0.0	0	0.0	0	0.0	7	1.0	0	0.0	532	78.1	404	59.3	79	11.6	223	32.7	0	0.0	4	0.6	0	0.0	56	8.2	42	6.2	128	18.8	35	5.1	24	3.5	4	0.6	0	0.0	0	0.0	51	7.5	14	2.1
1400000US25025080300	25025080300	Census Tract 803, Suffolk County, Massachusetts	791	100.0	693	87.6	98	12.4	693	100.0	133	19.2	112	16.2	21	3.0	560	80.8	98	100.0	51	52.0	1	1.0	2	2.0	4	4.1	4	4.1	0	0.0	36	36.7	693	100.0	133	19.2	114	16.5	9	1.3	91	13.1	1	0.1	3	0.4	0	0.0	4	0.6	6	0.9	19	2.7	3	0.4	3	0.4	0	0.0	0	0.0	0	0.0	9	1.3	4	0.6	560	80.8	416	60.0	19	2.7	370	53.4	7	1.0	4	0.6	0	0.0	4	0.6	12	1.7	144	20.8	35	5.1	25	3.6	2	0.3	0	0.0	0	0.0	71	10.2	11	1.6
1400000US25025080401	25025080401	Census Tract 804.01, Suffolk County, Massachusetts	1249	100.0	1225	98.1	24	1.9	1225	100.0	128	10.4	121	9.9	7	0.6	1097	89.6	24	100.0	16	66.7	0	0.0	1	4.2	4	16.7	1	4.2	0	0.0	2	8.3	1225	100.0	128	10.4	123	10.0	78	6.4	29	2.4	1	0.1	8	0.7	0	0.0	0	0.0	7	0.6	5	0.4	2	0.2	1	0.1	0	0.0	0	0.0	0	0.0	2	0.2	0	0.0	1097	89.6	704	57.5	44	3.6	603	49.2	8	0.7	21	1.7	0	0.0	5	0.4	23	1.9	393	32.1	117	9.6	74	6.0	7	0.6	1	0.1	0	0.0	142	11.6	52	4.2
1400000US25025080500	25025080500	Census Tract 805, Suffolk County, Massachusetts	1323	100.0	1269	95.9	54	4.1	1269	100.0	59	4.6	42	3.3	17	1.3	1210	95.4	54	100.0	44	81.5	1	1.9	0	0.0	0	0.0	0	0.0	0	0.0	9	16.7	1269	100.0	59	4.6	55	4.3	21	1.7	31	2.4	0	0.0	1	0.1	0	0.0	0	0.0	2	0.2	4	0.3	2	0.2	0	0.0	0	0.0	0	0.0	0	0.0	2	0.2	0	0.0	1210	95.4	701	55.2	85	6.7	558	44.0	1	0.1	33	2.6	0	0.0	2	0.2	22	1.7	509	40.1	140	11.0	116	9.1	4	0.3	0	0.0	2	0.2	189	14.9	58	4.6
1400000US25025080601	25025080601	Census Tract 806.01, Suffolk County, Massachusetts	920	100.0	882	95.9	38	4.1	882	100.0	105	11.9	94	10.7	11	1.2	777	88.1	38	100.0	28	73.7	2	5.3	0	0.0	0	0.0	3	7.9	0	0.0	5	13.2	882	100.0	105	11.9	95	10.8	17	1.9	50	5.7	0	0.0	24	2.7	0	0.0	0	0.0	4	0.5	10	1.1	2	0.2	3	0.3	0	0.0	0	0.0	0	0.0	5	0.6	0	0.0	777	88.1	550	62.4	198	22.4	285	32.3	4	0.5	38	4.3	0	0.0	10	1.1	15	1.7	227	25.7	69	7.8	34	3.9	3	0.3	1	0.1	0	0.0	98	11.1	22	2.5
1400000US25025080801	25025080801	Census Tract 808.01, Suffolk County, Massachusetts	946	100.0	927	98.0	19	2.0	927	100.0	2	0.2	2	0.2	0	0.0	925	99.8	19	100.0	17	89.5	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	2	10.5	927	100.0	2	0.2	1	0.1	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	925	99.8	491	53.0	62	6.7	305	32.9	6	0.6	100	10.8	0	0.0	1	0.1	17	1.8	434	46.8	156	16.8	40	4.3	7	0.8	1	0.1	0	0.0	198	21.4	32	3.5
1400000US25025080900	25025080900	Census Tract 809, Suffolk County, Massachusetts	1776	100.0	1686	94.9	90	5.1	1686	100.0	143	8.5	91	5.4	52	3.1	1543	91.5	90	100.0	52	57.8	5	5.6	2	2.2	3	3.3	10	11.1	0	0.0	18	20.0	1686	100.0	143	8.5	136	8.1	110	6.5	10	0.6	0	0.0	11	0.7	0	0.0	0	0.0	5	0.3	7	0.4	3	0.2	0	0.0	0	0.0	0	0.0	0	0.0	4	0.2	0	0.0	1543	91.5	1428	84.7	985	58.4	143	8.5	3	0.2	263	15.6	0	0.0	5	0.3	29	1.7	115	6.8	61	3.6	12	0.7	2	0.1	0	0.0	0	0.0	29	1.7	11	0.7
1400000US25025081001	25025081001	Census Tract 810.01, Suffolk County, Massachusetts	2287	100.0	2234	97.7	53	2.3	2234	100.0	174	7.8	144	6.4	30	1.3	2060	92.2	53	100.0	26	49.1	2	3.8	2	3.8	3	5.7	5	9.4	0	0.0	15	28.3	2234	100.0	174	7.8	162	7.3	117	5.2	18	0.8	2	0.1	20	0.9	0	0.0	0	0.0	5	0.2	12	0.5	7	0.3	1	0.0	0	0.0	0	0.0	0	0.0	4	0.2	0	0.0	2060	92.2	1684	75.4	939	42.0	301	13.5	9	0.4	375	16.8	1	0.0	7	0.3	52	2.3	376	16.8	143	6.4	41	1.8	8	0.4	2	0.1	0	0.0	159	7.1	23	1.0
1400000US25025081100	25025081100	Census Tract 811, Suffolk County, Massachusetts	1781	100.0	1682	94.4	99	5.6	1682	100.0	440	26.2	369	21.9	71	4.2	1242	73.8	99	100.0	39	39.4	1	1.0	35	35.4	0	0.0	6	6.1	0	0.0	18	18.2	1682	100.0	440	26.2	393	23.4	224	13.3	73	4.3	0	0.0	84	5.0	0	0.0	1	0.1	11	0.7	47	2.8	23	1.4	5	0.3	0	0.0	0	0.0	0	0.0	15	0.9	4	0.2	1242	73.8	1053	62.6	663	39.4	232	13.8	2	0.1	135	8.0	0	0.0	3	0.2	18	1.1	189	11.2	83	4.9	23	1.4	2	0.1	3	0.2	0	0.0	62	3.7	16	1.0
1400000US25025081200	25025081200	Census Tract 812, Suffolk County, Massachusetts	1232	100.0	1125	91.3	107	8.7	1125	100.0	156	13.9	138	12.3	18	1.6	969	86.1	107	100.0	63	58.9	3	2.8	16	15.0	1	0.9	1	0.9	0	0.0	23	21.5	1125	100.0	156	13.9	105	9.3	71	6.3	16	1.4	0	0.0	7	0.6	0	0.0	0	0.0	11	1.0	51	4.5	18	1.6	9	0.8	0	0.0	0	0.0	0	0.0	19	1.7	5	0.4	969	86.1	468	41.6	83	7.4	344	30.6	2	0.2	20	1.8	0	0.0	5	0.4	14	1.2	501	44.5	166	14.8	55	4.9	13	1.2	0	0.0	0	0.0	218	19.4	49	4.4
1400000US25025081300	25025081300	Census Tract 813, Suffolk County, Massachusetts	2111	100.0	2001	94.8	110	5.2	2001	100.0	201	10.0	166	8.3	35	1.7	1800	90.0	110	100.0	79	71.8	0	0.0	6	5.5	1	0.9	1	0.9	0	0.0	23	20.9	2001	100.0	201	10.0	158	7.9	44	2.2	101	5.0	0	0.0	6	0.3	0	0.0	1	0.0	6	0.3	43	2.1	13	0.6	7	0.3	0	0.0	0	0.0	0	0.0	19	0.9	4	0.2	1800	90.0	1041	52.0	108	5.4	867	43.3	14	0.7	13	0.6	2	0.1	5	0.2	32	1.6	759	37.9	223	11.1	115	5.7	12	0.6	1	0.0	0	0.0	327	16.3	81	4.0
1400000US25025081400	25025081400	Census Tract 814, Suffolk County, Massachusetts	1462	100.0	1300	88.9	162	11.1	1300	100.0	419	32.2	376	28.9	43	3.3	881	67.8	162	100.0	49	30.2	4	2.5	7	4.3	7	4.3	6	3.7	0	0.0	89	54.9	1300	100.0	419	32.2	380	29.2	97	7.5	248	19.1	2	0.2	18	1.4	0	0.0	4	0.3	11	0.8	39	3.0	14	1.1	13	1.0	0	0.0	0	0.0	0	0.0	10	0.8	2	0.2	881	67.8	699	53.8	206	15.8	447	34.4	4	0.3	14	1.1	0	0.0	4	0.3	24	1.8	182	14.0	42	3.2	41	3.2	7	0.5	0	0.0	0	0.0	81	6.2	11	0.8
1400000US25025081500	25025081500	Census Tract 815, Suffolk County, Massachusetts	905	100.0	839	92.7	66	7.3	839	100.0	265	31.6	224	26.7	41	4.9	574	68.4	66	100.0	34	51.5	0	0.0	13	19.7	5	7.6	1	1.5	0	0.0	13	19.7	839	100.0	265	31.6	233	27.8	31	3.7	189	22.5	2	0.2	4	0.5	0	0.0	2	0.2	5	0.6	32	3.8	9	1.1	6	0.7	0	0.0	0	0.0	0	0.0	11	1.3	6	0.7	574	68.4	440	52.4	35	4.2	371	44.2	4	0.5	5	0.6	1	0.1	9	1.1	15	1.8	134	16.0	42	5.0	31	3.7	0	0.0	0	0.0	0	0.0	44	5.2	17	2.0
1400000US25025081700	25025081700	Census Tract 817, Suffolk County, Massachusetts	1599	100.0	1473	92.1	126	7.9	1473	100.0	337	22.9	275	18.7	62	4.2	1136	77.1	126	100.0	63	50.0	3	2.4	3	2.4	3	2.4	2	1.6	0	0.0	52	41.3	1473	100.0	337	22.9	315	21.4	15	1.0	280	19.0	2	0.1	3	0.2	1	0.1	2	0.1	12	0.8	22	1.5	1	0.1	8	0.5	0	0.0	0	0.0	0	0.0	10	0.7	3	0.2	1136	77.1	920	62.5	27	1.8	824	55.9	10	0.7	10	0.7	0	0.0	11	0.7	38	2.6	216	14.7	51	3.5	43	2.9	4	0.3	1	0.1	0	0.0	99	6.7	18	1.2
1400000US25025081800	25025081800	Census Tract 818, Suffolk County, Massachusetts	1388	100.0	1139	82.1	249	17.9	1139	100.0	343	30.1	279	24.5	64	5.6	796	69.9	249	100.0	102	41.0	2	0.8	11	4.4	11	4.4	2	0.8	0	0.0	121	48.6	1139	100.0	343	30.1	309	27.1	22	1.9	256	22.5	1	0.1	6	0.5	0	0.0	5	0.4	19	1.7	34	3.0	4	0.4	15	1.3	0	0.0	0	0.0	0	0.0	12	1.1	3	0.3	796	69.9	564	49.5	14	1.2	515	45.2	5	0.4	1	0.1	1	0.1	8	0.7	20	1.8	232	20.4	50	4.4	45	4.0	1	0.1	1	0.1	0	0.0	112	9.8	23	2.0
1400000US25025081900	25025081900	Census Tract 819, Suffolk County, Massachusetts	1397	100.0	1256	89.9	141	10.1	1256	100.0	257	20.5	208	16.6	49	3.9	999	79.5	141	100.0	105	74.5	0	0.0	9	6.4	1	0.7	4	2.8	0	0.0	22	15.6	1256	100.0	257	20.5	221	17.6	6	0.5	195	15.5	1	0.1	2	0.2	0	0.0	4	0.3	13	1.0	36	2.9	5	0.4	15	1.2	0	0.0	0	0.0	0	0.0	13	1.0	3	0.2	999	79.5	756	60.2	21	1.7	686	54.6	9	0.7	3	0.2	0	0.0	13	1.0	24	1.9	243	19.3	58	4.6	36	2.9	1	0.1	0	0.0	0	0.0	119	9.5	29	2.3
1400000US25025082000	25025082000	Census Tract 820, Suffolk County, Massachusetts	1278	100.0	1158	90.6	120	9.4	1158	100.0	330	28.5	256	22.1	74	6.4	828	71.5	120	100.0	57	47.5	8	6.7	6	5.0	1	0.8	2	1.7	0	0.0	46	38.3	1158	100.0	330	28.5	310	26.8	3	0.3	287	24.8	2	0.2	3	0.3	0	0.0	5	0.4	10	0.9	20	1.7	2	0.2	6	0.5	0	0.0	0	0.0	0	0.0	8	0.7	4	0.3	828	71.5	664	57.3	19	1.6	601	51.9	3	0.3	3	0.3	1	0.1	17	1.5	20	1.7	164	14.2	38	3.3	30	2.6	1	0.1	0	0.0	0	0.0	80	6.9	15	1.3
1400000US25025082100	25025082100	Census Tract 821, Suffolk County, Massachusetts	2117	100.0	2035	96.1	82	3.9	2035	100.0	198	9.7	163	8.0	35	1.7	1837	90.3	82	100.0	55	67.1	1	1.2	3	3.7	0	0.0	1	1.2	0	0.0	22	26.8	2035	100.0	198	9.7	179	8.8	13	0.6	156	7.7	0	0.0	4	0.2	0	0.0	0	0.0	6	0.3	19	0.9	3	0.1	8	0.4	0	0.0	0	0.0	0	0.0	7	0.3	1	0.0	1837	90.3	1229	60.4	22	1.1	1133	55.7	7	0.3	9	0.4	1	0.0	16	0.8	41	2.0	608	29.9	122	6.0	82	4.0	10	0.5	0	0.0	0	0.0	336	16.5	58	2.9
1400000US25025090100	25025090100	Census Tract 901, Suffolk County, Massachusetts	1863	100.0	1681	90.2	182	9.8	1681	100.0	400	23.8	336	20.0	64	3.8	1281	76.2	182	100.0	113	62.1	2	1.1	8	4.4	2	1.1	3	1.6	0	0.0	54	29.7	1681	100.0	400	23.8	372	22.1	9	0.5	342	20.3	4	0.2	0	0.0	0	0.0	4	0.2	13	0.8	28	1.7	2	0.1	10	0.6	0	0.0	0	0.0	0	0.0	11	0.7	5	0.3	1281	76.2	975	58.0	23	1.4	896	53.3	6	0.4	10	0.6	1	0.1	14	0.8	25	1.5	306	18.2	46	2.7	72	4.3	4	0.2	0	0.0	1	0.1	158	9.4	25	1.5
1400000US25025090200	25025090200	Census Tract 902, Suffolk County, Massachusetts	830	100.0	772	93.0	58	7.0	772	100.0	123	15.9	95	12.3	28	3.6	649	84.1	58	100.0	29	50.0	1	1.7	6	10.3	6	10.3	1	1.7	0	0.0	15	25.9	772	100.0	123	15.9	100	13.0	1	0.1	82	10.6	0	0.0	8	1.0	0	0.0	7	0.9	2	0.3	23	3.0	3	0.4	6	0.8	0	0.0	0	0.0	0	0.0	10	1.3	4	0.5	649	84.1	404	52.3	19	2.5	358	46.4	3	0.4	2	0.3	0	0.0	11	1.4	11	1.4	245	31.7	46	6.0	35	4.5	4	0.5	0	0.0	1	0.1	143	18.5	16	2.1
1400000US25025090300	25025090300	Census Tract 903, Suffolk County, Massachusetts	1268	100.0	1123	88.6	145	11.4	1123	100.0	223	19.9	178	15.9	45	4.0	900	80.1	145	100.0	76	52.4	3	2.1	8	5.5	3	2.1	2	1.4	0	0.0	53	36.6	1123	100.0	223	19.9	183	16.3	2	0.2	166	14.8	1	0.1	1	0.1	1	0.1	5	0.4	7	0.6	40	3.6	8	0.7	9	0.8	1	0.1	0	0.0	0	0.0	15	1.3	7	0.6	900	80.1	609	54.2	21	1.9	533	47.5	3	0.3	4	0.4	0	0.0	16	1.4	32	2.8	291	25.9	73	6.5	53	4.7	2	0.2	1	0.1	1	0.1	140	12.5	21	1.9
1400000US25025090400	25025090400	Census Tract 904, Suffolk County, Massachusetts	1294	100.0	1148	88.7	146	11.3	1148	100.0	369	32.1	318	27.7	51	4.4	779	67.9	146	100.0	76	52.1	4	2.7	7	4.8	7	4.8	2	1.4	0	0.0	50	34.2	1148	100.0	369	32.1	307	26.7	15	1.3	232	20.2	1	0.1	4	0.3	0	0.0	31	2.7	24	2.1	62	5.4	20	1.7	13	1.1	1	0.1	1	0.1	0	0.0	21	1.8	6	0.5	779	67.9	508	44.3	26	2.3	412	35.9	4	0.3	5	0.4	0	0.0	30	2.6	31	2.7	271	23.6	65	5.7	57	5.0	5	0.4	1	0.1	0	0.0	117	10.2	26	2.3
1400000US25025090600	25025090600	Census Tract 906, Suffolk County, Massachusetts	793	100.0	720	90.8	73	9.2	720	100.0	258	35.8	199	27.6	59	8.2	462	64.2	73	100.0	35	47.9	0	0.0	3	4.1	3	4.1	0	0.0	0	0.0	32	43.8	720	100.0	258	35.8	230	31.9	13	1.8	125	17.4	1	0.1	5	0.7	0	0.0	60	8.3	26	3.6	28	3.9	11	1.5	5	0.7	0	0.0	0	0.0	0	0.0	9	1.3	3	0.4	462	64.2	355	49.3	21	2.9	165	22.9	1	0.1	8	1.1	1	0.1	125	17.4	34	4.7	107	14.9	25	3.5	22	3.1	2	0.3	0	0.0	0	0.0	46	6.4	12	1.7
1400000US25025090700	25025090700	Census Tract 907, Suffolk County, Massachusetts	1990	100.0	1832	92.1	158	7.9	1832	100.0	603	32.9	462	25.2	141	7.7	1229	67.1	158	100.0	70	44.3	1	0.6	12	7.6	8	5.1	17	10.8	0	0.0	50	31.6	1832	100.0	603	32.9	580	31.7	471	25.7	26	1.4	0	0.0	67	3.7	0	0.0	8	0.4	8	0.4	23	1.3	17	0.9	1	0.1	0	0.0	0	0.0	0	0.0	5	0.3	0	0.0	1229	67.1	1128	61.6	783	42.7	129	7.0	4	0.2	169	9.2	0	0.0	15	0.8	28	1.5	101	5.5	31	1.7	11	0.6	1	0.1	0	0.0	0	0.0	53	2.9	5	0.3
1400000US25025090901	25025090901	Census Tract 909.01, Suffolk County, Massachusetts	1640	100.0	1540	93.9	100	6.1	1540	100.0	3	0.2	0	0.0	3	0.2	1537	99.8	100	100.0	86	86.0	4	4.0	0	0.0	0	0.0	9	9.0	0	0.0	1	1.0	1540	100.0	3	0.2	2	0.1	0	0.0	1	0.1	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	1537	99.8	1266	82.2	615	39.9	303	19.7	4	0.3	302	19.6	1	0.1	15	1.0	26	1.7	271	17.6	104	6.8	23	1.5	3	0.2	0	0.0	0	0.0	128	8.3	13	0.8
1400000US25025091001	25025091001	Census Tract 910.01, Suffolk County, Massachusetts	1315	100.0	1236	94.0	79	6.0	1236	100.0	527	42.6	410	33.2	117	9.5	709	57.4	79	100.0	39	49.4	3	3.8	9	11.4	7	8.9	2	2.5	0	0.0	19	24.1	1236	100.0	527	42.6	519	42.0	445	36.0	20	1.6	0	0.0	45	3.6	0	0.0	2	0.2	7	0.6	8	0.6	4	0.3	0	0.0	0	0.0	0	0.0	0	0.0	4	0.3	0	0.0	709	57.4	631	51.1	393	31.8	110	8.9	0	0.0	98	7.9	0	0.0	8	0.6	22	1.8	78	6.3	23	1.9	9	0.7	0	0.0	0	0.0	0	0.0	35	2.8	11	0.9
1400000US25025091100	25025091100	Census Tract 911, Suffolk County, Massachusetts	1966	100.0	1792	91.1	174	8.9	1792	100.0	709	39.6	555	31.0	154	8.6	1083	60.4	174	100.0	65	37.4	4	2.3	54	31.0	4	2.3	3	1.7	0	0.0	44	25.3	1792	100.0	709	39.6	685	38.2	522	29.1	38	2.1	0	0.0	89	5.0	0	0.0	15	0.8	21	1.2	24	1.3	12	0.7	3	0.2	0	0.0	0	0.0	0	0.0	8	0.4	1	0.1	1083	60.4	975	54.4	526	29.4	171	9.5	5	0.3	218	12.2	0	0.0	24	1.3	31	1.7	108	6.0	40	2.2	10	0.6	0	0.0	1	0.1	2	0.1	49	2.7	6	0.3
1400000US25025091200	25025091200	Census Tract 912, Suffolk County, Massachusetts	1239	100.0	1160	93.6	79	6.4	1160	100.0	399	34.4	346	29.8	53	4.6	761	65.6	79	100.0	40	50.6	1	1.3	5	6.3	4	5.1	3	3.8	0	0.0	26	32.9	1160	100.0	399	34.4	368	31.7	252	21.7	50	4.3	0	0.0	20	1.7	0	0.0	29	2.5	17	1.5	31	2.7	5	0.4	5	0.4	0	0.0	0	0.0	1	0.1	16	1.4	4	0.3	761	65.6	592	51.0	218	18.8	219	18.9	2	0.2	48	4.1	3	0.3	65	5.6	37	3.2	169	14.6	44	3.8	17	1.5	2	0.2	0	0.0	0	0.0	86	7.4	20	1.7
1400000US25025091300	25025091300	Census Tract 913, Suffolk County, Massachusetts	868	100.0	790	91.0	78	9.0	790	100.0	216	27.3	169	21.4	47	5.9	574	72.7	78	100.0	31	39.7	3	3.8	0	0.0	0	0.0	0	0.0	0	0.0	44	56.4	790	100.0	216	27.3	185	23.4	38	4.8	62	7.8	0	0.0	14	1.8	0	0.0	52	6.6	19	2.4	31	3.9	13	1.6	5	0.6	0	0.0	0	0.0	1	0.1	9	1.1	3	0.4	574	72.7	431	54.6	47	5.9	219	27.7	3	0.4	11	1.4	0	0.0	122	15.4	29	3.7	143	18.1	37	4.7	16	2.0	0	0.0	1	0.1	0	0.0	70	8.9	19	2.4
1400000US25025091400	25025091400	Census Tract 914, Suffolk County, Massachusetts	939	100.0	879	93.6	60	6.4	879	100.0	301	34.2	263	29.9	38	4.3	578	65.8	60	100.0	27	45.0	3	5.0	1	1.7	4	6.7	0	0.0	0	0.0	25	41.7	879	100.0	301	34.2	245	27.9	31	3.5	180	20.5	0	0.0	4	0.5	0	0.0	14	1.6	16	1.8	56	6.4	19	2.2	11	1.3	1	0.1	0	0.0	0	0.0	22	2.5	3	0.3	578	65.8	357	40.6	23	2.6	251	28.6	2	0.2	1	0.1	0	0.0	47	5.3	33	3.8	221	25.1	55	6.3	26	3.0	2	0.2	0	0.0	0	0.0	125	14.2	13	1.5
1400000US25025091500	25025091500	Census Tract 915, Suffolk County, Massachusetts	1653	100.0	1470	88.9	183	11.1	1470	100.0	457	31.1	396	26.9	61	4.1	1013	68.9	183	100.0	95	51.9	13	7.1	16	8.7	3	1.6	1	0.5	0	0.0	55	30.1	1470	100.0	457	31.1	407	27.7	123	8.4	171	11.6	0	0.0	20	1.4	0	0.0	57	3.9	36	2.4	50	3.4	16	1.1	11	0.7	1	0.1	0	0.0	0	0.0	19	1.3	3	0.2	1013	68.9	784	53.3	104	7.1	416	28.3	2	0.1	38	2.6	0	0.0	141	9.6	83	5.6	229	15.6	58	3.9	36	2.4	2	0.1	0	0.0	0	0.0	113	7.7	20	1.4
1400000US25025091600	25025091600	Census Tract 916, Suffolk County, Massachusetts	1165	100.0	1043	89.5	122	10.5	1043	100.0	285	27.3	248	23.8	37	3.5	758	72.7	122	100.0	69	56.6	4	3.3	3	2.5	0	0.0	0	0.0	0	0.0	46	37.7	1043	100.0	285	27.3	263	25.2	97	9.3	87	8.3	1	0.1	48	4.6	0	0.0	11	1.1	19	1.8	22	2.1	3	0.3	3	0.3	0	0.0	1	0.1	0	0.0	12	1.2	3	0.3	758	72.7	642	61.6	113	10.8	262	25.1	1	0.1	183	17.5	0	0.0	54	5.2	29	2.8	116	11.1	26	2.5	20	1.9	0	0.0	3	0.3	0	0.0	55	5.3	12	1.2
1400000US25025091700	25025091700	Census Tract 917, Suffolk County, Massachusetts	1050	100.0	917	87.3	133	12.7	917	100.0	319	34.8	273	29.8	46	5.0	598	65.2	133	100.0	79	59.4	4	3.0	5	3.8	0	0.0	5	3.8	0	0.0	40	30.1	917	100.0	319	34.8	272	29.7	44	4.8	151	16.5	0	0.0	12	1.3	0	0.0	47	5.1	18	2.0	47	5.1	9	1.0	19	2.1	0	0.0	0	0.0	0	0.0	13	1.4	6	0.7	598	65.2	473	51.6	42	4.6	304	33.2	2	0.2	19	2.1	0	0.0	73	8.0	33	3.6	125	13.6	28	3.1	29	3.2	3	0.3	0	0.0	0	0.0	53	5.8	12	1.3
1400000US25025091800	25025091800	Census Tract 918, Suffolk County, Massachusetts	1214	100.0	1042	85.8	172	14.2	1042	100.0	388	37.2	339	32.5	49	4.7	654	62.8	172	100.0	109	63.4	2	1.2	10	5.8	0	0.0	3	1.7	0	0.0	48	27.9	1042	100.0	388	37.2	327	31.4	23	2.2	233	22.4	0	0.0	8	0.8	0	0.0	40	3.8	23	2.2	61	5.9	18	1.7	14	1.3	0	0.0	0	0.0	0	0.0	26	2.5	3	0.3	654	62.8	523	50.2	25	2.4	350	33.6	3	0.3	9	0.9	0	0.0	88	8.4	48	4.6	131	12.6	28	2.7	31	3.0	0	0.0	0	0.0	0	0.0	69	6.6	3	0.3
1400000US25025091900	25025091900	Census Tract 919, Suffolk County, Massachusetts	1380	100.0	1244	90.1	136	9.9	1244	100.0	401	32.2	331	26.6	70	5.6	843	67.8	136	100.0	78	57.4	1	0.7	6	4.4	7	5.1	1	0.7	0	0.0	43	31.6	1244	100.0	401	32.2	367	29.5	10	0.8	326	26.2	1	0.1	1	0.1	0	0.0	16	1.3	13	1.0	34	2.7	5	0.4	14	1.1	1	0.1	0	0.0	0	0.0	9	0.7	5	0.4	843	67.8	652	52.4	22	1.8	576	46.3	8	0.6	4	0.3	0	0.0	16	1.3	26	2.1	191	15.4	41	3.3	44	3.5	4	0.3	0	0.0	0	0.0	88	7.1	14	1.1
1400000US25025092000	25025092000	Census Tract 920, Suffolk County, Massachusetts	1693	100.0	1532	90.5	161	9.5	1532	100.0	535	34.9	442	28.9	93	6.1	997	65.1	161	100.0	61	37.9	2	1.2	3	1.9	3	1.9	2	1.2	0	0.0	90	55.9	1532	100.0	535	34.9	462	30.2	52	3.4	324	21.1	0	0.0	45	2.9	0	0.0	19	1.2	22	1.4	73	4.8	13	0.8	19	1.2	0	0.0	0	0.0	0	0.0	31	2.0	10	0.7	997	65.1	780	50.9	63	4.1	561	36.6	2	0.1	69	4.5	1	0.1	44	2.9	40	2.6	217	14.2	50	3.3	46	3.0	1	0.1	0	0.0	1	0.1	102	6.7	17	1.1
1400000US25025092101	25025092101	Census Tract 921.01, Suffolk County, Massachusetts	2454	100.0	2252	91.8	202	8.2	2252	100.0	872	38.7	705	31.3	167	7.4	1380	61.3	202	100.0	140	69.3	8	4.0	18	8.9	4	2.0	3	1.5	0	0.0	29	14.4	2252	100.0	872	38.7	823	36.5	481	21.4	135	6.0	1	0.0	181	8.0	0	0.0	10	0.4	15	0.7	49	2.2	23	1.0	4	0.2	1	0.0	2	0.1	0	0.0	15	0.7	4	0.2	1380	61.3	1207	53.6	413	18.3	377	16.7	9	0.4	319	14.2	0	0.0	47	2.1	42	1.9	173	7.7	45	2.0	22	1.0	4	0.2	2	0.1	0	0.0	91	4.0	9	0.4
1400000US25025092200	25025092200	Census Tract 922, Suffolk County, Massachusetts	1227	100.0	1134	92.4	93	7.6	1134	100.0	536	47.3	465	41.0	71	6.3	598	52.7	93	100.0	66	71.0	2	2.2	4	4.3	3	3.2	1	1.1	0	0.0	17	18.3	1134	100.0	536	47.3	505	44.5	226	19.9	205	18.1	0	0.0	57	5.0	0	0.0	10	0.9	7	0.6	31	2.7	9	0.8	11	1.0	0	0.0	0	0.0	0	0.0	9	0.8	2	0.2	598	52.7	512	45.1	105	9.3	292	25.7	5	0.4	65	5.7	0	0.0	16	1.4	29	2.6	86	7.6	26	2.3	10	0.9	0	0.0	0	0.0	0	0.0	41	3.6	9	0.8
1400000US25025092300	25025092300	Census Tract 923, Suffolk County, Massachusetts	1077	100.0	956	88.8	121	11.2	956	100.0	362	37.9	310	32.4	52	5.4	594	62.1	121	100.0	65	53.7	2	1.7	3	2.5	7	5.8	4	3.3	0	0.0	40	33.1	956	100.0	362	37.9	332	34.7	5	0.5	308	32.2	1	0.1	1	0.1	0	0.0	6	0.6	11	1.2	30	3.1	3	0.3	11	1.2	0	0.0	0	0.0	0	0.0	12	1.3	4	0.4	594	62.1	490	51.3	12	1.3	446	46.7	2	0.2	4	0.4	0	0.0	7	0.7	19	2.0	104	10.9	27	2.8	20	2.1	2	0.2	0	0.0	0	0.0	41	4.3	14	1.5
1400000US25025092400	25025092400	Census Tract 924, Suffolk County, Massachusetts	2065	100.0	1873	90.7	192	9.3	1873	100.0	386	20.6	309	16.5	77	4.1	1487	79.4	192	100.0	122	63.5	8	4.2	1	0.5	4	2.1	1	0.5	0	0.0	56	29.2	1873	100.0	386	20.6	355	19.0	3	0.2	328	17.5	2	0.1	3	0.2	0	0.0	3	0.2	16	0.9	31	1.7	6	0.3	12	0.6	1	0.1	0	0.0	0	0.0	12	0.6	0	0.0	1487	79.4	1038	55.4	20	1.1	953	50.9	9	0.5	6	0.3	0	0.0	9	0.5	41	2.2	449	24.0	106	5.7	84	4.5	5	0.3	1	0.1	0	0.0	204	10.9	49	2.6
1400000US25025100100	25025100100	Census Tract 1001, Suffolk County, Massachusetts	2047	100.0	1895	92.6	152	7.4	1895	100.0	418	22.1	370	19.5	48	2.5	1477	77.9	152	100.0	79	52.0	2	1.3	12	7.9	6	3.9	3	2.0	0	0.0	50	32.9	1895	100.0	418	22.1	365	19.3	4	0.2	340	17.9	0	0.0	4	0.2	0	0.0	9	0.5	8	0.4	53	2.8	7	0.4	23	1.2	0	0.0	0	0.0	0	0.0	18	0.9	5	0.3	1477	77.9	1039	54.8	27	1.4	932	49.2	6	0.3	11	0.6	2	0.1	26	1.4	35	1.8	438	23.1	106	5.6	97	5.1	1	0.1	0	0.0	0	0.0	201	10.6	33	1.7
1400000US25025100200	25025100200	Census Tract 1002, Suffolk County, Massachusetts	1013	100.0	905	89.3	108	10.7	905	100.0	336	37.1	292	32.3	44	4.9	569	62.9	108	100.0	53	49.1	0	0.0	13	12.0	0	0.0	1	0.9	0	0.0	41	38.0	905	100.0	336	37.1	311	34.4	3	0.3	293	32.4	2	0.2	3	0.3	0	0.0	2	0.2	8	0.9	25	2.8	7	0.8	7	0.8	1	0.1	0	0.0	0	0.0	8	0.9	2	0.2	569	62.9	470	51.9	11	1.2	428	47.3	0	0.0	3	0.3	0	0.0	10	1.1	18	2.0	99	10.9	11	1.2	33	3.6	1	0.1	0	0.0	0	0.0	43	4.8	11	1.2
1400000US25025100300	25025100300	Census Tract 1003, Suffolk County, Massachusetts	1262	100.0	1121	88.8	141	11.2	1121	100.0	477	42.6	404	36.0	73	6.5	644	57.4	141	100.0	69	48.9	5	3.5	13	9.2	1	0.7	0	0.0	0	0.0	53	37.6	1121	100.0	477	42.6	443	39.5	21	1.9	403	36.0	1	0.1	3	0.3	0	0.0	3	0.3	12	1.1	34	3.0	9	0.8	12	1.1	0	0.0	0	0.0	0	0.0	12	1.1	1	0.1	644	57.4	569	50.8	22	2.0	509	45.4	2	0.2	3	0.3	0	0.0	18	1.6	15	1.3	75	6.7	9	0.8	25	2.2	0	0.0	0	0.0	0	0.0	35	3.1	6	0.5
1400000US25025100400	25025100400	Census Tract 1004, Suffolk County, Massachusetts	1830	100.0	1695	92.6	135	7.4	1695	100.0	715	42.2	610	36.0	105	6.2	980	57.8	135	100.0	86	63.7	11	8.1	7	5.2	5	3.7	2	1.5	0	0.0	24	17.8	1695	100.0	715	42.2	672	39.6	146	8.6	463	27.3	2	0.1	28	1.7	0	0.0	15	0.9	18	1.1	43	2.5	9	0.5	13	0.8	0	0.0	1	0.1	0	0.0	15	0.9	5	0.3	980	57.8	888	52.4	83	4.9	717	42.3	2	0.1	32	1.9	0	0.0	16	0.9	38	2.2	92	5.4	16	0.9	29	1.7	1	0.1	0	0.0	0	0.0	37	2.2	9	0.5
1400000US25025100500	25025100500	Census Tract 1005, Suffolk County, Massachusetts	2383	100.0	2174	91.2	209	8.8	2174	100.0	680	31.3	554	25.5	126	5.8	1494	68.7	209	100.0	130	62.2	3	1.4	25	12.0	1	0.5	1	0.5	0	0.0	49	23.4	2174	100.0	680	31.3	633	29.1	222	10.2	339	15.6	1	0.0	46	2.1	0	0.0	8	0.4	17	0.8	47	2.2	15	0.7	13	0.6	0	0.0	0	0.0	0	0.0	15	0.7	4	0.2	1494	68.7	1239	57.0	158	7.3	881	40.5	4	0.2	109	5.0	0	0.0	33	1.5	54	2.5	255	11.7	58	2.7	55	2.5	7	0.3	0	0.0	1	0.0	108	5.0	26	1.2
1400000US25025100601	25025100601	Census Tract 1006.01, Suffolk County, Massachusetts	2192	100.0	2028	92.5	164	7.5	2028	100.0	927	45.7	758	37.4	169	8.3	1101	54.3	164	100.0	95	57.9	1	0.6	17	10.4	6	3.7	7	4.3	0	0.0	38	23.2	2028	100.0	927	45.7	887	43.7	601	29.6	171	8.4	3	0.1	82	4.0	0	0.0	15	0.7	15	0.7	40	2.0	9	0.4	11	0.5	0	0.0	1	0.0	0	0.0	11	0.5	8	0.4	1101	54.3	981	48.4	396	19.5	386	19.0	2	0.1	135	6.7	1	0.0	35	1.7	26	1.3	120	5.9	30	1.5	32	1.6	0	0.0	0	0.0	0	0.0	49	2.4	9	0.4
1400000US25025100603	25025100603	Census Tract 1006.03, Suffolk County, Massachusetts	840	100.0	754	89.8	86	10.2	754	100.0	413	54.8	340	45.1	73	9.7	341	45.2	86	100.0	37	43.0	2	2.3	21	24.4	3	3.5	7	8.1	0	0.0	16	18.6	754	100.0	413	54.8	398	52.8	335	44.4	28	3.7	0	0.0	27	3.6	1	0.1	3	0.4	4	0.5	15	2.0	9	1.2	2	0.3	0	0.0	0	0.0	0	0.0	3	0.4	1	0.1	341	45.2	316	41.9	234	31.0	56	7.4	0	0.0	17	2.3	0	0.0	1	0.1	8	1.1	25	3.3	12	1.6	4	0.5	0	0.0	0	0.0	0	0.0	9	1.2	0	0.0
1400000US25025100700	25025100700	Census Tract 1007, Suffolk County, Massachusetts	1975	100.0	1873	94.8	102	5.2	1873	100.0	1038	55.4	791	42.2	247	13.2	835	44.6	102	100.0	33	32.4	3	2.9	5	4.9	10	9.8	4	3.9	1	1.0	46	45.1	1873	100.0	1038	55.4	1022	54.6	971	51.8	20	1.1	1	0.1	25	1.3	0	0.0	1	0.1	4	0.2	16	0.9	9	0.5	1	0.1	1	0.1	0	0.0	0	0.0	5	0.3	0	0.0	835	44.6	811	43.3	728	38.9	55	2.9	0	0.0	16	0.9	0	0.0	4	0.2	8	0.4	24	1.3	12	0.6	1	0.1	0	0.0	0	0.0	0	0.0	10	0.5	1	0.1
1400000US25025100800	25025100800	Census Tract 1008, Suffolk County, Massachusetts	2702	100.0	2524	93.4	178	6.6	2524	100.0	1152	45.6	915	36.3	237	9.4	1372	54.4	178	100.0	93	52.2	7	3.9	16	9.0	3	1.7	9	5.1	0	0.0	50	28.1	2524	100.0	1152	45.6	1119	44.3	856	33.9	159	6.3	0	0.0	78	3.1	0	0.0	9	0.4	17	0.7	33	1.3	13	0.5	5	0.2	0	0.0	1	0.0	0	0.0	12	0.5	2	0.1	1372	54.4	1260	49.9	622	24.6	476	18.9	4	0.2	94	3.7	0	0.0	15	0.6	49	1.9	112	4.4	37	1.5	25	1.0	0	0.0	0	0.0	0	0.0	33	1.3	17	0.7
1400000US25025100900	25025100900	Census Tract 1009, Suffolk County, Massachusetts	1729	100.0	1610	93.1	119	6.9	1610	100.0	868	53.9	742	46.1	126	7.8	742	46.1	119	100.0	63	52.9	4	3.4	14	11.8	4	3.4	4	3.4	0	0.0	30	25.2	1610	100.0	868	53.9	832	51.7	296	18.4	465	28.9	0	0.0	43	2.7	0	0.0	10	0.6	18	1.1	36	2.2	9	0.6	15	0.9	0	0.0	0	0.0	1	0.1	9	0.6	2	0.1	742	46.1	664	41.2	201	12.5	398	24.7	0	0.0	36	2.2	0	0.0	12	0.7	17	1.1	78	4.8	18	1.1	24	1.5	1	0.1	0	0.0	0	0.0	26	1.6	9	0.6
1400000US25025101001	25025101001	Census Tract 1010.01, Suffolk County, Massachusetts	2266	100.0	2127	93.9	139	6.1	2127	100.0	949	44.6	787	37.0	162	7.6	1178	55.4	139	100.0	73	52.5	4	2.9	11	7.9	6	4.3	1	0.7	0	0.0	44	31.7	2127	100.0	949	44.6	909	42.7	37	1.7	841	39.5	3	0.1	1	0.0	0	0.0	6	0.3	21	1.0	40	1.9	3	0.1	24	1.1	1	0.0	0	0.0	0	0.0	8	0.4	4	0.2	1178	55.4	996	46.8	28	1.3	915	43.0	5	0.2	2	0.1	0	0.0	9	0.4	37	1.7	182	8.6	40	1.9	36	1.7	3	0.1	1	0.0	0	0.0	89	4.2	13	0.6
1400000US25025101002	25025101002	Census Tract 1010.02, Suffolk County, Massachusetts	2149	100.0	1968	91.6	181	8.4	1968	100.0	667	33.9	551	28.0	116	5.9	1301	66.1	181	100.0	129	71.3	8	4.4	9	5.0	5	2.8	2	1.1	0	0.0	28	15.5	1968	100.0	667	33.9	623	31.7	29	1.5	565	28.7	2	0.1	1	0.1	0	0.0	4	0.2	22	1.1	44	2.2	5	0.3	22	1.1	1	0.1	1	0.1	0	0.0	8	0.4	7	0.4	1301	66.1	1120	56.9	57	2.9	999	50.8	5	0.3	16	0.8	0	0.0	14	0.7	29	1.5	181	9.2	31	1.6	44	2.2	3	0.2	0	0.0	1	0.1	83	4.2	19	1.0
1400000US25025101101	25025101101	Census Tract 1011.01, Suffolk County, Massachusetts	1160	100.0	1048	90.3	112	9.7	1048	100.0	414	39.5	345	32.9	69	6.6	634	60.5	112	100.0	60	53.6	0	0.0	8	7.1	2	1.8	0	0.0	0	0.0	42	37.5	1048	100.0	414	39.5	391	37.3	5	0.5	377	36.0	0	0.0	1	0.1	0	0.0	3	0.3	5	0.5	23	2.2	0	0.0	13	1.2	0	0.0	0	0.0	0	0.0	8	0.8	2	0.2	634	60.5	524	50.0	5	0.5	492	46.9	1	0.1	1	0.1	0	0.0	1	0.1	24	2.3	110	10.5	11	1.0	25	2.4	1	0.1	0	0.0	1	0.1	61	5.8	11	1.0
1400000US25025101102	25025101102	Census Tract 1011.02, Suffolk County, Massachusetts	1672	100.0	1511	90.4	161	9.6	1511	100.0	407	26.9	347	23.0	60	4.0	1104	73.1	161	100.0	114	70.8	5	3.1	7	4.3	2	1.2	2	1.2	0	0.0	31	19.3	1511	100.0	407	26.9	389	25.7	5	0.3	372	24.6	0	0.0	1	0.1	1	0.1	1	0.1	9	0.6	18	1.2	4	0.3	10	0.7	0	0.0	0	0.0	0	0.0	3	0.2	1	0.1	1104	73.1	979	64.8	16	1.1	924	61.2	5	0.3	3	0.2	1	0.1	0	0.0	30	2.0	125	8.3	22	1.5	37	2.4	3	0.2	0	0.0	0	0.0	55	3.6	8	0.5
1400000US25025110103	25025110103	Census Tract 1101.03, Suffolk County, Massachusetts	2353	100.0	2186	92.9	167	7.1	2186	100.0	859	39.3	713	32.6	146	6.7	1327	60.7	167	100.0	98	58.7	6	3.6	16	9.6	5	3.0	8	4.8	0	0.0	34	20.4	2186	100.0	859	39.3	758	34.7	563	25.8	99	4.5	1	0.0	75	3.4	1	0.0	6	0.3	13	0.6	101	4.6	41	1.9	6	0.3	2	0.1	0	0.0	0	0.0	47	2.2	5	0.2	1327	60.7	893	40.9	507	23.2	282	12.9	4	0.2	57	2.6	1	0.0	6	0.3	36	1.6	434	19.9	162	7.4	28	1.3	4	0.2	0	0.0	0	0.0	206	9.4	34	1.6
1400000US25025110201	25025110201	Census Tract 1102.01, Suffolk County, Massachusetts	874	100.0	815	93.2	59	6.8	815	100.0	301	36.9	249	30.6	52	6.4	514	63.1	59	100.0	25	42.4	0	0.0	12	20.3	7	11.9	1	1.7	0	0.0	14	23.7	815	100.0	301	36.9	234	28.7	107	13.1	106	13.0	1	0.1	12	1.5	0	0.0	2	0.2	6	0.7	67	8.2	22	2.7	7	0.9	3	0.4	1	0.1	0	0.0	27	3.3	7	0.9	514	63.1	336	41.2	104	12.8	214	26.3	3	0.4	6	0.7	0	0.0	5	0.6	4	0.5	178	21.8	65	8.0	17	2.1	4	0.5	1	0.1	0	0.0	79	9.7	12	1.5
1400000US25025110301	25025110301	Census Tract 1103.01, Suffolk County, Massachusetts	955	100.0	898	94.0	57	6.0	898	100.0	602	67.0	489	54.5	113	12.6	296	33.0	57	100.0	33	57.9	2	3.5	6	10.5	2	3.5	1	1.8	0	0.0	13	22.8	898	100.0	602	67.0	486	54.1	337	37.5	122	13.6	4	0.4	13	1.4	0	0.0	3	0.3	7	0.8	116	12.9	50	5.6	13	1.4	0	0.0	0	0.0	0	0.0	46	5.1	7	0.8	296	33.0	206	22.9	112	12.5	75	8.4	2	0.2	8	0.9	0	0.0	2	0.2	7	0.8	90	10.0	30	3.3	12	1.3	0	0.0	0	0.0	0	0.0	44	4.9	4	0.4
1400000US25025110401	25025110401	Census Tract 1104.01, Suffolk County, Massachusetts	1362	100.0	1285	94.3	77	5.7	1285	100.0	605	47.1	500	38.9	105	8.2	680	52.9	77	100.0	44	57.1	1	1.3	9	11.7	2	2.6	1	1.3	0	0.0	20	26.0	1285	100.0	605	47.1	495	38.5	333	25.9	140	10.9	1	0.1	15	1.2	0	0.0	1	0.1	5	0.4	110	8.6	49	3.8	3	0.2	0	0.0	1	0.1	0	0.0	45	3.5	12	0.9	680	52.9	398	31.0	188	14.6	181	14.1	2	0.2	10	0.8	2	0.2	4	0.3	11	0.9	282	21.9	104	8.1	29	2.3	3	0.2	0	0.0	1	0.1	117	9.1	28	2.2
1400000US25025110403	25025110403	Census Tract 1104.03, Suffolk County, Massachusetts	1767	100.0	1675	94.8	92	5.2	1675	100.0	1076	64.2	848	50.6	228	13.6	599	35.8	92	100.0	34	37.0	3	3.3	12	13.0	2	2.2	0	0.0	0	0.0	41	44.6	1675	100.0	1076	64.2	930	55.5	724	43.2	150	9.0	3	0.2	36	2.1	1	0.1	1	0.1	15	0.9	146	8.7	67	4.0	14	0.8	0	0.0	1	0.1	0	0.0	57	3.4	7	0.4	599	35.8	442	26.4	269	16.1	152	9.1	2	0.1	3	0.2	0	0.0	6	0.4	10	0.6	157	9.4	48	2.9	27	1.6	0	0.0	0	0.0	0	0.0	61	3.6	21	1.3
1400000US25025110501	25025110501	Census Tract 1105.01, Suffolk County, Massachusetts	1371	100.0	1300	94.8	71	5.2	1300	100.0	818	62.9	588	45.2	230	17.7	482	37.1	71	100.0	34	47.9	5	7.0	3	4.2	2	2.8	5	7.0	0	0.0	22	31.0	1300	100.0	818	62.9	772	59.4	706	54.3	33	2.5	0	0.0	25	1.9	0	0.0	2	0.2	6	0.5	46	3.5	23	1.8	2	0.2	0	0.0	0	0.0	0	0.0	16	1.2	5	0.4	482	37.1	392	30.2	302	23.2	70	5.4	1	0.1	5	0.4	0	0.0	1	0.1	13	1.0	90	6.9	29	2.2	6	0.5	2	0.2	0	0.0	0	0.0	42	3.2	11	0.8
1400000US25025110502	25025110502	Census Tract 1105.02, Suffolk County, Massachusetts	1684	100.0	1580	93.8	104	6.2	1580	100.0	821	52.0	642	40.6	179	11.3	759	48.0	104	100.0	43	41.3	5	4.8	28	26.9	2	1.9	5	4.8	0	0.0	21	20.2	1580	100.0	821	52.0	727	46.0	606	38.4	86	5.4	0	0.0	22	1.4	0	0.0	2	0.1	11	0.7	94	5.9	53	3.4	3	0.2	2	0.1	0	0.0	0	0.0	30	1.9	6	0.4	759	48.0	556	35.2	380	24.1	152	9.6	0	0.0	10	0.6	0	0.0	2	0.1	12	0.8	203	12.8	88	5.6	13	0.8	4	0.3	0	0.0	0	0.0	86	5.4	12	0.8
1400000US25025110601	25025110601	Census Tract 1106.01, Suffolk County, Massachusetts	1295	100.0	1235	95.4	60	4.6	1235	100.0	948	76.8	639	51.7	309	25.0	287	23.2	60	100.0	30	50.0	0	0.0	9	15.0	4	6.7	4	6.7	0	0.0	13	21.7	1235	100.0	948	76.8	924	74.8	863	69.9	12	1.0	1	0.1	40	3.2	0	0.0	1	0.1	7	0.6	24	1.9	21	1.7	0	0.0	0	0.0	0	0.0	0	0.0	2	0.2	1	0.1	287	23.2	274	22.2	255	20.6	14	1.1	0	0.0	4	0.3	1	0.1	0	0.0	0	0.0	13	1.1	8	0.6	0	0.0	0	0.0	0	0.0	0	0.0	4	0.3	1	0.1
1400000US25025110607	25025110607	Census Tract 1106.07, Suffolk County, Massachusetts	2227	100.0	2089	93.8	138	6.2	2089	100.0	1171	56.1	902	43.2	269	12.9	918	43.9	138	100.0	49	35.5	6	4.3	18	13.0	10	7.2	5	3.6	0	0.0	50	36.2	2089	100.0	1171	56.1	1134	54.3	1075	51.5	22	1.1	1	0.0	27	1.3	0	0.0	6	0.3	3	0.1	37	1.8	25	1.2	1	0.0	0	0.0	1	0.0	0	0.0	9	0.4	1	0.0	918	43.9	805	38.5	684	32.7	83	4.0	2	0.1	12	0.6	0	0.0	4	0.2	20	1.0	113	5.4	53	2.5	11	0.5	2	0.1	1	0.0	0	0.0	35	1.7	11	0.5
1400000US25025120103	25025120103	Census Tract 1201.03, Suffolk County, Massachusetts	696	100.0	660	94.8	36	5.2	660	100.0	447	67.7	337	51.1	110	16.7	213	32.3	36	100.0	20	55.6	0	0.0	5	13.9	2	5.6	4	11.1	1	2.8	4	11.1	660	100.0	447	67.7	432	65.5	387	58.6	20	3.0	0	0.0	17	2.6	0	0.0	2	0.3	6	0.9	15	2.3	12	1.8	0	0.0	0	0.0	0	0.0	0	0.0	1	0.2	2	0.3	213	32.3	202	30.6	177	26.8	11	1.7	1	0.2	4	0.6	0	0.0	1	0.2	8	1.2	11	1.7	9	1.4	0	0.0	0	0.0	0	0.0	0	0.0	1	0.2	1	0.2
1400000US25025120104	25025120104	Census Tract 1201.04, Suffolk County, Massachusetts	1060	100.0	1000	94.3	60	5.7	1000	100.0	459	45.9	374	37.4	85	8.5	541	54.1	60	100.0	21	35.0	0	0.0	6	10.0	3	5.0	3	5.0	0	0.0	27	45.0	1000	100.0	459	45.9	429	42.9	382	38.2	14	1.4	0	0.0	28	2.8	0	0.0	1	0.1	4	0.4	30	3.0	21	2.1	3	0.3	0	0.0	0	0.0	0	0.0	4	0.4	2	0.2	541	54.1	433	43.3	344	34.4	50	5.0	0	0.0	22	2.2	0	0.0	4	0.4	13	1.3	108	10.8	49	4.9	10	1.0	1	0.1	0	0.0	0	0.0	39	3.9	9	0.9
1400000US25025120105	25025120105	Census Tract 1201.05, Suffolk County, Massachusetts	953	100.0	898	94.2	55	5.8	898	100.0	811	90.3	524	58.4	287	32.0	87	9.7	55	100.0	4	7.3	2	3.6	11	20.0	7	12.7	14	25.5	0	0.0	17	30.9	898	100.0	811	90.3	784	87.3	716	79.7	28	3.1	0	0.0	30	3.3	0	0.0	0	0.0	10	1.1	27	3.0	15	1.7	1	0.1	1	0.1	1	0.1	0	0.0	4	0.4	5	0.6	87	9.7	82	9.1	71	7.9	3	0.3	0	0.0	5	0.6	0	0.0	1	0.1	2	0.2	5	0.6	2	0.2	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	2	0.2
1400000US25025120201	25025120201	Census Tract 1202.01, Suffolk County, Massachusetts	1726	100.0	1659	96.1	67	3.9	1659	100.0	573	34.5	512	30.9	61	3.7	1086	65.5	67	100.0	32	47.8	1	1.5	11	16.4	4	6.0	0	0.0	0	0.0	19	28.4	1659	100.0	573	34.5	524	31.6	436	26.3	50	3.0	2	0.1	25	1.5	0	0.0	2	0.1	9	0.5	49	3.0	30	1.8	3	0.2	1	0.1	0	0.0	0	0.0	13	0.8	2	0.1	1086	65.5	814	49.1	540	32.5	205	12.4	2	0.1	33	2.0	0	0.0	9	0.5	25	1.5	272	16.4	85	5.1	30	1.8	4	0.2	0	0.0	0	0.0	130	7.8	23	1.4
1400000US25025120301	25025120301	Census Tract 1203.01, Suffolk County, Massachusetts	1895	100.0	1784	94.1	111	5.9	1784	100.0	772	43.3	672	37.7	100	5.6	1012	56.7	111	100.0	46	41.4	0	0.0	8	7.2	2	1.8	2	1.8	0	0.0	53	47.7	1784	100.0	772	43.3	626	35.1	461	25.8	126	7.1	0	0.0	29	1.6	0	0.0	1	0.1	9	0.5	146	8.2	58	3.3	15	0.8	3	0.2	1	0.1	0	0.0	52	2.9	17	1.0	1012	56.7	604	33.9	398	22.3	159	8.9	2	0.1	24	1.3	0	0.0	3	0.2	18	1.0	408	22.9	137	7.7	37	2.1	12	0.7	1	0.1	0	0.0	186	10.4	35	2.0
1400000US25025120400	25025120400	Census Tract 1204, Suffolk County, Massachusetts	2825	100.0	2710	95.9	115	4.1	2710	100.0	1330	49.1	1093	40.3	237	8.7	1380	50.9	115	100.0	33	28.7	11	9.6	28	24.3	1	0.9	5	4.3	0	0.0	37	32.2	2710	100.0	1330	49.1	1275	47.0	1133	41.8	55	2.0	2	0.1	60	2.2	0	0.0	3	0.1	22	0.8	55	2.0	40	1.5	2	0.1	0	0.0	1	0.0	0	0.0	8	0.3	4	0.1	1380	50.9	1201	44.3	961	35.5	146	5.4	4	0.1	46	1.7	0	0.0	6	0.2	38	1.4	179	6.6	85	3.1	19	0.7	3	0.1	0	0.0	0	0.0	62	2.3	10	0.4
1400000US25025120500	25025120500	Census Tract 1205, Suffolk County, Massachusetts	905	100.0	852	94.1	53	5.9	852	100.0	273	32.0	242	28.4	31	3.6	579	68.0	53	100.0	30	56.6	0	0.0	6	11.3	1	1.9	0	0.0	0	0.0	16	30.2	852	100.0	273	32.0	187	21.9	147	17.3	21	2.5	2	0.2	11	1.3	0	0.0	1	0.1	5	0.6	86	10.1	40	4.7	6	0.7	2	0.2	0	0.0	0	0.0	29	3.4	9	1.1	579	68.0	278	32.6	190	22.3	59	6.9	1	0.1	14	1.6	0	0.0	3	0.4	11	1.3	301	35.3	98	11.5	27	3.2	12	1.4	0	0.0	0	0.0	130	15.3	34	4.0
1400000US25025120600	25025120600	Census Tract 1206, Suffolk County, Massachusetts	1103	100.0	1054	95.6	49	4.4	1054	100.0	457	43.4	379	36.0	78	7.4	597	56.6	49	100.0	20	40.8	0	0.0	9	18.4	2	4.1	3	6.1	0	0.0	15	30.6	1054	100.0	457	43.4	413	39.2	362	34.3	21	2.0	0	0.0	19	1.8	0	0.0	1	0.1	10	0.9	44	4.2	22	2.1	0	0.0	2	0.2	1	0.1	0	0.0	14	1.3	5	0.5	597	56.6	531	50.4	472	44.8	20	1.9	0	0.0	19	1.8	1	0.1	4	0.4	15	1.4	66	6.3	36	3.4	1	0.1	1	0.1	0	0.0	0	0.0	20	1.9	8	0.8
1400000US25025120700	25025120700	Census Tract 1207, Suffolk County, Massachusetts	1044	100.0	983	94.2	61	5.8	983	100.0	499	50.8	401	40.8	98	10.0	484	49.2	61	100.0	31	50.8	0	0.0	6	9.8	0	0.0	3	4.9	0	0.0	21	34.4	983	100.0	499	50.8	462	47.0	396	40.3	31	3.2	0	0.0	27	2.7	0	0.0	1	0.1	7	0.7	37	3.8	18	1.8	3	0.3	0	0.0	0	0.0	0	0.0	13	1.3	3	0.3	484	49.2	391	39.8	301	30.6	38	3.9	0	0.0	45	4.6	0	0.0	0	0.0	7	0.7	93	9.5	35	3.6	8	0.8	1	0.1	0	0.0	0	0.0	35	3.6	14	1.4
1400000US25025130100	25025130100	Census Tract 1301, Suffolk County, Massachusetts	2816	100.0	2668	94.7	148	5.3	2668	100.0	1941	72.8	1407	52.7	534	20.0	727	27.2	148	100.0	62	41.9	5	3.4	19	12.8	9	6.1	16	10.8	0	0.0	37	25.0	2668	100.0	1941	72.8	1876	70.3	1739	65.2	28	1.0	0	0.0	91	3.4	0	0.0	1	0.0	17	0.6	65	2.4	43	1.6	2	0.1	1	0.0	0	0.0	0	0.0	16	0.6	3	0.1	727	27.2	692	25.9	517	19.4	46	1.7	1	0.0	108	4.0	0	0.0	8	0.3	12	0.4	35	1.3	18	0.7	1	0.0	0	0.0	0	0.0	0	0.0	14	0.5	2	0.1
1400000US25025130200	25025130200	Census Tract 1302, Suffolk County, Massachusetts	1914	100.0	1829	95.6	85	4.4	1829	100.0	1303	71.2	918	50.2	385	21.0	526	28.8	85	100.0	29	34.1	3	3.5	11	12.9	4	4.7	11	12.9	0	0.0	27	31.8	1829	100.0	1303	71.2	1285	70.3	1224	66.9	8	0.4	1	0.1	48	2.6	0	0.0	0	0.0	4	0.2	18	1.0	18	1.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	526	28.8	490	26.8	435	23.8	30	1.6	2	0.1	16	0.9	0	0.0	3	0.2	4	0.2	36	2.0	23	1.3	3	0.2	1	0.1	0	0.0	0	0.0	4	0.2	5	0.3
1400000US25025130300	25025130300	Census Tract 1303, Suffolk County, Massachusetts	1811	100.0	1756	97.0	55	3.0	1756	100.0	1349	76.8	973	55.4	376	21.4	407	23.2	55	100.0	16	29.1	2	3.6	6	10.9	2	3.6	8	14.5	0	0.0	21	38.2	1756	100.0	1349	76.8	1325	75.5	1238	70.5	23	1.3	1	0.1	53	3.0	1	0.1	2	0.1	7	0.4	24	1.4	19	1.1	1	0.1	0	0.0	0	0.0	0	0.0	4	0.2	0	0.0	407	23.2	364	20.7	310	17.7	27	1.5	1	0.1	15	0.9	0	0.0	1	0.1	10	0.6	43	2.4	16	0.9	8	0.5	0	0.0	1	0.1	0	0.0	15	0.9	3	0.2
1400000US25025130402	25025130402	Census Tract 1304.02, Suffolk County, Massachusetts	2196	100.0	2102	95.7	94	4.3	2102	100.0	1400	66.6	937	44.6	463	22.0	702	33.4	94	100.0	36	38.3	3	3.2	9	9.6	3	3.2	4	4.3	0	0.0	39	41.5	2102	100.0	1400	66.6	1358	64.6	1237	58.8	28	1.3	1	0.0	80	3.8	1	0.0	1	0.0	10	0.5	42	2.0	26	1.2	5	0.2	0	0.0	0	0.0	0	0.0	8	0.4	3	0.1	702	33.4	636	30.3	542	25.8	47	2.2	1	0.0	34	1.6	0	0.0	6	0.3	6	0.3	66	3.1	33	1.6	3	0.1	0	0.0	0	0.0	1	0.0	23	1.1	6	0.3
1400000US25025130404	25025130404	Census Tract 1304.04, Suffolk County, Massachusetts	1322	100.0	1258	95.2	64	4.8	1258	100.0	740	58.8	564	44.8	176	14.0	518	41.2	64	100.0	36	56.3	2	3.1	6	9.4	1	1.6	3	4.7	0	0.0	16	25.0	1258	100.0	740	58.8	704	56.0	619	49.2	18	1.4	0	0.0	56	4.5	0	0.0	3	0.2	8	0.6	36	2.9	22	1.7	2	0.2	0	0.0	1	0.1	0	0.0	10	0.8	1	0.1	518	41.2	435	34.6	339	26.9	72	5.7	0	0.0	13	1.0	0	0.0	2	0.2	9	0.7	83	6.6	34	2.7	6	0.5	1	0.1	0	0.0	0	0.0	38	3.0	4	0.3
1400000US25025130406	25025130406	Census Tract 1304.06, Suffolk County, Massachusetts	2192	100.0	2112	96.4	80	3.6	2112	100.0	556	26.3	390	18.5	166	7.9	1556	73.7	80	100.0	58	72.5	1	1.3	12	15.0	1	1.3	1	1.3	0	0.0	7	8.8	2112	100.0	556	26.3	524	24.8	439	20.8	27	1.3	0	0.0	52	2.5	0	0.0	1	0.0	5	0.2	32	1.5	16	0.8	2	0.1	1	0.0	0	0.0	0	0.0	11	0.5	2	0.1	1556	73.7	1208	57.2	417	19.7	723	34.2	3	0.1	34	1.6	0	0.0	8	0.4	23	1.1	348	16.5	98	4.6	58	2.7	1	0.0	0	0.0	0	0.0	163	7.7	28	1.3
1400000US25025140102	25025140102	Census Tract 1401.02, Suffolk County, Massachusetts	1654	100.0	1548	93.6	106	6.4	1548	100.0	1049	67.8	834	53.9	215	13.9	499	32.2	106	100.0	31	29.2	2	1.9	13	12.3	5	4.7	3	2.8	0	0.0	52	49.1	1548	100.0	1049	67.8	935	60.4	582	37.6	312	20.2	2	0.1	21	1.4	0	0.0	6	0.4	12	0.8	114	7.4	44	2.8	19	1.2	1	0.1	1	0.1	0	0.0	42	2.7	7	0.5	499	32.2	401	25.9	192	12.4	186	12.0	1	0.1	5	0.3	0	0.0	5	0.3	12	0.8	98	6.3	20	1.3	10	0.6	0	0.0	0	0.0	1	0.1	53	3.4	14	0.9
1400000US25025140105	25025140105	Census Tract 1401.05, Suffolk County, Massachusetts	1324	100.0	1274	96.2	50	3.8	1274	100.0	898	70.5	692	54.3	206	16.2	376	29.5	50	100.0	16	32.0	0	0.0	5	10.0	2	4.0	1	2.0	0	0.0	26	52.0	1274	100.0	898	70.5	746	58.6	504	39.6	202	15.9	1	0.1	16	1.3	1	0.1	3	0.2	19	1.5	152	11.9	70	5.5	12	0.9	0	0.0	1	0.1	0	0.0	57	4.5	12	0.9	376	29.5	262	20.6	97	7.6	151	11.9	0	0.0	1	0.1	0	0.0	7	0.5	6	0.5	114	8.9	36	2.8	14	1.1	1	0.1	1	0.1	0	0.0	56	4.4	6	0.5
1400000US25025140106	25025140106	Census Tract 1401.06, Suffolk County, Massachusetts	898	100.0	791	88.1	107	11.9	791	100.0	70	8.8	55	7.0	15	1.9	721	91.2	107	100.0	50	46.7	1	0.9	3	2.8	0	0.0	0	0.0	0	0.0	53	49.5	791	100.0	70	8.8	61	7.7	45	5.7	10	1.3	0	0.0	3	0.4	0	0.0	1	0.1	2	0.3	9	1.1	4	0.5	2	0.3	0	0.0	0	0.0	0	0.0	3	0.4	0	0.0	721	91.2	529	66.9	126	15.9	373	47.2	3	0.4	14	1.8	0	0.0	3	0.4	10	1.3	192	24.3	62	7.8	19	2.4	3	0.4	0	0.0	0	0.0	85	10.7	23	2.9
1400000US25025140107	25025140107	Census Tract 1401.07, Suffolk County, Massachusetts	1051	100.0	977	93.0	74	7.0	977	100.0	563	57.6	446	45.6	117	12.0	414	42.4	74	100.0	37	50.0	1	1.4	8	10.8	1	1.4	2	2.7	0	0.0	25	33.8	977	100.0	563	57.6	476	48.7	297	30.4	156	16.0	2	0.2	10	1.0	0	0.0	1	0.1	10	1.0	87	8.9	48	4.9	5	0.5	1	0.1	0	0.0	0	0.0	24	2.5	9	0.9	414	42.4	293	30.0	152	15.6	131	13.4	2	0.2	2	0.2	0	0.0	0	0.0	6	0.6	121	12.4	37	3.8	16	1.6	1	0.1	1	0.1	0	0.0	51	5.2	15	1.5
1400000US25025140201	25025140201	Census Tract 1402.01, Suffolk County, Massachusetts	935	100.0	861	92.1	74	7.9	861	100.0	336	39.0	271	31.5	65	7.5	525	61.0	74	100.0	53	71.6	2	2.7	5	6.8	0	0.0	0	0.0	0	0.0	14	18.9	861	100.0	336	39.0	291	33.8	204	23.7	72	8.4	1	0.1	9	1.0	0	0.0	0	0.0	5	0.6	45	5.2	22	2.6	3	0.3	1	0.1	0	0.0	0	0.0	12	1.4	7	0.8	525	61.0	454	52.7	270	31.4	150	17.4	2	0.2	8	0.9	0	0.0	14	1.6	10	1.2	71	8.2	13	1.5	9	1.0	1	0.1	0	0.0	0	0.0	41	4.8	7	0.8
1400000US25025140202	25025140202	Census Tract 1402.02, Suffolk County, Massachusetts	2081	100.0	1952	93.8	129	6.2	1952	100.0	1228	62.9	969	49.6	259	13.3	724	37.1	129	100.0	67	51.9	2	1.6	12	9.3	3	2.3	7	5.4	0	0.0	38	29.5	1952	100.0	1228	62.9	1094	56.0	744	38.1	312	16.0	0	0.0	19	1.0	0	0.0	7	0.4	12	0.6	134	6.9	55	2.8	17	0.9	2	0.1	1	0.1	2	0.1	48	2.5	9	0.5	724	37.1	547	28.0	282	14.4	230	11.8	4	0.2	10	0.5	1	0.1	4	0.2	16	0.8	177	9.1	41	2.1	25	1.3	5	0.3	0	0.0	0	0.0	85	4.4	21	1.1
1400000US25025140300	25025140300	Census Tract 1403, Suffolk County, Massachusetts	2525	100.0	2353	93.2	172	6.8	2353	100.0	1016	43.2	880	37.4	136	5.8	1337	56.8	172	100.0	87	50.6	8	4.7	19	11.0	9	5.2	4	2.3	0	0.0	45	26.2	2353	100.0	1016	43.2	854	36.3	303	12.9	511	21.7	3	0.1	16	0.7	0	0.0	5	0.2	16	0.7	162	6.9	61	2.6	28	1.2	2	0.1	0	0.0	0	0.0	61	2.6	10	0.4	1337	56.8	1036	44.0	317	13.5	681	28.9	4	0.2	9	0.4	0	0.0	6	0.3	19	0.8	301	12.8	96	4.1	37	1.6	1	0.0	0	0.0	1	0.0	137	5.8	29	1.2
1400000US25025140400	25025140400	Census Tract 1404, Suffolk County, Massachusetts	2906	100.0	2743	94.4	163	5.6	2743	100.0	1689	61.6	1422	51.8	267	9.7	1054	38.4	163	100.0	76	46.6	5	3.1	19	11.7	13	8.0	8	4.9	0	0.0	42	25.8	2743	100.0	1689	61.6	1499	54.6	272	9.9	1160	42.3	7	0.3	19	0.7	0	0.0	9	0.3	32	1.2	190	6.9	66	2.4	37	1.3	3	0.1	0	0.0	0	0.0	61	2.2	23	0.8	1054	38.4	861	31.4	77	2.8	739	26.9	6	0.2	10	0.4	2	0.1	4	0.1	23	0.8	193	7.0	45	1.6	43	1.6	8	0.3	1	0.0	0	0.0	83	3.0	13	0.5
1400000US25025160101	25025160101	Census Tract 1601.01, Suffolk County, Massachusetts	2159	100.0	2014	93.3	145	6.7	2014	100.0	580	28.8	487	24.2	93	4.6	1434	71.2	145	100.0	77	53.1	6	4.1	9	6.2	1	0.7	3	2.1	0	0.0	49	33.8	2014	100.0	580	28.8	299	14.8	231	11.5	30	1.5	0	0.0	22	1.1	0	0.0	7	0.3	9	0.4	281	14.0	111	5.5	6	0.3	0	0.0	1	0.0	0	0.0	146	7.2	17	0.8	1434	71.2	377	18.7	230	11.4	94	4.7	3	0.1	22	1.1	0	0.0	18	0.9	10	0.5	1057	52.5	354	17.6	35	1.7	20	1.0	0	0.0	0	0.0	575	28.6	73	3.6
1400000US25025160200	25025160200	Census Tract 1602, Suffolk County, Massachusetts	1225	100.0	1181	96.4	44	3.6	1181	100.0	152	12.9	132	11.2	20	1.7	1029	87.1	44	100.0	39	88.6	0	0.0	4	9.1	0	0.0	0	0.0	0	0.0	1	2.3	1181	100.0	152	12.9	76	6.4	58	4.9	7	0.6	0	0.0	6	0.5	0	0.0	1	0.1	4	0.3	76	6.4	24	2.0	3	0.3	1	0.1	0	0.0	0	0.0	39	3.3	9	0.8	1029	87.1	225	19.1	126	10.7	68	5.8	0	0.0	15	1.3	0	0.0	6	0.5	10	0.8	804	68.1	202	17.1	15	1.3	7	0.6	0	0.0	1	0.1	531	45.0	48	4.1
1400000US25025160300	25025160300	Census Tract 1603, Suffolk County, Massachusetts	1279	100.0	1197	93.6	82	6.4	1197	100.0	489	40.9	414	34.6	75	6.3	708	59.1	82	100.0	36	43.9	1	1.2	22	26.8	0	0.0	10	12.2	0	0.0	13	15.9	1197	100.0	489	40.9	455	38.0	433	36.2	14	1.2	0	0.0	5	0.4	0	0.0	0	0.0	3	0.3	34	2.8	21	1.8	0	0.0	1	0.1	0	0.0	0	0.0	11	0.9	1	0.1	708	59.1	568	47.5	472	39.4	61	5.1	2	0.2	13	1.1	0	0.0	2	0.2	18	1.5	140	11.7	55	4.6	8	0.7	4	0.3	0	0.0	0	0.0	64	5.3	9	0.8
1400000US25025160400	25025160400	Census Tract 1604, Suffolk County, Massachusetts	1028	100.0	943	91.7	85	8.3	943	100.0	136	14.4	104	11.0	32	3.4	807	85.6	85	100.0	56	65.9	0	0.0	3	3.5	3	3.5	1	1.2	0	0.0	22	25.9	943	100.0	136	14.4	82	8.7	65	6.9	5	0.5	0	0.0	11	1.2	0	0.0	0	0.0	1	0.1	54	5.7	22	2.3	2	0.2	0	0.0	0	0.0	0	0.0	24	2.5	6	0.6	807	85.6	306	32.4	175	18.6	96	10.2	0	0.0	19	2.0	0	0.0	6	0.6	10	1.1	501	53.1	161	17.1	20	2.1	10	1.1	3	0.3	0	0.0	270	28.6	37	3.9
1400000US25025160501	25025160501	Census Tract 1605.01, Suffolk County, Massachusetts	1971	100.0	1867	94.7	104	5.3	1867	100.0	476	25.5	405	21.7	71	3.8	1391	74.5	104	100.0	54	51.9	2	1.9	6	5.8	3	2.9	1	1.0	0	0.0	38	36.5	1867	100.0	476	25.5	233	12.5	176	9.4	25	1.3	0	0.0	23	1.2	0	0.0	2	0.1	7	0.4	243	13.0	111	5.9	6	0.3	4	0.2	0	0.0	0	0.0	103	5.5	19	1.0	1391	74.5	523	28.0	338	18.1	117	6.3	4	0.2	27	1.4	0	0.0	9	0.5	28	1.5	868	46.5	343	18.4	29	1.6	16	0.9	0	0.0	0	0.0	421	22.5	59	3.2
1400000US25025160502	25025160502	Census Tract 1605.02, Suffolk County, Massachusetts	1589	100.0	1476	92.9	113	7.1	1476	100.0	497	33.7	403	27.3	94	6.4	979	66.3	113	100.0	43	38.1	4	3.5	28	24.8	4	3.5	4	3.5	0	0.0	30	26.5	1476	100.0	497	33.7	327	22.2	268	18.2	16	1.1	1	0.1	28	1.9	0	0.0	5	0.3	9	0.6	170	11.5	74	5.0	2	0.1	0	0.0	0	0.0	0	0.0	80	5.4	14	0.9	979	66.3	417	28.3	288	19.5	68	4.6	2	0.1	24	1.6	0	0.0	10	0.7	25	1.7	562	38.1	201	13.6	28	1.9	5	0.3	1	0.1	0	0.0	285	19.3	42	2.8
1400000US25025160601	25025160601	Census Tract 1606.01, Suffolk County, Massachusetts	1570	100.0	1470	93.6	100	6.4	1470	100.0	411	28.0	331	22.5	80	5.4	1059	72.0	100	100.0	57	57.0	1	1.0	14	14.0	0	0.0	6	6.0	0	0.0	22	22.0	1470	100.0	411	28.0	303	20.6	258	17.6	17	1.2	0	0.0	20	1.4	0	0.0	5	0.3	3	0.2	108	7.3	53	3.6	7	0.5	1	0.1	0	0.0	0	0.0	42	2.9	5	0.3	1059	72.0	630	42.9	430	29.3	107	7.3	3	0.2	46	3.1	0	0.0	25	1.7	19	1.3	429	29.2	189	12.9	25	1.7	6	0.4	1	0.1	1	0.1	180	12.2	27	1.8
1400000US25025160602	25025160602	Census Tract 1606.02, Suffolk County, Massachusetts	1800	100.0	1683	93.5	117	6.5	1683	100.0	652	38.7	476	28.3	176	10.5	1031	61.3	117	100.0	64	54.7	1	0.9	15	12.8	1	0.9	4	3.4	0	0.0	32	27.4	1683	100.0	652	38.7	506	30.1	424	25.2	32	1.9	1	0.1	38	2.3	0	0.0	4	0.2	7	0.4	146	8.7	59	3.5	3	0.2	1	0.1	1	0.1	0	0.0	65	3.9	17	1.0	1031	61.3	636	37.8	473	28.1	92	5.5	2	0.1	30	1.8	0	0.0	30	1.8	9	0.5	395	23.5	162	9.6	13	0.8	5	0.3	1	0.1	0	0.0	184	10.9	30	1.8
1400000US25025170100	25025170100	Census Tract 1701, Suffolk County, Massachusetts	3064	100.0	2852	93.1	212	6.9	2852	100.0	1573	55.2	1197	42.0	376	13.2	1279	44.8	212	100.0	55	25.9	5	2.4	33	15.6	10	4.7	14	6.6	0	0.0	95	44.8	2852	100.0	1573	55.2	1341	47.0	1211	42.5	41	1.4	0	0.0	53	1.9	1	0.0	16	0.6	19	0.7	232	8.1	111	3.9	9	0.3	3	0.1	0	0.0	0	0.0	98	3.4	11	0.4	1279	44.8	987	34.6	837	29.3	70	2.5	1	0.0	33	1.2	0	0.0	27	0.9	19	0.7	292	10.2	107	3.8	12	0.4	3	0.1	0	0.0	1	0.0	144	5.0	25	0.9
1400000US25025170200	25025170200	Census Tract 1702, Suffolk County, Massachusetts	1814	100.0	1728	95.3	86	4.7	1728	100.0	828	47.9	600	34.7	228	13.2	900	52.1	86	100.0	27	31.4	2	2.3	7	8.1	2	2.3	15	17.4	3	3.5	30	34.9	1728	100.0	828	47.9	738	42.7	681	39.4	13	0.8	0	0.0	29	1.7	0	0.0	7	0.4	8	0.5	90	5.2	46	2.7	1	0.1	1	0.1	0	0.0	0	0.0	38	2.2	4	0.2	900	52.1	759	43.9	671	38.8	37	2.1	2	0.1	28	1.6	0	0.0	11	0.6	10	0.6	141	8.2	59	3.4	2	0.1	1	0.1	0	0.0	0	0.0	70	4.1	9	0.5
1400000US25025170300	25025170300	Census Tract 1703, Suffolk County, Massachusetts	3816	100.0	3586	94.0	230	6.0	3586	100.0	1912	53.3	1325	36.9	587	16.4	1674	46.7	230	100.0	138	60.0	3	1.3	18	7.8	3	1.3	9	3.9	0	0.0	59	25.7	3586	100.0	1912	53.3	1764	49.2	1635	45.6	40	1.1	3	0.1	55	1.5	0	0.0	12	0.3	19	0.5	148	4.1	73	2.0	0	0.0	0	0.0	1	0.0	0	0.0	62	1.7	12	0.3	1674	46.7	1466	40.9	1126	31.4	150	4.2	3	0.1	116	3.2	1	0.0	37	1.0	33	0.9	208	5.8	111	3.1	7	0.2	2	0.1	2	0.1	0	0.0	73	2.0	13	0.4
1400000US25025170400	25025170400	Census Tract 1704, Suffolk County, Massachusetts	2332	100.0	2191	94.0	141	6.0	2191	100.0	970	44.3	714	32.6	256	11.7	1221	55.7	141	100.0	51	36.2	2	1.4	34	24.1	4	2.8	5	3.5	0	0.0	45	31.9	2191	100.0	970	44.3	830	37.9	758	34.6	30	1.4	1	0.0	26	1.2	0	0.0	5	0.2	10	0.5	140	6.4	70	3.2	2	0.1	1	0.0	0	0.0	0	0.0	58	2.6	9	0.4	1221	55.7	994	45.4	800	36.5	95	4.3	4	0.2	44	2.0	0	0.0	29	1.3	22	1.0	227	10.4	96	4.4	12	0.5	3	0.1	0	0.0	0	0.0	93	4.2	23	1.0
1400000US25025170501	25025170501	Census Tract 1705.01, Suffolk County, Massachusetts	1927	100.0	1634	84.8	293	15.2	1634	100.0	772	47.2	561	34.3	211	12.9	862	52.8	293	100.0	195	66.6	6	2.0	31	10.6	12	4.1	27	9.2	0	0.0	22	7.5	1634	100.0	772	47.2	697	42.7	626	38.3	21	1.3	0	0.0	33	2.0	0	0.0	6	0.4	11	0.7	75	4.6	43	2.6	2	0.1	1	0.1	0	0.0	0	0.0	23	1.4	6	0.4	862	52.8	681	41.7	572	35.0	41	2.5	1	0.1	40	2.4	0	0.0	11	0.7	16	1.0	181	11.1	105	6.4	4	0.2	2	0.1	3	0.2	0	0.0	51	3.1	16	1.0
1400000US25025170502	25025170502	Census Tract 1705.02, Suffolk County, Massachusetts	1548	100.0	1406	90.8	142	9.2	1406	100.0	790	56.2	550	39.1	240	17.1	616	43.8	142	100.0	51	35.9	0	0.0	18	12.7	2	1.4	31	21.8	0	0.0	40	28.2	1406	100.0	790	56.2	753	53.6	713	50.7	14	1.0	4	0.3	12	0.9	0	0.0	3	0.2	7	0.5	37	2.6	25	1.8	2	0.1	0	0.0	0	0.0	0	0.0	8	0.6	2	0.1	616	43.8	577	41.0	546	38.8	14	1.0	0	0.0	7	0.5	0	0.0	0	0.0	10	0.7	39	2.8	26	1.8	0	0.0	1	0.1	0	0.0	0	0.0	10	0.7	2	0.1
1400000US25025170601	25025170601	Census Tract 1706.01, Suffolk County, Massachusetts	2007	100.0	1875	93.4	132	6.6	1875	100.0	1030	54.9	729	38.9	301	16.1	845	45.1	132	100.0	56	42.4	3	2.3	13	9.8	2	1.5	7	5.3	0	0.0	51	38.6	1875	100.0	1030	54.9	881	47.0	825	44.0	18	1.0	1	0.1	25	1.3	0	0.0	8	0.4	4	0.2	149	7.9	58	3.1	1	0.1	1	0.1	0	0.0	0	0.0	76	4.1	13	0.7	845	45.1	621	33.1	553	29.5	21	1.1	2	0.1	18	1.0	0	0.0	14	0.7	13	0.7	224	11.9	97	5.2	7	0.4	0	0.0	0	0.0	0	0.0	105	5.6	15	0.8
1400000US25025170701	25025170701	Census Tract 1707.01, Suffolk County, Massachusetts	1053	100.0	963	91.5	90	8.5	963	100.0	379	39.4	286	29.7	93	9.7	584	60.6	90	100.0	47	52.2	1	1.1	16	17.8	1	1.1	9	10.0	0	0.0	16	17.8	963	100.0	379	39.4	310	32.2	277	28.8	11	1.1	0	0.0	16	1.7	0	0.0	3	0.3	3	0.3	69	7.2	44	4.6	4	0.4	0	0.0	0	0.0	0	0.0	20	2.1	1	0.1	584	60.6	491	51.0	438	45.5	24	2.5	1	0.1	12	1.2	0	0.0	4	0.4	12	1.2	93	9.7	54	5.6	2	0.2	1	0.1	0	0.0	0	0.0	32	3.3	4	0.4
1400000US25025170702	25025170702	Census Tract 1707.02, Suffolk County, Massachusetts	2319	100.0	2144	92.5	175	7.5	2144	100.0	638	29.8	506	23.6	132	6.2	1506	70.2	175	100.0	107	61.1	3	1.7	10	5.7	0	0.0	6	3.4	0	0.0	49	28.0	2144	100.0	638	29.8	470	21.9	355	16.6	26	1.2	0	0.0	74	3.5	0	0.0	5	0.2	10	0.5	168	7.8	87	4.1	3	0.1	0	0.0	0	0.0	0	0.0	70	3.3	8	0.4	1506	70.2	938	43.8	599	27.9	100	4.7	4	0.2	172	8.0	0	0.0	40	1.9	23	1.1	568	26.5	266	12.4	6	0.3	3	0.1	1	0.0	0	0.0	250	11.7	42	2.0
1400000US25025170800	25025170800	Census Tract 1708, Suffolk County, Massachusetts	2217	100.0	2072	93.5	145	6.5	2072	100.0	835	40.3	621	30.0	214	10.3	1237	59.7	145	100.0	54	37.2	4	2.8	17	11.7	3	2.1	21	14.5	0	0.0	46	31.7	2072	100.0	835	40.3	735	35.5	672	32.4	32	1.5	1	0.0	18	0.9	0	0.0	6	0.3	6	0.3	100	4.8	51	2.5	1	0.0	4	0.2	0	0.0	0	0.0	34	1.6	10	0.5	1237	59.7	963	46.5	851	41.1	56	2.7	2	0.1	16	0.8	0	0.0	11	0.5	27	1.3	274	13.2	130	6.3	6	0.3	4	0.2	0	0.0	0	0.0	117	5.6	17	0.8
1400000US25025180101	25025180101	Census Tract 1801.01, Suffolk County, Massachusetts	2502	100.0	2347	93.8	155	6.2	2347	100.0	1142	48.7	832	35.4	310	13.2	1205	51.3	155	100.0	65	41.9	8	5.2	26	16.8	7	4.5	23	14.8	0	0.0	26	16.8	2347	100.0	1142	48.7	1110	47.3	1063	45.3	21	0.9	0	0.0	8	0.3	0	0.0	6	0.3	12	0.5	32	1.4	18	0.8	0	0.0	0	0.0	1	0.0	0	0.0	10	0.4	3	0.1	1205	51.3	1145	48.8	1087	46.3	27	1.2	2	0.1	10	0.4	0	0.0	6	0.3	13	0.6	60	2.6	30	1.3	3	0.1	0	0.0	0	0.0	0	0.0	22	0.9	5	0.2
1400000US25025180200	25025180200	Census Tract 1802, Suffolk County, Massachusetts	1794	100.0	1683	93.8	111	6.2	1683	100.0	966	57.4	725	43.1	241	14.3	717	42.6	111	100.0	37	33.3	3	2.7	18	16.2	8	7.2	11	9.9	0	0.0	34	30.6	1683	100.0	966	57.4	941	55.9	917	54.5	8	0.5	0	0.0	10	0.6	0	0.0	2	0.1	4	0.2	25	1.5	17	1.0	0	0.0	0	0.0	0	0.0	0	0.0	6	0.4	2	0.1	717	42.6	670	39.8	635	37.7	12	0.7	1	0.1	5	0.3	0	0.0	6	0.4	11	0.7	47	2.8	25	1.5	1	0.1	1	0.1	0	0.0	0	0.0	17	1.0	3	0.2
1400000US25025180301	25025180301	Census Tract 1803.01, Suffolk County, Massachusetts	1228	100.0	1180	96.1	48	3.9	1180	100.0	850	72.0	647	54.8	203	17.2	330	28.0	48	100.0	16	33.3	1	2.1	8	16.7	2	4.2	3	6.3	0	0.0	18	37.5	1180	100.0	850	72.0	838	71.0	816	69.2	3	0.3	1	0.1	9	0.8	1	0.1	3	0.3	5	0.4	12	1.0	10	0.8	0	0.0	1	0.1	0	0.0	0	0.0	0	0.0	1	0.1	330	28.0	308	26.1	296	25.1	5	0.4	0	0.0	1	0.1	0	0.0	3	0.3	3	0.3	22	1.9	16	1.4	1	0.1	0	0.0	0	0.0	0	0.0	5	0.4	0	0.0
1400000US25025180400	25025180400	Census Tract 1804, Suffolk County, Massachusetts	782	100.0	742	94.9	40	5.1	742	100.0	418	56.3	312	42.0	106	14.3	324	43.7	40	100.0	19	47.5	4	10.0	5	12.5	2	5.0	1	2.5	0	0.0	9	22.5	742	100.0	418	56.3	412	55.5	403	54.3	4	0.5	0	0.0	1	0.1	0	0.0	1	0.1	3	0.4	6	0.8	5	0.7	0	0.0	0	0.0	0	0.0	0	0.0	1	0.1	0	0.0	324	43.7	303	40.8	280	37.7	8	1.1	1	0.1	3	0.4	0	0.0	5	0.7	6	0.8	21	2.8	11	1.5	0	0.0	0	0.0	0	0.0	0	0.0	6	0.8	4	0.5
1400000US25025180500	25025180500	Census Tract 1805, Suffolk County, Massachusetts	2014	100.0	1831	90.9	183	9.1	1831	100.0	931	50.8	731	39.9	200	10.9	900	49.2	183	100.0	67	36.6	13	7.1	18	9.8	12	6.6	29	15.8	0	0.0	44	24.0	1831	100.0	931	50.8	898	49.0	877	47.9	8	0.4	0	0.0	5	0.3	1	0.1	0	0.0	7	0.4	33	1.8	19	1.0	0	0.0	3	0.2	0	0.0	0	0.0	8	0.4	3	0.2	900	49.2	838	45.8	779	42.5	28	1.5	3	0.2	12	0.7	0	0.0	5	0.3	11	0.6	62	3.4	22	1.2	2	0.1	0	0.0	1	0.1	0	0.0	32	1.7	5	0.3
1400000US25025980101	25025980101	Census Tract 9801.01, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025980300	25025980300	Census Tract 9803, Suffolk County, Massachusetts	2	100.0	2	100.0	0	0.0	2	100.0	1	50.0	0	0.0	1	50.0	1	50.0	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	2	100.0	1	50.0	1	50.0	1	50.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	50.0	1	50.0	1	50.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025980700	25025980700	Census Tract 9807, Suffolk County, Massachusetts	5	100.0	4	80.0	1	20.0	4	100.0	3	75.0	1	25.0	2	50.0	1	25.0	1	100.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	100.0	4	100.0	3	75.0	3	75.0	2	50.0	0	0.0	0	0.0	0	0.0	1	25.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	25.0	1	25.0	1	25.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025981000	25025981000	Census Tract 9810, Suffolk County, Massachusetts	5	100.0	5	100.0	0	0.0	5	100.0	0	0.0	0	0.0	0	0.0	5	100.0	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	5	100.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	5	100.0	5	100.0	2	40.0	2	40.0	0	0.0	0	0.0	0	0.0	0	0.0	1	20.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025981100	25025981100	Census Tract 9811, Suffolk County, Massachusetts	136	100.0	85	62.5	51	37.5	85	100.0	15	17.6	14	16.5	1	1.2	70	82.4	51	100.0	13	25.5	1	2.0	33	64.7	2	3.9	0	0.0	0	0.0	2	3.9	85	100.0	15	17.6	15	17.6	3	3.5	9	10.6	0	0.0	2	2.4	0	0.0	0	0.0	1	1.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	70	82.4	60	70.6	5	5.9	50	58.8	0	0.0	2	2.4	0	0.0	1	1.2	2	2.4	10	11.8	3	3.5	6	7.1	0	0.0	0	0.0	0	0.0	1	1.2	0	0.0
1400000US25025981201	25025981201	Census Tract 9812.01, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025981202	25025981202	Census Tract 9812.02, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025981300	25025981300	Census Tract 9813, Suffolk County, Massachusetts	245	100.0	236	96.3	9	3.7	236	100.0	154	65.3	143	60.6	11	4.7	82	34.7	9	100.0	4	44.4	0	0.0	0	0.0	0	0.0	1	11.1	0	0.0	4	44.4	236	100.0	154	65.3	145	61.4	125	53.0	2	0.8	0	0.0	13	5.5	0	0.0	0	0.0	5	2.1	9	3.8	5	2.1	0	0.0	0	0.0	1	0.4	0	0.0	3	1.3	0	0.0	82	34.7	67	28.4	54	22.9	5	2.1	0	0.0	3	1.3	0	0.0	0	0.0	5	2.1	15	6.4	11	4.7	0	0.0	0	0.0	0	0.0	0	0.0	3	1.3	1	0.4
1400000US25025981501	25025981501	Census Tract 9815.01, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025981502	25025981502	Census Tract 9815.02, Suffolk County, Massachusetts	3	100.0	3	100.0	0	0.0	3	100.0	2	66.7	1	33.3	1	33.3	1	33.3	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	3	100.0	2	66.7	2	66.7	2	66.7	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	33.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	1	33.3	1	33.3	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025981600	25025981600	Census Tract 9816, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025981700	25025981700	Census Tract 9817, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
1400000US25025981800	25025981800	Census Tract 9818, Suffolk County, Massachusetts	49	100.0	46	93.9	3	6.1	46	100.0	39	84.8	28	60.9	11	23.9	7	15.2	3	100.0	0	0.0	0	0.0	0	0.0	0	0.0	1	33.3	0	0.0	2	66.7	46	100.0	39	84.8	38	82.6	35	76.1	1	2.2	0	0.0	2	4.3	0	0.0	0	0.0	0	0.0	1	2.2	1	2.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	7	15.2	7	15.2	6	13.0	1	2.2	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0	0	0.0
1400000US25025990101	25025990101	Census Tract 9901.01, Suffolk County, Massachusetts	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)	0	(X)
\.


--
-- TOC entry 1875 (class 0 OID 4499900)
-- Dependencies: 168
-- Data for Name: pop_import; Type: TABLE DATA; Schema: staging; Owner: postgres
--

COPY pop_import (geo_id, geo_id2, geo_display, d001, d002, d003, d004, d005, d006, d007, d008, d009, d010, d011, d012, d013, d014, d015, d016, d017) FROM stdin;
\N	\N	\N	D001	D002	D003	D004	D005	D006	D007	D008	D009	D010	D011	D012	D013	D014	D015	D016	D017
\N	\N	\N	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:	Total:
GEO.id	GEO.id2	GEO.display-label	\N	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Not Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:	Hispanic or Latino:
Id	Id2	Geography	\N	\N	White alone	Black or African American alone	American Indian and Alaska Native alone	Asian alone	Native Hawaiian and Other Pacific Islander alone	Some Other Race alone	Two or More Races	\N	White alone	Black or African American alone	American Indian and Alaska Native alone	Asian alone	Native Hawaiian and Other Pacific Islander alone	Some Other Race alone	Two or More Races
1400000US25001010100	25001010100	Census Tract 101, Barnstable County, Massachusetts	2942	2800	2603	114	11	18	0	9	45	142	88	4	7	0	1	37	5
1400000US25001010206	25001010206	Census Tract 102.06, Barnstable County, Massachusetts	2750	2709	2635	22	7	13	0	7	25	41	31	0	0	0	0	8	2
1400000US25001010208	25001010208	Census Tract 102.08, Barnstable County, Massachusetts	2003	1962	1883	38	3	10	0	4	24	41	28	1	1	0	0	5	6
1400000US25001010304	25001010304	Census Tract 103.04, Barnstable County, Massachusetts	2421	2381	2316	17	6	16	0	5	21	40	35	0	0	1	0	1	3
1400000US25001010306	25001010306	Census Tract 103.06, Barnstable County, Massachusetts	2535	2500	2434	17	6	12	0	2	29	35	25	0	0	0	3	4	3
1400000US25001010400	25001010400	Census Tract 104, Barnstable County, Massachusetts	2999	2938	2821	37	4	26	0	12	38	61	41	2	1	1	0	10	6
1400000US25001010500	25001010500	Census Tract 105, Barnstable County, Massachusetts	2891	2871	2809	13	2	18	1	6	22	20	17	1	0	0	0	2	0
1400000US25001010600	25001010600	Census Tract 106, Barnstable County, Massachusetts	2973	2923	2812	49	8	15	0	10	29	50	29	5	0	0	0	10	6
1400000US25001010700	25001010700	Census Tract 107, Barnstable County, Massachusetts	3152	3094	2999	32	7	21	0	6	29	58	45	0	1	0	0	12	0
1400000US25001010800	25001010800	Census Tract 108, Barnstable County, Massachusetts	4878	4809	4680	20	9	44	0	6	50	69	46	3	0	2	0	14	4
1400000US25001010900	25001010900	Census Tract 109, Barnstable County, Massachusetts	4942	4845	4690	47	4	42	0	23	39	97	80	1	2	0	2	7	5
1400000US25001011002	25001011002	Census Tract 110.02, Barnstable County, Massachusetts	4157	4088	3778	88	20	14	2	110	76	69	31	0	5	3	0	27	3
1400000US25001011100	25001011100	Census Tract 111, Barnstable County, Massachusetts	4694	4620	4368	62	10	45	0	31	104	74	43	1	6	0	0	18	6
1400000US25001011200	25001011200	Census Tract 112, Barnstable County, Massachusetts	3392	3357	3201	38	7	21	0	48	42	35	23	4	4	0	0	3	1
1400000US25001011300	25001011300	Census Tract 113, Barnstable County, Massachusetts	2600	2561	2493	18	8	8	6	12	16	39	25	1	0	0	2	4	7
1400000US25001011400	25001011400	Census Tract 114, Barnstable County, Massachusetts	2991	2914	2825	32	6	9	0	4	38	77	42	6	1	0	1	17	10
1400000US25001011500	25001011500	Census Tract 115, Barnstable County, Massachusetts	4029	3943	3701	88	13	29	2	43	67	86	43	10	9	0	0	12	12
1400000US25001011600	25001011600	Census Tract 116, Barnstable County, Massachusetts	2710	2642	2355	121	17	11	0	52	86	68	36	5	3	0	0	16	8
1400000US25001011700	25001011700	Census Tract 117, Barnstable County, Massachusetts	1877	1841	1743	20	12	24	1	20	21	36	26	1	0	0	0	4	5
1400000US25001011801	25001011801	Census Tract 118.01, Barnstable County, Massachusetts	2403	2384	2339	8	7	17	1	2	10	19	19	0	0	0	0	0	0
1400000US25001011802	25001011802	Census Tract 118.02, Barnstable County, Massachusetts	4255	4198	4034	36	7	39	0	26	56	57	32	2	2	0	0	15	6
1400000US25001012001	25001012001	Census Tract 120.01, Barnstable County, Massachusetts	5732	5609	5305	119	10	54	0	51	70	123	66	12	0	0	0	32	13
1400000US25001012002	25001012002	Census Tract 120.02, Barnstable County, Massachusetts	3007	2886	2611	78	7	73	0	43	74	121	65	7	7	2	0	22	18
1400000US25001012101	25001012101	Census Tract 121.01, Barnstable County, Massachusetts	5339	5152	4713	134	24	42	1	102	136	187	77	10	1	1	0	69	29
1400000US25001012102	25001012102	Census Tract 121.02, Barnstable County, Massachusetts	3057	2943	2696	73	4	33	1	57	79	114	74	7	3	1	0	19	10
1400000US25001012200	25001012200	Census Tract 122, Barnstable County, Massachusetts	5046	5003	4829	38	9	54	1	10	62	43	23	0	1	0	2	10	7
1400000US25001012502	25001012502	Census Tract 125.02, Barnstable County, Massachusetts	3080	2946	2547	119	24	48	1	117	90	134	82	8	0	1	0	35	8
1400000US25001012601	25001012601	Census Tract 126.01, Barnstable County, Massachusetts	2877	2729	2340	116	16	78	7	67	105	148	104	8	4	1	1	27	3
1400000US25001012602	25001012602	Census Tract 126.02, Barnstable County, Massachusetts	4915	4505	3409	407	72	76	0	214	327	410	236	14	10	0	1	120	29
1400000US25001012700	25001012700	Census Tract 127, Barnstable County, Massachusetts	4562	4449	4111	86	22	53	0	88	89	113	77	5	3	0	1	23	4
1400000US25001012800	25001012800	Census Tract 128, Barnstable County, Massachusetts	3923	3851	3638	59	0	36	1	44	73	72	45	3	1	0	0	9	14
1400000US25001012900	25001012900	Census Tract 129, Barnstable County, Massachusetts	4135	4063	3804	61	11	45	5	70	67	72	38	2	2	0	0	19	11
1400000US25001013002	25001013002	Census Tract 130.02, Barnstable County, Massachusetts	2899	2863	2738	23	4	19	0	26	53	36	22	2	0	0	0	5	7
1400000US25001013100	25001013100	Census Tract 131, Barnstable County, Massachusetts	5935	5819	5529	65	33	49	1	29	113	116	82	6	3	0	0	15	10
1400000US25001013200	25001013200	Census Tract 132, Barnstable County, Massachusetts	4783	4695	4513	51	20	25	0	23	63	88	56	6	1	0	0	10	15
1400000US25001013300	25001013300	Census Tract 133, Barnstable County, Massachusetts	3218	3190	3107	10	1	42	4	10	16	28	20	2	0	0	0	6	0
1400000US25001013400	25001013400	Census Tract 134, Barnstable County, Massachusetts	4163	4119	4051	9	3	28	0	4	24	44	27	0	1	0	0	1	15
1400000US25001013500	25001013500	Census Tract 135, Barnstable County, Massachusetts	6940	6859	6645	19	13	99	0	12	71	81	51	2	5	1	0	13	9
1400000US25001013600	25001013600	Census Tract 136, Barnstable County, Massachusetts	6334	6214	5997	32	27	75	1	8	74	120	81	4	1	1	0	23	10
1400000US25001013700	25001013700	Census Tract 137, Barnstable County, Massachusetts	4911	4831	4569	46	29	45	1	35	106	80	49	0	1	0	0	20	10
1400000US25001013800	25001013800	Census Tract 138, Barnstable County, Massachusetts	4840	4745	4475	52	22	78	0	24	94	95	53	3	1	1	2	24	11
1400000US25001013900	25001013900	Census Tract 139, Barnstable County, Massachusetts	4831	4791	4533	36	25	64	4	31	98	40	22	3	4	0	0	3	8
1400000US25001014002	25001014002	Census Tract 140.02, Barnstable County, Massachusetts	4053	4005	3795	60	13	34	1	31	71	48	33	4	1	0	0	4	6
1400000US25001014100	25001014100	Census Tract 141, Barnstable County, Massachusetts	1141	1047	908	93	9	11	0	5	21	94	50	3	1	1	0	31	8
1400000US25001014300	25001014300	Census Tract 143, Barnstable County, Massachusetts	4384	4334	4166	38	12	41	1	24	52	50	38	1	1	0	0	6	4
1400000US25001014402	25001014402	Census Tract 144.02, Barnstable County, Massachusetts	6947	6824	6287	139	33	82	7	93	183	123	85	2	2	0	0	22	12
1400000US25001014500	25001014500	Census Tract 145, Barnstable County, Massachusetts	5395	5256	4810	101	34	38	0	85	188	139	68	4	7	0	0	38	22
1400000US25001014600	25001014600	Census Tract 146, Barnstable County, Massachusetts	4130	4041	3636	115	31	57	3	61	138	89	53	6	5	0	0	7	18
1400000US25001014700	25001014700	Census Tract 147, Barnstable County, Massachusetts	3690	3628	3326	66	26	51	0	66	93	62	52	1	4	0	0	2	3
1400000US25001014800	25001014800	Census Tract 148, Barnstable County, Massachusetts	3387	3342	3059	70	21	59	0	63	70	45	29	2	1	2	0	6	5
1400000US25001014900	25001014900	Census Tract 149, Barnstable County, Massachusetts	3598	3541	3328	47	6	77	1	16	66	57	42	2	0	2	0	7	4
1400000US25001015001	25001015001	Census Tract 150.01, Barnstable County, Massachusetts	4417	4290	3795	80	181	42	6	52	134	127	84	2	10	2	0	14	15
1400000US25001015002	25001015002	Census Tract 150.02, Barnstable County, Massachusetts	3713	3632	3090	133	157	59	3	49	141	81	54	4	10	0	0	6	7
1400000US25001015100	25001015100	Census Tract 151, Barnstable County, Massachusetts	3809	3725	3420	77	56	52	0	27	93	84	46	2	7	0	0	22	7
1400000US25001015200	25001015200	Census Tract 152, Barnstable County, Massachusetts	2065	2042	1974	22	11	15	0	5	15	23	19	0	0	1	0	3	0
1400000US25001015300	25001015300	Census Tract 153, Barnstable County, Massachusetts	3038	2852	2054	266	44	77	2	204	205	186	79	21	0	0	4	52	30
1400000US25001990000	25001990000	Census Tract 9900, Barnstable County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25003900100	25003900100	Census Tract 9001, Berkshire County, Massachusetts	3389	3073	2543	306	10	68	0	16	130	316	125	19	7	0	0	130	35
1400000US25003900200	25003900200	Census Tract 9002, Berkshire County, Massachusetts	4449	3907	3285	322	17	69	0	20	194	542	276	33	2	0	1	169	61
1400000US25003900300	25003900300	Census Tract 9003, Berkshire County, Massachusetts	2903	2733	2509	100	3	40	1	6	74	170	79	9	0	0	2	66	14
1400000US25003900400	25003900400	Census Tract 9004, Berkshire County, Massachusetts	4862	4647	4263	216	2	31	0	12	123	215	102	17	1	0	0	76	19
1400000US25003900500	25003900500	Census Tract 9005, Berkshire County, Massachusetts	3288	3196	3056	62	0	45	1	6	26	92	70	7	0	0	0	8	7
1400000US25003900600	25003900600	Census Tract 9006, Berkshire County, Massachusetts	4117	3813	2912	592	15	52	1	29	212	304	125	43	2	0	0	92	42
1400000US25003900700	25003900700	Census Tract 9007, Berkshire County, Massachusetts	2910	2841	2731	58	1	14	0	0	37	69	43	0	0	0	0	19	7
1400000US25003900800	25003900800	Census Tract 9008, Berkshire County, Massachusetts	4835	4763	4582	45	2	63	0	8	63	72	35	0	0	0	0	26	11
1400000US25003900900	25003900900	Census Tract 9009, Berkshire County, Massachusetts	5134	4854	4477	170	16	42	0	12	137	280	129	15	1	0	0	124	11
1400000US25003901100	25003901100	Census Tract 9011, Berkshire County, Massachusetts	3729	3657	3386	141	5	74	0	1	50	72	42	5	0	0	0	22	3
1400000US25003911100	25003911100	Census Tract 9111, Berkshire County, Massachusetts	3091	3050	2963	39	1	20	1	1	25	41	32	4	0	0	0	4	1
1400000US25003912100	25003912100	Census Tract 9121, Berkshire County, Massachusetts	6756	6647	6469	48	4	53	1	4	68	109	69	1	0	0	0	33	6
1400000US25003913100	25003913100	Census Tract 9131, Berkshire County, Massachusetts	5025	4887	4671	55	4	69	2	17	69	138	95	3	3	0	0	29	8
1400000US25003914100	25003914100	Census Tract 9141, Berkshire County, Massachusetts	5943	5682	5453	57	10	100	0	23	39	261	156	4	1	0	1	75	24
1400000US25003920101	25003920101	Census Tract 9201.01, Berkshire County, Massachusetts	4638	4440	3933	128	4	241	1	7	126	198	124	8	2	0	3	38	23
1400000US25003920102	25003920102	Census Tract 9201.02, Berkshire County, Massachusetts	3116	2994	2654	84	2	157	0	9	88	122	71	4	0	2	0	23	22
1400000US25003921300	25003921300	Census Tract 9213, Berkshire County, Massachusetts	5118	4926	4598	142	15	40	6	6	119	192	102	18	2	1	0	53	16
1400000US25003921400	25003921400	Census Tract 9214, Berkshire County, Massachusetts	1699	1605	1530	28	4	3	2	0	38	94	45	5	0	0	0	28	16
1400000US25003921500	25003921500	Census Tract 9215, Berkshire County, Massachusetts	3100	3020	2862	45	8	29	0	4	72	80	38	0	0	2	0	33	7
1400000US25003922100	25003922100	Census Tract 9221, Berkshire County, Massachusetts	2680	2651	2579	12	0	18	1	1	40	29	20	2	0	1	0	1	5
1400000US25003922200	25003922200	Census Tract 9222, Berkshire County, Massachusetts	3689	3644	3542	27	8	14	0	4	49	45	26	1	7	0	0	10	1
1400000US25003922300	25003922300	Census Tract 9223, Berkshire County, Massachusetts	2116	2092	2045	12	0	8	1	0	26	24	14	2	0	1	0	3	4
1400000US25003923100	25003923100	Census Tract 9231, Berkshire County, Massachusetts	3235	3200	3139	14	5	12	0	1	29	35	28	1	0	0	0	6	0
1400000US25003924100	25003924100	Census Tract 9241, Berkshire County, Massachusetts	1947	1888	1826	18	1	19	0	8	16	59	50	0	0	0	0	8	1
1400000US25003925100	25003925100	Census Tract 9251, Berkshire County, Massachusetts	7104	6680	6200	177	12	124	1	24	142	424	249	12	13	0	0	104	46
1400000US25003926100	25003926100	Census Tract 9261, Berkshire County, Massachusetts	3257	3152	3070	34	5	11	0	2	30	105	51	2	2	0	0	39	11
1400000US25003931100	25003931100	Census Tract 9311, Berkshire County, Massachusetts	1702	1686	1668	3	0	2	0	0	13	16	14	0	0	0	0	0	2
1400000US25003931300	25003931300	Census Tract 9313, Berkshire County, Massachusetts	1444	1430	1370	18	6	7	0	0	29	14	9	1	0	1	0	0	3
1400000US25003931400	25003931400	Census Tract 9314, Berkshire County, Massachusetts	1746	1742	1690	14	4	8	0	1	25	4	3	0	1	0	0	0	0
1400000US25003932200	25003932200	Census Tract 9322, Berkshire County, Massachusetts	2317	2274	2225	12	4	8	0	4	21	43	27	0	1	0	0	15	0
1400000US25003932300	25003932300	Census Tract 9323, Berkshire County, Massachusetts	2032	2014	1976	8	1	7	0	0	22	18	11	0	3	0	0	4	0
1400000US25003933200	25003933200	Census Tract 9332, Berkshire County, Massachusetts	1288	1279	1256	17	0	4	0	0	2	9	4	0	1	0	0	4	0
1400000US25003933300	25003933300	Census Tract 9333, Berkshire County, Massachusetts	1509	1482	1439	18	1	12	0	0	12	27	18	4	0	0	0	5	0
1400000US25003933400	25003933400	Census Tract 9334, Berkshire County, Massachusetts	2527	2499	2434	10	4	16	2	3	30	28	21	0	1	0	0	4	2
1400000US25003934200	25003934200	Census Tract 9342, Berkshire County, Massachusetts	1306	1294	1250	14	0	18	0	1	11	12	4	1	0	0	0	4	3
1400000US25003934300	25003934300	Census Tract 9343, Berkshire County, Massachusetts	1886	1854	1815	11	1	10	1	0	16	32	18	0	0	0	0	7	7
1400000US25003935100	25003935100	Census Tract 9351, Berkshire County, Massachusetts	2420	2384	2324	11	4	17	0	2	26	36	19	2	2	1	0	6	6
1400000US25003935200	25003935200	Census Tract 9352, Berkshire County, Massachusetts	5121	5028	4693	202	6	52	1	4	70	93	53	7	0	0	0	25	8
1400000US25003935300	25003935300	Census Tract 9353, Berkshire County, Massachusetts	3791	3681	3508	64	12	25	0	3	69	110	61	8	2	0	0	25	14
1400000US25005600100	25005600100	Census Tract 6001, Bristol County, Massachusetts	3920	3826	3599	94	4	63	2	26	38	94	75	0	0	0	0	10	9
1400000US25005600202	25005600202	Census Tract 6002.02, Bristol County, Massachusetts	4481	4360	3929	160	1	143	1	43	83	121	71	0	0	0	0	34	16
1400000US25005600203	25005600203	Census Tract 6002.03, Bristol County, Massachusetts	5611	5508	5151	138	8	138	0	11	62	103	71	9	1	1	0	17	4
1400000US25005600204	25005600204	Census Tract 6002.04, Bristol County, Massachusetts	3895	3787	3332	205	3	142	1	16	88	108	52	5	1	0	0	35	15
1400000US25005610100	25005610100	Census Tract 6101, Bristol County, Massachusetts	5103	5001	4628	124	6	173	0	10	60	102	63	8	0	0	0	24	7
1400000US25005610202	25005610202	Census Tract 6102.02, Bristol County, Massachusetts	5586	5488	5119	114	7	158	0	18	72	98	68	4	0	0	4	16	6
1400000US25005610203	25005610203	Census Tract 6102.03, Bristol County, Massachusetts	6883	6755	6401	101	11	152	0	17	73	128	94	3	0	2	0	14	15
1400000US25005610204	25005610204	Census Tract 6102.04, Bristol County, Massachusetts	5612	5453	4751	262	35	308	4	15	78	159	103	18	0	0	0	27	11
1400000US25005611101	25005611101	Census Tract 6111.01, Bristol County, Massachusetts	4585	4503	4282	74	8	60	0	16	63	82	55	3	0	5	0	14	5
1400000US25005611102	25005611102	Census Tract 6111.02, Bristol County, Massachusetts	5047	4916	4563	129	8	132	3	12	69	131	58	18	2	1	0	40	12
1400000US25005611201	25005611201	Census Tract 6112.01, Bristol County, Massachusetts	3003	2958	2848	26	0	40	0	1	43	45	30	3	0	0	0	4	8
1400000US25005611202	25005611202	Census Tract 6112.02, Bristol County, Massachusetts	6396	6280	5976	89	5	106	3	13	88	116	73	7	4	0	6	16	10
1400000US25005612100	25005612100	Census Tract 6121, Bristol County, Massachusetts	4538	4468	4247	84	3	80	0	16	38	70	38	1	0	6	0	13	12
1400000US25005612200	25005612200	Census Tract 6122, Bristol County, Massachusetts	8845	8668	8072	260	20	129	0	42	145	177	116	5	4	2	0	32	18
1400000US25005613100	25005613100	Census Tract 6131, Bristol County, Massachusetts	6327	6172	5775	140	10	74	2	64	107	155	74	7	1	0	0	51	22
1400000US25005613300	25005613300	Census Tract 6133, Bristol County, Massachusetts	7201	7032	6697	136	10	38	5	54	92	169	97	8	4	3	0	34	23
1400000US25005613400	25005613400	Census Tract 6134, Bristol County, Massachusetts	3812	3523	3148	162	7	44	0	43	119	289	144	36	8	0	0	64	37
1400000US25005613600	25005613600	Census Tract 6136, Bristol County, Massachusetts	3771	3514	3100	199	9	9	1	68	128	257	133	18	1	0	0	62	43
1400000US25005613700	25005613700	Census Tract 6137, Bristol County, Massachusetts	4369	4146	3712	202	1	38	0	57	136	223	104	13	3	1	0	81	21
1400000US25005613800	25005613800	Census Tract 6138, Bristol County, Massachusetts	4519	4099	3362	340	30	49	2	131	185	420	200	20	9	5	1	138	47
1400000US25005613901	25005613901	Census Tract 6139.01, Bristol County, Massachusetts	2801	2563	2154	208	7	9	0	92	93	238	112	30	1	0	0	73	22
1400000US25005613902	25005613902	Census Tract 6139.02, Bristol County, Massachusetts	4751	4552	4178	152	14	29	0	79	100	199	108	12	0	1	4	59	15
1400000US25005614000	25005614000	Census Tract 6140, Bristol County, Massachusetts	4472	3922	3221	291	9	54	1	132	214	550	214	53	2	2	0	209	70
1400000US25005614101	25005614101	Census Tract 6141.01, Bristol County, Massachusetts	6833	6495	5576	464	6	119	6	89	235	338	187	35	4	2	1	75	34
1400000US25005614102	25005614102	Census Tract 6141.02, Bristol County, Massachusetts	7018	6798	6298	235	5	83	1	58	118	220	148	12	1	0	1	37	21
1400000US25005615100	25005615100	Census Tract 6151, Bristol County, Massachusetts	7086	6982	6769	55	12	45	0	14	87	104	79	1	0	2	0	9	13
1400000US25005616100	25005616100	Census Tract 6161, Bristol County, Massachusetts	6411	6321	6125	55	6	27	1	37	70	90	69	3	1	2	0	9	6
1400000US25005617101	25005617101	Census Tract 6171.01, Bristol County, Massachusetts	4681	4622	4511	29	4	29	0	16	33	59	34	1	3	0	0	21	0
1400000US25005617102	25005617102	Census Tract 6171.02, Bristol County, Massachusetts	4189	4139	3969	48	5	26	0	41	50	50	36	3	1	0	0	5	5
1400000US25005630101	25005630101	Census Tract 6301.01, Bristol County, Massachusetts	2855	2733	2539	44	12	85	1	5	47	122	65	2	1	1	0	47	6
1400000US25005630102	25005630102	Census Tract 6301.02, Bristol County, Massachusetts	4201	4049	3803	69	12	97	1	6	61	152	84	2	12	0	0	44	10
1400000US25005630200	25005630200	Census Tract 6302, Bristol County, Massachusetts	8204	8086	7615	113	1	247	0	14	96	118	77	3	1	2	0	18	17
1400000US25005630300	25005630300	Census Tract 6303, Bristol County, Massachusetts	8597	8429	7832	118	1	335	5	23	115	168	116	0	5	2	0	31	14
1400000US25005630400	25005630400	Census Tract 6304, Bristol County, Massachusetts	4855	4740	4340	73	6	237	0	17	67	115	76	3	0	2	0	23	11
1400000US25005631100	25005631100	Census Tract 6311, Bristol County, Massachusetts	8093	7784	7119	195	7	310	2	46	105	309	197	10	0	0	2	81	19
1400000US25005631200	25005631200	Census Tract 6312, Bristol County, Massachusetts	6841	6560	5931	183	8	317	1	25	95	281	178	4	1	0	0	75	23
1400000US25005631300	25005631300	Census Tract 6313, Bristol County, Massachusetts	5183	4934	4503	131	5	180	3	24	88	249	118	7	3	2	3	99	17
1400000US25005631400	25005631400	Census Tract 6314, Bristol County, Massachusetts	2674	2157	1757	123	6	182	1	19	69	517	246	4	7	0	0	217	43
1400000US25005631500	25005631500	Census Tract 6315, Bristol County, Massachusetts	2797	2584	2339	91	6	58	0	7	83	213	81	2	1	2	2	111	14
1400000US25005631600	25005631600	Census Tract 6316, Bristol County, Massachusetts	3955	3290	2668	143	10	347	8	19	95	665	272	15	21	1	3	293	60
1400000US25005631700	25005631700	Census Tract 6317, Bristol County, Massachusetts	6471	6230	5756	149	8	213	9	10	85	241	114	3	0	0	0	91	33
1400000US25005631800	25005631800	Census Tract 6318, Bristol County, Massachusetts	7579	7289	6535	232	14	366	3	19	120	290	161	7	1	0	2	98	21
1400000US25005632100	25005632100	Census Tract 6321, Bristol County, Massachusetts	6543	6448	6237	43	9	54	1	33	71	95	57	4	6	0	0	21	7
1400000US25005632200	25005632200	Census Tract 6322, Bristol County, Massachusetts	7179	7023	6661	94	14	112	1	40	101	156	103	6	1	0	0	37	9
1400000US25005633100	25005633100	Census Tract 6331, Bristol County, Massachusetts	5490	5412	5239	28	4	64	4	18	55	78	50	2	0	2	0	18	6
1400000US25005633200	25005633200	Census Tract 6332, Bristol County, Massachusetts	6118	6013	5845	28	18	51	0	8	63	105	70	2	0	0	1	17	15
1400000US25005640100	25005640100	Census Tract 6401, Bristol County, Massachusetts	5358	4811	4308	152	9	198	0	27	117	547	309	41	8	3	0	165	21
1400000US25005640200	25005640200	Census Tract 6402, Bristol County, Massachusetts	5954	5616	5131	140	18	108	2	52	165	338	145	20	6	0	0	132	35
1400000US25005640300	25005640300	Census Tract 6403, Bristol County, Massachusetts	3693	3132	2721	157	11	130	0	20	93	561	305	56	5	0	0	166	29
1400000US25005640400	25005640400	Census Tract 6404, Bristol County, Massachusetts	2682	2612	2461	53	5	24	0	17	52	70	38	0	0	0	0	23	9
1400000US25005640500	25005640500	Census Tract 6405, Bristol County, Massachusetts	5165	4876	4512	121	12	67	0	41	123	289	131	23	1	3	0	97	34
1400000US25005640600	25005640600	Census Tract 6406, Bristol County, Massachusetts	4450	4161	3701	166	6	144	0	42	102	289	109	35	5	4	0	103	33
1400000US25005640700	25005640700	Census Tract 6407, Bristol County, Massachusetts	2900	2840	2641	47	2	103	0	19	28	60	25	3	0	0	3	27	2
1400000US25005640800	25005640800	Census Tract 6408, Bristol County, Massachusetts	3813	3391	2881	164	7	198	0	42	99	422	188	30	4	5	2	153	40
1400000US25005640901	25005640901	Census Tract 6409.01, Bristol County, Massachusetts	5071	4528	3942	273	6	61	0	81	165	543	190	34	8	1	0	275	35
1400000US25005641000	25005641000	Census Tract 6410, Bristol County, Massachusetts	2419	2206	1968	102	2	25	0	33	76	213	101	15	0	0	0	87	10
1400000US25005641101	25005641101	Census Tract 6411.01, Bristol County, Massachusetts	1712	1480	1230	134	4	36	0	21	55	232	66	23	10	0	0	123	10
1400000US25005641200	25005641200	Census Tract 6412, Bristol County, Massachusetts	2803	2540	2135	127	2	112	0	83	81	263	152	27	0	0	0	63	21
1400000US25005641300	25005641300	Census Tract 6413, Bristol County, Massachusetts	5326	4461	3676	290	26	259	3	67	140	865	401	35	17	2	7	328	75
1400000US25005641400	25005641400	Census Tract 6414, Bristol County, Massachusetts	2586	2333	1931	111	4	151	0	72	64	253	128	10	0	3	0	78	34
1400000US25005641500	25005641500	Census Tract 6415, Bristol County, Massachusetts	2401	2284	2118	66	5	24	1	12	58	117	75	9	0	1	0	29	3
1400000US25005641600	25005641600	Census Tract 6416, Bristol County, Massachusetts	2323	2280	2191	31	4	14	0	8	32	43	28	0	2	0	0	9	4
1400000US25005641700	25005641700	Census Tract 6417, Bristol County, Massachusetts	5096	4952	4663	71	4	128	0	21	65	144	75	14	1	2	4	37	11
1400000US25005641800	25005641800	Census Tract 6418, Bristol County, Massachusetts	2059	1978	1847	54	5	24	0	4	44	81	58	7	2	0	0	12	2
1400000US25005641900	25005641900	Census Tract 6419, Bristol County, Massachusetts	2275	2158	1933	100	9	25	0	33	58	117	76	4	4	1	0	25	7
1400000US25005642000	25005642000	Census Tract 6420, Bristol County, Massachusetts	3274	2901	2479	194	5	128	0	16	79	373	213	14	2	0	4	107	33
1400000US25005642100	25005642100	Census Tract 6421, Bristol County, Massachusetts	4144	3870	3480	179	5	82	1	43	80	274	147	22	4	0	0	70	31
1400000US25005642200	25005642200	Census Tract 6422, Bristol County, Massachusetts	3881	3621	3338	116	4	61	0	17	85	260	143	17	1	0	0	70	29
1400000US25005642300	25005642300	Census Tract 6423, Bristol County, Massachusetts	2195	2160	2063	20	4	45	0	10	18	35	21	0	2	0	0	6	6
1400000US25005642400	25005642400	Census Tract 6424, Bristol County, Massachusetts	2760	2677	2506	71	2	57	2	0	39	83	47	10	1	1	0	18	6
1400000US25005642500	25005642500	Census Tract 6425, Bristol County, Massachusetts	4517	4427	4251	77	2	45	1	6	45	90	71	1	4	0	0	10	4
1400000US25005644101	25005644101	Census Tract 6441.01, Bristol County, Massachusetts	5828	5771	5618	26	8	55	0	9	55	57	47	2	0	0	0	4	4
1400000US25005644102	25005644102	Census Tract 6441.02, Bristol County, Massachusetts	5057	4999	4878	11	3	33	1	10	63	58	38	0	0	0	0	10	10
1400000US25005644200	25005644200	Census Tract 6442, Bristol County, Massachusetts	7280	7204	7059	29	9	60	0	7	40	76	60	0	0	0	0	14	2
1400000US25005645101	25005645101	Census Tract 6451.01, Bristol County, Massachusetts	4863	4820	4735	20	1	20	0	1	43	43	33	1	1	0	0	2	6
1400000US25005645102	25005645102	Census Tract 6451.02, Bristol County, Massachusetts	5385	5311	5132	42	4	50	0	10	73	74	56	4	2	1	0	4	7
1400000US25005645103	25005645103	Census Tract 6451.03, Bristol County, Massachusetts	5617	5561	5420	33	4	39	1	21	43	56	53	1	1	0	0	1	0
1400000US25005646101	25005646101	Census Tract 6461.01, Bristol County, Massachusetts	7356	7289	7111	37	4	52	0	22	63	67	56	4	0	0	0	4	3
1400000US25005646103	25005646103	Census Tract 6461.03, Bristol County, Massachusetts	5604	5557	5458	18	0	27	4	9	41	47	38	1	1	0	0	4	3
1400000US25005646104	25005646104	Census Tract 6461.04, Bristol County, Massachusetts	2572	2548	2487	12	1	24	0	5	19	24	20	0	1	0	0	1	2
1400000US25005650101	25005650101	Census Tract 6501.01, Bristol County, Massachusetts	5753	5571	5237	108	4	26	0	89	107	182	111	7	2	0	0	34	28
1400000US25005650102	25005650102	Census Tract 6501.02, Bristol County, Massachusetts	4879	4188	3676	125	12	71	0	139	165	691	294	55	15	1	0	297	29
1400000US25005650201	25005650201	Census Tract 6502.01, Bristol County, Massachusetts	2916	2787	2592	50	8	46	0	47	44	129	85	12	0	0	0	21	11
1400000US25005650202	25005650202	Census Tract 6502.02, Bristol County, Massachusetts	2142	1969	1818	63	6	10	0	26	46	173	94	12	1	0	0	53	13
1400000US25005650300	25005650300	Census Tract 6503, Bristol County, Massachusetts	3304	3083	2849	77	5	29	0	37	86	221	105	24	22	0	0	58	12
1400000US25005650400	25005650400	Census Tract 6504, Bristol County, Massachusetts	3773	3361	3047	93	6	14	0	73	128	412	236	30	2	0	1	107	36
1400000US25005650500	25005650500	Census Tract 6505, Bristol County, Massachusetts	3141	2796	2536	64	1	40	4	47	104	345	95	26	21	1	0	162	40
1400000US25005650600	25005650600	Census Tract 6506, Bristol County, Massachusetts	2759	2213	1920	115	7	25	0	59	87	546	170	37	48	0	0	236	55
1400000US25005650700	25005650700	Census Tract 6507, Bristol County, Massachusetts	2583	1408	993	154	32	18	0	129	82	1175	271	60	308	2	3	456	75
1400000US25005650800	25005650800	Census Tract 6508, Bristol County, Massachusetts	3651	2839	2272	222	17	30	2	167	129	812	217	24	44	0	5	458	64
1400000US25005650900	25005650900	Census Tract 6509, Bristol County, Massachusetts	2867	1769	1267	162	16	44	0	159	121	1098	383	92	26	2	0	505	90
1400000US25005651001	25005651001	Census Tract 6510.01, Bristol County, Massachusetts	2865	2693	2297	87	14	77	3	123	92	172	86	4	5	0	0	55	22
1400000US25005651002	25005651002	Census Tract 6510.02, Bristol County, Massachusetts	3833	3243	2596	232	20	63	2	141	189	590	258	30	11	1	0	256	34
1400000US25005651100	25005651100	Census Tract 6511, Bristol County, Massachusetts	4117	3159	2380	282	12	25	0	220	240	958	417	96	19	0	0	334	92
1400000US25005651200	25005651200	Census Tract 6512, Bristol County, Massachusetts	2068	1496	1126	156	33	16	0	75	90	572	141	41	65	0	8	299	18
1400000US25005651300	25005651300	Census Tract 6513, Bristol County, Massachusetts	2227	1792	1318	152	17	36	1	139	129	435	138	62	9	0	0	186	40
1400000US25005651400	25005651400	Census Tract 6514, Bristol County, Massachusetts	3215	2773	1906	353	14	15	1	235	249	442	159	45	9	1	1	180	47
1400000US25005651500	25005651500	Census Tract 6515, Bristol County, Massachusetts	3115	2380	1461	340	13	41	0	288	237	735	299	66	13	2	0	309	46
1400000US25005651600	25005651600	Census Tract 6516, Bristol County, Massachusetts	3862	3431	2347	363	26	50	0	369	276	431	146	41	5	0	0	194	45
1400000US25005651700	25005651700	Census Tract 6517, Bristol County, Massachusetts	1983	1599	885	323	15	14	1	214	147	384	161	44	4	0	0	133	42
1400000US25005651800	25005651800	Census Tract 6518, Bristol County, Massachusetts	1745	1466	1082	145	18	31	0	91	99	279	97	27	17	0	1	103	34
1400000US25005651900	25005651900	Census Tract 6519, Bristol County, Massachusetts	1942	1309	499	214	18	16	1	362	199	633	247	48	6	0	0	269	63
1400000US25005652000	25005652000	Census Tract 6520, Bristol County, Massachusetts	2676	2347	1720	184	17	9	0	231	186	329	121	23	12	1	4	144	24
1400000US25005652100	25005652100	Census Tract 6521, Bristol County, Massachusetts	2815	2591	2160	129	12	21	0	105	164	224	101	20	1	0	0	85	17
1400000US25005652200	25005652200	Census Tract 6522, Bristol County, Massachusetts	2836	2732	2455	86	10	19	0	71	91	104	58	6	3	0	0	29	8
1400000US25005652300	25005652300	Census Tract 6523, Bristol County, Massachusetts	2870	2469	2142	100	6	9	0	94	118	401	172	28	12	0	0	156	33
1400000US25005652400	25005652400	Census Tract 6524, Bristol County, Massachusetts	2664	2288	2046	87	5	26	0	45	79	376	164	25	6	0	0	154	27
1400000US25005652500	25005652500	Census Tract 6525, Bristol County, Massachusetts	2589	2005	1637	107	11	27	0	155	68	584	252	28	21	1	2	236	44
1400000US25005652600	25005652600	Census Tract 6526, Bristol County, Massachusetts	2843	1624	1277	134	19	4	0	90	100	1219	488	105	85	2	10	417	112
1400000US25005652700	25005652700	Census Tract 6527, Bristol County, Massachusetts	3762	2669	2150	165	12	15	0	150	177	1093	539	43	18	0	0	421	72
1400000US25005652800	25005652800	Census Tract 6528, Bristol County, Massachusetts	3277	3106	2907	47	3	12	0	54	83	171	96	3	1	0	0	60	11
1400000US25005653101	25005653101	Census Tract 6531.01, Bristol County, Massachusetts	6664	6518	6026	93	9	194	3	64	129	146	105	3	0	2	0	27	9
1400000US25005653102	25005653102	Census Tract 6531.02, Bristol County, Massachusetts	5381	5115	4623	285	11	79	1	34	82	266	182	12	2	3	0	54	13
1400000US25005653203	25005653203	Census Tract 6532.03, Bristol County, Massachusetts	5005	4930	4620	49	8	73	0	98	82	75	38	2	8	0	0	19	8
1400000US25005653204	25005653204	Census Tract 6532.04, Bristol County, Massachusetts	3214	3168	2920	36	3	114	0	35	60	46	33	5	0	0	0	5	3
1400000US25005653301	25005653301	Census Tract 6533.01, Bristol County, Massachusetts	5057	4978	4785	38	4	58	0	28	65	79	59	0	1	2	0	15	2
1400000US25005653304	25005653304	Census Tract 6533.04, Bristol County, Massachusetts	3205	3176	3078	7	6	23	0	18	44	29	20	3	2	0	0	2	2
1400000US25005654100	25005654100	Census Tract 6541, Bristol County, Massachusetts	6916	6844	6689	34	7	25	0	40	49	72	62	1	0	0	0	6	3
1400000US25005654200	25005654200	Census Tract 6542, Bristol County, Massachusetts	3387	3340	3230	14	9	6	0	23	58	47	30	0	0	0	0	9	8
1400000US25005655100	25005655100	Census Tract 6551, Bristol County, Massachusetts	4225	4173	3972	45	4	42	5	48	57	52	35	0	2	0	0	12	3
1400000US25005655200	25005655200	Census Tract 6552, Bristol County, Massachusetts	4415	4342	4146	48	11	46	4	24	63	73	39	4	0	1	0	24	5
1400000US25005655300	25005655300	Census Tract 6553, Bristol County, Massachusetts	3317	3277	3162	29	3	27	0	30	26	40	32	1	0	0	0	5	2
1400000US25005655400	25005655400	Census Tract 6554, Bristol County, Massachusetts	3916	3883	3754	18	5	37	0	23	46	33	26	0	0	1	0	4	2
1400000US25005985500	25005985500	Census Tract 9855, Bristol County, Massachusetts	5506	5342	4750	316	7	101	2	49	117	164	84	20	0	2	0	45	13
1400000US25005985600	25005985600	Census Tract 9856, Bristol County, Massachusetts	5205	5056	4774	128	1	75	0	23	55	149	90	6	1	1	1	41	9
1400000US25005990000	25005990000	Census Tract 9900, Bristol County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25007200100	25007200100	Census Tract 2001, Dukes County, Massachusetts	3949	3831	3334	141	16	30	1	189	120	118	74	3	1	1	0	17	22
1400000US25007200200	25007200200	Census Tract 2002, Dukes County, Massachusetts	4527	4417	3737	209	41	52	1	167	210	110	71	11	3	0	4	11	10
1400000US25007200300	25007200300	Census Tract 2003, Dukes County, Massachusetts	4067	3968	3550	85	17	19	1	193	103	99	41	17	3	4	2	31	1
1400000US25007200400	25007200400	Census Tract 2004, Dukes County, Massachusetts	3992	3935	3654	42	101	22	1	22	93	57	31	3	1	0	0	12	10
1400000US25007990000	25007990000	Census Tract 9900, Dukes County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25009201100	25009201100	Census Tract 2011, Essex County, Massachusetts	3410	3358	3257	15	3	58	0	5	20	52	33	1	0	0	0	14	4
1400000US25009202101	25009202101	Census Tract 2021.01, Essex County, Massachusetts	2063	2017	1944	14	1	24	0	5	29	46	24	1	0	0	0	14	7
1400000US25009202102	25009202102	Census Tract 2021.02, Essex County, Massachusetts	5836	5649	5336	101	4	129	4	8	67	187	108	7	0	0	0	43	29
1400000US25009202200	25009202200	Census Tract 2022, Essex County, Massachusetts	5888	5766	5544	42	2	111	0	8	59	122	92	0	6	1	0	17	6
1400000US25009203100	25009203100	Census Tract 2031, Essex County, Massachusetts	7071	6918	6717	31	2	93	1	9	65	153	106	5	4	1	0	27	10
1400000US25009203200	25009203200	Census Tract 2032, Essex County, Massachusetts	4557	4473	4361	19	4	38	0	8	43	84	55	0	0	3	0	21	5
1400000US25009203301	25009203301	Census Tract 2033.01, Essex County, Massachusetts	4010	3952	3820	46	3	33	0	10	40	58	37	4	1	0	0	9	7
1400000US25009203302	25009203302	Census Tract 2033.02, Essex County, Massachusetts	4170	4048	3920	35	3	34	0	4	52	122	71	11	5	0	0	27	8
1400000US25009204101	25009204101	Census Tract 2041.01, Essex County, Massachusetts	4669	4055	3658	153	2	116	2	19	105	614	188	53	22	2	0	292	57
1400000US25009204102	25009204102	Census Tract 2041.02, Essex County, Massachusetts	4935	4504	4054	228	7	129	5	10	71	431	145	56	11	1	0	192	26
1400000US25009204200	25009204200	Census Tract 2042, Essex County, Massachusetts	4797	3906	3559	152	12	81	1	19	82	891	311	64	8	2	0	416	90
1400000US25009204300	25009204300	Census Tract 2043, Essex County, Massachusetts	3904	2093	1800	163	10	52	1	12	55	1811	669	190	15	1	0	747	189
1400000US25009204400	25009204400	Census Tract 2044, Essex County, Massachusetts	3301	3130	2989	37	4	29	3	12	56	171	84	11	3	0	0	46	27
1400000US25009204500	25009204500	Census Tract 2045, Essex County, Massachusetts	3132	2792	2552	68	5	83	1	19	64	340	143	47	9	3	0	99	39
1400000US25009204600	25009204600	Census Tract 2046, Essex County, Massachusetts	5154	4623	4316	94	2	77	1	39	94	531	207	39	9	3	4	203	66
1400000US25009204701	25009204701	Census Tract 2047.01, Essex County, Massachusetts	5782	4692	4058	315	14	189	3	8	105	1090	341	97	23	0	0	497	132
1400000US25009204702	25009204702	Census Tract 2047.02, Essex County, Massachusetts	5666	5080	4391	240	10	327	0	28	84	586	229	33	7	0	0	251	66
1400000US25009205100	25009205100	Census Tract 2051, Essex County, Massachusetts	5352	4712	4087	314	0	179	2	23	107	640	193	40	1	4	0	341	61
1400000US25009205200	25009205200	Census Tract 2052, Essex County, Massachusetts	5319	4004	3115	456	7	302	0	15	109	1315	413	90	4	9	1	691	107
1400000US25009205300	25009205300	Census Tract 2053, Essex County, Massachusetts	4490	4071	3697	181	7	101	0	13	72	419	166	12	0	0	0	185	56
1400000US25009205400	25009205400	Census Tract 2054, Essex County, Massachusetts	5048	4871	4550	98	8	107	2	19	87	177	88	16	3	1	0	59	10
1400000US25009205500	25009205500	Census Tract 2055, Essex County, Massachusetts	4606	2681	1738	510	7	313	4	14	95	1925	659	66	45	4	6	970	175
1400000US25009205600	25009205600	Census Tract 2056, Essex County, Massachusetts	3881	2966	2212	463	10	167	0	11	103	915	236	96	4	4	0	452	123
1400000US25009205700	25009205700	Census Tract 2057, Essex County, Massachusetts	4650	3732	3035	297	14	303	0	12	71	918	383	71	6	2	0	374	82
1400000US25009205800	25009205800	Census Tract 2058, Essex County, Massachusetts	3312	2014	1137	311	1	449	0	21	95	1298	430	107	27	5	6	634	89
1400000US25009205900	25009205900	Census Tract 2059, Essex County, Massachusetts	4350	2894	2025	428	5	308	0	30	98	1456	491	101	46	3	5	715	95
1400000US25009206000	25009206000	Census Tract 2060, Essex County, Massachusetts	3359	1551	693	498	3	281	0	17	59	1808	487	123	47	2	0	993	156
1400000US25009206100	25009206100	Census Tract 2061, Essex County, Massachusetts	3844	1950	786	569	13	490	10	10	72	1894	687	147	29	0	0	848	183
1400000US25009206200	25009206200	Census Tract 2062, Essex County, Massachusetts	5254	2422	1050	712	8	499	0	23	130	2832	1016	147	45	5	0	1359	260
1400000US25009206300	25009206300	Census Tract 2063, Essex County, Massachusetts	3773	2234	1174	584	6	323	2	20	125	1539	389	121	26	3	1	859	140
1400000US25009206400	25009206400	Census Tract 2064, Essex County, Massachusetts	5249	3718	2764	540	8	276	3	22	105	1531	477	140	10	6	1	771	126
1400000US25009206500	25009206500	Census Tract 2065, Essex County, Massachusetts	3358	1782	897	518	7	232	0	21	107	1576	432	130	11	6	2	880	115
1400000US25009206600	25009206600	Census Tract 2066, Essex County, Massachusetts	4243	3215	2396	391	15	285	2	13	113	1028	310	61	38	5	0	507	107
1400000US25009206700	25009206700	Census Tract 2067, Essex County, Massachusetts	4080	2866	2159	463	8	108	1	20	107	1214	366	91	15	2	2	611	127
1400000US25009206800	25009206800	Census Tract 2068, Essex County, Massachusetts	3546	1840	1044	465	18	195	1	23	94	1706	466	162	46	4	0	891	137
1400000US25009206900	25009206900	Census Tract 2069, Essex County, Massachusetts	3965	2925	2097	591	15	107	0	28	87	1040	271	108	17	5	3	534	102
1400000US25009207000	25009207000	Census Tract 2070, Essex County, Massachusetts	2198	1320	792	357	8	116	4	1	42	878	296	69	18	0	0	437	58
1400000US25009207100	25009207100	Census Tract 2071, Essex County, Massachusetts	3513	1843	648	389	3	675	6	40	82	1670	472	73	27	8	18	965	107
1400000US25009207200	25009207200	Census Tract 2072, Essex County, Massachusetts	2939	1705	873	359	7	394	0	11	61	1234	322	75	16	4	0	721	96
1400000US25009208101	25009208101	Census Tract 2081.01, Essex County, Massachusetts	5124	4878	4576	99	4	119	0	11	69	246	147	3	6	2	0	65	23
1400000US25009208102	25009208102	Census Tract 2081.02, Essex County, Massachusetts	3243	3032	2755	81	1	128	1	10	56	211	112	9	1	0	2	56	31
1400000US25009208200	25009208200	Census Tract 2082, Essex County, Massachusetts	5262	5103	4820	101	3	85	0	42	52	159	75	4	4	0	0	54	22
1400000US25009208300	25009208300	Census Tract 2083, Essex County, Massachusetts	7254	6994	6599	111	17	165	0	41	61	260	176	2	0	0	0	71	11
1400000US25009208400	25009208400	Census Tract 2084, Essex County, Massachusetts	5745	5555	5110	133	3	211	0	28	70	190	109	9	0	2	0	52	18
1400000US25009209100	25009209100	Census Tract 2091, Essex County, Massachusetts	6088	5965	5619	33	2	241	0	17	53	123	89	5	0	0	0	12	17
1400000US25009209200	25009209200	Census Tract 2092, Essex County, Massachusetts	5508	5429	5219	15	3	138	0	13	41	79	59	5	0	0	0	10	5
1400000US25009210100	25009210100	Census Tract 2101, Essex County, Massachusetts	6948	6796	6574	37	5	133	0	8	39	152	97	8	0	0	0	40	7
1400000US25009210200	25009210200	Census Tract 2102, Essex County, Massachusetts	5384	5281	5071	64	8	83	0	8	47	103	67	1	2	2	0	28	3
1400000US25009210300	25009210300	Census Tract 2103, Essex County, Massachusetts	9110	8772	8146	243	5	260	3	35	80	338	187	20	14	10	0	85	22
1400000US25009210400	25009210400	Census Tract 2104, Essex County, Massachusetts	6823	6487	6036	146	5	162	2	65	71	336	154	36	3	2	0	97	44
1400000US25009210500	25009210500	Census Tract 2105, Essex County, Massachusetts	6438	6233	5970	104	4	95	0	11	49	205	114	16	3	1	0	53	18
1400000US25009210600	25009210600	Census Tract 2106, Essex County, Massachusetts	4095	3714	3513	73	7	34	0	25	62	381	115	36	3	1	0	193	33
1400000US25009210700	25009210700	Census Tract 2107, Essex County, Massachusetts	4001	3254	2782	123	3	83	0	184	79	747	300	60	8	0	0	334	45
1400000US25009210800	25009210800	Census Tract 2108, Essex County, Massachusetts	4569	3830	3372	127	2	67	0	183	79	739	263	53	13	0	0	356	54
1400000US25009210900	25009210900	Census Tract 2109, Essex County, Massachusetts	3883	3672	3470	53	6	23	0	54	66	211	87	6	0	0	0	94	24
1400000US25009211100	25009211100	Census Tract 2111, Essex County, Massachusetts	3794	3708	3561	52	1	49	0	7	38	86	61	1	0	1	0	21	2
1400000US25009211200	25009211200	Census Tract 2112, Essex County, Massachusetts	6100	5956	5746	45	9	82	1	6	67	144	83	9	4	1	0	34	13
1400000US25009211300	25009211300	Census Tract 2113, Essex County, Massachusetts	6967	6854	6628	27	2	168	0	1	28	113	73	6	0	0	0	24	10
1400000US25009211401	25009211401	Census Tract 2114.01, Essex County, Massachusetts	3560	3424	3181	66	3	112	3	10	49	136	92	9	0	0	0	24	11
1400000US25009211402	25009211402	Census Tract 2114.02, Essex County, Massachusetts	6072	5933	5723	63	9	87	0	10	41	139	79	4	2	0	0	42	12
1400000US25009212100	25009212100	Census Tract 2121, Essex County, Massachusetts	8987	8347	7845	153	13	202	0	15	119	640	218	51	30	2	3	291	45
1400000US25009213100	25009213100	Census Tract 2131, Essex County, Massachusetts	7961	7816	7570	32	2	123	0	7	82	145	111	5	3	0	0	14	12
1400000US25009214100	25009214100	Census Tract 2141, Essex County, Massachusetts	6089	5977	5802	31	4	75	0	8	57	112	87	4	1	2	0	9	9
1400000US25009215101	25009215101	Census Tract 2151.01, Essex County, Massachusetts	4896	4832	4367	37	12	375	0	3	38	64	45	4	2	0	0	6	7
1400000US25009215102	25009215102	Census Tract 2151.02, Essex County, Massachusetts	2868	2811	2721	5	0	45	0	2	38	57	42	0	0	3	0	11	1
1400000US25009216100	25009216100	Census Tract 2161, Essex County, Massachusetts	4875	4780	4607	29	4	82	4	16	38	95	64	1	2	0	0	23	5
1400000US25009217100	25009217100	Census Tract 2171, Essex County, Massachusetts	7291	7054	6675	121	3	161	3	11	80	237	147	13	0	2	0	49	26
1400000US25009217201	25009217201	Census Tract 2172.01, Essex County, Massachusetts	4218	4062	3853	79	0	71	2	11	46	156	84	1	2	1	0	57	11
1400000US25009217202	25009217202	Census Tract 2172.02, Essex County, Massachusetts	3491	3446	3345	10	1	48	0	7	35	45	34	6	0	1	0	3	1
1400000US25009217300	25009217300	Census Tract 2173, Essex County, Massachusetts	4504	4102	3687	127	13	101	13	64	97	402	174	21	7	1	0	153	46
1400000US25009217400	25009217400	Census Tract 2174, Essex County, Massachusetts	5218	4964	4520	143	9	118	4	55	115	254	131	18	2	1	0	82	20
1400000US25009217500	25009217500	Census Tract 2175, Essex County, Massachusetts	6101	5945	5742	46	9	59	0	18	71	156	101	3	3	3	0	36	10
1400000US25009217600	25009217600	Census Tract 2176, Essex County, Massachusetts	8679	8532	8283	58	7	119	1	9	55	147	92	1	6	0	0	29	19
1400000US25009218100	25009218100	Census Tract 2181, Essex County, Massachusetts	5136	5060	4952	6	11	41	0	1	49	76	61	1	0	3	0	4	7
1400000US25009220101	25009220101	Census Tract 2201.01, Essex County, Massachusetts	4003	3942	3856	23	2	35	0	2	24	61	43	1	0	0	0	7	10
1400000US25009220102	25009220102	Census Tract 2201.02, Essex County, Massachusetts	2949	2899	2810	18	2	21	6	7	35	50	36	3	1	0	0	6	4
1400000US25009221100	25009221100	Census Tract 2211, Essex County, Massachusetts	4182	4124	4049	12	1	19	1	5	37	58	39	3	1	0	1	12	2
1400000US25009221300	25009221300	Census Tract 2213, Essex County, Massachusetts	4532	4470	4366	9	2	54	0	4	35	62	50	1	1	1	0	4	5
1400000US25009221400	25009221400	Census Tract 2214, Essex County, Massachusetts	3221	3055	2902	34	0	26	5	52	36	166	55	12	3	0	5	75	16
1400000US25009221500	25009221500	Census Tract 2215, Essex County, Massachusetts	2923	2777	2659	28	6	30	5	18	31	146	112	4	0	0	4	15	11
1400000US25009221600	25009221600	Census Tract 2216, Essex County, Massachusetts	2448	2291	2183	43	1	10	1	5	48	157	75	9	2	0	0	47	24
1400000US25009221700	25009221700	Census Tract 2217, Essex County, Massachusetts	2840	2749	2635	28	3	33	4	8	38	91	39	2	3	1	0	39	7
1400000US25009221800	25009221800	Census Tract 2218, Essex County, Massachusetts	1773	1766	1733	3	0	18	0	0	12	7	6	0	0	0	0	0	1
1400000US25009221901	25009221901	Census Tract 2219.01, Essex County, Massachusetts	3419	3380	3313	2	7	32	0	4	22	39	29	2	1	0	0	1	6
1400000US25009221902	25009221902	Census Tract 2219.02, Essex County, Massachusetts	3451	3390	3260	40	9	34	0	3	44	61	43	7	0	0	0	10	1
1400000US25009222100	25009222100	Census Tract 2221, Essex County, Massachusetts	3504	3458	3369	11	0	34	1	4	39	46	37	1	3	1	0	3	1
1400000US25009223100	25009223100	Census Tract 2231, Essex County, Massachusetts	3880	3823	3695	25	3	36	0	7	57	57	43	1	1	0	0	10	2
1400000US25009223200	25009223200	Census Tract 2232, Essex County, Massachusetts	3740	3661	3515	15	5	52	6	25	43	79	48	2	1	0	0	20	8
1400000US25009223300	25009223300	Census Tract 2233, Essex County, Massachusetts	5555	5459	5261	21	4	86	0	23	64	96	74	1	6	0	0	11	4
1400000US25009250100	25009250100	Census Tract 2501, Essex County, Massachusetts	2329	592	471	75	6	28	0	3	9	1737	521	123	25	3	0	919	146
1400000US25009250200	25009250200	Census Tract 2502, Essex County, Massachusetts	5524	1546	1241	141	20	80	0	12	52	3978	1093	226	53	5	0	2393	208
1400000US25009250300	25009250300	Census Tract 2503, Essex County, Massachusetts	2101	227	137	43	6	30	0	5	6	1874	455	115	18	1	0	1119	166
1400000US25009250400	25009250400	Census Tract 2504, Essex County, Massachusetts	3858	368	263	62	9	13	0	10	11	3490	1105	322	67	13	7	1649	327
1400000US25009250500	25009250500	Census Tract 2505, Essex County, Massachusetts	3810	245	162	40	2	9	0	13	19	3565	1102	298	48	12	4	1705	396
1400000US25009250600	25009250600	Census Tract 2506, Essex County, Massachusetts	5599	948	739	111	18	28	0	14	38	4651	1182	362	24	9	13	2608	453
1400000US25009250700	25009250700	Census Tract 2507, Essex County, Massachusetts	4756	666	479	104	10	42	0	21	10	4090	1209	283	45	5	4	2146	398
1400000US25009250800	25009250800	Census Tract 2508, Essex County, Massachusetts	6932	2544	2161	171	14	110	1	19	68	4388	1770	373	69	12	3	1820	341
1400000US25009250900	25009250900	Census Tract 2509, Essex County, Massachusetts	2193	153	101	26	3	5	1	13	4	2040	603	192	35	1	2	1023	184
1400000US25009251000	25009251000	Census Tract 2510, Essex County, Massachusetts	1782	270	208	37	1	12	0	5	7	1512	447	118	29	4	0	819	95
1400000US25009251100	25009251100	Census Tract 2511, Essex County, Massachusetts	2937	785	695	44	3	14	0	10	19	2152	713	140	32	8	0	1115	144
1400000US25009251200	25009251200	Census Tract 2512, Essex County, Massachusetts	1357	188	147	27	0	5	0	6	3	1169	365	98	49	1	2	585	69
1400000US25009251300	25009251300	Census Tract 2513, Essex County, Massachusetts	3721	391	253	69	5	44	0	7	13	3330	889	178	39	15	3	1933	273
1400000US25009251400	25009251400	Census Tract 2514, Essex County, Massachusetts	5053	1157	804	157	13	112	0	32	39	3896	1183	222	42	16	0	2148	285
1400000US25009251500	25009251500	Census Tract 2515, Essex County, Massachusetts	6149	1857	1360	139	2	293	0	18	45	4292	1347	345	72	5	10	2157	356
1400000US25009251600	25009251600	Census Tract 2516, Essex County, Massachusetts	5977	1583	1077	178	3	271	0	27	27	4394	1338	305	81	13	2	2413	242
1400000US25009251700	25009251700	Census Tract 2517, Essex County, Massachusetts	5145	2009	1467	114	7	349	0	16	56	3136	931	212	54	8	4	1745	182
1400000US25009251800	25009251800	Census Tract 2518, Essex County, Massachusetts	7154	4485	3872	184	8	311	0	22	88	2669	814	154	45	8	1	1468	179
1400000US25009252101	25009252101	Census Tract 2521.01, Essex County, Massachusetts	3509	2927	2633	108	6	111	0	15	54	582	239	52	8	0	0	203	80
1400000US25009252102	25009252102	Census Tract 2521.02, Essex County, Massachusetts	3798	3613	3447	24	3	110	0	7	22	185	67	6	2	1	0	93	16
1400000US25009252201	25009252201	Census Tract 2522.01, Essex County, Massachusetts	3230	2807	2652	49	2	80	0	5	19	423	178	23	4	4	0	176	38
1400000US25009252202	25009252202	Census Tract 2522.02, Essex County, Massachusetts	3198	3097	2951	24	5	82	0	9	26	101	45	0	0	2	0	46	8
1400000US25009252300	25009252300	Census Tract 2523, Essex County, Massachusetts	6552	4758	4259	177	13	212	0	22	75	1794	681	120	21	2	2	811	157
1400000US25009252400	25009252400	Census Tract 2524, Essex County, Massachusetts	4175	1570	1261	135	3	121	1	7	42	2605	918	193	34	6	3	1244	207
1400000US25009252501	25009252501	Census Tract 2525.01, Essex County, Massachusetts	3874	2855	2536	117	11	136	0	6	49	1019	379	70	9	5	4	492	60
1400000US25009252502	25009252502	Census Tract 2525.02, Essex County, Massachusetts	4865	4295	3985	87	5	157	0	10	51	570	328	23	2	0	0	192	25
1400000US25009252601	25009252601	Census Tract 2526.01, Essex County, Massachusetts	6621	6000	5454	107	3	356	0	24	56	621	237	23	3	6	0	304	48
1400000US25009252602	25009252602	Census Tract 2526.02, Essex County, Massachusetts	4407	4022	3710	61	9	182	0	5	55	385	200	22	5	0	0	124	34
1400000US25009252603	25009252603	Census Tract 2526.03, Essex County, Massachusetts	3026	2780	2499	46	8	194	0	1	32	246	103	9	4	0	0	112	18
1400000US25009253100	25009253100	Census Tract 2531, Essex County, Massachusetts	5352	5031	4684	100	11	163	2	4	67	321	210	19	0	0	0	70	22
1400000US25009253201	25009253201	Census Tract 2532.01, Essex County, Massachusetts	2913	2741	2527	24	1	154	0	6	29	172	121	5	0	0	0	35	11
1400000US25009253202	25009253202	Census Tract 2532.02, Essex County, Massachusetts	6253	5608	4765	220	0	525	1	11	86	645	268	46	1	2	1	280	47
1400000US25009253203	25009253203	Census Tract 2532.03, Essex County, Massachusetts	4160	4094	3860	27	6	168	0	4	29	66	51	0	0	0	0	11	4
1400000US25009253204	25009253204	Census Tract 2532.04, Essex County, Massachusetts	5329	5216	4494	32	4	611	0	2	73	113	76	5	4	1	0	21	6
1400000US25009253205	25009253205	Census Tract 2532.05, Essex County, Massachusetts	4345	4264	4025	24	0	162	0	5	48	81	63	4	1	1	0	9	3
1400000US25009254100	25009254100	Census Tract 2541, Essex County, Massachusetts	6009	5846	5160	49	4	533	6	16	78	163	89	3	0	2	1	50	18
1400000US25009254200	25009254200	Census Tract 2542, Essex County, Massachusetts	5018	4752	4372	77	3	219	2	3	76	266	137	6	0	6	1	89	27
1400000US25009254301	25009254301	Census Tract 2543.01, Essex County, Massachusetts	3893	3816	3384	42	1	332	0	5	52	77	48	10	0	0	0	7	12
1400000US25009254302	25009254302	Census Tract 2543.02, Essex County, Massachusetts	4493	4412	3849	28	3	455	0	10	67	81	59	2	2	4	0	9	5
1400000US25009254401	25009254401	Census Tract 2544.01, Essex County, Massachusetts	3235	3106	2651	38	0	361	0	12	44	129	89	6	0	3	0	24	7
1400000US25009254402	25009254402	Census Tract 2544.02, Essex County, Massachusetts	6713	6335	4968	83	4	1157	0	19	104	378	171	19	7	5	1	146	29
1400000US25009254403	25009254403	Census Tract 2544.03, Essex County, Massachusetts	3840	3738	3314	26	0	358	0	8	32	102	69	2	0	3	0	19	9
1400000US25009260100	25009260100	Census Tract 2601, Essex County, Massachusetts	4789	3048	2615	227	8	74	0	34	90	1741	899	118	18	6	6	579	115
1400000US25009260200	25009260200	Census Tract 2602, Essex County, Massachusetts	3437	2798	2531	149	18	15	0	10	75	639	262	38	6	0	0	293	40
1400000US25009260301	25009260301	Census Tract 2603.01, Essex County, Massachusetts	4466	4259	4077	60	2	64	0	10	46	207	94	6	2	1	0	94	10
1400000US25009260302	25009260302	Census Tract 2603.02, Essex County, Massachusetts	3091	3012	2914	24	0	38	1	7	28	79	52	2	1	0	0	13	11
1400000US25009260401	25009260401	Census Tract 2604.01, Essex County, Massachusetts	3820	3610	3420	55	1	79	0	9	46	210	110	7	0	0	0	86	7
1400000US25009260402	25009260402	Census Tract 2604.02, Essex County, Massachusetts	6211	5911	5576	97	3	138	1	12	84	300	134	7	6	0	0	104	49
1400000US25009260500	25009260500	Census Tract 2605, Essex County, Massachusetts	3788	3549	3401	51	5	40	2	4	46	239	92	16	3	1	0	95	32
1400000US25009260600	25009260600	Census Tract 2606, Essex County, Massachusetts	3377	2583	2355	71	8	76	1	13	59	794	410	53	0	0	0	275	56
1400000US25009260700	25009260700	Census Tract 2607, Essex County, Massachusetts	4498	3784	3463	130	5	91	0	12	83	714	377	28	5	0	0	241	63
1400000US25009260800	25009260800	Census Tract 2608, Essex County, Massachusetts	4631	2832	2417	245	12	38	1	8	111	1799	653	90	24	0	3	891	138
1400000US25009260900	25009260900	Census Tract 2609, Essex County, Massachusetts	5089	3941	3616	118	10	98	0	19	80	1148	421	74	19	5	0	541	88
1400000US25009261000	25009261000	Census Tract 2610, Essex County, Massachusetts	3942	3579	3392	96	3	39	0	7	42	363	170	23	5	1	0	140	24
1400000US25009261101	25009261101	Census Tract 2611.01, Essex County, Massachusetts	4782	4646	4478	52	4	65	1	3	43	136	95	3	3	2	0	20	13
1400000US25009261102	25009261102	Census Tract 2611.02, Essex County, Massachusetts	4958	4496	4139	158	3	116	1	9	70	462	218	44	2	1	0	158	39
1400000US25009262100	25009262100	Census Tract 2621, Essex County, Massachusetts	6338	6223	6067	36	8	41	0	3	68	115	82	4	2	0	0	18	9
1400000US25009263100	25009263100	Census Tract 2631, Essex County, Massachusetts	4235	4169	4079	4	3	44	0	3	36	66	48	2	1	0	0	3	12
1400000US25009264100	25009264100	Census Tract 2641, Essex County, Massachusetts	6459	6374	6230	28	3	59	2	4	48	85	60	3	2	0	0	13	7
1400000US25009265101	25009265101	Census Tract 2651.01, Essex County, Massachusetts	3645	3580	3478	17	5	35	0	3	42	65	39	0	5	0	0	12	9
1400000US25009265102	25009265102	Census Tract 2651.02, Essex County, Massachusetts	4538	4460	4354	20	2	41	0	1	42	78	56	1	2	1	0	12	6
1400000US25009266100	25009266100	Census Tract 2661, Essex County, Massachusetts	4032	3962	3861	28	7	12	6	4	44	70	45	1	3	0	0	16	5
1400000US25009266200	25009266200	Census Tract 2662, Essex County, Massachusetts	5194	5083	4881	44	13	49	0	22	74	111	82	3	3	0	0	15	8
1400000US25009266300	25009266300	Census Tract 2663, Essex County, Massachusetts	3709	3640	3541	18	4	27	0	3	47	69	45	3	1	0	1	10	9
1400000US25009266400	25009266400	Census Tract 2664, Essex County, Massachusetts	3348	3288	3196	18	6	18	0	9	41	60	37	5	0	0	0	13	5
1400000US25009267101	25009267101	Census Tract 2671.01, Essex County, Massachusetts	3573	3517	3428	19	6	28	1	5	30	56	44	2	1	0	0	4	5
1400000US25009267102	25009267102	Census Tract 2671.02, Essex County, Massachusetts	4710	4638	4456	16	12	69	0	9	76	72	50	1	0	1	0	12	8
1400000US25009268100	25009268100	Census Tract 2681, Essex County, Massachusetts	2668	2617	2550	13	0	31	0	2	21	51	41	0	4	0	0	4	2
1400000US25009268200	25009268200	Census Tract 2682, Essex County, Massachusetts	6322	6215	5975	34	7	82	1	26	90	107	72	3	2	1	0	17	12
1400000US25009268300	25009268300	Census Tract 2683, Essex County, Massachusetts	4126	4058	3925	23	8	45	0	16	41	68	47	0	1	0	0	14	6
1400000US25009268400	25009268400	Census Tract 2684, Essex County, Massachusetts	4300	4235	4124	25	2	36	0	4	44	65	54	0	0	0	0	10	1
1400000US25009269100	25009269100	Census Tract 2691, Essex County, Massachusetts	6666	6599	6468	15	10	43	0	6	57	67	55	2	0	1	0	8	1
1400000US25009270100	25009270100	Census Tract 2701, Essex County, Massachusetts	5856	5797	5660	16	1	60	4	13	43	59	45	1	0	0	0	9	4
1400000US25009990100	25009990100	Census Tract 9901, Essex County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25011040100	25011040100	Census Tract 401, Franklin County, Massachusetts	4494	4447	4307	17	9	31	0	6	77	47	33	4	3	0	0	5	2
1400000US25011040200	25011040200	Census Tract 402, Franklin County, Massachusetts	4340	4303	4202	17	6	37	0	0	41	37	23	0	1	0	0	9	4
1400000US25011040300	25011040300	Census Tract 403, Franklin County, Massachusetts	3032	2976	2915	13	5	8	0	1	34	56	29	0	1	1	0	17	8
1400000US25011040400	25011040400	Census Tract 404, Franklin County, Massachusetts	3428	3368	3286	15	12	17	0	2	36	60	33	6	4	0	0	9	8
1400000US25011040501	25011040501	Census Tract 405.01, Franklin County, Massachusetts	4264	4118	3972	50	11	15	1	8	61	146	94	5	1	0	0	36	10
1400000US25011040502	25011040502	Census Tract 405.02, Franklin County, Massachusetts	3575	3499	3337	25	18	59	0	6	54	76	58	1	1	0	0	6	10
1400000US25011040600	25011040600	Census Tract 406, Franklin County, Massachusetts	4612	4508	4229	60	12	69	0	10	128	104	77	1	3	1	0	12	10
1400000US25011040701	25011040701	Census Tract 407.01, Franklin County, Massachusetts	4213	3867	3635	59	9	29	0	7	128	346	163	15	9	0	1	128	30
1400000US25011040702	25011040702	Census Tract 407.02, Franklin County, Massachusetts	4224	4132	3986	22	6	38	1	10	69	92	39	5	1	0	0	32	15
1400000US25011040800	25011040800	Census Tract 408, Franklin County, Massachusetts	5180	4973	4558	105	12	196	2	11	89	207	107	13	3	0	0	59	25
1400000US25011040900	25011040900	Census Tract 409, Franklin County, Massachusetts	5125	4993	4781	34	1	96	1	3	77	132	86	7	2	2	0	22	13
1400000US25011041000	25011041000	Census Tract 410, Franklin County, Massachusetts	3271	3104	2958	39	5	28	0	6	68	167	84	14	1	2	0	46	20
1400000US25011041100	25011041100	Census Tract 411, Franklin County, Massachusetts	3603	3521	3410	25	6	36	0	7	37	82	48	1	1	0	0	15	17
1400000US25011041200	25011041200	Census Tract 412, Franklin County, Massachusetts	3156	3041	2906	37	10	37	0	3	48	115	54	3	1	0	0	44	13
1400000US25011041300	25011041300	Census Tract 413, Franklin County, Massachusetts	4642	4400	4092	69	25	89	1	13	111	242	146	9	2	1	0	63	21
1400000US25011041400	25011041400	Census Tract 414, Franklin County, Massachusetts	2784	2537	2309	92	6	46	1	3	80	247	116	8	4	0	3	84	32
1400000US25011041501	25011041501	Census Tract 415.01, Franklin County, Massachusetts	3634	3575	3459	9	15	20	2	2	68	59	48	1	1	0	0	2	7
1400000US25011041502	25011041502	Census Tract 415.02, Franklin County, Massachusetts	3795	3760	3636	15	7	36	0	1	65	35	23	0	0	1	0	5	6
1400000US25013800101	25013800101	Census Tract 8001.01, Hampden County, Massachusetts	4052	2763	1990	614	7	65	1	1	85	1289	462	74	12	2	0	639	100
1400000US25013800102	25013800102	Census Tract 8001.02, Hampden County, Massachusetts	4119	2560	1719	655	8	56	3	8	111	1559	819	75	12	2	0	520	131
1400000US25013800201	25013800201	Census Tract 8002.01, Hampden County, Massachusetts	6334	3992	3050	659	16	113	0	15	139	2342	945	130	31	2	1	1048	185
1400000US25013800202	25013800202	Census Tract 8002.02, Hampden County, Massachusetts	1333	974	776	144	2	23	2	0	27	359	184	26	1	1	0	123	24
1400000US25013800300	25013800300	Census Tract 8003, Hampden County, Massachusetts	4395	2674	2043	473	6	50	0	5	97	1721	697	64	19	4	0	834	103
1400000US25013800400	25013800400	Census Tract 8004, Hampden County, Massachusetts	6726	3328	2397	699	11	84	4	9	124	3398	1363	164	48	4	3	1565	251
1400000US25013800500	25013800500	Census Tract 8005, Hampden County, Massachusetts	3366	1404	996	311	3	56	0	11	27	1962	682	101	20	5	0	1010	144
1400000US25013800600	25013800600	Census Tract 8006, Hampden County, Massachusetts	2620	251	105	85	2	9	0	9	41	2369	839	123	29	4	9	1189	176
1400000US25013800700	25013800700	Census Tract 8007, Hampden County, Massachusetts	4000	499	164	292	6	17	0	0	20	3501	1312	232	20	0	0	1720	217
1400000US25013800800	25013800800	Census Tract 8008, Hampden County, Massachusetts	2098	397	183	195	3	4	0	1	11	1701	803	102	18	2	5	678	93
1400000US25013800900	25013800900	Census Tract 8009, Hampden County, Massachusetts	4136	1164	523	534	4	39	0	15	49	2972	1326	166	41	2	7	1287	143
1400000US25013801101	25013801101	Census Tract 8011.01, Hampden County, Massachusetts	1862	639	301	255	4	43	0	2	34	1223	478	79	10	1	1	585	69
1400000US25013801102	25013801102	Census Tract 8011.02, Hampden County, Massachusetts	1537	934	591	271	7	31	1	1	32	603	209	30	5	1	2	331	25
1400000US25013801200	25013801200	Census Tract 8012, Hampden County, Massachusetts	2638	1056	466	526	4	17	0	1	42	1582	603	106	27	0	0	754	92
1400000US25013801300	25013801300	Census Tract 8013, Hampden County, Massachusetts	4636	2864	645	2043	15	19	4	3	135	1772	729	190	25	6	1	663	158
1400000US25013801401	25013801401	Census Tract 8014.01, Hampden County, Massachusetts	3992	2255	370	1769	6	16	0	2	92	1737	547	143	35	5	6	914	87
1400000US25013801402	25013801402	Census Tract 8014.02, Hampden County, Massachusetts	2016	1375	538	688	5	87	0	0	57	641	268	61	3	1	1	261	46
1400000US25013801501	25013801501	Census Tract 8015.01, Hampden County, Massachusetts	5361	3776	1757	1769	25	67	1	6	151	1585	577	129	27	11	2	723	116
1400000US25013801502	25013801502	Census Tract 8015.02, Hampden County, Massachusetts	3412	2127	934	1000	12	33	0	0	148	1285	447	60	6	3	0	662	107
1400000US25013801503	25013801503	Census Tract 8015.03, Hampden County, Massachusetts	4036	2741	1672	867	12	90	1	10	89	1295	492	115	10	0	0	567	111
1400000US25013801601	25013801601	Census Tract 8016.01, Hampden County, Massachusetts	5067	4461	3217	975	17	115	2	16	119	606	300	59	4	0	0	186	57
1400000US25013801602	25013801602	Census Tract 8016.02, Hampden County, Massachusetts	5108	4135	3022	906	8	72	4	7	116	973	432	94	13	11	3	371	49
1400000US25013801603	25013801603	Census Tract 8016.03, Hampden County, Massachusetts	4185	3506	2604	656	5	124	2	7	108	679	310	66	16	3	0	235	49
1400000US25013801604	25013801604	Census Tract 8016.04, Hampden County, Massachusetts	3767	3418	2879	374	10	81	0	6	68	349	230	38	0	1	0	55	25
1400000US25013801605	25013801605	Census Tract 8016.05, Hampden County, Massachusetts	4608	3643	2452	928	4	126	4	10	119	965	460	144	10	0	10	269	72
1400000US25013801700	25013801700	Census Tract 8017, Hampden County, Massachusetts	7577	5737	1963	3503	13	65	5	9	179	1840	646	224	23	1	13	793	140
1400000US25013801800	25013801800	Census Tract 8018, Hampden County, Massachusetts	4279	2250	377	1745	11	9	0	13	95	2029	643	179	15	10	0	1083	99
1400000US25013801901	25013801901	Census Tract 8019.01, Hampden County, Massachusetts	3938	1582	474	955	18	52	2	6	75	2356	845	195	26	4	0	1146	140
1400000US25013801902	25013801902	Census Tract 8019.02, Hampden County, Massachusetts	3614	1447	615	690	13	51	4	9	65	2167	814	138	39	4	0	1047	125
1400000US25013802000	25013802000	Census Tract 8020, Hampden County, Massachusetts	2849	810	379	358	4	34	0	6	29	2039	718	115	28	2	2	1058	116
1400000US25013802100	25013802100	Census Tract 8021, Hampden County, Massachusetts	6075	4105	2856	907	6	169	0	38	129	1970	678	126	20	1	2	1012	131
1400000US25013802200	25013802200	Census Tract 8022, Hampden County, Massachusetts	3308	1591	612	607	10	275	0	6	81	1717	624	108	21	1	0	883	80
1400000US25013802300	25013802300	Census Tract 8023, Hampden County, Massachusetts	6838	3384	1369	1291	15	578	2	3	126	3454	1188	258	27	1	13	1716	251
1400000US25013802400	25013802400	Census Tract 8024, Hampden County, Massachusetts	3544	3244	2753	278	2	147	0	3	61	300	177	32	3	4	0	51	33
1400000US25013802500	25013802500	Census Tract 8025, Hampden County, Massachusetts	6694	5877	4824	638	4	276	0	6	129	817	412	53	2	3	0	260	87
1400000US25013802601	25013802601	Census Tract 8026.01, Hampden County, Massachusetts	7038	4889	3058	1187	31	458	4	4	147	2149	760	135	10	11	0	1066	167
1400000US25013802602	25013802602	Census Tract 8026.02, Hampden County, Massachusetts	1902	1757	1574	87	0	64	1	0	31	145	68	5	2	0	0	58	12
1400000US25013810100	25013810100	Census Tract 8101, Hampden County, Massachusetts	6290	6129	5901	72	12	71	0	0	73	161	91	8	1	0	0	35	26
1400000US25013810200	25013810200	Census Tract 8102, Hampden County, Massachusetts	2710	2654	2584	17	5	9	0	4	35	56	26	5	0	0	0	11	14
1400000US25013810300	25013810300	Census Tract 8103, Hampden County, Massachusetts	3140	3066	2961	33	3	27	0	2	40	74	36	2	3	0	0	19	14
1400000US25013810403	25013810403	Census Tract 8104.03, Hampden County, Massachusetts	3931	3709	3517	54	2	33	4	14	85	222	115	6	4	0	0	73	24
1400000US25013810404	25013810404	Census Tract 8104.04, Hampden County, Massachusetts	3761	3616	3494	32	2	34	4	9	41	145	79	8	0	0	0	51	7
1400000US25013810412	25013810412	Census Tract 8104.12, Hampden County, Massachusetts	5933	5840	5694	26	3	52	0	16	49	93	78	2	0	0	0	9	4
1400000US25013810414	25013810414	Census Tract 8104.14, Hampden County, Massachusetts	7478	6755	6258	373	7	51	0	6	60	723	593	13	7	1	0	93	16
1400000US25013810601	25013810601	Census Tract 8106.01, Hampden County, Massachusetts	4267	3800	3515	123	7	90	8	13	44	467	227	29	4	0	0	174	33
1400000US25013810602	25013810602	Census Tract 8106.02, Hampden County, Massachusetts	2657	2594	2507	21	3	36	2	0	25	63	36	4	3	0	0	18	2
1400000US25013810700	25013810700	Census Tract 8107, Hampden County, Massachusetts	6151	5450	5108	148	12	71	1	8	102	701	298	37	4	0	1	309	52
1400000US25013810800	25013810800	Census Tract 8108, Hampden County, Massachusetts	3823	3135	2924	123	4	24	2	5	53	688	290	38	5	0	0	299	56
1400000US25013810901	25013810901	Census Tract 8109.01, Hampden County, Massachusetts	1948	1323	1157	83	4	18	0	31	30	625	260	33	2	0	0	282	48
1400000US25013810902	25013810902	Census Tract 8109.02, Hampden County, Massachusetts	4578	3726	3492	129	10	34	0	5	56	852	330	51	2	0	0	406	63
1400000US25013811000	25013811000	Census Tract 8110, Hampden County, Massachusetts	4622	4303	4132	65	5	53	0	0	48	319	215	9	2	0	0	78	15
1400000US25013811101	25013811101	Census Tract 8111.01, Hampden County, Massachusetts	5058	3703	3437	114	10	67	2	12	61	1355	781	89	44	4	3	383	51
1400000US25013811102	25013811102	Census Tract 8111.02, Hampden County, Massachusetts	6100	4242	3906	174	6	68	1	6	81	1858	930	168	36	4	9	583	128
1400000US25013811200	25013811200	Census Tract 8112, Hampden County, Massachusetts	4859	4525	4273	79	5	84	0	2	82	334	181	17	5	0	1	93	37
1400000US25013811301	25013811301	Census Tract 8113.01, Hampden County, Massachusetts	5494	4983	4695	111	9	96	2	10	60	511	276	25	2	1	0	180	27
1400000US25013811302	25013811302	Census Tract 8113.02, Hampden County, Massachusetts	5741	5318	4792	355	12	81	4	3	71	423	237	28	8	6	0	116	28
1400000US25013811400	25013811400	Census Tract 8114, Hampden County, Massachusetts	2447	240	188	26	3	1	0	2	20	2207	887	74	58	1	0	1087	100
1400000US25013811500	25013811500	Census Tract 8115, Hampden County, Massachusetts	2277	217	136	64	0	1	0	7	9	2060	789	136	25	0	12	943	155
1400000US25013811600	25013811600	Census Tract 8116, Hampden County, Massachusetts	3749	519	361	107	5	20	0	0	26	3230	1092	167	42	5	2	1712	210
1400000US25013811700	25013811700	Census Tract 8117, Hampden County, Massachusetts	2029	586	503	33	4	22	0	3	21	1443	594	71	20	3	2	662	91
1400000US25013811800	25013811800	Census Tract 8118, Hampden County, Massachusetts	4139	1775	1565	110	7	28	0	5	60	2364	927	107	25	1	1	1201	102
1400000US25013811900	25013811900	Census Tract 8119, Hampden County, Massachusetts	3555	3167	2999	57	7	59	0	1	44	388	219	17	0	0	1	130	21
1400000US25013812001	25013812001	Census Tract 8120.01, Hampden County, Massachusetts	3451	1677	1474	111	0	41	0	5	46	1774	689	125	24	5	1	845	85
1400000US25013812002	25013812002	Census Tract 8120.02, Hampden County, Massachusetts	4646	2675	2445	132	3	43	2	7	43	1971	850	86	28	6	0	906	95
1400000US25013812101	25013812101	Census Tract 8121.01, Hampden County, Massachusetts	5106	4741	4548	78	3	38	0	16	58	365	209	4	5	3	0	126	18
1400000US25013812103	25013812103	Census Tract 8121.03, Hampden County, Massachusetts	3836	2059	1782	134	4	68	1	2	68	1777	695	66	15	2	0	895	104
1400000US25013812104	25013812104	Census Tract 8121.04, Hampden County, Massachusetts	4645	2911	2650	109	7	81	4	13	47	1734	727	53	16	0	1	806	131
1400000US25013812201	25013812201	Census Tract 8122.01, Hampden County, Massachusetts	4600	4163	3654	146	8	260	3	10	82	437	235	18	0	2	0	152	30
1400000US25013812202	25013812202	Census Tract 8122.02, Hampden County, Massachusetts	4043	3532	3000	274	7	183	3	11	54	511	208	11	4	0	0	239	49
1400000US25013812300	25013812300	Census Tract 8123, Hampden County, Massachusetts	5861	4897	4070	269	6	398	5	2	147	964	430	52	24	4	0	381	73
1400000US25013812401	25013812401	Census Tract 8124.01, Hampden County, Massachusetts	6210	6065	5850	31	7	120	1	9	47	145	96	0	1	2	0	25	21
1400000US25013812403	25013812403	Census Tract 8124.03, Hampden County, Massachusetts	3796	3605	3353	76	4	123	0	0	49	191	116	4	2	0	0	58	11
1400000US25013812404	25013812404	Census Tract 8124.04, Hampden County, Massachusetts	3881	3658	3379	45	2	161	2	2	67	223	117	13	0	0	0	71	22
1400000US25013812500	25013812500	Census Tract 8125, Hampden County, Massachusetts	7665	6952	6591	124	5	100	3	3	126	713	437	26	9	2	0	192	47
1400000US25013812600	25013812600	Census Tract 8126, Hampden County, Massachusetts	6799	6584	6309	77	13	107	0	0	78	215	128	3	9	1	1	57	16
1400000US25013812701	25013812701	Census Tract 8127.01, Hampden County, Massachusetts	4078	3630	3439	39	10	63	0	4	75	448	245	30	3	1	1	144	24
1400000US25013812702	25013812702	Census Tract 8127.02, Hampden County, Massachusetts	5489	4587	4250	115	18	128	0	4	72	902	489	36	7	0	0	283	87
1400000US25013812800	25013812800	Census Tract 8128, Hampden County, Massachusetts	6666	6244	6088	53	4	42	3	0	54	422	241	9	3	0	0	141	28
1400000US25013812901	25013812901	Census Tract 8129.01, Hampden County, Massachusetts	3002	2847	2784	13	4	21	0	0	25	155	116	1	14	0	0	16	8
1400000US25013812902	25013812902	Census Tract 8129.02, Hampden County, Massachusetts	4802	4660	4535	33	1	43	2	0	46	142	92	8	0	2	0	34	6
1400000US25013812903	25013812903	Census Tract 8129.03, Hampden County, Massachusetts	2593	2493	2334	89	1	22	0	0	47	100	44	7	2	2	0	30	15
1400000US25013813000	25013813000	Census Tract 8130, Hampden County, Massachusetts	7234	7111	6985	27	19	20	0	1	59	123	78	6	2	0	0	15	22
1400000US25013813101	25013813101	Census Tract 8131.01, Hampden County, Massachusetts	5888	5784	5623	40	14	46	2	0	59	104	62	3	1	0	0	23	15
1400000US25013813102	25013813102	Census Tract 8131.02, Hampden County, Massachusetts	3614	3520	3405	39	9	31	1	1	34	94	67	3	0	0	0	13	11
1400000US25013813204	25013813204	Census Tract 8132.04, Hampden County, Massachusetts	3240	3181	3095	23	5	34	0	0	24	59	35	0	1	0	0	20	3
1400000US25013813205	25013813205	Census Tract 8132.05, Hampden County, Massachusetts	7481	7215	6956	83	8	103	0	2	63	266	203	3	2	0	0	34	24
1400000US25013813206	25013813206	Census Tract 8132.06, Hampden County, Massachusetts	4042	3916	3768	40	3	57	0	0	48	126	91	4	0	1	0	21	9
1400000US25013813207	25013813207	Census Tract 8132.07, Hampden County, Massachusetts	5111	4868	4583	94	6	129	0	12	44	243	148	10	6	3	0	60	16
1400000US25013813208	25013813208	Census Tract 8132.08, Hampden County, Massachusetts	2918	2836	2675	42	1	66	0	8	44	82	37	13	3	1	0	17	11
1400000US25013813209	25013813209	Census Tract 8132.09, Hampden County, Massachusetts	5646	5482	5210	101	6	107	0	3	55	164	98	13	4	1	0	35	13
1400000US25013813301	25013813301	Census Tract 8133.01, Hampden County, Massachusetts	7343	7140	6725	78	3	230	2	3	99	203	128	8	1	2	0	51	13
1400000US25013813303	25013813303	Census Tract 8133.03, Hampden County, Massachusetts	4387	4299	3965	35	0	259	0	1	39	88	69	3	0	0	0	9	7
1400000US25013813304	25013813304	Census Tract 8133.04, Hampden County, Massachusetts	4054	3975	3632	42	1	254	1	8	37	79	68	1	0	0	0	4	6
1400000US25013813401	25013813401	Census Tract 8134.01, Hampden County, Massachusetts	5243	5083	4773	88	5	150	0	6	61	160	93	7	0	0	0	40	20
1400000US25013813403	25013813403	Census Tract 8134.03, Hampden County, Massachusetts	3847	3765	3642	30	4	65	0	0	24	82	63	1	2	0	0	7	9
1400000US25013813404	25013813404	Census Tract 8134.04, Hampden County, Massachusetts	6630	6515	6197	94	0	161	0	10	53	115	90	2	0	1	0	12	10
1400000US25013813500	25013813500	Census Tract 8135, Hampden County, Massachusetts	5139	5064	4908	25	3	70	1	7	50	75	60	0	0	0	0	14	1
1400000US25013813601	25013813601	Census Tract 8136.01, Hampden County, Massachusetts	8146	7889	7402	201	1	177	1	10	97	257	163	14	3	0	0	49	28
1400000US25013813602	25013813602	Census Tract 8136.02, Hampden County, Massachusetts	6073	5937	5706	76	3	108	0	6	38	136	96	16	3	1	0	12	8
1400000US25013813701	25013813701	Census Tract 8137.01, Hampden County, Massachusetts	3462	3396	3313	28	2	23	0	1	29	66	45	0	0	0	0	8	13
1400000US25013813702	25013813702	Census Tract 8137.02, Hampden County, Massachusetts	5098	5011	4859	37	16	29	0	6	64	87	70	8	0	0	0	2	7
1400000US25013813801	25013813801	Census Tract 8138.01, Hampden County, Massachusetts	4319	4233	4119	31	15	14	0	2	52	86	63	1	0	0	0	16	6
1400000US25013813802	25013813802	Census Tract 8138.02, Hampden County, Massachusetts	3609	3530	3423	27	10	17	0	1	52	79	69	1	0	0	2	3	4
1400000US25015820101	25015820101	Census Tract 8201.01, Hampshire County, Massachusetts	6189	6053	5861	42	10	43	0	7	90	136	70	3	1	3	0	38	21
1400000US25015820102	25015820102	Census Tract 8201.02, Hampshire County, Massachusetts	3683	3430	3240	53	15	25	0	0	97	253	121	4	4	0	0	92	32
1400000US25015820202	25015820202	Census Tract 8202.02, Hampshire County, Massachusetts	1321	1280	1209	22	2	23	0	2	22	41	26	1	0	0	0	9	5
1400000US25015820203	25015820203	Census Tract 8202.03, Hampshire County, Massachusetts	8507	8227	7756	107	13	197	5	19	130	280	169	9	2	1	2	69	28
1400000US25015820204	25015820204	Census Tract 8202.04, Hampshire County, Massachusetts	6142	6037	5748	83	5	107	1	10	83	105	68	0	1	0	0	17	19
1400000US25015820300	25015820300	Census Tract 8203, Hampshire County, Massachusetts	6818	6371	4936	242	10	935	7	20	221	447	244	32	9	1	2	96	63
1400000US25015820400	25015820400	Census Tract 8204, Hampshire County, Massachusetts	12079	11475	9078	618	12	1350	1	57	359	604	281	87	5	8	0	153	70
1400000US25015820500	25015820500	Census Tract 8205, Hampshire County, Massachusetts	6342	5952	5215	169	7	396	1	20	144	390	219	31	4	2	0	91	43
1400000US25015820600	25015820600	Census Tract 8206, Hampshire County, Massachusetts	1681	1464	964	189	1	217	0	9	84	217	132	14	1	2	0	40	28
1400000US25015820700	25015820700	Census Tract 8207, Hampshire County, Massachusetts	4509	4068	3080	216	2	585	0	17	168	441	200	24	9	9	0	135	64
1400000US25015820801	25015820801	Census Tract 8208.01, Hampshire County, Massachusetts	5232	4654	3524	335	13	565	2	21	194	578	244	37	16	8	0	215	58
1400000US25015820802	25015820802	Census Tract 8208.02, Hampshire County, Massachusetts	1158	1078	920	46	2	61	0	2	47	80	39	4	1	1	0	22	13
1400000US25015820900	25015820900	Census Tract 8209, Hampshire County, Massachusetts	6240	6110	5941	23	13	68	1	4	60	130	80	2	2	1	0	36	9
1400000US25015821000	25015821000	Census Tract 8210, Hampshire County, Massachusetts	4251	4127	3986	45	5	54	0	4	33	124	85	0	1	0	0	28	10
1400000US25015821100	25015821100	Census Tract 8211, Hampshire County, Massachusetts	6939	6645	6280	95	10	117	7	18	118	294	174	9	0	2	0	84	25
1400000US25015821200	25015821200	Census Tract 8212, Hampshire County, Massachusetts	2127	1987	1308	166	1	403	2	6	101	140	77	12	2	2	0	33	14
1400000US25015821300	25015821300	Census Tract 8213, Hampshire County, Massachusetts	4197	4002	3734	62	4	127	0	5	70	195	126	4	0	1	0	45	19
1400000US25015821400	25015821400	Census Tract 8214, Hampshire County, Massachusetts	5250	5087	4695	96	8	210	1	5	72	163	104	6	1	3	0	36	13
1400000US25015821500	25015821500	Census Tract 8215, Hampshire County, Massachusetts	3279	3232	3168	22	3	16	0	4	19	47	28	0	0	1	0	13	5
1400000US25015821601	25015821601	Census Tract 8216.01, Hampshire County, Massachusetts	3424	3104	2712	109	6	217	0	8	52	320	149	14	2	6	0	108	41
1400000US25015821602	25015821602	Census Tract 8216.02, Hampshire County, Massachusetts	3844	3515	3273	82	8	65	2	10	75	329	148	24	8	1	4	110	34
1400000US25015821700	25015821700	Census Tract 8217, Hampshire County, Massachusetts	3725	3614	3391	71	10	66	1	7	68	111	63	2	2	0	0	39	5
1400000US25015821901	25015821901	Census Tract 8219.01, Hampshire County, Massachusetts	3291	3162	2849	75	6	140	1	12	79	129	75	0	2	0	2	44	6
1400000US25015821903	25015821903	Census Tract 8219.03, Hampshire County, Massachusetts	3425	3037	2753	114	10	94	0	7	59	388	169	17	4	2	0	173	23
1400000US25015821904	25015821904	Census Tract 8219.04, Hampshire County, Massachusetts	2764	2617	2401	43	7	79	0	19	68	147	76	2	2	0	0	57	10
1400000US25015822000	25015822000	Census Tract 8220, Hampshire County, Massachusetts	1962	1811	1292	129	2	290	0	10	88	151	76	12	2	2	0	34	25
1400000US25015822200	25015822200	Census Tract 8222, Hampshire County, Massachusetts	6114	5761	5359	77	10	197	3	11	104	353	239	5	2	3	1	59	44
1400000US25015822300	25015822300	Census Tract 8223, Hampshire County, Massachusetts	5372	5149	4887	52	8	125	3	6	68	223	139	2	0	0	0	67	15
1400000US25015822401	25015822401	Census Tract 8224.01, Hampshire County, Massachusetts	5842	5725	5503	37	11	108	0	3	63	117	83	2	0	1	0	23	8
1400000US25015822402	25015822402	Census Tract 8224.02, Hampshire County, Massachusetts	4839	4589	4287	71	12	145	0	4	70	250	127	10	0	1	1	80	31
1400000US25015822500	25015822500	Census Tract 8225, Hampshire County, Massachusetts	5792	5707	5593	20	5	32	0	3	54	85	45	2	0	1	0	22	15
1400000US25015822601	25015822601	Census Tract 8226.01, Hampshire County, Massachusetts	2180	2139	2090	4	5	3	2	0	35	41	24	5	0	0	0	7	5
1400000US25015822603	25015822603	Census Tract 8226.03, Hampshire County, Massachusetts	1607	1577	1558	2	1	8	0	2	6	30	18	1	1	0	0	3	7
1400000US25015822605	25015822605	Census Tract 8226.05, Hampshire County, Massachusetts	1222	1204	1189	1	1	5	1	0	7	18	10	1	0	0	0	3	4
1400000US25015822606	25015822606	Census Tract 8226.06, Hampshire County, Massachusetts	3536	3475	3391	11	3	23	0	8	39	61	43	0	2	0	0	8	8
1400000US25015822700	25015822700	Census Tract 8227, Hampshire County, Massachusetts	3197	3160	3078	18	1	27	0	3	33	37	30	0	0	0	0	6	1
1400000US25017300100	25017300100	Census Tract 3001, Middlesex County, Massachusetts	3074	3017	2954	9	2	10	1	2	39	57	32	3	3	0	0	9	10
1400000US25017301101	25017301101	Census Tract 3011.01, Middlesex County, Massachusetts	4024	3933	3781	35	7	48	0	4	58	91	64	1	1	1	0	16	8
1400000US25017301102	25017301102	Census Tract 3011.02, Middlesex County, Massachusetts	4902	4830	4725	19	10	26	0	4	46	72	54	1	0	0	0	11	6
1400000US25017310100	25017310100	Census Tract 3101, Middlesex County, Massachusetts	5267	3865	2854	492	9	290	1	86	133	1402	672	74	12	9	0	522	113
1400000US25017310200	25017310200	Census Tract 3102, Middlesex County, Massachusetts	5976	4863	3720	485	2	451	4	58	143	1113	518	39	4	4	0	455	93
1400000US25017310300	25017310300	Census Tract 3103, Middlesex County, Massachusetts	6016	4601	3322	553	8	498	0	68	152	1415	661	61	13	6	0	551	123
1400000US25017310400	25017310400	Census Tract 3104, Middlesex County, Massachusetts	3245	2122	1371	223	2	414	0	32	80	1123	506	63	6	15	4	435	94
1400000US25017310500	25017310500	Census Tract 3105, Middlesex County, Massachusetts	3449	3016	2231	205	10	483	2	29	56	433	192	28	0	2	1	172	38
1400000US25017310601	25017310601	Census Tract 3106.01, Middlesex County, Massachusetts	5746	5135	3876	255	9	868	1	27	99	611	350	15	1	1	2	168	74
1400000US25017310602	25017310602	Census Tract 3106.02, Middlesex County, Massachusetts	5825	5258	4076	321	4	687	0	51	119	567	280	40	3	7	0	200	37
1400000US25017310700	25017310700	Census Tract 3107, Middlesex County, Massachusetts	4441	3665	2059	231	4	1166	0	96	109	776	208	27	12	5	0	465	59
1400000US25017311100	25017311100	Census Tract 3111, Middlesex County, Massachusetts	2410	1618	582	137	11	822	0	22	44	792	283	53	25	3	2	363	63
1400000US25017311200	25017311200	Census Tract 3112, Middlesex County, Massachusetts	3267	2786	711	176	1	1801	0	24	73	481	124	31	4	21	0	250	51
1400000US25017311300	25017311300	Census Tract 3113, Middlesex County, Massachusetts	4057	3537	1599	245	1	1547	0	74	71	520	196	21	3	4	0	247	49
1400000US25017311400	25017311400	Census Tract 3114, Middlesex County, Massachusetts	5986	5131	2659	653	8	1539	3	113	156	855	364	34	15	5	0	361	76
1400000US25017311500	25017311500	Census Tract 3115, Middlesex County, Massachusetts	2974	2730	1488	155	1	972	3	44	67	244	79	12	2	7	0	111	33
1400000US25017311600	25017311600	Census Tract 3116, Middlesex County, Massachusetts	5295	4837	3110	189	2	1371	0	74	91	458	162	16	6	4	0	248	22
1400000US25017311700	25017311700	Census Tract 3117, Middlesex County, Massachusetts	5098	4417	1606	209	2	2374	7	54	165	681	275	40	2	15	0	289	60
1400000US25017311800	25017311800	Census Tract 3118, Middlesex County, Massachusetts	3513	2932	797	148	2	1848	0	27	110	581	223	9	17	6	0	284	42
1400000US25017311900	25017311900	Census Tract 3119, Middlesex County, Massachusetts	2429	1839	1224	144	9	309	2	85	66	590	242	34	3	6	0	270	35
1400000US25017312000	25017312000	Census Tract 3120, Middlesex County, Massachusetts	2938	2222	1388	175	16	450	1	92	100	716	351	52	5	8	0	241	59
1400000US25017312100	25017312100	Census Tract 3121, Middlesex County, Massachusetts	3149	2491	1400	208	4	651	0	137	91	658	277	33	1	7	0	291	49
1400000US25017312200	25017312200	Census Tract 3122, Middlesex County, Massachusetts	4309	3711	2364	274	2	911	1	64	95	598	269	25	0	13	0	255	36
1400000US25017312300	25017312300	Census Tract 3123, Middlesex County, Massachusetts	4931	4435	3573	232	5	433	0	90	102	496	261	18	3	4	1	177	32
1400000US25017312400	25017312400	Census Tract 3124, Middlesex County, Massachusetts	2354	1384	959	148	5	175	0	52	45	970	437	52	6	8	0	404	63
1400000US25017312501	25017312501	Census Tract 3125.01, Middlesex County, Massachusetts	4464	4062	3457	180	8	292	3	49	73	402	209	10	2	6	0	147	28
1400000US25017312502	25017312502	Census Tract 3125.02, Middlesex County, Massachusetts	3960	3686	3323	89	5	170	2	51	46	274	173	11	1	1	0	86	2
1400000US25017313101	25017313101	Census Tract 3131.01, Middlesex County, Massachusetts	5488	5361	4933	33	6	316	0	3	70	127	71	2	3	2	0	34	15
1400000US25017313102	25017313102	Census Tract 3131.02, Middlesex County, Massachusetts	5804	5666	5304	85	3	215	0	6	53	138	82	0	2	2	0	31	21
1400000US25017314101	25017314101	Census Tract 3141.01, Middlesex County, Massachusetts	6055	5840	5269	232	11	245	0	16	67	215	122	11	1	3	0	59	19
1400000US25017314102	25017314102	Census Tract 3141.02, Middlesex County, Massachusetts	7223	6927	6213	181	3	363	0	40	127	296	171	17	5	4	0	63	36
1400000US25017314200	25017314200	Census Tract 3142, Middlesex County, Massachusetts	5233	4993	4679	84	7	158	0	14	51	240	146	2	0	1	3	57	31
1400000US25017314301	25017314301	Census Tract 3143.01, Middlesex County, Massachusetts	8011	7673	7049	164	4	346	3	25	82	338	162	15	2	0	1	116	42
1400000US25017314302	25017314302	Census Tract 3143.02, Middlesex County, Massachusetts	2935	2875	2755	30	7	64	0	1	18	60	44	1	0	2	0	9	4
1400000US25017315100	25017315100	Census Tract 3151, Middlesex County, Massachusetts	5456	5345	5036	53	1	178	0	4	73	111	73	1	0	0	0	28	9
1400000US25017315200	25017315200	Census Tract 3152, Middlesex County, Massachusetts	7585	7428	6954	91	5	298	1	10	69	157	106	8	0	0	0	33	10
1400000US25017315401	25017315401	Census Tract 3154.01, Middlesex County, Massachusetts	3532	3416	3171	83	4	112	0	7	39	116	104	4	2	1	0	4	1
1400000US25017315402	25017315402	Census Tract 3154.02, Middlesex County, Massachusetts	2921	2871	2749	27	8	62	0	0	25	50	35	1	0	0	0	9	5
1400000US25017315403	25017315403	Census Tract 3154.03, Middlesex County, Massachusetts	1745	1726	1672	22	1	16	0	0	15	19	12	0	0	0	0	2	5
1400000US25017315500	25017315500	Census Tract 3155, Middlesex County, Massachusetts	7722	7573	7304	31	8	119	0	28	83	149	111	0	3	0	0	26	9
1400000US25017316101	25017316101	Census Tract 3161.01, Middlesex County, Massachusetts	5108	5016	4836	36	7	94	0	2	41	92	65	0	0	0	0	17	10
1400000US25017316102	25017316102	Census Tract 3161.02, Middlesex County, Massachusetts	6060	5957	5658	63	5	165	0	7	59	103	72	6	0	0	0	22	3
1400000US25017316201	25017316201	Census Tract 3162.01, Middlesex County, Massachusetts	4104	4031	3769	29	4	192	0	4	33	73	45	0	4	0	0	21	3
1400000US25017316202	25017316202	Census Tract 3162.02, Middlesex County, Massachusetts	4290	4190	3647	75	5	384	2	13	64	100	62	0	3	0	0	20	15
1400000US25017316300	25017316300	Census Tract 3163, Middlesex County, Massachusetts	8172	7931	6734	236	8	761	2	33	157	241	163	3	0	1	0	53	21
1400000US25017316400	25017316400	Census Tract 3164, Middlesex County, Massachusetts	6570	6343	5663	289	13	306	1	6	65	227	167	12	1	3	0	34	10
1400000US25017316500	25017316500	Census Tract 3165, Middlesex County, Massachusetts	5939	5740	5261	98	6	284	3	9	79	199	143	2	3	4	0	40	7
1400000US25017317101	25017317101	Census Tract 3171.01, Middlesex County, Massachusetts	6139	6013	5238	75	7	610	1	6	76	126	88	8	2	1	0	13	14
1400000US25017317102	25017317102	Census Tract 3171.02, Middlesex County, Massachusetts	4353	4253	3666	70	2	471	0	1	43	100	70	4	0	0	0	20	6
1400000US25017317103	25017317103	Census Tract 3171.03, Middlesex County, Massachusetts	4895	4819	4467	21	2	283	0	5	41	76	56	0	0	0	0	10	10
1400000US25017317201	25017317201	Census Tract 3172.01, Middlesex County, Massachusetts	2849	2797	2646	12	6	109	1	5	18	52	43	2	0	0	0	3	4
1400000US25017317202	25017317202	Census Tract 3172.02, Middlesex County, Massachusetts	3388	3325	3070	14	0	182	0	4	55	63	52	0	1	0	0	5	5
1400000US25017317203	25017317203	Census Tract 3172.03, Middlesex County, Massachusetts	4003	3947	3513	37	7	332	0	6	52	56	44	3	0	0	0	7	2
1400000US25017317301	25017317301	Census Tract 3173.01, Middlesex County, Massachusetts	2627	2542	2091	30	2	391	0	4	24	85	57	2	0	1	0	16	9
1400000US25017317302	25017317302	Census Tract 3173.02, Middlesex County, Massachusetts	5548	5420	4764	79	4	459	0	9	105	128	79	1	2	7	0	31	8
1400000US25017318100	25017318100	Census Tract 3181, Middlesex County, Massachusetts	6674	6585	5340	13	6	1124	1	13	88	89	61	6	2	0	0	16	4
1400000US25017318200	25017318200	Census Tract 3182, Middlesex County, Massachusetts	3853	3785	3317	26	0	382	0	6	54	68	55	0	1	0	0	6	6
1400000US25017318300	25017318300	Census Tract 3183, Middlesex County, Massachusetts	7516	7395	6411	19	5	826	0	11	123	121	101	3	1	0	0	13	3
1400000US25017318400	25017318400	Census Tract 3184, Middlesex County, Massachusetts	3908	3853	3357	16	1	429	0	1	49	55	36	0	2	1	0	4	12
1400000US25017320102	25017320102	Census Tract 3201.02, Middlesex County, Massachusetts	5040	4952	4592	43	2	224	0	14	77	88	75	1	1	0	0	9	2
1400000US25017320103	25017320103	Census Tract 3201.03, Middlesex County, Massachusetts	2795	2740	2463	31	3	213	0	0	30	55	38	0	0	0	0	11	6
1400000US25017320104	25017320104	Census Tract 3201.04, Middlesex County, Massachusetts	7090	6966	6632	48	3	217	0	14	52	124	102	0	2	1	0	7	12
1400000US25017321100	25017321100	Census Tract 3211, Middlesex County, Massachusetts	6992	6535	5543	196	6	436	0	178	176	457	271	13	3	1	0	129	40
1400000US25017321200	25017321200	Census Tract 3212, Middlesex County, Massachusetts	6267	5812	4781	146	10	267	0	366	242	455	271	20	1	0	0	137	26
1400000US25017321300	25017321300	Census Tract 3213, Middlesex County, Massachusetts	7497	6131	5202	230	12	175	9	299	204	1366	698	33	6	2	3	546	78
1400000US25017321400	25017321400	Census Tract 3214, Middlesex County, Massachusetts	3297	3136	2828	46	5	186	0	22	49	161	90	4	1	0	0	53	13
1400000US25017321500	25017321500	Census Tract 3215, Middlesex County, Massachusetts	6898	5673	4799	213	12	206	7	269	167	1225	598	3	26	1	6	521	70
1400000US25017321600	25017321600	Census Tract 3216, Middlesex County, Massachusetts	7548	7038	5800	150	7	657	0	249	175	510	266	7	2	2	0	191	42
1400000US25017322100	25017322100	Census Tract 3221, Middlesex County, Massachusetts	4671	4553	4335	31	3	115	0	20	49	118	66	0	2	1	0	45	4
1400000US25017322200	25017322200	Census Tract 3222, Middlesex County, Massachusetts	3687	3552	3270	63	1	80	0	55	83	135	83	2	0	2	0	34	14
1400000US25017322300	25017322300	Census Tract 3223, Middlesex County, Massachusetts	6090	5714	5235	122	5	160	0	84	108	376	254	2	12	2	0	79	27
1400000US25017322400	25017322400	Census Tract 3224, Middlesex County, Massachusetts	4615	4430	4105	60	4	71	0	91	99	185	126	9	0	0	0	34	16
1400000US25017323100	25017323100	Census Tract 3231, Middlesex County, Massachusetts	6590	6468	6079	44	9	213	0	10	113	122	90	0	2	5	0	15	10
1400000US25017324101	25017324101	Census Tract 3241.01, Middlesex County, Massachusetts	4761	4700	4410	31	1	179	0	3	76	61	49	0	1	2	0	1	8
1400000US25017324102	25017324102	Census Tract 3241.02, Middlesex County, Massachusetts	4163	4103	3829	15	5	171	0	9	74	60	40	8	3	0	0	5	4
1400000US25017325100	25017325100	Census Tract 3251, Middlesex County, Massachusetts	7427	7006	6045	425	15	266	11	41	203	421	215	14	4	4	5	133	46
1400000US25017326101	25017326101	Census Tract 3261.01, Middlesex County, Massachusetts	3896	3827	3636	21	2	106	1	4	57	69	47	0	0	0	0	14	8
1400000US25017326102	25017326102	Census Tract 3261.02, Middlesex County, Massachusetts	6750	6626	6328	24	5	187	0	4	78	124	100	1	0	1	0	14	8
1400000US25017327101	25017327101	Census Tract 3271.01, Middlesex County, Massachusetts	3586	3538	3440	13	5	35	0	2	43	48	35	0	3	1	0	5	4
1400000US25017327102	25017327102	Census Tract 3271.02, Middlesex County, Massachusetts	4333	4244	4073	36	7	64	0	13	51	89	59	10	1	0	1	9	9
1400000US25017327103	25017327103	Census Tract 3271.03, Middlesex County, Massachusetts	3578	3521	3433	1	2	34	0	5	46	57	42	0	2	0	1	7	5
1400000US25017328100	25017328100	Census Tract 3281, Middlesex County, Massachusetts	3179	3135	2993	6	3	97	4	0	32	44	38	1	0	1	0	0	4
1400000US25017330100	25017330100	Census Tract 3301, Middlesex County, Massachusetts	8231	8110	7841	26	4	168	0	7	64	121	99	0	6	0	0	10	6
1400000US25017330200	25017330200	Census Tract 3302, Middlesex County, Massachusetts	6661	6551	6150	58	12	229	0	17	85	110	84	0	1	0	0	19	6
1400000US25017331101	25017331101	Census Tract 3311.01, Middlesex County, Massachusetts	3011	2954	2704	35	2	161	8	1	43	57	38	1	0	0	0	15	3
1400000US25017331102	25017331102	Census Tract 3311.02, Middlesex County, Massachusetts	6971	6842	6516	40	9	204	0	4	69	129	84	9	0	0	0	16	20
1400000US25017331200	25017331200	Census Tract 3312, Middlesex County, Massachusetts	5346	5271	4939	43	1	204	4	17	63	75	50	2	1	0	1	17	4
1400000US25017331300	25017331300	Census Tract 3313, Middlesex County, Massachusetts	6997	6855	6441	44	3	262	0	17	88	142	97	0	2	0	0	30	13
1400000US25017332100	25017332100	Census Tract 3321, Middlesex County, Massachusetts	5972	5889	5066	79	3	650	0	3	88	83	67	0	1	0	0	11	4
1400000US25017332200	25017332200	Census Tract 3322, Middlesex County, Massachusetts	8376	8081	6194	371	18	1310	5	46	137	295	189	5	4	5	1	72	19
1400000US25017332300	25017332300	Census Tract 3323, Middlesex County, Massachusetts	6677	6572	5250	258	7	956	0	23	78	105	73	1	0	0	0	27	4
1400000US25017332400	25017332400	Census Tract 3324, Middlesex County, Massachusetts	3473	3378	2882	79	4	350	0	11	52	95	64	8	2	0	0	11	10
1400000US25017333100	25017333100	Census Tract 3331, Middlesex County, Massachusetts	7399	7222	6306	260	4	545	0	38	69	177	117	4	1	1	0	44	10
1400000US25017333200	25017333200	Census Tract 3332, Middlesex County, Massachusetts	5364	5202	4685	178	7	254	1	21	56	162	93	6	1	0	0	44	18
1400000US25017333300	25017333300	Census Tract 3333, Middlesex County, Massachusetts	4063	3764	3260	216	7	154	0	56	71	299	150	5	1	1	0	112	30
1400000US25017333400	25017333400	Census Tract 3334, Middlesex County, Massachusetts	6229	5877	4977	279	5	444	0	65	107	352	191	13	3	1	0	99	45
1400000US25017333501	25017333501	Census Tract 3335.01, Middlesex County, Massachusetts	5001	4790	4341	165	7	191	0	31	55	211	132	5	5	0	0	61	8
1400000US25017333502	25017333502	Census Tract 3335.02, Middlesex County, Massachusetts	3273	3030	2607	120	4	154	1	48	96	243	119	9	0	1	0	91	23
1400000US25017333600	25017333600	Census Tract 3336, Middlesex County, Massachusetts	6791	6511	4954	319	12	1028	0	66	132	280	175	13	4	1	0	60	27
1400000US25017334100	25017334100	Census Tract 3341, Middlesex County, Massachusetts	6718	6592	6104	90	4	309	3	13	69	126	83	5	5	1	0	24	8
1400000US25017334200	25017334200	Census Tract 3342, Middlesex County, Massachusetts	3968	3898	3726	19	1	108	0	5	39	70	44	0	3	0	0	13	10
1400000US25017334300	25017334300	Census Tract 3343, Middlesex County, Massachusetts	7605	7515	7220	27	1	212	0	3	52	90	70	0	0	1	0	13	6
1400000US25017334400	25017334400	Census Tract 3344, Middlesex County, Massachusetts	6456	6364	5827	47	4	400	3	5	78	92	67	0	0	0	0	15	10
1400000US25017335100	25017335100	Census Tract 3351, Middlesex County, Massachusetts	5728	5604	5397	49	7	99	0	5	47	124	80	6	2	0	0	32	4
1400000US25017335200	25017335200	Census Tract 3352, Middlesex County, Massachusetts	5637	5526	5272	54	1	149	0	6	44	111	88	2	1	0	0	17	3
1400000US25017335301	25017335301	Census Tract 3353.01, Middlesex County, Massachusetts	3852	3738	3483	50	6	134	0	5	60	114	65	3	3	1	0	31	11
1400000US25017335302	25017335302	Census Tract 3353.02, Middlesex County, Massachusetts	4621	4508	4258	18	4	156	0	8	64	113	79	1	1	0	0	22	10
1400000US25017335400	25017335400	Census Tract 3354, Middlesex County, Massachusetts	5094	4981	4771	43	4	121	0	2	40	113	80	3	1	0	0	22	7
1400000US25017336100	25017336100	Census Tract 3361, Middlesex County, Massachusetts	5360	5234	4878	86	3	172	1	12	82	126	104	1	1	1	0	13	6
1400000US25017336200	25017336200	Census Tract 3362, Middlesex County, Massachusetts	6142	6037	5743	54	3	169	0	6	62	105	77	2	1	0	1	12	12
1400000US25017336300	25017336300	Census Tract 3363, Middlesex County, Massachusetts	6664	6521	6158	91	3	171	0	5	93	143	98	2	6	0	1	30	6
1400000US25017336401	25017336401	Census Tract 3364.01, Middlesex County, Massachusetts	4260	4104	3373	238	1	359	0	45	88	156	80	18	0	1	0	43	14
1400000US25017336402	25017336402	Census Tract 3364.02, Middlesex County, Massachusetts	4557	4424	4009	156	1	149	0	32	77	133	74	8	3	0	2	37	9
1400000US25017337101	25017337101	Census Tract 3371.01, Middlesex County, Massachusetts	3095	3017	2827	50	8	81	0	6	45	78	41	8	2	0	0	24	3
1400000US25017337102	25017337102	Census Tract 3371.02, Middlesex County, Massachusetts	5042	4947	4612	50	4	213	0	9	59	95	60	3	2	0	0	17	13
1400000US25017337201	25017337201	Census Tract 3372.01, Middlesex County, Massachusetts	3192	3112	2898	53	2	103	0	31	25	80	55	4	0	0	0	19	2
1400000US25017337202	25017337202	Census Tract 3372.02, Middlesex County, Massachusetts	4849	4711	4459	49	0	154	1	11	37	138	75	3	2	2	0	42	14
1400000US25017337300	25017337300	Census Tract 3373, Middlesex County, Massachusetts	5259	5016	4608	137	4	172	4	26	65	243	132	22	2	2	0	60	25
1400000US25017338100	25017338100	Census Tract 3381, Middlesex County, Massachusetts	2964	2892	2385	33	1	376	0	4	93	72	54	3	4	1	0	6	4
1400000US25017338200	25017338200	Census Tract 3382, Middlesex County, Massachusetts	3869	3769	2837	97	2	712	1	13	107	100	64	4	0	2	0	17	13
1400000US25017338300	25017338300	Census Tract 3383, Middlesex County, Massachusetts	3180	3124	2927	28	3	123	0	3	40	56	50	1	0	0	1	2	2
1400000US25017338400	25017338400	Census Tract 3384, Middlesex County, Massachusetts	5745	5659	5075	20	3	470	2	11	78	86	70	0	0	1	0	12	3
1400000US25017338500	25017338500	Census Tract 3385, Middlesex County, Massachusetts	5616	5525	5085	35	3	311	5	9	77	91	78	0	1	2	0	3	7
1400000US25017339100	25017339100	Census Tract 3391, Middlesex County, Massachusetts	6442	6280	5641	242	13	246	0	45	93	162	110	2	12	1	0	24	13
1400000US25017339200	25017339200	Census Tract 3392, Middlesex County, Massachusetts	5830	5711	5324	115	2	168	1	15	86	119	82	5	1	0	0	17	14
1400000US25017339300	25017339300	Census Tract 3393, Middlesex County, Massachusetts	2890	2756	1580	884	5	114	0	35	138	134	57	15	6	0	1	29	26
1400000US25017339400	25017339400	Census Tract 3394, Middlesex County, Massachusetts	3326	3173	2703	199	7	156	0	35	73	153	91	6	0	0	0	45	11
1400000US25017339500	25017339500	Census Tract 3395, Middlesex County, Massachusetts	5399	5163	4185	312	8	408	0	84	166	236	170	11	0	1	0	35	19
1400000US25017339600	25017339600	Census Tract 3396, Middlesex County, Massachusetts	5024	4752	3737	467	4	298	1	125	120	272	128	18	8	3	0	90	25
1400000US25017339700	25017339700	Census Tract 3397, Middlesex County, Massachusetts	3878	3597	2539	547	3	279	0	118	111	281	142	20	4	1	0	79	35
1400000US25017339801	25017339801	Census Tract 3398.01, Middlesex County, Massachusetts	4410	4191	2781	285	10	945	0	112	58	219	104	14	1	1	0	76	23
1400000US25017339802	25017339802	Census Tract 3398.02, Middlesex County, Massachusetts	4557	4272	2904	687	13	484	3	55	126	285	140	30	6	0	0	98	11
1400000US25017339900	25017339900	Census Tract 3399, Middlesex County, Massachusetts	5171	4908	3936	424	8	236	2	197	105	263	157	13	1	0	0	66	26
1400000US25017340000	25017340000	Census Tract 3400, Middlesex County, Massachusetts	2594	2431	1793	335	3	127	0	87	86	163	86	8	1	0	0	51	17
1400000US25017340100	25017340100	Census Tract 3401, Middlesex County, Massachusetts	6652	6492	5666	290	5	395	0	35	101	160	77	10	3	2	0	44	24
1400000US25017341101	25017341101	Census Tract 3411.01, Middlesex County, Massachusetts	3675	3515	2214	299	0	905	0	24	73	160	77	17	2	3	0	43	18
1400000US25017341102	25017341102	Census Tract 3411.02, Middlesex County, Massachusetts	4564	4323	2596	455	3	1132	0	46	91	241	125	3	0	11	0	80	22
1400000US25017341200	25017341200	Census Tract 3412, Middlesex County, Massachusetts	6857	6418	3569	779	5	1735	1	197	132	439	198	21	0	19	0	160	41
1400000US25017341300	25017341300	Census Tract 3413, Middlesex County, Massachusetts	5439	5215	2174	681	9	2100	1	76	174	224	123	19	1	0	2	69	10
1400000US25017341400	25017341400	Census Tract 3414, Middlesex County, Massachusetts	6212	5504	3127	1092	11	896	1	211	166	708	332	50	3	10	0	230	83
1400000US25017341500	25017341500	Census Tract 3415, Middlesex County, Massachusetts	4780	4114	1857	1100	8	906	1	132	110	666	305	24	5	7	0	291	34
1400000US25017341600	25017341600	Census Tract 3416, Middlesex County, Massachusetts	6564	6196	3770	897	12	1194	3	115	205	368	212	27	2	0	0	97	30
1400000US25017341700	25017341700	Census Tract 3417, Middlesex County, Massachusetts	5298	4825	3439	762	2	455	1	55	111	473	303	42	5	1	0	74	48
1400000US25017341800	25017341800	Census Tract 3418, Middlesex County, Massachusetts	6554	5730	3047	1280	10	1043	2	129	219	824	381	33	1	13	0	334	62
1400000US25017341901	25017341901	Census Tract 3419.01, Middlesex County, Massachusetts	1387	1260	854	165	0	169	0	29	43	127	78	7	0	1	0	30	11
1400000US25017341902	25017341902	Census Tract 3419.02, Middlesex County, Massachusetts	8120	7358	4564	973	16	1363	4	236	202	762	346	70	9	8	0	286	43
1400000US25017342101	25017342101	Census Tract 3421.01, Middlesex County, Massachusetts	4457	3560	2563	577	13	171	3	135	98	897	420	32	9	7	0	377	52
1400000US25017342102	25017342102	Census Tract 3421.02, Middlesex County, Massachusetts	4066	3377	2349	643	16	140	0	125	104	689	340	32	11	0	3	247	56
1400000US25017342201	25017342201	Census Tract 3422.01, Middlesex County, Massachusetts	5268	4161	2751	924	16	181	1	173	115	1107	531	61	12	3	0	419	81
1400000US25017342202	25017342202	Census Tract 3422.02, Middlesex County, Massachusetts	3833	3115	2173	487	3	242	0	127	83	718	349	35	10	1	0	281	42
1400000US25017342300	25017342300	Census Tract 3423, Middlesex County, Massachusetts	6826	5481	3805	842	15	275	0	361	183	1345	507	34	2	1	0	703	98
1400000US25017342400	25017342400	Census Tract 3424, Middlesex County, Massachusetts	6055	4778	3130	713	10	388	5	351	181	1277	559	47	9	3	2	572	85
1400000US25017342500	25017342500	Census Tract 3425, Middlesex County, Massachusetts	6797	5215	3464	915	7	332	0	341	156	1582	701	51	13	5	0	702	110
1400000US25017342600	25017342600	Census Tract 3426, Middlesex County, Massachusetts	4365	3188	2081	551	4	253	4	220	75	1177	454	18	12	3	0	623	67
1400000US25017350103	25017350103	Census Tract 3501.03, Middlesex County, Massachusetts	1210	1099	905	85	0	63	0	27	19	111	43	3	0	0	0	50	15
1400000US25017350104	25017350104	Census Tract 3501.04, Middlesex County, Massachusetts	7275	5610	3377	1048	7	582	1	355	240	1665	605	65	23	4	5	879	84
1400000US25017350200	25017350200	Census Tract 3502, Middlesex County, Massachusetts	6567	5685	4117	548	3	548	1	223	245	882	325	34	10	1	3	433	76
1400000US25017350300	25017350300	Census Tract 3503, Middlesex County, Massachusetts	2441	2177	1669	184	4	182	0	80	58	264	152	7	3	1	0	80	21
1400000US25017350400	25017350400	Census Tract 3504, Middlesex County, Massachusetts	5568	5387	4778	125	7	330	0	26	121	181	130	6	0	2	1	22	20
1400000US25017350500	25017350500	Census Tract 3505, Middlesex County, Massachusetts	1629	1585	1425	33	1	86	1	1	38	44	32	2	1	0	1	6	2
1400000US25017350600	25017350600	Census Tract 3506, Middlesex County, Massachusetts	4572	4384	3584	104	3	544	0	12	137	188	119	9	3	4	0	37	16
1400000US25017350700	25017350700	Census Tract 3507, Middlesex County, Massachusetts	6048	5573	4380	647	4	334	0	41	167	475	199	35	1	0	1	200	39
1400000US25017350800	25017350800	Census Tract 3508, Middlesex County, Massachusetts	1828	1751	1433	145	0	123	0	4	46	77	49	6	1	0	0	15	6
1400000US25017350900	25017350900	Census Tract 3509, Middlesex County, Massachusetts	3314	3187	2811	55	5	234	1	3	78	127	87	11	1	1	0	16	11
1400000US25017351000	25017351000	Census Tract 3510, Middlesex County, Massachusetts	6450	6141	5135	169	8	678	3	28	120	309	196	11	7	3	0	70	22
1400000US25017351100	25017351100	Census Tract 3511, Middlesex County, Massachusetts	5622	5321	4467	267	4	436	3	41	103	301	169	18	1	4	0	87	22
1400000US25017351203	25017351203	Census Tract 3512.03, Middlesex County, Massachusetts	4241	4029	3239	137	9	495	2	30	117	212	138	5	2	1	0	42	24
1400000US25017351204	25017351204	Census Tract 3512.04, Middlesex County, Massachusetts	4129	3783	2784	252	4	503	1	121	118	346	173	4	6	0	2	125	36
1400000US25017351300	25017351300	Census Tract 3513, Middlesex County, Massachusetts	4233	3920	3089	242	7	289	1	131	161	313	159	12	16	1	1	97	27
1400000US25017351403	25017351403	Census Tract 3514.03, Middlesex County, Massachusetts	4028	2854	1899	313	8	345	1	194	94	1174	401	24	19	3	0	647	80
1400000US25017351404	25017351404	Census Tract 3514.04, Middlesex County, Massachusetts	4289	3353	2005	317	11	541	1	300	178	936	429	26	12	1	1	415	52
1400000US25017351500	25017351500	Census Tract 3515, Middlesex County, Massachusetts	2310	1898	1262	198	5	265	0	72	96	412	229	14	2	2	0	140	25
1400000US25017352101	25017352101	Census Tract 3521.01, Middlesex County, Massachusetts	1654	1422	895	102	1	372	0	5	47	232	178	5	0	1	0	40	8
1400000US25017352102	25017352102	Census Tract 3521.02, Middlesex County, Massachusetts	2277	2150	1668	88	0	319	2	17	56	127	77	5	3	3	0	31	8
1400000US25017352200	25017352200	Census Tract 3522, Middlesex County, Massachusetts	1849	1659	1160	159	6	259	0	30	45	190	91	31	1	0	0	53	14
1400000US25017352300	25017352300	Census Tract 3523, Middlesex County, Massachusetts	3450	3104	2102	232	4	641	0	16	109	346	223	24	4	1	0	56	38
1400000US25017352400	25017352400	Census Tract 3524, Middlesex County, Massachusetts	2126	1776	567	839	0	264	0	18	88	350	134	37	5	1	0	129	44
1400000US25017352500	25017352500	Census Tract 3525, Middlesex County, Massachusetts	2894	2610	1587	568	7	303	4	11	130	284	123	38	1	2	2	93	25
1400000US25017352600	25017352600	Census Tract 3526, Middlesex County, Massachusetts	2378	2113	1488	250	2	247	0	46	80	265	136	27	2	0	0	76	24
1400000US25017352700	25017352700	Census Tract 3527, Middlesex County, Massachusetts	2057	1829	1162	422	2	135	1	37	70	228	96	31	3	3	0	62	33
1400000US25017352800	25017352800	Census Tract 3528, Middlesex County, Massachusetts	2115	1901	1430	194	5	166	0	38	68	214	78	36	0	0	0	74	26
1400000US25017352900	25017352900	Census Tract 3529, Middlesex County, Massachusetts	2646	2508	2037	135	2	251	0	25	58	138	104	10	1	0	0	21	2
1400000US25017353000	25017353000	Census Tract 3530, Middlesex County, Massachusetts	3584	3271	2159	406	3	557	3	15	128	313	177	22	2	1	0	82	29
1400000US25017353101	25017353101	Census Tract 3531.01, Middlesex County, Massachusetts	2460	2194	1311	351	6	376	1	12	137	266	141	28	3	3	0	77	14
1400000US25017353102	25017353102	Census Tract 3531.02, Middlesex County, Massachusetts	5040	4479	2101	269	12	1836	0	14	247	561	400	20	1	8	2	78	52
1400000US25017353200	25017353200	Census Tract 3532, Middlesex County, Massachusetts	4897	4536	2826	458	5	1055	3	36	153	361	239	31	2	1	0	49	39
1400000US25017353300	25017353300	Census Tract 3533, Middlesex County, Massachusetts	3471	3301	2608	279	5	256	3	20	130	170	103	15	1	2	0	37	12
1400000US25017353400	25017353400	Census Tract 3534, Middlesex County, Massachusetts	2848	2607	1339	786	10	321	1	10	140	241	97	39	8	1	0	71	25
1400000US25017353500	25017353500	Census Tract 3535, Middlesex County, Massachusetts	2602	2427	1547	503	5	281	3	9	79	175	88	22	2	1	0	32	30
1400000US25017353600	25017353600	Census Tract 3536, Middlesex County, Massachusetts	4551	4305	3302	230	6	590	1	11	165	246	171	12	2	1	0	37	23
1400000US25017353700	25017353700	Census Tract 3537, Middlesex County, Massachusetts	5365	5011	3503	231	5	1003	0	22	247	354	242	11	3	4	0	61	33
1400000US25017353800	25017353800	Census Tract 3538, Middlesex County, Massachusetts	4702	4445	3299	240	1	754	0	24	127	257	210	7	0	3	0	24	13
1400000US25017353900	25017353900	Census Tract 3539, Middlesex County, Massachusetts	7090	6512	3743	509	10	1891	2	16	341	578	446	14	1	3	0	72	42
1400000US25017354000	25017354000	Census Tract 3540, Middlesex County, Massachusetts	4366	4102	3188	149	8	630	0	6	121	264	194	5	5	5	0	30	25
1400000US25017354100	25017354100	Census Tract 3541, Middlesex County, Massachusetts	2907	2760	2317	101	1	256	1	10	74	147	120	3	1	2	0	13	8
1400000US25017354200	25017354200	Census Tract 3542, Middlesex County, Massachusetts	2907	2812	2545	52	4	124	0	15	72	95	75	2	3	0	0	6	9
1400000US25017354300	25017354300	Census Tract 3543, Middlesex County, Massachusetts	3346	3100	2233	458	9	277	0	20	103	246	115	29	3	0	3	70	26
1400000US25017354400	25017354400	Census Tract 3544, Middlesex County, Massachusetts	1647	1580	1334	81	10	84	0	9	62	67	48	11	1	0	0	4	3
1400000US25017354500	25017354500	Census Tract 3545, Middlesex County, Massachusetts	2236	2124	1792	71	1	210	0	4	46	112	89	6	2	2	0	11	2
1400000US25017354600	25017354600	Census Tract 3546, Middlesex County, Massachusetts	4538	4304	2557	1066	9	489	0	23	160	234	145	32	1	1	0	38	17
1400000US25017354700	25017354700	Census Tract 3547, Middlesex County, Massachusetts	2509	2403	1942	150	2	219	1	7	82	106	71	2	5	1	0	19	8
1400000US25017354800	25017354800	Census Tract 3548, Middlesex County, Massachusetts	1903	1827	1550	83	0	134	0	7	53	76	48	1	2	2	0	15	8
1400000US25017354900	25017354900	Census Tract 3549, Middlesex County, Massachusetts	6058	5495	2140	1821	18	1241	5	34	236	563	187	95	15	5	0	180	81
1400000US25017355000	25017355000	Census Tract 3550, Middlesex County, Massachusetts	2689	2521	1827	306	0	277	0	8	103	168	101	13	2	4	0	25	23
1400000US25017356100	25017356100	Census Tract 3561, Middlesex County, Massachusetts	3110	2990	2658	31	2	202	1	5	91	120	88	1	2	1	0	18	10
1400000US25017356300	25017356300	Census Tract 3563, Middlesex County, Massachusetts	5040	4797	3861	261	3	526	4	30	112	243	144	27	0	1	0	53	18
1400000US25017356400	25017356400	Census Tract 3564, Middlesex County, Massachusetts	7247	7075	6387	93	2	449	0	20	124	172	124	3	9	0	1	19	16
1400000US25017356500	25017356500	Census Tract 3565, Middlesex County, Massachusetts	6580	6381	5535	118	3	534	1	46	144	199	117	4	1	3	0	50	24
1400000US25017356601	25017356601	Census Tract 3566.01, Middlesex County, Massachusetts	4216	4079	3475	112	5	384	0	12	91	137	91	6	1	0	0	22	17
1400000US25017356602	25017356602	Census Tract 3566.02, Middlesex County, Massachusetts	4169	4058	3606	93	3	268	0	19	69	111	68	4	0	1	0	23	15
1400000US25017356701	25017356701	Census Tract 3567.01, Middlesex County, Massachusetts	5844	5630	4690	144	3	650	0	19	124	214	141	10	2	1	0	28	32
1400000US25017356702	25017356702	Census Tract 3567.02, Middlesex County, Massachusetts	6638	6439	5592	129	8	528	1	27	154	199	140	4	5	2	0	26	22
1400000US25017357100	25017357100	Census Tract 3571, Middlesex County, Massachusetts	4185	4092	3499	29	4	477	0	5	78	93	77	0	0	2	0	8	6
1400000US25017357200	25017357200	Census Tract 3572, Middlesex County, Massachusetts	3202	3104	2630	32	2	357	0	6	77	98	76	1	0	0	0	7	14
1400000US25017357300	25017357300	Census Tract 3573, Middlesex County, Massachusetts	2973	2876	2395	54	0	343	1	15	68	97	65	3	5	3	0	12	9
1400000US25017357400	25017357400	Census Tract 3574, Middlesex County, Massachusetts	2339	2253	1989	28	0	169	0	10	57	86	57	1	0	0	0	18	10
1400000US25017357500	25017357500	Census Tract 3575, Middlesex County, Massachusetts	2130	2071	1751	21	0	241	0	4	54	59	33	0	2	1	0	10	13
1400000US25017357600	25017357600	Census Tract 3576, Middlesex County, Massachusetts	2432	2359	1907	60	2	336	1	6	47	73	41	1	0	3	0	26	2
1400000US25017357700	25017357700	Census Tract 3577, Middlesex County, Massachusetts	3727	3595	2866	135	5	477	1	21	90	132	91	0	3	0	0	26	12
1400000US25017357800	25017357800	Census Tract 3578, Middlesex County, Massachusetts	3741	3625	3081	84	5	324	0	13	118	116	81	6	0	2	0	15	12
1400000US25017358100	25017358100	Census Tract 3581, Middlesex County, Massachusetts	5105	5002	3989	76	1	813	0	12	111	103	86	1	1	0	0	3	12
1400000US25017358300	25017358300	Census Tract 3583, Middlesex County, Massachusetts	5526	5377	3700	144	3	1341	2	17	170	149	126	3	0	0	0	12	8
1400000US25017358400	25017358400	Census Tract 3584, Middlesex County, Massachusetts	4895	4775	3726	56	0	891	0	8	94	120	97	2	0	0	0	13	8
1400000US25017358500	25017358500	Census Tract 3585, Middlesex County, Massachusetts	4861	4760	3552	46	7	1023	0	17	115	101	74	2	2	0	0	13	10
1400000US25017358600	25017358600	Census Tract 3586, Middlesex County, Massachusetts	5947	5819	4382	57	7	1210	1	17	145	128	92	6	1	1	0	18	10
1400000US25017358700	25017358700	Census Tract 3587, Middlesex County, Massachusetts	5060	4948	3789	78	3	961	0	6	111	112	92	2	0	0	0	10	8
1400000US25017359100	25017359100	Census Tract 3591, Middlesex County, Massachusetts	6198	6017	5201	146	3	561	3	4	99	181	116	10	1	0	0	33	21
1400000US25017359300	25017359300	Census Tract 3593, Middlesex County, Massachusetts	7122	6947	5983	136	14	689	0	6	119	175	143	9	1	0	4	11	7
1400000US25017360100	25017360100	Census Tract 3601, Middlesex County, Massachusetts	1286	1094	843	129	6	41	3	2	70	192	119	18	3	3	0	33	16
1400000US25017360200	25017360200	Census Tract 3602, Middlesex County, Massachusetts	5076	4952	4423	95	4	306	3	19	102	124	91	11	0	1	0	13	8
1400000US25017361100	25017361100	Census Tract 3611, Middlesex County, Massachusetts	5657	5574	5296	35	2	177	0	8	56	83	69	0	2	0	0	8	4
1400000US25017361200	25017361200	Census Tract 3612, Middlesex County, Massachusetts	5765	5400	4578	462	1	276	0	16	67	365	251	17	0	0	0	86	11
1400000US25017361300	25017361300	Census Tract 3613, Middlesex County, Massachusetts	6246	6039	5528	151	5	255	0	8	92	207	128	8	4	1	0	44	22
1400000US25017362100	25017362100	Census Tract 3621, Middlesex County, Massachusetts	4852	4752	4257	14	1	380	1	10	89	100	73	6	0	1	0	12	8
1400000US25017363102	25017363102	Census Tract 3631.02, Middlesex County, Massachusetts	5909	5694	3905	102	5	1487	0	95	100	215	144	1	2	1	0	49	18
1400000US25017363103	25017363103	Census Tract 3631.03, Middlesex County, Massachusetts	3229	3149	2517	44	0	518	0	21	49	80	56	2	2	0	0	11	9
1400000US25017363104	25017363104	Census Tract 3631.04, Middlesex County, Massachusetts	6105	5962	4633	63	2	1167	3	19	75	143	98	3	0	2	0	30	10
1400000US25017363201	25017363201	Census Tract 3632.01, Middlesex County, Massachusetts	3219	3158	2635	6	2	455	0	6	54	61	54	0	1	0	0	4	2
1400000US25017363202	25017363202	Census Tract 3632.02, Middlesex County, Massachusetts	3462	3401	2865	17	4	435	0	18	62	61	46	0	0	2	0	10	3
1400000US25017364101	25017364101	Census Tract 3641.01, Middlesex County, Massachusetts	5266	5026	4718	93	9	123	1	21	61	240	162	8	1	0	0	53	16
1400000US25017364102	25017364102	Census Tract 3641.02, Middlesex County, Massachusetts	4840	4703	4392	66	3	151	0	31	60	137	93	3	0	1	0	27	13
1400000US25017365100	25017365100	Census Tract 3651, Middlesex County, Massachusetts	7732	7604	6911	60	2	475	2	24	130	128	102	2	0	1	0	10	13
1400000US25017365201	25017365201	Census Tract 3652.01, Middlesex County, Massachusetts	5607	5488	5023	25	1	323	3	17	96	119	87	4	2	0	3	14	9
1400000US25017365202	25017365202	Census Tract 3652.02, Middlesex County, Massachusetts	4320	4217	3845	52	3	242	1	11	63	103	68	6	1	0	0	23	5
1400000US25017366100	25017366100	Census Tract 3661, Middlesex County, Massachusetts	4697	4561	3830	61	3	593	2	13	59	136	109	5	0	0	0	10	12
1400000US25017366201	25017366201	Census Tract 3662.01, Middlesex County, Massachusetts	3598	3517	3193	20	1	243	0	5	55	81	65	6	0	1	0	4	5
1400000US25017366202	25017366202	Census Tract 3662.02, Middlesex County, Massachusetts	4699	4601	4059	20	0	448	0	3	71	98	74	1	0	1	0	16	6
1400000US25017367100	25017367100	Census Tract 3671, Middlesex County, Massachusetts	3959	3869	3342	20	3	436	0	4	64	90	80	1	0	0	0	6	3
1400000US25017367200	25017367200	Census Tract 3672, Middlesex County, Massachusetts	7302	7098	6051	189	2	678	0	30	148	204	138	20	3	0	0	30	13
1400000US25017368101	25017368101	Census Tract 3681.01, Middlesex County, Massachusetts	6101	5795	4452	284	10	914	0	35	100	306	199	9	1	3	0	66	28
1400000US25017368102	25017368102	Census Tract 3681.02, Middlesex County, Massachusetts	3627	3371	2560	300	0	431	0	10	70	256	130	4	6	0	0	108	8
1400000US25017368200	25017368200	Census Tract 3682, Middlesex County, Massachusetts	4294	3930	3287	219	5	325	0	9	85	364	160	20	3	1	0	151	29
1400000US25017368300	25017368300	Census Tract 3683, Middlesex County, Massachusetts	5345	4136	3148	418	7	449	1	44	69	1209	604	15	8	5	8	482	87
1400000US25017368400	25017368400	Census Tract 3684, Middlesex County, Massachusetts	8117	7352	5557	410	9	1162	2	30	182	765	451	25	0	6	1	235	47
1400000US25017368500	25017368500	Census Tract 3685, Middlesex County, Massachusetts	3297	2441	1827	144	6	385	9	21	49	856	321	12	8	0	12	453	50
1400000US25017368600	25017368600	Census Tract 3686, Middlesex County, Massachusetts	5196	3856	3300	231	5	224	6	19	71	1340	550	32	7	3	8	659	81
1400000US25017368700	25017368700	Census Tract 3687, Middlesex County, Massachusetts	2462	1593	1255	191	2	84	4	9	48	869	344	17	13	1	5	447	42
1400000US25017368800	25017368800	Census Tract 3688, Middlesex County, Massachusetts	4741	3609	2861	339	6	316	3	17	67	1132	491	20	11	3	6	540	61
1400000US25017368901	25017368901	Census Tract 3689.01, Middlesex County, Massachusetts	6801	6414	5421	213	2	658	3	18	99	387	250	16	14	3	2	76	26
1400000US25017368902	25017368902	Census Tract 3689.02, Middlesex County, Massachusetts	4320	3821	2607	542	4	542	1	38	87	499	321	17	2	1	0	130	28
1400000US25017369000	25017369000	Census Tract 3690, Middlesex County, Massachusetts	1528	1448	1192	47	2	174	0	4	29	80	62	4	0	0	0	13	1
1400000US25017369100	25017369100	Census Tract 3691, Middlesex County, Massachusetts	4803	4586	4211	121	8	170	2	18	56	217	136	1	0	0	0	73	7
1400000US25017370101	25017370101	Census Tract 3701.01, Middlesex County, Massachusetts	6488	6104	5355	195	7	391	1	47	108	384	198	25	4	8	0	117	32
1400000US25017370102	25017370102	Census Tract 3701.02, Middlesex County, Massachusetts	6751	6331	5150	224	7	761	1	37	151	420	272	9	0	3	2	113	21
1400000US25017370201	25017370201	Census Tract 3702.01, Middlesex County, Massachusetts	3757	3629	3229	74	1	214	0	13	98	128	91	3	2	0	0	24	8
1400000US25017370202	25017370202	Census Tract 3702.02, Middlesex County, Massachusetts	4149	3990	3699	67	5	129	0	29	61	159	108	2	5	0	0	32	12
1400000US25017370300	25017370300	Census Tract 3703, Middlesex County, Massachusetts	5644	5269	4343	192	2	445	7	84	196	375	219	23	3	1	2	83	44
1400000US25017370400	25017370400	Census Tract 3704, Middlesex County, Massachusetts	5126	4904	4289	131	3	346	1	34	100	222	138	5	1	6	0	50	22
1400000US25017373100	25017373100	Census Tract 3731, Middlesex County, Massachusetts	4755	4578	3793	139	8	500	1	29	108	177	100	6	0	0	0	59	12
1400000US25017373200	25017373200	Census Tract 3732, Middlesex County, Massachusetts	4391	4122	3359	106	2	555	2	28	70	269	148	13	0	2	0	87	19
1400000US25017373300	25017373300	Census Tract 3733, Middlesex County, Massachusetts	2799	2695	2234	79	0	304	0	16	62	104	50	6	0	5	0	20	23
1400000US25017373400	25017373400	Census Tract 3734, Middlesex County, Massachusetts	3204	3060	2641	60	2	283	0	7	67	144	81	7	4	2	0	35	15
1400000US25017373500	25017373500	Census Tract 3735, Middlesex County, Massachusetts	6187	5965	5203	70	1	514	3	31	143	222	179	2	4	1	0	22	14
1400000US25017373600	25017373600	Census Tract 3736, Middlesex County, Massachusetts	6026	5645	4747	146	1	599	1	9	142	381	268	15	5	7	1	51	34
1400000US25017373700	25017373700	Census Tract 3737, Middlesex County, Massachusetts	3790	3714	3309	47	3	238	1	11	105	76	58	2	2	0	0	8	6
1400000US25017373800	25017373800	Census Tract 3738, Middlesex County, Massachusetts	5923	5704	4627	134	2	806	1	13	121	219	158	6	0	0	0	28	27
1400000US25017373900	25017373900	Census Tract 3739, Middlesex County, Massachusetts	6373	6177	4975	115	2	965	2	17	101	196	146	8	0	4	0	26	12
1400000US25017374000	25017374000	Census Tract 3740, Middlesex County, Massachusetts	5237	5030	3931	200	6	775	0	19	99	207	128	9	4	2	0	46	18
1400000US25017374100	25017374100	Census Tract 3741, Middlesex County, Massachusetts	4647	4413	3216	173	5	895	4	13	107	234	138	10	1	3	0	65	17
1400000US25017374200	25017374200	Census Tract 3742, Middlesex County, Massachusetts	4194	4054	3416	100	1	438	2	22	75	140	109	2	2	1	0	15	11
1400000US25017374300	25017374300	Census Tract 3743, Middlesex County, Massachusetts	3494	3424	3087	35	2	226	0	9	65	70	53	6	0	0	0	6	5
1400000US25017374400	25017374400	Census Tract 3744, Middlesex County, Massachusetts	5743	5564	4830	76	2	515	1	14	126	179	129	11	1	3	0	16	19
1400000US25017374500	25017374500	Census Tract 3745, Middlesex County, Massachusetts	4339	4122	3407	142	6	457	0	5	105	217	147	6	4	0	0	47	13
1400000US25017374600	25017374600	Census Tract 3746, Middlesex County, Massachusetts	4829	4513	3814	114	6	471	0	27	81	316	159	12	5	1	0	118	21
1400000US25017374700	25017374700	Census Tract 3747, Middlesex County, Massachusetts	4477	4309	3483	107	3	611	0	13	92	168	118	6	1	0	0	40	3
1400000US25017374800	25017374800	Census Tract 3748, Middlesex County, Massachusetts	4738	4581	3729	165	4	607	0	11	65	157	104	25	2	0	0	21	5
1400000US25017382100	25017382100	Census Tract 3821, Middlesex County, Massachusetts	4911	4793	4199	93	0	423	0	10	68	118	91	5	1	0	0	19	2
1400000US25017382200	25017382200	Census Tract 3822, Middlesex County, Massachusetts	5158	5000	4559	117	9	205	0	22	88	158	113	8	0	0	0	25	12
1400000US25017382300	25017382300	Census Tract 3823, Middlesex County, Massachusetts	5568	5415	4982	67	9	231	1	23	102	153	99	7	2	6	1	25	13
1400000US25017382400	25017382400	Census Tract 3824, Middlesex County, Massachusetts	4523	4418	4163	36	3	132	1	22	61	105	62	6	2	0	0	27	8
1400000US25017382500	25017382500	Census Tract 3825, Middlesex County, Massachusetts	4418	4276	3800	111	0	266	1	18	80	142	88	3	3	4	0	32	12
1400000US25017382601	25017382601	Census Tract 3826.01, Middlesex County, Massachusetts	4269	4071	2962	138	5	804	1	56	105	198	102	8	0	1	0	68	19
1400000US25017382602	25017382602	Census Tract 3826.02, Middlesex County, Massachusetts	4159	4039	3524	85	2	314	5	25	84	120	78	8	6	0	0	19	9
1400000US25017383101	25017383101	Census Tract 3831.01, Middlesex County, Massachusetts	4217	3074	1686	299	13	55	6	548	467	1143	607	84	13	7	21	339	72
1400000US25017383102	25017383102	Census Tract 3831.02, Middlesex County, Massachusetts	4923	2570	1141	506	2	59	0	528	334	2353	1169	198	19	4	3	856	104
1400000US25017383200	25017383200	Census Tract 3832, Middlesex County, Massachusetts	6046	4470	2929	339	18	181	2	676	325	1576	680	48	22	2	0	714	110
1400000US25017383300	25017383300	Census Tract 3833, Middlesex County, Massachusetts	3042	2690	1993	145	7	111	1	335	98	352	112	20	5	4	0	179	32
1400000US25017383400	25017383400	Census Tract 3834, Middlesex County, Massachusetts	5540	4598	2881	384	14	309	3	702	305	942	497	53	16	2	0	304	70
1400000US25017383501	25017383501	Census Tract 3835.01, Middlesex County, Massachusetts	4259	3652	2464	246	12	481	2	291	156	607	257	38	4	1	0	273	34
1400000US25017383502	25017383502	Census Tract 3835.02, Middlesex County, Massachusetts	3773	3502	2981	163	3	153	0	89	113	271	136	15	3	2	0	99	16
1400000US25017383600	25017383600	Census Tract 3836, Middlesex County, Massachusetts	6138	5683	4421	372	8	482	1	268	131	455	225	30	3	3	0	172	22
1400000US25017383700	25017383700	Census Tract 3837, Middlesex County, Massachusetts	5213	4852	4091	201	3	295	0	136	126	361	205	6	0	0	3	112	35
1400000US25017383800	25017383800	Census Tract 3838, Middlesex County, Massachusetts	5360	5075	4423	148	4	290	0	75	135	285	138	10	7	2	1	104	23
1400000US25017383901	25017383901	Census Tract 3839.01, Middlesex County, Massachusetts	7628	7367	6602	225	8	353	2	62	115	261	189	11	2	1	1	39	18
1400000US25017383902	25017383902	Census Tract 3839.02, Middlesex County, Massachusetts	5227	5078	4383	124	9	414	0	55	93	149	77	3	0	3	0	56	10
1400000US25017384001	25017384001	Census Tract 3840.01, Middlesex County, Massachusetts	1437	1360	1092	54	0	148	0	41	25	77	39	3	4	0	0	24	7
1400000US25017384002	25017384002	Census Tract 3840.02, Middlesex County, Massachusetts	5515	5186	3538	240	3	971	1	261	172	329	166	28	3	0	0	110	22
1400000US25017385100	25017385100	Census Tract 3851, Middlesex County, Massachusetts	6717	6503	5721	110	3	492	0	80	97	214	139	6	2	1	0	45	21
1400000US25017385201	25017385201	Census Tract 3852.01, Middlesex County, Massachusetts	2568	2374	2058	69	3	121	0	83	40	194	94	10	2	0	3	69	16
1400000US25017385202	25017385202	Census Tract 3852.02, Middlesex County, Massachusetts	7308	6976	5751	190	10	837	0	73	115	332	215	6	3	1	0	87	20
1400000US25017386100	25017386100	Census Tract 3861, Middlesex County, Massachusetts	4119	4062	3845	16	1	137	0	10	53	57	42	0	0	0	0	9	6
1400000US25017387100	25017387100	Census Tract 3871, Middlesex County, Massachusetts	4257	4191	4005	32	2	82	0	18	52	66	54	0	0	0	0	10	2
1400000US25017387201	25017387201	Census Tract 3872.01, Middlesex County, Massachusetts	5464	5359	5047	60	7	154	2	39	50	105	73	0	1	1	0	21	9
1400000US25017387202	25017387202	Census Tract 3872.02, Middlesex County, Massachusetts	3826	3751	3593	25	3	95	0	4	31	75	53	1	0	5	0	13	3
1400000US25017388100	25017388100	Census Tract 3881, Middlesex County, Massachusetts	4996	4883	3940	24	1	813	1	14	90	113	83	0	1	1	0	18	10
1400000US25017388200	25017388200	Census Tract 3882, Middlesex County, Massachusetts	7211	6650	5739	574	12	200	5	11	109	561	474	5	4	1	1	59	17
1400000US25017388300	25017388300	Census Tract 3883, Middlesex County, Massachusetts	5420	3780	2531	240	7	815	4	55	128	1640	648	73	9	9	0	779	122
1400000US25017980000	25017980000	Census Tract 9800, Middlesex County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25019950100	25019950100	Census Tract 9501, Nantucket County, Massachusetts	1375	1345	1273	43	3	14	0	5	7	30	23	0	0	0	0	3	4
1400000US25019950200	25019950200	Census Tract 9502, Nantucket County, Massachusetts	4869	4267	3583	455	3	72	1	55	98	602	432	17	0	0	0	136	17
1400000US25019950307	25019950307	Census Tract 9503.07, Nantucket County, Massachusetts	342	338	331	1	0	2	0	0	4	4	0	0	0	0	0	4	0
1400000US25019950400	25019950400	Census Tract 9504, Nantucket County, Massachusetts	2422	2120	1898	146	0	27	0	13	36	302	253	6	0	0	0	35	8
1400000US25019950500	25019950500	Census Tract 9505, Nantucket County, Massachusetts	1164	1145	1107	19	0	3	0	6	10	19	13	1	0	0	0	3	2
1400000US25019990000	25019990000	Census Tract 9900, Nantucket County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25021400100	25021400100	Census Tract 4001, Norfolk County, Massachusetts	4977	4698	3609	232	3	698	1	18	137	279	193	3	3	2	1	57	20
1400000US25021400200	25021400200	Census Tract 4002, Norfolk County, Massachusetts	6132	5749	4247	156	6	1172	0	24	144	383	260	11	0	4	0	70	38
1400000US25021400300	25021400300	Census Tract 4003, Norfolk County, Massachusetts	4110	3922	3117	76	4	574	0	15	136	188	128	11	1	2	0	37	9
1400000US25021400400	25021400400	Census Tract 4004, Norfolk County, Massachusetts	5449	5219	4303	83	4	709	0	9	111	230	161	0	0	3	0	51	15
1400000US25021400500	25021400500	Census Tract 4005, Norfolk County, Massachusetts	5173	4936	4132	99	2	572	1	14	116	237	183	4	8	0	0	32	10
1400000US25021400600	25021400600	Census Tract 4006, Norfolk County, Massachusetts	5177	4960	4020	109	5	691	0	16	119	217	153	13	2	5	0	33	11
1400000US25021400700	25021400700	Census Tract 4007, Norfolk County, Massachusetts	3598	3429	2690	84	2	500	0	15	138	169	108	8	0	0	0	36	17
1400000US25021400800	25021400800	Census Tract 4008, Norfolk County, Massachusetts	5630	5358	3957	162	6	1068	8	14	143	272	195	9	3	2	1	29	33
1400000US25021400900	25021400900	Census Tract 4009, Norfolk County, Massachusetts	3865	3623	2424	237	2	850	0	7	103	242	138	29	2	4	0	50	19
1400000US25021401000	25021401000	Census Tract 4010, Norfolk County, Massachusetts	3149	2902	2141	180	2	460	0	12	107	247	145	13	4	1	0	59	25
1400000US25021401100	25021401100	Census Tract 4011, Norfolk County, Massachusetts	4441	4269	3530	113	2	532	0	12	80	172	120	11	0	1	0	22	18
1400000US25021401200	25021401200	Census Tract 4012, Norfolk County, Massachusetts	7031	6703	4870	297	4	1331	2	31	168	328	197	37	2	2	0	63	27
1400000US25021402101	25021402101	Census Tract 4021.01, Norfolk County, Massachusetts	3634	3441	3110	138	13	122	0	12	46	193	121	8	6	6	0	33	19
1400000US25021402102	25021402102	Census Tract 4021.02, Norfolk County, Massachusetts	4063	3719	3120	378	16	112	0	23	70	344	178	27	4	0	0	110	25
1400000US25021402200	25021402200	Census Tract 4022, Norfolk County, Massachusetts	2169	2013	1843	88	3	56	1	3	19	156	106	1	2	0	0	41	6
1400000US25021402300	25021402300	Census Tract 4023, Norfolk County, Massachusetts	4549	4400	4133	80	1	120	1	11	54	149	96	8	2	2	0	23	18
1400000US25021402400	25021402400	Census Tract 4024, Norfolk County, Massachusetts	6050	5734	5104	358	9	162	0	23	78	316	160	18	3	0	0	101	34
1400000US25021402500	25021402500	Census Tract 4025, Norfolk County, Massachusetts	4264	4069	3737	226	4	60	2	2	38	195	150	14	2	0	0	20	9
1400000US25021403100	25021403100	Census Tract 4031, Norfolk County, Massachusetts	6841	6710	6265	25	1	332	0	10	77	131	118	0	0	1	0	8	4
1400000US25021403300	25021403300	Census Tract 4033, Norfolk County, Massachusetts	4222	4123	3841	41	3	169	1	9	59	99	88	0	0	1	0	7	3
1400000US25021403400	25021403400	Census Tract 4034, Norfolk County, Massachusetts	6488	6328	5690	90	4	418	1	5	120	160	120	13	0	2	0	19	6
1400000US25021403500	25021403500	Census Tract 4035, Norfolk County, Massachusetts	5684	5551	4844	83	1	499	6	12	106	133	98	0	0	2	0	23	10
1400000US25021404100	25021404100	Census Tract 4041, Norfolk County, Massachusetts	4025	3833	3039	137	10	545	0	7	95	192	136	1	6	2	0	32	15
1400000US25021404201	25021404201	Census Tract 4042.01, Norfolk County, Massachusetts	3658	3582	3340	20	0	156	0	4	62	76	65	0	1	0	0	6	4
1400000US25021404202	25021404202	Census Tract 4042.02, Norfolk County, Massachusetts	4986	4747	4019	112	4	483	1	15	113	239	177	10	0	3	0	42	7
1400000US25021404301	25021404301	Census Tract 4043.01, Norfolk County, Massachusetts	5508	5383	4822	32	1	460	0	5	63	125	116	1	0	0	0	7	1
1400000US25021404302	25021404302	Census Tract 4043.02, Norfolk County, Massachusetts	3529	3433	2960	41	0	362	0	1	69	96	90	0	1	0	0	5	0
1400000US25021404400	25021404400	Census Tract 4044, Norfolk County, Massachusetts	6276	5984	4881	204	7	736	0	18	138	292	172	13	6	9	6	55	31
1400000US25021405100	25021405100	Census Tract 4051, Norfolk County, Massachusetts	5589	5506	5099	34	7	285	3	6	72	83	59	3	0	3	1	12	5
1400000US25021406101	25021406101	Census Tract 4061.01, Norfolk County, Massachusetts	5537	5444	5186	46	3	146	0	5	58	93	72	1	0	0	0	13	7
1400000US25021406102	25021406102	Census Tract 4061.02, Norfolk County, Massachusetts	6487	6400	6107	26	5	179	0	10	73	87	70	1	1	0	0	12	3
1400000US25021407100	25021407100	Census Tract 4071, Norfolk County, Massachusetts	7891	7755	7315	57	21	238	0	21	103	136	115	3	1	0	1	14	2
1400000US25021408101	25021408101	Census Tract 4081.01, Norfolk County, Massachusetts	7962	7828	7468	67	7	192	1	9	84	134	115	2	5	0	0	9	3
1400000US25021408102	25021408102	Census Tract 4081.02, Norfolk County, Massachusetts	4790	4674	4456	57	13	85	0	1	62	116	70	5	5	3	0	21	12
1400000US25021409101	25021409101	Census Tract 4091.01, Norfolk County, Massachusetts	6217	5470	4703	633	16	85	0	4	29	747	482	54	9	5	0	176	21
1400000US25021409102	25021409102	Census Tract 4091.02, Norfolk County, Massachusetts	5010	4955	4790	33	5	84	0	1	42	55	48	0	2	0	0	4	1
1400000US25021410100	25021410100	Census Tract 4101, Norfolk County, Massachusetts	6142	6061	5802	82	19	85	2	13	58	81	56	1	0	0	0	16	8
1400000US25021410300	25021410300	Census Tract 4103, Norfolk County, Massachusetts	4423	4351	4057	71	0	172	0	12	39	72	54	6	1	0	0	11	0
1400000US25021410400	25021410400	Census Tract 4104, Norfolk County, Massachusetts	6300	6144	5606	154	6	282	2	18	76	156	90	10	1	0	0	34	21
1400000US25021411100	25021411100	Census Tract 4111, Norfolk County, Massachusetts	7972	7751	7280	226	15	145	0	22	63	221	139	11	0	1	0	56	14
1400000US25021411200	25021411200	Census Tract 4112, Norfolk County, Massachusetts	6562	6425	5941	101	0	306	1	16	60	137	95	15	3	1	0	13	10
1400000US25021411301	25021411301	Census Tract 4113.01, Norfolk County, Massachusetts	5527	5464	5263	53	3	84	0	16	45	63	48	1	0	0	0	12	2
1400000US25021411302	25021411302	Census Tract 4113.02, Norfolk County, Massachusetts	4009	3779	3364	189	8	188	0	1	29	230	163	8	1	0	0	46	12
1400000US25021412100	25021412100	Census Tract 4121, Norfolk County, Massachusetts	6334	6229	5824	53	0	288	0	11	53	105	79	2	2	0	0	10	12
1400000US25021412200	25021412200	Census Tract 4122, Norfolk County, Massachusetts	3572	3522	3347	19	2	120	0	7	27	50	39	3	0	0	0	3	5
1400000US25021412300	25021412300	Census Tract 4123, Norfolk County, Massachusetts	4712	4630	4210	55	1	317	0	4	43	82	56	4	0	1	0	14	7
1400000US25021413100	25021413100	Census Tract 4131, Norfolk County, Massachusetts	5854	5681	5185	193	17	185	0	25	76	173	110	9	0	2	0	35	17
1400000US25021413200	25021413200	Census Tract 4132, Norfolk County, Massachusetts	6079	5835	5291	254	10	181	3	41	55	244	122	14	2	0	1	70	35
1400000US25021413300	25021413300	Census Tract 4133, Norfolk County, Massachusetts	4954	4776	4245	220	2	214	0	31	64	178	108	22	3	0	0	27	18
1400000US25021413401	25021413401	Census Tract 4134.01, Norfolk County, Massachusetts	3167	3061	2846	110	1	59	0	4	41	106	64	9	0	0	0	27	6
1400000US25021413402	25021413402	Census Tract 4134.02, Norfolk County, Massachusetts	4244	4031	2777	357	7	790	2	22	76	213	129	28	0	1	2	44	9
1400000US25021413500	25021413500	Census Tract 4135, Norfolk County, Massachusetts	4304	3991	3298	258	4	266	0	61	104	313	170	9	5	0	0	100	29
1400000US25021414100	25021414100	Census Tract 4141, Norfolk County, Massachusetts	5693	5561	4222	310	0	908	4	13	104	132	71	25	0	0	0	26	10
1400000US25021414200	25021414200	Census Tract 4142, Norfolk County, Massachusetts	7183	7011	5915	228	8	724	2	15	119	172	105	15	5	1	0	29	17
1400000US25021414300	25021414300	Census Tract 4143, Norfolk County, Massachusetts	4736	4667	4134	163	1	288	0	21	60	69	50	5	1	1	0	6	6
1400000US25021415101	25021415101	Census Tract 4151.01, Norfolk County, Massachusetts	4532	4444	3928	134	1	315	0	12	54	88	52	11	4	4	1	10	6
1400000US25021415102	25021415102	Census Tract 4151.02, Norfolk County, Massachusetts	7465	7255	6164	496	11	437	1	37	109	210	116	22	1	2	0	49	20
1400000US25021415200	25021415200	Census Tract 4152, Norfolk County, Massachusetts	5850	5612	4560	547	5	369	0	25	106	238	115	29	1	1	0	61	31
1400000US25021415300	25021415300	Census Tract 4153, Norfolk County, Massachusetts	3714	3654	3299	124	0	191	0	7	33	60	39	0	0	0	0	13	8
1400000US25021416101	25021416101	Census Tract 4161.01, Norfolk County, Massachusetts	5724	5612	5028	196	0	275	4	27	82	112	79	9	0	2	0	16	6
1400000US25021416102	25021416102	Census Tract 4161.02, Norfolk County, Massachusetts	3810	3694	3172	295	0	129	1	16	81	116	66	11	0	2	0	29	8
1400000US25021416200	25021416200	Census Tract 4162, Norfolk County, Massachusetts	6651	6263	3376	2319	11	246	0	86	225	388	118	108	8	0	0	111	43
1400000US25021416300	25021416300	Census Tract 4163, Norfolk County, Massachusetts	4749	4563	3417	801	17	160	0	36	132	186	98	33	1	3	0	35	16
1400000US25021416400	25021416400	Census Tract 4164, Norfolk County, Massachusetts	6069	5990	5496	94	2	301	0	13	84	79	51	6	0	0	0	12	10
1400000US25021417100	25021417100	Census Tract 4171, Norfolk County, Massachusetts	4264	4179	2919	84	5	1101	5	8	57	85	45	7	1	2	0	21	9
1400000US25021417200	25021417200	Census Tract 4172, Norfolk County, Massachusetts	8182	8024	4023	214	1	3640	2	21	123	158	72	8	1	5	0	63	9
1400000US25021417300	25021417300	Census Tract 4173, Norfolk County, Massachusetts	2681	2609	2071	88	5	395	1	11	38	72	44	8	0	0	0	19	1
1400000US25021417400	25021417400	Census Tract 4174, Norfolk County, Massachusetts	2566	2518	2397	21	8	66	0	1	25	48	29	3	0	0	0	13	3
1400000US25021417501	25021417501	Census Tract 4175.01, Norfolk County, Massachusetts	5004	4899	2837	106	2	1852	0	17	85	105	64	4	1	2	0	27	7
1400000US25021417502	25021417502	Census Tract 4175.02, Norfolk County, Massachusetts	4639	4494	2185	125	6	2099	0	9	70	145	85	13	1	1	0	37	8
1400000US25021417601	25021417601	Census Tract 4176.01, Norfolk County, Massachusetts	5196	5056	3271	131	3	1565	0	11	75	140	84	9	0	1	0	42	4
1400000US25021417602	25021417602	Census Tract 4176.02, Norfolk County, Massachusetts	5155	5015	3368	95	11	1441	0	11	89	140	77	16	1	3	0	34	9
1400000US25021417701	25021417701	Census Tract 4177.01, Norfolk County, Massachusetts	5417	5246	3756	282	5	1077	0	39	87	171	99	8	1	2	0	38	23
1400000US25021417702	25021417702	Census Tract 4177.02, Norfolk County, Massachusetts	2765	2700	2294	127	4	237	0	10	28	65	52	5	1	0	0	4	3
1400000US25021417801	25021417801	Census Tract 4178.01, Norfolk County, Massachusetts	5443	5307	4851	99	13	238	1	22	83	136	79	10	1	4	0	26	16
1400000US25021417802	25021417802	Census Tract 4178.02, Norfolk County, Massachusetts	3150	3023	1534	247	10	1113	0	20	99	127	44	23	4	3	0	36	17
1400000US25021417901	25021417901	Census Tract 4179.01, Norfolk County, Massachusetts	6048	5845	4066	410	15	1127	5	86	136	203	102	19	3	2	0	53	24
1400000US25021417902	25021417902	Census Tract 4179.02, Norfolk County, Massachusetts	3542	3362	2293	188	2	653	0	138	88	180	100	11	1	2	0	62	4
1400000US25021418002	25021418002	Census Tract 4180.02, Norfolk County, Massachusetts	7020	6732	4165	345	12	1973	0	106	131	288	133	11	10	4	0	96	34
1400000US25021418003	25021418003	Census Tract 4180.03, Norfolk County, Massachusetts	2481	2328	1713	168	1	351	4	23	68	153	89	12	2	0	0	40	10
1400000US25021418004	25021418004	Census Tract 4180.04, Norfolk County, Massachusetts	4280	4061	2599	312	11	968	1	60	110	219	105	27	7	5	0	59	16
1400000US25021418101	25021418101	Census Tract 4181.01, Norfolk County, Massachusetts	4837	4674	3345	226	12	1016	1	19	55	163	97	3	1	3	0	33	26
1400000US25021418102	25021418102	Census Tract 4181.02, Norfolk County, Massachusetts	3377	3171	2269	335	8	390	1	77	91	206	99	13	1	2	0	78	13
1400000US25021418200	25021418200	Census Tract 4182, Norfolk County, Massachusetts	6224	5939	4492	395	3	822	0	79	148	285	151	40	3	9	0	60	22
1400000US25021419100	25021419100	Census Tract 4191, Norfolk County, Massachusetts	5691	5577	4898	113	2	427	0	48	89	114	49	6	6	3	2	37	11
1400000US25021419200	25021419200	Census Tract 4192, Norfolk County, Massachusetts	5002	4867	4347	142	11	284	1	18	64	135	83	10	0	0	0	37	5
1400000US25021419300	25021419300	Census Tract 4193, Norfolk County, Massachusetts	3863	3649	2844	298	12	350	8	43	94	214	109	23	4	7	0	41	30
1400000US25021419400	25021419400	Census Tract 4194, Norfolk County, Massachusetts	3166	3085	2729	67	1	236	1	18	33	81	46	1	0	0	0	22	12
1400000US25021419500	25021419500	Census Tract 4195, Norfolk County, Massachusetts	3077	3022	2653	62	2	255	0	11	39	55	37	1	0	1	0	11	5
1400000US25021419600	25021419600	Census Tract 4196, Norfolk County, Massachusetts	6766	6641	5874	134	9	512	0	42	70	125	73	12	3	3	0	27	7
1400000US25021419700	25021419700	Census Tract 4197, Norfolk County, Massachusetts	3821	3759	3347	23	4	345	0	17	23	62	48	2	0	0	0	11	1
1400000US25021419800	25021419800	Census Tract 4198, Norfolk County, Massachusetts	4358	4254	3779	72	5	278	0	48	72	104	60	6	3	0	0	19	16
1400000US25021420100	25021420100	Census Tract 4201, Norfolk County, Massachusetts	7804	7294	3120	2555	15	1290	0	105	209	510	220	77	3	1	0	171	38
1400000US25021420201	25021420201	Census Tract 4202.01, Norfolk County, Massachusetts	3505	3308	1371	1270	2	481	1	82	101	197	82	35	5	1	0	56	18
1400000US25021420202	25021420202	Census Tract 4202.02, Norfolk County, Massachusetts	6303	5900	2280	2533	18	769	0	118	182	403	120	82	17	2	0	131	51
1400000US25021420301	25021420301	Census Tract 4203.01, Norfolk County, Massachusetts	6797	6268	2876	2304	11	724	0	163	190	529	205	111	12	2	1	135	63
1400000US25021420302	25021420302	Census Tract 4203.02, Norfolk County, Massachusetts	7703	7285	2906	3256	23	725	2	143	230	418	182	85	2	3	0	99	47
1400000US25021421100	25021421100	Census Tract 4211, Norfolk County, Massachusetts	5120	4859	3962	549	19	146	1	45	137	261	110	20	6	2	0	90	33
1400000US25021421200	25021421200	Census Tract 4212, Norfolk County, Massachusetts	5671	5458	4759	369	3	164	1	63	99	213	104	29	0	2	1	57	20
1400000US25021422100	25021422100	Census Tract 4221, Norfolk County, Massachusetts	5293	5188	4860	66	0	138	0	61	63	105	69	11	1	2	0	17	5
1400000US25021422200	25021422200	Census Tract 4222, Norfolk County, Massachusetts	6815	6688	6077	127	10	284	4	91	95	127	71	5	0	0	0	30	21
1400000US25021422301	25021422301	Census Tract 4223.01, Norfolk County, Massachusetts	2975	2929	2781	37	4	43	0	23	41	46	25	1	0	0	0	12	8
1400000US25021422302	25021422302	Census Tract 4223.02, Norfolk County, Massachusetts	6590	6384	5458	360	14	312	4	117	119	206	115	23	4	2	0	49	13
1400000US25021422400	25021422400	Census Tract 4224, Norfolk County, Massachusetts	7785	7593	6739	283	11	281	0	121	158	192	124	16	0	0	0	32	20
1400000US25021422501	25021422501	Census Tract 4225.01, Norfolk County, Massachusetts	4758	4589	3916	327	14	148	0	85	99	169	70	31	0	0	1	52	15
1400000US25021422502	25021422502	Census Tract 4225.02, Norfolk County, Massachusetts	5165	4959	4278	217	21	137	2	183	121	206	120	20	1	0	1	49	15
1400000US25021422600	25021422600	Census Tract 4226, Norfolk County, Massachusetts	6668	6515	6186	38	3	177	0	31	80	153	112	4	0	0	0	36	1
1400000US25021422700	25021422700	Census Tract 4227, Norfolk County, Massachusetts	3842	3731	3500	25	6	122	0	22	56	111	87	8	1	0	0	5	10
1400000US25021422800	25021422800	Census Tract 4228, Norfolk County, Massachusetts	3852	3755	3569	47	4	74	0	30	31	97	73	5	2	0	0	12	5
1400000US25021423100	25021423100	Census Tract 4231, Norfolk County, Massachusetts	7542	7446	7254	20	8	71	1	11	81	96	83	1	3	4	0	2	3
1400000US25021440100	25021440100	Census Tract 4401, Norfolk County, Massachusetts	8264	8117	7691	80	9	257	0	6	74	147	94	8	3	1	0	28	13
1400000US25021441202	25021441202	Census Tract 4412.02, Norfolk County, Massachusetts	2726	2683	2602	14	6	43	0	0	18	43	38	0	2	0	0	0	3
1400000US25021441203	25021441203	Census Tract 4412.03, Norfolk County, Massachusetts	3730	3691	3592	16	7	37	0	3	36	39	27	0	1	0	0	4	7
1400000US25021441204	25021441204	Census Tract 4412.04, Norfolk County, Massachusetts	4499	4448	4347	30	3	32	0	3	33	51	28	1	0	0	0	13	9
1400000US25021442101	25021442101	Census Tract 4421.01, Norfolk County, Massachusetts	5572	5450	5052	149	6	172	0	13	58	122	83	13	2	0	0	21	3
1400000US25021442102	25021442102	Census Tract 4421.02, Norfolk County, Massachusetts	7071	6961	6557	58	2	259	1	15	69	110	94	1	0	0	1	11	3
1400000US25021442103	25021442103	Census Tract 4421.03, Norfolk County, Massachusetts	6946	6831	6331	45	5	349	1	4	96	115	92	4	2	0	0	11	6
1400000US25021442201	25021442201	Census Tract 4422.01, Norfolk County, Massachusetts	4166	4092	3797	65	0	162	1	6	61	74	58	4	0	1	0	6	5
1400000US25021442202	25021442202	Census Tract 4422.02, Norfolk County, Massachusetts	7880	7681	7189	99	10	251	1	8	123	199	97	11	18	0	0	52	21
1400000US25021443101	25021443101	Census Tract 4431.01, Norfolk County, Massachusetts	7638	7403	6988	95	5	203	2	28	82	235	155	3	3	1	0	56	17
1400000US25021443102	25021443102	Census Tract 4431.02, Norfolk County, Massachusetts	8694	8520	7997	122	5	270	1	10	115	174	99	15	0	2	1	49	8
1400000US25021456101	25021456101	Census Tract 4561.01, Norfolk County, Massachusetts	3776	3679	2943	441	5	157	0	58	75	97	59	10	1	0	0	19	8
1400000US25021456102	25021456102	Census Tract 4561.02, Norfolk County, Massachusetts	4945	4773	3755	569	6	194	0	96	153	172	109	18	2	0	0	31	12
1400000US25021456200	25021456200	Census Tract 4562, Norfolk County, Massachusetts	3146	3071	2408	373	5	164	0	37	84	75	33	19	1	0	0	3	19
1400000US25021456301	25021456301	Census Tract 4563.01, Norfolk County, Massachusetts	1753	1665	1221	238	6	50	0	80	70	88	23	14	5	0	0	32	14
1400000US25021456302	25021456302	Census Tract 4563.02, Norfolk County, Massachusetts	5000	4833	4004	549	9	143	1	65	62	167	99	19	1	1	0	30	17
1400000US25021456401	25021456401	Census Tract 4564.01, Norfolk County, Massachusetts	2765	2674	2213	242	2	85	0	46	86	91	42	16	0	0	0	29	4
1400000US25021456402	25021456402	Census Tract 4564.02, Norfolk County, Massachusetts	5577	5391	4596	466	2	177	1	66	83	186	129	10	1	0	0	38	8
1400000US25021457100	25021457100	Census Tract 4571, Norfolk County, Massachusetts	4356	4235	3615	414	1	120	0	30	55	121	45	20	4	0	0	35	17
1400000US25021457200	25021457200	Census Tract 4572, Norfolk County, Massachusetts	5651	5556	5090	36	1	335	0	20	74	95	73	0	1	0	0	13	8
1400000US25023500101	25023500101	Census Tract 5001.01, Plymouth County, Massachusetts	3702	3650	3492	50	8	23	1	19	57	52	30	1	1	1	0	9	10
1400000US25023500103	25023500103	Census Tract 5001.03, Plymouth County, Massachusetts	2209	2184	2110	18	5	19	0	3	29	25	21	0	1	0	0	1	2
1400000US25023500104	25023500104	Census Tract 5001.04, Plymouth County, Massachusetts	4382	4286	4100	20	21	58	4	21	62	96	49	5	16	1	0	15	10
1400000US25023501101	25023501101	Census Tract 5011.01, Plymouth County, Massachusetts	3302	3276	3170	6	3	53	5	9	30	26	20	0	0	0	0	1	5
1400000US25023501102	25023501102	Census Tract 5011.02, Plymouth County, Massachusetts	8057	7957	7649	52	11	117	2	13	113	100	79	4	1	0	0	9	7
1400000US25023501201	25023501201	Census Tract 5012.01, Plymouth County, Massachusetts	3667	3634	3513	16	10	44	1	4	46	33	29	2	0	0	0	0	2
1400000US25023501202	25023501202	Census Tract 5012.02, Plymouth County, Massachusetts	7131	7049	6803	35	7	129	0	10	65	82	62	3	2	0	0	12	3
1400000US25023502101	25023502101	Census Tract 5021.01, Plymouth County, Massachusetts	6051	5950	5418	154	9	59	1	193	116	101	65	10	0	0	0	17	9
1400000US25023502102	25023502102	Census Tract 5021.02, Plymouth County, Massachusetts	5600	5439	4988	184	3	70	4	69	121	161	93	7	5	0	0	36	20
1400000US25023502200	25023502200	Census Tract 5022, Plymouth County, Massachusetts	5838	5752	5473	93	10	63	0	46	67	86	58	4	0	0	0	17	7
1400000US25023503101	25023503101	Census Tract 5031.01, Plymouth County, Massachusetts	7176	7091	6843	71	6	75	1	25	70	85	60	4	1	0	0	13	7
1400000US25023503102	25023503102	Census Tract 5031.02, Plymouth County, Massachusetts	6703	6660	6457	35	7	85	3	22	51	43	32	0	1	1	1	7	1
1400000US25023504101	25023504101	Census Tract 5041.01, Plymouth County, Massachusetts	5370	5287	5103	42	2	91	0	4	45	83	75	0	0	0	0	3	5
1400000US25023504102	25023504102	Census Tract 5041.02, Plymouth County, Massachusetts	5136	5091	4908	21	6	90	0	15	51	45	28	1	0	0	0	10	6
1400000US25023505101	25023505101	Census Tract 5051.01, Plymouth County, Massachusetts	6468	6396	6110	31	7	47	3	116	82	72	51	4	1	2	0	2	12
1400000US25023505102	25023505102	Census Tract 5051.02, Plymouth County, Massachusetts	4991	4941	4797	23	3	33	3	10	72	50	43	1	0	0	0	2	4
1400000US25023505200	25023505200	Census Tract 5052, Plymouth County, Massachusetts	6674	6605	6370	44	3	52	1	72	63	69	54	1	0	2	0	11	1
1400000US25023506101	25023506101	Census Tract 5061.01, Plymouth County, Massachusetts	6531	6448	6269	25	9	64	2	9	70	83	56	2	1	0	0	14	10
1400000US25023506102	25023506102	Census Tract 5061.02, Plymouth County, Massachusetts	5899	5796	5560	48	8	58	0	62	60	103	57	0	0	0	0	31	15
1400000US25023506202	25023506202	Census Tract 5062.02, Plymouth County, Massachusetts	2512	2490	2444	6	3	11	1	8	17	22	14	0	0	0	0	5	3
1400000US25023506203	25023506203	Census Tract 5062.03, Plymouth County, Massachusetts	5220	5161	5032	11	12	23	0	37	46	59	52	0	1	0	0	4	2
1400000US25023506204	25023506204	Census Tract 5062.04, Plymouth County, Massachusetts	4970	4922	4822	20	3	22	1	15	39	48	30	0	1	0	0	14	3
1400000US25023507101	25023507101	Census Tract 5071.01, Plymouth County, Massachusetts	5323	5254	5115	33	5	51	0	10	40	69	58	1	0	0	0	7	3
1400000US25023507103	25023507103	Census Tract 5071.03, Plymouth County, Massachusetts	4351	4286	4201	5	4	30	0	6	40	65	54	1	0	0	0	6	4
1400000US25023507104	25023507104	Census Tract 5071.04, Plymouth County, Massachusetts	5385	5335	5183	21	7	67	2	21	34	50	38	1	0	1	0	8	2
1400000US25023508101	25023508101	Census Tract 5081.01, Plymouth County, Massachusetts	6708	6635	6411	31	7	100	0	17	69	73	55	3	1	0	0	12	2
1400000US25023508102	25023508102	Census Tract 5081.02, Plymouth County, Massachusetts	5098	5042	4910	30	13	25	1	16	47	56	33	1	3	1	0	13	5
1400000US25023508200	25023508200	Census Tract 5082, Plymouth County, Massachusetts	6031	5967	5817	44	4	42	2	10	48	64	48	0	1	2	0	11	2
1400000US25023509101	25023509101	Census Tract 5091.01, Plymouth County, Massachusetts	6947	6862	6597	76	5	72	1	25	86	85	64	2	2	0	0	5	12
1400000US25023509102	25023509102	Census Tract 5091.02, Plymouth County, Massachusetts	5682	5627	5434	53	7	44	0	28	61	55	42	2	0	0	0	8	3
1400000US25023510100	25023510100	Census Tract 5101, Plymouth County, Massachusetts	4776	4454	3127	947	27	90	0	90	173	322	156	27	3	0	0	99	37
1400000US25023510200	25023510200	Census Tract 5102, Plymouth County, Massachusetts	5964	5477	3108	1516	22	167	1	398	265	487	192	59	1	1	0	179	55
1400000US25023510300	25023510300	Census Tract 5103, Plymouth County, Massachusetts	3798	3343	872	1451	6	111	4	489	410	455	133	82	4	0	1	175	60
1400000US25023510400	25023510400	Census Tract 5104, Plymouth County, Massachusetts	3706	3133	701	1417	14	61	0	682	258	573	228	71	6	0	4	217	47
1400000US25023510501	25023510501	Census Tract 5105.01, Plymouth County, Massachusetts	3358	3121	1618	1034	9	76	0	156	228	237	96	53	2	0	0	64	22
1400000US25023510502	25023510502	Census Tract 5105.02, Plymouth County, Massachusetts	5796	5275	2372	2075	14	172	2	328	312	521	210	78	8	0	2	182	41
1400000US25023510503	25023510503	Census Tract 5105.03, Plymouth County, Massachusetts	4296	4006	2035	1380	5	110	1	233	242	290	137	44	2	0	0	81	26
1400000US25023510600	25023510600	Census Tract 5106, Plymouth County, Massachusetts	2857	2726	2087	392	2	109	0	61	75	131	63	25	1	0	0	31	11
1400000US25023510700	25023510700	Census Tract 5107, Plymouth County, Massachusetts	5656	5226	2615	1747	11	206	2	360	285	430	172	83	2	0	0	130	43
1400000US25023510800	25023510800	Census Tract 5108, Plymouth County, Massachusetts	6339	5512	1170	2781	16	126	8	954	457	827	238	142	8	2	1	337	99
1400000US25023510900	25023510900	Census Tract 5109, Plymouth County, Massachusetts	2531	2125	602	916	14	21	2	367	203	406	143	65	5	2	1	133	57
1400000US25023511000	25023511000	Census Tract 5110, Plymouth County, Massachusetts	3040	2575	862	997	16	27	5	439	229	465	166	64	7	2	0	161	65
1400000US25023511100	25023511100	Census Tract 5111, Plymouth County, Massachusetts	5291	4911	3133	1295	16	113	0	169	185	380	172	38	0	2	0	122	46
1400000US25023511200	25023511200	Census Tract 5112, Plymouth County, Massachusetts	4849	4295	2303	1280	8	59	0	407	238	554	205	73	1	0	0	220	55
1400000US25023511301	25023511301	Census Tract 5113.01, Plymouth County, Massachusetts	5334	4725	2066	1643	16	92	0	494	414	609	233	71	5	0	6	234	60
1400000US25023511302	25023511302	Census Tract 5113.02, Plymouth County, Massachusetts	3531	3169	1789	1005	9	25	0	192	149	362	151	52	8	0	0	110	41
1400000US25023511400	25023511400	Census Tract 5114, Plymouth County, Massachusetts	3716	3186	908	1335	8	65	1	571	298	530	180	61	2	2	0	252	33
1400000US25023511500	25023511500	Census Tract 5115, Plymouth County, Massachusetts	4308	3751	926	1388	10	71	6	938	412	557	168	79	5	0	0	248	57
1400000US25023511600	25023511600	Census Tract 5116, Plymouth County, Massachusetts	7211	6455	2995	2122	16	148	1	750	423	756	286	108	8	6	0	262	86
1400000US25023511701	25023511701	Census Tract 5117.01, Plymouth County, Massachusetts	4655	4331	3011	846	4	157	1	161	151	324	144	38	0	2	0	104	36
1400000US25023511702	25023511702	Census Tract 5117.02, Plymouth County, Massachusetts	2798	2657	1968	372	10	125	3	90	89	141	80	24	1	1	0	25	10
1400000US25023520100	25023520100	Census Tract 5201, Plymouth County, Massachusetts	6458	6356	5986	110	24	84	2	71	79	102	69	5	1	1	0	14	12
1400000US25023520201	25023520201	Census Tract 5202.01, Plymouth County, Massachusetts	3952	3874	3618	41	5	57	0	114	39	78	25	7	5	0	0	38	3
1400000US25023520202	25023520202	Census Tract 5202.02, Plymouth County, Massachusetts	5575	5445	5013	162	12	141	0	41	76	130	77	17	0	1	0	25	10
1400000US25023521101	25023521101	Census Tract 5211.01, Plymouth County, Massachusetts	4303	4223	4026	53	13	46	4	28	53	80	51	3	0	0	0	18	8
1400000US25023521102	25023521102	Census Tract 5211.02, Plymouth County, Massachusetts	3316	3246	3094	38	5	31	1	17	60	70	44	0	0	0	0	16	10
1400000US25023521201	25023521201	Census Tract 5212.01, Plymouth County, Massachusetts	2904	2835	2721	37	4	11	0	19	43	69	44	1	0	0	0	18	6
1400000US25023521202	25023521202	Census Tract 5212.02, Plymouth County, Massachusetts	3966	3918	3762	48	10	20	0	29	49	48	26	0	3	3	0	5	11
1400000US25023522101	25023522101	Census Tract 5221.01, Plymouth County, Massachusetts	4745	4696	4514	54	2	23	0	37	66	49	35	6	0	0	0	4	4
1400000US25023522102	25023522102	Census Tract 5221.02, Plymouth County, Massachusetts	5464	5418	5271	42	0	25	1	12	67	46	30	2	1	0	0	10	3
1400000US25023523100	25023523100	Census Tract 5231, Plymouth County, Massachusetts	3044	2987	2820	39	11	42	0	20	55	57	29	3	0	0	0	9	16
1400000US25023523201	25023523201	Census Tract 5232.01, Plymouth County, Massachusetts	2897	2871	2707	65	5	20	0	25	49	26	16	0	1	0	0	7	2
1400000US25023523202	25023523202	Census Tract 5232.02, Plymouth County, Massachusetts	7853	7732	7477	105	9	55	0	17	69	121	90	4	2	0	0	15	10
1400000US25023524101	25023524101	Census Tract 5241.01, Plymouth County, Massachusetts	3035	2972	2829	46	0	37	0	19	41	63	49	0	0	0	0	9	5
1400000US25023524102	25023524102	Census Tract 5241.02, Plymouth County, Massachusetts	3881	3823	3647	55	7	38	0	24	52	58	39	3	0	0	0	15	1
1400000US25023525101	25023525101	Census Tract 5251.01, Plymouth County, Massachusetts	6305	6156	5734	154	11	123	0	39	95	149	79	15	5	0	0	37	13
1400000US25023525104	25023525104	Census Tract 5251.04, Plymouth County, Massachusetts	6289	6219	5906	157	8	55	0	22	71	70	49	3	0	0	0	10	8
1400000US25023525203	25023525203	Census Tract 5252.03, Plymouth County, Massachusetts	5595	5496	5147	187	5	59	0	24	74	99	72	4	0	1	0	14	8
1400000US25023525204	25023525204	Census Tract 5252.04, Plymouth County, Massachusetts	3382	3327	3136	84	5	29	0	14	59	55	34	7	0	0	0	11	3
1400000US25023525300	25023525300	Census Tract 5253, Plymouth County, Massachusetts	2063	1717	1136	533	23	16	0	4	5	346	251	20	2	0	0	65	8
1400000US25023526100	25023526100	Census Tract 5261, Plymouth County, Massachusetts	7518	7437	7236	45	4	42	0	17	93	81	55	0	2	0	0	8	16
1400000US25023530100	25023530100	Census Tract 5301, Plymouth County, Massachusetts	3808	3695	3439	127	18	42	1	17	51	113	55	11	3	0	0	33	11
1400000US25023530200	25023530200	Census Tract 5302, Plymouth County, Massachusetts	3600	3511	3038	136	19	40	3	143	132	89	53	2	1	0	0	27	6
1400000US25023530300	25023530300	Census Tract 5303, Plymouth County, Massachusetts	3782	3701	3445	54	7	36	3	67	89	81	57	2	0	2	0	15	5
1400000US25023530400	25023530400	Census Tract 5304, Plymouth County, Massachusetts	5823	5755	5570	48	6	66	0	21	44	68	45	4	8	0	0	5	6
1400000US25023530500	25023530500	Census Tract 5305, Plymouth County, Massachusetts	5680	5622	5211	98	21	74	2	72	144	58	43	0	1	0	0	10	4
1400000US25023530600	25023530600	Census Tract 5306, Plymouth County, Massachusetts	6364	6140	5602	360	25	30	2	70	51	224	184	9	1	0	0	22	8
1400000US25023530700	25023530700	Census Tract 5307, Plymouth County, Massachusetts	4242	4180	4039	37	9	41	3	7	44	62	40	0	0	0	0	13	9
1400000US25023530801	25023530801	Census Tract 5308.01, Plymouth County, Massachusetts	5587	5519	5355	40	7	46	2	4	65	68	43	0	0	0	0	11	14
1400000US25023530802	25023530802	Census Tract 5308.02, Plymouth County, Massachusetts	4785	4726	4546	43	15	24	0	15	83	59	44	1	2	0	0	6	6
1400000US25023530901	25023530901	Census Tract 5309.01, Plymouth County, Massachusetts	8328	8173	7757	113	33	81	4	35	150	155	115	9	2	0	0	24	5
1400000US25023530902	25023530902	Census Tract 5309.02, Plymouth County, Massachusetts	4469	4416	4236	50	15	34	2	20	59	53	38	3	0	0	0	12	0
1400000US25023540101	25023540101	Census Tract 5401.01, Plymouth County, Massachusetts	3783	3752	3630	30	2	29	0	20	41	31	26	2	0	0	0	0	3
1400000US25023540102	25023540102	Census Tract 5401.02, Plymouth County, Massachusetts	2570	2546	2484	15	3	12	0	4	28	24	20	0	0	0	0	4	0
1400000US25023540103	25023540103	Census Tract 5401.03, Plymouth County, Massachusetts	4249	4212	4073	33	8	45	1	14	38	37	29	0	0	0	0	2	6
1400000US25023541100	25023541100	Census Tract 5411, Plymouth County, Massachusetts	5232	5192	4973	51	4	33	0	44	87	40	31	0	0	0	0	2	7
1400000US25023542101	25023542101	Census Tract 5421.01, Plymouth County, Massachusetts	7131	7016	6742	89	11	34	0	41	99	115	91	6	0	0	1	7	10
1400000US25023542102	25023542102	Census Tract 5421.02, Plymouth County, Massachusetts	2552	2528	2389	65	7	10	0	21	36	24	20	0	0	0	0	2	2
1400000US25023542200	25023542200	Census Tract 5422, Plymouth County, Massachusetts	6114	6045	5865	70	11	19	0	26	54	69	64	1	0	0	0	2	2
1400000US25023542300	25023542300	Census Tract 5423, Plymouth County, Massachusetts	7319	7160	6734	118	19	105	2	31	151	159	105	12	8	2	1	17	14
1400000US25023543100	25023543100	Census Tract 5431, Plymouth County, Massachusetts	2820	2784	2708	23	2	22	0	5	24	36	23	1	6	0	0	3	3
1400000US25023544100	25023544100	Census Tract 5441, Plymouth County, Massachusetts	5629	5573	5294	79	13	27	0	55	105	56	37	3	0	0	0	12	4
1400000US25023544200	25023544200	Census Tract 5442, Plymouth County, Massachusetts	5880	5807	5628	53	5	19	1	29	72	73	43	1	0	0	0	16	13
1400000US25023545100	25023545100	Census Tract 5451, Plymouth County, Massachusetts	6446	6322	5566	192	22	48	1	264	229	124	78	9	5	0	0	24	8
1400000US25023545200	25023545200	Census Tract 5452, Plymouth County, Massachusetts	5669	5481	4764	152	31	44	4	256	230	188	105	16	3	3	0	36	25
1400000US25023545300	25023545300	Census Tract 5453, Plymouth County, Massachusetts	4413	4317	3623	238	38	28	0	189	201	96	50	9	6	0	0	17	14
1400000US25023545400	25023545400	Census Tract 5454, Plymouth County, Massachusetts	5294	5200	4641	146	34	27	0	141	211	94	47	7	2	0	0	23	15
1400000US25023560100	25023560100	Census Tract 5601, Plymouth County, Massachusetts	6045	5988	5770	41	7	36	1	61	72	57	42	0	1	0	0	12	2
1400000US25023561100	25023561100	Census Tract 5611, Plymouth County, Massachusetts	4907	4855	4509	82	5	31	2	122	104	52	41	0	0	0	0	5	6
1400000US25023561200	25023561200	Census Tract 5612, Plymouth County, Massachusetts	2929	2810	2563	116	3	43	0	16	69	119	56	12	0	2	0	38	11
1400000US25023990003	25023990003	Census Tract 9900.03, Plymouth County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25025000100	25025000100	Census Tract 1, Suffolk County, Massachusetts	4254	3633	2508	249	3	468	0	250	155	621	240	51	3	1	0	263	63
1400000US25025000201	25025000201	Census Tract 2.01, Suffolk County, Massachusetts	3854	3447	2728	244	5	322	2	70	76	407	190	32	3	5	0	139	38
1400000US25025000202	25025000202	Census Tract 2.02, Suffolk County, Massachusetts	3885	3289	2370	273	12	525	0	50	59	596	250	57	5	2	1	220	61
1400000US25025000301	25025000301	Census Tract 3.01, Suffolk County, Massachusetts	2740	2550	2050	124	0	295	0	24	57	190	100	7	6	3	0	60	14
1400000US25025000302	25025000302	Census Tract 3.02, Suffolk County, Massachusetts	3142	2913	2295	89	2	449	0	30	48	229	177	7	0	4	0	26	15
1400000US25025000401	25025000401	Census Tract 4.01, Suffolk County, Massachusetts	5672	5385	4089	132	2	1032	1	30	99	287	155	12	4	0	0	87	29
1400000US25025000402	25025000402	Census Tract 4.02, Suffolk County, Massachusetts	3648	3459	2734	69	0	543	2	28	83	189	129	3	0	1	0	45	11
1400000US25025000502	25025000502	Census Tract 5.02, Suffolk County, Massachusetts	6303	5857	4719	268	6	704	2	16	142	446	307	18	2	3	0	91	25
1400000US25025000503	25025000503	Census Tract 5.03, Suffolk County, Massachusetts	2211	2115	1739	55	2	264	0	11	44	96	59	2	1	1	0	26	7
1400000US25025000504	25025000504	Census Tract 5.04, Suffolk County, Massachusetts	4985	4667	3862	168	4	537	3	11	82	318	195	23	1	4	0	72	23
1400000US25025000601	25025000601	Census Tract 6.01, Suffolk County, Massachusetts	3571	3283	2480	82	2	540	0	94	85	288	165	12	0	1	0	95	15
1400000US25025000602	25025000602	Census Tract 6.02, Suffolk County, Massachusetts	3974	3333	2137	424	3	635	2	28	104	641	264	52	11	2	1	259	52
1400000US25025000701	25025000701	Census Tract 7.01, Suffolk County, Massachusetts	4446	4113	3050	179	4	728	4	42	106	333	176	19	4	2	0	109	23
1400000US25025000703	25025000703	Census Tract 7.03, Suffolk County, Massachusetts	2791	2609	1708	85	3	662	1	57	93	182	113	8	0	10	0	42	9
1400000US25025000704	25025000704	Census Tract 7.04, Suffolk County, Massachusetts	4801	4226	2873	288	3	874	4	73	111	575	336	29	10	5	1	156	38
1400000US25025000802	25025000802	Census Tract 8.02, Suffolk County, Massachusetts	8136	6670	4292	318	6	1565	3	250	236	1466	673	41	16	7	0	596	133
1400000US25025000803	25025000803	Census Tract 8.03, Suffolk County, Massachusetts	6584	6008	3935	384	8	1400	1	25	255	576	398	21	2	15	0	108	32
1400000US25025010103	25025010103	Census Tract 101.03, Suffolk County, Massachusetts	4569	4222	2574	130	4	1328	0	21	165	347	226	18	1	10	0	64	28
1400000US25025010104	25025010104	Census Tract 101.04, Suffolk County, Massachusetts	4804	4395	3140	128	8	967	0	14	138	409	299	1	2	7	0	72	28
1400000US25025010203	25025010203	Census Tract 102.03, Suffolk County, Massachusetts	5569	5000	3605	278	11	916	4	21	165	569	347	20	4	7	1	145	45
1400000US25025010204	25025010204	Census Tract 102.04, Suffolk County, Massachusetts	3173	2995	2134	90	3	669	0	7	92	178	114	3	1	3	1	44	12
1400000US25025010300	25025010300	Census Tract 103, Suffolk County, Massachusetts	4861	4404	3381	377	3	477	4	19	143	457	177	36	3	7	1	215	18
1400000US25025010403	25025010403	Census Tract 104.03, Suffolk County, Massachusetts	3003	2710	1686	295	10	628	0	10	81	293	144	22	0	4	0	95	28
1400000US25025010404	25025010404	Census Tract 104.04, Suffolk County, Massachusetts	5817	5431	4068	259	4	936	4	23	137	386	240	10	6	7	1	93	29
1400000US25025010405	25025010405	Census Tract 104.05, Suffolk County, Massachusetts	5522	5087	3767	426	10	717	2	15	150	435	233	45	8	2	0	116	31
1400000US25025010408	25025010408	Census Tract 104.08, Suffolk County, Massachusetts	1426	1293	1014	50	2	206	1	1	19	133	84	5	0	1	0	32	11
1400000US25025010500	25025010500	Census Tract 105, Suffolk County, Massachusetts	3044	2753	1970	308	4	405	1	12	53	291	193	14	1	0	0	61	22
1400000US25025010600	25025010600	Census Tract 106, Suffolk County, Massachusetts	2858	2702	2159	134	2	361	0	6	40	156	116	7	1	1	0	27	4
1400000US25025010701	25025010701	Census Tract 107.01, Suffolk County, Massachusetts	2478	2342	2009	57	2	211	0	14	49	136	96	4	0	4	0	22	10
1400000US25025010702	25025010702	Census Tract 107.02, Suffolk County, Massachusetts	2400	2298	2080	53	2	122	1	3	37	102	64	6	0	2	0	23	7
1400000US25025010801	25025010801	Census Tract 108.01, Suffolk County, Massachusetts	2783	2644	2336	62	3	186	0	5	52	139	104	10	0	0	0	17	8
1400000US25025010802	25025010802	Census Tract 108.02, Suffolk County, Massachusetts	3059	2940	2542	47	0	277	0	15	59	119	88	3	0	2	0	19	7
1400000US25025020101	25025020101	Census Tract 201.01, Suffolk County, Massachusetts	4193	4054	3782	26	1	186	1	19	39	139	114	3	0	1	0	12	9
1400000US25025020200	25025020200	Census Tract 202, Suffolk County, Massachusetts	3649	3475	3039	121	3	236	0	10	66	174	121	6	0	3	0	36	8
1400000US25025020301	25025020301	Census Tract 203.01, Suffolk County, Massachusetts	2023	1915	1403	51	2	416	0	4	39	108	82	3	0	1	0	19	3
1400000US25025020302	25025020302	Census Tract 203.02, Suffolk County, Massachusetts	1181	1120	1011	31	1	60	0	3	14	61	49	0	1	0	0	9	2
1400000US25025020303	25025020303	Census Tract 203.03, Suffolk County, Massachusetts	3400	3027	2047	564	6	329	1	8	72	373	317	11	0	2	0	35	8
1400000US25025030100	25025030100	Census Tract 301, Suffolk County, Massachusetts	1954	1886	1818	19	0	30	2	5	12	68	50	1	0	1	0	15	1
1400000US25025030200	25025030200	Census Tract 302, Suffolk County, Massachusetts	1665	1596	1523	8	6	36	1	6	16	69	57	0	1	1	0	4	6
1400000US25025030300	25025030300	Census Tract 303, Suffolk County, Massachusetts	4872	4633	3988	250	12	286	1	18	78	239	153	15	2	0	0	56	13
1400000US25025030400	25025030400	Census Tract 304, Suffolk County, Massachusetts	2451	2373	2253	13	5	74	0	6	22	78	58	1	1	0	0	16	2
1400000US25025030500	25025030500	Census Tract 305, Suffolk County, Massachusetts	2538	2445	2294	13	0	107	0	7	24	93	68	3	0	1	0	19	2
1400000US25025040100	25025040100	Census Tract 401, Suffolk County, Massachusetts	2168	2127	2052	11	2	46	0	1	15	41	25	1	1	0	0	12	2
1400000US25025040200	25025040200	Census Tract 402, Suffolk County, Massachusetts	1606	1255	861	224	2	130	0	15	23	351	147	54	3	0	0	131	16
1400000US25025040300	25025040300	Census Tract 403, Suffolk County, Massachusetts	3882	3498	3169	138	1	146	0	1	43	384	132	45	7	3	1	141	55
1400000US25025040401	25025040401	Census Tract 404.01, Suffolk County, Massachusetts	2439	2295	2002	50	4	203	1	5	30	144	68	17	1	1	0	42	15
1400000US25025040600	25025040600	Census Tract 406, Suffolk County, Massachusetts	2444	2386	2235	36	0	89	1	5	20	58	49	2	0	0	0	4	3
1400000US25025040801	25025040801	Census Tract 408.01, Suffolk County, Massachusetts	3900	3287	2139	305	9	720	8	35	71	613	285	66	5	1	0	204	52
1400000US25025050101	25025050101	Census Tract 501.01, Suffolk County, Massachusetts	5115	1975	1428	132	11	287	0	29	88	3140	1556	76	20	6	0	1266	216
1400000US25025050200	25025050200	Census Tract 502, Suffolk County, Massachusetts	5231	1804	1353	135	8	129	1	96	82	3427	1660	65	14	0	1	1422	265
1400000US25025050300	25025050300	Census Tract 503, Suffolk County, Massachusetts	2251	1223	650	231	4	236	0	40	62	1028	416	81	11	1	0	424	95
1400000US25025050400	25025050400	Census Tract 504, Suffolk County, Massachusetts	2372	1168	935	66	5	63	0	52	47	1204	704	24	4	4	0	406	62
1400000US25025050500	25025050500	Census Tract 505, Suffolk County, Massachusetts	1857	861	710	29	0	48	0	43	31	996	599	31	0	2	0	298	66
1400000US25025050600	25025050600	Census Tract 506, Suffolk County, Massachusetts	2063	689	523	40	5	45	0	44	32	1374	755	17	3	1	1	478	119
1400000US25025050700	25025050700	Census Tract 507, Suffolk County, Massachusetts	4504	1598	1225	82	5	86	0	154	46	2906	1226	42	29	2	7	1417	183
1400000US25025050901	25025050901	Census Tract 509.01, Suffolk County, Massachusetts	4165	1461	1215	70	3	86	0	50	37	2704	1557	29	16	7	0	931	164
1400000US25025051000	25025051000	Census Tract 510, Suffolk County, Massachusetts	4089	2517	2216	98	7	121	1	27	47	1572	919	43	19	4	1	508	78
1400000US25025051101	25025051101	Census Tract 511.01, Suffolk County, Massachusetts	6093	3918	3189	328	13	228	1	70	89	2175	1236	92	22	5	0	669	151
1400000US25025051200	25025051200	Census Tract 512, Suffolk County, Massachusetts	2379	1557	1349	59	4	52	0	50	43	822	507	29	4	5	5	227	45
1400000US25025060101	25025060101	Census Tract 601.01, Suffolk County, Massachusetts	3216	3172	3115	18	4	14	1	1	19	44	31	2	0	0	1	9	1
1400000US25025060200	25025060200	Census Tract 602, Suffolk County, Massachusetts	1916	1903	1884	3	0	7	0	0	9	13	10	0	0	1	0	2	0
1400000US25025060301	25025060301	Census Tract 603.01, Suffolk County, Massachusetts	3076	3048	2969	20	1	28	0	8	22	28	17	2	0	0	0	5	4
1400000US25025060400	25025060400	Census Tract 604, Suffolk County, Massachusetts	4904	4814	4626	50	5	85	2	2	44	90	60	1	2	1	0	24	2
1400000US25025060501	25025060501	Census Tract 605.01, Suffolk County, Massachusetts	3571	3499	3343	22	2	99	1	5	27	72	36	1	1	0	0	17	17
1400000US25025060600	25025060600	Census Tract 606, Suffolk County, Massachusetts	2357	2265	2039	29	7	150	1	6	33	92	71	4	0	0	0	11	6
1400000US25025060700	25025060700	Census Tract 607, Suffolk County, Massachusetts	1893	1016	354	381	1	185	0	37	58	877	218	108	4	9	0	456	82
1400000US25025060800	25025060800	Census Tract 608, Suffolk County, Massachusetts	3964	3858	3577	39	6	183	1	11	41	106	53	4	5	0	0	35	9
1400000US25025061000	25025061000	Census Tract 610, Suffolk County, Massachusetts	3098	2203	1284	464	3	342	0	49	61	895	242	133	13	4	0	386	117
1400000US25025061101	25025061101	Census Tract 611.01, Suffolk County, Massachusetts	2232	1297	449	467	7	313	2	9	50	935	361	140	13	0	4	331	86
1400000US25025061200	25025061200	Census Tract 612, Suffolk County, Massachusetts	3240	3084	2743	68	2	222	3	10	36	156	99	20	0	2	0	29	6
1400000US25025070101	25025070101	Census Tract 701.01, Suffolk County, Massachusetts	5902	5542	3524	274	3	1604	3	11	123	360	229	25	0	2	1	79	24
1400000US25025070200	25025070200	Census Tract 702, Suffolk County, Massachusetts	5218	5058	1749	182	3	3038	1	9	76	160	80	16	1	3	0	46	14
1400000US25025070300	25025070300	Census Tract 703, Suffolk County, Massachusetts	3909	3748	2983	105	4	567	1	17	71	161	108	5	0	1	0	27	20
1400000US25025070402	25025070402	Census Tract 704.02, Suffolk County, Massachusetts	1723	1565	110	221	2	1206	0	6	20	158	44	18	0	0	0	75	21
1400000US25025070500	25025070500	Census Tract 705, Suffolk County, Massachusetts	5460	4390	2962	381	4	937	0	17	89	1070	460	84	15	1	1	419	90
1400000US25025070600	25025070600	Census Tract 706, Suffolk County, Massachusetts	2240	2126	1838	91	3	130	1	15	48	114	64	5	0	0	0	34	11
1400000US25025070700	25025070700	Census Tract 707, Suffolk County, Massachusetts	2361	2167	1287	553	7	234	0	14	72	194	110	33	0	1	0	31	19
1400000US25025070800	25025070800	Census Tract 708, Suffolk County, Massachusetts	3706	3369	2307	685	3	264	0	20	90	337	172	45	2	1	0	84	33
1400000US25025070900	25025070900	Census Tract 709, Suffolk County, Massachusetts	3329	2615	1482	747	9	270	1	11	95	714	243	86	7	0	0	319	59
1400000US25025071101	25025071101	Census Tract 711.01, Suffolk County, Massachusetts	3753	3240	1837	593	17	670	1	38	84	513	180	50	7	1	0	234	41
1400000US25025071201	25025071201	Census Tract 712.01, Suffolk County, Massachusetts	3131	2373	1218	592	7	476	4	18	58	758	250	74	4	2	0	371	57
1400000US25025080100	25025080100	Census Tract 801, Suffolk County, Massachusetts	3350	2408	516	1448	6	44	0	283	111	942	606	89	12	0	0	187	48
1400000US25025080300	25025080300	Census Tract 803, Suffolk County, Massachusetts	1769	1261	83	1065	11	16	0	45	41	508	115	90	8	0	0	245	50
1400000US25025080401	25025080401	Census Tract 804.01, Suffolk County, Massachusetts	2710	1726	200	1349	16	66	0	15	80	984	288	187	12	1	0	368	128
1400000US25025080500	25025080500	Census Tract 805, Suffolk County, Massachusetts	3096	1767	233	1369	2	99	1	13	50	1329	413	304	9	2	2	481	118
1400000US25025080601	25025080601	Census Tract 806.01, Suffolk County, Massachusetts	4271	3528	2146	850	12	385	0	45	90	743	223	103	6	1	0	344	66
1400000US25025080801	25025080801	Census Tract 808.01, Suffolk County, Massachusetts	3885	2540	1258	791	19	386	0	12	74	1345	450	155	25	4	0	602	109
1400000US25025080900	25025080900	Census Tract 809, Suffolk County, Massachusetts	4008	3695	2601	329	5	660	4	8	88	313	147	31	5	0	0	89	41
1400000US25025081001	25025081001	Census Tract 810.01, Suffolk County, Massachusetts	4890	3940	2180	684	19	920	3	14	120	950	332	115	16	9	0	388	90
1400000US25025081100	25025081100	Census Tract 811, Suffolk County, Massachusetts	4091	3483	1953	876	6	549	1	15	83	608	278	75	5	6	1	185	58
1400000US25025081200	25025081200	Census Tract 812, Suffolk County, Massachusetts	3265	1545	393	962	3	83	0	17	87	1720	564	210	36	2	0	726	182
1400000US25025081300	25025081300	Census Tract 813, Suffolk County, Massachusetts	4760	2499	299	2012	22	39	5	27	95	2261	638	338	38	6	0	998	243
1400000US25025081400	25025081400	Census Tract 814, Suffolk County, Massachusetts	3003	2417	685	1516	18	92	0	18	88	586	145	132	19	1	0	238	51
1400000US25025081500	25025081500	Census Tract 815, Suffolk County, Massachusetts	2134	1618	177	1329	9	25	2	25	51	516	159	117	3	0	0	182	55
1400000US25025081700	25025081700	Census Tract 817, Suffolk County, Massachusetts	3820	3038	74	2725	18	58	1	37	125	782	188	165	16	5	0	330	78
1400000US25025081800	25025081800	Census Tract 818, Suffolk County, Massachusetts	2898	2162	78	1879	13	39	4	51	98	736	138	152	3	1	0	350	92
1400000US25025081900	25025081900	Census Tract 819, Suffolk County, Massachusetts	3115	2287	68	2046	16	18	0	45	94	828	195	169	5	0	0	376	83
1400000US25025082000	25025082000	Census Tract 820, Suffolk County, Massachusetts	2815	2281	52	2087	9	19	1	47	66	534	120	106	11	0	0	243	54
1400000US25025082100	25025082100	Census Tract 821, Suffolk County, Massachusetts	5025	3364	62	3093	21	32	1	44	111	1661	338	262	22	2	0	883	154
1400000US25025090100	25025090100	Census Tract 901, Suffolk County, Massachusetts	4571	3542	86	3231	28	30	1	51	115	1029	166	256	11	2	1	485	108
1400000US25025090200	25025090200	Census Tract 902, Suffolk County, Massachusetts	2233	1368	40	1176	5	45	0	53	49	865	184	108	14	0	4	481	74
1400000US25025090300	25025090300	Census Tract 903, Suffolk County, Massachusetts	3179	2097	47	1854	8	19	1	73	95	1082	270	193	12	9	1	515	82
1400000US25025090400	25025090400	Census Tract 904, Suffolk County, Massachusetts	3659	2454	89	1900	18	32	2	236	177	1205	299	255	25	4	1	477	144
1400000US25025090600	25025090600	Census Tract 906, Suffolk County, Massachusetts	2348	1856	93	916	8	36	3	605	195	492	140	101	8	0	0	194	49
1400000US25025090700	25025090700	Census Tract 907, Suffolk County, Massachusetts	4275	3896	2597	370	10	747	0	72	100	379	150	24	4	0	0	177	24
1400000US25025090901	25025090901	Census Tract 909.01, Suffolk County, Massachusetts	3730	2962	1400	659	10	742	5	62	84	768	274	101	10	0	0	332	51
1400000US25025091001	25025091001	Census Tract 910.01, Suffolk County, Massachusetts	2742	2530	1599	298	0	517	2	32	82	212	64	18	1	0	0	111	18
1400000US25025091100	25025091100	Census Tract 911, Suffolk County, Massachusetts	4861	4395	2260	597	16	1215	0	130	177	466	183	50	0	2	9	190	32
1400000US25025091200	25025091200	Census Tract 912, Suffolk County, Massachusetts	3234	2537	981	762	5	196	5	390	198	697	180	96	6	2	1	335	77
1400000US25025091300	25025091300	Census Tract 913, Suffolk County, Massachusetts	2499	1967	165	869	6	81	1	644	201	532	151	57	6	2	1	256	59
1400000US25025091400	25025091400	Census Tract 914, Suffolk County, Massachusetts	2741	1939	196	1267	6	26	1	262	181	802	217	106	5	1	0	414	59
1400000US25025091500	25025091500	Census Tract 915, Suffolk County, Massachusetts	4370	3453	407	1735	8	202	0	749	352	917	219	153	3	1	1	460	80
1400000US25025091600	25025091600	Census Tract 916, Suffolk County, Massachusetts	3138	2652	385	1015	9	805	0	263	175	486	104	64	0	8	0	263	47
1400000US25025091700	25025091700	Census Tract 917, Suffolk County, Massachusetts	3069	2437	200	1440	10	127	0	456	204	632	154	155	16	0	0	234	73
1400000US25025091800	25025091800	Census Tract 918, Suffolk County, Massachusetts	3452	2739	132	1798	14	59	0	524	212	713	162	149	3	1	0	366	32
1400000US25025091900	25025091900	Census Tract 919, Suffolk County, Massachusetts	3860	3036	94	2699	17	12	0	97	117	824	187	218	18	0	0	320	81
1400000US25025092000	25025092000	Census Tract 920, Suffolk County, Massachusetts	4945	3894	258	2676	11	467	4	220	258	1051	256	209	6	3	6	467	104
1400000US25025092101	25025092101	Census Tract 921.01, Suffolk County, Massachusetts	6451	5762	1906	1413	10	2026	3	181	223	689	214	80	15	19	0	299	62
1400000US25025092200	25025092200	Census Tract 922, Suffolk County, Massachusetts	3349	2927	740	1417	15	542	0	90	123	422	119	84	1	0	0	172	46
1400000US25025092300	25025092300	Census Tract 923, Suffolk County, Massachusetts	2893	2435	47	2222	5	21	0	41	99	458	113	92	4	0	0	201	48
1400000US25025092400	25025092400	Census Tract 924, Suffolk County, Massachusetts	5277	3807	56	3470	32	43	0	60	146	1470	354	320	20	4	0	625	147
1400000US25025100100	25025100100	Census Tract 1001, Suffolk County, Massachusetts	5510	3907	57	3542	17	48	4	112	127	1603	398	368	8	5	0	697	127
1400000US25025100200	25025100200	Census Tract 1002, Suffolk County, Massachusetts	2787	2374	37	2185	4	27	0	49	72	413	67	134	10	0	0	159	43
1400000US25025100300	25025100300	Census Tract 1003, Suffolk County, Massachusetts	3303	2951	120	2643	7	23	0	65	93	352	60	107	1	0	0	138	46
1400000US25025100400	25025100400	Census Tract 1004, Suffolk County, Massachusetts	4865	4408	557	3320	19	233	0	110	169	457	91	141	2	2	0	159	62
1400000US25025100500	25025100500	Census Tract 1005, Suffolk County, Massachusetts	5989	5021	796	3317	14	572	1	115	206	968	244	228	26	0	1	374	95
1400000US25025100601	25025100601	Census Tract 1006.01, Suffolk County, Massachusetts	5154	4676	2102	1418	8	839	2	174	133	478	115	124	1	5	0	172	61
1400000US25025100603	25025100603	Census Tract 1006.03, Suffolk County, Massachusetts	1904	1775	1314	235	1	160	1	20	44	129	67	23	0	0	1	34	4
1400000US25025100700	25025100700	Census Tract 1007, Suffolk County, Massachusetts	4322	4221	3847	152	5	167	0	16	34	101	54	5	3	0	0	30	9
1400000US25025100800	25025100800	Census Tract 1008, Suffolk County, Massachusetts	5546	5134	2896	1364	15	614	1	62	182	412	142	97	1	8	0	103	61
1400000US25025100900	25025100900	Census Tract 1009, Suffolk County, Massachusetts	4072	3722	933	2342	0	278	0	56	113	350	72	120	5	3	3	105	42
1400000US25025101001	25025101001	Census Tract 1010.01, Suffolk County, Massachusetts	5480	4886	133	4551	18	13	0	44	127	594	118	142	12	1	0	260	61
1400000US25025101002	25025101002	Census Tract 1010.02, Suffolk County, Massachusetts	4979	4286	201	3834	19	53	0	47	132	693	117	206	16	1	3	265	85
1400000US25025101101	25025101101	Census Tract 1011.01, Suffolk County, Massachusetts	3155	2676	29	2532	7	2	0	10	96	479	39	143	1	0	1	241	54
1400000US25025101102	25025101102	Census Tract 1011.02, Suffolk County, Massachusetts	4396	3875	54	3692	15	24	3	3	84	521	119	157	10	2	0	189	44
1400000US25025110103	25025110103	Census Tract 1101.03, Suffolk County, Massachusetts	5460	3714	2138	961	22	390	2	35	166	1746	668	128	20	5	0	785	140
1400000US25025110201	25025110201	Census Tract 1102.01, Suffolk County, Massachusetts	2051	1317	411	795	13	42	0	15	41	734	271	78	22	3	0	297	63
1400000US25025110301	25025110301	Census Tract 1103.01, Suffolk County, Massachusetts	2405	1713	955	602	13	60	0	19	64	692	272	79	5	1	0	286	49
1400000US25025110401	25025110401	Census Tract 1104.01, Suffolk County, Massachusetts	3566	2257	1117	945	5	92	5	14	79	1309	538	102	11	1	1	529	127
1400000US25025110403	25025110403	Census Tract 1104.03, Suffolk County, Massachusetts	4309	3307	2148	895	10	110	4	46	94	1002	391	127	4	5	0	366	109
1400000US25025110501	25025110501	Census Tract 1105.01, Suffolk County, Massachusetts	3253	2792	2299	321	1	91	0	10	70	461	178	27	9	0	0	187	60
1400000US25025110502	25025110502	Census Tract 1105.02, Suffolk County, Massachusetts	3806	2930	2070	625	5	113	0	29	88	876	426	56	11	2	0	310	71
1400000US25025110601	25025110601	Census Tract 1106.01, Suffolk County, Massachusetts	2969	2847	2580	76	7	131	1	13	39	122	86	1	3	1	0	19	12
1400000US25025110607	25025110607	Census Tract 1106.07, Suffolk County, Massachusetts	5077	4590	4085	263	6	128	0	29	79	487	250	33	6	4	0	148	46
1400000US25025120103	25025120103	Census Tract 1201.03, Suffolk County, Massachusetts	1508	1431	1270	55	1	54	0	8	43	77	51	0	1	0	0	12	13
1400000US25025120104	25025120104	Census Tract 1201.04, Suffolk County, Massachusetts	2095	1688	1359	150	2	126	0	8	43	407	194	39	3	0	0	141	30
1400000US25025120105	25025120105	Census Tract 1201.05, Suffolk County, Massachusetts	2444	2294	1890	117	2	209	1	5	70	150	87	8	6	1	0	22	26
1400000US25025120201	25025120201	Census Tract 1202.01, Suffolk County, Massachusetts	3439	2639	1903	510	7	115	0	28	76	800	283	86	11	3	0	346	71
1400000US25025120301	25025120301	Census Tract 1203.01, Suffolk County, Massachusetts	4795	2974	1908	789	9	136	0	28	104	1821	616	161	36	2	0	815	191
1400000US25025120400	25025120400	Census Tract 1204, Suffolk County, Massachusetts	5751	5185	4344	383	13	259	2	24	160	566	300	45	12	3	0	162	44
1400000US25025120500	25025120500	Census Tract 1205, Suffolk County, Massachusetts	2331	1136	764	232	6	63	0	22	49	1195	420	115	32	0	0	507	121
1400000US25025120600	25025120600	Census Tract 1206, Suffolk County, Massachusetts	2335	2034	1751	115	3	79	1	15	70	301	137	17	5	2	0	93	47
1400000US25025120700	25025120700	Census Tract 1207, Suffolk County, Massachusetts	2014	1660	1267	169	3	169	0	8	44	354	148	36	1	0	1	130	38
1400000US25025130100	25025130100	Census Tract 1301, Suffolk County, Massachusetts	5906	5641	4789	190	1	523	0	26	112	265	160	12	3	0	0	66	24
1400000US25025130200	25025130200	Census Tract 1302, Suffolk County, Massachusetts	4506	4299	3913	110	7	209	1	7	52	207	141	11	7	1	0	21	26
1400000US25025130300	25025130300	Census Tract 1303, Suffolk County, Massachusetts	4419	4149	3677	139	3	230	2	13	85	270	140	31	0	2	0	77	20
1400000US25025130402	25025130402	Census Tract 1304.02, Suffolk County, Massachusetts	4637	4337	3695	177	2	389	2	18	54	300	163	30	2	0	1	84	20
1400000US25025130404	25025130404	Census Tract 1304.04, Suffolk County, Massachusetts	2901	2552	2054	204	1	231	1	18	43	349	172	28	2	1	0	136	10
1400000US25025130406	25025130406	Census Tract 1304.06, Suffolk County, Massachusetts	5107	4047	1594	2063	8	256	0	23	103	1060	337	167	10	0	0	450	96
1400000US25025140102	25025140102	Census Tract 1401.02, Suffolk County, Massachusetts	4401	3646	1699	1717	4	88	1	38	99	755	249	91	4	3	3	339	66
1400000US25025140105	25025140105	Census Tract 1401.05, Suffolk County, Massachusetts	3675	2720	1305	1232	3	56	2	32	90	955	354	104	10	11	0	399	77
1400000US25025140106	25025140106	Census Tract 1401.06, Suffolk County, Massachusetts	1901	1306	278	930	7	30	0	13	48	595	179	74	7	1	0	271	63
1400000US25025140107	25025140107	Census Tract 1401.07, Suffolk County, Massachusetts	2531	1913	891	898	12	56	0	16	40	618	271	64	4	2	0	199	78
1400000US25025140201	25025140201	Census Tract 1402.01, Suffolk County, Massachusetts	2072	1731	978	607	7	51	0	39	49	341	104	44	3	0	0	157	33
1400000US25025140202	25025140202	Census Tract 1402.02, Suffolk County, Massachusetts	5600	4465	2400	1784	10	117	3	38	113	1135	368	154	18	1	5	467	122
1400000US25025140300	25025140300	Census Tract 1403, Suffolk County, Massachusetts	6382	4908	1184	3448	19	85	0	54	118	1474	483	219	8	0	4	627	133
1400000US25025140400	25025140400	Census Tract 1404, Suffolk County, Massachusetts	7650	6421	666	5425	30	71	4	45	180	1229	362	258	28	2	0	475	104
1400000US25025160101	25025160101	Census Tract 1601.01, Suffolk County, Massachusetts	7551	1836	1059	429	12	152	0	99	85	5715	2037	171	113	5	0	3057	332
1400000US25025160200	25025160200	Census Tract 1602, Suffolk County, Massachusetts	4043	696	391	176	3	50	0	32	44	3347	841	55	31	1	1	2224	194
1400000US25025160300	25025160300	Census Tract 1603, Suffolk County, Massachusetts	2065	1604	1343	161	2	38	0	4	56	461	208	19	7	1	0	191	35
1400000US25025160400	25025160400	Census Tract 1604, Suffolk County, Massachusetts	2716	794	400	234	2	106	0	15	37	1922	656	59	24	7	0	1025	151
1400000US25025160501	25025160501	Census Tract 1605.01, Suffolk County, Massachusetts	5604	1648	949	364	14	155	0	36	130	3956	1606	111	72	9	0	1884	274
1400000US25025160502	25025160502	Census Tract 1605.02, Suffolk County, Massachusetts	4460	1710	1154	230	9	162	0	42	113	2750	1029	97	20	6	0	1390	208
1400000US25025160601	25025160601	Census Tract 1606.01, Suffolk County, Massachusetts	4063	2341	1701	328	8	168	2	79	55	1722	780	80	17	10	4	713	118
1400000US25025160602	25025160602	Census Tract 1606.02, Suffolk County, Massachusetts	4675	2693	1885	419	5	221	0	116	47	1982	793	53	31	3	0	919	183
1400000US25025170100	25025170100	Census Tract 1701, Suffolk County, Massachusetts	7560	5553	4610	331	7	344	4	130	127	2007	835	76	29	3	3	927	134
1400000US25025170200	25025170200	Census Tract 1702, Suffolk County, Massachusetts	4564	3718	3225	150	7	203	0	56	77	846	370	10	6	0	0	403	57
1400000US25025170300	25025170300	Census Tract 1703, Suffolk County, Massachusetts	9040	7820	6533	465	11	503	1	150	157	1220	650	22	3	11	0	455	79
1400000US25025170400	25025170400	Census Tract 1704, Suffolk County, Massachusetts	5379	4173	3433	299	5	239	0	95	102	1206	574	37	14	2	2	482	95
1400000US25025170501	25025170501	Census Tract 1705.01, Suffolk County, Massachusetts	3435	2621	2194	133	2	185	0	48	59	814	470	22	9	6	0	251	56
1400000US25025170502	25025170502	Census Tract 1705.02, Suffolk County, Massachusetts	2818	2552	2340	74	9	76	0	18	35	266	167	6	6	0	0	61	26
1400000US25025170601	25025170601	Census Tract 1706.01, Suffolk County, Massachusetts	5105	3590	3123	117	9	186	0	78	77	1515	610	26	6	5	0	771	97
1400000US25025170701	25025170701	Census Tract 1707.01, Suffolk County, Massachusetts	2099	1561	1322	84	4	95	1	17	38	538	316	16	4	1	0	173	28
1400000US25025170702	25025170702	Census Tract 1707.02, Suffolk County, Massachusetts	6628	3735	2187	354	9	921	0	138	126	2893	1394	40	15	3	0	1270	171
1400000US25025170800	25025170800	Census Tract 1708, Suffolk County, Massachusetts	5118	3808	3325	230	3	104	0	57	89	1310	662	26	28	1	2	506	85
1400000US25025180101	25025180101	Census Tract 1801.01, Suffolk County, Massachusetts	4766	4487	4185	128	5	56	0	46	67	279	141	5	1	1	0	103	28
1400000US25025180200	25025180200	Census Tract 1802, Suffolk County, Massachusetts	4109	3843	3611	84	6	58	0	36	48	266	156	4	3	0	0	80	23
1400000US25025180301	25025180301	Census Tract 1803.01, Suffolk County, Massachusetts	3024	2899	2774	21	1	44	4	20	35	125	93	4	1	1	1	20	5
1400000US25025180400	25025180400	Census Tract 1804, Suffolk County, Massachusetts	1715	1622	1550	25	1	8	0	17	21	93	52	0	0	0	0	31	10
1400000US25025180500	25025180500	Census Tract 1805, Suffolk County, Massachusetts	3883	3580	3366	71	6	43	2	19	73	303	127	9	5	1	0	138	23
1400000US25025980101	25025980101	Census Tract 9801.01, Suffolk County, Massachusetts	535	401	165	204	2	8	1	13	8	134	45	13	0	0	0	66	10
1400000US25025980300	25025980300	Census Tract 9803, Suffolk County, Massachusetts	338	270	147	107	2	10	0	0	4	68	43	8	0	0	0	14	3
1400000US25025980700	25025980700	Census Tract 9807, Suffolk County, Massachusetts	6	6	5	0	0	0	1	0	0	0	0	0	0	0	0	0	0
1400000US25025981000	25025981000	Census Tract 9810, Suffolk County, Massachusetts	22	22	3	14	0	0	0	0	5	0	0	0	0	0	0	0	0
1400000US25025981100	25025981100	Census Tract 9811, Suffolk County, Massachusetts	418	333	84	228	0	13	0	2	6	85	45	18	0	1	0	20	1
1400000US25025981201	25025981201	Census Tract 9812.01, Suffolk County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25025981202	25025981202	Census Tract 9812.02, Suffolk County, Massachusetts	207	170	155	11	0	2	1	0	1	37	29	5	0	0	0	3	0
1400000US25025981300	25025981300	Census Tract 9813, Suffolk County, Massachusetts	389	318	258	13	4	29	0	0	14	71	57	0	0	2	1	10	1
1400000US25025981501	25025981501	Census Tract 9815.01, Suffolk County, Massachusetts	12	11	7	3	0	1	0	0	0	1	1	0	0	0	0	0	0
1400000US25025981502	25025981502	Census Tract 9815.02, Suffolk County, Massachusetts	9	7	7	0	0	0	0	0	0	2	2	0	0	0	0	0	0
1400000US25025981600	25025981600	Census Tract 9816, Suffolk County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25025981700	25025981700	Census Tract 9817, Suffolk County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25025981800	25025981800	Census Tract 9818, Suffolk County, Massachusetts	82	79	71	5	0	3	0	0	0	3	2	0	0	0	0	0	1
1400000US25025990101	25025990101	Census Tract 9901.01, Suffolk County, Massachusetts	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0
1400000US25027700100	25027700100	Census Tract 7001, Worcester County, Massachusetts	6081	5926	5713	53	6	71	2	2	79	155	96	6	2	0	0	36	15
1400000US25027701100	25027701100	Census Tract 7011, Worcester County, Massachusetts	8340	8040	7628	118	11	179	0	7	97	300	170	20	4	1	0	75	30
1400000US25027702200	25027702200	Census Tract 7022, Worcester County, Massachusetts	3218	3134	3051	18	3	19	0	0	43	84	42	5	8	0	0	17	12
1400000US25027703100	25027703100	Census Tract 7031, Worcester County, Massachusetts	4323	4135	4020	35	8	19	0	1	52	188	98	16	6	0	0	40	28
1400000US25027703200	25027703200	Census Tract 7032, Worcester County, Massachusetts	3558	3473	3345	29	4	34	0	8	53	85	54	2	0	1	0	21	7
1400000US25027703300	25027703300	Census Tract 7033, Worcester County, Massachusetts	3703	3563	3439	31	5	30	0	6	52	140	84	0	6	0	0	38	12
1400000US25027704200	25027704200	Census Tract 7042, Worcester County, Massachusetts	2916	2865	2797	22	1	14	0	0	31	51	40	0	0	0	0	8	3
1400000US25027705100	25027705100	Census Tract 7051, Worcester County, Massachusetts	8013	7860	7656	52	7	42	0	4	99	153	96	6	3	0	0	26	22
1400000US25027706100	25027706100	Census Tract 7061, Worcester County, Massachusetts	4382	4319	4225	21	1	21	0	7	44	63	45	5	1	0	0	10	2
1400000US25027707100	25027707100	Census Tract 7071, Worcester County, Massachusetts	3909	3609	3453	54	2	32	1	4	63	300	192	18	4	0	0	52	34
1400000US25027707200	25027707200	Census Tract 7072, Worcester County, Massachusetts	1839	1702	1607	33	0	32	0	1	29	137	90	8	8	0	0	22	9
1400000US25027707300	25027707300	Census Tract 7073, Worcester County, Massachusetts	3931	3703	3467	69	11	71	0	0	85	228	108	16	4	0	5	69	26
1400000US25027707400	25027707400	Census Tract 7074, Worcester County, Massachusetts	4591	4378	4177	57	8	50	0	7	79	213	130	9	1	2	0	52	19
1400000US25027707500	25027707500	Census Tract 7075, Worcester County, Massachusetts	5958	5406	4891	287	23	106	3	11	85	552	381	17	3	0	1	131	19
1400000US25027708100	25027708100	Census Tract 7081, Worcester County, Massachusetts	7277	7084	6868	62	11	73	0	7	63	193	139	3	3	0	0	29	19
1400000US25027709100	25027709100	Census Tract 7091, Worcester County, Massachusetts	4066	3672	3437	87	3	53	0	8	84	394	250	20	1	3	0	104	16
1400000US25027709201	25027709201	Census Tract 7092.01, Worcester County, Massachusetts	6921	6105	5657	181	11	115	5	34	102	816	407	25	1	5	0	310	68
1400000US25027709202	25027709202	Census Tract 7092.02, Worcester County, Massachusetts	6829	5600	4687	382	9	233	8	123	158	1229	787	43	2	1	3	313	80
1400000US25027709400	25027709400	Census Tract 7094, Worcester County, Massachusetts	4750	3408	2825	189	10	243	0	43	98	1342	721	62	7	11	4	460	77
1400000US25027709501	25027709501	Census Tract 7095.01, Worcester County, Massachusetts	2149	2057	1912	60	0	52	0	9	24	92	61	2	0	0	0	16	13
1400000US25027709502	25027709502	Census Tract 7095.02, Worcester County, Massachusetts	5670	5311	4676	305	9	187	1	36	97	359	243	20	0	0	0	86	10
1400000US25027709600	25027709600	Census Tract 7096, Worcester County, Massachusetts	2423	1918	1547	202	4	47	0	70	48	505	303	17	3	0	0	155	27
1400000US25027709701	25027709701	Census Tract 7097.01, Worcester County, Massachusetts	5609	4671	4068	344	2	125	1	28	103	938	532	42	10	0	0	275	79
1400000US25027709702	25027709702	Census Tract 7097.02, Worcester County, Massachusetts	2342	2117	1936	76	1	49	1	12	42	225	126	3	0	0	0	71	25
1400000US25027710100	25027710100	Census Tract 7101, Worcester County, Massachusetts	3435	2473	2041	156	22	197	0	3	54	962	484	54	2	1	1	349	71
1400000US25027710200	25027710200	Census Tract 7102, Worcester County, Massachusetts	6759	5635	5064	212	7	223	1	17	111	1124	499	55	6	2	0	479	83
1400000US25027710300	25027710300	Census Tract 7103, Worcester County, Massachusetts	3224	2828	2530	110	8	103	0	11	66	396	240	39	6	1	0	78	32
1400000US25027710400	25027710400	Census Tract 7104, Worcester County, Massachusetts	2149	1878	1689	37	1	126	0	3	22	271	155	4	5	0	0	85	22
1400000US25027710500	25027710500	Census Tract 7105, Worcester County, Massachusetts	3246	2106	1720	129	10	146	0	4	97	1140	507	60	14	6	5	451	97
1400000US25027710600	25027710600	Census Tract 7106, Worcester County, Massachusetts	6594	4593	3904	267	7	213	0	24	178	2001	877	94	17	2	0	879	132
1400000US25027710700	25027710700	Census Tract 7107, Worcester County, Massachusetts	1580	1001	802	103	0	45	0	3	48	579	259	22	0	0	0	256	42
1400000US25027710800	25027710800	Census Tract 7108, Worcester County, Massachusetts	4539	3343	2857	286	3	81	1	12	103	1196	479	68	4	1	0	566	78
1400000US25027711000	25027711000	Census Tract 7110, Worcester County, Massachusetts	3080	2279	1841	164	8	159	2	3	102	801	355	32	10	1	0	363	40
1400000US25027711100	25027711100	Census Tract 7111, Worcester County, Massachusetts	5712	5455	5054	150	3	158	3	9	78	257	172	7	0	0	0	62	16
1400000US25027712101	25027712101	Census Tract 7121.01, Worcester County, Massachusetts	5955	5804	5579	45	8	92	0	13	67	151	86	10	1	4	0	40	10
1400000US25027712102	25027712102	Census Tract 7121.02, Worcester County, Massachusetts	4131	4042	3872	34	8	61	0	2	65	89	63	1	0	0	0	12	13
1400000US25027713100	25027713100	Census Tract 7131, Worcester County, Massachusetts	8055	7400	6568	572	5	140	0	30	85	655	391	52	2	0	0	169	41
1400000US25027715100	25027715100	Census Tract 7151, Worcester County, Massachusetts	4897	4810	4577	22	7	130	1	3	70	87	72	1	0	0	0	5	9
1400000US25027716100	25027716100	Census Tract 7161, Worcester County, Massachusetts	7558	6700	6240	156	9	121	2	50	122	858	428	60	6	1	2	313	48
1400000US25027716200	25027716200	Census Tract 7162, Worcester County, Massachusetts	2820	2398	2147	128	13	45	0	27	38	422	238	34	3	1	1	115	30
1400000US25027716300	25027716300	Census Tract 7163, Worcester County, Massachusetts	3228	2664	2497	57	3	14	0	52	41	564	295	35	13	0	0	189	32
1400000US25027717100	25027717100	Census Tract 7171, Worcester County, Massachusetts	2866	2822	2715	18	7	40	0	6	36	44	37	1	2	0	0	4	0
1400000US25027718100	25027718100	Census Tract 7181, Worcester County, Massachusetts	4355	4291	4021	29	9	159	0	10	63	64	40	1	0	0	0	19	4
1400000US25027719100	25027719100	Census Tract 7191, Worcester County, Massachusetts	7808	7650	7441	52	13	67	5	5	67	158	130	3	1	1	0	18	5
1400000US25027720100	25027720100	Census Tract 7201, Worcester County, Massachusetts	3413	3364	3277	14	1	40	0	0	32	49	41	2	1	0	0	1	4
1400000US25027721101	25027721101	Census Tract 7211.01, Worcester County, Massachusetts	1902	1856	1819	7	0	8	1	4	17	46	37	5	0	0	0	1	3
1400000US25027721102	25027721102	Census Tract 7211.02, Worcester County, Massachusetts	7973	7827	7510	91	6	126	1	14	79	146	115	1	0	0	0	21	9
1400000US25027722100	25027722100	Census Tract 7221, Worcester County, Massachusetts	5398	5295	5132	48	12	28	0	7	68	103	72	12	0	1	0	14	4
1400000US25027723100	25027723100	Census Tract 7231, Worcester County, Massachusetts	3989	3928	3833	30	12	12	2	0	39	61	36	2	1	0	0	12	10
1400000US25027724100	25027724100	Census Tract 7241, Worcester County, Massachusetts	3701	3638	3549	27	1	23	0	1	37	63	35	1	6	0	0	12	9
1400000US25027725100	25027725100	Census Tract 7251, Worcester County, Massachusetts	4680	4591	4482	16	14	13	3	1	62	89	62	0	5	0	0	8	14
1400000US25027726100	25027726100	Census Tract 7261, Worcester County, Massachusetts	5988	5896	5777	23	8	41	2	2	43	92	51	3	3	0	0	22	13
1400000US25027726200	25027726200	Census Tract 7262, Worcester County, Massachusetts	5700	5457	5284	38	12	38	3	8	74	243	137	10	3	5	3	70	15
1400000US25027727100	25027727100	Census Tract 7271, Worcester County, Massachusetts	4806	4655	4445	92	3	62	1	3	49	151	106	18	1	0	0	13	13
1400000US25027728100	25027728100	Census Tract 7281, Worcester County, Massachusetts	4126	4028	3779	43	4	144	0	4	54	98	66	5	0	0	0	13	14
1400000US25027728200	25027728200	Census Tract 7282, Worcester County, Massachusetts	3713	3642	3459	40	1	99	0	1	42	71	43	1	1	4	0	15	7
1400000US25027728300	25027728300	Census Tract 7283, Worcester County, Massachusetts	4544	4428	4254	43	4	88	0	9	30	116	80	4	0	0	0	21	11
1400000US25027728400	25027728400	Census Tract 7284, Worcester County, Massachusetts	4963	4875	4594	37	0	182	2	10	50	88	45	11	1	0	0	23	8
1400000US25027729100	25027729100	Census Tract 7291, Worcester County, Massachusetts	4997	4654	4297	280	17	29	1	1	29	343	292	2	0	0	0	43	6
1400000US25027729200	25027729200	Census Tract 7292, Worcester County, Massachusetts	2672	2611	2520	41	0	23	1	12	14	61	49	0	0	0	0	10	2
1400000US25027730100	25027730100	Census Tract 7301, Worcester County, Massachusetts	5923	5524	4510	572	13	293	3	12	121	399	251	18	4	1	0	88	37
1400000US25027730200	25027730200	Census Tract 7302, Worcester County, Massachusetts	5583	5148	4403	459	8	173	2	21	82	435	240	30	1	0	0	133	31
1400000US25027730300	25027730300	Census Tract 7303, Worcester County, Massachusetts	4559	4181	3651	230	15	146	0	12	127	378	209	30	3	4	0	99	33
1400000US25027730401	25027730401	Census Tract 7304.01, Worcester County, Massachusetts	5444	4280	3079	946	11	96	1	35	112	1164	610	97	14	0	0	355	88
1400000US25027730402	25027730402	Census Tract 7304.02, Worcester County, Massachusetts	1660	1243	889	209	3	74	0	21	47	417	227	25	0	0	0	146	19
1400000US25027730500	25027730500	Census Tract 7305, Worcester County, Massachusetts	3535	2975	2093	617	7	128	3	28	99	560	298	39	9	4	0	146	64
1400000US25027730600	25027730600	Census Tract 7306, Worcester County, Massachusetts	8799	8441	7545	369	5	391	1	10	120	358	235	23	4	6	1	60	29
1400000US25027730700	25027730700	Census Tract 7307, Worcester County, Massachusetts	6803	6432	5509	424	4	326	1	35	133	371	195	41	5	8	1	83	38
1400000US25027730801	25027730801	Census Tract 7308.01, Worcester County, Massachusetts	3665	3528	3222	114	1	114	0	12	65	137	86	8	0	0	0	35	8
1400000US25027730802	25027730802	Census Tract 7308.02, Worcester County, Massachusetts	2046	1901	1680	89	0	79	0	3	50	145	83	13	1	0	0	24	24
1400000US25027730901	25027730901	Census Tract 7309.01, Worcester County, Massachusetts	3404	3194	2883	142	7	86	0	13	63	210	96	5	4	3	0	69	33
1400000US25027730902	25027730902	Census Tract 7309.02, Worcester County, Massachusetts	3716	3491	3081	177	7	128	1	19	78	225	111	8	5	1	0	84	16
1400000US25027731001	25027731001	Census Tract 7310.01, Worcester County, Massachusetts	2229	2013	1411	296	6	270	3	4	23	216	151	12	1	3	0	42	7
1400000US25027731002	25027731002	Census Tract 7310.02, Worcester County, Massachusetts	6402	5321	3692	893	18	532	0	28	158	1081	503	98	18	1	0	360	101
1400000US25027731101	25027731101	Census Tract 7311.01, Worcester County, Massachusetts	3949	2925	1981	400	5	430	0	20	89	1024	448	68	11	1	3	410	83
1400000US25027731102	25027731102	Census Tract 7311.02, Worcester County, Massachusetts	2511	2220	1776	226	3	143	0	9	63	291	120	29	1	0	0	113	28
1400000US25027731202	25027731202	Census Tract 7312.02, Worcester County, Massachusetts	1111	1052	853	37	0	112	0	5	45	59	27	6	0	0	0	15	11
1400000US25027731203	25027731203	Census Tract 7312.03, Worcester County, Massachusetts	5198	3232	2003	454	19	611	2	45	98	1966	943	132	23	0	6	715	147
1400000US25027731204	25027731204	Census Tract 7312.04, Worcester County, Massachusetts	2498	1378	743	272	7	295	0	3	58	1120	482	69	17	1	0	473	78
1400000US25027731300	25027731300	Census Tract 7313, Worcester County, Massachusetts	3841	1834	828	398	7	485	0	17	99	2007	698	108	9	3	1	991	197
1400000US25027731400	25027731400	Census Tract 7314, Worcester County, Massachusetts	4673	2245	997	664	27	367	1	42	147	2428	1045	135	11	7	3	1078	149
1400000US25027731500	25027731500	Census Tract 7315, Worcester County, Massachusetts	5174	2755	1601	684	42	260	0	37	131	2419	1029	207	12	6	5	1054	106
1400000US25027731600	25027731600	Census Tract 7316, Worcester County, Massachusetts	7357	6306	4773	531	20	694	3	95	190	1051	515	65	3	6	3	399	60
1400000US25027731700	25027731700	Census Tract 7317, Worcester County, Massachusetts	2761	2002	1317	420	8	159	0	21	77	759	404	52	7	2	0	260	34
1400000US25027731800	25027731800	Census Tract 7318, Worcester County, Massachusetts	6172	3877	2635	636	10	268	0	108	220	2295	1142	161	24	4	1	784	179
1400000US25027731900	25027731900	Census Tract 7319, Worcester County, Massachusetts	5227	3267	1774	1066	39	192	0	53	143	1960	980	134	17	13	0	699	117
1400000US25027732001	25027732001	Census Tract 7320.01, Worcester County, Massachusetts	3327	1084	520	372	10	96	0	7	79	2243	967	168	7	11	0	851	239
1400000US25027732002	25027732002	Census Tract 7320.02, Worcester County, Massachusetts	4036	3565	2688	403	4	348	2	33	87	471	297	28	3	0	0	111	32
1400000US25027732201	25027732201	Census Tract 7322.01, Worcester County, Massachusetts	2820	2600	1986	223	2	256	0	74	59	220	115	19	2	0	0	63	21
1400000US25027732202	25027732202	Census Tract 7322.02, Worcester County, Massachusetts	3240	2846	2310	202	7	192	6	56	73	394	147	27	17	0	0	164	39
1400000US25027732203	25027732203	Census Tract 7322.03, Worcester County, Massachusetts	2853	2262	1516	317	5	306	2	26	90	591	334	28	6	0	1	181	41
1400000US25027732301	25027732301	Census Tract 7323.01, Worcester County, Massachusetts	4155	3830	3180	317	4	242	0	16	71	325	192	9	0	0	0	87	37
1400000US25027732302	25027732302	Census Tract 7323.02, Worcester County, Massachusetts	3902	3233	2474	449	1	123	0	45	141	669	307	44	1	2	0	255	60
1400000US25027732400	25027732400	Census Tract 7324, Worcester County, Massachusetts	6459	4032	2454	958	17	305	15	89	194	2427	1159	219	9	3	5	846	186
1400000US25027732500	25027732500	Census Tract 7325, Worcester County, Massachusetts	1776	1082	679	167	10	149	1	12	64	694	255	38	13	0	0	318	70
1400000US25027732600	25027732600	Census Tract 7326, Worcester County, Massachusetts	4253	2977	2186	475	24	128	0	15	149	1276	649	53	10	0	0	447	117
1400000US25027732700	25027732700	Census Tract 7327, Worcester County, Massachusetts	3938	2892	1978	615	5	191	2	9	92	1046	545	88	18	8	2	326	59
1400000US25027732801	25027732801	Census Tract 7328.01, Worcester County, Massachusetts	4829	4509	3663	444	7	278	0	44	73	320	199	20	0	0	0	76	25
1400000US25027732802	25027732802	Census Tract 7328.02, Worcester County, Massachusetts	4122	3714	2767	573	1	263	0	39	71	408	170	33	2	0	0	171	32
1400000US25027732901	25027732901	Census Tract 7329.01, Worcester County, Massachusetts	6592	5476	4074	877	19	337	1	41	127	1116	548	60	10	2	0	386	110
1400000US25027732902	25027732902	Census Tract 7329.02, Worcester County, Massachusetts	2459	2249	1993	98	3	117	0	3	35	210	123	16	0	3	1	52	15
1400000US25027733000	25027733000	Census Tract 7330, Worcester County, Massachusetts	3762	2376	1413	367	7	449	1	35	104	1386	498	73	19	3	0	646	147
1400000US25027733101	25027733101	Census Tract 7331.01, Worcester County, Massachusetts	2058	1803	1517	125	5	96	1	23	36	255	126	11	7	0	0	79	32
1400000US25027733102	25027733102	Census Tract 7331.02, Worcester County, Massachusetts	2224	1932	1487	194	4	199	0	14	34	292	133	8	0	1	0	132	18
1400000US25027735100	25027735100	Census Tract 7351, Worcester County, Massachusetts	6713	6490	6196	76	18	106	0	15	79	223	135	9	0	0	1	57	21
1400000US25027735200	25027735200	Census Tract 7352, Worcester County, Massachusetts	4257	4066	3765	137	13	75	6	8	62	191	109	6	0	0	0	60	16
1400000US25027736100	25027736100	Census Tract 7361, Worcester County, Massachusetts	2600	2533	2408	27	0	65	0	1	32	67	45	11	0	0	0	9	2
1400000US25027736200	25027736200	Census Tract 7362, Worcester County, Massachusetts	3722	3637	3470	38	7	62	1	5	54	85	42	2	0	0	0	20	21
1400000US25027736300	25027736300	Census Tract 7363, Worcester County, Massachusetts	2426	2319	2212	20	8	35	2	7	35	107	83	4	0	0	0	14	6
1400000US25027736400	25027736400	Census Tract 7364, Worcester County, Massachusetts	3071	2968	2815	39	5	76	0	3	30	103	69	6	1	0	0	20	7
1400000US25027736500	25027736500	Census Tract 7365, Worcester County, Massachusetts	4369	4305	4177	30	1	61	0	4	32	64	45	1	1	0	0	13	4
1400000US25027737100	25027737100	Census Tract 7371, Worcester County, Massachusetts	5116	5004	4793	57	4	73	1	4	72	112	59	8	0	0	1	28	16
1400000US25027737200	25027737200	Census Tract 7372, Worcester County, Massachusetts	1747	1709	1631	22	4	19	4	3	26	38	23	4	1	0	0	4	6
1400000US25027737300	25027737300	Census Tract 7373, Worcester County, Massachusetts	6398	6242	5885	86	12	156	3	20	80	156	106	0	5	0	0	31	14
1400000US25027738100	25027738100	Census Tract 7381, Worcester County, Massachusetts	4636	4480	3554	53	6	755	2	12	98	156	98	4	10	0	0	32	12
1400000US25027738201	25027738201	Census Tract 7382.01, Worcester County, Massachusetts	4075	3997	3680	45	1	216	0	1	54	78	58	6	0	0	0	8	6
1400000US25027738202	25027738202	Census Tract 7382.02, Worcester County, Massachusetts	5995	5902	5441	54	3	314	0	18	72	93	54	0	0	0	0	28	11
1400000US25027739100	25027739100	Census Tract 7391, Worcester County, Massachusetts	9557	9277	6585	308	14	2092	5	100	173	280	190	6	0	0	0	63	21
1400000US25027739200	25027739200	Census Tract 7392, Worcester County, Massachusetts	5958	5749	4289	121	3	1117	0	123	96	209	126	14	3	0	0	48	18
1400000US25027739300	25027739300	Census Tract 7393, Worcester County, Massachusetts	3688	3582	3026	71	5	386	0	28	66	106	75	0	0	4	0	20	7
1400000US25027739400	25027739400	Census Tract 7394, Worcester County, Massachusetts	8851	8658	7118	145	2	1189	0	53	151	193	131	8	3	0	0	43	8
1400000US25027739500	25027739500	Census Tract 7395, Worcester County, Massachusetts	7554	7381	6516	72	3	663	0	34	93	173	131	7	0	0	0	27	8
1400000US25027740101	25027740101	Census Tract 7401.01, Worcester County, Massachusetts	5191	5072	4463	43	5	434	0	21	106	119	69	1	4	2	0	39	4
1400000US25027740102	25027740102	Census Tract 7401.02, Worcester County, Massachusetts	6053	5875	5219	52	3	490	2	18	91	178	122	8	2	3	0	32	11
1400000US25027740200	25027740200	Census Tract 7402, Worcester County, Massachusetts	2911	2827	2478	32	2	229	0	8	78	84	54	6	0	0	1	14	9
1400000US25027741101	25027741101	Census Tract 7411.01, Worcester County, Massachusetts	4478	4347	3901	40	11	322	0	18	55	131	100	7	0	0	1	16	7
1400000US25027741102	25027741102	Census Tract 7411.02, Worcester County, Massachusetts	5289	5148	4504	40	2	491	0	18	93	141	100	2	3	2	0	12	22
1400000US25027742300	25027742300	Census Tract 7423, Worcester County, Massachusetts	4045	3794	3387	41	5	267	0	41	53	251	105	13	1	4	0	105	23
1400000US25027742401	25027742401	Census Tract 7424.01, Worcester County, Massachusetts	5421	5333	4665	39	3	532	0	5	89	88	72	2	1	0	0	10	3
1400000US25027742402	25027742402	Census Tract 7424.02, Worcester County, Massachusetts	3026	2928	1714	30	7	1136	0	11	30	98	48	0	1	3	0	38	8
1400000US25027743100	25027743100	Census Tract 7431, Worcester County, Massachusetts	7542	7423	7105	52	4	162	1	6	93	119	83	5	8	0	0	13	10
1400000US25027744101	25027744101	Census Tract 7441.01, Worcester County, Massachusetts	7445	7136	6492	129	4	287	1	54	169	309	216	6	2	0	0	65	20
1400000US25027744102	25027744102	Census Tract 7441.02, Worcester County, Massachusetts	5258	4968	4609	110	6	88	0	59	96	290	171	29	1	1	0	68	20
1400000US25027744200	25027744200	Census Tract 7442, Worcester County, Massachusetts	7484	6860	6165	120	12	198	0	235	130	624	311	15	8	3	3	249	35
1400000US25027744300	25027744300	Census Tract 7443, Worcester County, Massachusetts	3838	3149	2669	100	9	31	0	221	119	689	380	14	25	3	0	228	39
1400000US25027744400	25027744400	Census Tract 7444, Worcester County, Massachusetts	3974	3571	3169	76	2	70	1	147	106	403	211	12	0	0	1	144	35
1400000US25027745100	25027745100	Census Tract 7451, Worcester County, Massachusetts	5911	5784	5561	36	4	101	1	18	63	127	79	1	1	0	0	30	16
1400000US25027746100	25027746100	Census Tract 7461, Worcester County, Massachusetts	5839	5766	5631	17	2	57	2	5	52	73	43	5	0	0	0	23	2
1400000US25027747101	25027747101	Census Tract 7471.01, Worcester County, Massachusetts	5110	5012	4848	54	13	33	1	2	61	98	83	3	0	0	0	8	4
1400000US25027747102	25027747102	Census Tract 7471.02, Worcester County, Massachusetts	3916	3829	3707	23	8	38	2	3	48	87	66	2	1	0	0	15	3
1400000US25027748100	25027748100	Census Tract 7481, Worcester County, Massachusetts	3190	3149	3073	13	7	29	0	0	27	41	32	2	0	0	0	4	3
1400000US25027749100	25027749100	Census Tract 7491, Worcester County, Massachusetts	7988	7844	7568	63	1	96	1	14	101	144	92	8	9	0	0	29	6
1400000US25027749200	25027749200	Census Tract 7492, Worcester County, Massachusetts	5469	5356	5188	38	6	44	1	10	69	113	86	2	3	0	0	9	13
1400000US25027750100	25027750100	Census Tract 7501, Worcester County, Massachusetts	6048	5804	5586	44	10	60	1	5	98	244	159	10	0	0	0	63	12
1400000US25027750200	25027750200	Census Tract 7502, Worcester County, Massachusetts	6749	6631	6448	31	7	75	0	11	59	118	89	4	0	0	0	10	15
1400000US25027750300	25027750300	Census Tract 7503, Worcester County, Massachusetts	2910	2781	2686	21	5	24	0	1	44	129	103	2	1	0	0	16	7
1400000US25027751101	25027751101	Census Tract 7511.01, Worcester County, Massachusetts	6219	6142	5959	33	1	65	6	5	73	77	65	0	5	0	0	6	1
1400000US25027751102	25027751102	Census Tract 7511.02, Worcester County, Massachusetts	2744	2706	2645	5	2	19	2	3	30	38	22	1	4	0	0	6	5
1400000US25027752100	25027752100	Census Tract 7521, Worcester County, Massachusetts	8471	8332	8074	35	14	75	3	9	122	139	107	10	1	1	0	10	10
1400000US25027753100	25027753100	Census Tract 7531, Worcester County, Massachusetts	7458	7137	6848	95	8	86	2	9	89	321	187	8	2	1	0	103	20
1400000US25027753200	25027753200	Census Tract 7532, Worcester County, Massachusetts	6251	6108	5943	39	8	55	0	1	62	143	88	1	3	0	1	35	15
1400000US25027754100	25027754100	Census Tract 7541, Worcester County, Massachusetts	6502	6280	6047	66	9	77	0	12	69	222	129	3	1	6	0	55	28
1400000US25027754200	25027754200	Census Tract 7542, Worcester County, Massachusetts	3462	3116	2853	130	21	34	0	13	65	346	174	31	1	0	0	117	23
1400000US25027754300	25027754300	Census Tract 7543, Worcester County, Massachusetts	2960	2582	2307	133	6	47	0	17	72	378	233	9	1	0	0	113	22
1400000US25027754400	25027754400	Census Tract 7544, Worcester County, Massachusetts	3843	3641	3451	91	10	20	0	9	60	202	99	19	1	0	0	56	27
1400000US25027755100	25027755100	Census Tract 7551, Worcester County, Massachusetts	3300	3168	3044	44	5	24	1	3	47	132	77	3	1	0	0	41	10
1400000US25027755200	25027755200	Census Tract 7552, Worcester County, Massachusetts	8090	7892	7638	74	8	69	0	16	87	198	117	15	2	2	0	43	19
1400000US25027756101	25027756101	Census Tract 7561.01, Worcester County, Massachusetts	4512	4397	4240	40	4	49	0	9	55	115	79	1	0	1	1	20	13
1400000US25027756102	25027756102	Census Tract 7561.02, Worcester County, Massachusetts	8469	8210	7993	35	16	65	8	2	91	259	176	14	3	5	0	37	24
1400000US25027757100	25027757100	Census Tract 7571, Worcester County, Massachusetts	4514	3324	3073	67	27	102	1	7	47	1190	602	58	5	5	0	441	79
1400000US25027757200	25027757200	Census Tract 7572, Worcester County, Massachusetts	2293	1311	1189	40	1	46	0	0	35	982	509	35	1	4	0	361	72
1400000US25027757300	25027757300	Census Tract 7573, Worcester County, Massachusetts	2871	1707	1588	31	15	44	0	1	28	1164	431	60	19	4	0	591	59
1400000US25027757400	25027757400	Census Tract 7574, Worcester County, Massachusetts	2707	2253	2140	40	7	28	1	4	33	454	230	9	0	1	0	185	29
1400000US25027757500	25027757500	Census Tract 7575, Worcester County, Massachusetts	4334	3672	3475	58	8	76	1	6	48	662	343	33	5	0	0	227	54
1400000US25027758101	25027758101	Census Tract 7581.01, Worcester County, Massachusetts	1650	1629	1598	7	0	10	0	0	14	21	15	0	0	0	0	6	0
1400000US25027758102	25027758102	Census Tract 7581.02, Worcester County, Massachusetts	7618	7408	7067	49	23	174	0	12	83	210	136	0	2	0	0	52	20
1400000US25027759100	25027759100	Census Tract 7591, Worcester County, Massachusetts	2183	2132	2079	11	5	6	0	1	30	51	42	0	0	0	0	6	3
1400000US25027760100	25027760100	Census Tract 7601, Worcester County, Massachusetts	3390	3346	3265	10	3	7	0	0	61	44	34	0	2	0	0	4	4
1400000US25027761100	25027761100	Census Tract 7611, Worcester County, Massachusetts	5135	5015	4893	29	10	17	2	3	61	120	78	1	1	1	0	15	24
1400000US25027761200	25027761200	Census Tract 7612, Worcester County, Massachusetts	5780	5500	3957	121	11	1246	4	31	130	280	195	27	1	0	0	45	12
1400000US25027761300	25027761300	Census Tract 7613, Worcester County, Massachusetts	3059	2980	2802	32	5	85	0	8	48	79	61	2	0	0	0	12	4
1400000US25027761400	25027761400	Census Tract 7614, Worcester County, Massachusetts	6520	6256	5668	259	1	217	3	2	106	264	219	5	3	0	0	19	18
\.


SET search_path = census, pg_catalog;

--
-- TOC entry 1870 (class 2606 OID 4499866)
-- Dependencies: 167 167 167 167
-- Name: pk_facts; Type: CONSTRAINT; Schema: census; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY facts
    ADD CONSTRAINT pk_facts PRIMARY KEY (fact_type_id, tract_id, yr);


--
-- TOC entry 1868 (class 2606 OID 4499861)
-- Dependencies: 166 166
-- Name: pk_lu_fact_types; Type: CONSTRAINT; Schema: census; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lu_fact_types
    ADD CONSTRAINT pk_lu_fact_types PRIMARY KEY (fact_type_id);


--
-- TOC entry 1866 (class 2606 OID 4499850)
-- Dependencies: 164 164
-- Name: pk_lu_tracts; Type: CONSTRAINT; Schema: census; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lu_tracts
    ADD CONSTRAINT pk_lu_tracts PRIMARY KEY (tract_id);


--
-- TOC entry 1880 (class 0 OID 0)
-- Dependencies: 5
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2012-02-24 13:24:12

--
-- PostgreSQL database dump complete
--

